//@ui5-bundle sap/ui/core/library-preload.js
/*
 * ! OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/ui/base/ManagedObjectObserver',['sap/ui/base/Object','sap/ui/base/ManagedObject','sap/ui/base/EventProvider',"sap/base/util/array/uniqueSort",'sap/base/util/deepExtend'],function(B,M,E,u,d){"use strict";
var a=B.extend("sap.ui.base.ManagedObjectObserver",{constructor:function(C){if(!C&&typeof C!=="function"){throw new Error("Missing callback function in ManagedObjectObserver constructor");}this._fnCallback=C;}});
a.prototype.observe=function(i,C){if(!(i instanceof M)){if(i==null){return;}throw new TypeError("ManagedObjectObserver can only handle ManagedObjects, but observe was called for "+i);}p(i,C);c(i,this,C);};
a.prototype.unobserve=function(i,C){if(!(i instanceof M)){if(i==null){return;}throw new TypeError("ManagedObjectObserver can only handle ManagedObjects, but unobserve was called for "+i);}if(C){p(i,C);}r(i,this,C);};
a.prototype.isObserved=function(i,C){if(!(i instanceof M)){if(i==null){return false;}throw new TypeError("ManagedObjectObserver can only handle ManagedObjects, but isObserved was called for "+i);}return e(i,this,C);};
a.prototype.disconnect=function(){f(this);};
a.prototype.getConfiguration=function(i){return g(i,this);};
var O={},t=Object.create(null);
O.propertyChange=function(i,n,v,N){h("properties",i,n,function(){return{type:"property",old:v,current:N};});};
O.aggregationChange=function(i,n,s,v){h("aggregations",i,n,function(){return{type:"aggregation",mutation:s,children:Array.isArray(v)?v:null,child:!Array.isArray(v)?v:null};});};
O.parentChange=function(i,n,s,P){h("parent",i,n,function(){return{type:"parent",mutation:s,parent:P};});var q=s==="unset"?"remove":"insert";O.aggregationChange(P,n,q,i);};
O.associationChange=function(i,n,s,I){h("associations",i,n,function(){return{type:"association",mutation:s,ids:I};});};
O.eventChange=function(i,n,s,L,F,D){h("events",i,n,function(){return{type:"event",mutation:s,listener:L,func:F,data:D};});};
O.bindingChange=function(i,n,s,q,v){h("bindings",i,n,function(){return{type:"binding",mutation:s,bindingInfo:q,memberType:v};});};
O.objectDestroyed=function(i){h("destroy",i,null,function(){return{type:"destroy"};});var I=i.getId();if(t[I]){i.detachEvent("EventHandlerChange",H);delete t[I];}delete i._observer;};
function h(T,n,N,C){var I=n.getId(),q=t[I];if(q){var s;for(var i=0;i<q.listeners.length;i++){if(b(q.configurations[i],T,N)){if(!s){s=C();s.name=N;s.object=n;}var L=q.listeners[i];L._fnCallback(s);}}}}
function b(C,T,n){if(C==null||!T){return false;}if(T!="destroy"&&T!="parent"&&!n){return false;}return C[T]===true||(Array.isArray(C[T])&&C[T].indexOf(n)>-1);}
function c(T,L,C){j(T,L,C,false);}
function g(T,L){var i=T.getId();var n=t[i];if(n&&n.listeners){var I=n.listeners.indexOf(L);if(I>=0){var C=d({},n.configurations[I]);return C;}}return null;}
function r(T,L,C){C=C||g(T,L);j(T,L,C,true);}
function e(T,L,C){var i=T.getId(),n=t[i];C=C||g(T,L);if(!n){return false;}var I=n.listeners.indexOf(L);if(I===-1){return false;}else{return m(n.configurations[I].properties,C.properties)&&m(n.configurations[I].aggregations,C.aggregations)&&m(n.configurations[I].associations,C.associations)&&m(n.configurations[I].bindings,C.bindings)&&m(n.configurations[I].events,C.events)&&o(n.configurations[I].destroy,C.destroy)&&o(n.configurations[I].parent,C.parent);}}
function f(L){for(var n in t){var T=t[n];for(var i=0;i<T.listeners.length;i++){if(T.listeners[i]===L){T.listeners.splice(i,1);T.configurations.splice(i,1);}}if(T.listeners&&T.listeners.length===0){delete t[n];T.object._observer=undefined;}}}
function j(T,L,C,R){var i=T.getId(),n=t[i],q,I;if(R){if(!n){return;}I=n.listeners.indexOf(L);if(I>=0){q=n.configurations[I];}}else{if(!n){n=t[i]={listeners:[],configurations:[],object:T};}I=n.listeners.indexOf(L);if(I===-1){n.listeners.push(L);n.configurations.push(C);}else{q=n.configurations[I];}}if(q){q.properties=q.properties||[];l(q.properties,C.properties,R);q.aggregations=q.aggregations||[];l(q.aggregations,C.aggregations,R);q.associations=q.associations||[];l(q.associations,C.associations,R);q.bindings=q.bindings||[];l(q.bindings,C.bindings,R);q.events=q.events||[];l(q.events,C.events,R);if(C.destroy!=null){if(R){delete q.destroy;}else{q.destroy=C.destroy;}}if(C.parent!=null){if(R){delete q.parent;}else{q.parent=C.parent;}}}var s=k(T,"events");if(T._observer&&R){if(!s&&E.hasListener(T,"EventHandlerChange",H)){T.detachEvent("EventHandlerChange",H);}if(!s&&!k(T,"properties")&&!k(T,"aggregations")&&!k(T,"associations")&&!k(T,"destroy")&&!k(T,"parent")&&!k(T,"bindings")){delete T._observer;delete t[i];}}else if(!T._observer&&!R){if(s&&!E.hasListener(T,"EventHandlerChange",H)){T.attachEvent("EventHandlerChange",H);}T._observer=O;}}
function k(T,s){var i=T.getId(),n=t[i];if(n){var C=n.configurations.filter(function(q){return q.hasOwnProperty(s)&&q[s]&&(q[s]===true||q[s].length>0);});return C.length>0;}return false;}
function H(i){var T=i.getSource(),s=i.mParameters.EventId;if(T.getMetadata().hasEvent(s)){if(i.mParameters.type==="listenerAttached"){O.eventChange(T,s,"insert",i.mParameters.listener,i.mParameters.func,i.mParameters.data);}else if(i.mParameters.type==="listenerDetached"){O.eventChange(T,s,"remove",i.mParameters.listener,i.mParameters.func,i.mParameters.data);}}}
function l(n,A,R){if(!A){return;}for(var i=0;i<A.length;i++){var I=n.indexOf(A[i]);if(I>-1&&R){n.splice(I,1);}else if(I===-1&&!R){n.push(A[i]);}}}
function m(F,s){if(!Array.isArray(s)||s.length==0){return true;}if(!Array.isArray(F)||F.length==0){return false;}var U=u(F.concat(s));return F.length===U.length;}
function o(i,C){if(C==null){return true;}return i===C;}
function p(i,C){var n=i.getMetadata(),P=Object.keys(n.getAllProperties()),A=Object.keys(n.getAllAggregations()),q=Object.keys(n.getAllAssociations()),s=u(P.concat(A)),v=Object.keys(n.getAllEvents());C.properties=C.properties===true?P:C.properties;C.aggregations=C.aggregations===true?A:C.aggregations;C.associations=C.associations===true?q:C.associations;C.bindings=C.bindings===true?s:C.bindings;C.events=C.events===true?v:C.events;C.destroy=(C.destroy==null)?false:C.destroy;C.parent=(C.parent==null)?false:C.parent;}
return a;});
sap.ui.predefine('sap/ui/model/base/ManagedObjectModel',['../json/JSONModel','../json/JSONPropertyBinding','../json/JSONListBinding','sap/ui/base/ManagedObject','sap/ui/base/ManagedObjectObserver','../Context','../ChangeReason',"sap/base/util/uid","sap/base/Log","sap/base/util/isPlainObject","sap/base/util/deepClone"],function(J,a,b,M,c,C,d,u,L,e,f){"use strict";var g="@custom",I="--";
function _(n,o,A,O){var p=A.get(o)||[],q,r;for(var i=0;i<p.length;i++){q=p[i];if(!(q instanceof M)){continue;}r=true;if(O){n._oObserver.observe(q,{properties:true,aggregations:true});}else{n._oObserver.unobserve(q,{properties:true,aggregations:true});}var s=q.getMetadata().getAllAggregations();for(var K in s){_(n,q,s[K],O);}}if(r){var K=o.getId()+"/@"+A.name;if(O){if(!n._mObservedCount.aggregations[K]){n._mObservedCount.aggregations[K]=0;}n._mObservedCount.aggregations[K]++;}else{delete n._mObservedCount.aggregations[K];}}}
function h(n){var s,i=n.length-1,p=[];while(!(n[i].node instanceof M)){if(s){p.splice(0,0,s);}s=n[i].path;i--;}return[n[i].node,n[i+1],p,s];}
function j(o){var D="",p;var t=typeof o;if(o==null||(t!="object"&&t!="function")){D=o;}else if(e(o)){D=JSON.stringify(o);}else if(o instanceof M){D=o.getId();for(p in o.mProperties){D=D+"$"+j(o.mProperties[p]);}}else if(Array.isArray(o)){for(var i=0;o.length;i++){D=D+"$"+j(o);}}else{L.warning("Could not stringify object "+o);D="$";}return D;}
var k=b.extend("sap.ui.model.base.ManagedObjectModelAggregationBinding",{
constructor:function(){b.apply(this,arguments);this._getOriginOfManagedObjectModelBinding();},
_mightBeAffectedByChangesInside:function(o){while(o){if(o.getParent()===this._oOriginMO){return true;}o=o.getParent();}return false;},
getEntryKey:function(o){var O=o.getObject();if(O instanceof M){return O.getId();}return b.prototype.getEntryKey.apply(this,arguments);},
getEntryData:function(o){var O=o.getObject();if(O instanceof M){return j(O);}return b.prototype.getEntryData.apply(this,arguments);},
_getContexts:function(s,i){var S;if(this._oAggregation){var o=this._oOriginMO.getBinding(this._sMember);if(o){var n=o.getModel();S=n.iSizeLimit;}var B=this._oOriginMO.getBindingInfo(this._sMember);if(B&&s>=0&&i&&S&&i>S){var U=false;if(s!=B.startIndex){B.startIndex=s;U=true;}if(i!=B.length){B.length=i;U=true;}if(U){this._oAggregation.update(this._oOriginMO,"change");}}}return b.prototype._getContexts.apply(this,arguments);},
_getOriginOfManagedObjectModelBinding:function(){if(!this._oOriginMO){var o=this.oModel,n=[];o._getObject(this.sPath,this.oContext,n);var v=h(n);this._oOriginMO=v[0];this._aPartsInJSON=v[2];this._sMember=v[3];this._oAggregation=this._oOriginMO.getMetadata().getAggregation(this._sMember);}},
getLength:function(){if(this._aPartsInJSON.length==0){var i=this._oOriginMO.getBinding(this._sMember);if(i&&i.isA("sap.ui.model.ListBinding")){return i.getLength();}}return b.prototype.getLength.apply(this,arguments);},
isLengthFinal:function(){if(this._aPartsInJSON.length==0){var i=this._oOriginMO.getBinding(this._sMember);if(i&&i.isA("sap.ui.model.ListBinding")){return i.isLengthFinal();}}return true;}
});
var l=a.extend("sap.ui.model.base.ManagedObjectModelPropertyBinding");
var m=J.extend("sap.ui.model.base.ManagedObjectModel",{constructor:function(o,D){if(!D&&typeof D!="object"){D={};}D[g]={};this._oObject=o;this._mObservedCount={properties:{},aggregations:{}};this.mListBinding={};J.apply(this,[D]);this._oObserver=new c(this.observerChanges.bind(this));}});
m.prototype.getAggregation=J.prototype.getProperty;
m.prototype.setData=function(D,i){var n={};n[g]=D;J.prototype.setData.apply(this,[n,i]);};
m.prototype.getJSON=function(){return JSON.stringify(this.oData[g]);};
m.prototype.setProperty=function(p,v,o,A){var r=this.resolve(p,o),n,O,P;if(!r){return false;}if(r.indexOf("/"+g)===0){return J.prototype.setProperty.apply(this,arguments);}n=r.lastIndexOf("/");O=r.substring(0,n||1);P=r.substr(n+1);var N=[],q=this._getObject(O,null,N);if(q){if(q instanceof M){var s=q.getMetadata().getManagedProperty(P);if(s){if(s.get(q)!==v){s.set(q,v);var F=function(B){var p=this.resolve(B.sPath,B.oContext);return p?p.startsWith(r):false;}.bind(this);this.checkUpdate(false,A,F);return true;}}else{L.warning("The setProperty method only supports properties, the path "+r+" does not point to a property",null,"sap.ui.model.base.ManagedObjectModel");}}else if(q[P]!==v){var V=h(N);var t=f(V[1].node),w=V[2];var x=t;for(var i=0;i<w.length;i++){x=x[w[i]];}x[P]=v;var y="/"+P;if(w.length>0){y="/"+w.join("/")+y;}var D=r.lastIndexOf(y);var z=r.substr(0,D);return this.setProperty(z,t,o);}}return false;};
m.prototype.addBinding=function(B){J.prototype.addBinding.apply(this,arguments);if(B instanceof k){var A=B.sPath.replace("/","");this.mListBinding[A]=B;}B.checkUpdate(false);};
m.prototype.removeBinding=function(B){J.prototype.removeBinding.apply(this,arguments);if(B instanceof k){var A=B.sPath.replace("/","");delete this.mListBinding[A];}this._observeBeforeEvaluating(B,false);};
m.prototype.firePropertyChange=function(p){if(p.reason===d.Binding){p.resolvedPath=this.resolve(p.path,p.context);}J.prototype.firePropertyChange.call(this,p);};
m.prototype.bindAggregation=function(p,o,P){return J.prototype.bindProperty.apply(this,arguments);};
m.prototype.bindProperty=function(p,o,P){var B=new l(this,p,o,P);return B;};
m.prototype.bindList=function(p,o,s,F,P){var B=new k(this,p,o,s,F,P);return B;};
m.prototype.getManagedObject=function(p,o){if(p instanceof C){o=p;p=o.getPath();}var O=this.getProperty(p,o);if(O instanceof M){return O;}return null;};
m.prototype.getRootObject=function(){return this._oObject;};
m.prototype._observePropertyChange=function(o,p){if(!o||!p){return;}var K=o.getId()+"/@"+p.name;if(!this._oObserver.isObserved(o,{properties:[p.name]})){this._oObserver.observe(o,{properties:[p.name]});this._mObservedCount.properties[K]=1;}else{this._mObservedCount.properties[K]++;}};
m.prototype._unobservePropertyChange=function(o,p){if(!o||!p){return;}var K=o.getId()+"/@"+p.name;this._mObservedCount.properties[K]--;if(this._mObservedCount.properties[K]==0){this._oObserver.unobserve(o,{properties:[p.name]});delete this._mObservedCount.properties[K];}};
m.prototype._observeAggregationChange=function(o,A){if(!o||!A){return;}var K=o.getId()+"/@"+A.name;if(!this._oObserver.isObserved(o,{aggregations:[A.name]})){this._oObserver.observe(o,{aggregations:[A.name]});this._mObservedCount.aggregations[K]=1;_(this,o,A,true);}else{this._mObservedCount.aggregations[K]++;}};
m.prototype._unobserveAggregationChange=function(o,A){if(!o||!A){return;}var K=o.getId()+"/@"+A.name;this._mObservedCount.aggregations[K]--;if(this._mObservedCount.aggregations[K]==0){this._oObserver.unobserve(o,{aggregations:[A.name]});delete this._mObservedCount.aggregations[K];}};
m.prototype._createId=function(i){var o=this._oObject;if(typeof o.createId==="function"){return o.createId(i);}if(!i){return o.getId()+I+u();}if(i.indexOf(o.getId()+I)!=0){return o.getId()+I+i;}return i;};
m.prototype._getSpecialNode=function(n,s,p,P){if(n instanceof M){if(s==="className"){if(n.getMetadata){return n.getMetadata().getName();}else{return typeof n;}}else if(s==="id"){return n.getId();}else if(s==="metadataContexts"){return n._oProviderData;}}else if(s==="binding"&&p&&P){return p.getBinding(P);}else if(s==="bound"&&p&&P){return p.isBound(P);}else if(s==="bindingInfo"&&p&&P){return p.getBindingInfo(P);}else if(Array.isArray(n)){if(s==="length"){return n.length;}else if(s.indexOf("id=")===0){var o=s.substring(3),F=null;for(var i=0;i<n.length;i++){if(n[i].getId()===this._createId(o)||n[i].getId()===o){F=n[i];break;}}return F;}}return null;};
m.prototype._getObject=function(p,o,n){var N=this._oObject,r="",t=this;if(n){n.push({path:"/",node:N});}this.aBindings.forEach(function(B){if(!B._bAttached){t._observeBeforeEvaluating(B,true);}});if(typeof p==="string"&&p.indexOf("/")!=0&&!o){return null;}if(o instanceof M){N=o;r=p;}else if(!o||o instanceof C){r=this.resolve(p,o);if(!r){return N;}if(r.indexOf("/"+g)===0){return J.prototype._getObject.apply(this,[p,o]);}}else{N=o;r=p;}if(!N){return null;}var P=r.split("/"),i=0;if(!P[0]){i++;}var q=null,s=null,v;while(N!==null&&P[i]){v=P[i];if(v=="id"){v="@id";}if(v.indexOf("@")===0){N=this._getSpecialNode(N,v.substring(1),q,s);}else if(N instanceof M){var w=N.getMetadata();if(w.isInstanceOf("sap.ui.core.IDScope")&&v.indexOf("#")===0){N=N.byId(v.substring(1));}else{q=N;s=v;var x=w.getManagedProperty(v);if(x){N=x.get(N);}else{var A=w.getManagedAggregation(v);if(A){N=A.get(N);}else{if(N&&N[v]&&typeof N[v]==="function"){N=N[v]();}else{N=null;}}}}}else if(Array.isArray(N)||e(N)){N=N[v];}else{if(N&&N[v]&&typeof N[v]==="function"){N=N[v]();}else{N=null;}}if(n){n.push({path:v,node:N});}i++;}return N;};
m.prototype.destroy=function(){for(var n in this._mAggregationObjects){var o=this._mAggregationObjects[n];if(o.object.invalidate.fn){o.object.invalidate=o.object.invalidate.fn;}}J.prototype.destroy.apply(this,arguments);};
m.prototype._observeBeforeEvaluating=function(B,o){if(!B.isResolved()){return;}var p=B.getPath();var i=B.getContext(),n=this._oObject,r;if(i instanceof M){n=i;r=p;}else if(!i||i instanceof C){r=this.resolve(p,i);if(!r){return;}if(r.indexOf("/"+g)===0){return;}}else{return;}var P=r.split("/");if(!P[0]){P.shift();}var s=P[0];if(n.getMetadata().isInstanceOf("sap.ui.core.IDScope")&&s.indexOf("#")===0){n=n.byId(s.substring(1));s=P[1];}if(n instanceof M){var N=n.getMetadata(),q=N.getManagedProperty(s);if(q){if(o===true){this._observePropertyChange(n,q);}else if(o===false){this._unobservePropertyChange(n,q);}}else{var A=N.getAggregation(s)||N.getAllPrivateAggregations()[s];if(A){if(o===true){this._observeAggregationChange(n,A);}else if(o===false){this._unobserveAggregationChange(n,A);}}}B._bAttached=o;}};
m.prototype.observerChanges=function(o){if(o.type=="aggregation"){var A={};if(o.child instanceof M){A=o.child.getMetadata().getAllAggregations();}if(o.mutation=="insert"){if(o.child instanceof M){this._oObserver.observe(o.child,{properties:true,aggregations:true});}for(var K in A){_(this,o.child,A[K],true);}if(this.mListBinding[o.name]){var i=this._oObject.getBinding(o.name);var n=this._oObject.getAggregation(o.name);if(i&&i.getCurrentContexts().length!=n.length){return;}}}else{if(o.child instanceof M){this._oObserver.unobserve(o.child,{properties:true,aggregations:true});}for(var K in A){_(this,o.child,A[K],false);}}}else if(o.type==="property"){this.aBindings.forEach(function(B){if(B._mightBeAffectedByChangesInside&&B._mightBeAffectedByChangesInside(o.object)){B.checkUpdate(true);}});}this.checkUpdate();};
m.prototype.checkUpdate=function(F,A,i){if(A){if(!this.sUpdateTimer){this.sUpdateTimer=setTimeout(function(){this.checkUpdate(F,false,i);}.bind(this),0);}return;}if(this.sUpdateTimer){clearTimeout(this.sUpdateTimer);this.sUpdateTimer=null;}var B=this.aBindings.slice(0);B.forEach(function(o){if(!i||i(o)){o.checkUpdate(F);}});};
return m;});
sap.ui.predefine('sap/ui/model/base/XMLNodeAttributesModel',['../json/JSONModel','sap/ui/base/ManagedObject','./XMLNodeUtils','sap/ui/core/util/reflection/XmlTreeModifier'],function(J,M,U,X){"use strict";
var a=J.extend("sap.ui.model.base.XMLNodeAttributesModel",{
constructor:function(n,c,C){this.oCallback=c;this.oNode=n;this.sContext=C;this.getMetadata();J.apply(this,[n]);},
evalMode:{simple:"",binding:"@binding",bindingStr:"@bindingStr",data:"@data",metaContext:"@metaContext"}
});
a.prototype.getMetadata=function(){if(!this.oMetadata){var n=this.oNode.namespaceURI,c=U.findControlClass(n,U.localName(this.oNode));this.oMetadata=c.getMetadata();this.mAggregations=this.oMetadata.getAllAggregations();this.mProperties=this.oMetadata.getAllProperties();this.mSpecialSettings=this.oMetadata._mAllSpecialSettings;this.mEvent=this.oMetadata.getAllEvents();}return this.oMetadata;};
a.prototype.getVisitor=function(){return this.oCallback;};
a.prototype.getProperty=function(p,c){p=p||"/";var r,C=p.length==0;var e=this.evalMode.simple;p=this.resolve(p,c);p=p.substring(1);var P=p.split("/");var d=P.indexOf("@data");var m=P.indexOf("@metaContext");if(d>-1){e=this.evalMode.data;P.splice(d,1);}else if(m>-1){var b=P.slice(0,m);var s=P.slice(m+1,P.length);var o=this._diveDeep(b,C,this.evalMode.metaContext);r=this._getAnnotation(s,o);return r;}else{var l=P[P.length-1];if(l.startsWith("@")){P.splice(-1,1);e=l;}}if(P[0]=="metadataContexts"){var f=this.oNode.getAttribute("metadataContexts");if(P.length==1){r=f;}else{var g=M.bindingParser(f);switch(P[1]){case"model":r=g.model;break;case"data":P.splice(1,1);r=this._diveDeep(P,C,this.evalMode.data);break;default:r=f;break;}}}else{r=this._diveDeep(P,C,e);}return r;};
a.prototype.getAggregation=a.prototype.getProperty;a.prototype.getSpecialSetting=a.prototype.getProperty;a.prototype.getEvent=a.prototype.getProperty;
a.prototype._diveDeep=function(p,c,e){var r=this._getTopProperty(p[0],e);if(p.length>1){p.shift();for(var i=0;i<p.length;i++){if(r){r=r[p[i]];}}}return r;};
a.prototype._getTopProperty=function(p,e){var r=null;var P;if(p.length==0){return this.oNode;}if(this.mProperties.hasOwnProperty(p)){P=this.mProperties[p];if(e===this.evalMode.simple){e=this.evalMode.data;}if(!this.oNode.hasAttribute(p)){r=P.defaultValue;}else{r=this.oNode.getAttribute(p);}}else if(this.mAggregations.hasOwnProperty(p)){if(this.oNode.hasAttribute(p)){r=this.oNode.getAttribute(p);}else{r=X.getAggregation(this.oNode,p);}}else if(!this.mSpecialSettings.hasOwnProperty(p)&&!this.mEvents.hasOwnProperty(p)){r=null;}else{if(this.oNode.hasAttribute(p)){r=this.oNode.getAttribute(p);}}var b=M.bindingParser(r);switch(e){case this.evalMode.simple:break;case this.evalMode.binding:r=b;break;case this.evalMode.bindingStr:if(!b){r="";}break;case this.evalMode.metaContext:var m={};if(b){if(typeof b==="string"){b=M.bindingParser("{"+b+"}");}var o=this.oCallback.getSettings().models[b.model];if(o){m.metaModel=o.getMetaModel();if(m.metaModel&&m.metaModel.getMetaContext){m.metaContext=m.metaModel.getMetaContext(b.path);m.schema=m.metaModel.getProperty(m.metaContext.getPath());}}r=m;}return r;case this.evalMode.data:if(b){var R=null;try{R=this.oCallback.getResult(r);}catch(c){}if(R){r=R;}}break;}if(r){if(P){var s=U.parseScalarType(P.type,r,p);if(!(typeof s==="object"&&s.path)){r=s;}}}return r;};
a.prototype._getObject=function(p,c,C){p=this.resolve(p,c);var i,o=this.getProperty(p,c);if(Array.isArray(o)){var l=o;var P=function(b){return function(){return p+"/"+b;};};for(i=0;i<l.length;i++){l[i].getPath=P(i);}return l;}return o;};
a.prototype.getContextName=function(){return this.sContext;};
a.prototype._getAnnotation=function(p,m){var A=m.schema;var i=0;while(A&&p[i]){A=A[p[i]];i++;}return A;};
return a;});
sap.ui.predefine('sap/ui/model/base/XMLNodeUtils',['sap/ui/thirdparty/jquery','sap/ui/base/DataType','sap/ui/base/ManagedObject','sap/base/util/ObjectPath','sap/base/Log'],function(q,D,M,O,L){"use strict";return{parseScalarType:function(t,v,n,c){var b=M.bindingParser(v,c,true);if(b&&typeof b==="object"){return b;}var V=v=b||v;var T=D.getType(t);if(T){if(T instanceof D&&!T.isValid(V)){V=T.parseValue(v);}}else{throw new Error("Property "+n+" has unknown type "+t);}return typeof V==="string"?M.bindingParser.escape(V):V;},localName:function(x){return x.localName||x.baseName||x.nodeName;},findControlClass:function(n,l){var c;var m=sap.ui.getCore().getLoadedLibraries();q.each(m,function(s,o){if(n===o.namespace||n===o.name){c=o.name+"."+((o.tagNames&&o.tagNames[l])||l);}});c=c||n+"."+l;var C=sap.ui.requireSync(c.replace(/\./g,"/"));C=C||O.get(c);if(C){return C;}else{L.error("Can't find object class '"+c+"' for XML-view","","XMLTemplateProcessor.js");}},getChildren:function(N){var i,o=N.childNodes,n=o.length,c=[];for(i=0;i<n;i++){if(o.item(i).nodeType===1){c.push(o.item(i));}}return c;}};});
sap.ui.predefine('sap/ui/model/meta/AdapterConstants',[],function(){"use strict";return{TextArrangement:{TextOnly:"TextOnly",TextFirst:"TextFirst",TextLast:"TextLast",TextSeparate:"TextSeparate"},Relation:{atMostOne:"0..1",one:"1",many:"n"},SupportedSortDirection:{none:"none",both:"both",asc:"ascending",desc:"descending"},Status:{None:undefined,VeryNegative:-1,Neutral:0,Negative:1,Critical:2,Positive:3,VeryPositive:4},Importance:{None:undefined,High:0,Medium:1,Low:2},ContactType:{fn:"formattedName",photo:"photo",role:"role",title:"title",org:"org",adr:"addresses",email:"emails",tel:"phones"},AddressType:{street:"street",code:"code",locality:"locality",region:"region",country:"country"},EmailAddressType:{address:"uri"},PhoneNumberType:{uri:"uri"}};});
sap.ui.predefine('sap/ui/model/meta/AdapterFactory',[],function(){"use strict";var A=function(){};
A.requestAdapter=function(m){return null;};
A.getAdapter=function(m){return null;};
return A;});
sap.ui.predefine('sap/ui/model/meta/BaseAdapter',["sap/ui/base/Object","./AdapterConstants","sap/ui/model/json/JSONModel","sap/ui/base/SyncPromise"],function(B,A,J,S){"use strict";
var a=B.extend("sap.ui.model.meta.BaseAdapter",{
oMetaModel:undefined,
sModelName:undefined,
constructor:function(m,p){this.constants=A;this.mMetadataContext=m;this.oModel=m.model;this.oMetaModel=this.oModel.getMetaModel();this.modelName=m.modelName;this.contextName=m.contextName;this.path=m.path;this.metaPath=m.metaPath;this._mProperties={};this._mPropertyBag={};this._mCustomPropertyBag={};this.init();this.enhance(p);},
enhance:function(p){if(p){for(var P in p){this.putProperty(P,p[P]);}}},
init:function(){if(!this.metaPath){this.oMetaContext=this.oMetaModel.getMetaContext(this.path);this.metaPath=this.oMetaContext.getPath();}else{this.oMetaContext=this.oMetaModel.createBindingContext(this.metaPath);}},
getModelName:function(){return this.modelName;},
putProperty:function(p,g,b,c){if(!g){return;}if(!c){c=this;}Object.defineProperty(this,p,{configurable:true,get:function(){if(this._mCustomPropertyBag[p]){return this._mCustomPropertyBag[p];}if(!this._mPropertyBag.hasOwnProperty(p)){this._mPropertyBag[p]=new S(function(r,d){if(typeof g=='function'){r(g.apply(c,b));}else{r(g);}});}return this._mPropertyBag[p];},set:function(v){this._mCustomPropertyBag[p]=v;}});},
convertToSimpleBinding:function(v,t){var p="{";if(this.modelName){p=p+"model: '"+this.modelName+"',";}if(this.sContextPath&&v.startsWith(this.sContextPath)){v=v.replace(this.sContextPath,"");}p=p+"path: '"+escape(v)+"'";if(t){p=p+", type: '"+t+"'";}p=p+"}";return p;},
getContext:function(){return this.contextName;},
setValue:function(p,v){this.putProperty(p,this._identity,[v],this);},
_identity:function(v){return v;},
parentPromise:function(p,m){return new Promise(function(r,b){sap.ui.require([p],function(P){var o=new P(m);r(o);},b);});},
getAdapterModel:function(){if(!this._oAdapterModel){this._oAdapterModel=new J(this);}return this._oAdapterModel;},
updateContextPath:function(c){var C=c.getBindingContext(this.model);var s=C?this.removeKeys(C.getPath())+"/":null;if(s&&s!=this.sContextPath){this.sContextPath=s;this._mPropertyBag={};}},
removeKeys:function(p){return p;},
sibling:function(s){if(!s){return null;}var m={model:this.oModel,path:s};var c=this.getMetadata().getClass();var o=new c(m);o.sContextPath=this.sContextPath;return o;}
});
return a;});
/**
 * @license
 * Lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash strict include="omit,uniq,uniqBy,uniqWith,intersection,intersectionBy,intersectionWith,pick,pickBy,debounce,throttle,max,min,castArray,curry,merge,mergeWith,toArray,xor,xorBy,xorWith,isNil,difference,differenceBy,differenceWith,flatMap,flatMapDeep,flatMapDepth,isEqual,isEqualWith,without,flatten,flattenDeep,flattenDepth,compact,zipObject,zipObjectDeep,union,unionBy,unionWith"`
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
sap.ui.predefine('sap/base/util/restricted/_/lodash.custom',function(){'use strict';var u;var V='4.17.19';var L=200;var F='Expected a function';var H='__lodash_hash_undefined__';var M=500;var P='__lodash_placeholder__';var C=1,a=2,b=4;var c=1,d=2;var W=1,f=2,g=4,h=8,i=16,j=32,k=64,l=128,m=256,o=512;var p=800,q=16;var I=1/0,r=9007199254740991,s=1.7976931348623157e+308,N=0/0;var t=4294967295;var w=[['ary',l],['bind',W],['bindKey',f],['curry',h],['curryRight',i],['flip',o],['partial',j],['partialRight',k],['rearg',m]];var v='[object Arguments]',x='[object Array]',y='[object AsyncFunction]',z='[object Boolean]',A='[object Date]',B='[object Error]',D='[object Function]',E='[object GeneratorFunction]',G='[object Map]',J='[object Number]',K='[object Null]',O='[object Object]',Q='[object Promise]',R='[object Proxy]',S='[object RegExp]',T='[object Set]',U='[object String]',X='[object Symbol]',Y='[object Undefined]',Z='[object WeakMap]';var $='[object ArrayBuffer]',_='[object DataView]',a1='[object Float32Array]',b1='[object Float64Array]',c1='[object Int8Array]',d1='[object Int16Array]',e1='[object Int32Array]',f1='[object Uint8Array]',g1='[object Uint8ClampedArray]',h1='[object Uint16Array]',i1='[object Uint32Array]';var j1=/\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,k1=/^\w*$/,l1=/[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;var m1=/[\\^$.*+?()[\]{}|]/g;var n1=/^\s+|\s+$/g;var o1=/\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/,p1=/\{\n\/\* \[wrapped with (.+)\] \*/,q1=/,? & /;var r1=/\\(\\)?/g;var s1=/\w*$/;var t1=/^[-+]0x[0-9a-f]+$/i;var u1=/^0b[01]+$/i;var v1=/^\[object .+?Constructor\]$/;var w1=/^0o[0-7]+$/i;var x1=/^(?:0|[1-9]\d*)$/;var y1='\\ud800-\\udfff',z1='\\u0300-\\u036f',A1='\\ufe20-\\ufe2f',B1='\\u20d0-\\u20ff',C1=z1+A1+B1,D1='\\ufe0e\\ufe0f';var E1='['+y1+']',F1='['+C1+']',G1='\\ud83c[\\udffb-\\udfff]',H1='(?:'+F1+'|'+G1+')',I1='[^'+y1+']',J1='(?:\\ud83c[\\udde6-\\uddff]){2}',K1='[\\ud800-\\udbff][\\udc00-\\udfff]',L1='\\u200d';var M1=H1+'?',N1='['+D1+']?',O1='(?:'+L1+'(?:'+[I1,J1,K1].join('|')+')'+N1+M1+')*',P1=N1+M1+O1,Q1='(?:'+[I1+F1+'?',F1,J1,K1,E1].join('|')+')';var R1=RegExp(G1+'(?='+G1+')|'+Q1+P1,'g');var S1=RegExp('['+L1+y1+C1+D1+']');var T1={};T1[a1]=T1[b1]=T1[c1]=T1[d1]=T1[e1]=T1[f1]=T1[g1]=T1[h1]=T1[i1]=true;T1[v]=T1[x]=T1[$]=T1[z]=T1[_]=T1[A]=T1[B]=T1[D]=T1[G]=T1[J]=T1[O]=T1[S]=T1[T]=T1[U]=T1[Z]=false;var U1={};U1[v]=U1[x]=U1[$]=U1[_]=U1[z]=U1[A]=U1[a1]=U1[b1]=U1[c1]=U1[d1]=U1[e1]=U1[G]=U1[J]=U1[O]=U1[S]=U1[T]=U1[U]=U1[X]=U1[f1]=U1[g1]=U1[h1]=U1[i1]=true;U1[B]=U1[D]=U1[Z]=false;var V1=parseInt;var W1=typeof global=='object'&&global&&global.Object===Object&&global;var X1=typeof self=='object'&&self&&self.Object===Object&&self;var Y1=W1||X1||Function('return this')();var Z1=typeof exports=='object'&&exports&&!exports.nodeType&&exports;var $1=Z1&&typeof module=='object'&&module&&!module.nodeType&&module;var _1=$1&&$1.exports===Z1;var a2=_1&&W1.process;var b2=(function(){try{var n=$1&&$1.require&&$1.require('util').types;if(n){return n;}return a2&&a2.binding&&a2.binding('util');}catch(e){}}());var c2=b2&&b2.isMap,d2=b2&&b2.isSet,e2=b2&&b2.isTypedArray;
function f2(e,n,Y6){switch(Y6.length){case 0:return e.call(n);case 1:return e.call(n,Y6[0]);case 2:return e.call(n,Y6[0],Y6[1]);case 3:return e.call(n,Y6[0],Y6[1],Y6[2]);}return e.apply(n,Y6);}
function g2(e,H7){var n=-1,Y6=e==null?0:e.length;while(++n<Y6){if(H7(e[n],n,e)===false){break;}}return e;}
function h2(e,n){var Y6=-1,O7=e==null?0:e.length,P7=0,Q7=[];while(++Y6<O7){var R7=e[Y6];if(n(R7,Y6,e)){Q7[P7++]=R7;}}return Q7;}
function i2(e,n){var Y6=e==null?0:e.length;return!!Y6&&p2(e,n,0)>-1;}
function j2(e,n,Y6){var O7=-1,P7=e==null?0:e.length;while(++O7<P7){if(Y6(n,e[O7])){return true;}}return false;}
function k2(e,H7){var n=-1,Y6=e==null?0:e.length,O7=Array(Y6);while(++n<Y6){O7[n]=H7(e[n],n,e);}return O7;}
function l2(e,E7){var n=-1,Y6=E7.length,O7=e.length;while(++n<Y6){e[O7+n]=E7[n];}return e;}
function m2(e,n){var Y6=-1,O7=e==null?0:e.length;while(++Y6<O7){if(n(e[Y6],Y6,e)){return true;}}return false;}
function n2(e){return e.split('');}
function o2(e,n,Y6,O7){var P7=e.length,Q7=Y6+(O7?1:-1);while((O7?Q7--:++Q7<P7)){if(n(e[Q7],Q7,e)){return Q7;}}return-1;}
function p2(e,n,Y6){return n===n?E2(e,n,Y6):o2(e,q2,Y6);}
function q2(e){return e!==e;}
function r2(e){return function(n){return n==null?u:n[e];};}
function s2(n,H7){var e=-1,Y6=Array(n);while(++e<n){Y6[e]=H7(e);}return Y6;}
function t2(e){return function(n){return e(n);};}
function u2(e,n){return k2(n,function(Y6){return e[Y6];});}
function v2(e,n){return e.has(n);}
function w2(e,n){var Y6=e.length,O7=0;while(Y6--){if(e[Y6]===n){++O7;}}return O7;}
function x2(e,n){return e==null?u:e[n];}
function y2(e){return S1.test(e);}
function z2(e){var n,Y6=[];while(!(n=e.next()).done){Y6.push(n.value);}return Y6;}
function A2(R6){var e=-1,n=Array(R6.size);R6.forEach(function(Y6,O7){n[++e]=[O7,Y6];});return n;}
function B2(e,n){return function(Y6){return e(n(Y6));};}
function C2(e,n){var Y6=-1,O7=e.length,P7=0,Q7=[];while(++Y6<O7){var R7=e[Y6];if(R7===n||R7===P){e[Y6]=P;Q7[P7++]=Y6;}}return Q7;}
function D2(e){var n=-1,Y6=Array(e.size);e.forEach(function(O7){Y6[++n]=O7;});return Y6;}
function E2(e,n,Y6){var O7=Y6-1,P7=e.length;while(++O7<P7){if(e[O7]===n){return O7;}}return-1;}
function F2(e){return y2(e)?G2(e):n2(e);}
function G2(e){return e.match(R1)||[];}
var H2=Array.prototype,I2=Function.prototype,J2=Object.prototype;var K2=Y1['__core-js_shared__'];var L2=I2.toString;var M2=J2.hasOwnProperty;var N2=(function(){var e=/[^.]+$/.exec(K2&&K2.keys&&K2.keys.IE_PROTO||'');return e?('Symbol(src)_1.'+e):'';}());var O2=J2.toString;var P2=L2.call(Object);var Q2=RegExp('^'+L2.call(M2).replace(m1,'\\$&').replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g,'$1.*?')+'$');var R2=_1?Y1.Buffer:u,S2=Y1.Symbol,T2=Y1.Uint8Array,U2=R2?R2.allocUnsafe:u,V2=B2(Object.getPrototypeOf,Object),W2=Object.create,X2=J2.propertyIsEnumerable,Y2=H2.splice,Z2=S2?S2.isConcatSpreadable:u,$2=S2?S2.iterator:u,_2=S2?S2.toStringTag:u;var a3=(function(){try{var n=I5(Object,'defineProperty');n({},'',{});return n;}catch(e){}}());var b3=Object.getOwnPropertySymbols,c3=R2?R2.isBuffer:u,d3=B2(Object.keys,Object),e3=Math.max,f3=Math.min,g3=Date.now;var h3=I5(Y1,'DataView'),i3=I5(Y1,'Map'),j3=I5(Y1,'Promise'),k3=I5(Y1,'Set'),l3=I5(Y1,'WeakMap'),m3=I5(Object,'create');var n3=l3&&new l3;var o3={};var p3=p6(h3),q3=p6(i3),r3=p6(j3),s3=p6(k3),t3=p6(l3);var u3=S2?S2.prototype:u,v3=u3?u3.valueOf:u,w3=u3?u3.toString:u;
function x3(){}
var y3=(function(){function e(){}return function(n){if(!g7(n)){return{};}if(W2){return W2(n);}e.prototype=n;var Y6=new e;e.prototype=u;return Y6;};}());
function z3(){}
function A3(e){this.__wrapped__=e;this.__actions__=[];this.__dir__=1;this.__filtered__=false;this.__iteratees__=[];this.__takeCount__=t;this.__views__=[];}
A3.prototype=y3(z3.prototype);A3.prototype.constructor=A3;
function B3(e){var n=-1,Y6=e==null?0:e.length;this.clear();while(++n<Y6){var O7=e[n];this.set(O7[0],O7[1]);}}
function C3(){this.__data__=m3?m3(null):{};this.size=0;}
function D3(e){var n=this.has(e)&&delete this.__data__[e];this.size-=n?1:0;return n;}
function E3(e){var n=this.__data__;if(m3){var Y6=n[e];return Y6===H?u:Y6;}return M2.call(n,e)?n[e]:u;}
function F3(e){var n=this.__data__;return m3?(n[e]!==u):M2.call(n,e);}
function G3(e,n){var Y6=this.__data__;this.size+=this.has(e)?0:1;Y6[e]=(m3&&n===u)?H:n;return this;}
B3.prototype.clear=C3;B3.prototype['delete']=D3;B3.prototype.get=E3;B3.prototype.has=F3;B3.prototype.set=G3;
function H3(e){var n=-1,Y6=e==null?0:e.length;this.clear();while(++n<Y6){var O7=e[n];this.set(O7[0],O7[1]);}}
function I3(){this.__data__=[];this.size=0;}
function J3(e){var n=this.__data__,Y6=d4(n,e);if(Y6<0){return false;}var O7=n.length-1;if(Y6==O7){n.pop();}else{Y2.call(n,Y6,1);}--this.size;return true;}
function K3(e){var n=this.__data__,Y6=d4(n,e);return Y6<0?u:n[Y6][1];}
function L3(e){return d4(this.__data__,e)>-1;}
function M3(e,n){var Y6=this.__data__,O7=d4(Y6,e);if(O7<0){++this.size;Y6.push([e,n]);}else{Y6[O7][1]=n;}return this;}
H3.prototype.clear=I3;H3.prototype['delete']=J3;H3.prototype.get=K3;H3.prototype.has=L3;H3.prototype.set=M3;
function N3(e){var n=-1,Y6=e==null?0:e.length;this.clear();while(++n<Y6){var O7=e[n];this.set(O7[0],O7[1]);}}
function O3(){this.size=0;this.__data__={'hash':new B3,'map':new(i3||H3),'string':new B3};}
function P3(e){var n=G5(this,e)['delete'](e);this.size-=n?1:0;return n;}
function Q3(e){return G5(this,e).get(e);}
function R3(e){return G5(this,e).has(e);}
function S3(e,n){var Y6=G5(this,e),O7=Y6.size;Y6.set(e,n);this.size+=Y6.size==O7?0:1;return this;}
N3.prototype.clear=O3;N3.prototype['delete']=P3;N3.prototype.get=Q3;N3.prototype.has=R3;N3.prototype.set=S3;
function T3(E7){var e=-1,n=E7==null?0:E7.length;this.__data__=new N3;while(++e<n){this.add(E7[e]);}}
function U3(e){this.__data__.set(e,H);return this;}
function V3(e){return this.__data__.has(e);}
T3.prototype.add=T3.prototype.push=U3;T3.prototype.has=V3;
function W3(e){var n=this.__data__=new H3(e);this.size=n.size;}
function X3(){this.__data__=new H3;this.size=0;}
function Y3(e){var n=this.__data__,Y6=n['delete'](e);this.size=n.size;return Y6;}
function Z3(e){return this.__data__.get(e);}
function $3(e){return this.__data__.has(e);}
function _3(e,n){var Y6=this.__data__;if(Y6 instanceof H3){var O7=Y6.__data__;if(!i3||(O7.length<L-1)){O7.push([e,n]);this.size=++Y6.size;return this;}Y6=this.__data__=new N3(O7);}Y6.set(e,n);this.size=Y6.size;return this;}
W3.prototype.clear=X3;W3.prototype['delete']=Y3;W3.prototype.get=Z3;W3.prototype.has=$3;W3.prototype.set=_3;
function a4(e,n){var Y6=$6(e),O7=!Y6&&Z6(e),P7=!Y6&&!O7&&b7(e),Q7=!Y6&&!O7&&!P7&&o7(e),R7=Y6||O7||P7||Q7,S7=R7?s2(e.length,String):[],T7=S7.length;for(var U7 in e){if((n||M2.call(e,U7))&&!(R7&&(U7=='length'||(P7&&(U7=='offset'||U7=='parent'))||(Q7&&(U7=='buffer'||U7=='byteLength'||U7=='byteOffset'))||U5(U7,T7)))){S7.push(U7);}}return S7;}
function b4(e,n,Y6){if((Y6!==u&&!eq(e[n],Y6))||(Y6===u&&!(n in e))){g4(e,n,Y6);}}
function c4(e,n,Y6){var O7=e[n];if(!(M2.call(e,n)&&eq(O7,Y6))||(Y6===u&&!(n in e))){g4(e,n,Y6);}}
function d4(e,n){var Y6=e.length;while(Y6--){if(eq(e[Y6][0],n)){return Y6;}}return-1;}
function e4(e,n){return e&&h5(n,x7(n),e);}
function f4(e,n){return e&&h5(n,y7(n),e);}
function g4(e,n,Y6){if(n=='__proto__'&&a3){a3(e,n,{'configurable':true,'enumerable':true,'value':Y6,'writable':true});}else{e[n]=Y6;}}
function h4(e,n,Y6,O7,P7,Q7){var R7,S7=n&C,T7=n&a,U7=n&b;if(Y6){R7=P7?Y6(e,O7,P7,Q7):Y6(e);}if(R7!==u){return R7;}if(!g7(e)){return e;}var V7=$6(e);if(V7){R7=P5(e);if(!S7){return g5(e,R7);}}else{var W7=M5(e),X7=W7==D||W7==E;if(b7(e)){return $4(e,S7);}if(W7==O||W7==v||(X7&&!P7)){R7=(T7||X7)?{}:Q5(e);if(!S7){return T7?j5(e,f4(R7,e)):i5(e,e4(R7,e));}}else{if(!U1[W7]){return P7?e:{};}R7=R5(e,W7,S7);}}Q7||(Q7=new W3);var Y7=Q7.get(e);if(Y7){return Y7;}Q7.set(e,R7);if(l7(e)){e.forEach(function(_7){R7.add(h4(_7,n,Y6,_7,e,Q7));});}else if(i7(e)){e.forEach(function(_7,O7){R7.set(O7,h4(_7,n,Y6,O7,e,Q7));});}var Z7=U7?(T7?B5:A5):(T7?y7:x7);var $7=V7?u:Z7(e);g2($7||e,function(_7,O7){if($7){O7=_7;_7=e[O7];}c4(R7,O7,h4(_7,n,Y6,O7,e,Q7));});return R7;}
function i4(e,E7,H7,n){var Y6=-1,O7=i2,P7=true,Q7=e.length,R7=[],S7=E7.length;if(!Q7){return R7;}if(H7){E7=k2(E7,t2(H7));}if(n){O7=j2;P7=false;}else if(E7.length>=L){O7=v2;P7=false;E7=new T3(E7);}outer:while(++Y6<Q7){var T7=e[Y6],U7=H7==null?T7:H7(T7);T7=(n||T7!==0)?T7:0;if(P7&&U7===U7){var V7=S7;while(V7--){if(E7[V7]===U7){continue outer;}}R7.push(T7);}else if(!O7(E7,U7,n)){R7.push(T7);}}return R7;}
var j4=l5(n4);
function k4(e,H7,n){var Y6=-1,O7=e.length;while(++Y6<O7){var P7=e[Y6],Q7=H7(P7);if(Q7!=null&&(R7===u?(Q7===Q7&&!n7(Q7)):n(Q7,R7))){var R7=Q7,S7=P7;}}return S7;}
function l4(e,n,Y6,O7,P7){var Q7=-1,R7=e.length;Y6||(Y6=T5);P7||(P7=[]);while(++Q7<R7){var S7=e[Q7];if(n>0&&Y6(S7)){if(n>1){l4(S7,n-1,Y6,O7,P7);}else{l2(P7,S7);}}else if(!O7){P7[P7.length]=S7;}}return P7;}
var m4=m5();
function n4(e,H7){return e&&m4(e,H7,x7);}
function o4(e,n){n=Z4(n,e);var Y6=0,O7=n.length;while(e!=null&&Y6<O7){e=e[o6(n[Y6++])];}return(Y6&&Y6==O7)?e:u;}
function p4(e,n,Y6){var O7=n(e);return $6(e)?O7:l2(O7,Y6(e));}
function q4(e){if(e==null){return e===u?Y:K;}return(_2&&_2 in Object(e))?J5(e):e6(e);}
function r4(e,n){return e>n;}
function s4(e,n){return e!=null&&n in Object(e);}
function t4(e,H7,n){var Y6=n?j2:i2,O7=e[0].length,P7=e.length,Q7=P7,R7=Array(P7),S7=Infinity,T7=[];while(Q7--){var U7=e[Q7];if(Q7&&H7){U7=k2(U7,t2(H7));}S7=f3(U7.length,S7);R7[Q7]=!n&&(H7||(O7>=120&&U7.length>=120))?new T3(Q7&&U7):u;}U7=e[0];var V7=-1,W7=R7[0];outer:while(++V7<O7&&T7.length<S7){var X7=U7[V7],Y7=H7?H7(X7):X7;X7=(n||X7!==0)?X7:0;if(!(W7?v2(W7,Y7):Y6(T7,Y7,n))){Q7=P7;while(--Q7){var Z7=R7[Q7];if(!(Z7?v2(Z7,Y7):Y6(e[Q7],Y7,n))){continue outer;}}if(W7){W7.push(Y7);}T7.push(X7);}}return T7;}
function u4(e){return h7(e)&&q4(e)==v;}
function v4(e,n,Y6,O7,P7){if(e===n){return true;}if(e==null||n==null||(!h7(e)&&!h7(n))){return e!==e&&n!==n;}return w4(e,n,Y6,O7,v4,P7);}
function w4(e,n,Y6,O7,P7,Q7){var R7=$6(e),S7=$6(n),T7=R7?x:M5(e),U7=S7?x:M5(n);T7=T7==v?O:T7;U7=U7==v?O:U7;var V7=T7==O,W7=U7==O,X7=T7==U7;if(X7&&b7(e)){if(!b7(n)){return false;}R7=true;V7=false;}if(X7&&!V7){Q7||(Q7=new W3);return(R7||o7(e))?w5(e,n,Y6,O7,P7,Q7):x5(e,n,T7,Y6,O7,P7,Q7);}if(!(Y6&c)){var Y7=V7&&M2.call(e,'__wrapped__'),Z7=W7&&M2.call(n,'__wrapped__');if(Y7||Z7){var $7=Y7?e.value():e,_7=Z7?n.value():n;Q7||(Q7=new W3);return P7($7,_7,Y6,O7,Q7);}}if(!X7){return false;}Q7||(Q7=new W3);return y5(e,n,Y6,O7,P7,Q7);}
function x4(e){return h7(e)&&M5(e)==G;}
function y4(e,n,Y6,O7){var P7=Y6.length,Q7=P7,R7=!O7;if(e==null){return!Q7;}e=Object(e);while(P7--){var S7=Y6[P7];if((R7&&S7[2])?S7[1]!==e[S7[0]]:!(S7[0]in e)){return false;}}while(++P7<Q7){S7=Y6[P7];var T7=S7[0],U7=e[T7],V7=S7[1];if(R7&&S7[2]){if(U7===u&&!(T7 in e)){return false;}}else{var W7=new W3;if(O7){var X7=O7(U7,V7,T7,e,n,W7);}if(!(X7===u?v4(V7,U7,c|d,O7,W7):X7)){return false;}}}return true;}
function z4(e){if(!g7(e)||Z5(e)){return false;}var n=e7(e)?Q2:v1;return n.test(p6(e));}
function A4(e){return h7(e)&&M5(e)==T;}
function B4(e){return h7(e)&&f7(e.length)&&!!T1[q4(e)];}
function C4(e){if(typeof e=='function'){return e;}if(e==null){return G7;}if(typeof e=='object'){return $6(e)?I4(e[0],e[1]):H4(e);}return J7(e);}
function D4(e){if(!$5(e)){return d3(e);}var n=[];for(var Y6 in Object(e)){if(M2.call(e,Y6)&&Y6!='constructor'){n.push(Y6);}}return n;}
function E4(e){if(!g7(e)){return d6(e);}var n=$5(e),Y6=[];for(var O7 in e){if(!(O7=='constructor'&&(n||!M2.call(e,O7)))){Y6.push(O7);}}return Y6;}
function F4(e,n){return e<n;}
function G4(e,H7){var n=-1,Y6=_6(e)?Array(e.length):[];j4(e,function(O7,P7,e){Y6[++n]=H7(O7,P7,e);});return Y6;}
function H4(e){var n=H5(e);if(n.length==1&&n[0][2]){return a6(n[0][0],n[0][1]);}return function(Y6){return Y6===e||y4(Y6,e,n);};}
function I4(e,n){if(W5(e)&&_5(n)){return a6(o6(e),n);}return function(Y6){var O7=v7(Y6,e);return(O7===u&&O7===n)?w7(Y6,e):v4(n,O7,c|d);};}
function J4(e,n,Y6,O7,P7){if(e===n){return;}m4(n,function(Q7,R7){P7||(P7=new W3);if(g7(Q7)){K4(e,n,R7,Y6,J4,O7,P7);}else{var S7=O7?O7(i6(e,R7),Q7,(R7+''),e,n,P7):u;if(S7===u){S7=Q7;}b4(e,R7,S7);}},y7);}
function K4(e,n,Y6,O7,P7,Q7,R7){var S7=i6(e,Y6),T7=i6(n,Y6),U7=R7.get(T7);if(U7){b4(e,Y6,U7);return;}var V7=Q7?Q7(S7,T7,(Y6+''),e,n,R7):u;var W7=V7===u;if(W7){var X7=$6(T7),Y7=!X7&&b7(T7),Z7=!X7&&!Y7&&o7(T7);V7=T7;if(X7||Y7||Z7){if($6(S7)){V7=S7;}else if(a7(S7)){V7=g5(S7);}else if(Y7){W7=false;V7=$4(T7,true);}else if(Z7){W7=false;V7=d5(T7,true);}else{V7=[];}}else if(k7(T7)||Z6(T7)){V7=S7;if(Z6(S7)){V7=t7(S7);}else if(!g7(S7)||e7(S7)){V7=Q5(T7);}}else{W7=false;}}if(W7){R7.set(T7,V7);P7(V7,T7,O7,Q7,R7);R7['delete'](T7);}b4(e,Y6,V7);}
function L4(e,n){return M4(e,n,function(Y6,O7){return w7(e,O7);});}
function M4(e,n,Y6){var O7=-1,P7=n.length,Q7={};while(++O7<P7){var R7=n[O7],S7=o4(e,R7);if(Y6(S7,R7)){P4(Q7,Z4(R7,e),S7);}}return Q7;}
function N4(e){return function(n){return o4(n,e);};}
function O4(e,n){return k6(f6(e,n,G7),e+'');}
function P4(e,n,Y6,O7){if(!g7(e)){return e;}n=Z4(n,e);var P7=-1,Q7=n.length,R7=Q7-1,S7=e;while(S7!=null&&++P7<Q7){var T7=o6(n[P7]),U7=Y6;if(T7==='__proto__'||T7==='constructor'||T7==='prototype'){return e;}if(P7!=R7){var V7=S7[T7];U7=O7?O7(V7,T7,S7):u;if(U7===u){U7=g7(V7)?V7:(U5(n[P7+1])?[]:{});}}c4(S7,T7,U7);S7=S7[T7];}return e;}
var Q4=!n3?G7:function(e,n){n3.set(e,n);return e;};var R4=!a3?G7:function(e,n){return a3(e,'toString',{'configurable':true,'enumerable':false,'value':F7(n),'writable':true});};
function S4(e,n,Y6){var O7=-1,P7=e.length;if(n<0){n=-n>P7?0:(P7+n);}Y6=Y6>P7?P7:Y6;if(Y6<0){Y6+=P7;}P7=n>Y6?0:((Y6-n)>>>0);n>>>=0;var Q7=Array(P7);while(++O7<P7){Q7[O7]=e[O7+n];}return Q7;}
function T4(e){if(typeof e=='string'){return e;}if($6(e)){return k2(e,T4)+'';}if(n7(e)){return w3?w3.call(e):'';}var n=(e+'');return(n=='0'&&(1/e)==-I)?'-0':n;}
function U4(e,H7,n){var Y6=-1,O7=i2,P7=e.length,Q7=true,R7=[],S7=R7;if(n){Q7=false;O7=j2;}else if(P7>=L){var T7=H7?null:t5(e);if(T7){return D2(T7);}Q7=false;O7=v2;S7=new T3;}else{S7=H7?[]:R7;}outer:while(++Y6<P7){var U7=e[Y6],V7=H7?H7(U7):U7;U7=(n||U7!==0)?U7:0;if(Q7&&V7===V7){var W7=S7.length;while(W7--){if(S7[W7]===V7){continue outer;}}if(H7){S7.push(V7);}R7.push(U7);}else if(!O7(S7,V7,n)){if(S7!==R7){S7.push(V7);}R7.push(U7);}}return R7;}
function V4(e,n){n=Z4(n,e);e=g6(e,n);return e==null||delete e[o6(B6(n))];}
function W4(e,H7,n){var Y6=e.length;if(Y6<2){return Y6?U4(e[0]):[];}var O7=-1,P7=Array(Y6);while(++O7<Y6){var Q7=e[O7],R7=-1;while(++R7<Y6){if(R7!=O7){P7[O7]=i4(P7[O7]||Q7,e[R7],H7,n);}}}return U4(l4(P7,1),H7,n);}
function X4(e,E7,n){var Y6=-1,O7=e.length,P7=E7.length,Q7={};while(++Y6<O7){var R7=Y6<P7?E7[Y6]:u;n(Q7,e[Y6],R7);}return Q7;}
function Y4(e){return a7(e)?e:[];}
function Z4(e,n){if($6(e)){return e;}return W5(e,n)?[e]:n6(u7(e));}
function $4(e,n){if(n){return e.slice();}var Y6=e.length,O7=U2?U2(Y6):new e.constructor(Y6);e.copy(O7);return O7;}
function _4(e){var n=new e.constructor(e.byteLength);new T2(n).set(new T2(e));return n;}
function a5(e,n){var Y6=n?_4(e.buffer):e.buffer;return new e.constructor(Y6,e.byteOffset,e.byteLength);}
function b5(e){var n=new e.constructor(e.source,s1.exec(e));n.lastIndex=e.lastIndex;return n;}
function c5(e){return v3?Object(v3.call(e)):{};}
function d5(e,n){var Y6=n?_4(e.buffer):e.buffer;return new e.constructor(Y6,e.byteOffset,e.length);}
function e5(e,n,Y6,O7){var P7=-1,Q7=e.length,R7=Y6.length,S7=-1,T7=n.length,U7=e3(Q7-R7,0),V7=Array(T7+U7),W7=!O7;while(++S7<T7){V7[S7]=n[S7];}while(++P7<R7){if(W7||P7<Q7){V7[Y6[P7]]=e[P7];}}while(U7--){V7[S7++]=e[P7++];}return V7;}
function f5(e,n,Y6,O7){var P7=-1,Q7=e.length,R7=-1,S7=Y6.length,T7=-1,U7=n.length,V7=e3(Q7-S7,0),W7=Array(V7+U7),X7=!O7;while(++P7<V7){W7[P7]=e[P7];}var Y7=P7;while(++T7<U7){W7[Y7+T7]=n[T7];}while(++R7<S7){if(X7||P7<Q7){W7[Y7+Y6[R7]]=e[P7++];}}return W7;}
function g5(e,n){var Y6=-1,O7=e.length;n||(n=Array(O7));while(++Y6<O7){n[Y6]=e[Y6];}return n;}
function h5(e,n,Y6,O7){var P7=!Y6;Y6||(Y6={});var Q7=-1,R7=n.length;while(++Q7<R7){var S7=n[Q7];var T7=O7?O7(Y6[S7],e[S7],S7,Y6,e):u;if(T7===u){T7=e[S7];}if(P7){g4(Y6,S7,T7);}else{c4(Y6,S7,T7);}}return Y6;}
function i5(e,n){return h5(e,K5(e),n);}
function j5(e,n){return h5(e,L5(e),n);}
function k5(e){return O4(function(n,Y6){var O7=-1,P7=Y6.length,Q7=P7>1?Y6[P7-1]:u,R7=P7>2?Y6[2]:u;Q7=(e.length>3&&typeof Q7=='function')?(P7--,Q7):u;if(R7&&V5(Y6[0],Y6[1],R7)){Q7=P7<3?u:Q7;P7=1;}n=Object(n);while(++O7<P7){var S7=Y6[O7];if(S7){e(n,S7,O7,Q7);}}return n;});}
function l5(e,n){return function(Y6,H7){if(Y6==null){return Y6;}if(!_6(Y6)){return e(Y6,H7);}var O7=Y6.length,P7=n?O7:-1,Q7=Object(Y6);while((n?P7--:++P7<O7)){if(H7(Q7[P7],P7,Q7)===false){break;}}return Y6;};}
function m5(e){return function(n,H7,Y6){var O7=-1,P7=Object(n),Q7=Y6(n),R7=Q7.length;while(R7--){var S7=Q7[e?R7:++O7];if(H7(P7[S7],S7,P7)===false){break;}}return n;};}
function n5(e,n,Y6){var O7=n&W,P7=o5(e);function Q7(){var fn=(this&&this!==Y1&&this instanceof Q7)?P7:e;return fn.apply(O7?Y6:this,arguments);}return Q7;}
function o5(e){return function(){var n=arguments;switch(n.length){case 0:return new e;case 1:return new e(n[0]);case 2:return new e(n[0],n[1]);case 3:return new e(n[0],n[1],n[2]);case 4:return new e(n[0],n[1],n[2],n[3]);case 5:return new e(n[0],n[1],n[2],n[3],n[4]);case 6:return new e(n[0],n[1],n[2],n[3],n[4],n[5]);case 7:return new e(n[0],n[1],n[2],n[3],n[4],n[5],n[6]);}var Y6=y3(e.prototype),O7=e.apply(Y6,n);return g7(O7)?O7:Y6;};}
function p5(e,n,Y6){var O7=o5(e);function P7(){var Q7=arguments.length,R7=Array(Q7),S7=Q7,T7=E5(P7);while(S7--){R7[S7]=arguments[S7];}var U7=(Q7<3&&R7[0]!==T7&&R7[Q7-1]!==T7)?[]:C2(R7,T7);Q7-=U7.length;if(Q7<Y6){return s5(e,n,q5,P7.placeholder,u,R7,U7,u,u,Y6-Q7);}var fn=(this&&this!==Y1&&this instanceof P7)?O7:e;return f2(fn,this,R7);}return P7;}
function q5(e,n,Y6,O7,P7,Q7,R7,S7,T7,U7){var V7=n&l,W7=n&W,X7=n&f,Y7=n&(h|i),Z7=n&o,$7=X7?u:o5(e);function _7(){var a8=arguments.length,b8=Array(a8),c8=a8;while(c8--){b8[c8]=arguments[c8];}if(Y7){var d8=E5(_7),e8=w2(b8,d8);}if(O7){b8=e5(b8,O7,P7,Y7);}if(Q7){b8=f5(b8,Q7,R7,Y7);}a8-=e8;if(Y7&&a8<U7){var f8=C2(b8,d8);return s5(e,n,q5,_7.placeholder,Y6,b8,f8,S7,T7,U7-a8);}var g8=W7?Y6:this,fn=X7?g8[e]:e;a8=b8.length;if(S7){b8=h6(b8,S7);}else if(Z7&&a8>1){b8.reverse();}if(V7&&T7<a8){b8.length=T7;}if(this&&this!==Y1&&this instanceof _7){fn=$7||o5(fn);}return fn.apply(g8,b8);}return _7;}
function r5(e,n,Y6,O7){var P7=n&W,Q7=o5(e);function R7(){var S7=-1,T7=arguments.length,U7=-1,V7=O7.length,W7=Array(V7+T7),fn=(this&&this!==Y1&&this instanceof R7)?Q7:e;while(++U7<V7){W7[U7]=O7[U7];}while(T7--){W7[U7++]=arguments[++S7];}return f2(fn,P7?Y6:this,W7);}return R7;}
function s5(e,n,Y6,O7,P7,Q7,R7,S7,T7,U7){var V7=n&h,W7=V7?R7:u,X7=V7?u:R7,Y7=V7?Q7:u,Z7=V7?u:Q7;n|=(V7?j:k);n&=~(V7?k:j);if(!(n&g)){n&=~(W|f);}var $7=[e,n,P7,Y7,W7,Z7,X7,S7,T7,U7];var _7=Y6.apply(u,$7);if(Y5(e)){j6(_7,$7);}_7.placeholder=O7;return l6(_7,e,n);}
var t5=!(k3&&(1/D2(new k3([,-0]))[1])==I)?I7:function(E7){return new k3(E7);};
function u5(e,n,Y6,O7,P7,Q7,R7,S7){var T7=n&f;if(!T7&&typeof e!='function'){throw new TypeError(F);}var U7=O7?O7.length:0;if(!U7){n&=~(j|k);O7=P7=u;}R7=R7===u?R7:e3(r7(R7),0);S7=S7===u?S7:r7(S7);U7-=P7?P7.length:0;if(n&k){var V7=O7,W7=P7;O7=P7=u;}var X7=T7?u:C5(e);var Y7=[e,n,Y6,O7,P7,V7,W7,Q7,R7,S7];if(X7){c6(Y7,X7);}e=Y7[0];n=Y7[1];Y6=Y7[2];O7=Y7[3];P7=Y7[4];S7=Y7[9]=Y7[9]===u?(T7?0:e.length):e3(Y7[9]-U7,0);if(!S7&&n&(h|i)){n&=~(h|i);}if(!n||n==W){var Z7=n5(e,n,Y6);}else if(n==h||n==i){Z7=p5(e,n,S7);}else if((n==j||n==(W|j))&&!P7.length){Z7=r5(e,n,Y6,O7);}else{Z7=q5.apply(u,Y7);}var $7=X7?Q4:j6;return l6($7(Z7,Y7),e,n);}
function v5(e){return k7(e)?u:e;}
function w5(e,n,Y6,O7,P7,Q7){var R7=Y6&c,S7=e.length,T7=n.length;if(S7!=T7&&!(R7&&T7>S7)){return false;}var U7=Q7.get(e);var V7=Q7.get(n);if(U7&&V7){return U7==n&&V7==e;}var W7=-1,X7=true,Y7=(Y6&d)?new T3:u;Q7.set(e,n);Q7.set(n,e);while(++W7<S7){var Z7=e[W7],$7=n[W7];if(O7){var _7=R7?O7($7,Z7,W7,n,e,Q7):O7(Z7,$7,W7,e,n,Q7);}if(_7!==u){if(_7){continue;}X7=false;break;}if(Y7){if(!m2(n,function($7,a8){if(!v2(Y7,a8)&&(Z7===$7||P7(Z7,$7,Y6,O7,Q7))){return Y7.push(a8);}})){X7=false;break;}}else if(!(Z7===$7||P7(Z7,$7,Y6,O7,Q7))){X7=false;break;}}Q7['delete'](e);Q7['delete'](n);return X7;}
function x5(e,n,Y6,O7,P7,Q7,R7){switch(Y6){case _:if((e.byteLength!=n.byteLength)||(e.byteOffset!=n.byteOffset)){return false;}e=e.buffer;n=n.buffer;case $:if((e.byteLength!=n.byteLength)||!Q7(new T2(e),new T2(n))){return false;}return true;case z:case A:case J:return eq(+e,+n);case B:return e.name==n.name&&e.message==n.message;case S:case U:return e==(n+'');case G:var S7=A2;case T:var T7=O7&c;S7||(S7=D2);if(e.size!=n.size&&!T7){return false;}var U7=R7.get(e);if(U7){return U7==n;}O7|=d;R7.set(e,n);var V7=w5(S7(e),S7(n),O7,P7,Q7,R7);R7['delete'](e);return V7;case X:if(v3){return v3.call(e)==v3.call(n);}}return false;}
function y5(e,n,Y6,O7,P7,Q7){var R7=Y6&c,S7=A5(e),T7=S7.length,U7=A5(n),V7=U7.length;if(T7!=V7&&!R7){return false;}var W7=T7;while(W7--){var X7=S7[W7];if(!(R7?X7 in n:M2.call(n,X7))){return false;}}var Y7=Q7.get(e);var Z7=Q7.get(n);if(Y7&&Z7){return Y7==n&&Z7==e;}var $7=true;Q7.set(e,n);Q7.set(n,e);var _7=R7;while(++W7<T7){X7=S7[W7];var a8=e[X7],b8=n[X7];if(O7){var c8=R7?O7(b8,a8,X7,n,e,Q7):O7(a8,b8,X7,e,n,Q7);}if(!(c8===u?(a8===b8||P7(a8,b8,Y6,O7,Q7)):c8)){$7=false;break;}_7||(_7=X7=='constructor');}if($7&&!_7){var d8=e.constructor,e8=n.constructor;if(d8!=e8&&('constructor'in e&&'constructor'in n)&&!(typeof d8=='function'&&d8 instanceof d8&&typeof e8=='function'&&e8 instanceof e8)){$7=false;}}Q7['delete'](e);Q7['delete'](n);return $7;}
function z5(e){return k6(f6(e,u,v6),e+'');}
function A5(e){return p4(e,x7,K5);}
function B5(e){return p4(e,y7,L5);}
var C5=!n3?I7:function(e){return n3.get(e);};
function D5(e){var n=(e.name+''),Y6=o3[n],O7=M2.call(o3,n)?Y6.length:0;while(O7--){var P7=Y6[O7],Q7=P7.func;if(Q7==null||Q7==e){return P7.name;}}return n;}
function E5(e){var n=M2.call(x3,'placeholder')?x3:e;return n.placeholder;}
function F5(){var e=x3.iteratee||H7;e=e===H7?C4:e;return arguments.length?e(arguments[0],arguments[1]):e;}
function G5(R6,e){var n=R6.__data__;return X5(e)?n[typeof e=='string'?'string':'hash']:n.map;}
function H5(e){var n=x7(e),Y6=n.length;while(Y6--){var O7=n[Y6],P7=e[O7];n[Y6]=[O7,P7,_5(P7)];}return n;}
function I5(e,n){var Y6=x2(e,n);return z4(Y6)?Y6:u;}
function J5(n){var Y6=M2.call(n,_2),O7=n[_2];try{n[_2]=u;var P7=true;}catch(e){}var Q7=O2.call(n);if(P7){if(Y6){n[_2]=O7;}else{delete n[_2];}}return Q7;}
var K5=!b3?K7:function(e){if(e==null){return[];}e=Object(e);return h2(b3(e),function(n){return X2.call(e,n);});};var L5=!b3?K7:function(e){var n=[];while(e){l2(n,K5(e));e=V2(e);}return n;};var M5=q4;if((h3&&M5(new h3(new ArrayBuffer(1)))!=_)||(i3&&M5(new i3)!=G)||(j3&&M5(j3.resolve())!=Q)||(k3&&M5(new k3)!=T)||(l3&&M5(new l3)!=Z)){M5=function(e){var n=q4(e),Y6=n==O?e.constructor:u,O7=Y6?p6(Y6):'';if(O7){switch(O7){case p3:return _;case q3:return G;case r3:return Q;case s3:return T;case t3:return Z;}}return n;};}
function N5(e){var n=e.match(p1);return n?n[1].split(q1):[];}
function O5(e,n,Y6){n=Z4(n,e);var O7=-1,P7=n.length,Q7=false;while(++O7<P7){var R7=o6(n[O7]);if(!(Q7=e!=null&&Y6(e,R7))){break;}e=e[R7];}if(Q7||++O7!=P7){return Q7;}P7=e==null?0:e.length;return!!P7&&f7(P7)&&U5(R7,P7)&&($6(e)||Z6(e));}
function P5(e){var n=e.length,Y6=new e.constructor(n);if(n&&typeof e[0]=='string'&&M2.call(e,'index')){Y6.index=e.index;Y6.input=e.input;}return Y6;}
function Q5(e){return(typeof e.constructor=='function'&&!$5(e))?y3(V2(e)):{};}
function R5(e,n,Y6){var O7=e.constructor;switch(n){case $:return _4(e);case z:case A:return new O7(+e);case _:return a5(e,Y6);case a1:case b1:case c1:case d1:case e1:case f1:case g1:case h1:case i1:return d5(e,Y6);case G:return new O7;case J:case U:return new O7(e);case S:return b5(e);case T:return new O7;case X:return c5(e);}}
function S5(e,n){var Y6=n.length;if(!Y6){return e;}var O7=Y6-1;n[O7]=(Y6>1?'& ':'')+n[O7];n=n.join(Y6>2?', ':' ');return e.replace(o1,'{\n/* [wrapped with '+n+'] */\n');}
function T5(e){return $6(e)||Z6(e)||!!(Z2&&e&&e[Z2]);}
function U5(e,n){var Y6=typeof e;n=n==null?r:n;return!!n&&(Y6=='number'||(Y6!='symbol'&&x1.test(e)))&&(e>-1&&e%1==0&&e<n);}
function V5(e,n,Y6){if(!g7(Y6)){return false;}var O7=typeof n;if(O7=='number'?(_6(Y6)&&U5(n,Y6.length)):(O7=='string'&&n in Y6)){return eq(Y6[n],e);}return false;}
function W5(e,n){if($6(e)){return false;}var Y6=typeof e;if(Y6=='number'||Y6=='symbol'||Y6=='boolean'||e==null||n7(e)){return true;}return k1.test(e)||!j1.test(e)||(n!=null&&e in Object(n));}
function X5(e){var n=typeof e;return(n=='string'||n=='number'||n=='symbol'||n=='boolean')?(e!=='__proto__'):(e===null);}
function Y5(e){var n=D5(e),Y6=x3[n];if(typeof Y6!='function'||!(n in A3.prototype)){return false;}if(e===Y6){return true;}var O7=C5(Y6);return!!O7&&e===O7[0];}
function Z5(e){return!!N2&&(N2 in e);}
function $5(e){var n=e&&e.constructor,Y6=(typeof n=='function'&&n.prototype)||J2;return e===Y6;}
function _5(e){return e===e&&!g7(e);}
function a6(e,n){return function(Y6){if(Y6==null){return false;}return Y6[e]===n&&(n!==u||(e in Object(Y6)));};}
function b6(e){var n=V6(e,function(O7){if(Y6.size===M){Y6.clear();}return O7;});var Y6=n.cache;return n;}
function c6(e,n){var Y6=e[1],O7=n[1],P7=Y6|O7,Q7=P7<(W|f|l);var R7=((O7==l)&&(Y6==h))||((O7==l)&&(Y6==m)&&(e[7].length<=n[8]))||((O7==(l|m))&&(n[7].length<=n[8])&&(Y6==h));if(!(Q7||R7)){return e;}if(O7&W){e[2]=n[2];P7|=Y6&W?0:g;}var S7=n[3];if(S7){var T7=e[3];e[3]=T7?e5(T7,S7,n[4]):S7;e[4]=T7?C2(e[3],P):n[4];}S7=n[5];if(S7){T7=e[5];e[5]=T7?f5(T7,S7,n[6]):S7;e[6]=T7?C2(e[5],P):n[6];}S7=n[7];if(S7){e[7]=S7;}if(O7&l){e[8]=e[8]==null?n[8]:f3(e[8],n[8]);}if(e[9]==null){e[9]=n[9];}e[0]=n[0];e[1]=P7;return e;}
function d6(e){var n=[];if(e!=null){for(var Y6 in Object(e)){n.push(Y6);}}return n;}
function e6(e){return O2.call(e);}
function f6(e,n,Y6){n=e3(n===u?(e.length-1):n,0);return function(){var O7=arguments,P7=-1,Q7=e3(O7.length-n,0),R7=Array(Q7);while(++P7<Q7){R7[P7]=O7[n+P7];}P7=-1;var S7=Array(n+1);while(++P7<n){S7[P7]=O7[P7];}S7[n]=Y6(R7);return f2(e,this,S7);};}
function g6(e,n){return n.length<2?e:o4(e,S4(n,0,-1));}
function h6(e,n){var Y6=e.length,O7=f3(n.length,Y6),P7=g5(e);while(O7--){var Q7=n[O7];e[O7]=U5(Q7,Y6)?P7[Q7]:u;}return e;}
function i6(e,n){if(n==='constructor'&&typeof e[n]==='function'){return;}if(n=='__proto__'){return;}return e[n];}
var j6=m6(Q4);var k6=m6(R4);
function l6(e,n,Y6){var O7=(n+'');return k6(e,S5(O7,q6(N5(O7),Y6)));}
function m6(e){var n=0,Y6=0;return function(){var O7=g3(),P7=q-(O7-Y6);Y6=O7;if(P7>0){if(++n>=p){return arguments[0];}}else{n=0;}return e.apply(u,arguments);};}
var n6=b6(function(e){var n=[];if(e.charCodeAt(0)===46){n.push('');}e.replace(l1,function(Y6,O7,P7,Q7){n.push(P7?Q7.replace(r1,'$1'):(O7||Y6));});return n;});
function o6(e){if(typeof e=='string'||n7(e)){return e;}var n=(e+'');return(n=='0'&&(1/e)==-I)?'-0':n;}
function p6(n){if(n!=null){try{return L2.call(n);}catch(e){}try{return(n+'');}catch(e){}}return'';}
function q6(e,n){g2(w,function(Y6){var O7='_.'+Y6[0];if((n&Y6[1])&&!i2(e,O7)){e.push(O7);}});return e.sort();}
function r6(e){var n=-1,Y6=e==null?0:e.length,O7=0,P7=[];while(++n<Y6){var Q7=e[n];if(Q7){P7[O7++]=Q7;}}return P7;}
var s6=O4(function(e,E7){return a7(e)?i4(e,l4(E7,1,a7,true)):[];});var t6=O4(function(e,E7){var H7=B6(E7);if(a7(H7)){H7=u;}return a7(e)?i4(e,l4(E7,1,a7,true),F5(H7,2)):[];});var u6=O4(function(e,E7){var n=B6(E7);if(a7(n)){n=u;}return a7(e)?i4(e,l4(E7,1,a7,true),u,n):[];});
function v6(e){var n=e==null?0:e.length;return n?l4(e,1):[];}
function w6(e){var n=e==null?0:e.length;return n?l4(e,I):[];}
function x6(e,n){var Y6=e==null?0:e.length;if(!Y6){return[];}n=n===u?1:r7(n);return l4(e,n);}
var y6=O4(function(e){var n=k2(e,Y4);return(n.length&&n[0]===e[0])?t4(n):[];});var z6=O4(function(e){var H7=B6(e),n=k2(e,Y4);if(H7===B6(n)){H7=u;}else{n.pop();}return(n.length&&n[0]===e[0])?t4(n,F5(H7,2)):[];});var A6=O4(function(e){var n=B6(e),Y6=k2(e,Y4);n=typeof n=='function'?n:u;if(n){Y6.pop();}return(Y6.length&&Y6[0]===e[0])?t4(Y6,u,n):[];});
function B6(e){var n=e==null?0:e.length;return n?e[n-1]:u;}
var C6=O4(function(e){return U4(l4(e,1,a7,true));});var D6=O4(function(e){var H7=B6(e);if(a7(H7)){H7=u;}return U4(l4(e,1,a7,true),F5(H7,2));});var E6=O4(function(e){var n=B6(e);n=typeof n=='function'?n:u;return U4(l4(e,1,a7,true),u,n);});
function F6(e){return(e&&e.length)?U4(e):[];}
function G6(e,H7){return(e&&e.length)?U4(e,F5(H7,2)):[];}
function H6(e,n){n=typeof n=='function'?n:u;return(e&&e.length)?U4(e,u,n):[];}
var I6=O4(function(e,E7){return a7(e)?i4(e,E7):[];});var J6=O4(function(e){return W4(h2(e,a7));});var K6=O4(function(e){var H7=B6(e);if(a7(H7)){H7=u;}return W4(h2(e,a7),F5(H7,2));});var L6=O4(function(e){var n=B6(e);n=typeof n=='function'?n:u;return W4(h2(e,a7),u,n);});
function M6(e,E7){return X4(e||[],E7||[],c4);}
function N6(e,E7){return X4(e||[],E7||[],P4);}
function O6(e,H7){return l4(R6(e,H7),1);}
function P6(e,H7){return l4(R6(e,H7),I);}
function Q6(e,H7,n){n=n===u?1:r7(n);return l4(R6(e,H7),n);}
function R6(e,H7){var n=$6(e)?k2:G4;return n(e,F5(H7,3));}
var S6=function(){return Y1.Date.now();};
function T6(e,n,Y6){n=Y6?u:n;var O7=u5(e,h,u,u,u,u,u,n);O7.placeholder=T6.placeholder;return O7;}
function U6(e,n,Y6){var O7,P7,Q7,R7,S7,T7,U7=0,V7=false,W7=false,X7=true;if(typeof e!='function'){throw new TypeError(F);}n=s7(n)||0;if(g7(Y6)){V7=!!Y6.leading;W7='maxWait'in Y6;Q7=W7?e3(s7(Y6.maxWait)||0,n):Q7;X7='trailing'in Y6?!!Y6.trailing:X7;}function Y7(f8){var g8=O7,h8=P7;O7=P7=u;U7=f8;R7=e.apply(h8,g8);return R7;}function Z7(f8){U7=f8;S7=setTimeout(a8,n);return V7?Y7(f8):R7;}function $7(f8){var g8=f8-T7,h8=f8-U7,i8=n-g8;return W7?f3(i8,Q7-h8):i8;}function _7(f8){var g8=f8-T7,h8=f8-U7;return(T7===u||(g8>=n)||(g8<0)||(W7&&h8>=Q7));}function a8(){var f8=S6();if(_7(f8)){return b8(f8);}S7=setTimeout(a8,$7(f8));}function b8(f8){S7=u;if(X7&&O7){return Y7(f8);}O7=P7=u;return R7;}function c8(){if(S7!==u){clearTimeout(S7);}U7=0;O7=T7=P7=S7=u;}function d8(){return S7===u?R7:b8(S6());}function e8(){var f8=S6(),g8=_7(f8);O7=arguments;P7=this;T7=f8;if(g8){if(S7===u){return Z7(T7);}if(W7){clearTimeout(S7);S7=setTimeout(a8,n);return Y7(T7);}}if(S7===u){S7=setTimeout(a8,n);}return R7;}e8.cancel=c8;e8.flush=d8;return e8;}
function V6(e,n){if(typeof e!='function'||(n!=null&&typeof n!='function')){throw new TypeError(F);}var Y6=function(){var O7=arguments,P7=n?n.apply(this,O7):O7[0],Q7=Y6.cache;if(Q7.has(P7)){return Q7.get(P7);}var R7=e.apply(this,O7);Y6.cache=Q7.set(P7,R7)||Q7;return R7;};Y6.cache=new(V6.Cache||N3);return Y6;}
V6.Cache=N3;
function W6(e,n,Y6){var O7=true,P7=true;if(typeof e!='function'){throw new TypeError(F);}if(g7(Y6)){O7='leading'in Y6?!!Y6.leading:O7;P7='trailing'in Y6?!!Y6.trailing:P7;}return U6(e,n,{'leading':O7,'maxWait':n,'trailing':P7});}
function X6(){if(!arguments.length){return[];}var e=arguments[0];return $6(e)?e:[e];}
function eq(e,n){return e===n||(e!==e&&n!==n);}
var Z6=u4(function(){return arguments;}())?u4:function(e){return h7(e)&&M2.call(e,'callee')&&!X2.call(e,'callee');};var $6=Array.isArray;
function _6(e){return e!=null&&f7(e.length)&&!e7(e);}
function a7(e){return h7(e)&&_6(e);}
var b7=c3||L7;
function c7(e,n){return v4(e,n);}
function d7(e,n,Y6){Y6=typeof Y6=='function'?Y6:u;var O7=Y6?Y6(e,n):u;return O7===u?v4(e,n,u,Y6):!!O7;}
function e7(e){if(!g7(e)){return false;}var n=q4(e);return n==D||n==E||n==y||n==R;}
function f7(e){return typeof e=='number'&&e>-1&&e%1==0&&e<=r;}
function g7(e){var n=typeof e;return e!=null&&(n=='object'||n=='function');}
function h7(e){return e!=null&&typeof e=='object';}
var i7=c2?t2(c2):x4;
function j7(e){return e==null;}
function k7(e){if(!h7(e)||q4(e)!=O){return false;}var n=V2(e);if(n===null){return true;}var Y6=M2.call(n,'constructor')&&n.constructor;return typeof Y6=='function'&&Y6 instanceof Y6&&L2.call(Y6)==P2;}
var l7=d2?t2(d2):A4;
function m7(e){return typeof e=='string'||(!$6(e)&&h7(e)&&q4(e)==U);}
function n7(e){return typeof e=='symbol'||(h7(e)&&q4(e)==X);}
var o7=e2?t2(e2):B4;
function p7(e){if(!e){return[];}if(_6(e)){return m7(e)?F2(e):g5(e);}if($2&&e[$2]){return z2(e[$2]());}var n=M5(e),Y6=n==G?A2:(n==T?D2:E7);return Y6(e);}
function q7(e){if(!e){return e===0?e:0;}e=s7(e);if(e===I||e===-I){var n=(e<0?-1:1);return n*s;}return e===e?e:0;}
function r7(e){var n=q7(e),Y6=n%1;return n===n?(Y6?n-Y6:n):0;}
function s7(e){if(typeof e=='number'){return e;}if(n7(e)){return N;}if(g7(e)){var n=typeof e.valueOf=='function'?e.valueOf():e;e=g7(n)?(n+''):n;}if(typeof e!='string'){return e===0?e:+e;}e=e.replace(n1,'');var Y6=u1.test(e);return(Y6||w1.test(e))?V1(e.slice(2),Y6?2:8):(t1.test(e)?N:+e);}
function t7(e){return h5(e,y7(e));}
function u7(e){return e==null?'':T4(e);}
function v7(e,n,Y6){var O7=e==null?u:o4(e,n);return O7===u?Y6:O7;}
function w7(e,n){return e!=null&&O5(e,n,s4);}
function x7(e){return _6(e)?a4(e):D4(e);}
function y7(e){return _6(e)?a4(e,true):E4(e);}
var z7=k5(function(e,n,Y6){J4(e,n,Y6);});var A7=k5(function(e,n,Y6,O7){J4(e,n,Y6,O7);});var B7=z5(function(e,n){var Y6={};if(e==null){return Y6;}var O7=false;n=k2(n,function(Q7){Q7=Z4(Q7,e);O7||(O7=Q7.length>1);return Q7;});h5(e,B5(e),Y6);if(O7){Y6=h4(Y6,C|a|b,v5);}var P7=n.length;while(P7--){V4(Y6,n[P7]);}return Y6;});var C7=z5(function(e,n){return e==null?{}:L4(e,n);});
function D7(e,n){if(e==null){return{};}var Y6=k2(B5(e),function(O7){return[O7];});n=F5(n);return M4(e,Y6,function(O7,P7){return n(O7,P7[0]);});}
function E7(e){return e==null?[]:u2(e,x7(e));}
function F7(e){return function(){return e;};}
function G7(e){return e;}
function H7(e){return C4(typeof e=='function'?e:h4(e,C));}
function I7(){}
function J7(e){return W5(e)?r2(o6(e)):N4(e);}
function K7(){return[];}
function L7(){return false;}
function M7(e){return(e&&e.length)?k4(e,G7,r4):u;}
function N7(e){return(e&&e.length)?k4(e,G7,F4):u;}
x3.castArray=X6;x3.compact=r6;x3.constant=F7;x3.curry=T6;x3.debounce=U6;x3.difference=s6;x3.differenceBy=t6;x3.differenceWith=u6;x3.flatMap=O6;x3.flatMapDeep=P6;x3.flatMapDepth=Q6;x3.flatten=v6;x3.flattenDeep=w6;x3.flattenDepth=x6;x3.intersection=y6;x3.intersectionBy=z6;x3.intersectionWith=A6;x3.iteratee=H7;x3.keys=x7;x3.keysIn=y7;x3.map=R6;x3.memoize=V6;x3.merge=z7;x3.mergeWith=A7;x3.omit=B7;x3.pick=C7;x3.pickBy=D7;x3.property=J7;x3.throttle=W6;x3.toArray=p7;x3.toPlainObject=t7;x3.union=C6;x3.unionBy=D6;x3.unionWith=E6;x3.uniq=F6;x3.uniqBy=G6;x3.uniqWith=H6;x3.values=E7;x3.without=I6;x3.xor=J6;x3.xorBy=K6;x3.xorWith=L6;x3.zipObject=M6;x3.zipObjectDeep=N6;x3.eq=eq;x3.get=v7;x3.hasIn=w7;x3.identity=G7;x3.isArguments=Z6;x3.isArray=$6;x3.isArrayLike=_6;x3.isArrayLikeObject=a7;x3.isBuffer=b7;x3.isEqual=c7;x3.isEqualWith=d7;x3.isFunction=e7;x3.isLength=f7;x3.isMap=i7;x3.isNil=j7;x3.isObject=g7;x3.isObjectLike=h7;x3.isPlainObject=k7;x3.isSet=l7;x3.isString=m7;x3.isSymbol=n7;x3.isTypedArray=o7;x3.last=B6;x3.max=M7;x3.min=N7;x3.stubArray=K7;x3.stubFalse=L7;x3.noop=I7;x3.now=S6;x3.toFinite=q7;x3.toInteger=r7;x3.toNumber=s7;x3.toString=u7;x3.VERSION=V;T6.placeholder=x3;return x3;});
/*!
 * Copyright (c) Sindre Sorhus <sindresorhus@gmail.com> (sindresorhus.com)
 * Version 2.0.0, see https://github.com/sindresorhus/p-cancelable/tree/v2.0.0
 */
sap.ui.predefine('sap/base/util/restricted/_CancelablePromise',function(){'use strict';
function _(o,a){var e;if(typeof Symbol==="undefined"||o[Symbol.iterator]==null){if(Array.isArray(o)||(e=b(o))||a&&o&&typeof o.length==="number"){if(e)o=e;var i=0;var F=function F(){};return{s:F,n:function n(){if(i>=o.length)return{done:true};return{done:false,value:o[i++]};},e:function e(x){throw x;},f:F};}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");}var n=true,p=false,w;return{s:function s(){e=o[Symbol.iterator]();},n:function n(){var x=e.next();n=x.done;return x;},e:function e(x){p=true;w=x;},f:function f(){try{if(!n&&e.return!=null)e.return();}finally{if(p)throw w;}}};}
function b(o,a){if(!o)return;if(typeof o==="string")return c(o,a);var n=Object.prototype.toString.call(o).slice(8,-1);if(n==="Object"&&o.constructor)n=o.constructor.name;if(n==="Map"||n==="Set")return Array.from(o);if(n==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return c(o,a);}
function c(a,e){if(e==null||e>a.length)e=a.length;for(var i=0,n=new Array(e);i<e;i++){n[i]=a[i];}return n;}
function d(o){"@babel/helpers - typeof";if(typeof Symbol==="function"&&typeof Symbol.iterator==="symbol"){d=function d(o){return typeof o;};}else{d=function d(o){return o&&typeof Symbol==="function"&&o.constructor===Symbol&&o!==Symbol.prototype?"symbol":typeof o;};}return d(o);}
function f(i,a){if(!(i instanceof a)){throw new TypeError("Cannot call a class as a function");}}
function g(a,p){for(var i=0;i<p.length;i++){var e=p[i];e.enumerable=e.enumerable||false;e.configurable=true;if("value"in e)e.writable=true;Object.defineProperty(a,e.key,e);}}
function h(a,p,e){if(p)g(a.prototype,p);if(e)g(a,e);return a;}
function j(a,e){if(typeof e!=="function"&&e!==null){throw new TypeError("Super expression must either be null or a function");}a.prototype=Object.create(e&&e.prototype,{constructor:{value:a,writable:true,configurable:true}});if(e)u(a,e);}
function k(D){var a=s();return function _createSuperInternal(){var S=v(D),e;if(a){var N=v(this).constructor;e=Reflect.construct(S,arguments,N);}else{e=S.apply(this,arguments);}return l(this,e);};}
function l(a,e){if(e&&(d(e)==="object"||typeof e==="function")){return e;}return m(a);}
function m(a){if(a===void 0){throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return a;}
function q(a){var e=typeof Map==="function"?new Map():undefined;q=function q(a){if(a===null||!t(a))return a;if(typeof a!=="function"){throw new TypeError("Super expression must either be null or a function");}if(typeof e!=="undefined"){if(e.has(a))return e.get(a);e.set(a,W);}function W(){return r(a,arguments,v(this).constructor);}W.prototype=Object.create(a.prototype,{constructor:{value:W,enumerable:false,writable:true,configurable:true}});return u(W,a);};return q(a);}
function r(e,i,n){if(s()){r=Reflect.construct;}else{r=function r(e,i,n){var a=[null];a.push.apply(a,i);var o=Function.bind.apply(e,a);var p=new o();if(n)u(p,n.prototype);return p;};}return r.apply(null,arguments);}
function s(){if(typeof Reflect==="undefined"||!Reflect.construct)return false;if(Reflect.construct.sham)return false;if(typeof Proxy==="function")return true;try{Date.prototype.toString.call(Reflect.construct(Date,[],function(){}));return true;}catch(e){return false;}}
function t(a){return Function.toString.call(a).indexOf("[native code]")!==-1;}
function u(o,p){u=Object.setPrototypeOf||function u(o,p){o.__proto__=p;return o;};return u(o,p);}
function v(o){v=Object.setPrototypeOf?Object.getPrototypeOf:function v(o){return o.__proto__||Object.getPrototypeOf(o);};return v(o);}
var C=function(a){j(C,a);var e=k(C);function C(i){var n;f(this,C);n=e.call(this,i||'Promise was canceled');n.name='CancelError';return n;}h(C,[{key:"isCanceled",get:function get(){return true;}}]);return C;}(q(Error));var P=function(){h(P,null,[{key:"fn",value:function fn(a){return function(){for(var e=arguments.length,i=new Array(e),n=0;n<e;n++){i[n]=arguments[n];}return new P(function(o,p,w){i.push(w);a.apply(void 0,i).then(o,p);});};}}]);function P(e){var a=this;f(this,P);this._cancelHandlers=[];this._isPending=true;this._isCanceled=false;this._rejectOnCancel=true;this._promise=new Promise(function(i,n){a._reject=n;var o=function o(x){a._isPending=false;i(x);};var p=function p(x){a._isPending=false;n(x);};var w=function w(x){if(!a._isPending){throw new Error('The `onCancel` handler was attached after the promise settled.');}a._cancelHandlers.push(x);};Object.defineProperties(w,{shouldReject:{get:function get(){return a._rejectOnCancel;},set:function set(x){a._rejectOnCancel=x;}}});return e(o,p,w);});}h(P,[{key:"then",value:function then(o,a){return this._promise.then(o,a);}},{key:"catch",value:function _catch(o){return this._promise.catch(o);}},{key:"finally",value:function _finally(o){return this._promise.finally(o);}},{key:"cancel",value:function cancel(a){if(!this._isPending||this._isCanceled){return;}if(this._cancelHandlers.length>0){try{var e=_(this._cancelHandlers),i;try{for(e.s();!(i=e.n()).done;){var n=i.value;n();}}catch(o){e.e(o);}finally{e.f();}}catch(p){this._reject(p);}}this._isCanceled=true;if(this._rejectOnCancel){this._reject(new C(a));}}},{key:"isCanceled",get:function get(){return this._isCanceled;}}]);return P;}();Object.setPrototypeOf(P.prototype,Promise.prototype);P.CancelError=C;return P;});
/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('jquery.sap.act',['sap/ui/util/ActivityDetection','jquery.sap.global'],function(A,q){"use strict";q.sap.act=A;return q;});
sap.ui.predefine('jquery.sap.encoder',['jquery.sap.global','sap/base/security/encodeXML','sap/base/security/encodeJS','sap/base/security/encodeURL','sap/base/security/encodeURLParameters','sap/base/security/encodeCSS','sap/base/security/URLWhitelist','sap/base/security/sanitizeHTML'],function(q,e,a,b,c,d,U,s){"use strict";q.sap.encodeHTML=e;q.sap.encodeXML=e;q.sap.escapeHTML=e;q.sap.encodeJS=a;q.sap.escapeJS=a;q.sap.encodeURL=b;q.sap.encodeURLParameters=c;q.sap.encodeCSS=d;q.sap.clearUrlWhitelist=U.clear;q.sap.addUrlWhitelist=U.add;
q.sap.removeUrlWhitelist=function(i){U.delete(U.entries()[i]);};
q.sap.getUrlWhitelist=U.entries;q.sap.validateUrl=U.validate;q.sap._sanitizeHTML=s;return q;});
sap.ui.predefine('jquery.sap.events',['jquery.sap.global','sap/ui/events/ControlEvents','sap/ui/events/PseudoEvents','sap/ui/events/checkMouseEnterOrLeave','sap/ui/events/isSpecialKey','sap/ui/events/isMouseEventDelayed','sap/ui/events/F6Navigation','sap/ui/events/jquery/EventExtension','sap/ui/events/jquery/EventSimulation','sap/ui/events/KeyCodes','sap/base/util/defineCoupledProperty'],function(q,C,P,c,i,I,F,E,a,K,d){"use strict";q.sap.PseudoEvents=P.events;q.sap.ControlEvents=C.events;q.sap.disableTouchToMouseHandling=a.disableTouchToMouseHandling;d(q.sap,"touchEventMode",a,"touchEventMode");q.sap.bindAnyEvent=C.bindAnyEvent;q.sap.unbindAnyEvent=C.unbindAnyEvent;q.sap.checkMouseEnterOrLeave=c;
q.sap.isSpecialKey=function(e){if(e.key){return i(e);}function b(e){var k=e.which;return(k===K.SHIFT)||(k===K.CONTROL)||(k===K.ALT)||(k===K.CAPS_LOCK)||(k===K.NUM_LOCK);}function f(e){var k=e.which,A=(k>=37&&k<=40);switch(e.type){case"keydown":case"keyup":return A;case"keypress":return k===0;default:return false;}}var k=e.which,s=b(e)||f(e)||(k>=33&&k<=36)||(k>=44&&k<=46)||(k>=112&&k<=123)||(k===K.BREAK)||(k===K.BACKSPACE)||(k===K.TAB)||(k===K.ENTER)||(k===K.ESCAPE)||(k===K.SCROLL_LOCK);switch(e.type){case"keydown":case"keyup":return s;case"keypress":return(k===0||k===K.BACKSPACE||k===K.ESCAPE||k===K.ENTER)||false;default:return false;}};
q.sap.handleF6GroupNavigation=function(e,s){if(!e.key&&e.keyCode===K.F6){e.key="F6";}return F.handleF6GroupNavigation(e,s);};
q.sap._FASTNAVIGATIONKEY=F.fastNavigationKey;
q.sap._refreshMouseEventDelayedFlag=function(n){q.sap.isMouseEventDelayed=I.apply(this,arguments);};
q.sap._refreshMouseEventDelayedFlag(navigator);return q;});
sap.ui.predefine('jquery.sap.history',["jquery.sap.global","sap/base/Log","sap/base/util/uid","sap/base/strings/escapeRegExp"],function(q,L,u,e){"use strict";(function(w){var s="_skip",r=/\|id-[0-9]+-[0-9]+/,a=new RegExp(s+"[0-9]*$"),b=[],h=[],S={},c=0,d,I="|",H=[],f=false,g,j=false;
q.sap.history=function(B){if(!q.isPlainObject(B)){return;}if(!j){var W=q(w),C=(w.location.href.split("#")[1]||"");W.on('hashchange',l);if(Array.isArray(B.routes)){var i,D;for(i=0;i<B.routes.length;i++){D=B.routes[i];if(D.path&&D.handler){q.sap.history.addRoute(D.path,D.handler);}}}if(q.isFunction(B.defaultHandler)){g=B.defaultHandler;}h.push(C);if(C.length>1){W.trigger("hashchange",[true]);}else{d=C;}j=true;}};
q.sap.history.addHistory=function(i,B,C,V){var U,D;if(C===undefined){C=true;}if(!V){D=p(i,B);U=o(D);if(U){D+=(I+U);}D+=(I+(C?"1":"0"));}else{D=n(d);}H.push(D);S[D]=true;w.location.hash=D;return D;};
q.sap.history.addVirtualHistory=function(){q.sap.history.addHistory("",undefined,false,true);};
q.sap.history.addRoute=function(i,B,T){if(T){B=q.proxy(B,T);}var R={};R.sIdentifier=i;R['action']=B;b.push(R);return this;};
q.sap.history.setDefaultHandler=function(i){g=i;};
q.sap.history.getDefaultHandler=function(){return g;};
q.sap.history.backToHash=function(i){i=i||"";var B;if(h.length===1){if(q.isFunction(g)){g();}}else{B=k(d,i);if(B<0){w.history.go(B);}else{L.error("jQuery.sap.history.backToHash: "+i+"is not in the history stack or it's after the current hash");}}};
q.sap.history.backThroughPath=function(P){P=P||"";P=w.encodeURIComponent(P);var i;if(h.length===1){if(q.isFunction(g)){g();}}else{i=k(d,P,true);if(i<0){w.history.go(i);}else{L.error("jQuery.sap.history.backThroughPath: there's no history state which has the "+P+" identifier in the history stack before the current hash");}}};
q.sap.history.back=function(i){if(h.length===1){if(q.isFunction(g)){g(q.sap.history.NavType.Back);}}else{if(!i){i=1;}w.history.go(-1*i);}};
q.sap.history.NavType={Back:"_back",Forward:"_forward",Bookmark:"_bookmark",Unknown:"_unknown"};
function k(C,T,P){var B=h.indexOf(C),D,i,E;if(B>0){if(P){for(i=B-1;i>=0;i--){E=h[i];if(E.indexOf(T)===0&&!v(E)){return i-B;}}}else{D=h.indexOf(T);if((D===-1)&&T.length===0){return-1*B;}if((D>-1)&&(D<B)){return D-B;}}}return 0;}
function l(E,M){var i=(w.location.href.split("#")[1]||"");i=m(i);if(M||!S[i]){H.push(i);}if(!f){f=true;if(H.length>0){var B=H.shift();if(S[B]){t(B);delete S[B];}else{y(B);}d=B;}f=false;}}
function m(i,R){var B=i,C=i?i.indexOf("#"):-1;if(C===0){B=B.slice(C+1);}if(R){B=B.replace(r,"");}return B;}
function n(i){var P=i?i:"";if(v(P)){var B=P.lastIndexOf(s);P=P.slice(0,B);}return P+s+c++;}
function p(i,B){var E=w.encodeURIComponent(i);var C=w.encodeURIComponent(w.JSON.stringify(B));return E+I+C;}
function o(B){var C=h.indexOf(d),i,D;if(C>-1){for(i=0;i<C+1;i++){D=h[i];if(D.slice(0,D.length-2)===B){return u();}}}return"";}
function t(i){var B=h.indexOf(d);if(!(B===-1||B===h.length-1)){h.splice(B+1,h.length-1-B);}h.push(i);}
function v(i){return a.test(i);}
function x(C,F){var B=h.indexOf(C),i;if(B!==-1){if(F){for(i=B;i<h.length;i++){if(!v(h[i])){return i-B;}}}else{for(i=B;i>=0;i--){if(!v(h[i])){return i-B;}}return-1*(B+1);}}}
function y(i){var R,B,P,N,C;if(d===undefined){P=A(i);if(!P||!P.bBookmarkable){if(q.isFunction(g)){g(q.sap.history.NavType.Bookmark);}return;}}if(i.length===0){if(q.isFunction(g)){g(q.sap.history.NavType.Back);}}else{N=h.indexOf(i);if(N===0){P=A(i);if(!P||!P.bBookmarkable){if(q.isFunction(g)){g(q.sap.history.NavType.Back);}return;}}if(v(i)){if(v(d)){B=x(i,false);w.history.go(B);}else{var D=new RegExp(e(d+s)+"[0-9]*$");if(D.test(i)){B=x(i,true);if(B){w.history.go(B);}else{w.history.back();}}else{B=x(i,false);w.history.go(B);}}}else{if(N===-1){C=q.sap.history.NavType.Unknown;h.push(i);}else{if(h.indexOf(d,N+1)===-1){C=q.sap.history.NavType.Forward;}else{C=q.sap.history.NavType.Back;}}P=A(i);if(P){R=z(P.sIdentifier);if(R){R.action.apply(null,[P.oStateData,C]);}}else{L.error("hash format error! The current Hash: "+i);}}}}
function z(B){var i;for(i=0;i<b.length;i++){if(b[i].sIdentifier===B){return b[i];}}}
function A(B){if(v(B)){var i=B.lastIndexOf(s);B=B.slice(0,i);}var P=B.split(I),R={};if(P.length===4||P.length===3){R.sIdentifier=w.decodeURIComponent(P[0]);R.oStateData=w.JSON.parse(w.decodeURIComponent(P[1]));if(P.length===4){R.uid=P[2];}R.bBookmarkable=P[P.length-1]==="0"?false:true;return R;}else{return null;}}
})(this);return q;});
sap.ui.predefine('jquery.sap.keycodes',['jquery.sap.global','sap/ui/events/KeyCodes'],function(q,K){"use strict";q.sap.KeyCodes=K;return q;});
sap.ui.predefine('jquery.sap.mobile',['jquery.sap.global','sap/ui/util/Mobile','sap/ui/Device'],function(q,M,D){"use strict";
function g(t,p){var d=Object.getOwnPropertyDescriptor(t,p);return d&&d.value;}
(function(){q.os=q.extend({os:D.os.name,version:D.os.versionStr,fVersion:D.os.version},g(q,"os"));q.os[D.os.name]=true;q.device=q.extend({},g(q,"device"));q.device.is=q.extend({standalone:window.navigator.standalone,landscape:D.orientation.landscape,portrait:D.orientation.portrait,iphone:D.os.ios&&D.system.phone,ipad:D.os.ios&&D.system.tablet,android_phone:D.system.phone&&D.os.android,android_tablet:D.system.tablet&&D.os.android,tablet:D.system.tablet,phone:D.system.phone,desktop:D.system.desktop},q.device.is);})();q.sap.initMobile=M.init;q.sap.setIcons=M.setIcons;q.sap.setMobileWebAppCapable=M.setWebAppCapable;return q;});
sap.ui.predefine('jquery.sap.promise',[],function(){"use strict";if(!window.Promise){sap.ui.requireSync("sap/ui/thirdparty/es6-promise");}});
sap.ui.predefine('jquery.sap.properties',['jquery.sap.global','sap/base/util/Properties'],function(q,P){"use strict";q.sap.properties=P.create;return q;});
sap.ui.predefine('jquery.sap.resources',['sap/base/i18n/ResourceBundle','jquery.sap.global'],function(R,q){"use strict";
q.sap.resources=function(){return R.create.apply(R,arguments);};
q.sap.resources.isBundle=function(b){return b instanceof R;};
q.sap.resources._getFallbackLocales=R._getFallbackLocales;return q;});
sap.ui.predefine('jquery.sap.sjax',['jquery.sap.global'],function(q){"use strict";q.sap.sjaxSettings={complexResult:true,fallback:undefined};
q.sap.sjax=function sjax(o){var s=q.extend(true,{},q.sap.sjaxSettings,o,{async:false,success:function(d,t,x){r={success:true,data:d,status:t,statusCode:x&&x.status};},error:function(x,t,e){r={success:false,data:undefined,status:t,error:e,statusCode:x.status,errorResponse:x.responseText};}});var r;q.ajax(s);if(!s.complexResult){return r.success?r.data:s.fallback;}return r;};
q.sap.syncHead=function(u){return q.sap.sjax({type:'HEAD',url:u}).success;};
q.sap.syncGet=function syncGet(u,d,D){return q.sap.sjax({url:u,data:d,type:'GET',dataType:D||'text'});};
q.sap.syncPost=function syncPost(u,d,D){return q.sap.sjax({url:u,data:d,type:'POST',dataType:D||'text'});};
q.sap.syncGetText=function syncGetText(u,d,f){return q.sap.sjax({url:u,data:d,type:'GET',dataType:'text',fallback:f,complexResult:(arguments.length<3)});};
q.sap.syncGetJSON=function syncGetJSON(u,d,f){return q.sap.sjax({url:u,data:d||null,type:'GET',dataType:'json',fallback:f,complexResult:(arguments.length<3)});};
return q;});
sap.ui.predefine('jquery.sap.storage',['jquery.sap.global','sap/base/assert','sap/ui/util/Storage'],function(q,a,S){"use strict";var s={};
q.sap.storage=function(o,i){if(!o){o=S.Type.session;}if(typeof(o)==="string"&&S.Type[o]){var k=o;if(i&&i!="state.key_"){k=o+"_"+i;}return s[k]||(s[k]=new S(o,i));}a(o instanceof Object&&o.clear&&o.setItem&&o.getItem&&o.removeItem,"storage: duck typing the storage");return new S(o,i);};
q.sap.storage.Storage=S;q.sap.storage.Type=S.Type;Object.assign(q.sap.storage,S);return q;});
sap.ui.predefine('jquery.sap.strings',['jquery.sap.global','sap/base/strings/capitalize','sap/base/strings/camelize','sap/base/strings/hyphenate','sap/base/strings/escapeRegExp','sap/base/strings/formatMessage'],function(q,c,a,h,e,f){"use strict";
q.sap.endsWith=function(s,E){if(typeof(E)!="string"||E==""){return false;}return s.endsWith(E);};
q.sap.endsWithIgnoreCase=function(s,E){if(typeof(E)!="string"||E==""){return false;}s=s.toUpperCase();E=E.toUpperCase();return s.endsWith(E);};
q.sap.startsWith=function(s,S){if(typeof(S)!="string"||S==""){return false;}return s.startsWith(S);};
q.sap.startsWithIgnoreCase=function(s,S){if(typeof(S)!="string"||S==""){return false;}s=s.toUpperCase();S=S.toUpperCase();return s.startsWith(S);};
q.sap.charToUpperCase=function(s,p){if(!s){return s;}if(!p||isNaN(p)||p<=0||p>=s.length){return c(s);}var C=s.charAt(p).toUpperCase();if(p>0){return s.substring(0,p)+C+s.substring(p+1);}return C+s.substring(p+1);};
q.sap.padLeft=function(s,p,l){if(!s){s="";}if(p&&p.length===1){return s.padStart(l,p);}while(s.length<l){s=p+s;}return s;};
q.sap.padRight=function(s,p,l){if(!s){s="";}if(p&&p.length===1){return s.padEnd(l,p);}while(s.length<l){s=s+p;}return s;};
q.sap.camelCase=a;q.sap.hyphen=h;q.sap.escapeRegExp=e;q.sap.formatMessage=f;return q;});
sap.ui.predefine('jquery.sap.trace',['jquery.sap.global','sap/ui/thirdparty/URI','sap/ui/Device','sap/ui/performance/trace/Passport','sap/ui/performance/trace/Interaction','sap/ui/performance/trace/FESR','sap/base/Log','sap/ui/Global'],function(q,U,D,P,I,F,L){"use strict";
function l(){if(!(window.performance&&window.performance.getEntries)){L.warning("Interaction tracking is not supported on browsers with insufficient performance API");}}
q.sap.interaction={};
q.sap.interaction.setActive=function(){l();I.setActive.apply(this,arguments);};
q.sap.interaction.getActive=I.getActive;q.sap.interaction.notifyStepStart=I.notifyStepStart;q.sap.interaction.notifyStepEnd=I.notifyStepEnd;q.sap.interaction.notifyEventStart=I.notifyEventStart;q.sap.interaction.notifyScrollEvent=I.notifyScrollEvent;q.sap.interaction.notifyEventEnd=I.notifyEventEnd;q.sap.interaction.setStepComponent=I.setStepComponent;q.sap.fesr={};
q.sap.fesr.setActive=function(){l();F.setActive.apply(this,arguments);};
q.sap.fesr.getActive=F.getActive;q.sap.fesr.getCurrentTransactionId=P.getTransactionId;q.sap.fesr.getRootId=P.getRootId;q.sap.fesr.addBusyDuration=I.addBusyDuration;q.sap.passport={};q.sap.passport.setActive=P.setActive;q.sap.passport.traceFlags=P.traceFlags;
function g(){var a=!!document.querySelector("meta[name=sap-ui-fesr][content=true]"),p=window.location.search.match(/[\?|&]sap-ui-(?:xx-)?fesr=(true|x|X|false)&?/);if(p){a=p[1]&&p[1]!="false";}return a;}
q.sap.interaction.notifyStepStart(null,true);F.setActive(g());if(/sap-ui-xx-e2e-trace=(true|x|X)/.test(location.search)){sap.ui.requireSync("sap/ui/core/support/trace/E2eTraceLib");}return q;});
sap.ui.predefine('jquery.sap.ui',['jquery.sap.global','sap/base/util/ObjectPath','sap/ui/dom/jquery/control'],function(q,O){"use strict";
function f(c){return c.getUIArea().getInterface();}
function u(){return sap.ui.getCore().getUIArea(this.id)!=null;}
function a(){return sap.ui.getCore().getUIArea(this.id);}
q.fn.root=function(r){if(r){sap.ui.getCore().setRoot(this.get(0),r);return this;}var c=this.control();if(c.length>0){return c.map(f);}var U=this.uiarea();if(U.length>0){return U;}this.each(function(){sap.ui.getCore().createUIArea(this);});return this;};
q.fn.uiarea=function(i){var U=this.slice("[id]").filter(u).map(a).get();return typeof(i)==="number"?U[i]:U;};
q.fn.sapui=function(c,i,C){return this.each(function(){var o=null;if(this){if(c.indexOf(".")==-1){c="sap.ui.commons."+c;}var b=O.get(c);if(b){if(typeof C=='object'&&typeof C.press=='function'){C.press=q.proxy(C.press,this);}o=new(b)(i,C);o.placeAt(this);}}});};
return q;});
sap.ui.predefine('jquery.sap.unicode',['jquery.sap.global','sap/ui/Device'],function(q,D){'use strict';var i,N;if(!String.prototype.normalize&&!D.browser.mobile){N=sap.ui.requireSync('sap/base/strings/NormalizePolyfill');N.apply();i=N.isStringNFC;}else{i=function(s){return s.normalize("NFC")===s;};}q.sap.isStringNFC=i;return q;});
sap.ui.predefine('jquery.sap.xml',['jquery.sap.global','sap/ui/util/XMLHelper'],function(q,X){"use strict";q.sap.parseXML=X.parse;
q.sap.serializeXML=function(x){var s="";if(window.ActiveXObject){s=x.xml;if(s){return s;}}if(window.XMLSerializer){return X.serialize(x);}return s;};
q.sap.isEqualNode=function(n,N){if(n===N){return true;}if(!n||!N){return false;}if(n.isEqualNode){return n.isEqualNode(N);}if(n.nodeType!=N.nodeType){return false;}if(n.nodeValue!=N.nodeValue){return false;}if(n.baseName!=N.baseName){return false;}if(n.nodeName!=N.nodeName){return false;}if(n.nameSpaceURI!=N.nameSpaceURI){return false;}if(n.prefix!=N.prefix){return false;}if(n.nodeType!=1){return true;}if(n.attributes.length!=N.attributes.length){return false;}for(var i=0;i<n.attributes.length;i++){if(!q.sap.isEqualNode(n.attributes[i],N.attributes[i])){return false;}}if(n.childNodes.length!=N.childNodes.length){return false;}for(var i=0;i<n.childNodes.length;i++){if(!q.sap.isEqualNode(n.childNodes[i],N.childNodes[i])){return false;}}return true;};
q.sap.getParseError=X.getParseError;return q;});
sap.ui.predefine('sap/base/security/URLWhitelist',["sap/base/assert"],function(a){"use strict";var u={};
function U(p,h,b,c){if(p){this.protocol=p.toUpperCase();}if(h){this.host=h.toUpperCase();}this.port=b;this.path=c;}
var w=[];
u.clear=function(){w.splice(0,w.length);};
u.add=function(p,h,b,c){var e=new U(p,h,b,c);var i=w.length;w[i]=e;};
u.delete=function(e){w.splice(w.indexOf(e),1);};
u.entries=function(){return w.slice();};
u.validate=function(s){var r=/^(?:([^:\/?#]+):)?((?:\/\/((?:\[[^\]]+\]|[^\/?#:]+))(?::([0-9]+))?)?([^?#]*))(?:\?([^#]*))?(?:#(.*))?$/.exec(s);if(!r){return false;}var p=r[1],b=r[2],h=r[3],P=r[4],c=r[5],q=r[6],H=r[7];var d=/^([a-z0-9-._~!$&'()*+,;=:@]|%[0-9a-f]{2})*$/i;var e=/^([a-z0-9-._~!$&'()*+,;=:@\/?]|%[0-9a-f]{2})*$/i;var f=e;var g=/^([a-z0-9!$'*+:^_`{|}~-]|%[0-9a-f]{2})+(?:\.([a-z0-9!$'*+:^_`{|}~-]|%[0-9a-f]{2})+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?$/i;var j=/^([0-9]{1,3}\.){3}[0-9]{1,3}$/;var k=/^(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])$/;var l=/^\[[^\]]+\]$/;var m=/^\[(((([0-9a-f]{1,4}:){6}|(::([0-9a-f]{1,4}:){5})|(([0-9a-f]{1,4})?::([0-9a-f]{1,4}:){4})|((([0-9a-f]{1,4}:){0,1}[0-9a-f]{1,4})?::([0-9a-f]{1,4}:){3})|((([0-9a-f]{1,4}:){0,2}[0-9a-f]{1,4})?::([0-9a-f]{1,4}:){2})|((([0-9a-f]{1,4}:){0,3}[0-9a-f]{1,4})?::[0-9a-f]{1,4}:)|((([0-9a-f]{1,4}:){0,4}[0-9a-f]{1,4})?::))(([0-9a-f]{1,4}:[0-9a-f]{1,4})|(([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5])))|((([0-9a-f]{1,4}:){0,5}[0-9a-f]{1,4})?::[0-9a-f]{1,4})|((([0-9a-f]{1,4}:){0,6}[0-9a-f]{1,4})?::))\]$/i;var n=/^([a-z0-9]([a-z0-9\-]*[a-z0-9])?\.)*[a-z0-9]([a-z0-9\-]*[a-z0-9])?$/i;if(p){p=p.toUpperCase();if(w.length<=0){if(!/^(https?|ftp)/i.test(p)){return false;}}}if(h){if(j.test(h)){if(!k.test(h)){return false;}}else if(l.test(h)){if(!m.test(h)){return false;}}else if(!n.test(h)){return false;}h=h.toUpperCase();}if(c){if(p==="MAILTO"){var A=b.split(",");for(var i=0;i<A.length;i++){if(!g.test(A[i])){return false;}}}else{var C=c.split("/");for(var i=0;i<C.length;i++){if(!d.test(C[i])){return false;}}}}if(q){if(!e.test(q)){return false;}}if(H){if(!f.test(H)){return false;}}if(w.length>0){var F=false;for(var i=0;i<w.length;i++){a(w[i]instanceof U,"whitelist entry type wrong");if(!p||!w[i].protocol||p==w[i].protocol){var o=false;if(h&&w[i].host&&/^\*/.test(w[i].host)){var t=w[i].host.slice(1).replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&");var v=RegExp(t+"$");if(v.test(h)){o=true;}}else if(!h||!w[i].host||h==w[i].host){o=true;}if(o){if((!h&&!P)||!w[i].port||P==w[i].port){if(w[i].path&&/\*$/.test(w[i].path)){var x=w[i].path.slice(0,-1).replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&");var v=RegExp("^"+x);if(v.test(c)){F=true;}}else if(!w[i].path||c==w[i].path){F=true;}}}}if(F){break;}}if(!F){return false;}}return true;};
return u;});
sap.ui.predefine('sap/base/security/encodeJS',["sap/base/strings/toHex"],function(t){"use strict";var r=/[\x00-\x2b\x2d\x2f\x3a-\x40\x5b-\x5e\x60\x7b-\xff\u2028\u2029]/g,j={};var J=function(c){var E=j[c];if(!E){var C=c.charCodeAt(0);if(C<256){E="\\x"+t(C,2);}else{E="\\u"+t(C,4);}j[c]=E;}return E;};var e=function(s){return s.replace(r,J);};return e;});
sap.ui.predefine('sap/base/security/encodeURL',["sap/base/strings/toHex"],function(t){"use strict";var r=/[\ud800-\udbff][\udc00-\udfff]|[\x00-\x2c\x2f\x3a-\x40\x5b-\x5e\x60\x7b-\uffff]/g,u={};var U=function(c){var E=u[c];if(!E){var C=c.codePointAt(0);if(C<128){E="%"+t(C,2);}else if(C<2048){E="%"+t((C>>6)|192,2)+"%"+t((C&63)|128,2);}else if(C<65536){E="%"+t((C>>12)|224,2)+"%"+t(((C>>6)&63)|128,2)+"%"+t((C&63)|128,2);}else{E="%"+t((C>>18)|240,2)+"%"+t(((C>>12)&63)|128,2)+"%"+t(((C>>6)&63)|128,2)+"%"+t((C&63)|128,2);}u[c]=E;}return E;};var e=function(s){return s.replace(r,U);};return e;});
sap.ui.predefine('sap/base/security/encodeURLParameters',["./encodeURL"],function(e){"use strict";var E=function(p){if(!p){return"";}var u=[];Object.keys(p).forEach(function(n){var v=p[n];if(v instanceof String||typeof v==="string"){v=e(v);}u.push(e(n)+"="+v);});return u.join("&");};return E;});
sap.ui.predefine('sap/base/security/sanitizeHTML',["sap/base/assert","sap/base/security/URLWhitelist","sap/ui/thirdparty/caja-html-sanitizer"],function(a,U){"use strict";var s=function(h,o){a(window.html&&window.html.sanitize,"Sanitizer should have been loaded");o=o||{uriRewriter:function(u){if(U.validate(u)){return u;}}};var t=o.tagPolicy||window.html.makeTagPolicy(o.uriRewriter,o.tokenPolicy);return window.html.sanitizeWithPolicy(h,t);};return s;});
sap.ui.predefine('sap/base/strings/NormalizePolyfill',["sap/ui/thirdparty/unorm","sap/ui/thirdparty/unormdata"],function(){"use strict";
function apply(){String.prototype.normalize=function(s){switch(s){case'NFC':return nfcQuickCheck(this)?this:UNorm.nfc(this);case'NFD':return UNorm.nfd(this);case'NFKC':return UNorm.nfkc(this);case'NFKD':return UNorm.nfkd(this);default:return nfcQuickCheck(this)?this:UNorm.nfc(this);}};}
var mData={};(function(){var N=[[0x0340,0x0341],[0x0343,0x0344],0x374,0x037E,0x387,[0x0958,0x095F],[0x09DC,0x09DD],0x09DF,0x0A33,0x0A36,[0x0A59,0x0A5B],0x0A5E,[0x0B5C,0x0B5D],0x0F43,0x0F4D,0x0F52,0x0F57,0x0F5C,0x0F69,0x0F73,[0x0F75,0x0F76],0x0F78,0x0F81,0x0F93,0x0F9D,0x0FA2,0x0FA7,0x0FAC,0x0FB9,0x1F71,0x1F73,0x1F75,0x1F77,0x1F79,0x1F7B,0x1F7D,0x1FBB,0x1FBE,0x1FC9,0x1FCB,0x1FD3,0x1FDB,0x1FE3,0x1FEB,[0x1FEE,0x1FEF],0x1FF9,0x1FFB,0x1FFD,[0x2000,0x2001],0x2126,[0x212A,0x212B],0x2329,0x232A,0x2ADC,[0xF900,0xFA0D],0xFA10,0xFA12,[0xFA15,0xFA1E],0xFA20,0xFA22,[0xFA25,0xFA26],[0xFA2A,0xFA6D],[0xFA70,0xFAD9],0xFB1D,0xFB1F,[0xFB2A,0xFB36],[0xFB38,0xFB3C],0xFB3E,[0xFB40,0xFB41],[0xFB43,0xFB44],[0xFB46,0xFB4E],[0x1D15E,0x1D164],[0x1D1BB,0x1D1C0],[0x2F800,0x2FA1D],[0x0300,0x0304],[0x0306,0x030C],0x030F,0x311,[0x0313,0x0314],0x031B,[0x0323,0x0328],[0x032D,0x032E],[0x0330,0x0331],0x338,0x342,0x345,[0x0653,0x0655],0x093C,0x09BE,0x09D7,0x0B3E,0x0B56,0x0B57,0x0BBE,0x0BD7,0x0C56,0x0CC2,[0x0CD5,0x0CD6],0x0D3E,0x0D57,0x0DCA,0x0DCF,0x0DDF,0x102E,[0x1161,0x1175],[0x11A8,0x11C2],0x1B35,[0x3099,0x309A],0x110BA,0x11127,0x1133E,0x11357,0x114B0,0x114BA,0x114BD,0x115AF];for(var i=0;i<N.length;i++){if(typeof N[i]=="number"){mData[N[i]]=true;}else{var a=N[i][0];var b=N[i][1];while(a<=b){mData[a++]=true;}}}}());
function isHighSurrogate(c){return c>=0xD800&&c<=0xDBFF;}
function isLowSurrogate(c){return c>=0xDC00&&c<=0xDFFF;}
function getCanonicalClass(cp){var dunit,hash;hash=cp&0xFF00;dunit=UNorm.UChar.udata[hash];if(dunit===undefined){dunit=UNorm.UChar.udata[hash]={};}else if(typeof dunit==="string"){dunit=UNorm.UChar.udata[hash]=eval("("+dunit+")");}return dunit[cp]&&!!dunit[cp][1]?(dunit[cp][1]&0xff):0;}
function isNotAllowed(c){return mData[c];}
function nfcQuickCheck(s){if(!/^[\u0001-\u00ff]*$/.test(s)){var l=0;for(var i=0;i<s.length;++i){var c=s.charCodeAt(i);if(isHighSurrogate(c)){var n=s.charCodeAt(i+1);if(isLowSurrogate(n)){c=(c-0xD800)*0x400+(n-0xDC00)+0x10000;++i;}}var a=getCanonicalClass(c);if(l>a&&a!==0||isNotAllowed(c)){return false;}l=a;}}return true;}
var NormalizePolyfill=Object.create(null);NormalizePolyfill.apply=apply;NormalizePolyfill.isStringNFC=nfcQuickCheck;return NormalizePolyfill;});
sap.ui.predefine('sap/base/strings/camelize',[],function(){"use strict";var r=/-(.)/ig;var c=function(s){return s.replace(r,function(m,C){return C.toUpperCase();});};return c;});
sap.ui.predefine('sap/base/strings/capitalize',[],function(){"use strict";var c=function(s){return s.charAt(0).toUpperCase()+s.substring(1);};return c;});
sap.ui.predefine('sap/base/strings/hyphenate',[],function(){"use strict";var r=/([A-Z])/g;var h=function(s){return s.replace(r,function(m,c){return"-"+c.toLowerCase();});};return h;});
sap.ui.predefine('sap/base/util/defineCoupledProperty',[],function(){"use strict";var d=function(t,T,s,S){var v=s[S];var p={configurable:true,get:function(){return v;},set:function(_){v=_;}};Object.defineProperty(t,T,p);Object.defineProperty(s,S,p);};return d;});
sap.ui.predefine('sap/base/util/includes',["sap/base/util/values"],function(v){"use strict";
function e(a,b){return a===b||(a!==a&&b!==b);}
var I=function(c,V,f){if(typeof f!=='number'){f=0;}if(Array.isArray(c)){if(typeof c.includes==='function'){return c.includes(V,f);}f=f<0?f+c.length:f;f=f<0?0:f;for(var i=f;i<c.length;i++){if(e(c[i],V)){return true;}}return false;}else if(typeof c==='string'){f=f<0?c.length+f:f;if(typeof c.includes==='function'){return c.includes(V,f);}return c.indexOf(V,f)!==-1;}else{return I(v(c),V,f);}};return I;});
sap.ui.predefine('sap/base/util/restricted/_castArray',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.castArray;});
sap.ui.predefine('sap/base/util/restricted/_compact',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.compact;});
sap.ui.predefine('sap/base/util/restricted/_curry',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.curry;});
sap.ui.predefine('sap/base/util/restricted/_debounce',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.debounce;});
sap.ui.predefine('sap/base/util/restricted/_difference',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.difference;});
sap.ui.predefine('sap/base/util/restricted/_differenceBy',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.differenceBy;});
sap.ui.predefine('sap/base/util/restricted/_differenceWith',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.differenceWith;});
sap.ui.predefine('sap/base/util/restricted/_flatMap',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.flatMap;});
sap.ui.predefine('sap/base/util/restricted/_flatMapDeep',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.flatMapDeep;});
sap.ui.predefine('sap/base/util/restricted/_flatMapDepth',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.flatMapDepth;});
sap.ui.predefine('sap/base/util/restricted/_flatten',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.flatten;});
sap.ui.predefine('sap/base/util/restricted/_flattenDeep',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.flattenDeep;});
sap.ui.predefine('sap/base/util/restricted/_flattenDepth',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.flattenDepth;});
sap.ui.predefine('sap/base/util/restricted/_intersection',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.intersection;});
sap.ui.predefine('sap/base/util/restricted/_intersectionBy',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.intersectionBy;});
sap.ui.predefine('sap/base/util/restricted/_intersectionWith',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.intersectionWith;});
sap.ui.predefine('sap/base/util/restricted/_isEqual',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.isEqual;});
sap.ui.predefine('sap/base/util/restricted/_isEqualWith',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.isEqualWith;});
sap.ui.predefine('sap/base/util/restricted/_isNil',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.isNil;});
sap.ui.predefine('sap/base/util/restricted/_max',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.max;});
sap.ui.predefine('sap/base/util/restricted/_merge',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.merge;});
sap.ui.predefine('sap/base/util/restricted/_mergeWith',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.mergeWith;});
sap.ui.predefine('sap/base/util/restricted/_min',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.min;});
sap.ui.predefine('sap/base/util/restricted/_omit',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.omit;});
sap.ui.predefine('sap/base/util/restricted/_pick',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.pick;});
sap.ui.predefine('sap/base/util/restricted/_pickBy',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.pickBy;});
sap.ui.predefine('sap/base/util/restricted/_throttle',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.throttle;});
sap.ui.predefine('sap/base/util/restricted/_toArray',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.toArray;});
sap.ui.predefine('sap/base/util/restricted/_union',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.union;});
sap.ui.predefine('sap/base/util/restricted/_unionBy',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.unionBy;});
sap.ui.predefine('sap/base/util/restricted/_unionWith',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.unionWith;});
sap.ui.predefine('sap/base/util/restricted/_uniq',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.uniq;});
sap.ui.predefine('sap/base/util/restricted/_uniqBy',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.uniqBy;});
sap.ui.predefine('sap/base/util/restricted/_uniqWith',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.uniqWith;});
sap.ui.predefine('sap/base/util/restricted/_without',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.without;});
sap.ui.predefine('sap/base/util/restricted/_xor',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.xor;});
sap.ui.predefine('sap/base/util/restricted/_xorBy',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.xorBy;});
sap.ui.predefine('sap/base/util/restricted/_xorWith',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.xorWith;});
sap.ui.predefine('sap/base/util/restricted/_zipObject',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.zipObject;});
sap.ui.predefine('sap/base/util/restricted/_zipObjectDeep',["sap/base/util/restricted/_/lodash.custom"],function(l){"use strict";return l.zipObjectDeep;});
sap.ui.predefine('sap/base/util/values',function(){"use strict";var v=function values(o){if(typeof o==="undefined"||o===null||o!==o){return[];}if(typeof Object.values==='function'){return Object.values(o);}if(typeof o==='string'){return o.split('');}if(typeof o!=='object'){return[];}return Object.keys(o).map(function(V){return o[V];});};return v;});
sap.ui.predefine('sap/ui/app/Application',['sap/base/assert','./ApplicationMetadata','sap/ui/core/Component','sap/ui/core/ComponentContainer','sap/ui/model/Model','sap/ui/model/json/JSONModel','jquery.sap.sjax'],function(a,A,C,b,M,J,q){"use strict";
var c=C.extend("sap.ui.app.Application",{
metadata:{"abstract":true,properties:{root:"string",config:"any"},aggregations:{rootComponent:{type:"sap.ui.core.UIComponent",multiple:false}},publicMethods:["getView"],deprecated:true},
constructor:function(i,s){if(this.onError){this.onWindowError=this.onError;}if(this.onBeforeExit){this.onWindowBeforeUnload=this.onBeforeExit;}if(this.onExit){this.onWindowUnload=this.onExit;}C.apply(this,arguments);if(sap.ui.getApplication){throw new Error("Only one instance of sap.ui.app.Application is allowed");}sap.ui.getApplication=this._getInstance.bind(this);sap.ui.getCore().attachInit(function(){this._initRootComponent();this.main();}.bind(this));},
_initRootComponent:function(){var r=this.createRootComponent();if(r){this.setRootComponent(r);var o=new b({component:r});o.placeAt(this.getRoot()||document.body);}},
createRootComponent:function(){var r=this.getMetadata().getRootComponent();var R;if(r){R=sap.ui.component({name:r});}return R;},
getView:function(){return this.getRootComponent();},
_getInstance:function(){return this;},
main:function(){},
onBeforeExit:function(){},
onExit:function(){},
onError:null,
setConfig:function(v){if(typeof v==="string"){var u=v;v=new J();var r=q.sap.sjax({url:u,dataType:'json'});if(r.success){v.setData(r.data);}else{throw new Error("Could not load config file: "+u);}}if(typeof v==="object"&&!(v instanceof M)){v=new J(v);}a(v instanceof M,"the config property value must be a string, an object or an instance of sap.ui.model.Model");this.setProperty("config",v);},
destroy:function(s){delete sap.ui.getApplication;C.prototype.destroy.apply(this,arguments);}
},A);
return c;});
sap.ui.predefine('sap/ui/app/ApplicationMetadata',['sap/base/Log','sap/ui/core/ComponentMetadata','jquery.sap.sjax'],function(L,C,q){"use strict";var A=function(c,o){C.apply(this,arguments);};A.prototype=Object.create(C.prototype);A.prototype.constructor=A;
A.preprocessClassInfo=function(c){if(c&&typeof c.metadata==="string"){c.metadata={_src:c.metadata};}return c;};
A.prototype.applySettings=function(c){var s=c.metadata;C.prototype.applySettings.call(this,c);if(s._src){L.warning("The metadata of the application "+this.getName()+" is loaded from file "+s._src+". This is a design time feature and not for productive usage!");var p=this.getName().replace(/\.\w+?$/,"");var u=sap.ui.require.toUrl(p.replace(/\./g,"/")+"/"+s._src);var r=q.sap.syncGetJSON(u);if(r.success){Object.assign(s,r.data);}else{L.error("Failed to load application metadata from \""+s._src+"\"! Reason: "+r.error);}}this._mRootComponent=s.rootComponent||null;};
A.prototype.getRootComponent=function(){return this._mRootComponent;};
return A;},true);
sap.ui.predefine('sap/ui/app/MockServer',['jquery.sap.global','sap/ui/core/util/MockServer'],function(q,M){"use strict";var a=M;return a;},true);
sap.ui.predefine('sap/ui/core/AppCacheBuster',['sap/ui/base/ManagedObject','./Core','sap/ui/thirdparty/URI','sap/base/Log','sap/base/util/extend','sap/base/strings/escapeRegExp','sap/ui/thirdparty/jquery'],function(M,C,U,L,a,b,q){"use strict";var c=sap.ui.getCore().getConfiguration();var l=c.getLanguage();var s=c.getAppCacheBusterMode()==="sync";var B=c.getAppCacheBusterMode()==="batch";var S={index:{},active:false};var v,d,f,x,E;var g=document.baseURI.replace(/\?.*|#.*/g,"");var u=U(sap.ui.require.toUrl("")+"/../");var o=u.toString();if(u.is("relative")){u=u.absoluteTo(g);}var h=u.normalize().toString();var r=U("resources").absoluteTo(h).toString();var F=new RegExp("^"+b(r));var i=function(e){if(e.length>0&&e.slice(-1)!=="/"){e+="/";}return e;};var R=function(h,e){var I=S.index;var j;var k;var m;if(Array.isArray(h)&&!B){h.forEach(function(G){R(G,e);});}else if(Array.isArray(h)&&B){var n=i(h[0]);var p=[];L.debug("sap.ui.core.AppCacheBuster.register(\""+n+"\"); // BATCH MODE!");var t=A.normalizeURL(n);L.debug("  --> normalized to: \""+t+"\"");h.forEach(function(G){k=i(G);var J=A.normalizeURL(k);if(!I[m]){p.push(J);}});if(p.length>0){var k=t+"sap-ui-cachebuster-info.json?sap-ui-language="+l;j={url:k,type:"POST",async:!s&&!!e,dataType:"json",contentType:"text/plain",data:p.join("\n"),success:function(G){A.onIndexLoaded(k,G);a(I,G);},error:function(){L.error("Failed to batch load AppCacheBuster index file from: \""+k+"\".");}};}}else{h=i(h);L.debug("sap.ui.core.AppCacheBuster.register(\""+h+"\");");m=A.normalizeURL(h);L.debug("  --> normalized to: \""+m+"\"");if(!I[m]){var k=m+"sap-ui-cachebuster-info.json?sap-ui-language="+l;j={url:k,async:!s&&!!e,dataType:"json",success:function(G){A.onIndexLoaded(k,G);I[m]=G;},error:function(){L.error("Failed to load AppCacheBuster index file from: \""+k+"\".");}};}}if(j){var w=A.onIndexLoad(j.url);if(w!=null){L.info("AppCacheBuster index file injected for: \""+k+"\".");j.success(w);}else{if(j.async){var y=e.startTask("load "+k);var z=j.success,D=j.error;Object.assign(j,{success:function(G){z.apply(this,arguments);e.finishTask(y);},error:function(){D.apply(this,arguments);e.finishTask(y,false);}});}L.info("Loading AppCacheBuster index file from: \""+k+"\".");q.ajax(j);}}};var A={boot:function(e){var j=c.getAppCacheBuster();if(j&&j.length>0){j=j.slice();var k=true;var V=String(j[0]).toLowerCase();if(j.length===1){if(V==="true"||V==="x"){var u=U(o);j=u.is("relative")?[u.toString()]:[];}else if(V==="false"){k=false;}}if(k){A.init();R(j,e);}}},init:function(){S.active=true;v=M.prototype.validateProperty;d=Object.getOwnPropertyDescriptor(HTMLScriptElement.prototype,"src");f=Object.getOwnPropertyDescriptor(HTMLLinkElement.prototype,"href");var j=A.convertURL;var n=A.normalizeURL;var I=function(e){if(this.active===true&&e&&typeof(e)==="string"){e=n(e);return!e.match(F);}return false;}.bind(S);x=XMLHttpRequest.prototype.open;XMLHttpRequest.prototype.open=function(e,t){if(t&&I(t)){arguments[1]=j(t);}x.apply(this,arguments);};E=XMLHttpRequest.prototype.open;M.prototype.validateProperty=function(P,V){var t=this.getMetadata(),w=t.getProperty(P),y;if(w&&w.type==="sap.ui.core.URI"){y=Array.prototype.slice.apply(arguments);try{if(I(y[1])){y[1]=j(y[1]);}}catch(e){}}return v.apply(this,y||arguments);};var k=function(e){var t={get:e.get,set:function(w){if(I(w)){w=j(w);}e.set.call(this,w);},enumerable:e.enumerable,configurable:e.configurable};t.set._sapUiCoreACB=true;return t;};var m=false;try{Object.defineProperty(HTMLScriptElement.prototype,"src",k(d));}catch(p){L.error("Your browser doesn't support redefining the src property of the script tag. Disabling AppCacheBuster as it is not supported on your browser!\nError: "+p);m=true;}try{Object.defineProperty(HTMLLinkElement.prototype,"href",k(f));}catch(p){L.error("Your browser doesn't support redefining the href property of the link tag. Disabling AppCacheBuster as it is not supported on your browser!\nError: "+p);m=true;}if(m){this.exit();}},exit:function(){M.prototype.validateProperty=v;if(XMLHttpRequest.prototype.open===E){XMLHttpRequest.prototype.open=x;}var e;if((e=Object.getOwnPropertyDescriptor(HTMLScriptElement.prototype,"src"))&&e.set&&e.set._sapUiCoreACB===true){Object.defineProperty(HTMLScriptElement.prototype,"src",d);}if((e=Object.getOwnPropertyDescriptor(HTMLLinkElement.prototype,"href"))&&e.set&&e.set._sapUiCoreACB===true){Object.defineProperty(HTMLLinkElement.prototype,"href",f);}S.index={};S.active=false;S={index:{},active:false};},register:function(h){R(h);},convertURL:function(e){L.debug("sap.ui.core.AppCacheBuster.convertURL(\""+e+"\");");var I=S.index;if(I&&e&&!/^#/.test(e)){var n=A.normalizeURL(e);L.debug("  --> normalized to: \""+n+"\"");if(n&&A.handleURL(n)){for(var h in I){var m=I[h],j,k;if(h&&n.length>=h.length&&n.slice(0,h.length)===h){j=n.slice(h.length);k=j.match(/([^?#]*)/)[1];if(m[k]){e=h+"~"+m[k]+"~/"+j;L.debug("  ==> rewritten to \""+e+"\";");break;}}}}}return e;},normalizeURL:function(e){var u=U(e||"./");if(u.is("relative")){u=u.absoluteTo(g);}return u.normalizeProtocol().normalizeHostname().normalizePort().normalizePath().toString();},handleURL:function(e){return true;},onIndexLoad:function(e){return null;},onIndexLoaded:function(e,I){}};var H=c.getAppCacheBusterHooks();if(H){["handleURL","onIndexLoad","onIndexLoaded"].forEach(function(e){if(typeof H[e]==="function"){A[e]=H[e];}});}return A;},true);
sap.ui.predefine('sap/ui/core/BusyIndicator',['sap/ui/thirdparty/jquery','../base/EventProvider','./Popup','./BusyIndicatorUtils','sap/ui/core/library',"sap/ui/performance/trace/FESR","sap/ui/performance/trace/Interaction","sap/base/Log","sap/base/assert","sap/base/util/now"],function(q,E,P,B,l,F,I,L,a,n){"use strict";var b=l.BusyIndicatorSize;var c=Object.assign(new E(),{oPopup:null,oDomRef:null,bOpenRequested:false,iDEFAULT_DELAY_MS:1000,sDOM_ID:"sapUiBusyIndicator"});c.M_EVENTS={Open:"Open",Close:"Close"};c._bShowIsDelayed=undefined;
c._init=function(){var r=document.createElement("div");r.id=this.sDOM_ID;var o=document.createElement("div");this._oResBundle=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core");var t=this._oResBundle.getText("BUSY_TEXT");delete this._oResBundle;o.className="sapUiBusy";o.setAttribute("tabindex","0");o.setAttribute("role","progressbar");o.setAttribute("alt","");o.setAttribute("title",t);r.appendChild(o);var d=B.getElement(b.Large);d.setAttribute("title",t);r.appendChild(d);var i=sap.ui.getCore().getStaticAreaRef();i.appendChild(r);this.oDomRef=r;this.oPopup=new P(r);this.oPopup.setModal(true,"sapUiBlyBusy");this.oPopup.setShadow(false);this.oPopup.attachOpened(function(e){this._onOpen(e);},this);};
c._onOpen=function(e){var d=document.getElementById(c.sDOM_ID);d.style.height="100%";d.style.width="100%";var A=d.querySelector(".sapUiLocalBusyIndicator");A.className+=" sapUiLocalBusyIndicatorFade";if(d){d.focus();}this.fireOpen({$Busy:this.oPopup._$()});};
c.show=function(d){L.debug("sap.ui.core.BusyIndicator.show (delay: "+d+") at "+new Date().getTime());a(d===undefined||(typeof d=="number"&&(d%1==0)),"iDelay must be empty or an integer");if(!document.body||!sap.ui.getCore().isInitialized()){if(c._bShowIsDelayed===undefined){sap.ui.getCore().attachInit(function(){if(c._bShowIsDelayed){c.show(d);}});}c._bShowIsDelayed=true;return;}if((d===undefined)||((d!=0)&&(parseInt(d)==0))||(parseInt(d)<0)){d=this.iDEFAULT_DELAY_MS;}if(F.getActive()){this._fDelayedStartTime=n()+d;}if(!this.oDomRef){this._init();}this.bOpenRequested=true;if(d===0){this._showNowIfRequested();}else{setTimeout(this["_showNowIfRequested"].bind(this),d);}};
c._showNowIfRequested=function(){L.debug("sap.ui.core.BusyIndicator._showNowIfRequested (bOpenRequested: "+this.bOpenRequested+") at "+new Date().getTime());if(!this.bOpenRequested){return;}var o=(window.scrollX===undefined?window.pageXOffset:window.scrollX);var O=(window.scrollY===undefined?window.pageYOffset:window.scrollY);var s=o+" "+O;this.bOpenRequested=false;this.oPopup.open(0,P.Dock.LeftTop,P.Dock.LeftTop,document,s);};
c.hide=function(){L.debug("sap.ui.core.BusyIndicator.hide at "+new Date().getTime());if(this._fDelayedStartTime){var f=n()-this._fDelayedStartTime;I.addBusyDuration((f>0)?f:0);delete this._fDelayedStartTime;}var d=c;if(c._bShowIsDelayed===true){c._bShowIsDelayed=false;}d.bOpenRequested=false;if(d.oDomRef){var A=d.oDomRef.querySelector(".sapUiLocalBusyIndicator");q(A).removeClass("sapUiLocalBusyIndicatorFade");this.fireClose({$Busy:this.oPopup._$()});d.oPopup.close(0);}};
c.attachOpen=function(f,o){this.attachEvent(c.M_EVENTS.Open,f,o);return this;};
c.detachOpen=function(f,o){this.detachEvent(c.M_EVENTS.Open,f,o);return this;};
c.attachClose=function(f,o){this.attachEvent(c.M_EVENTS.Close,f,o);return this;};
c.detachClose=function(f,o){this.detachEvent(c.M_EVENTS.Close,f,o);return this;};
c.fireOpen=function(p){this.fireEvent(c.M_EVENTS.Open,p);};
c.fireClose=function(p){this.fireEvent(c.M_EVENTS.Close,p);};
return c;},true);
sap.ui.predefine('sap/ui/core/CommandExecution',['sap/base/Log','sap/base/util/isEmptyObject','sap/ui/core/Component','sap/ui/core/Element','sap/ui/core/Shortcut'],function(L,a,C,E,S){"use strict";
var b=E.extend("sap.ui.core.CommandExecution",{
metadata:{library:"sap.ui.core",properties:{command:{type:"string"},enabled:{type:"boolean",defaultValue:true},visible:{type:"boolean",defaultValue:true}},events:{execute:{}}},
bSkipUpdate:false,
trigger:function(){if(this.getVisible()&&this.getEnabled()){this.fireExecute({});}},
setCommand:function(c){if(!this.getCommand()){this.setProperty("command",c,true);}else{L.error("The 'command' property can only be applied initially!");}return this;},
_getCommandInfo:function(){var c,o=this.getParent(),d=C.getOwnerComponentFor(this);while(!d&&o&&o.getParent()){d=C.getOwnerComponentFor(o);o=o.getParent();}if(d){c=d.getCommand(this.getCommand());}return c?Object.assign({},c):null;},
_updateContextData:function(c){var p=this.getParent();c[this.getCommand()]={};c[this.getCommand()].enabled=this.getEnabled();c[this.getCommand()].id=this.getId();c[this.getCommand()].visible=this.getVisible();this.getModel("$cmd").setProperty("/"+p.getId(),c);},
_createCommandData:function(p){if(!this.bSkipUpdate){this.bSkipUpdate=true;var P=this.getParent(),m=P.getModel("$cmd"),d=m.getData(),c=d[P.getId()];if(!c){c=Object.create(p);}else if(p!==Object.getPrototypeOf(c)){c=Object.create(p);}this._updateContextData(c);if(!P.getObjectBinding("$cmd")){P.bindElement("$cmd>/"+P.getId());}this.bSkipUpdate=false;}},
setParent:function(p){var t=this,c,o=this.getParent(),P,s,i;function g(){var d=p.oPropagatedProperties.oBindingContexts["$cmd"];return d?d.getObject():null;}function m(){if(p.getModel("$cmd")){var P=g();t.getParent().detachModelContextChange(m);t._createCommandData(P);}}E.prototype.setParent.apply(this,arguments);c=this._getCommandInfo();if(c&&this.getVisible()){if(p&&p!==o){s=c.shortcut;i=S.isRegistered(this.getParent(),s);if(!i){S.register(p,s,this.trigger.bind(this));}if(p.getModel("$cmd")){P=g();this._createCommandData(P);}else{p.attachModelContextChange(m);}if(!p._propagateProperties._sapui_fnOrig){var O=p._propagateProperties;p._propagateProperties=function(n,d,e,u,N,U){O.apply(p,arguments);var A=p.getBindingContext("$cmd");var f=arguments[1];if(A&&f.isA("sap.ui.core.CommandExecution")){var h=A.getObject();var j=Object.getPrototypeOf(h);P=g();if(j!==P){t._createCommandData.apply(f,[P]);}}};p._propagateProperties._sapui_fnOrig=O;}}if(o&&o!=p){s=c.shortcut;i=S.isRegistered(o,s);if(i){S.unregister(o,c.shortcut);}this._cleanupContext(o);}}return this;},
_cleanupContext:function(c){if(c.getBindingContext("$cmd")){var o=c.getBindingContext("$cmd").getObject();if(o){delete o[this.getCommand()];if(a(Object.assign({},o))){if(c._propagateProperties._sapui_fnOrig){c._propagateProperties=c._propagateProperties._sapui_fnOrig;}if(!c._bIsBeingDestroyed){c.unbindElement("$cmd");}}}}},
setVisible:function(v){var p=this.getParent(),c=this.getModel("$cmd");this.setProperty("visible",v,true);v=this.getProperty("visible");if(p){var o=this._getCommandInfo(),s=o.shortcut,i=S.isRegistered(p,s);if(v&&!i){S.register(p,s,this.trigger.bind(this));}else if(!v&&i){S.unregister(p,s);}}if(c){var d=this.getBindingContext("$cmd");c.setProperty(this.getCommand()+"/visible",v,d);}return this;},
setEnabled:function(v){var c=this.getModel("$cmd");this.setProperty("enabled",v,true);if(c){var o=this.getBindingContext("$cmd");c.setProperty(this.getCommand()+"/enabled",this.getProperty("enabled"),o);}return this;},
destroy:function(){var p=this.getParent();if(p){var c=this._getCommandInfo();S.unregister(this.getParent(),c.shortcut);this._cleanupContext(p);}E.prototype.destroy.apply(this,arguments);}
});
b.find=function(c,s){var i,o,A;A=c.getDependents();for(i=0;i<A.length;i++){if(A[i].isA("sap.ui.core.CommandExecution")&&A[i].getCommand()===s){o=A[i];}}if(!o&&c.getParent()){o=b.find(c.getParent(),s);}return o;};
return b;});
sap.ui.predefine('sap/ui/core/ComponentContainer',['sap/ui/base/ManagedObject','./Control','./Component','./Core','./library',"./ComponentContainerRenderer","sap/base/Log"],function(M,C,a,b,l,c,L){"use strict";var d=l.ComponentLifecycle;
var e=C.extend("sap.ui.core.ComponentContainer",{metadata:{library:"sap.ui.core",properties:{name:{type:"string",defaultValue:null},url:{type:"sap.ui.core.URI",defaultValue:null},async:{type:"boolean",defaultValue:false},handleValidation:{type:"boolean",defaultValue:false},settings:{type:"object",defaultValue:null},propagateModel:{type:"boolean",defaultValue:false},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},lifecycle:{type:"sap.ui.core.ComponentLifecycle",defaultValue:d.Legacy},autoPrefixId:{type:"boolean",defaultValue:false},usage:{type:"string",defaultValue:null},manifest:{type:"any",defaultValue:null}},associations:{component:{type:"sap.ui.core.UIComponent",multiple:false}},events:{componentCreated:{parameters:{component:{type:"sap.ui.core.UIComponent"}}},componentFailed:{parameters:{reason:{type:"object"}}}},designtime:"sap/ui/core/designtime/ComponentContainer.designtime"}});
function s(o,v,S,D){var g=typeof v==="string"?b.getComponent(v):v;var O=o.getComponentInstance();if(O!==g){if(O){O.setContainer(undefined);if(D){O.destroy();}else{o._propagateProperties(true,O,M._oEmptyPropagatedProperties,true);}}o.setAssociation("component",g,S);g=o.getComponentInstance();if(g){g.setContainer(o);o.propagateProperties(true);}}}
e.prototype.getComponentInstance=function(){var g=this.getComponent();return g&&b.getComponent(g);};
e.prototype.setComponent=function(v,S){s(this,v,S,this.getLifecycle()===d.Container||(typeof this.getUsage()==="string"&&this.getUsage()&&this.getLifecycle()===d.Legacy));return this;};
e.prototype.applySettings=function(S,o){if(S){if(S.manifest==="true"||S.manifest==="false"){S.manifest=S.manifest==="true";}if(S.manifest&&S.async===undefined){S.async=true;}}C.prototype.applySettings.apply(this,arguments);};
function f(o){var n=o.getName();var m=o.getManifest();var u=o.getUrl();var S=o.getSettings();var g={name:n?n:undefined,manifest:m!==null?m:false,async:o.getAsync(),url:u?u:undefined,handleValidation:o.getHandleValidation(),settings:S!==null?S:undefined};return g;}
e.prototype._createComponent=function(){var o=a.getOwnerComponentFor(this),u=this.getUsage(),m=f(this);if(u){if(o){m=o._enhanceWithUsageConfig(u,m);}else{L.error("ComponentContainer \""+this.getId()+"\" does have a \"usage\", but no owner component!");}}if(this.getAutoPrefixId()){if(m.id){m.id=this.getId()+"-"+m.id;}if(m.settings&&m.settings.id){m.settings.id=this.getId()+"-"+m.settings.id;}}return a._createComponent(m,o);};
e.prototype.onBeforeRendering=function(){var o=this.getComponentInstance(),u=this.getUsage(),n=this.getName(),m=this.getManifest();if(!this._oComponentPromise&&!o&&(u||n||m)){o=this._createComponent();if(o instanceof Promise){this._oComponentPromise=o;o.then(function(o){delete this._oComponentPromise;this.setComponent(o);this.fireComponentCreated({component:o});}.bind(this),function(r){delete this._oComponentPromise;this.fireComponentFailed({reason:r});L.error("Failed to load component for container "+this.getId()+". Reason: "+r);}.bind(this));}else if(o){this.setComponent(o,true);this.fireComponentCreated({component:o});}else{this.fireComponentFailed({reason:new Error("The component could not be created.")});}}if(o&&o.onBeforeRendering){o.onBeforeRendering();}};
e.prototype.onAfterRendering=function(){var o=this.getComponentInstance();if(o&&o.onAfterRendering){o.onAfterRendering();}};
e.prototype.exit=function(){s(this,undefined,true,this.getLifecycle()!==d.Application);};
e.prototype.propagateProperties=function(n){var o=this.getComponentInstance();if(o&&this.getPropagateModel()){this._propagateProperties(n,o);}C.prototype.propagateProperties.apply(this,arguments);};
e.prototype._propagateContextualSettings=function(){var o=this.getComponentInstance();if(o){o._applyContextualSettings(this._getContextualSettings());}};
return e;});
sap.ui.predefine('sap/ui/core/ComponentContainerRenderer',function(){"use strict";var C={apiVersion:2};
C.render=function(r,c){var o=c.getComponentInstance();var w=c.getWidth();var h=c.getHeight();r.openStart("div",c);r.style("width",w);r.style("height",h);r.class("sapUiComponentContainer");r.openEnd();r.openStart("div",c.getId()+"-uiarea");if(w&&w!=="auto"){r.style("width","100%");}if(h&&h!=="auto"){r.style("height","100%");}r.openEnd();if(o){o.render(r);}r.close("div");r.close("div");};
return C;},true);
sap.ui.predefine('sap/ui/core/ComponentSupport',['sap/ui/base/DataType','sap/ui/core/Component','sap/ui/core/ComponentContainer','sap/ui/core/library',"sap/base/Log","sap/base/util/ObjectPath","sap/base/strings/camelize"],function(D,C,a,b,L,O,c){"use strict";var d=b.ComponentLifecycle;var e=a.getMetadata();var f=function(){};
f.run=function(){var E=f._find();for(var i=0,l=E.length;i<l;i++){var o=E[i];L.debug("Parsing element "+o.outerHTML,"","sap/ui/core/ComponentSupport");var s=f._parse(o);f._applyDefaultSettings(s);L.debug("Creating ComponentContainer with the following settings",JSON.stringify(s,0,2),"sap/ui/core/ComponentSupport");new a(s).placeAt(o);o.removeAttribute("data-sap-ui-component");}};
f._find=function(){return document.querySelectorAll("[data-sap-ui-component]");};
f._parse=function(E){var s={};for(var i=0,l=E.attributes.length;i<l;i++){var A=E.attributes[i];var p=/^data-((?!sap-ui-component).+)/g.exec(A.name);if(p){var k=c(p[1]);var v=A.value;if(k!=="id"){var P=e.getProperty(k);var o=!P&&e.getEvent(k);if(!P&&!o){L.warning("Property or event \""+k+"\" will be ignored as it does not exist in sap.ui.core.ComponentContainer");continue;}if(P){var t=D.getType(P.type);if(!t){throw new Error("Property \""+P.name+"\" has no known type");}v=t.parseValue(v);}else if(o){var g=O.get(v);if(typeof g!=="function"){throw new Error("Callback handler for event \""+o.name+"\" not found");}v=g;}}s[k]=v;}}return s;};
f._applyDefaultSettings=function(s){s.async=true;if(s.manifest===undefined||s.manifest==="true"){s.manifest=true;}else if(s.manifest==="false"){L.error("Ignoring \"manifest=false\" for ComponentContainer of component \""+s.name+"\" as it is not supported by ComponentSupport. "+"Forcing \"manifest=true\"","","sap/ui/core/ComponentSupport");s.manifest=true;}s.lifecycle=s.lifecycle===undefined?d.Container:s.lifecycle;s.autoPrefixId=s.autoPrefixId===undefined?true:s.autoPrefixId;};
f.run();return f;});
sap.ui.predefine('sap/ui/core/ContextMenuSupport',["./Control"],function(C){"use strict";var a=function(){var c;if(!(this instanceof C)){return;}function o(e){e.stopPropagation();if(e.srcControl!==this){return;}e.preventDefault();this._oContextMenu.openAsContextMenu(e,this);}c={oncontextmenu:o};this.setContextMenu=function(b){if(b==null&&this.getContextMenu()){this._oContextMenu=null;this.removeEventDelegate(c,this);return;}else if(!b||!b.getMetadata||!b.getMetadata().isInstanceOf("sap.ui.core.IContextMenu")){return;}if(!this._oContextMenu){this.addEventDelegate(c,this);}this._oContextMenu=b;};this.getContextMenu=function(){return this._oContextMenu;};};return a;},true);
sap.ui.predefine('sap/ui/core/CustomData',['./Element'],function(E){"use strict";var C=E._CustomData;return C;});
sap.ui.predefine('sap/ui/core/CustomizingConfiguration',['./Core','./Component','sap/base/Log','sap/base/util/extend','sap/base/util/ObjectPath',"sap/base/util/isEmptyObject"],function(C,a,L,e,O,i){"use strict";var b="sap.ui.viewReplacements",c="sap.ui.viewExtensions",d="sap.ui.viewModifications",f="sap.ui.controllerExtensions",g="sap.ui.controllerReplacements";var m={};
function h(t,o,k){var s=o&&typeof o==="string"?o:(o&&a.getOwnerIdFor(o));if(s){var l=a.get(s);var p=l&&l.getMetadata().getComponentName();var q=m[p+"::"+s];if(q&&q[t]&&k(q[t])){return false;}else{q=m[p];if(q&&q[t]&&k(q[t])){return false;}}}else{for(p in m){q=m[p];if(q&&q[t]&&k(q[t])){break;}}}}
var j={log:function(){if(window.console){window.console.log(m);}},activateForComponent:function(s){L.info("CustomizingConfiguration: activateForComponent('"+s+"')");var F=s+".Component";sap.ui.requireSync(F.replace(/\./g,"/"));var o=O.get(F).getMetadata().getCustomizing();m[s]=o;L.debug("CustomizingConfiguration: customizing configuration for component '"+s+"' loaded: "+JSON.stringify(o));},deactivateForComponent:function(s){if(m[s]){L.info("CustomizingConfiguration: deactivateForComponent('"+s+"')");delete m[s];}},activateForComponentInstance:function(o){L.info("CustomizingConfiguration: activateForComponentInstance('"+o.getId()+"')");var s=o.getMetadata().getComponentName(),k=s+"::"+o.getId(),l=o.getManifest()["sap.ui5"]&&o.getManifest()["sap.ui5"]["extends"]&&o.getManifest()["sap.ui5"]["extends"]["extensions"];m[k]=l;L.debug("CustomizingConfiguration: customizing configuration for component '"+k+"' loaded: "+JSON.stringify(l));},deactivateForComponentInstance:function(o){var s=o.getMetadata().getComponentName(),k=s+"::"+o.getId();if(m[k]){L.info("CustomizingConfiguration: deactivateForComponent('"+k+"')");delete m[k];}},getViewReplacement:function(v,o){var r;h(b,o,function(k){r=k[v];return!!r;});return r;},getViewExtension:function(v,E,o){var r;h(c,o,function(k){r=k[v]&&k[v][E];return!!r;});return r;},getControllerExtension:function(s,o){var r;h(f,o,function(k){r=k[s];return!!r;});return r;},getControllerReplacement:function(s,o){var r;h(g,o,function(k){r=k[s];return!!r;});return r;},getCustomProperties:function(v,s,o){var S;h(d,o,function(k){var l=k[v]&&k[v][s];var u={};var V=false;var p,n;if(l){for(n in l){p=l[n];if(n==="visible"){V=true;u[n]=p;L.info("Customizing: custom value for property '"+n+"' of control '"+s+"' in View '"+v+"' applied: "+p);}else{L.warning("Customizing: custom value for property '"+n+"' of control '"+s+"' in View '"+v+"' ignored: only the 'visible' property can be customized.");}}if(V){S=S||{};e(S,u);}}});return S;},hasCustomProperties:function(v,o){var s={};h(d,o,function(k){if(!!k[v]){s=k[v];}});return!i(s);}};if(sap.ui.getCore().getConfiguration().getDisableCustomizing()){L.info("CustomizingConfiguration: disabling Customizing now");for(var n in j){if(typeof j[n]==="function"){j[n]=function(){};}}}return j;},true);
sap.ui.predefine('sap/ui/core/DeclarativeSupport',['sap/ui/thirdparty/jquery','sap/ui/base/DataType','sap/ui/base/ManagedObject','./Control','./CustomData','./HTML','./mvc/View','./mvc/EventHandlerResolver','sap/base/Log','sap/base/util/ObjectPath','sap/base/assert','sap/base/strings/camelize'],function(q,D,M,C,a,H,V,E,L,O,b,c){"use strict";var d={};d.attributes={"data-sap-ui-type":true,"data-sap-ui-id":true,"data-sap-ui-aggregation":true,"data-sap-ui-default-aggregation":true,"data-sap-ui-binding":function(v,s){var B=M.bindingParser(v);s.objectBindings=s.objectBindings||{};s.objectBindings[B.model||undefined]=B;},"data-tooltip":function(v,s){s["tooltip"]=v;},"tooltip":function(v,s,f){s["tooltip"]=v;L.warning('[Deprecated] Control "'+s.id+'": The attribute "tooltip" is not prefixed with "data-*". Future version of declarative support will only suppport attributes with "data-*" prefix.');},"class":true,"style":true,"id":true};
d.compile=function(e,v,i){var t=this;q(e).find("[data-sap-ui-type]").filter(function(){return q(this).parents("[data-sap-ui-type]").length===0;}).each(function(){t._compile(this,v,i);});};
d._compile=function(e,v,i){var $=q(e);var t=$.attr("data-sap-ui-type");var f=[];var I=t==="sap.ui.core.UIArea";if(I){var g=this;$.children().each(function(){var o=g._createControl(this,v);if(o){f.push(o);}});}else{var o=this._createControl(e,v);if(o){f.push(o);}}$.empty();var A=[];q.each(e.attributes,function(h,j){var n=j.name;if(!I||I&&/^data-/g.test(n.toLowerCase())){A.push(n);}});if(A.length>0){$.removeAttr(A.join(" "));}f.forEach(function(o){if(o instanceof C){if(v&&!i){v.addContent(o);}else{o.placeAt(e);if(v){v.connectControl(o);}}}});};
d._createControl=function(e,v){var $=q(e);var o=null;var t=$.attr("data-sap-ui-type");if(t){var f=sap.ui.requireSync(t.replace(/\./g,"/"));f=f||O.get(t);b(typeof f!=="undefined","Class not found: "+t);var s={};s.id=this._getId($,v);if(v&&v._sProcessingMode!=null&&f.getMetadata().hasSpecialSetting("processingMode")){s.processingMode=v._sProcessingMode;}this._addSettingsForAttributes(s,f,e,v);this._addSettingsForAggregations(s,f,e,v);var o;if(V.prototype.isPrototypeOf(f.prototype)&&typeof f._sType==="string"){o=V._legacyCreate(s,undefined,f._sType);}else{o=new f(s);}if(e.className){o.addStyleClass(e.className);}$.removeAttr("data-sap-ui-type");}else{o=this._createHtmlControl(e,v);}return o;};
d._createHtmlControl=function(e,v){var h=new H();h.setDOMContent(e);this.compile(e,v,true);return h;};
d._addSettingsForAttributes=function(s,f,e,v){var t=this;var S=d.attributes;var B=M.bindingParser;var g=[];var r=/^data-custom-data:(.+)/i;q.each(e.attributes,function(i,A){var n=A.name;var h=A.value;if(!r.test(n)){if(typeof S[n]==="undefined"){n=t.convertAttributeToSettingName(n,s.id);var p=t._getProperty(f,n);if(p){var o=B(h,v&&v.getController(),true);if(o&&typeof o==="object"){s[n]=o;}else{s[n]=t.convertValueToType(t.getPropertyDataType(p),o||h);}}else if(t._getAssociation(f,n)){var j=t._getAssociation(f,n);if(j.multiple){h=h.replace(/\s*,\s*|\s+/g,",");s[n]=h.split(",").map(function(I){return v?v.createId(I):I;});}else{s[n]=v?v.createId(h):h;}}else if(t._getAggregation(f,n)){var k=t._getAggregation(f,n);if(k.multiple){var o=B(h,v&&v.getController());if(o){s[n]=o;}else{throw new Error("Aggregation "+n+" with cardinality 0..n only allows binding paths as attribute value");}}else if(k.altTypes){var o=B(h,v&&v.getController(),true);if(o&&typeof o==="object"){s[n]=o;}else{s[n]=t.convertValueToType(k.altTypes[0],o||h);}}else{throw new Error("Aggregation "+n+" not supported");}}else if(t._getEvent(f,n)){var l=v&&(v._oContainingView||v).getController();var m=E.resolveEventHandler(h,l);if(m){s[n]=m;}else{throw new Error('Control "'+s.id+'": The function "'+h+'" for the event "'+n+'" is not defined');}}else{b((n==="id"),"DeclarativeSupport encountered unknown setting '"+n+"' for class '"+f.getMetadata().getName()+"' (value:'"+h+"')");}}else if(typeof S[n]==="function"){S[n](h,s,f);}}else{n=c(r.exec(n)[1]);var o=B(h,v&&v.getController());g.push(new a({key:n,value:o||h}));}});if(g.length>0){s.customData=g;}return s;};
d._addSettingsForAggregations=function(s,f,e,v){var $=q(e);var g=this._getDefaultAggregation(f,e);var t=this;var A=f.getMetadata().getAllAggregations();$.children().each(function(){var h=q(this);var i=h.attr("data-sap-ui-aggregation");var T=h.attr("data-sap-ui-type");var u=false;if(!i){u=true;i=g;}if(i&&A[i]){var m=A[i].multiple;var j=function(o){var k=t._createControl(o,v);if(k){if(m){if(!s[i]){s[i]=[];}if(typeof s[i].path==="string"){b(!s[i].template,"list bindings support only a single template object");s[i].template=k;}else{s[i].push(k);}}else{s[i]=k;}}};if(u||(T&&!u)){j(this);}else{h.children().each(function(){j(this);});}}h.removeAttr("data-sap-ui-aggregation");h.removeAttr("data-sap-ui-type");});return s;};
d._getId=function(e,v){var $=q(e);var i=$.attr("id");if(i){if(v){i=v.createId(i);$.attr("data-sap-ui-id",i);}$.attr("id","");}return i;};
d._getProperty=function(f,n){return f.getMetadata().getProperty(n);};
d.convertValueToType=function(t,v){if(t instanceof D){v=t.parseValue(v);}return typeof v==="string"?M.bindingParser.escape(v):v;};
d.getPropertyDataType=function(p){var t=D.getType(p.type);if(!t){throw new Error("Property "+p.name+" has no known type");}return t;};
d.convertAttributeToSettingName=function(A,i,e){if(A.indexOf("data-")===0){A=A.substr(5);}else if(e){L.warning('[Deprecated] Control "'+i+'": The attribute "'+A+'" is not prefixed with "data-*". Future version of declarative support will only suppport attributes with "data-*" prefix.');}else{throw new Error('Control "'+i+'": The attribute "'+A+'" is not prefixed with "data-*".');}return c(A);};
d._getAssociation=function(f,n){return f.getMetadata().getAssociation(n);};
d._getAggregation=function(f,n){return f.getMetadata().getAggregation(n);};
d._getEvent=function(f,n){return f.getMetadata().getEvent(n);};
d._getDefaultAggregation=function(f,e){var $=q(e);var s=$.attr("data-sap-ui-default-aggregation")||f.getMetadata().getDefaultAggregationName();$.removeAttr("data-sap-ui-default-aggregation");return s;};
return d;},true);
sap.ui.predefine('sap/ui/core/EnabledPropagator',['./Control'],function(C){"use strict";var E=function(d,l){if(!(this instanceof C)){throw new Error("EnabledPropagator only supports subclasses of Control");}if(d===undefined){d=true;}function f(c){var p=c.getParent();while(p&&!p.getEnabled&&p.getParent){p=p.getParent();}return p;}if(this.getEnabled===undefined){this.getEnabled=function(){var p=f(this);return(p&&p.getEnabled&&!p.getEnabled())?false:this.getProperty("enabled");};if(l){this.getMetadata().addProperty("Enabled",{type:"boolean",group:"Behavior",defaultValue:!!d});}this.getMetadata().addProperty("enabled",{type:"boolean",group:"Behavior",defaultValue:!!d});this.getMetadata().addPublicMethods('getEnabled');}else{var o=this.getEnabled;this.getEnabled=function(){var p=f(this);return(p&&p.getEnabled&&!p.getEnabled())?false:o.apply(this);};}if(this.setEnabled===undefined){this.setEnabled=function(e){return this.setProperty("enabled",e);};this.getMetadata().addPublicMethods('setEnabled');}};return E;},true);
sap.ui.predefine('sap/ui/core/ExtensionPoint',["sap/base/Log","sap/base/util/ObjectPath","sap/ui/core/mvc/View"],function(L,O,V){"use strict";
sap.ui.extensionpoint=function(c,e,C,t,a){L.warning("Do not use deprecated factory function 'sap.ui.extensionpoint'. Use 'sap.ui.core.ExtensionPoint.load' instead","sap.ui.extensionpoint",null,function(){return{type:"sap.ui.extensionpoint",name:e};});return E._factory(c,e,C,t,a);};
var E=sap.ui.extensionpoint;
E._factory=function(c,e,C,t,a){var b,v,r;var d=sap.ui.require('sap/ui/core/CustomizingConfiguration');if(c){if(c.isA("sap.ui.core.mvc.View")){b=d&&d.getViewExtension(c.sViewName,e,c);v=c;}else if(c.isA("sap.ui.core.Fragment")){b=d&&d.getViewExtension(c.getFragmentName(),e,c);v=c._oContainingView;}}if(b){if(b.className){var f=sap.ui.requireSync(b.className.replace(/\./g,"/"));f=f||O.get(b.className);var I=v&&b.id?v.createId(b.id):b.id;L.info("Customizing: View extension found for extension point '"+e+"' in View '"+v.sViewName+"': "+b.className+": "+(b.viewName||b.fragmentName));if(b.className==="sap.ui.core.Fragment"){var F=new f({id:I,type:b.type,fragmentName:b.fragmentName,containingView:v});r=(Array.isArray(F)?F:[F]);}else if(b.className==="sap.ui.core.mvc.View"){v=V._legacyCreate({type:b.type,viewName:b.viewName,id:I});r=[v];}else{L.warning("Customizing: Unknown extension className configured (and ignored) in Component.js for extension point '"+e+"' in View '"+v.sViewName+"': "+b.className);}}else{L.warning("Customizing: no extension className configured in Component.js for extension point '"+e+"' in View '"+v.sViewName+"': "+b.className);}}else if(E._fnExtensionProvider){var s=E._fnExtensionProvider(v);if(s){return[{providerClass:s,view:v,name:e,createDefault:C,targetControl:undefined,aggregationName:undefined,index:undefined,ready:function(g){var n=this._nextSibling;while(n!=null){n.index+=g.length;n=n._nextSibling;}},_isExtensionPoint:true,_nextSibling:null}];}}if(!r&&typeof C==='function'){r=C();}var p=function(r){if(r&&!Array.isArray(r)){r=[r];}if(r&&t){var A=t.getMetadata().getAggregation(a);if(A){for(var i=0,l=r.length;i<l;i++){t[A._sMutator](r[i]);}}else{L.error("Creating extension point failed - Tried to add extension point with name "+e+" to an aggregation of "+t.getId()+" in view "+v.sViewName+", but sAggregationName was not provided correctly and I could not find a default aggregation");}}return r||[];};if(r&&typeof r.then==='function'){return r.then(p);}else{return p(r);}};
E.registerExtensionProvider=function(e){if(e==null){delete E._fnExtensionProvider;}else if(typeof e=="function"){E._fnExtensionProvider=e;}else{L.error("ExtensionPoint provider must be a function!");}};
E.load=function(o){return Promise.resolve(E._factory(o.container,o.name,o.createDefaultContent));};
return E;});
sap.ui.predefine('sap/ui/core/Fragment',['sap/ui/thirdparty/jquery','../base/ManagedObject','./Element','./DeclarativeSupport','./XMLTemplateProcessor','sap/base/Log','sap/base/util/LoaderExtensions','sap/base/util/merge'],function(q,M,E,D,X,L,a,m){"use strict";var r={},t={};
var F=M.extend("sap.ui.core.Fragment",{
metadata:{properties:{type:"string"},specialSettings:{fragmentName:'string',fragmentContent:'any',containingView:{type:'sap.ui.core.mvc.View',visibility:'hidden'},oController:{type:'sap.ui.core.mvc.Controller',visibility:'hidden'},sId:{type:'sap.ui.core.ID',visibility:'hidden'},processingMode:{type:"string",visibility:"hidden"}}},
constructor:function(i,s){M.apply(this,arguments);if(this._aContent&&this._aContent.length==1){return this._aContent[0];}else{return this._aContent;}}
});
F.registerType=function(T,o){if(!typeof(T)==="string"){L.error("Ignoring non-string Fragment type: "+T);return;}if(t[T]){L.warning("sap.ui.core.Fragment.registerType(): Fragment type '"+T+"' is already defined. Overriding this type now!");}t[T]=o;};
F.prototype._initCompositeSupport=function(s){if(!s){throw new Error("Settings must be set");}if(!(s.fragmentName||s.fragmentContent)){throw new Error("Please provide a fragment name");}if(s.oController){this.oController=s.oController;}this._sExplicitId=s.sId||s.id;this._sFragmentName=s.fragmentName;var o=t[s.type];if(o){o.init.apply(this,[s]);}else{throw new Error("No type for the fragment has been specified: "+s.type);}};
F.prototype.getFragmentName=function(){return this._sFragmentName;};
F.prototype.getController=function(){return this.oController;};
F.byId=function(s,i){if(!(typeof(s)==="string"&&typeof(i)==="string")){L.error("sap.ui.core.Fragment.byId: two strings must be given as parameters, but are: "+s+" and "+i);return undefined;}return sap.ui.getCore().byId(s+"--"+i);};
F.createId=function(s,i){if(!(typeof(s)==="string"&&typeof(i)==="string")){L.error("sap.ui.core.Fragment.createId: two strings must be given as parameters, but are: "+s+" and "+i);return undefined;}return s+"--"+i;};
F.prototype.createId=function(i){var b=this._sExplicitId?this._sExplicitId+"--"+i:i;if(this._oContainingView&&this._oContainingView!=this){b=this._oContainingView.createId(b);}return b;};
F.prototype.isSubView=function(){return true;};
sap.ui.fragment=function(n,T,c){var s;if(typeof(T)==="string"){s=T.toLowerCase();}else if(typeof(T)==="object"&&typeof(T.fragmentName)==="string"){s=T.fragmentName.toLowerCase();}else{s="";}L.info("Do not use deprecated factory function 'sap.ui."+s+"fragment'. Require 'sap/ui/core/Fragment' and use 'load()' instead","sap.ui."+s+"fragment",null,function(){return{type:"sap.ui."+s+"fragment",name:s?n+".fragment."+s:n};});return f(n,T,c);};
function f(n,T,c){var s={};if(typeof(n)==="string"){s.fragmentName=n;s.oController=c;s.type=T;}else if(typeof(n)==="object"){s=n;if(T){s.oController=T;}}else{L.error("sap.ui.fragment() must be called with Fragment name or config object as first parameter, but is: "+n);}return new F(s);}
F.load=function(o){var p=Object.assign({},o);p.type=p.type||"XML";p.fragmentName=p.name;p.fragmentContent=p.definition;p.oController=p.controller;delete p.name;delete p.definition;delete p.controller;return Promise.resolve(f(p));};
sap.ui.xmlfragment=function(i,v,c){if(typeof(i)==="string"){if(typeof(v)==="string"){return sap.ui.fragment({fragmentName:v,sId:i,type:"XML"},c);}else{return sap.ui.fragment(i,"XML",v);}}else{i.type="XML";return sap.ui.fragment(i,v);}};
sap.ui.jsfragment=function(n,v,c){if(typeof n==="string"&&typeof v==="object"){if(v.createContent){r[n]=v;sap.ui.loader._.declareModule(n.replace(/\./g,"/")+".fragment.js");}else{return sap.ui.fragment(n,"JS",v);}}else if(typeof n==="string"&&v===undefined){return sap.ui.fragment(n,"JS");}else{if(typeof n==="object"){n.type="JS";return sap.ui.fragment(n,v);}else if(arguments.length>=3){return sap.ui.fragment({id:n,fragmentName:v,type:"JS"},c);}else{L.error("sap.ui.jsfragment() was called with wrong parameter set: "+n+" + "+v);}}};
sap.ui.htmlfragment=function(i,v,c){if(typeof(i)==="string"){if(typeof(v)==="string"){return sap.ui.fragment({fragmentName:v,sId:i,type:"HTML"},c);}else{return sap.ui.fragment(i,"HTML",v);}}else{i.type="HTML";return sap.ui.fragment(i,v);}};
F.registerType("XML",{init:function(s){if(s.fragmentContent){if(typeof(s.fragmentContent)==="string"){this._xContent=q.parseXML(s.fragmentContent).documentElement;}else{this._xContent=s.fragmentContent;}}else{this._xContent=X.loadTemplate(s.fragmentName,"fragment");}this._oContainingView=this._sExplicitId?this:(s.containingView||this);if((this._oContainingView===this)){this._oContainingView.oController=(s.containingView&&s.containingView.oController)||s.oController;}var b=this;b._sProcessingMode=s.processingMode;M.runWithPreprocessors(function(){b._aContent=X.parseTemplate(b._xContent,b);if(b._aContent&&b._aContent.length&&s.objectBindings){b._aContent.forEach(function(c,i){if(c instanceof E){for(var d in s.objectBindings){c.bindObject(s.objectBindings[d]);}}});}},{settings:b._oContainingView._fnSettingsPreprocessor});}});F.registerType("JS",{init:function(s){if(!r[s.fragmentName]){sap.ui.requireSync(s.fragmentName.replace(/\./g,"/")+".fragment");}m(this,r[s.fragmentName]);this._oContainingView=s.containingView||this;var b=this;M.runWithPreprocessors(function(){var c=b.createContent(s.oController||b._oContainingView.oController);b._aContent=[];b._aContent=b._aContent.concat(c);},{settings:b._oContainingView._fnSettingsPreprocessor});}});(function(){var _={};var b=function(T){var u=sap.ui.require.toUrl(T.replace(/\./g,"/"))+".fragment.html";var h=_[u];var R;if(!h){R=T.replace(/\./g,"/")+".fragment.html";h=a.loadResource(R);_[u]=h;}return h;};F.registerType("HTML",{init:function(s){this._aContent=[];this.getContent=function(){return this._aContent;};this.addContent=function(C){this._aContent.push(C);};this._oContainingView=s.containingView||this;this._sProcessingMode=s.processingMode;var h=s.fragmentContent||b(s.fragmentName);this._oTemplate=document.createElement("div");if(typeof h==="string"){this._oTemplate.innerHTML=h;}else{var n=h;var o=document.createDocumentFragment();for(var i=0;i<n.length;i++){o.appendChild(n.item(i));}this._oTemplate.appendChild(o);}var c=this._oTemplate.getElementsByTagName("template")[0];var p=this.getMetadata().getAllProperties();if(c){var d=this;q.each(c.attributes,function(I,A){var N=D.convertAttributeToSettingName(A.name,d.getId());var v=A.value;var P=p[N];if(!s[N]){if(P){s[N]=D.convertValueToType(D.getPropertyDataType(P),v);}else if(sap.ui.core.mvc.HTMLView._mAllowedSettings[N]){s[N]=v;}}});this._oTemplate=c;}if(this._oTemplate.content){var o=this._oTemplate.content;this._oTemplate=document.createElement("div");this._oTemplate.appendChild(o);}var d=this;M.runWithPreprocessors(function(){D.compile(d._oTemplate,d);var e=d.getContent();if(e&&e.length===1){d._aContent=[e[0]];}},{settings:d._oContainingView._fnSettingsPreprocessor});}});}());return F;});
sap.ui.predefine('sap/ui/core/HTML',['sap/ui/thirdparty/jquery',"sap/base/Log",'./Control','./RenderManager',"./HTMLRenderer","sap/base/security/sanitizeHTML"],function(q,L,C,R,H,b){"use strict";var c=R.RenderPrefixes;
var d=C.extend("sap.ui.core.HTML",{metadata:{library:"sap.ui.core",properties:{content:{type:"string",group:"Misc",defaultValue:null},preferDOM:{type:"boolean",group:"Misc",defaultValue:true},sanitizeContent:{type:"boolean",group:"Misc",defaultValue:false},visible:{type:"boolean",group:"Appearance",defaultValue:true}},events:{afterRendering:{parameters:{isPreservedDOM:{type:"boolean"}}}}}});
d.prototype.getDomRef=function(s){var i=s?this.getId()+"-"+s:this.getId();return document.getElementById(c.Dummy+i)||document.getElementById(i);};
d.prototype.setContent=function(e){function p(s){if(q.parseHTML){var a=q.parseHTML(s);if(a){var f=0,g=a.length;while(f<g&&a[f].nodeType!=1){f++;}while(f<g&&a[g-1].nodeType!=1){g--;}if(f>0||g<a.length){a=a.slice(f,g);}return q(a);}}return q(s);}if(this.getSanitizeContent()){L.trace("sanitizing HTML content for "+this);e=b(e);}this.setProperty("content",e,true);if(this.getDomRef()){var $=p(this.getContent());q(this.getDomRef()).replaceWith($);this._postprocessNewContent($);}else{this.invalidate();}return this;};
d.prototype.setSanitizeContent=function(s){this.setProperty("sanitizeContent",s,true);if(s){this.setContent(this.getContent());}return this;};
d.prototype.onBeforeRendering=function(){if(!this.getPreferDOM()){return;}var D=this.getDomRef();if(D&&!R.isPreservedContent(D)){for(var i=D.id,n;D&&D.getAttribute("data-sap-ui-preserve")==i;D=n){n=D.nextElementSibling;R.preserveContent(D,true,false);}}};
d.prototype.onAfterRendering=function(){if(!this.getVisible()){return;}var $=q(document.getElementById(c.Dummy+this.getId()));var a=R.findPreservedContent(this.getId());var e;var i=false;if((!this.getPreferDOM()||a.length==0)){a.remove();e=new q(this.getContent());$.replaceWith(e);}else if(a.length>0){$.replaceWith(a);e=a;i=true;}else{$.remove();}this._postprocessNewContent(e);this.fireAfterRendering({isPreservedDOM:i});};
d.prototype._postprocessNewContent=function($){if($&&$.length>0){if($.length>1){L.warning("[Unsupported Feature]: "+this+" has rendered "+$.length+" root nodes!");}else{var s=$.attr("id");if(s&&s!=this.getId()){L.warning("[Unsupported Feature]: Id of HTML Control '"+this.getId()+"' does not match with content id '"+s+"'!");}}if(this.getPreferDOM()){R.markPreservableContent($,this.getId());}if($.find("#"+this.getId().replace(/(:|\.)/g,'\\$1')).length===0){$.filter(":not([id])").first().attr("id",this.getId());}}else{L.debug(""+this+" is empty after rendering, setting bOutput to false");this.bOutput=false;}};
d.prototype.setDOMContent=function(D){var $=q(D);if(this.getDomRef()){q(this.getDomRef()).replaceWith($);this._postprocessNewContent($);}else{$.appendTo(R.getPreserveAreaRef());if(this.getUIArea()){this.getUIArea().invalidate();}this._postprocessNewContent($);}return this;};
d.prototype.setTooltip=function(){L.warning("The sap.ui.core.HTML control doesn't support tooltips. Add the tooltip to the HTML content instead.");return C.prototype.setTooltip.apply(this,arguments);};
"hasStyleClass addStyleClass removeStyleClass toggleStyleClass".split(" ").forEach(function(m){d.prototype[m]=function(){L.warning("The sap.ui.core.HTML control doesn't support custom style classes. Manage custom CSS classes in the HTML content instead.");return C.prototype[m].apply(this,arguments);};});return d;});
sap.ui.predefine('sap/ui/core/HTMLRenderer',['./RenderManager'],function(R){"use strict";var a=R.RenderPrefixes;var H={apiVersion:2,render:function(r,c){r.openStart("div",a.Dummy+c.getId());r.style("display","none");r.openEnd();r.close("div");}};return H;},true);
sap.ui.predefine('sap/ui/core/History',['sap/ui/base/Object',"sap/ui/util/Storage"],function(B,S){"use strict";
var H=B.extend("sap.ui.core.History",{
constructor:function(i,s){B.apply(this);if(!s){s={};}var h=s.prefix?s.prefix:document.location.pathname;this._iMaxHistory=s.max?s.max:100;this._sHistoryId=h+i;this._oStorage=new S(S.Type.local);this._fFilter=s.filter?s.filter:function(a,v){return a&&(!v||(v&&((typeof v=="string"?a.toLowerCase().startsWith(v.toLowerCase()):false))));};this._fCheckHistory=s.checkHistory?s.checkHistory:function(a){return a;};},
_initHistory:function(){if(!this._aHistory){var h=this._oStorage.get(this._sHistoryId);if(typeof(h)==="string"){h=h.split(",");}else if(!h){h=[];}this._aHistory=this._fCheckHistory(h);}return this._aHistory;},
get:function(v){var h=this._initHistory();var r=[];for(var i=0;i<h.length;i++){if(this._fFilter(h[i],v)){r.push(h[i]);}}return r;},
remove:function(v){var h=this._initHistory();for(var i=0;i<h.length;i++){if(h[i]==v){h.splice(i,1);break;}}},
add:function(v){var h=this._initHistory();for(var i=0;i<h.length;i++){if(h[i]===v){h.splice(i,1);break;}}h.unshift(v);if(h.length>this._iMaxHistory){h.splice(this._iMaxHistory);}this._oStorage.put(this._sHistoryId,h);},
clear:function(){this._oStorage.remove(this._sHistoryId);this._aHistory=null;}
});
return H;});
sap.ui.predefine('sap/ui/core/Icon',['sap/base/assert','../Device','./Control','./IconPool','./InvisibleText','./library',"./IconRenderer","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/base/Log"],function(a,D,C,I,b,l,c,K,q,L){"use strict";var d=l.IconColor;var e=l.CSSColor;var i=function(v){if(v!=null&&v!==""&&!e.isValid(v)&&!(v in d)){L.error("\""+v+"\" is not of type sap.ui.core.CSSColor nor of type sap.ui.core.IconColor.");return false;}else{return true;}};
var f=C.extend("sap.ui.core.Icon",{metadata:{interfaces:["sap.ui.core.IFormContent"],library:"sap.ui.core",designtime:"sap/ui/core/designtime/Icon.designtime",properties:{src:{type:"sap.ui.core.URI",group:"Data",defaultValue:null},size:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},color:{type:"string",group:"Appearance",defaultValue:null},hoverColor:{type:"string",group:"Appearance",defaultValue:null},activeColor:{type:"string",group:"Appearance",defaultValue:null},width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},backgroundColor:{type:"string",group:"Appearance",defaultValue:null},hoverBackgroundColor:{type:"string",group:"Appearance",defaultValue:null},activeBackgroundColor:{type:"string",group:"Appearance",defaultValue:null},decorative:{type:"boolean",group:"Accessibility",defaultValue:true},useIconTooltip:{type:"boolean",group:"Accessibility",defaultValue:true},alt:{type:"string",group:"Accessibility",defaultValue:null},noTabStop:{type:"boolean",group:"Accessibility",defaultValue:false}},aggregations:{_invisibleText:{type:"sap.ui.core.InvisibleText",multiple:false,visibility:"hidden"}},associations:{ariaLabelledBy:{type:"sap.ui.core.Control",multiple:true,singularName:"ariaLabelledBy"}},events:{press:{}}}});
f.prototype[D.support.touch?"ontouchstart":"onmousedown"]=function(E){if(this.hasListeners("press")){E.setMarked();}var A=this.getActiveColor(),s=this.getActiveBackgroundColor(),$;if(A||s){if(!E.targetTouches||(E.targetTouches&&E.targetTouches.length===1)){$=this.$();$.addClass("sapUiIconActive");if(A){this._addColorClass(A,"color");}if(s){this._addColorClass(s,"background-color");}}}};f.prototype[D.support.touch?"ontouchend":"onmouseup"]=function(E){if(!E.targetTouches||(E.targetTouches&&E.targetTouches.length===0)){this.$().removeClass("sapUiIconActive");this._restoreColors(D.system.desktop?"hover":undefined);}};
f.prototype.onmouseover=function(){var h=this.getHoverColor(),H=this.getHoverBackgroundColor();if(h){this._addColorClass(h,"color");}if(H){this._addColorClass(H,"background-color");}};
f.prototype.onmouseout=function(){this._restoreColors();};
f.prototype[D.support.touch&&!D.system.desktop?"ontap":"onclick"]=function(E){if(this.hasListeners("press")){E.setMarked();}this.firePress({});};
f.prototype.onkeydown=function(E){if(E.which===K.SPACE||E.which===K.ENTER){E.preventDefault();var $=this.$(),A=this.getActiveColor(),s=this.getActiveBackgroundColor();$.addClass("sapUiIconActive");if(A){this._addColorClass(A,"color");}if(s){this._addColorClass(s,"background-color");}}};
f.prototype.onkeyup=function(E){if(E.which===K.SPACE||E.which===K.ENTER){this.$().removeClass("sapUiIconActive");this._restoreColors();this.firePress({});}};
f.prototype._restoreColors=function(m){var s,B;if(m==="hover"){s=this.getHoverColor();B=this.getHoverBackgroundColor();}s=s||this.getColor();B=B||this.getBackgroundColor();this._addColorClass(s||"","color");this._addColorClass(B||"","background-color");};
f.prototype._addColorClass=function(s,g){var $=this.$(),t=this;var h="";if(g==="color"){h="sapUiIconColor";}else if(g==="background-color"){h="sapUiIconBGColor";}else{return;}q.each(d,function(p,P){t.removeStyleClass(h+P);});if(s in d){$.css(g,"");this.addStyleClass(h+s);}else{$.css(g,s);}};
f.prototype.setSrc=function(s){a(s==null||I.isIconURI(s),this+": Property 'src' (value: '"+s+"') should be a valid Icon URI (sap-icon://...)");return this.setProperty("src",s);};
f.prototype.setColor=function(s){if(i(s)){this.setProperty("color",s,true);this._addColorClass(s,"color");}return this;};
f.prototype.setActiveColor=function(s){if(i(s)){this.setProperty("activeColor",s,true);}return this;};
f.prototype.setHoverColor=function(s){if(i(s)){this.setProperty("hoverColor",s,true);}return this;};
f.prototype.setBackgroundColor=function(s){if(i(s)){this.setProperty("backgroundColor",s,true);this._addColorClass(s,"background-color");}return this;};
f.prototype.setActiveBackgroundColor=function(s){if(i(s)){this.setProperty("activeBackgroundColor",s,true);}return this;};
f.prototype.setHoverBackgroundColor=function(s){if(i(s)){this.setProperty("hoverBackgroundColor",s,true);}return this;};
f.prototype.attachEvent=function(E){C.prototype.attachEvent.apply(this,arguments);if(E=="press"&&this.hasListeners("press")){this.invalidate();}return this;};
f.prototype.detachEvent=function(E){C.prototype.detachEvent.apply(this,arguments);if(E=="press"&&!this.hasListeners("press")){this.invalidate();}return this;};
f.prototype._getOutputTitle=function(o){var t=this.getTooltip_AsString(),u=this.getUseIconTooltip();if(t||(u&&o&&o.text)){return t||o.text;}};
f.prototype._getIconLabel=function(o){var A=this.getAlt(),t=this.getTooltip_AsString(),u=this.getUseIconTooltip(),s=A||t||(u&&o&&(o.text||o.name)),O=this._getOutputTitle(o);if(s&&s!==O){return s;}};
f.prototype._createInvisibleText=function(t){var o=this.getAggregation("_invisibleText");if(!o){o=new b(this.getId()+"-label",{text:t});this.setAggregation("_invisibleText",o,true);}else{o.setProperty("text",t,true);}return o;};
f.prototype._getAccessibilityAttributes=function(o){var g=this.getAriaLabelledBy(),A={},s=this._getIconLabel(o),h;if(this.getDecorative()){A.role="presentation";A.hidden="true";}else{if(this.hasListeners("press")){A.role="button";}else{A.role="img";}}if(g.length>0){if(s){h=this._createInvisibleText(s);g.push(h.getId());}A.labelledby=g.join(" ");}else if(s){A.label=s;}return A;};
f.prototype.getAccessibilityInfo=function(){if(this.getDecorative()){return null;}var h=this.hasListeners("press");var o=I.getIconInfo(this.getSrc(),undefined,"sync");return{role:h?"button":"img",type:sap.ui.getCore().getLibraryResourceBundle("sap.ui.core").getText(h?"ACC_CTR_TYPE_BUTTON":"ACC_CTR_TYPE_IMAGE"),description:this.getAlt()||this.getTooltip_AsString()||(o?o.text||o.name:""),focusable:h};};
return f;});
sap.ui.predefine('sap/ui/core/IconPool',['./Core','sap/ui/thirdparty/URI',"sap/base/i18n/ResourceBundle","sap/base/Log","sap/ui/thirdparty/jquery"],function(c,U,R,L,q){"use strict";var S='SAP-icons';var I='sap-icon';var f={undefined:{config:{fontFamily:S},metadataLoaded:true,inserted:true}};var r={'undefined':{'accidental-leave':0xe000,'account':0xe001,'wrench':0xe002,'windows-doors':0xe003,'washing-machine':0xe004,'visits':0xe005,'video':0xe006,'travel-expense':0x1e007,'temperature':0xe008,'task':0x1e009,'synchronize':0xe00a,'survey':0x1e00b,'settings':0xe00c,'search':0x1e00d,'sales-document':0x1e00e,'retail-store':0xe00f,'refresh':0xe010,'product':0xe011,'present':0xe012,'ppt-attachment':0xe013,'pool':0xe014,'pie-chart':0xe015,'picture':0xe016,'photo-voltaic':0xe017,'phone':0xe018,'pending':0xe019,'pdf-attachment':0xe01a,'past':0x1e01b,'outgoing-call':0xe01c,'opportunity':0xe01d,'opportunities':0x1e01e,'notes':0xe01f,'money-bills':0x1e020,'map':0xe021,'log':0xe022,'line-charts':0xe023,'lightbulb':0xe024,'leads':0xe025,'lead':0x1e026,'laptop':0xe027,'kpi-managing-my-area':0x1e028,'kpi-corporate-performance':0x1e029,'incoming-call':0xe02a,'inbox':0xe02b,'horizontal-bar-chart':0xe02c,'history':0xe02d,'heating-cooling':0xe02e,'gantt-bars':0xe02f,'future':0x1e030,'fridge':0xe031,'fallback':0xe032,'expense-report':0x1e033,'excel-attachment':0xe034,'energy-saving-lightbulb':0xe035,'employee':0xe036,'email':0xe037,'edit':0xe038,'duplicate':0xe039,'download':0xe03a,'doc-attachment':0xe03b,'dishwasher':0xe03c,'delete':0xe03d,'decline':0xe03e,'complete':0x1e03f,'competitor':0xe040,'collections-management':0xe041,'chalkboard':0x1e042,'cart':0xe043,'card':0xe044,'camera':0xe045,'calendar':0x1e046,'begin':0xe047,'basket':0xe048,'bar-chart':0xe049,'attachment':0xe04a,'arrow-top':0xe04b,'arrow-right':0xe04c,'arrow-left':0xe04d,'arrow-bottom':0xe04e,'approvals':0x1e04f,'appointment':0xe050,'alphabetical-order':0x1e051,'along-stacked-chart':0xe052,'alert':0xe053,'addresses':0xe054,'address-book':0x1e055,'add-filter':0xe056,'add-favorite':0xe057,'add':0xe058,'activities':0x1e059,'action':0xe05a,'accept':0x1e05b,'hint':0x1e05c,'group':0xe05d,'check-availability':0x1e05e,'weather-proofing':0xe05f,'payment-approval':0x1e060,'batch-payments':0x1e061,'bed':0xe062,'arobase':0x1e063,'family-care':0xe064,'favorite':0xe065,'navigation-right-arrow':0xe066,'navigation-left-arrow':0xe067,'e-care':0xe068,'less':0xe069,'lateness':0xe06a,'lab':0xe06b,'internet-browser':0xe06c,'instance':0xe06d,'inspection':0xe06e,'image-viewer':0xe06f,'home':0xe070,'grid':0xe071,'goalseek':0xe072,'general-leave-request':0xe073,'create-leave-request':0xe074,'flight':0xe075,'filter':0xe076,'favorite-list':0xe077,'factory':0xe078,'endoscopy':0xe079,'employee-pane':0xe07a,'employee-approvals':0x1e07b,'email-read':0xe07c,'electrocardiogram':0xe07d,'documents':0xe07e,'decision':0xe07f,'database':0xe080,'customer-history':0xe081,'customer':0xe082,'credit-card':0xe083,'create-entry-time':0xe084,'contacts':0xe085,'compare':0xe086,'clinical-order':0xe087,'chain-link':0xe088,'pull-down':0xe089,'cargo-train':0xe08a,'car-rental':0xe08b,'business-card':0xe08c,'bar-code':0xe08d,'folder-blank':0xe08e,'passenger-train':0xe08f,'question-mark':0x1e090,'world':0xe091,'iphone':0xe092,'ipad':0xe093,'warning':0xe094,'sort':0xe095,'course-book':0xe096,'course-program':0xe097,'add-coursebook':0xe098,'print':0xe099,'save':0xe09a,'play':0x1e09b,'pause':0xe09c,'record':0xe09d,'response':0xe09e,'pushpin-on':0xe09f,'pushpin-off':0xe0a0,'unfavorite':0xe0a1,'learning-assistant':0xe0a2,'timesheet':0xe0a3,'time-entry-request':0xe0a4,'list':0xe0a5,'action-settings':0xe0a6,'share':0xe0a7,'feed':0xe0a8,'role':0xe0a9,'flag':0x1e0aa,'post':0xe0ab,'inspect':0xe0ac,'inspect-down':0xe0ad,'appointment-2':0xe0ae,'target-group':0xe0af,'marketing-campaign':0xe0b0,'notification':0xe0b1,'message-error':0xe0b1,'comment':0xe0b2,'shipping-status':0xe0b3,'collaborate':0xe0b4,'shortcut':0xe0b5,'lead-outdated':0x1e0b6,'tools-opportunity':0xe0b7,'permission':0xe0b8,'supplier':0xe0b9,'table-view':0xe0ba,'table-chart':0xe0bb,'switch-views':0xe0bc,'e-learning':0xe0bd,'manager':0xe0be,'switch-classes':0xe0bf,'simple-payment':0x1e0c0,'signature':0xe0c1,'sales-order-item':0x1e0c2,'sales-order':0x1e0c3,'request':0xe0c4,'receipt':0xe0c5,'puzzle':0xe0c6,'process':0xe0c7,'private':0xe0c8,'popup-window':0xe0c9,'person-placeholder':0xe0ca,'per-diem':0x1e0cb,'paper-plane':0xe0cc,'paid-leave':0x1e0cd,'pdf-reader':0x1e0ce,'overview-chart':0xe0cf,'overlay':0xe0d0,'org-chart':0xe0d1,'number-sign':0xe0d2,'notification-2':0xe0d3,'my-sales-order':0x1e0d4,'meal':0xe0d5,'loan':0x1e0d6,'order-status':0x1e0d7,'customer-order-entry':0x1e0d8,'performance':0xe0d9,'menu':0xe0da,'employee-lookup':0xe0db,'education':0xe0dc,'customer-briefing':0xe0dd,'customer-and-contacts':0xe0de,'my-view':0xe0df,'accelerated':0xe0e0,'to-be-reviewed':0xe0e1,'warning2':0xe0e2,'feeder-arrow':0xe0e3,'quality-issue':0xe0e4,'workflow-tasks':0xe0e5,'create':0xe0e6,'home-share':0xe0e7,'globe':0x1e0e8,'tags':0xe0e9,'work-history':0xe0ea,'x-ray':0xe0eb,'wounds-doc':0xe0ec,'web-cam':0xe0ed,'waiver':0x1e0ee,'vertical-bar-chart':0xe0ef,'upstacked-chart':0xe0f0,'trip-report':0xe0f1,'microphone':0xe0f2,'unpaid-leave':0x1e0f3,'tree':0xe0f4,'toaster-up':0xe0f5,'toaster-top':0xe0f6,'toaster-down':0xe0f7,'time-account':0xe0f8,'theater':0xe0f9,'taxi':0xe0fa,'subway-train':0xe0fb,'study-leave':0xe0fc,'stethoscope':0xe0fd,'step':0xe0fe,'sonography':0xe0ff,'soccor':0xe100,'soccer':0xe100,'physical-activity':0xe101,'pharmacy':0xe102,'official-service':0xe103,'offsite-work':0xe104,'nutrition-activity':0xe105,'newspaper':0xe106,'monitor-payments':0x1e107,'map-2':0xe108,'machine':0xe109,'mri-scan':0xe10a,'end-user-experience-monitoring':0xe10b,'unwired':0xe10c,'customer-financial-fact-sheet':0x1e10d,'retail-store-manager':0xe10e,'Netweaver-business-client':0xe10f,'electronic-medical-record':0xe110,'eam-work-order':0x1e111,'customer-view':0xe112,'crm-service-manager':0xe113,'crm-sales':0x1e114,'widgets':0x1e115,'commission-check':0x1e116,'collections-insight':0x1e117,'clinical-tast-tracker':0xe118,'citizen-connect':0xe119,'cart-approval':0x1e11a,'capital-projects':0x1e11b,'bo-strategy-management':0xe11c,'business-objects-mobile':0xe11d,'business-objects-explorer':0xe11e,'business-objects-experience':0xe11f,'bbyd-dashboard':0xe120,'bbyd-active-sales':0x1e121,'business-by-design':0x1e122,'business-one':0x1e123,'sap-box':0xe124,'manager-insight':0xe125,'accounting-document-verification':0x1e126,'hr-approval':0x1e127,'idea-wall':0xe128,'Chart-Tree-Map':0xe129,'cart-5':0xe12a,'cart-4':0xe12b,'wallet':0xe12c,'vehicle-repair':0xe12d,'upload':0xe12e,'unlocked':0xe12f,'umbrella':0xe130,'travel-request':0x1e131,'travel-expense-report':0x1e132,'travel-itinerary':0xe133,'time-overtime':0x1e134,'thing-type':0xe135,'technical-object':0xe136,'tag':0xe137,'syringe':0xe138,'syntax':0xe139,'suitcase':0xe13a,'simulate':0xe13b,'shield':0xe13c,'share-2':0xe13d,'sales-quote':0x1e13e,'repost':0xe13f,'provision':0xe140,'projector':0xe141,'add-product':0xe142,'pipeline-analysis':0xe143,'add-photo':0xe144,'palette':0xe145,'nurse':0xe146,'sales-notification':0x1e147,'mileage':0xe148,'meeting-room':0xe149,'media-forward':0x1e14a,'media-play':0x1e14b,'media-pause':0xe14c,'media-reverse':0x1e14d,'media-rewind':0x1e14e,'measurement-document':0xe14f,'measuring-point':0xe150,'measure':0xe151,'map-3':0xe152,'locked':0xe153,'letter':0xe154,'journey-arrive':0xe155,'journey-change':0xe156,'journey-depart':0xe157,'it-system':0xe158,'it-instance':0xe159,'it-host':0xe15a,'iphone-2':0xe15b,'ipad-2':0xe15c,'inventory':0xe15d,'insurance-house':0xe15e,'insurance-life':0xe15f,'insurance-car':0xe160,'initiative':0xe161,'incident':0x1e162,'group-2':0xe163,'goal':0xe164,'functional-location':0xe165,'full-screen':0xe166,'form':0xe167,'fob-watch':0xe168,'blank-tag':0xe169,'family-protection':0xe16a,'folder':0xe16b,'fax-machine':0xe16c,'example':0xe16d,'eraser':0xe16e,'employee-rejections':0xe16f,'drop-down-list':0xe170,'draw-rectangle':0xe171,'document':0xe172,'doctor':0xe173,'discussion-2':0xe174,'discussion':0xe175,'dimension':0xe176,'customer-and-supplier':0xe177,'crop':0xe178,'add-contact':0xe179,'compare-2':0xe17a,'color-fill':0xe17b,'collision':0xe17c,'curriculum':0xe17d,'chart-axis':0xe17e,'full-stacked-chart':0xe17f,'full-stacked-column-chart':0xe180,'vertical-bar-chart-2':0xe181,'horizontal-bar-chart-2':0xe182,'horizontal-stacked-chart':0xe183,'vertical-stacked-chart':0xe184,'choropleth-chart':0x1e185,'geographic-bubble-chart':0x1e186,'multiple-radar-chart':0xe187,'radar-chart':0xe188,'crossed-line-chart':0xe189,'multiple-line-chart':0xe18a,'multiple-bar-chart':0xe18b,'line-chart':0xe18c,'line-chart-dual-axis':0xe18d,'bubble-chart':0xe18e,'scatter-chart':0xe18f,'multiple-pie-chart':0xe190,'column-chart-dual-axis':0xe191,'tag-cloud-chart':0xe192,'area-chart':0xe193,'cause':0xe194,'cart-3':0xe195,'cart-2':0xe196,'bus-public-transport':0xe197,'burglary':0xe198,'building':0xe199,'border':0xe19a,'bookmark':0xe19b,'badge':0xe19c,'attachment-audio':0xe19d,'attachment-video':0xe19e,'attachment-html':0xe19f,'attachment-photo':0xe1a0,'attachment-e-pub':0xe1a1,'attachment-zip-file':0xe1a2,'attachment-text-file':0xe1a3,'add-equipment':0xe1a4,'add-activity':0x1e1a5,'activity-individual':0xe1a6,'activity-2':0x1e1a7,'add-activity-2':0x1e1a8,'activity-items':0xe1a9,'activity-assigned-to-goal':0xe1aa,'status-completed':0xe1ab,'status-positive':0xe1ab,'status-error':0xe1ac,'status-negative':0xe1ac,'status-inactive':0xe1ad,'status-in-process':0xe1ae,'status-critical':0xe1ae,'blank-tag-2':0xe1af,'cart-full':0xe1b0,'locate-me':0xe1b1,'paging':0xe1b2,'company-view':0xe1b3,'document-text':0xe1b4,'explorer':0xe1b5,'personnel-view':0xe1b6,'sorting-ranking':0xe1b7,'drill-down':0xe1b8,'drill-up':0xe1b9,'vds-file':0xe1ba,'sap-logo-shape':0x1e1bb,'folder-full':0xe1bc,'system-exit':0xe1bd,'system-exit-2':0xe1be,'close-command-field':0xe1bf,'open-command-field':0xe1c0,'sys-enter-2':0x1e1c1,'sys-enter':0x1e1c2,'sys-help-2':0x1e1c3,'sys-help':0x1e1c4,'sys-back':0xe1c5,'sys-back-2':0xe1c6,'sys-cancel':0xe1c7,'sys-cancel-2':0xe1c8,'open-folder':0xe1c9,'sys-find-next':0xe1ca,'sys-find':0xe1cb,'sys-monitor':0xe1cc,'sys-prev-page':0xe1cd,'sys-first-page':0xe1ce,'sys-next-page':0xe1cf,'sys-last-page':0xe1d0,'generate-shortcut':0xe1d1,'create-session':0xe1d2,'display-more':0xe1d3,'enter-more':0xe1d4,'zoom-in':0xe1d5,'zoom-out':0xe1d6,'header':0xe1d7,'detail-view':0xe1d8,'show-edit':0xe1d8,'collapse':0xe1d9,'expand':0xe1da,'positive':0xe1db,'negative':0xe1dc,'display':0xe1dd,'menu2':0xe1de,'redo':0xe1df,'undo':0xe1e0,'navigation-up-arrow':0xe1e1,'navigation-down-arrow':0xe1e2,'down':0xe1e3,'up':0xe1e4,'shelf':0xe1e5,'background':0xe1e6,'resize':0xe1e7,'move':0xe1e8,'show':0xe1e9,'hide':0xe1ea,'nav-back':0xe1eb,'error':0xe1ec,'slim-arrow-right':0xe1ed,'slim-arrow-left':0xe1ee,'slim-arrow-down':0xe1ef,'slim-arrow-up':0xe1f0,'forward':0xe1f1,'overflow':0xe1f2,'value-help':0xe1f3,'multi-select':0x1e1f4,'exit-full-screen':0xe1f5,'sys-add':0xe1f6,'sys-minus':0xe1f7,'dropdown':0xe1f8,'expand-group':0xe1f9,'collapse-group':0xe200,'vertical-grip':0xe1fa,'horizontal-grip':0xe1fb,'sort-descending':0xe1fc,'sort-ascending':0xe1fd,'arrow-down':0xe1fe,'legend':0xe1ff,'message-warning':0xe201,'message-information':0x1e202,'message-success':0x1e203,'restart':0xe204,'stop':0xe205,'add-process':0xe206,'cancel-maintenance':0xe207,'activate':0xe208,'resize-horizontal':0xe209,'resize-vertical':0xe20a,'connected':0xe20b,'disconnected':0xe20c,'edit-outside':0xe20d,'key':0xe20e,'minimize':0xe20f,'back-to-top':0xe210,'hello-world':0xe211,'outbox':0xe212,'donut-chart':0xe213,'heatmap-chart':0xe214,'horizontal-bullet-chart':0xe215,'vertical-bullet-chart':0xe216,'call':0xe217,'download-from-cloud':0xe218,'upload-to-cloud':0xe219,'jam':0xe21a,'sap-ui5':0xe21b,'message-popup':0xe21c,'cloud':0xe21d,'horizontal-waterfall-chart':0x1e21e,'vertical-waterfall-chart':0x1e21f,'broken-link':0xe220,'headset':0xe221,'thumb-up':0x1e222,'thumb-down':0x1e223,'multiselect-all':0x1e224,'multiselect-none':0x1e225,'scissors':0xe226,'sound':0x1e227,'sound-loud':0x1e228,'sound-off':0x1e229,'date-time':0x1e22a,'user-settings':0xe22b,'key-user-settings':0xe22c,'developer-settings':0xe22d,'text-formatting':0x1e22e,'bold-text':0x1e22f,'italic-text':0x1e230,'underline-text':0x1e231,'text-align-justified':0x1e232,'text-align-left':0x1e233,'text-align-center':0x1e234,'text-align-right':0x1e235,'bullet-text':0x1e236,'numbered-text':0x1e237,'co':0xe238,'ui-notifications':0xe239,'bell':0xe23a,'cancel-share':0xe23b,'write-new-document':0xe23c,'write-new':0xe23d,'cancel':0x1e23e,'screen-split-one':0xe23f,'screen-split-two':0xe240,'screen-split-three':0xe241,'customize':0xe242,'user-edit':0xe243,'source-code':0xe244,'copy':0xe245,'paste':0xe246,'line-chart-time-axis':0x1e247,'clear-filter':0xe248,'reset':0xe249,'trend-up':0xe24a,'trend-down':0xe24b,'cursor-arrow':0xe24c,'add-document':0xe24d,'create-form':0xe24e,'resize-corner':0xe24f,'chevron-phase':0xe250,'chevron-phase-2':0xe251,'rhombus-milestone':0xe252,'rhombus-milestone-2':0xe253,'circle-task':0xe254,'circle-task-2':0xe255,'project-definition-triangle':0xe256,'project-definition-triangle-2':0xe257,'master-task-triangle':0xe258,'master-task-triangle-2':0xe259,'program-triangles':0xe25a,'program-triangles-2':0xe25b,'mirrored-task-circle':0xe25c,'mirrored-task-circle-2':0xe25d,'checklist-item':0xe25e,'checklist-item-2':0xe25f,'checklist':0xe260,'checklist-2':0xe261,'chart-table-view':0xe262,'filter-analytics':0xe263,'filter-facets':0xe264,'filter-fields':0xe265,'indent':0xe266,'outdent':0xe267,'heading1':0x1e268,'heading2':0x1e269,'heading3':0x1e26a,'decrease-line-height':0xe26b,'increase-line-height':0xe26c,'fx':0x1e26d,'add-folder':0xe26e,'away':0xe26f,'busy':0xe270,'appear-offline':0xe271,'blur':0xe272,'pixelate':0xe273,'horizontal-combination-chart':0xe274,'add-employee':0xe275,'text-color':0x1e276,'browse-folder':0xe277,'primary-key':0xe278,'two-keys':0xe279,'strikethrough':0xe27a,'text':0xe27b,'responsive':0xe27c,'desktop-mobile':0xe27d,'table-row':0xe27e,'table-column':0xe27f,'validate':0x1e280,'keyboard-and-mouse':0xe281,'touch':0xe282,'expand-all':0xe283,'collapse-all':0xe284,'combine':0xe285,'split':0xe286,'megamenu':0xe287,'feedback':0xe288,'information':0xe289,'s4hana':0x1e28A,'translate':0x1e28B}};var C;
function g(){if(!C){C=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core");}return C;}
var a;var b={};
b.createControlByURI=function(s,d){if(typeof s==="string"){s={src:s};}if(s&&s.src){var e=s.src,h=d;if(b.isIconURI(e)){a=a||sap.ui.requireSync("sap/ui/core/Icon");h=a;if(s.tap){s.press=s.tap;delete s.tap;}}if(typeof h==="function"){s=h.getMetadata().removeUnknownSettings(s);return new h(s);}}};
b.addIcon=function(d,e,h){if(typeof h==="string"){h={fontFamily:arguments[2],content:arguments[3],overWrite:!!arguments[4],suppressMirroring:!!arguments[5]};}if(typeof e!=="string"){e=String(e);}e=e==='undefined'?undefined:e;if(!r[e]){r[e]={};}var j=r[e],k=j[d],p,s,t,K;if(k){if(e===undefined){L.warning("Icon with name '"+d+"' in built-in collection already exists and can not be overwritten.","sap.ui.core.IconPool");return;}else if(!h.overWrite){L.warning("Icon with name '"+d+"' in collection '"+e+"' already exists. Specify 'iconInfo.overWrite' in order to overwrite.","sap.ui.core.IconPool");return;}}p={protocol:I,hostname:e||d,path:e?d:undefined};if(Array.isArray(h.content)){s=h.content.map(m).join('');}else{s=m(h.content);}if(h.resourceBundle instanceof R){K="Icon."+d;if(h.resourceBundle.hasText(K)){t=h.resourceBundle.getText(K);}}k=j[d]={name:d,collection:e,uri:U.build(p),fontFamily:h.fontFamily,content:s,text:t||'',suppressMirroring:h.suppressMirroring,skipMirroring:h.suppressMirroring};return k;};
b.getIconURI=function(d,e){var h=this.getIconInfo(d,e);return h&&h.uri;};
b.getIconInfo=function(d,e,l){var p,h,j,n=b.isIconURI(d);if(!d){return;}if(!l&&n){l=e;}l=l||"sync";j=(l==="async"||l==="mixed");function k(){var s=r[e];var h=s&&s[d];if(typeof h==='number'){r[e][d]=undefined;h=b.addIcon(d,e,{fontFamily:f[e].config.fontFamily,content:h&0xFFFF,suppressMirroring:!!(h&0x10000),resourceBundle:g()});}return h;}if(n){p=U.parse(d);if(p.path.length===1){e=undefined;d=p.hostname;}else{e=p.hostname;d=p.path.slice(1);}if(!d){return;}}if(typeof e!=="string"){e=String(e);}e=e==='undefined'?undefined:e;h=k();if(h===undefined&&e!==undefined){var o=b._loadFontMetadata(e,j);}if(j){if(o){return o.then(function(){h=k();if(!h){L.warning("Icon info for icon '"+d+"' in collection '"+e+"' could not be fetched");}return h;});}else{if(l==="async"){return Promise.resolve(h);}else{h=k();}}}else{h=k();}if(!h){L.warning("Icon info for icon '"+d+"' in collection '"+e+"' could not be fetched");}return h;};
b.fontLoaded=function(s){if(f[s]){if(f[s].metadataLoaded instanceof Promise){return f[s].metadataLoaded;}else if(f[s].metadataLoaded===true){return Promise.resolve();}}};
b.isIconURI=function(u){if(!u){return false;}var p=U.parse(u);return p.protocol===I&&!!p.hostname;};
b.getIconCollectionNames=function(){return Object.keys(r);};
b.getIconNames=function(d){var e=r[d];return e?Object.keys(e):[];};
b.insertFontFaceStyle=function(F,p,s){var e;if(arguments.length===0||F===S){L.info("It's not needed to call IconPool.insertFontFaceStyle to insert font-face for the predefined icon font SAP-icons because the font-face is included in the library.css of sap.ui.core");return;}if(F&&p===undefined){L.error("IconPool.insertFontFaceStyle must be called with at least two parameters!");return;}if(s===undefined){s=F;}if(!f[s]){L.error("Icon font '"+s+"' has not been registered yet.");return;}if(f[s].inserted){L.info("The font face style of icon font '"+s+"' was already inserted.");return;}e=document.createElement("style");e.type="text/css";e.textContent="@font-face {"+"font-family: '"+F+"';"+"src: url('"+p+F+".woff2') format('woff2'),"+"url('"+p+F+".woff') format('woff'),"+"url('"+p+F+".ttf') format('truetype'),"+"local('"+F+"');"+"font-weight: normal;"+"font-style: normal;"+"}";document.head.appendChild(e);f[s].inserted=true;f[s].fontFace=F;};
b.registerFont=function(o){o.collectionName=o.collectionName||o.fontFamily;if(!o.fontURI){L.error("The configuration parameter fontURI is missing, cannot register the font '"+o.collectionName+"'!");return;}if(o.fontFamily===S){L.error("The font family"+S+" is already registered");return;}if(o.fontURI.substr(o.fontURI.length-1)!=="/"){o.fontURI+="/";}if(!f[o.collectionName]||f[o.collectionName].metadataLoaded===false){f[o.collectionName]={config:o,inserted:false};}else{L.warning("The font '"+o.collectionName+"' is already registered");}if(!o.lazy){b._loadFontMetadata(o.collectionName,true);}};
b._loadFontMetadata=function(d,e){var o;if(f[d]){if(typeof f[d].metadataLoaded==="boolean"){return;}if(e&&f[d].metadataLoaded instanceof Promise){return f[d].metadataLoaded;}o=f[d].config;}else{if(!r[d]){L.error("The font configuration for collection '"+d+"' is not registered");}f[d]={metadataLoaded:false};}function l(F){for(var k in F){F[k]=parseInt(F[k],16);}r[d]=F;b.insertFontFaceStyle(o.fontFamily,o.fontURI,d);f[d].metadataLoaded=true;}if(o){if(o.metadataURI===undefined){o.metadataURI=o.fontURI+o.fontFamily+".json";}if(e&&!o.metadata){if(f[d].metadataLoaded instanceof Promise){return f[d].metadataLoaded;}var p=new Promise(function(h){if(r[d]===undefined){f[d].metadataLoadedResolve=h;f[d].metadataXhr=q.ajax(o.metadataURI,{dataType:"json",success:function(j){l(j);delete f[d].metadataXhr;delete f[d].metadataLoadedResolve;h();},error:function(j,s){if(s!=="abort"){L.error("An error occurred loading the font metadata for collection '"+d+"'");f[d].metadataLoaded=false;h();}}});}});f[d].metadataLoaded=p;return p;}else{if(o.metadataURI){if(f[d].metadataXhr){f[d].metadataXhr.abort("Replaced by sync request");f[d].metadataXhr=null;}L.warning("Synchronous loading of font meta data in IconPool, due to .getIconInfo() call"+" for '"+d+"'. Use loading mode 'async' to avoid this call.","SyncXHR",null,function(){return{type:"SyncXHR",name:"IconPool"};});q.ajax(o.metadataURI,{dataType:"json",async:false,success:function(j){l(j);if(f[d].metadataLoadedResolve){f[d].metadataLoadedResolve();delete f[d].metadataLoadedResolve;}},error:function(){if(f[d].metadataLoadedResolve){f[d].metadataLoadedResolve();delete f[d].metadataLoadedResolve;}L.error("An error occurred loading the font metadata for collection '"+d+"'");f[d].metadataLoaded=false;}});}else{l(o.metadata);}}}};
var i={"application/msword":"sap-icon://doc-attachment","application/vnd.openxmlformats-officedocument.wordprocessingml.document":"sap-icon://doc-attachment","application/rtf":"sap-icon://doc-attachment","application/pdf":"sap-icon://pdf-attachment","application/vnd.openxmlformats-officedocument.spreadsheetml.sheet":"sap-icon://excel-attachment","application/vnd.ms-excel":"sap-icon://excel-attachment","application/msexcel":"sap-icon://excel-attachment","application/vnd.ms-powerpoint":"sap-icon://ppt-attachment","application/vnd.openxmlformats-officedocument.presentationml.presentation":"sap-icon://ppt-attachment","application/vnd.openxmlformats-officedocument.presentationml.slideshow":"sap-icon://ppt-attachment","application/mspowerpoint":"sap-icon://ppt-attachment","application/xml":"sap-icon://attachment-html","application/xhtml+xml":"sap-icon://attachment-html","application/x-httpd-php":"sap-icon://attachment-html","application/x-javascript":"sap-icon://attachment-html","application/gzip":"sap-icon://attachment-zip-file","application/x-rar-compressed":"sap-icon://attachment-zip-file","application/x-tar":"sap-icon://attachment-zip-file","application/zip":"sap-icon://attachment-zip-file","audio/voxware":"sap-icon://attachment-audio","audio/x-aiff":"sap-icon://attachment-audio","audio/x-midi":"sap-icon://attachment-audio","audio/x-mpeg":"sap-icon://attachment-audio","audio/x-pn-realaudio":"sap-icon://attachment-audio","audio/x-pn-realaudio-plugin":"sap-icon://attachment-audio","audio/x-qt-stream":"sap-icon://attachment-audio","audio/x-wav":"sap-icon://attachment-audio","image/png":"sap-icon://attachment-photo","image/tiff":"sap-icon://attachment-photo","image/bmp":"sap-icon://attachment-photo","image/jpeg":"sap-icon://attachment-photo","image/gif":"sap-icon://attachment-photo","text/plain":"sap-icon://attachment-text-file","text/comma-separated-values":"sap-icon://attachment-text-file","text/css":"sap-icon://attachment-text-file","text/html":"sap-icon://attachment-text-file","text/javascript":"sap-icon://attachment-text-file","text/richtext":"sap-icon://attachment-text-file","text/rtf":"sap-icon://attachment-text-file","text/tab-separated-values":"sap-icon://attachment-text-file","text/xml":"sap-icon://attachment-text-file","video/mpeg":"sap-icon://attachment-video","video/quicktime":"sap-icon://attachment-video","video/x-msvideo":"sap-icon://attachment-video","application/x-shockwave-flash":"sap-icon://attachment-video"};
b.getIconForMimeType=function(M){return i[M]||"sap-icon://document";};
function m(d){return String.fromCharCode(typeof d==='number'?d:parseInt(d,16));}
return b;},true);
sap.ui.predefine('sap/ui/core/IconRenderer',['./IconPool','./library',"sap/base/security/encodeCSS"],function(I,l,e){"use strict";var a=l.IconColor;var b={apiVersion:2};
b.render=function(r,c){var i=I.getIconInfo(c.getSrc(),undefined,"mixed"),w=c.getWidth(),h=c.getHeight(),C=c.getColor(),B=c.getBackgroundColor(),s=c.getSize(),t=c._getOutputTitle(i),L,o,A,d=false;if(i instanceof Promise){i.then(c.invalidate.bind(c));}else if(i){d=true;L=c.getAriaLabelledBy();A=c._getAccessibilityAttributes(i);o=c.getAggregation("_invisibleText");}r.openStart("span",c);r.class("sapUiIcon");if(d){r.accessibilityState(c,A);r.attr("data-sap-ui-icon-content",i.content);r.style("font-family","'"+e(i.fontFamily)+"'");if(!i.suppressMirroring){r.class("sapUiIconMirrorInRTL");}}if(t){r.attr("title",t);}if(c.hasListeners("press")){r.class("sapUiIconPointer");if(!c.getNoTabStop()){r.attr("tabindex","0");}}r.style("width",w);r.style("height",h);r.style("line-height",h);r.style("font-size",s);if(C&&!(C in a)){r.style("color",C);}if(B&&!(B in a)){r.style("background-color",B);}r.openEnd();if(L&&L.length&&o){r.renderControl(o);}r.close("span");};
return b;},true);
sap.ui.predefine('sap/ui/core/IndicationColorSupport',['./Element','./library',"sap/base/assert"],function(E,l,a){"use strict";var I=l.IndicationColor;var b={};var t=null;var e=function(){if(!t){t={};var r=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core");t[I.Indication01]=r.getText("INDICATION_STATE_INDICATION01");t[I.Indication02]=r.getText("INDICATION_STATE_INDICATION02");t[I.Indication03]=r.getText("INDICATION_STATE_INDICATION03");t[I.Indication04]=r.getText("INDICATION_STATE_INDICATION04");t[I.Indication05]=r.getText("INDICATION_STATE_INDICATION05");t[I.Indication06]=r.getText("INDICATION_STATE_INDICATION06");t[I.Indication07]=r.getText("INDICATION_STATE_INDICATION07");t[I.Indication08]=r.getText("INDICATION_STATE_INDICATION08");}};
b.getAdditionalText=function(v){var i=null;if(v&&v.getValueState){i=v.getIndicationColor();}else if(I[v]){i=v;}if(i){e();return t[i];}return null;};
return b;},true);
sap.ui.predefine('sap/ui/core/InvisibleMessage',["./library","sap/ui/base/ManagedObject","sap/base/Log"],function(c,M,L){"use strict";var i;var I=c.InvisibleMessageMode;
var a=M.extend("sap.ui.core.InvisibleMessage",{constructor:function(){if(i){L.warning('This is a singleton, therefore you are not able to create another instance of this class.');return i;}i=this;M.apply(this,arguments);}});
a.getInstance=function(){if(!i){i=new a("__invisiblemessage",{});}return i;};
a.prototype.init=function(){var C=sap.ui.getCore(),s=C.getStaticAreaRef();s.insertAdjacentHTML("beforeend",this.getPoliteInstance());s.insertAdjacentHTML("beforeend",this.getAssertiveInstance());};
a.prototype.announce=function(t,m){var C=sap.ui.getCore(),s=C.getStaticAreaRef(),p=s.querySelector(".sapUiInvisibleMessagePolite"),A=s.querySelector(".sapUiInvisibleMessageAssertive");if(!p||!A){return;}var n=m===I.Assertive?A:p;n.textContent="";n.textContent=t;if(m!==I.Assertive&&m!==I.Polite){L.info('You have entered an invalid mode. Valid values are: '+'"Polite" '+'and "Assertive".'+' The framework will automatically set the mode to "Polite".');}};
a.prototype.getPoliteInstance=function(){var s=this.getId();return'<span id="'+s+'-polite'+'" data-sap-ui="'+s+'-polite'+'" class="sapUiInvisibleMessagePolite" role="status" aria-live="polite">'+'</span>';};
a.prototype.getAssertiveInstance=function(){var s=this.getId();return'<span id="'+s+'-assertive'+'" data-sap-ui="'+s+'-assertive'+'" class="sapUiInvisibleMessageAssertive" role="status" aria-live="assertive">'+'</span>';};
return a;});
sap.ui.predefine('sap/ui/core/InvisibleText',['./Control','./library',"sap/base/Log","sap/base/security/encodeXML"],function(C,l,L,a){"use strict";
var I=C.extend("sap.ui.core.InvisibleText",{
metadata:{library:"sap.ui.core",publicMethods:["toStatic"],properties:{text:{type:"string",defaultValue:""}}},
renderer:{apiVersion:2,render:function(r,c){r.openStart("span",c);r.class("sapUiInvisibleText");r.attr("aria-hidden","true");r.openEnd();r.text(c.getText()||"");r.close("span");}}
});
function m(w){return function(){L.warning(w+" is not supported by control sap.ui.core.InvisibleText.");return this;};}
I.prototype.setBusy=m("Property busy");I.prototype.setBusyIndicatorDelay=m("Property busy");I.prototype.setBusyIndicatorSize=m("Property busy");I.prototype.setVisible=m("Property visible");I.prototype.setTooltip=m("Aggregation tooltip");
I.prototype.setText=function(T){this.setProperty("text",T,true);this.$().html(a(this.getText()||""));return this;};
I.prototype.getRendererMarkup=function(){var i=this.getId();return'<span id="'+i+'" data-sap-ui="'+i+'" class="sapUiInvisibleText" aria-hidden="true">'+a(this.getText())+'</span>';};
I.prototype.toStatic=function(){var c=sap.ui.getCore();try{var s=c.getStaticAreaRef();s.insertAdjacentHTML("beforeend",this.getRendererMarkup());this.bOutput=true;}catch(e){this.placeAt("sap-ui-static");}return this;};
var t=Object.create(null);
I.getStaticId=function(s,T){var b="",k,B,o;if(sap.ui.getCore().getConfiguration().getAccessibility()&&T){k=s+"|"+T;b=t[k];if(b==null){B=sap.ui.getCore().getLibraryResourceBundle(s);o=new I().setText(B.getText(T));o.toStatic();b=t[k]=o.getId();}}return b;};
sap.ui.getCore().attachLocalizationChanged(function(e){var c=sap.ui.getCore(),k,p,b,T;for(k in t){p=k.indexOf('|');b=c.getLibraryResourceBundle(k.slice(0,p));T=c.byId(t[k]);T&&T.setText(b.getText(k.slice(p+1)));}});return I;});
sap.ui.predefine('sap/ui/core/Item',['./Element','./library'],function(E,l){"use strict";var T=l.TextDirection;
var I=E.extend("sap.ui.core.Item",{metadata:{library:"sap.ui.core",properties:{text:{type:"string",group:"Misc",defaultValue:""},enabled:{type:"boolean",group:"Misc",defaultValue:true},textDirection:{type:"sap.ui.core.TextDirection",group:"Misc",defaultValue:T.Inherit},key:{type:"string",group:"Data",defaultValue:null}}}});
return I;});
sap.ui.predefine('sap/ui/core/LayoutData',['./Element','./library',"sap/ui/thirdparty/jquery"],function(E,l,q){"use strict";
var L=E.extend("sap.ui.core.LayoutData",{metadata:{"abstract":true,library:"sap.ui.core"}});
L.prototype.invalidate=function(){var p=this.getParent();if(p&&p.getMetadata().getName()=="sap.ui.core.VariantLayoutData"){p=p.getParent();}if(p){var o=p.getParent();if(o){var e=q.Event("LayoutDataChange");e.srcControl=p;o._handleEvent(e);}}};
L.prototype.setLayoutData=function(o){return this;};
return L;});
sap.ui.predefine('sap/ui/core/ListItem',['./Item','./library'],function(I,l){"use strict";
var L=I.extend("sap.ui.core.ListItem",{metadata:{library:"sap.ui.core",properties:{icon:{type:"string",group:"Appearance",defaultValue:null},additionalText:{type:"string",group:"Data",defaultValue:null}}}});
return L;});
sap.ui.predefine('sap/ui/core/LocalBusyIndicator',['./Control','./library','./theming/Parameters',"./LocalBusyIndicatorRenderer","sap/ui/thirdparty/jquery"],function(C,l,P,L,q){"use strict";
var a=C.extend("sap.ui.core.LocalBusyIndicator",{metadata:{deprecated:true,library:"sap.ui.core",properties:{width:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:'100px'},height:{type:"sap.ui.core.CSSSize",group:"Misc",defaultValue:'100px'}}}});
(function(){
a.prototype.init=function(){var r="sap.ui.core.LocalBusyIndicator:";var p="sapUiLocalBusyIndicatorBoxSize";p=P.get(r+p);this._iBoxSize=8;p="sapUiLocalBusyIndicatorBoxColor";this._sBoxColor=P.get(r+p);p="sapUiLocalBusyIndicatorBoxColorActive";this._sBoxColorActive=P.get(r+p);this._animateProxy=q.proxy(A,this);};
a.prototype.exit=function(){clearTimeout(this._delayedCallId);delete this._delayedCallId;};
a.prototype.onThemeChanged=function(e){if(this.getDomRef()){this.invalidate();}};
a.prototype.onAfterRendering=function(){var w=parseInt(this.getWidth());var h=parseInt(this.getHeight());var $=this.$();$.css("width",w+"px");$.css("height",h+"px");var b=this.$("animation");var c=Math.floor(w/2);c-=Math.floor((5*this._iBoxSize)/2);var t=Math.floor(h/2)-Math.floor(this._iBoxSize/2);b.css("left",c+"px");b.css("top",t+"px");if(!this._$left){this._$left=this.$("leftBox");}if(!this._$middle){this._$middle=this.$("middleBox");}if(!this._$right){this._$right=this.$("rightBox");}this._delayedCallId=setTimeout(this._animateProxy.bind(this),0);};
var A=function(){if(this.getDomRef()){var t=this;var $,b,c;var d="",e="";if(t._$left){$=t._$left;}else{return;}if(t._$middle){b=t._$middle;}else{return;}if(t._$right){c=t._$right;}else{return;}if(t._sBoxColor){d=t._sBoxColor;}else{return;}if(t._sBoxColorActive){e=t._sBoxColorActive;}else{return;}$.css("background-color",e);setTimeout(function(){$.css("background-color",d);b.css("background-color",e);setTimeout(function(){b.css("background-color",d);c.css("background-color",e);setTimeout(function(){c.css("background-color",d);},150);},150);},150);this._delayedCallId=setTimeout(this._animateProxy.bind(this),1200);}};}());return a;});
sap.ui.predefine('sap/ui/core/LocalBusyIndicatorRenderer',function(){"use strict";var L={apiVersion:2};
L.render=function(R,c){R.openStart("div",c);R.class("sapUiLocalBusyIndicator");R.openEnd();r(R,c);R.close("div");};
var r=function(R,c){var I=c.getId();var s=I+"-animation";var b=["-leftBox","-middleBox","-rightBox"];R.openStart('div',s);R.class("sapUiLocalBusyIndicatorAnimation");R.openEnd();for(var i=0;i<b.length;i++){R.openStart('div',I+b[i]);R.class("sapUiLocalBusyIndicatorBox");R.openEnd();R.close("div");}R.close("div");};return L;},true);
sap.ui.predefine('sap/ui/core/LocalBusyIndicatorSupport',['./Control',"sap/base/Log"],function(C,L){"use strict";var a=function(){if(this===C.prototype){this.setDelay=this.setBusyIndicatorDelay;}else{L.error("Only controls can use the LocalBusyIndicator",this);}};return a;},true);
sap.ui.predefine('sap/ui/core/LocaleData',['sap/base/util/extend','sap/ui/base/Object','./CalendarType','./Locale','sap/base/assert','sap/base/util/LoaderExtensions'],function(e,B,C,L,a,b){"use strict";
var c=B.extend("sap.ui.core.LocaleData",{
constructor:function(o){this.oLocale=o;B.apply(this);this.mData=k(o);},
_get:function(){return this._getDeep(this.mData,arguments);},
_getMerged:function(){return this._get.apply(this,arguments);},
_getDeep:function(o,p){var r=o;for(var i=0;i<p.length;i++){r=r[p[i]];if(r===undefined){break;}}return r;},
getOrientation:function(){return this._get("orientation");},
getLanguages:function(){return this._get("languages");},
getScripts:function(){return this._get("scripts");},
getTerritories:function(){return this._get("territories");},
getMonths:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide","sWidth must be narrow, abbreviated or wide");return this._get(h(s),"months","format",w);},
getMonthsStandAlone:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide","sWidth must be narrow, abbreviated or wide");return this._get(h(s),"months","stand-alone",w);},
getDays:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide"||w=="short","sWidth must be narrow, abbreviate, wide or short");return this._get(h(s),"days","format",w);},
getDaysStandAlone:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide"||w=="short","sWidth must be narrow, abbreviated, wide or short");return this._get(h(s),"days","stand-alone",w);},
getQuarters:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide","sWidth must be narrow, abbreviated or wide");return this._get(h(s),"quarters","format",w);},
getQuartersStandAlone:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide","sWidth must be narrow, abbreviated or wide");return this._get(h(s),"quarters","stand-alone",w);},
getDayPeriods:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide","sWidth must be narrow, abbreviated or wide");return this._get(h(s),"dayPeriods","format",w);},
getDayPeriodsStandAlone:function(w,s){a(w=="narrow"||w=="abbreviated"||w=="wide","sWidth must be narrow, abbreviated or wide");return this._get(h(s),"dayPeriods","stand-alone",w);},
getDatePattern:function(s,i){a(s=="short"||s=="medium"||s=="long"||s=="full","sStyle must be short, medium, long or full");return this._get(h(i),"dateFormats",s);},
getTimePattern:function(s,i){a(s=="short"||s=="medium"||s=="long"||s=="full","sStyle must be short, medium, long or full");return this._get(h(i),"timeFormats",s);},
getDateTimePattern:function(s,i){a(s=="short"||s=="medium"||s=="long"||s=="full","sStyle must be short, medium, long or full");return this._get(h(i),"dateTimeFormats",s);},
getCombinedDateTimePattern:function(D,t,s){a(D=="short"||D=="medium"||D=="long"||D=="full","sStyle must be short, medium, long or full");a(t=="short"||t=="medium"||t=="long"||t=="full","sStyle must be short, medium, long or full");var i=this.getDateTimePattern(D,s),j=this.getDatePattern(D,s),T=this.getTimePattern(t,s);return i.replace("{0}",T).replace("{1}",j);},
getCustomDateTimePattern:function(s,i){var A=this._get(h(i),"dateTimeFormats","availableFormats");return this._getFormatPattern(s,A,i);},
getIntervalPattern:function(i,s){var I=this._get(h(s),"dateTimeFormats","intervalFormats"),j,o,D,p,P;if(i){j=i.split("-");o=j[0];D=j[1];p=I[o];if(p){P=p[D];if(P){return P;}}}return I.intervalFormatFallback;},
getCombinedIntervalPattern:function(p,s){var i=this._get(h(s),"dateTimeFormats","intervalFormats"),F=i.intervalFormatFallback;return F.replace(/\{(0|1)\}/g,p);},
getCustomIntervalPattern:function(s,G,i){var A=this._get(h(i),"dateTimeFormats","intervalFormats");return this._getFormatPattern(s,A,i,G);},
_getFormatPattern:function(s,A,i,D){var p,P,I;if(!D){p=A[s];}else if(typeof D==="string"){if(D=="j"||D=="J"){D=this.getPreferredHourSymbol();}I=A[s];p=I&&I[D];}if(p){if(typeof p==="object"){P=Object.keys(p).map(function(K){return p[K];});}else{return p;}}if(!P){P=this._createFormatPattern(s,A,i,D);}if(P&&P.length===1){return P[0];}return P;},
_createFormatPattern:function(s,A,j,D){var t=this._parseSkeletonFormat(s),p,o=this._findBestMatch(t,s,A),T,q,S,G,P,r,u,v,w=/^([GyYqQMLwWEecdD]+)([hHkKjJmszZvVOXx]+)$/,x,i;if(D){if(typeof D==="string"){v=d[D]?d[D].group:"";if(v){x=m[v].index>t[t.length-1].index;}u=D;}else{x=true;if(t[0].symbol==="y"&&o&&o.pattern.G){S=d["G"];G=m[S.group];t.splice(0,0,{symbol:"G",group:S.group,match:S.match,index:G.index,field:G.field,length:1});}for(i=t.length-1;i>=0;i--){T=t[i];if(D[T.group]){x=false;break;}}for(i=0;i<t.length;i++){T=t[i];if(D[T.group]){u=T.symbol;break;}}if((u=="h"||u=="K")&&D.DayPeriod){u="a";}}if(x){return[this.getCustomDateTimePattern(s,j)];}if(o&&o.missingTokens.length===0){P=o.pattern[u];if(P&&o.distance>0){P=this._expandFields(P,o.patternTokens,t);}}if(!P){q=this._get(h(j),"dateTimeFormats","availableFormats");if(w.test(s)&&"ahHkKjJms".indexOf(u)>=0){P=this._getMixedFormatPattern(s,q,j,D);}else{r=this._getFormatPattern(s,q,j);P=this.getCombinedIntervalPattern(r,j);}}p=[P];}else if(!o){P=s;p=[P];}else{if(typeof o.pattern==="string"){p=[o.pattern];}else if(typeof o.pattern==="object"){p=[];for(var K in o.pattern){P=o.pattern[K];p.push(P);}}if(o.distance>0){if(o.missingTokens.length>0){if(w.test(s)){p=[this._getMixedFormatPattern(s,A,j)];}else{p=this._expandFields(p,o.patternTokens,t);p=this._appendItems(p,o.missingTokens,j);}}else{p=this._expandFields(p,o.patternTokens,t);}}}if(s.indexOf("J")>=0){p.forEach(function(P,I){p[I]=P.replace(/ ?[abB](?=([^']*'[^']*')*[^']*)$/g,"");});}return p;},
_parseSkeletonFormat:function(s){var t=[],T={index:-1},S,o,G;for(var i=0;i<s.length;i++){S=s.charAt(i);if(S=="j"||S=="J"){S=this.getPreferredHourSymbol();}if(S==T.symbol){T.length++;continue;}o=d[S];G=m[o.group];if(o.group=="Other"||G.diffOnly){throw new Error("Symbol '"+S+"' is not allowed in skeleton format '"+s+"'");}if(G.index<=T.index){throw new Error("Symbol '"+S+"' at wrong position or duplicate in skeleton format '"+s+"'");}T={symbol:S,group:o.group,match:o.match,index:G.index,field:G.field,length:1};t.push(T);}return t;},
_findBestMatch:function(t,s,A){var T,j,o,p,q,D,r,F,u,v,w={distance:10000,firstDiffPos:-1};for(var x in A){if(x==="intervalFormatFallback"||x.indexOf("B")>-1){continue;}T=this._parseSkeletonFormat(x);D=0;j=[];r=true;if(t.length<T.length){continue;}q=0;F=t.length;for(var i=0;i<t.length;i++){o=t[i];p=T[q];if(F===t.length){F=i;}if(p){u=d[o.symbol];v=d[p.symbol];if(o.symbol===p.symbol){if(o.length===p.length){if(F===i){F=t.length;}}else{if(o.length<u.numericCeiling?p.length<v.numericCeiling:p.length>=v.numericCeiling){D+=Math.abs(o.length-p.length);}else{D+=5;}}q++;continue;}else{if(o.match==p.match){D+=Math.abs(o.length-p.length)+10;q++;continue;}}}j.push(o);D+=50-i;}if(q<T.length){r=false;}if(r&&(D<w.distance||(D===w.distance&&F>w.firstDiffPos))){w.distance=D;w.firstDiffPos=F;w.missingTokens=j;w.pattern=A[x];w.patternTokens=T;}}if(w.pattern){return w;}},
_expandFields:function(p,P,t){var s=(typeof p==="string");var o;if(s){o=[p];}else{o=p;}var r=o.map(function(q){var G={},u={},R="",Q=false,i=0,S,v,w,N,x,y,z,A;t.forEach(function(T){G[T.group]=T;});P.forEach(function(T){u[T.group]=T;});while(i<q.length){A=q.charAt(i);if(Q){R+=A;if(A=="'"){Q=false;}}else{z=d[A];if(z&&G[z.group]&&u[z.group]){x=G[z.group];y=u[z.group];S=x.length;w=y.length;v=1;while(q.charAt(i+1)==A){i++;v++;}if(S===w||((S<z.numericCeiling)?(v>=z.numericCeiling):(v<z.numericCeiling))){N=v;}else{N=Math.max(v,S);}for(var j=0;j<N;j++){R+=A;}}else{R+=A;if(A=="'"){Q=true;}}}i++;}return R;});return s?r[0]:r;},
_appendItems:function(p,j,s){var A=this._get(h(s),"dateTimeFormats","appendItems");p.forEach(function(P,I){var D,o,q;j.forEach(function(t){o=A[t.group];D="'"+this.getDisplayName(t.field)+"'";q="";for(var i=0;i<t.length;i++){q+=t.symbol;}p[I]=o.replace(/\{0\}/,P).replace(/\{1\}/,q).replace(/\{2\}/,D);}.bind(this));}.bind(this));return p;},
_getMixedFormatPattern:function(s,A,i,D){var r=/^([GyYqQMLwWEecdD]+)([hHkKjJmszZvVOXx]+)$/,j=/MMMM|LLLL/,o=/MMM|LLL/,p=/E|e|c/,R,q,t,S,u,T,v,w;R=r.exec(s);q=R[1];t=R[2];u=this._getFormatPattern(q,A,i);if(D){T=this.getCustomIntervalPattern(t,D,i);}else{T=this._getFormatPattern(t,A,i);}if(j.test(q)){S=p.test(q)?"full":"long";}else if(o.test(q)){S="medium";}else{S="short";}v=this.getDateTimePattern(S,i);w=v.replace(/\{1\}/,u).replace(/\{0\}/,T);return w;},
getNumberSymbol:function(t){a(t=="decimal"||t=="group"||t=="plusSign"||t=="minusSign"||t=="percentSign","sType must be decimal, group, plusSign, minusSign or percentSign");return this._get("symbols-latn-"+t);},
getLenientNumberSymbols:function(t){a(t=="plusSign"||t=="minusSign","sType must be plusSign or minusSign");return this._get("lenient-scope-number")[t];},
getDecimalPattern:function(){return this._get("decimalFormat").standard;},
getCurrencyPattern:function(s){return this._get("currencyFormat")[s]||this._get("currencyFormat").standard;},
getCurrencySpacing:function(p){return this._get("currencyFormat","currencySpacing",p==="after"?"afterCurrency":"beforeCurrency");},
getPercentPattern:function(){return this._get("percentFormat").standard;},
getMiscPattern:function(N){a(N=="approximately"||N=="atLeast"||N=="atMost"||N=="range","sName must be approximately, atLeast, atMost or range");return this._get("miscPattern")[N];},
getMinimalDaysInFirstWeek:function(){return this._get("weekData-minDays");},
getFirstDayOfWeek:function(){return this._get("weekData-firstDay");},
getWeekendStart:function(){return this._get("weekData-weekendStart");},
getWeekendEnd:function(){return this._get("weekData-weekendEnd");},
getCustomCurrencyCodes:function(){var i=this._get("currency")||{},j={};Object.keys(i).forEach(function(s){j[s]=s;});return j;},
getCurrencyDigits:function(s){var i=this._get("currency");if(i){if(i[s]&&i[s].hasOwnProperty("digits")){return i[s].digits;}else if(i["DEFAULT"]&&i["DEFAULT"].hasOwnProperty("digits")){return i["DEFAULT"].digits;}}var D=this._get("currencyDigits",s);if(D==null){D=this._get("currencyDigits","DEFAULT");if(D==null){D=2;}}return D;},
getCurrencySymbol:function(s){var o=this.getCurrencySymbols();return(o&&o[s])||s;},
getCurrencyCodeBySymbol:function(s){var o=this._get("currencySymbols"),i;for(i in o){if(o[i]===s){return i;}}return s;},
getCurrencySymbols:function(){var i=this._get("currency"),j={},I;for(var s in i){I=i[s].isoCode;if(i[s].symbol){j[s]=i[s].symbol;}else if(I){j[s]=this._get("currencySymbols")[I];}}return Object.assign({},this._get("currencySymbols"),j);},
getUnitDisplayName:function(u){var U=this.getUnitFormat(u);return(U&&U["displayName"])||"";},
getRelativePatterns:function(s,S){if(S===undefined){S="wide";}a(S==="wide"||S==="short"||S==="narrow","sStyle is only allowed to be set with 'wide', 'short' or 'narrow'");var p=[],P=this.getPluralCategories(),o,t,v,i;if(!s){s=["year","month","week","day","hour","minute","second"];}s.forEach(function(j){o=this._get("dateFields",j+"-"+S);for(var E in o){if(E.indexOf("relative-type-")===0){v=parseInt(E.substr(14));p.push({scale:j,value:v,pattern:o[E]});}else if(E.indexOf("relativeTime-type-")==0){t=o[E];i=E.substr(18)==="past"?-1:1;P.forEach(function(K){p.push({scale:j,sign:i,pattern:t["relativeTimePattern-count-"+K]});});}}}.bind(this));return p;},
getRelativePattern:function(s,D,F,S){var p,t,K,P;if(typeof F==="string"){S=F;F=undefined;}if(F===undefined){F=D>0;}if(S===undefined){S="wide";}a(S==="wide"||S==="short"||S==="narrow","sStyle is only allowed to be set with 'wide', 'short' or 'narrow'");K=s+"-"+S;if(D===0||D===-2||D===2){p=this._get("dateFields",K,"relative-type-"+D);}if(!p){t=this._get("dateFields",K,"relativeTime-type-"+(F?"future":"past"));P=this.getPluralCategory(Math.abs(D).toString());p=t["relativeTimePattern-count-"+P];}return p;},
getRelativeSecond:function(D,s){return this.getRelativePattern("second",D,s);},
getRelativeMinute:function(D,s){if(D==0){return null;}return this.getRelativePattern("minute",D,s);},
getRelativeHour:function(D,s){if(D==0){return null;}return this.getRelativePattern("hour",D,s);},
getRelativeDay:function(D,s){return this.getRelativePattern("day",D,s);},
getRelativeWeek:function(D,s){return this.getRelativePattern("week",D,s);},
getRelativeMonth:function(D,s){return this.getRelativePattern("month",D,s);},
getDisplayName:function(t,s){a(t=="second"||t=="minute"||t=="hour"||t=="zone"||t=="day"||t=="weekday"||t=="week"||t=="month"||t=="quarter"||t=="year"||t=="era","sType must be second, minute, hour, zone, day, weekday, week, month, quarter, year, era");if(s===undefined){s="wide";}a(s==="wide"||s==="short"||s==="narrow","sStyle is only allowed to be set with 'wide', 'short' or 'narrow'");var S=["era","weekday","zone"],K=S.indexOf(t)===-1?t+"-"+s:t;return this._get("dateFields",K,"displayName");},
getRelativeYear:function(D,s){return this.getRelativePattern("year",D,s);},
getDecimalFormat:function(s,N,p){var F;var o;switch(s){case"long":o=this._get("decimalFormat-long");break;default:o=this._get("decimalFormat-short");break;}if(o){var i=N+"-"+p;F=o[i];if(!F){i=N+"-other";F=o[i];}}return F;},
getCurrencyFormat:function(s,N,p){var F;var o=this._get("currencyFormat-"+s);if(!o){if(s==="sap-short"){throw new Error("Failed to get CLDR data for property \"currencyFormat-sap-short\"");}o=this._get("currencyFormat-short");}if(o){var i=N+"-"+p;F=o[i];if(!F){i=N+"-other";F=o[i];}}return F;},
getListFormat:function(t,s){var F=this._get("listPattern-"+(t||"standard")+"-"+(s||"wide"));if(F){return F;}return{};},
getResolvedUnitFormat:function(u){u=this.getUnitFromMapping(u)||u;return this.getUnitFormat(u);},
getUnitFormat:function(u){return this._get("units","short",u);},
getUnitFormats:function(){return this._getMerged("units","short");},
getUnitFromMapping:function(s){return this._get("unitMappings",s);},
getEras:function(w,s){a(w=="wide"||w=="abbreviated"||w=="narrow","sWidth must be wide, abbreviate or narrow");var E=this._get(h(s),"era-"+w),j=[];for(var i in E){j[parseInt(i)]=E[i];}return j;},
getEraDates:function(s){var E=this._get("eras-"+s.toLowerCase()),j=[];for(var i in E){j[parseInt(i)]=E[i];}return j;},
getCalendarWeek:function(s,w){a(s=="wide"||s=="narrow","sStyle must be wide or narrow");var o=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core",this.oLocale.toString()),K="date.week.calendarweek."+s;return o.getText(K,w);},
getPreferredCalendarType:function(){var s=this._get("calendarPreference"),j=s?s.split(" "):[],o,t,i;for(i=0;i<j.length;i++){o=j[i].split("-")[0];for(t in C){if(o===t.toLowerCase()){return t;}}}return C.Gregorian;},
getPreferredHourSymbol:function(){return this._get("timeData","_preferred");},
getPluralCategories:function(){var p=this._get("plurals"),i=Object.keys(p);i.push("other");return i;},
getPluralCategory:function(N){var p=this._get("plurals");if(typeof N==="number"){N=N.toString();}if(!this._pluralTest){this._pluralTest={};}for(var s in p){var t=this._pluralTest[s];if(!t){t=this._parsePluralRule(p[s]);this._pluralTest[s]=t;}if(t(N)){return s;}}return"other";},
_parsePluralRule:function(r){var O="or",j="and",p="%",q="=",s="!=",t="n",u="i",v="f",w="t",x="v",y="w",R="..",S=",";var i=0,T;T=r.split(" ");function z(o){if(T[i]===o){i++;return true;}return false;}function A(){var o=T[i];i++;return o;}function D(){var K,J;K=E();if(z(O)){J=D();return function(o){return K(o)||J(o);};}return K;}function E(){var K,N;K=F();if(z(j)){N=E();return function(o){return K(o)&&N(o);};}return K;}function F(){var K,N,P;K=G();if(z(q)){P=true;}else if(z(s)){P=false;}else{throw new Error("Expected '=' or '!='");}N=I();if(P){return function(o){return N(o).indexOf(K(o))>=0;};}else{return function(o){return N(o).indexOf(K(o))===-1;};}}function G(){var K;K=H();if(z(p)){var N=parseInt(A());return function(o){return K(o)%N;};}return K;}function H(){if(z(t)){return function(o){return o.n;};}else if(z(u)){return function(o){return o.i;};}else if(z(v)){return function(o){return o.f;};}else if(z(w)){return function(o){return o.t;};}else if(z(x)){return function(o){return o.v;};}else if(z(y)){return function(o){return o.w;};}else{throw new Error("Unknown operand: "+A());}}function I(){var V=[],K=A(),P=K.split(S),N,Q,U;P.forEach(function(o){N=o.split(R);if(N.length===1){V.push(parseInt(o));}else{Q=parseInt(N[0]);U=parseInt(N[1]);for(var i=Q;i<=U;i++){V.push(i);}}});return function(o){return V;};}var J=D();if(i!=T.length){throw new Error("Not completely parsed");}return function(V){var K=V.indexOf("."),N,P,Q,o;if(K===-1){N=V;P="";Q="";}else{N=V.substr(0,K);P=V.substr(K+1);Q=P.replace(/0+$/,'');}o={n:parseFloat(V),i:parseInt(N),v:P.length,w:Q.length,f:parseInt(P),t:parseInt(Q)};return J(o);};}
});
var m={"Era":{field:"era",index:0},"Year":{field:"year",index:1},"Quarter":{field:"quarter",index:2},"Month":{field:"month",index:3},"Week":{field:"week",index:4},"Day-Of-Week":{field:"weekday",index:5},"Day":{field:"day",index:6},"DayPeriod":{field:"hour",index:7,diffOnly:true},"Hour":{field:"hour",index:8},"Minute":{field:"minute",index:9},"Second":{field:"second",index:10},"Timezone":{field:"zone",index:11}};var d={"G":{group:"Era",match:"Era",numericCeiling:1},"y":{group:"Year",match:"Year",numericCeiling:100},"Y":{group:"Year",match:"Year",numericCeiling:100},"Q":{group:"Quarter",match:"Quarter",numericCeiling:3},"q":{group:"Quarter",match:"Quarter",numericCeiling:3},"M":{group:"Month",match:"Month",numericCeiling:3},"L":{group:"Month",match:"Month",numericCeiling:3},"w":{group:"Week",match:"Week",numericCeiling:100},"W":{group:"Week",match:"Week",numericCeiling:100},"d":{group:"Day",match:"Day",numericCeiling:100},"D":{group:"Day",match:"Day",numericCeiling:100},"E":{group:"Day-Of-Week",match:"Day-Of-Week",numericCeiling:1},"e":{group:"Day-Of-Week",match:"Day-Of-Week",numericCeiling:3},"c":{group:"Day-Of-Week",match:"Day-Of-Week",numericCeiling:2},"h":{group:"Hour",match:"Hour12",numericCeiling:100},"H":{group:"Hour",match:"Hour24",numericCeiling:100},"k":{group:"Hour",match:"Hour24",numericCeiling:100},"K":{group:"Hour",match:"Hour12",numericCeiling:100},"m":{group:"Minute",match:"Minute",numericCeiling:100},"s":{group:"Second",match:"Second",numericCeiling:100},"z":{group:"Timezone",match:"Timezone",numericCeiling:1},"Z":{group:"Timezone",match:"Timezone",numericCeiling:1},"O":{group:"Timezone",match:"Timezone",numericCeiling:1},"v":{group:"Timezone",match:"Timezone",numericCeiling:1},"V":{group:"Timezone",match:"Timezone",numericCeiling:1},"X":{group:"Timezone",match:"Timezone",numericCeiling:1},"x":{group:"Timezone",match:"Timezone",numericCeiling:1},"S":{group:"Other",numericCeiling:100},"u":{group:"Other",numericCeiling:100},"U":{group:"Other",numericCeiling:1},"r":{group:"Other",numericCeiling:100},"F":{group:"Other",numericCeiling:100},"g":{group:"Other",numericCeiling:100},"a":{group:"DayPeriod",numericCeiling:1},"b":{group:"Other",numericCeiling:1},"B":{group:"Other",numericCeiling:1},"A":{group:"Other",numericCeiling:100}};var M={"orientation":"left-to-right","languages":{},"scripts":{},"territories":{},"ca-gregorian":{"dateFormats":{"full":"EEEE, MMMM d, y","long":"MMMM d, y","medium":"MMM d, y","short":"M/d/yy"},"timeFormats":{"full":"h:mm:ss a zzzz","long":"h:mm:ss a z","medium":"h:mm:ss a","short":"h:mm a"},"dateTimeFormats":{"full":"{1} 'at' {0}","long":"{1} 'at' {0}","medium":"{1}, {0}","short":"{1}, {0}","availableFormats":{"d":"d","E":"ccc","Ed":"d E","Ehm":"E h:mm a","EHm":"E HH:mm","Ehms":"E h:mm:ss a","EHms":"E HH:mm:ss","Gy":"y G","GyMMM":"MMM y G","GyMMMd":"MMM d, y G","GyMMMEd":"E, MMM d, y G","h":"h a","H":"HH","hm":"h:mm a","Hm":"HH:mm","hms":"h:mm:ss a","Hms":"HH:mm:ss","hmsv":"h:mm:ss a v","Hmsv":"HH:mm:ss v","hmv":"h:mm a v","Hmv":"HH:mm v","M":"L","Md":"M/d","MEd":"E, M/d","MMM":"LLL","MMMd":"MMM d","MMMEd":"E, MMM d","MMMMd":"MMMM d","ms":"mm:ss","y":"y","yM":"M/y","yMd":"M/d/y","yMEd":"E, M/d/y","yMMM":"MMM y","yMMMd":"MMM d, y","yMMMEd":"E, MMM d, y","yMMMM":"MMMM y","yQQQ":"QQQ y","yQQQQ":"QQQQ y"},"appendItems":{"Day":"{0} ({2}: {1})","Day-Of-Week":"{0} {1}","Era":"{0} {1}","Hour":"{0} ({2}: {1})","Minute":"{0} ({2}: {1})","Month":"{0} ({2}: {1})","Quarter":"{0} ({2}: {1})","Second":"{0} ({2}: {1})","Timezone":"{0} {1}","Week":"{0} ({2}: {1})","Year":"{0} {1}"},"intervalFormats":{"intervalFormatFallback":"{0} – {1}","d":{"d":"d – d"},"h":{"a":"h a – h a","h":"h – h a"},"H":{"H":"HH – HH"},"hm":{"a":"h:mm a – h:mm a","h":"h:mm – h:mm a","m":"h:mm – h:mm a"},"Hm":{"H":"HH:mm – HH:mm","m":"HH:mm – HH:mm"},"hmv":{"a":"h:mm a – h:mm a v","h":"h:mm – h:mm a v","m":"h:mm – h:mm a v"},"Hmv":{"H":"HH:mm – HH:mm v","m":"HH:mm – HH:mm v"},"hv":{"a":"h a – h a v","h":"h – h a v"},"Hv":{"H":"HH – HH v"},"M":{"M":"M – M"},"Md":{"d":"M/d – M/d","M":"M/d – M/d"},"MEd":{"d":"E, M/d – E, M/d","M":"E, M/d – E, M/d"},"MMM":{"M":"MMM – MMM"},"MMMd":{"d":"MMM d – d","M":"MMM d – MMM d"},"MMMEd":{"d":"E, MMM d – E, MMM d","M":"E, MMM d – E, MMM d"},"y":{"y":"y – y"},"yM":{"M":"M/y – M/y","y":"M/y – M/y"},"yMd":{"d":"M/d/y – M/d/y","M":"M/d/y – M/d/y","y":"M/d/y – M/d/y"},"yMEd":{"d":"E, M/d/y – E, M/d/y","M":"E, M/d/y – E, M/d/y","y":"E, M/d/y – E, M/d/y"},"yMMM":{"M":"MMM – MMM y","y":"MMM y – MMM y"},"yMMMd":{"d":"MMM d – d, y","M":"MMM d – MMM d, y","y":"MMM d, y – MMM d, y"},"yMMMEd":{"d":"E, MMM d – E, MMM d, y","M":"E, MMM d – E, MMM d, y","y":"E, MMM d, y – E, MMM d, y"},"yMMMM":{"M":"MMMM – MMMM y","y":"MMMM y – MMMM y"}}},"months":{"format":{"abbreviated":["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],"narrow":["J","F","M","A","M","J","J","A","S","O","N","D"],"wide":["January","February","March","April","May","June","July","August","September","October","November","December"]},"stand-alone":{"abbreviated":["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],"narrow":["J","F","M","A","M","J","J","A","S","O","N","D"],"wide":["January","February","March","April","May","June","July","August","September","October","November","December"]}},"days":{"format":{"abbreviated":["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],"narrow":["S","M","T","W","T","F","S"],"short":["Su","Mo","Tu","We","Th","Fr","Sa"],"wide":["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]},"stand-alone":{"abbreviated":["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],"narrow":["S","M","T","W","T","F","S"],"short":["Su","Mo","Tu","We","Th","Fr","Sa"],"wide":["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"]}},"quarters":{"format":{"abbreviated":["Q1","Q2","Q3","Q4"],"narrow":["1","2","3","4"],"wide":["1st quarter","2nd quarter","3rd quarter","4th quarter"]},"stand-alone":{"abbreviated":["Q1","Q2","Q3","Q4"],"narrow":["1","2","3","4"],"wide":["1st quarter","2nd quarter","3rd quarter","4th quarter"]}},"dayPeriods":{"format":{"abbreviated":["AM","PM"],"narrow":["a","p"],"wide":["AM","PM"]},"stand-alone":{"abbreviated":["AM","PM"],"narrow":["AM","PM"],"wide":["AM","PM"]}},"era-wide":{"0":"Before Christ","1":"Anno Domini"},"era-abbreviated":{"0":"BC","1":"AD"},"era-narrow":{"0":"B","1":"A"}},"eras-gregorian":{"0":{"_end":"0-12-31"},"1":{"_start":"1-01-01"}},"dateFields":{"era":{"displayName":"era"},"year-wide":{"displayName":"year","relative-type--1":"last year","relative-type-0":"this year","relative-type-1":"next year","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} year","relativeTimePattern-count-other":"in {0} years"},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} year ago","relativeTimePattern-count-other":"{0} years ago"}},"year-short":{"displayName":"yr.","relative-type--1":"last yr.","relative-type-0":"this yr.","relative-type-1":"next yr.","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} yr.","relativeTimePattern-count-other":"in {0} yr."},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} yr. ago","relativeTimePattern-count-other":"{0} yr. ago"}},"year-narrow":{"displayName":"yr.","relative-type--1":"last yr.","relative-type-0":"this yr.","relative-type-1":"next yr.","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} yr.","relativeTimePattern-count-other":"in {0} yr."},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} yr. ago","relativeTimePattern-count-other":"{0} yr. ago"}},"quarter-wide":{"displayName":"quarter","relative-type--1":"last quarter","relative-type-0":"this quarter","relative-type-1":"next quarter","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} quarter","relativeTimePattern-count-other":"in {0} quarters"},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} quarter ago","relativeTimePattern-count-other":"{0} quarters ago"}},"quarter-short":{"displayName":"qtr.","relative-type--1":"last qtr.","relative-type-0":"this qtr.","relative-type-1":"next qtr.","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} qtr.","relativeTimePattern-count-other":"in {0} qtrs."},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} qtr. ago","relativeTimePattern-count-other":"{0} qtrs. ago"}},"quarter-narrow":{"displayName":"qtr.","relative-type--1":"last qtr.","relative-type-0":"this qtr.","relative-type-1":"next qtr.","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} qtr.","relativeTimePattern-count-other":"in {0} qtrs."},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} qtr. ago","relativeTimePattern-count-other":"{0} qtrs. ago"}},"month-wide":{"displayName":"month","relative-type--1":"last month","relative-type-0":"this month","relative-type-1":"next month","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} month","relativeTimePattern-count-other":"in {0} months"},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} month ago","relativeTimePattern-count-other":"{0} months ago"}},"month-short":{"displayName":"mo.","relative-type--1":"last mo.","relative-type-0":"this mo.","relative-type-1":"next mo.","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} mo.","relativeTimePattern-count-other":"in {0} mo."},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} mo. ago","relativeTimePattern-count-other":"{0} mo. ago"}},"month-narrow":{"displayName":"mo.","relative-type--1":"last mo.","relative-type-0":"this mo.","relative-type-1":"next mo.","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} mo.","relativeTimePattern-count-other":"in {0} mo."},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} mo. ago","relativeTimePattern-count-other":"{0} mo. ago"}},"week-wide":{"displayName":"week","relative-type--1":"last week","relative-type-0":"this week","relative-type-1":"next week","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} week","relativeTimePattern-count-other":"in {0} weeks"},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} week ago","relativeTimePattern-count-other":"{0} weeks ago"},"relativePeriod":"the week of {0}"},"week-short":{"displayName":"wk.","relative-type--1":"last wk.","relative-type-0":"this wk.","relative-type-1":"next wk.","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} wk.","relativeTimePattern-count-other":"in {0} wk."},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} wk. ago","relativeTimePattern-count-other":"{0} wk. ago"},"relativePeriod":"the week of {0}"},"week-narrow":{"displayName":"wk.","relative-type--1":"last wk.","relative-type-0":"this wk.","relative-type-1":"next wk.","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} wk.","relativeTimePattern-count-other":"in {0} wk."},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} wk. ago","relativeTimePattern-count-other":"{0} wk. ago"},"relativePeriod":"the week of {0}"},"day-wide":{"displayName":"day","relative-type--1":"yesterday","relative-type-0":"today","relative-type-1":"tomorrow","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} day","relativeTimePattern-count-other":"in {0} days"},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} day ago","relativeTimePattern-count-other":"{0} days ago"}},"day-short":{"displayName":"day","relative-type--1":"yesterday","relative-type-0":"today","relative-type-1":"tomorrow","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} day","relativeTimePattern-count-other":"in {0} days"},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} day ago","relativeTimePattern-count-other":"{0} days ago"}},"day-narrow":{"displayName":"day","relative-type--1":"yesterday","relative-type-0":"today","relative-type-1":"tomorrow","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} day","relativeTimePattern-count-other":"in {0} days"},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} day ago","relativeTimePattern-count-other":"{0} days ago"}},"weekday":{"displayName":"day of the week"},"hour-wide":{"displayName":"hour","relative-type-0":"this hour","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} hour","relativeTimePattern-count-other":"in {0} hours"},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} hour ago","relativeTimePattern-count-other":"{0} hours ago"}},"hour-short":{"displayName":"hr.","relative-type-0":"this hour","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} hr.","relativeTimePattern-count-other":"in {0} hr."},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} hr. ago","relativeTimePattern-count-other":"{0} hr. ago"}},"hour-narrow":{"displayName":"hr.","relative-type-0":"this hour","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} hr.","relativeTimePattern-count-other":"in {0} hr."},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} hr. ago","relativeTimePattern-count-other":"{0} hr. ago"}},"minute-wide":{"displayName":"minute","relative-type-0":"this minute","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} minute","relativeTimePattern-count-other":"in {0} minutes"},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} minute ago","relativeTimePattern-count-other":"{0} minutes ago"}},"minute-short":{"displayName":"min.","relative-type-0":"this minute","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} min.","relativeTimePattern-count-other":"in {0} min."},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} min. ago","relativeTimePattern-count-other":"{0} min. ago"}},"minute-narrow":{"displayName":"min.","relative-type-0":"this minute","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} min.","relativeTimePattern-count-other":"in {0} min."},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} min. ago","relativeTimePattern-count-other":"{0} min. ago"}},"second-wide":{"displayName":"second","relative-type-0":"now","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} second","relativeTimePattern-count-other":"in {0} seconds"},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} second ago","relativeTimePattern-count-other":"{0} seconds ago"}},"second-short":{"displayName":"sec.","relative-type-0":"now","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} sec.","relativeTimePattern-count-other":"in {0} sec."},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} sec. ago","relativeTimePattern-count-other":"{0} sec. ago"}},"second-narrow":{"displayName":"sec.","relative-type-0":"now","relativeTime-type-future":{"relativeTimePattern-count-one":"in {0} sec.","relativeTimePattern-count-other":"in {0} sec."},"relativeTime-type-past":{"relativeTimePattern-count-one":"{0} sec. ago","relativeTimePattern-count-other":"{0} sec. ago"}},"zone":{"displayName":"time zone"}},"decimalFormat":{"standard":"#,##0.###"},"currencyFormat":{"standard":"¤#,##0.00","currencySpacing":{"beforeCurrency":{"currencyMatch":"[:^S:]","surroundingMatch":"[:digit:]","insertBetween":" "},"afterCurrency":{"currencyMatch":"[:^S:]","surroundingMatch":"[:digit:]","insertBetween":" "}}},"percentFormat":{"standard":"#,##0%"},"miscPattern":{"approximately":"~{0}","atLeast":"{0}+","atMost":"≤{0}","range":"{0}–{1}"},"symbols-latn-decimal":".","symbols-latn-group":",","symbols-latn-plusSign":"+","symbols-latn-minusSign":"-","symbols-latn-percentSign":"%","weekData-minDays":4,"weekData-firstDay":1,"weekData-weekendStart":6,"weekData-weekendEnd":0,"timeData":{_allowed:"H h",_preferred:"H"},"lenient-scope-number":{"minusSign":"-‐‒–⁻₋−➖﹣","commaSign":",،٫、︐︑﹐﹑，","plusSign":"+⁺₊➕﬩﹢"},"plurals":{},"units":{"short":{"per":{"compoundUnitPattern":"{0}/{1}"},"acceleration-g-force":{"displayName":"g-force","unitPattern-count-one":"{0} G","unitPattern-count-other":"{0} G"},"acceleration-meter-per-second-squared":{"displayName":"meters/sec²","unitPattern-count-one":"{0} m/s²","unitPattern-count-other":"{0} m/s²"},"angle-revolution":{"displayName":"rev","unitPattern-count-one":"{0} rev","unitPattern-count-other":"{0} rev"},"angle-radian":{"displayName":"radians","unitPattern-count-one":"{0} rad","unitPattern-count-other":"{0} rad"},"angle-degree":{"displayName":"degrees","unitPattern-count-one":"{0} deg","unitPattern-count-other":"{0} deg"},"angle-arc-minute":{"displayName":"arcmins","unitPattern-count-one":"{0} arcmin","unitPattern-count-other":"{0} arcmins"},"angle-arc-second":{"displayName":"arcsecs","unitPattern-count-one":"{0} arcsec","unitPattern-count-other":"{0} arcsecs"},"area-square-kilometer":{"displayName":"km²","unitPattern-count-one":"{0} km²","unitPattern-count-other":"{0} km²","perUnitPattern":"{0}/km²"},"area-hectare":{"displayName":"hectares","unitPattern-count-one":"{0} ha","unitPattern-count-other":"{0} ha"},"area-square-meter":{"displayName":"meters²","unitPattern-count-one":"{0} m²","unitPattern-count-other":"{0} m²","perUnitPattern":"{0}/m²"},"area-square-centimeter":{"displayName":"cm²","unitPattern-count-one":"{0} cm²","unitPattern-count-other":"{0} cm²","perUnitPattern":"{0}/cm²"},"area-square-mile":{"displayName":"sq miles","unitPattern-count-one":"{0} sq mi","unitPattern-count-other":"{0} sq mi","perUnitPattern":"{0}/mi²"},"area-acre":{"displayName":"acres","unitPattern-count-one":"{0} ac","unitPattern-count-other":"{0} ac"},"area-square-yard":{"displayName":"yards²","unitPattern-count-one":"{0} yd²","unitPattern-count-other":"{0} yd²"},"area-square-foot":{"displayName":"sq feet","unitPattern-count-one":"{0} sq ft","unitPattern-count-other":"{0} sq ft"},"area-square-inch":{"displayName":"inches²","unitPattern-count-one":"{0} in²","unitPattern-count-other":"{0} in²","perUnitPattern":"{0}/in²"},"concentr-karat":{"displayName":"karats","unitPattern-count-one":"{0} kt","unitPattern-count-other":"{0} kt"},"concentr-milligram-per-deciliter":{"displayName":"mg/dL","unitPattern-count-one":"{0} mg/dL","unitPattern-count-other":"{0} mg/dL"},"concentr-millimole-per-liter":{"displayName":"millimol/liter","unitPattern-count-one":"{0} mmol/L","unitPattern-count-other":"{0} mmol/L"},"concentr-part-per-million":{"displayName":"parts/million","unitPattern-count-one":"{0} ppm","unitPattern-count-other":"{0} ppm"},"consumption-liter-per-kilometer":{"displayName":"liters/km","unitPattern-count-one":"{0} L/km","unitPattern-count-other":"{0} L/km"},"consumption-liter-per-100kilometers":{"displayName":"L/100 km","unitPattern-count-one":"{0} L/100 km","unitPattern-count-other":"{0} L/100 km"},"consumption-mile-per-gallon":{"displayName":"miles/gal","unitPattern-count-one":"{0} mpg","unitPattern-count-other":"{0} mpg"},"consumption-mile-per-gallon-imperial":{"displayName":"miles/gal Imp.","unitPattern-count-one":"{0} mpg Imp.","unitPattern-count-other":"{0} mpg Imp."},"digital-terabyte":{"displayName":"TByte","unitPattern-count-one":"{0} TB","unitPattern-count-other":"{0} TB"},"digital-terabit":{"displayName":"Tbit","unitPattern-count-one":"{0} Tb","unitPattern-count-other":"{0} Tb"},"digital-gigabyte":{"displayName":"GByte","unitPattern-count-one":"{0} GB","unitPattern-count-other":"{0} GB"},"digital-gigabit":{"displayName":"Gbit","unitPattern-count-one":"{0} Gb","unitPattern-count-other":"{0} Gb"},"digital-megabyte":{"displayName":"MByte","unitPattern-count-one":"{0} MB","unitPattern-count-other":"{0} MB"},"digital-megabit":{"displayName":"Mbit","unitPattern-count-one":"{0} Mb","unitPattern-count-other":"{0} Mb"},"digital-kilobyte":{"displayName":"kByte","unitPattern-count-one":"{0} kB","unitPattern-count-other":"{0} kB"},"digital-kilobit":{"displayName":"kbit","unitPattern-count-one":"{0} kb","unitPattern-count-other":"{0} kb"},"digital-byte":{"displayName":"byte","unitPattern-count-one":"{0} byte","unitPattern-count-other":"{0} byte"},"digital-bit":{"displayName":"bit","unitPattern-count-one":"{0} bit","unitPattern-count-other":"{0} bit"},"duration-century":{"displayName":"c","unitPattern-count-one":"{0} c","unitPattern-count-other":"{0} c"},"duration-year":{"displayName":"years","unitPattern-count-one":"{0} yr","unitPattern-count-other":"{0} yrs","perUnitPattern":"{0}/y"},"duration-month":{"displayName":"months","unitPattern-count-one":"{0} mth","unitPattern-count-other":"{0} mths","perUnitPattern":"{0}/m"},"duration-week":{"displayName":"weeks","unitPattern-count-one":"{0} wk","unitPattern-count-other":"{0} wks","perUnitPattern":"{0}/w"},"duration-day":{"displayName":"days","unitPattern-count-one":"{0} day","unitPattern-count-other":"{0} days","perUnitPattern":"{0}/d"},"duration-hour":{"displayName":"hours","unitPattern-count-one":"{0} hr","unitPattern-count-other":"{0} hr","perUnitPattern":"{0}/h"},"duration-minute":{"displayName":"mins","unitPattern-count-one":"{0} min","unitPattern-count-other":"{0} min","perUnitPattern":"{0}/min"},"duration-second":{"displayName":"secs","unitPattern-count-one":"{0} sec","unitPattern-count-other":"{0} sec","perUnitPattern":"{0}/s"},"duration-millisecond":{"displayName":"millisecs","unitPattern-count-one":"{0} ms","unitPattern-count-other":"{0} ms"},"duration-microsecond":{"displayName":"μsecs","unitPattern-count-one":"{0} μs","unitPattern-count-other":"{0} μs"},"duration-nanosecond":{"displayName":"nanosecs","unitPattern-count-one":"{0} ns","unitPattern-count-other":"{0} ns"},"electric-ampere":{"displayName":"amps","unitPattern-count-one":"{0} A","unitPattern-count-other":"{0} A"},"electric-milliampere":{"displayName":"milliamps","unitPattern-count-one":"{0} mA","unitPattern-count-other":"{0} mA"},"electric-ohm":{"displayName":"ohms","unitPattern-count-one":"{0} Ω","unitPattern-count-other":"{0} Ω"},"electric-volt":{"displayName":"volts","unitPattern-count-one":"{0} V","unitPattern-count-other":"{0} V"},"energy-kilocalorie":{"displayName":"kcal","unitPattern-count-one":"{0} kcal","unitPattern-count-other":"{0} kcal"},"energy-calorie":{"displayName":"cal","unitPattern-count-one":"{0} cal","unitPattern-count-other":"{0} cal"},"energy-foodcalorie":{"displayName":"Cal","unitPattern-count-one":"{0} Cal","unitPattern-count-other":"{0} Cal"},"energy-kilojoule":{"displayName":"kilojoule","unitPattern-count-one":"{0} kJ","unitPattern-count-other":"{0} kJ"},"energy-joule":{"displayName":"joules","unitPattern-count-one":"{0} J","unitPattern-count-other":"{0} J"},"energy-kilowatt-hour":{"displayName":"kW-hour","unitPattern-count-one":"{0} kWh","unitPattern-count-other":"{0} kWh"},"frequency-gigahertz":{"displayName":"GHz","unitPattern-count-one":"{0} GHz","unitPattern-count-other":"{0} GHz"},"frequency-megahertz":{"displayName":"MHz","unitPattern-count-one":"{0} MHz","unitPattern-count-other":"{0} MHz"},"frequency-kilohertz":{"displayName":"kHz","unitPattern-count-one":"{0} kHz","unitPattern-count-other":"{0} kHz"},"frequency-hertz":{"displayName":"Hz","unitPattern-count-one":"{0} Hz","unitPattern-count-other":"{0} Hz"},"length-kilometer":{"displayName":"km","unitPattern-count-one":"{0} km","unitPattern-count-other":"{0} km","perUnitPattern":"{0}/km"},"length-meter":{"displayName":"m","unitPattern-count-one":"{0} m","unitPattern-count-other":"{0} m","perUnitPattern":"{0}/m"},"length-decimeter":{"displayName":"dm","unitPattern-count-one":"{0} dm","unitPattern-count-other":"{0} dm"},"length-centimeter":{"displayName":"cm","unitPattern-count-one":"{0} cm","unitPattern-count-other":"{0} cm","perUnitPattern":"{0}/cm"},"length-millimeter":{"displayName":"mm","unitPattern-count-one":"{0} mm","unitPattern-count-other":"{0} mm"},"length-micrometer":{"displayName":"µmeters","unitPattern-count-one":"{0} µm","unitPattern-count-other":"{0} µm"},"length-nanometer":{"displayName":"nm","unitPattern-count-one":"{0} nm","unitPattern-count-other":"{0} nm"},"length-picometer":{"displayName":"pm","unitPattern-count-one":"{0} pm","unitPattern-count-other":"{0} pm"},"length-mile":{"displayName":"miles","unitPattern-count-one":"{0} mi","unitPattern-count-other":"{0} mi"},"length-yard":{"displayName":"yards","unitPattern-count-one":"{0} yd","unitPattern-count-other":"{0} yd"},"length-foot":{"displayName":"feet","unitPattern-count-one":"{0} ft","unitPattern-count-other":"{0} ft","perUnitPattern":"{0}/ft"},"length-inch":{"displayName":"inches","unitPattern-count-one":"{0} in","unitPattern-count-other":"{0} in","perUnitPattern":"{0}/in"},"length-parsec":{"displayName":"parsecs","unitPattern-count-one":"{0} pc","unitPattern-count-other":"{0} pc"},"length-light-year":{"displayName":"light yrs","unitPattern-count-one":"{0} ly","unitPattern-count-other":"{0} ly"},"length-astronomical-unit":{"displayName":"au","unitPattern-count-one":"{0} au","unitPattern-count-other":"{0} au"},"length-furlong":{"displayName":"furlongs","unitPattern-count-one":"{0} fur","unitPattern-count-other":"{0} fur"},"length-fathom":{"displayName":"fathoms","unitPattern-count-one":"{0} ftm","unitPattern-count-other":"{0} ftm"},"length-nautical-mile":{"displayName":"nmi","unitPattern-count-one":"{0} nmi","unitPattern-count-other":"{0} nmi"},"length-mile-scandinavian":{"displayName":"smi","unitPattern-count-one":"{0} smi","unitPattern-count-other":"{0} smi"},"length-point":{"displayName":"points","unitPattern-count-one":"{0} pt","unitPattern-count-other":"{0} pt"},"light-lux":{"displayName":"lux","unitPattern-count-one":"{0} lx","unitPattern-count-other":"{0} lx"},"mass-metric-ton":{"displayName":"t","unitPattern-count-one":"{0} t","unitPattern-count-other":"{0} t"},"mass-kilogram":{"displayName":"kg","unitPattern-count-one":"{0} kg","unitPattern-count-other":"{0} kg","perUnitPattern":"{0}/kg"},"mass-gram":{"displayName":"grams","unitPattern-count-one":"{0} g","unitPattern-count-other":"{0} g","perUnitPattern":"{0}/g"},"mass-milligram":{"displayName":"mg","unitPattern-count-one":"{0} mg","unitPattern-count-other":"{0} mg"},"mass-microgram":{"displayName":"µg","unitPattern-count-one":"{0} µg","unitPattern-count-other":"{0} µg"},"mass-ton":{"displayName":"tons","unitPattern-count-one":"{0} tn","unitPattern-count-other":"{0} tn"},"mass-stone":{"displayName":"stones","unitPattern-count-one":"{0} st","unitPattern-count-other":"{0} st"},"mass-pound":{"displayName":"pounds","unitPattern-count-one":"{0} lb","unitPattern-count-other":"{0} lb","perUnitPattern":"{0}/lb"},"mass-ounce":{"displayName":"oz","unitPattern-count-one":"{0} oz","unitPattern-count-other":"{0} oz","perUnitPattern":"{0}/oz"},"mass-ounce-troy":{"displayName":"oz troy","unitPattern-count-one":"{0} oz t","unitPattern-count-other":"{0} oz t"},"mass-carat":{"displayName":"carats","unitPattern-count-one":"{0} CD","unitPattern-count-other":"{0} CD"},"power-gigawatt":{"displayName":"GW","unitPattern-count-one":"{0} GW","unitPattern-count-other":"{0} GW"},"power-megawatt":{"displayName":"MW","unitPattern-count-one":"{0} MW","unitPattern-count-other":"{0} MW"},"power-kilowatt":{"displayName":"kW","unitPattern-count-one":"{0} kW","unitPattern-count-other":"{0} kW"},"power-watt":{"displayName":"watts","unitPattern-count-one":"{0} W","unitPattern-count-other":"{0} W"},"power-milliwatt":{"displayName":"mW","unitPattern-count-one":"{0} mW","unitPattern-count-other":"{0} mW"},"power-horsepower":{"displayName":"hp","unitPattern-count-one":"{0} hp","unitPattern-count-other":"{0} hp"},"pressure-hectopascal":{"displayName":"hPa","unitPattern-count-one":"{0} hPa","unitPattern-count-other":"{0} hPa"},"pressure-millimeter-of-mercury":{"displayName":"mmHg","unitPattern-count-one":"{0} mmHg","unitPattern-count-other":"{0} mmHg"},"pressure-pound-per-square-inch":{"displayName":"psi","unitPattern-count-one":"{0} psi","unitPattern-count-other":"{0} psi"},"pressure-inch-hg":{"displayName":"inHg","unitPattern-count-one":"{0} inHg","unitPattern-count-other":"{0} inHg"},"pressure-millibar":{"displayName":"mbar","unitPattern-count-one":"{0} mbar","unitPattern-count-other":"{0} mbar"},"speed-kilometer-per-hour":{"displayName":"km/hour","unitPattern-count-one":"{0} kph","unitPattern-count-other":"{0} kph"},"speed-meter-per-second":{"displayName":"meters/sec","unitPattern-count-one":"{0} m/s","unitPattern-count-other":"{0} m/s"},"speed-mile-per-hour":{"displayName":"miles/hour","unitPattern-count-one":"{0} mph","unitPattern-count-other":"{0} mph"},"speed-knot":{"displayName":"kn","unitPattern-count-one":"{0} kn","unitPattern-count-other":"{0} kn"},"temperature-generic":{"displayName":"°","unitPattern-count-other":"{0}°"},"temperature-celsius":{"displayName":"deg. C","unitPattern-count-one":"{0}°C","unitPattern-count-other":"{0}°C"},"temperature-fahrenheit":{"displayName":"deg. F","unitPattern-count-one":"{0}°F","unitPattern-count-other":"{0}°F"},"temperature-kelvin":{"displayName":"K","unitPattern-count-one":"{0} K","unitPattern-count-other":"{0} K"},"volume-cubic-kilometer":{"displayName":"km³","unitPattern-count-one":"{0} km³","unitPattern-count-other":"{0} km³"},"volume-cubic-meter":{"displayName":"m³","unitPattern-count-one":"{0} m³","unitPattern-count-other":"{0} m³","perUnitPattern":"{0}/m³"},"volume-cubic-centimeter":{"displayName":"cm³","unitPattern-count-one":"{0} cm³","unitPattern-count-other":"{0} cm³","perUnitPattern":"{0}/cm³"},"volume-cubic-mile":{"displayName":"mi³","unitPattern-count-one":"{0} mi³","unitPattern-count-other":"{0} mi³"},"volume-cubic-yard":{"displayName":"yards³","unitPattern-count-one":"{0} yd³","unitPattern-count-other":"{0} yd³"},"volume-cubic-foot":{"displayName":"feet³","unitPattern-count-one":"{0} ft³","unitPattern-count-other":"{0} ft³"},"volume-cubic-inch":{"displayName":"inches³","unitPattern-count-one":"{0} in³","unitPattern-count-other":"{0} in³"},"volume-megaliter":{"displayName":"ML","unitPattern-count-one":"{0} ML","unitPattern-count-other":"{0} ML"},"volume-hectoliter":{"displayName":"hL","unitPattern-count-one":"{0} hL","unitPattern-count-other":"{0} hL"},"volume-liter":{"displayName":"liters","unitPattern-count-one":"{0} L","unitPattern-count-other":"{0} L","perUnitPattern":"{0}/L"},"volume-deciliter":{"displayName":"dL","unitPattern-count-one":"{0} dL","unitPattern-count-other":"{0} dL"},"volume-centiliter":{"displayName":"cL","unitPattern-count-one":"{0} cL","unitPattern-count-other":"{0} cL"},"volume-milliliter":{"displayName":"mL","unitPattern-count-one":"{0} mL","unitPattern-count-other":"{0} mL"},"volume-pint-metric":{"displayName":"mpt","unitPattern-count-one":"{0} mpt","unitPattern-count-other":"{0} mpt"},"volume-cup-metric":{"displayName":"mcup","unitPattern-count-one":"{0} mc","unitPattern-count-other":"{0} mc"},"volume-acre-foot":{"displayName":"acre ft","unitPattern-count-one":"{0} ac ft","unitPattern-count-other":"{0} ac ft"},"volume-bushel":{"displayName":"bushels","unitPattern-count-one":"{0} bu","unitPattern-count-other":"{0} bu"},"volume-gallon":{"displayName":"gal","unitPattern-count-one":"{0} gal","unitPattern-count-other":"{0} gal","perUnitPattern":"{0}/gal US"},"volume-gallon-imperial":{"displayName":"Imp. gal","unitPattern-count-one":"{0} gal Imp.","unitPattern-count-other":"{0} gal Imp.","perUnitPattern":"{0}/gal Imp."},"volume-quart":{"displayName":"qts","unitPattern-count-one":"{0} qt","unitPattern-count-other":"{0} qt"},"volume-pint":{"displayName":"pints","unitPattern-count-one":"{0} pt","unitPattern-count-other":"{0} pt"},"volume-cup":{"displayName":"cups","unitPattern-count-one":"{0} c","unitPattern-count-other":"{0} c"},"volume-fluid-ounce":{"displayName":"fl oz","unitPattern-count-one":"{0} fl oz","unitPattern-count-other":"{0} fl oz"},"volume-tablespoon":{"displayName":"tbsp","unitPattern-count-one":"{0} tbsp","unitPattern-count-other":"{0} tbsp"},"volume-teaspoon":{"displayName":"tsp","unitPattern-count-one":"{0} tsp","unitPattern-count-other":"{0} tsp"},"coordinateUnit":{"east":"{0} E","north":"{0} N","south":"{0} S","west":"{0} W"}}}};var f={"iw":"he","ji":"yi","in":"id","sh":"sr"};var g=(function(){var j=L._cldrLocales,r={},i;if(j){for(i=0;i<j.length;i++){r[j[i]]=true;}}return r;}());var l={};
function h(s){if(!s){s=sap.ui.getCore().getConfiguration().getCalendarType();}return"ca-"+s.toLowerCase();}
function k(o){var s=o.getLanguage()||"",S=o.getScript()||"",r=o.getRegion()||"",D;function i(p,q){var t,v,u;if(!q){return;}for(t in q){if(q.hasOwnProperty(t)){v=p[t];u=q[t];if(v===undefined){p[t]=u;}else if(v===null){delete p[t];}else if(typeof v==='object'&&typeof u==='object'){i(v,u);}}}}function j(I){if(!l[I]&&(!g||g[I]===true)){var p=l[I]=b.loadResource("sap/ui/core/cldr/"+I+".json",{dataType:"json",failOnError:false});if(p&&p.__fallbackLocale){i(p,j(p.__fallbackLocale));delete p.__fallbackLocale;}}return l[I];}s=(s&&f[s])||s;if(s==="no"){s="nb";}if(s==="zh"&&!r){if(S==="Hans"){r="CN";}else if(S==="Hant"){r="TW";}}var I=s+"_"+r;if(s&&r){D=j(I);}if(!D&&s){D=j(s);}l[I]=D||M;return l[I];}
var n=c.extend("sap.ui.core.CustomLocaleData",{
constructor:function(o){c.apply(this,arguments);this.mCustomData=sap.ui.getCore().getConfiguration().getFormatSettings().getCustomLocaleData();},
_get:function(){var A=Array.prototype.slice.call(arguments),s,K;if(A[0].indexOf("ca-")==0){s=A[0];if(s==h()){A=A.slice(1);}}K=A.join("-");var v=this.mCustomData[K];if(v==null){v=this._getDeep(this.mCustomData,arguments);if(v==null){v=this._getDeep(this.mData,arguments);}}return v;},
_getMerged:function(){var D=this._getDeep(this.mData,arguments);var i=this._getDeep(this.mCustomData,arguments);return e({},D,i);}
});
c.getInstance=function(o){return o.hasPrivateUseSubtag("sapufmt")?new n(o):new c(o);};
return c;});
sap.ui.predefine('sap/ui/core/Message',['./Element','./library',"sap/base/Log"],function(E,l,L){"use strict";var M=l.MessageType;
var a=E.extend("sap.ui.core.Message",{metadata:{library:"sap.ui.core",properties:{text:{type:"string",group:"Misc",defaultValue:null},timestamp:{type:"string",group:"Misc",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},level:{type:"sap.ui.core.MessageType",group:"Misc",defaultValue:M.None},readOnly:{type:"boolean",group:"Misc",defaultValue:false}}}});
a.prototype.getDefaultIcon=function(s){var m=sap.ui.require.toUrl("sap/ui/core/themes/"+sap.ui.getCore().getConfiguration().getTheme());var i=m+"/img/message/";if(s&&s=="32x32"){i+="32x32/";}else{i+="16x16/";}var u="";switch(this.getProperty("level")){case M.Error:u=i+"Message_Icon_Error.png";break;case M.Information:u=i+"Message_Icon_Information.png";break;case M.Warning:u=i+"Message_Icon_Warning.png";break;case M.Success:u=i+"Message_Icon_Success.png";break;case M.None:default:u=this.getProperty("icon");break;}return u;};
a.prototype.compareByType=function(o){return a.compareByType(this,o);};
a.compareByType=function(m,o){if(!m&&!o){return 0;}if(m&&!o){return 1;}if(!m&&o){return-1;}var s=m.getLevel();var b=o.getLevel();if(s===b){return 0;}switch(s){case M.Error:return 1;case M.Warning:return b===M.Error?-1:1;case M.Success:return b===M.Error||b===M.Warning?-1:1;case M.Information:return b===M.None?1:-1;case M.None:return-1;default:L.error("Comparison error",this);return 0;}};
return a;});
sap.ui.predefine('sap/ui/core/Popup',['sap/ui/Device','sap/ui/base/ManagedObject','sap/ui/base/Object','sap/ui/base/ObjectPool','./Control','./IntervalTrigger','./RenderManager','./Element','./ResizeHandler','./library',"sap/base/assert","sap/base/Log","sap/base/util/Version","sap/base/util/uid","sap/base/util/extend","sap/base/util/deepExtend","sap/ui/dom/containsOrEquals","sap/ui/thirdparty/jquery","sap/ui/events/F6Navigation","sap/ui/events/isMouseEventDelayed","sap/ui/base/EventProvider","sap/ui/dom/jquery/control","sap/ui/dom/jquery/Focusable","sap/ui/dom/jquery/rect"],function(D,M,B,O,C,I,R,E,a,b,c,L,V,u,d,f,g,q,F,h,k){"use strict";var m=b.CSSSize;var n=b.OpenState;var s;
function o(){if(s){return s;}var S,i;try{S=sap.ui.getCore().getStaticAreaRef();s=sap.ui.getCore().getUIArea(S);}catch(e){L.error(e);throw new Error("Popup cannot be opened because static UIArea cannot be determined.");}i=new C();s.addDependent(i);s=i.getUIArea();i.destroy();return s;}
var P=M.extend("sap.ui.core.Popup",{
constructor:function(e,i,S,A){c(arguments.length==0||(e&&typeof e==="object"),"oContent must be an object or there may be no arguments at all");c((i===undefined||i===true||i===false),"bModal must be true, false, or undefined");c((S===undefined||S===true||S===false),"bShadow must be true, false, or undefined");c((A===undefined||A===true||A===false),"bAutoClose must be true, false, or undefined");M.apply(this);this._popupUID=u();this.bOpen=false;this.eOpenState=n.CLOSED;this._mEvents={};this._mEvents["sap.ui.core.Popup.addFocusableContent-"+this._popupUID]=this._addFocusableArea;this._mEvents["sap.ui.core.Popup.removeFocusableContent-"+this._popupUID]=this._removeFocusableArea;this._mEvents["sap.ui.core.Popup.closePopup-"+this._popupUID]=this._closePopup;this._mEvents["sap.ui.core.Popup.onFocusEvent-"+this._popupUID]=this.onFocusEvent;this._mEvents["sap.ui.core.Popup.increaseZIndex-"+this._popupUID]=this._increaseMyZIndex;this._mEvents["sap.ui.core.Popup.contains-"+this._popupUID]=this._containsEventBusWrapper;if(e){this.setContent(e);}this._oDefaultPosition={my:P.Dock.CenterCenter,at:P.Dock.CenterCenter,of:document,offset:"0 0",collision:"flip"};this._oPosition=Object.assign({},this._oDefaultPosition);this._bModal=!!i;this._oPreviousFocus=null;this._sInitialFocusId=null;this._bShadow=typeof(S)==="boolean"?S:true;this._bAutoClose=!!A;this._animations={open:null,close:null};this._durations={open:"fast",close:"fast"};this._iZIndex=-1;this._oBlindLayer=null;this.setNavigationMode();if(this.touchEnabled){this._fAutoCloseHandler=function(j){if(j.isMarked("delayedMouseEvent")||j.isMarked("cancelAutoClose")){return;}if(this.eOpenState===n.CLOSING||this.eOpenState===n.CLOSED){return;}if(!this._contains(j.target)){this.close();}};}this._F6NavigationHandler=function(j){var l={},v=this._sF6NavMode,w;if(v=="DOCK"){if(this._bModal){v="NONE";}else if(this._oLastPosition&&this._oLastPosition.of){w=this._getOfDom(this._oLastPosition.of);if(!w||w===document){w=null;v="NONE";}}}switch(v){case"SCOPE":l.scope=this._$()[0];break;case"DOCK":l.target=w;var $=q(w).parents("[data-sap-ui-popup]");l.scope=$.length?$[0]:null;break;default:l.skip=true;}F.handleF6GroupNavigation(j,l);};},
metadata:{library:"sap.ui.core",publicMethods:["open","close","setContent","getContent","setPosition","setShadow","setModal","getModal","setAutoClose","setAutoCloseAreas","setExtraContent","isOpen","getAutoClose","getOpenState","setAnimations","setDurations","attachOpened","attachClosed","detachOpened","detachClosed"],associations:{"childPopups":{type:"sap.ui.core.Popup",multiple:true,visibility:"hidden"}},events:{"opened":{},"closed":{}}}
});
P.prototype.getChildPopups=function(){return this.getAssociation("childPopups",[]);};
P.prototype.addChildPopup=function(v){return this.addAssociation("childPopups",v);};
P.prototype.removeChildPopup=function(v){return this.removeAssociation("childPopups",v);};
P._activateBlindLayer=true;P.blStack=[];P.Dock={BeginTop:"begin top",BeginCenter:"begin center",BeginBottom:"begin bottom",LeftTop:"left top",LeftCenter:"left center",LeftBottom:"left bottom",CenterTop:"center top",CenterCenter:"center center",CenterBottom:"center bottom",RightTop:"right top",RightCenter:"right center",RightBottom:"right bottom",EndTop:"end top",EndCenter:"end center",EndBottom:"end bottom"};P.prototype.touchEnabled=D.support.touch&&(D.browser.safari||!D.system.combi);P.prototype.preventBrowserFocus=D.support.touch&&!D.system.combi;
B.extend("sap.ui.core.Popup.Layer",{constructor:function(){var e=this.getDomString();this._$Ref=q(e).appendTo(sap.ui.getCore().getStaticAreaRef());}});
P.Layer.prototype.init=function(e,z){this._$Ref.css({"visibility":"visible","z-index":z});this.update(e,z);this._$Ref.insertAfter(e).show();};
P.Layer.prototype.update=function(e,z){if(e.length){var i=e.rect();this._$Ref.css({"left":i.left,"top":i.top});if(e.css("right")!="auto"&&e.css("right")!="inherit"){this._$Ref.css({"right":e.css("right"),"width":"auto"});}else{this._$Ref.css({"width":i.width,"right":"auto"});}if(e.css("bottom")!="auto"&&e.css("bottom")!="inherit"){this._$Ref.css({"bottom":e.css("bottom"),"height":"auto"});}else{this._$Ref.css({"height":i.height,"bottom":"auto"});}if(typeof(z)==="number"){this._$Ref.css("z-index",z);}}};
P.Layer.prototype.reset=function(){if(this._$Ref.length){this._$Ref[0].style.display="none";this._$Ref[0].style.visibility="hidden";this._$Ref.appendTo(sap.ui.getCore().getStaticAreaRef());}};
P.Layer.prototype.getDomString=function(){L.error("sap.ui.core.Popup.Layer: getDomString function must be overwritten!");return"";};
P.Layer.extend("sap.ui.core.Popup.BlindLayer",{constructor:function(){P.Layer.apply(this);}});
P.BlindLayer.prototype.getDomString=function(){return"<div class=\"sapUiBliLy\" id=\"sap-ui-blindlayer-"+u()+"\"><iframe scrolling=\"no\" tabIndex=\"-1\"></iframe></div>";};
P.prototype.oBlindLayerPool=new O(P.BlindLayer);
P.Layer.extend("sap.ui.core.Popup.ShieldLayer",{constructor:function(){P.Layer.apply(this);}});
P.ShieldLayer.prototype.getDomString=function(){return"<div class=\"sapUiPopupShield\" id=\"sap-ui-shieldlayer-"+u()+"\"></div>";};
P.prototype.oShieldLayerPool=new O(P.ShieldLayer);(function(){var l=0;var i=Math.pow(2,32)-1;
P.setInitialZIndex=function(e){if(e>=i){throw new Error("Z-index can't be higher than Number.MAX_SAFE_INTEGER");}l=Math.max(e,this.getLastZIndex());};
P.getLastZIndex=function(){return l;};
P.prototype.getLastZIndex=function(){return P.getLastZIndex();};
P.getNextZIndex=function(){l+=10;if(l>=i){throw new Error("Z-index can't be higher than Number.MAX_SAFE_INTEGER");}return l;};
P.prototype.getNextZIndex=function(){return P.getNextZIndex();};
}());var r=function(e,i){if((!e&&i)||(e&&!i)){return false;}if(!e&&!i){return true;}var j=3;var l=Math.abs(e.left-i.left);var T=Math.abs(e.top-i.top);var w=Math.abs(e.width-i.width);var H=Math.abs(e.height-i.height);if(l>j||T>j||w>j||H>j){return false;}return true;};
P.prototype.open=function(i,e,j,l,v,w,x){c(this.oContent,"Popup content must have been set by now");if(this.eOpenState!=n.CLOSED){return;}this.eOpenState=n.OPENING;var s=o(),U;this._bContentAddedToStatic=false;this._bUIAreaPatched=false;if(this.oContent instanceof C){if(!this.oContent.getParent()){s.addContent(this.oContent,true);this._bContentAddedToStatic=true;}else if(!this.oContent.getUIArea()){this.oContent.getUIArea=function(){return s;};this._bUIAreaPatched=true;}U=this.oContent.getUIArea();if(P._bEnableUIAreaCheck&&U.getRootNode().id!==s.getRootNode().id){L.warning("The Popup content is NOT connected with the static-UIArea and may not work properly!");}}if(typeof(i)=="string"){x=w;w=v;v=l;l=j;j=e;e=i;i=-1;}if(i===undefined){i=-1;}c(i===-1||(typeof i==="number"&&i%1==0),"iDuration must be an integer (or omitted)");c(e===undefined||typeof e==="string","my must be a string or empty");c(j===undefined||typeof j==="string","at must be a string or empty");c(!l||typeof l==="object"||typeof l==="function","of must be empty or an object");c(!v||typeof v==="string","offset must be empty or a string");c(!w||typeof w==="string","collision must be empty or a string");this._oPreviousFocus=P.getCurrentFocusInfo();if(this.isInPopup(l)||this.isInPopup(this._oPosition.of)){var y=this.getParentPopupId(l)||this.getParentPopupId(this._oPosition.of);var z="";var A=this.getContent();if(A instanceof E){z=A.getId();}else if(typeof A==="object"){z=A.id;}this.addChildToPopup(y,z);this.addChildToPopup(y,this._popupUID);}var $=this._$(true);var G="fast";if((i===0)||(i>0)){G=i;}else if((this._durations.open===0)||(this._durations.open>0)){G=this._durations.open;}var H;if(e||j||l||v||w){H=this._createPosition(e,j,l,v,w);this._oPosition=H;}else{H=this._oPosition;}if(!H.of){H.of=this._oPosition.of||document;}this._iZIndex=this._iZIndex===this.getLastZIndex()?this._iZIndex:this.getNextZIndex();var S=sap.ui.getCore().getStaticAreaRef();$.css({"position":"absolute","visibility":"hidden"});if(!($[0].parentNode==S)){$.appendTo(S);}$.css("z-index",this._iZIndex);L.debug("position popup content "+$.attr("id")+" at "+(window.JSON?JSON.stringify(H.at):String(H.at)));this._applyPosition(H);if(x!==undefined){this.setFollowOf(x);}$.toggleClass("sapUiShd",this._bShadow);var J=$[0];if(J){J.style.display="none";J.style.visibility="visible";}var N=G==0;this._duringOpen(!N);if(N){this._opened();}else if(this._animations.open){this._animations.open.call(null,$,G,this._opened.bind(this));}else{$.fadeIn(G,this._opened.bind(this));}};
P.prototype._getDomRefToFocus=function(){var $=this._$(false,true),e,i;if(this._shouldGetFocusAfterOpen()){if(this._sInitialFocusId){i=sap.ui.getCore().byId(this._sInitialFocusId);if(i){e=i.getFocusDomRef();}e=e||window.document.getElementById(this._sInitialFocusId);}e=e||$.firstFocusableDomRef();}return e;};
P.prototype._opened=function(){if(this.eOpenState!==n.OPENING){return;}this.bOpen=true;var $=this._$(false,true);if($[0]&&$[0].style){$[0].style.display="block";}if(this._shouldGetFocusAfterOpen()){var e=this._getDomRefToFocus();if(e){e.focus();}var i=this._getOfDom(this._oLastPosition.of);var j=q(i).rect();if(this._oLastOfRect&&j&&!r(this._oLastOfRect,j)){this._applyPosition(this._oLastPosition);}}this.eOpenState=n.OPEN;if(this.getFollowOf()){P.DockTrigger.addListener(P.checkDocking,this);}this._updateBlindLayer();this.fireOpened();};
P.prototype._duringOpen=function(e){var $=this._$(false,true),S=sap.ui.getCore().getStaticAreaRef(),i=document.getElementById(S.id+"-firstfe");P._clearSelection();this._setupUserSelection();if(h()){if(this._oTopShieldLayer){clearTimeout(this._iTopShieldRemoveTimer);this._iTopShieldRemoveTimer=null;}else{this._oTopShieldLayer=this.oShieldLayerPool.borrowObject($,this._iZIndex+1);}this._iTopShieldRemoveTimer=setTimeout(function(){this.oShieldLayerPool.returnObject(this._oTopShieldLayer);this._oTopShieldLayer=null;this._iTopShieldRemoveTimer=null;}.bind(this),500);}if(!!D.browser.msie&&!D.os.windows_phone&&P._activateBlindLayer){this._oBlindLayer=this.oBlindLayerPool.borrowObject($,this._iZIndex-1);}if(this._bModal){this._showBlockLayer();}if(e&&i&&this._shouldGetFocusAfterOpen()&&!this.isInPopup(document.activeElement)&&this._getDomRefToFocus()!==document.activeElement){i.focus({preventScroll:true});}if(this.oContent instanceof E){this.oContent.addDelegate(this);}this.bOpen=true;this._activateFocusHandle();this._$(false,true).on("keydown",q.proxy(this._F6NavigationHandler,this));if(this._oBlindLayer){this._resizeListenerId=a.register(this._$().get(0),q.proxy(this.onresize,this));}};
P.prototype._shouldGetFocusAfterOpen=function(){return this._bModal||this._bAutoClose||this._sInitialFocusId;};
P.prototype._contains=function(e){var i=this._$().get(0);if(!i){return false;}var j=g(i,e);var l;if(!j){l=this.getChildPopups();j=l.some(function(v){var w=(v?window.document.getElementById(v):null);var j=g(w,e);if(!j){var x="sap.ui.core.Popup.contains-"+v;var y={domRef:e};sap.ui.getCore().getEventBus().publish("sap.ui",x,y);j=y.contains;}return j;});}if(!j){p.forEach(function(S){j=j||q(e).closest(S).length>0;});}return j;};
P.prototype._containsEventBusWrapper=function(e,i,j){j.contains=this._contains(j.domRef);};
P.prototype.onFocusEvent=function(e){var i=q.event.fix(e);if(arguments.length>1&&arguments[1]==="sap.ui.core.Popup.onFocusEvent-"+this._popupUID){i=q.event.fix(arguments[2]);}var j=(i.type=="focus"||i.type=="activate")?"focus":"blur";var l=false;if(j=="focus"){var v=this._$().get(0);if(v){l=this._contains(i.target);L.debug("focus event on "+i.target.id+", contains: "+l);if(this._bModal&&!l){var T=P.blStack.length>0&&P.blStack[P.blStack.length-1].popup===this;if(T){if(D.system.desktop||q(i.target).is(":input")){if(this.oLastBlurredElement){setTimeout(function(){if(this.oLastBlurredElement){this.oLastBlurredElement.focus();}}.bind(this),0);}else{v.focus();}}}}else if(this._bAutoClose&&l&&this._sTimeoutId){clearTimeout(this._sTimeoutId);this._sTimeoutId=null;}}}else if(j=="blur"){L.debug("blur event on "+i.target.id);if(this._bModal){this.oLastBlurredElement=i.target;}else if(this._bAutoClose){if(!this.touchEnabled&&!this._sTimeoutId){if(i.target===document.activeElement){return;}var w=typeof this._durations.close==="string"?0:this._durations.close;this._sTimeoutId=setTimeout(function(){this.close(w,"autocloseBlur");var x=this._oLastPosition&&this._oLastPosition.of;if(x){var y=this.getParentPopupId(x);if(y){var z="sap.ui.core.Popup.onFocusEvent-"+y;sap.ui.getCore().getEventBus().publish("sap.ui",z,i);}}}.bind(this),w);}}}};
P.prototype.setInitialFocusId=function(i){c(!i||typeof i==="string","sId must be a string or empty");this._sInitialFocusId=i;};
P.prototype.close=function(i){if(P._autoCloseDebug){return;}if(this._sTimeoutId){clearTimeout(this._sTimeoutId);this._sTimeoutId=null;if(arguments.length>1){var A=arguments[1];if(typeof A=="string"&&A=="autocloseBlur"&&this._isFocusInsidePopup()){return;}}}c(i===undefined||(typeof i==="number"&&(i%1==0)),"iDuration must be empty or an integer");if(this.eOpenState==n.CLOSED||this.eOpenState==n.CLOSING){return;}var e="fast";if((i===0)||(i>0)){e=i;}else if((this._durations.close===0)||(this._durations.close>0)){e=this._durations.close;}this.eOpenState=n.CLOSING;if(this.getFollowOf()){P.DockTrigger.removeListener(P.checkDocking,this);}if(this.oContent){if(this._bContentAddedToStatic){sap.ui.getCore().getEventBus().publish("sap.ui","__beforePopupClose",{domNode:this._$().get(0)});var S=sap.ui.getCore().getStaticAreaRef();S=sap.ui.getCore().getUIArea(S);S.removeContent(S.indexOfContent(this.oContent),true);}else if(this._bUIAreaPatched){delete this.oContent.getUIArea;}}this._bContentAddedToStatic=false;this._bUIAreaPatched=false;this._sTimeoutId=null;this._deactivateFocusHandle();this._$(false,true).off("keydown",this._F6NavigationHandler);if(this.oContent instanceof E){this.oContent.removeDelegate(this);}var $=this._$();if(this._bEventBusEventsRegistered){this._unregisterEventBusEvents();}if(this._oBlindLayer){this.oBlindLayerPool.returnObject(this._oBlindLayer);}this._oBlindLayer=null;if(h()){if(this._oBottomShieldLayer){clearTimeout(this._iBottomShieldRemoveTimer);this._iBottomShieldRemoveTimer=null;}else{this._oBottomShieldLayer=this.oShieldLayerPool.borrowObject($,this._iZIndex-3);}this._iBottomShieldRemoveTimer=setTimeout(function(){this.oShieldLayerPool.returnObject(this._oBottomShieldLayer);this._oBottomShieldLayer=null;this._iBottomShieldRemoveTimer=null;}.bind(this),500);}if(this.isInPopup(this._oLastPosition.of)){var j=this.getParentPopupId(this._oLastPosition.of);var l="";var v=this.getContent();if(v instanceof E){l=v.getId();}else if(typeof v==="object"){l=v.id;}this.removeChildFromPopup(j,l);this.removeChildFromPopup(j,this._popupUID);}if(this._bModal&&this.preventBrowserFocus){$.one("mousedown",function(w){w.preventDefault();});}this._duringClose();if(e==0){this._closed();}else if(this._animations.close){this._animations.close.call(null,$,e,this._closed.bind(this));}else{$.fadeOut(e,this._closed.bind(this));}};
P.prototype._closed=function(){var $=this._$(false,true);if(this._bModal){this._hideBlockLayer();}P._clearSelection();this._restoreUserSelection();if($.length){var e=$.get(0);if(e){e.style.display="none";e.style.visibility="hidden";e.style.left="0px";e.style.top="0px";e.style.right="";}$=this._$(false,true);e=$.length?$[0]:null;if(e){e.style.display="none";e.style.visibility="hidden";e.style.left="0px";e.style.top="0px";e.style.right="";}}if(this._bModal){P.applyFocusInfo(this._oPreviousFocus);this._oPreviousFocus=null;this.oLastBlurredElement=null;}this.bOpen=false;this.eOpenState=n.CLOSED;var i=this.getChildPopups();for(var j=0,l=i.length;j<l;j++){this.closePopup(i[j]);}this.fireClosed();};
P.prototype._duringClose=function(){if(this._resizeListenerId){a.deregister(this._resizeListenerId);this._resizeListenerId=null;}};
P.getCurrentFocusInfo=function(){var e=null;var i=sap.ui.getCore().getCurrentFocusedControlId();if(i){var j=sap.ui.getCore().byId(i);e={'sFocusId':i,'oFocusInfo':j?j.getFocusInfo():{}};}else{try{var l=document.activeElement;if(l&&l.nodeName){e={'sFocusId':l.id,'oFocusedElement':l,'oFocusInfo':{}};}}catch(v){e=null;}}if(e){e.popup=this;}return e;};
P.applyFocusInfo=function(e){var i={preventScroll:true};if(e){var j=sap.ui.getCore().byId(e.sFocusId);if(j){j.applyFocusInfo(Object.assign(i,e.oFocusInfo));}else{var l=((e.sFocusId?window.document.getElementById(e.sFocusId):null))||e.oFocusedElement;if(l){l.focus(i);}}}};
P.prototype.setContent=function(e){c(typeof e==="object","oContent must be an object");this.oContent=e;return this;};
P.prototype.getContent=function(){return this.oContent;};
P.prototype.setPosition=function(e,i,j,l,v){c(typeof e==="string","my must be a string");c(typeof i==="string"||(typeof i==="object"&&(typeof i.left==="number")&&(typeof i.top==="number")),"my must be a string or an object with 'left' and 'top' properties");c(!j||typeof j==="object"||typeof j==="function","of must be empty or an object");c(!l||typeof l==="string","offset must be empty or a string");c(!v||typeof v==="string","collision must be empty or a string");this._oPosition=this._createPosition(e,i,j,l,v);if(this.eOpenState!=n.CLOSED){this._applyPosition(this._oPosition);this._oBlindLayer&&this._oBlindLayer.update(this._$());}return this;};
P.prototype._createPosition=function(e,i,j,l,v){var N=false;if(e&&(e.indexOf("+")>=0||e.indexOf("-")>=0)){N=true;if(l&&l!="0 0"){L.warning("offset used in my and in offset, the offset value will be ignored","sap.ui.core.Popup","setPosition");}l=null;}var w=d({},this._oDefaultPosition,{"my":e||this._oDefaultPosition.my,"at":i||this._oDefaultPosition.at,"of":j,"offset":l,"collision":v});if(!q.ui.version){if(P._bNewOffset==null){P._bNewOffset=true;var $=q(document.createElement("div"));$.position({of:window,using:function(A,G){P._bNewOffset=(G!==undefined);}});}}var x=[];var y=[];if(P._bNewOffset||V(q.ui.version).compareTo("1.8.23")>0){if(l&&l!="0 0"){x=w.my.split(" ");y=l.split(" ");var S=[parseInt(y[0])<0?"":"+",parseInt(y[1])<0?"":"+"];w.my=x[0]+S[0]+y[0]+" "+x[1]+S[1]+y[1];w.offset=null;}}else if(N){x=w.my.split(" ");y=["",""];var z=x[0].indexOf("+");if(z<0){z=x[0].indexOf("-");}if(z>=0){y[0]=x[0].slice(z);x[0]=x[0].slice(0,z);}z=x[1].indexOf("+");if(z<0){z=x[1].indexOf("-");}if(z>=0){y[1]=x[1].slice(z);x[1]=x[1].slice(0,z);}w.my=x[0]+" "+x[1];w.offset=y[0]+" "+y[1];}return w;};
P.prototype._getPositionOffset=function(){var e=[];if(this._oPosition.my&&(this._oPosition.my.indexOf("+")>=0||this._oPosition.my.indexOf("-")>=0)){var i=this._oPosition.my.split(" ");var j=i[0].indexOf("+");if(j<0){j=i[0].indexOf("-");}if(j>=0){e[0]=i[0].slice(j);}j=i[1].indexOf("+");if(j<0){j=i[1].indexOf("-");}if(j>=0){e[1]=i[1].slice(j);}}else if(this._oPosition.offset){e=this._oPosition.offset.split(" ");}return e;};
P.prototype._applyPosition=function(e){var i=sap.ui.getCore().getConfiguration().getRTL();var $=this._$();if($.length){var A=e.at;var j=$.get(0);if(typeof(A)==="string"){j.style.display="block";j.style.left="";j.style.right="";$.position(this._resolveReference(this._convertPositionRTL(e,i)));this._fixPositioning(e,i);}else if(m.isValid(A.left)&&m.isValid(A.top)){$.css({"left":A.left,"top":A.top});}else if(m.isValid(A.right)&&m.isValid(A.top)){$.css({"right":A.right,"top":A.top});}else if(typeof(A.left)==="number"&&typeof(A.top)==="number"){var l=$[0];if(l&&l.style.right){var w=$.outerWidth();$.css({"right":(document.documentElement.clientWidth-(A.left+w))+"px","top":A.top+"px"});}else{$.css({"left":A.left+"px","top":A.top+"px"});}}this._oLastPosition=e;this._oLastOfRect=this._calcOfRect(e.of);}};
P.prototype._calcOfRect=function(e){var i=this._getOfDom(e);if(i){return q(i).rect();}return null;};
P.prototype._getOfDom=function(e){if(e instanceof q.Event){return null;}var $;if(typeof(e)==="string"){$=q(document.getElementById(e));}else if(e instanceof q){$=e;}else{$=q(e instanceof E?e.getDomRef():e);}return $[0];};
P.prototype._convertPositionRTL=function(e,i){var j=Object.assign({},e);if(i){var N=false;if(j.my&&(j.my.indexOf("+")>=0||j.my.indexOf("-")>=0)){N=true;}if((j.offset||N)&&((j.my.indexOf("begin")>-1)||(j.my.indexOf("end")>-1))&&((j.at.indexOf("begin")>-1)||(j.at.indexOf("end")>-1))){if(N){var l=j.my.split(" ");if(l.length==2){j.my="";if(l[0]){if(l[0].indexOf("begin")>-1||l[0].indexOf("end")>-1){if(l[0].indexOf("+")>-1){l[0]=l[0].replace("+","-");}else if(l[0].indexOf("-")>-1){l[0]=l[0].replace("-","+");}}j.my=l[0];}if(l[1]){if(l[1].indexOf("begin")>-1||l[1].indexOf("end")>-1){if(l[1].indexOf("+")>-1){l[1]=l[1].replace("+","-");}else if(l[1].indexOf("-")>-1){l[1]=l[1].replace("-","+");}}if(l[0]){j.my=j.my+" ";}j.my=j.my+l[1];}}}else{j.offset=this._mirrorOffset(j.offset);}}j.my=j.my.replace("begin","right").replace("end","left");j.at=j.at.replace("begin","right").replace("end","left");}else{j.my=j.my.replace("end","right").replace("begin","left");j.at=j.at.replace("end","right").replace("begin","left");}return j;};
P.prototype._mirrorOffset=function(e){var i=q.trim(e).split(/\s/);var j=parseInt(i[0]);return(-j)+" "+i[i.length-1];};
P.prototype._fixPositioning=function(e,i){var j=e.my;var $=this._$();var l=0;if(typeof(j)==="string"){if(i&&((j.indexOf("right")>-1)||(j.indexOf("begin")>-1)||(j.indexOf("center")>-1))){$=this._$();l=q(window).width()-$.outerWidth()-$.offset().left;$.css({"right":l+"px","left":""});}else if((j.indexOf("right")>-1)||(j.indexOf("end")>-1)){$=this._$();l=q(window).width()-$.outerWidth()-$.offset().left;$.css({"right":l+"px","left":""});}}};
P.prototype._resolveReference=function(e){var i=e;if(e.of instanceof E){i=Object.assign({},e,{of:e.of.getDomRef()});}return i;};
P.prototype.setShadow=function(S){c(typeof S==="boolean","bShowShadow must be boolean");this._bShadow=S;if(this.eOpenState!=n.CLOSED){this._$().toggleClass("sapUiShd",S);}return this;};
P.prototype.setModal=function(e,i){c(typeof e==="boolean","bModal must be boolean");c(!i||typeof i==="string","sModalCSSClass must be empty or a string");var j=this._bModal;this._bModal=e;this._sModalCSSClass=i;if(this.isOpen()){if(j!==e){P._clearSelection();if(e){this._setupUserSelection();this._showBlockLayer();}else{this._hideBlockLayer();this._restoreUserSelection();}if(this.touchEnabled&&this._bAutoClose){if(!e){q(document).on("touchstart mousedown",q.proxy(this._fAutoCloseHandler,this));}else{q(document).off("touchstart mousedown",this._fAutoCloseHandler);}}}}return this;};
P.prototype.getModal=function(){return this._bModal;};
P.prototype.setNavigationMode=function(e){if(e!="NONE"&&e!="DOCK"&&e!="SCOPE"){this._sF6NavMode="NONE";}this._sF6NavMode=e;};
P.prototype.setAutoClose=function(A){c(typeof A==="boolean","bAutoClose must be boolean");if(this.touchEnabled&&this.isOpen()&&this._bAutoClose!==A){if(!this._bModal){if(A){q(document).on("touchstart mousedown",q.proxy(this._fAutoCloseHandler,this));}else{q(document).off("touchstart mousedown",this._fAutoCloseHandler);}}}this._bAutoClose=A;return this;};
P.prototype.setExtraContent=function(e){c(Array.isArray(e),"Extra popup content must be an array which contains either sap.ui.core.Element, DOM Element or an ID");if(!this._aExtraContent){this._aExtraContent=[];}var j=function(z){return{onBeforeRendering:function(){var A=z.getDomRef();if(A&&this.isOpen()){if(D.browser.msie){q(A).off("deactivate."+this._popupUID,this.fEventHandler);}else{A.removeEventListener("blur",this.fEventHandler,true);}}},onAfterRendering:function(){var A=z.getDomRef();if(A&&this.isOpen()){if(D.browser.msie){q(A).on("deactivate."+this._popupUID,this.fEventHandler);}else{A.addEventListener("blur",this.fEventHandler,true);}}}};};var v,w,x,y;for(var i=0,l=e.length;i<l;i++){w=e[i];if(w instanceof E){v=w.getId();}else if(typeof w==="object"){v=w.id;}else if(typeof w==="string"){v=w;}if(this.getChildPopups().indexOf(v)===-1){this.addChildPopup(v);y={id:v};if(w instanceof E){x=j(w);w.addEventDelegate(x,this);y.delegate=x;}this._aExtraContent.push(y);}}return this;};
P.prototype.setAutoCloseAreas=P.prototype.setExtraContent;
P.prototype.setAnimations=function(e,i){c(e===null||typeof e==="function","fnOpen must be a function");c(i===null||typeof i==="function","fnClose must be a function");if(e&&(typeof(e)=="function")){this._animations.open=e;}if(i&&(typeof(i)=="function")){this._animations.close=i;}return this;};
P.prototype.setDurations=function(i,e){c(i===null||(typeof i==="number"&&(i%1==0)),"iOpenDuration must be null or an integer");c(!e||(typeof e==="number"&&(e%1==0)),"iOpenDuration must be undefined or an integer");if((i>0)||(i===0)){this._durations.open=i;}if((e>0)||(e===0)){this._durations.close=e;}return this;};
P.CLOSE_ON_SCROLL="close_Popup_if_of_is_moved";
P.prototype._fnCloseOnScroll=function(e){this.close();};
P.prototype.setFollowOf=function(e){P.DockTrigger.removeListener(P.checkDocking,this);var U=false;this._bFollowOf=true;this._followOfHandler=null;if(typeof(e)==="function"){this._followOfHandler=e;U=true;}else if(typeof(e)==="boolean"){U=e;}else if(e===P.CLOSE_ON_SCROLL){this._followOfHandler=this._fnCloseOnScroll;U=true;}else{this._bFollowOf=false;if(e!==null){L.error("Trying to set an invalid type to 'followOf: "+e);}}if(U&&this._oLastPosition){this._oLastOfRect=this._calcOfRect(this._oLastPosition.of);}if(this._bFollowOf&&this.getOpenState()===n.OPEN){P.DockTrigger.addListener(P.checkDocking,this);}};
P.prototype.getAutoClose=function(){return this._bAutoClose;};
P.prototype.getFollowOf=function(){if(this._bFollowOf){return typeof(this._followOfHandler)==="function"?this._followOfHandler:true;}return false;};
P.prototype.isOpen=function(){return this.bOpen;};
P.prototype.getOpenState=function(){return this.eOpenState;};
P.prototype.destroy=function(){if(this._resizeListenerId){a.deregister(this._resizeListenerId);this._resizeListenerId=null;}this.close(0);this.oContent=null;if(this._bFollowOf){this.setFollowOf(null);}if(this._bEventBusEventsRegistered){this._unregisterEventBusEvents();}if(this._iTopShieldRemoveTimer){clearTimeout(this._iTopShieldRemoveTimer);this.oShieldLayerPool.returnObject(this._oTopShieldLayer);this._oTopShieldLayer=null;this._iTopShieldRemoveTimer=null;}if(this._iBottomShieldRemoveTimer){clearTimeout(this._iBottomShieldRemoveTimer);this.oShieldLayerPool.returnObject(this._oBottomShieldLayer);this._oBottomShieldLayer=null;this._iBottomShieldRemoveTimer=null;}if(this._aExtraContent){var e;this._aExtraContent.forEach(function(A){if(A.delegate){e=q(document.getElementById(A.id)).control(0);if(e){e.removeEventDelegate(A.delegate);}}});}M.prototype.destroy.apply(this,arguments);};
P.prototype.exit=function(){delete this._mEvents;};
P.prototype._addFocusEventListeners=function(e,j,v){if(!this.fEventHandler){this.fEventHandler=q.proxy(this.onFocusEvent,this);}var $=this._$();var w=this.getChildPopups();var x={};var i=0,l=0;if($.length){if(document.addEventListener&&!D.browser.msie){document.addEventListener("focus",this.fEventHandler,true);$.get(0).addEventListener("blur",this.fEventHandler,true);for(i=0,l=w.length;i<l;i++){x=(w[i]?window.document.getElementById(w[i]):null);if(x){x.addEventListener("blur",this.fEventHandler,true);}}}else{q(document).on("activate."+this._popupUID,this.fEventHandler);$.on("deactivate."+this._popupUID,this.fEventHandler);for(i=0,l=w.length;i<l;i++){x=(w[i]?window.document.getElementById(w[i]):null);if(x){q(x).on("deactivate."+this._popupUID,this.fEventHandler);}}}}};
P.prototype._removeFocusEventListeners=function(e,j,v){var $=this._$(false,true);if(!$.length){return;}var w=this.getChildPopups();var x={};var i=0,l=0;if(document.removeEventListener&&!D.browser.msie){document.removeEventListener("focus",this.fEventHandler,true);$.get(0).removeEventListener("blur",this.fEventHandler,true);for(i=0,l=w.length;i<l;i++){x=(w[i]?window.document.getElementById(w[i]):null);if(x){x.removeEventListener("blur",this.fEventHandler,true);}this.closePopup(w[i]);}}else{q(document).off("activate."+this._popupUID,this.fEventHandler);$.off("deactivate."+this._popupUID,this.fEventHandler);for(i=0,l=w.length;i<l;i++){x=(w[i]?window.document.getElementById(w[i]):null);if(x){q(x).off("deactivate."+this._popupUID,this.fEventHandler);}}}this.fEventHandler=null;};
P.prototype._activateFocusHandle=function(){if(this._bModal||this._bAutoClose){this._addFocusEventListeners();}if(this.touchEnabled&&!this._bModal&&this._bAutoClose){q(document).on("touchstart mousedown",q.proxy(this._fAutoCloseHandler,this));}};
P.prototype._deactivateFocusHandle=function(){if(this.fEventHandler){this._removeFocusEventListeners();}if(this.touchEnabled&&!this._bModal&&this._bAutoClose){q(document).off("touchstart mousedown",this._fAutoCloseHandler);}};
P.prototype._registerEventBusEvents=function(e,i,j){var l=this;q.each(l._mEvents,function(v,w){sap.ui.getCore().getEventBus().subscribe("sap.ui",v,w,l);});this._bEventBusEventsRegistered=true;};
P.prototype._unregisterEventBusEvents=function(e,i,j){var l=this;q.each(l._mEvents,function(v,w){sap.ui.getCore().getEventBus().unsubscribe("sap.ui",v,w,l);});delete this._bEventBusEventsRegistered;};
P.prototype._addFocusableArea=function(e,i,j){if(this.getChildPopups().indexOf(j.id)===-1){this.addChildPopup(j.id);}};
P.prototype._removeFocusableArea=function(e,i,j){this.removeChildPopup(j.id);};
P.prototype._closePopup=function(e,i,j){this.close(typeof this._durations.close==="string"?0:this._durations.close);};
P.prototype._setIdentity=function($){if(typeof $==="object"){$.attr("data-sap-ui-popup",this._popupUID);}else{L.warning("Incorrect DomRef-type for 'setIdentity': "+$,this);return;}if(!this._bEventBusEventsRegistered){this._registerEventBusEvents();}};
P.prototype._$=function(e,G){var $;if(this.oContent instanceof C){$=this.oContent.$();if(e||($.length===0&&!G)){L.info("Rendering of popup content: "+this.oContent.getId());if($.length>0){R.preserveContent($[0],true,false);}sap.ui.getCore().getRenderManager().render(this.oContent,sap.ui.getCore().getStaticAreaRef());$=this.oContent.$();}}else if(this.oContent instanceof E){$=this.oContent.$();}else{$=q(this.oContent);}this._setIdentity($);return $;};
function _(e){if(P._blockLayerStateProvider){P._blockLayerStateProvider.fireEvent("blockLayerStateChange",e);}}
P.attachBlockLayerStateChange=function(e,i,l){if(!P._blockLayerStateProvider){P._blockLayerStateProvider=new k();}P._blockLayerStateProvider.attachEvent("blockLayerStateChange",e,i,l);};
P.detachBlockLayerStateChange=function(e,l){if(P._blockLayerStateProvider){P._blockLayerStateProvider.detachEvent("blockLayerStateChange",e,l);}};
P.prototype._showBlockLayer=function(){var $=q("#sap-ui-blocklayer-popup"),e="sapUiBLy"+(this._sModalCSSClass?" "+this._sModalCSSClass:"");if($.length===0){$=q('<div id="sap-ui-blocklayer-popup" tabindex="0" class="'+e+'"></div>');$.appendTo(sap.ui.getCore().getStaticAreaRef());}else{$.removeClass().addClass(e);}P.blStack.push({zIndex:this._iZIndex-2,popup:this});$.css({"z-index":this._iZIndex-2,"visibility":"visible"}).show();q("html").addClass("sapUiBLyBack");if(P.blStack.length===1){_({visible:true,zIndex:P.blStack[0].zIndex});}};
P.prototype._hideBlockLayer=function(){var l=P.blStack.pop();var $=q("#sap-ui-blocklayer-popup");if($.length){var e=$.get(0);if(P.blStack.length>0){e.style.zIndex=P.blStack[P.blStack.length-1].zIndex;e.style.visibility="visible";e.style.display="block";}else{e.style.visibility="hidden";e.style.display="none";window.setTimeout(function(){q("html").removeClass("sapUiBLyBack");},0);_({visible:false,zIndex:l.zIndex});}}};
P.prototype._isFocusInsidePopup=function(){var e=this._$(false).get(0);if(e&&g(e,document.activeElement)){return true;}return false;};
P.DockTrigger=I;
P.checkDocking=function(){if(this.getOpenState()===n.OPEN){var e=this._getOfDom(this._oLastPosition.of),i;if(e){if((e===window)||(e===window.document)||g(document.documentElement,e)){i=q(e).rect();}else if(e.id){var N=window.document.getElementById(e.id);var j=q(N).rect();if(j&&!r(i,j)){i=j;this._oLastPosition.of=N;}}}if(!i){this.close();return;}else if(i.left===0&&i.top===0&&i.height===0&&i.height===0&&this._oLastPosition.of.id){this._oLastPosition.of=window.document.getElementById(this._oLastPosition.of.id);e=this._getOfDom(this._oLastPosition.of);i=q(e).rect();if(!i){this.close();return;}}if(this._oLastOfRect){if(!r(this._oLastOfRect,i)){if(this._followOfHandler){var l=f({},this._oLastPosition),v=f({},this._oLastOfRect);this._followOfHandler({lastPosition:l,lastOfRect:v,currentOfRect:i});}else{this._applyPosition(this._oLastPosition);}}}}};
P.prototype.ontouchstart=function(e){this.onmousedown(e,true);this._bMousedownCalled=true;};
P.prototype.onmousedown=function(e,S){if(this._bMousedownCalled&&!S){this._bMousedownCalled=false;return;}if(this._iZIndex===this.getLastZIndex()||this.getModal()){return;}this._increaseMyZIndex("","mousedown",e);};
P.prototype._increaseMyZIndex=function(e,j,v){var w=this.getParentPopup(this._oLastPosition.of);if(v&&v.type==="mousedown"||v&&v.isFromParentPopup||w.length===0){this._iZIndex=this.getNextZIndex();var $=this._$(false,true);$.css("z-index",this._iZIndex);if(this._oBlindLayer){this._oBlindLayer.update($,this._iZIndex-1);}if(v&&!v.type||v&&v.type!="mousedown"||j==="mousedown"){var x=this.getChildPopups();for(var i=0,l=x.length;i<l;i++){this.increaseZIndex(x[i],true);}}}else if(w.length>0){var y=q(w.get(0)).attr("data-sap-ui-popup");this.increaseZIndex(y,false);}};
P.prototype.onAfterRendering=function(e){var i=this.getContent();var $=i instanceof E?i.$():q(i);$.toggleClass("sapUiShd",this._bShadow);P._clearSelection();this._setupUserSelection();$.css("position","absolute");this._setIdentity($);var j=$[0];var l=j.style.left;var v=j.style.right;var w=j.style.top;var x=j.style.bottom;if(!(l&&l!="auto"||v&&v!="auto"||w&&w!="auto"||x&&x!="auto")){L.debug("reposition popup content "+$.attr("id")+" at "+(window.JSON?JSON.stringify(this._oLastPosition.at):String(this._oLastPosition.at)));this._applyPosition(this._oLastPosition);}$.show().css({"visibility":"visible","z-index":this._iZIndex});if(this._oBlindLayer){this._resizeListenerId=a.register(this._$().get(0),q.proxy(this.onresize,this));}if(this.isOpen()&&(this.getModal()||this.getAutoClose())){this._addFocusEventListeners();}this._$(false,true).on("keydown",q.proxy(this._F6NavigationHandler,this));};
P.prototype.onBeforeRendering=function(e){if(this._resizeListenerId){a.deregister(this._resizeListenerId);this._resizeListenerId=null;}if(this.isOpen()&&(this.getModal()||this.getAutoClose())){this._removeFocusEventListeners();}this._$(false,true).off("keydown",this._F6NavigationHandler);};
P.prototype.onresize=function(e){if(this.eOpenState!=n.CLOSED&&this._oBlindLayer){var i=this;setTimeout(function(){i._updateBlindLayer();},0);}};
P.prototype._updateBlindLayer=function(){if(this.eOpenState!=n.CLOSED&&this._oBlindLayer){this._oBlindLayer.update(this._$(false,true));}};
P.prototype.isInPopup=function(T){var $=this.getParentPopup(T);return $&&$.length>0;};
P.prototype.getParentPopup=function(T){var e=T?T:this;var $=q(e instanceof E?e.getDomRef():e);return $.closest("[data-sap-ui-popup]");};
P.prototype.getParentPopupId=function(T){var $=this.getParentPopup(T);return $.attr("data-sap-ui-popup");};
P.prototype.addChildToPopup=function(e,i){var j="sap.ui.core.Popup.addFocusableContent-"+e;sap.ui.getCore().getEventBus().publish("sap.ui",j,{id:i});};
P.prototype.removeChildFromPopup=function(e,i){var j="sap.ui.core.Popup.removeFocusableContent-"+e;sap.ui.getCore().getEventBus().publish("sap.ui",j,{id:i});};
P.prototype.closePopup=function(e){var i="sap.ui.core.Popup.closePopup-"+e;sap.ui.getCore().getEventBus().publish("sap.ui",i);};
P.prototype.increaseZIndex=function(e,i){var j="sap.ui.core.Popup.increaseZIndex-"+e;sap.ui.getCore().getEventBus().publish("sap.ui",j,{isFromParentPopup:i?i:false});};
P.prototype.focusTabChain=function(e){var S=e.event.target,N=e.that.getMetadata().getName(),i;if((!e.$FocusablesContent||!e.$FocusablesFooter)||(!e.$FocusablesContent.length&&!e.$FocusablesFooter.length)){return;}if(S.id===e.firstFocusable){L.debug("First dummy focus element was focused","",N);if(e.$FocusablesFooter.length>0){L.debug("Last footer element will be focused","",N);i=e.$FocusablesFooter[e.$FocusablesFooter.length-1];}else{L.debug("Last content element will be focused","",N);i=e.$FocusablesContent[e.$FocusablesContent.length-1];}}else if(S.id===e.lastFocusable){L.debug("Last dummy focus element was focues","",N);if(e.$FocusablesContent.length>0){L.debug("First content element will be focused","",N);i=e.$FocusablesContent[0];}else{L.debug("First footer element will be focused","",N);i=e.$FocusablesFooter[0];}}if(i){setTimeout(function(){var j=sap.ui.getCore().byId(i.id);if(j instanceof C){L.debug("Focus will be handled by "+j.getMetadata().getName(),"",N);}else{L.debug("oFocusDomRef will be focused","",N);}if(j){j.focus();}else if(i){i.focus();}return j?j.getId():i.id;},0);}};
P.prototype._setupUserSelection=function(){var $=this._$(false,true);P._markAsUserSelectable($,this._bModal||P.blStack.length>0);if(this._bModal){if(P.blStack.length>0){var l=P.blStack[P.blStack.length-1];var G=function(e){return e.popup.getId();};if(P.blStack.map(G).indexOf(this.getId())===-1){P._markAsNotUserSelectable(l.popup._$(false,true),true);}else if(l.popup.getId()!==this.getId()){P._markAsNotUserSelectable($,true);}}else{P._markAsNotUserSelectable(q("html"),true);P._markExternalContentAsUserSelectable(true);}}};
P.prototype._restoreUserSelection=function(){var $=this._$(false,true);P._markAsNotUserSelectable($,false);if(P.blStack.length>0){P._markAsUserSelectable(P.blStack[P.blStack.length-1].popup._$(false,true),true);}else{P._markAsUserSelectable(q("html"),false);P._markExternalContentAsNotUserSelectable(false);}};
P._clearSelection=function(){var S=document.getSelection();if(!S.isCollapsed){S.removeAllRanges();}};
P._markAsUserSelectable=function($,e){if(!(D.browser.msie||D.browser.edge)){$.removeClass("sapUiNotUserSelectable");if(e){$.addClass("sapUiUserSelectable");}}};
P._markAsNotUserSelectable=function($,e){if(!(D.browser.msie||D.browser.edge)){$.removeClass("sapUiUserSelectable");if(e){$.addClass("sapUiNotUserSelectable");}}};
var p=new Set(),t="[data-sap-ui-integration-popup-content]";p.add(t);
P.addExternalContent=function(S,e){if(!Array.isArray(S)){S=[S];}S.forEach(Set.prototype.add.bind(p));if(e){P.markExternalContentAsSelectable();}};
P.removeExternalContent=function(S,e){if(!Array.isArray(S)){S=[S];}if(e){P.markExternalContentAsNotSelectable();}S.forEach(function(i){if(i!==t){p.delete(i);}});};
P.markExternalContentAsSelectable=function(){P._clearSelection();if(P.blStack.length>0){P._markExternalContentAsUserSelectable(true);}};
P.markExternalContentAsNotSelectable=function(){P._clearSelection();if(P.blStack.length>0){P._markExternalContentAsNotUserSelectable(false);}};
P._getExternalContent=function(){var e=[];if(p.size>0){p.forEach(function(S){var $=q(S);if($.length>0){e.push($);}});}return e;};
P._markExternalContentAsUserSelectable=function(e){var i=P._getExternalContent();i.forEach(function($){P._markAsUserSelectable($,e);});};
P._markExternalContentAsNotUserSelectable=function(e){var i=P._getExternalContent();i.forEach(function($){P._markAsNotUserSelectable($,e);});};
return P;});
sap.ui.predefine('sap/ui/core/ScrollBar',['sap/ui/Device','./Control','./library',"./ScrollBarRenderer","sap/ui/performance/trace/Interaction","sap/base/Log","sap/ui/dom/containsOrEquals","sap/ui/events/jquery/EventSimulation","sap/ui/thirdparty/jquery"],function(D,C,l,S,I,L,c,E,q){"use strict";var a=l.ScrollBarAction;
var b=C.extend("sap.ui.core.ScrollBar",{metadata:{library:"sap.ui.core",properties:{vertical:{type:"boolean",group:"Behavior",defaultValue:true},scrollPosition:{type:"int",group:"Behavior",defaultValue:null},size:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},contentSize:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},steps:{type:"int",group:"Dimension",defaultValue:null}},events:{scroll:{parameters:{action:{type:"sap.ui.core.ScrollBarAction"},forward:{type:"boolean"},newScrollPos:{type:"int"},oldScrollPos:{type:"int"}}}}}});
b.prototype.init=function(){this._$ScrollDomRef=null;this._iOldScrollPos=0;this._iOldStep=0;this._bScrollPosIsChecked=false;this._bRTL=sap.ui.getCore().getConfiguration().getRTL();this._bSuppressScroll=false;this._iMaxContentDivSize=1000000;if(E.touchEventMode==="ON"){sap.ui.requireSync("sap/ui/thirdparty/zyngascroll");this._iLastTouchScrollerPosition=null;this._iTouchStepTreshold=24;this._bSkipTouchHandling=false;this._oTouchScroller=new window.Scroller(q.proxy(this._handleTouchScroll,this),{bouncing:false});}};
b.prototype.onBeforeRendering=function(){this.$("sb").off("scroll",this.onscroll);};
b.prototype.onAfterRendering=function(){this._iSteps=this.getSteps();var s=this.getContentSize();this._bStepMode=!s;var i=this.getSize();if(i.endsWith("px")){i=i.substr(0,i.length-2);}else{i=this.getVertical()?this.$().height():this.$().width();}var d=null;var $=this.$("ffsize");if(D.browser.firefox){d=$.outerHeight();if(d===0){d=window.getComputedStyle(q("body").get(0))["font-size"];if(d.endsWith("px")){d=d.substr(0,d.length-2);}d=parseInt(d);}}$.remove();if(D.browser.webkit){if(!document.width){d=Math.round(40/(window.outerWidth/q(document).width()));}else{d=Math.round(40/(document.width/q(document).width()));}}if(this.getVertical()){if(D.browser.firefox){this._iFactor=d;}else if(D.browser.webkit){this._iFactor=d;}else{this._iFactor=Math.floor(i*0.125);}this._iFactorPage=D.browser.firefox?i-d:Math.floor(i*0.875);}else{if(D.browser.firefox){this._iFactor=10;this._iFactorPage=Math.floor(i*0.8);}else if(D.browser.webkit){this._iFactor=d;this._iFactorPage=Math.floor(i*0.875);}else{this._iFactor=7;this._iFactorPage=i-14;}}this._$ScrollDomRef=this.$("sb");if(this._bStepMode){if(this.getVertical()){var e=this._iSteps*this._iFactor;if(e>this._iMaxContentDivSize){this._iFactor=this._iFactor/(e/this._iMaxContentDivSize);}var f=this._$ScrollDomRef.height()+Math.ceil(this._iSteps*this._iFactor);this._$ScrollDomRef.find("div").height(f);}else{var f=this._$ScrollDomRef.width()+this._iSteps*this._iFactor;this._$ScrollDomRef.find("div").width(f);}}this.setCheckedScrollPosition(this.getScrollPosition()?this.getScrollPosition():0,true);this._$ScrollDomRef.on("scroll",q.proxy(this.onscroll,this));if(E.touchEventMode==="ON"){this._bSkipTouchHandling=true;var o={width:0,height:0};o[this.getVertical()?"height":"width"]=this._bStepMode?(this.getSteps()*this._iTouchStepTreshold):parseInt(this.getContentSize());this._oTouchScroller.setDimensions(0,0,o.width,o.height);var g=this._$ScrollDomRef.get(0);if(g){var r=g.getBoundingClientRect();this._oTouchScroller.setPosition(r.left+g.clientLeft,r.top+g.clientTop);this._bSkipTouchHandling=false;}}};
b.prototype.onmousewheel=function(e){if(this.$().is(":visible")){var o=e.originalEvent;var w=o.detail?o.detail:o.wheelDelta*(-1)/40;var f=w>0?true:false;if(c(this._$ScrollDomRef[0],e.target)){this._doScroll(a.MouseWheel,f);}else{this._bMouseWheel=true;var p=null;if(this._bStepMode){p=w+this._iOldStep;}else{p=w*this._iFactor+this._iOldScrollPos;}this.setCheckedScrollPosition(p,true);}e.preventDefault();e.stopPropagation();return false;}};
b.prototype.ontouchstart=function(e){var t=e.touches;var f=t[0];if(f&&f.target&&f.target.tagName.match(/input|textarea|select/i)){return;}if(this._oTouchScroller){this._oTouchScroller.doTouchStart(t,e.timeStamp);}if(t.length==1){e.preventDefault();}};
b.prototype.ontouchmove=function(e){if(this._oTouchScroller){this._oTouchScroller.doTouchMove(e.touches,e.timeStamp,e.scale);}};
b.prototype.ontouchend=function(e){if(this._oTouchScroller){this._oTouchScroller.doTouchEnd(e.timeStamp);}};
b.prototype.ontouchcancel=function(e){if(this._oTouchScroller){this._oTouchScroller.doTouchEnd(e.timeStamp);}};
b.prototype.onscroll=function(e){if(this._bSuppressScroll){this._bSuppressScroll=false;e.preventDefault();e.stopPropagation();return false;}var s=null;if(this._$ScrollDomRef){if(this.getVertical()){s=Math.round(this._$ScrollDomRef.scrollTop());}else{s=Math.round(this._$ScrollDomRef.scrollLeft());if(D.browser.firefox&&this._bRTL){s=Math.abs(s);}else if(D.browser.webkit&&this._bRTL){var o=this._$ScrollDomRef.get(0);s=o.scrollWidth-o.clientWidth-o.scrollLeft;}}}var d=s-this._iOldScrollPos;var f=d>0?true:false;if(d<0){d=d*(-1);}var g=a.Drag;if(d==this._iFactor){g=a.Step;}else if(d==this._iFactorPage){g=a.Page;}else if(this._bMouseWheel){g=a.MouseWheel;}if(this._bLargeDataScrolling&&g===a.Drag){this._eAction=g;this._bForward=f;if(D.browser.msie){if(this._scrollTimeout){window.clearTimeout(this._scrollTimeout);}this._scrollTimeout=window.setTimeout(this._onScrollTimeout.bind(this),300);}}else{this._doScroll(g,f);}e.preventDefault();e.stopPropagation();return false;};
b.prototype._onScrollTimeout=function(){this._scrollTimeout=undefined;this._doScroll(this._eAction,this._bForward);this._eAction=undefined;this._bForward=undefined;this._bTouchScroll=undefined;};
b.prototype.onmouseup=function(){if(this._bLargeDataScrolling&&(this._eAction||this._bForward||this._bTouchScroll)&&!D.browser.msie){this._doScroll(this._eAction,this._bForward);this._eAction=undefined;this._bForward=undefined;this._bTouchScroll=undefined;}};
b.prototype.ontouchend=b.prototype.onmouseup;
b.prototype._handleTouchScroll=function(i,t,z){if(this._bSkipTouchHandling){return;}var v=this.getVertical()?t:i;var p;if(this._bStepMode){p=Math.max(Math.round(v/this._iTouchStepTreshold),0);}else{p=Math.round(v);}if(this._iLastTouchScrollerPosition!==p){this._iLastTouchScrollerPosition=p;this.setCheckedScrollPosition(p,true);if(this._bLargeDataScrolling){this._bTouchScroll=true;}else{this.fireScroll();}}};
b.prototype.unbind=function(o){if(o){this._$OwnerDomRef=q(o);if(this.getVertical()){this._$OwnerDomRef.off(D.browser.firefox?"DOMMouseScroll":"mousewheel",this.onmousewheel);}if(E.touchEventMode==="ON"){this._$OwnerDomRef.off(this._getTouchEventType("touchstart"),q.proxy(this.ontouchstart,this));this._$OwnerDomRef.off(this._getTouchEventType("touchmove"),q.proxy(this.ontouchmove,this));this._$OwnerDomRef.off(this._getTouchEventType("touchend"),q.proxy(this.ontouchend,this));this._$OwnerDomRef.off(this._getTouchEventType("touchcancel"),q.proxy(this.ontouchcancel,this));}}};
b.prototype.bind=function(o){if(o){this._$OwnerDomRef=q(o);if(this.getVertical()){this._$OwnerDomRef.on(D.browser.firefox?"DOMMouseScroll":"mousewheel",q.proxy(this.onmousewheel,this));}if(E.touchEventMode==="ON"){this._$OwnerDomRef.on(this._getTouchEventType("touchstart"),q.proxy(this.ontouchstart,this));this._$OwnerDomRef.on(this._getTouchEventType("touchmove"),q.proxy(this.ontouchmove,this));this._$OwnerDomRef.on(this._getTouchEventType("touchend"),q.proxy(this.ontouchend,this));this._$OwnerDomRef.on(this._getTouchEventType("touchcancel"),q.proxy(this.ontouchcancel,this));}}};
b.prototype._getTouchEventType=function(t){return E.touchEventMode==="SIM"?("sap"+t):t;};
b.prototype.pageUp=function(){this._doScroll(a.Page,false);};
b.prototype.pageDown=function(){this._doScroll(a.Page,true);};
b.prototype.setScrollPosition=function(s){if(this._$ScrollDomRef){this.setCheckedScrollPosition(s,true);}else{this.setProperty("scrollPosition",s);}return this;};
b.prototype.setCheckedScrollPosition=function(s,d){var i=Math.max(s,0);if(this._bStepMode===undefined){this._bStepMode=!this.getContentSize();}var e=i;if(this._bStepMode){i=Math.min(i,this.getSteps());e=i*this._iFactor;}i=Math.round(i);this._bSuppressScroll=!d;this.setProperty("scrollPosition",i,true);if(this.getVertical()){this._$ScrollDomRef.scrollTop(e);}else{if(D.browser.firefox&&this._bRTL){this._$ScrollDomRef.scrollLeft(-e);}else if(D.browser.webkit&&this._bRTL){var o=this._$ScrollDomRef.get(0);this._$ScrollDomRef.scrollLeft(o.scrollWidth-o.clientWidth-e);}else{this._$ScrollDomRef.scrollLeft(e);}}if(E.touchEventMode==="ON"){var v=i;if(this._bStepMode){v=Math.round(i*this._iTouchStepTreshold);}this._oTouchScroller.__scrollTop=this.getVertical()?v:0;this._oTouchScroller.__scrollLeft=this.getVertical()?0:v;}};
b.prototype.setContentSize=function(s){this.setProperty("contentSize",s,true);this._bStepMode=false;var $=this.$("sbcnt");if($){if(this.getVertical()){$.height(s);}else{$.width(s);}}return this;};
b.prototype._doScroll=function(A,f){var s=null;if(this._$ScrollDomRef){if(this.getVertical()){s=Math.round(this._$ScrollDomRef.scrollTop());}else{s=Math.round(this._$ScrollDomRef.scrollLeft());if(D.browser.firefox&&this._bRTL){s=Math.abs(s);}else if(D.browser.webkit&&this._bRTL){var o=this._$ScrollDomRef.get(0);s=o.scrollWidth-o.clientWidth-o.scrollLeft;}}}if(this._bStepMode){var i=Math.round(s/this._iFactor);var O=this._iOldStep;if(O!==i){this.setCheckedScrollPosition(i,false);L.debug("-----STEPMODE-----: New Step: "+i+" --- Old Step: "+O+" --- Scroll Pos in px: "+s+" --- Action: "+A+" --- Direction is forward: "+f);this.fireScroll({action:A,forward:f,newScrollPos:i,oldScrollPos:O});this._iOldStep=i;}}else{s=Math.round(s);this.setProperty("scrollPosition",s,true);L.debug("-----PIXELMODE-----: New ScrollPos: "+s+" --- Old ScrollPos: "+this._iOldScrollPos+" --- Action: "+A+" --- Direction is forward: "+f);this.fireScroll({action:A,forward:f,newScrollPos:s,oldScrollPos:this._iOldScrollPos});}if(Math.round(this._iFactor)==this._iFactor||!D.browser.msie){this._bSuppressScroll=false;}this._iOldScrollPos=s;this._bMouseWheel=false;I.notifyScrollEvent({type:A});};
b.prototype.onThemeChanged=function(){this.rerender();};
b.prototype.getNativeScrollPosition=function(){if(this._$ScrollDomRef){if(this.getVertical()){return Math.round(this._$ScrollDomRef.scrollTop());}else{return Math.round(this._$ScrollDomRef.scrollLeft());}}return 0;};
b.prototype.setNativeScrollPosition=function(n){var s=Math.round(n);if(this._$ScrollDomRef){if(this.getVertical()){this._$ScrollDomRef.scrollTop(s);}else{this._$ScrollDomRef.scrollLeft(s);}}};
return b;});
sap.ui.predefine('sap/ui/core/ScrollBarRenderer',['sap/ui/Device',"sap/ui/dom/getScrollbarSize"],function(D,g){"use strict";var S={apiVersion:2};
S.render=function(r,s){var R=sap.ui.getCore().getConfiguration().getRTL();r.openStart("div",s);r.class("sapUiScrollBar");var a;if(D.support.touch){a="sapUiScrollBarTouch";r.class(a);}var v=s.getVertical();var b=s.getSize();var c=s.getContentSize();var B=g(a);var w=B.width;var h=B.height;if(D.browser.edge){if(!w){w="15";}if(!h){h="15";}}if(v){r.style("overflow","hidden");r.style("width",w+"px");r.style("height",b);r.openEnd();r.openStart("div",s.getId()+"-sb");r.style("width",(w*2)+"px");r.style("height","100%");r.style("overflow-y","scroll");r.style("overflow-x","hidden");if(R){r.style("margin-right","-"+w+"px");}else{r.style("margin-left","-"+w+"px");}r.openEnd();r.openStart("div",s.getId()+"-sbcnt");r.style("width",w+"px");r.style("height",c);r.openEnd();r.close("div");r.close("div");r.openStart("div");r.openEnd();r.openStart("span",s.getId()+"-ffsize");r.style("position","absolute");r.style("top","-9000px");r.style("left","-9000px");r.style("visibility","hidden");r.style("line-height","normal");r.openEnd();r.text("FF Size");r.close("span");r.close("div");}else{r.style("overflow","hidden");r.style("height",h+"px");r.style("width",b);r.openEnd();r.openStart("div",s.getId()+"-sb");r.style("height",(h*2)+"px");r.style("margin-top","-"+h+"px");r.style("overflow-x","scroll");r.style("overflow-y","hidden");r.openEnd();r.openStart("div",s.getId()+"-sbcnt");r.style("height",h+"px");r.style("width",c);r.openEnd();r.close("div");r.close("div");}r.close("div");};
return S;},true);
sap.ui.predefine('sap/ui/core/SeparatorItem',['./Item','./library'],function(I,l){"use strict";
var S=I.extend("sap.ui.core.SeparatorItem",{metadata:{library:"sap.ui.core"}});
return S;});
sap.ui.predefine('sap/ui/core/Shortcut',["sap/ui/core/util/ShortcutHelper",'sap/base/assert','sap/ui/dom/jquery/control'],function(S,a,q){"use strict";var b={register:function(s,v,c){if(!s){throw new Error("Shortcut.register: oScopeControl must be given.");}if(typeof c!=="function"){throw new Error("Shortcut.register: a function fnCallback must be given.");}var n=S.getNormalizedShortcutSpec(v);S.validateKeyCombination(n);var e=S.findShortcut(s,n);if(e){throw new Error("Same shortcut is already registered on this element");}function w(){var f=document.activeElement,o=document.createElement("span"),g=sap.ui.getCore().getStaticAreaRef();o.setAttribute("tabindex",0);o.setAttribute("id","sap-ui-shortcut-focus");o.style.position="absolute";o.style.top="50%";o.style.bottom="50%";o.style.left="50%";o.style.right="50%";g.appendChild(o);o.focus();f.focus();g.removeChild(o);c.apply(null,arguments);}var d={};d["onkeydown"]=S.handleKeydown.bind(null,n,v,w);s.addEventDelegate(d);var D=s.data("sap.ui.core.Shortcut");if(!D){D=[];s.data("sap.ui.core.Shortcut",D);}D.push({shortcutSpec:n,platformIndependentShortcutString:S.getNormalizedShortcutString(n),delegate:d});},isRegistered:function(s,v){a(s,"Shortcut.isRegistered: oScopeControl must be given.");var n=S.getNormalizedShortcutSpec(v);return!!S.findShortcut(s,n);},unregister:function(s,v){a(s,"Shortcut.unregister: oScopeControl must be given.");var n=S.getNormalizedShortcutSpec(v);var o=S.findShortcut(s,n);if(o){s.removeEventDelegate(o.delegate);var d=s.data("sap.ui.core.Shortcut");var i=d.indexOf(o);d.splice(i,1);return true;}return false;}};return b;});
sap.ui.predefine('sap/ui/core/ShortcutHint',["sap/base/Log","sap/ui/core/Core","sap/ui/core/CommandExecution"],function(L,C,a){"use strict";var S=function(c,o){this.oControl=c;this.oConfig=o;};
S.prototype._getShortcutText=function(){var t;if(this.oConfig.commandName){t=this._getShortcutHintFromCommandExecution(this.oControl,this.oConfig.commandName);}else if(this.oConfig.message){t=this.oConfig.message;}else if(this.oConfig.messageBundleKey){t=this._getShortcutHintFromMessageBundle(this.oControl,this.oConfig.messageBundleKey);}return t;};
S.prototype._getShortcutHintFromCommandExecution=function(c,s){try{return a.find(c,s)._getCommandInfo().shortcut;}catch(e){L.error("Error on retrieving command shortcut. Command "+s+" was not found!");return;}};
S.prototype._getShortcutHintFromMessageBundle=function(c,m){var r=C.getLibraryResourceBundle(c.getMetadata().getLibraryName());return r.getText(m);};
return S;});
sap.ui.predefine('sap/ui/core/ShortcutHintsMixin',["sap/ui/base/EventProvider","./Element","./ShortcutHint","./Popup","./InvisibleText","sap/ui/dom/containsOrEquals","sap/ui/events/checkMouseEnterOrLeave"],function(E,a,S,P,I,c,b){"use strict";var d=function(C){this.sControlId=C.getId();this._hintConfigs=[];};
d.init=function(C){C._shortcutHintsMixin=new d(C);};
d.addConfig=function(C,o,i){var m=C._shortcutHintsMixin;if(!m){d.init(C);m=C._shortcutHintsMixin;}m._hintConfigs.push(o);m.initHint(o,i);};
d.hideAll=function(){var C;for(var s in h.mControls){C=a.registry.get(s);if(C){C._shortcutHintsMixin.hideShortcutHint();}}};
d.isDOMIDRegistered=function(D){return h.mDOMNodes[D]&&!!h.mDOMNodes[D].length;};
d.isControlRegistered=function(C){return!!h.mControls[C];};
d.prototype._attachToEvents=function(){var C;if(!d.isControlRegistered(this.sControlId)){C=a.registry.get(this.sControlId);C.addEventDelegate(H,this);}};
d.prototype.register=function(D,C,o){this._attachToEvents();h.mControls[this.sControlId]=true;if(!h.mDOMNodes[D]){h.mDOMNodes[D]=[];}h.mDOMNodes[D].push(new S(o,C));};
d.prototype.initHint=function(C,o){var i=this._getShortcutHintInfo(C);if(i.message){this.register(i.id,{message:i.message},o);}else if(i.messageBundleKey){this.register(i.id,{messageBundleKey:i.messageBundleKey},o);}else if(i.event){var j=E.getEventList(o)[i.event],A=[];if(j){A=j.reduce(function(r,l){if(l.fFunction&&l.fFunction._sapui_commandName){r.push(l.fFunction._sapui_commandName);}return r;},[]);}if(A.length){this.register(i.id,{commandName:A[0]},o);}else{o.attachEvent("EventHandlerChange",function(k){var F=k.getParameter("func");if(k.getParameter("type")==="listenerAttached"&&F&&F._sapui_commandName&&k.getParameter("EventId")===i.event){this.register(i.id,{commandName:F._sapui_commandName},o);}},this);}}};
d.prototype._getShortcutHintInfos=function(){return this._hintConfigs.map(this._getShortcutHintInfo,this);};
d.prototype._getShortcutHintInfo=function(o){var i;if(o.domrefid){i=o.domrefid;}else if(o.domrefid_suffix){i=this.sControlId+o.domrefid_suffix;}else{i=this.sControlId;}return{id:i,event:o.event,position:o.position,messageBundleKey:o.messageBundleKey,message:o.message,addAccessibilityLabel:o.addAccessibilityLabel};};
d.prototype.getRegisteredShortcutInfos=function(){return this._getShortcutHintInfos().filter(function(i){return d.isDOMIDRegistered(i.id);},this);};
d.prototype.showShortcutHint=function(o){var t,p=o[0].position||"0 8",m=P.Dock.CenterTop,O=P.Dock.CenterBottom,i=e(),s=o[0].ref,j=_(o[0].id),T;T=this._getControlTooltips();if(T[o[0].id]){j=T[o[0].id].tooltip+" ("+j+")";}if(!i){i=f(j);}i.oContent.children[0].textContent=j;if(!i.isOpen()){i.open(1000,m,O,s,p,"flipfit",function(k){i.oContent.style.visibility="hidden";if(t){clearTimeout(t);}t=setTimeout(function(){i.oContent.style.visibility="visible";},1000);i._applyPosition(i._oLastPosition);});}};
d.prototype.hideShortcutHint=function(){var p=e();if(p&&p.isOpen()){p.close();}};
d.prototype._findShortcutOptionsForRef=function(j){var o,k=this.getRegisteredShortcutInfos(),i,r=[];for(i=0;i<k.length;i++){o=k[i];o.ref=document.getElementById(o.id);if(c(o.ref,j)){r.push(o);}}return r;};
d.prototype._getControlTooltips=function(){var i=this.getRegisteredShortcutInfos(),C=a.registry.get(this.sControlId);return i.reduce(function(r,o){var t=C._getTitleAttribute&&C._getTitleAttribute(o.id);if(!t){t=C.getTooltip();}if(t){r[o.id]={tooltip:t};}return r;},{});};
d.prototype._updateShortcutHintAccLabel=function(o){var i,s,C;if(!o.addAccessibilityLabel){return;}i=g();s=i.getId();i.setText(_(o.id));C=a.registry.get(this.sControlId);if(i.getText()){if(C.getAriaDescribedBy().indexOf(s)===-1){C.addAriaDescribedBy(s);}}else{C.removeAriaDescribedBy(s);}};
var h=Object.create(null);h.mControls={};h.mDOMNodes={};var H={"onfocusin":function(o){var s=this._findShortcutOptionsForRef(o.target);if(!s.length){return;}d.hideAll();this._updateShortcutHintAccLabel(s[0]);this.showShortcutHint(s);},"onfocusout":function(o){var s=this._findShortcutOptionsForRef(o.target);if(!s.length){return;}this.hideShortcutHint();},"onmouseover":function(o){var s=this._findShortcutOptionsForRef(o.target);if(!s.length){return;}if(b(o,s[0].ref)){d.hideAll();this.showShortcutHint(s);}},"onmouseout":function(o){var s=this._findShortcutOptionsForRef(o.target);if(!s.length){return;}if(b(o,s[0].ref)){if(c(s[0].ref,document.activeElement)){return;}this.hideShortcutHint();}},"onAfterRendering":function(){var j=this.getRegisteredShortcutInfos(),o,D;for(var i=0;i<j.length;i++){D=j[i].id;o=document.getElementById(D);o.setAttribute("aria-keyshortcuts",_(D));}}};
function _(D){var i=h.mDOMNodes[D];if(!i||!i.length){return;}return i.map(function(o){return o._getShortcutText();}).join(", ");}
function g(){if(!d._invisibleText){d._invisibleText=new I();d._invisibleText.toStatic();}return d._invisibleText;}
function e(){return d._popup;}
function f(t){var p,C,T;C=document.createElement("span");C.classList.add("sapUiHintContainer");T=document.createElement("div");T.classList.add("sapUiHintText");T.textContent=t;C.appendChild(T);p=new P(C,false,false,false);p.setAnimations(function($,D,i){setTimeout(i,D);},function($,D,i){i();});d._popup=p;return p;}
return d;});
sap.ui.predefine('sap/ui/core/StashedControlSupport',['sap/ui/core/Element',"sap/base/Log","sap/base/assert"],function(E,L,a){"use strict";var S={},s={},b=E.extend("sap.ui.core._StashedControl",{constructor:function(i,c){E.apply(this,arguments);c.stashed=true;Object.assign(this,c);this._stash(c.sParentId,c.sParentAggregationName);return this;},metadata:{specialSettings:{stashed:{type:'boolean',visibility:'hidden'},sParentId:{type:'string',visibility:'hidden'},sParentAggregationName:{type:'string',visibility:'hidden'},fnCreate:{type:'function',visibility:'hidden'}}}});
b.prototype.setParent=function(){L.error("Cannot set parent on a StashedControl",this.getId());};
b.prototype.clone=function(){L.error("Cannot clone a StashedControl",this.getId());};
b.prototype.destroy=function(){delete s[this.getId()];E.prototype.destroy.apply(this,arguments);};
m(b,true);
S.mixInto=function(c,d){a(!c.getMetadata().hasProperty("stashed"),"StashedControlSupport: fnClass already has property 'stashed', sideeffects possible",c.getMetadata().getName());a(!c.prototype.setStashed,"StashedControlSupport: fnClass already has method 'setStashed', sideeffects possible",c.getMetadata().getName());m(c,d);};
function m(c,d){c.getMetadata().addSpecialSetting("stashed",{type:"boolean",defaultValue:!!d});c.prototype.setStashed=function(e){if(this.stashed===true&&!e){if(this.sParentId){var C=u(this,sap.ui.getCore().byId(this.sParentId));C.stashed=false;return;}}else if(e){L.warning("Cannot re-stash a control",this.getId());}};c.prototype.getStashed=function(){return this.stashed;};var D=c.prototype.destroy;c.prototype.destroy=function(){delete s[this.getId()];D.apply(this,arguments);};c.prototype._stash=function(p,P){this.sParentId=p;this.sParentAggregationName=P;s[this.getId()]=this;};}
function u(C,p){if(C instanceof b){var d,e,o,f=C.fnCreate,P=C.sParentAggregationName;C.destroy();e=sap.ui.require("sap/ui/core/Component");o=e&&e.getOwnerComponentFor(p);if(o){d=o.runAsOwner(f);}else{d=f();}d.forEach(function(c){p.getMetadata().getAggregation(P).add(p,c);});}delete s[C.getId()];return C;}
function g(A,p){var c=[];for(var i in s){var I=A?s[i]:s[i].getId();if(!p||s[i].sParentId===p){c.push(I);}}return c;}
S.getStashedControlIds=function(p){return g(false,p);};
S.getStashedControls=function(p){return g(true,p);};
S.createStashedControl=function(i,c){if(!c.sParentId){L.error("Cannot create a StashedControl without a parent with stable ID.","sap.ui.core.StashedControlSupport");}else{return new b(i,c);}};
return S;});
sap.ui.predefine('sap/ui/core/Title',['./Element','./library'],function(E,l){"use strict";var T=l.TitleLevel;
var a=E.extend("sap.ui.core.Title",{metadata:{library:"sap.ui.core",properties:{text:{type:"string",group:"Appearance",defaultValue:null},icon:{type:"sap.ui.core.URI",group:"Appearance",defaultValue:null},level:{type:"sap.ui.core.TitleLevel",group:"Appearance",defaultValue:T.Auto},emphasized:{type:"boolean",group:"Appearance",defaultValue:false}}}});
return a;});
sap.ui.predefine('sap/ui/core/TooltipBase',['./Control','./Popup','./library',"sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control"],function(C,P,l,K,q){"use strict";var O=l.OpenState;
var T=C.extend("sap.ui.core.TooltipBase",{
metadata:{"abstract":true,library:"sap.ui.core",properties:{text:{type:"string",group:"Misc",defaultValue:""},openDuration:{type:"int",group:"Behavior",defaultValue:200},closeDuration:{type:"int",group:"Behavior",defaultValue:200},myPosition:{type:"sap.ui.core.Dock",group:"Behavior",defaultValue:'begin top'},atPosition:{type:"sap.ui.core.Dock",group:"Behavior",defaultValue:'begin bottom'},offset:{type:"string",group:"Behavior",defaultValue:'10 3'},collision:{type:"sap.ui.core.Collision",group:"Behavior",defaultValue:'flip'},openDelay:{type:"int",group:"Misc",defaultValue:500},closeDelay:{type:"int",group:"Misc",defaultValue:100}},events:{closed:{}}},
renderer:null
});
T.prototype._getPopup=function(){var p=new P();p.setShadow(true);T.prototype._getPopup=function(){return p;};return p;};
T.prototype.onfocusin=function(e){var s=q(e.target).control(0);if(s!=null){var d=s.getFocusDomRef();this.sStoredTooltip=null;if(d.title&&d.title!=""){this.sStoredTooltip=d.title;d.title="";}var p=this._getPopup();if(!(p.isOpen()&&p.getContent()==this)){sap.ui.getCore().getRenderManager().render(this,sap.ui.getCore().getStaticAreaRef(),true);}var v=d.getAttribute("aria-describedby");var i=this.getId()+"-title "+this.getId()+"-txt";if(v==null||v==""){d.setAttribute("aria-describedby",i);}else if(v.indexOf(i)==-1){d.setAttribute("aria-describedby",v+" "+i);}}};
T.prototype.onfocusout=function(e){var s=q(e.target).control(0);if(s!=null){var d=s.getFocusDomRef();if(this.sStoredTooltip){d.title=this.sStoredTooltip;}var v=d.getAttribute("aria-describedby");var i=this.getId()+"-title "+this.getId()+"-txt";if(v&&v.indexOf(i)>=0){if(v.trim()==i){d.removeAttribute("aria-describedby");}else{v=v.replace(i,"");d.setAttribute("aria-describedby",v);}}}if(T.sOpenTimeout){clearTimeout(T.sOpenTimeout);T.sOpenTimeout=undefined;}this.sCloseNowTimeout=setTimeout(this["closePopup"].bind(this),this.getCloseDelay());};
T.prototype.isStandardTooltip=function(t){return typeof t==="string"&&!!t.trim();};
T.prototype.onmouseover=function(e){var E=q(e.target).control(0),c=q(e.currentTarget).control(0),L=q(e.relatedTarget).control(0);if(!E){return;}if(E===this){if(this.sCloseNowTimeout){clearTimeout(this.sCloseNowTimeout);this.sCloseNowTimeout=null;}e.stopPropagation();e.preventDefault();return;}if(c===E||!this.isStandardTooltip(E.getTooltip())){if(this.sCloseNowTimeout){clearTimeout(this.sCloseNowTimeout);this.sCloseNowTimeout=null;e.stopPropagation();e.preventDefault();}}if(L){if(L.getParent()){if(L.getParent()===c&&c===E){var o=L.getTooltip();if(!this.isStandardTooltip(o)&&(!o||!(o instanceof T))){if(this.sCloseNowTimeout){clearTimeout(this.sCloseNowTimeout);this.sCloseNowTimeout=null;e.stopPropagation();e.preventDefault();}}}}}if(this._currentControl===E||!this.isStandardTooltip(E.getTooltip())){this.removeStandardTooltips();if(T.sOpenTimeout){clearTimeout(T.sOpenTimeout);}T.sOpenTimeout=setTimeout(this["openPopup"].bind(this,this._currentControl),this.getOpenDelay());e.stopPropagation();e.preventDefault();}};
T.prototype.onmouseout=function(e){if(T.sOpenTimeout){clearTimeout(T.sOpenTimeout);T.sOpenTimeout=undefined;}if(!this.sCloseNowTimeout){this.sCloseNowTimeout=setTimeout(this["closePopup"].bind(this),this.getCloseDelay());}this.restoreStandardTooltips();e.stopPropagation();e.preventDefault();};
T.prototype.closePopup=function(){var p=this._getPopup();if(this.sCloseNowTimeout){clearTimeout(this.sCloseNowTimeout);}this.sCloseNowTimeout=undefined;p.attachClosed(this.handleClosed,this);p.close();this.restoreStandardTooltips();};
T.prototype.handleClosed=function(){this._getPopup().detachClosed(this.handleClosed,this);this.fireClosed();};
T.prototype.openPopup=function(s){if(!this.getVisible()){return;}if(s.getTooltip()!=null){if(this.sCloseNowTimeout){clearTimeout(this.sCloseNowTimeout);this.sCloseNowTimeout=null;return;}var p=this._getPopup();if(p.isOpen()&&p.getContent()==this){return;}sap.ui.getCore().getRenderManager().render(this,sap.ui.getCore().getStaticAreaRef(),true);var d=s.getDomRef();p.setContent(this);p.setPosition(this.getMyPosition(),this.getAtPosition(),d,this.getOffset(),this.getCollision());p.setDurations(this.getOpenDuration(),this.getCloseDuration());p.open();this.removeStandardTooltips();}};
T.prototype.removeStandardTooltips=function(){var d=this._currentControl.getDomRef();if(!this.aStoredTooltips){this.aStoredTooltips=[];}else{return;}var t="";while(d&&!(d===document)){t=d.title;if(t){this.aStoredTooltips.push({domref:d,tooltip:t});d.title="";}d=d.parentNode;}if(this._currentControl.getTooltipDomRefs){var D=this._currentControl.getTooltipDomRefs();for(var i=0;i<D.length;i++){d=D[i];if(d){t=d.title;if(t){this.aStoredTooltips.push({domref:d,tooltip:t});d.title="";}}}}};
T.prototype.restoreStandardTooltips=function(){var p=this._getPopup();var e=p.getOpenState();if(e===O.OPEN||e===O.OPENING){return;}if(T.sOpenTimeout){return;}if(this.aStoredTooltips){for(var i=0;i<this.aStoredTooltips.length;i++){var d=this.aStoredTooltips[i].domref;d.title=this.aStoredTooltips[i].tooltip;}}this.aStoredTooltips=null;};
T.prototype._setParent=T.prototype.setParent;
T.prototype.setParent=function(p,a){var _=this._getPopup();if(_&&_.isOpen()){this.closePopup();}this._setParent.apply(this,arguments);};
T.prototype.onkeydown=function(e){if(e.ctrlKey&&e.which==K.I){var E=q(e.target).control(0);if(E!=null){if(this._currentControl===E||!this.isStandardTooltip(E.getTooltip())){this.removeStandardTooltips();this.openPopup(this._currentControl);e.preventDefault();e.stopPropagation();}}}else if(e.which==K.ESCAPE){if(T.sOpenTimeout){clearTimeout(T.sOpenTimeout);T.sOpenTimeout=undefined;}var w=this.oPopup&&this.oPopup.isOpen();this.closePopup();if(w){e.preventDefault();e.stopPropagation();}}};
T.prototype._closeOrPreventOpen=function(){var p=this._getPopup();if(p.isOpen()){this.closePopup();}else if(T.sOpenTimeout){clearTimeout(T.sOpenTimeout);T.sOpenTimeout=undefined;}};
return T;});
sap.ui.predefine('sap/ui/core/UIComponent',['../base/ManagedObject','./Component','./library','./UIComponentMetadata','./mvc/Controller','./mvc/View',"sap/base/util/ObjectPath","sap/base/Log"],function(M,C,l,U,a,V,O,L){"use strict";var b=l.mvc.ViewType;
var c=C.extend("sap.ui.core.UIComponent",{
constructor:function(i,s){var d=false;try{if(typeof i!=="string"){s=i;i=undefined;}if(s&&s.hasOwnProperty("_routerHashChanger")){this._oRouterHashChanger=s._routerHashChanger;delete s._routerHashChanger;}if(s&&s.hasOwnProperty("_propagateTitle")){this._bRoutingPropagateTitle=s._propagateTitle;delete s._propagateTitle;}C.apply(this,arguments);d=true;}finally{if(!d){this._destroyCreatedInstances();}}},
metadata:{"abstract":true,rootView:null,publicMethods:["render"],aggregations:{"rootControl":{type:"sap.ui.core.Control",multiple:false,visibility:"hidden"}},designtime:"sap/ui/core/designtime/UIComponent.designtime",routing:{}}
},U);
c._fnOnInstanceInitialized=null;c._fnOnInstanceDestroy=null;
c.prototype.init=function(){var t=this;var p={};if(this.getAutoPrefixId()){p.id=function(i){return t.createId(i);};}var r=this._getManifestEntry("/sap.ui5/routing",true)||{},R=r.config||{},v=r.routes;if(v){var d=sap.ui.requireSync("sap/ui/core/routing/Router");var f=g(this._getRouterClassName()||d);this._oRouter=new f(v,R,this,r.targets,this._oRouterHashChanger);this._oTargets=this._oRouter.getTargets();this._oViews=this._oRouter.getViews();}else if(r.targets){var T=sap.ui.requireSync("sap/ui/core/routing/Targets");var e=sap.ui.requireSync("sap/ui/core/routing/Views");this._oViews=new e({component:this});var h=g(R.targetsClass||T);this._oTargets=new h({targets:r.targets,config:R,views:this._oViews});}this.runAsOwner(function(){M.runWithPreprocessors(function(){t.setAggregation("rootControl",t.createContent());},p);});var o=this.getRootControl();if(o instanceof V){if(R.targetParent===undefined){R.targetParent=o.getId();}if(this._oTargets){this._oTargets._setRootViewId(o.getId());}}if(typeof c._fnOnInstanceInitialized==="function"){c._fnOnInstanceInitialized(this);}};
function g(r){var f;if(typeof r==="string"){f=O.get(r);if(!f){L.error("The specified class for router or targets '"+r+"' is undefined.",this);}}else{f=r;}return f;}
c.prototype.destroy=function(){if(typeof c._fnOnInstanceDestroy==="function"){c._fnOnInstanceDestroy(this);}this._destroyCreatedInstances();C.prototype.destroy.apply(this,arguments);};
c.prototype._destroyCreatedInstances=function(){if(this._oRouter){this._oRouter.destroy();delete this._oRouter;}else{if(this._oTargets){this._oTargets.destroy();this._oTargets=null;}if(this._oViews){this._oViews.destroy();this._oViews=null;}}};
c.getRouterFor=function(o){var v=o;if(v instanceof a){v=v.getView();}if(v instanceof V){var d=C.getOwnerComponentFor(v);if(d){return d.getRouter();}else{return undefined;}}};
c.prototype.getRouter=function(){return this._oRouter;};
c.prototype.getTargets=function(){return this._oTargets;};
c.prototype.getAutoPrefixId=function(){return!!this.getManifestObject().getEntry("/sap.ui5/autoPrefixId");};
c.prototype.byId=function(i){return sap.ui.getCore().byId(this.createId(i));};
c.prototype.createId=function(i){if(!this.isPrefixedId(i)){i=this.getId()+"---"+i;}return i;};
c.prototype.getLocalId=function(i){var p=this.getId()+"---";return(i&&i.indexOf(p)===0)?i.slice(p.length):null;};
c.prototype.isPrefixedId=function(i){return!!(i&&i.indexOf(this.getId()+"---")===0);};
c.prototype.createContent=function(){var r=this._getManifestEntry("/sap.ui5/rootView",true);if(r&&typeof r==="string"){return V._legacyCreate({viewName:r,type:b.XML});}else if(r&&typeof r==="object"){if(r.id){r.id=this.createId(r.id);}if(r.async&&r.type===b.XML){r.processingMode="sequential";}return V._legacyCreate(r);}else if(r){throw new Error("Configuration option 'rootView' of component '"+this.getMetadata().getName()+"' is invalid! 'rootView' must be type of string or object!");}return null;};
c.prototype.getRootControl=function(){return this.getAggregation("rootControl");};
c.prototype.render=function(r){var o=this.getRootControl();if(o&&r){r.renderControl(o);}};
c.prototype.getUIArea=function(){return(this.oContainer?this.oContainer.getUIArea():null);};
c.prototype.getEventingParent=function(){return this.getUIArea();};
c.prototype.setContainer=function(o){this.oContainer=o;if(o){this._applyContextualSettings(o._getContextualSettings());}else{this._oContextualSettings=M._defaultContextualSettings;if(!this._bIsBeingDestroyed){setTimeout(function(){if(!this.oContainer){this._propagateContextualSettings();}}.bind(this),0);}}return this;};
c.prototype.onBeforeRendering=function(){};
c.prototype.onAfterRendering=function(){};
c.prototype._getRouterClassName=function(){var r=this._getManifestEntry("/sap.ui5/routing",true)||{},R=r.config||{};return R.routerClass;};
return c;});
sap.ui.predefine('sap/ui/core/UIComponentMetadata',['./ComponentMetadata','./library'],function(C,l){"use strict";var V=l.mvc.ViewType;var U=function(c,o){C.apply(this,arguments);};U.prototype=Object.create(C.prototype);U.prototype.constructor=U;
U.preprocessClassInfo=function(c){if(c&&typeof c.metadata==="string"){c.metadata={_src:c.metadata};}return c;};
U.prototype.getRootView=function(d){return this.getManifestEntry("/sap.ui5/rootView",!d);};
U.prototype.getRoutingConfig=function(d){return this.getManifestEntry("/sap.ui5/routing/config",!d);};
U.prototype.getRoutes=function(d){return this.getManifestEntry("/sap.ui5/routing/routes",!d);};
U.prototype._convertLegacyMetadata=function(s,m){C.prototype._convertLegacyMetadata.call(this,s,m);var u=m["sap.ui5"];var r=u["rootView"]||s["rootView"];if(r){u["rootView"]=r;}var R=u["routing"]||s["routing"];if(R){u["routing"]=R;}if(u["rootView"]&&typeof u["rootView"]==="string"){u["rootView"]={viewName:u["rootView"],type:V.XML};}};
return U;},true);
sap.ui.predefine('sap/ui/core/ValueStateSupport',['./Element','./library',"sap/base/assert"],function(E,l,a){"use strict";var V=l.ValueState;var b={};var t=null;var e=function(){if(!t){t={};var r=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core");t[V.Error]=r.getText("VALUE_STATE_ERROR");t[V.Warning]=r.getText("VALUE_STATE_WARNING");t[V.Success]=r.getText("VALUE_STATE_SUCCESS");t[V.Information]=r.getText("VALUE_STATE_INFORMATION");}};
b.enrichTooltip=function(o,T){a(o instanceof E,"oElement must be an Element");if(!T&&o.getTooltip()){return undefined;}var s=b.getAdditionalText(o);if(s){return(T?T+" - ":"")+s;}return T;};
b.getAdditionalText=function(v){var s=null;if(v&&v.getValueState){s=v.getValueState();}else if(V[v]){s=v;}if(s&&(s!=V.None)){e();return t[s];}return null;};
b.formatValueState=function(s){switch(s){case 1:return V.Warning;case 2:return V.Success;case 3:return V.Error;case 4:return V.Information;default:return V.None;}};
return b;},true);
sap.ui.predefine('sap/ui/core/VariantLayoutData',['./LayoutData','./library'],function(L,l){"use strict";
var V=L.extend("sap.ui.core.VariantLayoutData",{metadata:{library:"sap.ui.core",aggregations:{multipleLayoutData:{type:"sap.ui.core.LayoutData",multiple:true,singularName:"multipleLayoutData"}}}});
return V;});
sap.ui.predefine('sap/ui/core/XMLComposite',['sap/ui/core/Control','sap/ui/core/XMLCompositeMetadata','sap/ui/model/base/ManagedObjectModel','sap/ui/model/json/JSONModel','sap/ui/core/Fragment','sap/ui/base/ManagedObject','sap/ui/base/DataType','sap/ui/model/resource/ResourceModel','sap/base/Log','sap/ui/performance/Measurement'],function(C,X,M,J,F,a,D,R,L,b){"use strict";var x="sap.ui.core.XMLComposite";
var c=C.extend("sap.ui.core.XMLComposite",{
metadata:{interfaces:["sap.ui.core.IDScope"],properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%',invalidate:true},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null,invalidate:true},displayBlock:{type:"boolean",group:"Appearance",defaultValue:true,invalidate:true}},aggregations:{_content:{type:"sap.ui.core.Control",multiple:false,visibility:"hidden",invalidate:true}}},
constructor:function(){this._bIsCreating=true;C.apply(this,arguments);delete this._bIsCreating;},
renderer:{apiVersion:2,render:function(r,o){L.debug("Start rendering '"+o.sId,x);b.start(o.getId()+"---renderControl","Rendering of "+o.getMetadata().getName(),["rendering","control"]);r.openStart("div",o);r.accessibilityState(o);if(!o.getDisplayBlock()&&(o.getWidth()!=="100%"||o.getHeight()!=="100%")){r.style("display","inline-block");}r.style("height",o.getHeight());r.style("width",o.getWidth());r.openEnd();var d=o._renderingContent?o._renderingContent():o._getCompositeAggregation();if(d){r.renderControl(d);}r.close("div");b.end(o.getId()+"---renderControl");L.debug("Stop rendering '"+o.sId,x);}}
},X);
c.prototype.byId=function(i){return sap.ui.getCore().byId(F.createId(this.getId(),i));};
c.prototype._getManagedObjectModel=function(){if(!this._oManagedObjectModel){this._oManagedObjectModel=new M(this);}return this._oManagedObjectModel;};
c.prototype.getSuppressInvalidateAggregation=function(n,s){var m=this.getMetadata(),A=m.getAggregation(n)||m.getAllPrivateAggregations()[n];if(!A){return true;}s=m._suppressInvalidate(A,s);return s;};
c.prototype.setProperty=function(n,v,s){var m=this.getMetadata(),p=m.getManagedProperty(n);if(!p){return this;}s=m._suppressInvalidate(p,s);return C.prototype.setProperty.apply(this,[n,v,s]);};
c.prototype.setAggregation=function(n,o,s){return C.prototype.setAggregation.apply(this,[n,o,this.getSuppressInvalidateAggregation(n,s)]);};
c.prototype.addAggregation=function(n,o,s){return C.prototype.addAggregation.apply(this,[n,o,this.getSuppressInvalidateAggregation(n,s)]);};
c.prototype.insertAggregation=function(n,o,i,s){return C.prototype.insertAggregation.apply(this,[n,o,i,this.getSuppressInvalidateAggregation(n,s)]);};
c.prototype.removeAggregation=function(n,o,s){return C.prototype.removeAggregation.apply(this,[n,o,this.getSuppressInvalidateAggregation(n,s)]);};
c.prototype.removeAllAggregation=function(n,s){return C.prototype.removeAllAggregation.apply(this,[n,this.getSuppressInvalidateAggregation(n,s)]);};
c.prototype.destroyAggregation=function(n,s){return C.prototype.destroyAggregation.apply(this,[n,this.getSuppressInvalidateAggregation(n,s)]);};
c.prototype.updateAggregation=function(n,s){var A=this.getMetadata().getAggregation(n);if(A&&A.type==="TemplateMetadataContext"){this.invalidate();return;}C.prototype.updateAggregation.apply(this,arguments);};
c.prototype.setVisible=function(v){this.setProperty("visible",v);if(this.getParent()){this.getParent().invalidate();}return this;};
c.prototype._destroyCompositeAggregation=function(){var o=this._getCompositeAggregation();if(o){o.destroy("KeepDom");}return this;};
c.prototype.updateBindings=function(){if(this._bIsCreating){return;}var r=C.prototype.updateBindings.apply(this,arguments);for(var n in this.mBindingInfos){var A=this.getMetadata().getAggregation(n);if(A&&A.multiple&&!A._doesNotRequireFactory&&this.isBound(n)&&!this.getBinding(n)){this[A._sDestructor]();}}return r;};
c.prototype._getCompositeAggregation=function(){var s=this.getMetadata().getCompositeAggregationName();return this.getAggregation(s);};
c.prototype._setCompositeAggregation=function(n){var s=this.getMetadata().getCompositeAggregationName();this._destroyCompositeAggregation();if(!this._oManagedObjectModel){this._getManagedObjectModel();}if(Array.isArray(n)){this.setAggregation(s,null);return;}if(n){if(!n.enhanceAccessibilityState){n.enhanceAccessibilityState=function(e,A){this.enhanceAccessibilityState(e,A);}.bind(this);}n.bindObject("$"+this.alias+">/");n.setModel(this._oManagedObjectModel,"$"+this.alias);if(this.bUsesI18n){var r=this._getResourceModel();if(r){n.setModel(r,"$"+this.alias+".i18n");}}}this.setAggregation(s,n);};
c.mResourceModels={};
c.getLibraryResourceModel=function(l){var o=c.mResourceModels[l];if(!o){o=new R({bundleName:l+".messagebundle",async:true});c.mResourceModels[l]=o;}return o;};
c.prototype._getResourceModel=function(){if(this.resourceModel){return this.resourceModel;}if(this.messageBundle){this.resourceModel=new R({bundleName:this.messageBundle,async:true});return this.resourceModel;}else{this.sLibraryName=this.sLibraryName||this.getMetadata().getLibraryName();if(this.sLibraryName){return c.getLibraryResourceModel(this.sLibraryName);}}};
c.prototype.getResourceBundle=function(){var r=this._getResourceModel();return r?r.getResourceBundle():null;};
c.prototype.destroy=function(){C.prototype.destroy.apply(this,arguments);if(this.resourceModel){this.resourceModel.destroy();}if(this._oManagedObjectModel){this._oManagedObjectModel.destroy();}};
c.prototype._initCompositeSupport=function(s){var m=this.getMetadata(),f=m._fragment,A=m.getCompositeAggregationName();this._destroyCompositeAggregation();if(s&&A&&s[A]){var n=s[A];if(n.localName==="FragmentDefinition"){f=n;delete s[A];}}var d=f?(new XMLSerializer()).serializeToString(f):undefined;this.bUsesI18n=d?(d.indexOf("$"+this.alias+".i18n")!=-1):true;this._setCompositeAggregation(sap.ui.xmlfragment({sId:this.getId(),fragmentContent:f,oController:this}));this._bIsInitialized=true;};
c.prototype.enhanceAccessibilityState=function(e,A){var p=this.getParent();if(p&&p.enhanceAccessibilityState){return p.enhanceAccessibilityState(this,A);}return A;};
c.prototype.getFocusDomRef=function(){var o=this._renderingContent?this._renderingContent():this._getCompositeAggregation();return o.getFocusDomRef();};
c.prototype.getFocusInfo=function(){var o=this._renderingContent?this._renderingContent():this._getCompositeAggregation();return o.getFocusInfo();};
c.prototype.getIdForLabel=function(){var o=this._renderingContent?this._renderingContent():this._getCompositeAggregation();return o.getIdForLabel();};
return c;});
sap.ui.predefine('sap/ui/core/XMLCompositeMetadata',['sap/ui/core/ElementMetadata','sap/ui/core/XMLTemplateProcessor',"sap/base/Log"],function(E,X,L){"use strict";var f={};var a=function(c,C){this.InvalidationMode={Render:true,None:false};if(!C.hasOwnProperty("renderer")){C.renderer="sap.ui.core.XMLCompositeRenderer";}if(!C.hasOwnProperty("alias")){C.alias="this";}E.apply(this,arguments);var b=this._bAbstract;if(!b){if(!C.fragment&&c!=="sap.ui.core.XMLComposite"){C.fragment=c;C.fragmentUnspecified=true;}if(!this._fragment&&C.fragment){try{if(!this._fragment){if(C.fragmentContent){if(typeof C.fragmentContent==="string"){var p=new DOMParser();C.fragmentContent=p.parseFromString(C.fragmentContent,"text/xml").documentElement;if(C.fragmentContent&&C.fragmentContent.getElementsByTagName("parsererror").length){var m=C.fragmentContent.getElementsByTagName("parsererror")[0].innerText;throw new Error("There was an error parsing the XML fragment for XMLComposite '"+c+"'. The following message may contain hints to find the problem: "+m);}}this._fragment=C.fragmentContent;}else{this._fragment=this._loadFragment(C.fragment,"control");}}}catch(e){if(!C.fragmentUnspecified||e.message.startsWith("There was an error parsing")){throw(e);}else{L.warning("Implicitly inferred fragment xml "+C.fragment+" not found. "+c+" is not abstract!");}}}}this._sCompositeAggregation=C.metadata?C.metadata.compositeAggregation||null:null;this._createPrivateAggregationAccessors();this._applyAggregationSettings();};a.prototype=Object.create(E.prototype);a.prototype.constructor=a;a.uid=E.uid;
a.extend=function(s){for(var k in s){a[k]=s[k];}return a;};
a.prototype.getCompositeAggregationName=function(){return this._sCompositeAggregation||"_content";};
a.prototype.getFragment=function(){if(this._fragment){return this._fragment.cloneNode(true);}};
a.prototype._applyAggregationSettings=function(){var A=this.getAllAggregations();for(var n in A){if(A[n].type==="TemplateMetadataContext"){this.getAggregation(n)._doesNotRequireFactory=true;}}};
a.prototype._createPrivateAggregationAccessors=function(){var p=this.getAllPrivateAggregations(),b=this.getClass().prototype,g=function(c,d){if(!b[c]){b[c]=d;}};for(var n in p){p[n].generate(g);}};
a.prototype._suppressInvalidate=function(m,s){if(s){return true;}if(!m.appData){m.appData={};m.appData.invalidate=this.InvalidationMode.None;}if(m&&m.appData&&m.appData.invalidate===this.InvalidationMode.Render){return false;}return true;};
a.prototype.getMandatoryAggregations=function(){if(!this._mMandatoryAggregations){var A=this.getAllAggregations(),m={};for(var n in A){if(A[n].type==="TemplateMetadataContext"&&A[n].appData.mandatory){m[n]=A[n];}}this._mMandatoryAggregations=m;}return this._mMandatoryAggregations;};
a.prototype._loadFragment=function(F,e){var s=e+"$"+F;if(!f[s]){f[s]=X.loadTemplate(F,e);}return f[s];};
return a;},true);
sap.ui.predefine('sap/ui/core/XMLTemplateProcessor',['sap/ui/thirdparty/jquery','sap/ui/base/DataType','sap/ui/base/ManagedObject','sap/ui/core/CustomData','./mvc/View','./mvc/EventHandlerResolver','./ExtensionPoint','./StashedControlSupport','sap/ui/base/SyncPromise','sap/base/Log','sap/base/util/ObjectPath','sap/base/util/values','sap/base/assert','sap/base/security/encodeXML','sap/base/util/LoaderExtensions','sap/base/util/JSTokenizer','sap/base/util/isEmptyObject'],function(q,D,M,C,V,E,a,S,b,L,O,v,c,d,f,J,g){"use strict";
function h(e,i,N,j,R){var B=M.bindingParser(i,j,true,false,false,false,R);if(B&&typeof B==="object"){return B;}var p=i=B||i;var y=D.getType(e);if(y){if(y instanceof D){p=y.parseValue(i,{context:j,locals:R});if(!y.isValid(p)){L.error("Value '"+i+"' is not valid for type '"+y.getName()+"'.");}}}else{throw new Error("Property "+N+" has unknown type "+e);}return typeof p==="string"?M.bindingParser.escape(p):p;}
function l(e){return e.localName||e.baseName||e.nodeName;}
var X="http://www.w3.org/1999/xhtml";var k="http://www.w3.org/2000/svg";var m="sap.ui.core";var n="http://schemas.sap.com/sapui5/extension/sap.ui.core.CustomData/1";var o="http://schemas.sap.com/sapui5/extension/sap.ui.core.support.Support.info/1";var r="http://schemas.sap.com/sapui5/extension/sap.ui.core.xmlcomposite/1";var I="http://schemas.sap.com/sapui5/extension/sap.ui.core.Internal/1";var P="http://schemas.sap.com/sapui5/preprocessorextension/";
function s(A,e){function i(p,y,z,B){var F,G,H=[];for(F=p.firstChild;F;F=F.nextSibling){G=e(p,y,z,F,false,B);if(G){H.push(G.unwrap());}}return b.resolve(H);}function j(p,y,z,B){var F,G=Promise.resolve(),H=[B];for(F=p.firstChild;F;F=F.nextSibling){G=G.then(e.bind(null,p,y,z,F,false,B));H.push(G);}return Promise.all(H);}return A?j:i;}
var t={};
t.loadTemplate=function(e,i){var R=e.replace(/\./g,"/")+("."+(i||"view")+".xml");return f.loadResource(R).documentElement;};
t.loadTemplatePromise=function(e,i){var R=e.replace(/\./g,"/")+("."+(i||"view")+".xml");return f.loadResource(R,{async:true}).then(function(j){return j.documentElement;});};
t.parseViewAttributes=function(e,j,p){var A=j.getMetadata().getAllProperties();for(var i=0;i<e.attributes.length;i++){var y=e.attributes[i];if(y.name==='controllerName'){j._controllerName=y.value;}else if(y.name==='resourceBundleName'){j._resourceBundleName=y.value;}else if(y.name==='resourceBundleUrl'){j._resourceBundleUrl=y.value;}else if(y.name==='resourceBundleLocale'){j._resourceBundleLocale=y.value;}else if(y.name==='resourceBundleAlias'){j._resourceBundleAlias=y.value;}else if(y.name==='class'){j.addStyleClass(y.value);}else if(!p[y.name]&&A[y.name]){p[y.name]=h(A[y.name].type,y.value,y.name,j._oContainingView.oController);}}};
t.enrichTemplateIds=function(e,i){t.enrichTemplateIdsPromise(e,i,false);return e;};
t.enrichTemplateIdsPromise=function(e,i,A){return x(e,i,true,A).then(function(){return e;});};
t.parseTemplate=function(e,i){return t.parseTemplatePromise(e,i,false).unwrap();};
t.parseTemplatePromise=function(i,j,A,y){return x(i,j,false,A,y).then(function(){var p=b.resolve();var z=arguments;if(j.isA("sap.ui.core.mvc.View")&&j._epInfo&&j._epInfo.all.length>0){p=T(A,j,{"content":j._epInfo.all});}return p.then(function(){if(Array.isArray(z[0])){z[0]=z[0].filter(function(e){return!e._isExtensionPoint;});}return z[0];});});};
function u(R){var e,i=/^[a-zA-Z_$][a-zA-Z0-9_$]*$/;if(!R||typeof R!=="object"){e="core:require in XMLView can't be parsed to a valid object";}else{Object.keys(R).some(function(K){if(!i.test(K)){e="core:require in XMLView contains invalid identifier: '"+K+"'";return true;}if(!R[K]||typeof R[K]!=="string"){e="core:require in XMLView contains invalide value '"+R[K]+"'under key '"+K+"'";return true;}});}return e;}
function w(j,A){var p=j.getAttributeNS(m,"require"),R,y,z;if(p){try{R=J.parseJS(p);}catch(e){L.error("Require attribute can't be parsed on Node: ",j.nodeName);throw e;}z=u(R);if(z){throw new Error(z+" on Node: "+j.nodeName);}if(!g(R)){y={};if(A){return new Promise(function(B,F){var G=Object.keys(R).reduce(function(i,K){y[K]=sap.ui.require(R[K]);return i&&y[K]!==undefined;},true);if(G){B(y);return;}sap.ui.require(v(R),function(){var H=arguments;Object.keys(R).forEach(function(K,i){y[K]=H[i];});B(y);},F);});}else{Object.keys(R).forEach(function(K){y[K]=sap.ui.requireSync(R[K]);});return b.resolve(y);}}}}
function T(A,e,i){var j=b.resolve();if(!g(i)){var y=[];var R;if(A){j=new Promise(function(p){R=p;});}Object.keys(i).forEach(function(z){var B=i[z];B.forEach(function(F){F.targetControl=e;var G=sap.ui.require(F.providerClass);if(G){y.push(G.applyExtensionPoint(F));}else{var p=new Promise(function(H,K){sap.ui.require([F.providerClass],function(N){H(N);},K);}).then(function(H){return H.applyExtensionPoint(F);});y.push(p);}});});if(A){Promise.all(y).then(R);}}return j;}
function x(p,y,z,A,B){var R=[],F=w(p,A)||b.resolve();A=A&&y._sProcessingMode==="sequential";L.debug("XML processing mode is "+(A?"sequential":"default"),"","XMLTemplateProcessor");var G=sap.ui.getCore().getConfiguration().getDesignMode();if(G){y._sapui_declarativeSourceInfo={xmlNode:p,xmlRootNode:y._oContainingView===y?p:y._oContainingView._sapui_declarativeSourceInfo.xmlRootNode};}var H=y.sViewName||y._sFragmentName;if(!H){var K=y;var N=0;while(++N<1000&&K&&K!==K._oContainingView){K=K._oContainingView;}H=K.sViewName;}if(y.isSubView()){Z(p,true,false,F);}else{if(p.localName==="View"&&p.namespaceURI!=="sap.ui.core.mvc"){L.warning("XMLView root node must have the 'sap.ui.core.mvc' namespace, not '"+p.namespaceURI+"'"+(H?" (View name: "+H+")":""));}$(p,false,false,F);}var i=0;function Q(){for(;i<R.length;i++){var e=R[i];if(e&&typeof e.then==='function'){return e.then(U).then(Q);}}return R;}function U(e){var j=[i,1].concat(e);Array.prototype.splice.apply(R,j);}return F.then(Q);function W(e){return e;}function Y(e){return y._oContainingView.createId(e);}function Z(p,e,j,f1){if(p.nodeType===1){var g1=l(p);if(p.namespaceURI===X||p.namespaceURI===k){R.push("<"+g1+" ");var h1=false;for(var i=0;i<p.attributes.length;i++){var i1=p.attributes[i];var j1=i1.value;if(i1.name==="id"){h1=true;j1=d1(y,p);}R.push(i1.name+"=\""+d(j1)+"\" ");}if(e===true){R.push("data-sap-ui-preserve"+"=\""+y.getId()+"\" ");if(!h1){R.push("id"+"=\""+y.getId()+"\" ");}}R.push(">");var k1=p;if(window.HTMLTemplateElement&&p instanceof HTMLTemplateElement&&p.content instanceof DocumentFragment){k1=p.content;}$(k1,false,false,f1);R.push("</"+g1+">");}else if(g1==="FragmentDefinition"&&p.namespaceURI===m){$(p,false,true,f1);}else{F=F.then(function(){return b1(p,f1).then(function(n1){for(var i=0;i<n1.length;i++){var o1=n1[i];if(y.getMetadata().hasAggregation("content")){y._epInfo=y._epInfo||{contentControlsCount:0,last:null,all:[]};if(o1._isExtensionPoint){o1.index=y._epInfo.contentControlsCount;o1.targetControl=y;o1.aggregationName="content";if(y._epInfo.last){y._epInfo.last._nextSibling=o1;}y._epInfo.last=o1;y._epInfo.all.push(o1);}else{y._epInfo.contentControlsCount++;y.addAggregation("content",o1);}}else if(y.getMetadata().hasAssociation(("content"))){y.addAssociation("content",o1);}}return n1;});});R.push(F);}}else if(p.nodeType===3&&!j){var l1=p.textContent||p.text,m1=l(p.parentNode);if(l1){if(m1!="style"){l1=d(l1);}R.push(l1);}}}function $(p,e,j,f1){var g1=p.childNodes;for(var i=0;i<g1.length;i++){Z(g1[i],e,j,f1);}}function _(e,j){var f1;var g1=sap.ui.getCore().getLoadedLibraries();q.each(g1,function(k1,l1){if(e===l1.namespace||e===l1.name){f1=l1.name+"."+((l1.tagNames&&l1.tagNames[j])||j);}});f1=f1||e+"."+j;function h1(j1){if(!j1){L.error("Control '"+f1+"' did not return a class definition from sap.ui.define.","","XMLTemplateProcessor");j1=O.get(f1);}if(!j1){L.error("Can't find object class '"+f1+"' for XML-view","","XMLTemplateProcessor");}return j1;}var i1=f1.replace(/\./g,"/");var j1=sap.ui.require(i1);if(!j1){if(A){return new Promise(function(k1,l1){sap.ui.require([i1],function(j1){j1=h1(j1);k1(j1);},l1);});}else{j1=sap.ui.requireSync(i1);j1=h1(j1);}}return j1;}function a1(e,j){if(e.namespaceURI===X||e.namespaceURI===k){var id=e.attributes['id']?e.attributes['id'].textContent||e.attributes['id'].text:null;if(z){return t.enrichTemplateIdsPromise(e,y,A).then(function(){return[];});}else{var f1=function(h1){var i1={id:id?d1(y,e,id):undefined,xmlNode:e,containingView:y._oContainingView,processingMode:y._sProcessingMode};if(y.fnScopedRunWithOwner){return y.fnScopedRunWithOwner(function(){return new h1(i1);});}return new h1(i1);};if(A){return new Promise(function(h1,i1){sap.ui.require(["sap/ui/core/mvc/XMLView"],function(g1){h1([f1(g1)]);},i1);});}else{var g1=sap.ui.requireSync("sap/ui/core/mvc/XMLView");return b.resolve([f1(g1)]);}}}else{return b1(e,j);}}function b1(e,j){if(l(e)==="ExtensionPoint"&&e.namespaceURI===m){if(z){return b.resolve([]);}else{var f1=y instanceof V?y._oContainingView:y;var g1=a._factory.bind(null,f1,e.getAttribute("name"),function(){var i1=b.resolve();var j1=[];var k1=e.childNodes;for(var i=0;i<k1.length;i++){var l1=k1[i];if(l1.nodeType===1){i1=i1.then(a1.bind(null,l1,j));j1.push(i1);}}return b.all(j1).then(function(m1){var n1=[];m1.forEach(function(o1){n1=n1.concat(o1);});return n1;});});return b.resolve(y.fnScopedRunWithOwner?y.fnScopedRunWithOwner(g1):g1());}}else{var h1=_(e.namespaceURI,l(e));if(h1&&typeof h1.then==='function'){return h1.then(function(i1){return c1(e,i1,j);});}else{return c1(e,h1,j);}}}function c1(f1,g1,h1){var ns=f1.namespaceURI,j1={},k1={},l1="",m1=[],n1=null,o1=null;if(!g1){return b.resolve([]);}var p1=g1.getMetadata();var q1=p1.getAllSettings();var r1=w(f1,A);if(r1){h1=b.all([h1,r1]).then(function(e){return Object.assign({},e[0],e[1]);});}h1=h1.then(function(j){if(g(j)){j=null;}if(!z){for(var i=0;i<f1.attributes.length;i++){var i1=f1.attributes[i],w1=i1.name,x1,y1=q1[w1],z1=i1.value;if(w1==="id"){j1[w1]=d1(y,f1,z1);}else if(w1==="class"){l1+=z1;}else if(w1==="viewName"){j1[w1]=z1;}else if(w1==="fragmentName"){j1[w1]=z1;j1['containingView']=y._oContainingView;}else if((w1==="binding"&&!y1)||w1==='objectBindings'){var A1=M.bindingParser(z1,y._oContainingView.oController);if(A1){j1.objectBindings=j1.objectBindings||{};j1.objectBindings[A1.model||undefined]=A1;}}else if(w1==='metadataContexts'){var B1=null;try{B1=t._calculatedModelMapping(z1,y._oContainingView.oController,true);}catch(e){L.error(y+":"+e.message);}if(B1){j1.metadataContexts=B1;if(t._preprocessMetadataContexts){t._preprocessMetadataContexts(g1.getMetadata().getName(),j1,y._oContainingView.oController);}}}else if(w1.indexOf(":")>-1){x1=i1.namespaceURI;if(x1===n){var C1=l(i1);m1.push(new C({key:C1,value:h("any",z1,C1,y._oContainingView.oController)}));}else if(x1===o){o1=z1;}else if(x1&&x1.startsWith(P)){L.debug(y+": XMLView parser ignored preprocessor attribute '"+w1+"' (value: '"+z1+"')");}else if(x1===m||x1===I||w1.startsWith("xmlns:")){}else{if(!n1){n1={};}if(!n1.hasOwnProperty(i1.namespaceURI)){n1[i1.namespaceURI]={};}n1[i1.namespaceURI][l(i1)]=i1.nodeValue;L.debug(y+": XMLView parser encountered unknown attribute '"+w1+"' (value: '"+z1+"') with unknown namespace, stored as sap-ui-custom-settings of customData");}}else if(y1&&y1._iKind===0){j1[w1]=h(y1.type,z1,w1,y._oContainingView.oController,j);}else if(y1&&y1._iKind===1&&y1.altTypes){j1[w1]=h(y1.altTypes[0],z1,w1,y._oContainingView.oController,j);}else if(y1&&y1._iKind===2){var A1=M.bindingParser(z1,y._oContainingView.oController,false,false,false,false,j);if(A1){j1[w1]=A1;}else{L.error(y+": aggregations with cardinality 0..n only allow binding paths as attribute value (wrong value: "+w1+"='"+z1+"')");}}else if(y1&&y1._iKind===3){j1[w1]=Y(z1);}else if(y1&&y1._iKind===4){j1[w1]=z1.split(/[\s,]+/g).filter(W).map(Y);}else if(y1&&y1._iKind===5){var D1=[];E.parse(z1).forEach(function(E1){var F1=E.resolveEventHandler(E1,y._oContainingView.oController,j);if(F1){D1.push(F1);}else{L.warning(y+": event handler function \""+E1+"\" is not a function or does not exist in the controller.");}});if(D1.length){j1[w1]=D1;}}else if(y1&&y1._iKind===-1){if(V.prototype.isPrototypeOf(g1.prototype)&&w1=="async"){j1[w1]=h(y1.type,z1,w1,y._oContainingView.oController,j);}else{L.warning(y+": setting '"+w1+"' for class "+p1.getName()+" (value:'"+z1+"') is not supported");}}else{c(w1==='xmlns',y+": encountered unknown setting '"+w1+"' for class "+p1.getName()+" (value:'"+z1+"')");if(t._supportInfo){t._supportInfo({context:f1,env:{caller:"createRegularControls",error:true,info:"unknown setting '"+w1+"' for class "+p1.getName()}});}}}if(n1){m1.push(new C({key:"sap-ui-custom-settings",value:n1}));}if(m1.length>0){j1.customData=m1;}}return j;});var s1=s(A,t1);function t1(f1,u1,v1,e,i1,h1){var w1,x1;if(e.nodeType===1){if(e.namespaceURI===r){j1[l(e)]=e.querySelector("*");return;}w1=e.namespaceURI===ns&&v1&&v1[l(e)];if(w1){return s1(e,w1,false,h1);}else if(u1){if(!i1&&e.getAttribute("stashed")==="true"&&!z){x1=function(){S.createStashedControl(d1(y,e),{sParentId:j1["id"],sParentAggregationName:u1.name,fnCreate:function(){var j=A;A=false;try{return t1(f1,u1,v1,e,true,h1).unwrap();}finally{A=j;}}});};if(y.fnScopedRunWithOwner){y.fnScopedRunWithOwner(x1);}else{x1();}return;}return a1(e,h1).then(function(z1){for(var j=0;j<z1.length;j++){var A1=z1[j];var B1=u1.name;if(A1._isExtensionPoint){if(!j1[B1]){j1[B1]=[];}var C1=k1[B1];if(!C1){C1=k1[B1]=[];}A1.index=j1[B1].length;A1.aggregationName=B1;var D1=C1[C1.length-1];if(D1){D1._nextSibling=A1;}C1.push(A1);}else if(u1.multiple){if(!j1[B1]){j1[B1]=[];}if(typeof j1[B1].path==="string"){c(!j1[B1].template,"list bindings support only a single template object");j1[B1].template=A1;}else{j1[B1].push(A1);}}else{c(!j1[B1],"multiple aggregates defined for aggregation with cardinality 0..1");j1[B1]=A1;}}return z1;});}else if(l(f1)!=="FragmentDefinition"||f1.namespaceURI!==m){throw new Error("Cannot add direct child without default aggregation defined for control "+p1.getElementName());}}else if(e.nodeType===3){var y1=e.textContent||e.text;if(y1&&y1.trim()){throw new Error("Cannot add text nodes as direct child of an aggregation. For adding text to an aggregation, a surrounding html tag is needed: "+y1.trim());}}}var u1=p1.getDefaultAggregation();var v1=p1.getAllAggregations();return s1(f1,u1,v1,h1).then(function(){var e;var j=b.resolve();if(z&&f1.hasAttribute("id")){e1(y,f1);}else if(!z){if(V.prototype.isPrototypeOf(g1.prototype)&&typeof g1._sType==="string"){var i1=function(){if(g1.getMetadata().isA("sap.ui.core.mvc.XMLView")&&y._sProcessingMode==="sequential"){j1.processingMode="sequential";}return V._legacyCreate(j1,undefined,g1._sType);};if(y.fnScopedRunWithOwner){e=y.fnScopedRunWithOwner(i1);}else{e=i1();}}else{var w1=function(){var y1;if(g1.getMetadata().isA("sap.ui.core.Fragment")&&f1.getAttribute("type")!=="JS"&&y._sProcessingMode==="sequential"){j1.processingMode="sequential";}if(y.fnScopedRunWithOwner){y1=y.fnScopedRunWithOwner(function(){var y1=new g1(j1);return y1;});}else{y1=new g1(j1);}j=T(A,y1,k1);return y1;};if(B&&B.fnRunWithPreprocessor){e=B.fnRunWithPreprocessor(w1);}else{e=w1();}}if(l1&&e.addStyleClass){e.addStyleClass(l1);}}if(!e){e=[];}else if(!Array.isArray(e)){e=[e];}if(t._supportInfo&&e){for(var i=0,x1=e.length;i<x1;i++){var y1=e[i];if(y1&&y1.getId()){var z1=t._supportInfo({context:f1,env:{caller:"createRegularControls",nodeid:f1.getAttribute("id"),controlid:y1.getId()}}),A1=o1?o1+",":"";A1+=z1;t._supportInfo.addSupportInfo(y1.getId(),A1);}}}if(G){e.forEach(function(y1){if(p1.getCompositeAggregationName){var B1=f1.getElementsByTagName(y1.getMetadata().getCompositeAggregationName());for(var i=0;i<B1.length;i++){f1.removeChild(B1[0]);}}y1._sapui_declarativeSourceInfo={xmlNode:f1,xmlRootNode:y._sapui_declarativeSourceInfo.xmlRootNode,fragmentName:p1.getName()==='sap.ui.core.Fragment'?j1['fragmentName']:null};});}return j.then(function(){return e;});});}function d1(y,p,e){if(p.getAttributeNS(I,"id")){return p.getAttribute("id");}else{return Y(e?e:p.getAttribute("id"));}}function e1(y,p){p.setAttribute("id",Y(p.getAttribute("id")));p.setAttributeNS(I,"id",true);}}
t._preprocessMetadataContexts=null;
t._calculatedModelMapping=function(B,e,A){var j,p={},y=M.bindingParser(B,e);function z(F){if(F.length%2===0){throw new Error("The last entry is no binding");}for(var i=1;i<=F.length;i=i+2){if(typeof F[i-1]=='string'){throw new Error("Binding expected not a string");}if(F[i]){if((typeof F[i]!='string')||(F[i]!=",")){throw new Error("Missing delimiter ','");}}}}if(y){if(!y.formatter){j=y;y={parts:[j]};}else{z(y.formatter.textFragments);}for(var i=0;i<y.parts.length;i++){j=y.parts[i];p[j.model]=p[j.model]||(A?[]:null);if(Array.isArray(p[j.model])){p[j.model].push(j);}else{p[j.model]=j;}}}return p;};
return t;},true);
sap.ui.predefine('sap/ui/core/cache/CacheManager',['./LRUPersistentCache','./CacheManagerNOP','sap/ui/Device',"sap/base/Log","sap/ui/performance/Measurement",'sap/ui/performance/trace/Interaction'],function(L,C,D,a,M,I){"use strict";var b={_instance:null,_getInstance:function(){var p,o=d("_getInstance"),t=this;p=new Promise(function(r,e){var f;a.debug("Cache Manager: Initialization...");if(!b._instance){f=t._findImplementation();M.start(c,"CM",S);f.init().then(g,e);M.end(c,"CM");}else{g(b._instance);}function g(h){b._instance=h;o.endAsync();a.debug("Cache Manager initialized with implementation ["+b._instance.name+"], resolving _getInstance promise");r(h);}});o.endSync();return p;},_findImplementation:function(){if(i()&&this._isSupportedEnvironment()){return L;}else{a.warning("UI5 Cache Manager is switched off");return C;}},set:function(k,v){var p,o=d("set",k);a.debug("Cache Manager: Setting value of type["+typeof v+"] with key ["+k+"]");p=this._callInstanceMethod("set",arguments).then(function callInstanceHandler(){a.debug("Cache Manager: Setting key ["+k+"] completed successfully");o.endAsync();},function(e){a.error("Cache Manager: Setting key ["+k+"] failed. Error:"+e);o.endAsync();throw e;});o.endSync();return p;},get:function(k){var p,f=I.notifyAsyncStep(),o=d("get",k);a.debug("Cache Manager: Getting key ["+k+"]");p=this._callInstanceMethod("get",arguments).then(function callInstanceHandler(v){a.debug("Cache Manager: Getting key ["+k+"] done");o.endAsync();return v;},function(e){a.debug("Cache Manager: Getting key ["+k+"] failed. Error: "+e);o.endAsync();throw e;}).finally(f);o.endSync();return p;},has:function(k){var p,o=d("has",k);a.debug("Cache Manager: has key ["+k+"] called");p=this._callInstanceMethod("has",arguments).then(function callInstanceHandler(r){o.endAsync();a.debug("Cache Manager: has key ["+k+"] returned "+r);return r;});o.endSync();return p;},del:function(k){var p,o=d("del",k);a.debug("Cache Manager: del called.");p=this._callInstanceMethod("del",arguments).then(function callInstanceHandler(){a.debug("Cache Manager: del completed successfully.");o.endAsync();},function(e){a.debug("Cache Manager: del failed. Error: "+e);o.endAsync();throw e;});o.endSync();return p;},reset:function(){var p,o=d("reset");a.debug("Cache Manager: Reset called.");p=this._callInstanceMethod("reset",arguments).then(function callInstanceHandler(){a.debug("Cache Manager: Reset completed successfully.");o.endAsync();},function(e){a.debug("Cache Manager: Reset failed. Error: "+e);o.endAsync();throw e;});o.endSync();return p;},_switchOff:function(){var t=this;return Promise.resolve().then(function(){s(t);sap.ui.getCore().getConfiguration().setUI5CacheOn(false);});},_switchOn:function(){var t=this;return Promise.resolve().then(function(){var o=sap.ui.getCore().getConfiguration();if(!o.isUI5CacheOn()){s(t);sap.ui.getCore().getConfiguration().setUI5CacheOn(true);}return Promise.resolve();});},_callInstanceMethod:function(e,A){var p,f="[sync ] _callInstanceMethod";M.start(f,"CM",S);if(this._instance){a.debug("Cache Manager: calling instance...");return this._instance[e].apply(this._instance,A);}a.debug("Cache Manager: getting instance...");p=this._getInstance().then(function instanceResolving(g){return g[e].apply(g,A);});M.end(f);return p;},_isSupportedEnvironment:function(){var e=[];if(this._bSupportedEnvironment==undefined){e.push({system:D.system.SYSTEMTYPE.DESKTOP,browserName:D.browser.BROWSER.CHROME,browserVersion:49});e.push({system:D.system.SYSTEMTYPE.DESKTOP,browserName:D.browser.BROWSER.INTERNET_EXPLORER,browserVersion:11});e.push({system:D.system.SYSTEMTYPE.DESKTOP,browserName:D.browser.BROWSER.EDGE,browserVersion:80});e.push({system:D.system.SYSTEMTYPE.DESKTOP,browserName:D.browser.BROWSER.SAFARI,browserVersion:13});e.push({system:D.system.SYSTEMTYPE.TABLET,browserName:D.browser.BROWSER.SAFARI,browserVersion:13});e.push({system:D.system.SYSTEMTYPE.PHONE,browserName:D.browser.BROWSER.SAFARI,browserVersion:13});e.push({system:D.system.SYSTEMTYPE.TABLET,os:D.os.OS.ANDROID,browserName:D.browser.BROWSER.CHROME,browserVersion:80});e.push({system:D.system.SYSTEMTYPE.PHONE,os:D.os.OS.ANDROID,browserName:D.browser.BROWSER.CHROME,browserVersion:80});this._bSupportedEnvironment=e.some(function(o){var f=D.system[o.system],g=o.os?o.os===D.os.name:true,h=o.browserName===D.browser.name,j=D.browser.version>=o.browserVersion;try{return f&&g&&h&&j&&window.indexedDB;}catch(k){return false;}});}return this._bSupportedEnvironment;}};var S="CacheManager",c="[sync ] _initImplementation",m=0;
function i(){return sap.ui.getCore().getConfiguration().isUI5CacheOn();}
function s(e){if(e._instance){e._instance._destroy();e._instance=null;}}
function d(o,k){m++;var e="[async]  "+o+"["+k+"]- #"+(m),f="[sync ]  "+o+"["+k+"]- #"+(m);M.start(e,"CM",[S,o]);M.start(f,"CM",[S,o]);return{sMeasureAsync:e,sMeasureSync:f,endAsync:function(){M.end(this.sMeasureAsync);},endSync:function(){M.end(this.sMeasureSync);}};}
return b;});
sap.ui.predefine('sap/ui/core/cache/CacheManagerNOP',[],function(){"use strict";var C={name:"CacheManagerNOP",set:function(){return Promise.resolve();},get:function(){return Promise.resolve(undefined);},has:function(){return Promise.resolve(false);},del:function(){return Promise.resolve();},reset:function(){return Promise.resolve();},init:function(){return Promise.resolve(this);},_db:{close:function(){}},_getCount:function(){return Promise.resolve(0);},_destroy:function(){}};return C;});
sap.ui.predefine('sap/ui/core/date/Buddhist',['./UniversalDate','../CalendarType','./_Calendars'],function(U,C,_){"use strict";
var B=U.extend("sap.ui.core.date.Buddhist",{constructor:function(){var A=arguments;if(A.length>1){A=b(A);}this.oDate=this.createDate(Date,A);this.sCalendarType=C.Buddhist;}});
B.UTC=function(){var A=b(arguments);return Date.UTC.apply(Date,A);};
B.now=function(){return Date.now();};
function t(g){var e=U.getEraStartDate(C.Buddhist,0).year,y=g.year-e+1;if(g.year<1941&&g.month<3){y-=1;}if(g.year===null){y=undefined;}return{year:y,month:g.month,day:g.day};}
function a(o){var e=U.getEraStartDate(C.Buddhist,0).year,y=o.year+e-1;if(y<1941&&o.month<3){y+=1;}if(o.year===null){y=undefined;}return{year:y,month:o.month,day:o.day};}
function b(A){var o,g;o={year:A[0],month:A[1],day:A[2]!==undefined?A[2]:1};g=a(o);A[0]=g.year;return A;}
B.prototype._getBuddhist=function(){var g={year:this.oDate.getFullYear(),month:this.oDate.getMonth(),day:this.oDate.getDate()};return t(g);};
B.prototype._setBuddhist=function(o){var g=a(o);return this.oDate.setFullYear(g.year,g.month,g.day);};
B.prototype._getUTCBuddhist=function(){var g={year:this.oDate.getUTCFullYear(),month:this.oDate.getUTCMonth(),day:this.oDate.getUTCDate()};return t(g);};
B.prototype._setUTCBuddhist=function(o){var g=a(o);return this.oDate.setUTCFullYear(g.year,g.month,g.day);};
B.prototype.getYear=function(){return this._getBuddhist().year;};
B.prototype.getFullYear=function(){return this._getBuddhist().year;};
B.prototype.getUTCFullYear=function(){return this._getUTCBuddhist().year;};
B.prototype.setYear=function(y){var o=this._getBuddhist();o.year=y;return this._setBuddhist(o);};
B.prototype.setFullYear=function(y,m,d){var o=this._getBuddhist();o.year=y;if(m!==undefined){o.month=m;}if(d!==undefined){o.day=d;}return this._setBuddhist(o);};
B.prototype.setUTCFullYear=function(y,m,d){var o=this._getUTCBuddhist();o.year=y;if(m!==undefined){o.month=m;}if(d!==undefined){o.day=d;}return this._setUTCBuddhist(o);};
B.prototype.getWeek=function(){return U.getWeekByDate(this.sCalendarType,this.oDate.getFullYear(),this.getMonth(),this.getDate());};
B.prototype.getUTCWeek=function(){return U.getWeekByDate(this.sCalendarType,this.oDate.getUTCFullYear(),this.getUTCMonth(),this.getUTCDate());};
_.set(C.Buddhist,B);return B;});
sap.ui.predefine('sap/ui/core/date/Gregorian',['./UniversalDate','../CalendarType','./_Calendars'],function(U,C,_){"use strict";
var G=U.extend("sap.ui.core.date.Gregorian",{constructor:function(){this.oDate=this.createDate(Date,arguments);this.sCalendarType=C.Gregorian;}});
G.UTC=function(){return Date.UTC.apply(Date,arguments);};
G.now=function(){return Date.now();};
_.set(C.Gregorian,G);return G;});
sap.ui.predefine('sap/ui/core/date/Islamic',['./UniversalDate','../CalendarType','sap/base/Log','./_Calendars'],function(U,C,L,_){"use strict";
var I=U.extend("sap.ui.core.date.Islamic",{constructor:function(){var a=arguments;if(a.length>1){a=f(a);}this.oDate=this.createDate(Date,a);this.sCalendarType=C.Islamic;}});
I.UTC=function(){var a=f(arguments);return Date.UTC.apply(Date,a);};
I.now=function(){return Date.now();};
var B=1400,G=1721425.5,c=1948439.5,d=-42521587200000,O=86400000;var o=null;var s=["A","B"];
function t(a){var b=a.year,l=a.month,n=a.day,q,r,u,M,D,v,J;v=0;if((l+1)>2){v=j(b)?-1:-2;}J=(G-1)+(365*(b-1))+Math.floor((b-1)/4)+(-Math.floor((b-1)/100))+Math.floor((b-1)/400)+Math.floor((((367*(l+1))-362)/12)+v+n);J=Math.floor(J)+0.5;D=J-c;M=Math.floor(D/29.530588853);if(M<0){q=Math.floor(M/12)+1;r=M%12;if(r<0){r+=12;}u=D-m(q,r)+1;}else{M++;while(g(M)>D){M--;}q=Math.floor(M/12)+1;r=M%12;u=(D-g(12*(q-1)+r))+1;}return{day:u,month:r,year:q};}
function e(a){var b=a.year,l=a.month,n=a.day,M=b<1?m(b,l):g(12*(b-1)+l),J=n+M+c-1,q=Math.floor(J-0.5)+0.5,D=q-G,Q=Math.floor(D/146097),r=h(D,146097),u=Math.floor(r/36524),v=h(r,36524),w=Math.floor(v/1461),x=h(v,1461),y=Math.floor(x/365),Y=(Q*400)+(u*100)+(w*4)+y,z,A,E,F,H,K,N,P;if(!(u==4||y==4)){Y++;}E=G+(365*(Y-1))+Math.floor((Y-1)/4)-(Math.floor((Y-1)/100))+Math.floor((Y-1)/400);F=q-E;H=(G-1)+(365*(Y-1))+Math.floor((Y-1)/4)-(Math.floor((Y-1)/100))+Math.floor((Y-1)/400)+Math.floor((739/12)+((j(Y)?-1:-2))+1);N=0;if(q<H){N=0;}else{N=j(Y)?1:2;}z=Math.floor((((F+N)*12)+373)/367);K=(G-1)+(365*(Y-1))+Math.floor((Y-1)/4)-(Math.floor((Y-1)/100))+Math.floor((Y-1)/400);P=0;if(z>2){P=j(Y)?-1:-2;}K+=Math.floor((((367*z)-362)/12)+P+1);A=(q-K)+1;return{day:A,month:z-1,year:Y};}
function f(a){var b=Array.prototype.slice.call(a),l,n;l={year:a[0],month:a[1],day:a[2]!==undefined?a[2]:1};n=e(l);b[0]=n.year;b[1]=n.month;b[2]=n.day;return b;}
function i(){var D,a;o={};D=sap.ui.getCore().getConfiguration().getFormatSettings().getLegacyDateFormat();D=k(D)?D:"A";a=sap.ui.getCore().getConfiguration().getFormatSettings().getLegacyDateCalendarCustomizing();a=a||[];if(!a.length){L.warning("No calendar customizations.");return;}a.forEach(function(E){if(E.dateFormat===D){var b=p(E.gregDate);var l=new Date(Date.UTC(b.year,b.month-1,b.day));var M=l.getTime();var n=(M-d)/O;b=p(E.islamicMonthStart);var q=(b.year-1)*12+b.month-1;o[q]=n;}});L.info("Working with date format: ["+D+"] and customization: "+JSON.stringify(a));}
function p(D){return{year:parseInt(D.substr(0,4)),month:parseInt(D.substr(4,2)),day:parseInt(D.substr(6,2))};}
function g(a){if(!o){i();}var b=o[a];if(!b){var y=Math.floor(a/12)+1;var l=a%12;b=m(y,l);}return b;}
function m(y,a){return Math.ceil(29.5*a)+(y-1)*354+Math.floor((3+11*y)/30.0);}
function h(a,b){return a-(b*Math.floor(a/b));}
function j(y){return!(y%400)||(!(y%4)&&!!(y%100));}
function k(a){return s.indexOf(a)!==-1;}
I.prototype._getIslamic=function(){return t({day:this.oDate.getDate(),month:this.oDate.getMonth(),year:this.oDate.getFullYear()});};
I.prototype._setIslamic=function(a){var b=e(a);return this.oDate.setFullYear(b.year,b.month,b.day);};
I.prototype._getUTCIslamic=function(){return t({day:this.oDate.getUTCDate(),month:this.oDate.getUTCMonth(),year:this.oDate.getUTCFullYear()});};
I.prototype._setUTCIslamic=function(a){var b=e(a);return this.oDate.setUTCFullYear(b.year,b.month,b.day);};
I.prototype.getDate=function(D){return this._getIslamic().day;};
I.prototype.getMonth=function(){return this._getIslamic().month;};
I.prototype.getYear=function(){return this._getIslamic().year-B;};
I.prototype.getFullYear=function(){return this._getIslamic().year;};
I.prototype.setDate=function(D){var a=this._getIslamic();a.day=D;return this._setIslamic(a);};
I.prototype.setMonth=function(M,D){var a=this._getIslamic();a.month=M;if(D!==undefined){a.day=D;}return this._setIslamic(a);};
I.prototype.setYear=function(y){var a=this._getIslamic();a.year=y+B;return this._setIslamic(a);};
I.prototype.setFullYear=function(y,M,D){var a=this._getIslamic();a.year=y;if(M!==undefined){a.month=M;}if(D!==undefined){a.day=D;}return this._setIslamic(a);};
I.prototype.getUTCDate=function(D){return this._getUTCIslamic().day;};
I.prototype.getUTCMonth=function(){return this._getUTCIslamic().month;};
I.prototype.getUTCFullYear=function(){return this._getUTCIslamic().year;};
I.prototype.setUTCDate=function(D){var a=this._getUTCIslamic();a.day=D;return this._setUTCIslamic(a);};
I.prototype.setUTCMonth=function(M,D){var a=this._getUTCIslamic();a.month=M;if(D!==undefined){a.day=D;}return this._setUTCIslamic(a);};
I.prototype.setUTCFullYear=function(y,M,D){var a=this._getUTCIslamic();a.year=y;if(M!==undefined){a.month=M;}if(D!==undefined){a.day=D;}return this._setUTCIslamic(a);};
_.set(C.Islamic,I);return I;});
sap.ui.predefine('sap/ui/core/date/Japanese',['./UniversalDate','../CalendarType','./_Calendars'],function(U,C,_){"use strict";
var J=U.extend("sap.ui.core.date.Japanese",{constructor:function(){var A=arguments;if(A.length>1){A=b(A);}this.oDate=this.createDate(Date,A);this.sCalendarType=C.Japanese;}});
J.UTC=function(){var A=b(arguments);return Date.UTC.apply(Date,A);};
J.now=function(){return Date.now();};
function t(g){var e=U.getEraByDate(C.Japanese,g.year,g.month,g.day),E=U.getEraStartDate(C.Japanese,e).year;return{era:e,year:g.year-E+1,month:g.month,day:g.day};}
function a(j){var e=U.getEraStartDate(C.Japanese,j.era).year;return{year:e+j.year-1,month:j.month,day:j.day};}
function b(A){var j,g,e,y=A[0];if(typeof y=="number"){if(y>=100){return A;}else{e=U.getCurrentEra(C.Japanese);y=[e,y];}}else if(!Array.isArray(y)){y=[];}j={era:y[0],year:y[1],month:A[1],day:A[2]!==undefined?A[2]:1};g=a(j);A[0]=g.year;return A;}
J.prototype._getJapanese=function(){var g={year:this.oDate.getFullYear(),month:this.oDate.getMonth(),day:this.oDate.getDate()};return t(g);};
J.prototype._setJapanese=function(j){var g=a(j);return this.oDate.setFullYear(g.year,g.month,g.day);};
J.prototype._getUTCJapanese=function(){var g={year:this.oDate.getUTCFullYear(),month:this.oDate.getUTCMonth(),day:this.oDate.getUTCDate()};return t(g);};
J.prototype._setUTCJapanese=function(j){var g=a(j);return this.oDate.setUTCFullYear(g.year,g.month,g.day);};
J.prototype.getYear=function(){return this._getJapanese().year;};
J.prototype.getFullYear=function(){return this._getJapanese().year;};
J.prototype.getEra=function(){return this._getJapanese().era;};
J.prototype.getUTCFullYear=function(){return this._getUTCJapanese().year;};
J.prototype.getUTCEra=function(){return this._getUTCJapanese().era;};
J.prototype.setYear=function(y){var j=this._getJapanese();j.year=y;return this._setJapanese(j);};
J.prototype.setFullYear=function(y,m,d){var j=this._getJapanese();j.year=y;if(m!==undefined){j.month=m;}if(d!==undefined){j.day=d;}return this._setJapanese(j);};
J.prototype.setEra=function(e,y,m,d){var E=U.getEraStartDate(C.Japanese,e),j=t(E);if(y!==undefined){j.year=y;}if(m!==undefined){j.month=m;}if(d!==undefined){j.day=d;}return this._setJapanese(j);};
J.prototype.setUTCFullYear=function(y,m,d){var j=this._getUTCJapanese();j.year=y;if(m!==undefined){j.month=m;}if(d!==undefined){j.day=d;}return this._setUTCJapanese(j);};
J.prototype.setUTCEra=function(e,y,m,d){var E=U.getEraStartDate(C.Japanese,e),j=t(E);if(y!==undefined){j.year=y;}if(m!==undefined){j.month=m;}if(d!==undefined){j.day=d;}return this._setUTCJapanese(j);};
J.prototype.getWeek=function(){return U.getWeekByDate(this.sCalendarType,this.oDate.getFullYear(),this.getMonth(),this.getDate());};
J.prototype.getUTCWeek=function(){return U.getWeekByDate(this.sCalendarType,this.oDate.getUTCFullYear(),this.getUTCMonth(),this.getUTCDate());};
_.set(C.Japanese,J);return J;});
sap.ui.predefine('sap/ui/core/date/Persian',['./UniversalDate','../CalendarType','./_Calendars'],function(U,C,_){"use strict";
var P=U.extend("sap.ui.core.date.Persian",{constructor:function(){var a=arguments;if(a.length>1){a=e(a);}this.oDate=this.createDate(Date,a);this.sCalendarType=C.Persian;}});
P.UTC=function(){var a=e(arguments);return Date.UTC.apply(Date,a);};
P.now=function(){return Date.now();};
var B=1300;
function t(G){var j=l(G.year,G.month+1,G.day);return h(j);}
function c(a){var j=g(a.year,a.month+1,a.day);return m(j);}
function e(a){var G=Array.prototype.slice.call(a),b,d;if(typeof a[0]!=="number"||typeof a[1]!=="number"||(a[2]!==undefined&&typeof a[2]!="number")){G[0]=NaN;G[1]=NaN;G[2]=NaN;return G;}b={year:a[0],month:a[1],day:a[2]!==undefined?a[2]:1};d=c(b);G[0]=d.year;G[1]=d.month;G[2]=d.day;return G;}
function f(j){var b=[-61,9,38,199,426,686,756,818,1111,1181,1210,1635,2060,2097,2192,2262,2324,2394,2456,3178],a=b.length,d=j+621,k=-14,q=b[0],r,s,u,v,w,n,i;for(i=1;i<a;i+=1){r=b[i];s=r-q;if(j<r){break;}k=k+o(s,33)*8+o(p(s,33),4);q=r;}n=j-q;k=k+o(n,33)*8+o(p(n,33)+3,4);if(p(s,33)===4&&s-n===4){k+=1;}v=o(d,4)-o((o(d,100)+1)*3,4)-150;w=20+k-v;if(s-n<6){n=n-s+o(s+4,33)*33;}u=p(p(n+1,33)-1,4);if(u===-1){u=4;}return{leap:u,gy:d,march:w};}
function g(j,a,b){while(a<1){a+=12;j--;}while(a>12){a-=12;j++;}var r=f(j);return l(r.gy,3,r.march)+(a-1)*31-o(a,7)*(a-7)+b-1;}
function h(j){var a=m(j).year,b=a-621,r=f(b),d=l(a,3,r.march),i,n,k;k=j-d;if(k>=0){if(k<=185){n=1+o(k,31);i=p(k,31)+1;return{year:b,month:n-1,day:i};}else{k-=186;}}else{b-=1;k+=179;if(r.leap===1){k+=1;}}n=7+o(k,30);i=p(k,30)+1;return{year:b,month:n-1,day:i};}
function l(a,b,i){var d=o((a+o(b-8,6)+100100)*1461,4)+o(153*p(b+9,12)+2,5)+i-34840408;d=d-o(o(a+100100+o(b-8,6),100)*3,4)+752;return d;}
function m(a){var j,i,b,d,k;j=4*a+139361631;j=j+o(o(4*a+183187720,146097)*3,4)*4-3908;i=o(p(j,1461),4)*5+308;b=o(p(i,153),5)+1;d=p(o(i,153),12)+1;k=o(j,1461)-100100+o(8-d,6);return{year:k,month:d-1,day:b};}
function o(a,b){return~~(a/b);}
function p(a,b){return a-~~(a/b)*b;}
P.prototype._getPersian=function(){return t({day:this.oDate.getDate(),month:this.oDate.getMonth(),year:this.oDate.getFullYear()});};
P.prototype._setPersian=function(a){var G=c(a);return this.oDate.setFullYear(G.year,G.month,G.day);};
P.prototype._getUTCPersian=function(){return t({day:this.oDate.getUTCDate(),month:this.oDate.getUTCMonth(),year:this.oDate.getUTCFullYear()});};
P.prototype._setUTCPersian=function(a){var G=c(a);return this.oDate.setUTCFullYear(G.year,G.month,G.day);};
P.prototype.getDate=function(d){return this._getPersian().day;};
P.prototype.getMonth=function(){return this._getPersian().month;};
P.prototype.getYear=function(){return this._getPersian().year-B;};
P.prototype.getFullYear=function(){return this._getPersian().year;};
P.prototype.setDate=function(d){var a=this._getPersian();a.day=d;return this._setPersian(a);};
P.prototype.setMonth=function(M,d){var a=this._getPersian();a.month=M;if(d!==undefined){a.day=d;}return this._setPersian(a);};
P.prototype.setYear=function(y){var a=this._getPersian();a.year=y+B;return this._setPersian(a);};
P.prototype.setFullYear=function(y,M,d){var a=this._getPersian();a.year=y;if(M!==undefined){a.month=M;}if(d!==undefined){a.day=d;}return this._setPersian(a);};
P.prototype.getUTCDate=function(d){return this._getUTCPersian().day;};
P.prototype.getUTCMonth=function(){return this._getUTCPersian().month;};
P.prototype.getUTCFullYear=function(){return this._getUTCPersian().year;};
P.prototype.setUTCDate=function(d){var a=this._getUTCPersian();a.day=d;return this._setUTCPersian(a);};
P.prototype.setUTCMonth=function(M,d){var a=this._getUTCPersian();a.month=M;if(d!==undefined){a.day=d;}return this._setUTCPersian(a);};
P.prototype.setUTCFullYear=function(y,M,d){var a=this._getUTCPersian();a.year=y;if(M!==undefined){a.month=M;}if(d!==undefined){a.day=d;}return this._setUTCPersian(a);};
_.set(C.Persian,P);return P;});
sap.ui.predefine('sap/ui/core/date/UniversalDate',['sap/ui/base/Object','sap/ui/core/LocaleData','./_Calendars'],function(B,L,_){"use strict";
var U=B.extend("sap.ui.core.date.UniversalDate",{constructor:function(){var b=U.getClass();return this.createDate(b,arguments);}});
U.UTC=function(){var b=U.getClass();return b.UTC.apply(b,arguments);};
U.now=function(){return Date.now();};
U.prototype.createDate=function(b,A){switch(A.length){case 0:return new b();case 1:return new b(A[0]);case 2:return new b(A[0],A[1]);case 3:return new b(A[0],A[1],A[2]);case 4:return new b(A[0],A[1],A[2],A[3]);case 5:return new b(A[0],A[1],A[2],A[3],A[4]);case 6:return new b(A[0],A[1],A[2],A[3],A[4],A[5]);case 7:return new b(A[0],A[1],A[2],A[3],A[4],A[5],A[6]);}};
U.getInstance=function(d,C){var b,i;if(d instanceof U){d=d.getJSDate();}else if(!d){d=new Date();}if(!C){C=sap.ui.getCore().getConfiguration().getCalendarType();}b=U.getClass(C);i=Object.create(b.prototype);i.oDate=d;i.sCalendarType=C;return i;};
U.getClass=function(C){if(!C){C=sap.ui.getCore().getConfiguration().getCalendarType();}return _.get(C);};
["getDate","getMonth","getFullYear","getYear","getDay","getHours","getMinutes","getSeconds","getMilliseconds","getUTCDate","getUTCMonth","getUTCFullYear","getUTCDay","getUTCHours","getUTCMinutes","getUTCSeconds","getUTCMilliseconds","getTime","valueOf","getTimezoneOffset","toString","toDateString","setDate","setFullYear","setYear","setMonth","setHours","setMinutes","setSeconds","setMilliseconds","setUTCDate","setUTCFullYear","setUTCMonth","setUTCHours","setUTCMinutes","setUTCSeconds","setUTCMilliseconds"].forEach(function(n){U.prototype[n]=function(){return this.oDate[n].apply(this.oDate,arguments);};});
U.prototype.getJSDate=function(){return this.oDate;};
U.prototype.getCalendarType=function(){return this.sCalendarType;};
U.prototype.getEra=function(){return U.getEraByDate(this.sCalendarType,this.oDate.getFullYear(),this.oDate.getMonth(),this.oDate.getDate());};
U.prototype.setEra=function(E){};
U.prototype.getUTCEra=function(){return U.getEraByDate(this.sCalendarType,this.oDate.getUTCFullYear(),this.oDate.getUTCMonth(),this.oDate.getUTCDate());};
U.prototype.setUTCEra=function(E){};
U.prototype.getWeek=function(){return U.getWeekByDate(this.sCalendarType,this.getFullYear(),this.getMonth(),this.getDate());};
U.prototype.setWeek=function(w){var d=U.getFirstDateOfWeek(this.sCalendarType,w.year||this.getFullYear(),w.week);this.setFullYear(d.year,d.month,d.day);};
U.prototype.getUTCWeek=function(){return U.getWeekByDate(this.sCalendarType,this.getUTCFullYear(),this.getUTCMonth(),this.getUTCDate());};
U.prototype.setUTCWeek=function(w){var d=U.getFirstDateOfWeek(this.sCalendarType,w.year||this.getFullYear(),w.week);this.setUTCFullYear(d.year,d.month,d.day);};
U.prototype.getQuarter=function(){return Math.floor((this.getMonth()/3));};
U.prototype.getUTCQuarter=function(){return Math.floor((this.getUTCMonth()/3));};
U.prototype.getDayPeriod=function(){if(this.getHours()<12){return 0;}else{return 1;}};
U.prototype.getUTCDayPeriod=function(){if(this.getUTCHours()<12){return 0;}else{return 1;}};
U.prototype.getTimezoneShort=function(){if(this.oDate.getTimezoneShort){return this.oDate.getTimezoneShort();}};
U.prototype.getTimezoneLong=function(){if(this.oDate.getTimezoneLong){return this.oDate.getTimezoneLong();}};
var m=7*24*60*60*1000;
U.getWeekByDate=function(C,y,M,d){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),b=this.getClass(C),f=g(b,y),D=new b(b.UTC(y,M,d)),w,i,n,o,N;if(l.getRegion()==="US"){w=c(f,D);}else{i=y-1;n=y+1;o=g(b,i);N=g(b,n);if(D>=N){y=n;w=0;}else if(D<f){y=i;w=c(o,D);}else{w=c(f,D);}}return{year:y,week:w};};
U.getFirstDateOfWeek=function(C,y,w){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),b=this.getClass(C),f=g(b,y),d=new b(f.valueOf()+w*m);if(l.getRegion()==="US"&&w===0&&f.getUTCFullYear()<y){return{year:y,month:0,day:1};}return{year:d.getUTCFullYear(),month:d.getUTCMonth(),day:d.getUTCDate()};};
function g(b,y){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),o=L.getInstance(l),M=o.getMinimalDaysInFirstWeek(),f=o.getFirstDayOfWeek(),F=new b(b.UTC(y,0,1)),d=7;while(F.getUTCDay()!==f){F.setUTCDate(F.getUTCDate()-1);d--;}if(d<M){F.setUTCDate(F.getUTCDate()+7);}return F;}
function c(f,t){return Math.floor((t.valueOf()-f.valueOf())/m);}
var e={};
U.getEraByDate=function(C,y,M,d){var E=a(C),t=new Date(0).setUTCFullYear(y,M,d),o;for(var i=E.length-1;i>=0;i--){o=E[i];if(!o){continue;}if(o._start&&t>=o._startInfo.timestamp){return i;}if(o._end&&t<o._endInfo.timestamp){return i;}}};
U.getCurrentEra=function(C){var n=new Date();return this.getEraByDate(C,n.getFullYear(),n.getMonth(),n.getDate());};
U.getEraStartDate=function(C,E){var b=a(C),o=b[E]||b[0];if(o._start){return o._startInfo;}};
function a(C){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),o=L.getInstance(l),E=e[C];if(!E){var E=o.getEraDates(C);if(!E[0]){E[0]={_start:"1-1-1"};}for(var i=0;i<E.length;i++){var b=E[i];if(!b){continue;}if(b._start){b._startInfo=p(b._start);}if(b._end){b._endInfo=p(b._end);}}e[C]=E;}return E;}
function p(d){var P=d.split("-"),y,M,D;if(P[0]==""){y=-parseInt(P[1]);M=parseInt(P[2])-1;D=parseInt(P[3]);}else{y=parseInt(P[0]);M=parseInt(P[1])-1;D=parseInt(P[2]);}return{timestamp:new Date(0).setUTCFullYear(y,M,D),year:y,month:M,day:D};}
return U;});
sap.ui.predefine('sap/ui/core/date/UniversalDateUtils',['sap/ui/core/date/UniversalDate','sap/ui/core/Locale','sap/ui/core/LocaleData','sap/base/assert'],function(U,L,a,b){"use strict";
function c(u){b(u instanceof U,"method accepts only instances of UniversalDate");return u.createDate(u.constructor,[u.getJSDate()]);}
var d={};
d.getRange=function(D,u,B,e){if(e===undefined){e=true;}if(isNaN(D)){throw new TypeError("duration is NaN, but is "+D);}D=Math.trunc(D);var s=d.resetStartTime(B==undefined?null:B),E;if(e){switch(u){case"DAY":break;case"WEEK":s=d.getWeekStartDate(s);break;case"MONTH":s=d.getMonthStartDate(s);break;case"QUARTER":s=d.getQuarterStartDate(s);break;case"YEAR":s=d.getYearStartDate(s);break;default:throw new TypeError("invalid unit "+u);}}switch(u){case"DAY":if(D>0){s.setDate(s.getDate()+1);}E=c(s);D=D==0?1:D;E.setDate(s.getDate()+D);break;case"WEEK":if(D>0){s.setDate(s.getDate()+7);}E=c(s);D=D==0?1:D;E.setDate(s.getDate()+(D*7));break;case"MONTH":if(D>0){s.setMonth(s.getMonth()+1);}E=c(s);D=D==0?1:D;E.setMonth(s.getMonth()+D);break;case"QUARTER":if(D>0){s.setMonth(s.getMonth()+3);}E=c(s);D=D==0?1:D;E.setMonth(s.getMonth()+(D*3));break;case"YEAR":if(D>0){s.setFullYear(s.getFullYear()+1);}E=c(s);D=D==0?1:D;E.setFullYear(s.getFullYear()+D);break;default:throw new TypeError("invalid unit "+u);}if(E.getTime()<s.getTime()){E=[s,s=E][0];}E.setDate(E.getDate()-1);return[d.resetStartTime(s),d.resetEndTime(E)];};
d.getWeekStartDate=function(u,l){var o=l?new L(l):sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale(),e=a.getInstance(o),f=e.getFirstDayOfWeek();u=u?c(u):c(d.createNewUniversalDate());u.setDate(u.getDate()-u.getDay()+f);return d.resetStartTime(u);};
d.getMonthStartDate=function(u){u=u?c(u):c(d.createNewUniversalDate());u.setDate(1);return d.resetStartTime(u);};
d.getQuarterStartDate=function(u){u=u?c(u):c(d.createNewUniversalDate());u.setMonth(3*Math.floor(u.getMonth()/3));u.setDate(1);return d.resetStartTime(u);};
d.getYearStartDate=function(u){u=u?c(u):c(d.createNewUniversalDate());u.setMonth(0);u.setDate(1);return d.resetStartTime(u);};
d.resetStartTime=function(u){u=u?c(u):c(d.createNewUniversalDate());u.setHours(0,0,0,0);return u;};
d.resetEndTime=function(u){u=u?c(u):c(d.createNewUniversalDate());u.setHours(23,59,59,999);return u;};
d.createNewUniversalDate=function(){return new U();};
d.ranges={lastDays:function(D){return d.getRange(-D,"DAY");},yesterday:function(){return d.getRange(-1,"DAY");},today:function(){return d.getRange(0,"DAY");},tomorrow:function(){return d.getRange(1,"DAY");},nextDays:function(D){return d.getRange(D,"DAY");},lastWeeks:function(w){return d.getRange(-w,"WEEK");},lastWeek:function(){return d.getRange(-1,"WEEK");},currentWeek:function(){return d.getRange(0,"WEEK");},nextWeek:function(){return d.getRange(1,"WEEK");},nextWeeks:function(w){return d.getRange(w,"WEEK");},lastMonths:function(m){return d.getRange(-m,"MONTH");},lastMonth:function(){return d.getRange(-1,"MONTH");},currentMonth:function(){return d.getRange(0,"MONTH");},nextMonth:function(){return d.getRange(1,"MONTH");},nextMonths:function(m){return d.getRange(m,"MONTH");},lastQuarters:function(q){return d.getRange(-q,"QUARTER");},lastQuarter:function(){return d.getRange(-1,"QUARTER");},currentQuarter:function(){return d.getRange(0,"QUARTER");},nextQuarter:function(){return d.getRange(1,"QUARTER");},nextQuarters:function(q){return d.getRange(q,"QUARTER");},quarter:function(q){if(q<=2){return d.getRange(q-1,"QUARTER",d.getYearStartDate());}else{var r=d.getRange(q-2,"QUARTER",d.getYearStartDate());var s=r[1];s.setMilliseconds(1000);return d.getRange(0,"QUARTER",s);}},lastYears:function(y){return d.getRange(-y,"YEAR");},lastYear:function(){return d.getRange(-1,"YEAR");},currentYear:function(){return d.getRange(0,"YEAR");},nextYear:function(){return d.getRange(1,"YEAR");},nextYears:function(y){return d.getRange(y,"YEAR");},yearToDate:function(){var t=d.createNewUniversalDate();return[d.getYearStartDate(t),d.resetEndTime(t)];}};return d;});
sap.ui.predefine('sap/ui/core/date/_Calendars',[],function(){"use strict";var r=new Map();var _={get:function(c){if(!r.has(c)){sap.ui.requireSync("sap/ui/core/date/"+c);}return r.get(c);},set:function(c,C){r.set(c,C);}};return _;});
sap.ui.predefine('sap/ui/core/delegate/ItemNavigation',['sap/ui/base/EventProvider',"sap/base/assert","sap/base/Log","sap/ui/dom/containsOrEquals","sap/ui/events/KeyCodes","sap/ui/thirdparty/jquery","sap/ui/dom/jquery/Selectors"],function(E,a,L,c,K,q){"use strict";
var I=E.extend("sap.ui.core.delegate.ItemNavigation",{constructor:function(d,i,n){E.apply(this);this.oDomRef=null;if(d){this.setRootDomRef(d);}this.aItemDomRefs=[];if(i){this.setItemDomRefs(i);}this.iTabIndex=-1;this.iActiveTabIndex=!!n?-1:0;this.iFocusedIndex=-1;this.iSelectedIndex=-1;this.bCycling=true;this.bTableMode=false;this.iPageSize=-1;this._bMouseDownHappened=false;this.oDisabledModifiers={sapend:["alt","shift"],saphome:["alt","shift"]};}});
I.Events={BeforeFocus:"BeforeFocus",AfterFocus:"AfterFocus",BorderReached:"BorderReached",FocusAgain:"FocusAgain",FocusLeave:"FocusLeave"};
I.prototype.setDisabledModifiers=function(d){this.oDisabledModifiers=d;return this;};
I.prototype.getDisabledModifiers=function(d){return this.oDisabledModifiers;};
I.prototype.hasDisabledModifier=function(e){var d=this.oDisabledModifiers[e.type.replace("modifiers","")];if(Array.isArray(d)){for(var i=0;i<d.length;i++){if(e[d[i]+"Key"]){return true;}}}return false;};
I.prototype.setRootDomRef=function(d){this.oDomRef=d;if(!q(this.oDomRef).data("sap.INItem")){if(this.iFocusedIndex>=0){q(this.oDomRef).attr("tabindex",this.iTabIndex);}else{q(this.oDomRef).attr("tabindex",this.iActiveTabIndex);}}q(this.oDomRef).data("sap.INRoot",this);return this;};
I.prototype.getRootDomRef=function(){return this.oDomRef;};
I.prototype.getItemDomRefs=function(){return this.aItemDomRefs;};
I.prototype.setItemDomRefs=function(b){a(typeof b==="object"&&typeof b.length==="number","aItemDomRefs must be an array of DOM elements");this.aItemDomRefs=b;if(this.iFocusedIndex>-1){var d=b.length;if(this.iFocusedIndex>d-1){this.iFocusedIndex=d-1;}var A=document.activeElement;if(A&&A!=this.aItemDomRefs[this.iFocusedIndex]){for(var i=0;i<d;i++){if(A==this.aItemDomRefs[i]){this.iFocusedIndex=i;break;}}}}for(var i=0;i<this.aItemDomRefs.length;i++){if(this.aItemDomRefs[i]){var $=q(this.aItemDomRefs[i]);if(i==this.iFocusedIndex&&!$.data("sap.INRoot")){$.attr("tabindex",this.iActiveTabIndex);}else if($.attr("tabindex")=="0"){$.attr("tabindex",-1);}$.data("sap.INItem",true);$.data("sap.InNavArea",true);if($.data("sap.INRoot")&&i!=this.iFocusedIndex){$.data("sap.INRoot").setNestedItemsTabindex();}}}return this;};
I.prototype.setItemsTabindex=function(){for(var i=0;i<this.aItemDomRefs.length;i++){if(this.aItemDomRefs[i]){var $=q(this.aItemDomRefs[i]);if($.is(":sapFocusable")){if(i==this.iFocusedIndex&&!$.data("sap.INRoot")){$.attr("tabindex",this.iActiveTabIndex);}else{$.attr("tabindex",-1);}}}}return this;};
I.prototype.setNestedItemsTabindex=function(){if(q(this.oDomRef).data("sap.INItem")){for(var i=0;i<this.aItemDomRefs.length;i++){if(this.aItemDomRefs[i]&&q(this.aItemDomRefs[i]).attr("tabindex")=="0"){q(this.aItemDomRefs[i]).attr("tabindex",-1);}}}return this;};
I.prototype.destroy=function(){if(this.oDomRef){q(this.oDomRef).removeData("sap.INRoot");this.oDomRef=null;}if(this.aItemDomRefs){for(var i=0;i<this.aItemDomRefs.length;i++){if(this.aItemDomRefs[i]){q(this.aItemDomRefs[i]).removeData("sap.INItem");q(this.aItemDomRefs[i]).removeData("sap.InNavArea");}}this.aItemDomRefs=null;}this._bItemTabIndex=undefined;this.iFocusedIndex=-1;};
I.prototype.setCycling=function(C){this.bCycling=C;return this;};
I.prototype.setTableMode=function(t,T){this.bTableMode=t;if(this.oConfiguration===undefined){this.oConfiguration=sap.ui.getCore().getConfiguration();}this.bTableList=t?T:false;return this;};
I.prototype.setPageSize=function(p){this.iPageSize=p;return this;};
I.prototype.setSelectedIndex=function(i){this.iSelectedIndex=i;return this;};
I.prototype.setColumns=function(C,n){this.iColumns=C;this.bNoColumnChange=n;return this;};
I.prototype.setHomeEndColumnMode=function(s,C){this._bStayInRow=s;this._bCtrlEnabled=C;return this;};
I.prototype.focusItem=function(i,e){L.info("FocusItem: "+i+" iFocusedIndex: "+this.iFocusedIndex,"focusItem","ItemNavigation");if(i==this.iFocusedIndex&&this.aItemDomRefs[this.iFocusedIndex]==document.activeElement){this.fireEvent(I.Events.FocusAgain,{index:i,event:e});return;}if(!this.aItemDomRefs[i]||!q(this.aItemDomRefs[i]).is(":sapFocusable")){if(this.bTableMode){var C=i%this.iColumns;var o=i;if(e&&e.keyCode==K.ARROW_RIGHT){if(C<this.iColumns-1){i+=this.oConfiguration.getRTL()?-1:1;}}else if(e&&e.keyCode==K.ARROW_LEFT){if(C>1){i-=this.oConfiguration.getRTL()?-1:1;}}else{if(C>1){i-=1;}}if(i!=o){this.focusItem(i,e);}}return;}this.fireEvent(I.Events.BeforeFocus,{index:i,event:e});this.setFocusedIndex(i);this.bISetFocus=true;if(e&&q(this.aItemDomRefs[this.iFocusedIndex]).data("sap.INRoot")){var b=q(this.aItemDomRefs[this.iFocusedIndex]).data("sap.INRoot");b._sFocusEvent=e.type;}L.info("Set Focus on ID: "+this.aItemDomRefs[this.iFocusedIndex].id,"focusItem","ItemNavigation");this.aItemDomRefs[this.iFocusedIndex].focus();this.fireEvent(I.Events.AfterFocus,{index:i,event:e});};
I.prototype.setFocusedIndex=function(i){var $;if(this.aItemDomRefs.length<0){this.iFocusedIndex=-1;return this;}if(i<0){i=0;}if(i>this.aItemDomRefs.length-1){i=this.aItemDomRefs.length-1;}q(this.oDomRef).attr("tabindex",this.iTabIndex);if(this.iFocusedIndex!==-1&&this.aItemDomRefs.length>this.iFocusedIndex){q(this.aItemDomRefs[this.iFocusedIndex]).attr("tabindex",-1);$=q(this.aItemDomRefs[this.iFocusedIndex]);if($.data("sap.INRoot")&&i!=this.iFocusedIndex){q($.data("sap.INRoot").aItemDomRefs[$.data("sap.INRoot").iFocusedIndex]).attr("tabindex",-1);}}this.iFocusedIndex=i;var f=this.aItemDomRefs[this.iFocusedIndex];$=q(this.aItemDomRefs[this.iFocusedIndex]);if(!$.data("sap.INRoot")){q(f).attr("tabindex",this.iActiveTabIndex);}return this;};
I.prototype.getFocusedDomRef=function(){return this.aItemDomRefs[this.iFocusedIndex];};
I.prototype.getFocusedIndex=function(){return this.iFocusedIndex;};
I.prototype.onfocusin=function(e){var s=e.target;var i=0;if(s==this.oDomRef){if(!this._bItemTabIndex){this.setItemsTabindex();this._bItemTabIndex=true;}if(this._bMouseDownHappened){return;}var b;if(q(this.oDomRef).data("sap.INItem")&&this._sFocusEvent&&!q(this.oDomRef).data("sap.InNavArea")){switch(this._sFocusEvent){case"sapnext":b=0;break;case"sapprevious":b=this.aItemDomRefs.length-1;break;default:if(this.iSelectedIndex!=-1){b=this.iSelectedIndex;}else if(this.iFocusedIndex!=-1){b=this.iFocusedIndex;}else{b=0;}break;}this._sFocusEvent=undefined;}else{if(this.iSelectedIndex!=-1){b=this.iSelectedIndex;}else if(this.iFocusedIndex!=-1){b=this.iFocusedIndex;}else{b=0;}}this.focusItem(b,e);if(this.iFocusedIndex==-1){for(i=b+1;i<this.aItemDomRefs.length;i++){this.focusItem(i,e);if(this.iFocusedIndex==i){break;}}if(this.iFocusedIndex==-1&&b>0){for(i=b-1;i>=0;i--){this.focusItem(i,e);if(this.iFocusedIndex==i){break;}}}}e.preventDefault();e.stopPropagation();}else if(!this.bISetFocus){if(this.aItemDomRefs&&e.target!=this.aItemDomRefs[this.iFocusedIndex]){for(i=0;i<this.aItemDomRefs.length;i++){if(e.target==this.aItemDomRefs[i]){this.focusItem(i,e);break;}}}else{this.fireEvent(I.Events.AfterFocus,{index:this.iFocusedIndex,event:e});}}this.bISetFocus=false;};
I.prototype.onsapfocusleave=function(e){if(!e.relatedControlId||!c(this.oDomRef,sap.ui.getCore().byId(e.relatedControlId).getFocusDomRef())){var i;if(this.iSelectedIndex!=-1){i=this.iSelectedIndex;}else if(this.iFocusedIndex!=-1){i=this.iFocusedIndex;}else{i=0;}this.setFocusedIndex(i);var d;if(q(this.oDomRef).data("sap.INItem")){var p;d=q(this.oDomRef);while(!p){d=d.parent();if(d.data("sap.INRoot")){p=d.get(0);}}if(!e.relatedControlId||c(p,sap.ui.getCore().byId(e.relatedControlId).getFocusDomRef())){q(this.aItemDomRefs[this.iFocusedIndex]).attr("tabindex",-1);}}d=q(this.oDomRef);if(d.data("sap.InNavArea")===false){d.data("sap.InNavArea",true);}this.fireEvent(I.Events.FocusLeave,{index:i,event:e});}};
I.prototype.onmousedown=function(e){var s=e.target;var b=function(d,o){var f=false;var C=q(d);while(!C.is(":sapFocusable")&&C.get(0)!=o){C=C.parent();}if(C.get(0)!=o){f=true;}return f;};if(c(this.oDomRef,s)){for(var i=0;i<this.aItemDomRefs.length;i++){var o=this.aItemDomRefs[i];if(c(o,s)){if(!this.bTableMode){this.focusItem(i,e);}else{if(o===s||!b(s,o)){this.focusItem(i,e);}}return;}}if(s==this.oDomRef){this._bMouseDownHappened=true;var t=this;window.setTimeout(function(){t._bMouseDownHappened=false;},20);}}};
I.prototype.onsapnext=function(e){if(!c(this.oDomRef,e.target)){return;}if(q(this.oDomRef).data("sap.InNavArea")){return;}if(this.bTableMode&&this.aItemDomRefs.indexOf(e.target)===-1){return;}var i=this.iFocusedIndex,f=true,b=false;if(i>-1){if(this.bTableMode){var r=this.aItemDomRefs.length/this.iColumns,R=Math.floor(i/this.iColumns),C=i%this.iColumns;if(e.keyCode==K.ARROW_DOWN){if(R<r-1){i+=this.iColumns;}}else{if(C<this.iColumns-1){i+=1;}}}else{do{if(this.iColumns>1&&e.keyCode==K.ARROW_DOWN){if((i+this.iColumns)>=this.aItemDomRefs.length){if(!this.bNoColumnChange){if((i%this.iColumns)<(this.iColumns-1)){i=(i%this.iColumns)+1;}else if(this.bCycling){i=0;}}else{i=this.iFocusedIndex;b=true;}}else{i=i+this.iColumns;}}else{if(i==this.aItemDomRefs.length-1){if(q(this.oDomRef).data("sap.INItem")){return;}else if(this.bCycling){i=0;}else{i=this.iFocusedIndex;b=true;}}else{i++;}}if(i===this.iFocusedIndex){if(f){f=false;}else{throw new Error("ItemNavigation has no visible/existing items and is hence unable to select the next one");}}}while(!this.aItemDomRefs[i]||!q(this.aItemDomRefs[i]).is(":sapFocusable"));}this.focusItem(i,e);if(b){this.fireEvent(I.Events.BorderReached,{index:i,event:e});}e.preventDefault();e.stopPropagation();}};
I.prototype.onsapnextmodifiers=function(e){if(this.hasDisabledModifier(e)){return;}this.onsapnext(e);};
I.prototype.onsapprevious=function(e){if(!c(this.oDomRef,e.target)){return;}if(q(this.oDomRef).data("sap.InNavArea")){return;}if(this.bTableMode&&this.aItemDomRefs.indexOf(e.target)===-1){return;}var i=this.iFocusedIndex,f=true,b=false;var C=0;if(i>-1){if(this.bTableMode){var r=Math.floor(i/this.iColumns);C=i%this.iColumns;if(e.keyCode==K.ARROW_UP){if(r>0){i-=this.iColumns;}}else{if(C>0){i-=1;}}}else{do{if(this.iColumns>1&&e.keyCode==K.ARROW_UP){if((i-this.iColumns)<0){if(!this.bNoColumnChange){C=0;if((i%this.iColumns)>0){C=(i%this.iColumns)-1;}else if(this.bCycling){C=Math.min(this.iColumns-1,this.aItemDomRefs.length-1);}if(i===0&&C===0){i=0;}else{var R=Math.ceil(this.aItemDomRefs.length/this.iColumns);i=C+((R-1)*this.iColumns);if(i>=this.aItemDomRefs.length){i=i-this.iColumns;}}}else{i=this.iFocusedIndex;b=true;}}else{i=i-this.iColumns;}}else{if(i==0){if(q(this.oDomRef).data("sap.INItem")){return;}else if(this.bCycling){i=this.aItemDomRefs.length-1;}else{i=this.iFocusedIndex;b=true;}}else{i--;}}if(i==this.iFocusedIndex){if(f){f=false;}else{throw new Error("ItemNavigation has no visible/existing items and is hence unable to select the previous one");}}}while(!this.aItemDomRefs[i]||!q(this.aItemDomRefs[i]).is(":sapFocusable"));}this.focusItem(i,e);if(b){this.fireEvent(I.Events.BorderReached,{index:i,event:e});}e.preventDefault();e.stopPropagation();}};
I.prototype.onsappreviousmodifiers=function(e){if(this.hasDisabledModifier(e)){return;}this.onsapprevious(e);};
I.prototype.onsappageup=function(e){if(!c(this.oDomRef,e.target)){return;}if(this.bTableMode&&this.aItemDomRefs.indexOf(e.target)===-1){return;}var i=0;var b=false;if(this.iPageSize>0){i=this.iFocusedIndex;if(i>-1){i=i-this.iPageSize;while(i>0&&!q(this.aItemDomRefs[i]).is(":sapFocusable")){i--;}if(i<0){if(!this.bNoColumnChange){i=0;}else{i=this.iFocusedIndex;b=true;}}this.focusItem(i,e);}}else if(this.bTableMode){i=this.iFocusedIndex%this.iColumns;this.focusItem(i,e);}if(b){this.fireEvent(I.Events.BorderReached,{index:i,event:e});}e.preventDefault();e.stopPropagation();};
I.prototype.onsappagedown=function(e){if(!c(this.oDomRef,e.target)){return;}if(this.bTableMode&&this.aItemDomRefs.indexOf(e.target)===-1){return;}var i=0;var b=false;if(this.iPageSize>0){i=this.iFocusedIndex;if(i>-1){i=i+this.iPageSize;while(i<this.aItemDomRefs.length-1&&!q(this.aItemDomRefs[i]).is(":sapFocusable")){i++;}if(i>this.aItemDomRefs.length-1){if(!this.bNoColumnChange){i=this.aItemDomRefs.length-1;}else{i=this.iFocusedIndex;b=true;}}this.focusItem(i,e);}}else if(this.bTableMode){var r=this.aItemDomRefs.length/this.iColumns,C=this.iFocusedIndex%this.iColumns;i=(r-1)*this.iColumns+C;this.focusItem(i,e);}if(b){this.fireEvent(I.Events.BorderReached,{index:i,event:e});}e.preventDefault();e.stopPropagation();};
I.prototype.onsaphome=function(e){if(!c(this.oDomRef,e.target)){return;}if(this.bTableMode&&this.aItemDomRefs.indexOf(e.target)===-1){return;}var i=0;var r=0;if(this.bTableMode){if(!this.bTableList&&!(e.metaKey||e.ctrlKey)){r=Math.floor(this.iFocusedIndex/this.iColumns);i=r*this.iColumns;}}else{if(!!(e.metaKey||e.ctrlKey)&&!this._bCtrlEnabled){return;}if(this._bStayInRow&&!(this._bCtrlEnabled&&(e.metaKey||e.ctrlKey))&&this.iColumns>0){r=Math.floor(this.iFocusedIndex/this.iColumns);i=r*this.iColumns;}else{while(!this.aItemDomRefs[i]||!q(this.aItemDomRefs[i]).is(":sapFocusable")){i++;if(i==this.aItemDomRefs.length){return;}}}}this.focusItem(i,e);e.preventDefault();e.stopPropagation();};
I.prototype.onsaphomemodifiers=function(e){if(this.hasDisabledModifier(e)){return;}this.onsaphome(e);};
I.prototype.onsapend=function(e){if(!c(this.oDomRef,e.target)){return;}if(this.bTableMode&&this.aItemDomRefs.indexOf(e.target)===-1){return;}var i=this.aItemDomRefs.length-1;var r=0;if(this.bTableMode){if(!this.bTableList&&!(e.metaKey||e.ctrlKey)){r=Math.floor(this.iFocusedIndex/this.iColumns);i=r*this.iColumns+this.iColumns-1;}}else{if(!!(e.metaKey||e.ctrlKey)&&!this._bCtrlEnabled){return;}if(this._bStayInRow&&!(this._bCtrlEnabled&&(e.metaKey||e.ctrlKey))&&this.iColumns>0){r=Math.floor(this.iFocusedIndex/this.iColumns);i=(r+1)*this.iColumns-1;if(i>=this.aItemDomRefs.length){i=this.aItemDomRefs.length-1;}}else{while(!this.aItemDomRefs[i]||!q(this.aItemDomRefs[i]).is(":sapFocusable")){i--;if(i<0){return;}}}}this.focusItem(i,e);e.preventDefault();e.stopPropagation();};
I.prototype.onsapendmodifiers=function(e){if(this.hasDisabledModifier(e)){return;}this.onsapend(e);};
I.prototype.setTabIndex0=function(){this.iTabIndex=0;this.iActiveTabIndex=0;};
I.prototype.onkeyup=function(e){if(e.keyCode==K.F2){var d=q(this.oDomRef);if(d.data("sap.InNavArea")){d.data("sap.InNavArea",false);}else if(d.data("sap.InNavArea")===false){d.data("sap.InNavArea",true);}e.preventDefault();e.stopPropagation();}};
return I;});
sap.ui.predefine('sap/ui/core/delegate/ScrollEnablement',['sap/ui/Device','sap/ui/base/Object','sap/ui/core/IntervalTrigger','sap/ui/core/ResizeHandler',"sap/ui/thirdparty/jquery","sap/ui/events/KeyCodes"],function(D,B,I,R,q,K){"use strict";
var S=B.extend("sap.ui.core.delegate.ScrollEnablement",{
constructor:function(c,s,C){B.apply(this);this._oControl=c;this._oControl.addDelegate(this);this._sContentId=s;this._sContainerId=C.scrollContainerId;this._bHorizontal=!!C.horizontal;this._bVertical=!!C.vertical;this._scrollX=0;this._scrollY=0;this._scrollCoef=0.9;this._iLastMaxScrollTop=0;i(this);if(this._init){this._init.apply(this,arguments);}},
setHorizontal:function(h){this._bHorizontal=!!h;this._setOverflow&&this._setOverflow();},
setVertical:function(v){this._bVertical=!!v;this._setOverflow&&this._setOverflow();},
getHorizontal:function(){return this._bHorizontal;},
getVertical:function(){return this._bVertical;},
setBounce:function(b){},
setPullDown:function(c){this._oPullDown=c;return this;},
setGrowingList:function(s,a,o){this._fnScrollLoadCallback=s;this._sScrollLoadDirection=a;this.onOverflowChange(o);return this;},
onOverflowChange:function(c){this._fnOverflowChangeCallback=c;if(!this._fnOverflowChangeCallback){this._deregisterOverflowMonitor();}},
setIconTabBar:function(o,s,f){this._oIconTabBar=o;this._fnScrollEndCallback=q.proxy(s,o);this._fnScrollStartCallback=q.proxy(f,o);return this;},
scrollTo:function(x,y,t,s){this._scrollX=x;this._scrollY=y;this._scrollTo(x,y,t,s);return this;},
getChildPosition:function(e){var E=e instanceof q?e:q(e),o=E.position(),O=E.offsetParent(),a;while(!O.is(this._$Container)){a=O.position();o.top+=a.top;o.left+=a.left;O=O.offsetParent();}return o;},
scrollToElement:function(e,t,o){o=o||[0,0];if(!this._$Container[0].contains(e)||e.style.display==="none"||e.offsetParent.nodeName.toUpperCase()==="HTML"){return this;}var E=q(e),s=this.getChildPosition(E),l=this.getScrollLeft()+s.left+o[0],T=this.getScrollTop()+s.top+o[1];if(this._bFlipX){l=this.getScrollLeft()-(s.left-this._$Container.width())-E.width();}this._scrollTo(l,T,t);return this;},
destroy:function(){if(this._exit){this._exit();}if(this._oControl){this._oControl.removeDelegate(this);this._oControl=undefined;}},
refresh:function(){if(this._refresh){this._refresh();}},
_useDefaultScroll:function(t){return t.isContentEditable;},
onkeydown:function(e){if(this._useDefaultScroll(e.target)){return;}var c=this._$Container[0];if(e.altKey&&this.getHorizontal()){switch(e.keyCode){case K.PAGE_UP:this._customScrollTo(this._scrollX-c.clientWidth,this._scrollY,e);break;case K.PAGE_DOWN:this._customScrollTo(this._scrollX+c.clientWidth,this._scrollY,e);break;}}if(e.ctrlKey){switch(e.keyCode){case K.ARROW_UP:if(this.getVertical()){this._customScrollTo(this._scrollX,this._scrollY-c.clientHeight*this._scrollCoef,e);}break;case K.ARROW_DOWN:if(this.getVertical()){this._customScrollTo(this._scrollX,this._scrollY+c.clientHeight*this._scrollCoef,e);}break;case K.ARROW_LEFT:if(this.getHorizontal()){this._customScrollTo(this._scrollX-c.clientWidth,this._scrollY,e);}break;case K.ARROW_RIGHT:if(this.getHorizontal()){this._customScrollTo(this._scrollX+c.clientWidth,this._scrollY,e);}break;case K.HOME:if(this.getHorizontal()){this._customScrollTo(0,this._scrollY,e);}if(this.getVertical()){this._customScrollTo(this._scrollX,0,e);}break;case K.END:var l=c.scrollWidth-c.clientWidth;var t=c.scrollHeight-c.clientHeight;if(!this.getHorizontal()){t=this._scrollY;}if(!this.getVertical()){l=this._scrollX;}this._customScrollTo(l,t,e);break;}}},
_customScrollTo:function(l,t,e){var N=e.target.nodeName;if(N!="INPUT"&&N!="TEXTAREA"){e.preventDefault();e.setMarked();this._scrollTo(l,t);}}
});
var n={getScrollTop:function(){return this._scrollY||0;},getScrollLeft:function(){return this._scrollX||0;},getScrollHeight:function(){var c=this._$Container;return(c&&c[0])?c[0].scrollHeight:0;},getMaxScrollTop:function(){var c=this._$Container;return(c&&c[0])?c[0].scrollHeight-c[0].clientHeight:-1;},getContainerDomRef:function(){return this._$Container&&this._$Container[0];},_cleanup:function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this._deregisterOverflowMonitor();},_setOverflow:function(){var c=this._$Container;if(!c||!c[0]){return;}if(D.os.ios){c.css("overflow-x",this._bHorizontal&&!this._bDragScroll?"scroll":"hidden").css("overflow-y",this._bVertical&&!this._bDragScroll?"scroll":"hidden").css("-webkit-overflow-scrolling","touch");}else{c.css("overflow-x",this._bHorizontal&&!this._bDragScroll?"auto":"hidden").css("overflow-y",this._bVertical&&!this._bDragScroll?"auto":"hidden");}},_refresh:function(){var c=this._$Container;if(!(c&&c.length)){return;}if(this._oPullDown&&this._oPullDown._bTouchMode){var d=this._oPullDown.getDomRef();if(d){d.style.marginTop=this._oPullDown._iState==2?"":"-"+d.offsetHeight+"px";}}if(c.scrollTop()!=this._scrollY){c.scrollTop(this._scrollY);}if(!(this._oPullDown&&this._oPullDown._bTouchMode)&&!this._fnScrollLoadCallback&&!D.browser.msie){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}},_onScroll:function(){var c=this._$Container,s=c.scrollTop(),v=s-this._scrollY;this._scrollX=c.scrollLeft();this._scrollY=s;if(this._fnScrollLoadCallback){if(this._sScrollLoadDirection=="Upwards"){if(v<0&&s<10){this._fnScrollLoadCallback();}}else if(v>=0&&c[0].scrollHeight-s-c[0].clientHeight<100){this._fnScrollLoadCallback();}}if(this._oIconTabBar&&this._fnScrollEndCallback){this._fnScrollEndCallback();}},_onStart:function(e){var c=this._$Container[0];if(!c){return;}this._bDoDrag=this._bDragScroll;var p=e.touches?e.touches[0]:e;this._iX=p.pageX;this._iY=p.pageY;this._bPullDown=false;this._iDirection="";},_onTouchMove:function(e){var c=this._$Container[0];var p=e.touches?e.touches[0]:e;var d=p.pageX-this._iX;var a=p.pageY-this._iY;if(this._iDirection==""){if(d!=0||a!=0){this._iDirection=Math.abs(a)>Math.abs(d)?"v":"h";}if(this._oPullDown&&this._oPullDown._bTouchMode&&this._iDirection=="v"&&c.scrollTop<=1){if(a>Math.abs(d)){this._bPullDown=true;}}}if(this._bPullDown===true){var b=this._oPullDown.getDomRef();var t=e.touches[0].pageY-this._iY-b.offsetHeight;if(t>20){t=20;}b.style.marginTop=t+"px";this._oPullDown.doPull(t);e.preventDefault();this._bDoDrag=false;}if(this._bDoDrag){var s=c.scrollLeft,f=c.scrollTop;if(this._bHorizontal){if(this._bFlipX){c.scrollLeft=s-this._iX+p.pageX;}else{c.scrollLeft=s+this._iX-p.pageX;}}if(this._bVertical){c.scrollTop=f+this._iY-p.pageY;}if((c.scrollLeft!=s)||(c.scrollTop!=f)){e.setMarked&&e.setMarked();e.preventDefault();}this._iX=p.pageX;this._iY=p.pageY;return;}},_onEnd:function(e){if(this._oPullDown&&this._oPullDown._bTouchMode){this._oPullDown.doScrollEnd();this._refresh();}if(this._bDragScroll&&this._iDirection){e.setMarked&&e.setMarked();}},_onMouseDown:function(e){if(this._bDragScroll&&e.button==0){this._bScrolling=true;this._onStart(e);}},_onMouseMove:function(E){if(this._bScrolling){var e=E.originalEvent||E;var b=e.buttons||e.which;if(b==1||E.pressure){var c=this._$Container[0];if(this._bHorizontal){if(this._bFlipX){c.scrollLeft=c.scrollLeft-this._iX+E.pageX;}else{c.scrollLeft=c.scrollLeft+this._iX-E.pageX;}}if(this._bVertical){c.scrollTop=c.scrollTop+this._iY-E.pageY;}this._iX=E.pageX;this._iY=E.pageY;}}},_onMouseUp:function(){if(this._bScrolling){this._bScrolling=false;this._onEnd();}},onBeforeRendering:function(){if(this._sResizeListenerId){R.deregister(this._sResizeListenerId);this._sResizeListenerId=null;}this._deregisterOverflowMonitor();var c=this._$Container;if(c){if(c.height()>0){this._scrollX=c.scrollLeft();this._scrollY=c.scrollTop();}c.off();}},_checkOverflowChange:function(e){var m=this.getMaxScrollTop(),o=m>0&&this._iLastMaxScrollTop===0,u=m===0&&this._iLastMaxScrollTop>0,O=o||u;if(O){this._fnOverflowChangeCallback(o,m);}this._iLastMaxScrollTop=m;},_registerOverflowMonitor:function(){this._fnOverflowChangeCallback&&I.addListener(this._checkOverflowChange,this);},_deregisterOverflowMonitor:function(){I.removeListener(this._checkOverflowChange,this);},onAfterRendering:function(){var c=this._$Container=this._sContainerId?q(document.getElementById(this._sContainerId)):q(document.getElementById(this._sContentId)).parent();var _=q.proxy(this._refresh,this);var e=c.is(":visible");this._setOverflow();if(this._scrollX!==0||this._scrollY!==0){this._scrollTo(this._scrollX,this._scrollY);}this._refresh();if(!e||D.browser.msie||this._oPullDown||this._fnScrollLoadCallback){this._sResizeListenerId=R.register(c[0],_);}if(this._fnOverflowChangeCallback){this._iOverflowTimer&&window.cancelAnimationFrame(this._iOverflowTimer);this._iOverflowTimer=window.requestAnimationFrame(this._registerOverflowMonitor.bind(this));}c.on("scroll",this._onScroll.bind(this));var C=c[0];function a(E,l){E.split(" ").forEach(function(s){C&&C.addEventListener(s,l);});}function o(E){return E.pointerType=="touch"?this._onStart(E):this._onMouseDown(E);}function b(E){return E.pointerType=="touch"?this._onTouchMove(E):this._onMouseMove(E);}function d(E){return E.pointerType=="touch"?this._onEnd(E):this._onMouseUp(E);}if(D.support.pointer&&D.system.desktop){if(this._bDragScroll){a("pointerdown",o.bind(this));a("pointermove",b.bind(this));a("pointerup pointercancel pointerleave",d.bind(this));}}else if(D.support.touch){if(this._bDragScroll||this._oPullDown&&this._oPullDown._bTouchMode){c.on("touchcancel touchend",this._onEnd.bind(this)).on("touchstart",this._onStart.bind(this)).on("touchmove",this._onTouchMove.bind(this));}}else if(this._bDragScroll){c.on("mouseup mouseleave",this._onMouseUp.bind(this)).on("mousedown",this._onMouseDown.bind(this)).on("mousemove",this._onMouseMove.bind(this));}},_readActualScrollPosition:function(){if(this._$Container.width()>0){this._scrollX=this._$Container.scrollLeft();}if(this._$Container.height()>0){this._scrollY=this._$Container.scrollTop();}},_scrollTo:function(x,y,t,s){if(this._$Container.length>0){if(t>0){this._$Container.finish().animate({scrollTop:y,scrollLeft:x},t,q.proxy(function(){this._readActualScrollPosition();s&&s();},this));}else{this._$Container.scrollTop(y);this._$Container.scrollLeft(x);this._readActualScrollPosition();s&&s();}}}};
function i(s){var d={_init:function(c,a,C){if(q.event&&q.event.special&&q.event.special.swipe&&q.event.special.swipe.scrollSupressionThreshold<120){q.event.special.swipe.scrollSupressionThreshold=120;}Object.assign(this,n);if(C.nonTouchScrolling===true){this._bDragScroll=true;}if(sap.ui.getCore().getConfiguration().getRTL()){this._scrollX=9999;if(D.browser.msie||D.browser.edge){this._bFlipX=true;}}},_exit:function(){if(this._cleanup){this._cleanup();}}};Object.assign(s,d);}
return S;});
sap.ui.predefine('sap/ui/core/dnd/DragAndDrop',["sap/ui/Device","../UIArea",'sap/base/util/extend',"sap/ui/thirdparty/jquery","sap/ui/dom/jquery/control"],function(D,U,e,q){"use strict";var a={},d=null,o=null,v=null,V=[],b=[],c=null,$,f,g,C,t,l={},h;
function j(i,S){if(!i){return;}if(i.addStyleClass){i.addStyleClass(S);}else{i.$().addClass(S);}}
function r(i,S){if(!i){return;}if(i.removeStyleClass){i.removeStyleClass(S);}else{i.$().removeClass(S);}}
function k(i,F){var G=q(i.target).control(0,true);if(!G){return;}var N=q.Event(null,i);N.type=F;G.getUIArea()._handleEvent(N);}
function m(i){return!i.disabled&&/^(input|textarea)$/.test(i.localName);}
function s(d,i){if(D.browser.msie||!d||!d.getDragGhost){return;}var F=d.getDragGhost();if(!F){return;}if(!g){g=q('<div class="sapUiDnDGhostContainer"></div>');q(document.body).append(g);}g.append(F);window.setTimeout(function(){g.empty();},0);var O=i.originalEvent;O.dataTransfer.setDragImage(F,O.offsetX,O.offsetY);}
function n(i){var F={},I,G=i.originalEvent.dataTransfer,H=function(T,J){if(G&&T=="text"||(D.browser!="msie"&&D.browser!="edge")){G.setData(T,J);}};return{setData:function(K,J){J=""+J;F[K]=J;H(K,J);},getData:function(K){return F[K];},setTextData:function(J){J=""+J;F["text/plain"]=J;F["text"]=J;H("text/plain",J);H("text",J);},getTextData:function(){return F["text/plain"];},setComplexData:function(K,J){F[K]=J;},getComplexData:function(K){return F[K];},getIndicator:function(){return $&&$[0];},setIndicatorConfig:function(J){I=J;},getIndicatorConfig:function(J){return I;},getDragControl:function(){return d;},getDropControl:function(){return v;},setDropControl:function(J){v=J;},getDropInfo:function(){return b[0]||null;},getDropPosition:function(){return C;}};}
function p(i){d=o=v=c=null;C="";V=[];b=[];}
function u(){if($){return $;}if(!D.browser.msie){f=q("<div class='sapUiDnDIndicatorWrapper'></div>");}$=q("<div class='sapUiDnDIndicator'></div>");if(!f){q(sap.ui.getCore().getStaticAreaRef()).append($);}else{q(sap.ui.getCore().getStaticAreaRef()).append(f);$.appendTo(f);}return $;}
function w(){if($){$.removeAttr("style").hide();l={};}}
function x(i,F,G,H){if(!F){return;}var I=i.dragSession&&i.dragSession.getIndicatorConfig(),J=F.getBoundingClientRect(),P=window.pageYOffset,K=window.pageXOffset,L=u(),R,S={},M={top:J.top+P,bottom:J.bottom+P,left:J.left+K,right:J.right+K,width:J.width,height:J.height};if(!G||G=="On"){R="On";H="";}else if(H=="Horizontal"){var N=i.pageX-M.left;S.height=M.height;S.top=M.top;if(G=="Between"){S.width="";if(N<M.width*0.5){R="Before";S.left=M.left;}else{R="After";S.left=M.right;}}else if(G=="OnOrBetween"){if(N<M.width*0.25){R="Before";S.left=M.left;S.width="";}else if(N>M.width*0.75){R="After";S.left=M.right;S.width="";}else{R="On";}}if(R!="On"&&sap.ui.getCore().getConfiguration().getRTL()){R=(R=="After")?"Before":"After";}}else{var O=i.pageY-M.top;S.width=M.width;S.left=M.left;if(G=="Between"){S.height="";if(O<M.height*0.5){R="Before";S.top=M.top;}else{R="After";S.top=M.bottom;}}else if(G=="OnOrBetween"){if(O<M.height*0.25){R="Before";S.top=M.top;S.height="";}else if(O>M.height*0.75){R="After";S.top=M.bottom;S.height="";}else{R="On";}}}if(I&&I.display=="none"){return R;}if(R=="On"){S.top=M.top;S.left=M.left;S.width=M.width;S.height=M.height;G=R;}else{G="Between";}if(l.top!=S.top||l.left!=S.left||l.width!=S.width||l.height!=S.height){L.attr("data-drop-layout",H);L.attr("data-drop-position",G);L.css(e(S,I)).show();l=S;}return R;}
function y(i){var P=i.getParent(),S=(i.getDragDropConfig)?i.getDragDropConfig():[],F=(P&&P.getDragDropConfig)?P.getDragDropConfig():[];return S.concat(F);}
function z(d){var i=y(d);return i.filter(function(F){return F.isDraggable(d);});}
function A(o,i,F){var G=y(o);i=i||[];return G.filter(function(H){return!H.isA("sap.ui.core.dnd.IDragInfo");}).concat(i).filter(function(H){if(!H.isDroppable(o,F)){return false;}var I=H.getGroupName();if(!I){return true;}return i.some(function(J){return J.getGroupName()==I;});});}
function B(i,F){i.preventDefault();var G=F.getDropEffect().toLowerCase();i.originalEvent.dataTransfer.dropEffect=G;}
function E(i,F,v){var T=F.getTargetAggregation();if(!T){return x(i,v.getDomRef());}var G;if(i.getMark("DragWithin")==T){G=v.getDomRefForSetting(T);}G=G||v.getDomRef();return x(i,G,F.getDropPosition(true),F.getDropLayout(true));}
a.preprocessEvent=function(i){if(c&&i.type.indexOf("dr")==0){i.dragSession=c;}var F="onbefore"+i.type;if(a[F]){a[F](i);}};
a.postprocessEvent=function(i){var F="onafter"+i.type;if(a[F]){a[F](i);}};
a.onbeforemousedown=function(i){if((D.browser.msie||D.browser.firefox||D.browser.edge)&&m(i.target)){h=q(i.target).closest("[data-sap-ui-draggable=true]").prop("draggable",false)[0];}};
a.onbeforemouseup=function(i){if(h){h.draggable=true;h=null;}};
a.onbeforedragstart=function(i){if(!i.target.draggable){return;}if(m(document.activeElement)){i.target.getAttribute("data-sap-ui-draggable")&&i.preventDefault();return;}d=q(i.target).control(0,true);if(!d){return;}V=z(d);if(!V.length){return;}if(D.browser.firefox&&i.originalEvent.dataTransfer.types.length===0){i.originalEvent.dataTransfer.setData("ui5/dummyDataForFirefox","data");}i.dragSession=c=n(i);};
a.onafterdragstart=function(i){if(!V.length||i.isDefaultPrevented()){p();return;}V=i.isMarked("NonDraggable")?[]:V.filter(function(F){return F.fireDragStart(i);});if(!V.length){i.preventDefault();p();return;}s(d,i);j(d,"sapUiDnDDragging");q("html").addClass("sapUiDnDNoScrolling");};
a.onbeforedragenter=function(F){var G=q(F.target).control(0,true);if(G&&o===G){F.setMark("DragWithin","SameControl");}else{t=Date.now();o=G;}var H=[];v=G;for(var i=0;i<20&&v;i++,v=v.getParent()){H=A(v,V,F);if(H.length){break;}}if(F.getMark("DragWithin")!="SameControl"){b=H;if(c){c.setIndicatorConfig(null);}}if(!b.length){v=null;}else if(!c){F.dragSession=c=n(F);}};
a.onafterdragenter=function(i){if(!v||i.isMarked("NonDroppable")){b=[];}else if(i.getMark("DragWithin")!="SameControl"){b=b.filter(function(G){return G.fireDragEnter(i);});}var F=b[0];if(!F||F.getDropEffect()=="None"){w();C="";}else{B(i,F);C=E(i,F,v);}};
a.onbeforedragover=function(i){var F=Date.now();if(F-t>=1000){k(i,"longdragover");t=F;}};
a.onafterdragover=function(i){var F=b[0];if(!F||F.getDropEffect()=="None"){return;}b.forEach(function(G){G.fireDragOver(i);});B(i,F);if(F&&F.getDropPosition(true)=="On"){return;}C=E(i,F,v);};
a.onbeforedrop=function(i){if(b.length){i.preventDefault();}};
a.onafterdrop=function(i){b.forEach(function(F){F.fireDrop(i);});this.iDragEndTimer=window.requestAnimationFrame(this.onafterdragend.bind(this,i));};
a.onafterdragend=function(i){this.iDragEndTimer=window.cancelAnimationFrame(this.iDragEndTimer);V.forEach(function(F){F.fireDragEnd(i);});r(d,"sapUiDnDDragging");q("html").removeClass("sapUiDnDNoScrolling");w();p();};
U.addEventPreprocessor(a.preprocessEvent);U.addEventPostprocessor(a.postprocessEvent);return a;},true);
sap.ui.predefine('sap/ui/core/dnd/DragDropBase',['../Element','../library','sap/base/Log','./DragAndDrop'],function(E,l,L){"use strict";
var D=E.extend("sap.ui.core.dnd.DragDropBase",{metadata:{"abstract":true,library:"sap.ui.core",properties:{groupName:{type:"string",defaultValue:null,invalidate:false},enabled:{type:"boolean",defaultValue:true}}}});
D.prototype.bIgnoreMetadataCheck=false;
D.prototype.isDraggable=function(c){return false;};
D.prototype.isDroppable=function(c,e){return false;};
D.prototype.checkMetadata=function(c,a,r){if(this.bIgnoreMetadataCheck){return true;}var m=c.getMetadata().getDragDropInfo(a);if(!m[r]){L.warning((a?a+" aggregation of ":"")+c+" is not configured to be "+r);return false;}return true;};
D.prototype.setEnabled=function(e){return this.setProperty("enabled",e,!this.isA("sap.ui.core.dnd.IDragInfo"));};
D.prototype.setProperty=function(p,v,s){s=s||(this.getMetadata().getProperty(p).appData||{}).invalidate===false;return E.prototype.setProperty.call(this,p,v,s);};
return D;});
sap.ui.predefine('sap/ui/core/dnd/DragDropInfo',["./DragInfo","./DropInfo","sap/ui/Device","sap/base/Log"],function(D,a,b,L){"use strict";
var c=a.extend("sap.ui.core.dnd.DragDropInfo",{metadata:{library:"sap.ui.core",interfaces:["sap.ui.core.dnd.IDragInfo","sap.ui.core.dnd.IDropInfo"],properties:{sourceAggregation:{type:"string",defaultValue:null}},associations:{targetElement:{type:"sap.ui.core.Element",multiple:false}},events:{dragStart:{allowPreventDefault:true},dragEnd:{}}}});
c.prototype.isDraggable=D.prototype.isDraggable;c.prototype.fireDragEnd=D.prototype.fireDragEnd;
c.prototype.fireDragStart=function(e){if(b.browser.msie){e.originalEvent.dataTransfer.effectAllowed=this.getDropEffect().toLowerCase();}return D.prototype.fireDragStart.apply(this,arguments);};
c.prototype.getDropTarget=function(){var t=this.getTargetElement();if(t){return sap.ui.getCore().byId(t);}return this.getParent();};
c.prototype.setGroupName=function(){L.error("groupName property must not be set on "+this);return this;};
return c;});
sap.ui.predefine('sap/ui/core/dnd/DragInfo',["./DragDropBase"],function(D){"use strict";
var a=D.extend("sap.ui.core.dnd.DragInfo",{metadata:{library:"sap.ui.core",interfaces:["sap.ui.core.dnd.IDragInfo"],properties:{sourceAggregation:{type:"string",defaultValue:null}},events:{dragStart:{allowPreventDefault:true},dragEnd:{}}}});
a.prototype.isDraggable=function(c){if(!this.getEnabled()){return false;}var d=this.getParent();if(!d){return false;}var s=this.getSourceAggregation();if(!this.checkMetadata(d,s,"draggable")){return false;}if(d===c&&!s){return true;}if(c.getParent()===d&&s===c.sParentAggregationName){return true;}return false;};
a.prototype.fireDragStart=function(e){if(!e||!e.dragSession){return;}var d=e.dragSession;return this.fireEvent("dragStart",{dragSession:d,browserEvent:e.originalEvent,target:d.getDragControl()},true);};
a.prototype.fireDragEnd=function(e){if(!e||!e.dragSession){return;}var d=e.dragSession;return this.fireEvent("dragEnd",{dragSession:d,browserEvent:e.originalEvent,target:d.getDragControl()});};
return a;});
sap.ui.predefine('sap/ui/core/dnd/DropInfo',["./DragDropBase"],function(D){"use strict";
var a=D.extend("sap.ui.core.dnd.DropInfo",{metadata:{library:"sap.ui.core",interfaces:["sap.ui.core.dnd.IDropInfo"],properties:{targetAggregation:{type:"string",defaultValue:null,invalidate:false},dropEffect:{type:"sap.ui.core.dnd.DropEffect",defaultValue:"Move",invalidate:false},dropPosition:{type:"sap.ui.core.dnd.DropPosition",defaultValue:"On",invalidate:false},dropLayout:{type:"sap.ui.core.dnd.DropLayout",defaultValue:"Default",invalidate:false}},events:{dragEnter:{allowPreventDefault:true},dragOver:{},drop:{}}}});
a.prototype.getDropTarget=function(){return this.getParent();};
a.prototype.isDroppable=function(c,e){this.sTemporaryDropPosition="";if(!this.getEnabled()){return false;}var d=this.getDropTarget();if(!d){return false;}var t=this.getTargetAggregation();if(!this.checkMetadata(d,t,"droppable")){return false;}var t=this.getTargetAggregation();if(d===c&&!t){return true;}if(c.getParent()===d&&t===c.sParentAggregationName){return true;}if(e&&t&&d===c){var A=c.getDomRefForSetting(t);if(A&&A!=e.target&&A.contains(e.target)){e.setMark("DragWithin",t);this.sTemporaryDropPosition="On";return true;}}return false;};
a.prototype.getDropPosition=function(c){if(c&&this.sTemporaryDropPosition){return this.sTemporaryDropPosition;}return this.getProperty("dropPosition");};
a.prototype.getDropLayout=function(d){var s=this.getProperty("dropLayout");if(!d||s!="Default"){return s;}return this.getDropTarget().getMetadata().getDragDropInfo(this.getTargetAggregation()).layout;};
a.prototype.fireDragEnter=function(e){if(!e||!e.dragSession){return;}var d=e.dragSession;return this.fireEvent("dragEnter",{dragSession:e.dragSession,browserEvent:e.originalEvent,target:d.getDropControl()},true);};
a.prototype.fireDragOver=function(e){if(!e||!e.dragSession){return;}var d=e.dragSession;return this.fireEvent("dragOver",{dragSession:e.dragSession,browserEvent:e.originalEvent,target:d.getDropControl(),dropPosition:d.getDropPosition()});};
a.prototype.fireDrop=function(e){if(!e||!e.dragSession){return;}var d=e.dragSession;this.fireEvent("drop",{dragSession:e.dragSession,browserEvent:e.originalEvent,dropPosition:d.getDropPosition(),draggedControl:d.getDragControl(),droppedControl:d.getDropControl()});};
return a;});
sap.ui.predefine('sap/ui/core/format/DateFormat',['sap/ui/core/CalendarType','sap/ui/core/Locale','sap/ui/core/LocaleData','sap/ui/core/date/UniversalDate',"sap/base/util/deepEqual","sap/base/strings/formatMessage","sap/base/Log","sap/base/util/extend"],function(C,L,a,U,d,f,b,e){"use strict";var D=function(){throw new Error();};var c={};D.oDateInfo={oDefaultFormatOptions:{style:"medium",relativeScale:"day",relativeStyle:"wide"},aFallbackFormatOptions:[{style:"short"},{style:"medium"},{pattern:"yyyy-MM-dd"},{pattern:"yyyyMMdd",strictParsing:true}],bShortFallbackFormatOptions:true,bPatternFallbackWithoutDelimiter:true,getPattern:function(o,s,i){return o.getDatePattern(s,i);},oRequiredParts:{"text":true,"year":true,"weekYear":true,"month":true,"day":true},aRelativeScales:["year","month","week","day"],aRelativeParseScales:["year","quarter","month","week","day","hour","minute","second"],aIntervalCompareFields:["Era","FullYear","Quarter","Month","Week","Date"]};D.oDateTimeInfo={oDefaultFormatOptions:{style:"medium",relativeScale:"auto",relativeStyle:"wide"},aFallbackFormatOptions:[{style:"short"},{style:"medium"},{pattern:"yyyy-MM-dd'T'HH:mm:ss"},{pattern:"yyyyMMdd HHmmss"}],getPattern:function(o,s,i){var S=s.indexOf("/");if(S>0){return o.getCombinedDateTimePattern(s.substr(0,S),s.substr(S+1),i);}else{return o.getCombinedDateTimePattern(s,s,i);}},oRequiredParts:{"text":true,"year":true,"weekYear":true,"month":true,"day":true,"hour0_23":true,"hour1_24":true,"hour0_11":true,"hour1_12":true},aRelativeScales:["year","month","week","day","hour","minute","second"],aRelativeParseScales:["year","quarter","month","week","day","hour","minute","second"],aIntervalCompareFields:["Era","FullYear","Quarter","Month","Week","Date","DayPeriod","Hours","Minutes","Seconds"]};D.oTimeInfo={oDefaultFormatOptions:{style:"medium",relativeScale:"auto",relativeStyle:"wide"},aFallbackFormatOptions:[{style:"short"},{style:"medium"},{pattern:"HH:mm:ss"},{pattern:"HHmmss"}],getPattern:function(o,s,i){return o.getTimePattern(s,i);},oRequiredParts:{"text":true,"hour0_23":true,"hour1_24":true,"hour0_11":true,"hour1_12":true},aRelativeScales:["hour","minute","second"],aRelativeParseScales:["year","quarter","month","week","day","hour","minute","second"],aIntervalCompareFields:["DayPeriod","Hours","Minutes","Seconds"]};
D.getInstance=function(o,i){return this.getDateInstance(o,i);};
D.getDateInstance=function(o,i){return this.createInstance(o,i,this.oDateInfo);};
D.getDateTimeInstance=function(o,i){return this.createInstance(o,i,this.oDateTimeInfo);};
D.getTimeInstance=function(o,i){return this.createInstance(o,i,this.oTimeInfo);};
function g(o){var P=o.oLocaleData.getIntervalPattern("",o.oFormatOptions.calendarType);P=P.replace(/[^\{\}01 ]/,"-");return P.replace(/\{(0|1)\}/g,o.oFormatOptions.pattern);}
D.createInstance=function(o,i,I){var j=Object.create(this.prototype);if(o instanceof L){i=o;o=undefined;}if(!i){i=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();}j.oLocale=i;j.oLocaleData=a.getInstance(i);j.oFormatOptions=e({},I.oDefaultFormatOptions,o);if(!j.oFormatOptions.calendarType){j.oFormatOptions.calendarType=sap.ui.getCore().getConfiguration().getCalendarType();}if(!j.oFormatOptions.pattern){if(j.oFormatOptions.format){j.oFormatOptions.pattern=j.oLocaleData.getCustomDateTimePattern(j.oFormatOptions.format,j.oFormatOptions.calendarType);}else{j.oFormatOptions.pattern=I.getPattern(j.oLocaleData,j.oFormatOptions.style,j.oFormatOptions.calendarType);}}if(j.oFormatOptions.interval){if(j.oFormatOptions.format){j.intervalPatterns=j.oLocaleData.getCustomIntervalPattern(j.oFormatOptions.format,null,j.oFormatOptions.calendarType);if(typeof j.intervalPatterns==="string"){j.intervalPatterns=[j.intervalPatterns];}j.intervalPatterns.push(j.oLocaleData.getCustomDateTimePattern(j.oFormatOptions.format,j.oFormatOptions.calendarType));}else{j.intervalPatterns=[j.oLocaleData.getCombinedIntervalPattern(j.oFormatOptions.pattern,j.oFormatOptions.calendarType),j.oFormatOptions.pattern];}var s=g(j);j.intervalPatterns.push(s);}if(!j.oFormatOptions.fallback){if(!I.oFallbackFormats){I.oFallbackFormats={};}var n=i.toString(),q=j.oFormatOptions.calendarType,K=n+"-"+q,P,t;if(j.oFormatOptions.pattern&&I.bPatternFallbackWithoutDelimiter){K=K+"-"+j.oFormatOptions.pattern;}if(j.oFormatOptions.interval){K=K+"-"+"interval";}var u=I.oFallbackFormats[K]?Object.assign({},I.oFallbackFormats[K]):undefined;if(!u){t=I.aFallbackFormatOptions;if(I.bShortFallbackFormatOptions){P=I.getPattern(j.oLocaleData,"short");t=t.concat(D._createFallbackOptionsWithoutDelimiter(P));}if(j.oFormatOptions.pattern&&I.bPatternFallbackWithoutDelimiter){t=D._createFallbackOptionsWithoutDelimiter(j.oFormatOptions.pattern).concat(t);}u=D._createFallbackFormat(t,q,i,I,j.oFormatOptions.interval);}j.aFallbackFormats=u;}j.oRequiredParts=I.oRequiredParts;j.aRelativeScales=I.aRelativeScales;j.aRelativeParseScales=I.aRelativeParseScales;j.aIntervalCompareFields=I.aIntervalCompareFields;j.init();return j;};
D.prototype.init=function(){var s=this.oFormatOptions.calendarType;this.aMonthsAbbrev=this.oLocaleData.getMonths("abbreviated",s);this.aMonthsWide=this.oLocaleData.getMonths("wide",s);this.aMonthsNarrow=this.oLocaleData.getMonths("narrow",s);this.aMonthsAbbrevSt=this.oLocaleData.getMonthsStandAlone("abbreviated",s);this.aMonthsWideSt=this.oLocaleData.getMonthsStandAlone("wide",s);this.aMonthsNarrowSt=this.oLocaleData.getMonthsStandAlone("narrow",s);this.aDaysAbbrev=this.oLocaleData.getDays("abbreviated",s);this.aDaysWide=this.oLocaleData.getDays("wide",s);this.aDaysNarrow=this.oLocaleData.getDays("narrow",s);this.aDaysShort=this.oLocaleData.getDays("short",s);this.aDaysAbbrevSt=this.oLocaleData.getDaysStandAlone("abbreviated",s);this.aDaysWideSt=this.oLocaleData.getDaysStandAlone("wide",s);this.aDaysNarrowSt=this.oLocaleData.getDaysStandAlone("narrow",s);this.aDaysShortSt=this.oLocaleData.getDaysStandAlone("short",s);this.aQuartersAbbrev=this.oLocaleData.getQuarters("abbreviated",s);this.aQuartersWide=this.oLocaleData.getQuarters("wide",s);this.aQuartersNarrow=this.oLocaleData.getQuarters("narrow",s);this.aQuartersAbbrevSt=this.oLocaleData.getQuartersStandAlone("abbreviated",s);this.aQuartersWideSt=this.oLocaleData.getQuartersStandAlone("wide",s);this.aQuartersNarrowSt=this.oLocaleData.getQuartersStandAlone("narrow",s);this.aErasNarrow=this.oLocaleData.getEras("narrow",s);this.aErasAbbrev=this.oLocaleData.getEras("abbreviated",s);this.aErasWide=this.oLocaleData.getEras("wide",s);this.aDayPeriods=this.oLocaleData.getDayPeriods("abbreviated",s);this.aFormatArray=this.parseCldrDatePattern(this.oFormatOptions.pattern);this.sAllowedCharacters=this.getAllowedCharacters(this.aFormatArray);};
D._createFallbackFormat=function(i,s,o,I,j){return i.map(function(O){var n=Object.assign({},O);if(j){n.interval=true;}n.calendarType=s;n.fallback=true;var q=D.createInstance(n,o,I);q.bIsFallback=true;return q;});};
D._createFallbackOptionsWithoutDelimiter=function(B){var i=/[^dMyGU]/g,o={regex:/d+/g,replace:"dd"},M={regex:/M+/g,replace:"MM"},y={regex:/[yU]+/g,replace:["yyyy","yy"]};B=B.replace(i,"");B=B.replace(o.regex,o.replace);B=B.replace(M.regex,M.replace);return y.replace.map(function(R){return{pattern:B.replace(y.regex,R),strictParsing:true};});};
var p={isNumber:function(i){return i>=48&&i<=57;},findNumbers:function(v,M){var i=0;while(i<M&&this.isNumber(v.charCodeAt(i))){i++;}if(typeof v!=="string"){v=v.toString();}return v.substr(0,i);},findEntry:function(v,i){var n=-1,M=0;for(var j=0;j<i.length;j++){if(i[j]&&i[j].length>M&&v.indexOf(i[j])===0){n=j;M=i[j].length;}}return{index:n,value:n===-1?null:i[n]};},parseTZ:function(v,i){var j=0;var t=v.charAt(0)=="+"?-1:1;var P;j++;P=this.findNumbers(v.substr(j),2);var T=parseInt(P);j+=2;if(i){j++;}P=this.findNumbers(v.substr(j),2);var n=0;if(P){j+=2;n=parseInt(P);}return{length:j,tzDiff:(n+60*T)*t};},checkValid:function(t,P,o){if(t in o.oRequiredParts&&P){return false;}}};D.prototype.oSymbols={"":{name:"text",format:function(o,i,u,j){return o.value;},parse:function(v,P,o,i){var s;var V=true;var j=0;var n=0;var q="\u002d\u007E\u2010\u2011\u2012\u2013\u2014\ufe58\ufe63\uff0d\uFF5E";for(;n<P.value.length;n++){s=P.value.charAt(n);if(s===" "){while(v.charAt(j)===" "){j++;}}else if(q.includes(s)){if(!q.includes(v.charAt(j))){V=false;}j++;}else{if(v.charAt(j)!==s){V=false;}j++;}if(!V){break;}}if(V){return{length:j};}else{var t=false;if(i.index<i.formatArray.length-1){t=(i.formatArray[i.index+1].type in o.oRequiredParts);}return{valid:p.checkValid(P.type,t,o)};}}},"G":{name:"era",format:function(o,i,u,j){var E=u?i.getUTCEra():i.getEra();if(o.digits<=3){return j.aErasAbbrev[E];}else if(o.digits===4){return j.aErasWide[E];}else{return j.aErasNarrow[E];}},parse:function(v,P,o,j){var E=[o.aErasWide,o.aErasAbbrev,o.aErasNarrow];for(var i=0;i<E.length;i++){var V=E[i];var n=p.findEntry(v,V);if(n.index!==-1){return{era:n.index,length:n.value.length};}}return{era:o.aErasWide.length-1,valid:p.checkValid(P.type,true,o)};}},"y":{name:"year",format:function(o,i,u,j){var y=u?i.getUTCFullYear():i.getFullYear();var Y=String(y);var s=j.oFormatOptions.calendarType;if(o.digits==2&&Y.length>2){Y=Y.substr(Y.length-2);}if(s!=C.Japanese&&o.digits==1&&y<100){Y=Y.padStart(4,"0");}return Y.padStart(o.digits,"0");},parse:function(v,P,o,i){var s=o.oFormatOptions.calendarType;var j;if(P.digits==1){j=p.findNumbers(v,4);}else if(P.digits==2){j=p.findNumbers(v,2);}else{j=p.findNumbers(v,P.digits);}var y=parseInt(j);if(s!=C.Japanese&&j.length<=2){var n=U.getInstance(new Date(),s),q=n.getFullYear(),t=Math.floor(q/100),Y=t*100+y-q;if(Y<-70){y+=(t+1)*100;}else if(Y<30){y+=t*100;}else{y+=(t-1)*100;}}return{length:j.length,valid:p.checkValid(P.type,j==="",o),year:y};}},"Y":{name:"weekYear",format:function(o,i,u,j){var w=u?i.getUTCWeek():i.getWeek();var W=w.year;var s=String(W);var n=j.oFormatOptions.calendarType;if(o.digits==2&&s.length>2){s=s.substr(s.length-2);}if(n!=C.Japanese&&o.digits==1&&W<100){s=s.padStart(4,"0");}return s.padStart(o.digits,"0");},parse:function(v,P,o,i){var s=o.oFormatOptions.calendarType;var j;if(P.digits==1){j=p.findNumbers(v,4);}else if(P.digits==2){j=p.findNumbers(v,2);}else{j=p.findNumbers(v,P.digits);}var y=parseInt(j);var w;if(s!=C.Japanese&&j.length<=2){var n=U.getInstance(new Date(),s),q=n.getFullYear(),t=Math.floor(q/100),Y=t*100+w-q;if(Y<-70){w+=(t+1)*100;}else if(Y<30){w+=t*100;}else{w+=(t-1)*100;}}return{length:j.length,valid:p.checkValid(P.type,j==="",o),year:y,weekYear:w};}},"M":{name:"month",format:function(o,i,u,j){var M=u?i.getUTCMonth():i.getMonth();if(o.digits==3){return j.aMonthsAbbrev[M];}else if(o.digits==4){return j.aMonthsWide[M];}else if(o.digits>4){return j.aMonthsNarrow[M];}else{return String(M+1).padStart(o.digits,"0");}},parse:function(v,P,o,j){var M=[o.aMonthsWide,o.aMonthsWideSt,o.aMonthsAbbrev,o.aMonthsAbbrevSt,o.aMonthsNarrow,o.aMonthsNarrowSt];var V;var n;var s;if(P.digits<3){s=p.findNumbers(v,Math.max(P.digits,2));V=p.checkValid(P.type,s==="",o);n=parseInt(s)-1;if(j.strict&&(n>11||n<0)){V=false;}}else{for(var i=0;i<M.length;i++){var q=M[i];var t=p.findEntry(v,q);if(t.index!==-1){return{month:t.index,length:t.value.length};}}V=p.checkValid(P.type,true,o);}return{month:n,length:s?s.length:0,valid:V};}},"L":{name:"monthStandalone",format:function(o,i,u,j){var M=u?i.getUTCMonth():i.getMonth();if(o.digits==3){return j.aMonthsAbbrevSt[M];}else if(o.digits==4){return j.aMonthsWideSt[M];}else if(o.digits>4){return j.aMonthsNarrowSt[M];}else{return String(M+1).padStart(o.digits,"0");}},parse:function(v,P,o,j){var M=[o.aMonthsWide,o.aMonthsWideSt,o.aMonthsAbbrev,o.aMonthsAbbrevSt,o.aMonthsNarrow,o.aMonthsNarrowSt];var V;var n;var s;if(P.digits<3){s=p.findNumbers(v,Math.max(P.digits,2));V=p.checkValid(P.type,s==="",o);n=parseInt(s)-1;if(j.strict&&(n>11||n<0)){V=false;}}else{for(var i=0;i<M.length;i++){var q=M[i];var t=p.findEntry(v,q);if(t.index!==-1){return{month:t.index,length:t.value.length};}}V=p.checkValid(P.type,true,o);}return{month:n,length:s?s.length:0,valid:V};}},"w":{name:"weekInYear",format:function(o,i,u,j){var w=u?i.getUTCWeek():i.getWeek();var W=w.week;var s=String(W+1);if(o.digits<3){s=s.padStart(o.digits,"0");}else{s=j.oLocaleData.getCalendarWeek(o.digits===3?"narrow":"wide",s.padStart(2,"0"));}return s;},parse:function(v,P,o,i){var V;var s;var w;var j=0;if(P.digits<3){s=p.findNumbers(v,2);j=s.length;w=parseInt(s)-1;V=p.checkValid(P.type,!s,o);}else{s=o.oLocaleData.getCalendarWeek(P.digits===3?"narrow":"wide");s=s.replace("{0}","[0-9]+");var n=new RegExp(s),R=n.exec(v);if(R){j=R[0].length;w=parseInt(R[0])-1;}else{V=p.checkValid(P.type,true,o);}}return{length:j,valid:V,week:w};}},"W":{name:"weekInMonth",format:function(o,i,u,j){return"";},parse:function(){return{};}},"D":{name:"dayInYear",format:function(o,i,u,j){},parse:function(){return{};}},"d":{name:"day",format:function(o,i,u,j){var n=u?i.getUTCDate():i.getDate();return String(n).padStart(o.digits,"0");},parse:function(v,P,o,i){var s=p.findNumbers(v,Math.max(P.digits,2));var V=p.checkValid(P.type,s==="",o);var j=parseInt(s);if(i.strict&&(j>31||j<1)){V=false;}return{day:j,length:s.length,valid:V};}},"Q":{name:"quarter",format:function(o,i,u,j){var q=u?i.getUTCQuarter():i.getQuarter();if(o.digits==3){return j.aQuartersAbbrev[q];}else if(o.digits==4){return j.aQuartersWide[q];}else if(o.digits>4){return j.aQuartersNarrow[q];}else{return String(q+1).padStart(o.digits,"0");}},parse:function(v,P,o,j){var V;var q;var s;var Q=[o.aQuartersWide,o.aQuartersWideSt,o.aQuartersAbbrev,o.aQuartersAbbrevSt,o.aQuartersNarrow,o.aQuartersNarrowSt];if(P.digits<3){s=p.findNumbers(v,Math.max(P.digits,2));V=p.checkValid(P.type,s==="",o);q=parseInt(s)-1;if(j.strict&&q>3){V=false;}}else{for(var i=0;i<Q.length;i++){var n=Q[i];var t=p.findEntry(v,n);if(t.index!==-1){return{quarter:t.index,length:t.value.length};}}V=p.checkValid(P.type,true,o);}return{length:s?s.length:0,quarter:q,valid:V};}},"q":{name:"quarterStandalone",format:function(o,i,u,j){var q=u?i.getUTCQuarter():i.getQuarter();if(o.digits==3){return j.aQuartersAbbrevSt[q];}else if(o.digits==4){return j.aQuartersWideSt[q];}else if(o.digits>4){return j.aQuartersNarrowSt[q];}else{return String(q+1).padStart(o.digits,"0");}},parse:function(v,P,o,j){var V;var q;var s;var Q=[o.aQuartersWide,o.aQuartersWideSt,o.aQuartersAbbrev,o.aQuartersAbbrevSt,o.aQuartersNarrow,o.aQuartersNarrowSt];if(P.digits<3){s=p.findNumbers(v,Math.max(P.digits,2));V=p.checkValid(P.type,s==="",o);q=parseInt(s)-1;if(j.strict&&q>3){V=false;}}else{for(var i=0;i<Q.length;i++){var n=Q[i];var t=p.findEntry(v,n);if(t.index!==-1){return{quarter:t.index,length:t.value.length};}}V=p.checkValid(P.type,true,o);}return{length:s?s.length:0,quarter:q,valid:V};}},"F":{name:"dayOfWeekInMonth",format:function(o,i,u,j){return"";},parse:function(){return{};}},"E":{name:"dayNameInWeek",format:function(o,i,u,j){var n=u?i.getUTCDay():i.getDay();if(o.digits<4){return j.aDaysAbbrev[n];}else if(o.digits==4){return j.aDaysWide[n];}else if(o.digits==5){return j.aDaysNarrow[n];}else{return j.aDaysShort[n];}},parse:function(v,P,o,j){var n=[o.aDaysWide,o.aDaysWideSt,o.aDaysAbbrev,o.aDaysAbbrevSt,o.aDaysShort,o.aDaysShortSt,o.aDaysNarrow,o.aDaysNarrowSt];for(var i=0;i<n.length;i++){var V=n[i];var q=p.findEntry(v,V);if(q.index!==-1){return{dayOfWeek:q.index,length:q.value.length};}}}},"c":{name:"dayNameInWeekStandalone",format:function(o,i,u,j){var n=u?i.getUTCDay():i.getDay();if(o.digits<4){return j.aDaysAbbrevSt[n];}else if(o.digits==4){return j.aDaysWideSt[n];}else if(o.digits==5){return j.aDaysNarrowSt[n];}else{return j.aDaysShortSt[n];}},parse:function(v,P,o,j){var n=[o.aDaysWide,o.aDaysWideSt,o.aDaysAbbrev,o.aDaysAbbrevSt,o.aDaysShort,o.aDaysShortSt,o.aDaysNarrow,o.aDaysNarrowSt];for(var i=0;i<n.length;i++){var V=n[i];var q=p.findEntry(v,V);if(q.index!==-1){return{day:q.index,length:q.value.length};}}}},"u":{name:"dayNumberOfWeek",format:function(o,i,u,j){var n=u?i.getUTCDay():i.getDay();return j._adaptDayOfWeek(n);},parse:function(v,P,o,i){var s=p.findNumbers(v,P.digits);return{dayNumberOfWeek:parseInt(s),length:s.length};}},"a":{name:"amPmMarker",format:function(o,i,u,j){var n=u?i.getUTCDayPeriod():i.getDayPeriod();return j.aDayPeriods[n];},parse:function(v,P,o,i){var j;var n;var A=o.aDayPeriods[0],s=o.aDayPeriods[1];var q=/[aApP](?:\.)?[mM](?:\.)?/;var M=v.match(q);var V=(M&&M.index===0);if(V){v=M[0].replace(/\./g,"").toLowerCase()+v.substring(M[0].length);A=A.replace(/\./g,"").toLowerCase();s=s.replace(/\./g,"").toLowerCase();}if(v.indexOf(A)===0){j=false;n=(V?M[0].length:A.length);}else if(v.indexOf(s)===0){j=true;n=(V?M[0].length:s.length);}return{pm:j,length:n};}},"H":{name:"hour0_23",format:function(o,i,u,j){var H=u?i.getUTCHours():i.getHours();return String(H).padStart(o.digits,"0");},parse:function(v,P,o,i){var V;var s=p.findNumbers(v,Math.max(P.digits,2));var H=parseInt(s);V=p.checkValid(P.type,s==="",o);if(i.strict&&H>23){V=false;}return{hour:H,length:s.length,valid:V};}},"k":{name:"hour1_24",format:function(o,i,u,j){var H=u?i.getUTCHours():i.getHours();var s=(H===0?"24":String(H));return s.padStart(o.digits,"0");},parse:function(v,P,o,i){var V;var s=p.findNumbers(v,Math.max(P.digits,2));var H=parseInt(s);V=p.checkValid(P.type,s==="",o);if(H==24){H=0;}if(i.strict&&H>23){V=false;}return{hour:H,length:s.length,valid:V};}},"K":{name:"hour0_11",format:function(o,i,u,j){var H=u?i.getUTCHours():i.getHours();var s=String(H>11?H-12:H);return s.padStart(o.digits,"0");},parse:function(v,P,o,i){var V;var s=p.findNumbers(v,Math.max(P.digits,2));var H=parseInt(s);V=p.checkValid(P.type,s==="",o);if(i.strict&&H>11){V=false;}return{hour:H,length:s.length,valid:V};}},"h":{name:"hour1_12",format:function(o,i,u,j){var H=u?i.getUTCHours():i.getHours();var s;if(H>12){s=String(H-12);}else if(H==0){s="12";}else{s=String(H);}return s.padStart(o.digits,"0");},parse:function(v,P,o,i){var j=i.dateValue.pm;var s=p.findNumbers(v,Math.max(P.digits,2));var H=parseInt(s);var V=p.checkValid(P.type,s==="",o);if(H==12){H=0;j=(j===undefined)?true:j;}if(i.strict&&H>11){V=false;}return{hour:H,length:s.length,pm:j,valid:V};}},"m":{name:"minute",format:function(o,i,u,j){var M=u?i.getUTCMinutes():i.getMinutes();return String(M).padStart(o.digits,"0");},parse:function(v,P,o,i){var V;var s=p.findNumbers(v,Math.max(P.digits,2));var M=parseInt(s);V=p.checkValid(P.type,s==="",o);if(i.strict&&M>59){V=false;}return{length:s.length,minute:M,valid:V};}},"s":{name:"second",format:function(o,i,u,j){var s=u?i.getUTCSeconds():i.getSeconds();return String(s).padStart(o.digits,"0");},parse:function(v,P,o,i){var V;var s=p.findNumbers(v,Math.max(P.digits,2));var S=parseInt(s);V=p.checkValid(P.type,s==="",o);if(i.strict&&S>59){V=false;}return{length:s.length,second:S,valid:V};}},"S":{name:"fractionalsecond",format:function(o,i,u,j){var M=u?i.getUTCMilliseconds():i.getMilliseconds();var s=String(M);var n=s.padStart(3,"0");n=n.substr(0,o.digits);n=n.padEnd(o.digits,"0");return n;},parse:function(v,P,o,i){var s=p.findNumbers(v,P.digits);var j=s.length;s=s.substr(0,3);s=s.padEnd(3,"0");var M=parseInt(s);return{length:j,millisecond:M};}},"z":{name:"timezoneGeneral",format:function(o,i,u,j){if(o.digits>3&&i.getTimezoneLong&&i.getTimezoneLong()){return i.getTimezoneLong();}else if(i.getTimezoneShort&&i.getTimezoneShort()){return i.getTimezoneShort();}var t="GMT";var T=Math.abs(i.getTimezoneOffset());var P=i.getTimezoneOffset()>0;var H=Math.floor(T/60);var M=T%60;if(!u&&T!=0){t+=(P?"-":"+");t+=String(H).padStart(2,"0");t+=":";t+=String(M).padStart(2,"0");}else{t+="Z";}return t;},parse:function(v,P,o,i){var j=0;var t;var T=v.substring(0,3);if(T==="GMT"||T==="UTC"){j=3;}else if(v.substring(0,2)==="UT"){j=2;}else if(v.charAt(0)==="Z"){j=1;t=0;}else{return{error:"cannot be parsed correcly by sap.ui.core.format.DateFormat: The given timezone is not supported!"};}if(v.charAt(0)!=="Z"){var n=p.parseTZ(v.substr(j),true);j+=n.length;t=n.tzDiff;}return{length:j,tzDiff:t};}},"Z":{name:"timezoneRFC822",format:function(o,i,u,j){var t=Math.abs(i.getTimezoneOffset());var P=i.getTimezoneOffset()>0;var H=Math.floor(t/60);var M=t%60;var T="";if(!u){T+=(P?"-":"+");T+=String(H).padStart(2,"0");T+=String(M).padStart(2,"0");}return T;},parse:function(v,P,o,i){return p.parseTZ(v,false);}},"X":{name:"timezoneISO8601",format:function(o,i,u,j){var t=Math.abs(i.getTimezoneOffset());var P=i.getTimezoneOffset()>0;var H=Math.floor(t/60);var M=t%60;var T="";if(!u&&t!=0){T+=(P?"-":"+");T+=String(H).padStart(2,"0");if(o.digits>1||M>0){if(o.digits===3||o.digits===5){T+=":";}T+=String(M).padStart(2,"0");}}else{T+="Z";}return T;},parse:function(v,P,o,i){if(v.charAt(0)==="Z"){return{length:1,tzDiff:0};}else{return p.parseTZ(v,P.digits===3||P.digits===5);}}}};
D.prototype._format=function(j,u){if(this.oFormatOptions.relative){var R=this.formatRelative(j,u,this.oFormatOptions.relativeRange);if(R){return R;}}var s=this.oFormatOptions.calendarType;var o=U.getInstance(j,s);var B=[],P,n,S;for(var i=0;i<this.aFormatArray.length;i++){P=this.aFormatArray[i];S=P.symbol||"";B.push(this.oSymbols[S].format(P,o,u,this));}n=B.join("");if(sap.ui.getCore().getConfiguration().getOriginInfo()){n=new String(n);n.originInfo={source:"Common Locale Data Repository",locale:this.oLocale.toString(),style:this.oFormatOptions.style,pattern:this.oFormatOptions.pattern};}return n;};
D.prototype.format=function(j,u){var s=this.oFormatOptions.calendarType,R;if(u===undefined){u=this.oFormatOptions.UTC;}if(Array.isArray(j)){if(!this.oFormatOptions.interval){b.error("Non-interval DateFormat can't format more than one date instance.");return"";}if(j.length!==2){b.error("Interval DateFormat can only format with 2 date instances but "+j.length+" is given.");return"";}if(this.oFormatOptions.singleIntervalValue){if(j[0]===null){b.error("First date instance which is passed to the interval DateFormat shouldn't be null.");return"";}if(j[1]===null){R=this._format(j[0],u);}}if(R===undefined){var v=j.every(function(J){return J&&!isNaN(J.getTime());});if(!v){b.error("At least one date instance which is passed to the interval DateFormat isn't valid.");return"";}R=this._formatInterval(j,u);}}else{if(!j||isNaN(j.getTime())){b.error("The given date instance isn't valid.");return"";}if(this.oFormatOptions.interval){b.error("Interval DateFormat expects an array with two dates for the first argument but only one date is given.");return"";}R=this._format(j,u);}if(s==C.Japanese&&this.oLocale.getLanguage()==="ja"){R=R.replace(/(^|[^\d])1年/g,"$1元年");}return R;};
D.prototype._formatInterval=function(j,u){var s=this.oFormatOptions.calendarType;var o=U.getInstance(j[0],s);var t=U.getInstance(j[1],s);var n;var P;var S;var B=[];var q;var v=[];var w=this._getGreatestDiffField([o,t],u);if(!w){return this._format(j[0],u);}if(this.oFormatOptions.format){q=this.oLocaleData.getCustomIntervalPattern(this.oFormatOptions.format,w,s);}else{q=this.oLocaleData.getCombinedIntervalPattern(this.oFormatOptions.pattern,s);}v=this.parseCldrDatePattern(q);n=o;for(var i=0;i<v.length;i++){P=v[i];S=P.symbol||"";if(P.repeat){n=t;}B.push(this.oSymbols[S].format(P,n,u,this));}return B.join("");};
var F={Era:"Era",FullYear:"Year",Quarter:"Quarter",Month:"Month",Week:"Week",Date:"Day",DayPeriod:"DayPeriod",Hours:"Hour",Minutes:"Minute",Seconds:"Second"};
D.prototype._getGreatestDiffField=function(i,u){var j=false,n={};this.aIntervalCompareFields.forEach(function(s){var G="get"+(u?"UTC":""),M=G+s,o=F[s],v=i[0][M].apply(i[0]),t=i[1][M].apply(i[1]);if(!d(v,t)){j=true;n[o]=true;}});if(j){return n;}return null;};
D.prototype._parse=function(v,j,u,s){var I=0,P,S,R;var o={valid:true};var n={formatArray:j,dateValue:o,strict:s};for(var i=0;i<j.length;i++){S=v.substr(I);P=j[i];n.index=i;R=this.oSymbols[P.symbol||""].parse(S,P,this,n)||{};o=e(o,R);if(R.valid===false){break;}I+=R.length||0;}o.index=I;if(o.pm){o.hour+=12;}if(o.dayNumberOfWeek===undefined&&o.dayOfWeek!==undefined){o.dayNumberOfWeek=this._adaptDayOfWeek(o.dayOfWeek);}if(o.quarter!==undefined&&o.month===undefined&&o.day===undefined){o.month=3*o.quarter;o.day=1;}return o;};
D.prototype._parseInterval=function(v,s,u,S){var j,R,o;this.intervalPatterns.some(function(P){var n=this.parseCldrDatePattern(P);R=undefined;for(var i=0;i<n.length;i++){if(n[i].repeat){R=i;break;}}if(R===undefined){o=this._parse(v,n,u,S);if(o.index===0||o.index<v.length){o.valid=false;}if(o.valid===false){return;}j=[o,o];return true;}else{j=[];o=this._parse(v,n.slice(0,R),u,S);if(o.valid===false){return;}j.push(o);var q=o.index;o=this._parse(v.substring(q),n.slice(R),u,S);if(o.index===0||o.index+q<v.length){o.valid=false;}if(o.valid===false){return;}j.push(o);return true;}}.bind(this));return j;};
var h=function(o,s,u,S){var i,y=typeof o.year==="number"?o.year:1970;if(o.valid){if(u||o.tzDiff!==undefined){i=U.getInstance(new Date(0),s);i.setUTCEra(o.era||U.getCurrentEra(s));i.setUTCFullYear(y);i.setUTCMonth(o.month||0);i.setUTCDate(o.day||1);i.setUTCHours(o.hour||0);i.setUTCMinutes(o.minute||0);i.setUTCSeconds(o.second||0);i.setUTCMilliseconds(o.millisecond||0);if(S&&(o.day||1)!==i.getUTCDate()){o.valid=false;i=undefined;}else{if(o.tzDiff){i.setUTCMinutes((o.minute||0)+o.tzDiff);}if(o.week!==undefined&&(o.month===undefined||o.day===undefined)){i.setUTCWeek({year:o.weekYear||o.year,week:o.week});if(o.dayNumberOfWeek!==undefined){i.setUTCDate(i.getUTCDate()+o.dayNumberOfWeek-1);}}}}else{i=U.getInstance(new Date(1970,0,1,0,0,0),s);i.setEra(o.era||U.getCurrentEra(s));i.setFullYear(y);i.setMonth(o.month||0);i.setDate(o.day||1);i.setHours(o.hour||0);i.setMinutes(o.minute||0);i.setSeconds(o.second||0);i.setMilliseconds(o.millisecond||0);if(S&&(o.day||1)!==i.getDate()){o.valid=false;i=undefined;}else if(o.week!==undefined&&(o.month===undefined||o.day===undefined)){i.setWeek({year:o.weekYear||o.year,week:o.week});if(o.dayNumberOfWeek!==undefined){i.setDate(i.getDate()+o.dayNumberOfWeek-1);}}}if(o.valid){i=i.getJSDate();return i;}}return null;};
function m(o,i){if(o===i){return o;}var M={};Object.keys(o).forEach(function(K){M[K]=o[K];});Object.keys(i).forEach(function(K){if(!M.hasOwnProperty(K)){M[K]=i[K];}});return M;}
function k(s,E){if(s.getTime()>E.getTime()){return false;}return true;}
D.prototype.parse=function(v,u,s){v=v==null?"":String(v).trim();var o;var i=this.oFormatOptions.calendarType;if(u===undefined){u=this.oFormatOptions.UTC;}if(s===undefined){s=this.oFormatOptions.strictParsing;}if(i==C.Japanese&&this.oLocale.getLanguage()==="ja"){v=v.replace(/元年/g,"1年");}if(!this.oFormatOptions.interval){var j=this.parseRelative(v,u);if(j){return j;}o=this._parse(v,this.aFormatArray,u,s);if(o.index===0||o.index<v.length){o.valid=false;}j=h(o,i,u,s);if(j){return j;}}else{var n=this._parseInterval(v,i,u,s);var J,q;if(n&&n.length==2){var t=m(n[0],n[1]);var w=m(n[1],n[0]);J=h(t,i,u,s);q=h(w,i,u,s);if(J&&q){if(this.oFormatOptions.singleIntervalValue&&J.getTime()===q.getTime()){return[J,null];}var V=k(J,q);if(s&&!V){b.error("StrictParsing: Invalid date range. The given end date is before the start date.");return[null,null];}return[J,q];}}}if(!this.bIsFallback){var x;this.aFallbackFormats.every(function(y){x=y.parse(v,u,s);if(Array.isArray(x)){return!(x[0]&&x[1]);}else{return!x;}});return x;}if(!this.oFormatOptions.interval){return null;}else{return[null,null];}};
D.prototype.parseCldrDatePattern=function(P){if(c[P]){return c[P];}var j=[],i,q=false,o=null,s="",n="",A={},I=false;for(i=0;i<P.length;i++){var t=P.charAt(i),N,u,v;if(q){if(t=="'"){u=P.charAt(i-1);v=P.charAt(i-2);N=P.charAt(i+1);if(u=="'"&&v!="'"){q=false;}else if(N=="'"){i+=1;}else{q=false;continue;}}if(s=="text"){o.value+=t;}else{o={type:"text",value:t};j.push(o);s="text";}}else{if(t=="'"){q=true;}else if(this.oSymbols[t]){n=this.oSymbols[t].name;if(s==n){o.digits++;}else{o={type:n,symbol:t,digits:1};j.push(o);s=n;if(!I){if(A[n]){o.repeat=true;I=true;}else{A[n]=true;}}}}else{if(s=="text"){o.value+=t;}else{o={type:"text",value:t};j.push(o);s="text";}}}}c[P]=j;return j;};
D.prototype.parseRelative=function(v,u){var P,E,j,R,V;if(!v){return null;}P=this.oLocaleData.getRelativePatterns(this.aRelativeParseScales,this.oFormatOptions.relativeStyle);for(var i=0;i<P.length;i++){E=P[i];j=new RegExp("^\\s*"+E.pattern.replace(/\{0\}/,"(\\d+)")+"\\s*$","i");R=j.exec(v);if(R){if(E.value!==undefined){return n(E.value,E.scale);}else{V=parseInt(R[1]);return n(V*E.sign,E.scale);}}}function n(o,s){var t,T=new Date(),J;if(u){t=T.getTime();}else{t=Date.UTC(T.getFullYear(),T.getMonth(),T.getDate(),T.getHours(),T.getMinutes(),T.getSeconds(),T.getMilliseconds());}J=new Date(t);switch(s){case"second":J.setUTCSeconds(J.getUTCSeconds()+o);break;case"minute":J.setUTCMinutes(J.getUTCMinutes()+o);break;case"hour":J.setUTCHours(J.getUTCHours()+o);break;case"day":J.setUTCDate(J.getUTCDate()+o);break;case"week":J.setUTCDate(J.getUTCDate()+o*7);break;case"month":J.setUTCMonth(J.getUTCMonth()+o);break;case"quarter":J.setUTCMonth(J.getUTCMonth()+o*3);break;case"year":J.setUTCFullYear(J.getUTCFullYear()+o);break;}if(u){return J;}else{return new Date(J.getUTCFullYear(),J.getUTCMonth(),J.getUTCDate(),J.getUTCHours(),J.getUTCMinutes(),J.getUTCSeconds(),J.getUTCMilliseconds());}}};
D.prototype.formatRelative=function(j,u,R){var t=new Date(),o,s=this.oFormatOptions.relativeScale||"day",i,P,n;n=(j.getTime()-t.getTime())/1000;if(this.oFormatOptions.relativeScale=="auto"){s=this._getScale(n,this.aRelativeScales);}if(!R){R=this._mRanges[s];}if(s=="year"||s=="month"||s=="day"){t=new Date(Date.UTC(t.getFullYear(),t.getMonth(),t.getDate()));o=new Date(0);if(u){o.setUTCFullYear(j.getUTCFullYear(),j.getUTCMonth(),j.getUTCDate());}else{o.setUTCFullYear(j.getFullYear(),j.getMonth(),j.getDate());}j=o;}i=this._getDifference(s,[t,j]);if(this.oFormatOptions.relativeScale!="auto"&&(i<R[0]||i>R[1])){return null;}P=this.oLocaleData.getRelativePattern(s,i,n>0,this.oFormatOptions.relativeStyle);return f(P,[Math.abs(i)]);};
D.prototype._mRanges={second:[-60,60],minute:[-60,60],hour:[-24,24],day:[-6,6],week:[-4,4],month:[-12,12],year:[-10,10]};D.prototype._mScales={second:1,minute:60,hour:3600,day:86400,week:604800,month:2592000,quarter:7776000,year:31536000};
D.prototype._getScale=function(j,s){var S,t;j=Math.abs(j);for(var i=0;i<s.length;i++){t=s[i];if(j>=this._mScales[t]){S=t;break;}}if(!S){S=s[s.length-1];}return S;};
function l(o,s){var j=["FullYear","Month","Date","Hours","Minutes","Seconds","Milliseconds"],M;for(var i=s;i<j.length;i++){M="set"+j[s];o[M].apply(o,[0]);}}
var r={year:function(o,t){return t.getFullYear()-o.getFullYear();},month:function(o,t){return t.getMonth()-o.getMonth()+(this.year(o,t)*12);},week:function(o,t,i){var j=i._adaptDayOfWeek(o.getDay());var T=i._adaptDayOfWeek(t.getDay());l(o,3);l(t,3);return(t.getTime()-o.getTime()-(T-j)*i._mScales.day*1000)/(i._mScales.week*1000);},day:function(o,t,i){l(o,3);l(t,3);return(t.getTime()-o.getTime())/(i._mScales.day*1000);},hour:function(o,t,i){l(o,4);l(t,4);return(t.getTime()-o.getTime())/(i._mScales.hour*1000);},minute:function(o,t,i){l(o,5);l(t,5);return(t.getTime()-o.getTime())/(i._mScales.minute*1000);},second:function(o,t,i){l(o,6);l(t,6);return(t.getTime()-o.getTime())/(i._mScales.second*1000);}};
D.prototype._adaptDayOfWeek=function(i){var j=a.getInstance(sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale()).getFirstDayOfWeek();var n=i-(j-1);if(n<=0){n+=7;}return n;};
D.prototype._getDifference=function(s,i){var o=i[0];var t=i[1];return Math.round(r[s](o,t,this));};
D.prototype.getAllowedCharacters=function(j){if(this.oFormatOptions.relative){return"";}var A="";var n=false;var o=false;var P;for(var i=0;i<j.length;i++){P=j[i];switch(P.type){case"text":if(A.indexOf(P.value)<0){A+=P.value;}break;case"day":case"year":case"weekYear":case"dayNumberOfWeek":case"weekInYear":case"hour0_23":case"hour1_24":case"hour0_11":case"hour1_12":case"minute":case"second":case"fractionalsecond":if(!n){A+="0123456789";n=true;}break;case"month":case"monthStandalone":if(P.digits<3){if(!n){A+="0123456789";n=true;}}else{o=true;}break;default:o=true;break;}}if(o){A="";}return A;};
return D;},true);
sap.ui.predefine('sap/ui/core/format/FileSizeFormat',['sap/ui/base/Object','sap/ui/core/Locale','sap/ui/core/LocaleData','sap/ui/core/format/NumberFormat'],function(B,L,a,N){"use strict";var _=[{binaryFactor:1,decimalFactor:1,decimalUnit:"Byte",binaryUnit:"Byte"},{binaryFactor:1,decimalFactor:1,decimalUnit:"Bytes",binaryUnit:"Bytes"},{binaryFactor:Math.pow(2,10),decimalFactor:1e3,decimalUnit:"Kilobyte",binaryUnit:"Kibibyte"},{binaryFactor:Math.pow(2,20),decimalFactor:1e6,decimalUnit:"Megabyte",binaryUnit:"Mebibyte"},{binaryFactor:Math.pow(2,30),decimalFactor:1e9,decimalUnit:"Gigabyte",binaryUnit:"Gibibyte"},{binaryFactor:Math.pow(2,40),decimalFactor:1e12,decimalUnit:"Terabyte",binaryUnit:"Tebibyte"},{binaryFactor:Math.pow(2,50),decimalFactor:1e15,decimalUnit:"Petabyte",binaryUnit:"Pebibyte"},{binaryFactor:Math.pow(2,60),decimalFactor:1e18,decimalUnit:"Exabyte",binaryUnit:"Exbibyte"},{binaryFactor:Math.pow(2,70),decimalFactor:1e21,decimalUnit:"Zettabyte",binaryUnit:"Zebibyte"},{binaryFactor:Math.pow(2,80),decimalFactor:1e24,decimalUnit:"Yottabyte",binaryUnit:"Yobibyte"}];
var F=B.extend("sap.ui.core.format.FileSizeFormat",{constructor:function(f){throw new Error();}});
F.getInstance=function(f,l){return this.createInstance(f,l);};
F.createInstance=function(f,l){var o=Object.create(this.prototype);if(f instanceof L){l=f;f=undefined;}if(!l){l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();}o.oLocale=l;o.oLocaleData=a.getInstance(l);o.oNumberFormat=N.getFloatInstance(f,l);o.oBundle=sap.ui.getCore().getLibraryResourceBundle("sap.ui.core",l.toString());o.bBinary=f?!!f.binaryFilesize:false;return o;};
F.prototype.format=function(v){var V=null,o;if(typeof v=="string"){try{if(/^\s*[\+-]?0[xX]/.test(v)){V=parseInt(v,16);}else{V=parseFloat(v,10);}}catch(e){}}else if(typeof v=="number"){V=v;}if(V===null){return"NaN";}o=V;var u=c(V,this.bBinary),s=this.oNumberFormat.format(V/u.factor);if(!u.noSecondRounding){V=this.oNumberFormat.parse(s);if((this.bBinary&&Math.abs(V)>=1024)||(!this.bBinary&&Math.abs(V)>=1000)){u=c(V*u.factor,this.bBinary);s=this.oNumberFormat.format(o/u.factor);}}return this.oBundle.getText("FileSize."+u.unit,s);};
F.prototype.parse=function(v){var u,b,V,e;if(!v){return NaN;}for(var i=0;i<_.length;i++){u=_[i];b=d(this.oBundle,u.decimalUnit,v);if(b){e=false;break;}else{b=d(this.oBundle,u.binaryUnit,v);if(b){e=true;break;}}}if(!b){b=v;e=false;u=_[0];}V=this.oNumberFormat.parse(b);return V*(e?u.binaryFactor:u.decimalFactor);};
function c(f,e){var b=Math.abs(f),u,g;for(var i=_.length-1;i>=2;i--){u=_[i];g=e?u.binaryFactor:u.decimalFactor;if(b>=g){return{factor:g,unit:e?u.binaryUnit:u.decimalUnit,noSecondRounding:(i==_.length-1)};}}return{factor:1,unit:_[b>=2?1:0].decimalUnit};}
function d(b,u,v){var p=b.getText("FileSize."+u),e;if(p.startsWith("{0}")){e=p.substr(3,p.length);if((typeof e=="string"&&e!=""?v.toLowerCase().endsWith(e.toLowerCase()):false)){return v.substr(0,v.length-e.length);}}else if(p.endsWith("{0}")){e=p.substr(0,p.length-3);if((typeof e=="string"&&e!=""?v.toLowerCase().startsWith(e.toLowerCase()):false)){return v.substr(e.length,v.length);}}else{e=p.split("{0}");if(e.length==2&&((typeof e[0]=="string"&&e[0]!=""?v.toLowerCase().startsWith(e[0].toLowerCase()):false))&&((typeof e[1]=="string"&&e[1]!=""?v.toLowerCase().endsWith(e[1].toLowerCase()):false))){return v.substr(e[0].length,v.length-e[1].length);}}return null;}
return F;});
sap.ui.predefine('sap/ui/core/format/ListFormat',['sap/ui/core/Locale','sap/ui/core/LocaleData',"sap/base/Log","sap/base/util/extend","sap/base/util/isEmptyObject"],function(L,a,b,e,c){"use strict";var d=function(){throw new Error();};d.oDefaultListFormat={type:"standard",style:"wide"};
d.getInstance=function(f,l){return this.createInstance(f,l);};
d.createInstance=function(f,l){var F=Object.create(this.prototype);if(f instanceof L){l=f;f=undefined;}if(!l){l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();}F.oLocale=l;F.oLocaleData=a.getInstance(l);F.oOriginalFormatOptions=e({},this.oDefaultListFormat,f);return F;};
d.prototype.format=function(l){if(!Array.isArray(l)){b.error("ListFormat can only format with an array given.");return"";}var o=this.oOriginalFormatOptions,m,p,v,s,M,E,V=[].concat(l),S,f;m=this.oLocaleData.getListFormat(o.type,o.style);if(c(m)){b.error("No list pattern exists for the provided format options (type, style).");return"";}function r(V,p){var R=V[0];for(var i=1;i<V.length;i++){R=p.replace("{0}",R);R=R.replace("{1}",V[i]);}return R;}if(m[V.length]){p=m[V.length];for(var i=0;i<V.length;i++){p=p.replace('{'+i+'}',V[i]);}v=p;}else if(V.length<2){v=V.toString();}else{S=V.shift();E=V.pop();f=V;s=m.start.replace("{0}",S);E=m.end.replace("{1}",E);M=r(f,m.middle);v=s.replace("{1}",E.replace("{0}",M));}return v;};
d.prototype.parse=function(v){if(typeof v!=='string'){b.error("ListFormat can only parse a String.");return[];}var r=[],s=[],m=[],E=[],f=[],o=this.oOriginalFormatOptions,l,g=/\{[01]\}/g,h,S,i,j,k;if(!o){o=d.oDefaultListFormat;}l=this.oLocaleData.getListFormat(o.type,o.style);if(c(l)){b.error("No list pattern exists for the provided format options (type, style).");return[];}i=l.start.replace(g,"");j=l.middle.replace(g,"");k=l.end.replace(g,"");s=v.split(i);r=r.concat(s.shift());E=s.join(i).split(k);h=E.pop();m=E.join(k).split(j);r=r.concat(m);r.push(h);if(s.length<1||m.length<1||E.length<1){S=l["2"].replace(g,"");f=v.split(S);if(f.length===2){return f;}if(v){return[v];}else{return[];}}return r;};
return d;});
sap.ui.predefine('sap/ui/core/format/NumberFormat',['sap/ui/base/Object','sap/ui/core/Locale','sap/ui/core/LocaleData','sap/base/Log','sap/base/assert','sap/base/util/extend'],function(B,L,a,b,c,e){"use strict";
var N=B.extend("sap.ui.core.format.NumberFormat",{constructor:function(F){throw new Error();}});
var r=/0+(\.0+)?/;var d=/^0+$/;var n={INTEGER:"integer",FLOAT:"float",CURRENCY:"currency",UNIT:"unit",PERCENT:"percent"};var R={FLOOR:"floor",CEILING:"ceiling",TOWARDS_ZERO:"towards_zero",AWAY_FROM_ZERO:"away_from_zero",HALF_FLOOR:"half_floor",HALF_CEILING:"half_ceiling",HALF_TOWARDS_ZERO:"half_towards_zero",HALF_AWAY_FROM_ZERO:"half_away_from_zero"};var m={};m[R.FLOOR]=Math.floor;m[R.CEILING]=Math.ceil;m[R.TOWARDS_ZERO]=function(i){return i>0?Math.floor(i):Math.ceil(i);};m[R.AWAY_FROM_ZERO]=function(i){return i>0?Math.ceil(i):Math.floor(i);};m[R.HALF_TOWARDS_ZERO]=function(i){return i>0?Math.ceil(i-0.5):Math.floor(i+0.5);};m[R.HALF_AWAY_FROM_ZERO]=function(i){return i>0?Math.floor(i+0.5):Math.ceil(i-0.5);};m[R.HALF_FLOOR]=function(i){return Math.ceil(i-0.5);};m[R.HALF_CEILING]=Math.round;N.RoundingMode=R;N.oDefaultIntegerFormat={minIntegerDigits:1,maxIntegerDigits:99,minFractionDigits:0,maxFractionDigits:0,groupingEnabled:false,groupingSize:3,groupingSeparator:",",decimalSeparator:".",plusSign:"+",minusSign:"-",isInteger:true,type:n.INTEGER,showMeasure:false,style:"standard",parseAsString:false,roundingMode:N.RoundingMode.TOWARDS_ZERO,emptyString:NaN,showScale:true};N.oDefaultFloatFormat={minIntegerDigits:1,maxIntegerDigits:99,minFractionDigits:0,maxFractionDigits:99,groupingEnabled:true,groupingSize:3,groupingSeparator:",",decimalSeparator:".",plusSign:"+",minusSign:"-",isInteger:false,type:n.FLOAT,showMeasure:false,style:"standard",parseAsString:false,roundingMode:N.RoundingMode.HALF_AWAY_FROM_ZERO,emptyString:NaN,showScale:true};N.oDefaultPercentFormat={minIntegerDigits:1,maxIntegerDigits:99,minFractionDigits:0,maxFractionDigits:99,groupingEnabled:true,groupingSize:3,groupingSeparator:",",decimalSeparator:".",plusSign:"+",minusSign:"-",percentSign:"%",isInteger:false,type:n.PERCENT,showMeasure:false,style:"standard",parseAsString:false,roundingMode:N.RoundingMode.HALF_AWAY_FROM_ZERO,emptyString:NaN,showScale:true};N.oDefaultCurrencyFormat={minIntegerDigits:1,maxIntegerDigits:99,groupingEnabled:true,groupingSize:3,groupingSeparator:",",decimalSeparator:".",plusSign:"+",minusSign:"-",isInteger:false,type:n.CURRENCY,showMeasure:true,currencyCode:true,currencyContext:'standard',style:"standard",customCurrencies:undefined,parseAsString:false,roundingMode:N.RoundingMode.HALF_AWAY_FROM_ZERO,emptyString:NaN,showScale:true,ignorePrecision:true};N.oDefaultUnitFormat={minIntegerDigits:1,maxIntegerDigits:99,groupingEnabled:true,groupingSize:3,groupingSeparator:",",decimalSeparator:".",plusSign:"+",minusSign:"-",isInteger:false,type:n.UNIT,showMeasure:true,style:"standard",customUnits:undefined,allowedUnits:undefined,parseAsString:false,roundingMode:N.RoundingMode.HALF_AWAY_FROM_ZERO,emptyString:NaN,showScale:true};
N.getInstance=function(F,i){return this.getFloatInstance(F,i);};
N.getFloatInstance=function(F,i){var t=this.createInstance(F,i),u=this.getLocaleFormatOptions(t.oLocaleData,n.FLOAT);t.oFormatOptions=e({},this.oDefaultFloatFormat,u,F);return t;};
N.getIntegerInstance=function(F,i){var t=this.createInstance(F,i),u=this.getLocaleFormatOptions(t.oLocaleData,n.INTEGER);t.oFormatOptions=e({},this.oDefaultIntegerFormat,u,F);return t;};
N.getCurrencyInstance=function(F,i){var t=this.createInstance(F,i);var C=F&&F.currencyContext;var S=s(F);if(S){C=C||this.oDefaultCurrencyFormat.style;C="sap-"+C;}var u=this.getLocaleFormatOptions(t.oLocaleData,n.CURRENCY,C);t.oFormatOptions=e({},this.oDefaultCurrencyFormat,u,F);t.oFormatOptions.trailingCurrencyCode=S;t._defineCustomCurrencySymbols();return t;};
N.getUnitInstance=function(F,i){var t=this.createInstance(F,i),u=this.getLocaleFormatOptions(t.oLocaleData,n.UNIT);t.oFormatOptions=e({},this.oDefaultUnitFormat,u,F);return t;};
N.getPercentInstance=function(F,i){var t=this.createInstance(F,i),u=this.getLocaleFormatOptions(t.oLocaleData,n.PERCENT);t.oFormatOptions=e({},this.oDefaultPercentFormat,u,F);return t;};
N.createInstance=function(F,i){var t=Object.create(this.prototype),P;if(F instanceof L){i=F;F=undefined;}if(!i){i=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();}t.oLocale=i;t.oLocaleData=a.getInstance(i);t.oOriginalFormatOptions=F;if(F){if(F.pattern){P=this.parseNumberPattern(F.pattern);Object.keys(P).forEach(function(u){F[u]=P[u];});}if(F.emptyString!==undefined){c(F.emptyString===""||F.emptyString===0||F.emptyString===null||F.emptyString!==F.emptyString,"The format option 'emptyString' must be either 0, null or NaN");}}return t;};
N.getDefaultUnitPattern=function(S){return"{0} "+S;};
N.getLocaleFormatOptions=function(i,t,C){var u,v;switch(t){case n.PERCENT:v=i.getPercentPattern();break;case n.CURRENCY:v=i.getCurrencyPattern(C);break;case n.UNIT:v=i.getDecimalPattern();break;default:v=i.getDecimalPattern();}u=this.parseNumberPattern(v);u.plusSign=i.getNumberSymbol("plusSign");u.minusSign=i.getNumberSymbol("minusSign");u.decimalSeparator=i.getNumberSymbol("decimal");u.groupingSeparator=i.getNumberSymbol("group");u.percentSign=i.getNumberSymbol("percentSign");u.pattern=v;switch(t){case n.UNIT:case n.FLOAT:case n.PERCENT:u.minFractionDigits=0;u.maxFractionDigits=99;break;case n.INTEGER:u.minFractionDigits=0;u.maxFractionDigits=0;u.groupingEnabled=false;break;case n.CURRENCY:u.minFractionDigits=undefined;u.maxFractionDigits=undefined;break;}return u;};
N.parseNumberPattern=function(F){var M=0,t=0,u=0,G=false,v=0,w=0,S=F.indexOf(";"),x={Integer:0,Fraction:1},y=x.Integer;if(S!==-1){F=F.substring(0,S);}for(var i=0;i<F.length;i++){var C=F[i];switch(C){case",":if(G){v=w;w=0;}G=true;break;case".":y=x.Fraction;break;case"0":if(y===x.Integer){M++;if(G){w++;}}else{t++;u++;}break;case"#":if(y===x.Integer){if(G){w++;}}else{u++;}break;}}if(!v){v=w;w=0;}return{minIntegerDigits:M,minFractionDigits:t,maxFractionDigits:u,groupingEnabled:G,groupingSize:v,groupingBaseSize:w};};
N.prototype._defineCustomCurrencySymbols=function(){var O=this.oFormatOptions;var C=this.oLocaleData.getCurrencySymbols();var F=function(S,i){var u=[];var t;for(var K in S){t=S[K];if(u.indexOf(t)===-1){u.push(t);}else if(t!==undefined){i[t]=true;b.error("Symbol '"+t+"' is defined multiple times in custom currencies.",undefined,"NumberFormat");}}};if(O.customCurrencies&&typeof O.customCurrencies==="object"){this.mKnownCurrencySymbols={};this.mKnownCurrencyCodes={};Object.keys(O.customCurrencies).forEach(function(K){if(O.customCurrencies[K].symbol){this.mKnownCurrencySymbols[K]=O.customCurrencies[K].symbol;}else{var i=O.customCurrencies[K].isoCode;if(i){this.mKnownCurrencySymbols[K]=C[i];}}this.mKnownCurrencyCodes[K]=K;}.bind(this));}else{this.mKnownCurrencySymbols=C;this.mKnownCurrencyCodes=this.oLocaleData.getCustomCurrencyCodes();}this.mDuplicatedSymbols={};F(this.mKnownCurrencySymbols,this.mDuplicatedSymbols);};
N.prototype.format=function(v,M){if(Array.isArray(v)){M=v[1];v=v[0];}var i="",F="",G="",t="",u="",P="",w=0,x=0,y=0,z=0,A=v<0,D=-1,O=Object.assign({},this.oFormatOptions),C=this.oOriginalFormatOptions,I=O.type===n.CURRENCY&&M==="INR"&&this.oLocale.getLanguage()==="en"&&this.oLocale.getRegion()==="IN",E,S,H,J,U,K;if(v===O.emptyString||(isNaN(v)&&isNaN(O.emptyString))){return"";}if(M&&O.customCurrencies&&!O.customCurrencies[M]){b.error("Currency '"+M+"' is unknown.");return"";}if(O.type===n.UNIT){if(O.customUnits&&typeof O.customUnits==="object"){U=O.customUnits[M];}else{K=this.oLocaleData.getUnitFromMapping(M)||M;U=this.oLocaleData.getUnitFormat(K);}O.decimals=(U&&(typeof U.decimals==="number"&&U.decimals>=0))?U.decimals:O.decimals;O.precision=(U&&(typeof U.precision==="number"&&U.precision>=0))?U.precision:O.precision;}if(O.type==n.CURRENCY){if(O.customCurrencies&&O.customCurrencies[M]){O.decimals=O.customCurrencies[M].decimals!==undefined?O.customCurrencies[M].decimals:O.decimals;}}if(O.decimals!==undefined){O.minFractionDigits=O.decimals;O.maxFractionDigits=O.decimals;}if(O.shortLimit===undefined||Math.abs(v)>=O.shortLimit){H=O.shortRefNumber===undefined?v:O.shortRefNumber;S=g(H,O,this.oLocaleData,I);if(S&&S.formatString!="0"){v=v/S.magnitude;if(O.shortDecimals!==undefined){O.minFractionDigits=O.shortDecimals;O.maxFractionDigits=O.shortDecimals;}else{if(C.minFractionDigits===undefined&&C.maxFractionDigits===undefined&&C.decimals===undefined&&C.precision===undefined&&C.pattern===undefined){O.precision=2;O.minFractionDigits=0;O.maxFractionDigits=99;}if(C.maxFractionDigits===undefined&&C.decimals===undefined){O.maxFractionDigits=99;}}O.roundingMode=N.RoundingMode.HALF_AWAY_FROM_ZERO;}}if((S||!O.ignorePrecision)&&O.precision!==undefined){O.maxFractionDigits=Math.min(O.maxFractionDigits,k(v,O.precision));O.minFractionDigits=Math.min(O.minFractionDigits,O.maxFractionDigits);}if(O.type==n.PERCENT){v=N._shiftDecimalPoint(v,2);}if(O.type==n.CURRENCY){var Q=this.oLocaleData.getCurrencyDigits(M);if(O.customCurrencies&&O.customCurrencies[M]&&O.customCurrencies[M].decimals!==undefined){Q=O.customCurrencies[M].decimals;}if(O.maxFractionDigits===undefined){O.maxFractionDigits=Q;}if(O.minFractionDigits===undefined){O.minFractionDigits=Q;}}if(typeof v==="number"){v=j(v,O.maxFractionDigits,O.roundingMode);}if(v==0){A=false;}u=this.convertToDecimal(v);if(u=="NaN"){return u;}if(A){u=u.substr(1);}D=u.indexOf(".");if(D>-1){i=u.substr(0,D);F=u.substr(D+1);}else{i=u;}if(i.length<O.minIntegerDigits){i=i.padStart(O.minIntegerDigits,"0");}else if(i.length>O.maxIntegerDigits){i="".padStart(O.maxIntegerDigits,"?");}if(F.length<O.minFractionDigits){F=F.padEnd(O.minFractionDigits,"0");}else if(F.length>O.maxFractionDigits){F=F.substr(0,O.maxFractionDigits);}x=i.length;if(O.groupingEnabled){if(I){var T=[3,2,2],V,W=0;w=i.length;while(w>0){V=T[W%3];w-=V;if(W>0){G=O.groupingSeparator+G;}if(w<0){V+=w;w=0;}G=i.substr(w,V)+G;W++;}}else{y=O.groupingSize;z=O.groupingBaseSize||y;w=Math.max(x-z,0)%y||y;G=i.substr(0,w);while(x-w>=z){G+=O.groupingSeparator;G+=i.substr(w,y);w+=y;}G+=i.substr(w);}}else{G=i;}if(A){t=O.minusSign;}t+=G;if(F){t+=O.decimalSeparator+F;}if(S&&S.formatString&&O.showScale&&O.type!==n.CURRENCY){J=this.oLocaleData.getPluralCategory(i+"."+F);S.formatString=this.oLocaleData.getDecimalFormat(O.style,S.key,J);t=S.formatString.replace(S.valueSubString,t);t=t.replace(/'.'/g,".");}if(O.type===n.CURRENCY){P=O.pattern;if(S&&S.formatString&&O.showScale){var X;if(O.trailingCurrencyCode){X="sap-short";}else{X="short";}J=this.oLocaleData.getPluralCategory(i+"."+F);if(I){P=h(X,S.key,J);}else{P=this.oLocaleData.getCurrencyFormat(X,S.key,J);}P=P.replace(/'.'/g,".");}E=P.split(";");if(E.length===2){P=A?E[1]:E[0];if(A){t=t.substring(1);}}if(!O.currencyCode){var Y;if(O.customCurrencies&&typeof O.customCurrencies==="object"){Y=this.mKnownCurrencySymbols[M];}else{Y=this.oLocaleData.getCurrencySymbol(M);}if(Y&&Y!==M){M=Y;}}t=this._composeCurrencyResult(P,t,M,{showMeasure:O.showMeasure,negative:A,minusSign:O.minusSign});}if(O.type===n.PERCENT){P=O.pattern;t=P.replace(/[0#.,]+/,t);t=t.replace(/%/,O.percentSign);}if(O.showMeasure&&O.type===n.UNIT){J=this.oLocaleData.getPluralCategory(i+"."+F);c(J,"Cannot find plural category for "+(i+"."+F));var Z=!O.allowedUnits||O.allowedUnits.indexOf(M)>=0;if(!Z){c(Z,"The given unit '"+M+"' is not part of the allowed unit types: ["+O.allowedUnits.join(",")+"].");return"";}if(U){P=U["unitPattern-count-"+J];if(!P){P=U["unitPattern-count-other"];}c(P,"Cannot find pattern 'unitPattern-count-"+J+"' in '"+M+"'");if(!P){return"";}t=P.replace("{0}",t);}else if(!O.unitOptional){c(U,"Unit '"+M+"' is unknown");return"";}}if(sap.ui.getCore().getConfiguration().getOriginInfo()){t=new String(t);t.originInfo={source:"Common Locale Data Repository",locale:this.oLocale.toString()};}return t;};
N.prototype._composeCurrencyResult=function(P,F,M,O){var i=O.minusSign;P=P.replace(/[0#.,]+/,F);if(O.showMeasure&&M){var t="\u00a4",u={"[:digit:]":/\d/,"[:^S:]":/[^\$\xA2-\xA5\u058F\u060B\u09F2\u09F3\u09FB\u0AF1\u0BF9\u0E3F\u17DB\u20A0-\u20BD\uA838\uFDFC\uFE69\uFF04\uFFE0\uFFE1\uFFE5\uFFE6]/},v=P.indexOf(t),w=v<P.length/2?"after":"before",S=this.oLocaleData.getCurrencySpacing(w),C=(w==="after"?M.charAt(M.length-1):M.charAt(0)),x,y=u[S.currencyMatch],z=u[S.surroundingMatch],I;P=P.replace(t,M);x=(w==="after"?P.charAt(v+M.length):P.charAt(v-1));if(y&&y.test(C)&&z&&z.test(x)){if(w==="after"){I=v+M.length;}else{I=v;}P=P.slice(0,I)+S.insertBetween+P.slice(I);}else if(O.negative&&w==="after"){i="\ufeff"+O.minusSign;}}else{P=P.replace(/\s*\u00a4\s*/,"");}if(O.negative){P=P.replace(/-/,i);}return P;};
N.prototype.parse=function(v){var O=this.oFormatOptions,P=O.plusSign+this.oLocaleData.getLenientNumberSymbols("plusSign"),M=O.minusSign+this.oLocaleData.getLenientNumberSymbols("minusSign"),t=q(P+M),G=q(O.groupingSeparator),D=q(O.decimalSeparator),u="^\\s*(["+t+"]?(?:[0-9"+G+"]+|[0-9"+G+"]*"+D+"[0-9]*)(?:[eE][+-][0-9]+)?)\\s*$",w="^\\s*(["+t+"]?[0-9"+G+"]+)\\s*$",x=new RegExp(G,"g"),y=new RegExp(D,"g"),z=this.oLocaleData.getNumberSymbol("percentSign"),I=O.type===n.CURRENCY&&this.oLocale.getLanguage()==="en"&&this.oLocale.getRegion()==="IN",A,C,E,F,H=0,S,J;if(v===""){J=O.emptyString;if(O.parseAsString&&(O.emptyString===0||isNaN(O.emptyString))){J=O.emptyString+"";}if(O.type===n.CURRENCY||O.type===n.UNIT){return[J,undefined];}else{return J;}}F=O.type===n.PERCENT?O.pattern:this.oLocaleData.getPercentPattern();if(F.charAt(0)==="%"){u=u.slice(0,1)+"%?"+u.slice(1);}else if(F.charAt(F.length-1)==="%"){u=u.slice(0,u.length-1)+"%?"+u.slice(u.length-1);}var U;if(O.type===n.UNIT){var K;if(O.customUnits&&typeof O.customUnits==="object"){K=O.customUnits;}else{K=this.oLocaleData.getUnitFormats();}c(K,"Unit patterns cannot be loaded");if(O.allowedUnits){var Q={};for(var i=0;i<O.allowedUnits.length;i++){var T=O.allowedUnits[i];Q[T]=K[T];}K=Q;}var V=p(K,v);var W=false;U=V.cldrCode;if(U.length===1){E=U[0];}else if(U.length===0){if((O.unitOptional||!O.showMeasure)&&typeof v==="string"){V.numberValue=v;}else{c(U.length===1,"Cannot find unit for input: '"+(v)+"'");return null;}}else{c(U.length===1,"Ambiguous unit ["+U.join(", ")+"] for input: '"+(v)+"'");E=undefined;W=true;}if(O.strictParsing){if((E&&!O.showMeasure)||W){return null;}}v=V.numberValue||v;}var X;if(O.type===n.CURRENCY){X=o({value:v,currencySymbols:this.mKnownCurrencySymbols,customCurrencyCodes:this.mKnownCurrencyCodes,duplicatedSymbols:this.mDuplicatedSymbols,customCurrenciesAvailable:!!O.customCurrencies});if(!X){return null;}if(O.strictParsing){if((O.showMeasure&&!X.currencyCode)||X.duplicatedSymbolFound){return null;}}v=X.numberValue;E=X.currencyCode;if((O.customCurrencies&&E===null)||(!O.showMeasure&&E)){return null;}}if(typeof v==="string"||v instanceof String){v=v.replace(/[\u202a\u200e\u202c\u202b\u200f]/g,"");v=v.replace(/\s/g,"");}S=f(v,this.oLocaleData,I);if(S){v=S.number;}if(O.isInteger&&!S){A=new RegExp(w);}else{A=new RegExp(u);}if(!A.test(v)){return O.type===n.CURRENCY||O.type===n.UNIT?null:NaN;}v=v.replace(x,"");var Y=v.length;for(var Z=0;Z<Y;Z++){var $=v[Z];if(P.includes($)){v=v.replace($,"+");break;}else if(M.includes($)){v=v.replace($,"-");break;}}v=v.replace(/^\+/,"");if(S){v=v.replace(y,".");v=N._shiftDecimalPoint(v,Math.round(Math.log(S.factor)/Math.LN10));}if(O.isInteger){H=O.parseAsString?v:parseInt(v);}else{v=v.replace(y,".");if(v.indexOf(z)!==-1){C=true;v=v.replace(z,"");}H=O.parseAsString?v:parseFloat(v);if(C){H=N._shiftDecimalPoint(H,-2);}}if(O.parseAsString){H=N._shiftDecimalPoint(v,0);}if(O.type===n.CURRENCY||O.type===n.UNIT){return[H,E];}return H;};
N.prototype.convertToDecimal=function(v){var V=""+v,t,u,D,F,E,P;if(V.indexOf("e")==-1&&V.indexOf("E")==-1){return V;}var w=V.match(/^([+-]?)((\d+)(?:\.(\d+))?)[eE]([+-]?\d+)$/);t=w[1]=="-";u=w[2].replace(/\./g,"");D=w[3]?w[3].length:0;F=w[4]?w[4].length:0;E=parseInt(w[5]);if(E>0){if(E<F){P=D+E;V=u.substr(0,P)+"."+u.substr(P);}else{V=u;E-=F;for(var i=0;i<E;i++){V+="0";}}}else{if(-E<D){P=D+E;V=u.substr(0,P)+"."+u.substr(P);}else{V=u;E+=D;for(var i=0;i>E;i--){V="0"+V;}V="0."+V;}}if(t){V="-"+V;}return V;};
N.prototype.getScale=function(){if((this.oFormatOptions.style!=="short"&&this.oFormatOptions.style!=="long")||this.oFormatOptions.shortRefNumber===undefined){return;}var S=g(this.oFormatOptions.shortRefNumber,this.oFormatOptions,this.oLocaleData),i;if(S&&S.formatString){i=S.formatString.replace(r,"").replace(/'.'/g,".").trim();if(i){return i;}}};
N._shiftDecimalPoint=function(v,S){if(typeof S!=="number"){return NaN;}var M="";var E=v.toString().toLowerCase().split("e");if(typeof v==="number"){S=E[1]?(+E[1]+S):S;return+(E[0]+"e"+S);}else if(typeof v==="string"){if(parseFloat(v)===0&&S>=0){return d.test(v)?"0":v;}var F=E[0].charAt(0);M=F==="-"?F:"";if(M){E[0]=E[0].slice(1);}v=E[0];var D=v.indexOf("."),A,i,t;if(D===-1){v=v+".";D=v.length-1;}if(E[1]){D+=(+E[1]);}A=D+S;if(A<=0){v=v.padStart(v.length-A+1,'0');A=1;}else if(A>=v.length-1){v=v.padEnd(A+1,'0');A=v.length-1;}v=v.replace(".","");i=v.substring(0,A);t=v.substring(A);i=i.replace(/^(-?)0+(\d)/,"$1$2");return M+i+(t?("."+t):"");}else{return null;}};
function g(v,O,t,I){var S,K,u,C,w=O.style,P=O.precision!==undefined?O.precision:2;if(w!="short"&&w!="long"){return undefined;}for(var i=0;i<15;i++){K=Math.pow(10,i);if(j(Math.abs(v)/K,P-1)<10){break;}}u=K.toString();if(O.type===n.CURRENCY){if(O.trailingCurrencyCode){w="sap-short";}if(I){C=h(w,u,"other",true);}else{C=t.getCurrencyFormat(w,u,"other");}}else{C=t.getDecimalFormat(w,u,"other");}if(!C||C=="0"){return undefined;}else{S={};S.key=u;S.formatString=C;var x=C.match(r);if(x){S.valueSubString=x[0];var y=S.valueSubString.indexOf(".");if(y==-1){S.decimals=0;S.magnitude=K*Math.pow(10,1-S.valueSubString.length);}else{S.decimals=S.valueSubString.length-y-1;S.magnitude=K*Math.pow(10,1-y);}}else{return undefined;}}return S;}
function f(v,t,I){var u,F=1,K=10,P=t.getPluralCategories(),C,w={number:undefined,factor:F},G=function(y,K,S,z){if(z){C=h(S,K.toString(),y,true);}else{C=t.getDecimalFormat(S,K.toString(),y);}if(C){C=C.replace(/[\s\u00a0\u200F]/g,"");C=C.replace(/'.'/g,".");var A=C.match(r);if(A){var V=A[0];var U=C.replace(V,"");if(!U){return;}var D=v.indexOf(U);if(D>=0){u=v.replace(U,"");u=u.replace(/\u200F/g,"");F=K;F*=Math.pow(10,1-V.length);if(w.number===undefined||u.length<w.number.length){w.number=u;w.factor=F;}}}}};["long","short"].forEach(function(S){K=10;while(K<1e15){for(var i=0;i<P.length;i++){var x=P[i];G(x,K,S);}K=K*10;}});if(I&&!u){K=10;while(K<1e15){for(var i=0;i<P.length;i++){var x=P[i];G(x,K,"short",true);}K=K*10;}}if(!u){return;}return w;}
function s(F){var S=sap.ui.getCore().getConfiguration().getFormatSettings().getTrailingCurrencyCode();if(F){if(F.trailingCurrencyCode!==undefined){S=F.trailingCurrencyCode;}if(F.pattern){S=false;}if(F.currencyCode===false){S=false;}}return S;}
function h(S,K,P,D){var F,C={"short":{"1000-one":"¤0000","1000-other":"¤0000","10000-one":"¤00000","10000-other":"¤00000","100000-one":"¤0 Lk","100000-other":"¤0 Lk","1000000-one":"¤00 Lk","1000000-other":"¤00 Lk","10000000-one":"¤0 Cr","10000000-other":"¤0 Cr","100000000-one":"¤00 Cr","100000000-other":"¤00 Cr","1000000000-one":"¤000 Cr","1000000000-other":"¤000 Cr","10000000000-one":"¤0000 Cr","10000000000-other":"¤0000 Cr","100000000000-one":"¤00000 Cr","100000000000-other":"¤00000 Cr","1000000000000-one":"¤0 Lk Cr","1000000000000-other":"¤0 Lk Cr","10000000000000-one":"¤00 Lk Cr","10000000000000-other":"¤00 Lk Cr","100000000000000-one":"¤0 Cr Cr","100000000000000-other":"¤0 Cr Cr"},"sap-short":{"1000-one":"0000 ¤","1000-other":"0000 ¤","10000-one":"00000 ¤","10000-other":"00000 ¤","100000-one":"0 Lk ¤","100000-other":"0 Lk ¤","1000000-one":"00 Lk ¤","1000000-other":"00 Lk ¤","10000000-one":"0 Cr ¤","10000000-other":"0 Cr ¤","100000000-one":"00 Cr ¤","100000000-other":"00 Cr ¤","1000000000-one":"000 Cr ¤","1000000000-other":"000 Cr ¤","10000000000-one":"0000 Cr ¤","10000000000-other":"0000 Cr ¤","100000000000-one":"00000 Cr ¤","100000000000-other":"00000 Cr ¤","1000000000000-one":"0 Lk Cr ¤","1000000000000-other":"0 Lk Cr ¤","10000000000000-one":"00 Lk Cr ¤","10000000000000-other":"00 Lk Cr ¤","100000000000000-one":"0 Cr Cr ¤","100000000000000-other":"0 Cr Cr ¤"}},i={"short":{"1000-one":"0000","1000-other":"0000","10000-one":"00000","10000-other":"00000","100000-one":"0 Lk","100000-other":"0 Lk","1000000-one":"00 Lk","1000000-other":"00 Lk","10000000-one":"0 Cr","10000000-other":"0 Cr","100000000-one":"00 Cr","100000000-other":"00 Cr","1000000000-one":"000 Cr","1000000000-other":"000 Cr","10000000000-one":"0000 Cr","10000000000-other":"0000 Cr","100000000000-one":"00000 Cr","100000000000-other":"00000 Cr","1000000000000-one":"0 Lk Cr","1000000000000-other":"0 Lk Cr","10000000000000-one":"00 Lk Cr","10000000000000-other":"00 Lk Cr","100000000000000-one":"0 Cr Cr","100000000000000-other":"0 Cr Cr"}};i["sap-short"]=i["short"];var t=D?i:C;var u=t[S];if(!u){u=t["short"];}if(P!=="one"){P="other";}F=u[K+"-"+P];return F;}
function j(v,M,i){if(typeof v!=="number"){return NaN;}i=i||N.RoundingMode.HALF_AWAY_FROM_ZERO;M=parseInt(M);if(typeof i==="function"){v=i(v,M);}else{if(!M){return m[i](v);}v=N._shiftDecimalPoint(m[i](N._shiftDecimalPoint(v,M)),-M);}return v;}
function q(i){return i.replace(/([.?*+^$[\]\\(){}|-])/g,"\\$1");}
function k(v,P){var i=Math.floor(Math.log(Math.abs(v))/Math.LN10);return Math.max(0,P-i-1);}
function p(u,v){var i={numberValue:undefined,cldrCode:[]};if(typeof v!=="string"){return i;}var t=Number.POSITIVE_INFINITY;var U,K;for(U in u){for(K in u[U]){if(K.indexOf("unitPattern")===0){var w=u[U][K];var x=w.indexOf("{0}");var C=x>-1;if(C){var P=w.substring(0,x);var y=w.substring(x+"{0}".length);var M=v.startsWith(P)&&v.endsWith(y);var z=M&&v.substring(P.length,v.length-y.length);if(z){if(z.length<t){t=z.length;i.numberValue=z;i.cldrCode=[U];}else if(z.length===t&&i.cldrCode.indexOf(U)===-1){i.cldrCode.push(U);}}}else if(w===v){i.cldrCode=[U];var A;if(K.endsWith("-zero")){A="0";}else if(K.endsWith("-one")){A="1";}else if(K.endsWith("-two")){A="2";}i.numberValue=A;return i;}}}}return i;}
function l(v,C){var S="",i,t;for(var u in C){t=C[u];if(v.indexOf(t)>=0&&S.length<t.length){S=t;i=u;}}return{symbol:S,code:i};}
function o(C){var v=C.value;var M=l(v,C.currencySymbols);if(!M.code){M=l(v,C.customCurrencyCodes);if(!M.code&&!C.customCurrenciesAvailable){var i=v.match(/(^[A-Z]{3}|[A-Z]{3}$)/);M.code=i&&i[0];}}if(M.code){var t=M.code.length-1;var u=M.code.charAt(t);var D;var w=/[\-\s]+/;if(/\d$/.test(u)){if(v.startsWith(M.code)){D=t+1;if(!w.test(v.charAt(D))){return undefined;}}}else if(/^\d/.test(M.code)){if(v.endsWith(M.code)){D=v.indexOf(M.code)-1;if(!w.test(v.charAt(D))){return undefined;}}}v=v.replace(M.symbol||M.code,"");}var x=false;if(C.duplicatedSymbols&&C.duplicatedSymbols[M.symbol]){M.code=undefined;x=true;b.error("The parsed currency symbol '"+M.symbol+"' is defined multiple "+"times in custom currencies.Therefore the result is not distinct.");}return{numberValue:v,currencyCode:M.code||undefined,duplicatedSymbolFound:x};}
return N;});
sap.ui.predefine('sap/ui/core/hyphenation/HyphenationTestingWords',[],function(){"use strict";var t={"bg":"непротивоконституционствувателствувайте","ca":"Psiconeuroimmunoendocrinologia","hr":"prijestolonasljednikovičičinima","cs":"nejnezdevětadevadesáteronásobitelnějšími","da":"Gedebukkebensoverogundergeneralkrigskommandersergenten","nl":"meervoudigepersoonlijkheidsstoornissen","en-us":"pneumonoultramicroscopicsilicovolcanoconiosis","et":"Sünnipäevanädalalõpupeopärastlõunaväsimus","fi":"kolmivaihekilowattituntimittari","fr":"hippopotomonstrosesquippedaliophobie","de":"Kindercarnavalsoptochtvoorbereidingswerkzaamhedenplan","el-monoton":"ηλεκτροεγκεφαλογράφημα","hi":"किंकर्तव्यविमूढ़","hu":"Megszentségteleníthetetlenségeskedéseitekért","it":"hippopotomonstrosesquippedaliofobia","lt":"nebeprisikiškiakopūstlapiaujančiuosiuose","nb-no":"supercalifragilisticexpialidocious","pl":"dziewięćdziesięciokilkuletniemu","pt":"pneumoultramicroscopicossilicovulcanoconiose","ru":"превысокомногорассмотрительствующий","sr":"Семпаравиливичинаверсаламилитипиковски","sl":"Dialektičnomaterialističen","es":"Electroencefalografistas","sv":"Realisationsvinstbeskattning","th":"ตัวอย่างข้อความที่จะใช้ในการยืนยันการถ่ายโอน","tr":"Muvaffakiyetsizleştiricileştiriveremeyebileceklerimizdenmişsinizcesine","uk":"Нікотинамідаденіндинуклеотидфосфат"};return t;});
sap.ui.predefine('sap/ui/core/message/MessageMixin',["sap/ui/core/library","sap/base/Log"],function(l,L){"use strict";var V=l.ValueState;var M=function(){this.refreshDataState=r;this.fnDestroy=this.destroy;this.destroy=d;};
function r(n,D){if(D.getChanges().messages&&this.getBinding(n)&&this.getBinding(n).isA("sap.ui.model.PropertyBinding")){var m=D.getMessages();var a=sap.ui.core.LabelEnablement.getReferencingLabels(this);var s=a[0];var f=false;m.forEach(function(b){if(a&&a.length>0){var c=sap.ui.getCore().byId(s);if(c.getMetadata().isInstanceOf("sap.ui.core.Label")&&c.getText&&b.getAdditionalText()!==c.getText()){b.setAdditionalText(c.getText());f=true;}else{L.warning("sap.ui.core.message.Message: Can't create labelText."+"Label with id "+s+" is no valid sap.ui.core.Label.",this);}}if(b.getControlId()!==this.getId()){b.addControlId(this.getId());f=true;}}.bind(this));var o=sap.ui.getCore().getMessageManager().getMessageModel();o.checkUpdate(f,true);if(m&&m.length>0){var b=m[0];if(V[b.type]){this.setValueState(b.type);this.setValueStateText(b.message);}}else{this.setValueState(V.None);this.setValueStateText('');}}}
function d(){var c=this.getId();function a(o){o.removeControlId(c);}for(var n in this.mBindingInfos){var b=this.mBindingInfos[n];if(b.binding){var D=b.binding.getDataState();var m=D.getMessages();m.forEach(a);}}this.fnDestroy.apply(this,arguments);}
return M;},true);
sap.ui.predefine('sap/ui/core/message/MessageParser',["sap/ui/base/Object","sap/base/Log"],function(O,L){"use strict";
var M=O.extend("sap.ui.core.message.MessageParser",{
metadata:{publicMethods:["parse","setProcessor"]},
constructor:function(){this._processor=null;}
});
M.prototype.setProcessor=function(p){this._processor=p;return this;};
M.prototype.getProcessor=function(){return this._processor;};
M.prototype.parse=function(r){L.error("MessageParser: parse-method must be implemented in the specific parser class. Messages "+"have been ignored.");};
return M;});
sap.ui.predefine('sap/ui/core/mvc/Controller',['sap/base/util/ObjectPath','sap/base/util/extend','sap/ui/base/EventProvider','sap/ui/base/ManagedObject','sap/ui/core/mvc/ControllerMetadata','sap/ui/core/mvc/ControllerExtension','sap/ui/core/mvc/OverrideExecution',"sap/base/Log","sap/ui/thirdparty/jquery"],function(O,e,E,M,C,a,b,L,q){"use strict";var r={};var m={};
var c=E.extend("sap.ui.core.mvc.Controller",{
metadata:{stereotype:"controller",methods:{"byId":{"public":true,"final":true},"getView":{"public":true,"final":true},"getInterface":{"public":false,"final":true},"onInit":{"public":false,"final":false,"overrideExecution":b.After},"onExit":{"public":false,"final":false,"overrideExecution":b.Before},"onBeforeRendering":{"public":false,"final":false,"overrideExecution":b.Before},"onAfterRendering":{"public":false,"final":false,"overrideExecution":b.After}}},
constructor:function(n){var t=null;if(typeof(n)=="string"){if(!r[n]){L.warning("Do not call sap.ui.core.mvc.Controller constructor for non typed scenario!");}t=r[n];}E.apply(this,arguments);if(t){e(this,r[n]);}if(this.extension){throw new Error("The keyword 'extension' cannot be used as a member of a controller");}this["_sapui_Extensions"]={};c.extendByMember(this,false);this._sapui_isExtended=false;},
_isExtended:function(){return this._sapui_isExtended;},
getInterface:function(){var i={};var o=this.getMetadata();var p=o.getAllPublicMethods();p.forEach(function(s){var F=this[s];if(typeof F==='function'){i[s]=function(){var t=F.apply(this,arguments);return(t instanceof c)?t.getInterface():t;}.bind(this);}}.bind(this));this.getInterface=function(){return i;};return i;}
},C);
function d(o,i,l){var n=i.getMetadata().getName();var p=o.getMetadata();var s=o["_sapui_Extensions"];var I=o.getInterface();var t=a.getMetadata().getLifecycleConfiguration();var u={namespace:n,extension:i,reloadNeeded:false};i._setController(I);if(i.getMetadata().hasOverrides()){var v,w,x,y,z=i.getMetadata().getOverrides(),S=i.getMetadata().getStaticOverrides();for(y in S){x=i.getMetadata();if(!x.isMethodFinal(y)){a.overrideMethod(y,i,S,i,x.getOverrideExecution(y));}else{L.error("Method '"+y+"' of extension '"+n+"' is flagged final and cannot be overridden by calling 'override'");}}for(y in z){if(y!=='extension'){if(y in i.base){L.debug("Overriding  member '"+y+"' of original controller.");var A=z[y];var B=o[y];if(typeof B=="object"&&typeof A=="object"){w=s[y];x=w.extension.getMetadata();for(v in A){if(!x.isMethodFinal(v)){a.overrideMethod(v,B,A,i,x.getOverrideExecution(v));}else{L.error("Method '"+v+"' of extension '"+w.namespace+"' is flagged final and cannot be overridden by extension '"+n+"'");}}}else if(!p.isMethodFinal(y)){a.overrideMethod(y,o,z,i,p.getOverrideExecution(y));}else{L.error("Method '"+y+"' of controller '"+o.getMetadata().getName()+"' is flagged final and cannot be overridden by extension '"+n+"'");}}else if(y in t){a.overrideMethod(y,o,z,i,p.getOverrideExecution(y));}else{L.error("Method '"+y+"' does not exist in controller "+o.getMetadata().getName()+" and cannot be overridden");}}if(z.extension){for(var D in z.extension){x=s[D].extension.getMetadata();var F=O.create(D,o.extension);var G=s[D].extension;var H=z.extension[D];for(v in H){if(!x.isMethodFinal(v)){a.overrideMethod(v,F,H,i,x.getOverrideExecution(v));a.overrideMethod(v,G,H,i,x.getOverrideExecution(v));}else{L.error("Method '"+v+"' of extension '"+D+"' is flagged final and cannot be overridden by extension '"+n+"'");}}}}u.reloadNeeded=true;}}var J=i.getInterface();if(l){s[l]=u;u.location=l;o[l]=J;I[l]=J;}else{s[n]=u;u.location="extension."+n;O.set("extension."+n,J,o);O.set("extension."+n,J,I);}}
function f(o,i,l){if(i instanceof a){d(o,i,l);}else if(i.getMetadata&&i.getMetadata().getStereotype()=="controllerextension"){var n=new i();d(o,n,l);}else{var p=a.getMetadata().getLifecycleConfiguration();for(var s in i){if(s in p){a.overrideMethod(s,o,i,o,p[s].overrideExecution);}else{a.overrideMethod(s,o,i);}}}}
function g(n,A){if(!n){throw new Error("Controller name ('sName' parameter) is required");}var s=n.replace(/\./g,"/")+".controller",i=l(sap.ui.require(s));function l(i){if(i){return i;}else if(r[n]){return c;}else{return O.get(n);}}if(A){return new Promise(function(o,p){if(!i){sap.ui.require([s],function(i){o(l(i));},p);}else{o(i);}});}else if(!i){i=sap.ui.requireSync(s);return l(i);}else{return i;}}
function h(o,A){var p=c._sExtensionProvider.replace(/\./g,"/"),P=m[p];if(A){return new Promise(function(l,n){if(p){if(P){l(P);}else{sap.ui.require([p],function(i){P=new i();m[p]=P;l(P);},n);}}else{l();}});}else if(p){if(P){return P;}else{var i=sap.ui.requireSync(p);P=new i();m[p]=P;return P;}}}
function j(i,n){var o;if(r[n]){o=new i(n);}else{o=new i();}if(!o){throw new Error("Controller "+n+" couldn't be instantiated");}return o;}
c.extendByMember=function(o,A){var s;for(s in o){if(o[s]&&o[s].getMetadata&&o[s].getMetadata().getStereotype()=="controllerextension"){o[s]=new o[s]();}}for(s in o){if(o[s]&&o[s].getMetadata&&o[s].getMetadata().getStereotype()=="controllerextension"){f(o,o[s],s);}}if(A){return Promise.resolve(o);}else{return o;}};
c.extendByCustomizing=function(o,n,A){var p=sap.ui.require('sap/ui/core/CustomizingConfiguration');if(!p){return A?Promise.resolve(o):o;}function s(z,o){return g(z,A).then(function(t){t=r[z]||t;if(t!==undefined){if(t.getMetadata&&t.getMetadata().isA("sap.ui.core.mvc.Controller")){L.warning("Attempt to load Extension Controller "+z+" was not successful","Controller extension should be a plain object.",null,function(){return{type:"ControllerExtension",name:z};});}else{f(o,t);}return o;}},function(B){L.error("Attempt to load Extension Controller "+z+" was not successful - is the Controller correctly defined in its file?");});}var t,u=[],v,w=A?Promise.resolve(o):o,x=p.getControllerExtension(n,M._sOwnerId);if(x){v=typeof x==="string"?x:x.controllerName;u=x.controllerNames||[];if(v){u.unshift(v);}}for(var i=0,l=u.length;i<l;i++){var y=u[i];if(typeof y==="string"){L.info("Customizing: Controller '"+n+"' is now extended by '"+y+"'");if(A){w=w.then(s.bind(null,y,o));}else{if(!r[y]&&!sap.ui.require(y)){g(y);}if((t=r[y])!==undefined){f(o,t);}else{L.error("Attempt to load Extension Controller "+y+" was not successful - is the Controller correctly defined in its file?",null,function(){return{type:"ControllerExtension",name:y};});}}}}return w;};
c.extendByProvider=function(o,n,s,A){if(!c._sExtensionProvider){return A?Promise.resolve(o):o;}L.info("Customizing: Controller '"+n+"' is now extended by Controller Extension Provider '"+c._sExtensionProvider+"'");var p,t;if(A){return h(o,A).then(function(t){return t.getControllerExtensions(n,s,A);}).then(function(u){if(u&&u.length){for(var i=0,l=u.length;i<l;i++){f(o,u[i]);}}return o;},function(u){L.error("Controller Extension Provider: Error '"+u+"' thrown in "+c._sExtensionProvider+"; extension provider ignored.");return o;});}else{t=h(o,A);p=t.getControllerExtensions(n,s,A);if(p&&Array.isArray(p)){for(var i=0,l=p.length;i<l;i++){f(o,p[i]);}}else{L.error("Controller Extension Provider: Error in ExtensionProvider.getControllerExtensions: "+c._sExtensionProvider+" - no valid extensions returned");}}return o;};
c.create=function(o){return k(o.name,undefined,true);};
sap.ui.controller=function(n,o,A){if(A){L.info("Do not use deprecated factory function 'sap.ui.controller("+n+")'. Use 'sap.ui.core.mvc.Controller.create(...)' instead.","sap.ui.controller",null,function(){return{type:"sap.ui.controller",name:n};});}else{L.warning("Do not use synchronous controller creation for controller '"+n+"'! Use the new asynchronous factory 'sap.ui.core.mvc.Controller.create(...)' instead.","sap.ui.controller",null,function(){return{type:"sap.ui.controller",name:n};});}return k.apply(this,arguments);};
function k(n,o,A){var i,l,s=M._sOwnerId;if(typeof o==="boolean"){o=undefined;}if(!o){if(A){return g(n,A).then(function(l){return j(l,n);}).then(function(i){return c.extendByCustomizing(i,n,A);}).then(function(i){return c.extendByProvider(i,n,s,A);}).then(function(i){i._sapui_isExtended=true;return i;});}else{l=g(n,A);i=j(l,n);i=c.extendByCustomizing(i,n,A);i=c.extendByProvider(i,n,s,A);i._sapui_isExtended=true;}return i;}else{r[n]=o;L.info("For defining controllers use Controller.extend instead");}}
c.prototype.getPublicMethods=function(){var p={},o=this.getMetadata(),i=o.getAllMethods(),l=o.getLifecycleConfiguration();Object.keys(i).forEach(function(s){if(o.isMethodPublic(s)){p[s]=i[s];p[s].reloadNeeded=!!(s in l);}});delete p.extension;var n=this["_sapui_Extensions"];Object.keys(n).forEach(function(N){var s=n[N];var t=s.extension.getInterface();var A=s.extension.getMetadata().getAllMethods();Object.keys(t).forEach(function(u){delete p[s.location];var v=e({},A[u],{reloadNeeded:s.reloadNeeded});p[s.location+"."+u]=v;});});return p;};
c.prototype.destroy=function(){Object.keys(this["_sapui_Extensions"]).forEach(function(o){O.set(o.location,null,this);}.bind(this));delete this["_sapui_Extensions"];delete this["_sapui_Interface"];E.prototype.destroy.apply(this,arguments);};
c.prototype.getView=function(){return this.oView;};
c.prototype.byId=function(i){return this.oView?this.oView.byId(i):undefined;};
c.prototype.createId=function(i){return this.oView?this.oView.createId(i):undefined;};
c.prototype.getOwnerComponent=function(){var i=sap.ui.requireSync("sap/ui/core/Component");return i.getOwnerComponentFor(this.getView());};
c.prototype.connectToView=function(v){this.oView=v;if(this.onInit){v.attachAfterInit(this.onInit,this);}if(this.onExit){v.attachBeforeExit(this.onExit,this);}if(this.onAfterRendering){v.attachAfterRendering(this.onAfterRendering,this);}if(this.onBeforeRendering){v.attachBeforeRendering(this.onBeforeRendering,this);}};
c._sExtensionProvider=null;
c.registerExtensionProvider=function(s){c._sExtensionProvider=s;};
return c;});
sap.ui.predefine('sap/ui/core/mvc/ControllerExtension',['sap/ui/base/Object','sap/ui/base/Metadata','sap/ui/core/mvc/ControllerMetadata','sap/ui/core/mvc/OverrideExecution','sap/base/util/uid',"sap/base/Log"],function(B,M,C,O,u,L){"use strict";
var a=B.extend("sap.ui.core.mvc.ControllerExtension",{
metadata:{stereotype:"controllerextension",methods:{"byId":{"public":true,"final":true},"getView":{"public":true,"final":true},"getInterface":{"public":false,"final":true}}},
_setController:function(c){this.base=c;},
byId:function(i){var n=this.getMetadata().getNamespace();i=n+"."+i;return this.base?this.base.byId(i):undefined;},
getView:function(){return this.base.getView();},
getInterface:function(){var m={};var o=this.getMetadata();var p=o.getAllPublicMethods();p.forEach(function(s){var f=this[s];if(typeof f==='function'){m[s]=function(){var t=f.apply(this,arguments);return(t instanceof a)?t.getInterface():t;}.bind(this);}}.bind(this));this.getInterface=function(){return m;};return m;}
},C);
a.override=function(e){var c=M.createClass(this,"anonymousExtension~"+u(),{},C);c.getMetadata()._staticOverride=e;c.getMetadata()._override=this.getMetadata()._override;return c;};
a.overrideMethod=function(m,o,c,b,s){var f=o[m];var d=c[m];s=s||O.Instead;function w(e){(function(d,f,b,e){o[m]=function(){if(e){d.apply(b,arguments);return f.apply(o,arguments);}else{f.apply(o,arguments);return d.apply(b,arguments);}};})(d,f,b,e);}if(typeof d==='function'&&b){d=d.bind(b);}switch(s){case O.Before:if(f&&typeof f==="function"){w(true);}else if(typeof d==="function"){o[m]=d;}else{L.error("Controller extension failed: lifecycleMethod '"+m+"', is not a function");}break;case O.After:if(f&&typeof f==="function"){w(false);}else if(typeof d==="function"){o[m]=d;}else{L.error("Controller extension failed: lifecycleMethod '"+m+"', is not a function");}break;case O.Instead:default:if(m in o){L.debug("Overriding  member '"+m+"' of extension "+this.getMetadata().getName());if(!this.getMetadata().isMethodFinal(m)){o[m]=d;}else{L.error("Error in ControllerExtension.override: Method '"+m+"' of extension '"+this.getMetadata().getName()+"' is flagged final and cannot be overridden!");}}else{o[m]=d;}break;}};
return a;});
sap.ui.predefine('sap/ui/core/mvc/ControllerMetadata',['sap/ui/base/Metadata','sap/base/util/merge','sap/ui/core/mvc/OverrideExecution',"sap/base/Log"],function(M,a,O,L){"use strict";var C=function(c,o){M.apply(this,arguments);if(this.isA("sap.ui.core.mvc.ControllerExtension")&&this.getParent().getClass().override){this.getClass().override=this.getParent().getClass().override;}};C.prototype=Object.create(M.prototype);C.prototype.constructor=C;
C.prototype.applySettings=function(c){if(c.override){this._override=c.override;delete c.override;}M.prototype.applySettings.call(this,c);var s=c.metadata;this._defaultLifecycleMethodMetadata={"onInit":{"public":true,"final":false,"overrideExecution":O.After},"onExit":{"public":true,"final":false,"overrideExecution":O.Before},"onBeforeRendering":{"public":true,"final":false,"overrideExecution":O.Before},"onAfterRendering":{"public":true,"final":false,"overrideExecution":O.After}};var i=this.isA("sap.ui.core.mvc.ControllerExtension");var r=/^_/;var e=this._oParent.isA("sap.ui.core.mvc.Controller");var d=c.metadata&&c.metadata.methods?true:false;if(!i){if(e&&!d){r=/^_|^on|^init$|^exit$/;}if(e&&d){a(s.methods,this._defaultLifecycleMethodMetadata);}}if(i||d){this._aPublicMethods=[];}this._mMethods=s.methods||{};for(var n in c){if(n!=="metadata"&&n!=="constructor"){if(!n.match(r)){if(e&&this._oParent&&this._oParent.isMethodFinal(n)){L.error("Method: '"+n+"' of controller '"+this._oParent.getName()+"' is final and cannot be overridden by controller '"+this.getName()+"'");delete this._oClass.prototype[n];}if(!(n in this._mMethods)&&typeof c[n]==='function'){if(!(c[n].getMetadata&&c[n].getMetadata().isA("sap.ui.core.mvc.ControllerExtension"))){this._mMethods[n]={"public":true,"final":false};}}}}}for(var m in this._mMethods){if(this.isMethodPublic(m)){this._aPublicMethods.push(m);}}};
C.prototype.afterApplySettings=function(){M.prototype.afterApplySettings.call(this);var i=this.isA("sap.ui.core.mvc.ControllerExtension");if(this._oParent){var p=this._oParent._mMethods?this._oParent._mMethods:{};for(var m in p){if(this._mMethods[m]&&!i){var P=this._mMethods[m].public;this._mMethods[m]=a({},p[m]);if(P!==undefined){this._mMethods[m].public=P;}if(!this.isMethodPublic(m)&&this._mMethods[m].public!==p[m].public){this._aAllPublicMethods.splice(this._aAllPublicMethods.indexOf(m),1);}}else{this._mMethods[m]=p[m];}}}if(this._oParent&&this._oParent.isA("sap.ui.core.mvc.ControllerExtension")){this._bFinal=true;}};
C.prototype.getNamespace=function(){var i=this._sClassName.indexOf("anonymousExtension~")==0;var n=i?this._oParent._sClassName:this._sClassName;return n.substr(0,n.lastIndexOf("."));};
C.prototype.isMethodFinal=function(m){var o=this._mMethods[m];return o&&o.final;};
C.prototype.isMethodPublic=function(m){var o=this._mMethods[m];return o&&o.public;};
C.prototype.getAllMethods=function(){return this._mMethods;};
C.prototype.getOverrideExecution=function(m){var o=this._mMethods[m];var s=O.Instead;if(o){s=o.overrideExecution;}return s;};
C.prototype.getOverrides=function(){return this._override;};
C.prototype.getStaticOverrides=function(){return this._staticOverride;};
C.prototype.hasOverrides=function(){return!!this._override||!!this._staticOverride;};
C.prototype.getLifecycleConfiguration=function(){return this._defaultLifecycleMethodMetadata;};
return C;});
sap.ui.predefine('sap/ui/core/mvc/EventHandlerResolver',["sap/ui/base/BindingParser","sap/ui/core/CommandExecution","sap/ui/model/BindingMode","sap/ui/model/CompositeBinding","sap/ui/model/json/JSONModel","sap/ui/model/base/ManagedObjectModel","sap/base/util/JSTokenizer","sap/base/util/ObjectPath","sap/base/util/resolveReference","sap/base/Log"],function(B,C,a,b,J,M,c,O,r,L){"use strict";var E={resolveEventHandler:function(n,o,l){var h,s,f;n=n.trim();if(sap.ui.getCore().getConfiguration().getControllerCodeDeactivated()){h=function(){};}else{if(n.startsWith("cmd:")){var d=n.substr(4);h=function(e){var j=C.find(e.getSource(),d);if(j){j.trigger();}else{L.error("Handler '"+n+"' could not be resolved. No CommandExecution defined for command: "+d);}};h._sapui_commandName=d;}else{s=n.indexOf("(");f=n;if(s>0){f=n.substring(0,s).trim();}else if(s===0){throw new Error("Event handler name starts with a bracket, must start with a function name "+"(or with a dot followed by controller-local function name): "+n);}h=r(f,Object.assign({".":o},l),{preferDotContext:f.indexOf(".")===-1,bindContext:false});}if(h&&s>0){var i=n.lastIndexOf(")");if(i>s){if(n.substring(s).indexOf("{=")>-1){L.warning("It looks like an event handler parameter contains a binding expression ({=...}). This is not allowed and will cause an error later on "+"because the entire event handler is already considered an expression: "+n);}h=(function(f,o){return function(j){var p,S,k=n;if(n.indexOf("$parameters")>-1){p=new J(j.mParameters);}if(n.indexOf("$source")>-1){S=new M(j.getSource());}var m={"$controller":o,$event:j};if(f.indexOf(".")>0){var G=f.split(".")[0];m[G]=window[G];}else if(f.indexOf(".")===-1){if(o&&o[f]){k="$controller."+k;}else if(window[f]){m[f]=window[f];}}Object.assign(m,l);var q=B.parseExpression(k.replace(/^\./,"$controller."),0,{oContext:o},m);if(q.result){try{g(q.result,j.getSource(),o,p,S);}catch(e){e.message="Error when evaluating event handler '"+n+"': "+e.message;throw e;}}if(p){p.destroy();}if(S){S.destroy();}};})(f,o);}else{L.error("Syntax error in event handler '"+n+"': arguments must be enclosed in a pair of brackets");}}}if(typeof h==="function"){h._sapui_handlerName=n;return[h,o];}L.warning("Event handler name '"+n+"' could not be resolved to an event handler function");},parse:function parse(v){v=v.trim();var t=new c();var R=[];var s="";var p=0;t.init(v,0);for(;;){var S=t.next();if(S==='"'||S==="'"){var d=t.getIndex();t.string();s+=v.slice(d,t.getIndex());S=t.getCh();}if(!S){break;}switch(S){case"(":p++;break;case")":p--;break;}if(S===";"&&p===0){R.push(s.trim());s="";}else{s+=S;}}if(s){R.push(s.trim());}return R;}};
function g(o,e,d,p,s){var t,P;o.mode=a.OneWay;if(!o.parts){o.parts=[];o.parts[0]={path:o.path,targetType:o.targetType,type:o.type,suspended:o.suspended,formatOptions:o.formatOptions,constraints:o.constraints,model:o.model,mode:o.mode};delete o.path;delete o.targetType;delete o.mode;delete o.model;}for(var i=0;i<o.parts.length;i++){P=o.parts[i];if(typeof P=="string"){P={path:P};o.parts[i]=P;}if(!P.path&&P.parts){throw new Error("Bindings in event handler parameters cannot use parts. Just use one single path.");}var S=P.path.indexOf(">");if(S>0){P.model=P.path.substr(0,S);P.path=P.path.substr(S+1);}}var f,h,j,k=[];o.parts.forEach(function(P){var m;if(P.model==="$parameters"){m=p;h=p.createBindingContext("/");}else if(P.model==="$source"){m=s;h=s.createBindingContext("/");}else{m=e.getModel(P.model);h=e.getBindingContext(P.model);}t=P.type;if(typeof t=="string"){f=O.get(t);if(typeof f!=="function"){throw new Error("Cannot find type \""+t+"\" used for binding \""+P.path+"\"!");}t=new f(P.formatOptions,P.constraints);}j=m.bindProperty(P.path,h,o.parameters);j.setType(t,P.targetType||"any");j.setFormatter(P.formatter);j.setBindingMode(a.OneTime);k.push(j);});if(k.length>1||(o.formatter&&o.formatter.textFragments)){t=o.type;if(typeof t=="string"){f=O.get(t);t=new f(o.formatOptions,o.constraints);}j=new b(k,o.useRawValues,o.useInternalValues);j.setType(t,P.targetType||"any");j.setBindingMode(a.OneTime);}else{j=k[0];}j.setFormatter(o.formatter);j.initialize();return j.getExternalValue();}
return E;});
sap.ui.predefine('sap/ui/core/mvc/HTMLView',['sap/ui/thirdparty/jquery','./View','./HTMLViewRenderer','sap/base/util/merge','sap/ui/base/ManagedObject','sap/ui/core/DeclarativeSupport','sap/ui/core/library','sap/ui/model/resource/ResourceModel','sap/base/util/LoaderExtensions'],function(q,V,H,m,M,D,l,R,L){"use strict";var a=l.mvc.ViewType;
var b=V.extend("sap.ui.core.mvc.HTMLView",{metadata:{library:"sap.ui.core"}});
b.create=function(o){var p=m({},o);p.type=a.HTML;return V.create(p);};
sap.ui.htmlview=function(i,v){return sap.ui.view(i,v,a.HTML);};
b._sType=a.HTML;b.asyncSupport=true;b._mTemplates={};b._mAllowedSettings={"viewName":true,"controller":true,"viewContent":true,"definition":true,"controllerName":true,"resourceBundleName":true,"resourceBundleUrl":true,"resourceBundleLocale":true,"resourceBundleAlias":true};
b._getTemplate=function(t,o){var u=this._getViewUrl(t);var h=this._mTemplates[u];if(!h){h=this._loadTemplate(t,o);if(o&&o.async){var c=this;return h.then(function(_){c._mTemplates[u]=_;return Promise.resolve(_);});}else{this._mTemplates[u]=h;}}return o.async?Promise.resolve(h):h;};
b.prototype.getControllerName=function(){return this._controllerName;};
b._getViewUrl=function(t){return sap.ui.require.toUrl(t.replace(/\./g,"/"))+".view.html";};
b._loadTemplate=function(t,o){var r=t.replace(/\./g,"/")+".view.html";return L.loadResource(r,o);};
b.prototype.initViewSettings=function(s){if(!s){throw new Error("mSettings must be given");}if(s.viewName&&s.viewContent){throw new Error("View name and view content are given. There is no point in doing this, so please decide.");}else if(!s.viewName&&!s.viewContent){throw new Error("Neither view name nor view content is given. One of them is required.");}var t=this;function I(){t._oTemplate=document.createElement("div");if(typeof h==="string"){t._oTemplate.innerHTML=h;}else{var n=h;var f=document.createDocumentFragment();for(var i=0;i<n.length;i++){f.appendChild(n.item(i));}t._oTemplate.appendChild(f);}var o=t._oTemplate.getElementsByTagName("template")[0];var p=t.getMetadata().getAllProperties();if(o){q.each(o.attributes,function(d,A){var N=D.convertAttributeToSettingName(A.name,t.getId());var v=A.value;var P=p[N];if(!s[N]){if(P){s[N]=D.convertValueToType(D.getPropertyDataType(P),v);}else if(b._mAllowedSettings[N]){s[N]=v;}}});t._oTemplate=o;}if(t._oTemplate.content){var f=t._oTemplate.content;t._oTemplate=document.createElement("div");t._oTemplate.appendChild(f);}if(s.controllerName){t._controllerName=s.controllerName;}if((s.resourceBundleName||s.resourceBundleUrl)&&(!s.models||!s.models[s.resourceBundleAlias])){var c=new R({bundleName:s.resourceBundleName,bundleUrl:s.resourceBundleUrl,bundleLocale:s.resourceBundleLocale,async:s.async});var B=c.getResourceBundle();if(B instanceof Promise){return B.then(function(){t.setModel(c,s.resourceBundleAlias);});}t.setModel(c,s.resourceBundleAlias);}}var h=s.viewContent;if(!h){h=b._getTemplate(s.viewName,{async:s.async});}if(s.async){return h.then(function(_){h=_;return I();});}I();};
b.prototype.onControllerConnected=function(c){var t=this;M.runWithPreprocessors(function(){D.compile(t._oTemplate,t);},{settings:this._fnSettingsPreprocessor});};
b.prototype.exit=function(){this._oTemplate=null;V.prototype.exit.call(this);if(this._connectedControls){for(var i=0;i<this._connectedControls.length;i++){this._connectedControls[i].destroy();}this._connectedControls=null;}};
b.prototype.connectControl=function(c){this._connectedControls=this._connectedControls||[];this._connectedControls.push(c);};
return b;});
sap.ui.predefine('sap/ui/core/mvc/HTMLViewRenderer',['./ViewRenderer'],function(V){"use strict";var H={apiVersion:1};
H.render=function(r,c){r.openStart("div",c);r.class("sapUiView");r.class("sapUiHTMLView");V.addDisplayClass(r,c);r.style("width",c.getWidth());r.style("height",c.getHeight());r.openEnd();if(c._oTemplate){var h=c._oTemplate.innerHTML;var a=c.getContent();var d=[];var b=function(c){var t=H._getHTML(r,c,h);if(t){h=t;}else{d.push(c);}};if(a){if(Array.isArray(a)){for(var i=0;i<a.length;i++){b(a[i]);}}else if(a){b(a);}}r.unsafeHtml(h);for(var i=0;i<d.length;i++){r.renderControl(d[i]);}}r.close("div");};
H._getHTML=function(r,c,h){var i=c.getId();h=h.replace(/(<div)/gi,"\n$1");var a=new RegExp('<div.*?data-sap-ui-id="'+i+'".*?></div>',"gi");var m=a.exec(h);if(m){h=h.replace(m[0],r.getHTML(c));return h;}else{return"";}};
return H;},true);
sap.ui.predefine('sap/ui/core/mvc/JSONView',['sap/ui/thirdparty/jquery','./View','./JSONViewRenderer','./EventHandlerResolver','sap/base/util/merge','sap/ui/base/ManagedObject','sap/ui/core/library','sap/ui/model/resource/ResourceModel','sap/base/Log','sap/base/util/LoaderExtensions'],function(q,V,J,E,m,M,l,R,L,a){"use strict";var b=l.mvc.ViewType;
var c=V.extend("sap.ui.core.mvc.JSONView",{metadata:{library:"sap.ui.core"}});
c.create=function(o){var p=m({},o);for(var O in p){if(O==='preprocessors'){delete p['preprocessors'];L.warning("JSView.create does not support the option preprocessors!");}}p.type=b.JSON;return V.create(p);};
sap.ui.jsonview=function(i,v){return sap.ui.view(i,v,b.JSON);};
c._sType=b.JSON;c.asyncSupport=true;
c.prototype.initViewSettings=function(s){if(!s){throw new Error("mSettings must be given");}if(s.viewName&&s.viewContent){throw new Error("View name and view content are given. There is no point in doing this, so please decide.");}else if(!s.viewName&&!s.viewContent){throw new Error("Neither view name nor view content is given. One of them is required.");}var t=this;var i=function(){if((t._oJSONView.resourceBundleName||t._oJSONView.resourceBundleUrl)&&(!s.models||!s.models[t._oJSONView.resourceBundleAlias])){var o=new R({bundleName:t._oJSONView.resourceBundleName,bundleUrl:t._oJSONView.resourceBundleUrl,async:s.async});var B=o.getResourceBundle();if(B instanceof Promise){return B.then(function(){t.setModel(o,t._oJSONView.resourceBundleAlias);});}t.setModel(o,t._oJSONView.resourceBundleAlias);}};if(s.viewName){if(s.async){return this._loadTemplate(s.viewName,{async:true}).then(i);}else{this._loadTemplate(s.viewName);i();}}else if(s.viewContent){this.mProperties["viewContent"]=s.viewContent;if(typeof s.viewContent==="string"){this._oJSONView=JSON.parse(s.viewContent);if(!this._oJSONView){throw new Error("error when parsing viewContent: "+s.viewContent);}}else if(typeof s.viewContent==="object"){this._oJSONView=s.viewContent;}else{throw new Error("viewContent must be a JSON string or object, but is a "+(typeof s.viewContent));}if(s.async){return Promise.resolve().then(i);}else{i();}}};
c.prototype.onControllerConnected=function(C){var t=this;M.runWithPreprocessors(function(){t.applySettings({content:t._oJSONView.content},C);},{id:function(i){return t.createId(i);},settings:function(s){var o=this.getMetadata(),v=o.getJSONKeys(),k,d,K;for(k in s){if((K=v[k])!==undefined){d=s[k];switch(K._iKind){case 3:if(typeof d==="string"){s[k]=t.createId(d);}break;case 5:if(typeof d==="string"){s[k]=E.resolveEventHandler(d,C);}break;}}}}});};
c.prototype._loadTemplate=function(t,o){var r=t.replace(/\./g,"/")+".view.json";if(!o||!o.async){this._oJSONView=a.loadResource(r);}else{var d=this;return a.loadResource(r,o).then(function(j){d._oJSONView=j;});}};
c.prototype.getControllerName=function(){return this._oJSONView.controllerName;};
return c;});
sap.ui.predefine('sap/ui/core/mvc/JSONViewRenderer',['./ViewRenderer','sap/ui/core/Control'],function(V,C){"use strict";var J={apiVersion:2};
J.render=function(r,c){r.openStart("div",c);r.class("sapUiView");r.class("sapUiJSONView");V.addDisplayClass(r,c);r.style("width",c.getWidth());r.style("height",c.getHeight());r.openEnd();c.getContent().forEach(r.renderControl,r);r.close("div");};
return J;},true);
sap.ui.predefine('sap/ui/core/mvc/JSView',['./View','./JSViewRenderer','sap/base/util/extend','sap/base/util/merge','sap/ui/base/ManagedObject','sap/ui/core/library','sap/base/Log'],function(V,J,m,e,M,l,L){"use strict";
var a=V.extend("sap.ui.core.mvc.JSView",{metadata:{library:"sap.ui.core"}});
var r={};a.asyncSupport=true;var b=l.mvc.ViewType;
a.create=function(o){var p=m({},o);for(var O in p){if(O==='definition'||O==='preprocessors'){delete p[O];L.warning("JSView.create does not support the options definition or preprocessor!");}}p.type=b.JS;return V.create(p);};
sap.ui.jsview=function(i,c,A){var f=function(s){L[s]("Do not use deprecated view factory functions. "+"Use the static create function on the specific view module instead: [XML|JS|HTML|JSON]View.create().","sap.ui.view",null,function(){return{type:"sap.ui.view",name:i||(c&&c.name)};});};if(c&&c.async){f("info");}else{f("warning");}return v.apply(this,arguments);};
function v(i,c,A){var s={},o;if(c&&typeof(c)=="string"){s.viewName=c;if(typeof arguments[2]=="boolean"){s.async=A;}else if(typeof arguments[2]=="object"){s.controller=arguments[2];s.async=!!arguments[3];}o=new a(i,s);return o;}else if(c&&typeof(c)=="object"){r[i]=c;sap.ui.loader._.declareModule(i.replace(/\./g,"/")+".view.js");L.info("For defining views use JSView.extend instead.");}else if(arguments.length==1&&typeof i=="string"||arguments.length==2&&typeof arguments[0]=="string"&&typeof arguments[1]=="boolean"){s.viewName=arguments[0];s.async=!!arguments[1];o=s.id?new a(s.id,s):new a(s);return o;}else{throw new Error("Wrong arguments ('"+i+"', '"+c+"')! Either call sap.ui.jsview([sId,] sViewName) to instantiate a View or sap.ui.jsview(sViewName, oViewImpl) to define a View type.");}}
a.prototype.initViewSettings=function(s){var p;if(!r[s.viewName]){var c=s.viewName.replace(/\./g,"/")+".view";if(s.async){p=new Promise(function(d,f){sap.ui.require([c],d,f);});}else{sap.ui.requireSync(c);}}if(s.async){return Promise.resolve(p).then(function(){e(this,r[s.viewName]);}.bind(this));}e(this,r[s.viewName]);};
a.prototype.onControllerConnected=function(c){M.runWithPreprocessors(function(){this.applySettings({content:this.createContent(c)});},{id:this.getAutoPrefixId()?this.createId.bind(this):undefined,settings:this._fnSettingsPreprocessor},this);};
a.prototype.getAutoPrefixId=function(){return false;};
return a;});
sap.ui.predefine('sap/ui/core/mvc/JSViewRenderer',['./ViewRenderer'],function(V){"use strict";var J={apiVersion:2};
J.render=function(r,c){r.openStart("div",c);r.class("sapUiView");r.class("sapUiJSView");V.addDisplayClass(r,c);r.style("width",c.getWidth());r.style("height",c.getHeight());r.openEnd();c.getContent().forEach(r.renderControl,r);r.close("div");};
return J;},true);
sap.ui.predefine('sap/ui/core/mvc/OverrideExecution',function(){"use strict";var O={After:"After",Before:"Before",Instead:"Instead"};return O;},true);
sap.ui.predefine('sap/ui/core/mvc/TemplateView',['sap/ui/core/library','./View',"./TemplateViewRenderer","sap/base/Log"],function(l,V,T,L){"use strict";var a=l.mvc.ViewType;
var b=V.extend("sap.ui.core.mvc.TemplateView",{metadata:{library:"sap.ui.core"}});
(function(){
sap.ui.templateview=function(i,v){L.warning("sap.ui.core.mvc.TemplateView is deprecated. Use XMLView or JSView instead.");return sap.ui.view(i,v,a.Template);};
b._sType=a.Template;
b.prototype.getControllerName=function(){return this._sControllerName;};
b._getViewUrl=function(t){return sap.ui.require.toUrl(t.replace(/\./g,"/"))+".view.tmpl";};
b.prototype.initViewSettings=function(s){if(!s){throw new Error("mSettings must be given");}if(!s.viewName){throw new Error("No view name is given.");}this._oTemplate=sap.ui.template({id:this.getId(),src:b._getViewUrl(s.viewName)});this._sControllerName=this._oTemplate._sControllerName;this._oTemplate=this._oTemplate.createControl(undefined,undefined,this);this.addContent(this._oTemplate);};
}());return b;});
sap.ui.predefine('sap/ui/core/mvc/TemplateViewRenderer',['./ViewRenderer'],function(V){"use strict";var T={apiVersion:2};
T.render=function(r,c){r.openStart("div",c);r.class("sapUiView");r.class("sapUiTmplView");V.addDisplayClass(r,c);r.style("width",c.getWidth());r.style("height",c.getHeight());r.openEnd();r.renderControl(c._oTemplate);r.close("div");};
return T;},true);
sap.ui.predefine('sap/ui/core/mvc/View',['sap/ui/base/ManagedObject','sap/ui/core/Control','sap/ui/core/mvc/Controller','sap/base/util/merge','sap/ui/core/library',"./ViewRenderer","sap/base/assert","sap/base/Log","sap/base/util/extend"],function(M,C,a,m,b,V,c,L,d){"use strict";var f=b.mvc.ViewType;
var g=C.extend("sap.ui.core.mvc.View",{metadata:{interfaces:["sap.ui.core.IDScope"],library:"sap.ui.core",properties:{width:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:'100%'},height:{type:"sap.ui.core.CSSSize",group:"Dimension",defaultValue:null},viewName:{type:"string",group:"Misc",defaultValue:null},displayBlock:{type:"boolean",group:"Appearance",defaultValue:false}},aggregations:{content:{type:"sap.ui.core.Control",multiple:true,singularName:"content"}},events:{afterInit:{},beforeExit:{},afterRendering:{},beforeRendering:{}},specialSettings:{controller:'sap.ui.core.mvc.Controller',controllerName:'string',preprocessors:'Object',resourceBundleName:'string',resourceBundleUrl:'sap.ui.core.URI',resourceBundleLocale:'string',resourceBundleAlias:'string',type:'string',definition:'any',viewContent:{type:'any',deprecated:true},viewData:'any',async:{type:"boolean",defaultValue:false}},designtime:"sap/ui/core/designtime/mvc/View.designtime"}});
g._mPreprocessors={};
function h(P){P._settings={};for(var e in P){if(e.indexOf("_")!==0){P._settings[e]=P[e];}}}
function k(P,A){var e;if(typeof P.preprocessor==="string"){var i=P.preprocessor.replace(/\./g,"/");if(A){return new Promise(function(j,l){sap.ui.require([i],function(e){j(e);},l);});}else{return sap.ui.requireSync(i);}}else if(typeof P.preprocessor==="function"&&!P.preprocessor.process){e={process:P.preprocessor};}else{e=P.preprocessor;}if(A){return Promise.resolve(e);}else{return e;}}
function n(e,T){var j=this.mPreprocessors[T]||[],G=[],i,l,O,P=[];if(g._mPreprocessors[e]&&g._mPreprocessors[e][T]){G=g._mPreprocessors[e][T].map(function(x){return Object.assign({},x);});}for(i=0,l=G.length;i<l;i++){if(G[i]._onDemand){O=G[i];}else{P.push(G[i]);}}for(i=0,l=j.length;i<l;i++){var I=!j[i].preprocessor;if(I&&O){P.unshift(d(j[i],O));}else if(!I){P.push(j[i]);}}return P;}
function o(e,S){var i=e.getMetadata().getClass();function j(P){P.preprocessor=k(P,S.async);}e.mPreprocessors=Object.assign({},S.preprocessors);for(var _ in i.PreprocessorType){var T=i.PreprocessorType[_];if(e.mPreprocessors[T]&&!Array.isArray(e.mPreprocessors[T])){e.mPreprocessors[T]=[e.mPreprocessors[T]];}else if(!e.mPreprocessors[T]){e.mPreprocessors[T]=[];}e.mPreprocessors[T].forEach(h);e.mPreprocessors[T]=n.call(e,i._sType,T);e.mPreprocessors[T].forEach(j);}}
function p(e){e.oAsyncState={};e.oAsyncState.promise=null;}
var q=function(T,S){if(!sap.ui.getCore().getConfiguration().getControllerCodeDeactivated()){var e=S.controller,N=e&&typeof e.getMetadata==="function"&&e.getMetadata().getName(),A=S.async;if(!e&&T.getControllerName){var i=T.getControllerName();if(i){var j=sap.ui.require('sap/ui/core/CustomizingConfiguration');var l=j&&j.getControllerReplacement(i,M._sOwnerId);if(l){i=typeof l==="string"?l:l.controllerName;}if(A){e=a.create({name:i});}else{e=sap.ui.controller(i,true);}}}else if(e){var O=M._sOwnerId;if(!e._isExtended()){if(A){e=a.extendByCustomizing(e,N,A).then(function(e){return a.extendByProvider(e,N,O,A);});}else{e=a.extendByCustomizing(e,N,A);e=a.extendByProvider(e,N,O,A);}}else if(A){e=Promise.resolve(e);}}if(e){var x=function(e){T.oController=e;e.oView=T;};if(A){if(!T.oAsyncState){throw new Error("The view "+T.sViewName+" runs in sync mode and therefore cannot use async controller extensions!");}return e.then(x);}else{x(e);}}}else{sap.ui.controller("sap.ui.core.mvc.EmptyControllerImpl",{"_sap.ui.core.mvc.EmptyControllerImpl":true});T.oController=sap.ui.controller("sap.ui.core.mvc.EmptyControllerImpl");}};
g.prototype._initCompositeSupport=function(S){c(!S.preprocessors||this.getMetadata().getName().indexOf("XMLView"),"Preprocessors only available for XMLView");this.oViewData=S.viewData;this.sViewName=S.viewName;var i=this;o(this,S);if(S.async){p(this);}var j=sap.ui.require('sap/ui/core/CustomizingConfiguration');if(j&&j.hasCustomProperties(this.sViewName,this)){this._fnSettingsPreprocessor=function(S){var I=this.getId();if(j&&I){if(i.isPrefixedId(I)){I=I.substring((i.getId()+"--").length);}var e=j.getCustomProperties(i.sViewName,I,i);if(e){S=d(S,e);}}};}var P=function(e,l){c(typeof e==="function","fn must be a function");var x=sap.ui.require("sap/ui/core/Component");var O=x&&x.getOwnerComponentFor(i);if(O){if(l){i.fnScopedRunWithOwner=i.fnScopedRunWithOwner||function(y){return O.runAsOwner(y);};}return O.runAsOwner(e);}return e();};var A=function(e){if(e.oController&&e.oController.connectToView){return e.oController.connectToView(e);}};var F=function(){if(i.onControllerConnected){return i.onControllerConnected(i.oController);}};if(this.initViewSettings){if(S.async){this.oAsyncState.promise=this.initViewSettings(S).then(function(){return P(q.bind(null,i,S),true);}).then(function(){return P(F,true);}).then(function(){return A(i);}).then(function(){return i.runPreprocessor("controls",i,false);}).then(function(){return P(i.fireAfterInit.bind(i),true);}).then(function(){return i;}).catch(function(e){this.deregister();throw e;}.bind(this));}else{this.initViewSettings(S);q(this,S);F();A(this);this.runPreprocessor("controls",this,true);this.fireAfterInit();}}};
g.prototype.getController=function(){return this.oController;};
g.prototype.byId=function(i){return sap.ui.getCore().byId(this.createId(i));};
g.prototype.createId=function(i){if(!this.isPrefixedId(i)){i=this.getId()+"--"+i;}return i;};
g.prototype.getLocalId=function(i){var P=this.getId()+"--";return(i&&i.indexOf(P)===0)?i.slice(P.length):null;};
g.prototype.isPrefixedId=function(i){return!!(i&&i.indexOf(this.getId()+"--")===0);};
g.prototype.getViewData=function(){return this.oViewData;};
function r(){this.oAsyncState=null;}
g.prototype.exit=function(){this.fireBeforeExit();delete this.oController;delete this.oPreprocessorInfo;if(this.oAsyncState){var D=r.bind(this);this.oAsyncState.promise.then(D,D);}};
g.prototype.onAfterRendering=function(){this.fireAfterRendering();};
g.prototype.onBeforeRendering=function(){this.fireBeforeRendering();};
g.prototype.clone=function(i,l){var S={},K,e;for(K in this.mProperties&&!(this.isBound&&this.isBound(K))){if(this.mProperties.hasOwnProperty(K)){S[K]=this.mProperties[K];}}e=C.prototype.clone.call(this,i,l,{cloneChildren:false,cloneBindings:true});var E,x,j;for(E in e.mEventRegistry){x=e.mEventRegistry[E];for(j=x.length-1;j>=0;j--){if(x[j].oListener===this.getController()){x[j]={oListener:e.getController(),fFunction:x[j].fFunction,oData:x[j].oData};}}}e.applySettings(S);return e;};
g.prototype.getPreprocessors=function(){return this.mPreprocessors;};
g.prototype.getPreprocessorInfo=function(S){if(!this.oPreprocessorInfo){this.oPreprocessorInfo={name:this.sViewName,componentId:this._sOwnerId,id:this.getId(),caller:this+" ("+this.sViewName+")",sync:!!S};}if(g._supportInfo){this.oPreprocessorInfo._supportInfo=g._supportInfo;}return this.oPreprocessorInfo;};
g.prototype.runPreprocessor=function(T,S,e){var j=this.getPreprocessorInfo(e),P=this.mPreprocessors&&this.mPreprocessors[T]||[],x,A,y;if(!e){A=function(j,z){return function(S){return z.preprocessor.then(function(B){return B.process(S,j,z._settings);});};};y=Promise.resolve(S);}for(var i=0,l=P.length;i<l;i++){if(e&&P[i]._syncSupport===true){x=P[i].preprocessor.process;S=x(S,j,P[i]._settings);}else if(!e){y=y.then(A(j,P[i]));}else{L.debug("Async \""+T+"\"-preprocessor was skipped in sync view execution for "+this.getMetadata().getClass()._sType+"View",this.getId());}}return e?S:y;};
function s(T,e){if(!g._mPreprocessors[e]){g._mPreprocessors[e]={};}if(!g._mPreprocessors[e][T]){g._mPreprocessors[e][T]=[];}}
function t(e,i,T){g._mPreprocessors[i][T].forEach(function(P){if(P._onDemand){L.error("Registration for \""+T+"\" failed, only one on-demand-preprocessor allowed",e.getMetadata().getName());return false;}});return true;}
g.registerPreprocessor=function(T,P,e,S,O,i){if(typeof O!=="boolean"){i=O;O=false;}if(P){s(T,e);if(O&&!t(this,e,T)){return;}g._mPreprocessors[e][T].push({preprocessor:P,_onDemand:O,_syncSupport:S,_settings:i});L.debug("Registered "+(O?"on-demand-":"")+"preprocessor for \""+T+"\""+(S?" with syncSupport":""),this.getMetadata().getName());}else{L.error("Registration for \""+T+"\" failed, no preprocessor specified",this.getMetadata().getName());}};
g.prototype.hasPreprocessor=function(T){return!!this.mPreprocessors[T].length;};
g.create=function(O){var P=m({},O);P.async=true;P.viewContent=P.definition;var e=sap.ui.require("sap/ui/core/Component");var i;if(e&&M._sOwnerId){i=e.get(M._sOwnerId);}function w(){return v(P.id,P,P.type).loaded();}return new Promise(function(j,l){var x=u(P);sap.ui.require([x],function(y){j(y);},l);}).then(function(j){if(j.getMetadata().isA("sap.ui.core.mvc.XMLView")){P.processingMode="sequential";}if(i){return i.runAsOwner(w);}else{return w();}});};
g._legacyCreate=v;
sap.ui.view=function(i,e,T){var l=function(j){var N="";if(typeof i=="object"){N=i.viewName;}N=N||(e&&e.name);L[j]("Do not use deprecated view factory functions ("+N+"). "+"Use the static create function on the view module instead: [XML|JS|HTML|JSON|]View.create().","sap.ui.view",null,function(){return{type:"sap.ui.view",name:N};});};if(e&&e.async){l("info");}else{l("warning");}return v(i,e,T);};
function v(i,e,T){var j=null,l={};if(typeof i==="object"||typeof i==="string"&&e===undefined){e=i;i=undefined;}if(e){if(typeof e==="string"){l.viewName=e;}else{l=e;}}c(!l.async||typeof l.async==="boolean","sap.ui.view factory: Special setting async has to be of the type 'boolean'!");if(i){l.id=i;}if(T){l.type=T;}var x=sap.ui.require('sap/ui/core/CustomizingConfiguration');if(x){var y=x.getViewReplacement(l.viewName,M._sOwnerId);if(y){L.info("Customizing: View replacement for view '"+l.viewName+"' found and applied: "+y.viewName+" (type: "+y.type+")");d(l,y);}else{L.debug("Customizing: no View replacement found for view '"+l.viewName+"'.");}}var z=u(l);j=w(z,l);return j;}
function u(e){var i;if(!e.type){throw new Error("No view type specified.");}else if(e.type===f.JS){i='sap/ui/core/mvc/JSView';}else if(e.type===f.JSON){i='sap/ui/core/mvc/JSONView';}else if(e.type===f.XML){i='sap/ui/core/mvc/XMLView';}else if(e.type===f.HTML){i='sap/ui/core/mvc/HTMLView';}else if(e.type===f.Template){i='sap/ui/core/mvc/TemplateView';}else{throw new Error("Unknown view type "+e.type+" specified.");}return i;}
function w(e,i){var j=sap.ui.require(e);if(!j){j=sap.ui.requireSync(e);if(i.async){L.warning("sap.ui.view was called without requiring the according view class.");}}return new j(i);}
g.prototype.loaded=function(){if(this.oAsyncState&&this.oAsyncState.promise){return this.oAsyncState.promise;}else{return Promise.resolve(this);}};
return g;});
sap.ui.predefine('sap/ui/core/mvc/ViewRenderer',function(){"use strict";var V={};
V.addDisplayClass=function(r,c){if(c.getDisplayBlock()||(c.getWidth()==="100%"&&c.getHeight()==="100%")){r.class("sapUiViewDisplayBlock");}};
return V;},true);
sap.ui.predefine('sap/ui/core/mvc/XMLView',['sap/ui/thirdparty/jquery','./View',"./XMLViewRenderer","sap/base/util/deepExtend",'sap/ui/base/ManagedObject','sap/ui/core/XMLTemplateProcessor','sap/ui/core/library','sap/ui/core/Control','sap/ui/core/RenderManager','sap/ui/core/cache/CacheManager','sap/ui/model/resource/ResourceModel','sap/ui/util/XMLHelper','sap/base/strings/hash','sap/base/Log','sap/base/util/LoaderExtensions',"sap/ui/performance/trace/Interaction"],function(q,V,X,d,M,a,l,C,R,b,c,f,h,L,g,I){"use strict";var j=R.RenderPrefixes,k=l.mvc.ViewType,x="XMLViewCacheError",n={};
var m=V.extend("sap.ui.core.mvc.XMLView",{metadata:{library:"sap.ui.core",specialSettings:{containingView:{type:'sap.ui.core.mvc.XMLView',visibility:'hidden'},xmlNode:{type:'Element',visibility:'hidden'},cache:'Object',processingMode:{type:"string",visibility:"hidden"}},designtime:"sap/ui/core/designtime/mvc/XMLView.designtime"}});
sap.ui.xmlview=function(i,e){return sap.ui.view(i,e,k.XML);};
m.create=function(o){var P=d({},o);P.viewContent=P.definition;P.async=true;P.type=k.XML;P.processingMode=P.processingMode||"sequential";return V.create(P);};
m._sType=k.XML;m.asyncSupport=true;m._bUseCache=sap.ui.getCore().getConfiguration().getViewCache()&&b._isSupportedEnvironment();
function v(e){if(e.parseError.errorCode!==0){var P=e.parseError;throw new Error("The following problem occurred: XML parse Error for "+P.url+" code: "+P.errorCode+" reason: "+P.reason+" src: "+P.srcText+" line: "+P.line+" linepos: "+P.linepos+" filepos: "+P.filepos);}}
function p(o,S){if(!S){throw new Error("mSettings must be given");}else if(S.viewName&&S.viewContent){throw new Error("View name and view content are given. There is no point in doing this, so please decide.");}else if((S.viewName||S.viewContent)&&S.xmlNode){throw new Error("View name/content AND an XML node are given. There is no point in doing this, so please decide.");}else if(!(S.viewName||S.viewContent)&&!S.xmlNode){throw new Error("Neither view name/content nor an XML node is given. One of them is required.");}else if(S.cache&&!(S.cache.keys&&S.cache.keys.length)){throw new Error("No cache keys provided. At least one is required.");}}
function r(o,S){o.mProperties["viewContent"]=S.viewContent;var e=f.parse(S.viewContent);v(e);return e.documentElement;}
function s(o,S){if((o._resourceBundleName||o._resourceBundleUrl)&&(!S.models||!S.models[o._resourceBundleAlias])){var e=new c({bundleName:o._resourceBundleName,bundleUrl:o._resourceBundleUrl,bundleLocale:o._resourceBundleLocale,async:S.async});var i=e.getResourceBundle();if(i instanceof Promise){return i.then(function(){o.setModel(e,o._resourceBundleAlias);});}o.setModel(e,o._resourceBundleAlias);}}
function t(o){o.oAfterRenderingNotifier=new G();o.oAfterRenderingNotifier.addDelegate({onAfterRendering:function(){o.onAfterRenderingBeforeChildren();}});}
function u(S){var e=sap.ui.require("sap/ui/core/Component"),o;while(S&&e){var i=e.getOwnerComponentFor(S);if(i){S=o=i;}else{if(S instanceof e){o=S;}S=S.getParent&&S.getParent();}}return o;}
function w(o,e){var i=u(o),H=i?JSON.stringify(i.getManifest()):null,J=[];J=J.concat(A(o,i),D(),B(o),e.keys);return z(o,J).then(function(K){return{key:K+"("+h(H||"")+")",componentManifest:H,additionalData:e.additionalData};});}
function y(K){return K;}
function z(o,i){return Promise.all(i).then(function(K){K=K.filter(function(H){return H!==n;});if(K.every(y)){return K.join('_');}else{var e=new Error("Provided cache keys may not be empty or undefined.");e.name=x;return Promise.reject(e);}});}
function A(o,e){var i=e&&e.getMetadata().getName();return[i||window.location.host+window.location.pathname,o.getId(),sap.ui.getCore().getConfiguration().getLanguageTag()].concat(e&&e.getActiveTerminologies()||[]);}
function B(e){var P=e.getPreprocessors(),i=e.getPreprocessorInfo(false),H=[];function J(o){H.push(o.preprocessor.then(function(K){if(K.getCacheKey){return K.getCacheKey(i);}else{return n;}}));}for(var T in P){P[T].forEach(J);}return H;}
function D(){return sap.ui.getVersionInfo({async:true}).then(function(i){var T="";if(!i.libraries){T=sap.ui.buildinfo.buildtime;}else{i.libraries.forEach(function(o){T+=o.buildTimestamp;});}return T;}).catch(function(e){L.warning("sap.ui.getVersionInfo could not be retrieved","sap.ui.core.mvc.XMLView");L.debug(e);return"";});}
function E(e,i){var K=e.key;delete e.key;e.xml=f.serialize(i);return b.set(K,e);}
function F(e){return b.get(e.key).then(function(i){if(i&&i.componentManifest==e.componentManifest){i.xml=f.parse(i.xml,"application/xml").documentElement;if(i.additionalData){d(e.additionalData,i.additionalData);}return i;}});}
m.prototype.initViewSettings=function(S){var e=this,_;function i(P){e._xContent=P;if(V._supportInfo){V._supportInfo({context:e._xContent,env:{caller:"view",viewinfo:d({},e),settings:d({},S||{}),type:"xmlview"}});}if(!e.isSubView()){var Q={};a.parseViewAttributes(P,e,Q);if(!S.async){Object.assign(S,Q);}else{e.applySettings(Q);}}else{delete S.controller;}var T=s(e,S);if(T instanceof Promise){return T.then(function(){t(e);});}t(e);}function o(P,Q){if(e.hasPreprocessor("viewxml")){return a.enrichTemplateIdsPromise(P,e,Q).then(function(){return e.runPreprocessor("viewxml",P,!Q);});}return P;}function H(P){var Q=I.notifyAsyncStep("VIEW PREPROCESSING");return e.runPreprocessor("xml",P).then(function(P){return o(P,true);}).finally(Q);}function J(O){return g.loadResource(O,{async:true}).then(function(P){return P.documentElement;});}function K(O,P){return J(O).then(H).then(function(Q){if(P){E(P,Q);}return Q;});}function N(O,P){return w(e,P).then(function(Q){return F(Q).then(function(T){if(!T){return K(O,Q);}else{return T.xml;}});}).catch(function(Q){if(Q.name===x){L.debug(Q.message,Q.name,"sap.ui.core.mvc.XMLView");L.debug("Processing the View without caching.","sap.ui.core.mvc.XMLView");return K(O);}else{return Promise.reject(Q);}});}this._oContainingView=S.containingView||this;this._sProcessingMode=S.processingMode;if(this.oAsyncState){this.oAsyncState.suppressPreserve=true;}p(this,S);if(S.viewName){var O=S.viewName.replace(/\./g,"/")+".view.xml";if(S.async){if(S.cache&&m._bUseCache){return N(O,S.cache).then(i);}else{return J(O).then(H).then(i);}}else{_=g.loadResource(O).documentElement;}}else if(S.viewContent){if(S.viewContent.nodeType===window.Node.DOCUMENT_NODE){_=S.viewContent.documentElement;}else{_=r(this,S);}}else if(S.xmlNode){_=S.xmlNode;}if(S.async){return H(_).then(i);}else{_=this.runPreprocessor("xml",_,true);_=o(_,false);if(_&&typeof _.getResult==='function'){if(_.isRejected()){throw _.getResult();}_=_.getResult();}i(_);}};
m.prototype.onBeforeRendering=function(){var o=this.getDomRef();if(o&&!R.isPreservedContent(o)){R.preserveContent(o,true);}V.prototype.onBeforeRendering.apply(this,arguments);};
m.prototype.exit=function(){if(this.oAfterRenderingNotifier){this.oAfterRenderingNotifier.destroy();}V.prototype.exit.apply(this,arguments);};
m.prototype.onControllerConnected=function(o){var e=this;function i(J){return M.runWithPreprocessors(J,{settings:e._fnSettingsPreprocessor});}if(!this.oAsyncState){this._aParsedContent=i(a.parseTemplate.bind(null,this._xContent,this));}else{var H=I.notifyAsyncStep("VIEW PROCESSING");return a.parseTemplatePromise(this._xContent,this,true,{fnRunWithPreprocessor:i}).then(function(P){e._aParsedContent=P;delete e.oAsyncState.suppressPreserve;}).finally(H);}};
m.prototype.getControllerName=function(){return this._controllerName;};
m.prototype.isSubView=function(){return this._oContainingView!=this;};
m.prototype.onAfterRenderingBeforeChildren=function(){if(this._$oldContent.length!==0){var e=this.getAggregation("content");if(e){for(var i=0;i<e.length;i++){var N=document.getElementById(j.Temporary+e[i].getId())||e[i].getDomRef()||document.getElementById(j.Invisible+e[i].getId());if(N){q(document.getElementById(j.Dummy+e[i].getId())).replaceWith(N);}}}q(document.getElementById(j.Temporary+this.getId())).replaceWith(this._$oldContent);}this._$oldContent=undefined;};
m.prototype._onChildRerenderedEmpty=function(o,e){q(e).replaceWith('<div id="'+j.Dummy+o.getId()+'" class="sapUiHidden"></div>');return true;};
m.registerPreprocessor=function(T,P,S,o,e){T=T.toUpperCase();if(m.PreprocessorType[T]){V.registerPreprocessor(m.PreprocessorType[T],P,this.getMetadata().getClass()._sType,S,o,e);}else{L.error("Preprocessor could not be registered due to unknown sType \""+T+"\"",this.getMetadata().getName());}};
m.PreprocessorType={XML:"xml",VIEWXML:"viewxml",CONTROLS:"controls"};
var G=C.extend("sap.ui.core.mvc.XMLAfterRenderingNotifier",{
metadata:{library:"sap.ui.core"},
renderer:{apiVersion:2,render:function(o,e){o.text("");}}
});
m.registerPreprocessor("xml","sap.ui.core.util.XMLPreprocessor",true,true);return m;});
sap.ui.predefine('sap/ui/core/mvc/XMLViewRenderer',['./ViewRenderer','../RenderManager',"sap/ui/thirdparty/jquery"],function(V,R,q){"use strict";var P=R.RenderPrefixes.Dummy,a=R.RenderPrefixes.Invisible,b=R.RenderPrefixes.Temporary;var X={apiVersion:1};
X.render=function(r,c){var $=c._$oldContent=R.findPreservedContent(c.getId());if($.length===0){var s=c.isSubView();if(!s){r.openStart("div",c);r.class("sapUiView");r.class("sapUiXMLView");V.addDisplayClass(r,c);if(!c.oAsyncState||!c.oAsyncState.suppressPreserve){r.attr("data-sap-ui-preserve",c.getId());}r.style("width",c.getWidth());r.style("height",c.getHeight());r.openEnd();}if(c._aParsedContent){for(var i=0;i<c._aParsedContent.length;i++){var f=c._aParsedContent[i];if(f&&typeof(f)==="string"){r.write(f);}else{r.renderControl(f);if(!f.bOutput){r.openStart("div",P+f.getId());r.class("sapUiHidden");r.openEnd();}}}}if(!s){r.close("div");}}else{r.renderControl(c.oAfterRenderingNotifier);r.openStart("div",b+c.getId());r.class("sapUiHidden");r.openEnd();for(var i=0;i<c._aParsedContent.length;i++){var f=c._aParsedContent[i];if(typeof(f)!=="string"){r.renderControl(f);var F=f.getId(),d=q(document.getElementById(F));if(d.length==0){d=q(document.getElementById(a+F));}if(!R.isPreservedContent(d[0])){d.replaceWith('<div id="'+P+F+'" class="sapUiHidden"></div>');}}}r.close("div");}};
return X;},true);
sap.ui.predefine('sap/ui/core/plugin/TemplatingSupport',['sap/ui/core/Core','sap/ui/core/tmpl/Template',"sap/base/Log"],function(C,T,L){"use strict";var a=function(){};
a.prototype.startPlugin=function(c,o){L.info("Starting TemplatingSupport plugin.");this.oCore=c;sap.ui.template();};
a.prototype.stopPlugin=function(){L.info("Stopping TemplatingSupport plugin.");this.oCore=null;};
(function(){var t=new a();sap.ui.getCore().registerPlugin(t);}());return a;},true);
sap.ui.predefine('sap/ui/core/postmessage/Bus',["sap/ui/core/EventBus","sap/base/util/includes","sap/base/util/isPlainObject","sap/base/Log"],function(E,i,a,L){"use strict";var I;var s='______UI5______';
var P=E.extend("sap.ui.core.postmessage.Bus",{constructor:function(){if(I){return I;}I=this;E.apply(this,arguments);this._aAcceptedOrigins=[window.location.origin];this._aDeclinedOrigins=[];this._oPendingProcess=null;this._aEventQueue=[];this._receiver=this._receiver.bind(this);window.addEventListener('message',this._receiver);}});
P.event={CONNECT:'______CONNECT______',READY:'______READY______',ACCEPTED:'______ACCEPTED______',DECLINED:'______DECLINED______'};
P.prototype.destroy=function(){window.removeEventListener('message',this._receiver);this._aEventQueue=[];E.prototype.destroy.apply(this,arguments);I=undefined;this.bIsDestroyed=true;};
P.getInstance=function(){if(!I){I=new P();}return I;};
P.prototype.publish=function(p){var t=p.target;var o=p.origin;var c=p.channelId;var e=p.eventId;var d=p.data;if(e===P.event.READY){if(!t){if(window.opener&&window.opener!==window){t=window.opener;}else if(window.parent!==window){t=window.parent;}else{return;}}if(!o){o='*';}}if((typeof window==="undefined")||!(t!=null&&t===t.window)||t===window){throw TypeError("Target must be a window object and has to differ from current window");}if(typeof o!=="string"){throw TypeError("Origin must be a string");}if(typeof c!=="string"){throw TypeError("ChannelId must be a string");}if(typeof e!=="string"){throw TypeError("EventId must be a string");}if(!i([P.event.READY,P.event.ACCEPTED,P.event.DECLINED],e)&&o!=='*'&&!i(this._aAcceptedOrigins,o)){this._aAcceptedOrigins.push(o);}var m={origin:o,channelId:c,eventId:e,data:d};m[s]=true;t.postMessage(m,o);};
P.prototype._callListener=function(c,l,C,e,d){c.call(l,d);};
P.prototype._getText=function(k,p){return sap.ui.getCore().getLibraryResourceBundle(true).then(function(l){return l.getText(k,p);});};
P.prototype._receiver=function(e){var d=e.data;if(!a(d)||!d.hasOwnProperty(s)){return;}if(this._oPendingProcess){this._aEventQueue.push(e);}else{this._oPendingProcess=this._processEvent(e);}};
P.prototype._processEvent=function(e){return new Promise(function(r,R){var d=e.data;var o=e.origin;if(i(this._aDeclinedOrigins,o)){r();return;}switch(d.eventId){case P.event.CONNECT:{if(typeof d.data!=="string"){this.publish({target:e.source,origin:e.origin,channelId:d.channelId,eventId:P.event.DECLINED});r();}else if(i(this._aAcceptedOrigins,o)){this.publish({target:e.source,origin:e.origin,channelId:d.channelId,eventId:P.event.ACCEPTED});r();}else{sap.ui.require(["sap/ui/core/postmessage/confirmationDialog"],function(c){this._getText('PostMessage.Message',[d.data,o]).then(function(t){return c(t);}).then(function(){this.addAcceptedOrigin(o);this.publish({target:e.source,origin:e.origin,channelId:d.channelId,eventId:P.event.ACCEPTED});}.bind(this),function(){this.addDeclinedOrigin(o);this.publish({target:e.source,origin:e.origin,channelId:d.channelId,eventId:P.event.DECLINED});}.bind(this)).then(r);}.bind(this),R);}break;}case P.event.ACCEPTED:case P.event.DECLINED:case P.event.READY:{e.data.data=undefined;this._emitMessage(e);r();break;}default:{if(i(this._aAcceptedOrigins,o)){this._emitMessage(e);}r();}}}.bind(this)).catch(function(v){var m;var d;if(typeof v==='string'){m=v;}else if(v instanceof Error){m=v.message;d=v.stack;}else{m='Some unexpected error happened during post message processing';}L.error(m,d,'sap.ui.core.postmessage.Bus');}).then(function(){this._oPendingProcess=(this._aEventQueue.length>0?this._processEvent(this._aEventQueue.shift()):null);}.bind(this));};
P.prototype._emitMessage=function(e){var c=e.data.channelId;var b=e.data.eventId;E.prototype.publish.call(this,c,b,{originalEvent:e,channelId:c,eventId:b,source:e.source,origin:e.origin,data:e.data.data});};
P.prototype.getAcceptedOrigins=function(){return this._aAcceptedOrigins.slice();};
P.prototype.setAcceptedOrigins=function(o){if(!Array.isArray(o)){throw new TypeError('Expected an array, but got '+typeof o);}this._aAcceptedOrigins=o.slice();};
P.prototype.addAcceptedOrigin=function(o){if(typeof o!=='string'){throw new TypeError('Expected a string, but got '+typeof o);}if(!i(this._aAcceptedOrigins,o)){this._aAcceptedOrigins.push(o);}};
P.prototype.resetAcceptedOrigins=function(){this.setAcceptedOrigins([]);};
P.prototype.getDeclinedOrigins=function(){return this._aDeclinedOrigins.slice();};
P.prototype.setDeclinedOrigins=function(o){if(!Array.isArray(o)){throw new TypeError('Expected an array, but got '+typeof o);}this._aDeclinedOrigins=o.slice();};
P.prototype.addDeclinedOrigin=function(o){if(typeof o!=='string'){throw new TypeError('Expected a string, but got '+typeof o);}if(!i(this._aDeclinedOrigins,o)){this._aDeclinedOrigins.push(o);}};
P.prototype.resetDeclinedOrigins=function(){this.setDeclinedOrigins([]);};
return P;});
sap.ui.predefine('sap/ui/core/postmessage/confirmationDialog',function(){"use strict";return function(m){return new Promise(function(r,R){var M=sap.ui.getCore().getLoadedLibraries().hasOwnProperty('sap.m');if(M){sap.ui.require(['sap/m/MessageBox'],function(a){a.confirm(m,{actions:[a.Action.YES,a.Action.NO],onClose:function(A){if(A===a.Action.YES){r();}else{R();}}});},R);}else{var c=window.confirm(m);if(c){r();}else{R();}}});};});
sap.ui.predefine('sap/ui/core/routing/HashChanger',["./HashChangerBase","./RouterHashChanger",'sap/ui/thirdparty/hasher',"sap/base/Log","sap/base/util/ObjectPath"],function(H,R,h,L,O){"use strict";
var a=H.extend("sap.ui.core.routing.HashChanger",{constructor:function(){H.apply(this);}});
a.prototype.init=function(){if(this._initialized){L.info("this HashChanger instance has already been initialized.");return false;}this._initialized=true;h.changed.add(this.fireHashChanged,this);if(!h.isActive()){h.initialized.addOnce(this.fireHashChanged,this);h.init();}else{this.fireHashChanged(h.getHash());}return this._initialized;};
a.prototype.fireHashChanged=function(n,o){this.fireEvent("hashChanged",{newHash:n,oldHash:o});};
a.prototype.createRouterHashChanger=function(){if(!this._oRouterHashChanger){this._oRouterHashChanger=new R({parent:this});this._registerListenerToRelevantEvents();this._oRouterHashChanger.attachEvent("hashSet",this._onHashModified,this);this._oRouterHashChanger.attachEvent("hashReplaced",this._onHashModified,this);}return this._oRouterHashChanger;};
a.prototype._registerListenerToRelevantEvents=function(){if(!this._mEventListeners){this._mEventListeners={};this.getRelevantEventsInfo().forEach(function(e){var E=e.name,l=this._onHashChangedForRouterHashChanger.bind(this,e);this._mEventListeners[E]=l;this.attachEvent(E,l,this);}.bind(this));}};
a.prototype._deregisterListenerFromRelevantEvents=function(){if(this._mEventListeners){var e=Object.keys(this._mEventListeners);e.forEach(function(E){this.detachEvent(E,this._mEventListeners[E],this);}.bind(this));delete this._mEventListeners;}};
a.prototype._onHashChangedForRouterHashChanger=function(e,E){if(this._oRouterHashChanger){var p=e.paramMapping||{},P=p["newHash"]||"newHash",n=E.getParameter(P)||"",o=this._parseHash(n);this._oRouterHashChanger.fireHashChanged(o.hash,o.subHashMap,!!e.updateHashOnly);}};
a.prototype._onHashModified=function(e){var E=e.getId(),b=[e.getParameter("hash")],k=[e.getParameter("key")],n=e.getParameter("nestedHashInfo"),d=e.getParameter("deletePrefix")||[];if(Array.isArray(n)){n.forEach(function(o){b.push(o.hash);k.push(o.key);if(Array.isArray(o.deletePrefix)){o.deletePrefix.forEach(function(D){if(d.indexOf(D)===-1){d.push(D);}});}});}if(E==="hashSet"){this._setSubHash(k,b,d);}else{this._replaceSubHash(k,b,d);}};
a.prototype._setSubHash=function(k,s,c){var b=this._reconstructHash(k,s,c);this.setHash(b);};
a.prototype._replaceSubHash=function(k,s,c){var b=this._reconstructHash(k,s,c);this.replaceHash(b);};
a.prototype._reconstructHash=function(k,v,d){var p=this.getHash().split("&/"),t=p.shift();k.forEach(function(K,b){if(d){d=d.filter(function(D){return D!==K;});}var V=v[b];if(K===undefined){t=V+"";}else{var f=p.some(function(P,i,p){if(P.startsWith(K)){if(V){p[i]=K+"/"+V;}else{d.push(K);}return true;}});if(!f){p.push(K+"/"+V);}}});if(d&&d.length>0){p=p.filter(function(P){return!d.some(function(s){return P.startsWith(s);});});}p.unshift(t);return p.join("&/");};
a.prototype._parseHash=function(s){var p=s.split("&/");return{hash:p.shift(),subHashMap:p.reduce(function(m,P){var S=P.indexOf("/");m[P.substring(0,S)]=P.substring(S+1);return m;},{})};};
a.prototype.setHash=function(s){H.prototype.setHash.apply(this,arguments);h.setHash(s);};
a.prototype.replaceHash=function(s){H.prototype.replaceHash.apply(this,arguments);h.replaceHash(s);};
a.prototype.getHash=function(){return h.getHash();};
a.prototype.getRelevantEventsInfo=function(){return[{name:"hashChanged",paramMapping:{fullHash:"newHash"}}];};
a.prototype.destroy=function(){if(this._oRouterHashChanger){this._deregisterListenerFromRelevantEvents();this._oRouterHashChanger.destroy();this._oRouterHashChanger=undefined;}delete this._initialized;h.changed.remove(this.fireHashChanged,this);H.prototype.destroy.apply(this,arguments);};
a.prototype.deregisterRouterHashChanger=function(){this._deregisterListenerFromRelevantEvents();delete this._oRouterHashChanger;};
(function(){var _=null;
a.getInstance=function(){if(!_){_=new a();}return _;};
function e(o){var E,b,n;for(E in _.mEventRegistry){if(_.mEventRegistry.hasOwnProperty(E)){b=_.mEventRegistry[E];n=o.mEventRegistry[E];if(n){o.mEventRegistry[E]=b.concat(n);}else{o.mEventRegistry[E]=b;}}}}
a.replaceHashChanger=function(o){if(_&&o){var g=O.get("sap.ui.core.routing.History.getInstance"),b;if(g){b=g();b._setHashChanger(o);}if(_._oRouterHashChanger){_._oRouterHashChanger.detachEvent("hashSet",_._onHashModified,_);_._oRouterHashChanger.detachEvent("hashReplaced",_._onHashModified,_);_._deregisterListenerFromRelevantEvents();o._oRouterHashChanger=_._oRouterHashChanger;o._oRouterHashChanger.parent=o;delete _._oRouterHashChanger;o._oRouterHashChanger.attachEvent("hashSet",o._onHashModified,o);o._oRouterHashChanger.attachEvent("hashReplaced",o._onHashModified,o);o._registerListenerToRelevantEvents();}e(o);_.destroy();}_=o;};
}());return a;});
sap.ui.predefine('sap/ui/core/routing/HashChangerBase',['sap/ui/base/EventProvider'],function(E){"use strict";
var H=E.extend("sap.ui.core.routing.HashChangerBase",{
metadata:{"abstract":true,publicMethods:["getHash","setHash","replaceHash"]},
constructor:function(){E.apply(this);}
});
H.M_EVENTS={"HashChanged":"hashChanged","HashSet":"hashSet","HashReplaced":"hashReplaced"};
H.prototype.setHash=function(h){this.fireEvent("hashSet",{sHash:h,hash:h});};
H.prototype.replaceHash=function(h){this.fireEvent("hashReplaced",{sHash:h,hash:h});};
return H;});
sap.ui.predefine('sap/ui/core/routing/History',['sap/ui/core/library','./HashChanger',"sap/base/Log","sap/ui/thirdparty/URI","sap/ui/Device","sap/base/util/ObjectPath"],function(l,H,L,U,D,O){"use strict";var a=l.routing.HistoryDirection;var b="Direction_Unchanged";var c=function(h){this._iHistoryLength=window.history.length;this.aHistory=[];this._bIsInitial=true;if(c._bUsePushState){var s=window.history.state===null?{}:window.history.state,d=window.location.hash;d=d.replace(/^#/,"");if(typeof s==="object"){c._aStateHistory.push(d);s.sap={};s.sap.history=c._aStateHistory;window.history.replaceState(s,window.document.title);}else{L.debug("Unable to determine HistoryDirection as history.state is already set: "+window.history.state,"sap.ui.core.routing.History");}}if(!h){L.error("sap.ui.core.routing.History constructor was called and it did not get a hashChanger as parameter");}this._setHashChanger(h);this._reset();};c._aStateHistory=[];c._bUsePushState=!D.browser.msie&&(window.self===window.top);
c.prototype.getHistoryStateOffset=function(){if(!c._bUsePushState){return undefined;}var s=O.get("history.state.sap.history");if(!Array.isArray(s)){return undefined;}return s.length-c._aStateHistory.length;};
c.prototype.destroy=function(){this._unRegisterHashChanger();};
c.prototype.getDirection=function(n){if(n!==undefined&&this._bIsInitial){return undefined;}if(n===undefined){return this._sCurrentDirection;}return this._getDirection(n);};
c.prototype.getPreviousHash=function(){return this.aHistory[this.iHistoryPosition-1];};
c.prototype._setHashChanger=function(h){if(this._oHashChanger){this._unRegisterHashChanger();}this._oHashChanger=h;this._mEventListeners={};h.getRelevantEventsInfo().forEach(function(e){var E=e.name,p=e.paramMapping||{},f=this._onHashChange.bind(this,p);this._mEventListeners[E]=f;this._oHashChanger.attachEvent(E,f,this);}.bind(this));this._oHashChanger.attachEvent("hashReplaced",this._hashReplaced,this);this._oHashChanger.attachEvent("hashSet",this._hashSet,this);};
c.prototype._unRegisterHashChanger=function(){if(this._mEventListeners){var e=Object.keys(this._mEventListeners);e.forEach(function(E){this._oHashChanger.detachEvent(E,this._mEventListeners[E],this);}.bind(this));delete this._mEventListeners;}this._oHashChanger.detachEvent("hashReplaced",this._hashReplaced,this);this._oHashChanger.detachEvent("hashSet",this._hashSet,this);this._oHashChanger=null;};
c.prototype._reset=function(){this.aHistory.length=0;this.iHistoryPosition=0;this._bUnknown=true;this.aHistory[0]=this._oHashChanger.getHash();};
c.prototype._getDirection=function(n,h,C){if(C&&this._oNextHash&&this._oNextHash.sHash===n){return a.NewEntry;}if(h){return a.NewEntry;}if(this._bUnknown){return a.Unknown;}if(this.aHistory[this.iHistoryPosition+1]===n&&this.aHistory[this.iHistoryPosition-1]===n){return a.Unknown;}if(this.aHistory[this.iHistoryPosition-1]===n){return a.Backwards;}if(this.aHistory[this.iHistoryPosition+1]===n){return a.Forwards;}return a.Unknown;};
c.prototype._getDirectionWithState=function(h){var s=window.history.state===null?{}:window.history.state,B,d;if(typeof s==="object"){if(s.sap===undefined){c._aStateHistory.push(h);s.sap={};s.sap.history=c._aStateHistory;history.replaceState(s,document.title);d=a.NewEntry;}else{B=s.sap.history.every(function(u,e){return u===c._aStateHistory[e];});if(B&&s.sap.history.length===c._aStateHistory.length){d=b;}else{d=B?a.Backwards:a.Forwards;c._aStateHistory=s.sap.history;}}}else{L.debug("Unable to determine HistoryDirection as history.state is already set: "+window.history.state,"sap.ui.core.routing.History");}return d;};
c.prototype._onHashChange=function(p,e){var n=p.newHash||"newHash",o=p.oldHash||"oldHash",f=p.fullHash||"fullHash";this._hashChange(e.getParameter(n),e.getParameter(o),e.getParameter(f));};
c.prototype._hashChange=function(n,o,f){var d=window.history.length,s;if(this._oNextHash&&this._oNextHash.bWasReplaced&&this._oNextHash.sHash===n){this.aHistory[this.iHistoryPosition]=n;if(f!==undefined&&c._bUsePushState&&this===c.getInstance()){c._aStateHistory[c._aStateHistory.length-1]=f;window.history.replaceState({sap:{history:c._aStateHistory}},window.document.title);}this._oNextHash=null;if(!this._bIsInitial){this._sCurrentDirection=a.Unknown;}return;}this._bIsInitial=false;if(f!==undefined&&c._bUsePushState&&this===c.getInstance()){s=this._getDirectionWithState(f);}if(s===b){return;}if(!s){s=this._getDirection(n,this._iHistoryLength<window.history.length,true);}this._sCurrentDirection=s;this._iHistoryLength=d;if(this._oNextHash){this._oNextHash=null;}if(s===a.Unknown){this._reset();return;}this._bUnknown=false;if(s===a.NewEntry){if(this.iHistoryPosition+1<this.aHistory.length){this.aHistory=this.aHistory.slice(0,this.iHistoryPosition+1);}this.aHistory.push(n);this.iHistoryPosition+=1;return;}if(s===a.Forwards){this.iHistoryPosition++;return;}if(s===a.Backwards){this.iHistoryPosition--;}};
c.prototype._hashSet=function(e){this._hashChangedByApp(e.getParameter("sHash"),false);};
c.prototype._hashReplaced=function(e){this._hashChangedByApp(e.getParameter("sHash"),true);};
c.prototype._hashChangedByApp=function(n,w){this._oNextHash={sHash:n,bWasReplaced:w};};
var i=new c(H.getInstance());
c.getInstance=function(){return i;};
return c;},true);
sap.ui.predefine('sap/ui/core/routing/Route',['sap/ui/base/EventProvider','sap/ui/core/routing/Target','sap/ui/core/routing/async/Route','sap/ui/core/routing/sync/Route','sap/ui/core/Component',"sap/base/Log","sap/base/assert","sap/base/util/deepExtend"],function(E,T,a,s,C,L,b,d){"use strict";
var R=E.extend("sap.ui.core.routing.Route",{
metadata:{publicMethods:["getURL","getPattern"]},
constructor:function(r,c,p){E.apply(this,arguments);this._validateConfig(c);this._aPattern=[];this._aRoutes=[];this._oParent=p;this._oConfig=c;this._oRouter=r;var t=this,v=c.pattern,S,e,o,f,g=r._isAsync();f=g?a:s;for(var h in f){this[h]=f[h];}if(!Array.isArray(v)){v=[v];}if(c.parent){var j=this._getParentRoute(c.parent);if(!j){L.error("No parent route with '"+c.parent+"' could be found",this);}else if(j._aPattern.length>1){L.error("Routes with multiple patterns cannot be used as parent for nested routes",this);return;}else{this._oNestingParent=j;v.forEach(function(l,i){var n=j._aPattern[0];n=n.charAt(n.length)==="/"?n:n+"/";v[i]=n+l;});}}if(Array.isArray(c.subroutes)){S=c.subroutes;c.subroutes={};S.forEach(function(i){c.subroutes[i.name]=i;});}if(!c.target){var k=this._convertToTargetOptions(c);k._async=g;this._oTarget=new T(k,r._oViews,p&&p._oTarget);this._oTarget._bUseRawViewId=true;}if(c.subroutes){for(e in c.subroutes){o=c.subroutes[e];if(o.name===undefined){o.name=e;}r.addRoute(o,t);}}if(c.pattern===undefined){return;}v.forEach(function(i,I){t._aPattern[I]=i;t._aRoutes[I]=r._oRouter.addRoute(i);t._checkRoute(t._aRoutes[I]);t._aRoutes[I].greedy=c.greedy;t._aRoutes[I].matched.add(function(){var A={};Array.from(arguments).forEach(function(l,m){A[t._aRoutes[I]._paramsIds[m]]=l;});t._routeMatched(A,true);});t._aRoutes[I].switched.add(function(){t._routeSwitched();});});},
_checkRoute:function(r){var p=r._paramsIds;if(Array.isArray(p)){var D=p.filter(function(P){return P.charAt(0)==="?";}).filter(function(P){return p.indexOf(P.substring(1))>-1;}).map(function(P){return P.substring(1);});if(D.length>0){throw Error("The config of route '"+this._oConfig.name+"' contains standard parameter and query parameter with the same name: '"+D+"'. The name of the routing parameters and query parameter have to differentiate.");}}},
_routeSwitched:function(){this._suspend();this.fireEvent("switched",{name:this._oConfig.name});},
_suspend:function(){if(this._oRouter._oTargets){this._oRouter._oTargets.suspend(this._oConfig.target);}},
destroy:function(){E.prototype.destroy.apply(this);this._aPattern=null;this._aRoutes=null;this._oParent=null;this._oConfig=null;this.bIsDestroyed=true;return this;},
getURL:function(p){return this._aRoutes[0].interpolate(p||{});},
_alignTargetsConfig:function(t){if(!t){return[];}if(!Array.isArray(t)){return(typeof t==="string")?[{name:t}]:[t];}return t.map(function(v){if(typeof v==="string"){v={name:v};}return v;});},
_changeHashWithComponentTargets:function(c,p){var t=this._alignTargetsConfig(this._oConfig.target),o=this._oRouter._oTargets,e,l;if(t&&t.length>0&&o){e=o.getTarget(t);if(!Array.isArray(e)){e=[e];}}else{e=[];}var f=this;l=e.map(function(g,i){if(g._oOptions.type==="Component"){var h=g._load({prefix:t[i].prefix,propagateTitle:t[i].hasOwnProperty("propagateTitle")?t[i].propagateTitle:f._oRouter._oConfig.propagateTitle});return h.then(function(j){var r=j.getRouter(),H=r&&r.getHashChanger(),k=c&&c[t[i].name],m=k&&k.route,n=r&&r.getRoute(m),q;if(k){if(n){q=r._getLastMatchedRouteName()!==m;H.setHash(n.getURL(k.parameters),p||!q);return n._changeHashWithComponentTargets(k.componentTargetInfo,p||q);}else{L.error("Can not navigate to route with name '"+m+"' because the route does not exist in component with id '"+j.getId()+"'");}}});}});return Promise.all(l);},
getPattern:function(){return this._aPattern[0];},
match:function(h){return this._aRoutes.some(function(r){return r.match(h);});},
attachMatched:function(D,f,l){return this.attachEvent("matched",D,f,l);},
detachMatched:function(f,l){return this.detachEvent("matched",f,l);},
attachBeforeMatched:function(D,f,l){return this.attachEvent("beforeMatched",D,f,l);},
detachBeforeMatched:function(f,l){return this.detachEvent("beforeMatched",f,l);},
fireBeforeMatched:function(p){this.fireEvent("beforeMatched",p);return this;},
attachPatternMatched:function(D,f,l){return this.attachEvent("patternMatched",D,f,l);},
detachPatternMatched:function(f,l){return this.detachEvent("patternMatched",f,l);},
_validateConfig:function(c){if(!c.name){L.error("A name has to be specified for every route",this);}if(c.viewName){L.error("The 'viewName' option shouldn't be used in Route. please use 'view' instead",this);}},
_convertToTargetOptions:function(o){return d({},o,{rootView:o.targetParent,controlId:o.targetControl,controlAggregation:o.targetAggregation,clearControlAggregation:o.clearTarget,viewName:o.view,viewType:o.viewType,viewId:o.viewId});},
_getParentRoute:function(p){var P=p.split(":");if(P.length===1||(P.length===2&&!P[0])){return this._oRouter.getRoute(P[P.length-1]);}else{b(this._oRouter._oOwner,"No owner component for "+this._oRouter._oOwner.getId());var o=C.getOwnerComponentFor(this._oRouter._oOwner);while(o){if(o.getMetadata().getName()===P[0]){var r=o.getRouter();return r.getRoute(P[1]);}o=C.getOwnerComponentFor(o);}return null;}},
getPatternArguments:function(h){return this._aRoutes[0].extrapolate(h);}
});
R.M_EVENTS={BeforeMatched:"beforeMatched",Matched:"matched",PatternMatched:"patternMatched"};return R;});
sap.ui.predefine('sap/ui/core/routing/Router',['sap/ui/core/library','sap/ui/base/EventProvider','./HashChanger','./Route','./Views','./Targets','./History','sap/ui/thirdparty/crossroads',"sap/base/util/UriParameters","sap/base/util/deepEqual","sap/base/util/isEmptyObject","sap/base/Log","sap/ui/thirdparty/jquery","./RouterHashChanger","sap/ui/core/Component"],function(l,E,H,R,V,T,a,c,U,d,b,L,q,e,C){"use strict";var r={};
var f=E.extend("sap.ui.core.routing.Router",{
constructor:function(o,i,O,t,j){E.apply(this);this._oConfig=i||{};this._oRouter=c.create();this._oRouter.ignoreState=true;this._oRoutes={};this._oOwner=O;function k(){if(U.fromQuery(window.location.search).get("sap-ui-xx-asyncRouting")==="true"){L.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","Router");return true;}return false;}this._oConfig._async=this._oConfig.async;if(this._oConfig._async===undefined){this._oConfig._async=k();}this._oViews=new V({component:O,async:this._oConfig._async});if(t){this._oTargets=this._createTargets(this._oConfig,t);this._oTargets.attachDisplay(function(s){if(this.isInitialized()&&!this._bMatchingProcessStarted){var u=this.getHashChanger();if(u instanceof e){u.resetHash();}}},this);}var m=this,n;if(!o){o={};}if(Array.isArray(o)){n=o;o={};n.forEach(function(s){o[s.name]=s;});}q.each(o,function(s,u){if(u.name===undefined){u.name=s;}m.addRoute(u);});this._oRouter.bypassed.add(q.proxy(this._onBypassed,this));if(!j){j=H.getInstance().createRouterHashChanger();}this.setHashChanger(j);var p=this._oOwner&&C.getOwnerComponentFor(this._oOwner);var P=p&&p.getRouter();if(P){this.attachTitleChanged(function(s){if(this._oOwner&&!this._oOwner._bRoutingPropagateTitle){return;}var u=s.getParameters(),N,F;if(P._fnTitleChangedFiredOnChild){P._fnTitleChangedFiredOnChild(u);}else{N=u.nestedHistory.slice();N.unshift({ownerComponentId:P._oOwner.getId(),history:P.getTitleHistory()});F={propagated:true,title:u.title,history:u.history,nestedHistory:N};P.fireTitleChanged(F);}});}},
addRoute:function(o,p){if(!o.name){L.error("A name has to be specified for every route",this);}if(this._oRoutes[o.name]){L.error("Route with name "+o.name+" already exists",this);}this._oRoutes[o.name]=this._createRoute(this,o,p);},
parse:function(n){if(this._oRouter){this._oRouter.parse(n);}else{L.warning("This router has been destroyed while the hash changed. No routing events where fired by the destroyed instance.",this);}},
initialize:function(i){var t=this,s;if(this._bIsInitialized){L.warning("Router is already initialized.",this);return this;}this._bIsInitialized=true;this._bLastHashReplaced=false;this._bHashChangedAfterTitleChange=false;this.fnHashChanged=function(k){t.parse(k.getParameter("newHash"));t._bHashChangedAfterTitleChange=true;};if(!this.oHashChanger){L.error("navTo of the router is called before the router is initialized. If you want to replace the current hash before you initialize the router you may use getUrl and use replaceHash of the Hashchanger.",this);return this;}if(this._oTargets){var o=this._oRoutes[this._oConfig.homeRoute];this._oTargets.attachTitleChanged(this._forwardTitleChanged,this);this._aHistory=[];var j=o&&h(this._oOwner,o);if(j){this._aHistory.push(j);}}this.oHashChanger.init();s=this.oHashChanger.getHash();this.oHashChanger.attachEvent("hashChanged",this.fnHashChanged);if(!i&&s!==e.InvalidHash){this.parse(s);}return this;},
_forwardTitleChanged:function(o){var p=o.getParameters();var i={title:p.title};var j=this._oRoutes[this._oConfig.homeRoute];if(j&&g(p.name,j._oConfig.name)){i.isHome=true;}this.fireTitleChanged(i);},
stop:function(){if(!this._bIsInitialized){L.warning("Router is not initialized. But it got stopped",this);}if(this.fnHashChanged){this.oHashChanger.detachEvent("hashChanged",this.fnHashChanged);}if(this.fnHashReplaced){this.oHashChanger.detachEvent("hashReplaced",this.fnHashReplaced);}if(this._oTargets){this._oTargets.detachTitleChanged(this._forwardTitleChanged,this);this._oTargets._oLastTitleTarget={};}if(this._oMatchedRoute){this._oMatchedRoute._routeSwitched();this._oMatchedRoute=null;}this._bIsInitialized=false;delete this._oPreviousTitleChangedRoute;return this;},
isStopped:function(){return this._bIsInitialized===false;},
isInitialized:function(){return this._bIsInitialized===true;},
getHashChanger:function(){return this.oHashChanger;},
setHashChanger:function(o){if(this.oHashChanger){L.warning("The Router already has a HashChanger set and this call is ignored");}else{this.oHashChanger=o;}return this;},
destroy:function(){if(this.bIsDestroyed){return this;}E.prototype.destroy.apply(this);if(this._oViews){this._oViews.destroy();this._oViews=null;}if(!this._bIsInitialized){L.info("Router is not initialized, but got destroyed.",this);}if(this.fnHashChanged){this.oHashChanger.detachEvent("hashChanged",this.fnHashChanged);}if(this.fnHashReplaced){this.oHashChanger.detachEvent("hashReplaced",this.fnHashReplaced);}this._oRouter.removeAllRoutes();this._oRouter=null;q.each(this._oRoutes,function(i,o){o.destroy();});this._oRoutes=null;this._oConfig=null;if(this._oTargets){this._oTargets.destroy();this._oTargets=null;}delete this._bIsInitialized;this.bIsDestroyed=true;return this;},
getURL:function(n,p){var o=this.getRoute(n);if(o){return o.getURL(p);}else{L.warning("Route with name "+n+" does not exist",this);}},
match:function(s){return Object.keys(this._oRoutes).some(function(i){return this._oRoutes[i].match(s);}.bind(this));},
getRouteByHash:function(s){for(var i in this._oRoutes){if(this._oRoutes.hasOwnProperty(i)){var o=this.getRoute(i);if(o.match(s)){return o;}}}},
getRouteInfoByHash:function(s){var o=this.getRouteByHash(s);if(!o){return undefined;}return{name:o._oConfig.name,arguments:o.getPatternArguments(s)};},
getRoute:function(n){return this._oRoutes[n];},
getViews:function(){return this._oViews;},
_createTargets:function(o,t){return new T({views:this._oViews,config:o,targets:t});},
_createRoute:function(o,i,p){return new R(o,i,p);},
getView:function(v,s,i){L.warning("Deprecated API Router#getView called - use Router#getViews instead.",this);var o=this._oViews._getViewWithGlobalId({viewName:v,type:s,id:i});this.fireViewCreated({view:o,viewName:v,type:s});return o;},
setView:function(v,o){this._oViews.setView(v,o);return this;},
navTo:function(n,p,o,i){var t=this,j=this._getLastMatchedRouteName()!==n,k=this.getRoute(n),m,s;if(!k){L.warning("Route with name "+n+" does not exist",this);return this;}if(typeof o==="boolean"){i=o;}if(p===undefined){p={};}if(o&&!b(o)){if(!this._oConfig._async){L.error("navTo with component target info is only supported with async router",this);return this;}m=k._changeHashWithComponentTargets(o,j);}s=k.getURL(p);if(i){t._bLastHashReplaced=true;t.oHashChanger.replaceHash(s,m,!j);}else{t.oHashChanger.setHash(s,m,!j);}return this;},
_getLastMatchedRouteName:function(){return this._oMatchedRoute&&this._oMatchedRoute._oConfig.name;},
getTargets:function(){return this._oTargets;},
getTarget:function(n){return this._oTargets.getTarget(n);},
attachRouteMatched:function(D,F,o){this.attachEvent("routeMatched",D,F,o);return this;},
detachRouteMatched:function(F,o){this.detachEvent("routeMatched",F,o);return this;},
fireRouteMatched:function(p){this.fireEvent("routeMatched",p);if(f._interceptRouteMatched){f._interceptRouteMatched(this._oConfig.controlId,this);}return this;},
attachBeforeRouteMatched:function(D,F,o){this.attachEvent("beforeRouteMatched",D,F,o);return this;},
detachBeforeRouteMatched:function(F,o){this.detachEvent("beforeRouteMatched",F,o);return this;},
fireBeforeRouteMatched:function(p){this.fireEvent("beforeRouteMatched",p);return this;},
attachViewCreated:function(D,F,o){this.attachEvent("viewCreated",D,F,o);return this;},
detachViewCreated:function(F,o){this.detachEvent("viewCreated",F,o);return this;},
fireViewCreated:function(p){this.fireEvent("viewCreated",p);return this;},
attachRoutePatternMatched:function(D,F,o){this.attachEvent("routePatternMatched",D,F,o);return this;},
detachRoutePatternMatched:function(F,o){this.detachEvent("routePatternMatched",F,o);return this;},
fireRoutePatternMatched:function(p){this.fireEvent("routePatternMatched",p);return this;},
attachBypassed:function(D,F,o){return this.attachEvent(f.M_EVENTS.BYPASSED,D,F,o);},
detachBypassed:function(F,o){return this.detachEvent(f.M_EVENTS.BYPASSED,F,o);},
fireBypassed:function(p){return this.fireEvent(f.M_EVENTS.BYPASSED,p);},
attachTitleChanged:function(D,F,o){this.attachEvent(f.M_EVENTS.TITLE_CHANGED,D,F,o);return this;},
detachTitleChanged:function(F,o){return this.detachEvent(f.M_EVENTS.TITLE_CHANGED,F,o);},
fireTitleChanged:function(p){if(this.isStopped()){return this;}var I=!this._pWaitForTitleChangedOnChild;if(!p.propagated){p.propagated=false;var D=a.getInstance().getDirection(),s=this.getHashChanger().getHash(),j=l.routing.HistoryDirection,o=this._aHistory[this._aHistory.length-1],n;if(D===j.Backwards&&o&&!o.isHome){if(o&&o.title!==p.title){this._aHistory.pop();}}else if(o&&o.hash==s){o.title=p.title;this._aHistory.some(function(k,i,m){if(i<m.length-1&&d(k,o)){return m.splice(i,1);}});}else{if(this._bLastHashReplaced){this._aHistory.pop();}n={hash:s,title:p.title};this._aHistory.some(function(k,i,m){if(d(k,n)){return m.splice(i,1);}});this._aHistory.push(n);}p.history=this._aHistory.slice(0,-1);p.nestedHistory=[{history:this.getTitleHistory(),ownerComponentId:this._oOwner&&this._oOwner.getId()}];this._bLastHashReplaced=false;this._oPreviousTitleChangedRoute=this._oMatchedRoute;this._bFireTitleChanged=false;if(this._pWaitForTitleChangedOnChild){this._pWaitForTitleChangedOnChild.then(function(i){p.title=i.title;p.propagated=true;Array.prototype.push.apply(p.nestedHistory,i.nestedHistory);this._stopWaitingTitleChangedFromChild();this.fireEvent(f.M_EVENTS.TITLE_CHANGED,p);}.bind(this));}}if(I){this.fireEvent(f.M_EVENTS.TITLE_CHANGED,p);}return this;},
getTitleHistory:function(){return this._aHistory||[];},
_waitForTitleChangedOn:function(n){if(this._bFireTitleChanged){this._pWaitForTitleChangedOnChild=new Promise(function(i){this._fnTitleChangedFiredOnChild=i;}.bind(this));}},
_stopWaitingTitleChangedFromChild:function(){delete this._pWaitForTitleChangedOnChild;delete this._fnTitleChangedFiredOnChild;},
register:function(n){r[n]=this;return this;},
_onBypassed:function(s){var F=function(){this.fireBypassed({hash:s});}.bind(this);if(this._oConfig.bypassed){var o=this._oTargets.display(this._oConfig.bypassed.target,{hash:s});if(o instanceof Promise){o.then(F);return;}}F();},
_isAsync:function(){return this._oConfig._async;},
metadata:{publicMethods:["initialize","getURL","register","getRoute"]}
});
function g(s,i){return i&&i.indexOf(s)>-1;}
function h(o,i){var s=i.getPattern(),A=o&&o.getManifestEntry("sap.app/title");if(s===""||(s!==undefined&&!/({.*})+/.test(s))){return{hash:s,isHome:true,title:A};}else{L.error("Routes with dynamic parts cannot be resolved as home route.");}}
f.M_EVENTS={BEFORE_ROUTE_MATCHED:"beforeRouteMatched",ROUTE_MATCHED:"routeMatched",ROUTE_PATTERN_MATCHED:"routePatternMatched",VIEW_CREATED:"viewCreated",BYPASSED:"bypassed",TITLE_CHANGED:"titleChanged"};f._interceptRouteMatched=undefined;
f.getRouter=function(n){return r[n];};
return f;});
sap.ui.predefine('sap/ui/core/routing/RouterHashChanger',['./HashChangerBase',"sap/base/Log"],function(H,L){"use strict";
var R=H.extend("sap.ui.core.routing.RouterHashChanger",{constructor:function(s){if(!s||!s.parent){throw new Error("sap.ui.core.routing.RouterHashChanger can't be instantiated without a parent");}this.parent=s.parent;this.hash=s.hash||"";this.subHashMap=s.subHashMap;this.key=s.key||"";H.apply(this);}});
R.InvalidHash=Object.create(null);
R.prototype.init=function(){this.parent.init();};
R.prototype._generatePrefixedKey=function(k){return this.key?(this.key+"-"+k):k;};
R.prototype.createSubHashChanger=function(k){this.children=this.children||{};var p=this._generatePrefixedKey(k);if(this.children[p]){return this.children[p];}var c=new R({key:p,parent:this,subHashMap:this.subHashMap,hash:(this.subHashMap&&this.subHashMap[p])||""});c.attachEvent("hashSet",this._onChildHashChanged.bind(this,p));c.attachEvent("hashReplaced",this._onChildHashChanged.bind(this,p));this.children[p]=c;return c;};
R.prototype.fireHashChanged=function(h,s,u){var k,o=this.hash;this.hash=h;this.subHashMap=s;if(!u&&h!==o){this.fireEvent("hashChanged",{newHash:h,oldHash:o});}if(this.children){k=Object.keys(this.children);k.forEach(function(c){var C=(s[c]===undefined?"":s[c]);this.children[c].fireHashChanged(C,s,u);}.bind(this));}};
R.prototype._onChildHashChanged=function(k,e){var c=e.getParameter("key")||k,h=e.getParameter("hash"),n=e.getParameter("nestedHashInfo"),d=e.getParameter("deletePrefix");if(this._bCollectMode){this._collectHash(c,h,d);}else{this.fireEvent(e.getId(),{hash:h,key:c,nestedHashInfo:n,deletePrefix:d});}};
R.prototype._collectHash=function(k,h,d){this._aCollectedHashInfo=this._aCollectedHashInfo||[];this._aCollectedHashInfo.push({key:k,hash:h,deletePrefix:d});};
R.prototype._hasRouterAttached=function(){return this.hasListeners("hashChanged");};
R.prototype._collectActiveDescendantPrefix=function(){if(this.children){var k=Object.keys(this.children);return k.reduce(function(p,K){var c=this.children[K];if(c._hasRouterAttached()){p.push(K);Array.prototype.push.apply(p,c._collectActiveDescendantPrefix());}return p;}.bind(this),[]);}else{return[];}};
R.prototype.getHash=function(){if(this._isUnderCollectMode()){return R.InvalidHash;}else{return this.hash;}};
R.prototype.resetHash=function(){this.hash=undefined;return this;};
R.prototype.setHash=function(h,p,s){if(!(p instanceof Promise)){s=p;p=null;}return this._modifyHash(h,p,s);};
R.prototype.replaceHash=function(h,p,s){if(!(p instanceof Promise)){s=p;p=null;}return this._modifyHash(h,p,s,true);};
R.prototype._modifyHash=function(h,p,s,r){var a,e=r?"hashReplaced":"hashSet",t=this;if(!s){a=this._collectActiveDescendantPrefix();}if(p){this._bCollectMode=true;return p.then(function(){t.fireEvent(e,{hash:h,nestedHashInfo:t._aCollectedHashInfo,deletePrefix:a});t._aCollectedHashInfo=null;t._bCollectMode=false;});}else{this.fireEvent(e,{hash:h,deletePrefix:a});}};
R.prototype._isUnderCollectMode=function(){return this.parent instanceof R&&this.parent._isInCollectMode();};
R.prototype._isInCollectMode=function(){return this._bCollectMode||(this.parent instanceof R&&this.parent._isInCollectMode());};
R.prototype.destroy=function(){this.parent.deregisterRouterHashChanger(this);if(this.children){Object.keys(this.children).forEach(function(k){var c=this.children[k];c.destroy();}.bind(this));delete this.children;}delete this.hash;delete this.subHashMap;delete this.parent;delete this.key;H.prototype.destroy.apply(this,arguments);};
R.prototype.deregisterRouterHashChanger=function(r){if(this.children){Object.keys(this.children).some(function(k){var c=this.children[k];if(c===r){delete this.children[k];return true;}}.bind(this));}};
return R;});
sap.ui.predefine('sap/ui/core/routing/Target',['sap/ui/core/Control','sap/ui/base/EventProvider','sap/ui/core/mvc/View','sap/ui/core/routing/async/Target','sap/ui/core/routing/sync/Target',"sap/base/util/UriParameters","sap/base/Log"],function(C,E,V,a,s,U,L){"use strict";
var T=E.extend("sap.ui.core.routing.Target",{
constructor:function(o,c){var e;function d(){if(U.fromQuery(window.location.search).get("sap-ui-xx-asyncRouting")==="true"){L.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","Target");return true;}return false;}if(o._async===undefined){o._async=d();}if(o.type==="Component"&&!o._async){e="sap.ui.core.routing.Target doesn't support loading component in synchronous mode, please switch routing to async";L.error(e);throw new Error(e);}this._updateOptions(o);this._oCache=c;E.apply(this,arguments);if(this._oOptions.title){this._oTitleProvider=new b({target:this});}var f=this._oOptions._async?a:s;for(var g in f){this[g]=f[g];}this._bIsDisplayed=false;this._bIsLoaded=false;},
destroy:function(){this._oParent=null;this._oOptions=null;this._oCache=null;if(this._oTitleProvider){this._oTitleProvider.destroy();}this._oTitleProvider=null;E.prototype.destroy.apply(this,arguments);this.bIsDestroyed=true;return this;},
attachDisplay:function(d,f,l){return this.attachEvent(this.M_EVENTS.DISPLAY,d,f,l);},
detachDisplay:function(f,l){return this.detachEvent(this.M_EVENTS.DISPLAY,f,l);},
fireDisplay:function(p){var t=this._oTitleProvider&&this._oTitleProvider.getTitle();if(t){this.fireTitleChanged({name:this._oOptions._name,title:t});}this._bIsDisplayed=true;return this.fireEvent(this.M_EVENTS.DISPLAY,p);},
attachTitleChanged:function(d,f,l){var h=this.hasListeners("titleChanged"),t=this._oTitleProvider&&this._oTitleProvider.getTitle();this.attachEvent(this.M_EVENTS.TITLE_CHANGED,d,f,l);if(!h&&t&&this._bIsDisplayed){this.fireTitleChanged({name:this._oOptions._name,title:t});}return this;},
detachTitleChanged:function(f,l){return this.detachEvent(this.M_EVENTS.TITLE_CHANGED,f,l);},
fireTitleChanged:function(p){return this.fireEvent(this.M_EVENTS.TITLE_CHANGED,p);},
_getEffectiveObjectName:function(n){var p=this._oOptions.path;if(p){n=p+"."+n;}return n;},
_updateOptions:function(o){if(o.viewName){if(o.name){o._name=o.name;}o.type="View";o.name=o.viewName;if(o.viewPath){o.path=o.viewPath;}if(o.viewId){o.id=o.viewId;}}this._oOptions=o;},
_bindTitleInTitleProvider:function(v){if(this._oTitleProvider&&v instanceof V){this._oTitleProvider.applySettings({title:this._oOptions.title},v.getController());}},
_addTitleProviderAsDependent:function(v){if(!this._oTitleProvider){return;}var o=this._oTitleProvider.getParent();if(o){o.removeDependent(this._oTitleProvider);}if(v instanceof V){v.addDependent(this._oTitleProvider);}},
_beforePlacingViewIntoContainer:function(A){},
M_EVENTS:{DISPLAY:"display",TITLE_CHANGED:"titleChanged"}
});
var b=C.extend("sap.ui.core.routing.Target.TitleProvider",{
metadata:{library:"sap.ui.core",properties:{title:{type:"string",group:"Data",defaultValue:null}}},
constructor:function(S){this._oTarget=S.target;delete S.target;C.prototype.constructor.call(this,S);},
setTitle:function(t){this.setProperty("title",t,true);if(this._oTarget._bIsDisplayed&&t){this._oTarget.fireTitleChanged({name:this._oTarget._oOptions._name,title:t});}}
});
return T;});
sap.ui.predefine('sap/ui/core/routing/TargetCache',['sap/ui/base/EventProvider','sap/ui/core/routing/async/TargetCache','sap/ui/core/routing/sync/TargetCache',"sap/base/assert","sap/base/Log"],function(E,a,s,b,L){"use strict";
var T=E.extend("sap.ui.core.routing.TargetCache",{
constructor:function(o){if(!o){o={};}this._oCache={view:{},component:{}};this._oComponent=o.component;if(this._oComponent){b(this._oComponent.isA("sap.ui.core.UIComponent"),this+' - the component passed to the constructor needs to be an instance of UIComponent');}E.apply(this,arguments);this.async=o.async;if(this.async===undefined){this.async=true;}var C=this.async?a:s;for(var f in C){this[f]=C[f];}},
metadata:{publicMethods:["get","set"]},
get:function(o,t){var O;try{if(t==="Component"&&!this.async){L.error("sap.ui.core.routing.Target doesn't support loading component in synchronous mode, please switch routing to async");throw new Error("sap.ui.core.routing.Target doesn't support loading component in synchronous mode, please switch routing to async");}if(!o){L.error("the oOptions parameter of getObject is mandatory",this);throw new Error("the oOptions parameter of getObject is mandatory");}O=this._get(o,t);}catch(e){return Promise.reject(e);}if(O instanceof Promise){return O;}else if(O.isA("sap.ui.core.mvc.View")){return O.loaded();}else{return Promise.resolve(O);}},
set:function(n,t,o){var i;this._checkName(n,t);b(t==="View"||t==="Component","sType must be either 'View' or 'Component'");i=this._oCache[t.toLowerCase()][n];if(!i){i=this._oCache[t.toLowerCase()][n]={};}i[undefined]=o;return this;},
destroy:function(){E.prototype.destroy.apply(this);if(this.bIsDestroyed){return this;}function d(o){if(o&&o.destroy){o.destroy();}}Object.keys(this._oCache).forEach(function(t){var o=this._oCache[t];Object.keys(o).forEach(function(k){var i=o[k];Object.keys(i).forEach(function(I){var O=i[I];if(O instanceof Promise){O.then(d);}else{d(O);}});});}.bind(this));this._oCache=undefined;this.bIsDestroyed=true;return this;},
attachCreated:function(d,f,l){return this.attachEvent("created",d,f,l);},
detachCreated:function(f,l){return this.detachEvent("created",f,l);},
fireCreated:function(p){return this.fireEvent("created",p);},
_get:function(o,t,g,i){var O;switch(t){case"View":O=this._getView(o,g);break;case"Component":O=this._getComponent(o,g,i);break;default:throw Error("The given sType: "+t+" isn't supported by TargetCache.getObject");}return O;},
_getView:function(o,g){if(!g){o=this._createId(o);}return this._getViewWithGlobalId(o);},
_getComponent:function(o,g,i){if(!g){o=this._createId(o);}return this._getComponentWithGlobalId(o,i);},
_createId:function(o){if(this._oComponent&&o.id){o=Object.assign({},o,{id:this._oComponent.createId(o.id)});}return o;},
_checkName:function(n,t){if(!n){var m="A name for the "+t.toLowerCase()+" has to be defined";L.error(m,this);throw Error(m);}}
});
return T;});
sap.ui.predefine('sap/ui/core/routing/Targets',['sap/ui/base/EventProvider','./Target','./async/Targets','./sync/Targets',"sap/base/util/UriParameters","sap/base/Log","sap/base/util/deepExtend"],function(E,T,a,s,U,L,d){"use strict";
var b=E.extend("sap.ui.core.routing.Targets",{
constructor:function(o){var t,c;E.apply(this);this._mTargets={};this._oLastTitleTarget={};this._oConfig=o.config;this._oCache=o.cache||o.views;if(!this._oConfig){this._oConfig={_async:false};}function e(){if(U.fromQuery(window.location.search).get("sap-ui-xx-asyncRouting")==="true"){L.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","Targets");return true;}return false;}if(this._oConfig._async===undefined){this._oConfig._async=(this._oConfig.async===undefined)?e():this._oConfig.async;}var f=this._oConfig._async?a:s;for(var g in f){this[g]=f[g];}for(t in o.targets){if(o.targets.hasOwnProperty(t)){this._createTarget(t,o.targets[t]);}}for(c in this._mTargets){if(this._mTargets.hasOwnProperty(c)){this._addParentTo(this._mTargets[c]);}}},
destroy:function(){var t;E.prototype.destroy.apply(this);for(t in this._mTargets){if(this._mTargets.hasOwnProperty(t)){this._mTargets[t].destroy();}}this._mTargets=null;this._oCache=null;this._oConfig=null;this.bIsDestroyed=true;return this;},
getViews:function(){return this._oCache;},
getCache:function(){return this._oCache;},
getTarget:function(n,S){var t=this,c=this._alignTargetsInfo(n),e;e=c.reduce(function(A,C){var o=t._mTargets[C.name];if(o){A.push(o);}else if(!S){L.error("The target you tried to get \""+C.name+"\" does not exist!",t);}return A;},[]);return e.length<=1?e[0]:e;},
addTarget:function(n,t){var o=this.getTarget(n,true),c;if(o){L.error("Target with name "+n+" already exists",this);}else{c=this._createTarget(n,t);this._addParentTo(c);}return this;},
suspend:function(t){var c=this._alignTargetsInfo(t);c.forEach(function(o){var e=this.getTarget(o.name);if(e){e.suspend();}}.bind(this));return this;},
attachDisplay:function(D,f,l){return this.attachEvent(this.M_EVENTS.DISPLAY,D,f,l);},
detachDisplay:function(f,l){return this.detachEvent(this.M_EVENTS.DISPLAY,f,l);},
fireDisplay:function(p){return this.fireEvent(this.M_EVENTS.DISPLAY,p);},
attachTitleChanged:function(D,f,l){this.attachEvent(this.M_EVENTS.TITLE_CHANGED,D,f,l);return this;},
detachTitleChanged:function(f,l){return this.detachEvent(this.M_EVENTS.TITLE_CHANGED,f,l);},
fireTitleChanged:function(p){if(this._oLastTitleTarget.name!==p.name||this._oLastTitleTarget.title!==p.title){this._oLastTitleTarget.name=p.name;this._oLastTitleTarget.title=p.title;this.fireEvent(this.M_EVENTS.TITLE_CHANGED,p);}return this;},
M_EVENTS:{DISPLAY:"display",TITLE_CHANGED:"titleChanged"},
_alignTargetsInfo:function(t){if(t===undefined){return[];}if(!Array.isArray(t)){return(typeof t==="object")?[t]:[{name:t}];}return t.map(function(v){if(typeof v!=="object"){v={name:v};}return v;});},
_createTarget:function(n,t){var o,O;O=d({_name:n},this._oConfig,t);o=this._constructTarget(O);o.attachDisplay(function(e){var p=e.getParameters();this.fireDisplay({name:n,view:p.view,control:p.control,config:p.config,data:p.data});},this);this._mTargets[n]=o;return o;},
_addParentTo:function(t){var p,P=t._oOptions.parent;if(!P){return;}p=this._mTargets[P];if(!p){L.error("The target '"+t._oOptions._name+" has a parent '"+P+"' defined, but it was not found in the other targets",this);return;}t._oParent=p;},
_constructTarget:function(o,p){return new T(o,this._oCache,p);},
_setRootViewId:function(i){var t,o;for(t in this._mTargets){if(this._mTargets.hasOwnProperty(t)){o=this._mTargets[t]._oOptions;if(o.rootView===undefined){o.rootView=i;}}}},
_getTitleTargetName:function(t,p){var o,c;if(p){t=[p];}t=this._alignTargetsInfo(t);t.some(function(e){o=this.getTarget(e);while(o&&!o._oOptions.title){o=o._oParent;}if(o){c=o._oOptions._name;return true;}}.bind(this));return c;},
_forwardTitleChanged:function(e){this.fireTitleChanged({name:e.getParameter("name"),title:e.getParameter("title")});},
_attachTitleChanged:function(t,c){var o,C;C=this._getTitleTargetName(t,c);if(C){o=this.getTarget(C);}if(this._oLastDisplayedTitleTarget){this._oLastDisplayedTitleTarget.detachTitleChanged(this._forwardTitleChanged,this);this._oLastDisplayedTitleTarget._bIsDisplayed=false;}if(o){o.attachTitleChanged({name:o._oOptions._name},this._forwardTitleChanged,this);this._oLastDisplayedTitleTarget=o;}else if(c){L.error("The target with the name \""+c+"\" where the titleChanged event should be fired does not exist!",this);}}
});
return b;});
sap.ui.predefine('sap/ui/core/routing/Views',["./TargetCache","sap/base/util/UriParameters","sap/base/Log"],function(T,U,L){"use strict";
var V=T.extend("sap.ui.core.routing.Views",{
metadata:{publicMethods:["getView","setView"]},
constructor:function(o){if(!o){o={};}function c(){if(U.fromQuery(window.location.search).get("sap-ui-xx-asyncRouting")==="true"){L.warning("Activation of async view loading in routing via url parameter is only temporarily supported and may be removed soon","TargetCache");return true;}return false;}if(o.async===undefined){o.async=c();}T.apply(this,[o]);},
getView:function(o){return this.get(o,"View");},
setView:function(v,o){return this.set(v,"View",o);},
fireCreated:function(p){if(p){p.view=p.object;p.viewOptions=p.options;}return this.fireEvent("created",p);}
});
return V;});
sap.ui.predefine('sap/ui/core/routing/async/Route',['sap/ui/Device',"sap/base/Log","sap/base/util/extend","sap/ui/core/Component"],function(D,L,e,C){"use strict";return{_routeMatched:function(a,s,n){var r=this._oRouter,t,T,c,E,v=null,o=null,i,b,d,A,f=this;r._stopWaitingTitleChangedFromChild();r._oMatchedRoute=this;r._bMatchingProcessStarted=true;c=e({},r._oConfig,this._oConfig);T=r.getTargets();var g;if(T){g=T._getTitleTargetName(c.target,c.titleTarget);if(g&&r._oPreviousTitleChangedRoute!==this){r._bFireTitleChanged=true;if((r._oOwner&&r._oOwner._bRoutingPropagateTitle)){var p=C.getOwnerComponentFor(r._oOwner);var P=p&&p.getRouter();if(P){P._waitForTitleChangedOn(r);}}}else{r._bFireTitleChanged=false;}if(this._oConfig.target){A=T._alignTargetsInfo(this._oConfig.target);A.forEach(function(t){t.propagateTitle=t.hasOwnProperty("propagateTitle")?t.propagateTitle:r._oConfig.propagateTitle;});}}else{A=this._oConfig.target;}if(!s||s===true){i=true;s=Promise.resolve();}if(this._oParent){s=this._oParent._routeMatched(a,s);}else if(this._oNestingParent){this._oNestingParent._routeMatched(a,s,this);}b=Object.assign({},a);b.routeConfig=c;E={name:c.name,arguments:a,config:c};if(n){E.nestedRoute=n;}this.fireBeforeMatched(E);r.fireBeforeRouteMatched(E);if(this._oTarget){t=this._oTarget;t._updateOptions(this._convertToTargetOptions(c));s=t._place(s);if(this._oRouter._oTargetHandler&&this._oRouter._oTargetHandler._chainNavigation){d=s;s=this._oRouter._oTargetHandler._chainNavigation(function(){return d;});}}else{if(D.browser.msie||D.browser.edge){d=s;s=new Promise(function(h,j){setTimeout(function(){if(r._oTargets){var k=r._oTargets._display(A,b,f._oConfig.titleTarget,d);k.then(h,j);}else{h();}},0);});}else{s=r._oTargets._display(A,b,this._oConfig.titleTarget,s);}}return s.then(function(R){r._bMatchingProcessStarted=false;var h,V,j;if(Array.isArray(R)){h=R;R=h[0];}R=R||{};v=R.view;o=R.control;E.view=v;E.targetControl=o;if(h){V=[];j=[];h.forEach(function(R){V.push(R.view);j.push(R.control);});E.views=V;E.targetControls=j;}if(c.callback){c.callback(this,a,c,o,v);}this.fireEvent("matched",E);r.fireRouteMatched(E);if(i){L.info("The route named '"+c.name+"' did match with its pattern",this);this.fireEvent("patternMatched",E);r.fireRoutePatternMatched(E);}return R;}.bind(this));}};});
sap.ui.predefine('sap/ui/core/routing/async/Target',["sap/base/Log","sap/ui/core/ComponentContainer","sap/ui/core/library"],function(L,C,c){"use strict";var a=c.ComponentLifecycle;return{display:function(d){var s=Promise.resolve();return this._display(d,s);},_display:function(d,s,t){if(this._oParent){s=this._oParent._display(d,s,t);}return this._place(d,s,t);},suspend:function(){if(this._oParent){this._oParent.suspend();}if(this._isLoaded()){var o=this._get(),r;if(o.isA("sap.ui.core.UIComponent")&&(r=o.getRouter())){r.stop();}}else{L.warning("The target with name '"+this._oOptions._name+"' can't be suspended because it's being loaded or not loaded yet");}return this;},_isLoaded:function(){return this._bIsLoaded;},_get:function(t){var n=this._getEffectiveObjectName(this._oOptions.name),o=this._oOptions,b;switch(o.type){case"View":b={name:n,type:o.viewType,id:o.id,async:true};break;case"Component":b={id:o.id};if(o.usage){b.usage=o.usage;}else{b.name=n;}b=Object.assign({},o.options||{},b);break;default:throw new Error("The given type "+o.type+" isn't support by sap.ui.core.routing.Target");}return this._oCache._get(b,o.type,this._bUseRawViewId,t);},_load:function(t){var o=this._get(t),p;if(!(o instanceof Promise)){if(o.isA("sap.ui.core.mvc.View")){p=o.loaded();}else{p=Promise.resolve(o);}}else{p=o;}return p.then(function(o){this._bIsLoaded=true;return o;}.bind(this));},_place:function(d,s,t){if(d instanceof Promise){t=s;s=d;d=undefined;}var o=this._oOptions,b=this,O,e,p,i=true,r,f;if((o.name||o.usage)&&o.type){f=new Promise(function(g){r=g;});p=this._load(t).then(function(O){if(O.isA("sap.ui.core.UIComponent")){var R=O.getRouter();if(R){var h=R.getHashChanger().getHash();var g=R.getRouteByHash(h);if(!R._oConfig.async){throw new Error("The router of component '"+O.getId()+"' which is loaded via the target '"+b._oOptions._name+"' is defined as synchronous which is not supported using as a nested component.");}if(R._oOwner){R._oOwner._bRoutingPropagateTitle=t.propagateTitle;}if(g&&g._oConfig.target){i=false;R.attachRouteMatched(r);}if(R.isStopped()){R.initialize();}}}if(i){r();}return O;});s=s.then(function(P){return p.then(function(O){return{object:O,parentInfo:P||{}};});}).then(function(v){var V=b._isValid(v.parentInfo),g,R;O=v.object;if(O.isA("sap.ui.core.UIComponent")){R=O.getRootControl();if(R&&R.isA("sap.ui.core.mvc.View")){g=R;}}else{g=O;}b._bindTitleInTitleProvider(g);b._addTitleProviderAsDependent(g);if(V!==true){e=V;return b._refuseInvalidTarget(o._name,e);}var h=v.parentInfo.view,j=v.parentInfo.control,k=Promise.resolve(j);if(h&&h.isA("sap.ui.core.ComponentContainer")){h=h.getComponentInstance().getRootControl();}if(!h&&o.rootView){h=sap.ui.getCore().byId(o.rootView);if(!h){e="Did not find the root view with the id "+o.rootView;return b._refuseInvalidTarget(o._name,e);}}if(o.controlId){if(h&&h.isA("sap.ui.core.mvc.View")){k=h.loaded().then(function(l){return l.byId(o.controlId);});}k=k.then(function(l){if(!l){l=sap.ui.getCore().byId(o.controlId);}if(!l){e="Control with ID "+o.controlId+" could not be found";return b._refuseInvalidTarget(o._name,e);}else{return l;}});}return k;}).then(function(g){var h,j,k;if(O.isA("sap.ui.core.UIComponent")){h=O;j=h.getId()+"-container";O=sap.ui.getCore().byId(j);if(!O){var l=Object.assign({component:h,height:"100%",width:"100%",lifecycle:a.Application},o.containerOptions);O=new C(j,l);k=h.destroy;h.destroy=function(){if(k){k.apply(this);}O.destroy();};}}b._beforePlacingViewIntoContainer({container:g,view:O,data:d});var A=g.getMetadata().getJSONKeys()[o.controlAggregation];if(!A){e="Control "+o.controlId+" does not have an aggregation called "+o.controlAggregation;return b._refuseInvalidTarget(o._name,e);}if(o.clearControlAggregation===true){g[A._sRemoveAllMutator]();}L.info("Did place the "+o.type.toLowerCase()+" target '"+(o.name?b._getEffectiveObjectName(o.name):o.usage)+"' with the id '"+O.getId()+"' into the aggregation '"+o.controlAggregation+"' of a control with the id '"+g.getId()+"'",b);g[A._sMutator](O);return{name:o._name,view:O,control:g};});}else{s=s.then(function(){return{name:o._name};});}return Promise.all([s,f]).then(function(g){var h=g[0].control;var O=g[0].view;if(h&&O){b.fireDisplay({view:O.isA("sap.ui.core.mvc.View")?O:undefined,object:O,control:h,config:b._oOptions,data:d});}return g[0];});},_isValid:function(p){var o=this._oOptions,b=p&&p.control,h=(b||o.controlId),i=true,l="";if(!h){l="The target "+o._name+" has no controlId set and no parent so the target cannot be displayed.";i=false;}if(!o.controlAggregation){l="The target "+o._name+" has a control id or a parent but no 'controlAggregation' was set, so the target could not be displayed.";i=false;}if(l){L.error(l,this);}return i||l;},_refuseInvalidTarget:function(n,m){return Promise.reject(new Error(m+" - Target: "+n));}};});
sap.ui.predefine('sap/ui/core/routing/async/TargetCache',["sap/ui/core/mvc/View","sap/ui/core/Component","sap/ui/core/routing/HashChanger","sap/ui/core/library"],function(V,C,H,l){"use strict";var a=l.mvc.ViewType;return{_getObjectWithGlobalId:function(o,t,T){var b=this,p,n,i,O=this._oComponent,w=[];T=T||{};function c(){switch(t){case"View":o.viewName=o.name;delete o.name;if(o.type===a.XML&&!o.processingMode){o.processingMode="sequential";}return V._legacyCreate(o);case"Component":o.settings=o.settings||{};o.settings._propagateTitle=T.propagateTitle;var r=b._createRouterHashChanger(T.prefix);if(r){o.settings._routerHashChanger=r;}if(o.usage){return O.createComponent(o);}else{return C.create(o);}break;default:}}function d(e){if(b._oCache){w.forEach(function(I){i[I]=e;});if(T.afterCreate){T.afterCreate(e);}b.fireCreated({object:e,type:t,options:o});}return e;}if(o.async===undefined){o.async=true;}n=o.usage||o.name;this._checkName(n,t);i=this._oCache[t.toLowerCase()][n];p=i&&i[o.id];if(p){return p;}if(O){p=O.runAsOwner(c);}else{p=c();}if(p instanceof Promise){p=p.then(d);}else{p.loaded().then(d);}if(!i){i=this._oCache[t.toLowerCase()][n]={};i[undefined]=p;w.push(undefined);}if(o.id!==undefined){i[o.id]=p;w.push(o.id);}return p;},_getViewWithGlobalId:function(o){if(o&&!o.name){o.name=o.viewName;}return this._getObjectWithGlobalId(o,"View");},_getComponentWithGlobalId:function(o,t){return this._getObjectWithGlobalId(o,"Component",t);},_createRouterHashChanger:function(p){var r;var R=this._oComponent&&this._oComponent.getRouter();if(R){r=R.getHashChanger();if(r&&p){r=r.createSubHashChanger(p);}}return r||H.getInstance().createRouterHashChanger();}};});
sap.ui.predefine('sap/ui/core/routing/async/Targets',["sap/base/Log"],function(L){"use strict";return{display:function(t,d,T){var s=Promise.resolve();return this._display(t,d,T,s);},_display:function(t,d,T,s){var a=this,v=[];if(!Array.isArray(t)){t=[t];}this._attachTitleChanged(t,T);return this._alignTargetsInfo(t).reduce(function(p,o){var b={prefix:o.prefix,propagateTitle:o.propagateTitle||false};return a._displaySingleTarget(o,d,p,b).then(function(V){V=V||{};V.targetInfo=o;v.push(V);});},s).then(function(){return v;});},_displaySingleTarget:function(t,d,s,T){var n=t.name,o=this.getTarget(n);if(o!==undefined){return o._display(d,s,T);}else{var e="The target with the name \""+n+"\" does not exist!";L.error(e,this);return Promise.resolve({name:n,error:e});}}};});
sap.ui.predefine('sap/ui/core/routing/sync/Route',["sap/base/Log","sap/base/util/extend"],function(L,e){"use strict";return{_routeMatched:function(a,i,n){var r=this._oRouter,p,P,t,c,E,v=null,T=null,o,C,V,b,d;r._oMatchedRoute=this;r._bMatchingProcessStarted=true;if(this._oParent){p=this._oParent._routeMatched(a);}else if(this._oNestingParent){this._oNestingParent._routeMatched(a,false,this);}c=e({},r._oConfig,this._oConfig);o=Object.assign({},a);o.routeConfig=c;E={name:c.name,arguments:a,config:c};if(n){E.nestedRoute=n;}this.fireBeforeMatched(E);r.fireBeforeRouteMatched(E);if(this._oTarget){t=this._oTarget;t._updateOptions(this._convertToTargetOptions(c));if(t._isValid(p,false)){P=t._place(p);}P=P||{};v=P.oTargetParent;T=P.oTargetControl;E.view=v;E.targetControl=T;}else{V=[];b=[];C=function(f){V.push(f.getParameter("view"));b.push(f.getParameter("control"));};if(Array.isArray(this._oConfig.target)){d=this._oConfig.target;}else{d=[this._oConfig.target];}d.forEach(function(s){var t=r._oTargets.getTarget(s);if(t){t.attachEventOnce("display",C);}});r._oTargets._display(this._oConfig.target,o,this._oConfig.titleTarget);E.view=V[0];E.targetControl=b[0];E.views=V;E.targetControls=b;}r._bMatchingProcessStarted=false;if(c.callback){c.callback(this,a,c,T,v);}this.fireEvent("matched",E);r.fireRouteMatched(E);if(i){L.info("The route named '"+c.name+"' did match with its pattern",this);this.fireEvent("patternMatched",E);r.fireRoutePatternMatched(E);}return P;}};});
sap.ui.predefine('sap/ui/core/routing/sync/Target',["sap/base/Log"],function(L){"use strict";return{display:function(d){var p;if(this._oParent){p=this._oParent.display(d);}return this._place(p,d);},suspend:function(){return this;},_place:function(p,d){var o=this._oOptions;p=p||{};var v,c=p.oTargetControl,V=p.oTargetParent;if(!this._isValid(p,true)){return undefined;}if(!V&&o.rootView){V=sap.ui.getCore().byId(o.rootView);if(!V){L.error("Did not find the root view with the id "+o.rootView,this);return undefined;}}if(o.controlId){if(V){c=V.byId(o.controlId);}if(!c){c=sap.ui.getCore().byId(o.controlId);}if(!c){L.error("Control with ID "+o.controlId+" could not be found",this);return undefined;}}var a=c.getMetadata().getJSONKeys()[o.controlAggregation];if(!a){L.error("Control "+o.controlId+" does not have an aggregation called "+o.controlAggregation,this);return undefined;}var s=this._getEffectiveObjectName(o.viewName);var b={name:s,type:o.viewType,id:o.viewId};v=this._oCache._get(b,"View",this._bUseRawViewId);this._beforePlacingViewIntoContainer({container:c,view:v,data:d});this._bindTitleInTitleProvider(v);this._addTitleProviderAsDependent(v);if(o.clearControlAggregation===true){c[a._sRemoveAllMutator]();}L.info("Did place the view '"+s+"' with the id '"+v.getId()+"' into the aggregation '"+o.controlAggregation+"' of a control with the id '"+c.getId()+"'",this);c[a._sMutator](v);this.fireDisplay({view:v,control:c,config:this._oOptions,data:d});return{oTargetParent:v,oTargetControl:c};},_isValid:function(p,l){var o=this._oOptions,c=p&&p.oTargetControl,h=(c||o.controlId),i=true,s="";if(!h){s="The target "+o._name+" has no controlId set and no parent so the target cannot be displayed.";i=false;}if(!o.controlAggregation){s="The target "+o._name+" has a control id or a parent but no 'controlAggregation' was set, so the target could not be displayed.";i=false;}if(!o.viewName){s="The target "+o._name+" no viewName defined.";i=false;}if(l&&s){L.error(s,this);}return i;}};});
sap.ui.predefine('sap/ui/core/routing/sync/TargetCache',["sap/base/Log","sap/ui/core/mvc/View"],function(L,V){"use strict";return{_getObjectWithGlobalId:function(o){function c(){o.viewName=o.name;delete o.name;return V._legacyCreate(o);}var v,s=o.name,i;this._checkName(s,"View");i=this._oCache.view[s];v=i&&i[o.id];if(v){return v;}if(this._oComponent){v=this._oComponent.runAsOwner(c);}else{v=c();}i=this._oCache.view[s];if(!i){i=this._oCache.view[s]={};i[undefined]=v;}if(o.id!==undefined){i[o.id]=v;}this.fireCreated({object:v,type:"View",options:o});return v;},_getViewWithGlobalId:function(o){if(o&&!o.name){o.name=o.viewName;}return this._getObjectWithGlobalId(o);}};});
sap.ui.predefine('sap/ui/core/routing/sync/Targets',["sap/base/Log"],function(L){"use strict";return{display:function(t,d,T){this._display(t,d,T);},_display:function(t,d,T){var a=this;this._attachTitleChanged(t,T);if(Array.isArray(t)){t.forEach(function(s){a._displaySingleTarget(s,d);});}else{this._displaySingleTarget(t,d);}return this;},_displaySingleTarget:function(n,d){var t=this.getTarget(n);if(t!==undefined){t.display(d);}else{L.error("The target with the name \""+n+"\" does not exist!",this);}}};});
sap.ui.predefine('sap/ui/core/search/OpenSearchProvider',['sap/ui/core/library','./SearchProvider',"sap/base/Log","sap/base/security/encodeURL","sap/ui/thirdparty/jquery"],function(l,S,L,e,q){"use strict";
var O=S.extend("sap.ui.core.search.OpenSearchProvider",{metadata:{library:"sap.ui.core",properties:{suggestUrl:{type:"sap.ui.core.URI",group:"Misc",defaultValue:null},suggestType:{type:"string",group:"Misc",defaultValue:'json'}}}});
O.prototype.suggest=function(v,c){var u=this.getSuggestUrl();if(!u){return;}u=u.replace("{searchTerms}",e(v));var t=this.getSuggestType();var s;if(t&&t.toLowerCase()==="xml"){t="xml";s=function(d){var x=q(d);var i=x.find("Text");var a=[];i.each(function(){a.push(q(this).text());});c(v,a);};}else{t="json";s=function(d){c(v,d[1]);};}q.ajax({url:u,dataType:t,success:s,error:function(X,a,b){L.fatal("The following problem occurred: "+a,X.responseText+","+X.status);}});};
return O;});
sap.ui.predefine('sap/ui/core/search/SearchProvider',['sap/ui/core/Element','sap/ui/core/library',"sap/base/Log"],function(E,l,L){"use strict";
var S=E.extend("sap.ui.core.search.SearchProvider",{metadata:{"abstract":true,library:"sap.ui.core",properties:{icon:{type:"string",group:"Misc",defaultValue:null}}}});
S.prototype.suggest=function(v,c){L.warning("sap.ui.core.search.SearchProvider is the abstract base class for all SearchProviders. Do not create instances of this class, but use a concrete sub class instead.");};
return S;});
sap.ui.predefine('sap/ui/core/service/Service',['sap/ui/base/Object',"sap/base/assert","sap/base/Log"],function(B,a,L){"use strict";
var S=B.extend("sap.ui.core.service.Service",{
metadata:{"abstract":true,"library":"sap.ui.core"},
constructor:function(s){B.apply(this);if(s){a(typeof s.scopeObject==="object","The service context requires a scope object!");a(typeof s.scopeType==="string","The service context requires a scope type!");}this._oServiceContext=s;if(typeof this.init==="function"){this.init();}}
});
S.create=function(s){var A=function A(o){for(var m in s){if(!m.match(/^(metadata|constructor|getContext|destroy)$/)){this[m]=s[m];}else{L.warning("The member "+m+" is not allowed for anonymous service declaration and will be ignored!");}}S.apply(this,arguments);};A.prototype=Object.create(S.prototype);return A;};
S.prototype.getInterface=function(){var p=Object.create(null);for(var m in this){if(!m.match(/^_|^metadata$|^constructor$|^getInterface$|^destroy$|^init$|^exit$|^getContext$/)&&typeof this[m]==="function"){p[m]=this[m].bind(this);}}this.getInterface=function(){return p;};return p;};
S.prototype.getContext=function(){return this._oServiceContext;};
S.prototype.destroy=function(){if(typeof this.exit==="function"){this.exit();}B.prototype.destroy.apply(this,arguments);delete this._oServiceContext;};
return S;});
sap.ui.predefine('sap/ui/core/service/ServiceFactory',['sap/ui/base/Object','sap/ui/core/service/Service',"sap/base/assert"],function(B,S,a){"use strict";
var b=B.extend("sap.ui.core.service.ServiceFactory",{
metadata:{"library":"sap.ui.core"},
constructor:function(s){B.apply(this);var f=typeof s==="object"?S.create(s):s;a(!f||f&&typeof f==="function","The service constructor either should be undefined or a constructor function!");this._fnService=f;}
});
b.prototype.destroy=function(){B.prototype.destroy.apply(this,arguments);delete this._fnService;};
b.prototype.createInstance=function(s){if(typeof this._fnService==="function"){return Promise.resolve(new this._fnService(s));}else{return Promise.reject(new Error("Usage of sap.ui.core.service.ServiceFactory requires a service constructor function to create a new service instance or to override the createInstance function!"));}};
return b;});
sap.ui.predefine('sap/ui/core/service/ServiceFactoryRegistry',['./ServiceFactory',"sap/base/assert"],function(S,a){"use strict";var s=Object.create(null);var b=Object.create(null);
b.register=function(c,o){a(c,"sServiceFactoryName must not be empty, null or undefined");a(o instanceof S,"oServiceFactory must be an instance of sap.ui.core.service.ServiceFactory");s[c]=o;return this;};
b.unregister=function(c){a(c,"sServiceFactoryName must not be empty, null or undefined");delete s[c];return this;};
b.get=function(c){return s[c];};
return b;},true);
sap.ui.predefine('sap/ui/core/syncStyleClass',['sap/ui/thirdparty/jquery','sap/ui/base/Object','sap/base/assert'],function(q,B,a){"use strict";var s=function(S,v,d){if(!S){return d;}if(B.isA(v,'sap.ui.core.Control')){v=v.$();}else if(typeof v==="string"){v=q(document.getElementById(v));}else if(!(v instanceof q)){a(false,'sap/ui/core/syncStyleClass(): vSource must be a jQuery object or a Control or a string');return d;}var c=!!v.closest("."+S).length;if(d instanceof q){d.toggleClass(S,c);}else if(B.isA(d,'sap.ui.core.Control')){d.toggleStyleClass(S,c);}else{a(false,'sap/ui/core/syncStyleClass(): vDestination must be a jQuery object or a Control');}return d;};return s;});
sap.ui.predefine('sap/ui/core/theming/Parameters',['sap/ui/thirdparty/URI','../Element','sap/base/util/UriParameters','sap/base/Log','sap/base/util/extend','sap/ui/thirdparty/jquery'],function(U,E,a,L,e,q){"use strict";var c=window["sap-ui-config"]||{};var s=0;if(c['xx-nosync']==='warn'||/(?:\?|&)sap-ui-xx-nosync=(?:warn)/.exec(window.location.search)){s=1;}if(c['xx-nosync']===true||c['xx-nosync']==='true'||/(?:\?|&)sap-ui-xx-nosync=(?:x|X|true)/.exec(window.location.search)){s=2;}var P={};var p=null;var t=null;var b=[];var r=/url[\s]*\('?"?([^\'")]*)'?"?\)/;var u=a.fromQuery(window.location.search).get("sap-ui-xx-no-inline-theming-parameters")!=="true";
function d(){p=null;}
function f(i,T){var M=r.exec(i);if(M){var j=new U(M[1]);if(j.is("relative")){var N=j.absoluteTo(T).normalize().toString();i="url('"+N+"')";}}return i;}
function m(C,N,T){for(var i in N){if(typeof C[i]==="undefined"){C[i]=f(N[i],T);}}return C;}
function g(N,T){if(typeof N["default"]!=="object"){N={"default":N,"scopes":{}};}p=p||{};p["default"]=p["default"]||{};p["scopes"]=p["scopes"]||{};m(p["default"],N["default"],T);if(typeof N["scopes"]==="object"){for(var S in N["scopes"]){p["scopes"][S]=p["scopes"][S]||{};m(p["scopes"][S],N["scopes"][S],T);}}}
function h(C){q("link[id^=sap-ui-theme-]").each(function(){C(this.getAttribute("id"));});}
function l(i){var k=document.getElementById(i);if(!k){L.warning("Could not find stylesheet element with ID",i,"sap.ui.core.theming.Parameters");return;}var S=k.href;var T=new U(S).filename("").query("").toString();var x=sap.ui.getCore().isThemeApplied();if(!x){L.warning("Parameters have been requested but theme is not applied, yet.","sap.ui.core.theming.Parameters");}if(x&&u){var $=q(k);var D=$.css("background-image");var y=/\(["']?data:text\/plain;utf-8,(.*?)['"]?\)$/i.exec(D);if(y&&y.length>=2){var z=y[1];if(z.charAt(0)!=="{"&&z.charAt(z.length-1)!=="}"){try{z=decodeURIComponent(z);}catch(A){L.warning("Could not decode theme parameters URI from "+S);}}try{var B=JSON.parse(z);g(B,T);return;}catch(A){L.warning("Could not parse theme parameters from "+S+". Loading library-parameters.json as fallback solution.");}}}var C=S.replace(/\/(?:css_variables|library)([^\/.]*)\.(?:css|less)($|[?#])/,function(j,F,G){return"/library-parameters.json"+(G?G:"");});if(s===2){L.error("[nosync] Loading library-parameters.json ignored",C,"sap.ui.core.theming.Parameters");return;}else if(s===1){L.error("[nosync] Loading library-parameters.json with sync XHR",C,"sap.ui.core.theming.Parameters");}q.ajax({url:C,dataType:'json',async:false,success:function(F,G,H){if(Array.isArray(F)){for(var j=0;j<F.length;j++){var B=F[j];g(B,T);}}else{g(F,T);}},error:function(j,F,G){L.error("Could not load theme parameters from: "+C,G);}});}
function n(){if(!p){g({},"");t=sap.ui.getCore().getConfiguration().getTheme();h(l);}return p;}
function o(){b.forEach(l);b=[];}
P._addLibraryTheme=function(i){if(p){b.push("sap-ui-theme-"+i);}};
function v(O){var i=n();if(O.scopeName){i=i["scopes"][O.scopeName];}else{i=i["default"];}var j=i[O.parameterName];if(typeof j==="undefined"&&typeof O.parameterName==="string"){var I=O.parameterName.indexOf(":");if(I!==-1){O.parameterName=O.parameterName.substr(I+1);}j=i[O.parameterName];}if(O.loadPendingParameters&&typeof j==="undefined"){o();j=v({parameterName:O.parameterName,scopeName:O.scopeName,loadPendingParameters:false});}return j;}
function w(j,S){for(var i=0;i<S.length;i++){var C=S[i];for(var k=0;k<C.length;k++){var x=C[k];var y=v({parameterName:j,scopeName:x});if(y){return y;}}}return v({parameterName:j});}
P._getScopes=function(A){if(A&&!p){return;}var i=n();var S=Object.keys(i["scopes"]);return S;};
P.getActiveScopesFor=function(i){var S=[];if(i instanceof E){var j=i.getDomRef();o();var k=this._getScopes();if(j){var N=function(x){var y=j.classList;return y&&y.contains(x);};while(j){var F=k.filter(N);if(F.length>0){S.push(F);}j=j.parentNode;}}else{var C=function(x){return typeof i.hasStyleClass==="function"&&i.hasStyleClass(x);};while(i){var F=k.filter(C);if(F.length>0){S.push(F);}i=typeof i.getParent==="function"&&i.getParent();}}}return S;};
P.get=function(N,k){var x;if(!sap.ui.getCore().isInitialized()){L.warning("Called sap.ui.core.theming.Parameters.get() before core has been initialized. "+"This could lead to bad performance and sync XHR as inline parameters might not be available, yet. "+"Consider using the API only when required, e.g. onBeforeRendering.");}if(arguments.length===0){o();var y=n();return Object.assign({},y["default"]);}if(!N){return undefined;}if(k instanceof E){o();var S=this.getActiveScopesFor(k);if(typeof N==="string"){return w(N,S);}else if(Array.isArray(N)){var z={};for(var j=0;j<N.length;j++){var A=N[j];z[A]=w(A,S);}return z;}}else{if(typeof N==="string"){x=v({parameterName:N,loadPendingParameters:true});return x;}else if(Array.isArray(N)){var z={};for(var i=0;i<N.length;i++){var A=N[i];z[A]=P.get(A);}return z;}}};
P._setOrLoadParameters=function(i){p={"default":{},"scopes":{}};t=sap.ui.getCore().getConfiguration().getTheme();h(function(I){var j=I.substr(13);if(i[j]){e(p["default"],i[j]);}else{l(I);}});};
P.reset=function(){var O=arguments[0]===true;if(!O||sap.ui.getCore().getConfiguration().getTheme()!==t){d();}};
P._getThemeImage=function(i,F){i=i||"sapUiGlobalLogo";var j=P.get(i);if(j){var k=r.exec(j);if(k){j=k[1];}else if(j==="''"||j==="none"){j=null;}}if(!!F&&!j){return sap.ui.resource('sap.ui.core','themes/base/img/1x1.gif');}return j;};
return P;},true);
sap.ui.predefine('sap/ui/core/tmpl/DOMAttribute',['sap/ui/core/Element','sap/ui/core/library'],function(E,l){"use strict";
var D=E.extend("sap.ui.core.tmpl.DOMAttribute",{metadata:{library:"sap.ui.core",properties:{name:{type:"string",group:"Data",defaultValue:null},value:{type:"string",group:"Data",defaultValue:null}}}});
D.prototype.setValue=function(v){this.setProperty("value",v,true);var p=this.getParent(),$=p&&p.$();if($&&$.length>0){$.attr(this.getName(),this.getProperty("value"));}return this;};
return D;});
sap.ui.predefine('sap/ui/core/tmpl/DOMElement',['sap/ui/core/Control','sap/ui/core/library','./DOMAttribute',"./DOMElementRenderer","sap/base/Log","sap/ui/thirdparty/jquery"],function(C,l,D,a,L,q){"use strict";
var b=C.extend("sap.ui.core.tmpl.DOMElement",{metadata:{library:"sap.ui.core",properties:{text:{type:"string",group:"Appearance",defaultValue:null},tag:{type:"string",group:"Behavior",defaultValue:'span'}},defaultAggregation:"attributes",aggregations:{attributes:{type:"sap.ui.core.tmpl.DOMAttribute",multiple:true,singularName:"attribute"},elements:{type:"sap.ui.core.tmpl.DOMElement",multiple:true,singularName:"element"}}}});
b.prototype.applySettings=function(s){var m=this.getMetadata(),j=m.getJSONKeys();if(s){if(!s["attributes"]){var A=s["attributes"]=[];q.each(s,function(k,v){if(k!=="id"&&!j[k]&&typeof v==="string"){A.push(new D({name:k,value:v}));delete s[k];}});}else{L.warning("DOMElement#"+this.getId()+": custom attributes in settings will be ignored since attributes are provided!");}}C.prototype.applySettings.apply(this,arguments);};
b.prototype.exit=b.prototype.onBeforeRendering=function(){var t=this.getTag().toLowerCase();if(t==="input"||t==="textarea"||t==="select"){this.$().off("change");}};
b.prototype.onAfterRendering=function(){var t=this.getTag().toLowerCase();if(t==="input"||t==="textarea"||t==="select"){this.$().on("change",q.proxy(this.oninputchange,this));}};
b.prototype.oninputchange=function(e){var t=this.getTag().toLowerCase();if(t==="input"){var v=this.$().val();this.getAttributes().forEach(function(A){if(A.getName().toLowerCase()==="value"){A.setValue(v);}});}else if(t==="textarea"){var T=this.$().val();this.setText(T);}else if(t==="select"){var T="";this.$().find("select option:selected").each(function(){T+=q(this).text()+" ";});this.setText(T);}};
b.prototype.attr=function(k,v){var A=this.getAttributes(),o;A.forEach(function(V){var n=V.getName();if(n.toLowerCase()===k){o=V;return false;}});if(v===undefined){return o&&o.getValue();}else{if(o){if(v===null){this.removeAttribute(o);}else{o.setValue(v);}}else{if(v!==null){this.addAttribute(new D({name:k,value:v}));}}return this;}};
b.prototype.removeAttr=function(k){this.attr(k,null);return this;};
b.prototype.setText=function(t){this.setProperty("text",t,true);var $=this.$();if($.length>0){var T=this.getTag().toLowerCase();if(T==="textarea"){$.val(this.getProperty("text"));}else{$.text(this.getProperty("text"));}}return this;};
return b;});
sap.ui.predefine('sap/ui/core/tmpl/DOMElementRenderer',["sap/base/Log","sap/base/security/encodeXML"],function(L,e){"use strict";var D={apiVersion:2};var r=/^(?:area|base|br|col|embed|hr|img|input|link|meta|param|source|track|wbr)$/i;
D.render=function(R,E){var s=e(E.getTag()),i=r.test(s);if(i){R.voidStart(s,E);}else{R.openStart(s,E);}E.getAttributes().forEach(function(A){var n=A.getName().toLowerCase();if(n==="class"){var c=A.getValue().split(" ");c.forEach(function(C){var C=C.trim();if(C){R.class(C);}});}else if(n==="style"){var S=A.getValue().split(";");S.forEach(function(b){var I=b.indexOf(":");if(I!=-1){var k=b.substring(0,I).trim();var v=b.substring(I+1).trim();R.style(e(k),v);}});}else if(A.getName()){R.attr(e(A.getName()),A.getValue());}else{L.error("Attributes must have a non-empty name");}});if(i){R.voidEnd();}else{R.openEnd();}var a=E.getElements(),h=!!E.getText()||a.length>0;if(h){if(i){L.error("Void element '"+s+"' is rendered with children");}if(E.getText()){R.text(E.getText());}a.forEach(function(I,c){R.renderControl(c);});}if(!i){R.close(s);}};
return D;},true);
sap.ui.predefine('sap/ui/core/tmpl/HandlebarsTemplate',['sap/ui/core/Core','./Template','./TemplateControl','sap/ui/thirdparty/handlebars','sap/ui/base/ManagedObject','sap/base/util/ObjectPath',"sap/base/security/encodeXML","sap/ui/thirdparty/jquery","sap/base/util/isEmptyObject"],function(C,T,a,H,M,O,e,q,b){"use strict";
var c=T.extend("sap.ui.core.tmpl.HandlebarsTemplate",{constructor:function(i,s){T.apply(this,arguments);}});
T.registerType("text/x-handlebars-template","sap.ui.core.tmpl.HandlebarsTemplate");
function d(h){for(var k in h){h[k]=h[k].replace("&gt;",">").replace("&lt;","<").replace("&quot;","\"").replace("&amp;","&");}}
function f(p,P){var r=/^((\w+)>)?(.*)/,g=r.exec(p),s=g[2],h=r.exec(P),i=h[2];var g=r.exec(p);if(P&&s==i){return P+g[3];}else{return p;}}
c.RENDER_HELPERS=(function(){var E=H.helpers["each"],w=H.helpers["with"],I=H.helpers["if"],u=H.helpers["unless"],r=sap.ui.getCore().createRenderManager();r.renderControl=function(o){this.writeControlData(o);this.writeClasses(o);this.writeStyles(o);};var h={"each":function(g,o){o=o||g;if(!o.hash.path){return E.apply(this,arguments);}else{d(o.hash);var R=o.data.renderManager,i=o.data.rootControl,p=o.data.path,P=o.data.parentControl,s=f(o.hash.path,p),j=i.bindList(s),k=[],l;if(o.data){l=H.createFrame(o.data);}if(j){for(var K in j){if(l){l.renderManager=R;l.rootControl=i;l.path=s+"/"+K+"/";l.parentControl=P;}k.push(o.fn({},{data:l}));}}if(!P){return new H.SafeString(k.join(""));}}},"with":function(g,o){o=o||g;if(!o.hash.path){return w.apply(this,arguments);}},"if":function(g,o){o=o||g;if(!o.hash.path){return I.apply(this,arguments);}else{d(o.hash);var R=o.data.rootControl,p=o.data.path,P=f(o.hash.path,p);if(P){var v=R.bindProp(P);if(v){return o.fn(this);}else{return o.inverse(this);}}}},"unless":function(g,o){o=o||g;if(!o.hash.path){return u.apply(this,arguments);}else{d(o.hash);var R=o.data.rootControl,p=o.data.path,P=f(o.hash.path,p);if(P){var v=R.bindProp(P);if(!v){return o.fn(this);}else{return o.inverse(this);}}}},"text":function(g,o){o=o||g;d(o.hash);var R=o.data.rootControl,p=o.data.path,P=f(o.hash.path,p);if(P){var v=R.bindProp(P);return v&&new H.SafeString(e(v));}else{throw new Error("The expression \"text\" requires the option \"path\"!");}},"element":function(g,o){o=o||g;d(o.hash);var R=o.data.renderManager,i=o.data.rootControl,j=i.createDOMElement(o.hash,o.data.path),p=o.data.parentElement;if(o.fn){o.fn({},{data:{renderManager:R,rootControl:i,parentElement:j}});}if(p){p.addElement(j);return;}return new H.SafeString(R.getHTML(j));},"control":function(g,o){o=o||g;d(o.hash);var R=o.data.renderManager,j=o.data.control;if(j){return new H.SafeString(R.getHTML(j));}var k=o.data.rootControl,p=o.data.path,P=o.data.children,t=o.hash["sap-ui-type"],m=O.get(t||""),n=m&&m.getMetadata(),D=o.hash["sap-ui-default-aggregation"]||n&&n.getDefaultAggregationName(),v=o.data.view;if(!m){throw new Error("Control of type "+t+" cannot be found.");}var s={};if(o.fn){o.fn({},{data:{rootControl:k,path:p,children:s,defaultAggregation:D,view:v}});}var S=Object.assign({},o.hash),x;for(var K in S){if(K==="sap-ui-class"&&typeof S[K]==="string"){x=S["sap-ui-class"]&&S["sap-ui-class"].split(" ");delete S[K];}else if(s[K]){delete S[K];}}var N=k.createControl(S,o.data.path,!!P,v);if(x&&x.length>0){x.forEach(N.addStyleClass.bind(N));}if(!b(s)){S=o.hash;var A=n.getAllAggregations();for(var y in s){var z=s[y];for(var i=0,l=z.length;i<l;i++){var B=z[i],F=A[y],G=F&&F.multiple;if(typeof S[y]==="string"){var J=M.bindingParser(S[y],v&&v.getController());J.template=B;N.bindAggregation(y,J);}else{if(G){N.addAggregation(y,B);}else{N.setAggregation(y,B);}}}}}if(P){var y=o.hash["sap-ui-aggregation"]||o.data.defaultAggregation;P[y]=P[y]||[];P[y].push(N);return;}return new H.SafeString(R.getHTML(N));},"property":function(g,o){o=o||g;d(o.hash);var R=o.data.rootControl,m=R.getMetadata(),p=o.hash.name,G=m.getProperty(p)._sGetter;return R[G]();},"aggregation":function(g,o){o=o||g;d(o.hash);if(o.data.children){var A=o.hash.name;if(o.fn){var D=Object.assign({},o.data,{defaultAggregation:A});o.fn({},{data:D});}}else{var R=o.data.renderManager,j=o.data.rootControl,m=j.getMetadata(),A=o.hash.name,G=m.getAggregation(A)._sGetter,k=[];var n=j[G]();if(n){for(var i=0,l=n.length;i<l;i++){if(o.fn){k.push(o.fn({},{data:{renderManager:R,rootControl:j,control:n[i]}}));}else{k.push(R.getHTML(n[i]));}}}return new H.SafeString(k.join(""));}},"event":function(g,o){o=o||g;},"controlData":function(g,o){o=o||g;var R=o.data.rootControl;return new H.SafeString(r.getHTML(R));}};return h;}());
c.prototype.createMetadata=function(){var t=this.getContent(),g=this._fnTemplate=this._fnTemplate||H.compile(t);var m={},j=a.getMetadata().getAllSettings(),p=a.getMetadata().getAllPrivateAggregations();var h={"property":function(i,o){o=o||i;d(o.hash);var n=o.hash.name;if(n&&n!=="id"&&!j[n]){m.properties=m.properties||{};m.properties[n]=Object.assign({},{type:"string"},o.hash);}else{throw new Error("The property name \""+n+"\" is reserved.");}},"aggregation":function(i,o){o=o||i;d(o.hash);var n=o.hash.name;if(n&&!j[n]&&!p[n]){o.hash.multiple=o.hash.multiple=="true";m.aggregations=m.aggregations||{};m.aggregations[n]=Object.assign({},o.hash);}else{throw new Error("The aggregation name \""+n+"\" is reserved.");}},"event":function(i,o){o=o||i;},"controlData":function(i,o){o=o||i;m._hasControlData=true;}};["each","if","unless","with"].forEach(function(v){h[v]=function(){};});g({},{helpers:h});return m;};
c.prototype.createRenderer=function(v){var t=this.getContent(),g=this._fnTemplate=this._fnTemplate||H.compile(t);var r=function(h,o){var s=g(o.getContext()||{},{data:{renderManager:h,rootControl:o,view:v},helpers:c.RENDER_HELPERS});h.write(s);};return r;};
return c;});
sap.ui.predefine('sap/ui/core/tmpl/Template',['sap/ui/base/ManagedObject','sap/ui/base/BindingParser','sap/ui/core/Control','sap/ui/core/RenderManager','sap/base/util/ObjectPath','sap/base/Log','sap/base/assert','sap/ui/thirdparty/jquery'],function(M,B,C,R,O,L,a,q){"use strict";
var T=M.extend("sap.ui.core.tmpl.Template",{
constructor:function(i,s){M.apply(this,arguments);},
metadata:{stereotype:"template","abstract":true,library:"sap.ui.core",properties:{"content":{type:"string",group:"Data",defaultValue:null}},publicMethods:["declareControl","createControl","placeAt","createMetadata","createRenderer"]}
});
var t={};
T.prototype.register=function(){var i=this.getId(),o=t[i],m;if(o&&this!==o){m="adding template with duplicate id '"+i+"'";L.error(m);throw new Error("Error: "+m);}t[i]=this;};
T.prototype.deregister=function(){delete t[this.getId()];};
T.byId=function(i){return t[i];};
T.prototype.getInterface=function(){return this;};
T._mSupportedTypes={};
T.registerType=function(s,c){T._mSupportedTypes[s]=c;};
T.unregisterType=function(s){delete T._mSupportedTypes[s];};
T.parsePath=function(p){var m,s=p.indexOf(">");if(s>0){m=p.substr(0,s);p=p.substr(s+1);}return{path:p,model:m};};
T.prototype.init=function(s,S){if(this.getMetadata().getName()==="sap.ui.core.tmpl.Template"){throw new Error("The class 'sap.ui.core.tmpl.Template' is abstract and must not be instantiated!");}if(M.bindingParser===B.complexParser){T.prototype.extractBindingInfo=function(v,i,S){M.bindingParser=B.simpleParser;var r=C.prototype.extractBindingInfo.apply(this,arguments);M.bindingParser=B.complexParser;return r;};}};
T.prototype.declareControl=function(c){a(!!c,"A fully qualified name must be specified!");if(c){var m=this.createMetadata(),r=this.createRenderer(),b=this;var d=sap.ui.requireSync('sap/ui/core/tmpl/TemplateControl');d.extend(c,{metadata:m,init:function(){d.prototype.init.apply(this,arguments);this.setTemplate(b);},renderer:{renderTemplate:r,hasControlData:m._hasControlData}});return O.get(c||"");}};
T.prototype.createControl=function(i,c,v){var b=sap.ui.requireSync('sap/ui/core/tmpl/TemplateControl');var o=new b({id:i,template:this,context:c});o.setTemplateRenderer(this.createRenderer(v));return o;};
T.prototype.placeAt=function(r,c,p,i){if(typeof c==="string"||typeof c==="number"){p=c;c=undefined;}var I;if(!(r instanceof C)&&i){var $=typeof r==="string"?q(document.getElementById(r)):q(r);if($.length>0){I=$.attr("id");r=$.get(0);var s=$.attr("data-context");c=c||s&&JSON.parse(s);R.markInlineTemplate($);}}var o=this.createControl(I,c);o.placeAt(r,p);return o;};
T.prototype.createMetadata=function(){L.error("The function createMetadata is an abstract function which needs to be implemented by subclasses.");};
T.prototype.createRenderer=function(){L.error("The function createRenderer is an abstract function which needs to be implemented by subclasses.");};
sap.ui.template=function(o){var l=function(n){L.warning("The usage of Template Views is deprecated since 1.56. Please make use of the asynchronous create functions of the different view classes, e.g. XMLView.create()","Deprecation",null,function(){return{type:"sap.ui.template",name:n};});};if(!o){var b=[];q.each(T._mSupportedTypes,function(s,j){q("script[type='"+s+"'], [data-type='"+s+"']").each(function(n,E){b.push(sap.ui.template({id:E.id,domref:E,type:s,_class:j}));});});return b;}else{if(typeof o==="string"){return sap.ui.template({id:o});}else if(o&&o.tagName&&o.nodeName&&o.ownerDocument&&o.nodeType===1){return sap.ui.template({id:o.id,domref:o});}o=q.extend({type:T.DEFAULT_TEMPLATE},o);l(o.id);var i,s,c,d,e=false,f=typeof o.src==="string",I=false;if(f){q.ajax({url:o.src,dataType:"text",async:false,success:function(n){i=o.id;s=o.type;c=o.control;d=n;var r=/^<!--\sUI5:Template\stype=([a-z\/\-]*)\s(?:controller=([A-Za-z.]*)\s)?-->/,p=d.match(r);if(p){s=p[1];if(p.length==3){e=p[2];}d=d.substr(p[0].length);}},error:function(){throw new Error("The template could not be loaded from "+o.src+"!");}});}else{var E=o.domref||((o.id?window.document.getElementById(o.id):null)),$=q(E);I=false;i=o.id||E&&E.id;s=$.attr("type")||o.type;c=$.attr("data-control")||o.control;if(i){var g=sap.ui.getCore().getTemplate(i);if(!g instanceof T){throw new Error("Object for id \""+i+"\" is no sap.ui.core.tmpl.Template!");}else{if(g){return g;}}}if($.length===0){throw new Error("DOM element for the Template with the id \""+i+"\" not found!");}d=$.html();var h=E.tagName.toLowerCase();if(h!=="script"){I=$.parents("body").length===1;}}var j=o._class;if(!j){j=T._mSupportedTypes[s];if(!j){throw new Error("The type \""+s+"\" is not supported.");}}var k=sap.ui.requireSync(j.replace(/\./g,"/"));k=k||O.get(j||"");var m=new k({id:i,content:d});if(c){m.declareControl(c);}if(e){m._sControllerName=e;}if(I){m.placeAt(i,o.context,undefined,true);}return m;}};
T.DEFAULT_TEMPLATE="text/x-handlebars-template";T.registerType(T.DEFAULT_TEMPLATE,"sap.ui.core.tmpl.HandlebarsTemplate");return T;});
sap.ui.predefine('sap/ui/core/tmpl/TemplateControl',['sap/ui/core/Control','sap/ui/core/DeclarativeSupport','sap/ui/core/library','sap/ui/core/UIArea','./DOMElement','./Template',"./TemplateControlRenderer","sap/base/strings/capitalize","sap/base/strings/hyphenate","sap/base/Log","sap/ui/thirdparty/jquery"],function(C,D,l,U,a,T,b,c,h,L,q){"use strict";
var d=C.extend("sap.ui.core.tmpl.TemplateControl",{metadata:{library:"sap.ui.core",properties:{context:{type:"object",group:"Data",defaultValue:null}},aggregations:{controls:{type:"sap.ui.core.Control",multiple:true,singularName:"control",visibility:"hidden"}},associations:{template:{type:"sap.ui.core.tmpl.Template",multiple:false}},events:{afterRendering:{},beforeRendering:{}}}});
d.prototype.init=function(){this._aBindingInfos=[];};
d.prototype.isInline=function(){var i=false,p=this.getParent();if(p instanceof U&&q(p.getRootNode()).attr("id")===this.getId()){i=true;}return i;};
d.prototype.placeAt=function(r,p){var i=this.isInline();var $=this.$(),u=this.getUIArea();C.prototype.placeAt.apply(this,arguments);if(i&&$.length===1){$.remove();u.destroyContent();}};
d.prototype.getTemplateRenderer=function(){return this.fnRenderer;};
d.prototype.setTemplateRenderer=function(r){this.fnRenderer=r;return this;};
d.prototype._cleanup=function(){this.destroyAggregation("controls");this._aBindingInfos.forEach(function(B){var o=B.binding;if(o){o.detachChange(B.changeHandler);o.destroy();}});this._aBindingInfos=[];};
d.prototype._compile=function(){var t=sap.ui.getCore().byId(this.getTemplate()),e=t&&t.getDeclarativeSupport();if(e){var f=this;setTimeout(function(){D.compile(f.getDomRef());});}};
d.prototype.exit=function(){this._cleanup();};
d.prototype.onBeforeRendering=function(){this.fireBeforeRendering();this._cleanup();};
d.prototype.onAfterRendering=function(){this.fireAfterRendering();};
d.prototype.clone=function(){var o=C.prototype.clone.apply(this,arguments);o.fnRenderer=this.fnRenderer;return o;};
d.prototype.updateBindings=function(u,m){C.prototype.updateBindings.apply(this,arguments);if(this.getDomRef()){this.invalidate();}};
d.prototype.bind=function(p,t){var P=T.parsePath(p),m=this.getModel(P.model),p=P.path,M=t?"bind"+c(t):"bindProperty",B=m&&m[M](p),o={binding:B,path:P.path,model:P.model};if(B){o.changeHandler=function(){L.debug("TemplateControl#"+this.getId()+": "+t+" binding changed for path \""+p+"\"");this.invalidate();}.bind(this);B.attachChange(o.changeHandler);}this._aBindingInfos.push(o);return B;};
d.prototype.calculatePath=function(p,t){var B=this.getBindingContext(),s=B&&B.getPath();if(p&&s&&!p.startsWith("/")){if(!s.endsWith("/")){s+="/";}p=s+p;}return p;};
d.prototype.bindProp=function(p){var B=this.bind(this.calculatePath(p),"property");return B&&B.getExternalValue();};
d.prototype.bindList=function(p){var B=this.bind(this.calculatePath(p),"list"),m=B&&B.getModel(),p=B&&B.getPath();return B&&m.getProperty(p);};
d.prototype.createDOMElement=function(s,p,e){var E=new a(s);if(p){E.bindObject(p);}if(!e){this.addAggregation("controls",E);}return E;};
d.prototype.createControl=function(s,p,e,v){var H={};q.each(s,function(k,V){H["data-"+h(k)]=V;});var $=q("<div></div>",H);var o=D._createControl($.get(0),v);if(p){o.bindObject(p);}if(!e){this.addAggregation("controls",o);}return o;};
return d;});
sap.ui.predefine('sap/ui/core/tmpl/TemplateControlRenderer',function(){"use strict";var T={apiVersion:1};
T.render=function(r,c){var s=c.isInline()||this.hasControlData;if(!s){r.openStart("div",c).openEnd();}var R=this.renderTemplate||c.getTemplateRenderer();if(R){R.apply(this,arguments);}if(!s){r.close("div");}};
return T;},true);
sap.ui.predefine('sap/ui/core/util/AsyncHintsHelper',[],function(){'use strict';var A={};
A.modifyUrls=function(a,u){function _(o,U){if(U===undefined){delete o.url;}}[a.components,a.libs].forEach(function(i){if(Array.isArray(i)){i.forEach(function(v){if(typeof v!=="object"){return;}if(typeof v.url==="string"){v.url=u(v.url);_(v,v.url);}else if(typeof v.url==="object"&&typeof v.url.url==="string"){v.url.url=u(v.url.url);_(v,v.url.url);}});}});return a;};
return A;});
sap.ui.predefine('sap/ui/core/util/DraftEnabledMockServer',["sap/ui/core/util/MockServer","sap/ui/thirdparty/jquery","jquery.sap.sjax"],function(M,q){"use strict";return{_oDraftMetadata:{},_oConstants:{COM_SAP_VOCABULARIES_COMMON_V1_DRAFTROOT:"com.sap.vocabularies.Common.v1.DraftRoot",COM_SAP_VOCABULARIES_COMMON_V1_DRAFTNODE:"com.sap.vocabularies.Common.v1.DraftNode",COM_SAP_VOCABULARIES_COMMON_V1_SEMANTICKEY:"com.sap.vocabularies.Common.v1.SemanticKey",EMPTY_GUID:"00000000-0000-0000-0000-000000000000",SIBLINGENTITY_NAVIGATION:"SiblingEntity",DRAFT_ADMINISTRATIVE_DATA:"DraftAdministrativeData",DRAFT_ADMINISTRATIVE_DATA_UUID:"DraftAdministrativeDataUUID",ACTIVATION_ACTION:"ActivationAction",EDIT_ACTION:"EditAction",VALIDATE_ACTION:"ValidationFunction",PREPARE_ACTION:"PreparationAction"},handleDraft:function(a,m){var n=function(b){var N=b.getParameter("oEntity");N.IsActiveEntity=false;N.HasActiveEntity=false;N.HasDraftEntity=false;};var d=function(b){var x=b.getParameter("oXhr");var c=q.sap.sjax({url:x.url,dataType:"json"}).data.d;for(var i=0;i<this._oDraftMetadata.draftNodes.length;i++){for(var f in this._mEntitySets[this._oDraftMetadata.draftRootName].navprops){if(this._mEntitySets[this._oDraftMetadata.draftRootName].navprops[f].to.entitySet===this._oDraftMetadata.draftNodes[i]){var r=q.sap.sjax({url:c[f].__deferred.uri,dataType:"json"});if(r.data&&r.data.d&&r.data.d.results){var N;for(var j=0;j<r.data.d.results.length;j++){N=r.data.d.results[j];q.sap.sjax({url:N.__metadata.uri,type:"DELETE"});}}}}}};if(a&&a.EntityContainer){var e=a.EntityContainer[Object.keys(a.EntityContainer)[0]];for(var E in e){var o=e[E];if(o[this._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_DRAFTROOT]){this._oDraftMetadata.draftRootName=E;this._oDraftMetadata.annotations=a;this._oDraftMetadata.mockServerRootUri=m.getRootUri();if(o[this._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_DRAFTROOT][this._oConstants.ACTIVATION_ACTION]){this._oDraftMetadata.draftRootActivationName=o[this._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_DRAFTROOT][this._oConstants.ACTIVATION_ACTION].String;}if(this._oDraftMetadata.draftRootActivationName){this._oDraftMetadata.draftRootActivationName=this._oDraftMetadata.draftRootActivationName.substring(this._oDraftMetadata.draftRootActivationName.lastIndexOf("/")+1);}this._oDraftMetadata.draftRootEditName=o[this._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_DRAFTROOT][this._oConstants.EDIT_ACTION];this._oDraftMetadata.draftRootEditName=this._oDraftMetadata.draftRootEditName?this._oDraftMetadata.draftRootEditName.String:undefined;if(this._oDraftMetadata.draftRootEditName){this._oDraftMetadata.draftRootEditName=this._oDraftMetadata.draftRootEditName.substring(this._oDraftMetadata.draftRootEditName.lastIndexOf("/")+1);}this._oDraftMetadata.draftRootValidationName=o[this._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_DRAFTROOT][this._oConstants.VALIDATE_ACTION];this._oDraftMetadata.draftRootValidationName=this._oDraftMetadata.draftRootValidationName?this._oDraftMetadata.draftRootValidationName.String:undefined;if(this._oDraftMetadata.draftRootValidationName){this._oDraftMetadata.draftRootValidationName=this._oDraftMetadata.draftRootValidationName.substring(this._oDraftMetadata.draftRootValidationName.lastIndexOf("/")+1);}this._oDraftMetadata.draftRootPreparationtionName=o[this._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_DRAFTROOT][this._oConstants.PREPARE_ACTION];this._oDraftMetadata.draftRootPreparationtionName=this._oDraftMetadata.draftRootPreparationtionName?this._oDraftMetadata.draftRootPreparationtionName.String:undefined;if(this._oDraftMetadata.draftRootPreparationtionName){this._oDraftMetadata.draftRootPreparationtionName=this._oDraftMetadata.draftRootPreparationtionName.substring(this._oDraftMetadata.draftRootPreparationtionName.lastIndexOf("/")+1);}q.extend(m,this);m.attachAfter(M.HTTPMETHOD.POST,n,this._oDraftMetadata.draftRootName);m.attachBefore(M.HTTPMETHOD.DELETE,d,this._oDraftMetadata.draftRootName);m.attachAfter(M.HTTPMETHOD.GET,this._fnDraftAdministrativeData,this._oDraftMetadata.draftRootName);}}}},_calcSemanticKeys:function(e,E){var s=[];for(var a in this._oDraftMetadata.annotations){if(a.lastIndexOf(E[e].type)>-1){s=this._oDraftMetadata.annotations[a][this._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_SEMANTICKEY]||[];break;}}var S=[];var b;for(var i=0;i<s.length;i++){b=s[i];for(var k in b){S.push(b[k]);}}return S;},_prepareDraftMetadata:function(e){var t=this;this._oDraftMetadata.draftNodes=[];this._oDraftMetadata.draftRootKey=e[this._oDraftMetadata.draftRootName].keys.filter(function(x){return t._calcSemanticKeys(t._oDraftMetadata.draftRootName,e).indexOf(x)<0;})[0];var a=t._oDraftMetadata.annotations;var E=a.EntityContainer[Object.keys(a.EntityContainer)[0]];for(var s in E){var o=E[s];if(o[t._oConstants.COM_SAP_VOCABULARIES_COMMON_V1_DRAFTNODE]){this._oDraftMetadata.draftNodes.push(s);}}for(var j=0;j<this._oDraftMetadata.draftNodes.length;j++){this.attachAfter(M.HTTPMETHOD.GET,this._fnDraftAdministrativeData,this._oDraftMetadata.draftNodes[j]);}},_fnDraftAdministrativeData:function(e){var E={};var d=e.getParameter("oFilteredData");if(!d){E=e.getParameter("oEntry");if(E.IsActiveEntity&&!E.HasDraftEntity){E[this._oConstants.DRAFT_ADMINISTRATIVE_DATA]=null;}}else{if(d.results){d=d.results;}else{if(q.isEmptyObject(d)){d=null;return;}}for(var i=0;i<d.length;i++){E=d[i];if(E.IsActiveEntity&&!E.HasDraftEntity){E[this._oConstants.DRAFT_ADMINISTRATIVE_DATA]=null;}}}},_handleDraftArtifacts:function(e){var t=this;var m=this._oMockdata;var d=m[this._oDraftMetadata.draftRootName];var g=function(c,C){return c.filter(function(x){return C.indexOf(x)<0;})[0];};if(d.length===100){for(var i=0;i<d.length;i++){var E=d[i];if(i<25){E.IsActiveEntity=true;E.HasActiveEntity=false;E.HasDraftEntity=false;E[this._oDraftMetadata.draftRootKey]=this._oConstants.EMPTY_GUID;if(E[this._oConstants.DRAFT_ADMINISTRATIVE_DATA_UUID]){E[this._oConstants.DRAFT_ADMINISTRATIVE_DATA_UUID]=null;}var D=[];var s=[];for(var j=0;j<this._oDraftMetadata.draftNodes.length;j++){s=this._calcSemanticKeys(this._oDraftMetadata.draftNodes[j],e);D=m[this._oDraftMetadata.draftNodes[j]];var o=e[this._oDraftMetadata.draftRootName];for(var n in o.navprops){var N=o.navprops[n];if(N.to.entitySet===this._oDraftMetadata.draftNodes[j]){var p=N.from.propRef.length;for(var k=0;k<p;k++){D[i][N.to.propRef[k]]=E[N.from.propRef[k]];}}}D[i].IsActiveEntity=true;D[i].HasActiveEntity=false;D[i].HasDraftEntity=false;D[i][this._oDraftMetadata.draftRootKey]=this._oConstants.EMPTY_GUID;if(D[i][this._oConstants.DRAFT_ADMINISTRATIVE_DATA_UUID]){D[i][this._oConstants.DRAFT_ADMINISTRATIVE_DATA_UUID]=null;}var a=g(e[this._oDraftMetadata.draftNodes[j]].keys,s);D[i][a]=this._oConstants.EMPTY_GUID;}}else if(i<50){E.IsActiveEntity=false;E.HasActiveEntity=false;E.HasDraftEntity=false;D=[];s=[];for(var j=0;j<this._oDraftMetadata.draftNodes.length;j++){s=this._calcSemanticKeys(this._oDraftMetadata.draftNodes[j],e);D=m[this._oDraftMetadata.draftNodes[j]];var o=e[this._oDraftMetadata.draftRootName];for(var n in o.navprops){var N=o.navprops[n];if(N.to.entitySet===this._oDraftMetadata.draftNodes[j]){var p=N.from.propRef.length;for(var k=0;k<p;k++){D[i][N.to.propRef[k]]=E[N.from.propRef[k]];}}}D[i].IsActiveEntity=false;D[i].HasActiveEntity=false;D[i].HasDraftEntity=false;a=g(e[this._oDraftMetadata.draftNodes[j]].keys,s);}}else if(i<75){var S=q.extend(true,{},E);E.IsActiveEntity=true;E.HasActiveEntity=false;E.HasDraftEntity=true;E[this._oDraftMetadata.draftRootKey]=this._oConstants.EMPTY_GUID;D=[];s=[];for(var j=0;j<this._oDraftMetadata.draftNodes.length;j++){s=this._calcSemanticKeys(this._oDraftMetadata.draftNodes[j],e);D=m[this._oDraftMetadata.draftNodes[j]];var o=e[this._oDraftMetadata.draftRootName];for(var n in o.navprops){var N=o.navprops[n];if(N.to.entitySet===this._oDraftMetadata.draftNodes[j]){var p=N.from.propRef.length;for(var k=0;k<p;k++){D[i][N.to.propRef[k]]=E[N.from.propRef[k]];}}}D[i].IsActiveEntity=true;D[i].HasActiveEntity=false;D[i].HasDraftEntity=true;a=g(e[this._oDraftMetadata.draftNodes[j]].keys,s);D[i][a]=this._oConstants.EMPTY_GUID;}S.IsActiveEntity=false;S.HasActiveEntity=true;S.HasDraftEntity=false;d[i+25]=S;}}}var r=this._getRootUri();q.each(e,function(b,o){q.each(m[b],function(I,c){c.__metadata=c.__metadata||{};c.__metadata.uri=r+b+"("+t._createKeysString(o,c)+")";c.__metadata.type=o.schema+"."+o.type;q.each(o.navprops,function(K){c[K]={__deferred:{uri:r+b+"("+t._createKeysString(o,c)+")/"+K}};});});});},_activate:function(e){var r;var g=function(c,C){return c.filter(function(x){return C.indexOf(x)<0;})[0];};for(var i=0;i<this._oDraftMetadata.draftNodes.length;i++){for(var n in this._mEntitySets[this._oDraftMetadata.draftRootName].navprops){if(this._mEntitySets[this._oDraftMetadata.draftRootName].navprops[n].to.entitySet===this._oDraftMetadata.draftNodes[i]){r=q.sap.sjax({url:e[n].__deferred.uri,dataType:"json"});if(r.success&&r.data&&r.data.d&&r.data.d.results){var N;for(var j=0;j<r.data.d.results.length;j++){N=r.data.d.results[j];N.IsActiveEntity=true;N.HasActiveEntity=false;N.HasDraftEntity=false;N[this._oDraftMetadata.draftRootKey]=this._oConstants.EMPTY_GUID;var s=this._calcSemanticKeys(this._oDraftMetadata.draftNodes[i],this._mEntitySets);var d=g(this._mEntitySets[this._oDraftMetadata.draftNodes[i]].keys,s);N[d]=this._oConstants.EMPTY_GUID;q.sap.sjax({url:N.__metadata.uri,type:"PATCH",data:JSON.stringify(N)});}}}}}e.IsActiveEntity=true;e.HasActiveEntity=false;e.HasDraftEntity=false;e[this._oDraftMetadata.draftRootKey]=this._oConstants.EMPTY_GUID;q.sap.sjax({url:e.__metadata.uri,type:"PATCH",data:JSON.stringify(e)});return e;},setRequests:function(r){var t=this;r.push({method:"POST",path:new RegExp(t._oDraftMetadata.draftRootActivationName),response:function(x){var R=JSON.parse(x.requestBody);var f=[];for(var p in R){f.push(p+" eq "+R[p]);}var o=q.sap.sjax({url:t._oDraftMetadata.mockServerRootUri+t._oDraftMetadata.draftRootName+"?$filter="+f.join(" and "),dataType:"json"});if(!o.success||!o.data.d.results[0]){x.respond(404);}var e=o.data.d.results[0];if(e.IsActiveEntity){x.respond(400);}if(e.HasActiveEntity){var s=e.SiblingEntity.__deferred.uri;o=q.sap.sjax({url:s,dataType:"json"});if(o.success&&o.data&&o.data.d.__metadata){var S=o.data.d;o=q.sap.sjax({url:S.__metadata.uri,type:"DELETE"});}}e=t._activate(e);x.respondJSON(200,{},JSON.stringify({d:e}));return true;}});if(t._oDraftMetadata.draftRootEditName){r.push({method:"POST",path:new RegExp(t._oDraftMetadata.draftRootEditName+"(\\?(.*))?"),response:function(x,u){var f=[];var R=JSON.parse(x.requestBody);if(R&&!q.isEmptyObject(R)){for(var p in R){f.push(p+" eq "+R[p]);}}else{var U=decodeURIComponent(u).replace("?","&").split("&");for(var a in U){var P=U[a];var b=new RegExp("(.*)=(.*)");var c;if(P){c=b.exec(P);f.push(c[1]+" eq "+c[2]);}}}var o=q.sap.sjax({url:t._oDraftMetadata.mockServerRootUri+t._oDraftMetadata.draftRootName+"?$filter="+f.join(" and "),dataType:"json"});if(!o.success||!o.data.d.results[0]){x.respond(404);}var e=o.data.d.results[0];if(!e.IsActiveEntity||e.HasDraftEntity){x.respond(400);}var d=q.extend(true,{},e);d.IsActiveEntity=false;d.HasActiveEntity=true;d.HasDraftEntity=false;d[t._oDraftMetadata.draftRootKey]=t._generatePropertyValue(t._oDraftMetadata.draftRootKey,"Guid");var s=t._getRootUri();var E=t._mEntitySets[t._oDraftMetadata.draftRootName];d.__metadata=d.__metadata||{};d.__metadata.uri=s+t._oDraftMetadata.draftRootName+"("+t._createKeysString(E,d)+")";d.__metadata.type=E.schema+"."+E.type;q.each(E.navprops,function(k){d[k]={__deferred:{uri:s+t._oDraftMetadata.draftRootName+"("+t._createKeysString(E,d)+")/"+k}};});t._oMockdata[t._oDraftMetadata.draftRootName].push(d);o=q.sap.sjax({url:e.__metadata.uri,type:"PATCH",data:JSON.stringify({HasDraftEntity:true})});x.respondJSON(200,{},JSON.stringify({d:d}));return true;}});}if(t._oDraftMetadata.draftRootValidationName){r.push({method:"GET",path:new RegExp(t._oDraftMetadata.draftRootValidationName+"(\\?(.*))?"),response:function(x,u){var v=t._oDraftMetadata.draftRootValidationName;t.fireEvent(M.HTTPMETHOD.GET+v+":before",{oXhr:x,sUrlParams:u});t.fireEvent(M.HTTPMETHOD.GET+":before",{oXhr:x,sUrlParams:u});var R={d:{}};R.d[v]={"__metadata":{"type":"ValidationResult"},"IsValid":true};t.fireEvent(M.HTTPMETHOD.GET+v+":after",{oXhr:x,oResult:R});t.fireEvent(M.HTTPMETHOD.GET+":after",{oXhr:x,oResult:R});x.respondJSON(200,{},JSON.stringify(R));return true;}});}if(t._oDraftMetadata.draftRootPreparationtionName){r.push({method:"POST",path:new RegExp(t._oDraftMetadata.draftRootPreparationtionName),response:function(x){t.fireEvent(M.HTTPMETHOD.POST+t._oDraftMetadata.draftRootPreparationtionName+":before",{oXhr:x});t.fireEvent(M.HTTPMETHOD.POST+":before",{oXhr:x});var R=JSON.parse(x.requestBody);var f=[];for(var p in R){f.push(p+" eq "+R[p]);}var o=q.sap.sjax({url:t._oDraftMetadata.mockServerRootUri+t._oDraftMetadata.draftRootName+"?$filter="+f.join(" and "),dataType:"json"});if(!o.success||!o.data.d.results[0]){x.respond(404);}var e=o.data.d.results[0];t.fireEvent(M.HTTPMETHOD.POST+t._oDraftMetadata.draftRootPreparationtionName+":after",{oXhr:x,oEntry:e});t.fireEvent(M.HTTPMETHOD.POST+":after",{oXhr:x,oEntry:e});x.respondJSON(200,{},JSON.stringify({d:e}));return true;}});}M.prototype.setRequests.apply(this,[r]);},_generateMockdata:function(e,b){M.prototype._generateMockdata.apply(this,[e,b]);this._handleDraftArtifacts(e);},_loadMockdata:function(e,b){M.prototype._loadMockdata.apply(this,[e,b]);this._handleDraftArtifacts(e);},_resolveNavigation:function(e,f,n,E){var a=M.prototype._resolveNavigation.apply(this,[e,f,n,E]);if(n===this._oConstants.SIBLINGENTITY_NAVIGATION){if(E&&E.IsActiveEntity){a.splice(0,1);}else{a.length>1?a.splice(1,1):a.splice(0,1);}}else if(n===this._oConstants.DRAFT_ADMINISTRATIVE_DATA){if(E){if(E.IsActiveEntity&&!E.HasDraftEntity){a[0]=null;}}else{a[0]=null;}}return a;},_findEntitySets:function(m){var e=M.prototype._findEntitySets.apply(this,[m]);this._prepareDraftMetadata(e);return e;},getEntitySetData:function(e){var E=M.prototype.getEntitySetData.apply(this,[e]);var g=function(){return E;};if(e===this._oDraftMetadata.draftRootName){this._fnDraftAdministrativeData({getParameter:g});return E;}for(var j=0;j<this._oDraftMetadata.draftNodes.length;j++){if(e===this._oDraftMetadata.draftNodes[j]){this._fnDraftAdministrativeData({getParameter:g});return E;}}return E;}};},true);
sap.ui.predefine('sap/ui/core/util/Export',['sap/ui/core/Control','./ExportColumn','./ExportRow','./ExportType','./File',"sap/base/Log"],function(C,E,a,b,F,L){'use strict';
function w(f,o){if(f){return function(){return f.apply(o,arguments);};}else{return f;}}
function p(m){L.warning("Usage of deprecated jQuery Promise method: '"+m+"'. "+"Please use the standard Promise methods 'then' / 'catch' instead!","","sap.ui.core.util.Export");}
function c(P,o){var O=new Promise(P);o=o||O;var r=false,R=false;O.then(function(v){r=true;return v;},function(e){R=true;throw e;});var m={then:O.then,"catch":O["catch"]};function f(e){e.then=function(s,g){var A=[w(s,o),w(g,o)];return f(m.then.apply(e,A),o);};e["catch"]=function(g){var A=[w(g,o)];return f(m["catch"].apply(e,A),o);};[{jq:"done",es6:"then"},{jq:"fail",es6:"catch"},{jq:"always",es6:"then"}].forEach(function(g){e[g.jq]=function(){p(g.jq);var h=null;Array.prototype.concat.apply([],arguments).forEach(function(i){var W=w(i,o);var j=function(v){W.apply(this,arguments);return v;};var A=[j];if(g.jq==="always"){A.push(j);}if(!h){h=m[g.es6].apply(e,A);}else{h=h[g.es6].apply(h,A);}});return f(h,o);};});e.pipe=function(D,g){p("pipe");return e.then(D,g);};e.state=function(){p("state");if(r){return"resolved";}else if(R){return"rejected";}else{return"pending";}};return e;}return f(O);}
var d=C.extend('sap.ui.core.util.Export',{
metadata:{publicMethods:["generate","saveFile"],library:"sap.ui.core",aggregations:{exportType:{type:'sap.ui.core.util.ExportType',multiple:false},columns:{type:'sap.ui.core.util.ExportColumn',multiple:true,bindable:'bindable'},rows:{type:'sap.ui.core.util.ExportRow',multiple:true,bindable:'bindable'},_template:{type:'sap.ui.core.util.ExportRow',multiple:false,visibility:'hidden'}}},
renderer:null
});
d.getMetadata().getAggregation("rows")._doesNotRequireFactory=true;
d.prototype.init=function(){this._oPromise=null;this._fnResolvePromise=null;this._oRowBindingArgs=null;};
d.prototype.exit=function(){delete this._oPromise;delete this._fnResolvePromise;delete this._oRowBindingArgs;};
d.prototype._createRowTemplate=function(){var t=new a(this.getId()+"-row"),e=this.getColumns();for(var i=0,l=e.length;i<l;i++){var o=e[i].getTemplate();if(o){t.addCell(o.clone("col"+i));}}return t;};
d.prototype.bindAggregation=function(n,B){if(n==='rows'){this._oRowBindingArgs=arguments;return this;}return C.prototype.bindAggregation.apply(this,arguments);};
d.prototype.updateRows=function(r){if(r==='change'&&this._fnResolvePromise){var s=this.getExportType()._generate(this);this.destroyAggregation('_template');this.unbindAggregation('rows');this._fnResolvePromise(s);this._oPromise=null;this._fnResolvePromise=null;}};
d.prototype.generate=function(){var t=this;if(!this._oPromise){this._oPromise=c(function(r,e){t._fnResolvePromise=r;if(!t.hasModel()){e("Generate is not possible beause no model was set.");}else{var T=t._createRowTemplate();t.setAggregation('_template',T,true);C.prototype.bindAggregation.apply(t,t._oRowBindingArgs);if(t.getBinding("rows")){t.getBinding("rows").getContexts(0,t.getBinding("rows").getLength());}}},this);}return this._oPromise;};
d.prototype.saveFile=function(f){return this.generate().then(function(s){var e=this.getExportType();F.save(s,f||"data",e.getFileExtension(),e.getMimeType(),e.getCharset(),e.getByteOrderMark());});};
return d;});
sap.ui.predefine('sap/ui/core/util/ExportCell',['sap/ui/core/Element'],function(E){'use strict';
var a=E.extend('sap.ui.core.util.ExportCell',{metadata:{library:"sap.ui.core",properties:{content:'string'}}});
return a;});
sap.ui.predefine('sap/ui/core/util/ExportColumn',['sap/ui/base/ManagedObject','./ExportCell'],function(M,E){'use strict';
var a=M.extend("sap.ui.core.util.ExportColumn",{metadata:{library:"sap.ui.core",properties:{name:"string"},aggregations:{template:{type:"sap.ui.core.util.ExportCell",multiple:false}}}});
return a;});
sap.ui.predefine('sap/ui/core/util/ExportRow',['sap/ui/base/ManagedObject','./ExportCell'],function(M,E){'use strict';
var a=M.extend("sap.ui.core.util.ExportRow",{metadata:{library:"sap.ui.core",aggregations:{cells:{type:"sap.ui.core.util.ExportCell",multiple:true}}}});
return a;});
sap.ui.predefine('sap/ui/core/util/ExportType',['sap/ui/base/ManagedObject'],function(M){'use strict';
var E=M.extend('sap.ui.core.util.ExportType',{metadata:{library:"sap.ui.core",properties:{fileExtension:'string',mimeType:'string',charset:'string',byteOrderMark:{type:'boolean',defaultValue:undefined}}}});
E.prototype.init=function(){this._oExport=null;};
E.prototype._generate=function(e){this._oExport=e;var c=this.generate();this._oExport=null;return c;};
E.prototype.generate=function(){return'';};
E.prototype.getColumnCount=function(){if(this._oExport){return this._oExport.getColumns().length;}return 0;};
E.prototype.getRowCount=function(){if(this._oExport&&this._oExport.getBinding("rows")){return this._oExport.getBinding("rows").getLength();}return 0;};
E.prototype.columnGenerator=function(){var i=0,c=this._oExport.getColumns(),C=c.length;return{next:function(){if(i<C){var I=i;i++;return{value:{index:I,name:c[I].getName()},done:false};}else{return{value:undefined,done:true};}}};};
E.prototype.cellGenerator=function(){var i=0,r=this._oExport.getAggregation('_template'),c=r.getCells(),C=c.length;return{next:function(){if(i<C){var I=i;i++;var m={};c[I].getCustomData().forEach(function(o){m[o.getKey()]=o.getValue();});return{value:{index:I,content:c[I].getContent(),customData:m},done:false};}else{return{value:undefined,done:true};}}};};
E.prototype.rowGenerator=function(){var t=this,i=0,e=this._oExport,b=e.getBinding("rows"),B=e.getBindingInfo("rows"),c=b.getContexts(0,b.getLength()),C=c.length,r=e.getAggregation('_template');return{next:function(){if(i<C){var I=i;i++;r.setBindingContext(c[I],B.model);return{value:{index:I,cells:t.cellGenerator()},done:false};}else{return{value:undefined,done:true};}}};};
return E;});
sap.ui.predefine('sap/ui/core/util/ExportTypeCSV',['./ExportType'],function(E){'use strict';var r=/[\r\n"\t;,]/;var a=/^[=\+\-@](?![\d.,]+(?:e[\+-]?\d+)?$)/i;
var C=E.extend('sap.ui.core.util.ExportTypeCSV',{metadata:{library:"sap.ui.core",properties:{separatorChar:{type:'string',defaultValue:','}}}});
C.MAX_CELL_LENGTH=32760;
C.prototype.setSeparatorChar=function(s){var s=this.validateProperty('separatorChar',s);if(s.length>1){throw new Error("Value of property \"separatorChar\" needs to be exactly one character or empty. "+"\""+s+"\" is "+s.length+" characters long.");}return this.setProperty('separatorChar',s);};
C.prototype.init=function(){this.setProperty('fileExtension','csv',true);this.setProperty('mimeType','text/csv',true);this.setProperty('charset','utf-8',true);};
C.prototype.escapeContent=function(v){if(!v){return v;}if(v.length>C.MAX_CELL_LENGTH){v=v.slice(0,C.MAX_CELL_LENGTH);}if(a.test(v)){v="'"+v;}var c=v.indexOf(this.getSeparatorChar())>-1;if(c||r.test(v)){v=v.replace(/"/g,'""');v='"'+v+'"';}return v;};
C.prototype.generate=function(){var b=[];this.generateColumns(b);this.generateRows(b);return b.join('\r\n');};
C.prototype.generateColumns=function(b){var c=[],o=this.columnGenerator(),d;while(!(d=o.next()).done){c.push(this.escapeContent(d.value.name));}b.push(c.join(this.getSeparatorChar()));};
C.prototype.generateRows=function(b){var R=this.rowGenerator(),o;while(!(o=R.next()).done){var c=[];var d=o.value.cells,e;while(!(e=d.next()).done){c.push(this.escapeContent(e.value.content));}b.push(c.join(this.getSeparatorChar()));}};
return C;});
sap.ui.predefine('sap/ui/core/util/File',["sap/ui/thirdparty/jquery"],function(q){'use strict';var F={save:function(d,f,s,m,c,b){var a=f+'.'+s;if(typeof b==='undefined'&&c==='utf-8'&&s==='csv'){b=true;}if(b===true&&c==='utf-8'){d='\ufeff'+d;}if(window.Blob){var t='data:'+m;if(c){t+=';charset='+c;}var B=new window.Blob([d],{type:t});if(window.navigator.msSaveOrOpenBlob){window.navigator.msSaveOrOpenBlob(B,a);}else{var u=window.URL||window.webkitURL;var e=u.createObjectURL(B);var l=window.document.createElement('a');if('download'in l){var $=q(document.body);var g=q(l).attr({download:a,href:e,style:'display:none'});$.append(g);g.get(0).click();g.remove();}else{d=encodeURI(d);var w=window.open(t+","+d);if(!w){throw new Error("Could not download the file, please deactivate your pop-up blocker.");}}}}}};return F;},true);
sap.ui.predefine('sap/ui/core/util/LibraryInfo',['sap/ui/base/Object',"sap/base/Log","sap/base/util/Version","sap/ui/thirdparty/jquery"],function(B,L,V,q){"use strict";
var a=B.extend("sap.ui.core.util.LibraryInfo",{
constructor:function(){B.apply(this);this._oLibInfos={};},
destroy:function(){B.prototype.destroy.apply(this,arguments);this._oLibInfos={};},
getInterface:function(){return this;}
});
a.prototype._loadLibraryMetadata=function(l,c){l=l.replace(/\//g,".");if(this._oLibInfos[l]){setTimeout(c.bind(window,this._oLibInfos[l]),0);return;}var t=this,u,s,p=/themelib_(.*)/i.exec(l);if(!p){s=".library";u=sap.ui.require.toUrl(l.replace(/\./g,"/"))+"/";}else{s=".theme";u=sap.ui.require.toUrl("sap/ui/core/themes/"+p[1]+"/");}q.ajax({url:u+s,dataType:"xml",error:function(x,b,e){L.error("failed to load library details from '"+u+s+": "+b+", "+e);t._oLibInfos[l]={name:l,data:null,url:u};c(t._oLibInfos[l]);},success:function(d,S,x){t._oLibInfos[l]={name:l,data:d,url:u};c(t._oLibInfos[l]);}});};
a.prototype._getLibraryInfo=function(l,c){this._loadLibraryMetadata(l,function(d){var r={libs:[],library:d.name,libraryUrl:d.url};if(d.data){var $=q(d.data);r.vendor=$.find("vendor").text();r.copyright=$.find("copyright").text();r.version=$.find("version").text();r.documentation=$.find("documentation").text();r.releasenotes=$.find("releasenotes").attr("url");r.componentInfo=a.prototype._getLibraryComponentInfo($);}c(r);});};
a.prototype._getThirdPartyInfo=function(l,c){this._loadLibraryMetadata(l,function(d){var r={libs:[],library:d.name,libraryUrl:d.url};if(d.data){var $=q(d.data).find("appData").find("thirdparty").children();$.each(function(i,o){if(o.nodeName==="lib"){var b=q(o);var e=b.children("license");r.libs.push({displayName:b.attr("displayName"),homepage:b.attr("homepage"),license:{url:e.attr("url"),type:e.attr("type"),file:d.url+e.attr("file")}});}});}c(r);});};
a.prototype._getDocuIndex=function(l,c){this._loadLibraryMetadata(l,function(d){var b=d.name,f=d.url,r={"docu":{},library:b,libraryUrl:f};if(!d.data){c(r);return;}var D=q(d.data).find("appData").find("documentation");var u=D.attr("indexUrl");if(!u){c(r);return;}if(D.attr("resolve")=="lib"){u=d.url+u;}q.ajax({url:u,dataType:"json",error:function(x,s,e){L.error("failed to load library docu from '"+u+"': "+s+", "+e);c(r);},success:function(d,s,x){d.library=b;d.libraryUrl=f;c(d);}});});};
a.prototype._getReleaseNotes=function(l,v,c){this._loadLibraryMetadata(l,function(d){if(!d.data){c({});return;}var i=(v.split(".").length===3)&&!(/-SNAPSHOT/.test(v));var o=V(v);var m=o.getMajor();var M=o.getMinor();var p=o.getPatch();var D=q(d.data).find("appData").find("releasenotes");var u=D.attr("url");if(!u){L.warning("failed to load release notes for library "+l);c({});return;}if(o.getSuffix()==="-SNAPSHOT"){if(M%2!=0){M=(M+1);p=0;}v=m+"."+M+"."+p;}var b=window.location.href,r=/\/\d.\d{1,2}.\d{1,2}\//;if(D.attr("resolve")=="lib"){if(r.test(b)||i===false){u=d.url+u;}else{u="{major}.{minor}.{patch}/"+d.url+u;}}u=u.replace(/\{major\}/g,m);u=u.replace(/\{minor\}/g,M);u=u.replace(/\{patch\}/g,p);q.ajax({url:u,dataType:"json",error:function(x,s,e){if(s==="parsererror"){L.error("failed to parse release notes for library '"+l+", "+e);}else{L.warning("failed to load release notes for library '"+l+", "+e);}c({});},success:function(d,s,x){c(d,v);}});});};
a.prototype._getLibraryComponentInfo=function(d){var A={};var c=[];var D="";d.find("ownership > component").each(function(b,C){if(C.childElementCount===0){D=C.textContent;}else{var v=C.getElementsByTagName("name");if(v&&v.length>0){v=v[0].textContent;var e=C.getElementsByTagName("module");if(v&&e&&e.length>0){var m=[];for(var i=0;i<e.length;i++){var M=e[i].textContent.replace(/\//g,".");if(M){m.push(M);}}if(m.length>0){c.push({"component":v,"modules":m});}}}}});A["defaultComponent"]=D;if(c&&c.length>0){A["specialCases"]=c;}return A;};
a.prototype._getActualComponent=function(c,m){function b(m,p){m=m.toLowerCase();p=p.toLowerCase();return(m===p||p.match(/\*$/)&&m.indexOf(p.slice(0,-1))===0||p.match(/\.\*$/)&&m===p.slice(0,-2));}if(m){for(var k in c){if(!c[k]){L.error("No library information deployed for "+k);continue;}var C;if(m.indexOf(k)===0){C=c[k].defaultComponent;}var s=c[k].specialCases;if(s){for(var i=0;i<s.length;i++){var S=s[i].modules;for(var j=0;j<S.length;j++){if(b(m,S[j])){C=s[i].component;}}}}if(C){return C;}}}};
a.prototype._getDefaultComponent=function(l){return l&&l.componentInfo&&l.componentInfo.defaultComponent;};
return a;});
sap.ui.predefine('sap/ui/core/util/MockServer',['jquery.sap.global','sap/ui/Device','sap/ui/base/ManagedObject','sap/ui/thirdparty/sinon',"sap/base/Log",'jquery.sap.sjax'],function(q,D,M,d,L){"use strict";if(D.browser.msie){if(window.sinon.log){sap.ui.requireSync("sap/ui/thirdparty/sinon-ie");}if(!window.FormData){window.FormData=function(){};}}
var f=M.extend("sap.ui.core.util.MockServer",{
constructor:function(i,s,S){M.apply(this,arguments);f._aServers.push(this);},
metadata:{properties:{rootUri:"string",recordRequests:{type:"boolean",defaultValue:true},requests:{type:"object[]",defaultValue:[]}}},
_oServer:null,
_aFilter:null,
_oMockdata:null,
_oMetadata:null,
_sMetadataUrl:null,
_sMockdataBaseUrl:null,
_mEntitySets:null,
_oErrorMessages:{INVALID_SYSTEM_QUERY_OPTION_VALUE:"Invalid system query options value",IS_NOT_A_VALID_SYSTEM_QUERY_OPTION:"## is not a valid system query option",URI_VIOLATING_CONSTRUCTION_RULES:"The URI is violating the construction rules defined in the Data Services specification",UNSUPPORTED_FORMAT_VALUE:"Unsupported format value. Only json format is supported",MALFORMED_SYNTAX:"The Data Services Request could not be understood due to malformed syntax",RESOURCE_NOT_FOUND:"Resource not found",INVALID_SORTORDER_DETECTED:"Invalid sortorder ## detected",PROPERTY_NOT_FOUND:"Property ## not found",INVALID_FILTER_QUERY_STATEMENT:"Invalid filter query statement",INVALID_FILTER_OPERATOR:"Invalid $filter operator ##",RESOURCE_NOT_FOUND_FOR_SEGMENT:"Resource not found for the segment ##",MALFORMED_URI_LITERAL_SYNTAX_IN_KEY:"Malformed URI literal syntax in key ##",INVALID_KEY_NAME:"Invalid key name in key predicate. Expected name is ##",INVALID_KEY_PREDICATE_QUANTITY:"Invalid key predicate. The quantity of provided keys does not match the expected value",INVALID_KEY_TYPE:"Invalid key predicate. The key literal for key property ## does not match its type."},
_oRandomSeed:{}
});
f.prototype._getPseudoRandomNumber=function(t){if(!this._oRandomSeed){this._oRandomSeed={};}if(!this._oRandomSeed.hasOwnProperty(t)){this._oRandomSeed[t]=0;}this._oRandomSeed[t]=(this._oRandomSeed[t]+11)*25214903917%281474976710655;return this._oRandomSeed[t]/281474976710655;};
f.prototype._resetPseudoRandomNumberGenerator=function(){this._oRandomSeed={};};
f.prototype.start=function(){this._oServer=f._getInstance();this._aFilters=[];var r=this.getRequests();var t=this;r.forEach(function(R){var a;if(t.getRecordRequests()===false&&R.response){a=function(){R.response.apply(this,arguments);t._oServer.requests=[];};}else{a=R.response;}t._addRequestHandler(R.method,R.path,a);});};
f.prototype.stop=function(){if(this.isStarted()){this._removeAllRequestHandlers();this._removeAllFilters();this._oServer=null;}};
f.prototype.attachBefore=function(h,c,e){e=e?e:"";this.attachEvent(h+e+":before",c);};
f.prototype.attachAfter=function(h,c,e){e=e?e:"";this.attachEvent(h+e+":after",c);};
f.prototype.detachBefore=function(h,c,e){e=e?e:"";this.detachEvent(h+e+":before",c);};
f.prototype.detachAfter=function(h,c,e){e=e?e:"";this.detachEvent(h+e+":after",c);};
f.prototype.isStarted=function(){return!!this._oServer;};
f.prototype.getEntitySetData=function(e){var t=this;var c;if(this._oMockdata&&this._oMockdata.hasOwnProperty(e)){c=q.extend(true,[],t._oMockdata[e]);}else{L.error("Unrecognized EntitySet name: "+e);}return c;};
f.prototype.setEntitySetData=function(e,a){if(this._oMockdata&&this._oMockdata.hasOwnProperty(e)){this._oMockdata[e]=a;}else{L.error("Unrecognized EntitySet name: "+e);}};
f.prototype._applyQueryOnCollection=function(F,Q,e,u){var a=Q.split('=');var o=a[1];if(o===""){return;}if(o.lastIndexOf(',')===o.length-1){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.URI_VIOLATING_CONSTRUCTION_RULES);}switch(a[0]){case"$top":if(!(new RegExp(/^\d+$/).test(o))){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.INVALID_SYSTEM_QUERY_OPTION_VALUE);}F.results=F.results.slice(0,o);break;case"$skip":if(!(new RegExp(/^\d+$/).test(o))){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.INVALID_SYSTEM_QUERY_OPTION_VALUE);}F.results=F.results.slice(o,F.results.length);break;case"$orderby":F.results=this._getOdataQueryOrderby(F.results,o,e);break;case"$filter":F.results=this._recursiveOdataQueryFilter(F.results,o);break;case"search-focus":break;case"search":var s="";for(var i=0;i<u.length;i++){if(u[i].indexOf("search-focus")!=-1){s=u[i].split('=')[1];break;}}F.results=this._recursiveOdataQuerySearch(F.results,o,s,e);break;case"$select":F.results=this._getOdataQuerySelect(F.results,o,e);break;case"$inlinecount":var c=this._getOdataInlineCount(F.results,o);if(c){F.__count=c;}break;case"$expand":F.results=this._getOdataQueryExpand(F.results,o,e);break;case"$format":F.results=this._getOdataQueryFormat(F.results,o);break;default:this._logAndThrowMockServerCustomError(400,this._oErrorMessages.IS_NOT_A_VALID_SYSTEM_QUERY_OPTION,a[0]);}};
f.prototype._applyQueryOnEntry=function(e,Q,E){var a=Q.split('=');var o=a[1];if(o===""){return;}if(o.lastIndexOf(',')===o.length-1){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.URI_VIOLATING_CONSTRUCTION_RULES);}switch(a[0]){case"$filter":return this._recursiveOdataQueryFilter([e],o)[0];case"$select":return this._getOdataQuerySelect([e],o,E)[0];case"$expand":return this._getOdataQueryExpand([e],o,E)[0];case"$format":return this._getOdataQueryFormat([e],o);default:this._logAndThrowMockServerCustomError(400,this._oErrorMessages.IS_NOT_A_VALID_SYSTEM_QUERY_OPTION,a[0]);}};
f.prototype._getOdataQueryOrderby=function(c,o,e){var p=o.split(',');var t=this;q.each(p,function(i,P){p[i]=t._trim(P);});var C=function compare(a,b){for(var i=0;i<p.length;i++){var s=p[i].split(' ');var S=1;if(s.length>1){switch(s[1]){case'asc':S=1;break;case'desc':S=-1;break;default:t._logAndThrowMockServerCustomError(400,t._oErrorMessages.INVALID_SORTORDER_DETECTED,s[1]);}}var P,h;var j=s[0].indexOf("/");if(j!==-1){P=s[0].substring(j+1);h=s[0].substring(0,j);if(!a[h].hasOwnProperty(P)){var E=false;var T=[];if(h){var k=t._mEntitySets[e].navprops[h].to.entitySet;T=t._mEntityTypes[t._mEntitySets[k].type].properties;for(var i=0;i<T.length;i++){if(T[i].name===P){E=true;break;}}}if(!E){t._logAndThrowMockServerCustomError(400,t._oErrorMessages.PROPERTY_NOT_FOUND,P);}}if(a[h][P]<b[h][P]){return-1*S;}if(a[h][P]>b[h][P]){return 1*S;}}else{P=s[0];if(!a.hasOwnProperty(P)){t._logAndThrowMockServerCustomError(400,t._oErrorMessages.PROPERTY_NOT_FOUND,P);}if(a[P]<b[P]){return-1*S;}if(a[P]>b[P]){return 1*S;}}}return 0;};return c.sort(C);};
f.prototype._arrayUnique=function(b){var a=b.concat();for(var i=0;i<a.length;++i){for(var j=i+1;j<a.length;++j){if(a[i]===a[j]){a.splice(j--,1);}}}return a;};
f.prototype._getBracketIndices=function(s){var S=[];var r=false;var i,e=0;for(var c=0;c<s.length;c++){if(s[c]==='('){if(/[substringof|endswith|startswith]$/.test(s.substring(0,c))){r=true;}else{S.push(s[c]);if(i===undefined){i=c;}}}else if(s[c]===')'){if(!r){S.pop();e=c;if(S.length===0){return{start:i,end:e};}}else{r=false;}}}return{start:i,end:e};};
f.prototype._recursiveOdataQueryFilter=function(a,o){var I=this._getBracketIndices(o);if(I.start===0&&I.end===o.length-1){o=this._trim(o.substring(I.start+1,I.end));return this._recursiveOdataQueryFilter(a,o);}var r=/([^substringof|endswith|startswith]|^)\((.*)\)/,s,p;var O;if(r.test(o)){var b=o.substring(I.start,I.end+1);var c=new RegExp("(.*) +(or|and) +("+this._trim(this._escapeStringForRegExp(b))+".*)");if(I.start===0){c=new RegExp("("+this._trim(this._escapeStringForRegExp(b))+") +(or|and) +(.*)");}var e=c.exec(o);if(e===null){return this._getOdataQueryFilter(a,this._trim(o));}var E=e[1];O=e[2];var h=e[3];var S=this._recursiveOdataQueryFilter(a,E);if(O==="or"){s=this._recursiveOdataQueryFilter(a,h);return this._arrayUnique(S.concat(s));}if(O==="and"){return this._recursiveOdataQueryFilter(S,h);}}else{p=o.split(/ +and | or +/);if(p.length===1){if(o.match(/ +and | or +/)){throw new Error("400");}return this._getOdataQueryFilter(a,this._trim(o));}var R=this._recursiveOdataQueryFilter(a,p[0]);var j;for(var i=1;i<p.length;i++){j=new RegExp(this._trim(this._escapeStringForRegExp(p[i-1]))+" +(and|or) +"+this._trim(this._escapeStringForRegExp(p[i])));O=j.exec(o)[1];if(O==="or"){s=this._recursiveOdataQueryFilter(a,p[i]);R=this._arrayUnique(R.concat(s));}if(O==="and"){R=this._recursiveOdataQueryFilter(R,p[i]);}}return R;}};
f.prototype._getOdataQueryFilter=function(a,o){if(a.length===0){return a;}var r=new RegExp("(.*) (eq|ne|gt|lt|le|ge) (.*)");var b=new RegExp("(endswith|startswith|substringof)\\((.*)");var O=null;var c=r.exec(o);if(c){O=c[2];}else{c=b.exec(o);if(c){O=c[1];}else{this._logAndThrowMockServerCustomError(400,this._oErrorMessages.INVALID_FILTER_QUERY_STATEMENT);}}var t=this;var G=function(v,V,p,s){var c,e,P;if(!v){c=r.exec(o);e=t._trim(c[V+1]);P=t._trim(c[p+1]);}else{var h=new RegExp("(substringof|startswith|endswith)\\(([^\\)]*),(.*)\\)");c=h.exec(o);e=t._trim(c[V+2]);P=t._trim(c[p+2]);}if(/^\(.+\)$/.test(e)){e=e.replace(/^\(|\)$/g,"");}var T=e[e.length-1];if(T==="M"||T==="m"||T==="L"||T==="f"){e=e.substring(0,e.length-1);}if(e.indexOf("datetime")===0){e=t._getJsonDate(e);}else if(e.indexOf("guid")===0){e=e.substring(5,e.length-1);}else if(e==="true"){e=true;}else if(e==="false"){e=false;}else if(t._isValidNumber(e)){e=parseFloat(e);}else if((e.charAt(0)==="'")&&(e.charAt(e.length-1)==="'")){e=e.substr(1,e.length-2);}var C=P.indexOf("/");if(C!==-1){var i=P.substring(C+1);var j=P.substring(0,C);if(a[0][j]){if(!a[0][j].hasOwnProperty(i)){var E=t._oErrorMessages.PROPERTY_NOT_FOUND.replace("##","'"+i+"'");L.error("MockServer: navigation property '"+j+"' was not expanded, so "+E);return a;}}else{t._logAndThrowMockServerCustomError(400,t._oErrorMessages.PROPERTY_NOT_FOUND,P);}return s(P,e,j,i);}else{if(!a[0].hasOwnProperty(P)){t._logAndThrowMockServerCustomError(400,t._oErrorMessages.PROPERTY_NOT_FOUND,P);}return s(P,e);}};switch(O){case"substringof":return G(true,0,1,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(typeof m[C][P]==="string"&&m[C][P].indexOf(v)!==-1);}return(typeof m[p]==="string"&&m[p].indexOf(v)!==-1);});});case"startswith":return G(true,1,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(typeof m[C][P]==="string"&&m[C][P].indexOf(v)===0);}return(typeof m[p]==="string"&&m[p].indexOf(v)===0);});});case"endswith":return G(true,1,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(typeof m[C][P]==="string"&&m[C][P].indexOf(v)===(m[C][P].length-v.length));}return(typeof m[p]==="string"&&m[p].indexOf(v)===(m[p].length-v.length));});});case"eq":return G(false,2,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(m[C][P]===v);}return(m[p]===v);});});case"ne":return G(false,2,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(m[C][P]!==v);}return(m[p]!==v);});});case"gt":return G(false,2,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(m[C][P]>v);}return(m[p]>v);});});case"lt":return G(false,2,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(m[C][P]<v);}return(m[p]<v);});});case"ge":return G(false,2,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(m[C][P]>=v);}return(m[p]>=v);});});case"le":return G(false,2,0,function(p,v,C,P){return a.filter(function(m){if(C&&P){return(m[C][P]<=v);}return(m[p]<=v);});});default:this._logAndThrowMockServerCustomError(400,t._oErrorMessages.INVALID_FILTER_OPERATOR,O);}};
f.prototype._recursiveOdataQuerySearch=function(a,o,O,e){var F="";if(O==""||O==undefined){for(var i=0;i<this._mEntitySets[e].keys.length;i++){if(i!=0){F=F+" or ";}F=F+"startswith("+this._mEntitySets[e].keys[i]+",'"+o+"')";}}else{F="substringof('"+o+"',"+O+")";}return this._recursiveOdataQueryFilter(a,F);};
f.prototype._getOdataQuerySelect=function(a,o,e){var t=this;var p,c;var P=o.split(',');var s=[];var b;var h=a[0]?a[0][P[0].split('/')[0]]:null;if(!(h!=null&&h.results&&h.results.length>0)){var C=function(P,k,b,l){var n={};q.each(P,function(i,j){var r=j.indexOf("/");if(r!==-1){p=j.substring(r+1);c=j.substring(0,r);if(n[c]){n[c].push(p);}else{n[c]=[p];}}});q.each(Object.keys(n),function(i,j){if(!b[j]){b[j]={};}b[j]=C(n[j],k[j],b[j],j);});if(k.results){var F=[];q.each(k.results,function(i,r){var u={};q.each(P,function(j,v){u[v]=r[v];});F.push(u);});if(b){b.results=F;}}else{if(k["__metadata"]){b["__metadata"]=k["__metadata"];}q.each(P,function(i,j){var r=j.indexOf("/");if(r===-1){if(k&&!k.hasOwnProperty(j)){var E=false;var T=[];if(l){var u=t._mEntitySets[e].navprops[l].to.entitySet;T=t._mEntityTypes[t._mEntitySets[u].type].properties;for(var i=0;i<T.length;i++){if(T[i].name===j){E=true;break;}}}if(!E){t._logAndThrowMockServerCustomError(404,t._oErrorMessages.RESOURCE_NOT_FOUND_FOR_SEGMENT,j);}}b[j]=k[j];}});}return b;};if(P.indexOf("*")!==-1){return a;}q.each(P,function(i,j){P[i]=t._trim(j);});q.each(a,function(i,j){b={};s.push(C(P,j,b));});}else{var m=function(i,j,k){var r={};k=k||'';if(typeof i!=='object'){return i;}if(typeof i.slice==='function'){return i.map(function(l,n){return m(l,j,k);});}if(i.__metadata!==undefined&&k.length===0){r.__metadata=i.__metadata;}j.filter(function(l){return(l+'/').indexOf(k)===0;}).forEach(function(l,_,n){var u=l.substr(k.length).split('/')[0];if(i[u]!==undefined){r[u]=m(i[u],n,k+u+'/');}});if(i.results!==undefined){r.results=m(i.results,j,k);}return r;};s=m(a,P);}return s;};
f.prototype._getOdataInlineCount=function(a,o){var p=o.split(',');if(p.length!==1||(p[0]!=='none'&&p[0]!=='allpages')){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.INVALID_SYSTEM_QUERY_OPTION_VALUE);}if(p[0]==='none'){return;}return a.length;};
f.prototype._getOdataQueryFormat=function(a,o){if(o!=='json'){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.UNSUPPORTED_FORMAT_VALUE);}return a;};
f.prototype._getOdataQueryExpand=function(a,o,e){var t=this;var n=o.split(',');q.each(n,function(i,p){n[i]=t._trim(p);});var E=t._mEntitySets[e].navprops;q.each(a,function(i,r){q.each(n,function(i,N){var b=N.split("/");var s=b[0];if(!r[s]){t._logAndThrowMockServerCustomError(404,t._oErrorMessages.RESOURCE_NOT_FOUND_FOR_SEGMENT,s);}var c=r[s].results||r[s];if(!c||!!c.__deferred){c=q.extend(true,[],t._resolveNavigation(e,r,s,r));}else if(!Array.isArray(c)){c=[c];}if(!!c&&b.length>1){var R=b.splice(1,b.length).join("/");c=t._getOdataQueryExpand(c,R,E[s].to.entitySet);}if(E[s].to.multiplicity==="*"){r[s]={results:c};}else{r[s]=c[0]?c[0]:{};}});});return a;};
f.prototype._refreshData=function(){var m=this._loadMetadata(this._sMetadataString);if(!m){return;}this._mEntitySets=this._findEntitySets(this._oMetadata);this._mEntityTypes=this._findEntityTypes(this._oMetadata);if(!this._sMockdataBaseUrl){this._generateMockdata(this._mEntitySets,this._oMetadata);}else{if(!this._sMockdataBaseUrl.endsWith("/")&&!this._sMockdataBaseUrl.endsWith(".json")){this._sMockdataBaseUrl+="/";}this._loadMockdata(this._mEntitySets,this._sMockdataBaseUrl);}};
f.prototype._getRootUri=function(){var u=this.getRootUri();u=u&&/([^?#]*)([?#].*)?/.exec(u)[1];return u;};
f.prototype._loadMetadata=function(m){var m;m=m.trim();if(m.substring(0,1)!=="<"){m=q.sap.sjax({url:m,dataType:"text"}).data;if(!m){L.error("MockServer: The metadata for url \""+m+"\" could not be found!");}}this._sMetadata=m;try{this._oMetadata=q.parseXML(m);}catch(e){L.error("MockServer: Invalid metadata XML! Reason: "+e);}return this._oMetadata;};
f.prototype._findEntitySets=function(m){var e={};var p=q(m).find("Principal");var o=q(m).find("Dependent");q(m).find("EntitySet").each(function(i,E){var $=q(E);var a=/((.*)\.)?(.*)/.exec($.attr("EntityType"));e[$.attr("Name")]={"name":$.attr("Name"),"schema":a[2],"type":a[3],"keys":[],"keysType":{},"navprops":{}};});var r=function(R,a,A,F){var E=q(A).find("End[Role='"+R+"']").attr("EntitySet");var s=q(a).find("End[Role='"+R+"']").attr("Multiplicity");var P=[];var c=q(a).find("ReferentialConstraint > [Role='"+R+"']");if(c&&c.length>0){q(c[0]).children("PropertyRef").each(function(i,h){P.push(q(h).attr("Name"));});}else{var b=(F)?p:o;q(b).each(function(i,h){if(R===(q(h).attr("Role"))){q(h).children("PropertyRef").each(function(i,j){P.push(q(j).attr("Name"));});return false;}});}return{"role":R,"entitySet":E,"propRef":P,"multiplicity":s};};q.each(e,function(E,a){var $=q(m).find("EntityType[Name='"+a.type+"']");var k=q($).find("PropertyRef");q.each(k,function(i,P){var K=q(P).attr("Name");a.keys.push(K);a.keysType[K]=q($).find("Property[Name='"+K+"']").attr("Type");});var n=q(m).find("EntityType[Name='"+a.type+"'] NavigationProperty");q.each(n,function(i,N){var b=q(N);var R=b.attr("Relationship").split(".");var A=q(m).find("AssociationSet[Association = '"+R.join(".")+"']");var s=R.pop();var c=q(m).find("Association[Name = '"+s+"']");a.navprops[b.attr("Name")]={"name":b.attr("Name"),"from":r(b.attr("FromRole"),c,A,true),"to":r(b.attr("ToRole"),c,A,false)};});});return e;};
f.prototype._findEntityTypes=function(m){var e={};q(m).find("EntityType").each(function(i,E){var $=q(E);e[$.attr("Name")]={"name":$.attr("Name"),"properties":[],"keys":[]};$.find("Property").each(function(i,p){var P=q(p);var t=P.attr("Type");e[$.attr("Name")].properties.push({"schema":t.substring(0,t.lastIndexOf(".")),"type":t.substring(t.lastIndexOf(".")+1),"name":P.attr("Name"),"precision":P.attr("Precision"),"scale":P.attr("Scale")});});$.find("PropertyRef").each(function(i,k){var K=q(k);var p=K.attr("Name");e[$.attr("Name")].keys.push(p);});});return e;};
f.prototype._findComplexTypes=function(m){var c={};q(m).find("ComplexType").each(function(i,C){var $=q(C);c[$.attr("Name")]={"name":$.attr("Name"),"properties":[]};$.find("Property").each(function(i,p){var P=q(p);var t=P.attr("Type");c[$.attr("Name")].properties.push({"schema":t.substring(0,t.lastIndexOf(".")),"type":t.substring(t.lastIndexOf(".")+1),"name":P.attr("Name"),"precision":P.attr("Precision"),"scale":P.attr("Scale")});});});return c;};
f.prototype._createKeysString=function(e,E){var t=this;var k="";if(E){q.each(e.keys,function(i,K){if(k){k+=",";}var o=E[K];if(e.keysType[K]==="Edm.String"){o=encodeURIComponent("'"+o+"'");}else if(e.keysType[K]==="Edm.DateTime"){o=t._getDateTime(o);o=encodeURIComponent(o);}else if(e.keysType[K]==="Edm.Guid"){o="guid'"+o+"'";}if(e.keys.length===1){k+=o;return k;}k+=K+"="+o;});}return k;};
f.prototype._loadMockdata=function(e,b){var t=this,m={};this._oMockdata={};var l=function(u,o){var r=q.sap.sjax({url:u,dataType:"json"});if(r.success){if(r.data.d){if(r.data.d.results){m[o.name]=r.data.d.results;}else{L.error("The mock data format for entity set \""+o.name+"\" invalid");}}else{if(Array.isArray(r.data)){m[o.name]=r.data;}else{L.error("The mock data for entity set \""+o.name+"\" could not be loaded due to wrong format!");return false;}}return true;}else{if(r.status==="parsererror"){L.error("The mock data for entity set \""+o.name+"\" could not be loaded due to a parsing error!");}return false;}};if(b.endsWith(".json")){var r=q.sap.sjax({url:b,dataType:"json"});if(r.success){m=r.data;}else{L.warning("The mock data for all the entity types could not be found at \""+b+"\"!");}}else{var E={};if(t._aEntitySetsNames&&t._aEntitySetsNames.length>0){var s;for(var i=0;i<t._aEntitySetsNames.length;i++){s=t._aEntitySetsNames[i];if(e[s]){E[s]=e[s];}}}else{E=e;}q.each(E,function(a,o){if(!m[o.type]||!m[o.name]){var c=b+o.name+".json";if(!l(c,o)){L.warning("The mock data for entity set \""+o.name+"\" could not be found at \""+b+"\"!");var h=b+o.type+".json";if(!l(h,o)){L.warning("The mock data for entity type \""+o.type+"\" could not be found at \""+b+"\"!");if(t._bGenerateMissingMockData){var j={};j[o.name]=o;m[o.type]=t._generateODataMockdataForEntitySet(j,t._oMetadata)[o.name];}}}}});}q.each(e,function(a,o){t._oMockdata[a]=[];if(m[o.name]){q.each(m[o.name],function(I,c){t._oMockdata[a].push(q.extend(true,{},c));});}else if(m[o.type]){q.each(m[o.type],function(I,c){t._oMockdata[a].push(q.extend(true,{},c));});}});q.each(e,function(a,o){if(t._oMockdata[a].length>0){t._enhanceWithMetadata(o,t._oMockdata[a]);}});return this._oMockdata;};
f.prototype._enhanceWithMetadata=function(e,m){if(m){var t=this,r=this._getRootUri(),E=e&&e.name;q.each(m,function(i,o){o.__metadata=o.__metadata||{};o.__metadata.id=r+E+"("+t._createKeysString(e,o)+")";o.__metadata.type=e.schema+"."+e.type;o.__metadata.uri=r+E+"("+t._createKeysString(e,o)+")";q.each(e.navprops,function(k,n){if(o[k]&&!q.isEmptyObject(o[k])&&!o[k]["__deferred"]){t._oMockdata[n.to.entitySet]=t._oMockdata[n.to.entitySet].concat(o[k]);}o[k]={__deferred:{uri:r+E+"("+t._createKeysString(e,o)+")/"+k}};});});}};
f.prototype._isRequestedKeysValid=function(e,r){if(r.length===1){var s=r[0].split('=');if(this._trim(s[0])!==e.keys[0]){r=[e.keys[0]+"="+r[0]];}}for(var i=0;i<r.length;i++){var k=this._trim(r[i].substring(0,r[i].indexOf('=')));var R=this._trim(r[i].substring(r[i].indexOf('=')+1));var F=R.charAt(0);var l=R.charAt(R.length-1);if(e.keysType[k]==="Edm.String"){if(F!=="'"||l!=="'"){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.MALFORMED_URI_LITERAL_SYNTAX_IN_KEY,k);}}else if(e.keysType[k]==="Edm.DateTime"){if(F==="'"||l!=="'"){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.MALFORMED_URI_LITERAL_SYNTAX_IN_KEY,k);}}else if(e.keysType[k]==="Edm.Guid"){if(F==="'"||l!=="'"){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.MALFORMED_URI_LITERAL_SYNTAX_IN_KEY,k);}}else if(e.keysType[k]==="Edm.Binary"){if(!(new RegExp("(binary|X)'[A-Fa-f0-9][A-Fa-f0-9]*'").test(R))){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.MALFORMED_URI_LITERAL_SYNTAX_IN_KEY,k);}}else{if((F==="'"&&l!=="'")||(l==="'"&&F!=="'")){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.MALFORMED_URI_LITERAL_SYNTAX_IN_KEY,k);}}var K=e.keys.join(",");if(e.keys.indexOf(k)===-1){this._logAndThrowMockServerCustomError(400,this._oErrorMessages.INVALID_KEY_NAME,K);}}};
f.prototype._parseKeys=function(k,e){var r={};var p=k.split(",");var K,s,P;for(var i=0;i<p.length;i++){P=p[i].split("=");if(P.length===1&&e.keys.length===1){K=e.keys[0];s=P[0];}else{if(P.length===2){K=P[0];s=P[1];}}r[K]=s;switch(e.keysType[K]){case"Edm.String":r[K]=r[K].replace(/^\'|\'$/g,"");break;case"Edm.Int16":case"Edm.Int32":case"Edm.Int64":case"Edm.Decimal":case"Edm.Byte":case"Edm.Double":case"Edm.Single":case"Edm.SByte":r[K]=parseFloat(r[K]);break;case"Edm.Guid":r[K]=r[K].replace(/^guid\'|\'$/g,"");break;case"Edm.Boolean":case"Edm.Binary":case"Edm.DateTimeOffset":default:r[K]=r[K];}}return r;};
f.prototype._generatePropertyValue=function(k,t,C,i){var I=i;if(!I){I=Math.floor(this._getPseudoRandomNumber("String")*10000)+101;}switch(t){case"String":return k+" "+I;case"DateTime":var a=new Date();a.setFullYear(2000+Math.floor(this._getPseudoRandomNumber("DateTime")*20));a.setDate(Math.floor(this._getPseudoRandomNumber("DateTime")*30));a.setMonth(Math.floor(this._getPseudoRandomNumber("DateTime")*12));a.setMilliseconds(0);return"/Date("+a.getTime()+")/";case"Int16":case"Int32":case"Int64":return Math.floor(this._getPseudoRandomNumber("Int")*10000);case"Decimal":return Math.floor(this._getPseudoRandomNumber("Decimal")*1000000)/100;case"Boolean":return this._getPseudoRandomNumber("Boolean")<0.5;case"Byte":return Math.floor(this._getPseudoRandomNumber("Byte")*10);case"Double":return this._getPseudoRandomNumber("Double")*10;case"Single":return this._getPseudoRandomNumber("Single")*1000000000;case"SByte":return Math.floor(this._getPseudoRandomNumber("SByte")*10);case"Time":return"PT"+Math.floor(this._getPseudoRandomNumber("Time")*23)+"H"+Math.floor(this._getPseudoRandomNumber("Time")*59)+"M"+Math.floor(this._getPseudoRandomNumber("Time")*59)+"S";case"Guid":return'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g,function(c){var r=this._getPseudoRandomNumber("Guid")*16|0,v=c==='x'?r:(r&0x3|0x8);return v.toString(16);}.bind(this));case"Binary":var n=Math.floor(-2147483648+this._getPseudoRandomNumber("Binary")*4294967295),m="";for(var b=0,e=n;b<32;b++,m+=String(e>>>31),e<<=1);return m;case"DateTimeOffset":var a=new Date();a.setFullYear(2000+Math.floor(this._getPseudoRandomNumber("DateTimeOffset")*20));a.setDate(Math.floor(this._getPseudoRandomNumber("DateTimeOffset")*30));a.setMonth(Math.floor(this._getPseudoRandomNumber("DateTimeOffset")*12));a.setMilliseconds(0);return"/Date("+a.getTime()+"+0000)/";default:return this._generateDataFromEntity(C[t],I,C);}};
f.prototype._isFalseyValue=function(k,K,s){switch(s){case"Edm.String":return k==="";case"Edm.Boolean":return k===false;case"Edm.Int16":case"Edm.Int32":case"Edm.Int64":case"Edm.Decimal":case"Edm.Byte":case"Edm.Double":case"Edm.Single":case"Edm.SByte":return k===0||isNaN(k);default:return false;}};
f.prototype._completeKey=function(e,k,E){if(E){for(var i=0;i<e.keys.length;i++){var K=e.keys[i];if(k[K]!==undefined&&k[K]!==null){if(!E[K]){switch(e.keysType[K]){case"Edm.DateTime":E[K]=this._getJsonDate(k[K]);break;case"Edm.Guid":E[K]=k[K].replace(/^guid\'|\'$/g,"");break;default:E[K]=k[K];}}}else{if(!E[K]){E[K]=this._generatePropertyValue(K,e.keysType[K].substring(e.keysType[K].lastIndexOf('.')+1));}}}}};
f.prototype._generateDataFromEntity=function(e,I,c){var E={};if(!e){return E;}for(var i=0;i<e.properties.length;i++){var p=e.properties[i];E[p.name]=this._generatePropertyValue(p.name,p.type,c,I);}return E;};
f.prototype._generateDataFromEntitySet=function(e,E,c){var o=E[e.type];var m=[];for(var i=0;i<100;i++){m.push(this._generateDataFromEntity(o,i+1,c));}return m;};
f.prototype._generateMockdata=function(e,m){var t=this;var o={};var r=this._getRootUri();q.each(e,function(E,a){var b={};b[a.name]=a;o[E]=t._generateODataMockdataForEntitySet(b,m)[E];});q.each(e,function(E,a){for(var n in a.navprops){var N=a.navprops[n];var p=N.from.propRef.length;for(var j=0;j<p;j++){for(var i=0;i<o[E].length;i++){var b=o[E][i];o[N.to.entitySet][i][N.to.propRef[j]]=b[N.from.propRef[j]];}}}q.each(o[E],function(I,c){c.__metadata={uri:r+E+"("+t._createKeysString(a,c)+")",type:a.schema+"."+a.type};q.each(a.navprops,function(k,N){c[k]={__deferred:{uri:r+E+"("+t._createKeysString(a,c)+")/"+k}};});});});this._oMockdata=o;};
f.prototype._generateODataMockdataForEntitySet=function(e,m){var t=this,o={};var E=this._findEntityTypes(m);var c=this._findComplexTypes(m);q.each(e,function(s,a){o[s]=t._generateDataFromEntitySet(a,E,c);});return o;};
f.prototype._resolveNavigation=function(e,F,n){var E=this._mEntitySets[e];var N=E.navprops[n];if(!N){this._logAndThrowMockServerCustomError(404,this._oErrorMessages.RESOURCE_NOT_FOUND);}var a=[];var p=N.from.propRef.length;if(p===0){if(N.to.multiplicity==="*"){return this._oMockdata[N.to.entitySet];}else{a.push(this._oMockdata[N.to.entitySet][0]);return a;}}q.each(this._oMockdata[N.to.entitySet],function(I,t){var b=true;for(var i=0;i<p;i++){if(F[N.from.propRef[i]]!==t[N.to.propRef[i]]){b=false;break;}}if(b){a.push(t);}});return a;};
f.prototype.simulate=function(s,v){var t=this;this._sMetadataString=s;if(!v||typeof v==="string"){this._sMockdataBaseUrl=v;}else{this._sMockdataBaseUrl=v.sMockdataBaseUrl;this._bGenerateMissingMockData=v.bGenerateMissingMockData;this._aEntitySetsNames=v.aEntitySetsNames;}var o=this._loadMetadata(this._sMetadataString);if(!o){return;}if(this._sMetadata){var a=sap.ui.requireSync("sap/ui/core/util/MockServerAnnotationsHandler");var A=a.parse(this._oMetadata,this._sMetadata);var b=sap.ui.requireSync("sap/ui/core/util/DraftEnabledMockServer");b.handleDraft(A,this);}this._resetPseudoRandomNumberGenerator();this._refreshData();var h=function(x,m){if(x.requestHeaders["x-csrf-token"]==="Fetch"){m["X-CSRF-Token"]="42424242424242424242424242424242";}};var G=function(e,k){k=decodeURIComponent(k);var F;var E=t._mEntitySets[e];var K=E.keys;var j=k.split(',');if(j.length!==K.length){t._logAndThrowMockServerCustomError(400,t._oErrorMessages.INVALID_KEY_PREDICATE_QUANTITY);}t._isRequestedKeysValid(E,j);if(j.length===1&&!j[0].split('=')[1]){j=[K[0]+"="+j[0]];}q.each(t._oMockdata[e],function(I,l){for(var i=0;i<j.length;i++){var m=j[i].split('=');var n=t._trim(m[0]);if(!K||K.indexOf(n)===-1){return true;}var N=t._trim(m[1]);var O=l[n];switch(E.keysType[n]){case"Edm.String":N=N.replace(/^\'|\'$/g,'');break;case"Edm.Time":case"Edm.DateTime":O=t._getDateTime(O);break;case"Edm.Int16":case"Edm.Int32":case"Edm.Decimal":case"Edm.Byte":case"Edm.Double":case"Edm.Single":case"Edm.SByte":if(!t._isValidNumber(N)){return false;}N=parseFloat(N);break;case"Edm.Guid":N=N.replace(/^guid\'|\'$/g,'');break;case"Edm.Boolean":if(["true","false"].indexOf(N)===-1){t._logAndThrowMockServerCustomError(400,t._oErrorMessages.INVALID_KEY_TYPE,n);}N=N==="true";break;case"Edm.Binary":case"Edm.DateTimeOffset":default:N=N;}if(O!==N){return true;}}F={index:I,entry:l};return false;});return F;};var r=function(e,k,u){var S=e.name;var n;if(u){n=e.navprops[u];}if(n){S=n.to.entitySet;}return S;};var H=function(u){var U=[];var S=function(V){var j=V.indexOf("'");var m=V.indexOf("\"");if(j===-1&&m===-1){return null;}else{if(j>-1&&m===-1){return"appost";}if(m>-1&&j===-1){return"doublequotes";}if(j>-1&&m>-1&&j<m){return"appost";}if(j>-1&&m>-1&&m<j){return"doublequotes";}}};var e=function(p,P,m,n){var w=p[m];var j=m+1;while(j<p.length&&p[j].indexOf(n)===-1){w=w+"&"+p[j];j++;}w=w+"&"+p[j];P.push(w);m=j;return m;};for(var i=0;i<u.length;i++){if(!S(u[i])){U.push(u[i]);}if(S(u[i])==="appost"){var k=u[i].indexOf("'");if(u[i].indexOf("'",k+1)===-1){i=e(u,U,i,"'");}else{U.push(u[i]);}}if(S(u[i])==="doublequotes"){var l=u[i].indexOf("\"");if(u[i].indexOf("\"",l+1)===-1){i=e(u,U,i,"\"");}else{U.push(u[i]);}}}return U;};var c=function(x,T,k,u){k=k?decodeURIComponent(k):k;var e=JSON.parse(x.requestBody);if(e){var K={};if(k){K=t._parseKeys(k,t._mEntitySets[T]);}t._completeKey(t._mEntitySets[T],K,e);t._enhanceWithMetadata(t._mEntitySets[T],[e]);return e;}return null;};var R=[];R.push({method:"GET",path:new RegExp("\\$metadata([?#].*)?"),response:function(x){sap.ui.requireSync("jquery.sap.xml");L.debug("MockServer: incoming request for url: "+x.url);var m={"Content-Type":"application/xml;charset=utf-8"};h(x,m);x.respond(200,m,t._sMetadata);L.debug("MockServer: response sent with: 200, "+t._sMetadata);return true;}});R.push({method:"HEAD",path:new RegExp("$"),response:function(x){L.debug("MockServer: incoming request for url: "+x.url);var m={"Content-Type":"application/json;charset=utf-8"};h(x,m);x.respond(200,m);L.debug("MockServer: response sent with: 200");return true;}});R.push({method:"GET",path:new RegExp("$"),response:function(x){L.debug("MockServer: incoming request for url: "+x.url);var m={"Content-Type":"application/json;charset=utf-8"};h(x,m);var e=[];q.each(t._mEntitySets,function(E,j){e.push(E);});var i={EntitySets:e};x.respond(200,m,JSON.stringify({d:i}));L.debug("MockServer: response sent with: 200, "+JSON.stringify({d:i}));return true;}});R.push({method:"POST",path:new RegExp("\\$batch([?#].*)?"),response:function(x){L.debug("MockServer: incoming request for url: "+x.url);var e=function(b1){switch(b1.statusCode){case 200:return"200 OK";case 201:return"201 Created";case 204:return"204 No Content";case 400:return"400 Bad Request";case 401:return"401 Unauthorized";case 403:return"403 Forbidden";case 404:return"404 Not Found";case 405:return"405 Method Not Allowed";case 409:return"409 Conflict";case 412:return"412 Precondition Failed";case 415:return"415 Unsupported Media Type";case 500:return"500 Internal Server Error";case 501:return"501 Not Implemented";case 503:return"503 Service Unavailable";default:return b1.statusCode+" "+b1.status;}};var B=function(b1,c1){var d1;if(b1.success){d1=JSON.stringify(b1.data)||"";}else{d1=b1.errorResponse;}c1=c1||"application/json";if(b1.responseHeaders){return"HTTP/1.1 "+e(b1)+"\r\n"+b1.responseHeaders+"dataserviceversion: 2.0\r\n\r\n"+d1+"\r\n";}else{return"HTTP/1.1 "+e(b1)+"\r\nContent-Type: "+c1+"\r\nContent-Length: "+d1.length+"\r\ndataserviceversion: 2.0\r\n\r\n"+d1+"\r\n";}};var C=function(b1,V,c1,P,W){var d1;var e1=function(g1,h1,i1){d1={success:true,data:g1,status:h1,statusCode:i1&&i1.status,responseHeaders:i1&&i1.getAllResponseHeaders()};};var f1=function(g1,h1,i1){d1={success:false,data:undefined,status:h1,error:i1,statusCode:g1.status,errorResponse:g1.responseText,responseHeaders:g1&&g1.getAllResponseHeaders()};};q.ajax({type:c1,async:false,url:b1,headers:W,data:V,dataType:"json",success:e1,error:f1});if(d1.statusCode===400||d1.statusCode===404){var _=B(d1);throw new Error(_);}P.push(B(d1));};var l=function(b1,y){var c1;var d1;var e1=function(g1,h1,i1){c1={success:true,data:g1,status:h1,statusCode:i1&&i1.status,responseHeaders:i1&&i1.getAllResponseHeaders()};};var f1=function(g1,h1,i1){c1={success:false,data:undefined,status:h1,error:i1,statusCode:g1.status,errorResponse:g1.responseText,responseHeaders:g1&&g1.getAllResponseHeaders()};};q.ajax({async:false,url:b1,dataType:"json",success:e1,error:f1});var d1;if(b1.indexOf('$count')!==-1){d1=B(c1,"text/plain");}else{d1=B(c1);}y.push("\r\nContent-Type: application/http\r\n"+"Content-Length: "+d1.length+"\r\n"+"content-transfer-encoding: binary\r\n\r\n"+d1);};var p=function(U){var W={};U.split("HTTP/1.1")[1].split("{")[0].split("\n").forEach(function(b1){if(b1.indexOf(":")!==-1){var c1=b1.split(":");W[c1[0].trim()]=c1[1].trim();}});delete W["Content-Length"];return W;};var n=x.requestBody;var u=new RegExp("--batch_[a-z0-9-]*");var w=u.exec(n)[0];if(!!w){var y=[];var z=n.split(w);var S=x.url.split("$")[0];var E=new RegExp("PUT (.*) HTTP");var F=new RegExp("MERGE (.*) HTTP");var I=new RegExp("POST (.*) HTTP");var J=new RegExp("DELETE (.*) HTTP");var K=new RegExp("GET (.*) HTTP");for(var i=1;i<z.length-1;i++){var N=z[i];if(K.test(N)&&N.indexOf("multipart/mixed")===-1){if(E.test(N)||I.test(N)||J.test(N)){x.respond(400,null,"The Data Services Request could not be understood due to malformed syntax");L.debug("MockServer: response sent with: 400");return true;}l(S+K.exec(N)[1],y);}else{var O=q.extend(true,{},t._oMockdata);var P=[];var Q=N.substring(N.indexOf("boundary=")+9,N.indexOf("\r\n\r\n"));var T=N.split("--"+Q);try{for(var j=1;j<T.length-1;j++){var U=T[j];var V;if(K.test(U)){t._oMockdata=O;x.respond(400,null,"The Data Services Request could not be understood due to malformed syntax");L.debug("MockServer: response sent with: 400");return;}else{var V=U.substring(U.indexOf("{"),U.lastIndexOf("}")+1),W=p(U),X,Y;if(E.test(U)){Y="PUT";X=E.exec(U)[1];}else if(F.test(U)){Y="MERGE";X=F.exec(U)[1];}else if(I.test(U)){Y="POST";X=I.exec(U)[1];}else if(J.test(U)){Y="DELETE";V=undefined;X=J.exec(U)[1];}C(S+X,V,Y,P,W);}}var Z="\r\nContent-Type: multipart/mixed; boundary=ejjeeffe1\r\n\r\n--ejjeeffe1";for(var k=0;k<P.length;k++){Z+="\r\nContent-Type: application/http\r\n"+"Content-Length: "+P[k].length+"\r\n"+"content-transfer-encoding: binary\r\n\r\n"+P[k]+"--ejjeeffe1";}Z+="--\r\n";y.push(Z);}catch($){t._oMockdata=O;var _="\r\nContent-Type: application/http\r\n"+"Content-Length: "+$.message.length+"\r\n"+"content-transfer-encoding: binary\r\n\r\n"+$.message;y.push(_);}}}var a1="--ejjeeffe0";for(var m=0;m<y.length;m++){a1+=y[m]+"--ejjeeffe0";}a1+="--";var W={'Content-Type':"multipart/mixed; boundary=ejjeeffe0"};h(x,W);x.respond(202,W,a1);L.debug("MockServer: response sent with: 202, "+a1);}else{x.respond(202);}return true;}});q.each(this._mEntitySets,function(E,i){R.push({method:"GET",path:new RegExp("("+E+")/\\$count/?(.*)?"),response:function(x,E,u){L.debug("MockServer: incoming request for url: "+x.url);t.fireEvent(f.HTTPMETHOD.GET+E+":before",{oXhr:x,sUrlParams:u});t.fireEvent(f.HTTPMETHOD.GET+":before",{oXhr:x,sUrlParams:u});var m={"Content-Type":"text/plain;charset=utf-8"};h(x,m);try{var j=t._oMockdata[E];if(j){var F={results:q.extend(true,[],j)};if(u){var U=decodeURIComponent(u).replace("?","&").split("&");U=H(U);if(U.length>1){U=t._orderQueryOptions(U);}q.each(U,function(I,Q){t._applyQueryOnCollection(F,Q,E,U);});}t.fireEvent(f.HTTPMETHOD.GET+E+":after",{oXhr:x,oFilteredData:F});t.fireEvent(f.HTTPMETHOD.GET+":after",{oXhr:x,oFilteredData:F});x.respond(200,m,""+F.results.length);L.debug("MockServer: response sent with: 200, "+F.results.length);}else{t._logAndThrowMockServerCustomError(404,t._oErrorMessages.RESOURCE_NOT_FOUND);}}catch(e){if(e.error){x.respond(e.error.code,m,JSON.stringify(e));}else{L.error("MockServer: request failed due to invalid system query options value!");x.respond(parseInt(e.message||e.number));}}return true;}});R.push({method:"GET",path:new RegExp("("+E+")/?(\\?(.*))?"),response:function(x,E,u){L.debug("MockServer: incoming request for url: "+x.url);t.fireEvent(f.HTTPMETHOD.GET+E+":before",{oXhr:x,sUrlParams:u});t.fireEvent(f.HTTPMETHOD.GET+":before",{oXhr:x,sUrlParams:u});var m={"Content-Type":"application/json;charset=utf-8"};h(x,m);try{var j=t._oMockdata[E];if(j){var F={results:q.extend(true,[],j)};if(u){var U=decodeURIComponent(u).replace("?","&").split("&");U=H(U);if(U.length>1){U=t._orderQueryOptions(U);}q.each(U,function(I,Q){t._applyQueryOnCollection(F,Q,E,U);});}t.fireEvent(f.HTTPMETHOD.GET+E+":after",{oXhr:x,oFilteredData:F});t.fireEvent(f.HTTPMETHOD.GET+":after",{oXhr:x,oFilteredData:F});x.respond(200,m,JSON.stringify({d:F}));L.debug("MockServer: response sent with: 200, "+JSON.stringify({d:F}));}else{t._logAndThrowMockServerCustomError(404,t._oErrorMessages.RESOURCE_NOT_FOUND);}}catch(e){if(e.error){x.respond(e.error.code,m,JSON.stringify(e));}else{L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));x.respond(parseInt(e.message||e.number));}}return true;}});R.push({method:"GET",path:new RegExp("("+E+")\\(([^/\\?#]+)\\)/?(\\?(.*))?"),response:function(x,E,k,u){L.debug("MockServer: incoming request for url: "+x.url);t.fireEvent(f.HTTPMETHOD.GET+E+":before",{oXhr:x,sKeys:k,sUrlParams:u});t.fireEvent(f.HTTPMETHOD.GET+":before",{oXhr:x,sKeys:k,sUrlParams:u});var m={"Content-Type":"application/json;charset=utf-8"};try{var j=q.extend(true,{},G(E,k));if(!q.isEmptyObject(j)){if(u){var U=decodeURIComponent(u).replace("?","&").split("&");U=H(U);if(U.length>1){U=t._orderQueryOptions(U);}q.each(U,function(I,Q){j.entry=t._applyQueryOnEntry(j.entry,Q,E);});}t.fireEvent(f.HTTPMETHOD.GET+E+":after",{oXhr:x,oEntry:j.entry});t.fireEvent(f.HTTPMETHOD.GET+":after",{oXhr:x,oEntry:j.entry});x.respond(200,m,JSON.stringify({d:j.entry}));L.debug("MockServer: response sent with: 200, "+JSON.stringify({d:j.entry}));}else{t._logAndThrowMockServerCustomError(404,t._oErrorMessages.RESOURCE_NOT_FOUND);}}catch(e){if(e.error){x.respond(e.error.code,m,JSON.stringify(e));}else{L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));x.respond(parseInt(e.message||e.number));}}return true;}});q.each(i.navprops,function(n,N){R.push({method:"GET",path:new RegExp("("+E+")\\(([^/\\?#]+)\\)/("+n+")/\\$count/?(.*)?"),response:function(x,E,k,j,u){L.debug("MockServer: incoming request for url: "+x.url);t.fireEvent(f.HTTPMETHOD.GET+E+":before",{oXhr:x,sKeys:k,sNavProp:j,sUrlParams:u});t.fireEvent(f.HTTPMETHOD.GET+":before",{oXhr:x,sKeys:k,sNavProp:j,sUrlParams:u});var m={"Content-Type":"text/plain;charset=utf-8"};h(x,m);try{var l=G(E,k);if(l){var p,F={};p=t._resolveNavigation(E,l.entry,j);var w=t._mEntitySets[E].navprops[j].to.multiplicity;if(w==="*"){F={results:q.extend(true,[],p)};}else{F=q.extend(true,{},p[0]);}if(p&&p.length!==0){if(u){var U=decodeURIComponent(u).replace("?","&").split("&");U=H(U);if(U.length>1){U=t._orderQueryOptions(U);}if(w==="*"){q.each(U,function(I,Q){t._applyQueryOnCollection(F,Q,t._mEntitySets[E].navprops[j].to.entitySet,U);});}else{q.each(U,function(I,Q){F=t._applyQueryOnEntry(F,Q,t._mEntitySets[E].navprops[j].to.entitySet);});}}}t.fireEvent(f.HTTPMETHOD.GET+E+":after",{oXhr:x,oFilteredData:F});t.fireEvent(f.HTTPMETHOD.GET+":after",{oXhr:x,oFilteredData:F});F.results=F.results||[];x.respond(200,m,""+F.results.length);L.debug("MockServer: response sent with: 200, "+F.results.length);}else{t._logAndThrowMockServerCustomError(404,t._oErrorMessages.RESOURCE_NOT_FOUND);}}catch(e){if(e.error){x.respond(e.error.code,m,JSON.stringify(e));}else{L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));x.respond(parseInt(e.message||e.number));}}return true;}});R.push({method:"GET",path:new RegExp("("+E+")\\(([^/\\?#]+)\\)/("+n+")/?(\\?(.*))?"),response:function(x,E,k,j,u){L.debug("MockServer: incoming request for url: "+x.url);t.fireEvent(f.HTTPMETHOD.GET+E+":before",{oXhr:x,sKeys:k,sNavProp:j,sUrlParams:u});t.fireEvent(f.HTTPMETHOD.GET+":before",{oXhr:x,sKeys:k,sNavProp:j,sUrlParams:u});var m={"Content-Type":"application/json;charset=utf-8"};h(x,m);try{var l=G(E,k);if(l){var p,F={};p=t._resolveNavigation(E,l.entry,j,l.entry);var w=t._mEntitySets[E].navprops[j].to.multiplicity;if(w==="*"){F={results:q.extend(true,[],p)};}else{F=q.extend(true,{},p[0]);}if(p&&p.length!==0){if(u){var U=decodeURIComponent(u).replace("?","&").split("&");U=H(U);if(U.length>1){U=t._orderQueryOptions(U);}if(w==="*"){q.each(U,function(I,Q){t._applyQueryOnCollection(F,Q,t._mEntitySets[E].navprops[j].to.entitySet,U);});}else{q.each(U,function(I,Q){F=t._applyQueryOnEntry(F,Q,t._mEntitySets[E].navprops[j].to.entitySet);});}}}t.fireEvent(f.HTTPMETHOD.GET+E+":after",{oXhr:x,oFilteredData:F});t.fireEvent(f.HTTPMETHOD.GET+":after",{oXhr:x,oFilteredData:F});x.respond(200,m,JSON.stringify({d:F}));L.debug("MockServer: response sent with: 200, "+JSON.stringify({d:F}));}else{t._logAndThrowMockServerCustomError(404,t._oErrorMessages.RESOURCE_NOT_FOUND);}}catch(e){if(e.error){x.respond(e.error.code,m,JSON.stringify(e));}else{x.respond(parseInt(e.message||e.number));L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));}}return true;}});});R.push({method:"POST",path:new RegExp("("+E+")(\\(([^/\\?#]+)\\)/?(.*)?)?"),response:function(x,E,j,k,n){var m=false;if(x.requestHeaders["x-http-method"]==="MERGE"){m=true;}L.debug("MockServer: incoming create request for url: "+x.url);t.fireEvent(f.HTTPMETHOD.POST+E+":before",{oXhr:x,sKeys:k,sNavName:n});t.fireEvent(f.HTTPMETHOD.POST+":before",{oXhr:x,sKeys:k,sNavName:n});var l=null;var p=null;var u=405;try{if(k&&!k.split('=')[1]){k=t._mEntitySets[E].keys[0]+"="+k;}var T=r(i,decodeURIComponent(k),n);if(T){var w=c(x,T,k,n);if(w){p={"Content-Type":"application/json;charset=utf-8"};t.fireEvent(f.HTTPMETHOD.POST+E+":after",{oXhr:x,oEntity:w});t.fireEvent(f.HTTPMETHOD.POST+":after",{oXhr:x,oEntity:w});if(m){var y=G(E,k);if(y){q.extend(t._oMockdata[E][y.index],w);}u=204;}else{var U=t._getRootUri()+T+"("+t._createKeysString(t._mEntitySets[T],w)+")";l=JSON.stringify({d:w,uri:U});t._oMockdata[T]=t._oMockdata[T].concat([w]);u=201;}}}x.respond(u,p,l);L.debug("MockServer: response sent with: "+u+", "+l);}catch(e){if(e.error){var z={"Content-Type":"text/plain;charset=utf-8"};x.respond(e.error.code,z,JSON.stringify(e));}else{x.respond(parseInt(e.message||e.number));L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));}}return true;}});R.push({method:"PUT",path:new RegExp("("+E+")\\(([^/\\?#]+)\\)/?(.*)?"),response:function(x,E,k,n){L.debug("MockServer: incoming update request for url: "+x.url);t.fireEvent(f.HTTPMETHOD.PUT+E+":before",{oXhr:x,sKeys:k,sNavName:n});t.fireEvent(f.HTTPMETHOD.PUT+":before",{oXhr:x,sKeys:k,sNavName:n});var j=405;var l=null;var m=null;try{var T=r(i,decodeURIComponent(k),n);if(T){var p=c(x,T,k,n);if(p){m={"Content-Type":"application/json;charset=utf-8"};t.fireEvent(f.HTTPMETHOD.PUT+E+":after",{oXhr:x,oEntity:p});t.fireEvent(f.HTTPMETHOD.PUT+":after",{oXhr:x,oEntity:p});var u=G(E,k);if(u){t._oMockdata[E][u.index]=p;}j=204;}}x.respond(j,m,l);L.debug("MockServer: response sent with: "+j+", "+l);}catch(e){if(e.error){var w={"Content-Type":"text/plain;charset=utf-8"};x.respond(e.error.code,w,JSON.stringify(e));}else{x.respond(parseInt(e.message||e.number));L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));}}return true;}});R.push({method:"MERGE",path:new RegExp("("+E+")\\(([^/\\?#]+)\\)/?(.*)?"),response:function(x,E,k,n){L.debug("MockServer: incoming merge update request for url: "+x.url);t.fireEvent(f.HTTPMETHOD.MERGE+E+":before",{oXhr:x,sKeys:k,sNavName:n});t.fireEvent(f.HTTPMETHOD.MERGE+":before",{oXhr:x,sKeys:k,sNavName:n});var j=405;var l=null;var m=null;try{var T=r(i,decodeURIComponent(k),n);if(T){var p=c(x,T,k,n);if(p){m={"Content-Type":"application/json;charset=utf-8"};t.fireEvent(f.HTTPMETHOD.MERGE+E+":after",{oXhr:x,oEntity:p});t.fireEvent(f.HTTPMETHOD.MERGE+":after",{oXhr:x,oEntity:p});var u=G(E,k);if(u){q.extend(t._oMockdata[E][u.index],p);}j=204;}}x.respond(j,m,l);L.debug("MockServer: response sent with: "+j+", "+l);}catch(e){if(e.error){var w={"Content-Type":"text/plain;charset=utf-8"};x.respond(e.error.code,w,JSON.stringify(e));}else{x.respond(parseInt(e.message||e.number));L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));}}return true;}});R.push({method:"PATCH",path:new RegExp("("+E+")\\(([^/\\?#]+)\\)/?(.*)?"),response:function(x,E,k,n){L.debug("MockServer: incoming patch update request for url: "+x.url);t.fireEvent(f.HTTPMETHOD.PATCH+E+":before",{oXhr:x,sKeys:k,sNavName:n});t.fireEvent(f.HTTPMETHOD.PATCH+":before",{oXhr:x,sKeys:k,sNavName:n});var j=405;var l=null;var m=null;try{var T=r(i,decodeURIComponent(k),n);if(T){var p=c(x,T,k,n);if(p){m={"Content-Type":"application/json;charset=utf-8"};t.fireEvent(f.HTTPMETHOD.PATCH+E+":after",{oXhr:x,oEntity:p});t.fireEvent(f.HTTPMETHOD.PATCH+":after",{oXhr:x,oEntity:p});var u=G(E,k);if(u){q.extend(t._oMockdata[E][u.index],p);}j=204;}}x.respond(j,m,l);L.debug("MockServer: response sent with: "+j+", "+l);}catch(e){if(e.error){var w={"Content-Type":"text/plain;charset=utf-8"};x.respond(e.error.code,w,JSON.stringify(e));}else{x.respond(parseInt(e.message||e.number));L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));}}return true;}});R.push({method:"DELETE",path:new RegExp("("+E+")\\(([^/\\?#]+)\\)/?(.*)?"),response:function(x,E,k,u){L.debug("MockServer: incoming delete request for url: "+x.url);t.fireEvent(f.HTTPMETHOD.DELETE+E+":before",{oXhr:x});t.fireEvent(f.HTTPMETHOD.DELETE+":before",{oXhr:x});var j=204;try{var l=G(E,k);if(l){t._oMockdata[E].splice(l.index,1);}else{j=400;}t.fireEvent(f.HTTPMETHOD.DELETE+E+":after",{oXhr:x});t.fireEvent(f.HTTPMETHOD.DELETE+":after",{oXhr:x});x.respond(j,null,null);L.debug("MockServer: response sent with: "+j);}catch(e){if(e.error){var m={"Content-Type":"text/plain;charset=utf-8"};x.respond(e.error.code,m,JSON.stringify(e));}else{x.respond(parseInt(e.message||e.number));L.debug("MockServer: response sent with: "+parseInt(e.message||e.number));}}return true;}});});this.setRequests(R);};
f.prototype._orderQueryOptions=function(u){var F,i,s,t,o,S,e,a,b,c,O=[];var h=this;q.each(u,function(I,Q){var j=u.indexOf(Q);switch(Q.split('=')[0]){case"$top":t=j;break;case"$skip":s=j;break;case"$orderby":o=j;break;case"$expand":e=j;break;case"$filter":F=j;break;case"$select":S=j;break;case"$inlinecount":i=j;break;case"$format":a=j;break;case"search-focus":c=j;break;case"search":b=j;break;default:if(Q.split('=')[0].indexOf('$')===0){h._logAndThrowMockServerCustomError(400,h._oErrorMessages.IS_NOT_A_VALID_SYSTEM_QUERY_OPTION,Q.split('=')[0]);}}});if(e>=0){O.push(u[e]);}if(F>=0){O.push(u[F]);}if(c>=0){O.push(u[c]);}if(b>=0){O.push(u[b]);}if(i>=0){O.push(u[i]);}if(o>=0){O.push(u[o]);}if(s>=0){O.push(u[s]);}if(t>=0){O.push(u[t]);}if(S>=0){O.push(u[S]);}if(a>=0){O.push(u[a]);}return O;};
f.prototype._removeAllRequestHandlers=function(){var r=this.getRequests();var l=r.length;for(var i=0;i<l;i++){f._removeResponse(r[i].response);}};
f.prototype._removeAllFilters=function(){for(var i=0;i<this._aFilters.length;i++){f._removeFilter(this._aFilters[i]);}this._aFilters=null;};
f.prototype._addRequestHandler=function(m,p,r){m=m?m.toUpperCase():m;if(typeof m!=="string"){throw new Error("Error in request configuration: value of 'method' has to be a string");}if(!(typeof p==="string"||p instanceof RegExp)){throw new Error("Error in request configuration: value of 'path' has to be a string or a regular expression");}if(typeof r!=="function"){throw new Error("Error in request configuration: value of 'response' has to be a function");}var u=this._getRootUri();u=u&&new RegExp(this._escapeStringForRegExp(u));if(p&&!(p instanceof RegExp)){p=new RegExp(this._createRegExpPattern(p));}var R=this._createRegExp(u?u.source+p.source:p.source);this._addFilter(this._createFilter(m,R));this._oServer.respondWith(m,R,r);L.debug("MockServer: adding "+m+" request handler for pattern "+R);};
f.prototype._createRegExp=function(p){return new RegExp("^"+p+"$");};
f.prototype._createRegExpPattern=function(p){return p.replace(/:([\w\d]+)/g,"([^\/]+)");};
f.prototype._escapeStringForRegExp=function(s){return s.replace(/[\\\/\[\]\{\}\(\)\-\*\+\?\.\^\$\|]/g,"\\$&");};
f.prototype._trim=function(s){return s&&s.replace(/^\s+|\s+$/g,"");};
f.prototype._isValidNumber=function(s){return!isNaN(parseFloat(s))&&isFinite(s);};
f.prototype._getDateTime=function(s){if(!s){return;}return"datetime'"+new Date(Number(s.replace("/Date(",'').replace(")/",''))).toJSON().substring(0,19)+"'";};
f.prototype._getJsonDate=function(S){if(!S){return;}var n=function(s){var a=q.map(s.slice(0,-5).split(/\D/),function(i){return parseInt(i)||0;});a[1]-=1;a=new Date(Date.UTC.apply(Date,a));var o=s.slice(-5);var b=parseInt(o)/100;if(o.slice(0,1)==="+"){b*=-1;}a.setHours(a.getHours()+b);return a.getTime();};if(S.indexOf("datetimeoffset")>-1){return"/Date("+n(S.substring("datetimeoffset'".length,S.length-1))+")/";}else{return"/Date("+n(S.substring("datetime'".length,S.length-1))+")/";}};
f.prototype._addFilter=function(F){this._aFilters.push(F);f._addFilter(F);};
f.prototype._createFilter=function(r,R){return function(m,u,a,U,p){return r===m&&R.test(u);};};
f.prototype._logAndThrowMockServerCustomError=function(e,E,p){if(E.indexOf('##')>-1&&p){E=E.replace("##","'"+p+"'");}L.error("MockServer: "+E);throw{error:{code:e,message:{lang:"en",value:E}}};};
f.prototype.destroy=function(s){M.prototype.destroy.apply(this,arguments);this.stop();var S=f._aServers;var i=S.indexOf(this);S.splice(i,1);};
f._aFilters=[];f._oServer=null;f._aServers=[];
f._getInstance=function(){if(!this._oServer){this._oServer=window.sinon.fakeServer.create();this._oServer.autoRespond=true;}return this._oServer;};
f.config=function(c){var s=this._getInstance();s.autoRespond=c.autoRespond===false?false:true;s.autoRespondAfter=c.autoRespondAfter||0;s.fakeHTTPMethods=c.fakeHTTPMethods||false;};
f.respond=function(){this._getInstance().respond();};
f.startAll=function(){for(var i=0;i<this._aServers.length;i++){this._aServers[i].start();}};
f.stopAll=function(){for(var i=0;i<this._aServers.length;i++){this._aServers[i].stop();}this._getInstance().restore();this._oServer=null;};
f.destroyAll=function(){this.stopAll();for(var i=0;i<this._aServers.length;i++){this._aServers[i].destroy();}};
f.HTTPMETHOD={GET:"GET",POST:"POST",DELETE:"DELETE",PUT:"PUT",MERGE:"MERGE",PATCH:"PATCH"};
f._addFilter=function(F){this._aFilters.push(F);};
f._removeFilter=function(F){this._aFilters.splice(this._aFilters.indexOf(F),1);};
f._removeResponse=function(r){var R=this._oServer.responses;var l=R.length;for(var i=0;i<l;i++){if(R[i].response===r){R.splice(i,1);return true;}}return false;};
window.sinon.FakeXMLHttpRequest.useFilters=true;window.sinon.FakeXMLHttpRequest.addFilter(function(m,u,a,U,p){var F=f._aFilters;for(var i=0;i<F.length;i++){var b=F[i];if(b(m,u,a,U,p)){return false;}}return true;});var g=function(F){if(/.*\.json$/i.test(F)){return"JSON";}if(/.*\.xml$/i.test(F)){return"XML";}if(/.*metadata$/i.test(F)){return"XML";}return null;};
window.sinon.FakeXMLHttpRequest.prototype.respondFile=function(s,h,F){var r=q.sap.sjax({url:F,dataType:"text"});if(!r.success){throw new Error("Could not load file from: "+F);}var o=r.data;var m=g(F);if(this["respond"+m]){this["respond"+m](s,h,o);}else{this.respond(s,h,o);}};
window.sinon.FakeXMLHttpRequest.prototype.respondJSON=function(s,h,j){h=h||{};h["Content-Type"]=h["Content-Type"]||"application/json";this.respond(s,h,typeof j==="string"?j:JSON.stringify(j));};
window.sinon.FakeXMLHttpRequest.prototype.respondXML=function(s,h,x){h=h||{};h["Content-Type"]=h["Content-Type"]||"application/xml";this.respond(s,h,x);};
return f;});
sap.ui.predefine('sap/ui/core/util/MockServerAnnotationsHandler',['sap/ui/core/util/MockServer','sap/ui/model/odata/ODataModel'],function(M,O){"use strict";return{parse:function(m,s){if(!this._index){this._index=0;}var u="/annotationhandler"+this._index++ +"/";var o=new M({rootUri:u,requests:[{method:"GET",path:new RegExp("\\$metadata"),response:function(x){x.respond(200,{"Content-Type":"application/xml;charset=utf-8"},s);}}]});o.start();var a={annotationURI:[u+"$metadata"],json:true};var b=new O(u,a);var A=b.getServiceAnnotations();o.destroy();return A;}};},true);
sap.ui.predefine('sap/ui/core/util/PasteHelper',["sap/ui/core/Core","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/base/Log"],function(C,P,V,L){"use strict";var a={};
a.getPastedDataAs2DArray=function(e){var c=e.clipboardData;if(!c){c=window.clipboardData;}var r=/sapui5Placeholder4MultiLine/g;var p=r.source;var b=/""/g;var d,D,R,f=[];if(c){d=c.getData('Text');var g=[];var m=false;var h=d.indexOf("\""),k=-1;var l,n;while(h>-1){n=d.charAt(h-1);if((h===0)||(n==='\n')||(n==='\t')||(n==='\r')){k=d.indexOf("\"",h+1);if(k>-1){l=d.charAt(k+1);while((k>-1)&&(l==='\"')){k=d.indexOf("\"",k+2);l=d.charAt(k+1);}if((l==='\n')||(l==='\t')||(l==='')||(l==='\r')){var M=d.substring(h+1,k);d=d.replace("\""+M+"\"",p);M=M.replace(b,"\"");g.push(M);h=d.indexOf("\"",h+p.length+1);m=true;}}}if(!m){h=d.indexOf("\"",h+1);}m=false;}D=d.split(/\r\n|\r|\n/);var j=0;var G=function(){return g[j++];};for(var i=0;i<D.length;i++){R=D[i];if(g.length>0){R=R.replace(r,G);}if(R.length||i<D.length-1){f.push(R.split("\t"));}}}return f;};
a.parse=function(d,c){var r={parsedData:null,errors:null};if(!d){throw new Error("Parameter aData is not specified");}if(c){for(var i=0;i<c.length;i++){var o=c[i];if(o.ignore){continue;}if(o.property){if(o.type){var t=o.type;if(t.isA&&t.isA("sap.ui.model.SimpleType")){o.typeInstance=t;}else{throw new Error("Data type "+o.type+" is not an instance of any data type");}}else if(o.customParseFunction==undefined){throw new Error("Missing ColumnInfo.type or custom type parse function for column "+(i+1)+". Check the application calling PasteHelper.parse(aData, aColumnInfo) and specify the missing type in the parameter aColumnInfo.");}}else{throw new Error("Missing ColumnInfo.property for column "+(i+1)+". Check the application calling PasteHelper.parse(aData, aColumnInfo) and specify the missing property in the parameter aColumnInfo.");}}}else{throw new Error("Missing parameter aColumnInfo");}var e=[],R=[],b=C.getLibraryResourceBundle();var p=function(g,t){return t.parseValue(g,"string");};var v=function(g,t){return t.validateValue(g);};for(var i=0;i<d.length;i++){var f=d[i];var s=a._parseRow(f,c,i,p,v,b,e);R.push(s);}return Promise.all(R).then(function(g){if(e.length>0){r.parsedData=null;r.errors=e;}else{if(g){r.parsedData=g;}r.errors=null;}return r;});};
a._parseRow=function(r,c,R,p,v,b,e){var d=[],o={};for(var i=0;(i<c.length)&&(i<r.length);i++){var f=c[i];if(f.ignore){continue;}var s=r[i];if(!f.typeInstance){p=f.customParseFunction;v=function(){};}var S=a._parseCell(i,s,f,R,p,v,b,o,e);d.push(S);}return Promise.all(d).then(function(){return o;});};
a._parseCell=function(i,c,o,r,p,v,b,O,e){return Promise.resolve(c).then(function(d){return p(d,o.typeInstance);}).then(function(d){return Promise.all([d,v(d,o.typeInstance)]);}).then(function(R){O[o.property]=R[0];}).catch(function(E){if(E instanceof P||E instanceof V){var d={row:r+1,column:i+1,property:o.property,value:c,type:o.type,message:b.getText("PasteHelper.ErrorMessage",[c,r+1,i+1])+" "+E.message+"\n"};e.push(d);c=null;}else{L.error(E);}});};
return a;});
sap.ui.predefine('sap/ui/core/util/ResponsivePaddingsEnablement',["sap/ui/core/library","sap/base/Log",'sap/ui/core/ResizeHandler',"sap/ui/thirdparty/jquery"],function(l,L,R,q){"use strict";var B={S:599,M:1023,L:1439};var M={S:"sapUi-Std-PaddingS",M:"sapUi-Std-PaddingM",L:"sapUi-Std-PaddingL",XL:"sapUi-Std-PaddingXL"};var a=function(s){if(!this.isA||!this.isA("sap.ui.core.Control")){L.error("Responsive Paddings enablement could be applied over controls only");return;}this._initResponsivePaddingsEnablement=function(){this.addEventDelegate({onAfterRendering:b,onBeforeRendering:o},this);};function o(){c(this);}function b(){var S=e(this,s);if(S.length){window.requestAnimationFrame(function(){_(this);}.bind(this));}}function _(C){d(C);if(!C.__iResponsivePaddingsResizeHandlerId__){C.__iResponsivePaddingsResizeHandlerId__=R.register(C,d.bind(C,C));}}function c(C){if(C.__iResponsivePaddingsResizeHandlerId__){R.deregister(C.__iResponsivePaddingsResizeHandlerId__);C.__iResponsivePaddingsResizeHandlerId__=null;}}function d(C,E){var r=e(C,s);var $=f(C,r);var w=E?E.size.width:C.$().width();g($);h($,w);}function e(C,s){var S=i(s);S=S.filter(function(j){return C.hasStyleClass(j);});if(!S.length){return[];}S=S.map(function(j){return j.split("--")[1];});S=S.map(function(A){return s[A];}).filter(function(j){return j;});return S;}function f(C,S){var $=q();S.forEach(function(j){if(j.suffix){$=$.add(C.$(j.suffix));}if(j.selector){$=$.add(C.$().find(j.selector).first());}});return $;}function g($){var C=Object.keys(M).map(function(k){return M[k];});$.each(function(j,k){var m=q(k).control(0);if(k===m.getDomRef()){C.forEach(m.removeStyleClass.bind(m));}else{q(k).removeClass(C.join(" "));}});}function h($,w){var k;switch(true){case w<=B.S:k="S";break;case w<=B.M&&w>B.S:k="M";break;case w<=B.L&&w>B.M:k="L";break;default:k="XL";break;}$.each(function(j,m){var C=q(m).control(0);if(m===C.getDomRef()){C.addStyleClass(M[k]);}else{q(m).addClass(M[k]);}});}function i(s){return Object.keys(s).map(function(k){return"sapUiResponsivePadding--"+k;});}};return a;});
sap.ui.predefine('sap/ui/core/util/ShortcutHelper',['sap/ui/Device','sap/ui/events/jquery/EventExtension'],function(D){"use strict";var k={plus:"+",space:" "};var d=1.1;var s=d.toLocaleString().substring(1,2);var E={Win:"Meta",Scroll:"ScrollLock",Spacebar:" ",Down:"ArrowDown",Left:"ArrowLeft",Right:"ArrowRight",Up:"ArrowUp",Del:"Delete",Apps:"ContextMenu",Esc:"Escape",Multiply:"*",Decimal:s,OS:"Meta"};var m={"ctrl+l":"jump to address bar","ctrl+n":"new window, cannot be registered in Chrome","ctrl+shift+n":"new incognito window, cannot be registered in Chrome","ctrl+alt+shift+p":"UI5 Technical Info","ctrl+q":"quit Chrome in Mac","ctrl+alt+shift+s":"UI5 Support Popup","ctrl+t":"new tab, cannot be registered in Chrome","ctrl+shift+t":"reopen last tab, cannot be registered in Chrome","ctrl+w":"close tab, cannot be registered in Chrome","ctrl+shift+w":"close window, cannot be registered in Chrome","ctrl+0":"reset zoom","ctrl+-":"zoom out","ctrl++":"zoom in","ctrl+shift+=":"cannot be handled","tab":"TAB-based keyboard navigation","shift+tab":"TAB-based keyboard navigation","ctrl+tab":"cycling through tabs, cannot be registered in Chrome","ctrl+shift+tab":"cycling through tabs, cannot be registered in Chrome","ctrl+alt+delete":"nice try","ctrl+pageup":"cycling through tabs, cannot be registered in Chrome","ctrl+pagedown":"cycling through tabs, cannot be registered in Chrome","ctrl+alt+left":"cannot be handled in IE","ctrl+alt+right":"cannot be handled in IE","ctrl+f1":"always opens help menu in IE","ctrl+f4":"always closes tab in IE","f6":"F6-based group navigation","f11":"fullscreen, cannot be registered in Chrome","f12":"browser dev tools"};var l=false;document.addEventListener('keydown',function(e){try{if(e.keyCode===18){l=(typeof e.location!=="number"||e.location===1);return;}}catch(a){}});var S={findShortcut:function(o,n){var r=o.data("sap.ui.core.Shortcut");if(!r){return;}var M=r.filter(function(a){var b=a.shortcutSpec.key===n.key&&a.shortcutSpec.ctrlKey===n.ctrlKey&&a.shortcutSpec.altKey===n.altKey&&a.shortcutSpec.shiftKey===n.shiftKey&&a.shortcutSpec.metaKey===n.metaKey;return b;});return M[0];},getNormalizedShortcutSpec:function(v){var n;if(typeof v==="string"){n=S.parseShortcut(v);}else{var a=v.key;var V=/^([a-z0-9\.,\-\*\/= +]|Tab|Enter|Backspace|Home|Delete|End|Pageup|Pagedown|ArrowUp|ArrowDown|ArrowLeft|ArrowRight|Escape|F[1-9]|F1[0-2])$/i.test(a);if(!V){throw new Error("Shortcut key '"+a+"' is not a valid shortcut key. It must match /^([a-z0-9\.,\-\*\/= +]|Tab|Enter|Backspace|Home|Delete|End|Pageup|Pagedown|ArrowUp|ArrowDown|ArrowLeft|ArrowRight|Escape|F[1-9]|F1[0-2])$/i");}n={key:S.translateRegisteredKeyToStandard(a).toLowerCase(),ctrlKey:D.os.macintosh?false:!!v.ctrl,ctrlRequested:v.ctrl,altKey:!!v.alt,shiftKey:!!v.shift,metaKey:D.os.macintosh?!!v.ctrl:false};}return n;},parseShortcut:function(a){this.validateShortcutString(a);var p=a.toLowerCase().split("+");return{key:S.translateRegisteredKeyToStandard(p.pop()),ctrlKey:D.os.macintosh?false:p.indexOf("ctrl")>-1,ctrlRequested:p.indexOf("ctrl")>-1,altKey:p.indexOf("alt")>-1,shiftKey:p.indexOf("shift")>-1,metaKey:D.os.macintosh?p.indexOf("ctrl")>-1:false};},translateRegisteredKeyToStandard:function(K){return k.hasOwnProperty(K)?k[K]:K;},validateShortcutString:function(a){var v=/^((Ctrl|Shift|Alt)\+){0,3}([a-z0-9\.,\-\*\/=]|Plus|Tab|Space|Enter|Backspace|Home|Delete|End|Pageup|Pagedown|Escape|ArrowUp|ArrowDown|ArrowLeft|ArrowRight|F[1-9]|F1[0-2])$/i.test(a);if(!v){throw new Error("Shortcut '"+a+"' is not a valid shortcut string. It must be a '+'-separated list of modifier keys and the actual key, like 'Ctrl+Alt+S'. Or more generally, it must match the expression /^((Ctrl|Shift|Alt)\+){0,3}([a-z0-9\.,\-\*\/=]|Plus|Tab|Space|Enter|Backspace|Home|Delete|End|Pageup|Pagedown|ArrowUp|ArrowDown|ArrowLeft|ArrowRight|Escape|F[1-9]|F1[0-2])$/i.");}},validateKeyCombination:function(n){var N=n.ctrlRequested?"ctrl+":"";N+=n.altKey?"alt+":"";N+=n.shiftKey?"shift+":"";N+=n.key;if(m[N]){throw new Error("Registering the shortcut '"+N+"' is not allowed ("+m[N]+").");}if([".",",","-","+","=","*","/"].indexOf(n.key)>-1&&N.indexOf("shift")>-1){throw new Error("Registering the shortcut '"+N+"' is not allowed because the 'Shift' modifier changes the meaning of the "+n.key+" key on many keyboards.");}},getNormalizedShortcutString:function(n){var N=n.ctrlRequested?"ctrl+":"";N+=n.altKey?"alt+":"";N+=n.shiftKey?"shift+":"";N+=n.key;return N;},shortcutMayBeUsedHere:function(o,a){var t=a.tagName.toLowerCase();if((t==="input"||t==="textarea")&&o.key.includes("arrow")){return false;}return true;},handleKeydown:function(o,O,c,e){if(e.key==="Control"||e.key==="Shift"||e.key==="Alt"||e.key==="AltGraph"||e.key==="Meta"){return;}if(e.isMarked()){return;}if(e.altKey&&!l){return;}var a=E.hasOwnProperty(e.key)?E[e.key]:e.key;a=a.toLowerCase();if(a!==o.key||e.ctrlKey!==o.ctrlKey||e.altKey!==o.altKey||e.shiftKey!==o.shiftKey||e.metaKey!==o.metaKey){return;}if(!S.shortcutMayBeUsedHere(o,e.target||e.srcElement)){return;}e.preventDefault();e.setMarked();e.stopPropagation();var b={registeredShortcut:O,originalBrowserEvent:e.originalEvent||e};c(b);}};return S;});
sap.ui.predefine('sap/ui/core/util/XMLPreprocessor',["sap/base/Log","sap/base/util/deepExtend","sap/base/util/JSTokenizer","sap/base/util/ObjectPath","sap/ui/base/BindingParser","sap/ui/base/ManagedObject","sap/ui/base/SyncPromise","sap/ui/core/XMLTemplateProcessor","sap/ui/model/BindingMode","sap/ui/model/CompositeBinding","sap/ui/model/Context","sap/ui/performance/Measurement"],function(L,d,J,O,B,M,S,X,a,C,b,c){"use strict";var N="http://schemas.sap.com/sapui5/extension/sap.ui.core.template/1",x="sap.ui.core.util.XMLPreprocessor",p=[x],P=x+"/getResolvedBinding",s=x+"/insertFragment",f=x+".process",o=S.resolve(),g=S.resolve(true),t=Object.prototype.toString,v={},W=M.extend("sap.ui.core.util._with",{metadata:{properties:{any:"any"},aggregations:{child:{multiple:false,type:"sap.ui.core.util._with"}}},updateProperty:function(){this.setAny(this.mBindingInfos.any.binding.getExternalValue());}}),R=W.extend("sap.ui.core.util._repeat",{metadata:{aggregations:{list:{multiple:true,type:"n/a",_doesNotRequireFactory:true}}},updateList:function(){}});
function h(w,e,i,n){function q(u){if(!n){n=w.getBinding("any");if(n instanceof C){n=n.getBindings();if(i!==undefined){n=n[i];}}}return Array.isArray(n)?n[u]:n;}function r(u){return u instanceof b?u.getPath():u.getModel().resolve(u.getPath(),u.getContext());}return{getInterface:function(u,y){var z,A,D;if(typeof u==="string"){y=u;u=undefined;}q();if(Array.isArray(n)){if(u>=0&&u<n.length){A=n[u];}else{throw new Error("Invalid index of part: "+u);}}else if(u!==undefined){throw new Error("Not the root formatter of a composite binding");}else if(y){A=n;}else{throw new Error("Missing path");}if(y){D=A.getModel();if(y.charAt(0)!=='/'){z=A instanceof b?A:D.createBindingContext(A.getPath(),A.getContext());}A=D.createBindingContext(y,z);if(!A){throw new Error("Model could not create binding context synchronously: "+D);}}return h(null,e,undefined,A);},getModel:function(u){var y=q(u);return y&&y.getModel();},getPath:function(u){var y=q(u);return y&&r(y);},getSetting:function(u){if(u==="bindingContexts"||u==="models"){throw new Error("Illegal argument: "+u);}return e[u];}};}
function j(w,n,q,r,A){var V=false;function u(I,i){var F=I.formatter,y,z=I.model;if(I.path&&I.path.indexOf(">")>0){z=I.path.slice(0,I.path.indexOf(">"));}y=w.getModel(z);if(F&&F.requiresIContext===true){F=I.formatter=F.bind(null,h(w,q,i));}if(F&&A&&(y&&y.$$valueAsPromise||i===undefined&&V)){I.formatter=function(){var D=this;return S.all(arguments).then(function(E){return F.apply(D,E);});};I.formatter.textFragments=F.textFragments;}I.mode=a.OneTime;I.parameters=I.parameters||{};I.parameters.scope=r;if(A&&y&&y.$$valueAsPromise){V=I.parameters.$$valueAsPromise=true;}}try{if(n.parts){n.parts.forEach(u);}u(n);w.bindProperty("any",n);return w.getBinding("any")?S.resolve(w.getAny()):null;}catch(e){return S.reject(e);}finally{w.unbindProperty("any",true);}}
function k(e,n){var i=-1;function q(F){if(F){return e[i];}i+=1;if(i<e.length){return n(e[i],i,e).then(q);}}return e.length?q():o;}
function l(e){var A,q=e.attributes,T="<"+e.nodeName,i,n;for(i=0,n=q.length;i<n;i+=1){A=q.item(i);T+=" "+A.name+'="'+A.value+'"';}return T+(e.childNodes.length?">":"/>");}
function m(e,i){return i.visitNode(e);}
return{plugIn:function(V,n,e){var i=v[n];if(V!==null&&typeof V!=="function"||V===m){throw new Error("Invalid visitor: "+V);}if(!n||n===N||n==="sap.ui.core"||n.indexOf(" ")>=0){throw new Error("Invalid namespace: "+n);}L.debug("Plug-in visitor for namespace '"+n+"', local name '"+e+"'",V,x);if(e){n=n+" "+e;i=v[n]||i;}v[n]=V;return i||m;},visitNodeWrapper:m,process:function(r,V,q){var u=V.caller,D=L.isLoggable(L.Level.DEBUG,x),w=D,y=V.name,F={},z,A=0,E={},G=V._supportInfo,H=L.isLoggable(L.Level.WARNING,x);function I(i){return{find:function(n,p1){try{return S.resolve(k(n,p1));}catch(e){return S.reject(e);}},getContext:function(e){var n,p1,q1;e=e||"";if(e[0]==="{"){throw new Error("Must be a simple path, not a binding: "+e);}n=B.simpleParser("{"+e+"}");p1=i.getModel(n.model);if(!p1){throw new Error("Unknown model '"+n.model+"': "+e);}q1=p1.resolve(n.path,i.getBindingContext(n.model));if(!q1){throw new Error("Cannot resolve path: "+e);}return p1.createBindingContext(q1);},getResult:function(e,n){return $(e,n,i,true);},getSettings:function(){return q;},getViewInfo:function(){return d({},V);},insertFragment:function(e,n){return _(e,n,i);},visitAttribute:function(e,n){return k1(e,n,i);},visitAttributes:function(e){return l1(e,i);},visitChildNodes:function(n){return m1(n,i);},visitNode:function(n){try{return n1(n,i);}catch(e){return S.reject(e);}},"with":function(e,n){var p1,q1=false,z,r1=new W();if(!n){i.setChild(r1);}for(z in e){p1=e[z];q1=true;r1.setModel(p1.getModel(),z);r1.bindObject({model:z,path:p1.getPath()});}return q1||n?I(r1):this;}};}function K(e){if(D){L.debug(Y()+Array.prototype.slice.call(arguments,1).join(" "),e&&l(e),x);}}function Q(e){if(D){L.debug(Y()+"Finished","</"+e.nodeName+">",x);}}function T(e,i){e=e+l(i);L.error(e,u,x);throw new Error(u+": "+e);}function U(e){var p1,q1=Array.prototype.filter.call(e.childNodes,s1),i,n,r1=false;function s1(u1){return u1.nodeType===1;}function t1(u1,v1){return u1.namespaceURI===N&&u1.localName===v1;}if(!q1.length||!t1(q1[0],"then")){return null;}for(i=1,n=q1.length;i<n;i+=1){p1=q1[i];if(r1){T("Expected </"+e.prefix+":if>, but instead saw ",p1);}if(t1(p1,"else")){r1=true;}else if(!t1(p1,"elseif")){T("Expected <"+e.prefix+":elseif> or <"+e.prefix+":else>, but instead saw ",q1[i]);}}return q1;}function Y(){return(A<10?"[ ":"[")+A+"] ";}function Z(z){return z&&z.charAt(0)==="."?O.get(z.slice(1),E):O.get(z||"",E)||O.get(z||"");}function $(i,n,p1,q1,r1){var s1,t1;c.average(P,"",p);try{s1=B.complexParser(i,E,q1,true,true,true)||i;}catch(e){return S.reject(e);}if(s1.functionsNotFound){if(q1){o1(n,'Function name(s)',s1.functionsNotFound.join(", "),'not found');}c.end(P);return null;}if(typeof s1==="object"){t1=j(p1,s1,q,E,!V.sync);if(q1&&!t1){o1(n,'Binding not ready');}else if(V.sync&&t1&&t1.isPending()){T("Async formatter in sync view in "+i+" of ",n);}}else{t1=S.resolve(s1);if(r1){r1();}}c.end(P);return t1;}function _(e,i,n){var p1,q1=V.sync?X.loadTemplate:X.loadTemplatePromise,r1=y;n.$mFragmentContexts=n.$mFragmentContexts||{};if(n.$mFragmentContexts[e]){T("Cyclic reference to fragment '"+e+"' ",i);}A++;K(i,"fragmentName =",e);n.$mFragmentContexts[e]=true;y=e;c.average(s,"",p);p1=F[e];if(!p1){F[e]=p1=S.resolve(q1(e,"fragment"));}return p1.then(function(s1){s1=i.ownerDocument.importNode(s1,true);c.end(s);return c1(s1).then(function(){if(s1.namespaceURI==="sap.ui.core"&&s1.localName==="FragmentDefinition"){return a1(s1,n,i);}i.parentNode.insertBefore(s1,i);return n1(s1,n);});}).then(function(){i.parentNode.removeChild(i);y=r1;n.$mFragmentContexts[e]=false;Q(i);A-=1;});}function a1(e,i,n){return m1(e,i).then(function(){var p1;n=n||e;while((p1=e.firstChild)){n.parentNode.insertBefore(p1,n);}});}function b1(e,i){var n=o1.bind(null,e,'Constant test condition'),p1=$(e.getAttribute("test"),e,i,true,n)||S.resolve(false);return p1.catch(function(ex){o1(e,'Error in formatter:',ex);}).then(function(q1){var r1=!!q1&&q1!=="false";if(D){if(typeof q1==="string"){q1=JSON.stringify(q1);}else if(q1===undefined){q1="undefined";}else if(Array.isArray(q1)){q1="[object Array]";}K(e,"test ==",q1,"-->",r1);}return r1;});}function c1(e){var n={},p1=e.getAttributeNodeNS(N,"require"),q1,r1;function s1(){return new S(function(i,t1){var u1=r1.map(sap.ui.require);if(u1.every(Boolean)){i(u1);}else{sap.ui.require(r1,function(){i(arguments);},t1);}}).then(function(t1){Object.keys(n).forEach(function(u1,i){E[u1]=t1[i];});});}if(p1&&p1.value){q1=p1.value;e.removeAttributeNode(p1);if(q1[0]==="{"){n=J.parseJS(q1);r1=Object.keys(n).map(function(i){return n[i];});return s1();}r1=q1.split(" ").map(function(i){return i.replace(/\./g,"/");});if(!V.sync){return s1();}r1.forEach(sap.ui.requireSync);}return o;}function d1(e,i,n){var p1=$(i.value,e,n,false);if(!p1){K(e,'Binding not ready for attribute',i.name);return o;}return p1.then(function(q1){if(q1===undefined){K(e,"Removed attribute",i.name);e.removeAttributeNode(i);}else if(q1!==i.value){switch(typeof q1){case"boolean":case"number":case"string":K(e,i.name,"=",q1);i.value=q1;break;default:K(e,"Ignoring",t.call(q1),"value for attribute",i.name);}}},function(q1){K(e,"Error in formatter of attribute",i.name,q1);});}function e1(e,i){var z=e.getAttribute("name"),n,p1,q1=e.getAttribute("value");if(z&&z[0]==="."){z=z.slice(1);}if(!z||z.includes(".")){T("Missing proper relative name in ",e);}n=Z(q1);if(!n){T("Invalid value in ",e);}p1=E[z];E[z]=n;return a1(e,i).then(function(){e.parentNode.removeChild(e);E[z]=p1;});}function f1(e,i){var n=e.getAttribute("name"),p1=$(n,e,i,true);if(!p1){return g;}return p1.then(function(z){var q1=sap.ui.require("sap/ui/core/CustomizingConfiguration"),r1;if(z!==n){K(e,"name =",z);}if(q1){r1=q1.getViewExtension(y,z,V.componentId);if(r1&&r1.className==="sap.ui.core.Fragment"&&r1.type==="XML"){return _(r1.fragmentName,e,i);}}return true;},function(ex){o1(e,'Error in formatter:',ex);return true;});}function g1(e,i){var n=e.getAttribute("fragmentName"),p1=$(n,e,i,true);if(!p1){return o;}return p1.then(function(n){var q1=E;E=Object.create(E);return _(n,e,i).then(function(){E=q1;});},function(ex){o1(e,'Error in formatter:',ex);});}function h1(i,e){A++;return k(U(i)||[i],function(n){if(n.localName==="else"){return g;}if(n.localName==="then"){n=i;}return b1(n,e);}).then(function(n){return(n?a1(n,e,i):o).then(function(){i.parentNode.removeChild(i);Q(i);A-=1;});});}function i1(e,n){var p1=e.getAttribute("list")||"",q1=B.complexParser(p1,E,false,true,true,true),r1,s1,t1,u1,v1,w1=e.getAttribute("var");if(w1===""){T("Missing variable name for ",e);}if(!q1){T("Missing binding for ",e);}if(q1.functionsNotFound){o1(e,'Function name(s)',q1.functionsNotFound.join(", "),'not found');}u1=new R();n.setChild(u1);q1.mode=a.OneTime;u1.bindAggregation("list",q1);s1=u1.getBinding("list");u1.unbindAggregation("list",true);t1=q1.model;if(!s1){T("Missing model '"+t1+"' in ",e);}s1.enableExtendedChangeDetection();r1=s1.getContexts(q1.startIndex,q1.length||Infinity);if(!V.sync&&r1.dataRequested){v1=new S(function(i){s1.attachEventOnce("change",i);}).then(function(){return s1.getContexts(q1.startIndex,q1.length);});}else{v1=S.resolve(r1);}w1=w1||t1;u1.setModel(s1.getModel(),w1);A++;K(e,"Starting");return v1.then(function(r1){return k(r1,function(x1,i){var y1=(i===r1.length-1)?e:e.cloneNode(true);u1.setBindingContext(x1,w1);K(e,w1,"=",x1.getPath());return a1(y1,u1,e);}).then(function(){Q(e);A-=1;e.parentNode.removeChild(e);});});}function j1(e,i){var n,p1,q1,r1,s1=e.getAttribute("helper"),t1,u1=e.getAttribute("path"),v1,w1,x1=e.getAttribute("var");if(x1===""){T("Missing variable name for ",e);}q1=new W();i.setChild(q1);n=B.simpleParser("{"+u1+"}");x1=x1||n.model;if(s1||x1){p1=i.getModel(n.model);if(!p1){T("Missing model '"+n.model+"' in ",e);}w1=p1.resolve(n.path,i.getBindingContext(n.model));if(!w1){T("Cannot resolve path for ",e);}t1=p1.createBindingContext(w1);if(s1){r1=Z(s1);if(typeof r1!=="function"){T("Cannot resolve helper for ",e);}t1=r1(t1);}v1=S.resolve(t1);if(V.sync&&v1.isPending()){T("Async helper in sync view in ",e);}v1=v1.then(function(t1){if(t1 instanceof b){p1=t1.getModel();w1=t1.getPath();}else if(t1!==undefined){if(typeof t1!=="string"||t1===""){T("Illegal helper result '"+t1+"' in ",e);}w1=t1;}q1.setModel(p1,x1);q1.bindObject({model:x1,path:w1});});}else{w1=u1;q1.bindObject(w1);v1=o;}return v1.then(function(){A++;K(e,x1,"=",w1);if(q1.getBindingContext(x1)===i.getBindingContext(x1)){o1(e,'Set unchanged path:',w1);q1=i;}return a1(e,q1).then(function(){e.parentNode.removeChild(e);Q(e);A-=1;});});}function k1(e,i,n){if(G){G({context:undefined,env:{caller:"visitAttribute",before:{name:i.name,value:i.value}}});}return d1(e,i,n).then(function(){if(G){G({context:undefined,env:{caller:"visitAttribute",after:{name:i.name,value:i.value}}});}});}function l1(e,i){function n(p1,q1){return p1.name.localeCompare(q1.name);}return k(Array.prototype.slice.apply(e.attributes).sort(n),function(p1){return k1(e,p1,i);});}function m1(n,e){return k(Array.prototype.slice.apply(n.childNodes),function(i){return n1(i,e);});}function n1(n,e){var i;function p1(){return l1(n,e).then(function(){return m1(n,e);}).then(function(){if(G){G({context:n,env:{caller:"visitNode",after:{name:n.tagName}}});}});}if(n.nodeType!==1){return o;}if(G){G({context:n,env:{caller:"visitNode",before:{name:n.tagName}}});}if(n.namespaceURI===N){switch(n.localName){case"alias":return e1(n,e);case"if":return h1(n,e);case"repeat":return i1(n,e);case"with":return j1(n,e);default:T("Unexpected tag ",n);}}else if(n.namespaceURI==="sap.ui.core"){switch(n.localName){case"ExtensionPoint":return f1(n,e).then(function(q1){if(q1){return p1();}});case"Fragment":if(n.getAttribute("type")==="XML"){return g1(n,e);}break;}}else{i=v[n.namespaceURI+" "+n.localName]||v[n.namespaceURI];if(i){A++;K(n,"Calling visitor");return i(n,I(e)).then(function(q1){if(q1!==undefined){T("Unexpected return value from visitor for ",n);}Q(n);A-=1;});}}return p1();}function o1(e){if(H){if(!w){w=true;L.warning("Warning(s) during processing of "+u,null,x);}L.warning(Y()+Array.prototype.slice.call(arguments,1).join(" "),e&&l(e),x);}}c.average(f,"",p);q=q||{};if(D){K(undefined,"Start processing",u);if(q.bindingContexts instanceof b){K(undefined,"undefined =",q.bindingContexts);}else{for(z in q.bindingContexts){K(undefined,z,"=",q.bindingContexts[z]);}}}if(G){G({context:r,env:{caller:"view",viewinfo:d({},V),settings:d({},q),clone:r.cloneNode(true),type:"template"}});}return c1(r).then(function(){return n1(r,new W({models:q.models,bindingContexts:q.bindingContexts}));}).then(function(){K(undefined,"Finished processing",u);c.end(f);return r;}).unwrap();}};},true);
sap.ui.predefine('sap/ui/core/util/reflection/BaseTreeModifier',["sap/ui/base/ManagedObject","sap/ui/base/ManagedObjectMetadata","sap/base/util/ObjectPath","sap/ui/util/XMLHelper","sap/ui/core/XMLTemplateProcessor","sap/ui/core/util/XMLPreprocessor","sap/base/util/isPlainObject","sap/base/Log"],function(M,a,O,X,b,c,d,L){"use strict";return{bySelector:function(s,A,v){var C;if(s&&s.name){v=v||this.bySelector(s.viewSelector,A);var e=this.getExtensionPointInfo(s.name,v);return e?e.parent:undefined;}C=this.getControlIdBySelector(s,A);return this._byId(C,v);},getControlIdBySelector:function(s,A){if(!s){return undefined;}if(typeof s==="string"){s={id:s};}var C=s.id;if(s.idIsLocal){if(A){C=A.createId(C);}else{throw new Error("App Component instance needed to get a control's ID from selector");}}return C;},getSelector:function(C,A,m){var s=C;if(typeof s!=="string"){s=(C)?this.getId(C):undefined;}else if(!A){throw new Error("App Component instance needed to get a selector from string ID");}if(m&&(m.id||m.idIsLocal)){throw new Error("A selector of control with the ID '"+s+"' was requested, "+"but core properties were overwritten by the additionally passed information.");}var v=this.checkControlId(s,A);if(!v){throw new Error("Generated ID attribute found - to offer flexibility a stable control ID is needed to assign the changes to, but for this control the ID was generated by SAPUI5 "+s);}var S=Object.assign({},m,{id:"",idIsLocal:false});if(this.hasLocalIdSuffix(s,A)){var l=A.getLocalId(s);S.id=l;S.idIsLocal=true;}else{S.id=s;}return S;},checkControlId:function(C,A){var s=C instanceof M?C.getId():C;var i=a.isGeneratedId(s);return!i||this.hasLocalIdSuffix(C,A);},hasLocalIdSuffix:function(C,A){var s=(C instanceof M)?C.getId():C;if(!A){L.error("Determination of a local ID suffix failed due to missing app component for "+s);return false;}return!!A.getLocalId(s);},_checkAndPrefixIdsInFragment:function(f,I){var p=X.getParseError(f);if(p.errorCode!==0){throw new Error(f.parseError.reason);}var C=f.documentElement;var r=[],e=[];if(C.localName==="FragmentDefinition"){r=this._getElementNodeChildren(C);}else{r=[C];}e=[].concat(r);function o(g){e.push(g);}for(var i=0,n=r.length;i<n;i++){this._traverseXmlTree(o,r[i]);}for(var j=0,m=e.length;j<m;j++){if(e[j].getAttribute("id")){e[j].setAttribute("id",I+"."+e[j].getAttribute("id"));}else{throw new Error("At least one control does not have a stable ID");}}return C;},_getElementNodeChildren:function(N){var C=[];var e=N.childNodes;for(var i=0,n=e.length;i<n;i++){if(e[i].nodeType===1){C.push(e[i]);}}return C;},_isInstanceOf:function(e,t){var i=O.get(t);if(typeof i==="function"){return e instanceof i;}else{return false;}},_hasInterface:function(e,i){var I=e.getMetadata().getInterfaces();return I.indexOf(i)!==-1;},_getControlMetadataInXml:function(C){var s=this._getControlTypeInXml(C);jQuery.sap.require(s);var e=O.get(s);return e.getMetadata();},getControlMetadata:function(C){},getLibraryName:function(C){var m=this.getControlMetadata(C);return m.getLibraryName();},_getControlTypeInXml:function(C){var s=C.namespaceURI;s=s?s+".":"";s+=C.localName;return s;},_traverseXmlTree:function(C,r){function e(p,o,i){var A;if(!i){var m=this._getControlMetadataInXml(o);A=m.getAllAggregations();}var f=this._getElementNodeChildren(o);f.forEach(function(g){var I=A&&A[g.localName];e.call(this,o,g,I);if(!I){C(g);}}.bind(this));}e.call(this,r,r,false);},_getSerializedValue:function(p){if(this._isSerializable(p)&&typeof p!=="string"){return JSON.stringify(p);}return p;},_isSerializable:function(p){return d(p)||Array.isArray(p)||Object(p)!==p;},_escapeCurlyBracketsInString:function(p){return typeof p==="string"?p.replace(/({|})/g,"\\$&"):p;},_templateFragment:function(f,p){return Promise.resolve(c.process(b.loadTemplate(f,"fragment"),{name:f},p));},getPropertyBindingOrProperty:function(C,p){return this.getPropertyBinding(C,p)||this.getProperty(C,p);},setPropertyBindingOrProperty:function(C,p,B){var i=B&&(B.path||B.parts);var I=B&&typeof B==="string"&&B.substring(0,1)==="{"&&B.slice(-1)==="}";var o=i||I?"setPropertyBinding":"setProperty";this[o](C,p,B);},setVisible:function(C,v){},getVisible:function(C){},setStashed:function(C,s){},getStashed:function(C){},bindProperty:function(C,p,B){},unbindProperty:function(C,p){},bindAggregation:function(C,A,B){},unbindAggregation:function(C,A){},setProperty:function(C,p,P){},getProperty:function(C,p){},isPropertyInitial:function(C,p){},setPropertyBinding:function(C,p,P){},getPropertyBinding:function(C,p){},createControl:function(C,A,v,s,S,e){},applySettings:function(C,s){},_byId:function(i,v){},getId:function(C){},getParent:function(C){},getControlType:function(C){},setAssociation:function(p,n,i){},getAssociation:function(p,n){},getAllAggregations:function(C){},getAggregation:function(p,n){},insertAggregation:function(p,A,o,i,v){},removeAggregation:function(p,A,o){},removeAllAggregation:function(p,A){},getBindingTemplate:function(C,A){},updateAggregation:function(p,A){},findIndexInParentAggregation:function(C){},getParentAggregationName:function(C,p){},validateType:function(C,A,p,f,i){},instantiateFragment:function(f,n,v){},templateControlFragment:function(f,p,v){},destroy:function(C){},getChangeHandlerModulePath:function(C){return this._getFlexCustomData(C,"flexibility");},_getFlexCustomData:function(C){},getFlexDelegate:function(C){var D;var s=this._getFlexCustomData(C,"delegate");if(typeof s==="string"){try{D=JSON.parse(s);if(D.payload===undefined){D.payload={};}}catch(e){L.error("Flex Delegate for control "+this.getId(C)+" is malformed",e.message);}}return D;},attachEvent:function(o,e,f,D){},detachEvent:function(o,e,f){},getExtensionPointInfo:function(e,v){}};});
sap.ui.predefine('sap/ui/core/util/reflection/JsControlTreeModifier',["./BaseTreeModifier","./XmlTreeModifier","sap/base/util/ObjectPath","sap/ui/util/XMLHelper","sap/ui/core/Component","sap/base/util/merge","sap/ui/core/Fragment"],function(B,X,O,a,C,m,F){"use strict";var J={targets:"jsControlTree",setVisible:function(c,v){if(c.setVisible){this.unbindProperty(c,"visible");c.setVisible(v);}else{throw new Error("Provided control instance has no setVisible method");}},getVisible:function(c){if(c.getVisible){return c.getVisible();}else{throw new Error("Provided control instance has no getVisible method");}},setStashed:function(c,s,A){s=!!s;if(c.setStashed){var u;if(c.getStashed()===true&&s===false){c.setStashed(s);if(A instanceof C){u=this.bySelector(this.getSelector(c,A),A);}}if((u||c)["setVisible"]){this.setVisible(u||c,!s);}return u;}else{throw new Error("Provided control instance has no setStashed method");}},getStashed:function(c){if(c.getStashed){return typeof c.getStashed()!=="boolean"?!this.getVisible(c):c.getStashed();}else{throw new Error("Provided control instance has no getStashed method");}},bindProperty:function(c,p,b){c.bindProperty(p,b);},unbindProperty:function(c,p){if(c){c.unbindProperty(p,true);}},setProperty:function(c,p,P){var M=c.getMetadata().getPropertyLikeSetting(p);this.unbindProperty(c,p);if(M){if(this._isSerializable(P)){P=this._escapeCurlyBracketsInString(P);var s=M._sMutator;c[s](P);}else{throw new TypeError("Value cannot be stringified","sap.ui.core.util.reflection.JsControlTreeModifier");}}},getProperty:function(c,p){var M=c.getMetadata().getPropertyLikeSetting(p);if(M){var P=M._sGetter;return c[P]();}},isPropertyInitial:function(c,p){return c.isPropertyInitial(p);},setPropertyBinding:function(c,p,P){this.unbindProperty(c,p);var s={};s[p]=P;c.applySettings(s);},getPropertyBinding:function(c,p){return c.getBindingInfo(p);},createControl:function(c,A,v,s,S,b){var e;if(this.bySelector(s,A)){e="Can't create a control with duplicated ID "+(s.id||s);if(b){return Promise.reject(e);}throw new Error(e);}if(b){return new Promise(function(r,R){sap.ui.require([c.replace(/\./g,"/")],function(d){var i=this.getControlIdBySelector(s,A);r(new d(i,S));}.bind(this),function(){R(new Error("Required control '"+c+"' couldn't be created asynchronously"));});}.bind(this));}var d=O.get(c);if(!d){throw new Error("Can't create a control because the matching class object has not yet been loaded. Please preload the '"+c+"' module");}var i=this.getControlIdBySelector(s,A);return new d(i,S);},applySettings:function(c,s){c.applySettings(s);},_byId:function(i){return sap.ui.getCore().byId(i);},getId:function(c){return c.getId();},getParent:function(c){return c.getParent&&c.getParent();},getControlMetadata:function(c){return c&&c.getMetadata();},getControlType:function(c){return c&&c.getMetadata().getName();},setAssociation:function(p,n,i){var M=p.getMetadata().getAssociation(n);M.set(p,i);},getAssociation:function(p,n){var M=p.getMetadata().getAssociation(n);return M.get(p);},getAllAggregations:function(p){return p.getMetadata().getAllAggregations();},getAggregation:function(p,n){var A=this.findAggregation(p,n);if(A){return p[A._sGetter]();}},insertAggregation:function(p,n,o,i){if(n==="customData"){p.insertAggregation(n,o,i,true);}else{var A=this.findAggregation(p,n);if(A){if(A.multiple){var I=i||0;p[A._sInsertMutator](o,I);}else{p[A._sMutator](o);}}}},removeAggregation:function(c,n,o){if(n==="customData"){c.removeAggregation(n,o,true);}else{var A=this.findAggregation(c,n);if(A){c[A._sRemoveMutator](o);}}},removeAllAggregation:function(c,n){if(n==="customData"){c.removeAllAggregation(n,true);}else{var A=this.findAggregation(c,n);if(A){c[A._sRemoveAllMutator]();}}},getBindingTemplate:function(c,A){var b=c.getBindingInfo(A);return b&&b.template;},updateAggregation:function(c,A){var o=this.findAggregation(c,A);if(o){c[o._sDestructor]();c.updateAggregation(A);}},findIndexInParentAggregation:function(c){var p=this.getParent(c),b;if(!p){return-1;}b=this.getAggregation(p,this.getParentAggregationName(c));if(Array.isArray(b)){return b.indexOf(c);}else{return 0;}},getParentAggregationName:function(c){return c.sParentAggregationName;},findAggregation:function(c,A){if(c){if(c.getMetadata){var M=c.getMetadata();var o=M.getAllAggregations();if(o){return o[A];}}}},validateType:function(c,A,p,f){var t=A.type;if(A.multiple===false&&this.getAggregation(p,A.name)&&this.getAggregation(p,A.name).length>0){return false;}return this._isInstanceOf(c,t)||this._hasInterface(c,t);},instantiateFragment:function(f,n,v){var o=a.parse(f);o=this._checkAndPrefixIdsInFragment(o,n);var N;var i=v&&v.getId();var c=v.getController();N=sap.ui.xmlfragment({fragmentContent:o,sId:i},c);if(!Array.isArray(N)){N=[N];}return N;},templateControlFragment:function(f,p,v){return B._templateFragment(f,p).then(function(o){var c=(v&&v.getController())||undefined;return F.load({definition:o,controller:c});});},destroy:function(c,s){c.destroy(s);},_getFlexCustomData:function(c,t){var o=typeof c==="object"&&typeof c.data==="function"&&c.data("sap-ui-custom-settings");return O.get(["sap.ui.fl",t],o);},attachEvent:function(o,e,f,d){var c=O.get(f);if(typeof c!=="function"){throw new Error("Can't attach event because the event handler function is not found or not a function.");}o.attachEvent(e,d,c);},detachEvent:function(o,e,f){var c=O.get(f);if(typeof c!=="function"){throw new Error("Can't attach event because the event handler function is not found or not a function.");}o.detachEvent(e,c);},bindAggregation:function(c,A,b){c.bindAggregation(A,b);},unbindAggregation:function(c,A){c.unbindAggregation(A);},getExtensionPointInfo:function(e,v){var V=(v._xContent)?v._xContent:v;var E=X.getExtensionPointInfo(e,V);if(E){E.index--;E.parent=E.parent&&this._byId(v.createId(E.parent.getAttribute("id")));E.defaultContent=E.defaultContent.map(function(n){var i=v.createId(n.getAttribute("id"));return this._byId(i);}.bind(this)).filter(function(c){return!!c;});}return E;}};return m({},B,J);},true);
sap.ui.predefine('sap/ui/core/util/reflection/XmlTreeModifier',["./BaseTreeModifier","sap/ui/base/ManagedObject","sap/ui/base/DataType","sap/base/util/merge","sap/ui/util/XMLHelper","sap/ui/core/mvc/EventHandlerResolver","sap/base/util/includes","sap/base/util/ObjectPath","sap/base/util/isPlainObject","sap/ui/core/Fragment"],function(B,M,D,m,X,E,a,O,b){"use strict";var c=m({},B,{targets:"xmlTree",setVisible:function(C,v){if(v){C.removeAttribute("visible");}else{C.setAttribute("visible",v);}},getVisible:function(C){return c.getProperty(C,"visible");},setStashed:function(C,s){if(!s){C.removeAttribute("stashed");}else{C.setAttribute("stashed",s);}c.setVisible(C,!s);},getStashed:function(C){return c.getProperty(C,"stashed")||!c.getProperty(C,"visible");},bindProperty:function(C,p,v){C.setAttribute(p,"{"+v+"}");},unbindProperty:function(C,p){C.removeAttribute(p);},_setProperty:function(C,p,P,e){var v=c._getSerializedValue(P);if(e){v=c._escapeCurlyBracketsInString(v);}C.setAttribute(p,v);},setProperty:function(C,p,P){c._setProperty(C,p,P,true);},getProperty:function(C,p){var P=C.getAttribute(p);var o=c.getControlMetadata(C).getProperty(p);if(o){var t=o.getType();if(p==="value"&&c.getControlType(C)==="sap.ui.core.CustomData"&&c.getProperty(C,"key")==="sap-ui-custom-settings"){t=D.getType("object");}if(P===null){P=o.getDefaultValue()||t.getDefaultValue();}else{var u=M.bindingParser(P,undefined,true);if(b(u)){if(u.path||u.parts){P=undefined;}else{P=u;}}else{P=t.parseValue(u||P);}}}return P;},isPropertyInitial:function(C,p){var P=C.getAttribute(p);return(P==null);},setPropertyBinding:function(C,p,P){if(typeof P!=="string"){throw new Error("For XML, only strings are supported to be set as property binding.");}C.setAttribute(p,P);},getPropertyBinding:function(C,p){var P=C.getAttribute(p);if(P){var u=M.bindingParser(P,undefined,true);if(u&&(u.path||u.parts)){return u;}}},createControl:function(C,A,v,s,S,d){var i,l,e;if(!c.bySelector(s,A,v)){var f=C.split('.');var n="";if(f.length>1){l=f.pop();n=f.join('.');}var N=v.ownerDocument.createElementNS(n,l);i=c.getControlIdBySelector(s,A);if(i){N.setAttribute("id",i);}if(S){c.applySettings(N,S);}return d?Promise.resolve(N):N;}else{e=new Error("Can't create a control with duplicated ID "+i);if(d){return Promise.reject(e);}throw e;}},applySettings:function(C,s){var o=c.getControlMetadata(C);var d=o.getJSONKeys();Object.keys(s).forEach(function(k){var K=d[k];var v=s[k];switch(K._iKind){case 0:c._setProperty(C,k,v,false);break;case 3:c.setAssociation(C,k,v);break;default:throw new Error("Unsupported in applySettings on XMLTreeModifier: "+k);}});},_byId:function(i,v){if(v){if(v.ownerDocument&&v.ownerDocument.getElementById&&v.ownerDocument.getElementById(i)){return v.ownerDocument.getElementById(i);}else{return v.querySelector("[id='"+i+"']");}}},getId:function(C){return C.getAttribute("id");},getParent:function(C){var p=C.parentNode;if(!c.getId(p)&&!c._isExtensionPoint(p)){p=p.parentNode;}return p;},_getLocalName:function(x){return x.localName||x.baseName||x.nodeName;},getControlType:function(C){return c._getControlTypeInXml(C);},setAssociation:function(p,n,i){if(typeof i!=="string"){i=c.getId(i);}p.setAttribute(n,i);},getAssociation:function(p,n){return p.getAttribute(n);},getAllAggregations:function(C){var o=c.getControlMetadata(C);return o.getAllAggregations();},getAggregation:function(p,n){var A=c._findAggregationNode(p,n);var s=c._isSingleValueAggregation(p,n);var C=[];if(A){C=c._getControlsInAggregation(p,A);}else if(c._isAltTypeAggregation(p,n)&&s){C.push(c.getProperty(p,n));}if(n==="customData"){var d="http://schemas.sap.com/sapui5/extension/sap.ui.core.CustomData/1";var e;var N=Array.prototype.slice.call(p.attributes).reduce(function(f,g){var l=c._getLocalName(g);if(g.namespaceURI===d){var o=p.ownerDocument.createElementNS("sap.ui.core","CustomData");o.setAttribute("key",l);o.setAttribute("value",g.value);f.push(o);}else if(g.namespaceURI&&g.name.indexOf("xmlns:")!==0){if(!e){e={};}if(!e.hasOwnProperty(g.namespaceURI)){e[g.namespaceURI]={};}e[g.namespaceURI][l]=g.nodeValue;}return f;},[]);C=C.concat(N);if(e){var o=p.ownerDocument.createElementNS("sap.ui.core","CustomData");o.setAttribute("key","sap-ui-custom-settings");c.setProperty(o,"value",e);C.push(o);}}return s?C[0]:C;},insertAggregation:function(p,n,o,i,v){var A=c._findAggregationNode(p,n);if(!A){var N=p.namespaceURI;A=c.createControl(N+"."+n,undefined,v);p.appendChild(A);}if(i>=A.childElementCount){A.appendChild(o);}else{var r=c._getControlsInAggregation(p,A)[i];A.insertBefore(o,r);}},removeAggregation:function(p,n,o){var A=c._findAggregationNode(p,n);A.removeChild(o);},removeAllAggregation:function(C,n){var A=c._findAggregationNode(C,n);if(C===A){var d=c._getControlsInAggregation(C,C);d.forEach(function(o){C.removeChild(o);});}else{C.removeChild(A);}},_findAggregationNode:function(p,n){var A;var C=c._children(p);for(var i=0;i<C.length;i++){var N=C[i];if(N.localName===n){A=N;break;}}if(!A&&c._isDefaultAggregation(p,n)){A=p;}return A;},_isDefaultAggregation:function(p,A){var C=c.getControlMetadata(p);var d=C.getDefaultAggregation();return d&&A===d.name;},_isNotNamedAggregationNode:function(p,C){var A=c.getAllAggregations(p);var o=A[C.localName];return p.namespaceURI!==C.namespaceURI||!o;},_isSingleValueAggregation:function(p,A){var d=c.getAllAggregations(p);var o=d[A];return!o.multiple;},_isAltTypeAggregation:function(p,A){var C=c.getControlMetadata(p);var o=C.getAllAggregations()[A];return!!o.altTypes;},_isExtensionPoint:function(C){return c._getControlTypeInXml(C)==="sap.ui.core.ExtensionPoint";},getControlMetadata:function(C){return c._getControlMetadataInXml(C);},_getControlsInAggregation:function(p,A){var C=Array.prototype.slice.call(c._children(A));return C.filter(c._isNotNamedAggregationNode.bind(this,p));},_children:function(p){if(p.children){return p.children;}else{var C=[];for(var i=0;i<p.childNodes.length;i++){var n=p.childNodes[i];if(n.nodeType===n.ELEMENT_NODE){C.push(n);}}return C;}},getBindingTemplate:function(C,A){var o=c._findAggregationNode(C,A);if(o){var d=c._children(o);if(d.length===1){return d[0];}}},updateAggregation:function(C,A){},findIndexInParentAggregation:function(C){var p,A,d;p=c.getParent(C);if(!p){return-1;}A=c.getParentAggregationName(C,p);d=c.getAggregation(p,A);if(Array.isArray(d)){d=d.filter(function(C){if(c._isExtensionPoint(C)){return true;}return!c.getProperty(C,"stashed");});return d.indexOf(C);}else{return 0;}},getParentAggregationName:function(C,p){var n,A;if(!p.isSameNode(C.parentNode)){n=false;}else{n=c._isNotNamedAggregationNode(p,C);}if(n){A=c.getControlMetadata(p).getDefaultAggregationName();}else{A=c._getLocalName(C.parentNode);}return A;},findAggregation:function(C,A){var o=c.getControlMetadata(C);var d=o.getAllAggregations();if(d){return d[A];}},validateType:function(C,A,p,f,i){var t=A.type;if(A.multiple===false&&c.getAggregation(p,A.name)&&c.getAggregation(p,A.name).length>0){return false;}var d=sap.ui.xmlfragment({fragmentContent:f});if(!Array.isArray(d)){d=[d];}var r=c._isInstanceOf(d[i],t)||c._hasInterface(d[i],t);d.forEach(function(F){F.destroy();});return r;},instantiateFragment:function(f,n,v){var C;var F=X.parse(f);F=c._checkAndPrefixIdsInFragment(F,n);if(F.localName==="FragmentDefinition"){C=c._getElementNodeChildren(F);}else{C=[F];}C.forEach(function(N){if(c._byId(N.getAttribute("id"),v)){throw Error("The following ID is already in the view: "+N.getAttribute("id"));}});return C;},templateControlFragment:function(f,p){return B._templateFragment(f,p).then(function(F){return c._children(F);});},destroy:function(C){var p=C.parentNode;if(p){p.removeChild(C);}},_getFlexCustomData:function(C,t){if(!C){return undefined;}return C.getAttributeNS("sap.ui.fl",t);},attachEvent:function(n,e,f,d){if(typeof O.get(f)!=="function"){throw new Error("Can't attach event because the event handler function is not found or not a function.");}var v=c.getProperty(n,e)||"";var g=E.parse(v);var s=f;var p=["$event"];if(d){p.push(JSON.stringify(d));}s+="("+p.join(",")+")";if(!a(g,s)){g.push(s);}n.setAttribute(e,g.join(";"));},detachEvent:function(n,e,f){if(typeof O.get(f)!=="function"){throw new Error("Can't attach event because the event handler function is not found or not a function.");}var v=c.getProperty(n,e)||"";var d=E.parse(v);var i=d.findIndex(function(s){return s.includes(f);});if(i>-1){d.splice(i,1);}if(d.length){n.setAttribute(e,d.join(";"));}else{n.removeAttribute(e);}},bindAggregation:function(n,A,v,V){c.bindProperty(n,A,v.path);c.insertAggregation(n,A,v.template,0,V);},unbindAggregation:function(n,A){if(n.hasAttribute(A)){n.removeAttribute(A);c.removeAllAggregation(n,A);}},getExtensionPointInfo:function(e,v){if(v&&e){var d=Array.prototype.slice.call(v.getElementsByTagNameNS("sap.ui.core","ExtensionPoint"));var f=d.filter(function(h){return h.getAttribute("name")===e;});var o=(f.length===1)?f[0]:undefined;if(o){var p=c.getParent(o);var g={parent:p,aggregationName:c.getParentAggregationName(o,p),index:c.findIndexInParentAggregation(o)+1,defaultContent:Array.prototype.slice.call(c._children(o))};return g;}}}});return c;},true);
sap.ui.predefine('sap/ui/core/util/serializer/HTMLViewSerializer',['sap/ui/base/EventProvider','./Serializer','./delegate/HTML','sap/ui/thirdparty/vkbeautify'],function(E,S,H,v){"use strict";
var a=E.extend("sap.ui.core.util.serializer.HTMLViewSerializer",{constructor:function(V,w,g,G){E.apply(this);this._oView=V;this._oWindow=w;this._fnGetControlId=g;this._fnGetEventHandlerName=G;}});
a.prototype.serialize=function(){var t=this;var s=function(C){return C instanceof this._oWindow.sap.ui.core.mvc.View&&C!==t._oView;};var c=new S(this._oView,new H(this._fnGetControlId,this._fnGetEventHandlerName),true,this._oWindow,s);var r=c.serialize();var V=[];V.push('<template');if(this._oView.getControllerName&&this._oView.getControllerName()){V.push(' data-controller-name="'+this._oView.getControllerName()+'"');}V.push(" >");V.push(r);V.push("</template>");return v.xml(V.join(""));};
return a;});
sap.ui.predefine('sap/ui/core/util/serializer/Serializer',['sap/ui/base/EventProvider',"sap/base/assert"],function(E,a){"use strict";
var S=E.extend("sap.ui.core.util.serializer.Serializer",{constructor:function(r,s,b,w,f,c){E.apply(this);this._oRootControl=r;this._delegate=s;this._bSkipRoot=!!b;this._oWindow=w||window;this._fnSkipAggregations=f;this._fnSkipElement=c;}});
S.prototype.serialize=function(){return this._serializeRecursive(this._oRootControl,0);};
S.prototype._serializeRecursive=function(c,l,A,b){a(typeof c!=="undefined","The control must not be undefined");var C=[];var w=(!this._bSkipRoot||l!==0);if(w){var s=this._delegate.start(c,A,b);var m=this._delegate.middle(c,A,b);C.push(s+m);}var d=c.getMetadata().getAllAggregations();if(d){for(var n in d){if(this._fnSkipAggregations&&this._fnSkipAggregations(c,n)){continue;}var e=[];var o=d[n];var v=c[o._sGetter]();if(c.getBindingPath(n)&&c.getBindingInfo(n).template){e.push(c.getBindingInfo(n).template);}else if(v&&v.length){for(var i=0;i<v.length;i++){var O=v[i];if(this._isObjectSerializable(O)){e.push(O);}}}else if(this._isObjectSerializable(v)){e.push(v);}if(e.length>0){if(w){C.push(this._delegate.startAggregation(c,n));}var f=this._isDefaultAggregation(c,n);for(var j=0;j<e.length;j++){C.push(this._serializeRecursive(e[j],l+1,n,f));}if(w){C.push(this._delegate.endAggregation(c,n));}}}}if(w){var g=this._delegate.end(c,A,b);C.push(g);}return C.join("");};
S.prototype._isObjectSerializable=function(o){return o instanceof this._oWindow.sap.ui.core.Element&&!(this._fnSkipElement&&this._fnSkipElement(o));};
S.prototype._isDefaultAggregation=function(c,A){return c.getMetadata().getDefaultAggregationName()===A;};
return S;});
sap.ui.predefine('sap/ui/core/util/serializer/ViewSerializer',['sap/ui/base/EventProvider','./HTMLViewSerializer','./XMLViewSerializer',"sap/base/assert"],function(E,H,X,a){"use strict";
var V=E.extend("sap.ui.core.util.serializer.ViewSerializer",{constructor:function(r,w,d){E.apply(this);this._oRootControl=r;this._oWindow=w||window;this._mViews={};this._sDefaultXmlNamespace=d;}});
V.prototype.serializeToXML=function(){return this.serialize("XML");};
V.prototype.serializeToHTML=function(){return this.serialize("HTML");};
V.prototype.serialize=function(c){this._mViews={};this._sConvertToViewType=c||undefined;return this._serializeRecursive(this._oRootControl);};
V.prototype._getViewType=function(v){if(!this._sConvertToViewType){if(v instanceof this._oWindow.sap.ui.core.mvc.HTMLView){return"HTML";}else if(v instanceof this._oWindow.sap.ui.core.mvc.XMLView){return"XML";}}return this._sConvertToViewType;};
V.prototype._serializeRecursive=function(c){a(typeof c!=="undefined","The control must not be undefined");if(c instanceof this._oWindow.sap.ui.core.mvc.View){var v=this._getViewSerializer(c,this._getViewType(c));if(v){var o=c.getViewName()||c.getControllerName();if(!this._mViews[o]){this._mViews[o]=v.serialize(this._getViewType(c));}}}if(c.getMetadata().getClass()===this._oWindow.sap.ui.core.UIArea){var C=c.getContent();for(var i=0;i<C.length;i++){this._serializeRecursive(C[i]);}}else if(c.getMetadata().getClass()===this._oWindow.sap.ui.core.ComponentContainer){this._serializeRecursive(c.getComponentInstance().getRootControl());}else{var A=c.getMetadata().getAllAggregations();if(A){for(var n in A){var b=A[n];var d=c[b._sGetter]();if(d&&d.length){for(var i=0;i<d.length;i++){var O=d[i];if(O instanceof this._oWindow.sap.ui.core.Element){this._serializeRecursive(O);}}}else if(d instanceof this._oWindow.sap.ui.core.Element){this._serializeRecursive(d);}}}}return this._mViews;};
V.prototype._getViewSerializer=function(v,t){var g=function(e){if(e.fFunction&&e.fFunction._sapui_handlerName){var h=e.fFunction._sapui_handlerName;var c=v.getController();if(c[h]||sap.ui.getCore().getConfiguration().getControllerCodeDeactivated()){return h;}}};var G=function(c){if(c._sapui_controlId){return c._sapui_controlId;}return c.getId().replace(v.createId(""),"");};if(t==="HTML"){return new H(v,this._oWindow,G,g);}else if(t==="XML"){return new X(v,this._oWindow,this._sDefaultXmlNamespace,G,g);}else{var t=(v)?v.constructor:"?";throw Error("View type '"+t+"' is not supported for conversion. Only HTML and XML is supported");}};
return V;});
sap.ui.predefine('sap/ui/core/util/serializer/XMLViewSerializer',['sap/ui/base/EventProvider','./Serializer','./delegate/XML','sap/ui/thirdparty/vkbeautify'],function(E,S,X,v){"use strict";
var a=E.extend("sap.ui.core.util.serializer.XMLViewSerializer",{constructor:function(V,w,d,g,G){E.apply(this);this._oView=V;this._oWindow=w;this._sDefaultNamespace=d;this._fnGetControlId=g;this._fnGetEventHandlerName=G;}});
a.prototype.serialize=function(){var p=[];var m=function(C,P){if(!P){var T=(C)?C.constructor:"?";throw Error("Controls with empty package are currently not supported by the XML serializer: "+T);}if(p.indexOf(P)===-1){p.push(P);}};var t=this;var s=function(C){return C instanceof this._oWindow.sap.ui.core.mvc.View&&C!==t._oView;};var c=new S(this._oView,new X(this._sDefaultNamespace,this._fnGetControlId,this._fnGetEventHandlerName,m),true,this._oWindow,s);var r=c.serialize();var V=[];V.push('<sap.ui.core.mvc:View');if(this._oView.getControllerName&&this._oView.getControllerName()){V.push(' controllerName="'+this._oView.getControllerName()+'"');}if(p.indexOf('sap.ui.core.mvc')===-1){p.push('sap.ui.core.mvc');}for(var i=0;i<p.length;i++){if(this._sDefaultNamespace&&this._sDefaultNamespace===p[i]){V.push(' xmlns="'+p[i]+'"');}else{V.push(' xmlns:'+p[i]+'="'+p[i]+'"');}}V.push(" >");V.push(r);V.push("</sap.ui.core.mvc:View>");return v.xml(V.join(""));};
return a;});
sap.ui.predefine('sap/ui/core/util/serializer/delegate/Delegate',['sap/ui/base/EventProvider'],function(E){"use strict";
var D=E.extend("sap.ui.core.util.serializer.delegate.Delegate",{constructor:function(){E.apply(this);}});
D.prototype.start=function(c,a,i){return"";};
D.prototype.middle=function(c,a,i){return"";};
D.prototype.end=function(c,a,i){return"";};
D.prototype.startAggregation=function(c,a){return"";};
D.prototype.endAggregation=function(c,a){return"";};
return D;});
sap.ui.predefine('sap/ui/core/util/serializer/delegate/HTML',['./Delegate',"sap/base/strings/hyphenate","sap/base/util/deepEqual"],function(D,h,d){"use strict";
var H=D.extend("sap.ui.core.util.serializer.delegate.HTML",{constructor:function(g,G){D.apply(this);this._fnGetControlId=g;this._fnGetEventHandlerName=G;}});
H.prototype.startAggregation=function(c,a){return'<div data-sap-ui-aggregation="'+a+'">';};
H.prototype.endAggregation=function(c,a){return'</div>';};
H.prototype.start=function(c,a,i){return"<div";};
H.prototype.middle=function(c,a,b){var e=[];var I=(this._fnGetControlId)?this._fnGetControlId(c):c.getId();if(I.indexOf("__")!==0){e.push(this._createAttribute("id",I));}e.push(this._createAttribute("data-sap-ui-type",c.getMetadata()._sClassName));if(c.aCustomStyleClasses){var C=c.aCustomStyleClasses;var f=[];for(var i=0;i<C.length;i++){var s=C[i];if(!s.startsWith("sapM")&&!s.startsWith("sapUi")){f.push(s);}}if(f.length>0){e.push(this._createAttribute("class",f.join(" ")));}}if(this._fnGetEventHandlerName){var E=c.getMetadata().getAllEvents();for(var g in E){if(c.hasListeners(g)){var j=c.mEventRegistry[g];for(var i=0;i<j.length;i++){var k=this._fnGetEventHandlerName(j[i]);if(k){e.push(this._createAttribute("data-"+this._createHtmlAttributeName(g),k));break;}}}}}var A=c.getMetadata().getAllAssociations();this._createAttributes(e,c,A,function(n,v){if(A[n].multiple){return v.join(" ");}return v;},function(n,v){return(v!==null&&typeof v!==undefined&&v!=="");});var p=c.getMetadata().getAllProperties();var o=c.getMetadata().getPropertyDefaults();this._createAttributes(e,c,p,null,function(n,v){return!d(v,o[n]);});var l=c.getMetadata().getAllAggregations();this._createAttributes(e,c,l,null,function(n,v){if(!c.getBindingInfo(n)&&(!v||(typeof v!=="string"))){return false;}return true;});e.push('>');return e.join('');};
H.prototype.end=function(c,a,i){return"</div>";};
H.prototype._createAttributes=function(a,c,o,g,v){for(var n in o){var p=o[n];var G=p._sGetter;if(c[G]){var V=c[G]();V=g?g(n,V):V;if(!c.getBindingInfo(n)){if(!v||v(n,V)){a.push(this._createAttribute("data-"+this._createHtmlAttributeName(n),V));}}else{a.push(this._createDataBindingAttribute(c,n,V));}}}};
H.prototype._createDataBindingAttribute=function(c,n,v){var b=c.getBindingInfo(n);var B=null;var p=v;if(!b.bindingString){if(b.binding){var C=b.binding.getMetadata().getName();if(C==="sap.ui.model.PropertyBinding"||C==="sap.ui.model.resource.ResourcePropertyBinding"){B=b.binding.getValue();}}if(b.parts){b=b.parts[0];}var m=b.model;if(B===v||B===null){p="{"+(m?(m+">"+b.path):b.path)+"}";}}else{p=b.bindingString;}return this._createAttribute("data-"+this._createHtmlAttributeName(n),p);};
H.prototype._createAttribute=function(a,v){return' '+a+'="'+v+'"';};
H.prototype._createHtmlAttributeName=function(n){return h(n);};
return H;});
sap.ui.predefine('sap/ui/core/util/serializer/delegate/XML',['./Delegate',"sap/base/util/deepEqual","sap/base/security/encodeXML","sap/ui/thirdparty/jquery"],function(D,d,e,q){"use strict";
var X=D.extend("sap.ui.core.util.serializer.delegate.XML",{constructor:function(s,g,G,m){D.apply(this);this._sDefaultNamespace=s;this._fnGetControlId=g;this._fnMemorizePackage=m;this._fnGetEventHandlerName=G;}});
X.prototype.startAggregation=function(c,a){return'<'+this._createAggregationName(c,a)+'>';};
X.prototype.endAggregation=function(c,a){return'</'+this._createAggregationName(c,a)+'>';};
X.prototype.start=function(c,a,i){return"<"+this._createTagName(c);};
X.prototype.end=function(c,a,i){return"</"+this._createTagName(c)+">";};
X.prototype.middle=function(c,a,b){var x=[];var I=(this._fnGetControlId)?this._fnGetControlId(c):c.getId();if(I.indexOf("__")!==0){x.push(this._createAttribute("id",I));}if(c.aCustomStyleClasses){var C=c.aCustomStyleClasses;var f=[];for(var i=0;i<C.length;i++){var s=C[i];if(!s.startsWith("sapM")&&!s.startsWith("sapUi")){f.push(s);}}if(f.length>0){x.push(this._createAttribute("class",f.join(" ")));}}if(this._fnGetEventHandlerName){var E=c.getMetadata().getAllEvents();for(var g in E){if(c.hasListeners(g)){var h=c.mEventRegistry[g];for(var i=0;i<h.length;i++){var H=this._fnGetEventHandlerName(h[i]);if(H){x.push(this._createAttribute(g,H));break;}}}}}var A=c.getMetadata().getAllAssociations();this._createAttributes(x,c,A,function(n,v){if(A[n].multiple){return v.join(" ");}return v;},function(n,v){return(v!==null&&typeof v!==undefined&&v!=="");});var p=c.getMetadata().getAllProperties();var o=c.getMetadata().getPropertyDefaults();this._createAttributes(x,c,p,null,function(n,v){return!d(v,o[n]);});var j=c.getMetadata().getAllAggregations();this._createAttributes(x,c,j,null,function(n,v){if(!c.getBindingInfo(n)&&(!v||(typeof v!=="string"))){return false;}return true;});x.push('>');return x.join('');};
X.prototype._createAttributes=function(x,c,o,g,v){for(var n in o){var p=o[n];var G=p._sGetter;if(c[G]){var V=c[G]();V=g?g(n,V):V;if(!c.getBindingInfo(n)){if(!v||v(n,V)){x.push(this._createAttribute(n,V));}}else{x.push(this._createDataBindingAttribute(c,n,V));}}}};
X.prototype._createDataBindingAttribute=function(c,n,v){var b=c.getBindingInfo(n);var B=null;var p=v;if(!b.bindingString){if(b.binding){var C=b.binding.getMetadata().getName();if(C==="sap.ui.model.PropertyBinding"||C==="sap.ui.model.resource.ResourcePropertyBinding"){B=b.binding.getValue();}}if(b.parts){b=b.parts[0];}var m=b.model;if(B===v||B===null){p="{"+(m?(m+">"+b.path):b.path)+"}";}}else{p=b.bindingString;}return this._createAttribute(n,p);};
X.prototype._createAttribute=function(a,v){var E=(typeof v==="string"||v instanceof String)?e(v):v;return' '+a+'="'+E+'"';};
X.prototype._createTagName=function(c){var C=c.getMetadata()._sClassName;var l=C.lastIndexOf(".");var s=(l===-1)?C:C.substring(l+1);var p=(l===-1)?C:C.substring(0,l);if(this._fnMemorizePackage){this._fnMemorizePackage(c,p);}return this._createNamespace(p,s);};
X.prototype._createAggregationName=function(c,a){var C=c.getMetadata()._sClassName;var l=C.lastIndexOf(".");var p=(l===-1)?C:C.substring(0,l);return this._createNamespace(p,a);};
X.prototype._createNamespace=function(n,N){if(this._sDefaultNamespace&&this._sDefaultNamespace===n){return N;}else{return n+":"+N;}};
return X;});
sap.ui.predefine('sap/ui/core/ws/ReadyState',function(){"use strict";var R={CONNECTING:0,OPEN:1,CLOSING:2,CLOSED:3};return R;},true);
sap.ui.predefine('sap/ui/core/ws/SapPcpWebSocket',['./WebSocket',"sap/base/Log"],function(W,L){"use strict";
var S=W.extend("sap.ui.core.ws.SapPcpWebSocket",{constructor:function(u,p){W.apply(this,arguments);}});
S.SUPPORTED_PROTOCOLS={v10:"v10.pcp.sap.com"};S._deserializeRegexp=/((?:[^:\\]|(?:\\.))+):((?:[^:\\\n]|(?:\\.))*)/;S._SEPARATOR="\n\n";S._MESSAGE="MESSAGE";
S.prototype._onopen=function(){var s=false;if(this.getProtocol()===""){s=true;}else{for(var p in S.SUPPORTED_PROTOCOLS){if(S.SUPPORTED_PROTOCOLS.hasOwnProperty(p)){if(S.SUPPORTED_PROTOCOLS[p]===this.getProtocol()){s=true;break;}}}}if(s){this.fireOpen();}else{L.error("Unsupported protocol '"+this.getProtocol()+"' selected by the server. "+"Connection will be closed.");this.close("Unsupported protocol selected by the server");}};
S.prototype._onmessage=function(m){var s=-1,e={};if(typeof m.data==="string"){s=m.data.indexOf(S._SEPARATOR);}if(s!==-1){e.pcpFields=this._extractPcpFields(m.data.substring(0,s));e.data=m.data.substr(s+S._SEPARATOR.length);}else{L.warning("Invalid PCP message received: "+m.data);e.pcpFields={};e.data=m.data;}this.fireMessage(e);};
S.prototype._extractPcpFields=function(h){var f=h.split("\n"),l=[],p={};for(var i=0;i<f.length;i++){l=f[i].match(S._deserializeRegexp);if(l&&l.length===3){p[this._unescape(l[1])]=this._unescape(l[2]);}}return p;};
S.prototype._unescape=function(e){var p=e.split("\u0008"),u="";for(var i=0;i<p.length;i++){p[i]=p[i].replace(/\\\\/g,"\u0008").replace(/\\:/g,':').replace(/\\n/g,'\n').replace(/\u0008/g,"\\");}u=p.join("\u0008");return u;};
S.prototype._serializePcpFields=function(p,m,P){var s="",f="",a="";if(m==='string'){a='text';}else if(m==='blob'||m==='arraybuffer'){a='binary';}if(p&&typeof p==='object'){for(f in p){if(p.hasOwnProperty(f)&&f.indexOf('pcp-')!==0){s+=this._escape(f)+":"+this._escape(String(p[f]))+"\n";}}}return"pcp-action:"+P+"\npcp-body-type:"+a+"\n"+s+"\n";};
S.prototype._escape=function(u){return u.replace(/\\/g,'\\\\').replace(/:/g,'\\:').replace(/\n/g,'\\n');};
S.prototype.send=function(m,p){var M=typeof m,P="";P=this._serializePcpFields(p,M,S._MESSAGE);W.prototype.send.call(this,P+m);return this;};
return S;});
sap.ui.predefine('sap/ui/core/ws/WebSocket',['sap/ui/Device','sap/ui/base/EventProvider','./ReadyState','sap/ui/thirdparty/URI',"sap/base/Log","sap/ui/thirdparty/jquery"],function(D,E,R,U,L,q){"use strict";
var W=E.extend("sap.ui.core.ws.WebSocket",{
constructor:function(u,p){E.apply(this);if(!D.support.websocket){throw new Error("Browser does not support WebSockets.");}if(typeof(u)!=="string"){throw new Error("sUrl must be a string.");}if(typeof(p)!=='undefined'&&!Array.isArray(p)&&typeof(p)!=='string'){throw new Error("aProtocols must be a string, array of strings or undefined.");}this._openConnection(u,p);},
metadata:{publicMethods:["send","close","getReadyState","getProtocol"]}
});
W.prototype.getInterface=function(){return this;};
W.M_EVENTS={Open:"open",Close:"close",Error:"error",Message:"message"};
W.prototype.attachOpen=function(d,f,l){this.attachEvent("open",d,f,l);return this;};
W.prototype.detachOpen=function(f,l){this.detachEvent("open",f,l);return this;};
W.prototype.fireOpen=function(p){this.fireEvent("open",p);return this;};
W.prototype.attachClose=function(d,f,l){this.attachEvent("close",d,f,l);return this;};
W.prototype.detachClose=function(f,l){this.detachEvent("close",f,l);return this;};
W.prototype.fireClose=function(p){this.fireEvent("close",p);return this;};
W.prototype.attachError=function(d,f,l){this.attachEvent("error",d,f,l);return this;};
W.prototype.detachError=function(f,l){this.detachEvent("error",f,l);return this;};
W.prototype.fireError=function(p){this.fireEvent("error",p);return this;};
W.prototype.attachMessage=function(d,f,l){this.attachEvent("message",d,f,l);return this;};
W.prototype.detachMessage=function(f,l){this.detachEvent("message",f,l);return this;};
W.prototype.fireMessage=function(p){this.fireEvent("message",p);return this;};
W.prototype._resolveFullUrl=function(u){var o=new U(u);var b=new U(document.baseURI);b.search('');b.protocol(b.protocol()==='https'?'wss':'ws');o=o.absoluteTo(b);return o.toString();};
W.prototype._openConnection=function(u,p){var u=this._resolveFullUrl(u);this._oWs=(typeof(p)==='undefined')?new window.WebSocket(u):new window.WebSocket(u,p);this._oWs.onopen=q.proxy(this._onopen,this);this._oWs.onclose=q.proxy(this._onclose,this);this._oWs.onmessage=q.proxy(this._onmessage,this);this._oWs.onerror=q.proxy(this._onerror,this);};
W.prototype._onopen=function(){this.fireOpen();};
W.prototype._onclose=function(c){this.fireClose({code:c.code,reason:c.reason,wasClean:c.wasClean});};
W.prototype._onerror=function(e){this.fireError();};
W.prototype._onmessage=function(m){this.fireMessage({data:m.data});};
W.prototype.send=function(m){if(this.getReadyState()===R.OPEN){this._oWs.send(m);}else if(this.getReadyState()===R.CONNECTING){this.attachEventOnce("open",function(e){this._oWs.send(m);});}else{L.warning("Unable to send WebSocket message. "+"Connection is already closed or closing. message: "+m);}return this;};
W.prototype.close=function(c,r){if(typeof(c)==='string'){r=c;c=undefined;}c=(typeof(c)==='undefined')?1000:c;r=(typeof(r)==='undefined')?"":r;if(this.getReadyState()===R.OPEN){this._oWs.close(c,r);}else if(this.getReadyState()===R.CONNECTING){this.attachEventOnce("open",function(e){this._oWs.close(c,r);});}else{var t='';switch(this.getReadyState()){case R.CLOSED:t="Connection is already closed.";break;case R.CLOSING:t="Connection is already closing.";break;}L.warning("Unable to close WebSocket connection. "+t);}return this;};
W.prototype.getReadyState=function(){return this._oWs.readyState;};
W.prototype.getProtocol=function(){return this._oWs.protocol;};
return W;});
sap.ui.predefine('sap/ui/dom/denormalizeScrollBeginRTL',["sap/ui/Device"],function(D){"use strict";var d=function(n,o){if(o){if(D.browser.msie){return n;}else if(D.browser.webkit){return o.scrollWidth-o.clientWidth-n;}else if(D.browser.firefox){return-n;}else{return n;}}};return d;});
sap.ui.predefine('sap/ui/dom/denormalizeScrollLeftRTL',["sap/ui/Device"],function(D){"use strict";var d=function(n,o){if(o){if(D.browser.msie||D.browser.edge){return o.scrollWidth-o.clientWidth-n;}else if(D.browser.firefox||(D.browser.safari&&D.browser.version>=10)){return o.clientWidth+n-o.scrollWidth;}else if(D.browser.webkit){return n;}else{return n;}}};return d;});
sap.ui.predefine('sap/ui/dom/getFirstEditableInput',["sap/ui/thirdparty/jquery","sap/ui/dom/isHidden"],function(q,i){"use strict";
function f(c){return q(c).find('input, textarea').not('input[readonly],textarea[readonly],input[type=hidden],input[type=button],input[type=submit],input[type=reset],input[type=image],button').filter(':enabled:visible:first')[0];}
function g(c){if(!c||i(c)){return null;}return f(c);}
return g;});
sap.ui.predefine('sap/ui/dom/getOwnerWindow',[],function(){"use strict";var g=function ownerWindow(d){if(d.ownerDocument.parentWindow){return d.ownerDocument.parentWindow;}return d.ownerDocument.defaultView;};return g;});
sap.ui.predefine('sap/ui/dom/isHidden',["sap/ui/thirdparty/jquery"],function(q){"use strict";
function i(e){return(e.offsetWidth<=0&&e.offsetHeight<=0)||q.css(e,'visibility')==='hidden';}
return i;});
sap.ui.predefine('sap/ui/dom/jquery/Aria',['sap/ui/thirdparty/jquery'],function(q){"use strict";
function a(A,v,p){var s=this.attr(A);if(!s){return this.attr(A,v);}var b=s.split(" ");if(b.indexOf(v)==-1){p?b.unshift(v):b.push(v);this.attr(A,b.join(" "));}return this;}
function r(A,v){var s=this.attr(A)||"",b=s.split(" "),i=b.indexOf(v);if(i==-1){return this;}b.splice(i,1);if(b.length){this.attr(A,b.join(" "));}else{this.removeAttr(A);}return this;}
q.fn.addAriaLabelledBy=function(i,p){return a.call(this,"aria-labelledby",i,p);};
q.fn.removeAriaLabelledBy=function(i){return r.call(this,"aria-labelledby",i);};
q.fn.addAriaDescribedBy=function(i,p){return a.call(this,"aria-describedby",i,p);};
q.fn.removeAriaDescribedBy=function(i){return r.call(this,"aria-describedby",i);};
return q;});
sap.ui.predefine('sap/ui/dom/jquery/Focusable',["sap/ui/thirdparty/jquery","sap/ui/dom/jquery/hasTabIndex","sap/ui/dom/isHidden"],function(q,d,i){"use strict";
function f(c,F){var C=F?c.firstChild:c.lastChild,o;while(C){if(C.nodeType==1&&!i(C)){if(q(C).hasTabIndex()){return C;}o=f(C,F);if(o){return o;}}C=F?C.nextSibling:C.previousSibling;}return null;}
q.fn.firstFocusableDomRef=function(){var c=this.get(0);if(!c||i(c)){return null;}return f(c,true);};
q.fn.lastFocusableDomRef=function(){var c=this.get(0);if(!c||i(c)){return null;}return f(c,false);};
return q;});
sap.ui.predefine('sap/ui/dom/jquery/Selection',["sap/ui/thirdparty/jquery"],function(q){"use strict";
q.fn.disableSelection=function(){return this.on(("onselectstart"in document.createElement("div")?"selectstart":"mousedown")+".ui-disableSelection",function(e){e.preventDefault();});};
q.fn.enableSelection=function(){return this.off(".ui-disableSelection");};
return q;});
sap.ui.predefine('sap/ui/dom/jquery/cursorPos',['sap/ui/thirdparty/jquery'],function(q){"use strict";var c=function cursorPos(p){var l=arguments.length,t,T;t=this.prop("tagName");T=this.prop("type");if(this.length===1&&((t=="INPUT"&&(T=="text"||T=="password"||T=="search"))||t=="TEXTAREA")){var d=this.get(0);if(l>0){if(typeof(d.selectionStart)=="number"){d.focus();d.selectionStart=p;d.selectionEnd=p;}return this;}else{if(typeof(d.selectionStart)=="number"){return d.selectionStart;}return-1;}}else{return this;}};q.fn.cursorPos=c;return q;});
sap.ui.predefine('sap/ui/dom/jquery/getSelectedText',['sap/ui/thirdparty/jquery'],function(q){"use strict";var g=function(){var d=this.get(0);try{if(typeof d.selectionStart==="number"){return d.value.substring(d.selectionStart,d.selectionEnd);}}catch(e){}return"";};q.fn.getSelectedText=g;return q;});
sap.ui.predefine('sap/ui/dom/jquery/hasTabIndex',["sap/ui/thirdparty/jquery"],function(q){"use strict";var h=function(e){var t=q.prop(e,"tabIndex");return t!=null&&t>=0&&(!q.attr(e,"disabled")||q.attr(e,"tabindex"));};
q.fn.hasTabIndex=function(){return h(this.get(0));};
return q;});
sap.ui.predefine('sap/ui/dom/jquery/parentByAttribute',['sap/ui/thirdparty/jquery'],function(q){"use strict";var p=function parentByAttribute(a,v){if(this.length>0){if(v){return this.first().parents("["+a+"='"+v+"']").get(0);}else{return this.first().parents("["+a+"]").get(0);}}};q.fn.parentByAttribute=p;return q;});
sap.ui.predefine('sap/ui/dom/jquery/rect',["sap/ui/thirdparty/jquery","sap/ui/dom/getOwnerWindow"],function(q,d){"use strict";var r=function rect(){var D=this.get(0);if(D){if(D.getBoundingClientRect){var c=D.getBoundingClientRect();var R={top:c.top,left:c.left,width:c.right-c.left,height:c.bottom-c.top};var w=d(D);R.left+=q(w).scrollLeft();R.top+=q(w).scrollTop();return R;}else{return{top:10,left:10,width:D.offsetWidth,height:D.offsetHeight};}}return null;};q.fn.rect=r;return q;});
sap.ui.predefine('sap/ui/dom/jquery/rectContains',["sap/ui/thirdparty/jquery","sap/base/assert","sap/ui/dom/jquery/rect"],function(q,a){"use strict";var r=function rectContains(p,P){a(!isNaN(p),"iPosX must be a number");a(!isNaN(P),"iPosY must be a number");var R=this.rect();if(R){return p>=R.left&&p<=R.left+R.width&&P>=R.top&&P<=R.top+R.height;}return false;};q.fn.rectContains=r;return q;});
sap.ui.predefine('sap/ui/dom/jquery/scrollLeftRTL',["sap/ui/Device","sap/ui/dom/denormalizeScrollLeftRTL","sap/ui/thirdparty/jquery"],function(D,d,q){"use strict";var s=function(p){var o=this.get(0);if(o){if(p===undefined){if(D.browser.msie||D.browser.edge){return o.scrollWidth-o.scrollLeft-o.clientWidth;}else if(D.browser.firefox||(D.browser.safari&&D.browser.version>=10)){return o.scrollWidth+o.scrollLeft-o.clientWidth;}else if(D.browser.webkit){return o.scrollLeft;}else{return o.scrollLeft;}}else{o.scrollLeft=d(p,o);return this;}}};q.fn.scrollLeftRTL=s;return q;});
sap.ui.predefine('sap/ui/dom/jquery/scrollRightRTL',["sap/ui/Device","sap/ui/thirdparty/jquery"],function(D,q){"use strict";var s=function(){var d=this.get(0);if(d){if(D.browser.msie){return d.scrollLeft;}else if(D.browser.firefox||(D.browser.safari&&D.browser.version>=10)){return(-d.scrollLeft);}else if(D.browser.webkit){return d.scrollWidth-d.scrollLeft-d.clientWidth;}else{return d.scrollLeft;}}};q.fn.scrollRightRTL=s;return q;});
sap.ui.predefine('sap/ui/dom/jquery/selectText',['sap/ui/thirdparty/jquery'],function(q){"use strict";var s=function selectText(S,E){var d=this.get(0);try{if(typeof(d.selectionStart)==="number"){d.setSelectionRange(S>0?S:0,E);}}catch(e){}return this;};q.fn.selectText=s;return q;});
sap.ui.predefine('sap/ui/dom/units/Rem',['sap/base/assert'],function(a){"use strict";
function g(){var r=document.documentElement;if(!r){return 16;}return parseFloat(window.getComputedStyle(r).getPropertyValue("font-size"));}
var R={fromPx:function(p){a(((typeof p==="string")&&(p!=="")&&!isNaN(parseFloat(p))&&(typeof parseFloat(p)==="number"))||((typeof p==="number")&&!isNaN(p)),'Rem.fromPx: either the "vPx" parameter must be an integer, or a string e.g.: "16px"');return parseFloat(p)/g();},toPx:function(r){a(((typeof r==="string")&&(r!=="")&&!isNaN(parseFloat(r))&&(typeof parseFloat(r)==="number"))||((typeof r==="number")&&!isNaN(r)),'Rem.toPx: either the "vRem" parameter must be an integer, or a string e.g.: "1rem"');return parseFloat(r)*g();}};return R;});
sap.ui.predefine('sap/ui/events/isMouseEventDelayed',["sap/ui/Device"],function(D){"use strict";var i=function(n){n=n||navigator;return!!(D.browser.mobile&&!((D.os.ios&&D.os.version>=8&&D.browser.safari&&!D.browser.webview)||(D.browser.chrome&&!/SAMSUNG/.test(n.userAgent)&&D.browser.version>=32)));};return i;});
sap.ui.predefine('sap/ui/events/isSpecialKey',function(){"use strict";var i=function(e){function a(e){var k=e.key;return(k==='Shift')||(k==='Control')||(k==='Alt')||(k==='AltGraph')||(k==='CapsLock')||(k==='NumLock');}function b(e){var k=e.key;return(k==='ArrowLeft')||(k==='ArrowUp')||(k==='ArrowRight')||(k==='ArrowDown')||(k==='Left')||(k==='Up')||(k==='Right')||(k==='Down');}var k=e.key,s=a(e)||b(e)||k==='PageUp'||k==='PageDown'||k==='End'||k==='Home'||k==='PrintScreen'||k==='Insert'||k==='Del'||k==='Delete'||k==='F1'||k==='F2'||k==='F3'||k==='F4'||k==='F5'||k==='F6'||k==='F7'||k==='F8'||k==='F9'||k==='F10'||k==='F11'||k==='F12'||k==='Pause'||k==='Backspace'||k==='Tab'||k==='Enter'||k==='Escape'||k==='Esc'||k==='ScrollLock'||k==='Scroll';switch(e.type){case"keydown":case"keyup":case"keypress":return s;default:return false;}};return i;});
sap.ui.predefine('sap/ui/model/ClientTreeBindingAdapter',['sap/ui/model/TreeBinding','sap/ui/model/ClientTreeBinding','./TreeBindingAdapter','sap/ui/model/ChangeReason',"sap/base/assert","sap/base/Log"],function(T,C,a,b,c,L){"use strict";var d=function(){if(!(this instanceof T)||this._bIsAdapted){return;}a.apply(this);for(var f in d.prototype){if(d.prototype.hasOwnProperty(f)){this[f]=d.prototype[f];}}this._invalidTree=true;this.setNumberOfExpandedLevels(this.mParameters.numberOfExpandedLevels||0);};
d.prototype.setNumberOfExpandedLevels=function(n){this._iNumberOfExpandedLevels=parseInt(n);};
d.prototype.getNumberOfExpandedLevels=function(){return this._iNumberOfExpandedLevels;};
d.prototype.nodeHasChildren=function(n){c(n,"TreeBindingAdapter.nodeHasChildren: No node given!");if(!n){return false;}else if(n.isArtificial){return true;}else{return C.prototype.hasChildren.call(this,n.context);}};
d.prototype.resetData=function(o,p){var r=C.prototype.resetData.call(this,o,p);this._aRowIndexMap=[];this._oRootNode=undefined;this._iPageSize=0;this._iThreshold=0;if(!p||p.reason!==b.Sort){this.clearSelection();this._createTreeState(true);}return r;};
d.prototype._calculateGroupID=function(n){var B=this.getPath();var g;if(n.context){var s=n.context.getPath();if(B!="/"){var m=s.match(B+"(.*)");if(m!=null&&m[1]){g=m[1];}else{L.warning("CTBA: BindingPath/ContextPath matching problem!");}}if(!g){g=s;}if(g.startsWith("/")){g=g.substring(1,g.length);}var p;if(!n.parent){p=this._calculateGroupID({context:n.context._parentContext||null});}else{p=n.parent.groupID;}g=p+g.replace(/\//g,"_")+"/";}else if(n.context===null){g="/";}return g;};
d.prototype.expand=function(){this._buildTree();a.prototype.expand.apply(this,arguments);};
d.prototype.collapse=function(){this._buildTree();a.prototype.collapse.apply(this,arguments);};
d.prototype._buildTree=function(s,l){if(this._invalidTree){s=s||0;l=l||this.getRootContexts().length;this._invalidTree=false;this._aRowIndexMap=[];a.prototype._buildTree.call(this,s,l);}};
d.prototype.findNode=function(){this._buildTree();return a.prototype.findNode.apply(this,arguments);};
d.prototype.setSelectedIndex=function(){this._buildTree();return a.prototype.setSelectedIndex.apply(this,arguments);};
d.prototype.setSelectionInterval=function(){this._buildTree();return a.prototype.setSelectionInterval.apply(this,arguments);};
d.prototype.addSelectionInterval=function(){this._buildTree();a.prototype.addSelectionInterval.apply(this,arguments);};
d.prototype.removeSelectionInterval=function(){this._buildTree();a.prototype.removeSelectionInterval.apply(this,arguments);};
d.prototype.clearSelection=function(){this._buildTree();a.prototype.clearSelection.apply(this,arguments);};
d.prototype.selectAll=function(){this._buildTree();a.prototype.selectAll.apply(this,arguments);};
d.prototype._calculateRequestLength=function(m,s){return m;};
d.prototype.getLength=function(){this._buildTree();return a.prototype.getLength.apply(this,arguments);};
d.prototype._fireChange=function(){this._invalidTree=true;this.constructor.prototype._fireChange.apply(this,arguments);};
return d;},true);
sap.ui.predefine('sap/ui/model/MetaModel',['./Model'],function(M){"use strict";
var a=M.extend("sap.ui.model.MetaModel",{constructor:function(){M.apply(this,arguments);}});
a.prototype.createBindingContext=function(p,c,P,C){if(typeof c=="function"){C=c;c=null;}if(typeof P=="function"){C=P;P=null;}var s=this.resolve(p,c),n=(s==undefined)?undefined:this.getContext(s?s:"/");if(!n){n=null;}if(C){C(n);}return n;};
a.prototype.destroyBindingContext=function(c){};
return a;});
sap.ui.predefine('sap/ui/model/SelectionModel',['sap/ui/base/EventProvider',"sap/base/assert"],function(E,c){"use strict";
var S=E.extend("sap.ui.model.SelectionModel",{constructor:function(s){E.apply(this);this.iSelectionMode=s||S.SINGLE_SELECTION;this.aSelectedIndices=[];this.iLeadIndex=-1;this.fnSort=function(a,b){return a-b;};this.fnSortReverse=function(a,b){return b-a;};}});
S.SINGLE_SELECTION=0;S.MULTI_SELECTION=1;
S.prototype.getSelectionMode=function(){return this.iSelectionMode;};
S.prototype.setSelectionMode=function(s){this.iSelectionMode=s||S.SINGLE_SELECTION;};
S.prototype.isSelectedIndex=function(i){return this.aSelectedIndices.indexOf(i)!==-1;};
S.prototype.getLeadSelectedIndex=function(){return this.iLeadIndex;};
S.prototype.setLeadSelectedIndex=function(l){c(typeof l==="number","iLeadIndex must be an integer");this.setSelectionInterval(l,l);return this;};
S.prototype.getMinSelectionIndex=function(){if(this.aSelectedIndices.length>0){var i=this.aSelectedIndices.sort(this.fnSort);return i[0];}else{return-1;}};
S.prototype.getMaxSelectionIndex=function(){if(this.aSelectedIndices.length>0){var i=this.aSelectedIndices.sort(this.fnSortReverse);return i[0];}else{return-1;}};
S.prototype.getSelectedIndices=function(){var i=this.aSelectedIndices.sort(this.fnSort);return i;};
S.prototype.setSelectionInterval=function(f,t){c(typeof f==="number","iFromIndex must be an integer");c(typeof t==="number","iToIndex must be an integer");if(this.iSelectionMode===S.SINGLE_SELECTION){f=t;}var F=Math.min(f,t);var T=Math.max(f,t);var o=this.aSelectedIndices.slice();var l={};var C=[];for(var i=0;i<o.length;i++){l[o[i]]=true;if(o[i]<f||o[i]>t){C.push(o[i]);}}var s=[];for(var I=F;I<=T;I++){s.push(I);if(!l[I]){C.push(I);}}this._update(s,t,C);return this;};
S.prototype.addSelectionInterval=function(f,t){c(typeof f==="number","iFromIndex must be an integer");c(typeof t==="number","iToIndex must be an integer");if(this.iSelectionMode===S.SINGLE_SELECTION){return this.setSelectionInterval(f,t);}var F=Math.min(f,t);var T=Math.max(f,t);var C=[];var s=this.aSelectedIndices;for(var i=F;i<=T;i++){if(s.indexOf(i)===-1){s.push(i);C.push(i);}}this._update(s,T,C);return this;};
S.prototype.moveSelectionInterval=function(s,m){c(typeof s==="number","iFromIndex must be an integer");c(typeof m==="number","iToIndex must be an integer");var C=[];var a=this.aSelectedIndices;var l=this.iLeadIndex;for(var i=0;i<a.length;i++){var I=a[i];if(I>=s){C.push(a[i]);a[i]+=m;C.push(a[i]);if(I===this.iLeadIndex){l+=m;}}}this._update(a,l,C);return this;};
S.prototype.removeSelectionInterval=function(f,t){c(typeof f==="number","iFromIndex must be an integer");c(typeof t==="number","iToIndex must be an integer");if(this.iSelectionMode===S.SINGLE_SELECTION){f=t;}var F=Math.min(f,t);var T=Math.max(f,t);var C=[];var s=this.aSelectedIndices;var l=this.iLeadIndex;for(var i=F;i<=T;i++){var I=s.indexOf(i);if(I>-1){s.splice(I,1);C.push(i);}if(i===this.iLeadIndex){l=-1;}}this._update(s,l,C);return this;};
S.prototype.sliceSelectionInterval=function(f,t){c(typeof f==="number","iFromIndex must be an integer");c(typeof t==="number","iToIndex must be an integer");var F=Math.min(f,t);var T=Math.max(f,t);var C=[];var r=[];var o=this.aSelectedIndices.slice(0);var s=this.aSelectedIndices;var l=this.iLeadIndex;var R=T-F+1;for(var I=T;I>=F;I--){var a=s.indexOf(I);if(a>-1){s.splice(a,1);r.push(I);}if(I===this.iLeadIndex){l=-1;}}for(var I=0;I<s.length;I++){var O=s[I];if(O>=F){var n=s[I]-R;if(O===l){l=n;}s[I]=n;if(o.indexOf(n)===-1){C.push(n);}}}for(var i=0;i<r.length;i++){var I=o[o.length-1-i];if(C.indexOf(I)===-1){C.push(I);}}for(var i=0;i<r.length;i++){if(s.indexOf(r[i])===-1&&C.indexOf(r[i])===-1){C.push(r[i]);}}this._update(s,l,C);return this;};
S.prototype.clearSelection=function(){if(this.aSelectedIndices.length>0||this.iLeadIndex!==-1){this._update([],-1,this.aSelectedIndices.slice());}return this;};
S.prototype.attachSelectionChanged=function(d,f,l){this.attachEvent("selectionChanged",d,f,l);return this;};
S.prototype.detachSelectionChanged=function(f,l){this.detachEvent("selectionChanged",f,l);return this;};
S.prototype.fireSelectionChanged=function(p){this.fireEvent("selectionChanged",p);return this;};
S.prototype._update=function(s,l,C,b){var p={rowIndices:C&&C.sort(this.fnSort),selectAll:b};this.aSelectedIndices=s;p.oldIndex=this.iLeadIndex;if(this.iLeadIndex!==l){this.iLeadIndex=l;p.leadIndex=this.iLeadIndex;}if(C.length>0||typeof p.leadIndex!=="undefined"){this.fireSelectionChanged(p);}};
S.prototype.selectAll=function(t){c(typeof t==="number","iToIndex must be an integer");var o=this.aSelectedIndices.slice();var l={};var C=[];var s=[];var i=0;for(i=0;i<o.length;i++){l[o[i]]=true;if(o[i]>t){C.push(o[i]);}}for(i=0;i<=t;i++){s.push(i);if(!l[i]){C.push(i);}}this._update(s,0,C,true);return this;};
return S;});
sap.ui.predefine('sap/ui/model/TreeAutoExpandMode',[],function(){"use strict";var T={Sequential:"Sequential",Bundled:"Bundled"};return T;},true);
sap.ui.predefine('sap/ui/model/TreeBindingAdapter',['sap/ui/model/TreeBinding','sap/ui/model/TreeAutoExpandMode','sap/ui/model/ChangeReason','sap/ui/model/TreeBindingUtils',"sap/base/assert","sap/base/Log","sap/base/util/each","sap/base/util/isEmptyObject"],function(T,c,C,d,e,L,f,g){"use strict";var h=function(){if(!(this instanceof T)||this._bIsAdapted){return;}for(var a in h.prototype){if(h.prototype.hasOwnProperty(a)){this[a]=h.prototype[a];}}this.mParameters=this.mParameters||{};this._aRowIndexMap=[];this._iThreshold=0;this._iPageSize=0;this.setAutoExpandMode(this.mParameters.autoExpandMode||c.Sequential);if(this.mParameters.collapseRecursive===undefined){this.bCollapseRecursive=true;}else{this.bCollapseRecursive=!!this.mParameters.collapseRecursive;}this._createTreeState();this._bIsAdapted=true;};
h.prototype.getCurrentTreeState=function(){var D=";";var E={};for(var G in this._mTreeState.expanded){E[G]=true;}var m={};for(var G in this._mTreeState.collapsed){m[G]=true;}var s={};for(var G in this._mTreeState.selected){s[G]=true;}return{_getExpandedList:function(){return Object.keys(E).join(D);},_getCollapsedList:function(){return Object.keys(m).join(D);},_getSelectedList:function(){return Object.keys(s).join(D);},_isExpanded:function(G){return!!E[G];},_isCollapsed:function(G){return!!m[G];},_remove:function(G){delete E[G];delete m[G];delete s[G];}};};
h.prototype.setTreeState=function(t){this._oInitialTreeState=t;};
h.prototype.setAutoExpandMode=function(a){this._autoExpandMode=a;};
h.prototype.getLength=function(){if(!this._oRootNode){return 0;}return this._oRootNode.magnitude;};
h.prototype.getContextByIndex=function(i){if(this.isInitial()){return;}var n=this.findNode(i);return n?n.context:undefined;};
h.prototype.getNodeByIndex=function(i){if(this.isInitial()){return;}if(i>=this.getLength()){return undefined;}return this.findNode(i);};
h.prototype.findNode=function(p){if(this.isInitial()){return;}var P=typeof p;var F;var s=[];if(P==="number"){F=this._aRowIndexMap[p];if(!F){var i=-1;this._match(this._oRootNode,s,1,function(n){if(i===p){return true;}i+=1;});F=s[0];}}return F;};
h.prototype._createTreeState=function(r){if(!this._mTreeState||r){this._mTreeState={expanded:{},collapsed:{},selected:{},deselected:{}};}};
h.prototype._updateTreeState=function(p){p=p||{};var t=p.expanded?this._mTreeState.expanded:this._mTreeState.collapsed;var s=p.expanded?this._mTreeState.collapsed:this._mTreeState.expanded;var n=this._getNodeState(p.groupID);if(!n){n=p.fallbackNodeState||this._createNodeState({groupID:p.groupID,expanded:p.expanded,sum:p.sum});}delete s[p.groupID];t[p.groupID]=n;n.expanded=p.expanded;return n;};
h.prototype._createNodeState=function(p){if(!p.groupID){e(false,"To create a node state a group ID is mandatory!");return;}var i;var I;if(this._oInitialTreeState){i=this._oInitialTreeState._isExpanded(p.groupID);I=this._oInitialTreeState._isCollapsed(p.groupID);this._oInitialTreeState._remove(p.groupID);}var b=p.expanded||i||false;var a=p.selected||false;var n={groupID:p.groupID,expanded:b,sections:p.sections||[{startIndex:0,length:this._iPageSize}],sum:p.sum||false,selected:a};if(i||I){this._updateTreeState({groupID:p.groupID,fallbackNodeState:n,expanded:i,collapsed:I});}return n;};
h.prototype._getNodeState=function(G){var E=this._mTreeState.expanded[G];var o=this._mTreeState.collapsed[G];var s=this._mTreeState.selected[G];var D=this._mTreeState.deselected[G];return E||o||s||D;};
h.prototype._updateNodeSections=function(G,n){var N=this._getNodeState(G);if(!N){e(false,"No Node State for Group ID '"+G+"' found!");return;}else if(!n){e(false,"No Section given!");return;}else if(n.length<=0){e(false,"The length of the given section must be positive greater than 0.");return;}else if(n.startIndex<0){e(false,"The sections start index must be greater/equal to 0.");return;}N.sections=d.mergeSections(N.sections,n);return N.sections;};
h.prototype._increaseSections=function(){var I=function(n){if(!n){return;}var m=this._getMaxGroupSize(n);var N=n.nodeState;if(m===undefined){var a=[];for(var i=0;i<N.sections.length;i++){var o=N.sections[i];o.length=Math.max(o.length,this._iPageSize);a=d.mergeSections(a,o);}N.sections=a;}};this._map(this._oRootNode,I);};
h.prototype._getMaxGroupSize=function(n){var m=0;if(n.isArtificial){var i=this.oModel.isList(this.sPath,this.getContext());if(this.bDisplayRootNode&&!i&&!this._bRootMissing){m=1;}else{m=this._getGroupSize(n)||0;}}else{m=this.nodeHasChildren(n)?this._getGroupSize(n):0;}return m;};
h.prototype.getContexts=function(s,l,t,r){if(this.isInitial()){return[];}if(!l){l=this.oModel.iSizeLimit;}if(!t){t=0;}if(l>this._iPageSize){this._iPageSize=l;this._increaseSections();}this._iThreshold=Math.max(this._iThreshold,t);this._aRowIndexMap=[];this._buildTree(s,l);var n=[];if(this._oRootNode){n=this._retrieveNodeSection(this._oRootNode,s,l);}this._updateRowIndexMap(n,s);var a=[];var m;for(var i=0;i<n.length;i++){var N=n[i];if(!N.context){m=m||{};var p=N.parent;m[p.groupID]=p;this._updateNodeSections(p.groupID,{startIndex:N.positionInParent,length:1});}a.push(N.context);}if(m){var b=this;f(m,function(G,N){N.magnitude=0;N.numberOfTotals=0;b._loadChildContexts(N);});a=[];for(var j=0;j<n.length;j++){var N=n[j];a.push(N.context);}}if(r){return n;}else{return a;}};
h.prototype.getNodes=function(s,l,t){return this.getContexts(s,l,t,true);};
h.prototype._updateRowIndexMap=function(n,s){this._aRowIndexMap=[];for(var i=0;i<n.length;i++){this._aRowIndexMap[s+i]=n[i];}};
h.prototype._retrieveNodeSection=function(n,s,l){var N=-1;var a=[];this._match(this._oRootNode,[],l,function(n,p,P){if(!n||!n.isArtificial){N++;}if(N>=s&&N<s+l){if(!n){n=this._createNode({parent:P,positionInParent:p});P.children[p]=n;}a.push(n);return true;}});return a;};
h.prototype._buildTree=function(s,l){this._oRootNode=undefined;var r=null;var R=this._calculateGroupID({context:r,parent:null});var o=this._getNodeState(R);if(!o){var o=this._createNodeState({groupID:R,sum:true,sections:[{startIndex:s,length:l}]});this._updateTreeState({groupID:o.groupID,fallbackNodeState:o,expanded:true});}this._oRootNode=this._createNode({context:r,parent:null,level:this.bDisplayRootNode&&!(r===null)?0:-1,nodeState:o,isLeaf:false,autoExpand:this.getNumberOfExpandedLevels()+1});this._oRootNode.isArtificial=true;if(this._mTreeState.expanded[this._oRootNode.groupID]){this._loadChildContexts(this._oRootNode);}};
h.prototype._calculateRequestLength=function(m,s){var r;if(!m){r=s.length;}else{r=Math.max(Math.min(s.length,m-s.startIndex),0);}return r;};
h.prototype._loadChildContexts=function(n){var N=n.nodeState;var m=this._getMaxGroupSize(n);if(m>0){if(!n.children[m-1]){n.children[m-1]=undefined;}N.leafCount=m;}if(this.bClientOperation){N.sections=[{startIndex:0,length:m}];}for(var i=0;i<N.sections.length;i++){var o=N.sections[i];var r=this._calculateRequestLength(m,o);if(n.autoExpand>=0&&this._autoExpandMode===c.Bundled){r=Math.max(0,m);}var a;if(n.isArtificial){a=this.getRootContexts(o.startIndex,r,this._iThreshold);}else{a=this.nodeHasChildren(n)?this.getNodeContexts(n.context,o.startIndex,r,this._iThreshold):[];}for(var j=0;j<a.length;j++){var b=a[j];if(!b){continue;}var k=j+o.startIndex;var l=n.children[k];var u={context:a[j],parent:n,level:n.level+1,positionInParent:k,autoExpand:Math.max(n.autoExpand-1,-1)};if(l){l.context=u.context;l.parent=u.parent;l.level=u.level;l.positionInParent=u.positionInParent;l.magnitude=0;l.numberOfTotals=0;l.autoExpand=u.autoExpand;var G;if(b){G=this._calculateGroupID(l);}l.groupID=G;}else{l=this._createNode(u);}l.nodeState=this._getNodeState(l.groupID);if(!l.nodeState){l.nodeState=this._createNodeState({groupID:l.groupID,expanded:false});}l.nodeState.parentGroupID=n.groupID;l.isLeaf=!this.nodeHasChildren(l);n.children[k]=l;if(l.isLeaf){n.numberOfLeafs+=1;}if(l.parent.nodeState.selectAllMode&&!this._mTreeState.deselected[l.groupID]){this.setNodeSelection(l.nodeState,true);}if((l.autoExpand>0||l.nodeState.expanded)&&this.isGrouped()){if(!this._mTreeState.collapsed[l.groupID]&&!l.isLeaf){this._updateTreeState({groupID:l.nodeState.groupID,fallbackNodeState:l.nodeState,expanded:true});this._loadChildContexts(l);}n.magnitude+=Math.max(l.magnitude||0,0);n.numberOfLeafs+=l.numberOfLeafs;}}}n.magnitude+=Math.max(m||0,0);};
h.prototype.isGrouped=function(){return true;};
h.prototype._calculateGroupID=function(n){L.error("TreeBindingAdapter#_calculateGroupID: Not implemented. Needs to be implemented in respective sub-classes.");};
h.prototype._createNode=function(p){p=p||{};var o=p.context;var l=p.level||0;var n={context:o,level:l,children:p.children||[],parent:p.parent,nodeState:p.nodeState,isLeaf:p.isLeaf||false,positionInParent:p.positionInParent,magnitude:p.magnitude||0,numberOfTotals:p.numberOfTotals||0,numberOfLeafs:p.numberOfLeafs||0,autoExpand:p.autoExpand||0,absoluteNodeIndex:p.absoluteNodeIndex||0,totalNumberOfLeafs:0};if(o!==undefined){n.groupID=this._calculateGroupID(n);}return n;};
h.prototype.expand=function(i,s){var n=this.findNode(i);if(!n){e(false,"No node found for index "+i);return;}this._updateTreeState({groupID:n.nodeState.groupID,fallbackNodeState:n.nodeState,expanded:true});if(!s){this._fireChange({reason:C.Expand});}};
h.prototype.expandToLevel=function(l){this._mTreeState.collapsed={};this.setNumberOfExpandedLevels(l);this._fireChange({reason:C.Expand});};
h.prototype.isExpanded=function(i){var n=this.findNode(i);return n&&n.nodeState?n.nodeState.expanded:false;};
h.prototype.collapse=function(p,s){var n;var t=this;if(typeof p==="object"){n=p;}else if(typeof p==="number"){var N=this.findNode(p);if(!N){e(false,"No node found for index "+p);return;}n=N.nodeState;}this._updateTreeState({groupID:n.groupID,fallbackNodeState:n,expanded:false});n.selectAllMode=false;if(this.bCollapseRecursive){var G=n.groupID;f(this._mTreeState.expanded,function(b,o){if(typeof G=="string"&&G.length>0&&b.startsWith(G)){t._updateTreeState({groupID:b,expanded:false});}});var D=[];f(this._mTreeState.selected,function(b,o){if(typeof G=="string"&&G.length>0&&b.startsWith(G)&&b!==G){o.selectAllMode=false;t.setNodeSelection(o,false);D.push(b);}});if(D.length){var a={rowIndices:[]};var i=-1;this._map(this._oRootNode,function(N){if(!N||!N.isArtificial){i++;}if(N&&D.indexOf(N.groupID)!==-1){if(N.groupID===this._sLeadSelectionGroupID){a.oldIndex=i;a.leadIndex=-1;}a.rowIndices.push(i);}});this._publishSelectionChanges(a);}}if(!s){this._fireChange({reason:C.Collapse});}};
h.prototype.collapseToLevel=function(l){if(!l||l<0){l=0;}var t=this;f(this._mTreeState.expanded,function(G,n){var N=t._getGroupIdLevel(G)-1;if(N===l){t.collapse(n,true);}});this._fireChange({reason:C.Collapse});};
h.prototype._map=function(n,m){m.call(this,n);if(!n){return;}for(var i=0;i<n.children.length;i++){var o=n.children[i];this._map(o,m);}if(this._afterMapHook){this._afterMapHook(n,m);}};
h.prototype._match=function(n,r,m,M,p,P){if(r.length===m){return true;}var N=M.call(this,n,p,P);if(N){r.push(n);}if(!n){return false;}for(var i=0;i<n.children.length;i++){var o=n.children[i];var b=this._match(o,r,m,M,i,n);if(b){return true;}}return this._afterMatchHook?this._afterMatchHook(n,r,m,M,p,P):false;};
h.prototype.toggleIndex=function(i){var n=this.findNode(i);if(!n){e(false,"There is no node at index "+i+".");return;}if(n.nodeState.expanded){this.collapse(i);}else{this.expand(i);}};
h.prototype._getGroupIdLevel=function(G){if(G==null){L.warning("assertion failed: no need to determine level of group ID = null");return-1;}return G.split("/").length-2;};
h.prototype._getGroupSize=function(n){return this.getChildCount(n.context);};
h.prototype.setNodeSelection=function(n,i){if(!n.groupID){e(false,"NodeState must have a group ID!");return;}n.selected=i;if(i){this._mTreeState.selected[n.groupID]=n;delete this._mTreeState.deselected[n.groupID];}else{delete this._mTreeState.selected[n.groupID];this._mTreeState.deselected[n.groupID]=n;}};
h.prototype.isIndexSelected=function(r){var n=this.getNodeByIndex(r);return n&&n.nodeState?n.nodeState.selected:false;};
h.prototype.isIndexSelectable=function(r){var n=this.getNodeByIndex(r);return this._isNodeSelectable(n);};
h.prototype._isNodeSelectable=function(n){return!!n&&!n.isArtificial;};
h.prototype.setSelectedIndex=function(r){var n=this.findNode(r);if(n&&this._isNodeSelectable(n)){var o=this._clearSelection();var i=o.rowIndices.indexOf(r);if(i>=0){o.rowIndices.splice(i,1);}else{o.rowIndices.push(r);}o.leadGroupID=n.groupID;o.leadIndex=r;this.setNodeSelection(n.nodeState,true);this._publishSelectionChanges(o);}else{L.warning("TreeBindingAdapter: The selection was ignored. Please make sure to only select rows, for which data has been fetched to the client. For AnalyticalTables, some rows might not be selectable at all.");}};
h.prototype.getSelectedIndex=function(){if(!this._sLeadSelectionGroupID||g(this._mTreeState.selected)){return-1;}var n=-1;var a=false;var m=function(N){if(!N||!N.isArtificial){n++;}if(N){if(N.groupID===this._sLeadSelectionGroupID){a=true;return true;}}};this._match(this._oRootNode,[],1,m);if(a){return n;}return-1;};
h.prototype.getSelectedIndices=function(){var r=[];var t=this;if(g(this._mTreeState.selected)){return r;}var n=Object.keys(this._mTreeState.selected).length;var N=-1;var m=function(o){if(!o||!o.isArtificial){N++;}if(o){if(o.nodeState&&o.nodeState.selected&&!o.isArtificial){r.push(N);t._aRowIndexMap[N]=o;return true;}}};this._match(this._oRootNode,[],n,m);return r;};
h.prototype.getSelectedNodesCount=function(){var s;if(this._oRootNode&&this._oRootNode.nodeState.selectAllMode){var G,v,p,o;var a,V=[];if(this.filterInfo&&this.oCombinedFilter){for(var i=this.filterInfo.aFilteredContexts.length-1;i>=0;i--){a=this.filterInfo.aFilteredContexts[i];V.push(this._calculateGroupID({context:a}));}}v=0;for(G in this._mTreeState.expanded){if(!this.oCombinedFilter||V.indexOf(G)!==-1){o=this._mTreeState.expanded[G];if(!o.selectAllMode&&o.leafCount!==undefined){v+=o.leafCount;}}}for(G in this._mTreeState.selected){if(!this.oCombinedFilter||V.indexOf(G)!==-1){o=this._mTreeState.selected[G];p=this._mTreeState.expanded[o.parentGroupID];if(p&&!p.selectAllMode){v--;}}}for(G in this._mTreeState.deselected){if(!this.oCombinedFilter||V.indexOf(G)!==-1){o=this._mTreeState.deselected[G];p=this._mTreeState.expanded[o.parentGroupID];if(p&&p.selectAllMode){v++;}}}s=this._getSelectableNodesCount(this._oRootNode)-v;}else{s=Object.keys(this._mTreeState.selected).length;}return s;};
h.prototype._getSelectableNodesCount=function(n){if(n){return n.magnitude;}else{return 0;}};
h.prototype.getSelectedContexts=function(){var r=[];var t=this;if(g(this._mTreeState.selected)){return r;}var n=Object.keys(this._mTreeState.selected).length;var N=-1;var m=function(o){if(!o||!o.isArtificial){N++;}if(o){if(o.nodeState&&o.nodeState.selected&&!o.isArtificial){r.push(o.context);t._aRowIndexMap[N]=o;return true;}}};this._match(this._oRootNode,[],n,m);return r;};
h.prototype.setSelectionInterval=function(F,t){var m=this._clearSelection();var s=this._setSelectionInterval(F,t,true);var I={};var r=[];for(var i=0;i<m.rowIndices.length;i++){var a=m.rowIndices[i];I[a]=true;}for(i=0;i<s.rowIndices.length;i++){a=s.rowIndices[i];if(I[a]){delete I[a];}else{I[a]=true;}}for(a in I){if(I[a]){r.push(parseInt(a));}}this._publishSelectionChanges({rowIndices:r,oldIndex:m.oldIndex,leadIndex:s.leadIndex,leadGroupID:s.leadGroupID});};
h.prototype._setSelectionInterval=function(F,t,s){var n=Math.min(F,t);var N=Math.max(F,t);var a=[];var b=[];var i=Math.abs(N-n)+1;var o;var j=-1;var m=function(k){if(!k||!k.isArtificial){j++;}if(k){if(j>=n&&j<=N){if(this._isNodeSelectable(k)){if(k.nodeState.selected!==!!s){b.push(j);}if(k.groupID===this._sLeadSelectionGroupID){o=j;}this.setNodeSelection(k.nodeState,!!s);}return true;}}};this._match(this._oRootNode,a,i,m);var p={rowIndices:b,oldIndex:o,leadIndex:o&&!s?-1:undefined};if(a.length>0&&s){var l=a[a.length-1];p.leadGroupID=l.groupID;p.leadIndex=N;}return p;};
h.prototype.addSelectionInterval=function(F,t){var p=this._setSelectionInterval(F,t,true);this._publishSelectionChanges(p);};
h.prototype.removeSelectionInterval=function(F,t){var p=this._setSelectionInterval(F,t,false);this._publishSelectionChanges(p);};
h.prototype.selectAll=function(){this._mTreeState.deselected={};var p={rowIndices:[],oldIndex:-1,selectAll:true};var n=-1;this._map(this._oRootNode,function(N){if(!N||!N.isArtificial){n++;}if(N){if(N.groupID===this._sLeadSelectionGroupID){p.oldIndex=n;}if(this._isNodeSelectable(N)){if(N.nodeState.selected!==true){p.rowIndices.push(n);}this.setNodeSelection(N.nodeState,true);p.leadGroupID=N.groupID;p.leadIndex=n;}if(N.nodeState.expanded){N.nodeState.selectAllMode=true;}}});this._publishSelectionChanges(p);};
h.prototype._clearSelection=function(){var n=-1;var o=-1;var m;var a=[];if(this._oRootNode&&!this._oRootNode.nodeState.selectAllMode){m=0;for(var G in this._mTreeState.selected){if(G){m++;}}}var M=function(N){if(!N||!N.isArtificial){n++;}if(N){N.nodeState.selectAllMode=false;if(this._mTreeState.selected[N.groupID]){if(!N.isArtificial){a.push(n);}this.setNodeSelection(N.nodeState,false);if(N.groupID===this._sLeadSelectionGroupID){o=n;}return true;}}};this._match(this._oRootNode,[],m,M);if(this._oRootNode&&this._oRootNode.nodeState&&this._oRootNode.isArtificial){this._oRootNode.nodeState.selectAllMode=false;}return{rowIndices:a,oldIndex:o,leadIndex:-1};};
h.prototype.clearSelection=function(s){var o=this._clearSelection();if(!s){this._publishSelectionChanges(o);}};
h.prototype._publishSelectionChanges=function(p){p.oldIndex=p.oldIndex||this.getSelectedIndex();p.rowIndices.sort(function(a,b){return a-b;});if(p.leadIndex>=0&&p.leadGroupID){this._sLeadSelectionGroupID=p.leadGroupID;}else if(p.leadIndex===-1){this._sLeadSelectionGroupID=undefined;}else{p.leadIndex=p.oldIndex;}if(p.rowIndices.length>0||(p.leadIndex!=undefined&&p.leadIndex!==-1)){this.fireSelectionChanged(p);}};
h.prototype.setCollapseRecursive=function(b){this.bCollapseRecursive=!!b;};
h.prototype.getCollapseRecursive=function(){return this.bCollapseRecursive;};
h.prototype.attachSelectionChanged=function(D,F,l){this.attachEvent("selectionChanged",D,F,l);return this;};
h.prototype.detachSelectionChanged=function(F,l){this.detachEvent("selectionChanged",F,l);return this;};
h.prototype.fireSelectionChanged=function(p){this.fireEvent("selectionChanged",p);return this;};
return h;},true);
sap.ui.predefine('sap/ui/model/TreeBindingCompatibilityAdapter',["sap/base/util/each"],function(e){"use strict";var T=function(b,t){var a=t;Object.assign(b,{_init:function(E){this._bExpandFirstLevel=E;this.mContextInfo={};this._initContexts();if(E&&!this._bFirstLevelExpanded){this._expandFirstLevel();}},_initContexts:function(s){this.aContexts=this.getRootContexts(0,Number.MAX_VALUE);for(var i=0,l=this.aContexts.length;i<l;i++){var o=this._getContextInfo(this.aContexts[i]);this._setContextInfo({oContext:this.aContexts[i],iLevel:0,bExpanded:o?o.bExpanded:false});}if(this._bExpandFirstLevel&&!this._bFirstLevelExpanded){this._expandFirstLevel(s);}},_expandFirstLevel:function(s){var a=this;if(this.aContexts&&this.aContexts.length>0){e(this.aContexts.slice(),function(i,c){if(!s){a._loadChildContexts(c);}a._getContextInfo(c).bExpanded=true;});this._bFirstLevelExpanded=true;}},_fnFireFilter:b._fireFilter,_fireFilter:function(){this._fnFireFilter.apply(this,arguments);this._initContexts(true);this._restoreContexts(this.aContexts);},_fnFireChange:b._fireChange,_fireChange:function(){this._fnFireChange.apply(this,arguments);this._initContexts(true);this._restoreContexts(this.aContexts);},_restoreContexts:function(c){var a=this;var n=[];e(c.slice(),function(i,C){var o=a._getContextInfo(C);if(o&&o.bExpanded){n.push.apply(n,a._loadChildContexts(C));}});if(n.length>0){this._restoreContexts(n);}},_loadChildContexts:function(c){var C=this._getContextInfo(c);var I=(this.aContexts?this.aContexts.indexOf(c):-1);var n=this.getNodeContexts(c,0,Number.MAX_VALUE);for(var i=0,l=n.length;i<l;i++){this.aContexts.splice(I+i+1,0,n[i]);var o=this._getContextInfo(n[i]);this._setContextInfo({oParentContext:c,oContext:n[i],iLevel:C.iLevel+1,bExpanded:o?o.bExpanded:false});}return n;},_getContextInfo:function(c){return c?this.mContextInfo[c.getPath()]:undefined;},_setContextInfo:function(d){if(d&&d.oContext){this.mContextInfo[d.oContext.getPath()]=d;}},getLength:function(){return this.aContexts?this.aContexts.length:0;},getContexts:function(s,l){return this.aContexts.slice(s,s+l);},getNodes:function(s,l){var c=this.getContexts(s,s+l);var n=[];for(var i=0;i<c.length;i++){var C=this._getContextInfo(c[i])||{};var o=c[i];n.push({context:o,level:C.iLevel,parent:C.oParentContext,nodeState:{expanded:C.bExpanded,collapsed:!C.bExpanded,selected:false}});}return n;},hasChildren:function(){return true;},nodeHasChildren:function(){return true;},getContextByIndex:function(r){return this.aContexts[r];},getLevel:function(c){var C=this._getContextInfo(c);return C?C.iLevel:-1;},isExpanded:function(r){var c=this.getContextByIndex(r);var C=this._getContextInfo(c);return C?C.bExpanded:false;},expandContext:function(c){var C=this._getContextInfo(c);if(C&&!C.bExpanded){this.storeSelection();this._loadChildContexts(c);C.bExpanded=true;this._fireChange();this.restoreSelection();}},expand:function(r){this.expandContext(this.getContextByIndex(r));},collapseContext:function(c,s){var C=this._getContextInfo(c);if(C&&C.bExpanded){this.storeSelection();for(var i=this.aContexts.length-1;i>0;i--){if(this._getContextInfo(this.aContexts[i]).oParentContext===c){this.aContexts.splice(i,1);}}C.bExpanded=false;if(!s){this._fireChange();}this.restoreSelection();}},collapse:function(r){this.collapseContext(this.getContextByIndex(r));},collapseToLevel:function(l){if(!l||l<0){l=0;}var c=this.aContexts.slice();for(var i=c.length-1;i>=0;i--){var C=this.getLevel(c[i]);if(C!=-1&&C>=l){this.collapseContext(c[i],true);}}this._fireChange();},toggleContext:function(c){var C=this._getContextInfo(c);if(C){if(C.bExpanded){this.collapseContext(c);}else{this.expandContext(c);}}},toggleIndex:function(r){this.toggleContext(this.getContextByIndex(r));},storeSelection:function(){var s=a.getSelectedIndices();var S=[];e(s,function(i,v){S.push(a.getContextByIndex(v));});this._aSelectedContexts=S;},restoreSelection:function(){a.clearSelection();var _=this._aSelectedContexts;e(this.aContexts,function(i,c){if(((_?_.indexOf(c):-1))>=0){a.addSelectionInterval(i,i);}});this._aSelectedContexts=undefined;},attachSelectionChanged:function(){return undefined;},detachSelectionChanged:function(){},clearSelection:function(){a._oSelection.clearSelection();},attachSort:function(){},detachSort:function(){}});b._init(t.getExpandFirstLevel());};return T;},true);
sap.ui.predefine('sap/ui/model/TreeBindingUtils',function(){"use strict";var T=function(){};
T.mergeSections=function(s,n){var N=[];for(var i=0;i<s.length;i++){var c=s[i];var C=c.startIndex+c.length;var a=n.startIndex+n.length;if(n.startIndex<=C&&a>=C&&n.startIndex>=c.startIndex){n.startIndex=c.startIndex;n.length=a-c.startIndex;}else if(n.startIndex<=c.startIndex&&a>=c.startIndex&&a<=C){n.length=C-n.startIndex;}else if(n.startIndex>=c.startIndex&&a<=C){n.startIndex=c.startIndex;n.length=c.length;}else if(a<c.startIndex||n.startIndex>C){N.push(c);}}N.push(n);return N;};
T._determineRequestDelta=function(n,p){var N=n.iSkip+n.iTop;var P=p.iSkip+p.iTop;if(n.iSkip===p.iSkip&&n.iTop===p.iTop){return false;}else if(n.iSkip<p.iSkip&&N>p.iSkip&&N<=P){n.iTop=p.iSkip-n.iSkip;if(n.iThreshold){n.iTop=n.iTop+n.iThreshold;n.iSkip=Math.max(0,n.iSkip-n.iThreshold);n.iThreshold=0;}}else if(n.iSkip<P&&N>P&&n.iSkip>=p.iSkip){n.iSkip=P;n.iTop=N-n.iSkip;if(n.iThreshold){n.iTop+=n.iThreshold;n.iThreshold=0;}}else if(n.iSkip>=p.iSkip&&N<=P){return false;}else if(n.iSkip<=p.iSkip&&N>=P){p.oRequestHandle.abort();}else if(N<=p.iSkip||n.iSkip>=P){}};
return T;});
sap.ui.predefine('sap/ui/model/analytics/AnalyticalBinding',['sap/ui/model/TreeBinding','sap/ui/model/ChangeReason','sap/ui/model/Filter','sap/ui/model/FilterOperator','sap/ui/model/FilterProcessor','sap/ui/model/FilterType','sap/ui/model/Sorter','sap/ui/model/odata/CountMode','sap/ui/model/TreeAutoExpandMode','./odata4analytics','./BatchResponseCollector','./AnalyticalVersionInfo',"sap/base/util/uid","sap/ui/thirdparty/jquery","sap/base/Log"],function(T,C,F,a,b,c,S,d,f,t,B,A,u,Q,L){"use strict";var v="sap.ui.model.analytics.AnalyticalBinding",w=L.getLogger(v);
function x(o){var e=new t.QueryResultRequest(o.oAnalyticalQueryResult),g,s,h,i,j,m,n,p,k=o.mParameters.select.split(","),l=D(k,o.sPath);e.setAggregationLevel(o.aMaxAggregationLevel);e.setMeasures(o.aMeasureName);Object.keys(o.oDimensionDetailsSet).forEach(function(q){h=o.oDimensionDetailsSet[q];e.includeDimensionKeyTextAttributes(q,true,h.textPropertyName!==undefined,h.aAttributeName);});Object.keys(o.oMeasureDetailsSet).forEach(function(M){m=o.oMeasureDetailsSet[M];e.includeMeasureRawFormattedValueUnit(M,m.rawValuePropertyName!==undefined,m.formattedValuePropertyName!==undefined,m.unitPropertyName!==undefined);});s=e.getURIQueryOptionValue("$select");if(s){g=s.split(",");for(i=0,n=g.length;i<n;i++){p=g[i];j=k.indexOf(p);if(j<0){w.warning("Ignored the 'select' binding parameter, because"+" it does not contain the property '"+p+"'",o.sPath);l=true;}else{k.splice(j,1);}}}for(i=0,n=k.length;i<n;i++){p=k[i];h=o.oAnalyticalQueryResult.findDimensionByPropertyName(p);if(h&&o.oDimensionDetailsSet[h.getName()]===undefined){y(o.sPath,p,h);l=true;}m=o.oAnalyticalQueryResult.findMeasureByPropertyName(p);if(m&&o.oMeasureDetailsSet[m.getName()]===undefined){y(o.sPath,p,m);l=true;}}return l?[]:k;}
function y(p,s,o){var e=o instanceof sap.ui.model.analytics.odata4analytics.Dimension?"dimension":"measure";if(o.getName()===s){w.warning("Ignored the 'select' binding parameter, because it contains"+" the "+e+" property '"+s+"' which is not contained in the analytical info (see updateAnalyticalInfo)",p);}else{w.warning("Ignored the 'select' binding parameter, because the property '"+s+"' is associated with the "+e+" property '"+o.getName()+"' which is not contained in the analytical"+" info (see updateAnalyticalInfo)",p);}}
function D(s,p){var e,g=false,i,n;for(i=0,n=s.length;i<n;i++){s[i]=s[i].trim();}for(i=s.length-1;i>=0;i--){e=s[i];if(s.indexOf(e)!==i){w.warning("Ignored the 'select' binding parameter, because it"+" contains the property '"+e+"' multiple times",p);s.splice(i,1);g=true;}}return g;}
var E=T.extend("sap.ui.model.analytics.AnalyticalBinding",{constructor:function(m,p,o,s,e,P){T.call(this,m,p,o,e,P);this.aAdditionalSelects=[];this.sEntitySetName=(P&&P.entitySet)?P.entitySet:undefined;this.bArtificalRootContext=false;this.aApplicationFilter=this._convertDeprecatedFilterObjects(e);this.aControlFilter=undefined;this.aSorter=s?s:[];this.aMaxAggregationLevel=[];this.aAggregationLevel=[];this.oPendingRequests={};this.oPendingRequestHandle=[];this.oGroupedRequests={};this.bUseBatchRequests=(P&&P.useBatchRequests===true)?true:false;this.bProvideTotalSize=(P&&P.provideTotalResultSize===false)?false:true;this.bProvideGrandTotals=(P&&P.provideGrandTotals===false)?false:true;this.bReloadSingleUnitMeasures=(P&&P.reloadSingleUnitMeasures===false)?false:true;this.bUseAcceleratedAutoExpand=(P&&P.useAcceleratedAutoExpand===false)?false:true;this.bNoPaging=(P&&P.noPaging===true)?true:false;this.iTotalSize=-1;this.mServiceKey={};this.mServiceLength={};this.mServiceFinalLength={};this.mKeyIndex={};this.mFinalLength=this.mServiceFinalLength;this.mLength={};this.mMultiUnitKey={};this.aMultiUnitLoadFactor={};this.bNeedsUpdate=false;this.bApplySortersToGroups=true;this.sLastAutoExpandMode=undefined;this.mEntityKey={};this.sCustomParams=this.oModel.createCustomParams({custom:this.mParameters.custom});this.oAnalyticalQueryResult=null;this.aAnalyticalInfo=[];this.mAnalyticalInfoByProperty={};this.aBatchRequestQueue=[];if(P&&P.countMode==d.None){w.fatal("requested count mode is ignored; OData requests will include $inlinecout options");}else if(P&&(P.countMode==d.Request||P.countMode==d.Both)){w.warning("default count mode is ignored; OData requests will include $inlinecout options");}else if(this.oModel.sDefaultCountMode==d.Request){w.warning("default count mode is ignored; OData requests will include $inlinecout options");}this.iModelVersion=A.getVersion(this.oModel);if(this.iModelVersion===null){w.error("The AnalyticalBinding does not support Models other than sap.ui.model.odata.ODataModel version 1 or 2.");return;}this.aAllDimensionSortedByName=null;this.aInitialAnalyticalInfo=(P==undefined?[]:P.analyticalInfo);this.bInitial=true;}});
function G(o,e){return function(){if(!o.__supportUID){o.__supportUID=u();}return{type:v,analyticalError:e,analyticalBindingId:o.__supportUID};};}
E.prototype.setContext=function(o){var r;if(this.oContext!==o){this.oContext=o;if(!this.isRelative()){return;}this.oDataState=null;this.bApplySortersToGroups=true;this.iTotalSize=-1;this._abortAllPendingRequests();r=this.oModel.resolve(this.sPath,this.oContext);if(r){this.resetData();this._initialize();this._fireChange({reason:C.Context});}else{this.bInitial=true;}}};
E.prototype.initialize=function(){if(this.oModel.oMetadata&&this.oModel.oMetadata.isLoaded()&&this.isInitial()){var i=this.isRelative();if(!i||(i&&this.oContext)){this._initialize();}this._fireRefresh({reason:C.Refresh});}return this;};
E.prototype._initialize=function(){if(this.oModel.oMetadata&&this.oModel.oMetadata.isLoaded()){this.bInitial=false;this.oAnalyticalQueryResult=this.oModel.getAnalyticalExtensions().findQueryResultByName(this._getEntitySet());if(!this.oAnalyticalQueryResult){throw("Error in AnalyticalBinding - The QueryResult '"+this._getEntitySet()+"' could not be retrieved. Please check your service definition.");}this.updateAnalyticalInfo(this.aInitialAnalyticalInfo);this.aAllDimensionSortedByName=this.oAnalyticalQueryResult.getAllDimensionNames().concat([]).sort();this._fireRefresh({reason:C.Refresh});}};
E.prototype.getRootContexts=function(p){if(this.isInitial()){return[];}var i=(p&&p.numberOfExpandedLevels?p.numberOfExpandedLevels+1:1);var r=null;var R=this._getRequestId(E._requestType.groupMembersQuery,{groupId:null});if(this.bArtificalRootContext&&!this._cleanupGroupingForCompletedRequest(R)){return r;}r=this._getContextsForParentContext(null);if(r.length==1){return r;}if(i<=1){if(i==1){this._considerRequestGrouping([R,this._getRequestId(E._requestType.groupMembersQuery,{groupId:"/"})]);this.getNodeContexts(this.getModel().getContext("/"),{startIndex:p.startIndex,length:p.length,threshold:p.threshold,level:0,numberOfExpandedLevels:0});}}else{var e=this._prepareGroupMembersAutoExpansionRequestIds("/",p.numberOfExpandedLevels);e.push(R);this._considerRequestGrouping(e);this.getNodeContexts(this.getModel().getContext("/"),{startIndex:p.startIndex,length:p.length,threshold:p.threshold,level:0,numberOfExpandedLevels:p.numberOfExpandedLevels});}if(r.length>1){w.fatal("assertion failed: grand total represented by a single entry");}return r;};
E.prototype.getNodeContexts=function(o,p){if(this.isInitial()){return[];}var s,l,i,e,n,g;if(typeof p=="object"){s=p.startIndex;l=p.length;i=p.threshold;e=p.level;n=p.numberOfExpandedLevels;g=p.supressRequest;}else{s=arguments[1];l=arguments[2];i=arguments[3];e=arguments[4];n=arguments[5];g=arguments[6];}var h=this._getContextsForParentContext(o,s,l,i,e,n,g);return h;};
E.prototype.ContextsAvailabilityStatus={ALL:2,SOME:1,NONE:0};
E.prototype.hasAvailableNodeContexts=function(o,l){var g=this._getGroupIdFromContext(o,l);if(this._getKeys(g)!=undefined){if(this.mFinalLength[g]==true){return E.prototype.ContextsAvailabilityStatus.ALL;}else{return E.prototype.ContextsAvailabilityStatus.SOME;}}else{return E.prototype.ContextsAvailabilityStatus.NONE;}};
E.prototype.getGroupSize=function(o,l){if(o===undefined){return 0;}var g=this._getGroupIdFromContext(o,l);return this.mFinalLength[g]?this.mLength[g]:-1;};
E.prototype.getTotalSize=function(){if(!this.bProvideTotalSize){w.fatal("total size of result explicitly turned off, but getter invoked");}return+this.iTotalSize;};
E.prototype.hasChildren=function(o,p){if(o===undefined){return false;}if(o==null){return true;}var i=p.level;if(i==0){return true;}if(this.aAggregationLevel.length<i){return false;}return this.aMaxAggregationLevel.indexOf(this.aAggregationLevel[i-1])<this.aMaxAggregationLevel.length-1;};
E.prototype.hasMeasures=function(){var h=false;for(var p in this.oMeasureDetailsSet){if(this.oMeasureDetailsSet.hasOwnProperty(p)){h=true;break;}}return h;};
E.prototype.getDimensionDetails=function(){return this.oDimensionDetailsSet;};
E.prototype.getMeasureDetails=function(){return this.oMeasureDetailsSet;};
E.prototype.providesGrandTotal=function(){return this.bProvideGrandTotals;};
E.prototype.getProperty=function(p){if(this.isInitial()){return{};}return this.oAnalyticalQueryResult.getEntityType().findPropertyByName(p);};
E.prototype.getFilterablePropertyNames=function(){if(this.isInitial()){return[];}return this.oAnalyticalQueryResult.getEntityType().getFilterablePropertyNames();};
E.prototype.getSortablePropertyNames=function(){if(this.isInitial()){return[];}return this.oAnalyticalQueryResult.getEntityType().getSortablePropertyNames();};
E.prototype.getPropertyLabel=function(p){if(this.isInitial()){return"";}return this.oAnalyticalQueryResult.getEntityType().getLabelOfProperty(p);};
E.prototype.getPropertyHeading=function(p){if(this.isInitial()){return"";}return this.oAnalyticalQueryResult.getEntityType().getHeadingOfProperty(p);};
E.prototype.getPropertyQuickInfo=function(p){if(this.isInitial()){return"";}return this.oAnalyticalQueryResult.getEntityType().getQuickInfoOfProperty(p);};
E.prototype.isMeasure=function(p){return this.aMeasureName&&this.aMeasureName.indexOf(p)!==-1;};
E.prototype.filter=function(e,s){if(!e){e=[];}if(e instanceof F){e=[e];}e=this._convertDeprecatedFilterObjects(e);if(s==c.Application){this.aApplicationFilter=e;}else{this.aControlFilter=e;}this.iTotalSize=-1;this._abortAllPendingRequests();this.resetData();this.bApplySortersToGroups=true;this._fireRefresh({reason:C.Filter});return this;};
E.prototype.getFilterInfo=function(i){var o=b.combineFilters(this.aControlFilter,this.aApplicationFilter);if(o){return o.getAST(i);}return null;};
E.prototype.sort=function(s){if(s instanceof S){s=[s];}this.aSorter=s?s:[];this._abortAllPendingRequests();this.resetData(undefined,{reason:C.Sort});this._fireRefresh({reason:C.Sort});return this;};
E.prototype.getGroupName=function(o,l){if(o===undefined){return"";}var g=this.aAggregationLevel[l-1],e=this.oAnalyticalQueryResult.findDimensionByPropertyName(g),V=this.mAnalyticalInfoByProperty[g]&&this.mAnalyticalInfoByProperty[g].formatter,p=o.getProperty(g),s,h,i,j,k,m,n,q;if(e&&this.oDimensionDetailsSet[g].textPropertyName){k=e.getTextProperty();}if(k){m=k.name;q=this.mAnalyticalInfoByProperty[m]&&this.mAnalyticalInfoByProperty[m].formatter;n=o.getProperty(m);s=V?V(p,n):p;h=q?q(n,p):n;}else{s=V?V(p):p;}j=e.getLabelText&&e.getLabelText();i=(j?j+': ':'')+s;if(h){i+=' - '+h;}return i;};
E.prototype.updateAnalyticalInfo=function(e,g){var h,o,k,H,l=this;function m(K){var N=K.level,O=K.name;H=H||k.getAllHierarchyPropertyNames();H.forEach(function(R){var V=l.oAnalyticalQueryResult.findDimensionByPropertyName(R).getHierarchy(),W=null,X=V.getNodeIDProperty().name,Y;if(X===O){W=n(V);}else{Y=V.getNodeExternalKeyProperty();if(Y&&Y.name===O){W=n(V);W.nodeExternalKeyName=O;}else{Y=k.getTextPropertyOfProperty(X);if(Y&&Y.name===O){W=n(V);W.nodeTextName=O;}}}if(W&&"level"in K){if(typeof N==="number"){if("level"in W&&W.level!==N){throw new Error("Multiple different level filter for hierarchy '"+X+"' defined");}W.level=N;W.grouped=!!K.grouped;}else{throw new Error("The level of '"+X+"' has to be an integer value");}}});}function n(K){var N=K.getNodeIDProperty().name,O,R=l.mHierarchyDetailsByName[N];if(!R){O=K.getNodeLevelProperty();R={dimensionName:K.getNodeValueProperty().name,nodeIDName:N,nodeLevelName:O&&O.name};l.mHierarchyDetailsByName[N]=R;}return R;}if(!this.oModel.oMetadata||!this.oModel.oMetadata.isLoaded()||this.isInitial()){this.aInitialAnalyticalInfo=e;return;}h=t.helper.deepEqual(this._aLastChangedAnalyticalInfo,e,function(K){l.mAnalyticalInfoByProperty[K.name].formatter=K.formatter;});if(h){this._aLastChangedAnalyticalInfo=[];for(var j=0;j<e.length;j++){this._aLastChangedAnalyticalInfo[j]=Q.extend({},e[j]);}}if(h<2){if(g||h){setTimeout(function(){this._fireChange({reason:C.Change});}.bind(this),0);}return;}var p=this.oDimensionDetailsSet||{},P=this.oMeasureDetailsSet||{};this.mAnalyticalInfoByProperty={};this.aMaxAggregationLevel=[];this.aAggregationLevel=[];this.aMeasureName=[];if(this.iAnalyticalInfoVersionNumber==undefined){this.iAnalyticalInfoVersionNumber=1;}else if(this.iAnalyticalInfoVersionNumber>999){this.iAnalyticalInfoVersionNumber=1;}else{this.iAnalyticalInfoVersionNumber=this.iAnalyticalInfoVersionNumber+1;}this.oMeasureDetailsSet={};this.oDimensionDetailsSet={};this.aAdditionalSelects=[];this.mHierarchyDetailsByName={};k=this.oAnalyticalQueryResult.getEntityType();for(var i=0;i<e.length;i++){var q=this.oAnalyticalQueryResult.findDimensionByPropertyName(e[i].name);if(q&&(e[i].inResult==true||e[i].visible==true)){e[i].dimensionPropertyName=q.getName();o=this.oDimensionDetailsSet[q.getName()];if(!o){o={};o.name=q.getName();o.aAttributeName=[];o.grouped=false;this.oDimensionDetailsSet[q.getName()]=o;this.aMaxAggregationLevel.push(o.name);if(e[i].grouped==true){this.aAggregationLevel.push(o.name);}}if(e[i].grouped==true){if(!this.getSortablePropertyNames()||this.getSortablePropertyNames().indexOf(q.getName())==-1){w.fatal("property "+q.getName()+" must be sortable in order to be used as grouped dimension");}o.grouped=true;}if(q.getName()==e[i].name){o.keyPropertyName=e[i].name;}var r=q.getTextProperty();if(r&&r.name==e[i].name){o.textPropertyName=e[i].name;}if(q.findAttributeByName(e[i].name)){o.aAttributeName.push(e[i].name);}o.analyticalInfo=e[i];}var M=this.oAnalyticalQueryResult.findMeasureByPropertyName(e[i].name);if(M&&(e[i].inResult==true||e[i].visible==true)){e[i].measurePropertyName=M.getName();var s=this.oMeasureDetailsSet[M.getName()];if(!s){s={};s.name=M.getName();this.oMeasureDetailsSet[M.getName()]=s;this.aMeasureName.push(s.name);}if(M.getRawValueProperty().name==e[i].name){s.rawValuePropertyName=e[i].name;}var z=M.getFormattedValueProperty();if(z&&z.name==e[i].name){s.formattedValuePropertyName=e[i].name;}s.analyticalInfo=e[i];}if(!q&&!M){m(e[i]);}this.mAnalyticalInfoByProperty[e[i].name]=e[i];}Object.keys(this.mHierarchyDetailsByName).forEach(function(N){var K=l.mHierarchyDetailsByName[N];if(!("level"in K)){delete l.mHierarchyDetailsByName[N];if(w.isLoggable(L.Level.INFO)){w.info("No level specified for hierarchy node '"+N+"'; ignoring hierarchy","");}}else if(!l.oDimensionDetailsSet[N]){l.oDimensionDetailsSet[N]={aAttributeName:[],grouped:K.grouped,isHierarchyDimension:true,name:N};l.aMaxAggregationLevel.push(N);if(K.grouped){l.aAggregationLevel.push(N);}}});for(var I in this.oMeasureDetailsSet){var U=this.oAnalyticalQueryResult.findMeasureByName(I).getUnitProperty();if(U){this.oMeasureDetailsSet[I].unitPropertyName=U.name;}}var J=Object.keys(p).sort().join(";")!==Object.keys(this.oDimensionDetailsSet).sort().join(";");if(J){this.iTotalSize=-1;}if(J||Object.keys(P).sort().join(";")!==Object.keys(this.oMeasureDetailsSet).sort().join(";")){this.bApplySortersToGroups=true;}this.aAnalyticalInfo=e;this.resetData();this.bNeedsUpdate=false;if(this.mParameters.select){this.aAdditionalSelects=x(this);}if(g){this._fireChange({reason:C.Change});}};
E.prototype.getAnalyticalInfoForColumn=function(s){return this.mAnalyticalInfoByProperty[s];};
E.prototype.loadGroups=function(g){var e=[];for(var s in g){e.push(s);this._resetData(s);var h=g[s];for(var i=0;i<h.length;i++){var o=h[i];this._getContextsForParentGroupId(s,o.startIndex,o.length,o.threshold);}var r=[];for(var j=-1,k;(k=e[++j])!==undefined;){r.push(this._getRequestId(E._requestType.groupMembersQuery,{groupId:k}));}this._considerRequestGrouping(r);}};
E.prototype.getAnalyticalQueryResult=function(){return this.oAnalyticalQueryResult;};
E._requestType={groupMembersQuery:1,totalSizeQuery:2,groupMembersAutoExpansionQuery:3,levelMembersQuery:4,reloadMeasuresQuery:5};E._artificialRootContextGroupId="artificialRootContext";
E._addHierarchyLevelFilters=function(e,o){e.forEach(function(g){o.removeConditions(g.propertyName);o.addCondition(g.propertyName,a.EQ,g.level);});};
E.prototype._getContextsForParentContext=function(p,s,l,i,e,n,g){if(p===undefined){return[];}if(p&&p.getPath()=="/"+E._artificialRootContextGroupId){p=this.getModel().getContext("/");}var P=this._getGroupIdFromContext(p,e);return this._getContextsForParentGroupId(P,s,l,i,n,g);};
E.prototype._getContextsForParentGroupId=function(p,s,l,e,n,g){if(p===undefined){return[];}if(!s){s=0;}if(!l){l=this.oModel.iSizeLimit;}if(this.mFinalLength[p]&&this.mLength[p]<s+l){l=this.mLength[p]-s;if(l<0){w.fatal("invalid start index greater than total group length passed");}}if(!e){e=0;}if(!n){n=0;}if(p==null){if(n>0){w.fatal("invalid request to determine nodes of root context");return null;}}else{if(this._getGroupIdLevel(p)>=this.aAggregationLevel.length&&n>0){w.fatal("invalid request to determine nodes of context with group ID "+p);return null;}if(this._getGroupIdLevel(p)+n>this.aAggregationLevel.length){n=this.aAggregationLevel.length-this._getGroupIdLevel(p)-1;}}var h=[],k,o,m,q;var r=p==null?0:this._getGroupIdLevel(p)+1;if(!this.aMultiUnitLoadFactor[r]){this.aMultiUnitLoadFactor[r]=1;}var z=n>0&&p!=null;if(z){var M=this._getGroupIdLevel(p);var H=M+n;var I=true;if(!g){m=this._calculateRequiredGroupExpansion(p,H,s,l+e);I=m.groupId_Missing==null;I=I||m.groupId_Missing.length<p.length||m.groupId_Missing.substring(0,p.length)!=p;}if(I){h=this._getLoadedContextsForGroup(p,s,l);}else{q=l+e;}k=!I;q=Math.ceil(q*this.aMultiUnitLoadFactor[r]);}else{h=this._getLoadedContextsForGroup(p,s,l,g);k=false;if(!g){if(this._oWatermark&&p===this._oWatermark.groupID){e=10000;}o=this._calculateRequiredGroupSection(p,s,l,e);var P=o.length>0&&l<o.length;k=(h.length!=l&&!(this.mFinalLength[p]&&h.length>=this.mLength[p]-s))||P;o.length=Math.ceil(o.length*this.aMultiUnitLoadFactor[r]);}}if(!k){this._cleanupGroupingForCompletedRequest(this._getRequestId(E._requestType.groupMembersQuery,{groupId:p}));}var J=false;if(this.oModel.getServiceMetadata()){if(k){var N=this.bProvideTotalSize&&this.iTotalSize==-1&&!this._isRequestPending(this._getRequestId(E._requestType.totalSizeQuery));J=true;var K;if(this.bUseBatchRequests){if(z){K=this._prepareGroupMembersAutoExpansionRequestIds(p,n);for(var i=-1,R;(R=K[++i])!==undefined;){if(this._isRequestPending(R)){J=false;break;}}if(J){this.aBatchRequestQueue.push([E._requestType.groupMembersAutoExpansionQuery,p,m,q,n]);}}else{J=o.length&&!this._isRequestPending(this._getRequestId(E._requestType.groupMembersQuery,{groupId:p}));if(J){this.aBatchRequestQueue.push([E._requestType.groupMembersQuery,p,o.startIndex,o.length]);K=[this._getRequestId(E._requestType.groupMembersQuery,{groupId:p})];}}if(J&&N){K.push(this._getRequestId(E._requestType.totalSizeQuery));this._considerRequestGrouping(K);this.aBatchRequestQueue.push([E._requestType.totalSizeQuery]);}if(J){if(p==null){this._abortAllPendingRequests();}Promise.resolve().then(E.prototype._processRequestQueue.bind(this));}}else{var O;if(z){K=this._prepareGroupMembersAutoExpansionRequestIds(p,n);for(var j=-1,U;(U=K[++j])!==undefined;){if(this._isRequestPending(U)){J=false;break;}}if(J){O=this._prepareGroupMembersAutoExpansionQueryRequest(E._requestType.groupMembersAutoExpansionQuery,p,m,q,n);}}else{J=o.length&&!this._isRequestPending(this._getRequestId(E._requestType.groupMembersQuery,{groupId:p}));if(J){O=this._prepareGroupMembersQueryRequest(E._requestType.groupMembersQuery,p,o.startIndex,o.length);K=[O.sRequestId];}}if(J){if(p==null){this._abortAllPendingRequests();}this._executeQueryRequest(O);if(N&&!O.bIsFlatListRequest){K.push(this._getRequestId(E._requestType.totalSizeQuery));this._considerRequestGrouping(K);this._executeQueryRequest(this._prepareTotalSizeQueryRequest(E._requestType.totalSizeQuery));}}}}}return h;};
E.prototype._getHierarchyLevelFiltersAndAddRecursiveHierarchy=function(o,g){var h,H=[],e=this;if(g===null){return H;}h=Object.keys(this.mHierarchyDetailsByName);if(h.length>0&&g!=="/"){w.error("Hierarchy cannot be requested for members of a group",g);return H;}h.forEach(function(s){var i=e.mHierarchyDetailsByName[s];o.addRecursiveHierarchy(i.dimensionName,!!i.nodeExternalKeyName,!!i.nodeTextName);H.push({propertyName:i.nodeLevelName,level:i.level});});return H;};
E.prototype._getNonHierarchyDimensions=function(e){var g=this;return e.filter(function(s){return!g.oDimensionDetailsSet[s].isHierarchyDimension;});};
E.prototype._processRequestQueue=function(r){if(r===undefined||r===null){r=this.aBatchRequestQueue||[];}if(r.length==0){return;}var R=[];var e=false;var i,o,g;for(i=-1;(g=r[++i])!==undefined;){if(g[0]==E._requestType.groupMembersQuery){o=E.prototype._prepareGroupMembersQueryRequest.apply(this,g);e=e||o.bIsFlatListRequest;R.push(o);}}for(i=-1;(g=r[++i])!==undefined;){o=null;switch(g[0]){case E._requestType.groupMembersQuery:continue;case E._requestType.totalSizeQuery:if(!e){o=E.prototype._prepareTotalSizeQueryRequest.apply(this,g);R.push(o);}break;case E._requestType.groupMembersAutoExpansionQuery:o=E.prototype._prepareGroupMembersAutoExpansionQueryRequest.apply(this,g);for(var j=-1,l;(l=o.aGroupMembersAutoExpansionRequestDetails[++j])!==undefined;){R.push(l);}break;case E._requestType.reloadMeasuresQuery:{var h=g[1];for(var k=-1,m;(m=h[++k])!==undefined;){R.push(m);}break;}default:w.fatal("unhandled request type "+r[i][0]);continue;}}if(R.length>1){this._executeBatchRequest(R);}else{this._executeQueryRequest(R[0]);}if(r===this.aBatchRequestQueue){this.aBatchRequestQueue=[];}};
E.prototype._prepareGroupMembersQueryRequest=function(r,g,s,e){var h=[],m=[],H;var o=new t.QueryResultRequest(this.oAnalyticalQueryResult);o.setResourcePath(this._getResourcePath());o.getSortExpression().clear();var p=0,q=-1;if(g){h=this._getGroupIdComponents(g);p=q=h.length;var U=0;for(var j=0,z=0;j<p;z++){if(this.oDimensionDetailsSet[this.aMaxAggregationLevel[z]].grouped==false){++U;}else{++j;}}p=q=p+U;if(this.aMaxAggregationLevel.length>0){while(this.oDimensionDetailsSet[this.aMaxAggregationLevel[q]].grouped==false){if(++q==this.aMaxAggregationLevel.length){break;}}}}var I=q>=this.aMaxAggregationLevel.length-1;H=this._getHierarchyLevelFiltersAndAddRecursiveHierarchy(o,g);var J=this.aMaxAggregationLevel.slice(0,q+1);var K=this._getNonHierarchyDimensions(J);o.setAggregationLevel(K);for(var i=0;i<K.length;i++){var M=this.oDimensionDetailsSet[K[i]];var N=(M.textPropertyName!=undefined);o.includeDimensionKeyTextAttributes(M.name,true,N,M.aAttributeName);if(M.grouped){m.push({sPath:K[i],bDescending:false});}}var O=o.getFilterExpression();O.clear();if(this.aApplicationFilter){O.addUI5FilterConditions(this.aApplicationFilter);}if(this.aControlFilter){O.addUI5FilterConditions(this.aControlFilter);}if(p>=1){for(var k=0,l=h.length;k<l;k++){O.removeConditions(this.aAggregationLevel[k]);O.addCondition(this.aAggregationLevel[k],a.EQ,h[k]);}}E._addHierarchyLevelFilters(H,O);var P;var R;var V;var W;var X=[];if(g!=null||this.bProvideGrandTotals||(this._canApplySortersToGroups()&&this.aSorter.length>0)){o.setMeasures(this.aMeasureName);for(var Y in this.oMeasureDetailsSet){W=this.oMeasureDetailsSet[Y];if(!I&&this.mAnalyticalInfoByProperty[Y].total==false){P=false;R=false;V=false;}else{P=(W.rawValuePropertyName!=undefined);R=(W.formattedValuePropertyName!=undefined);V=(W.unitPropertyName!=undefined);if(V){if(X.indexOf(W.unitPropertyName)==-1){X.push(W.unitPropertyName);}}}o.includeMeasureRawFormattedValueUnit(W.name,P,R,V);}for(var n in K){var Z;if((Z=X.indexOf(K[n]))!=-1){X.splice(Z,1);}}}if(g){this._addSorters(o.getSortExpression(),m);}if(e==0){w.fatal("unhandled case: load 0 entities of sub group");}var $=this._getKeyIndexMapping(g,s);if(!this.bNoPaging){o.setResultPageBoundaries($.iServiceKeyIndex+1,$.iServiceKeyIndex+e);}o.setRequestOptions(null,!this.mFinalLength[g]);return{iRequestType:r,sRequestId:this._getRequestId(E._requestType.groupMembersQuery,{groupId:g}),oAnalyticalQueryRequest:o,sGroupId:g,aSelectedUnitPropertyName:X,aAggregationLevel:J,bIsFlatListRequest:I&&p==0,bIsLeafGroupsRequest:I,iStartIndex:s,iLength:e,oKeyIndexMapping:$};};
E.prototype._prepareTotalSizeQueryRequest=function(r){var h;var o=new t.QueryResultRequest(this.oAnalyticalQueryResult);o.setResourcePath(this._getResourcePath());h=this._getHierarchyLevelFiltersAndAddRecursiveHierarchy(o,"/");o.setAggregationLevel(this._getNonHierarchyDimensions(this.aMaxAggregationLevel));o.setMeasures([]);var e=o.getFilterExpression();e.clear();if(this.aApplicationFilter){e.addUI5FilterConditions(this.aApplicationFilter);}if(this.aControlFilter){e.addUI5FilterConditions(this.aControlFilter);}E._addHierarchyLevelFilters(h,e);o.setRequestOptions(null,null,true);o.setRequestOptions(null,true);return{iRequestType:r,sRequestId:this._getRequestId(E._requestType.totalSizeQuery),oAnalyticalQueryRequest:o};};
E.prototype._prepareGroupMembersAutoExpansionQueryRequest=function(r,g,o,e,n){var h=this;var p=function(o,s){var I=[];if(o.groupId_Missing==null){w.fatal("missing group Id not present");return I;}var z=h._getGroupIdComponents(o.groupId_Missing);var H=z.length;if(H>s){w.fatal("the given group ID is too deep for requested level for auto expansion");return I;}var k=[];for(var i=0;i<H;i++){var l=h.aAggregationLevel[i];var Y=z[i];var Z=h._getFilterOperatorMatchingPropertySortOrder(l);k[i]=new F(l,Z,Y);}var $=null;if(o.startIndex_Missing>0){var _=h._getKey(o.groupId_Missing,o.startIndex_Missing-1);var a1=h.oModel.getObject("/"+_);var b1=h.aAggregationLevel[H];var c1=a1[b1];$=new F(b1,h._getFilterOperatorMatchingPropertySortOrder(b1,false),c1);}for(var K=0;K<s;K++){var d1=[];var e1=Math.min(H,K+1);for(var f1=0;f1<e1;f1++){var g1=[];var h1=Math.min(H,f1+1);var i1=o.startIndex_Missing>0;for(var j1=0;j1<h1;j1++){var k1=new F("x",a.EQ,"x");k1=Q.extend(true,k1,k[j1]);if(h1>1&&j1<h1-1){k1.sOperator=a.EQ;}if(j1==H-1&&K>H-1&&!i1){if(k1.sOperator==a.GT){k1.sOperator=a.GE;}else{k1.sOperator=a.LE;}}g1.push(k1);}if(g1.length>0){d1.push(new F(g1,true));if(K>H-1&&f1==H-1&&i1){var l1=[];for(var j=0;j<g1.length;j++){var m1=new F("x",a.EQ,"x");m1=Q.extend(true,m1,g1[j]);l1.push(m1);}l1[H-1].sOperator=a.EQ;l1.push($);d1.push(new F(l1,true));break;}}}if(d1.length>0){I[K]=new F(d1,false);}else{I[K]=null;}}return I;};var m=function(r,g,K,Y,M,e,Z,$){var _;var a1=new t.QueryResultRequest(h.oAnalyticalQueryResult);a1.setResourcePath(h._getResourcePath());a1.getSortExpression().clear();var b1=0,c1=-1;b1=c1=K-1;var d1=0;for(var i=0,e1=0;i<b1;e1++){if(h.oDimensionDetailsSet[h.aMaxAggregationLevel[e1]].grouped==false){++d1;}else{++i;}}b1=c1=b1+d1;if(h.aMaxAggregationLevel.length>0){while(h.aMaxAggregationLevel[c1]&&h.oDimensionDetailsSet[h.aMaxAggregationLevel[c1]].grouped==false){if(++c1==h.aMaxAggregationLevel.length){break;}}}var f1=c1>=h.aMaxAggregationLevel.length-1;_=h._getHierarchyLevelFiltersAndAddRecursiveHierarchy(a1,g);var g1=h.aMaxAggregationLevel.slice(0,c1+1);a1.setAggregationLevel(g1);for(var l=0;l<g1.length;l++){var h1=h.oDimensionDetailsSet[g1[l]];var i1=(h1.textPropertyName!=undefined);a1.includeDimensionKeyTextAttributes(h1.name,true,i1,h1.aAttributeName);if(h1.grouped){a1.getSortExpression().addSorter(g1[l],t.SortOrder.Ascending);}}var j1=a1.getFilterExpression();j1.clear();if(h.aApplicationFilter){j1.addUI5FilterConditions(h.aApplicationFilter);}if(h.aControlFilter){j1.addUI5FilterConditions(h.aControlFilter);}if(Y){j1.addUI5FilterConditions([Y]);}E._addHierarchyLevelFilters(_,j1);var k1;var l1;var m1;var n1;var o1=[];a1.setMeasures(h.aMeasureName);for(var p1 in h.oMeasureDetailsSet){n1=h.oMeasureDetailsSet[p1];if(!f1&&h.mAnalyticalInfoByProperty[p1].total==false){k1=false;l1=false;m1=false;}else{k1=(n1.rawValuePropertyName!=undefined);l1=(n1.formattedValuePropertyName!=undefined);m1=(n1.unitPropertyName!=undefined);if(m1){if(o1.indexOf(n1.unitPropertyName)==-1){o1.push(n1.unitPropertyName);}}}a1.includeMeasureRawFormattedValueUnit(n1.name,k1,l1,m1);}for(var j in g1){var q1;if((q1=o1.indexOf(g1[j]))!=-1){o1.splice(q1,1);}}var r1=a1.getSortExpression();for(var k=0;k<h.aSorter.length;k++){if(h.aSorter[k]){r1.addSorter(h.aSorter[k].sPath,h.aSorter[k].bDescending?t.SortOrder.Descending:t.SortOrder.Ascending);}}if(e==0){w.fatal("unhandled case: load 0 entities of sub group");}var s1=M;if(!$){s1=0;}else{var t1=0;for(var u1 in h.mServiceKey){if(u1.split("/").length===K+1){t1+=h.mServiceKey[u1].length;}}s1=Math.max(s1,t1);}if(!h.bNoPaging){a1.setResultPageBoundaries(s1+1,s1+e);}return{iRequestType:r,sRequestId:null,oAnalyticalQueryRequest:a1,iLevel:K,aSelectedUnitPropertyName:o1,aAggregationLevel:g1,bIsFlatListRequest:f1,bIsLeafGroupsRequest:f1,iStartIndex:M,iLength:e,bAvoidLengthUpdate:Z};};var q=[];var R=[];if(!o){w.fatal("no first missing group member specified");}var s=this._getGroupIdLevel(g)+n+1;var z=h._getGroupIdComponents(o.groupId_Missing);var H=z.length;var I=p(o,s);var J;for(var K=1;K<=s;K++){var M;if(K>=H+2){M=0;J=undefined;}else if(K==H+1){M=o.startIndex_Missing;J=o.groupId_Missing;}else if(H>0){if(K==H){J=o.groupId_Missing;}else{J=this._getGroupIdAncestors(o.groupId_Missing,-(H-K))[0];}var N=this._getGroupIdAncestors(o.groupId_Missing,-(H-K+1))[0];if(!N){w.fatal("failed to determine group id at parent level; group ID = "+g+", level = "+K);}M=this._findKeyIndex(N,this.mEntityKey[J]);if(M==-1){w.fatal("failed to determine position of value "+J+" in group "+N);}J=N;M++;}var O=e>K?Math.ceil((e-K)/(s-K+1)):e;var P=I[K-1];if(this.bUseAcceleratedAutoExpand){var U=m(E._requestType.levelMembersQuery,g,K,P,M,O,false,P==null?true:false);U.sGroupId_Missing_AtLevel=J;U.sRequestId=this._getRequestId(E._requestType.levelMembersQuery,{groupId:g,level:K});q.push(U);R.push(U.sRequestId);}else if(P&&P.aFilters.length>0){if(!P._bMultiFilter||P.bAnd){w.fatal("level filter in wrong shape; cannot break it up");}for(var i=0;i<P.aFilters.length;i++){var V=P.aFilters[i];var W=m(E._requestType.levelMembersQuery,g,K,V,M,O,false,P==null?true:false);W.sGroupId_Missing_AtLevel=J;W.sRequestId=this._getRequestId(E._requestType.levelMembersQuery,{groupId:g,level:K,tupleIndex:i});q.push(W);R.push(W.sRequestId);}}else{var X=m(E._requestType.levelMembersQuery,g,K,null,M,O,false,P==null?true:false);X.sGroupId_Missing_AtLevel=J;X.sRequestId=this._getRequestId(E._requestType.levelMembersQuery,{groupId:g,level:K});q.push(X);R.push(X.sRequestId);}}return{iRequestType:r,aRequestId:R,aGroupMembersAutoExpansionRequestDetails:q,sGroupId:g,iLength:e};};
E.prototype._prepareReloadMeasurePropertiesQueryRequest=function(r,g,m){var o=new t.QueryResultRequest(this.oAnalyticalQueryResult);o.setResourcePath(this._getResourcePath());o.getSortExpression().clear();var e=g.aAggregationLevel;o.setAggregationLevel(e);var I=g.bIsLeafGroupsRequest;var h=o.getFilterExpression();h.clear();if(this.aApplicationFilter){h.addUI5FilterConditions(this.aApplicationFilter);}if(this.aControlFilter){h.addUI5FilterConditions(this.aControlFilter);}var k=[];for(var i=0;i<e.length;i++){var l=new F(e[i],a.EQ,m.oEntry[e[i]]);k.push(l);}h.addUI5FilterConditions(k);var n;var p;var q;var M;var s=[];o.setMeasures(m.aReloadMeasurePropertyName);for(var z in this.oMeasureDetailsSet){M=this.oMeasureDetailsSet[z];if(!m.aReloadMeasurePropertyName||m.aReloadMeasurePropertyName.indexOf(M.name)==-1){continue;}if(!I&&this.mAnalyticalInfoByProperty[z].total==false){n=false;p=false;q=false;}else{n=(M.rawValuePropertyName!=undefined);p=(M.formattedValuePropertyName!=undefined);q=(M.unitPropertyName!=undefined);if(q){if(s.indexOf(M.unitPropertyName)==-1){s.push(M.unitPropertyName);}}}o.includeMeasureRawFormattedValueUnit(M.name,n,p,q);}for(var j in e){var H;if((H=s.indexOf(e[j]))!=-1){s.splice(H,1);}}return{iRequestType:r,sRequestId:this._getRequestId(E._requestType.reloadMeasuresQuery,{multiUnitEntryKey:this.oModel.getKey(m.oEntry)}),oAnalyticalQueryRequest:o,aSelectedUnitPropertyName:s,aAggregationLevel:e,oMultiUnitRepresentative:m};};
E.prototype._prepareGroupMembersAutoExpansionRequestIds=function(g,n){var m=this._getGroupIdLevel(g)+1;var i=m+n;var r=[];for(var l=m;l<=i;l++){r.push(this._getRequestId(E._requestType.levelMembersQuery,{groupId:g,level:l}));}return r;};
E.prototype._getQueryODataRequestOptions=function(o,g,p){var i;p=p||{};try{o.getFilterExpression().checkValidity();}catch(e){w.fatal("filter expression is not valid",e.toString());return undefined;}var s=o.getURIQueryOptionValue("$select");var h=o.getURIQueryOptionValue("$filter");var O=o.getURIQueryOptionValue("$orderby");var j=o.getURIQueryOptionValue("$skip");var k=o.getURIQueryOptionValue("$top");var I=o.getURIQueryOptionValue("$inlinecount");if(g&&this.aAdditionalSelects.length>0){s=(s?s.split(","):[]).concat(this.aAdditionalSelects).join(",");}if(this.mParameters&&this.mParameters["filter"]){if(h===null){h=this.mParameters["filter"];}else{h+="and ("+this.mParameters["filter"]+")";}}var P=[];if(s!==null){P.push("$select="+s);}if(h!==null){P.push("$filter="+h);}if(O!==null){P.push("$orderby="+O);}if(j!==null){P.push("$skip="+j);}if(k!==null){P.push("$top="+k);}if(I!==null){P.push("$inlinecount="+I);}if(p.encode===true){for(i=0;i<P.length;i++){P[i]=P[i].replace(/\ /g,"%20");}}return P;};
E.prototype._executeBatchRequest=function(r){var e=this.iAnalyticalInfoVersionNumber,R,g=this;var h=[],l=[];function m(){g.fireDataReceived({__simulateAsyncAnalyticalBinding:true});}var o=new B();function s(j,k){o.success(k);}function n(j,k){o.error(k||j);}this.bNeedsUpdate=true;for(var p=0;p<r.length;p++){var q=r[p];if(q.aAggregationLevel&&q.aAggregationLevel.length>0){this.bNeedsUpdate=false;}}for(var i=-1,z;(z=r[++i])!==undefined;){var H=z.oAnalyticalQueryRequest,I=z.sGroupId;if(H.getURIQueryOptionValue("$select")==null){this.fireDataRequested({__simulateAsyncAnalyticalBinding:true});I=null;this.mServiceLength[I]=this.mLength[I]=1;this.mServiceFinalLength[I]=true;this._setServiceKey(this._getKeyIndexMapping(I,0),E._artificialRootContextGroupId);setTimeout(m);this.bArtificalRootContext=true;continue;}var P=H.getURIToQueryResultEntries();if(!this.oContext&&P[0]!=="/"){P="/"+P;}if(!this._isRequestPending(z.sRequestId)){this._registerNewRequest(z.sRequestId);if(this.iModelVersion===A.V1){h.push(this.oModel.createBatchOperation(P.replace(/\ /g,"%20"),"GET"));}else if(this.iModelVersion===A.V2){var U=this._getQueryODataRequestOptions(H,z.bIsLeafGroupsRequest,{encode:true});if(this.sCustomParams){U.push(this.sCustomParams);}var J=this.oModel.read(P.replace(/\ /g,"%20"),{success:s,error:n,context:this.oContext,urlParameters:U});h.push(J);}l.push(z);}}if(h.length>0){w.debug("AnalyticalBinding: executing batch request with "+l.length+" operations");var K;R=this._getIdForNewRequestHandle();this.fireDataRequested();if(this.iModelVersion===A.V1){this.oModel.addBatchReadOperations(h);K=this.oModel.submitBatch(M,N,true,true);this.oModel.fireRequestSent({url:this.oModel.sServiceUrl+"/$batch",type:"POST",async:true,info:"",infoObject:{}});}else{K={abort:function(){for(var j=0;j<h.length;j++){h[j].abort();}}};o.setup({executedRequests:l,binding:this,success:M,error:N});}this._registerNewRequestHandle(R,K);}function M(O,V){g._deregisterHandleOfCompletedRequest(R);if(l.length!=O.__batchResponses.length){w.fatal("assertion failed: received "+O.__batchResponses.length+" responses for "+l.length+" read operations in the batch request");}if(e!=g.iAnalyticalInfoVersionNumber){for(var j=0;j<l.length;j++){var W=l[j].sRequestId;if(W!==undefined){g._deregisterCompletedRequest(W);g._cleanupGroupingForCompletedRequest(W);}}g.fireDataReceived({data:[]});return;}var X=0;for(var k=0;k<O.__batchResponses.length;k++){if(O.__batchResponses[k].data!=undefined){if(O.__batchResponses[k].data.results.length==0){X++;}switch(l[k].iRequestType){case E._requestType.groupMembersQuery:g._processGroupMembersQueryResponse(l[k],O.__batchResponses[k].data);break;case E._requestType.totalSizeQuery:g._processTotalSizeQueryResponse(l[k],O.__batchResponses[k].data);break;case E._requestType.levelMembersQuery:g._processLevelMembersQueryResponse(l[k],O.__batchResponses[k].data);break;case E._requestType.reloadMeasuresQuery:g._processReloadMeasurePropertiesQueryResponse(l[k],O.__batchResponses[k].data);break;default:w.fatal("invalid request type "+l[k].iRequestType);continue;}}g._deregisterCompletedRequest(l[k].sRequestId);g._cleanupGroupingForCompletedRequest(l[k].sRequestId);}if(g.mParameters&&g.mParameters.numberOfExpandedLevels>0){if(X==O.__batchResponses.length){g.mLength["/"]=0;g.mFinalLength["/"]=true;}}var Y=true;var Z;g.fireDataReceived({data:O});var $={};if(g.iModelVersion===A.V1){Z=g.oModel._getBatchErrors(O);if(Z.length>0){Y=false;$=g.oModel._handleError(Z[0]);}g.oModel.fireRequestCompleted({url:V.requestUri,type:"POST",async:true,info:"",infoObject:{},success:Y,errorobject:Y?{}:$});if(Y){g.oModel.checkUpdate();}}}function N(k){if(k&&k.statusText!="abort"){g._deregisterHandleOfCompletedRequest(R);for(var j=-1,O;(O=l[++j])!==undefined;){g._deregisterCompletedRequest(O.sRequestId);g._cleanupGroupingForCompletedRequest(O.sRequestId);}}if(e!=g.iAnalyticalInfoVersionNumber){return;}var V=k;if(g.iModelVersion===A.V1){V=g.oModel._handleError(k);}g.oModel.fireRequestCompleted({url:"",type:"POST",async:true,info:"",infoObject:{},success:false,errorobject:V});if(g.iModelVersion===A.V1){g.oModel.fireRequestFailed(V);}g.fireDataReceived();}};
E.prototype._executeQueryRequest=function(r){if(r.iRequestType==E._requestType.groupMembersAutoExpansionQuery){for(var i=-1,o;(o=r.aGroupMembersAutoExpansionRequestDetails[++i])!==undefined;){this._executeQueryRequest(o);}return;}var e=this.iAnalyticalInfoVersionNumber;var g=r.oAnalyticalQueryRequest,s=r.sGroupId;var p=g.getURIToQueryResultEntitySet();var P=this._getQueryODataRequestOptions(g,r.bIsLeafGroupsRequest);if(!P){return;}var h=this;if(g.getURIQueryOptionValue("$select")==null){this.fireDataRequested({__simulateAsyncAnalyticalBinding:true});s=null;this.mServiceLength[s]=this.mLength[s]=1;this.mServiceFinalLength[s]=true;this._setServiceKey(this._getKeyIndexMapping(s,0),E._artificialRootContextGroupId);this.bNeedsUpdate=true;setTimeout(function(){if(h._cleanupGroupingForCompletedRequest(r.sRequestId)){h.fireDataReceived({__simulateAsyncAnalyticalBinding:true});}});this.bArtificalRootContext=true;return;}this._registerNewRequest(r.sRequestId);this.fireDataRequested();for(var j=0;j<P.length;j++){P[j]=P[j].replace(/\ /g,"%20");}w.debug("AnalyticalBinding: executing query request");var R=this._getIdForNewRequestHandle();if(this.iModelVersion===A.V1){this.oModel._loadData(p,P,l,n,false,U,m);}else{if(this.sCustomParams){P.push(this.sCustomParams);}var k=this.oModel.read(p.replace(/ /g,"%20"),{success:l,error:n,context:this.oContext,urlParameters:P});h._registerNewRequestHandle(R,k);}function l(q){h._deregisterHandleOfCompletedRequest(R);if(e!=h.iAnalyticalInfoVersionNumber){h._deregisterCompletedRequest(r.sRequestId);return;}switch(r.iRequestType){case E._requestType.groupMembersQuery:h._processGroupMembersQueryResponse(r,q);break;case E._requestType.totalSizeQuery:h._processTotalSizeQueryResponse(r,q);break;case E._requestType.levelMembersQuery:h._processLevelMembersQueryResponse(r,q);break;case E._requestType.reloadMeasuresQuery:h._processReloadMeasurePropertiesQueryResponse(r,q);break;default:w.fatal("invalid request type "+r.iRequestType);break;}h._deregisterCompletedRequest(r.sRequestId);if(h.iModelVersion===A.V2){m(q);}}function m(q){if(e!=h.iAnalyticalInfoVersionNumber){return;}if(h._cleanupGroupingForCompletedRequest(r.sRequestId)){h.fireDataReceived({data:q});}}function n(q){if(q&&q.statusText=="abort"){h.fireDataReceived();return;}h._deregisterHandleOfCompletedRequest(R);h._deregisterCompletedRequest(r.sRequestId);h._cleanupGroupingForCompletedRequest(r.sRequestId);if(e!=h.iAnalyticalInfoVersionNumber){return;}h.fireDataReceived();}function U(k){h._registerNewRequestHandle(R,k);}};
E.prototype._abortAllPendingRequests=function(){this._abortAllPendingRequestsByHandle();this._clearAllPendingRequests();};
E.prototype._processGroupMembersQueryResponse=function(R,e){var s,n=R.sGroupId,H=this.aSorter.length>0,z=R.aSelectedUnitPropertyName,I=R.aAggregationLevel,J=R.oKeyIndexMapping.iIndex,K=R.oKeyIndexMapping.iServiceKeyIndex,M=R.iLength,N=R.oKeyIndexMapping,O=n==null?0:this._getGroupIdLevel(n)+1,U=(z.length>0),P,V,W,X=0,Y,Z,$=[];var _=e.results.length;if(n===null&&_>1&&this._canApplySortersToGroups()){this._warnNoSortingOfGroups(H?"binding is refreshed":undefined);if(H){setTimeout(this.refresh.bind(this),0);return;}}var a1=this._getServiceKeys(n,N.iIndex-1);P=undefined;if(a1&&a1.length>0){for(var i=0,b1=a1.length;i<b1;i++){e.results[i-b1]=this.oModel.getObject("/"+a1[i]);}var c1=e.results[-a1.length];P="";for(var j=0;j<I.length;j++){P+=c1[I[j]]+"|";}}Y=a1&&a1.length==1;for(var h=0;h<_;h++){var d1=e.results[h];if(U){V="";for(var g=0;g<I.length;g++){V+=d1[I[g]]+"|";}if(P==V){this._warnNoSortingOfGroups();if(W===undefined){if(h==0){W=-a1.length;N.iServiceKeyIndex-=a1.length-1;}else{W=h-1;}}var e1=-1,f1=e.results[h-1];for(var k=0;k<z.length;k++){if(f1[z[k]]!=d1[z[k]]){e1=k;break;}}if(e1==-1){w.fatal("assertion failed: no deviating units found for result entries "+(h-1)+" and "+h,null,null,G(this,"NO_DEVIATING_UNITS"));}}if((P!=V||h==_-1)&&W!==undefined){var g1=[];for(var l=W;l<h;l++){g1.push(e.results[l]);}if(P==V){g1.push(e.results[h]);}var h1=[];for(var m=0;m<z.length;m++){var i1=z[m];for(var o=1;o<g1.length;o++){if(g1[o-1][i1]!=g1[o][i1]){h1.push(i1);break;}}}var j1=this._createMultiUnitRepresentativeEntry(n,e.results[W],z,h1,R.bIsFlatListRequest);if(j1.aReloadMeasurePropertyName.length>0){Z=this._prepareReloadMeasurePropertiesQueryRequest(E._requestType.reloadMeasuresQuery,R,j1);if(Z.oAnalyticalQueryRequest&&Z.oAnalyticalQueryRequest.getURIQueryOptionValue("$select")!=null){$.push(Z);}}var k1=this._setAdjacentMultiUnitKeys(N,j1,g1);var l1;if(j1.bIsNewEntry){l1=g1.length-1;}else{l1=k1;}if(Y){Y=false;}if(l1<0){w.fatal("assertion failed: iDiscardedEntriesCount must be non-negative");}X+=l1;var m1=this.oModel._getKey(j1.oEntry);var n1=this.oModel.getContext('/'+m1);this._getGroupIdFromContext(n1,O);this.mEntityKey[s]=m1;W=undefined;if(P!=V){Y=this._setServiceKey(N,this.oModel._getKey(d1));}}else if(P!=V){Y=this._setServiceKey(N,this.oModel._getKey(d1));}P=V;}else{this._setServiceKey(N,this.oModel._getKey(d1));}if(!R.bIsLeafGroupsRequest){var o1=this._getKey(n,N.iIndex-1);s=this._getGroupIdFromContext(this.oModel.getContext('/'+o1),O);this.mEntityKey[s]=o1;}}var p1=[];if(this.bReloadSingleUnitMeasures&&$.length>0){if(this.bUseBatchRequests){this.aBatchRequestQueue.push([E._requestType.reloadMeasuresQuery,$]);Promise.resolve().then(E.prototype._processRequestQueue.bind(this));}else{for(var q=0;q<$.length;q++){var q1=$[q];this._executeQueryRequest(q1);}}for(var p=0;p<$.length;p++){var r1=$[p];p1.push(r1.sRequestId);}this._considerRequestGrouping(p1);}if(a1&&a1.length>0){for(var r=0,s1=a1.length;r<s1;r++){delete e.results[r-s1];}}if(U){X+=this._mergeLoadedKeyIndexWithSubsequentIndexes(N,I,z,R.bIsFlatListRequest);}if(!R.bAvoidLengthUpdate){var t1=false;if(e.__count){this.mServiceLength[n]=parseInt(e.__count);this.mLength[n]=this.mServiceLength[n]-X;this.mFinalLength[n]=true;if(R.bIsFlatListRequest){this.iTotalSize=e.__count;}t1=true;}if(!(n in this.mServiceLength)||this.mServiceLength[n]<K+_){this.mServiceLength[n]=K+_;this.mLength[n]=J+_-X;this.mFinalLength[n]=false;}if(_<M||M===undefined){this.mServiceLength[n]=K+_;this.mLength[n]=J+N.iIndex-J;this.mFinalLength[n]=true;t1=true;}if(_==0){this.mLength[n]=this.mServiceLength[n]=0;this.mFinalLength[n]=true;t1=true;}if(!t1&&this.mLength[n]!==undefined&&X>0){this.mLength[n]-=X;}}this.bNeedsUpdate=true;if(X>0){if(e.results.length-X>0){this.aMultiUnitLoadFactor[I.length]=e.results.length/(e.results.length-X);}if(this.aMultiUnitLoadFactor[I.length]<1.5){this.aMultiUnitLoadFactor[I.length]=2;}}w.info("MultiUnit Situation in Group ("+n+"), discarded: "+X+", load-factor is now: "+this.aMultiUnitLoadFactor[I.length]);};
E.prototype._processTotalSizeQueryResponse=function(r,o){if(o.__count==undefined){w.fatal("missing entity count in query result");return;}this.iTotalSize=o.__count;};
E.prototype._processLevelMembersQueryResponse=function(r,o){var e=this;var p,P;var g=function(h,I){var l={iRequestType:E._requestType.groupMembersQuery,sRequestId:e._getRequestId(E._requestType.groupMembersQuery,{groupId:p}),oAnalyticalQueryRequest:r.oAnalyticalQueryRequest,sGroupId:p,aSelectedUnitPropertyName:r.aSelectedUnitPropertyName,aAggregationLevel:r.aAggregationLevel,bIsFlatListRequest:r.bIsFlatListRequest,bIsLeafGroupsRequest:r.bIsLeafGroupsRequest,iStartIndex:h?r.iStartIndex:0,iLength:r.iLength,bAvoidLengthUpdate:r.bAvoidLengthUpdate};if(h&&r.iStartIndex>0&&(r.sGroupId_Missing_AtLevel!=l.sGroupId||e._getKeys(l.sGroupId)===undefined)){var s=e._getParentGroupId(l.sGroupId);var m=e._findKeyIndex(s,e.mEntityKey[l.sGroupId]);if(m<0){w.fatal("assertion failed: failed to determine position of "+l.sGroupId+" in group "+s);}else if(!m){e.mFinalLength[r.sGroupId_Missing_AtLevel]=true;}else if(e._getKey(s,m-1)!==undefined){var n=e._getKey(s,m-1);var q=e._getGroupIdFromContext(e.oModel.getContext('/'+n),e._getGroupIdLevel(l.sGroupId));e.mFinalLength[q]=true;l.iStartIndex=0;}}if(I){l.iLength=P.length;}l.oKeyIndexMapping=e._getKeyIndexMapping(l.sGroupId,l.iStartIndex);var z=Q.extend(true,{},o);z.results=P;e._processGroupMembersQueryResponse(l,z);};if(o.results.length==0){return;}p=this._getGroupIdFromContext(this.oModel.getContext("/"+this.oModel._getKey(o.results[0])),r.iLevel-1);P=[];var h=true;for(var i=0;i<o.results.length;i++){var j=o.results[i];var k=this.oModel.getContext("/"+this.oModel._getKey(o.results[i]));var s=this._getGroupIdFromContext(k,r.iLevel-1);if(p==s){P.push(j);if(i<o.results.length-1){continue;}}g(h,o.results.length==r.iLength&&i==o.results.length-1);h=false;if(p!=s){P=[j];}p=s;}if(o.results.length>1&&P.length==1){g(h,o.results.length==r.iLength);}};
E.prototype._processReloadMeasurePropertiesQueryResponse=function(r,o){var m=r.oMultiUnitRepresentative;var M=this.oModel.getKey(m.oEntry);if(o.results.length!=1){w.fatal("assertion failed: more than one entity for reloaded measure properties of entity with key "+M);return;}var R=o.results[0];var e=this.oModel.getObject("/"+M);if(!e){w.fatal("assertion failed: no entity found with key "+M);return;}var g=m.aReloadMeasurePropertyName;for(var i=0;i<g.length;i++){e[g[i]]=R[g[i]];}};
E.prototype._getLoadedContextsForGroup=function(g,s,l,e){var h=[],o,i,k=this._getKeys(g),K;if(!k){return h;}if(!s){s=0;}if(!l){l=this.oModel.iSizeLimit;if(this.mFinalLength[g]){l=this.mLength[g];}}if(e){i=s||0;K=k(i);while(K){o=this.oModel.getContext('/'+K);h.push(o);i++;K=k(i);}return h;}for(i=s;i<s+l;i++){K=k(i);if(!K){break;}o=this.oModel.getContext('/'+K);h.push(o);}return h;};
E.prototype._calculateRequiredGroupSection=function(g,s,l,i){var e=this._getKeys(g);if(s>=i){s-=i;l+=i;}else{l+=s;s=0;}l+=i;if(this.mFinalLength[g]&&s+l>this.mLength[g]){l=this.mLength[g]-s;}if(e){while(l&&e(s)){s+=1;l-=1;}while(l&&e(s+l-1)){l-=1;}}return{startIndex:s,length:l};};
E.prototype._calculateRequiredGroupExpansion=function(g,e,s,l){var n={groupId_Missing:null,length_Missing:0};var h=this;var j=function(g,e,s,l){var k=h._getGroupIdLevel(g);if(k==e){var H=h._getLoadedContextsForGroup(g,s,l);var I=s+H.length-1;if(H.length>=l){return n;}else if(h.mFinalLength[g]){if(H.length>=h.mLength[g]){return{groupId_Missing:null,length_Missing:l-H.length};}else{return{groupId_Missing:g,startIndex_Missing:I+1,length_Missing:l-H.length};}}else{return{groupId_Missing:g,startIndex_Missing:I+1,length_Missing:l-H.length};}}var J=h._getLoadedContextsForGroup(g,s,l);var m=l,K=s+J.length-1;for(var i=-1,M;(M=J[++i])!==undefined;){m--;var p=j(h._getGroupIdFromContext(M,k+1),e,0,m);if(p.groupId_Missing==null){if(p.length_Missing==0){return p;}else{m=p.length_Missing;}}else{return p;}if(m==0){break;}}if(h.mFinalLength[g]||m==0){return{groupId_Missing:null,length_Missing:m};}else{return{groupId_Missing:g,startIndex_Missing:K+1,length_Missing:m};}};var k=this._getGroupIdLevel(g);if(k==e+1){g=this._getParentGroupId(g);--k;}if(g==null||k>e){return n;}var m=l,o=s;while(g!=null){var p=j(g,e,o,m);if(p.groupId_Missing!=null){return p;}else if(p.length_Missing==0){return p;}else{var q=false;while(!q){var P=this._getParentGroupId(g);if(P==null){g=P;--k;break;}var r=this.mEntityKey[g];if(!r){return n;}var z=this._findKeyIndex(P,r);if(z==-1){return n;}if(z==this._getKeyCount(P)-1){if(this.mFinalLength[P]){g=P;--k;continue;}else{return{groupId_Missing:P,startIndex_Missing:z+1,length_Missing:m};}}else{r=this._getKey(P,z+1);g=this._getGroupIdFromContext(this.oModel.getContext('/'+r),k);q=true;}}o=0;m=p.length_Missing;}}return{groupId_Missing:null,length_Missing:m};};
E.prototype._getResourcePath=function(){return this.isRelative()?this.oModel.resolve(this.sPath,this.getContext()):this.sPath;};
E.prototype._getEntitySet=function(){var e=this.sEntitySetName;if(!e){e=this.sPath.split("/")[1];if(e.indexOf("(")!=-1){e=e.split("(")[0]+"Results";}}return e;};
E.prototype._getEffectiveSortOrder=function(p){for(var i=0;i<this.aSorter.length;i++){if(this.aSorter[i]&&this.aSorter[i].sPath==p){return this.aSorter[i].bDescending?t.SortOrder.Descending:t.SortOrder.Ascending;}}return null;};
E.prototype._getFilterOperatorMatchingPropertySortOrder=function(p,W){var s;switch(this._getEffectiveSortOrder(p)){case t.SortOrder.Ascending:if(W){s=a.GE;}else{s=a.GT;}break;case t.SortOrder.Descending:if(W){s=a.LE;}else{s=a.LT;}break;default:s=a.GT;}return s;};
E.prototype._convertDeprecatedFilterObjects=function(e){if(!e){return e;}var O=sap.ui.require("sap/ui/model/odata/Filter");if(typeof O==='function'){for(var i=0,l=e.length;i<l;i++){if(e[i]instanceof O){e[i]=e[i].convert();}}}return e;};
E.prototype._getGroupIdFromContext=function(o,l){if(!o){return null;}var g="/";var s=null;if(l>this.aAggregationLevel.length){w.fatal("assertion failed: aggregation level deeper than number of current aggregation levels");}for(var i=0;i<l;i++){s=o.getProperty(this.aAggregationLevel[i]);if(s!=null){if(s.__edmType==="Edm.Time"){s=s.ms;}g+=encodeURIComponent(s)+"/";}else{g+="@/";}}return g;};
E.prototype._getGroupIdLevel=function(g){if(g==null){w.fatal("assertion failed: no need to determine level of group ID = null");return-1;}return g.split("/").length-2;};
E.prototype._getGroupIdComponents=function(g){if(g==null){return null;}var e=g.split("/");var h=[];for(var i=1;i<e.length-1;i++){if(e[i]=="@"){h[i-1]=null;}else{h[i-1]=decodeURIComponent(e[i]);}}return h;};
E.prototype._getGroupIdAncestors=function(g,n){if(!n){return[];}if(g==null){w.fatal("group ID null does not have ancestors");return[];}if(g=="/"){if(Math.abs(n)==1){return[null];}else{w.fatal("invalid level count "+n+" for ancestors of groupId "+g);return[];}}var e=g.split("/");var h=[],s="";var k=0,l=e.length-3;if(n>0){if(n-1>l){w.fatal("invalid level count "+n+" for ancestors of groupId "+g);}else{l=n-1;}}else if(-(n+1)>l){w.fatal("invalid level count "+n+" for ancestors of groupId "+g);}else{k=l+1+n;for(var i=0;i<k;i++){s+=e[i]+"/";}}for(var j=k;j<=l;j++){s+=e[j]+"/";h.push(s);}return h;};
E.prototype._getParentGroupId=function(g){return this._getGroupIdAncestors(g,-1)[0];};
E.prototype._removeDuplicatesFromStringArray=function(e){var o={};for(var i=0;i<e.length;i++){o[e[i]]=true;}var U=[];for(var s in o){U.push(s);}return U;};
E.prototype._getIdForNewRequestHandle=function(){if(this.oPendingRequestHandle===undefined){this.oPendingRequestHandle=[];}for(var i=0;i<this.oPendingRequestHandle.length;i++){if(this.oPendingRequestHandle[i]===undefined){return i;}}this.oPendingRequestHandle[this.oPendingRequestHandle.length]=undefined;return this.oPendingRequestHandle.length-1;};
E.prototype._registerNewRequestHandle=function(r,R){if(this.oPendingRequestHandle[r]!==undefined){w.fatal("request handle ID already in use");}this.oPendingRequestHandle[r]=R;};
E.prototype._deregisterHandleOfCompletedRequest=function(r){if(Q.isEmptyObject(this.oPendingRequestHandle)){w.warning("No request handles to be cleared. Previous abort/resetData?");return;}if(this.oPendingRequestHandle[r]===undefined){w.fatal("no handle found for this request ID");}this.oPendingRequestHandle[r]=undefined;};
E.prototype._abortAllPendingRequestsByHandle=function(){for(var i=0;i<this.oPendingRequestHandle.length;i++){if(this.oPendingRequestHandle[i]){if(this.oPendingRequestHandle[i]!==undefined){this.oPendingRequestHandle[i].abort();}}}this.oPendingRequestHandle=[];};
E.prototype._getRequestId=function(r,p){switch(r){case E._requestType.groupMembersQuery:if(p.groupId===undefined){w.fatal("missing group ID");}return E._requestType.groupMembersQuery+(p.groupId==null?"":p.groupId);case E._requestType.levelMembersQuery:if(p.level===undefined){w.fatal("missing level");}if(p.groupId===undefined){w.fatal("missing groupId");}return""+E._requestType.levelMembersQuery+p.level+(p.tupleIndex?"-"+p.tupleIndex:"");case E._requestType.totalSizeQuery:return E._requestType.totalSizeQuery;case E._requestType.reloadMeasuresQuery:if(!p.multiUnitEntryKey){w.fatal("missing multi unit entry key");}return E._requestType.reloadMeasuresQuery+p.multiUnitEntryKey;default:w.fatal("invalid request type "+r);return-1;}};
E.prototype._registerNewRequest=function(r){if(r==undefined||r==""){w.fatal("missing request ID");return;}if(!this.oPendingRequests[r]){this.oPendingRequests[r]=1;}else{++this.oPendingRequests[r];}};
E.prototype._considerRequestGrouping=function(r){for(var i=-1,R;(R=r[++i])!==undefined;){if(this.oGroupedRequests[R]===undefined){this.oGroupedRequests[R]={};}var g=this.oGroupedRequests[R];for(var j=0;j<r.length;j++){g[r[j]]=true;}}};
E.prototype._isRequestPending=function(r){return this.oPendingRequests[r]!=undefined&&this.oPendingRequests[r]>0;};
E.prototype._deregisterCompletedRequest=function(r){if(Q.isEmptyObject(this.oPendingRequests)){w.warning("There are no pending requests which could be set to 'completed'.");return;}if(!this.oPendingRequests[r]){w.fatal("assertion failed: there is no pending request ID "+r);}if(this.oPendingRequests[r]==1){delete this.oPendingRequests[r];}else{--this.oPendingRequests[r];}};
E.prototype._cleanupGroupingForCompletedRequest=function(r){if(this._isRequestPending(r)){return false;}var g=true;if(this.oGroupedRequests[r]!=undefined){for(var o in this.oGroupedRequests[r]){if(this.oPendingRequests[o]){g=false;break;}}}if(g){var R=this.oGroupedRequests[r];delete this.oGroupedRequests[r];for(var O in R){if(O!=r){this._cleanupGroupingForCompletedRequest(O);}}}return g;};
E.prototype._getKeyIndexMapping=function(g,s){var k=this.mKeyIndex[g];var e=this.mServiceKey[g];var i=s;if(k!==undefined){var l=s;if(l>0){while(--l>0){if(k[l]!==undefined){break;}}}var h;if(l==0){h=0;}else{if(k[l]>=0){h=k[l];}else if(k[l+1]===undefined){h=k[l]=="ZERO"?0:-k[l];while(e[h+1]!==undefined){++h;}}else{h=Math.abs(k[l+1])-1;}if(e[h]===undefined){w.fatal("assertion failed: no service key at iLastOccupiedServiceKeyIndex = "+h);}}var j=s-l;i=h+j;}var K={sGroupId:g,iIndex:s,iServiceKeyIndex:i};return K;};
E.prototype._moveKeyIndexMapping=function(k,i){return this._getKeyIndexMapping(k.sGroupId,k.iIndex+i);};
E.prototype._getKey=function(g,i){var s=this.mKeyIndex[g][i];if(s===undefined){return undefined;}if(s>=0){return this.mServiceKey[g][s];}if(this.mMultiUnitKey[g]===undefined){w.fatal("assertion failed: missing expected multi currency key for group with ID "+g);return null;}var k=this.mMultiUnitKey[g][i];if(k===undefined){w.fatal("assertion failed: missing expected multi currency key for group with ID "+g+" at pos "+i);return null;}return k;};
E.prototype._getKeys=function(g){if(this.mKeyIndex[g]===undefined){return undefined;}var e=this;return function(i){return e._getKey(g,i);};};
E.prototype._getServiceKeys=function(g,I){var k=this.mKeyIndex[g];if(k===undefined){return undefined;}var s=this.mServiceKey[g],e=k[I];if(e===undefined){return undefined;}if(e>=0){return[s[e]];}var h=[];if(k[I+1]===undefined){e=k[I]=="ZERO"?0:-k[I];while(s[e]!==undefined){h.push(s[e++]);}}else{e=k[I]=="ZERO"?0:-k[I];for(var i=e,n=Math.abs(k[I+1]);i<n;i++){h.push(s[i]);}}return h;};
E.prototype._getKeyCount=function(g){if(this.mKeyIndex[g]===undefined){return undefined;}return this.mKeyIndex[g].length;};
E.prototype._findKeyIndex=function(g,k){var K=this.mKeyIndex[g];var s=this.mServiceKey[g];var m=this.mMultiUnitKey[g];for(var i=0;i<this.mLength[g];i++){if(K[i]<0||K[i]==="ZERO"){if(m[i]==k){return i;}}else if(s[K[i]]==k){return i;}}return-1;};
E.prototype._setServiceKey=function(k,s){if(!this.mServiceKey[k.sGroupId]){this.mServiceKey[k.sGroupId]=[];}if(!this.mKeyIndex[k.sGroupId]){this.mKeyIndex[k.sGroupId]=[];}var n=this.mServiceKey[k.sGroupId][k.iServiceKeyIndex]===undefined;this.mServiceKey[k.sGroupId][k.iServiceKeyIndex++]=s;this.mKeyIndex[k.sGroupId][k.iIndex++]=k.iServiceKeyIndex-1;return n;};
E.prototype._setAdjacentMultiUnitKeys=function(k,m,M){if(!this.mServiceKey[k.sGroupId]){this.mServiceKey[k.sGroupId]=[];}if(!this.mKeyIndex[k.sGroupId]){this.mKeyIndex[k.sGroupId]=[];}if(!this.mMultiUnitKey[k.sGroupId]){this.mMultiUnitKey[k.sGroupId]=[];}--k.iIndex;--k.iServiceKeyIndex;this.mMultiUnitKey[k.sGroupId][k.iIndex]=this.oModel._getKey(m.oEntry);this.mKeyIndex[k.sGroupId][k.iIndex++]=k.iServiceKeyIndex>0?-k.iServiceKeyIndex:"ZERO";var n=0;for(var i=0;i<M.length;i++){if(!this.mServiceKey[k.sGroupId][k.iServiceKeyIndex]){++n;}this.mServiceKey[k.sGroupId][k.iServiceKeyIndex++]=this.oModel._getKey(M[i]);}return n;};
E.prototype._mergeLoadedKeyIndexWithSubsequentIndexes=function(k,e,s,I){var K=this.mKeyIndex[k.sGroupId],g=this.mServiceKey[k.sGroupId],m=this.mMultiUnitKey[k.sGroupId],h=0,n=k.iServiceKeyIndex,j=k.iIndex;var M,o;if(K===undefined){return h;}var N=false;var p=g[n-1],l=g[n];if(l===undefined){return h;}if(p===undefined){w.fatal("assertion failed: missing expected entry before given key index");return h;}var P=this.oModel.getObject("/"+p);var q=this.oModel.getObject("/"+l);var r="",z="";for(var i=0;i<e.length;i++){r+=P[e[i]]+"|";z+=q[e[i]]+"|";}N=r==z;var H=j;if(H>=this.mLength[k.sGroupId]){w.fatal("assertion failed: service key exists,but no corresponding key index found");return h;}while(K[H]===undefined||Math.abs(K[H])<n){++H;}if(N){if(Math.abs(K[H])==n&&K[H]<0){if(H>j){if(K[j-1]<0){m[H]=undefined;K.splice(j,H-j+1);m.splice(j,H-j+1);}else{K[j-1]=-K[j-1];m[j-1]=m[H];m[H]=undefined;K.splice(j,H-j+1);m.splice(j,H-j+1);h=1;}}}else if(Math.abs(K[H])>n){var J=H-1;if(K[J]>0){M=this._createMultiUnitRepresentativeEntry(k.sGroupId,P,s,undefined,I);o=this.oModel._getKey(M.oEntry);K[J]=-K[J];m[J]=o;if(J>j){K.splice(j,J-j);m.splice(j,J-j);}if(M.bIsNewEntry){h=1;}else{h=0;}}else if(K[j-1]<0){if(H>j){m[J]=undefined;K.splice(j,J-j+1);m.splice(j,J-j+1);}}else{K[j-1]=-K[j-1];m[j-1]=m[J];m[J]=undefined;K.splice(j,J-j+1);m.splice(j,J-j+1);}}else if(K[H]==n){if(H>j){if(K[j-1]<0){K.splice(j,H-j+1);m.splice(j,H-j+1);h=1;}else{M=this._createMultiUnitRepresentativeEntry(k.sGroupId,P,s,undefined,I);o=this.oModel._getKey(M.oEntry);if(!M.bIsNewEntry){w.fatal("assertion failed: multi-unit entry already existed before");}K[j-1]=-K[j-1];m[j-1]=o;K.splice(j,H-j+1);m.splice(j,H-j+1);h=1;}}}else{w.fatal("assertion failed: uncovered case detected");return h;}}else if(K[H]>n){w.fatal("unstable query result for group ID "+k.sGroupId+": entries have been removed or added. Complete reload required");}else if(H-j>0){K.splice(j,H-j);m.splice(j,H-j);}return h;};
E.prototype._createMultiUnitRepresentativeEntry=function(g,r,s,e,i){var m=Q.extend(true,{},r);var R=[];for(var M in this.oMeasureDetailsSet){var o=this.oMeasureDetailsSet[M];if(!i&&!this.mAnalyticalInfoByProperty[M].total){if(o.rawValuePropertyName!=undefined){m[o.rawValuePropertyName]=undefined;}if(o.formattedValuePropertyName!=undefined){m[o.formattedValuePropertyName]=undefined;}}else{if(o.rawValuePropertyName!=undefined){m[o.rawValuePropertyName]=null;}if(o.formattedValuePropertyName!=undefined){m[o.formattedValuePropertyName]="*";}}if(e){if(!o.unitPropertyName||e.indexOf(o.unitPropertyName)==-1){R.push(o.rawValuePropertyName);}}}for(var k=0;k<s.length;k++){if(e.indexOf(s[k])!=-1){m[s[k]]="*";}}var h="";for(var l=0;l<this.aAllDimensionSortedByName.length;l++){var j=m[this.aAllDimensionSortedByName[l]];var n=j===""?'""':j;n=n===undefined?"":n;h+=(encodeURIComponent(n)+",");}h+="-multiple-units-not-dereferencable";var p;if(this.mMultiUnitKey[g]&&(p=this.mMultiUnitKey[g].indexOf(h))!=-1){return{oEntry:this.oModel.getObject("/"+h),bIsNewEntry:false,iIndex:p,aReloadMeasurePropertyName:R};}m.__metadata.uri=h;delete m.__metadata["self"];delete m.__metadata["self_link_extensions"];m["^~volatile"]=true;this.oModel._importData(m,{},{});var q=this.oModel._getKey(m);this.oModel.getContext('/'+q)["_volatile"]=true;return{oEntry:m,bIsNewEntry:true,aReloadMeasurePropertyName:R};};
E.prototype._clearAllPendingRequests=function(){this.oPendingRequests={};this.oGroupedRequests={};};
E.prototype.resetData=function(o){var g=o?o.getPath():undefined;this._resetData(g);};
E.prototype._resetData=function(g){if(g){delete this.mServiceKey[g];delete this.mServiceLength[g];delete this.mServiceFinalLength[g];delete this.mKeyIndex[g];delete this.mLength[g];delete this.mMultiUnitKey[g];delete this.mEntityKey[g];}else{this.mServiceKey={};this.mServiceLength={};this.mServiceFinalLength={};this.mFinalLength=this.mServiceFinalLength;this.mKeyIndex={};this.mLength={};this.mMultiUnitKey={};this.mEntityKey={};}};
E.prototype.refresh=function(e){E.prototype._refresh.apply(this,arguments);};
E.prototype._refresh=function(e,m,g){var h=false;if(!e){if(g){var r=this.oModel.resolve(this.sPath,this.oContext);var o=this.oModel.oMetadata._getEntityTypeByPath(r);if(o&&(o.entityType in g)){h=true;}}if(m&&!h){Q.each(this.mServiceKey,function(i,n){Q.each(n,function(i,k){if(k in m){h=true;return false;}});if(h){return false;}});}if(!m&&!g){h=true;}}if(e||h){this.iTotalSize=-1;this._abortAllPendingRequests();this.resetData();this.bNeedsUpdate=false;this._fireRefresh({reason:C.Refresh});}};
E.prototype.checkUpdate=function(e,m){var g=false;if(!e){if(this.bNeedsUpdate||!m){g=true;}else{Q.each(this.mServiceKey,function(i,n){Q.each(n,function(i,k){if(k in m){g=true;return false;}});if(g){return false;}});}}if(e||g){this.bNeedsUpdate=false;this._fireChange({reason:C.Change});}};
E.prototype.getDownloadUrl=function(s){var e,p,z;var o=new t.QueryResultRequest(this.oAnalyticalQueryResult);o.setResourcePath(this._getResourcePath());var g=[];var h=[];for(var n in this.oDimensionDetailsSet){g.push(n);}o.setAggregationLevel(g);for(var q in this.oDimensionDetailsSet){var r=this.oDimensionDetailsSet[q];var I=(r.textPropertyName!=undefined);o.includeDimensionKeyTextAttributes(r.name,true,I,r.aAttributeName);}for(var M in this.oMeasureDetailsSet){h.push(M);}o.setMeasures(h);for(var H in this.oMeasureDetailsSet){var J=this.oMeasureDetailsSet[H];var K=(J.rawValuePropertyName!=undefined);var N=(J.formattedValuePropertyName!=undefined);var O=(J.unitPropertyName!=undefined);o.includeMeasureRawFormattedValueUnit(J.name,K,N,O);}var P=o.getSortExpression();P.clear();for(var i=0;i<this.aSorter.length;i++){if(this.aSorter[i]){P.addSorter(this.aSorter[i].sPath,this.aSorter[i].bDescending?t.SortOrder.Descending:t.SortOrder.Ascending);}}var R=o.getFilterExpression();R.clear();if(this.aApplicationFilter){R.addUI5FilterConditions(this.aApplicationFilter);}if(this.aControlFilter){R.addUI5FilterConditions(this.aControlFilter);}var U=o.getURIToQueryResultEntitySet();var V=this._getQueryODataRequestOptions(o,true);if(!V){return undefined;}var W=[];for(var k=0,m=this.aAnalyticalInfo.length;k<m;k++){var X=this.aAnalyticalInfo[k];if((X.visible||X.inResult)&&X.name!==""&&X.name!==W[W.length-1]){W.push(X.name);if(this.oMeasureDetailsSet[X.name]!=undefined&&this.oMeasureDetailsSet[X.name].unitPropertyName!=undefined){W.push(this.oMeasureDetailsSet[X.name].unitPropertyName);}}}for(var j=0,l=V.length;j<l;j++){if(/^\$select/i.test(V[j])){if(this.mParameters.select){e=V[j].slice(8).split(",");for(z=0;z<e.length;z++){p=e[z];if(W.indexOf(p)===-1){W.push(p);}}}V[j]="$select="+W.join(",");break;}}if(s){V.splice(0,0,"$format="+encodeURIComponent(s));}if(this.sCustomParams){V.push(this.sCustomParams);}if(U){return this.oModel._createRequestUrl(U,null,V).replace(/ /g,"%20");}};
E.prototype._addSorters=function(s,g){var e=this._canApplySortersToGroups()?[].concat(this.aSorter).concat(g):[].concat(g).concat(this.aSorter);e.forEach(function(o){s.addSorter(o.sPath,o.bDescending?t.SortOrder.Descending:t.SortOrder.Ascending);});};
E.prototype._canApplySortersToGroups=function(){var s=this._autoExpandMode;if(this.bApplySortersToGroups){if(this.aSorter.length>0){if(s!==this.sLastAutoExpandMode&&s!==f.Sequential){w.warning("Applying sorters to groups is only possible with auto"+" expand mode 'Sequential'; current mode is: "+s,this.sPath);}this.sLastAutoExpandMode=s;}return s===f.Sequential;}return false;};
E.prototype._warnNoSortingOfGroups=function(s){var m;if(this.bApplySortersToGroups){m="Detected a multi-unit case, so sorting is only possible on leaves";if(s){m+="; "+s;}w.warning(m,this.sPath);}this.bApplySortersToGroups=false;};
E.Logger=w;return E;});
sap.ui.predefine('sap/ui/model/analytics/AnalyticalTreeBindingAdapter',['sap/ui/model/TreeBinding','./AnalyticalBinding','sap/ui/model/TreeAutoExpandMode','sap/ui/model/ChangeReason','sap/ui/model/odata/ODataTreeBindingAdapter','sap/ui/model/TreeBindingAdapter','sap/ui/model/TreeBindingUtils',"sap/base/assert","sap/base/Log","sap/ui/thirdparty/jquery"],function(T,A,a,C,O,b,c,d,L,q){"use strict";var e=function(){if(!(this instanceof T)||this._bIsAdapted){return;}O.apply(this);for(var f in e.prototype){if(e.prototype.hasOwnProperty(f)){this[f]=e.prototype[f];}}this.setAutoExpandMode(this.mParameters.autoExpandMode||a.Bundled);};
e.prototype.getGrandTotalContext=function(){if(this._oRootNode){return this._oRootNode.context;}};
e.prototype.getGrandTotalNode=function(){if(this._oRootNode){return this._oRootNode;}};
e.prototype.getGrandTotalContextInfo=function(){return this._oRootNode;};
e.prototype.getLength=function(){if(!this._oRootNode){return 0;}if(this._oRootNode&&this._oWatermark&&this._isRunningInAutoExpand(a.Bundled)){if(this._oWatermark.groupID===this._oRootNode.groupID){return this._oRootNode.magnitude+this._oRootNode.numberOfTotals;}return this._oWatermark.absoluteNodeIndex+this._oRootNode.numberOfTotals+1;}return this._oRootNode.magnitude+this._oRootNode.numberOfTotals;};
e.prototype.getContextByIndex=function(i){if(this._oRootNode&&i===(this.getLength()-1)&&this.providesGrandTotal()&&this.hasTotaledMeasures()){return this._oRootNode.context;}var n=this.findNode(i);if(!n||!n.context){n={context:this.getContexts(i,1,0)[0]};}return n?n.context:undefined;};
e.prototype.getNodeByIndex=function(i){if(i===(this.getLength()-1)&&this.providesGrandTotal()&&this.hasTotaledMeasures()){return this._oRootNode;}if(i>=this.getLength()){return undefined;}return this.findNode(i);};
e.prototype._isNodeSelectable=function(n){if(!n){return false;}return n.isLeaf&&!n.isArtificial;};
e.prototype.getContexts=function(s,l,t,r){if(!l){l=this.oModel.iSizeLimit;}if(!t){t=0;}this._iPageSize=l;this._iThreshold=Math.max(this._iThreshold,t);this._aRowIndexMap=[];this._buildTree(s,l);var n=[];if(this._oRootNode){n=this._retrieveNodeSection(this._oRootNode,s,l);}this._updateRowIndexMap(n,s);var f=[];var m;for(var i=0;i<n.length;i++){var N=n[i];if(this._isRunningInAutoExpand(a.Bundled)&&this._oWatermark){if(N.groupID===this._oWatermark.groupID||(this._oWatermark.groupID===this._oRootNode.groupID&&(s+i+1)==this.getLength()-1)){this._autoExpandPaging();}}if(!N.context){m=m||{};var p=N.parent;m[p.groupID]=p;this._updateNodeSections(p.groupID,{startIndex:N.positionInParent,length:1});}f.push(N.context);}if(m){var g=this;q.each(m,function(G,N){N.magnitude=0;N.numberOfTotals=0;g._loadChildContexts(N,{absoluteNodeIndex:N.absoluteNodeIndex});});f=[];for(var j=0;j<n.length;j++){var N=n[j];f.push(N.context);}}if(r){return n;}else{return f;}};
e.prototype._autoExpandPaging=function(){d(this._oWatermark,"No watermark was set!");d(this._isRunningInAutoExpand(a.Bundled),"Optimised AutoExpand Paging can only be used with TreeAutoExpandMode.Bundled!");var f=this.getNodeContexts(this._oWatermark.context,{startIndex:this._oWatermark.startIndex,length:this._iPageSize,threshold:this._iThreshold,level:this._oWatermark.level,numberOfExpandedLevels:this._oWatermark.autoExpand});return f;};
e.prototype._afterMatchHook=function(n,r,m,M,p,P){if(n.sumNode&&n!==this._oRootNode){if(r.length===m){return true;}var N=M.call(this,n.sumNode,n.sumNode.positionInParent,P);if(N){r.push(n.sumNode);}}};
e.prototype._afterMapHook=function(n,m){if(n.sumNode&&n!==this._oRootNode){m.call(this,n.sumNode);}};
e.prototype._createSumNode=function(n){var s;if(this.bProvideGrandTotals&&!this.mParameters.sumOnTop&&this.hasTotaledMeasures()&&n.children.length>1){s=this._createNode({parent:n.parent,positionInParent:n.children.length,context:n.context,level:n.level});s.nodeState=this._createNodeState({groupID:s.groupID,sum:true,expanded:false});}return s;};
e.prototype._buildTree=function(s,l){this._oRootNode=undefined;this._oWatermark=undefined;var n=this.mParameters&&this.getNumberOfExpandedLevels();var r=this.getRootContexts({startIndex:0,length:this._iPageSize,threshold:this._iThreshold,numberOfExpandedLevels:this._autoExpandMode===a.Bundled?n:undefined});var R;if(r==null){L.warning("AnalyticalTreeBindingAdapter: No Dimensions given. An artificial rootContext has be created. Please check your Table/Service definition for dimension columns!");}else{R=r[0];}if(!R){return;}var o=this._getNodeState("/");if(!o){o=this._updateTreeState({groupID:"/",expanded:true,sum:true});this._updateNodeSections("/",{startIndex:0,length:l});}this._oRootNode=this._createNode({context:R,parent:null,level:0,nodeState:o,isLeaf:false,autoExpand:n,absoluteNodeIndex:-1});this._oRootNode.isArtificial=true;this._loadChildContexts(this._oRootNode,{absoluteNodeIndex:-1});};
e.prototype._loadChildContexts=function(n,r){var N=n.nodeState;var m=this.getGroupSize(n.context,n.level);if(m>=0){if(!n.children[m-1]){n.children[m-1]=undefined;}if(n.level===this.aAggregationLevel.length){N.leafCount=m;}n.sumNode=this._createSumNode(n);}for(var i=0;i<N.sections.length;i++){var o=N.sections[i];if(o.startIndex>n.children.length){continue;}var R;if(m===-1){R=o.length;}else{R=Math.min(o.length,m-o.startIndex);}var s=false;if(n.autoExpand>=0&&this._isRunningInAutoExpand(a.Bundled)){s=true;R=Math.max(0,m);}var f=this.getNodeContexts(n.context,{startIndex:o.startIndex,length:R,threshold:s?0:this._iThreshold,level:n.level,supressRequest:s});for(var j=0;j<f.length;j++){var g=f[j];var h=j+o.startIndex;var k=n.children[h];var u={context:f[j],parent:n,level:n.level+1,positionInParent:h,autoExpand:Math.max(n.autoExpand-1,-1),absoluteNodeIndex:(++r.absoluteNodeIndex)};if(k){k.context=u.context;k.parent=u.parent;k.level=u.level;k.positionInParent=u.positionInParent;k.magnitude=0;k.numberOfTotals=0;k.totalNumberOfLeafs=0;k.autoExpand=u.autoExpand;k.absoluteNodeIndex=u.absoluteNodeIndex;var G;if(g){G=this._calculateGroupID(k);}k.groupID=G;}else{k=this._createNode(u);}k.nodeState=this._getNodeState(k.groupID);if(!k.nodeState){k.nodeState=this._createNodeState({groupID:k.groupID,expanded:false});}k.nodeState.parentGroupID=n.groupID;k.isLeaf=!this.nodeHasChildren(k);n.children[h]=k;if(k.isLeaf){n.numberOfLeafs+=1;}if(k.parent.nodeState.selectAllMode&&!this._mTreeState.deselected[k.groupID]&&k.isLeaf){this.setNodeSelection(k.nodeState,true);}if((k.autoExpand>=0||k.nodeState.expanded)&&this.isGrouped()){if(!this._mTreeState.collapsed[k.groupID]){if(k.autoExpand>=0&&k.parent.nodeState.selectAllMode&&!this._mTreeState.deselected[k.groupID]){if(k.nodeState.selectAllMode===undefined){k.nodeState.selectAllMode=true;}}this._updateTreeState({groupID:k.nodeState.groupID,fallbackNodeState:k.nodeState,expanded:true});this._loadChildContexts(k,r);}n.magnitude+=k.magnitude;n.numberOfTotals+=k.numberOfTotals;n.numberOfLeafs+=k.numberOfLeafs;}if(k&&k.isLeaf){n.totalNumberOfLeafs=m;}else{n.totalNumberOfLeafs+=k.totalNumberOfLeafs;}}}m=this._isRunningInAutoExpand(a.Bundled)?n.children.length:m;n.magnitude+=Math.max(m||0,0);if(!m&&!this._isRunningInAutoExpand(a.Bundled)){L.warning("AnalyticalTreeBindingAdapter: iMaxGroupSize("+m+") is undefined for node '"+n.groupID+"'!");}if(n.sumNode||(n===this._oRootNode&&this.providesGrandTotal()&&this.hasTotaledMeasures())){n.numberOfTotals+=1;}if(this._isRunningInAutoExpand(a.Bundled)&&n.autoExpand!=-1){if(!this._oWatermark&&!n.isLeaf&&!this.mFinalLength[n.groupID]){this._oWatermark={groupID:n.groupID,context:n.context,absoluteNodeIndex:n.absoluteNodeIndex,startIndex:n.children.length,level:n.level,autoExpand:n.autoExpand};}}};
e.prototype._calculateGroupID=function(n){var g;var m=this.aAggregationLevel.length;if(!this.isGrouped()&&n&&n.positionInParent){g="/"+n.positionInParent+"/";}else{if(n.level>m){g=this._getGroupIdFromContext(n.context,m);d(n.positionInParent!=undefined,"If the node level is greater than the number of grouped columns, the position of the node to its parent must be defined!");g+=n.positionInParent+"/";}else{g=this._getGroupIdFromContext(n.context,n.level);}}return g;};
e.prototype.collapse=function(p){var n,N;if(typeof p==="object"){n=p;}else if(typeof p==="number"){N=this.findNode(p);d(N&&N.nodeState,"AnalyticalTreeBindingAdapter.collapse("+p+"): No node found!");if(!N){return;}n=N.nodeState;}this._updateTreeState({groupID:n.groupID,expanded:false});n.selectAllMode=false;var f=false;if(this.bCollapseRecursive||this._isRunningInAutoExpand(a.Bundled)){var g=n.groupID;if(this._isRunningInAutoExpand(a.Bundled)&&this._oWatermark&&(typeof g=="string"&&g.length>0&&this._oWatermark.groupID.startsWith(g))){if(N&&N.parent){this._oWatermark={groupID:N.parent.groupID,context:N.parent.context,absoluteNodeIndex:N.parent.absoluteNodeIndex,startIndex:N.positionInParent+1,level:N.parent.level,autoExpand:N.parent.autoExpand};}this._autoExpandPaging();f=true;}var t=this;q.each(this._mTreeState.expanded,function(G,o){if(typeof g=="string"&&g.length>0&&G.startsWith(g)){t._updateTreeState({groupID:G,expanded:false});}});var D=[];q.each(this._mTreeState.selected,function(G,o){if(typeof g=="string"&&g.length>0&&G.startsWith(g)){o.selectAllMode=false;t.setNodeSelection(o,false);D.push(G);}});if(D.length){var s={rowIndices:[]};var i=0;this._map(this._oRootNode,function(N){if(!N||!N.isArtificial){i++;}if(N&&D.indexOf(N.groupID)!==-1){if(N.groupID===this._sLeadSelectionGroupID){s.oldIndex=i;s.leadIndex=-1;}s.rowIndices.push(i);}});this._publishSelectionChanges(s);}}if(!f){this._fireChange({reason:C.Collapse});}};
e.prototype.collapseToLevel=function(l){this.setNumberOfExpandedLevels(l,true);b.prototype.collapseToLevel.call(this,l);};
e.prototype.nodeHasChildren=function(n){d(n,"AnalyticalTreeBindingAdapter.nodeHasChildren: No node given!");if(!n||!n.parent||n.nodeState.sum){return false;}else if(n.isArtificial){return true;}else{return A.prototype.hasChildren.call(this,n.context,{level:n.level});}};
e.prototype.resetData=function(o,p){var r=A.prototype.resetData.call(this,o,p);this._aRowIndexMap=[];this._oRootNode=undefined;this._oWatermark=undefined;this._iPageSize=0;this._iThreshold=0;if(!p||p.reason!==C.Sort){this.clearSelection();this._createTreeState(true);}return r;};
e.prototype.hasTotaledMeasures=function(){var h=false;q.each(this.getMeasureDetails()||[],function(i,m){if(m.analyticalInfo.total){h=true;return false;}});return h;};
e.prototype.isGrouped=function(){return(this.aAggregationLevel.length>0);};
e.prototype._isRunningInAutoExpand=function(s){if(this.getNumberOfExpandedLevels()>0&&this._autoExpandMode===s){return true;}else{return false;}};
e.prototype.setNumberOfExpandedLevels=function(l,s){l=l||0;if(l<0){L.warning("AnalyticalTreeBindingAdapter: numberOfExpanded levels was set to 0. Negative values are prohibited.");l=0;}if(!s){this.resetData();}this.mParameters.numberOfExpandedLevels=l;};
e.prototype.getNumberOfExpandedLevels=function(){return this.mParameters.numberOfExpandedLevels;};
e.prototype._getSelectableNodesCount=function(n){if(n){return n.totalNumberOfLeafs;}else{return 0;}};
return e;},true);
sap.ui.predefine('sap/ui/model/analytics/AnalyticalVersionInfo',["sap/base/Log"],function(L){"use strict";var A={NONE:null,V1:1,V2:2,getVersion:function(o){var v;var O;if(o&&o.getMetadata){O=o.getMetadata().getName();}switch(O){case"sap.ui.model.odata.ODataModel":v=this.V1;break;case"sap.ui.model.odata.v2.ODataModel":v=this.V2;break;default:v=this.NONE;L.info("AnalyticalVersionInfo.getVersion(...) - The given object is no instance of ODataModel V1 or V2!");break;}return v;}};return A;},true);
sap.ui.predefine('sap/ui/model/analytics/BatchResponseCollector',function(){"use strict";
function B(p){if(p){this.setup(p);}}
B.TYPE_SUCCESS="success";B.TYPE_ERROR="error";
B.prototype.setup=function(p){this.iRequestCollectionCount=0;this.aCollectedSuccesses=[];this.aCollectedErrors=[];this.aExecutedRequestDetails=p.executedRequests;this.oAnalyticalBinding=p.binding;this.fnSuccessHandler=p.success;this.fnErrorHandler=p.error;};
B.prototype.success=function(r){this.collect(r,B.TYPE_SUCCESS);};
B.prototype.error=function(r){this.collect(r,B.TYPE_ERROR);};
B.prototype.collect=function(r,R){this.iRequestCollectionCount++;if(R===B.TYPE_SUCCESS){this.aCollectedSuccesses.push(r);}else{this.aCollectedErrors.push(r);}var o=(this.aCollectedSuccesses.length+this.aCollectedErrors.length);if(o===this.aExecutedRequestDetails.length){if((this.aCollectedSuccesses.length===o)&&this.aCollectedErrors.length===0){this.fnSuccessHandler.call(window,{__batchResponses:this.aCollectedSuccesses},{requestUri:this.oAnalyticalBinding.oModel.sServiceUrl+"/$batch"});}else{this.fnErrorHandler.call(window,this.aCollectedErrors[0]||{});}}};
return B;},true);
sap.ui.predefine('sap/ui/model/analytics/ODataModelAdapter',['./AnalyticalBinding',"./AnalyticalTreeBindingAdapter",'./odata4analytics','./AnalyticalVersionInfo',"sap/base/Log"],function(A,a,o,b,L){"use strict";var O=function(){var m=b.getVersion(this);if(m===b.NONE||this.getAnalyticalExtensions){return;}this._mPreadapterFunctions={bindList:this.bindList,bindTree:this.bindTree};for(var f in O.prototype){if(O.prototype.hasOwnProperty(f)){this[f]=O.prototype[f];}}if(m===b.V1&&this.isCountSupported()){L.info("ODataModelAdapter: switched ODataModel to use inlinecount (mandatory for the AnalyticalBinding)");this.setCountSupported(false);}};
O.prototype.bindList=function(p,c,s,f,P){if(P&&P.analyticalInfo){var B=new A(this,p,c,s,f,P);a.apply(B);return B;}else{return this._mPreadapterFunctions.bindList.apply(this,arguments);}};
O.prototype.bindTree=function(p,c,f,P){if(P&&P.analyticalInfo){var B=new A(this,p,c,[],f,P);return B;}else{return this._mPreadapterFunctions.bindTree.apply(this,arguments);}};
O.prototype.getAnalyticalExtensions=function(){if(this.oOData4SAPAnalyticsModel!=undefined&&this.oOData4SAPAnalyticsModel!=null){return this.oOData4SAPAnalyticsModel;}var m=b.getVersion(this);if(m===b.V2&&!(this.oMetadata&&this.oMetadata.isLoaded())){throw"Failed to get the analytical extensions. The metadata have not been loaded by the model yet."+"Register for the 'metadataLoaded' event of the ODataModel(v2) to know when the analytical extensions can be retrieved.";}var s=null;if(arguments.length==1){var c=arguments[0];var r=jQuery.sap.syncGetText(c);if(r.success){s=r.data;}}try{this.oOData4SAPAnalyticsModel=new o.Model(new o.Model.ReferenceByModel(this),{sAnnotationJSONDoc:s});}catch(e){throw"Failed to instantiate analytical extensions for given OData model: "+e.message;}return this.oOData4SAPAnalyticsModel;};
O.prototype.setAnalyticalExtensions=function(c){this.oOData4SAPAnalyticsModel=c;};
return O;},true);
sap.ui.predefine('sap/ui/model/analytics/odata4analytics',['sap/ui/model/Filter','sap/ui/model/FilterOperator','sap/ui/model/Sorter','./AnalyticalVersionInfo',"sap/base/security/encodeURL"],function(F,c,S,A,e){"use strict";var o=o||{},d=/^\d+$/;o.constants={};o.constants["SAP_NAMESPACE"]="http://www.sap.com/Protocols/SAPData";o.constants["VERSION"]="0.7";o.helper={deepEqual:function(O,N,f){var a,b,r=0,i,n;if(!O||O.length!==N.length){return 2;}if(O!==N){for(i=0,n=O.length;i<n;i+=1){b=O[i];a=N[i];if(b.grouped!==a.grouped||b.inResult!==a.inResult||b.level!==a.level||b.name!==a.name||b.total!==a.total||b.visible!==a.visible){return 2;}if(b.formatter!==a.formatter){r=1;if(f){f(a);}}}}return r;},tokenizeNametoLabelText:function(n){var l="";l=n.replace(/^P_(.*)/,"$1");l=l.replace(/([^A-Z0-9_]+)([A-Z0-9_])/g,"$1 $2");l=l.replace(/([A-Z0-9_]{2,})([A-Z0-9_])([^A-Z0-9_]+)/g,"$1 $2$3");l=l.replace(/(.*) _E$/,"$1");l=l.replace(/(.*) _(.*)/g,"$1 $2");return l;}};
o.Model=function(m,p){this._init(m,p);};
o.Model.ReferenceByURI=function(u){return{sServiceURI:u};};
o.Model.ReferenceByModel=function(m){return{oModel:m};};
o.Model.ReferenceWithWorkaround=function(m,w){return{oModelReference:m,aWorkaroundID:w};};
o.Model.prototype={_init:function(m,p){if(typeof p=="string"){throw"Deprecated second argument: Adjust your invocation by passing an object with a property sAnnotationJSONDoc as a second argument instead";}this._mParameter=p;var t=this;this._oActivatedWorkarounds={};if(m&&m.aWorkaroundID){for(var i=-1,I;(I=m.aWorkaroundID[++i])!==undefined;){this._oActivatedWorkarounds[I]=true;}m=m.oModelReference;}if(!m||(!m.sServiceURI&&!m.oModel)){throw"Usage with oModelReference being an instance of Model.ReferenceByURI or Model.ReferenceByModel";}if(m.oModel){this._oModel=m.oModel;this._iVersion=A.getVersion(this._oModel);a();}else if(p&&p.modelVersion===A.V2){var V=sap.ui.requireSync("sap/ui/model/odata/v2/ODataModel");this._oModel=new V(m.sServiceURI);this._iVersion=A.V2;a();}else{var O=sap.ui.requireSync("sap/ui/model/odata/ODataModel");this._oModel=new O(m.sServiceURI);this._iVersion=A.V1;a();}if(this._oModel.getServiceMetadata()&&this._oModel.getServiceMetadata().dataServices==undefined){throw"Model could not be loaded";}function a(){if(!t._oModel.getServiceMetadata()){t._oModel.attachMetadataLoaded(b);}else{b();}}function b(){if(t.bIsInitialized){return;}t.bIsInitialized=true;if(p&&p.sAnnotationJSONDoc){t.mergeV2Annotations(p.sAnnotationJSONDoc);}t._interpreteMetadata(t._oModel.getServiceMetadata().dataServices);}},_interpreteMetadata:function(M){this._oQueryResultSet={};this._oParameterizationSet={};this._oEntityTypeSet={};this._oEntitySetSet={};this._oEntityTypeNameToEntitySetMap={};var a=this._oModel.getServiceMetadata().dataServices.schema[0];for(var j=-1,C;(C=a.entityContainer[++j])!==undefined;){if(C.isDefaultEntityContainer=="true"){this._oDefaultEntityContainer=C;break;}}var E=a.entityType;var q=[],P=[],u=[];for(var k=-1,T;(T=E[++k])!==undefined;){var b=false;if(T.extensions!=undefined){for(var l=-1,f;(f=T.extensions[++l])!==undefined;){if(f.namespace==o.constants.SAP_NAMESPACE&&f.name=="semantics"){b=true;switch(f.value){case"aggregate":q.push(T);break;case"parameters":P.push(T);break;default:u.push(T);}}if(b){continue;}}if(!b){u.push(T);}}else{u.push(T);}}for(var m=-1,g;(g=u[++m])!==undefined;){var h=new o.EntityType(this._oModel.getServiceMetadata(),a,g);this._oEntityTypeSet[h.getQName()]=h;var i=this._getEntitySetsOfType(a,h.getQName());if(i.length==0){throw"Invalid consumption model: No entity set for entity type "+h.getQName()+" found";}if(i.length>1){throw"Unsupported consumption model: More than one entity set for entity type "+h.getQName()+" found";}var v=new o.EntitySet(this._oModel.getServiceMetadata(),a,i[0][0],i[0][1],h);this._oEntitySetSet[v.getQName()]=v;this._oEntityTypeNameToEntitySetMap[h.getQName()]=v;}var w={};for(var n=-1,x;(x=P[++n])!==undefined;){var y=new o.EntityType(this._oModel.getServiceMetadata(),a,x);this._oEntityTypeSet[y.getQName()]=y;var z=this._getEntitySetsOfType(a,y.getQName());if(z.length==0){throw"Invalid consumption model: No entity set for parameter entity type "+y.getQName()+" found";}if(z.length>1){throw"Unsupported consumption model: More than one entity set for parameter entity type "+y.getQName()+" found";}var B=new o.EntitySet(this._oModel.getServiceMetadata(),a,z[0][0],z[0][1],y);this._oEntitySetSet[B.getQName()]=B;this._oEntityTypeNameToEntitySetMap[y.getQName()]=B;var D=new o.Parameterization(y,B);this._oParameterizationSet[D.getName()]=D;w[y.getQName()]=D;var G=y.getQName();if(a.association!=undefined){for(var p=-1,H;(H=a.association[++p])!==undefined;){if(H.referentialConstraint==undefined){continue;}var I=null;if(H.end[0].type==G&&H.end[0].multiplicity=="*"&&H.end[1].multiplicity=="1"){I=H.end[1].type;}else if(H.end[1].type==G&&H.end[1].multiplicity=="*"&&H.end[0].multiplicity=="1"){I=H.end[0].type;}if(!I){continue;}if(H.referentialConstraint.dependent.propertyRef.length!=1){continue;}var J=D.findParameterByName(H.referentialConstraint.dependent.propertyRef[0].name);if(J==null){continue;}var V=this._oEntityTypeSet[I];var K=this._oEntityTypeNameToEntitySetMap[I];J.setValueSetEntity(V,K);}}}for(var r=-1,L;(L=q[++r])!==undefined;){var N=new o.EntityType(this._oModel.getServiceMetadata(),a,L);this._oEntityTypeSet[N.getQName()]=N;var Q=N.getQName();var O=null;var R=null;if(a.association!=undefined){for(var s=-1,U;(U=a.association[++s])!==undefined;){var W=null;if(U.end[0].type==Q){W=U.end[1].type;}else if(U.end[1].type==Q){W=U.end[0].type;}else{continue;}var X=null;X=w[W];if(X!=null){if(O!=null){throw"LIMITATION: Unable to handle multiple parameter entity types of query entity "+N.name;}else{O=X;R=U;}}}}var Y=this._getEntitySetsOfType(a,N.getQName());if(Y.length!=1){throw"Invalid consumption model: There must be exactly one entity set for an entity type annotated with aggregating semantics";}var Z=new o.EntitySet(this._oModel.getServiceMetadata(),a,Y[0][0],Y[0][1],N);this._oEntitySetSet[Z.getQName()]=Z;this._oEntityTypeNameToEntitySetMap[N.getQName()]=Z;var $=new o.QueryResult(this,N,Z,O);this._oQueryResultSet[$.getName()]=$;if(O){O.setTargetQueryResult($,R);}if(a.association!=undefined){for(var t=-1,_;(_=a.association[++t])!==undefined;){if(_.referentialConstraint==undefined){continue;}var a1=null;if(_.end[0].type==Q&&_.end[0].multiplicity=="*"&&_.end[1].multiplicity=="1"){a1=_.end[1].type;}else if(_.end[1].type==Q&&_.end[1].multiplicity=="*"&&_.end[0].multiplicity=="1"){a1=_.end[0].type;}if(!a1){continue;}if(_.referentialConstraint.dependent.propertyRef.length!=1){continue;}var b1=$.findDimensionByName(_.referentialConstraint.dependent.propertyRef[0].name);if(b1==null){continue;}var c1=this._oEntityTypeNameToEntitySetMap[a1];b1.setMembersEntitySet(c1);}}}},oUI5ODataModelAnnotatableObject:{objectName:"schema",keyPropName:"namespace",extensions:true,aSubObject:[{objectName:"entityType",keyPropName:"name",extensions:true,aSubObject:[{objectName:"property",keyPropName:"name",aSubObject:[],extensions:true}]},{objectName:"entityContainer",keyPropName:"name",extensions:false,aSubObject:[{objectName:"entitySet",keyPropName:"name",extensions:true,aSubObject:[]}]}]},mergeV2Annotations:function(a){var b=null;try{b=JSON.parse(a);}catch(f){return;}var m;try{m=this._oModel.getServiceMetadata().dataServices;}catch(f){return;}for(var p in b){if(!(this.oUI5ODataModelAnnotatableObject.objectName==p)){continue;}if(!(b[p]instanceof Array)){continue;}this.mergeV2AnnotationLevel(m[this.oUI5ODataModelAnnotatableObject.objectName],b[this.oUI5ODataModelAnnotatableObject.objectName],this.oUI5ODataModelAnnotatableObject);break;}return;},mergeV2AnnotationLevel:function(M,a,u){for(var i=-1,b;(b=a[++i])!==undefined;){for(var j=-1,f;(f=M[++j])!==undefined;){if(!(b[u.keyPropName]==f[u.keyPropName])){continue;}if(b["extensions"]!=undefined){if(f["extensions"]==undefined){f["extensions"]=[];}for(var l=-1,g;(g=b["extensions"][++l])!==undefined;){var h=false;for(var m=-1,n;(n=f["extensions"][++m])!==undefined;){if(g.name==n.name&&g.namespace==n.namespace){n.value=g.value;h=true;break;}}if(!h){f["extensions"].push(g);}}}for(var k=-1,U;(U=u.aSubObject[++k])!==undefined;){for(var p in b){if(!(U.objectName==p)){continue;}if(!(b[U.objectName]instanceof Array)){continue;}if((f[U.objectName]==undefined)||(!(f[U.objectName]instanceof Array))){continue;}this.mergeV2AnnotationLevel(f[U.objectName],b[U.objectName],U);break;}}}}return;},findQueryResultByName:function(n){var q=this._oQueryResultSet[n];if(!q&&this._oDefaultEntityContainer){var Q=this._oDefaultEntityContainer.name+"."+n;q=this._oQueryResultSet[Q];}return q;},getAllQueryResultNames:function(){if(this._aQueryResultNames){return this._aQueryResultNames;}this._aQueryResultNames=new Array(0);for(var n in this._oQueryResultSet){this._aQueryResultNames.push(this._oQueryResultSet[n].getName());}return this._aQueryResultNames;},getAllQueryResults:function(){return this._oQueryResultSet;},getODataModel:function(){return this._oModel;},_getEntitySetsOfType:function(s,q){var E=[];for(var i=-1,a;(a=s.entityContainer[++i])!==undefined;){for(var j=-1,b;(b=a.entitySet[++j])!==undefined;){if(b.entityType==q){E.push([a,b]);}}}return E;},_mParameter:null,_oModel:null,_oDefaultEntityContainer:null,_aQueryResultNames:null,_oQueryResultSet:null,_oParameterizationSet:null,_oEntityTypeSet:null,_oEntitySetSet:null,_oEntityTypeNameToEntitySetMap:null,_oActivatedWorkarounds:null};
o.QueryResult=function(m,E,a,p){this._init(m,E,a,p);};
o.QueryResult.prototype={_init:function(m,E,a,p,b){this._oModel=m;this._oEntityType=E;this._oEntitySet=a;this._oParameterization=p;this._oDimensionSet={};this._oMeasureSet={};var P=E.getTypeDescription().property;var f={};for(var i=-1,g;(g=P[++i])!==undefined;){if(g.extensions==undefined){continue;}for(var j=-1,h;(h=g.extensions[++j])!==undefined;){if(!h.namespace==o.constants.SAP_NAMESPACE){continue;}switch(h.name){case"aggregation-role":switch(h.value){case"dimension":{var D=new o.Dimension(this,g);this._oDimensionSet[D.getName()]=D;break;}case"measure":{var M=new o.Measure(this,g);this._oMeasureSet[M.getName()]=M;break;}case"totaled-properties-list":this._oTotaledPropertyListProperty=g;break;default:}break;case"attribute-for":{var k=new o.DimensionAttribute(this,g);var K=k.getKeyProperty();f[K.name]=k;break;}default:}}}for(var s in f){var l=f[s];l.getDimension().addAttribute(l);}if(m._oActivatedWorkarounds.IdentifyTextPropertiesByName){var n=[];for(var q in this._oDimensionSet){var r=this._oDimensionSet[q];if(!r.getTextProperty()){var T=null;T=E.findPropertyByName(q+"Name");if(!T){T=E.findPropertyByName(q+"Text");}if(!T){T=E.findPropertyByName(q+"Desc");}if(!T){T=E.findPropertyByName(q+"Description");}if(T){r.setTextProperty(T);n.push(T.name);}}}for(var t=-1,u;(u=n[++t])!==undefined;){delete this._oDimensionSet[u];}}},getName:function(){return this.getEntitySet().getQName();},getParameterization:function(){return this._oParameterization;},getAllDimensionNames:function(){if(this._aDimensionNames){return this._aDimensionNames;}this._aDimensionNames=[];for(var n in this._oDimensionSet){this._aDimensionNames.push(this._oDimensionSet[n].getName());}return this._aDimensionNames;},getAllDimensions:function(){return this._oDimensionSet;},getAllMeasureNames:function(){if(this._aMeasureNames){return this._aMeasureNames;}this._aMeasureNames=[];for(var n in this._oMeasureSet){this._aMeasureNames.push(this._oMeasureSet[n].getName());}return this._aMeasureNames;},getAllMeasures:function(){return this._oMeasureSet;},findDimensionByName:function(n){return this._oDimensionSet[n];},findDimensionByPropertyName:function(n){if(this._oDimensionSet[n]){return this._oDimensionSet[n];}for(var D in this._oDimensionSet){var a=this._oDimensionSet[D];var t=a.getTextProperty();if(t&&t.name==n){return a;}if(a.findAttributeByName(n)){return a;}}return null;},getTotaledPropertiesListProperty:function(){return this._oTotaledPropertyListProperty;},findMeasureByName:function(n){return this._oMeasureSet[n];},findMeasureByPropertyName:function(n){if(this._oMeasureSet[n]){return this._oMeasureSet[n];}for(var m in this._oMeasureSet){var M=this._oMeasureSet[m];var f=M.getFormattedValueProperty();if(f&&f.name==n){return M;}}return null;},getModel:function(){return this._oModel;},getEntityType:function(){return this._oEntityType;},getEntitySet:function(){return this._oEntitySet;},_oModel:null,_oEntityType:null,_oEntitySet:null,_oParameterization:null,_aDimensionNames:null,_oDimensionSet:null,_aMeasureNames:null,_oMeasureSet:null,_oTotaledPropertyListProperty:null};
o.Parameterization=function(E,a){this._init(E,a);};
o.Parameterization.prototype={_init:function(E,a){this._oEntityType=E;this._oEntitySet=a;this._oParameterSet={};var p=E.getTypeDescription().property;for(var i=-1,P;(P=p[++i])!==undefined;){if(P.extensions==undefined){continue;}for(var j=-1,b;(b=P.extensions[++j])!==undefined;){if(!b.namespace==o.constants.SAP_NAMESPACE){continue;}switch(b.name){case"parameter":{var f=new o.Parameter(this,P);this._oParameterSet[f.getName()]=f;break;}default:}}}},setTargetQueryResult:function(q,a){this._oQueryResult=q;var Q=this._oEntityType.getSchema().namespace+"."+a.name;var n=this._oEntityType.getTypeDescription().navigationProperty;if(!n){throw"Invalid consumption model: Parameters entity type lacks navigation property for association to query result entity type";}for(var i=-1,N;(N=n[++i])!==undefined;){if(N.relationship==Q){this._oNavPropToQueryResult=N.name;}}if(!this._oNavPropToQueryResult){throw"Invalid consumption model: Parameters entity type lacks navigation property for association to query result entity type";}},getTargetQueryResult:function(){if(!this._oQueryResult){throw"No target query result set";}return this._oQueryResult;},getName:function(){return this.getEntitySet().getQName();},getAllParameterNames:function(){if(this._aParameterNames){return this._aParameterNames;}this._aParameterNames=[];for(var n in this._oParameterSet){this._aParameterNames.push(this._oParameterSet[n].getName());}return this._aParameterNames;},getAllParameters:function(){return this._oParameterSet;},findParameterByName:function(n){return this._oParameterSet[n];},getNavigationPropertyToQueryResult:function(){return this._oNavPropToQueryResult;},getEntityType:function(){return this._oEntityType;},getEntitySet:function(){return this._oEntitySet;},_oEntityType:null,_oEntitySet:null,_oQueryResult:null,_oNavPropToQueryResult:null,_aParameterNames:null,_oParameterSet:null};
o.Parameter=function(p,P){this._init(p,P);};
o.Parameter.prototype={_init:function(p,P){this._oParameterization=p;this._oProperty=P;var E=p.getEntityType();if(P.extensions!=undefined){for(var i=-1,a;(a=P.extensions[++i])!==undefined;){if(!a.namespace==o.constants.SAP_NAMESPACE){continue;}switch(a.name){case"parameter":switch(a.value){case"mandatory":this._bRequired=true;break;case"optional":this._bRequired=false;break;default:throw"Invalid annotation value for parameter property";}break;case"label":this._sLabelText=a.value;break;case"text":this._oTextProperty=E.findPropertyByName(a.value);break;case"upper-boundary":this._bIntervalBoundaryParameter=true;this._oUpperIntervalBoundaryParameterProperty=E.findPropertyByName(a.value);break;case"lower-boundary":this._bIntervalBoundaryParameter=true;this._oLowerIntervalBoundaryParameterProperty=E.findPropertyByName(a.value);break;default:}}}if(!this._sLabelText){this._sLabelText="";}},setValueSetEntity:function(E,a){this._oValueSetEntityType=E;this._oValueSetEntitySet=a;},getTextProperty:function(){return this._oTextProperty;},getLabelText:function(){if(!this._sLabelText&&this._oParameterization._oQueryResult._oModel._oActivatedWorkarounds.CreateLabelsFromTechnicalNames){this._sLabelText=o.helper.tokenizeNametoLabelText(this.getName());}return this._sLabelText;},isOptional:function(){return(!this._bRequired);},isIntervalBoundary:function(){return this._bIntervalBoundaryParameter;},isLowerIntervalBoundary:function(){return(this._oUpperIntervalBoundaryParameterProperty?true:false);},getPeerIntervalBoundaryParameter:function(){var p=null;if(this._oLowerIntervalBoundaryParameterProperty){p=this._oLowerIntervalBoundaryParameterProperty.name;}else{p=this._oUpperIntervalBoundaryParameterProperty.name;}if(!p){throw"Parameter is not an interval boundary";}return this._oParameterization.findParameterByName(p);},isValueSetAvailable:function(){return(this._oValueSetEntityType?true:false);},getName:function(){return this._oProperty.name;},getProperty:function(){return this._oProperty;},getContainingParameterization:function(){return this._oParameterization;},getURIToValueEntitySet:function(s){var u=null;u=(s?s:"")+"/"+this._oValueSetEntitySet.getQName();return u;},_oParameterization:null,_oProperty:null,_sLabelText:null,_oTextProperty:null,_bRequired:false,_bIntervalBoundaryParameter:false,_oLowerIntervalBoundaryParameterProperty:null,_oUpperIntervalBoundaryParameterProperty:null,_oValueSetEntityType:null,_oValueSetEntitySet:null};
o.Dimension=function(q,p){this._init(q,p);};
o.Dimension.prototype={_init:function(q,p){this._oQueryResult=q;this._oProperty=p;this._oAttributeSet={};},setMembersEntitySet:function(E){this._oMembersEntitySet=E;},getName:function(){return this._oProperty.name;},getKeyProperty:function(){return this._oProperty;},getTextProperty:function(){if(!this._oTextProperty){this._oTextProperty=this._oQueryResult.getEntityType().getTextPropertyOfProperty(this.getName());}return this._oTextProperty;},setTextProperty:function(t){this._oTextProperty=t;},getLabelText:function(){if(!this._sLabelText){this._sLabelText=this._oQueryResult.getEntityType().getLabelOfProperty(this.getName());}if(!this._sLabelText&&this._oQueryResult._oModel._oActivatedWorkarounds.CreateLabelsFromTechnicalNames){this._sLabelText=o.helper.tokenizeNametoLabelText(this.getName());}return(this._sLabelText==null?"":this._sLabelText);},getSuperOrdinateDimension:function(){if(!this._sSuperOrdinateDimension){var s=this._oQueryResult.getEntityType().getSuperOrdinatePropertyOfProperty(this.getName());if(s){this._sSuperOrdinateDimension=this._oQueryResult.findDimensionByName(s.name);}}return this._sSuperOrdinateDimension;},getHierarchy:function(){if(!this._oHierarchy){this._oHierarchy=this._oQueryResult.getEntityType().getHierarchy(this._oProperty.name);}return this._oHierarchy;},getAllAttributeNames:function(){if(this._aAttributeNames){return this._aAttributeNames;}this._aAttributeNames=[];for(var n in this._oAttributeSet){this._aAttributeNames.push(this._oAttributeSet[n].getName());}return this._aAttributeNames;},getAllAttributes:function(){return this._oAttributeSet;},findAttributeByName:function(n){return this._oAttributeSet[n];},addAttribute:function(D){this._oAttributeSet[D.getName()]=D;},getContainingQueryResult:function(){return this._oQueryResult;},hasMasterData:function(){return this._oMembersEntitySet!=null?true:false;},getMasterDataEntitySet:function(){return this._oMembersEntitySet;},_oQueryResult:null,_oProperty:null,_oTextProperty:null,_sLabelText:null,_sSuperOrdinateDimension:null,_aAttributeNames:null,_oAttributeSet:null,_oMembersEntitySet:null,_oHierarchy:null};
o.DimensionAttribute=function(q,p){this._init(q,p);};
o.DimensionAttribute.prototype={_init:function(q,p){this._oQueryResult=q;this._oProperty=p;if(p.extensions!=undefined){for(var i=-1,E;(E=p.extensions[++i])!==undefined;){if(!E.namespace==o.constants.SAP_NAMESPACE){continue;}switch(E.name){case"attribute-for":this._sDimensionName=E.value;break;case"label":this._sLabelText=E.value;break;case"text":this._oTextProperty=q.getEntityType().findPropertyByName(E.value);break;default:}}}},getName:function(){return this._oProperty.name;},getKeyProperty:function(){return this._oProperty;},getTextProperty:function(){return this._oTextProperty;},getLabelText:function(){if(!this._sLabelText&&this._oQueryResult._oModel._oActivatedWorkarounds.CreateLabelsFromTechnicalNames){this._sLabelText=o.helper.tokenizeNametoLabelText(this.getName());}return this._sLabelText;},getDimension:function(){return this._oQueryResult.findDimensionByName(this._sDimensionName);},_oQueryResult:null,_oProperty:null,_oTextProperty:null,_sLabelText:null,_sDimensionName:null};
o.Measure=function(q,p){this._init(q,p);};
o.Measure.prototype={_init:function(q,p){this._oQueryResult=q;this._oProperty=p;if(p.extensions!=undefined){for(var i=-1,E;(E=p.extensions[++i])!==undefined;){if(!E.namespace==o.constants.SAP_NAMESPACE){continue;}switch(E.name){case"label":this._sLabelText=E.value;break;case"text":this._oTextProperty=q.getEntityType().findPropertyByName(E.value);break;case"unit":this._oUnitProperty=q.getEntityType().findPropertyByName(E.value);break;default:}}}if(!this._sLabelText){this._sLabelText="";}},getName:function(){return this._oProperty.name;},getRawValueProperty:function(){return this._oProperty;},getFormattedValueProperty:function(){return this._oTextProperty;},getUnitProperty:function(){return this._oUnitProperty;},getLabelText:function(){if(!this._sLabelText&&this._oQueryResult._oModel._oActivatedWorkarounds.CreateLabelsFromTechnicalNames){this._sLabelText=o.helper.tokenizeNametoLabelText(this.getName());}return this._sLabelText;},isUpdatable:function(){if(this._bIsUpdatable!=null){return this._bIsUpdatable;}var u=this._oQueryResult.getEntitySet().getUpdatablePropertyNameSet();return(u[this.getName()]!=undefined);},_oQueryResult:null,_oProperty:null,_oTextProperty:null,_sLabelText:null,_oUnitProperty:null,_bIsUpdatable:null};
o.EntitySet=function(m,s,C,E,a){this._init(m,s,C,E,a);};
o.EntitySet.prototype={_init:function(m,s,C,E,a){this._oEntityType=a;this._oEntitySet=E;this._oContainer=C;this._oSchema=s;this._oModel=m;if(s.entityContainer.length>1){this._sQName=C.name+"."+E.name;}else{this._sQName=E.name;}},getQName:function(){return this._sQName;},getSetDescription:function(){return this._oEntitySet;},getEntityType:function(){return this._oEntityType;},getSchema:function(){return this._oSchema;},getModel:function(){return this._oModel;},getUpdatablePropertyNameSet:function(){if(this._oUpdatablePropertyNames){return this._oUpdatablePropertyNames;}this._oUpdatablePropertyNames={};var s=true;if(this._oEntitySet.extensions!=undefined){for(var j=-1,E;(E=this._oEntitySet.extensions[++j])!==undefined;){if(E.namespace==o.constants.SAP_NAMESPACE&&E.name=="updatable"){if(E.value=="false"){s=false;break;}}}}if(!s){return this._oUpdatablePropertyNames;}var p=this._oEntityType.getTypeDescription().property;for(var i=-1,P;(P=p[++i])!==undefined;){var b=true;if(P.extensions==undefined){continue;}for(var k=-1,a;(a=P.extensions[++k])!==undefined;){if(a.namespace!=o.constants.SAP_NAMESPACE){continue;}if(a.name=="updatable"){if(a.value=="false"){b=false;break;}}}if(b){this._oUpdatablePropertyNames[P.name]=true;}}return this._oUpdatablePropertyNames;},_oEntityType:null,_oEntitySet:null,_oContainer:null,_oSchema:null,_oModel:null,_sQName:null,_oUpdatablePropertyNames:null};
o.EntityType=function(m,s,E){this._init(m,s,E);};
o.EntityType.propertyFilterRestriction={SINGLE_VALUE:"single-value",MULTI_VALUE:"multi-value",INTERVAL:"interval"};o.EntityType.prototype={_init:function(m,s,E){this._oEntityType=E;this._oSchema=s;this._oModel=m;this._aKeyProperties=[];this._oPropertySet={};this._aFilterablePropertyNames=[];this._aSortablePropertyNames=[];this._aRequiredFilterPropertyNames=[];this._oPropertyFilterRestrictionSet={};this._oPropertyHeadingsSet={};this._oPropertyQuickInfosSet={};this._sQName=s.namespace+"."+E.name;var r={};function g(K){var R=r[K];if(!R){R=r[K]={};}return R;}for(var i=-1,p;(p=E.key.propertyRef[++i])!==undefined;){this._aKeyProperties.push(p.name);}for(var k=-1,P;(P=E.property[++k])!==undefined;){this._oPropertySet[P.name]=P;this._aFilterablePropertyNames.push(P.name);this._aSortablePropertyNames.push(P.name);if(P.extensions==undefined){continue;}for(var j=-1,a;(a=P.extensions[++j])!==undefined;){if(a.namespace!==o.constants.SAP_NAMESPACE){continue;}switch(a.name){case"filterable":if(a.value=="false"){this._aFilterablePropertyNames.pop(P.name);}break;case"sortable":if(a.value=="false"){this._aSortablePropertyNames.pop(P.name);}break;case"required-in-filter":if(a.value=="true"){this._aRequiredFilterPropertyNames.push(P.name);}break;case"filter-restriction":if(a.value==o.EntityType.propertyFilterRestriction.SINGLE_VALUE||a.value==o.EntityType.propertyFilterRestriction.MULTI_VALUE||a.value==o.EntityType.propertyFilterRestriction.INTERVAL){this._oPropertyFilterRestrictionSet[P.name]=a.value;}break;case"hierarchy-node-external-key-for":g(a.value).externalKeyProperty=P;break;case"hierarchy-node-for":g(P.name).dimensionName=a.value;break;case"hierarchy-parent-node-for":case"hierarchy-parent-nod":g(a.value).parentNodeIDProperty=P;break;case"hierarchy-level-for":g(a.value).levelProperty=P;break;case"hierarchy-drill-state-for":case"hierarchy-drill-stat":g(a.value).drillStateProperty=P;break;default:}}}this._oRecursiveHierarchySet={};for(var h in r){var H=r[h];var b=this._oPropertySet[h];var D=this._oPropertySet[H.dimensionName];if(D==null){D=b;}this._oRecursiveHierarchySet[D.name]=new o.RecursiveHierarchy(E,b,H.parentNodeIDProperty,H.levelProperty,D,H.externalKeyProperty);}},getProperties:function(){return this._oPropertySet;},findPropertyByName:function(p){return this._oPropertySet[p];},getKeyProperties:function(){return this._aKeyProperties;},getLabelOfProperty:function(p){var P=this._oPropertySet[p];if(P==null){throw"no such property with name "+p;}if(P.extensions!=undefined){for(var i=-1,E;(E=P.extensions[++i])!==undefined;){if(!E.namespace==o.constants.SAP_NAMESPACE){continue;}if(E.name=="label"){return E.value;}}}return null;},getHeadingOfProperty:function(p){var P=this._oPropertySet[p];if(P==null){throw"no such property with name "+p;}var s=null;if(P.extensions!=undefined){for(var i=-1,E;(E=P.extensions[++i])!==undefined;){if(!E.namespace==o.constants.SAP_NAMESPACE){continue;}if(E.name=="heading"){return E.value;}if(E.name=="label"){s=E.value;}}}return s;},getQuickInfoOfProperty:function(p){var P=this._oPropertySet[p];if(P==null){throw"no such property with name "+p;}var s=null;if(P.extensions!=undefined){for(var i=-1,E;(E=P.extensions[++i])!==undefined;){if(!E.namespace==o.constants.SAP_NAMESPACE){continue;}if(E.name=="quickinfo"){return E.value;}if(E.name=="label"){s=E.value;}}}return s;},getTextPropertyOfProperty:function(p){var P=this._oPropertySet[p];if(P==null){throw"no such property with name "+p;}if(P.extensions!=undefined){for(var i=-1,E;(E=P.extensions[++i])!==undefined;){if(E.name=="text"){return this.findPropertyByName(E.value);}}}return null;},getSuperOrdinatePropertyOfProperty:function(p){var P=this._oPropertySet[p];if(P==null){throw"no such property with name "+p;}if(P.extensions!=undefined){for(var i=-1,E;(E=P.extensions[++i])!==undefined;){if(E.name=="super-ordinate"){return this.findPropertyByName(E.value);}}}return null;},getFilterablePropertyNames:function(){return this._aFilterablePropertyNames;},getSortablePropertyNames:function(){return this._aSortablePropertyNames;},getRequiredFilterPropertyNames:function(){return this._aRequiredFilterPropertyNames;},getPropertiesWithFilterRestrictions:function(){return this._oPropertyFilterRestrictionSet;},getAllHierarchyPropertyNames:function(){if(this._aHierarchyPropertyNames){return this._aHierarchyPropertyNames;}this._aHierarchyPropertyNames=[];for(var n in this._oRecursiveHierarchySet){this._aHierarchyPropertyNames.push(this._oRecursiveHierarchySet[n].getNodeValueProperty().name);}return this._aHierarchyPropertyNames;},getHierarchy:function(n){if(this._oRecursiveHierarchySet[n]==undefined){return null;}return this._oRecursiveHierarchySet[n];},getQName:function(){return this._sQName;},getTypeDescription:function(){return this._oEntityType;},getSchema:function(){return this._oSchema;},getModel:function(){return this._oModel;},_oEntityType:null,_oSchema:null,_oModel:null,_sQName:null,_aKeyProperties:null,_oPropertySet:null,_aFilterablePropertyNames:null,_aRequiredFilterPropertyNames:null,_oPropertyFilterRestrictionSet:null,_aHierarchyPropertyNames:null,_oRecursiveHierarchySet:null};
o.RecursiveHierarchy=function(E,n,p,N,a,b){this._init(E,n,p,N,a,b);};
o.RecursiveHierarchy.prototype={_init:function(E,n,p,N,a,b){this._oEntityType=E;this._oNodeIDProperty=n;this._oParentNodeIDProperty=p;this._oNodeLevelProperty=N;this._oNodeValueProperty=a;this._oNodeExternalKeyProperty=b;},isRecursiveHierarchy:function(){return true;},isLeveledHierarchy:function(){return false;},getNodeExternalKeyProperty:function(){return this._oNodeExternalKeyProperty;},getNodeIDProperty:function(){return this._oNodeIDProperty;},getParentNodeIDProperty:function(){return this._oParentNodeIDProperty;},getNodeLevelProperty:function(){return this._oNodeLevelProperty;},getNodeValueProperty:function(){return this._oNodeValueProperty;},_oEntityType:null,_oNodeIDProperty:null,_oParentNodeIDProperty:null,_oNodeLevelProperty:null,_oNodeValueProperty:null,_oNodeExternalKeyProperty:null};
o.FilterExpression=function(m,s,E){this._init(m,s,E);};
o.FilterExpression.prototype={_init:function(m,s,E){this._oEntityType=E;this._oSchema=s;this._oModel=m;this._aConditionUI5Filter=[];this._aUI5FilterArray=[];},_renderPropertyFilterValue:function(f,p){if(p==="Edm.Time"&&d.test(f)){f={ms:parseInt(f),__edmType:"Edm.Time"};}return e(this._oModel.getODataModel().formatValue(f,p));},clear:function(){this._aConditionUI5Filter=[];this._aUI5FilterArray=[];},_addCondition:function(p,O,v,V){for(var i=-1,u;(u=this._aConditionUI5Filter[++i])!==undefined;){if(u.sPath==p&&u.sOperator==O&&u.oValue1==v&&u.oValue2==V){return;}}this._aConditionUI5Filter.push(new F(p,O,v,V));},_addUI5FilterArray:function(u){this._aUI5FilterArray.push(u);},addCondition:function(p,O,v,V){var P=this._oEntityType.findPropertyByName(p);if(P==null){throw"Cannot add filter condition for unknown property name "+p;}var f=this._oEntityType.getFilterablePropertyNames();if(((f?Array.prototype.indexOf.call(f,p):-1))===-1){throw"Cannot add filter condition for not filterable property name "+p;}this._addCondition(p,O,v,V);return this;},removeConditions:function(p){var P=this._oEntityType.findPropertyByName(p);if(P==null){throw"Cannot remove filter conditions for unknown property name "+p;}for(var i=0;i<this._aConditionUI5Filter.length;i++){var u=this._aConditionUI5Filter[i];if(u.sPath==p){this._aConditionUI5Filter.splice(i--,1);}}return this;},addSetCondition:function(p,v){var P=this._oEntityType.findPropertyByName(p);if(P==null){throw"Cannot add filter condition for unknown property name "+p;}var f=this._oEntityType.getFilterablePropertyNames();if(((f?Array.prototype.indexOf.call(f,p):-1))===-1){throw"Cannot add filter condition for not filterable property name "+p;}for(var i=-1,V;(V=v[++i])!==undefined;){this._addCondition(p,c.EQ,V);}return this;},addUI5FilterConditions:function(u){if(!Array.isArray(u)){throw"Argument is not an array";}if(u.length==0){return this;}var h=false;for(var i=0;i<u.length;i++){if(u[i].aFilters!=undefined){h=true;break;}}if(h){this._addUI5FilterArray(u);}else{for(var j=0;j<u.length;j++){this.addCondition(u[j].sPath,u[j].sOperator,u[j].oValue1,u[j].oValue2);}}return this;},getExpressionAsUI5FilterArray:function(){var f=this._aConditionUI5Filter.concat([]);for(var i=-1,a;(a=this._aUI5FilterArray[++i])!==undefined;){for(var j=-1,b;(b=a[++j])!==undefined;){f.push(b);}}return f;},getPropertiesReferencedByUI5FilterArray:function(u,r){for(var i=-1,U;(U=u[++i])!==undefined;){if(U.aFilters!=undefined){this.getPropertiesReferencedByUI5FilterArray(U.aFilters,r);}else{if(r[U.sPath]==undefined){r[U.sPath]=[];}r[U.sPath].push(U);}}},getReferencedProperties:function(){var r={};for(var i=-1,u;(u=this._aConditionUI5Filter[++i])!==undefined;){if(r[u.sPath]==undefined){r[u.sPath]=[];}r[u.sPath].push(u);}for(var j=-1,U;(U=this._aUI5FilterArray[++j])!==undefined;){this.getPropertiesReferencedByUI5FilterArray(U,r);}return r;},renderUI5Filter:function(u){var f=null,p=this._oEntityType.findPropertyByName(u.sPath);if(p==null){throw"Cannot add filter condition for unknown property name "+u.sPath;}switch(u.sOperator){case c.BT:f="("+u.sPath+" ge "+this._renderPropertyFilterValue(u.oValue1,p.type)+" and "+u.sPath+" le "+this._renderPropertyFilterValue(u.oValue2,p.type)+")";break;case c.NB:f="("+u.sPath+" lt "+this._renderPropertyFilterValue(u.oValue1,p.type)+" or "+u.sPath+" gt "+this._renderPropertyFilterValue(u.oValue2,p.type)+")";break;case c.Contains:case c.NotContains:f=(u.sOperator[0]==="N"?"not ":"")+"substringof("+this._renderPropertyFilterValue(u.oValue1,"Edm.String")+","+u.sPath+")";break;case c.StartsWith:case c.EndsWith:case c.NotStartsWith:case c.NotEndsWith:f=u.sOperator.toLowerCase().replace("not","not ")+"("+u.sPath+","+this._renderPropertyFilterValue(u.oValue1,"Edm.String")+")";break;default:f=u.sPath+" "+u.sOperator.toLowerCase()+" "+this._renderPropertyFilterValue(u.oValue1,p.type);}return f;},renderUI5MultiFilter:function(u){var U=[];var O="";var l=u.bAnd==true?" and ":" or ";for(var i=-1,a;(a=u.aFilters[++i])!==undefined;){if(a.aFilters!=undefined){U.push(a);continue;}O+=(O==""?"":l)+"("+this.renderUI5Filter(a)+")";}if(U.length>0){for(var j=-1,m;(m=U[++j])!==undefined;){O+=(O==""?"":l)+"("+this.renderUI5MultiFilter(m)+")";}}return O;},renderUI5FilterArray:function(u){if(u.length==0){return"";}var O="";u.sort(function(a,b){if(a.sPath==b.sPath){return 0;}if(a.sPath>b.sPath){return 1;}else{return-1;}});var p=u[0].sPath;var s="";var n=[],U=[];for(var i=-1,f;(f=u[++i])!==undefined;){if(f.aFilters!=undefined){U.push(f);continue;}if(p!=f.sPath){if(s!=""){O+=(O==""?"":" and ")+"("+s+")";}s="";if(n.length>0){for(var j=-1,N;(N=n[++j])!==undefined;){s+=(s==""?"":" and ")+this.renderUI5Filter(N);}O+=(O==""?"":" and ")+"("+s+")";s="";}p=f.sPath;n=[];}if(f.sOperator==c.NE){n.push(f);continue;}s+=(s==""?"":" or ")+this.renderUI5Filter(f);}if(s!=""){O+=(O==""?"":" and ")+"("+s+")";}if(n.length>0){s="";for(var k=-1,g;(g=n[++k])!==undefined;){s+=(s==""?"":" and ")+this.renderUI5Filter(g);}O+=(O==""?"":" and ")+"("+s+")";}if(U.length>0){for(var l=-1,m;(m=U[++l])!==undefined;){O+=(O==""?"":" and ")+"("+this.renderUI5MultiFilter(m)+")";}}return O;},getURIFilterOptionValue:function(){var O=this.renderUI5FilterArray(this._aConditionUI5Filter);for(var i=-1,u;(u=this._aUI5FilterArray[++i])!==undefined;){O+=(O==""?"":" and ")+"("+this.renderUI5FilterArray(u)+")";}return O;},checkValidity:function(){var r=this._oEntityType.getRequiredFilterPropertyNames();var p=this.getReferencedProperties();for(var i=-1,P;(P=r[++i])!==undefined;){if(p[P]==undefined){throw"filter expression does not contain required property "+P;}}var a=this._oEntityType.getPropertiesWithFilterRestrictions();for(var s in a){var f=a[s];if(f==o.EntityType.propertyFilterRestriction.SINGLE_VALUE){if(p[s]!=undefined){if(p[s].length>1){var t=p[s][0].oValue1;for(var j=0;j<p[s].length;j++){if(p[s][j].oValue1!=t||p[s][j].sOperator!=c.EQ){throw"filter expression may use "+s+" only with a single EQ condition";}}}}}}return true;},getEntityType:function(){return this._oEntityType;},getSchema:function(){return this._oSchema;},getModel:function(){return this._oModel;},_oEntityType:null,_oSchema:null,_oModel:null,_aFilterCondition:null};o.SortOrder={Ascending:"asc",Descending:"desc"};
o.SortExpression=function(m,s,E){this._init(m,s,E);};
o.SortExpression.prototype={_init:function(m,s,E){this._oEntityType=E;this._oSchema=s;this._oModel=m;this._aSortCondition=[];},_containsSorter:function(p){var r=null;for(var i=-1,C;(C=this._aSortCondition[++i])!==undefined;){if(C.property.name===p){r={sorter:C,index:i};break;}}return r;},_removeFromArray:function(a,f,t){var r=a.slice((t||f)+1||a.length);a.length=f<0?a.length+f:f;return a.push.apply(a,r);},clear:function(){this._aSortCondition=[];},addSorter:function(p,s){var P=this._oEntityType.findPropertyByName(p);if(P==null){throw"Cannot add sort condition for unknown property name "+p;}var E=this._containsSorter(p);if(E!=null){E.sorter.order=s;return this;}var a=this._oEntityType.getSortablePropertyNames();if(((a?Array.prototype.indexOf.call(a,p):-1))===-1){throw"Cannot add sort condition for not sortable property name "+p;}this._aSortCondition.push({property:P,order:s});return this;},removeSorter:function(p){if(!p){return;}var s=this._containsSorter(p);if(s){this._removeFromArray(this._aSortCondition,s.index);}},getExpressionsAsUI5SorterArray:function(){var s=[];for(var i=-1,C;(C=this._aSortCondition[++i])!==undefined;){s.push(new S(C.property.name,C.order==o.SortOrder.Descending));}return s;},getExpressionAsUI5Sorter:function(){var s=this.getExpressionsAsUI5SorterArray();if(s.length==0){return null;}else{return s[0];}},getURIOrderByOptionValue:function(s){if(this._aSortCondition.length==0){return"";}var O="";for(var i=-1,C;(C=this._aSortCondition[++i])!==undefined;){if(!s[C.property.name]){continue;}O+=(O==""?"":",")+C.property.name+" "+C.order;}return O;},getEntityType:function(){return this._oEntityType;},getSchema:function(){return this._oSchema;},getModel:function(){return this._oModel;},_oEntityType:null,_oSchema:null,_oModel:null,_aSortCondition:null};
o.ParameterizationRequest=function(p){this._init(p);};
o.ParameterizationRequest.prototype={_init:function(p){if(!p){throw"No parameterization given";}this._oParameterization=p;this._oParameterValueAssignment=[];},_renderParameterKeyValue:function(k,p){return e(this._oParameterization.getTargetQueryResult().getModel().getODataModel().formatValue(k,p));},getParameterization:function(){return this._oParameterization;},setParameterValue:function(p,v,t){var P=this._oParameterization.findParameterByName(p);if(!P){throw"Invalid parameter name "+p;}if(t!=null){if(!P.isIntervalBoundary()){throw"Range value cannot be applied to parameter "+p+" accepting only single values";}if(!P.isLowerIntervalBoundary()){throw"Range value given, but parameter "+p+" does not hold the lower boundary";}}if(!P.isIntervalBoundary()){if(v==null){delete this._oParameterValueAssignment[p];}else{this._oParameterValueAssignment[p]=v;}}else{if(v==null&&t!=null){throw"Parameter "+p+": An upper boundary cannot be given without the lower boundary";}if(v==null){delete this._oParameterValueAssignment[p];t=null;}else{this._oParameterValueAssignment[p]=v;}var u=P.getPeerIntervalBoundaryParameter();if(t==null){t=v;}if(v==null){delete this._oParameterValueAssignment[u.getName()];}else{this._oParameterValueAssignment[u.getName()]=t;}}return;},getURIToParameterizationEntitySet:function(s){return(s?s:"")+"/"+this._oParameterization.getEntitySet().getQName();},getURIToParameterizationEntry:function(s){var D=this._oParameterization.getAllParameters();for(var a in D){if(this._oParameterValueAssignment[a]==undefined){throw"Parameter "+a+" has no value assigned";}}var k="",f=true;for(var p in this._oParameterValueAssignment){k+=(f?"":",")+p+"="+this._renderParameterKeyValue(this._oParameterValueAssignment[p],D[p].getProperty().type);f=false;}return(s?s:"")+"/"+this._oParameterization.getEntitySet().getQName()+"("+k+")";},_oParameterization:null,_oParameterValueAssignment:null};
o.QueryResultRequest=function(q,p){this._init(q,p);};
o.QueryResultRequest.prototype={_init:function(q,p){this._oQueryResult=q;this._oParameterizationRequest=p;this._oAggregationLevel={};this._oDimensionHierarchies={};this._oMeasures={};this._bIncludeEntityKey=false;this._oFilterExpression=null;this._oSortExpression=null;this._oSelectedPropertyNames=null;},addRecursiveHierarchy:function(h,i,I){var D;if(!h){return;}D=this._oQueryResult.findDimensionByName(h);if(!D){throw new Error("'"+h+"' is not a dimension property");}if(!D.getHierarchy()){throw new Error("Dimension '"+h+"' does not have a hierarchy");}this._oSelectedPropertyNames=null;this._oDimensionHierarchies[h]={externalKey:i,id:true,text:I};},setParameterizationRequest:function(p){this._oParameterizationRequest=p;},setResourcePath:function(r){this._sResourcePath=r;if(this._sResourcePath.indexOf("/")!=0){throw"Missing leading / (slash) for resource path";}if(this._oQueryResult.getParameterization()){var l=r.lastIndexOf("/");if(l==-1){throw"Missing navigation from parameter entity set to query result in resource path";}var n=r.substring(l+1);if(n!=this._oQueryResult.getParameterization().getNavigationPropertyToQueryResult()){throw"Invalid navigation property from parameter entity set to query result in resource path";}}},getParameterizationRequest:function(){return this._oParameterizationRequest;},getQueryResult:function(){return this._oQueryResult;},setAggregationLevel:function(D){this._oAggregationLevel={};if(!D){D=this._oQueryResult.getAllDimensionNames();}this.addToAggregationLevel(D);this._oSelectedPropertyNames=null;},addToAggregationLevel:function(D){if(!D){return;}this._oSelectedPropertyNames=null;for(var i=-1,s;(s=D[++i])!==undefined;){if(!this._oQueryResult.findDimensionByName(s)){throw s+" is not a valid dimension name";}this._oAggregationLevel[s]={key:true,text:false,attributes:null};}},removeFromAggregationLevel:function(D){if(!D){return;}this._oSelectedPropertyNames=null;for(var i=-1,s;(s=D[++i])!==undefined;){if(!this._oQueryResult.findDimensionByName(s)){throw s+" is not a valid dimension name";}if(this._oAggregationLevel[s]!=undefined){delete this._oAggregationLevel[s];this.getSortExpression().removeSorter(s);}}},getAggregationLevel:function(){var D=[];for(var s in this._oAggregationLevel){D.push(s);}return D;},getAggregationLevelDetails:function(D){if(this._oAggregationLevel[D]==undefined){throw"Aggregation level does not include dimension "+D;}return this._oAggregationLevel[D];},setMeasures:function(m){if(!m){m=this._oQueryResult.getAllMeasureNames();}this._oSelectedPropertyNames=null;this._oMeasures={};for(var i=-1,M;(M=m[++i])!==undefined;){if(!this._oQueryResult.findMeasureByName(M)){throw M+" is not a valid measure name";}this._oMeasures[M]={value:true,text:false,unit:false};}},getMeasureNames:function(){var m=[];for(var M in this._oMeasures){m.push(M);}return m;},includeDimensionKeyTextAttributes:function(D,I,b,a){this._oSelectedPropertyNames=null;var f=[];if(D){if(this._oAggregationLevel[D]==undefined){throw D+" is not included in the aggregation level";}f.push(D);}else{for(var n in this._oAggregationLevel){f.push(n);}a=null;}for(var i=-1,s;(s=f[++i])!==undefined;){if(I!=null){this._oAggregationLevel[s].key=I;}if(b!=null){this._oAggregationLevel[s].text=b;}if(a!=null){this._oAggregationLevel[s].attributes=a;}}},includeMeasureRawFormattedValueUnit:function(m,I,b,a){this._oSelectedPropertyNames=null;var M=[];if(m){if(this._oMeasures[m]==undefined){throw m+" is not part of the query result";}M.push(m);}else{for(var n in this._oMeasures){M.push(n);}}for(var i=-1,s;(s=M[++i])!==undefined;){if(I!=null){this._oMeasures[s].value=I;}if(b!=null){this._oMeasures[s].text=b;}if(a!=null){this._oMeasures[s].unit=a;}}},getFilterExpression:function(){if(this._oFilterExpression==null){var E=this._oQueryResult.getEntityType();this._oFilterExpression=new o.FilterExpression(this._oQueryResult.getModel(),E.getSchema(),E);}return this._oFilterExpression;},setFilterExpression:function(f){this._oFilterExpression=f;},getSortExpression:function(){if(this._oSortExpression==null){var E=this._oQueryResult.getEntityType();this._oSortExpression=new o.SortExpression(E.getModel(),E.getSchema(),E);}return this._oSortExpression;},setSortExpression:function(s){this._oSortExpression=s;},setRequestOptions:function(i,I,r){if(i!=null){this._bIncludeEntityKey=i;}if(I!=null){this._bIncludeCount=I;}if(r!=null){this._bReturnNoEntities=r;}},setResultPageBoundaries:function(s,a){if(s!=null&&typeof s!=="number"){throw"Start value must be null or numeric";}if(a!==null&&typeof a!=="number"){throw"End value must be null or numeric";}if(s==null){s=1;}if(s<1||s>(a==null?s:a)){throw"Invalid values for requested page boundaries";}this._iSkipRequestOption=(s>1)?s-1:null;this._iTopRequestOption=(a!=null)?(a-s+1):null;},getResultPageBoundaries:function(){var E=null;if(this._iTopRequestOption!=null){if(this._iSkipRequestOption==null){E=1;}else{E=this._iSkipRequestOption+this._iTopRequestOption;}}return{start:(this._iSkipRequestOption==null)?1:this._iSkipRequestOption,end:E};},getURIToQueryResultEntitySet:function(s){var u=null;if(this._sResourcePath!=null){u=(s?s:"")+this._sResourcePath;}else if(this._oQueryResult.getParameterization()){if(!this._oParameterizationRequest){throw"Missing parameterization request";}else{u=this._oParameterizationRequest.getURIToParameterizationEntry(s)+"/"+this._oQueryResult.getParameterization().getNavigationPropertyToQueryResult();}}else{u=(s?s:"")+"/"+this._oQueryResult.getEntitySet().getQName();}return u;},getURIOrderByOptionValue:function(){var a,C,O=null,s=this._oSortExpression?this._oSortExpression._aSortCondition:[],i,n=s.length;if(n){a=this._oQueryResult.getAllMeasureNames();for(i=0;i<n;i+=1){C=s[i];if(!this._oSelectedPropertyNames[C.property.name]&&a.indexOf(C.property.name)<0){continue;}O=(O?O+",":"")+C.property.name+" "+C.order;}}return O;},getURIQueryOptionValue:function(q){var n,Q=null,s,t=this;function a(p){var P;if(!p){return;}P=typeof p==="string"?p:p.name;if(!t._oSelectedPropertyNames[P]){s+=(s==""?"":",")+P;t._oSelectedPropertyNames[P]=true;}}switch(q){case"$select":{s="";this._oSelectedPropertyNames={};for(n in this._oAggregationLevel){var D=this._oQueryResult.findDimensionByName(n);var b=this._oAggregationLevel[n];if(b.key==true){a(D.getKeyProperty());}if(b.text==true){a(D.getTextProperty());}if(b.attributes){for(var i=-1,f;(f=b.attributes[++i])!==undefined;){a(D.findAttributeByName(f).getName());}}}for(n in this._oMeasures){var m=this._oQueryResult.findMeasureByName(n);var M=this._oMeasures[n];if(M.value==true){a(m.getRawValueProperty());}if(M.text==true){a(m.getFormattedValueProperty());}if(M.unit==true){a(m.getUnitProperty());}}for(n in this._oDimensionHierarchies){var h=this._oQueryResult.findDimensionByName(n).getHierarchy();var H=this._oDimensionHierarchies[n];if(H.id){a(h.getNodeIDProperty());}if(H.externalKey){a(h.getNodeExternalKeyProperty());}if(H.text){a(this._oQueryResult.getEntityType().getTextPropertyOfProperty(h.getNodeIDProperty().name));}}if(this._bIncludeEntityKey){var k=this._oQueryResult.getEntityType().getTypeDescription().key.propertyRef;for(var j=-1,K;(K=k[++j])!==undefined;){s+=(s==""?"":",")+K.name;}}Q=(s?s:null);break;}case"$filter":{var g=null;if(this._oFilterExpression){g=this._oFilterExpression.getURIFilterOptionValue();}Q=(g?g:null);break;}case"$orderby":{Q=this.getURIOrderByOptionValue();break;}case"$top":{Q=null;if(this._bReturnNoEntities){Q=0;}else if(this._iTopRequestOption!==null){Q=this._iTopRequestOption;}break;}case"$skip":{Q=null;if(!this._bReturnNoEntities){Q=this._iSkipRequestOption;}break;}case"$inlinecount":{Q=(this._bIncludeCount==true?"allpages":null);break;}default:break;}return Q;},getURIToQueryResultEntries:function(s,r){if(!r){r=this.getURIToQueryResultEntitySet(s);}this.getFilterExpression().checkValidity();var a=this.getURIQueryOptionValue("$select");var f=this.getURIQueryOptionValue("$filter");var b=this.getURIQueryOptionValue("$orderby");var t=this.getURIQueryOptionValue("$top");var g=this.getURIQueryOptionValue("$skip");var i=this.getURIQueryOptionValue("$inlinecount");var u=r;var q=false;if(a!==null){u+="?$select="+a;q=true;}if(this._oFilterExpression&&f!==null){if(!q){u+="?";q=true;}else{u+="&";}u+="$filter="+f;}if(this._oSortExpression&&b!==null){if(!q){u+="?";q=true;}else{u+="&";}u+="$orderby="+b;}if((this._iTopRequestOption||this._bReturnNoEntities)&&t!==null){if(!q){u+="?";q=true;}else{u+="&";}u+="$top="+t;}if(this._iSkipRequestOption&&g!==null){if(!q){u+="?";q=true;}else{u+="&";}u+="$skip="+g;}if(this._bIncludeCount&&i!==null){if(!q){u+="?";q=true;}else{u+="&";}u+="$inlinecount="+i;}return u;},_oQueryResult:null,_oParameterizationRequest:null,_sResourcePath:null,_oAggregationLevel:null,_oDimensionHierarchies:null,_oMeasures:null,_bIncludeEntityKey:null,_bIncludeCount:null,_bReturnNoEntities:null,_oFilterExpression:null,_oSortExpression:null,_iSkipRequestOption:null,_iTopRequestOption:null};
o.ParameterValueSetRequest=function(p){this._init(p);};
o.ParameterValueSetRequest.prototype={_init:function(p){this._oParameter=p;this._oValueSetResult={};this._oFilterExpression=null;this._oSortExpression=null;},includeParameterText:function(i){if(i!=null){this._oValueSetResult.text=i;}},getFilterExpression:function(){if(this._oFilterExpression==null){var E=this._oParameter.getContainingParameterization().getEntityType();var m=this._oParameter.getContainingParameterization().getTargetQueryResult().getModel();this._oFilterExpression=new o.FilterExpression(m,E.getSchema(),E);}return this._oFilterExpression;},setFilterExpression:function(f){this._oFilterExpression=f;},getSortExpression:function(){if(this._oSortExpression==null){var E=this._oParameter.getContainingParameterization().getEntityType();this._oSortExpression=new o.SortExpression(E.getModel(),E.getSchema(),E);}return this._oSortExpression;},setSortExpression:function(s){this._oSortExpression=s;},getURIQueryOptionValue:function(q){var Q=null;switch(q){case"$select":{var s="";s+=(s==""?"":",")+this._oParameter.getProperty().name;if(this._oValueSetResult.text==true&&this._oParameter.getTextProperty()){s+=(s==""?"":",")+this._oParameter.getTextProperty().name;}Q=(s?s:null);break;}case"$filter":{var f=null;if(this._oFilterExpression){f=this._oFilterExpression.getURIFilterOptionValue();}Q=(f?f:null);break;}case"$orderby":{var a=null;if(this._oSortExpression){a=this._oSortExpression.getURIOrderByOptionValue();}Q=(a?a:null);break;}default:break;}return Q;},getURIToParameterValueSetEntries:function(s){var r=null;r=(s?s:"")+"/"+this._oParameter.getContainingParameterization().getEntitySet().getQName();this.getFilterExpression().checkValidity();var a=this.getURIQueryOptionValue("$select");var f=this.getURIQueryOptionValue("$filter");var b=this.getURIQueryOptionValue("$orderby");var u=r;var q=false;if(a){u+="?$select="+a;q=true;}if(this._oFilterExpression&&f){if(!q){u+="?";q=true;}else{u+="&";}u+="$filter="+f;}if(this._oSortExpression&&b){if(!q){u+="?";q=true;}else{u+="&";}u+="$orderby="+b;}return u;},_oParameter:null,_oFilterExpression:null,_oSortExpression:null,_oValueSetResult:null};
o.DimensionMemberSetRequest=function(D,p,u){this._init(D,p,u);};
o.DimensionMemberSetRequest.prototype={_init:function(D,p,u){this._oDimension=D;this._oParameterizationRequest=p;this._bUseMasterData=u;this._oValueSetResult={};this._oFilterExpression=null;this._oSortExpression=null;if(this._oParameterizationRequest!=null&&this._bUseMasterData==true){throw"LIMITATION: parameterized master data entity sets are not yet implemented";}if(this._bUseMasterData){this._oEntitySet=this._oDimension.getMasterDataEntitySet();}else{this._oEntitySet=this._oDimension.getContainingQueryResult().getEntitySet();if(this._oDimension.getContainingQueryResult().getParameterization()&&!this._oParameterizationRequest){throw"Missing parameterization request";}}},setParameterizationRequest:function(p){this._oParameterizationRequest=p;},includeDimensionTextAttributes:function(i,I){this._oValueSetResult.text={text:false,attributes:false};if(i==true){this._oValueSetResult.text=true;}if(I==true){this._oValueSetResult.attributes=true;}},getFilterExpression:function(){if(this._oFilterExpression==null){var E=this._oEntitySet.getEntityType();var m=this._oDimension.getContainingQueryResult().getModel();this._oFilterExpression=new o.FilterExpression(m,E.getSchema(),E);}return this._oFilterExpression;},setFilterExpression:function(f){this._oFilterExpression=f;},getSortExpression:function(){if(this._oSortExpression==null){this._oSortExpression=new o.SortExpression(this._oEntityType.getModel(),this._oEntityType.getSchema(),this._oEntityType);}return this._oSortExpression;},setSortExpression:function(s){this._oSortExpression=s;},setRequestOptions:function(i){if(i!=null){this._bIncludeCount=i;}},setResultPageBoundaries:function(s,a){if(s!=null&&typeof s!=="number"){throw"Start value must be null or numeric";}if(a!==null&&typeof a!=="number"){throw"End value must be null or numeric";}if(s==null){s=1;}if(s<1||s>(a==null?s:a)){throw"Invalid values for requested page boundaries";}this._iSkipRequestOption=(s>1)?s-1:null;this._iTopRequestOption=(a!=null)?(a-s+1):null;},getResultPageBoundaries:function(){var E=null;if(this._iTopRequestOption!=null){if(this._iSkipRequestOption==null){E=1;}else{E=this._iSkipRequestOption+this._iTopRequestOption;}}return{start:(this._iSkipRequestOption==null)?1:this._iSkipRequestOption,end:E};},getURIQueryOptionValue:function(q){var Q=null;switch(q){case"$select":{var s="";var E=this._oEntitySet.getEntityType();var K=E.getKeyProperties();var a=[];if(this._bUseMasterData){for(var i=-1,b;(b=K[++i])!==undefined;){s+=(s==""?"":",")+b;var f=E.getTextPropertyOfProperty(b);if(f){if(this._oValueSetResult.text==true){s+=","+f.name;}a.push(f.name);}}}else{s+=(s==""?"":",")+this._oDimension.getKeyProperty().name;if(this._oValueSetResult.text==true&&this._oDimension.getTextProperty()){s+=(s==""?"":",")+this._oDimension.getTextProperty().name;}}if(this._oValueSetResult.attributes){if(this._bUseMasterData){var g=E.getProperties();for(var p in g){var I=false;for(var j=-1,h;(h=K[++j])!==undefined;){if(p==h){I=true;break;}}if(I){continue;}for(var k=-1,m;(m=a[++k])!==undefined;){if(p==m){I=true;break;}}if(!I){s+=","+p;}}}else{var n=this._oDimension.getAllAttributeNames();for(var l=-1,r;(r=n[++l])!==undefined;){s+=(s==""?"":",")+this._oDimension.findAttributeByName(r).getName();}}}Q=(s?s:null);break;}case"$filter":{var t=null;if(this._oFilterExpression){t=this._oFilterExpression.getURIFilterOptionValue();}Q=(t?t:null);break;}case"$orderby":{var u=null;if(this._oSortExpression){u=this._oSortExpression.getURIOrderByOptionValue();}Q=(u?u:null);break;}case"$top":{if(this._iTopRequestOption!==null){Q=this._iTopRequestOption;}break;}case"$skip":{Q=this._iSkipRequestOption;break;}case"$inlinecount":{Q=(this._bIncludeCount==true?"allpages":null);break;}default:break;}return Q;},getURIToDimensionMemberEntitySet:function(s){var r=null;if(!this._bUseMasterData&&this._oParameterizationRequest){r=this._oParameterizationRequest.getURIToParameterizationEntry(s)+"/"+this._oDimension.getContainingQueryResult().getParameterization().getNavigationPropertyToQueryResult();}else{r=(s?s:"")+"/"+this._oEntitySet.getQName();}return r;},getURIToDimensionMemberEntries:function(s){var r=this.getURIToDimensionMemberEntitySet(s);this.getFilterExpression().checkValidity();var a=this.getURIQueryOptionValue("$select");var f=this.getURIQueryOptionValue("$filter");var b=this.getURIQueryOptionValue("$orderby");var t=this.getURIQueryOptionValue("$top");var g=this.getURIQueryOptionValue("$skip");var i=this.getURIQueryOptionValue("$inlinecount");var u=r;var q=false;if(a){u+="?$select="+a;q=true;}if(this._oFilterExpression&&f){if(!q){u+="?";q=true;}else{u+="&";}u+="$filter="+f;}if(this._oSortExpression&&b){if(!q){u+="?";q=true;}else{u+="&";}u+="$orderby="+b;}if(this._iTopRequestOption&&t){if(!q){u+="?";q=true;}else{u+="&";}u+="$top="+t;}if(this._iSkipRequestOption&&g){if(!q){u+="?";q=true;}else{u+="&";}u+="$skip="+g;}if(this._bIncludeCount&&i){if(!q){u+="?";q=true;}else{u+="&";}u+="$inlinecount="+i;}return u;},_oDimension:null,_oParameterizationRequest:null,_oEntitySet:null,_bUseMasterData:false,_oFilterExpression:null,_oSortExpression:null,_oValueSetResult:null,_bIncludeCount:null,_iSkipRequestOption:0,_iTopRequestOption:null};return o;},true);
sap.ui.predefine('sap/ui/model/json/JSONListBinding',['sap/ui/model/ChangeReason','sap/ui/model/ClientListBinding',"sap/base/util/deepEqual","sap/base/Log","sap/ui/thirdparty/jquery"],function(C,a,d,L,q){"use strict";
var J=a.extend("sap.ui.model.json.JSONListBinding");
J.prototype.getContexts=function(s,l){this.iLastStartIndex=s;this.iLastLength=l;if(!s){s=0;}if(!l){l=Math.min(this.iLength,this.oModel.iSizeLimit);}var c=this._getContexts(s,l),b=[];if(this.bUseExtendedChangeDetection){try{for(var i=0;i<c.length;i++){b.push(this.getContextData(c[i]));}if(this.aLastContextData&&s<this.iLastEndIndex){c.diff=this.diffData(this.aLastContextData,b);}this.iLastEndIndex=s+l;this.aLastContexts=c.slice(0);this.aLastContextData=b.slice(0);}catch(e){this.bUseExtendedChangeDetection=false;L.warning("JSONListBinding: Extended change detection has been disabled as JSON data could not be serialized.");}}return c;};
J.prototype.getCurrentContexts=function(){if(this.bUseExtendedChangeDetection){return this.aLastContexts||[];}else{return this.getContexts(this.iLastStartIndex,this.iLastLength);}};
J.prototype.updateIndices=function(){var i;this.aIndices=[];if(Array.isArray(this.oList)){for(i=0;i<this.oList.length;i++){this.aIndices.push(i);}}else{for(i in this.oList){this.aIndices.push(i);}}};
J.prototype.update=function(){var l=this.oModel._getObject(this.sPath,this.oContext);if(l){if(Array.isArray(l)){if(this.bUseExtendedChangeDetection){this.oList=q.extend(true,[],l);}else{this.oList=l.slice(0);}}else{this.oList=q.extend(this.bUseExtendedChangeDetection,{},l);}this.updateIndices();this.applyFilter();this.applySort();this.iLength=this._getLength();}else{this.oList=[];this.aIndices=[];this.iLength=0;}};
J.prototype.checkUpdate=function(f){if(this.bSuspended&&!this.bIgnoreSuspend&&!f){return;}if(!this.bUseExtendedChangeDetection){var l=this.oModel._getObject(this.sPath,this.oContext)||[];if(!d(this.oList,l)||f){this.update();this._fireChange({reason:C.Change});}}else{var c=false;var t=this;var l=this.oModel._getObject(this.sPath,this.oContext)||[];if(this.oList.length!=l.length){c=true;}if(!d(this.oList,l)){this.update();}var b=this._getContexts(this.iLastStartIndex,this.iLastLength);if(this.aLastContexts){if(this.aLastContexts.length!=b.length){c=true;}else{q.each(this.aLastContextData,function(i,o){var e=t.getContextData(b[i]);if(e!==o){c=true;return false;}});}}else{c=true;}if(c||f){this._fireChange({reason:C.Change});}}};
return J;});
sap.ui.predefine('sap/ui/model/json/JSONModel',['sap/ui/model/ClientModel','sap/ui/model/Context','./JSONListBinding','./JSONPropertyBinding','./JSONTreeBinding',"sap/base/Log","sap/ui/thirdparty/jquery","sap/base/util/isPlainObject"],function(C,a,J,b,c,L,q,d){"use strict";
var f=C.extend("sap.ui.model.json.JSONModel",{
constructor:function(D,o){this.pSequentialImportCompleted=Promise.resolve();C.apply(this,arguments);this.bObserve=o;if(D&&typeof D=="object"){this.setData(D);}},
metadata:{publicMethods:["setJSON","getJSON"]}
});
f.prototype.setData=function(D,m){if(m){this.oData=q.extend(true,Array.isArray(this.oData)?[]:{},this.oData,D);}else{this.oData=D;}if(this.bObserve){this.observeData();}this.checkUpdate();};
f.prototype.observeData=function(){var t=this;function e(v){return function(){return v;};}function g(O,n){return function(v){o(v,O,n);t.checkUpdate();};}function h(O,n,v){if(typeof v=="function"){O[n]=v;}else{Object.defineProperty(O,n,{get:e(v),set:g(O,n)});}}function o(O,p,n){if(Array.isArray(O)){for(var i=0;i<O.length;i++){o(O[i],O,i);}}else if(d(O)){for(var i in O){o(O[i],O,i);}}if(p){h(p,n,O);}}o(this.oData);};
f.prototype.setJSON=function(j,m){var o;try{o=JSON.parse(j+"");this.setData(o,m);}catch(e){L.fatal("The following problem occurred: JSON parse Error: "+e);this.fireParseError({url:"",errorCode:-1,reason:"",srcText:e,line:-1,linepos:-1,filepos:-1});}};
f.prototype.getJSON=function(){return JSON.stringify(this.oData);};
f.prototype.loadData=function(u,p,A,t,m,e,h){var g;A=(A!==false);t=t||"GET";e=e===undefined?this.bCache:e;this.fireRequestSent({url:u,type:t,async:A,headers:h,info:"cache="+e+";bMerge="+m,infoObject:{cache:e,merge:m}});var s=function(D){if(!D){L.fatal("The following problem occurred: No data was retrieved by service: "+u);}this.setData(D,m);this.fireRequestCompleted({url:u,type:t,async:A,headers:h,info:"cache="+e+";bMerge="+m,infoObject:{cache:e,merge:m},success:true});}.bind(this);var E=function(P,T){var M=T||P.textStatus;var P=A?P.request:P;var S=P.status;var j=P.statusText;var r=P.responseText;var o={message:M,statusCode:S,statusText:j,responseText:r};L.fatal("The following problem occurred: "+M,r+","+S+","+j);this.fireRequestCompleted({url:u,type:t,async:A,headers:h,info:"cache="+e+";bMerge="+m,infoObject:{cache:e,merge:m},success:false,errorobject:o});this.fireRequestFailed(o);if(A){return Promise.reject(o);}}.bind(this);var _=function(s,E){this._ajax({url:u,async:A,dataType:'json',cache:e,data:p,headers:h,type:t,success:s,error:E});}.bind(this);if(A){g=new Promise(function(r,j){var R=function(x,T,o){j({request:x,textStatus:T,error:o});};_(r,R);});var i=this.pSequentialImportCompleted.then(function(){return g.then(s,E);});this.pSequentialImportCompleted=i.catch(function(o){L.error("Loading of data failed: "+o.stack);});return i;}else{_(s,E);}};
f.prototype.dataLoaded=function(){return this.pSequentialImportCompleted;};
f.prototype.bindProperty=function(p,o,P){var B=new b(this,p,o,P);return B;};
f.prototype.bindList=function(p,o,s,F,P){var B=new J(this,p,o,s,F,P);return B;};
f.prototype.bindTree=function(p,o,F,P,s){var B=new c(this,p,o,F,P,s);return B;};
f.prototype.setProperty=function(p,v,o,A){var r=this.resolve(p,o),l,O,P;if(!r){return false;}if(r=="/"){this.setData(v);return true;}l=r.lastIndexOf("/");O=r.substring(0,l||1);P=r.substr(l+1);var e=this._getObject(O);if(e){e[P]=v;this.checkUpdate(false,A);return true;}return false;};
f.prototype.getProperty=function(p,o){return this._getObject(p,o);};
f.prototype._getObject=function(p,o){var n=this.isLegacySyntax()?this.oData:null;if(o instanceof a){n=this._getObject(o.getPath());}else if(o!=null){n=o;}if(!p){return n;}var P=p.split("/"),i=0;if(!P[0]){n=this.oData;i++;}while(n&&P[i]){n=n[P[i]];i++;}return n;};
f.prototype.isList=function(p,o){var A=this.resolve(p,o);return Array.isArray(this._getObject(A));};
f.prototype._setMetaModel=function(m){this._oMetaModel=m;};
f.prototype.getMetaModel=function(){return this._oMetaModel;};
return f;});
sap.ui.predefine('sap/ui/model/json/JSONPropertyBinding',['sap/ui/model/ChangeReason','sap/ui/model/ClientPropertyBinding',"sap/base/util/deepEqual"],function(C,a,d){"use strict";
var J=a.extend("sap.ui.model.json.JSONPropertyBinding");
J.prototype.setValue=function(v){if(this.bSuspended){return;}if(!d(this.oValue,v)){if(this.oModel.setProperty(this.sPath,v,this.oContext,true)){this.oValue=v;this.getDataState().setValue(this.oValue);this.oModel.firePropertyChange({reason:C.Binding,path:this.sPath,context:this.oContext,value:v});}}};
J.prototype.checkUpdate=function(f){if(this.bSuspended&&!f){return;}var v=this._getValue();if(!d(v,this.oValue)||f){this.oValue=v;this.getDataState().setValue(this.oValue);this.checkDataState();this._fireChange({reason:C.Change});}};
return J;});
sap.ui.predefine('sap/ui/model/json/JSONTreeBinding',['sap/ui/model/ClientTreeBinding'],function(C){"use strict";
var J=C.extend("sap.ui.model.json.JSONTreeBinding");
J.prototype._saveSubContext=function(n,c,s,N){if(n&&typeof n=="object"){var o=this.oModel.getContext(s+N);if(this.oCombinedFilter&&!this.bIsFiltering){if(this.filterInfo.aFilteredContexts&&this.filterInfo.aFilteredContexts.indexOf(o)!=-1){c.push(o);}}else{c.push(o);}}};
return J;});
sap.ui.predefine('sap/ui/model/odata/AnnotationHelper',["./_AnnotationHelperBasics","./_AnnotationHelperExpression","sap/base/Log","sap/ui/base/BindingParser"],function(B,E,L,a){'use strict';
function c(f,b){if(!b){return f;}function d(){return f.call(this,b.apply(this,arguments));}return d;}
var A={createPropertySetting:function(p,r){var m=false,P;p=p.slice();p.forEach(function(v,i){switch(typeof v){case"boolean":case"number":case"undefined":m=true;break;case"string":P=a.complexParser(v,null,true,true);if(P!==undefined){if(P.functionsNotFound){throw new Error("Function name(s) "+P.functionsNotFound.join(", ")+" not found");}p[i]=v=P;}case"object":if(!v||typeof v!=="object"||!("path"in v)){m=true;}break;default:throw new Error("Unsupported part: "+v);}});P={formatter:r,parts:p};if(m){a.mergeParts(P);}if(P.parts.length===0){P=P.formatter&&P.formatter();if(typeof P==="string"){P=a.complexParser.escape(P);}}else if(P.parts.length===1){r=P.formatter;P=P.parts[0];if(r){P.formatter=c(r,P.formatter);}}return P;},format:function(i,r){if(arguments.length===1){r=i.getObject("");}return E.getExpression(i,r,true);},getNavigationPath:function(i,r){if(arguments.length===1){r=i.getObject("");}var R=B.followPath(i,r);return R?"{"+R.navigationProperties.join("/")+"}":"";},gotoEntitySet:function(C){var e,s,r=C.getObject(),R;if(typeof r==="string"){e=r;}else{R=B.followPath(C,r);e=R&&R.associationSetEnd&&R.associationSetEnd.entitySet;}if(e){s=C.getModel().getODataEntitySet(e,true);}if(!s){L.warning(C.getPath()+": found '"+e+"' which is not a name of an entity set",undefined,"sap.ui.model.odata.AnnotationHelper");}return s;},gotoEntityType:function(C){var e=C.getProperty(""),r=C.getModel().getODataEntityType(e,true);if(!r){L.warning(C.getPath()+": found '"+e+"' which is not a name of an entity type",undefined,"sap.ui.model.odata.AnnotationHelper");}return r;},gotoFunctionImport:function(C){var f=C.getProperty("String"),r=C.getModel().getODataFunctionImport(f,true);if(!r){L.warning(C.getPath()+": found '"+f+"' which is not a name of a function import",undefined,"sap.ui.model.odata.AnnotationHelper");}return r;},isMultiple:function(i,r){if(arguments.length===1){r=i.getObject("");}var R=B.followPath(i,r);if(R){if(R.navigationAfterMultiple){throw new Error('Association end with multiplicity "*" is not the last one: '+r.AnnotationPath);}return String(R.isMultiple);}return"";},resolvePath:function(C){var r=B.followPath(C,C.getObject());if(!r){L.warning(C.getPath()+": Path could not be resolved ",undefined,"sap.ui.model.odata.AnnotationHelper");}return r?r.resolvedPath:undefined;},simplePath:function(i,r){if(arguments.length===1){r=i.getObject("");}return E.getExpression(i,r,false);}};A.format.requiresIContext=true;A.getNavigationPath.requiresIContext=true;A.isMultiple.requiresIContext=true;A.simplePath.requiresIContext=true;return A;},true);
sap.ui.predefine('sap/ui/model/odata/AnnotationParser',["sap/base/assert","sap/base/Log","sap/ui/Device","sap/ui/thirdparty/jquery"],function(a,L,D,q){"use strict";var A={EnumMember:true,Path:true,PropertyPath:true,NavigationPropertyPath:true,AnnotationPath:true};var t={Binary:true,Bool:true,Date:true,DateTimeOffset:true,Decimal:true,Duration:true,Float:true,Guid:true,Int:true,String:true,TimeOfDay:true,LabelElementReference:true,EnumMember:true,Path:true,PropertyPath:true,NavigationPropertyPath:true,AnnotationPath:true};var M={And:true,Or:true,Eq:true,Ne:true,Gt:true,Ge:true,Lt:true,Le:true,If:true,Collection:true};
function g(o){return o.getAttribute("Qualifier")||o.parentNode.nodeName==="Annotations"&&o.parentNode.getAttribute("Qualifier");}
var b={merge:function(T,s){var c,d;var S=["annotationsAtArrays","propertyAnnotations","EntityContainer","annotationReferences"];for(c in s){if(S.indexOf(c)!==-1){continue;}b._mergeAnnotation(c,s,T);}for(var i=1;i<S.length;++i){var e=S[i];T[e]=T[e]||{};for(c in s[e]){for(d in s[e][c]){T[e][c]=T[e][c]||{};b._mergeAnnotation(d,s[e][c],T[e][c]);}}}if(s.annotationsAtArrays){T.annotationsAtArrays=(T.annotationsAtArrays||[]).concat(s.annotationsAtArrays);}},_mergeAnnotation:function(n,m,T){if(Array.isArray(m[n])){T[n]=m[n].slice(0);}else{T[n]=T[n]||{};for(var k in m[n]){T[n][k]=m[n][k];}}},parse:function(m,x,s){try{b._parserData={};b._oXPath=b.getXPath();return b._parse(m,x,s);}finally{delete b._parserData;delete b._oXPath;}},_parse:function(m,x,s){var c={},d,e,f,T,h,l,n,p,r,u,v,w,y,z,B,C,E,F,G,H,I,i,J,K=[];b._parserData.metadataInstance=m;b._parserData.serviceMetadata=m.getServiceMetadata();b._parserData.xmlDocument=b._oXPath.setNameSpace(x);b._parserData.schema={};b._parserData.aliases={};b._parserData.url=s?s:"metadata document";b._parserData.annotationsAtArrays=K;d=b._oXPath.selectNodes("//d:Schema",b._parserData.xmlDocument);for(i=0;i<d.length;i+=1){e=b._oXPath.nextNode(d,i);b._parserData.schema.Alias=e.getAttribute("Alias");b._parserData.schema.Namespace=e.getAttribute("Namespace");}var N={};var O=b._parseReferences(N);if(O){c.annotationReferences=N;c.aliasDefinitions=b._parserData.aliases;}f=b._oXPath.selectNodes("//d:Term",b._parserData.xmlDocument);if(f.length>0){T={};for(J=0;J<f.length;J+=1){h=b._oXPath.nextNode(f,J);l=b.replaceWithAlias(h.getAttribute("Type"));T["@"+b._parserData.schema.Alias+"."+h.getAttribute("Name")]=l;}c.termDefinitions=T;}b._parserData.metadataProperties=b.getAllPropertiesMetadata(b._parserData.serviceMetadata);if(b._parserData.metadataProperties.extensions){c.propertyExtensions=b._parserData.metadataProperties.extensions;}n=b._oXPath.selectNodes("//d:Annotations ",b._parserData.xmlDocument);for(J=0;J<n.length;J+=1){p=b._oXPath.nextNode(n,J);if(p.hasChildNodes()===false){continue;}r=p.getAttribute("Target");u=r.split(".")[0];if(u&&b._parserData.aliases[u]){r=r.replace(new RegExp(u,""),b._parserData.aliases[u]);}v=r;w=null;var P=null;if(r.indexOf("/")>0){v=r.split("/")[0];var S=b._parserData.serviceMetadata.dataServices&&b._parserData.serviceMetadata.dataServices.schema&&b._parserData.serviceMetadata.dataServices.schema.length;if(S){for(var j=b._parserData.serviceMetadata.dataServices.schema.length-1;j>=0;j--){var Q=b._parserData.serviceMetadata.dataServices.schema[j];if(Q.entityContainer){var R=v.split('.');for(var k=Q.entityContainer.length-1;k>=0;k--){if(Q.entityContainer[k].name===R[R.length-1]){P=r.replace(v+"/","");break;}}}}}if(!P){w=r.replace(v+"/","");}}if(w){if(!c.propertyAnnotations){c.propertyAnnotations={};}if(!c.propertyAnnotations[v]){c.propertyAnnotations[v]={};}if(!c.propertyAnnotations[v][w]){c.propertyAnnotations[v][w]={};}y=b._oXPath.selectNodes("./d:Annotation",p);for(var U=0;U<y.length;U+=1){z=b._oXPath.nextNode(y,U);B=b.replaceWithAlias(z.getAttribute("Term"));var V=g(z);if(V){B+="#"+V;}if(z.hasChildNodes()===false){var o={};b.enrichFromPropertyValueAttributes(o,z);if(q.isEmptyObject(o)){o.Bool="true";}c.propertyAnnotations[v][w][B]=o;}else{c.propertyAnnotations[v][w][B]=b.getPropertyValue(z);}}}else{var W;if(P){if(!c["EntityContainer"]){c["EntityContainer"]={};}if(!c["EntityContainer"][v]){c["EntityContainer"][v]={};}W=c["EntityContainer"][v];}else{if(!c[v]){c[v]={};}W=c[v];}C=v.replace(b._parserData.aliases[u],u);y=b._oXPath.selectNodes("./d:Annotation",p);for(var X=0;X<y.length;X+=1){z=b._oXPath.nextNode(y,X);var Y=W;if(P){if(!W[P]){W[P]={};}Y=W[P];}b._parseAnnotation(v,z,Y);}E=b._oXPath.selectNodes("//d:Annotations[contains(@Target, '"+C+"')]//d:PropertyValue[contains(@Path, '/')]//@Path",b._parserData.xmlDocument);for(i=0;i<E.length;i+=1){F=b._oXPath.nextNode(E,i);G=F.value;if(c.propertyAnnotations){if(c.propertyAnnotations[v]){if(c.propertyAnnotations[v][G]){continue;}}}H=G.split('/');if(b.findNavProperty(v,H[0])){if(!c.expand){c.expand={};}if(!c.expand[v]){c.expand[v]={};}c.expand[v][H[0]]=H[0];}}I=b._oXPath.selectNodes("//d:Annotations[contains(@Target, '"+C+"')]//d:Path[contains(., '/')]",b._parserData.xmlDocument);for(i=0;i<I.length;i+=1){F=b._oXPath.nextNode(I,i);G=b._oXPath.getNodeText(F);if(c.propertyAnnotations&&c.propertyAnnotations[v]&&c.propertyAnnotations[v][G]){continue;}if(!c.expand){c.expand={};}if(!c.expand[v]){c.expand[v]={};}H=G.split('/');if(b.findNavProperty(v,H[0])){if(!c.expand){c.expand={};}if(!c.expand[v]){c.expand[v]={};}c.expand[v][H[0]]=H[0];}}}}if(K.length){c.annotationsAtArrays=K.map(function(Z){return b.backupAnnotationAtArray(Z,c);});}return c;},backupAnnotationAtArray:function(e,m){var Q,s=[];function i(){return Array.prototype.filter.call(e.parentNode.childNodes,function(n){return n.nodeType===1;}).indexOf(e);}while(e.nodeName!=="Annotations"){switch(e.nodeName){case"Annotation":Q=g(e);s.unshift(e.getAttribute("Term")+(Q?"#"+Q:""));break;case"Collection":break;case"PropertyValue":s.unshift(e.getAttribute("Property"));break;case"Record":if(e.parentNode.nodeName==="Collection"){s.unshift(i());}break;default:if(e.parentNode.nodeName==="Apply"){s.unshift("Value");s.unshift(i());s.unshift("Parameters");}else{s.unshift(e.nodeName);}break;}e=e.parentNode;}s.unshift(e.getAttribute("Target"));s=s.map(function(S){return typeof S==="string"?b.replaceWithAlias(S):S;});b.syncAnnotationsAtArrays(m,s,true);return s;},restoreAnnotationsAtArrays:function(m){if(m.annotationsAtArrays){m.annotationsAtArrays.forEach(function(s){b.syncAnnotationsAtArrays(m,s);});}},syncAnnotationsAtArrays:function(m,s,w){var i,n=s.length-2,c=s[n+1],p=m,P=s[n],S=P+"@"+c;for(i=0;i<n;i+=1){p=p&&p[s[i]];}if(p&&Array.isArray(p[P])){if(!(S in p)){p[S]=p[P][c];}if(!(c in p[P])){p[P][c]=p[S];}}else if(w){L.warning("Wrong path to annotation at array",s,"sap.ui.model.odata.AnnotationParser");}},_parseAnnotation:function(s,o,c){var Q=g(o);var T=b.replaceWithAlias(o.getAttribute("Term"));if(Q){T+="#"+Q;}var v=b.getPropertyValue(o,s);v=b.setEdmTypes(v,b._parserData.metadataProperties.types,s,b._parserData.schema);c[T]=v;if(Array.isArray(c)){b._parserData.annotationsAtArrays.push(o);}},_parseReferences:function(m){var f=false;var n,i;var x=b._oXPath;var s="//edmx:Reference/edmx:Include[@Namespace and @Alias]";var o=x.selectNodes(s,b._parserData.xmlDocument);for(i=0;i<o.length;++i){f=true;n=x.nextNode(o,i);b._parserData.aliases[n.getAttribute("Alias")]=n.getAttribute("Namespace");}var r="//edmx:Reference[@Uri]/edmx:IncludeAnnotations[@TermNamespace]";var R=x.selectNodes(r,b._parserData.xmlDocument);for(i=0;i<R.length;++i){f=true;n=x.nextNode(R,i);var T=n.getAttribute("TermNamespace");var c=n.getAttribute("TargetNamespace");var d=n.parentNode.getAttribute("Uri");if(c){if(!m[c]){m[c]={};}m[c][T]=d;}else{m[T]=d;}}return f;},getAllPropertiesMetadata:function(o){var c={},P={},d={},e=false,n,E,C,f={},h={},r={},s=false,u,v,w,T,x,R={types:P};if(!o.dataServices.schema){return R;}for(var i=o.dataServices.schema.length-1;i>=0;i-=1){c=o.dataServices.schema[i];if(c.entityType){n=c.namespace;E=c.entityType;C=c.complexType;for(var j=0;j<E.length;j+=1){f=E[j];r={};h={};if(f.property){for(var k=0;k<f.property.length;k+=1){u=f.property[k];if(u.type.substring(0,n.length)===n){if(C){for(var l=0;l<C.length;l+=1){if(C[l].name===u.type.substring(n.length+1)){if(C[l].property){for(var m=0;m<C[l].property.length;m+=1){v=C[l].property[m];h[C[l].name+"/"+v.name]=v.type;}}}}}}else{w=u.name;T=u.type;if(u.extensions){for(var p=0;p<u.extensions.length;p+=1){x=u.extensions[p];if((x.name==="display-format")&&(x.value==="Date")){T="Edm.Date";}else{s=true;if(!r[w]){r[w]={};}if(x.namespace&&!r[w][x.namespace]){r[w][x.namespace]={};}r[w][x.namespace][x.name]=x.value;}}}h[w]=T;}}}if(!P[n+"."+f.name]){P[n+"."+f.name]={};}P[n+"."+f.name]=h;if(s){if(!d[n+"."+f.name]){e=true;}d[n+"."+f.name]={};d[n+"."+f.name]=r;}}}}if(e){R={types:P,extensions:d};}return R;},setEdmTypes:function(p,P,T,s){function c(d){var o,e='';if(p[d]){o=p[d];if(o.Value&&o.Value.Path){e=b.getEdmType(o.Value.Path,P,T,s);if(e){p[d].EdmType=e;}}else if(o.Path){e=b.getEdmType(o.Path,P,T,s);if(e){p[d].EdmType=e;}}else if(o.Facets){p[d].Facets=b.setEdmTypes(o.Facets,P,T,s);}else if(o.Data){p[d].Data=b.setEdmTypes(o.Data,P,T,s);}else if(d==="Data"){p.Data=b.setEdmTypes(o,P,T,s);}else if(o.Value&&o.Value.Apply){p[d].Value.Apply.Parameters=b.setEdmTypes(o.Value.Apply.Parameters,P,T,s);}else if(o.Value&&o.Type&&(o.Type==="Path")){e=b.getEdmType(o.Value,P,T,s);if(e){p[d].EdmType=e;}}}}if(Array.isArray(p)){for(var v=0;v<p.length;v+=1){c(v);}}else{for(var V in p){c(V);}}return p;},getEdmType:function(p,P,T,s){var i=p.indexOf("/");if(i>-1){var c=p.substr(0,i);var n=b.findNavProperty(T,c);if(n){var m=b._parserData.metadataInstance._getEntityTypeByNavPropertyObject(n);if(m){T=m.entityType;p=p.substr(i+1);}}}if((p.charAt(0)==="@")&&(p.indexOf(s.Alias)===1)){p=p.slice(s.Alias.length+2);}if(p.indexOf("/")>=0){if(P[p.slice(0,p.indexOf("/"))]){T=p.slice(0,p.indexOf("/"));p=p.slice(p.indexOf("/")+1);}}return P[T]&&P[T][p];},enrichFromPropertyValueAttributes:function(m,n){var I={"Property":true,"Qualifier":true,"Term":true,"xmlns":true};for(var i=0;i<n.attributes.length;i+=1){var N=n.attributes[i].name;if(!I[N]&&(N.indexOf("xmlns:")!==0)){var v=n.attributes[i].value;if(N==="EnumMember"&&v.indexOf(" ")>-1){var V=v.split(" ");m[N]=V.map(b.replaceWithAlias).join(" ");}else{m[N]=b.replaceWithAlias(v);}}}return m;},_getRecordValues:function(n){var N=[];var x=b._oXPath;for(var i=0;i<n.length;++i){var o=x.nextNode(n,i);var v=b.getPropertyValues(o);var T=o.getAttribute("Type");if(T){v["RecordType"]=b.replaceWithAlias(T);}N.push(v);}return N;},_getTextValues:function(n){var N=[];var x=b._oXPath;for(var i=0;i<n.length;i+=1){var o=x.nextNode(n,i);var v={};var T=x.getNodeText(o);v[o.nodeName]=b._parserData.aliases?b.replaceWithAlias(T):T;N.push(v);}return N;},_getTextValue:function(n){var x=b._oXPath;var v="";if(n.nodeName in A){v=b.replaceWithAlias(x.getNodeText(n));}else{v=x.getNodeText(n);}if(n.nodeName!=="String"){v=v.trim();}return v;},getPropertyValue:function(d,s){var i;var x=b._oXPath;var p=d.nodeName==="Collection"?[]:{};if(d.hasChildNodes()){var r=x.selectNodes("./d:Record",d);var R=b._getRecordValues(r);var c=x.selectNodes("./d:Collection/d:Record | ./d:Collection/d:If/d:Record",d);var C=b._getRecordValues(c);var P=R.concat(C);if(P.length>0){if(c.length===0&&r.length>0){p=P[0];}else{p=P;}}else{var o=x.selectNodes("./d:Collection/d:AnnotationPath | ./d:Collection/d:NavigationPropertyPath | ./d:Collection/d:PropertyPath",d);if(o.length>0){p=b._getTextValues(o);}else{var e=x.selectNodes("./d:*[not(local-name() = \"Annotation\")]",d);if(e.length>0){for(i=0;i<e.length;i++){var f=x.nextNode(e,i);var v;var n=f.nodeName;var h=f.parentNode.nodeName;if(n==="Apply"){v=b.getApplyFunctions(f);}else{v=b.getPropertyValue(f);}if(M[h]){if(!Array.isArray(p)){p=[];}var V={};V[n]=v;p.push(V);}else if(n==="Collection"){p=v;}else{if(p[n]){L.warning("Annotation contained multiple "+n+" values. Only the last "+"one will be stored: "+x.getPath(f));}p[n]=v;}}b.enrichFromPropertyValueAttributes(p,d);}else if(d.nodeName in t){p=b._getTextValue(d);}else{b.enrichFromPropertyValueAttributes(p,d);}}}var N=x.selectNodes("./d:Annotation",d);if(N.length>0){for(i=0;i<N.length;i++){var j=x.nextNode(N,i);b._parseAnnotation(s,j,p);}}}else if(d.nodeName in t){p=b._getTextValue(d);}else if(d.nodeName.toLowerCase()==="null"){p=null;}else{b.enrichFromPropertyValueAttributes(p,d);}return p;},getPropertyValues:function(p){var P={},i;var x=b._oXPath;var o=x.selectNodes("./d:Annotation",p);var c=x.selectNodes("./d:PropertyValue",p);function d(p,w,N){var k,l=p;while(l.nodeName!=="Annotation"){l=l.parentNode;}k=l.parentNode;return(w+" '"+N+"' is defined twice; "+"Source = "+b._parserData.url+", Annotation Target = "+k.getAttribute("Target")+", Term = "+l.getAttribute("Term"));}if(o.length===0&&c.length===0){P=b.getPropertyValue(p);}else{for(i=0;i<o.length;i++){var e=x.nextNode(o,i);var T=b.replaceWithAlias(e.getAttribute("Term"));a(!P[T],function(){return d(p,"Annotation",T);});P[T]=b.getPropertyValue(e);}for(i=0;i<c.length;i++){var f=x.nextNode(c,i);var s=f.getAttribute("Property");a(!P[s],function(){return d(p,"Property",s);});P[s]=b.getPropertyValue(f);var h=x.selectNodes("./d:Apply",f);for(var n=0;n<h.length;n+=1){var j=x.nextNode(h,n);P[s]={};P[s]['Apply']=b.getApplyFunctions(j);}}}return P;},getApplyFunctions:function(c){var x=b._oXPath;var m={Name:c.getAttribute('Function'),Parameters:[]};var p=x.selectNodes("./d:*",c);for(var i=0;i<p.length;i+=1){var P=x.nextNode(p,i);var d={Type:P.nodeName};if(P.nodeName==="Apply"){d.Value=b.getApplyFunctions(P);}else if(P.nodeName==="LabeledElement"){d.Value=b.getPropertyValue(P);d.Name=d.Value.Name;delete d.Value.Name;}else if(M[P.nodeName]){d.Value=b.getPropertyValue(P);}else{d.Value=x.getNodeText(P);}m.Parameters.push(d);}return m;},findNavProperty:function(e,p){var m=b._parserData.serviceMetadata;for(var i=m.dataServices.schema.length-1;i>=0;i-=1){var o=m.dataServices.schema[i];if(o.entityType){var n=o.namespace+".";var E=o.entityType;for(var k=E.length-1;k>=0;k-=1){if(n+E[k].name===e&&E[k].navigationProperty){for(var j=0;j<E[k].navigationProperty.length;j+=1){if(E[k].navigationProperty[j].name===p){return E[k].navigationProperty[j];}}}}}}return null;},replaceWithAlias:function(v,r){if(r===undefined){r=1;}for(var s in b._parserData.aliases){if(v.indexOf(s+".")>=0&&v.indexOf("."+s+".")<0){v=v.replace(s+".",b._parserData.aliases[s]+".");r--;if(r===0){return v;}}}return v;},getXPath:function(){var x={};var p=b._parserData;if(D.browser.msie){x={setNameSpace:function(o){o.setProperty("SelectionNamespaces",'xmlns:edmx="http://docs.oasis-open.org/odata/ns/edmx" xmlns:d="http://docs.oasis-open.org/odata/ns/edm"');o.setProperty("SelectionLanguage","XPath");return o;},selectNodes:function(x,i){return i.selectNodes(x);},nextNode:function(n){return n.nextNode();},getNodeText:function(n){return n.text;}};}else{x={setNameSpace:function(o){return o;},nsResolver:function(c){var n={"edmx":"http://docs.oasis-open.org/odata/ns/edmx","d":"http://docs.oasis-open.org/odata/ns/edm"};return n[c]||null;},selectNodes:function(P,i){var c=p.xmlDocument.evaluate(P,i,this.nsResolver,7,null);c.length=c.snapshotLength;return c;},nextNode:function(n,i){return n.snapshotItem(i);},getNodeText:function(n){return n.textContent;}};}x.getPath=function(n){var P="";var I="getAttribute"in n?n.getAttribute("id"):"";var T=n.tagName?n.tagName:"";if(I){P='id("'+I+'")';}else if(n instanceof Document){P="/";}else if(T.toLowerCase()==="body"){P=T;}else if(n.parentNode){var c=1;for(var i=0;i<n.parentNode.childNodes.length;++i){if(n.parentNode.childNodes[i]===n){P=x.getPath(n.parentNode)+"/"+T+"["+c+"]";break;}else if(n.parentNode.childNodes[i].nodeType===1&&n.parentNode.childNodes[i].tagName===T){++c;}}}else{L.error("Wrong Input node - cannot find XPath to it: "+T);}return P;};return x;}};return b;});
sap.ui.predefine('sap/ui/model/odata/CountMode',function(){"use strict";var C={Request:"Request",Inline:"Inline",InlineRepeat:"InlineRepeat",Both:"Both",None:"None"};return C;},true);
sap.ui.predefine('sap/ui/model/odata/Filter',['sap/ui/base/Object','sap/ui/model/Filter','sap/ui/model/FilterOperator'],function(B,F,a){"use strict";
var O=B.extend("sap.ui.model.odata.Filter",{
constructor:function(p,v,A){if(typeof p==="object"){var f=p;p=f.path;v=f.values;A=f.and;}this.sPath=p;this.aValues=v;this.bAND=A==undefined?true:A;},
convert:function(){var f=[];for(var i=0,l=this.aValues&&this.aValues.length||0;i<l;i++){f.push(new F({path:this.sPath,operator:this.aValues[i].operator,value1:this.aValues[i].value1,value2:this.aValues[i].value2}));}if(f.length>1){var o=new F({filters:f,and:this.bAND});return o;}else{return f[0];}}
});
return O;});
sap.ui.predefine('sap/ui/model/odata/MessageScope',function(){"use strict";var M={RequestedObjects:"RequestedObjects",BusinessObject:"BusinessObject"};return M;},true);
sap.ui.predefine('sap/ui/model/odata/ODataAnnotations',["./AnnotationParser","sap/base/assert","sap/base/Log","sap/ui/Device","sap/ui/base/EventProvider","sap/ui/thirdparty/jquery"],function(A,a,L,D,E,q){"use strict";
var O=E.extend("sap.ui.model.odata.ODataAnnotations",{
constructor:function(o){E.apply(this,arguments);if(arguments.length!==1){if(typeof arguments[2]==="object"){o=arguments[2];}o.urls=arguments[0];o.metadata=arguments[1];}this.oMetadata=o.metadata;this.oAnnotations=o.annotationData?o.annotationData:{};this.bLoaded=false;this.bAsync=o&&o.async;this.xPath=null;this.oError=null;this.bValidXML=true;this.oRequestHandles=[];this.oLoadEvent=null;this.oFailedEvent=null;this.mCustomHeaders=o.headers?q.extend({},o.headers):{};if(o.urls){this.addUrl(o.urls);if(!this.bAsync){a(!q.isEmptyObject(this.oMetadata),"Metadata must be available for synchronous annotation loading");if(this.oError){L.error("OData annotations could not be loaded: "+this.oError.message);}}}},
metadata:{publicMethods:["parse","getAnnotationsData","attachFailed","detachFailed","attachLoaded","detachLoaded"]}
});
O.prototype.getAnnotationsData=function(){return this.oAnnotations;};
O.prototype.isLoaded=function(){return this.bLoaded;};
O.prototype.isFailed=function(){return this.oError!==null;};
O.prototype.fireLoaded=function(p){this.fireEvent("loaded",p);return this;};
O.prototype.attachLoaded=function(d,f,l){this.attachEvent("loaded",d,f,l);return this;};
O.prototype.detachLoaded=function(f,l){this.detachEvent("loaded",f,l);return this;};
O.prototype.fireFailed=function(p){this.fireEvent("failed",p);return this;};
O.prototype.attachFailed=function(d,f,l){this.attachEvent("failed",d,f,l);return this;};
O.prototype.detachFailed=function(f,l){this.detachEvent("failed",f,l);return this;};
O.prototype.setHeaders=function(h){this.mCustomHeaders=q.extend({},h);};
O.prototype._createXMLDocument=function(x,X){var o=null;if(typeof x==="string"){X=x;x=null;}if(D.browser.msie){o=new ActiveXObject("Microsoft.XMLDOM");o.preserveWhiteSpace=true;if(X.indexOf(" xmlns:xml=")>-1){X=X.replace(' xmlns:xml="http://www.w3.org/XML/1998/namespace"',"").replace(" xmlns:xml='http://www.w3.org/XML/1998/namespace'","");}o.loadXML(X);}else if(x){o=x;}else if(window.DOMParser){o=new DOMParser().parseFromString(X,'application/xml');}else{L.fatal("The browser does not support XML parsing. Annotations are not available.");}return o;};
O.prototype._documentHasErrors=function(x){return(x.getElementsByTagName("parsererror").length>0||(x.parseError&&x.parseError.errorCode!==0));};
O.prototype._mergeAnnotationData=function(m,s){if(!this.oAnnotations){this.oAnnotations={};}A.merge(this.oAnnotations,m);this.bLoaded=true;if(!s){this.fireLoaded({annotations:m});}};
O.prototype.setXML=function(x,X,o){var d={success:function(){},error:function(){},fireEvents:false};o=q.extend({},d,o);var b=this._createXMLDocument(x,X);var p=function(b){var r={xmlDoc:b};var c=A.parse(this.oMetadata,b);if(c){r.annotations=c;o.success(r);this._mergeAnnotationData(c,!o.fireEvents);}else{o.error(r);if(o.fireEvents){this.fireFailed(r);}}}.bind(this,b);if(this._documentHasErrors(b)){o.error({xmlDoc:b});return false;}else{var m=this.oMetadata.getServiceMetadata();if(!m||q.isEmptyObject(m)){this.oMetadata.attachLoaded(p);}else{p();}return true;}};
O.prototype.addUrl=function(u){var t=this;var U=u;if(Array.isArray(u)&&u.length==0){return Promise.resolve({annotations:this.oAnnotations});}if(!Array.isArray(u)){U=[u];}return new Promise(function(r,R){var l=0;var m={annotations:null,success:[],fail:[]};var f=function(c){l++;if(c.type==="success"){m.success.push(c);}else{m.fail.push(c);}if(l===U.length){m.annotations=t.oAnnotations;if(m.success.length>0){var s={annotations:t.oAnnotations,results:m};t.fireLoaded(s);}if(m.success.length<U.length){var e=new Error("At least one annotation failed to load/parse/merge");e.annotations=m.annotations;e.success=m.success;e.fail=m.fail;R(e);}else{r(m);}}};var i=0;if(t.bAsync){var p=Promise.resolve();for(i=0;i<U.length;++i){var b=t._loadFromUrl.bind(t,U[i]);p=p.then(b,b).then(f,f);}}else{for(i=0;i<U.length;++i){t._loadFromUrl(U[i]).then(f,f);}}});};
O.prototype._loadFromUrl=function(u){var t=this;return new Promise(function(r,R){var m={url:u,async:t.bAsync,headers:q.extend({},t.mCustomHeaders,{"Accept-Language":sap.ui.getCore().getConfiguration().getLanguageTag()})};var o;var f=function(j,S){if(o&&o.bSuppressErrorHandlerCall){return;}t.oError={type:"fail",url:u,message:S,statusCode:j.status,statusText:j.statusText,responseText:j.responseText};if(t.bAsync){t.oFailedEvent=setTimeout(t.fireFailed.bind(t,t.oError),0);}else{t.fireFailed(t.oError);}R(t.oError);};var s=function(d,S,j){t.setXML(j.responseXML,j.responseText,{success:function(b){r({type:"success",url:u,message:S,statusCode:j.status,statusText:j.statusText,responseText:j.responseText});},error:function(b){f(j,"Malformed XML document");},url:u});};q.ajax(m).done(s).fail(f);});};
O.prototype.destroy=function(){for(var i=0;i<this.oRequestHandles.length;++i){if(this.oRequestHandles[i]){this.oRequestHandles[i].bSuppressErrorHandlerCall=true;this.oRequestHandles[i].abort();this.oRequestHandles[i]=null;}}E.prototype.destroy.apply(this,arguments);if(this.oLoadEvent){clearTimeout(this.oLoadEvent);}if(this.oFailedEvent){clearTimeout(this.oFailedEvent);}};
return O;});
sap.ui.predefine('sap/ui/model/odata/ODataContextBinding',['sap/ui/model/ContextBinding','sap/ui/model/ChangeReason'],function(C,a){"use strict";
var O=C.extend("sap.ui.model.odata.ODataContextBinding",{constructor:function(m,p,c,P,e){C.call(this,m,p,c,P,e);}});
O.prototype.initialize=function(){var t=this,r=this.oModel.resolve(this.sPath,this.oContext),d=this.oModel._getObject(this.sPath,this.oContext),R=this.oModel._isReloadNeeded(r,d,this.mParameters);if(this.oModel.oMetadata.isLoaded()){if(r&&R){this.fireDataRequested();}this.oModel.createBindingContext(this.sPath,this.oContext,this.mParameters,function(c){t.oElementContext=c;t._fireChange({reason:a.Context});if(r&&R){t.fireDataReceived();}},R);}};
O.prototype.refresh=function(f,c){var t=this,k,s,b=false,r=this.oModel.resolve(this.sPath,this.oContext);if(c){s=this.oModel._getObject(this.sPath,this.oContext);if(s){k=this.oModel._getKey(s);if(k in c){b=true;}}}else{b=true;}if(f||b){if(r){this.fireDataRequested();}this.oModel.createBindingContext(this.sPath,this.oContext,this.mParameters,function(o){if(t.oElementContext===o){if(f){t._fireChange({reason:a.Context});}}else{t.oElementContext=o;t._fireChange({reason:a.Context});}if(r){t.fireDataReceived();}},true);}};
O.prototype.setContext=function(c){var t=this,r,d,R;if(this.oContext!==c&&this.isRelative()){this.oContext=c;r=this.oModel.resolve(this.sPath,this.oContext);d=this.oModel._getObject(this.sPath,this.oContext);R=this.oModel._isReloadNeeded(r,d,this.mParameters);if(r&&R){this.fireDataRequested();}this.oModel.createBindingContext(this.sPath,this.oContext,this.mParameters,function(c){t.oElementContext=c;t._fireChange({reason:a.Context});if(r&&R){t.fireDataReceived();}},R);}};
return O;});
sap.ui.predefine('sap/ui/model/odata/ODataListBinding',['sap/ui/model/ChangeReason','sap/ui/model/Filter','sap/ui/model/odata/Filter','sap/ui/model/FilterType','sap/ui/model/FilterProcessor','sap/ui/model/ListBinding','sap/ui/model/Sorter','./ODataUtils','./CountMode','sap/base/util/deepEqual','sap/base/util/merge','sap/base/Log','sap/base/assert','sap/ui/thirdparty/jquery'],function(C,F,O,a,b,L,S,c,d,e,m,f,g,q){"use strict";
var h=L.extend("sap.ui.model.odata.ODataListBinding",{constructor:function(M,p,o,s,i,P){L.apply(this,arguments);this.sFilterParams=null;this.sSortParams=null;this.sRangeParams=null;this.sCustomParams=this.oModel.createCustomParams(this.mParameters);this.iStartIndex=0;this.bPendingChange=false;this.aKeys=[];this.bInitial=true;this.sCountMode=(P&&P.countMode)||this.oModel.sDefaultCountMode;this.bRefresh=false;this.bNeedsUpdate=false;this.bDataAvailable=false;this.bIgnoreSuspend=false;this.oCombinedFilter=null;this.oModel.checkFilterOperation(this.aApplicationFilters);if(!this.oModel.getServiceMetadata()){var t=this,j=function(E){t.bInitial=false;t._initSortersFilters();t.oModel.detachMetadataLoaded(j);};this.oModel.attachMetadataLoaded(this,j);}else{this.bInitial=false;this._initSortersFilters();}var r=this.oModel._getObject(this.sPath,this.oContext);this.aExpandRefs=r;if(Array.isArray(r)&&!s&&!i){this.aKeys=r;this.iLength=r.length;this.bLengthFinal=true;this.bDataAvailable=true;}else if(r===null&&this.oModel.resolve(this.sPath,this.oContext)){this.aKeys=[];this.iLength=0;this.bLengthFinal=true;this.bDataAvailable=true;}else{if(this.oModel.getServiceMetadata()){this.resetData();}}}});
h.prototype.getContexts=function(s,l,t){if(this.bInitial){return[];}this.iLastLength=l;this.iLastStartIndex=s;this.iLastThreshold=t;if(!s){s=0;}if(!l){l=this.oModel.iSizeLimit;if(this.bLengthFinal&&this.iLength<l){l=this.iLength;}}if(!t){t=0;}var j=true,k=this._getContexts(s,l),o={},n;n=this.calculateSection(s,l,t,k);j=k.length!=l&&!(this.bLengthFinal&&k.length>=this.iLength-s);if(this.oModel.getServiceMetadata()){if(!this.bPendingRequest&&n.length>0&&(j||l<n.length)){this.loadData(n.startIndex,n.length);k.dataRequested=true;}}if(this.bRefresh){if(this.bLengthFinal&&this.iLength==0){this.loadData(n.startIndex,n.length,true);k.dataRequested=true;}this.bRefresh=false;}else{for(var i=0;i<k.length;i++){o[k[i].getPath()]=k[i].getObject();}if(this.bUseExtendedChangeDetection){if(this.aLastContexts&&s<this.iLastEndIndex){var p=this;var D=q.sap.arrayDiff(this.aLastContexts,k,function(r,N){return e(r&&p.oLastContextData&&p.oLastContextData[r.getPath()],N&&o&&o[N.getPath()]);},true);k.diff=D;}}this.iLastEndIndex=s+l;this.aLastContexts=k.slice(0);this.oLastContextData=m({},o);}return k;};
h.prototype.getCurrentContexts=function(){return this.aLastContexts||[];};
h.prototype._getContexts=function(s,l){var j=[],o,k;if(!s){s=0;}if(!l){l=this.oModel.iSizeLimit;if(this.bLengthFinal&&this.iLength<l){l=this.iLength;}}for(var i=s;i<s+l;i++){k=this.aKeys[i];if(!k){break;}o=this.oModel.getContext('/'+k);j.push(o);}return j;};
h.prototype.calculateSection=function(s,l,t,k){var n,o,p,P,r,u={},K;o=s;n=0;for(var i=s;i>=Math.max(s-t,0);i--){K=this.aKeys[i];if(!K){P=i+1;break;}}for(var j=s+l;j<s+l+t;j++){K=this.aKeys[j];if(!K){p=j;break;}}r=s-P;if(P&&s>t&&r<t){if(k.length!=l){o=s-t;}else{o=P-t;}n=t;}o=Math.max(o,0);if(o==s){o+=k.length;}if(k.length!=l){n+=l-k.length;}r=p-s-l;if(r==0){n+=t;}if(p&&r<t&&r>0){if(o>s){o=p;n+=t;}}if(this.bLengthFinal&&this.iLength<(n+o)){n=this.iLength-o;}u.startIndex=o;u.length=n;return u;};
h.prototype.setContext=function(o){if(this.oContext!=o){this.oContext=o;if(this.isRelative()){this._initSortersFilters();if(!this.bInitial){var r=this.oModel._getObject(this.sPath,this.oContext);this.aExpandRefs=r;if(Array.isArray(r)&&!this.aSorters.length>0&&!this.aFilters.length>0){this.aKeys=r;this.iLength=r.length;this.bLengthFinal=true;this._fireChange({reason:C.Context});}else if(!this.oModel.resolve(this.sPath,this.oContext)||r===null){this.aKeys=[];this.iLength=0;this.bLengthFinal=true;this._fireChange({reason:C.Context});}else{this.refresh();}}}}};
h.prototype.getDownloadUrl=function(s){var p=[],P;if(s){p.push("$format="+encodeURIComponent(s));}if(this.sSortParams){p.push(this.sSortParams);}if(this.sFilterParams){p.push(this.sFilterParams);}if(this.sCustomParams){p.push(this.sCustomParams);}P=this.oModel.resolve(this.sPath,this.oContext);if(P){return this.oModel._createRequestUrl(P,null,p);}};
h.prototype.loadData=function(s,l,p){var t=this,I=false;if(s||l){this.sRangeParams="$skip="+s+"&$top="+l;this.iStartIndex=s;}else{s=this.iStartIndex;}var P=[];if(this.sRangeParams){P.push(this.sRangeParams);}if(this.sSortParams){P.push(this.sSortParams);}if(this.sFilterParams){P.push(this.sFilterParams);}if(this.sCustomParams){P.push(this.sCustomParams);}if(!this.bLengthFinal&&(this.sCountMode==d.Inline||this.sCountMode==d.Both)){P.push("$inlinecount=allpages");I=true;}function j(D){q.each(D.results,function(i,r){t.aKeys[s+i]=t.oModel._getKey(r);});if(I&&D.__count){t.iLength=parseInt(D.__count);t.bLengthFinal=true;}if(t.iLength<s+D.results.length){t.iLength=s+D.results.length;t.bLengthFinal=false;}if(D.results.length<l||l===undefined){t.iLength=s+D.results.length;t.bLengthFinal=true;}if(s==0&&D.results.length==0){t.iLength=0;t.bLengthFinal=true;}t.oRequestHandle=null;t.bPendingRequest=false;t.bNeedsUpdate=true;t.bIgnoreSuspend=true;}function k(D){t.fireDataReceived({data:D});}function E(i,A){t.oRequestHandle=null;t.bPendingRequest=false;if(!A){t.aKeys=[];t.iLength=0;t.bLengthFinal=true;t.bDataAvailable=true;t._fireChange({reason:C.Change});}t.fireDataReceived();}function u(H){t.oRequestHandle=H;}var n=this.sPath,o=this.oContext;if(this.isRelative()){n=this.oModel.resolve(n,o);}if(n){if(p){var U=this.oModel._createRequestUrl(n,null,P);this.fireDataRequested();this.oModel.fireRequestSent({url:U,method:"GET",async:true});setTimeout(function(){t.bNeedsUpdate=true;t.checkUpdate();t.oModel.fireRequestCompleted({url:U,method:"GET",async:true,success:true});t.fireDataReceived({data:{}});},0);}else{this.bPendingRequest=true;this.fireDataRequested();this.oModel._loadData(n,P,j,E,false,u,k);}}};
h.prototype.getLength=function(){if(this.bLengthFinal||this.iLength==0){return this.iLength;}else{var A=this.iLastThreshold||this.iLastLength||10;return this.iLength+A;}};
h.prototype.isLengthFinal=function(){return this.bLengthFinal;};
h.prototype._getLength=function(){var t=this;var p=[];if(this.sFilterParams){p.push(this.sFilterParams);}if(this.mParameters&&this.mParameters.custom){var o={custom:{}};q.each(this.mParameters.custom,function(s,v){o.custom[s]=v;});p.push(this.oModel.createCustomParams(o));}function _(D){t.iLength=parseInt(D);t.bLengthFinal=true;}function i(E){var s="Request for $count failed: "+E.message;if(E.response){s+=", "+E.response.statusCode+", "+E.response.statusText+", "+E.response.body;}f.warning(s);}var P=this.oModel.resolve(this.sPath,this.oContext);if(P){var u=this.oModel._createRequestUrl(P+"/$count",null,p);var r=this.oModel._createRequest(u,"GET",false);r.headers["Accept"]="text/plain, */*;q=0.5";this.oModel._request(r,_,i,undefined,undefined,this.oModel.getServiceMetadata());}};
h.prototype.refresh=function(j,k,E){var l=false;if(!j){if(E){var r=this.oModel.resolve(this.sPath,this.oContext);var o=this.oModel.oMetadata._getEntityTypeByPath(r);if(o&&(o.entityType in E)){l=true;}}if(k&&!l){q.each(this.aKeys,function(i,K){if(K in k){l=true;return false;}});}if(!k&&!E){l=true;}}if(j||l){this.abortPendingRequest();this.resetData();this._fireRefresh({reason:C.Refresh});}};
h.prototype._fireRefresh=function(p){if(this.oModel.resolve(this.sPath,this.oContext)){this.bRefresh=true;this.fireEvent("refresh",p);}};
h.prototype.initialize=function(){if(this.oModel.oMetadata.isLoaded()){if(this.bDataAvailable){this._fireChange({reason:C.Change});}else{this._fireRefresh({reason:C.Refresh});}}};
h.prototype.checkUpdate=function(j,k){var l=this.sChangeReason?this.sChangeReason:C.Change,n=false,o,p,t=this,r,R;if(this.bSuspended&&!this.bIgnoreSuspend){return;}if(!j&&!this.bNeedsUpdate){r=this.oModel._getObject(this.sPath,this.oContext);R=Array.isArray(r)&&!e(r,this.aExpandRefs);this.aExpandRefs=r;if(R){if(this.aSorters.length>0||this.aFilters.length>0){this.refresh();return;}else{this.aKeys=r;this.iLength=r.length;this.bLengthFinal=true;n=true;}}else if(k){q.each(this.aKeys,function(i,K){if(K in k){n=true;return false;}});}else{n=true;}if(n&&this.aLastContexts){n=false;var s=this._getContexts(this.iLastStartIndex,this.iLastLength,this.iLastThreshold);if(this.aLastContexts.length!=s.length){n=true;}else{q.each(this.aLastContexts,function(i,u){o=t.oLastContextData[u.getPath()];p=s[i].getObject();if(!e(o,p,true)){n=true;return false;}});}}}if(j||n||this.bNeedsUpdate){this.bNeedsUpdate=false;this._fireChange({reason:l});}this.sChangeReason=undefined;this.bIgnoreSuspend=false;};
h.prototype.resetData=function(){this.aKeys=[];this.iLength=0;this.bLengthFinal=false;this.sChangeReason=undefined;this.bDataAvailable=false;if(this.oModel.isCountSupported()&&(this.sCountMode==d.Request||this.sCountMode==d.Both)){this._getLength();}};
h.prototype.abortPendingRequest=function(){if(this.oRequestHandle){this.oRequestHandle.abort();this.oRequestHandle=null;this.bPendingRequest=false;}};
h.prototype.sort=function(s,r){var i=false;if(!s){s=[];}if(s instanceof S){s=[s];}this.aSorters=s;this.createSortParams(s);if(!this.bInitial){this.aKeys=[];this.abortPendingRequest();this.sChangeReason=C.Sort;this._fireRefresh({reason:this.sChangeReason});this._fireSort({sorter:s});i=true;}if(r){return i;}else{return this;}};
h.prototype.createSortParams=function(s){this.sSortParams=c.createSortParams(s);};
h.prototype.filter=function(i,s,r){var j=false;if(!i){i=[];}if(i instanceof F){i=[i];}this.oModel.checkFilterOperation(i);if(s==a.Application){this.aApplicationFilters=i;}else{this.aFilters=i;}if(!i||!Array.isArray(i)||i.length==0){this.aFilters=[];}if(!this.aApplicationFilters||!Array.isArray(this.aApplicationFilters)||this.aApplicationFilters.length===0){this.aApplicationFilters=[];}this.convertFilters();this.oCombinedFilter=b.combineFilters(this.aFilters,this.aApplicationFilters);this.createFilterParams(this.oCombinedFilter);if(!this.bInitial){this.resetData();this.abortPendingRequest();this.sChangeReason=C.Filter;this._fireRefresh({reason:this.sChangeReason});if(s==a.Application){this._fireFilter({filters:this.aApplicationFilters});}else{this._fireFilter({filters:this.aFilters});}j=true;}if(r){return j;}else{return this;}};
h.prototype.convertFilters=function(){this.aFilters=this.aFilters.map(function(o){return o instanceof O?o.convert():o;});this.aApplicationFilters=this.aApplicationFilters.map(function(o){return o instanceof O?o.convert():o;});};
h.prototype.createFilterParams=function(o){this.sFilterParams=c.createFilterParams(o,this.oModel.oMetadata,this.oEntityType);};
h.prototype._initSortersFilters=function(){var r=this.oModel.resolve(this.sPath,this.oContext);if(!r){return;}this.oEntityType=this._getEntityType();this.convertFilters();this.oCombinedFilter=b.combineFilters(this.aFilters,this.aApplicationFilters);this.createSortParams(this.aSorters);this.createFilterParams(this.oCombinedFilter);};
h.prototype._getEntityType=function(){var r=this.oModel.resolve(this.sPath,this.oContext);if(r){var E=this.oModel.oMetadata._getEntityTypeByPath(r);g(E,"EntityType for path "+r+" could not be found!");return E;}return undefined;};
h.prototype.resume=function(){this.bIgnoreSuspend=false;L.prototype.resume.apply(this,arguments);};
return h;});
sap.ui.predefine('sap/ui/model/odata/ODataMessageParser',["sap/ui/model/odata/ODataUtils","sap/ui/core/library","sap/ui/thirdparty/URI","sap/ui/core/message/MessageParser","sap/ui/core/message/Message","sap/base/Log","sap/ui/thirdparty/jquery"],function(O,c,U,M,a,L,q){"use strict";var C="sap.ui.model.odata.ODataMessageParser",r=/^\/+|\/$/g,b=c.MessageType,s={"error":b.Error,"info":b.Information,"success":b.Success,"warning":b.Warning};
var d=M.extend("sap.ui.model.odata.ODataMessageParser",{
metadata:{publicMethods:["parse","setProcessor","getHeaderField","setHeaderField"]},
constructor:function(S,m){M.apply(this);this._serviceUrl=e(this._parseUrl(S).url);this._metadata=m;this._processor=null;this._headerField="sap-message";this._lastMessages=[];}
});
d.prototype.getHeaderField=function(){return this._headerField;};
d.prototype.setHeaderField=function(F){this._headerField=F;return this;};
d.prototype.parse=function(R,o,G,m,i){var j=[],k={request:o,response:R,url:o?o.requestUri:R.requestUri};if(R.statusCode>=200&&R.statusCode<300){this._parseHeader(j,R,k);}else if(R.statusCode>=400&&R.statusCode<600){this._parseBody(j,R,k);}else{L.warning("No rule to parse OData response with status "+R.statusCode+" for messages");}this._propagateMessages(j,k,G,m,!i);};
d.prototype._getAffectedTargets=function(m,R,G,i){var A=Object.assign({"":true},G,i),E,j=this._parseUrl(R.url).url;if(R.request&&R.request.key&&R.request.created){A[R.request.key]=true;}if(j.startsWith(this._serviceUrl)){j=j.slice(this._serviceUrl.length+1);}E=this._metadata._getEntitySetByPath(j);if(E){A[E.name]=true;}m.forEach(function(o){o.getTargets().forEach(function(t){var p,S,T;if(!t){return;}T=t.replace(r,"");A[T]=true;S=T.lastIndexOf("/");if(S>0){p=T.slice(0,S);A[p]=true;}});});return A;};
d.prototype._propagateMessages=function(m,R,G,i,S){var A,D=R.request.deepPath,k=[],p=D&&R.request.updateAggregatedMessages,t=R.request.headers&&R.request.headers["sap-messages"]==="transientOnly",j=[],n,o,u;function v(w,T){return T.some(function(x){return A[x];})||p&&w.aFullTargets.some(function(F){return F.startsWith(D);});}if(t){k=this._lastMessages;n=m.some(function(w){return!w.getPersistent()&&!w.getTechnical();});if(n){L.error("Unexpected non-persistent message in response, but requested only "+"transition messages",undefined,C);}}else{A=this._getAffectedTargets(m,R,G,i);o=R.response.statusCode;u=(o>=200&&o<300);this._lastMessages.forEach(function(w){var T=w.getTargets().map(function(x){x=x.replace(r,"");var P=x.lastIndexOf(")/");if(P>0){x=x.substr(0,P+1);}return x;});if(u||S){if(!w.getPersistent()&&v(w,T)){j.push(w);}else{k.push(w);}}else if(!w.getPersistent()&&w.getTechnical()&&v(w,T)){j.push(w);}else{k.push(w);}});}this.getProcessor().fireMessageChange({oldMessages:j,newMessages:m});this._lastMessages=k.concat(m);};
d.prototype._createMessage=function(m,R,i){var p=m.target&&m.target.indexOf("/#TRANSIENT#")===0||m.transient||m.transition,t,T=typeof m.message==="object"?m.message.value:m.message,j=m["@sap.severity"]||m.severity;m.transition=!!p;t=this._createTargets(m,R,i);return new a({code:m.code||"",description:m.description,descriptionUrl:m.longtext_url||"",fullTarget:t.aDeepPaths,message:T,persistent:!!p,processor:this._processor,target:t.aTargets,technical:i,technicalDetails:{headers:R.response.headers,statusCode:R.response.statusCode},type:s[j]||j});};
d._isResponseForCreate=function(R){var o=R.request,i=R.response;if(o.method==="POST"&&i.statusCode==201&&i.headers["location"]){return true;}if(o.key&&o.created&&i.statusCode>=400){return false;}};
d.prototype._createTarget=function(o,R,i,j){var k,m,D,p,P,n,u,t,v,w=R.request,x=R.response;if(o===undefined&&(!i&&w.headers["sap-message-scope"]==="BusinessObject"||i&&j)){return{deepPath:"",target:""};}o=o||"";o=o.startsWith("/#TRANSIENT#")?o.slice(12):o;if(o[0]!=="/"){m=d._isResponseForCreate(R);D=w.deepPath||"";if(m===true){v=x.headers["location"];}else if(m===false){v=w.key;}else{v=R.url;}t=this._parseUrl(v);u=t.url;p=u.indexOf(this._serviceUrl);if(p>-1){n=u.slice(p+this._serviceUrl.length);}else{n="/"+u;}if(!m&&w.functionMetadata){n=w.functionTarget;}if(n.slice(n.lastIndexOf("/")).indexOf("(")>-1||!this._metadata._isCollection(n)){D=o?D+"/"+o:D;o=o?n+"/"+o:n;}else{D=D+o;o=n+o;}}k=this._processor.resolve(o,undefined,true);while(k&&k.lastIndexOf("/")>0&&k!==P){P=k;k=this._processor.resolve(k,undefined,true)||P;}o=k||o;return{deepPath:this._metadata._getReducedPath(D||o),target:O._normalizeKey(o)};};
d.prototype._createTargets=function(m,R,i){var D=[],j=Array.isArray(m.additionalTargets)?[m.target].concat(m.additionalTargets):[m.target],t,T=[],k=this;if(m.propertyref!==undefined&&j[0]!==undefined){L.warning("Used the message's 'target' property for target calculation; the property"+" 'propertyref' is deprecated and must not be used together with 'target'",R.url,C);}else if(j[0]===undefined){j[0]=m.propertyref;}j.forEach(function(A){t=k._createTarget(A,R,i,m.transition);D.push(t.deepPath);T.push(t.target);});return{aDeepPaths:D,aTargets:T};};
d.prototype._parseHeader=function(m,R,j){var F=this.getHeaderField();if(!R.headers){return;}for(var k in R.headers){if(k.toLowerCase()===F.toLowerCase()){F=k;}}if(!R.headers[F]){return;}var n=R.headers[F];var S=null;try{S=JSON.parse(n);m.push(this._createMessage(S,j));if(Array.isArray(S.details)){for(var i=0;i<S.details.length;++i){m.push(this._createMessage(S.details[i],j));}}}catch(o){L.error("The message string returned by the back-end could not be parsed: '"+o.message+"'");return;}};
d.prototype._parseBody=function(m,R,i){var j=g(R);if(j&&j.indexOf("xml")>-1){this._parseBodyXML(m,R,i,j);}else{this._parseBodyJSON(m,R,i);}h(m);};
d.prototype._addGenericError=function(m,R){m.push(this._createMessage({description:R.response.body,message:sap.ui.getCore().getLibraryResourceBundle().getText("CommunicationError"),severity:b.Error,transition:true},R,true));};
d.prototype._parseBodyXML=function(j,R,k,o){try{var D=new DOMParser().parseFromString(R.body,o);var E=f(D,["error","errordetail"]);if(!E.length){this._addGenericError(j,k);return;}for(var i=0;i<E.length;++i){var N=E[i];var p={};p["severity"]=b.Error;for(var n=0;n<N.childNodes.length;++n){var t=N.childNodes[n];var u=t.nodeName;if(u==="errordetails"||u==="details"||u==="innererror"||u==="#text"){continue;}if(u==="message"&&t.hasChildNodes()&&t.firstChild.nodeType!==window.Node.TEXT_NODE){for(var m=0;m<t.childNodes.length;++m){if(t.childNodes[m].nodeName==="value"){p["message"]=t.childNodes[m].text||t.childNodes[m].textContent;}}}else{p[t.nodeName]=t.text||t.textContent;}}j.push(this._createMessage(p,k,true));}}catch(v){this._addGenericError(j,k);L.error("Error message returned by server could not be parsed");}};
d.prototype._parseBodyJSON=function(m,R,j){try{var E=JSON.parse(R.body);var o;if(E["error"]){o=E["error"];}else{o=E["odata.error"];}if(!o){this._addGenericError(m,j);L.error("Error message returned by server did not contain error-field");return;}o["severity"]=b.Error;m.push(this._createMessage(o,j,true));var F=null;if(Array.isArray(o.details)){F=o.details;}else if(o.innererror&&Array.isArray(o.innererror.errordetails)){F=o.innererror.errordetails;}else{F=[];}for(var i=0;i<F.length;++i){m.push(this._createMessage(F[i],j,true));}}catch(k){this._addGenericError(m,j);L.error("Error message returned by server could not be parsed");}};
d.prototype._parseUrl=function(u){var m={url:u,parameters:{},hash:""};var p=-1;p=u.indexOf("#");if(p>-1){m.hash=m.url.substr(p+1);m.url=m.url.substr(0,p);}p=u.indexOf("?");if(p>-1){var P=m.url.substr(p+1);m.parameters=U.parseQuery(P);m.url=m.url.substr(0,p);}return m;};
function g(R){if(R&&R.headers){for(var H in R.headers){if(H.toLowerCase()==="content-type"){return R.headers[H].replace(/([^;]*);.*/,"$1");}}}return false;}
var l=document.createElement("a");
function e(u){l.href=u;return U.parse(l.href).path;}
function f(D,E){var j=[];var m={};for(var i=0;i<E.length;++i){m[E[i]]=true;}var o=D;while(o){if(m[o.tagName]){j.push(o);}if(o.hasChildNodes()){o=o.firstChild;}else{while(!o.nextSibling){o=o.parentNode;if(!o||o===D){o=null;break;}}if(o){o=o.nextSibling;}}}return j;}
function h(m){if(m.length>1){for(var i=1;i<m.length;i++){if(m[0].getCode()==m[i].getCode()&&m[0].getMessage()==m[i].getMessage()){m.shift();break;}}}}
return d;});
sap.ui.predefine('sap/ui/model/odata/ODataMetaModel',['sap/ui/model/BindingMode','sap/ui/base/BindingParser','sap/ui/model/Context','sap/ui/base/ManagedObject','sap/ui/model/ClientContextBinding','sap/ui/model/FilterProcessor','sap/ui/model/json/JSONModel','sap/ui/model/json/JSONListBinding','sap/ui/model/json/JSONPropertyBinding','sap/ui/model/json/JSONTreeBinding','sap/ui/model/MetaModel','./_ODataMetaModelUtils',"sap/ui/performance/Measurement","sap/base/Log","sap/ui/thirdparty/jquery"],function(B,a,C,M,b,F,J,c,d,e,f,U,g,L,q){"use strict";var o="sap.ui.model.odata.ODataMetaModel",p=[o],P=o+"/load",r=/^((\/dataServices\/schema\/\d+)\/(?:complexType|entityType)\/\d+)\/property\/\d+$/;var O=c.extend("sap.ui.model.odata.ODataMetaListBinding"),R=M.extend("sap.ui.model.odata._resolver",{metadata:{properties:{any:"any"}}});
O.prototype.applyFilter=function(){var t=this,i=F.combineFilters(this.aFilters,this.aApplicationFilters);this.aIndices=F.apply(this.aIndices,i,function(v,s){return s==="@sapui.name"?v:t.oModel.getProperty(s,t.oList[v]);},this.mNormalizeCache);this.iLength=this.aIndices.length;};
var h=f.extend("sap.ui.model.odata.ODataMetaModel",{constructor:function(m,A,i){var t=this;function l(){var D;if(t.bDestroyed){throw new Error("Meta model already destroyed");}g.average(P,"",p);D=JSON.parse(JSON.stringify(m.getServiceMetadata()));t.oModel=new J(D);t.oModel.setDefaultBindingMode(t.sDefaultBindingMode);U.merge(A?A.getAnnotationsData():{},D,t);g.end(P);}i=i||{};f.apply(this);this.oModel=null;this.mContext2Promise={};this.sDefaultBindingMode=B.OneTime;this.oLoadedPromise=i.annotationsLoadedPromise?i.annotationsLoadedPromise.then(l):new Promise(function(j,k){l();j();});this.oMetadata=m;this.oODataModelInterface=i;this.mQueryCache={};this.mQName2PendingRequest={};this.oResolver=undefined;this.mSupportedBindingModes={"OneTime":true};}});
h.prototype._getObject=function(s,j){var k=j,l,m,i,E,n,v,t,u=s||"",w;if(!j||j instanceof C){u=this.resolve(s||"",j);if(!u){L.error("Invalid relative path w/o context",s,o);return null;}}if(u.charAt(0)==="/"){k=this.oModel._getObject("/");u=u.slice(1);}t="/";n=k;while(u){v=undefined;l=undefined;if(u.charAt(0)==='['){try{w=a.parseExpression(u,1);E=w.at;if(u.length===E+1||u.charAt(E+1)==='/'){l=w.result;v=u.slice(0,E+1);u=u.slice(E+2);}}catch(x){if(!(x instanceof SyntaxError)){throw x;}}}if(v===undefined){E=u.indexOf("/");if(E<0){v=u;u="";}else{v=u.slice(0,E);u=u.slice(E+1);}}if(!n){if(L.isLoggable(L.Level.WARNING,o)){L.warning("Invalid part: "+v,"path: "+s+", context: "+(j instanceof C?j.getPath():j),o);}break;}if(l){if(k===j){L.error("A query is not allowed when an object context has been given",s,o);return null;}if(!Array.isArray(n)){L.error("Invalid query: '"+t+"' does not point to an array",s,o);return null;}m=t+v;v=this.mQueryCache[m];if(v===undefined){this.oResolver=this.oResolver||new R({models:this.oModel});for(i=0;i<n.length;i+=1){this.oResolver.bindObject(t+i);this.oResolver.bindProperty("any",l);try{if(this.oResolver.getAny()){this.mQueryCache[m]=v=i;break;}}finally{this.oResolver.unbindProperty("any");this.oResolver.unbindObject();}}}}n=n[v];t=t+v+"/";}return n;};
h.prototype._mergeMetadata=function(i){var E=this.getODataEntityContainer(),m=U.getChildAnnotations(i.annotations,E.namespace+"."+E.name,true),j=E.entitySet.length,s=this.oModel.getObject("/dataServices/schema"),t=this;i.entitySets.forEach(function(k){var l,S,T=k.entityType,n=T.slice(0,T.lastIndexOf("."));if(!t.getODataEntitySet(k.name)){E.entitySet.push(JSON.parse(JSON.stringify(k)));if(!t.getODataEntityType(T)){l=t.oMetadata._getEntityTypeByName(T);S=U.getSchema(s,n);S.entityType.push(JSON.parse(JSON.stringify(l)));U.visitParents(S,i.annotations,"entityType",U.visitEntityType,S.entityType.length-1);}}});U.visitChildren(E.entitySet,m,"EntitySet",s,null,j);};
h.prototype._sendBundledRequest=function(){var Q=this.mQName2PendingRequest,j=Object.keys(Q),t=this;if(!j.length){return;}this.mQName2PendingRequest={};j=j.sort();j.forEach(function(s,i){j[i]=encodeURIComponent(s);});this.oODataModelInterface.addAnnotationUrl("$metadata?sap-value-list="+j.join(",")).then(function(i){var s;t._mergeMetadata(i);for(s in Q){try{Q[s].resolve(i);}catch(E){Q[s].reject(E);}}},function(E){var s;for(s in Q){Q[s].reject(E);}});};
h.prototype.bindContext=function(s,i,m){return new b(this,s,i,m);};
h.prototype.bindList=function(s,i,S,j,m){return new O(this,s,i,S,j,m);};
h.prototype.bindProperty=function(s,i,m){return new d(this,s,i,m);};
h.prototype.bindTree=function(s,i,j,m){return new e(this,s,i,j,m);};
h.prototype.destroy=function(){f.prototype.destroy.apply(this,arguments);return this.oModel&&this.oModel.destroy.apply(this.oModel,arguments);};
h.prototype.getMetaContext=function(s){var A,E,i,j,m,n,k,l,Q;function t(S){var u=S.indexOf("(");return u>=0?S.slice(0,u):S;}if(!s){return null;}l=s.split("/");if(l[0]!==""){throw new Error("Not an absolute path: "+s);}l.shift();k=t(l[0]);E=this.getODataEntitySet(k);if(E){Q=E.entityType;}else{j=this.getODataFunctionImport(k);if(j){if(l.length===1){m=this.getODataFunctionImport(k,true);}Q=j.returnType;if(Q.lastIndexOf("Collection(",0)===0){Q=Q.slice(11,-1);}}else{throw new Error("Entity set or function import not found: "+k);}}l.shift();while(l.length){i=this.getODataEntityType(Q);if(i){n=t(l[0]);A=this.getODataAssociationEnd(i,n);}else{i=this.getODataComplexType(Q);}if(A){Q=A.type;if(A.multiplicity==="1"&&n!==l[0]){throw new Error("Multiplicity is 1: "+l[0]);}l.shift();}else{m=this.getODataProperty(i,l,true);if(l.length){throw new Error("Property not found: "+l.join("/"));}break;}}m=m||this.getODataEntityType(Q,true);return this.createBindingContext(m);};
h.prototype.getODataAssociationEnd=function(E,n){var N=E?U.findObject(E.navigationProperty,n):null,A=N?U.getObject(this.oModel,"association",N.relationship):null,i=A?U.findObject(A.end,N.toRole,"role"):null;return i;};
h.prototype.getODataAssociationSetEnd=function(E,n){var A,i=null,j=this.getODataEntityContainer(),N=E?U.findObject(E.navigationProperty,n):null;if(j&&N){A=U.findObject(j.associationSet,N.relationship,"association");i=A?U.findObject(A.end,N.toRole,"role"):null;}return i;};
h.prototype.getODataComplexType=function(Q,A){return U.getObject(this.oModel,"complexType",Q,A);};
h.prototype.getODataEntityContainer=function(A){var v=A?undefined:null,s=this.oModel.getObject("/dataServices/schema");if(s){s.forEach(function(S,i){var j=U.findIndex(S.entityContainer,"true","isDefaultEntityContainer");if(j>=0){v=A?"/dataServices/schema/"+i+"/entityContainer/"+j:S.entityContainer[j];return false;}});if(!v&&s.length===1&&s[0].entityContainer&&s[0].entityContainer.length===1){v=A?"/dataServices/schema/0/entityContainer/0":s[0].entityContainer[0];}}return v;};
h.prototype.getODataEntitySet=function(n,A){return U.getFromContainer(this.getODataEntityContainer(),"entitySet",n,A);};
h.prototype.getODataEntityType=function(Q,A){return U.getObject(this.oModel,"entityType",Q,A);};
h.prototype.getODataFunctionImport=function(n,A){var i=n&&n.indexOf('/')>=0?n.split('/'):undefined,E=i?U.getObject(this.oModel,"entityContainer",i[0]):this.getODataEntityContainer();return U.getFromContainer(E,"functionImport",i?i[1]:n,A);};
h.prototype.getODataProperty=function(t,n,A){var i,j=Array.isArray(n)?n:[n],k=null,s;while(t&&j.length){i=U.findIndex(t.property,j[0]);if(i<0){break;}j.shift();k=t.property[i];s=t.$path+"/property/"+i;if(j.length){t=this.getODataComplexType(k.type);}}return A?s:k;};
h.prototype.getODataValueLists=function(i){var j=false,m,s=i.getPath(),k=this.mContext2Promise[s],t=this;if(k){return k;}m=r.exec(s);if(!m){throw new Error("Unsupported property context with path "+s);}k=new Promise(function(l,n){var u=i.getObject(),Q,v=U.getValueLists(u);if(!(""in v)&&u["sap:value-list"]&&t.oODataModelInterface.addAnnotationUrl){j=true;Q=t.oModel.getObject(m[2]).namespace+"."+t.oModel.getObject(m[1]).name;t.mQName2PendingRequest[Q+"/"+u.name]={resolve:function(w){q.extend(u,(w.annotations.propertyAnnotations[Q]||{})[u.name]);v=U.getValueLists(u);if(q.isEmptyObject(v)){n(new Error("No value lists returned for "+s));}else{delete t.mContext2Promise[s];l(v);}},reject:n};setTimeout(t._sendBundledRequest.bind(t),0);}else{l(v);}});if(j){this.mContext2Promise[s]=k;}return k;};
h.prototype.getProperty=function(){return this._getObject.apply(this,arguments);};
h.prototype.isList=function(){return this.oModel.isList.apply(this.oModel,arguments);};
h.prototype.loaded=function(){return this.oLoadedPromise;};
h.prototype.refresh=function(){throw new Error("Unsupported operation: ODataMetaModel#refresh");};
h.prototype.setLegacySyntax=function(l){if(l){throw new Error("Legacy syntax not supported by ODataMetaModel");}};
h.prototype.setProperty=function(){throw new Error("Unsupported operation: ODataMetaModel#setProperty");};
return h;});
sap.ui.predefine('sap/ui/model/odata/ODataMetadata',["./_ODataMetaModelUtils","sap/base/assert","sap/base/Log","sap/base/util/each","sap/base/util/uid","sap/ui/base/EventProvider","sap/ui/core/cache/CacheManager","sap/ui/thirdparty/datajs","sap/ui/thirdparty/jquery"],function(U,a,L,e,u,E,C,O,q){"use strict";var c="sap.ui.model.odata.ODataMetadata";
var b=E.extend("sap.ui.model.odata.ODataMetadata",{
constructor:function(m,p){E.apply(this,arguments);this.bLoaded=false;this.bFailed=false;this.mEntityTypes={};this.mRequestHandles={};this.sUrl=m;this.bAsync=p.async;this.sUser=p.user;this.bWithCredentials=p.withCredentials;this.sPassword=p.password;this.mHeaders=p.headers;this.sCacheKey=p.cacheKey;this.oLoadEvent=null;this.oFailedEvent=null;this.oMetadata=null;this.bMessageScopeSupported=false;this.mNamespaces=p.namespaces||{sap:"http://www.sap.com/Protocols/SAPData",m:"http://schemas.microsoft.com/ado/2007/08/dataservices/metadata","":"http://schemas.microsoft.com/ado/2007/06/edmx"};var t=this;this.pLoadedWithReject=new Promise(function(r,d){t.fnResolve=r;t.fnReject=d;});this.pLoaded=this.pLoadedWithReject.catch(function(o){return new Promise(function(r,d){t.fnResolve=r;});});function w(p){C.set(t.sCacheKey,JSON.stringify({metadata:t.oMetadata,params:p}));}function l(o){L.error("[ODataMetadata] initial loading of metadata failed");if(o&&o.message){L.error("Error: "+o.message);}}if(this.sCacheKey){C.get(this.sCacheKey).then(function(M){if(M){var o=JSON.parse(M);this.oMetadata=o.metadata;this._handleLoaded(this.oMetadata,o.params,false);}else{this._loadMetadata().then(w).catch(l);}}.bind(this)).catch(l);}else{this._loadMetadata().catch(l);}},
metadata:{publicMethods:["getServiceMetadata","attachFailed","detachFailed","attachLoaded","detachLoaded","refresh"]}
});
b.prototype._setNamespaces=function(n){this.mNamespaces=n;};
b.prototype._handleLoaded=function(m,p,s){var d=[];this.oMetadata=this.oMetadata?this.merge(this.oMetadata,m,d):m;this.oRequestHandle=null;p.entitySets=d;this.fnResolve(p);if(this.bAsync&&!s){this.fireLoaded(this);}else if(!this.bAsync&&!s){this.bLoaded=true;this.bFailed=false;this.oLoadEvent=setTimeout(this.fireLoaded.bind(this,p),0);}};
b.prototype._loadMetadata=function(s,S){var t=this;s=s||this.sUrl;var r=this._createRequest(s);return new Promise(function(d,f){var R;function _(m,o){if(!m||!m.dataServices){var p={message:"Invalid metadata document",request:r,response:o};h(p);return;}t.sMetadataBody=o.body;t.oRequestHandle=null;var P={metadataString:t.sMetadataBody};var l=o.headers["Last-Modified"];if(l){P.lastModified=l;}var i=o.headers["eTag"];if(i){P.eTag=i;}t._handleLoaded(m,P,S);d(P);}function h(o){var p={message:o.message,request:o.request,response:o.response};if(o.response){p.statusCode=o.response.statusCode;p.statusText=o.response.statusText;p.responseText=o.response.body;}if(R&&R.bSuppressErrorHandlerCall){return;}if(t.bAsync){delete t.mRequestHandles[R.id];}f(p);t.fnReject(p);if(t.bAsync&&!S){t.fireFailed(p);}else if(!t.bAsync&&!S){t.bFailed=true;t.oFailedEvent=setTimeout(t.fireFailed.bind(t,p),0);}}R=O.request(r,_,h,O.metadataHandler);if(t.bAsync){R.id=u();t.mRequestHandles[R.id]=R;}});};
b.prototype.refresh=function(){return this._loadMetadata();};
b.prototype.getServiceMetadata=function(){return this.oMetadata;};
b.prototype.isLoaded=function(){return this.bLoaded;};
b.prototype.loaded=function(r){return r?this.pLoadedWithReject:this.pLoaded;};
b.prototype.isFailed=function(){return this.bFailed;};
b.prototype.fireLoaded=function(p){this.bLoaded=true;this.bFailed=false;this.fireEvent("loaded",p);L.debug(this+" - loaded was fired");return this;};
b.prototype.attachLoaded=function(d,f,l){this.attachEvent("loaded",d,f,l);return this;};
b.prototype.detachLoaded=function(f,l){this.detachEvent("loaded",f,l);return this;};
b.prototype.fireFailed=function(p){this.bFailed=true;this.fireEvent("failed",p);return this;};
b.prototype.attachFailed=function(d,f,l){this.attachEvent("failed",d,f,l);return this;};
b.prototype.detachFailed=function(f,l){this.detachEvent("failed",f,l);return this;};
b.prototype._getEntityAssociationEnd=function(o,n){var s;if(!this._checkMetadataLoaded()){return null;}this._mGetEntityAssociationEndCache=this._mGetEntityAssociationEndCache||{};s=o.namespace+"."+o.name+"/"+n;if(this._mGetEntityAssociationEndCache[s]===undefined){var N=o?U.findObject(o.navigationProperty,n):null,A=N?U.getObject(this.oMetadata.dataServices.schema,"association",N.relationship):null,d=A?U.findObject(A.end,N.toRole,"role"):null;this._mGetEntityAssociationEndCache[s]=d;}return this._mGetEntityAssociationEndCache[s];};
function g(s){var m={};for(var i=0;i<s.length;i++){var S=s[i];if(S.entityContainer){for(var j=0;j<S.entityContainer.length;j++){var o=S.entityContainer[j];if(o.entitySet){for(var k=0;k<o.entitySet.length;k++){if(o.entitySet[k].name!=null){m[o.entitySet[k].name]=o.entitySet[k];}}}}}}return m;}
b.prototype._findEntitySetByName=function(n){if(!this.mEntitySets){this.mEntitySets=g(this.oMetadata.dataServices.schema);}return this.mEntitySets[n];};
b.prototype._getEntityTypeByPath=function(p){if(!p){a(undefined,"sPath not defined!");return null;}if(this.mEntityTypes[p]){return this.mEntityTypes[p];}if(!this._checkMetadataLoaded()){return null;}var s=p.replace(/^\/|\/$/g,""),P=s.split("/"),l=P.length,o,d,f,r,t=this;if(P[0].indexOf("(")!=-1){P[0]=P[0].substring(0,P[0].indexOf("("));}if(l>1){o=t._getEntityTypeByPath(P[0]);for(var i=1;i<P.length;i++){if(o){if(P[i].indexOf("(")!=-1){P[i]=P[i].substring(0,P[i].indexOf("("));}r=t._getEntityTypeByNavProperty(o,P[i]);if(r){o=r;}f=o;}}}else{d=this._splitName(this._getEntityTypeName(P[0]));f=this._getObjectMetadata("entityType",d.name,d.namespace);if(f){f.entityType=this._getEntityTypeName(P[0]);}}if(!f){var F=P[P.length-1];var h=this._getFunctionImportMetadata(F,"GET");if(!h){h=this._getFunctionImportMetadata(F,"POST");}if(h&&h.entitySet){f=Object.assign({},this._getEntityTypeByPath(h.entitySet));if(f){f.entityType=this._getEntityTypeName(h.entitySet);f.isFunction=true;}}}if(f){this.mEntityTypes[p]=f;}return f;};
b.prototype._getEntityTypeByName=function(n){var o,t=this,s,N,d;if(!n){a(undefined,"sName not defined!");return null;}d=this._splitName(n);N=d.namespace;s=d.name;if(!this._checkMetadataLoaded()){return null;}if(this.mEntityTypes[n]){o=this.mEntityTypes[n];}else{q.each(this.oMetadata.dataServices.schema,function(i,S){if(S.entityType&&(!N||S.namespace===N)){q.each(S.entityType,function(k,f){if(f.name===s){o=f;t.mEntityTypes[n]=o;o.namespace=S.namespace;return false;}});}});}return o;};
b.prototype._checkMetadataLoaded=function(){if(!this.oMetadata||q.isEmptyObject(this.oMetadata)){a(undefined,"No metadata loaded!");return false;}return true;};
b.prototype._getAnnotation=function(p){var n,P,m,M,o,s,d;P=p.split('/#');M=P[1].split('/');if(!P[0]){o=this._getEntityTypeByName(M[0]);a(o,M[0]+" is not a valid EntityType");if(!o){return;}s=P[1].substr(P[1].indexOf('/')+1);d=this._getPropertyMetadata(o,s);a(d,s+" is not a valid property path");if(!d){return;}m=s.substr(s.indexOf(d.name));m=m.substr(m.indexOf('/')+1);}else{o=this._getEntityTypeByPath(P[0]);a(o,P[0]+" is not a valid path");if(!o){return;}p=P[0].replace(/^\/|\/$/g,"");s=p;while(!d&&s.indexOf("/")>0){s=s.substr(s.indexOf('/')+1);d=this._getPropertyMetadata(o,s);}a(d,s+" is not a valid property path");if(!d){return;}m=M.join('/');}n=this._getAnnotationObject(o,d,m);return n;};
b.prototype._getAnnotationObject=function(o,d,m){var A,p,f,n,s;if(!d){return;}n=d;p=m.split('/');if(p[0].indexOf('.')>-1){return this._getV4AnnotationObject(o,d,p);}else{if(p.length>1){n=n[p[0]];if(!n&&d.extensions){for(var i=0;i<d.extensions.length;i++){var h=d.extensions[i];if(h.name==p[0]){n=h;break;}}}m=p.splice(0,1);f=this._getAnnotationObject(o,n,p.join('/'));}else{if(p[0].indexOf('@')>-1){s=p[0].substr(1);A=s.split(':');f=n[A[0]];if(!f&&n.extensions){for(var i=0;i<n.extensions.length;i++){var h=n.extensions[i];if(h.name===A[1]&&h.namespace===this.mNamespaces[A[0]]){f=h.value;break;}}}}else{A=p[0].split(':');f=n[A[0]];f=n[p[0]];if(!f&&n.extensions){for(var i=0;i<n.extensions.length;i++){var h=n.extensions[i];if(h.name===A[1]&&h.namespace===this.mNamespaces[A[0]]){f=h;break;}}}}}}return f;};
b.prototype._getV4AnnotationObject=function(o,d,p){var A,f=[];if(p.length>1){a(p.length==1,"'"+p.join('/')+"' is not a valid annotation path");return;}var t=o.namespace?o.namespace+".":"";t+=o.name+"/"+d.name;q.each(this.oMetadata.dataServices.schema,function(i,s){if(s.annotations){q.each(s.annotations,function(k,d){if(d.target===t&&!d.qualifier){f.push(d.annotation);return false;}});}});if(f){q.each(f,function(i,h){q.each(h,function(j,k){if(k.term===p[0]){A=k;}});});}return A;};
b.prototype._splitName=function(f){var i={};if(f){var s=f.lastIndexOf(".");i.name=f.substr(s+1);i.namespace=f.substr(0,s);}return i;};
b.prototype._getEntityTypeName=function(s){var d,o;if(s){o=this._findEntitySetByName(s);if(o){d=o.entityType;}}return d;};
b.prototype._getObjectMetadata=function(o,s,n){var d;if(s&&n){q.each(this.oMetadata.dataServices.schema,function(i,S){if(S[o]&&S.namespace===n){q.each(S[o],function(j,f){if(f.name===s){d=f;d.namespace=S.namespace;return false;}});return!d;}});}return d;};
b.prototype.getUseBatch=function(){var d=false;q.each(this.oMetadata.dataServices.schema,function(i,s){if(s.entityContainer){q.each(s.entityContainer,function(k,o){if(o.extensions){q.each(o.extensions,function(l,f){if(f.name==="use-batch"&&f.namespace==="http://www.sap.com/Protocols/SAPData"){d=(typeof f.value==='string')?(f.value.toLowerCase()==='true'):!!f.value;return false;}});}});}});return d;};
b.prototype._getFunctionImportMetadataIterate=function(f,s){var o=[];e(this.oMetadata.dataServices.schema,function(S,d){if(d["entityContainer"]){e(d["entityContainer"],function(i,h){if(h["functionImport"]){e(h["functionImport"],function(F,j){if(f(j)){o.push(j);if(s){return false;}}});}return!(s&&o.length===1);});}return!(s&&o.length===1);});return o;};
b.prototype._getFirstMatchingFunctionImportMetadata=function(f){var o=this._getFunctionImportMetadataIterate(f,true);return o.length===1?o[0]:null;};
b.prototype._getFunctionImportMetadataByName=function(f){if(f.indexOf("/")>-1){f=f.substr(f.indexOf("/")+1);}return this._getFunctionImportMetadataIterate(function(F){return F.name===f;});};
b.prototype._getFunctionImportMetadata=function(f,m){if(f.indexOf("/")>-1){f=f.substr(f.indexOf("/")+1);}return this._getFirstMatchingFunctionImportMetadata(function(F){return F.name===f&&F.httpMethod===m;});};
b.prototype._getEntityTypeByNavProperty=function(m,n){if(!m.navigationProperty){return undefined;}for(var i=0;i<m.navigationProperty.length;++i){var N=m.navigationProperty[i];if(N.name===n){return this._getEntityTypeByNavPropertyObject(N);}}return undefined;};
b.prototype._getEntityTypeByNavPropertyObject=function(n){var t;var A=this._splitName(n.relationship);var m=this._getObjectMetadata("association",A.name,A.namespace);if(m){var d=m.end[0];if(d.role!==n.toRole){d=m.end[1];}var o=this._splitName(d.type);t=this._getObjectMetadata("entityType",o.name,o.namespace);if(t){t.entityType=d.type;}}return t;};
b.prototype._getNavigationPropertyNames=function(o){var n=[];if(o.navigationProperty){q.each(o.navigationProperty,function(k,N){n.push(N.name);});}return n;};
b.prototype._getNavPropertyRefInfo=function(o,p){var n,A,d,f,P,D,h,r,j,s,k,t=this;e(o.navigationProperty,function(i,N){d=t._splitName(N.relationship);A=t._getObjectMetadata("association",d.name,d.namespace);if(!A||!A.referentialConstraint){return;}D=A.referentialConstraint.dependent;j=A.end.find(function(j){return j.role===D.role;});if(j.type!==o.namespace+"."+o.name){return;}h=D.propertyRef.some(function(l){return l.name===p;});if(!h){return;}P=A.referentialConstraint.principal;r=P.role;f=t._getAssociationSetByAssociation(N.relationship);j=f.end.find(function(j){return j.role===r;});s=j.entitySet;k=P.propertyRef.map(function(l){return l.name;});n={name:N.name,entitySet:s,keys:k};});return n;};
b.prototype._getPropertyMetadata=function(o,p){var P,t=this;if(!o){return;}p=p.replace(/^\/|\/$/g,"");var d=p.split("/");q.each(o.property,function(k,f){if(f.name===d[0]){P=f;return false;}});if(d.length>1){if(!P){while(o&&d.length>1){o=this._getEntityTypeByNavProperty(o,d[0]);d.shift();}if(o){P=t._getPropertyMetadata(o,d[0]);}}else if(!P.type.toLowerCase().startsWith("edm.")){var n=this._splitName(P.type);P=this._getPropertyMetadata(this._getObjectMetadata("complexType",n.name,n.namespace),d[1]);}}return P;};
b.prototype.destroy=function(){delete this.oMetadata;var t=this;q.each(this.mRequestHandles,function(k,r){r.bSuppressErrorHandlerCall=true;r.abort();delete t.mRequestHandles[k];});if(!!this.oLoadEvent){clearTimeout(this.oLoadEvent);}if(!!this.oFailedEvent){clearTimeout(this.oFailedEvent);}E.prototype.destroy.apply(this,arguments);};
b.prototype._fillElementCaches=function(){var t=this;if(this._entitySetMap||!this._checkMetadataLoaded()){return;}this._entitySetMap={};this.oMetadata.dataServices.schema.forEach(function(s){(s.entityContainer||[]).forEach(function(m){(m.entitySet||[]).forEach(function(d){var o=t._getEntityTypeByName(d.entityType);o.__navigationPropertiesMap={};(o.navigationProperty||[]).forEach(function(p){o.__navigationPropertiesMap[p.name]=p;});d.__entityType=o;t._entitySetMap[d.entityType]=d;});});});};
b.prototype._createRequest=function(s){var d={"sap-cancel-on-close":true},l={"Accept-Language":sap.ui.getCore().getConfiguration().getLanguageTag()};q.extend(d,this.mHeaders,l);var r={headers:d,requestUri:s,method:'GET',user:this.sUser,password:this.sPassword,async:this.bAsync};if(this.bAsync){r.withCredentials=this.bWithCredentials;}return r;};
b.prototype._getEntitySetByPath=function(s){var o;this._fillElementCaches();o=this._getEntityTypeByPath(s);if(o){return this._entitySetMap[o.entityType];}};
b.prototype._addUrl=function(v){var d=[].concat(v);return Promise.all(d.map(function(s){return this._loadMetadata(s,true);},this));};
b.prototype.merge=function(t,s,d){var f=this;if(this.mEntitySets){delete this.mEntitySets;}q.each(t.dataServices.schema,function(i,T){q.each(s.dataServices.schema,function(j,S){if(S.namespace===T.namespace){if(S.entityType){if(!f.mEntityTypeNames){f.mEntityTypeNames={};T.entityType.map(function(o){f.mEntityTypeNames[o.name]=true;});}T.entityType=!T.entityType?[]:T.entityType;for(var i=0;i<S.entityType.length;i++){if(!(S.entityType[i].name in f.mEntityTypeNames)){T.entityType.push(S.entityType[i]);f.mEntityTypeNames[S.entityType[i].name]=true;}}}if(T.entityContainer&&S.entityContainer){q.each(T.entityContainer,function(k,h){q.each(S.entityContainer,function(l,m){if(m.entitySet){if(m.name===h.name){if(!f.mEntitySetNames){f.mEntitySetNames={};h.entitySet.map(function(o){f.mEntitySetNames[o.name]=true;});}h.entitySet=!h.entitySet?[]:h.entitySet;for(var i=0;i<m.entitySet.length;i++){if(!(m.entitySet[i].name in f.mEntitySetNames)){h.entitySet.push(m.entitySet[i]);f.mEntitySetNames[m.entitySet[i].name]=true;}}m.entitySet.forEach(function(o){d.push(o);});}}});});}if(S.annotations){T.annotations=!T.annotations?[]:T.annotations;T.annotations=T.annotations.concat(S.annotations);}}});});return t;};
b.prototype._getEntitySetByType=function(d){var s=d.namespace+"."+d.name;var S=this.oMetadata.dataServices.schema;for(var i=0;i<S.length;++i){var f=S[i].entityContainer;if(f){for(var n=0;n<f.length;++n){var h=f[n].entitySet;if(h){for(var m=0;m<h.length;++m){if(h[m].entityType===s){return h[m];}}}}}}return null;};
b.prototype._calculateCanonicalPath=function(p){var s,i,P,t;if(p){i=p.lastIndexOf(")");if(i!==-1){t=p.substr(0,i+1);var o=this._getEntitySetByPath(t);if(o){if(o.__entityType.isFunction){s=p;}else{P=p.split("/");if(t==="/"+P[1]){if(!(P[2]in o.__entityType.__navigationPropertiesMap)){s=p;}}else{P=t.split("/");t='/'+o.name+P[P.length-1].substr(P[P.length-1].indexOf("("))+p.substr(i+1);if(t!==p){s=t;}}}}}}return s;};
b.prototype._getAssociationSetByAssociation=function(A){var s=this.oMetadata.dataServices.schema;for(var i=0;i<s.length;++i){var d=s[i].entityContainer;if(d){for(var n=0;n<d.length;++n){var S=d[n].associationSet;if(S){for(var m=0;m<S.length;++m){if(S[m].association===A){return S[m];}}}}}}return null;};
b.prototype._isMessageScopeSupported=function(){var s=this.oMetadata.dataServices.schema,o,d;if(!this.bMessageScopeSupported&&s){for(var i=0;i<s.length;++i){d=s[i].entityContainer;if(d){for(var n=0;n<d.length;++n){o=d[n];if(o.extensions&&Array.isArray(o.extensions)){for(var m=0;m<o.extensions.length;++m){if(o.extensions[m].name==="message-scope-supported"&&o.extensions[m].namespace===this.mNamespaces.sap){if(o.extensions[m].value==="true"){this.bMessageScopeSupported=true;break;}}}}}}}}return this.bMessageScopeSupported;};
b.prototype._isCollection=function(p){var d=false;var i=p.lastIndexOf("/");if(i>0){var s=p.substring(0,i);var o=this._getEntityTypeByPath(s);if(o){var A=this._getEntityAssociationEnd(o,p.substring(i+1));if(A&&A.multiplicity==="*"){d=true;}}}else{d=true;}return d;};
b.prototype._getReducedPath=function(p){var A,i,k,n,N,o,s,S=p.split("/"),d;if(S.length<4){return p;}this._fillElementCaches();for(i=1;i<S.length-2;i+=1){d=this._getEntityTypeByPath(S.slice(0,i+1).join('/'));N=d&&d.__navigationPropertiesMap[S[i+1].split("(")[0]];if(!N){continue;}s=S[i+2].split("(")[0];n=this._getEntityTypeByNavPropertyObject(N);o=n&&n.__navigationPropertiesMap[s];if(!o||N.relationship!==o.relationship){continue;}k=S[i+2].slice(s.length);A=this._getEntityAssociationEnd(n,s);if(A.multiplicity!=="*"||k&&S[i].endsWith(k)){S.splice(i+1,2);return this._getReducedPath(S.join("/"));}}return S.join("/");};
b.prototype.getKeyPropertyNamesByPath=function(p){var A,o,i=p.lastIndexOf("/");if(i>0){o=this._getEntityTypeByPath(p.slice(0,i));if(o){A=this._getEntityAssociationEnd(o,p.slice(i+1).split("(")[0]);o=A?this._getEntityTypeByName(A.type):undefined;}}else{o=this._getEntityTypeByPath(p);}if(o){return o.key.propertyRef.map(function(k){return k.name;});}};
b.prototype._getCanonicalPathOfFunctionImport=function(f,F){var A,m,d,i,k,p,P,h=f.extensions,I="";if(h){for(i=0;i<h.length;i+=1){if(h[i].name==="action-for"){A=h[i].value;break;}}}if(A){d=this._getEntityTypeByName(A);}else if(f.entitySet){d=this._getEntityTypeByPath(f.entitySet);}else if(f.returnType){d=this._getEntityTypeByName(f.returnType);}if(d){m=this._getEntitySetByType(d);if(m&&d.key&&d.key.propertyRef){P=d.key.propertyRef;if(P.length===1){p=P[0].name;if(F[p]){I=F[p];}}else{k=[];for(i=0;i<P.length;i+=1){p=P[i].name;if(F[p]){k.push(p+"="+F[p]);}}I=k.join(",");}return"/"+m.name+"("+I+")";}else if(!m){L.error("Cannot determine path of the EntitySet for the function import '"+f.name+"'",this,c);}else{L.error("Cannot determine keys of the EntityType '"+d.entityType+"' for the function import '"+f.name+"'",this,c);}}return"";};
return b;});
sap.ui.predefine('sap/ui/model/odata/ODataModel',['sap/ui/model/BindingMode','sap/ui/model/Context','sap/ui/model/Model','./ODataUtils','./CountMode','./ODataContextBinding','./ODataListBinding','./ODataMetadata','./ODataPropertyBinding','./ODataTreeBinding','sap/ui/model/FilterProcessor','sap/ui/model/odata/ODataMetaModel','sap/ui/thirdparty/URI','sap/ui/thirdparty/datajs',"sap/base/util/uid","sap/base/util/merge","sap/base/Log","sap/base/assert","sap/base/security/encodeURL","sap/ui/thirdparty/jquery","sap/base/util/isPlainObject"],function(B,C,M,O,a,b,c,d,e,f,F,g,U,h,u,m,L,n,o,q,p){"use strict";
var r=M.extend("sap.ui.model.odata.ODataModel",{
constructor:function(s,j,i,P,H,t,w,l){M.apply(this,arguments);var k,R,v,A=null,x,y,D,S,z,E,G=this;if(typeof(s)==="object"){j=s;s=j.serviceUrl;}if(typeof j==="object"){i=j.user;P=j.password;H=j.headers;t=j.tokenHandling;l=j.loadMetadataAsync;w=j.withCredentials;v=j.maxDataServiceVersion;k=j.useBatch;R=j.refreshAfterChange;A=j.annotationURI;x=j.loadAnnotationsJoined;D=j.defaultCountMode;y=j.metadataNamespaces;S=j.serviceUrlParams;z=j.metadataUrlParams;E=j.skipMetadataAnnotationParsing;j=j.json;}this.oServiceData={};this.sDefaultBindingMode=B.OneWay;this.mSupportedBindingModes={"OneWay":true,"OneTime":true,"TwoWay":true};this.mUnsupportedFilterOperators={"Any":true,"All":true};this.bCountSupported=true;this.bJSON=j;this.bCache=true;this.aPendingRequestHandles=[];this.oRequestQueue={};this.aBatchOperations=[];this.oHandler;this.bTokenHandling=t!==false;this.bWithCredentials=w===true;this.bUseBatch=k===true;this.bRefreshAfterChange=R!==false;this.sMaxDataServiceVersion=v;this.bLoadMetadataAsync=!!l;this.bLoadAnnotationsJoined=x===undefined?true:x;this.sAnnotationURI=A;this.sDefaultCountMode=D||a.Both;this.oMetadataLoadEvent=null;this.oMetadataFailedEvent=null;this.bSkipMetadataAnnotationParsing=E;this.oHeaders={};this.setHeaders(H);this.oData={};this.oMetadata=null;this.oAnnotations=null;this.aUrlParams=[];if(s.indexOf("?")==-1){this.sServiceUrl=s;}else{var I=s.split("?");this.sServiceUrl=I[0];if(I[1]){this.aUrlParams.push(I[1]);}}if(sap.ui.getCore().getConfiguration().getStatistics()){this.aUrlParams.push("sap-statistics=true");}this.sServiceUrl=this.sServiceUrl.replace(/\/$/,"");var J=this._createRequestUrl("$metadata",undefined,z);if(!r.mServiceData[J]){r.mServiceData[J]={};}this.oServiceData=r.mServiceData[J];if(this.bTokenHandling&&this.oServiceData.securityToken){this.oHeaders["x-csrf-token"]=this.oServiceData.securityToken;}this.sUser=i;this.sPassword=P;this.oHeaders["Accept-Language"]=sap.ui.getCore().getConfiguration().getLanguageTag();if(!this.oServiceData.oMetadata){this.oServiceData.oMetadata=new d(J,{async:this.bLoadMetadataAsync,user:this.sUser,password:this.sPassword,headers:this.mCustomHeaders,namespaces:y,withCredentials:this.bWithCredentials});}this.oMetadata=this.oServiceData.oMetadata;this.pAnnotationsLoaded=this.oMetadata.loaded();if(this.sAnnotationURI||!this.bSkipMetadataAnnotationParsing){var K=this._getAnnotationParser();if(!this.bSkipMetadataAnnotationParsing){if(!this.bLoadMetadataAsync){this.addAnnotationXML(this.oMetadata.sMetadataBody,!!this.sAnnotationURI);}else{this.pAnnotationsLoaded=this.oMetadata.loaded().then(function(N,Q){if(this.bDestroyed){return Promise.reject();}return this.addAnnotationXML(Q["metadataString"],N);}.bind(this,!!this.sAnnotationURI));}}if(this.sAnnotationURI){if(this.bLoadMetadataAsync){this.pAnnotationsLoaded=this.pAnnotationsLoaded.then(K.addUrl.bind(K,this.sAnnotationURI));}else{this.pAnnotationsLoaded=Promise.all([this.pAnnotationsLoaded,K.addUrl(this.sAnnotationURI)]);}}}if(S){this.aUrlParams=this.aUrlParams.concat(O._createUrlParamsArray(S));}this.onMetadataLoaded=function(N){G._initializeMetadata();G.initialize();};this.onMetadataFailed=function(N){G.fireMetadataFailed(N.getParameters());};if(!this.oMetadata.isLoaded()){this.oMetadata.attachLoaded(this.onMetadataLoaded);this.oMetadata.attachFailed(this.onMetadataFailed);}if(this.oMetadata.isFailed()){this.refreshMetadata();}if(this.oMetadata.isLoaded()){this._initializeMetadata(true);}if(this.bJSON){if(this.sMaxDataServiceVersion==="3.0"){this.oHeaders["Accept"]="application/json;odata=fullmetadata";}else{this.oHeaders["Accept"]="application/json";}this.oHandler=h.jsonHandler;}else{this.oHeaders["Accept"]="application/atom+xml,application/atomsvc+xml,application/xml";this.oHandler=h.atomHandler;}this.oHeaders["MaxDataServiceVersion"]="2.0";if(this.sMaxDataServiceVersion){this.oHeaders["MaxDataServiceVersion"]=this.sMaxDataServiceVersion;}this.oHeaders["DataServiceVersion"]="2.0";},
metadata:{publicMethods:["create","remove","update","submitChanges","getServiceMetadata","read","hasPendingChanges","refresh","refreshMetadata","resetChanges","isCountSupported","setCountSupported","setDefaultCountMode","getDefaultCountMode","forceNoCache","setProperty","getSecurityToken","refreshSecurityToken","setHeaders","getHeaders","setUseBatch"]}
});
r.M_EVENTS={RejectChange:"rejectChange",MetadataLoaded:"metadataLoaded",MetadataFailed:"metadataFailed",AnnotationsLoaded:"annotationsLoaded",AnnotationsFailed:"annotationsFailed"};r.mServiceData={};
r.prototype.fireRejectChange=function(P){this.fireEvent("rejectChange",P);return this;};
r.prototype.attachRejectChange=function(D,i,l){this.attachEvent("rejectChange",D,i,l);return this;};
r.prototype.detachRejectChange=function(i,l){this.detachEvent("rejectChange",i,l);return this;};
r.prototype._initializeMetadata=function(D){var t=this;this.bUseBatch=this.bUseBatch||this.oMetadata.getUseBatch();var i=function(j){if(!!j){t.metadataLoadEvent=setTimeout(i.bind(t),0);}else{if(t.oMetadata){t.fireMetadataLoaded({metadata:t.oMetadata});L.debug("ODataModel fired metadataloaded");}}};if(this.sAnnotationURI&&this.bLoadAnnotationsJoined){if(this.oAnnotations&&(this.oAnnotations.bInitialized||this.oAnnotations.isFailed())){i(!this.bLoadMetadataAsync);}else{this.oAnnotations.attachEventOnce("loaded",function(){i(true);});}}else{i(D);}};
r.prototype.fireAnnotationsLoaded=function(P){if(!this.bLoadMetadataAsync){setTimeout(this.fireEvent.bind(this,"annotationsLoaded",P),0);}else{this.fireEvent("annotationsLoaded",P);}return this;};
r.prototype.attachAnnotationsLoaded=function(D,i,l){this.attachEvent("annotationsLoaded",D,i,l);return this;};
r.prototype.detachAnnotationsLoaded=function(i,l){this.detachEvent("annotationsLoaded",i,l);return this;};
r.prototype.fireAnnotationsFailed=function(P){if(!this.bLoadMetadataAsync){setTimeout(this.fireEvent.bind(this,"annotationsFailed",P),0);}else{this.fireEvent("annotationsFailed",P);}L.debug("ODataModel fired annotationsFailed");return this;};
r.prototype.attachAnnotationsFailed=function(D,i,l){this.attachEvent("annotationsFailed",D,i,l);return this;};
r.prototype.detachAnnotationsFailed=function(i,l){this.detachEvent("annotationsFailed",i,l);return this;};
r.prototype.fireMetadataLoaded=function(P){this.fireEvent("metadataLoaded",P);return this;};
r.prototype.attachMetadataLoaded=function(D,i,l){this.attachEvent("metadataLoaded",D,i,l);return this;};
r.prototype.detachMetadataLoaded=function(i,l){this.detachEvent("metadataLoaded",i,l);return this;};
r.prototype.fireMetadataFailed=function(P){this.fireEvent("metadataFailed",P);return this;};
r.prototype.attachMetadataFailed=function(D,i,l){this.attachEvent("metadataFailed",D,i,l);return this;};
r.prototype.detachMetadataFailed=function(i,l){this.detachEvent("metadataFailed",i,l);return this;};
r.prototype.refreshMetadata=function(){if(this.oMetadata&&this.oMetadata.refresh){this.oMetadata.refresh();}};
r.prototype._createRequestUrl=function(P,i,j,k,l){var s,R,t,v="";if(P&&P.indexOf('?')!=-1){t=P.substr(P.indexOf('?')+1);P=P.substr(0,P.indexOf('?'));}R=this._normalizePath(P,i);if(!k){v=this.sServiceUrl+R;}else{v=R.substr(R.indexOf('/')+1);}s=O._createUrlParamsArray(j);if(this.aUrlParams){s=s.concat(this.aUrlParams);}if(t){s.push(t);}if(s.length>0){v+="?"+s.join("&");}if(l===undefined){l=true;}if(l===false){var w=q.now();var x=v.replace(/([?&])_=[^&]*/,"$1_="+w);v=x+((x===v)?(/\?/.test(v)?"&":"?")+"_="+w:"");}return v;};
r.prototype._loadData=function(P,i,s,E,j,H,k){var R,l,t=this;function _(D,z){var A=D,G={};if(z.statusCode==204){if(s){s(null);}if(k){k(null);}t.fireRequestCompleted({url:l.requestUri,type:"GET",async:l.async,info:"Accept headers:"+t.oHeaders["Accept"],infoObject:{acceptHeaders:t.oHeaders["Accept"]},success:true});return;}if(!A){L.fatal("The following problem occurred: No data was retrieved by service: "+z.requestUri);t.fireRequestCompleted({url:l.requestUri,type:"GET",async:l.async,info:"Accept headers:"+t.oHeaders["Accept"],infoObject:{acceptHeaders:t.oHeaders["Accept"]},success:false});return false;}if(t.bUseBatch){var I=t._getBatchErrors(D);if(I.length>0){v(I[0]);return false;}if(A.__batchResponses&&A.__batchResponses.length>0){A=A.__batchResponses[0].data;}else{L.fatal("The following problem occurred: No data was retrieved by service: "+z.requestUri);}}x=x.concat(A.results);if(A.__next){var J=new U(A.__next);l.requestUri=J.absoluteTo(z.requestUri).toString();w(l);}else{if(A.results){var V,K;for(K in x){V=x[K];if(x===V){continue;}A.results[K]=V;}}if(A.results&&!Array.isArray(A.results)){A=A.results;}t._importData(A,G);if(t.sChangeKey&&G){var N=t.sChangeKey.substr(t.sChangeKey.lastIndexOf('/')+1);if(G[N]){delete t.oRequestQueue[t.sChangeKey];t.sChangeKey=null;}}if(s){s(A);}t.checkUpdate(false,false,G);if(k){k(A);}t.fireRequestCompleted({url:l.requestUri,type:"GET",async:l.async,info:"Accept headers:"+t.oHeaders["Accept"],infoObject:{acceptHeaders:t.oHeaders["Accept"]},success:true});}}function v(z){if(t.bTokenHandling&&z.response){var T=t._getHeader("x-csrf-token",z.response.headers);if(!l.bTokenReset&&z.response.statusCode=='403'&&T&&T.toLowerCase()=="required"){t.resetSecurityToken();l.bTokenReset=true;w();return;}}var A=t._handleError(z);if(E){E(z,R&&R.bAborted);}t.fireRequestCompleted({url:l.requestUri,type:"GET",async:l.async,info:"Accept headers:"+t.oHeaders["Accept"],infoObject:{acceptHeaders:t.oHeaders["Accept"]},success:false,errorobject:A});if(!R||!R.bAborted){A.url=l.requestUri;t.fireRequestFailed(A);}}function w(){if(t.bUseBatch){t.updateSecurityToken();var z=U.parse(l.requestUri).query;var A=t._createRequestUrl(P,null,z,t.bUseBatch);l=t._createRequest(A,"GET",true);if(t.bTokenHandling){delete l.headers["x-csrf-token"];}var D=t._createBatchRequest([l],true);R=t._request(D,_,v,h.batchHandler,undefined,t.getServiceMetadata());}else{R=t._request(l,_,v,t.oHandler,undefined,t.getServiceMetadata());}if(H){var W={abort:function(){R.bAborted=true;R.abort();}};H(W);}}var x=[];var y=this._createRequestUrl(P,null,i,null,j||this.bCache);l=this._createRequest(y,"GET",true);if(t.bTokenHandling){delete l.headers["x-csrf-token"];}this.fireRequestSent({url:l.requestUri,type:"GET",async:l.async,info:"Accept headers:"+this.oHeaders["Accept"],infoObject:{acceptHeaders:this.oHeaders["Accept"]}});w();};
r.prototype._importData=function(D,k){var t=this,l,K,R,E;if(D.results){l=[];q.each(D.results,function(i,j){l.push(t._importData(j,k));});return l;}else{K=this._getKey(D);E=this.oData[K];if(!E){E=D;this.oData[K]=E;}q.each(D,function(N,P){if(P&&(P.__metadata&&P.__metadata.uri||P.results)&&!P.__deferred){R=t._importData(P,k);if(Array.isArray(R)){E[N]={__list:R};}else{E[N]={__ref:R};}}else if(!P||!P.__deferred){E[N]=P;}});k[K]=true;return K;}};
r.prototype._removeReferences=function(D){var t=this,l;if(D.results){l=[];q.each(D.results,function(i,j){l.push(t._removeReferences(j));});return l;}else{q.each(D,function(P,i){if(i){if(i["__ref"]||i["__list"]){delete D[P];}}});return D;}};
r.prototype._restoreReferences=function(D){var t=this,l,R=[];if(D.results){l=[];q.each(D.results,function(i,j){l.push(t._restoreReferences(j));});return l;}else{q.each(D,function(P,i){if(i&&i["__ref"]){var k=t._getObject("/"+i["__ref"]);n(k,"ODataModel inconsistent: "+i["__ref"]+" not found!");if(k){delete i["__ref"];D[P]=k;t._restoreReferences(k);}}else if(i&&i["__list"]){q.each(i["__list"],function(j,E){var k=t._getObject("/"+i["__list"][j]);n(k,"ODataModel inconsistent: "+i["__list"][j]+" not found!");if(k){R.push(k);t._restoreReferences(k);}});delete i["__list"];i.results=R;R=[];}});return D;}};
r.prototype.removeData=function(){this.oData={};};
r.prototype.initialize=function(){var i=this.getBindings();q.each(i,function(I,j){j.initialize();});};
r.prototype.refresh=function(i,R){if(R){this.removeData();}this._refresh(i);};
r.prototype._refresh=function(i,j,E){var k=this.getBindings();q.each(k,function(I,l){l.refresh(i,j,E);});};
r.prototype.checkUpdate=function(i,A,j,k){if(A){if(!this.sUpdateTimer){this.sUpdateTimer=setTimeout(function(){this.checkUpdate(i,false,j);}.bind(this),0);}return;}if(this.sUpdateTimer){clearTimeout(this.sUpdateTimer);this.sUpdateTimer=null;}var l=this.getBindings();q.each(l,function(I,s){if(!k||this.isMetaModelPath(s.getPath())){s.checkUpdate(i,j);}}.bind(this));};
r.prototype.bindProperty=function(P,i,j){var k=new e(this,P,i,j);return k;};
r.prototype.bindList=function(P,i,s,j,k){var l=new c(this,P,i,s,j,k);return l;};
r.prototype.bindTree=function(P,i,j,k){var l=new f(this,P,i,j,k);return l;};
r.prototype.createBindingContext=function(P,i,j,k,R){var R=!!R,s=this.resolve(P,i);if(typeof i=="function"){k=i;i=null;}if(typeof j=="function"){k=j;j=null;}if(!s){if(k){k(null);}return null;}var D=this._getObject(P,i),K,N,t=this;if(!R){R=this._isReloadNeeded(s,D,j);}if(!R){K=this._getKey(D);N=this.getContext('/'+K);if(k){k(N);}return N;}if(k){var I=!P.startsWith("/");if(s){var l=[],v=this.createCustomParams(j);if(v){l.push(v);}this._loadData(s,l,function(D){K=D?t._getKey(D):undefined;if(K&&i&&I){var w=i.getPath();w=w.substr(1);if(t.oData[w]){t.oData[w][P]={__ref:K};}}N=t.getContext('/'+K);k(N);},function(){k(null);});}else{k(null);}}};
r.prototype._isReloadNeeded=function(s,D,P){var N,j=[],S,k=[];if(!s){return false;}if(!D){return true;}if(P&&P["expand"]){N=P["expand"].replace(/\s/g,"");j=N.split(',');}if(j){for(var i=0;i<j.length;i++){var l=j[i].indexOf("/");if(l!==-1){var t=j[i].slice(0,l);var v=j[i].slice(l+1);j[i]=[t,v];}}}for(var i=0;i<j.length;i++){var w=j[i];if(Array.isArray(w)){var x=D[w[0]];var y=w[1];if(!x||(x&&x.__deferred)){return true;}else{if(x){if(x.__list&&x.__list.length>0){for(var z=0;z<x.__list.length;z++){var A="/"+x.__list[z];var E=this.getObject(A);var R=this._isReloadNeeded(A,E,{expand:y});if(R){return true;}}}else if(x.__ref){var A="/"+x.__ref;var E=this.getObject(A);var R=this._isReloadNeeded(A,E,{expand:y});if(R){return true;}}}}}else{if(D[w]===undefined||(D[w]&&D[w].__deferred)){return true;}}}if(P&&P["select"]){S=P["select"].replace(/\s/g,"");k=S.split(',');}for(var i=0;i<k.length;i++){if(D[k[i]]===undefined){return true;}}if(k.length==0){var G=this.oMetadata._getEntityTypeByPath(s);if(!G){return false;}else{for(var i=0;i<G.property.length;i++){if(D[G.property[i].name]===undefined){return true;}}}}return false;};
r.prototype.destroyBindingContext=function(i){};
r.prototype.createCustomParams=function(P){var i=[],j,s={expand:true,select:true};for(var N in P){if(N in s){i.push("$"+N+"="+o(P[N]));}if(N=="custom"){j=P[N];for(var N in j){if(N.indexOf("$")==0){L.warning("Trying to set OData parameter "+N+" as custom query option!");}else{i.push(N+"="+o(j[N]));}}}}return i.join("&");};
r.prototype.bindContext=function(P,i,j){var k=new b(this,P,i,j);return k;};
r.prototype.setCountSupported=function(i){this.bCountSupported=i;};
r.prototype.isCountSupported=function(){return this.bCountSupported;};
r.prototype.setDefaultCountMode=function(s){this.sDefaultCountMode=s;};
r.prototype.getDefaultCountMode=function(){return this.sDefaultCountMode;};
r.prototype._getKey=function(i,D){var k,s;if(i instanceof C){k=i.getPath().substr(1);}else if(i&&i.__metadata&&i.__metadata.uri){s=i.__metadata.uri;k=s.substr(s.lastIndexOf("/")+1);}if(D){k=decodeURIComponent(k);}return k;};
r.prototype.getKey=function(i,D){return this._getKey(i,D);};
r.prototype.createKey=function(s,k,D){var E=this.oMetadata._getEntityTypeByPath(s),K=s,t=this,N,v,P;n(E,"Could not find entity type of collection \""+s+"\" in service metadata!");K+="(";if(E.key.propertyRef.length==1){N=E.key.propertyRef[0].name;n(N in k,"Key property \""+N+"\" is missing in object!");P=this.oMetadata._getPropertyMetadata(E,N);v=O.formatValue(k[N],P.type);K+=D?v:encodeURIComponent(v);}else{q.each(E.key.propertyRef,function(i,j){if(i>0){K+=",";}N=j.name;n(N in k,"Key property \""+N+"\" is missing in object!");P=t.oMetadata._getPropertyMetadata(E,N);v=O.formatValue(k[N],P.type);K+=N;K+="=";K+=D?v:encodeURIComponent(v);});}K+=")";return K;};
r.prototype.getProperty=function(P,i,I){var v=this._getObject(P,i);if(I==null||I==undefined){return v;}if(!p(v)){return v;}v=m({},v);if(I==true){return this._restoreReferences(v);}else{return this._removeReferences(v);}};
r.prototype._getObject=function(P,i){var N=this.isLegacySyntax()?this.oData:null,R=this.resolve(P,i),s,D,j,k,K,l;if(this.oMetadata&&R&&R.indexOf('/#')>-1){if(this.isMetaModelPath(R)){s=R.indexOf('/##');l=this.getMetaModel();if(!this.bMetaModelLoaded){return null;}D=R.substr(0,s);j=R.substr(s+3);k=l.getMetaContext(D);N=l.getProperty(j,k);}else{N=this.oMetadata._getAnnotation(R);}}else{if(i){K=i.getPath();K=K.substr(1);N=this.oData[K];}if(!P){return N;}var t=P.split("/"),I=0;if(!t[0]){N=this.oData;I++;}while(N&&t[I]){N=N[t[I]];if(N){if(N.__ref){N=this.oData[N.__ref];}else if(N.__list){N=N.__list;}else if(N.__deferred){N=undefined;}}I++;}}return N;};
r.prototype.updateSecurityToken=function(){if(this.bTokenHandling){if(!this.oServiceData.securityToken){this.refreshSecurityToken();}if(this.bTokenHandling){this.oHeaders["x-csrf-token"]=this.oServiceData.securityToken;}}};
r.prototype.resetSecurityToken=function(){delete this.oServiceData.securityToken;delete this.oHeaders["x-csrf-token"];};
r.prototype.getSecurityToken=function(){var t=this.oServiceData.securityToken;if(!t){this.refreshSecurityToken();t=this.oServiceData.securityToken;}return t;};
r.prototype.refreshSecurityToken=function(s,E,A){var t=this,i,T;A=A===true;i=this._createRequestUrl("/");var R=this._createRequest(i,"GET",A);R.headers["x-csrf-token"]="Fetch";function _(D,k){if(k){T=t._getHeader("x-csrf-token",k.headers);if(T){t.oServiceData.securityToken=T;t.oHeaders["x-csrf-token"]=T;}else{t.resetSecurityToken();t.bTokenHandling=false;}}if(s){s(D,k);}}function j(k){t.resetSecurityToken();t.bTokenHandling=false;t._handleError(k);if(E){E(k);}}return this._request(R,_,j,undefined,undefined,this.getServiceMetadata());};
r.prototype._submitRequest=function(R,i,s,E,H,I){var t=this,j,k={};function _(D,w){if(i&&H){var x=t._getBatchErrors(D);if(x.length>0){l(x[0]);return false;}if(D.__batchResponses&&D.__batchResponses.length>0){j=D.__batchResponses[0].data;if(!j&&D.__batchResponses[0].__changeResponses){j=D.__batchResponses[0].__changeResponses[0].data;}}D=j;}if(I){if(D&&D.__batchResponses){q.each(D.__batchResponses,function(y,w){if(w&&w.data){t._importData(w.data,k);}});}}t._handleETag(R,w,i);t._updateRequestQueue(R,i);if(t._isRefreshNeeded(R,w)){t._refresh(false,R.keys,R.entityTypes);}if(s){s(D,w);}}function l(w){if(t.bTokenHandling&&w.response){var T=t._getHeader("x-csrf-token",w.response.headers);if(!R.bTokenReset&&w.response.statusCode=='403'&&T&&T.toLowerCase()=="required"){t.resetSecurityToken();R.bTokenReset=true;v();return;}}t._handleError(w);if(E){E(w);}}function v(){if(t.bTokenHandling){delete R.headers["x-csrf-token"];}if(t.bTokenHandling&&R.method!=="GET"){t.updateSecurityToken();if(t.bTokenHandling){R.headers["x-csrf-token"]=t.oServiceData.securityToken;}}if(i){return t._request(R,_,l,h.batchHandler,undefined,t.getServiceMetadata());}else{return t._request(R,_,l,t.oHandler,undefined,t.getServiceMetadata());}}return v();};
r.prototype._createBatchRequest=function(s,A){var t,R,v={},P={},K={},E={};P.__batchRequests=s;t=this.sServiceUrl+"/$batch";if(this.aUrlParams.length>0){t+="?"+this.aUrlParams.join("&");}q.extend(v,this.mCustomHeaders,this.oHeaders);delete v["Content-Type"];R={headers:v,requestUri:t,method:"POST",data:P,user:this.sUser,password:this.sPassword,async:A};if(A){R.withCredentials=this.bWithCredentials;}q.each(s,function(i,w){if(w["__changeRequests"]){q.each(w["__changeRequests"],function(j,x){if(x.keys&&x.method!="POST"){q.each(x.keys,function(k,l){K[k]=l;});}else if(x.entityTypes&&x.method=="POST"){q.each(x.entityTypes,function(l,k){E[l]=k;});}});}});R.keys=K;R.entityTypes=E;return R;};
r.prototype._handleETag=function(R,k,l){var s,E,t,v,w,x;if(l){w=R.data.__batchRequests;x=k.data.__batchResponses;if(x&&w){for(var i=0;i<w.length;i++){t=w[i].__changeRequests;if(x[i]){v=x[i].__changeResponses;if(t&&v){for(var j=0;j<t.length;j++){if(t[j].method=="MERGE"||t[j].method=="PUT"){s=t[j].requestUri.replace(this.sServiceUrl+'/','');if(!s.startsWith("/")){s="/"+s;}E=this._getObject(s);if(E&&E.__metadata&&v[j].headers&&v[j].headers.ETag){E.__metadata.etag=v[j].headers.ETag;}}}}}else{L.warning("could not update ETags for batch request: corresponding response for request missing");}}}else{L.warning("could not update ETags for batch request: no batch responses/requests available");}}else{s=R.requestUri.replace(this.sServiceUrl+'/','');if(!s.startsWith("/")){s="/"+s;}E=this._getObject(s);if(E&&E.__metadata&&k.headers.ETag){E.__metadata.etag=k.headers.ETag;}}};
r.prototype._handleBatchErrors=function(R,D){this._getBatchErrors(D);this._handleETag();};
r.prototype._getBatchErrors=function(D){var E=[],s;q.each(D.__batchResponses,function(i,j){if(j.message){s="The following problem occurred: "+j.message;if(j.response){s+=j.response.statusCode+","+j.response.statusText+","+j.response.body;}E.push(j);L.fatal(s);}if(j.__changeResponses){q.each(j.__changeResponses,function(i,k){if(k.message){s="The following problem occurred: "+k.message;if(k.response){s+=k.response.statusCode+","+k.response.statusText+","+k.response.body;}E.push(k);L.fatal(s);}});}});return E;};
r.prototype._handleError=function(E){var P={},t;var s="The following problem occurred: "+E.message;P.message=E.message;if(E.response){if(this.bTokenHandling){t=this._getHeader("x-csrf-token",E.response.headers);if(E.response.statusCode=='403'&&t&&t.toLowerCase()=="required"){this.resetSecurityToken();}}s+=E.response.statusCode+","+E.response.statusText+","+E.response.body;P.statusCode=E.response.statusCode;P.statusText=E.response.statusText;P.responseText=E.response.body;}L.fatal(s);return P;};
r.prototype.getData=function(P,i,I){return this.getProperty(P,i,I);};
r.prototype._getETag=function(P,i,E){var s,j,I;if(E){s=E;}else{if(i&&i.__metadata){s=i.__metadata.etag;}else if(P){j=P.replace(this.sServiceUrl+'/','');I=j.indexOf("?");if(I>-1){j=j.substr(0,I);}if(this.oData.hasOwnProperty(j)){s=this.getProperty('/'+j+'/__metadata/etag');}}}return s;};
r.prototype._createRequest=function(s,i,A,P,E){var j={},k;q.extend(j,this.mCustomHeaders,this.oHeaders);k=this._getETag(s,P,E);if(k&&i!="GET"){j["If-Match"]=k;}if(this.bJSON&&i!="DELETE"&&this.sMaxDataServiceVersion==="2.0"){j["Content-Type"]="application/json";}if(i=="MERGE"&&!this.bUseBatch){j["x-http-method"]="MERGE";i="POST";}var R={headers:j,requestUri:s,method:i,user:this.sUser,password:this.sPassword,async:A};if(P){R.data=P;}if(A){R.withCredentials=this.bWithCredentials;}return R;};
r.prototype._isRefreshNeeded=function(R,i){var j=false,E,k=[],t=this;if(!this.bRefreshAfterChange){return j;}if(R.data&&Array.isArray(R.data.__batchRequests)){if(i){k=t._getBatchErrors(i.data);q.each(k,function(I,l){if(l.response&&l.response.statusCode=="412"){E=l.response.statusCode;return false;}});if(!!E){return false;}}q.each(R.data.__batchRequests,function(I,l){if(Array.isArray(l.__changeRequests)){q.each(l.__changeRequests,function(I,s){j=j||t._isRefreshNeeded(s);return!j;});}return!j;});}else{if(R.method==="GET"){return false;}else{if(i&&i.statusCode=="412"){j=false;}else{j=true;}}}return j;};
r.prototype.update=function(P,D,i){var s,E,j,R,k,l,t,v,w,S,K,x,A=false;if(i instanceof C||arguments.length>3){l=i;s=arguments[3];E=arguments[4];j=arguments[5];}else{l=i.context||i.oContext;s=i.success||i.fnSuccess;E=i.error||i.fnError;t=i.eTag||i.sETag;j=typeof(i.merge)=="undefined"?i.bMerge===true:i.merge===true;A=typeof(i.async)=="undefined"?i.bAsync===true:i.async===true;x=i.urlParameters;}k=this._createRequestUrl(P,l,x,this.bUseBatch);if(j){R=this._createRequest(k,"MERGE",A,D,t);}else{R=this._createRequest(k,"PUT",A,D,t);}P=this._normalizePath(P,l);S=this._getObject(P);R.keys={};if(S){K=this._getKey(S);R.keys[K]=true;}if(this.bUseBatch){w=this._createBatchRequest([{__changeRequests:[R]}],A);v=this._submitRequest(w,this.bUseBatch,s,E,true);}else{v=this._submitRequest(R,this.bUseBatch,s,E);}return v;};
r.prototype.create=function(P,D,i){var R,j,s,k,E,l,S,t,A=false,v;if(i&&typeof(i)=="object"&&!(i instanceof C)){l=i.context;S=i.success;v=i.urlParameters;t=i.error;A=i.async===true;}else{l=i;S=arguments[3];t=arguments[4];}s=this._createRequestUrl(P,l,v,this.bUseBatch);R=this._createRequest(s,"POST",A,D);P=this._normalizePath(P,l);E=this.oMetadata._getEntityTypeByPath(P);R.entityTypes={};if(E){R.entityTypes[E.entityType]=true;}if(this.bUseBatch){j=this._createBatchRequest([{__changeRequests:[R]}],A);k=this._submitRequest(j,this.bUseBatch,S,t,true);}else{k=this._submitRequest(R,this.bUseBatch,S,t);}return k;};
r.prototype.remove=function(P,i){var j,E,s,S,k,R,l,t,K,v,_,w,x,y,A=false,z=this;if((i instanceof C)||arguments[2]){j=i;S=arguments[2];k=arguments[3];}else if(i){j=i.context||i.oContext;S=i.success||i.fnSuccess;k=i.error||i.fnError;t=i.eTag||i.sETag;v=i.payload||i.oPayload;A=typeof(i.async)=="undefined"?i.bAsync===true:i.async===true;y=i.urlParameters;}_=function(D,G){E=l.substr(l.lastIndexOf('/')+1);if(E.indexOf('?')!=-1){E=E.substr(0,E.indexOf('?'));}delete z.oData[E];delete z.mContexts["/"+E];if(S){S(D,G);}};l=this._createRequestUrl(P,j,y,this.bUseBatch);R=this._createRequest(l,"DELETE",A,v,t);P=this._normalizePath(P,j);s=this._getObject(P);R.keys={};if(s){K=this._getKey(s);R.keys[K]=true;}if(this.bUseBatch){w=this._createBatchRequest([{__changeRequests:[R]}],A);x=this._submitRequest(w,this.bUseBatch,_,k,true);}else{x=this._submitRequest(R,this.bUseBatch,_,k);}return x;};
r.prototype.callFunction=function(s,P){var R,i,j,k,l,t,v,S,E,A,w="GET",x={},y=this;if(P&&typeof(P)=="object"){w=P.method?P.method:w;t=P.urlParameters;v=P.context;S=P.success;E=P.error;A=P.async===true;}else{w=P;t=arguments[2];v=arguments[3];S=arguments[4];E=arguments[5];A=arguments[6]===true;}l=this.oMetadata._getFunctionImportMetadata(s,w);n(l,"Function "+s+" not found in the metadata !");if(l){j=this._createRequestUrl(s,v,null,this.bUseBatch);var z=U(j);if(l.parameter!=null){q.each(t,function(D,G){var H=l.parameter.filter(function(J){return J.name==D&&J.mode=="In";});if(H.length>0){var I=H[0];x[D]=O.formatValue(G,I.type);}else{L.warning("Parameter "+D+" is not defined for function call "+s+"!");}});}if(w==="GET"){return y.read(s,v,x,true,S,E);}else{q.each(x,function(D,G){z.addQuery(D,G);});R=this._createRequest(z.toString(),w,A);if(this.bUseBatch){i=this._createBatchRequest([{__changeRequests:[R]}],A);k=this._submitRequest(i,this.bUseBatch,S,E,true);}else{k=this._submitRequest(R,this.bUseBatch,S,E);}return k;}}};
r.prototype.read=function(P,i){var R,s,j,k,l,t,A,S,E,v,w,x,y,z,D,G,H;if(i&&typeof(i)=="object"&&!(i instanceof C)){l=i.context;t=i.urlParameters;A=i.async!==false;S=i.success;E=i.error;v=i.filters;w=i.sorters;}else{l=i;t=arguments[2];A=arguments[3]!==false;S=arguments[4];E=arguments[5];}A=A!==false;H=O._createUrlParamsArray(t);y=O.createSortParams(w);if(y){H.push(y);}if(v&&!this.oMetadata){L.fatal("Tried to use filters in read method before metadata is available.");}else{G=this._normalizePath(P,l);D=this.oMetadata&&this.oMetadata._getEntityTypeByPath(G);z=F.groupFilters(v);x=O.createFilterParams(z,this.oMetadata,D);if(x){H.push(x);}}s=this._createRequestUrl(P,l,H,this.bUseBatch);R=this._createRequest(s,"GET",A);if(this.bUseBatch){k=this._createBatchRequest([R],A);j=this._submitRequest(k,this.bUseBatch,S,E,true);}else{j=this._submitRequest(R,this.bUseBatch,S,E);}return j;};
r.prototype.createBatchOperation=function(P,s,D,i){var j={},E,S,k,l;q.extend(j,this.mCustomHeaders,this.oHeaders);if(P.startsWith("/")){P=P.substr(1);}if(i){E=i.sETag;}if(s!="GET"){E=this._getETag(P,D,E);if(E){j["If-Match"]=E;}}if(this.bJSON){if(s!="DELETE"&&s!="GET"&&this.sMaxDataServiceVersion==="2.0"){j["Content-Type"]="application/json";}}else{j["Content-Type"]="application/atom+xml";}var R={requestUri:P,method:s.toUpperCase(),headers:j};if(D){R.data=D;}if(s!="GET"&&s!="POST"){if(P&&P.indexOf("/")!=0){P='/'+P;}S=this._getObject(P);if(S){k=this._getKey(S);R.keys={};R.keys[k]=true;}}else if(s=="POST"){var N=P;if(P.indexOf('?')!=-1){N=P.substr(0,P.indexOf('?'));}l=this.oMetadata._getEntityTypeByPath(N);if(l){R.entityTypes={};R.entityTypes[l.entityType]=true;}}return R;};
r.prototype.addBatchReadOperations=function(R){if(!Array.isArray(R)||R.length<=0){L.warning("No array with batch operations provided!");return false;}var t=this;q.each(R,function(i,j){if(j.method!="GET"){L.warning("Batch operation should be a GET operation!");return false;}t.aBatchOperations.push(j);});};
r.prototype.addBatchChangeOperations=function(i){if(!Array.isArray(i)||i.length<=0){return false;}q.each(i,function(I,j){if(j.method!="POST"&&j.method!="PUT"&&j.method!="MERGE"&&j.method!="DELETE"){L.warning("Batch operation should be a POST/PUT/MERGE/DELETE operation!");return false;}});this.aBatchOperations.push({__changeRequests:i});};
r.prototype.clearBatch=function(){this.aBatchOperations=[];};
r.prototype.submitBatch=function(s,E,A,i){var R,j,t=this;function _(D,v){if(s){s(D,v,t._getBatchErrors(D));}}if(!(typeof(s)=="function")){var k=A;var l=E;A=s;s=l;E=k;}A=A!==false;if(this.aBatchOperations.length<=0){L.warning("No batch operations in batch. No request will be triggered!");return false;}R=this._createBatchRequest(this.aBatchOperations,A);j=this._submitRequest(R,true,_,E,false,i);this.clearBatch();return j;};
r.prototype.getServiceMetadata=function(){if(this.oMetadata&&this.oMetadata.isLoaded()){return this.oMetadata.getServiceMetadata();}};
r.prototype.getServiceAnnotations=function(){if(this.oAnnotations&&this.oAnnotations.getAnnotationsData){return this.oAnnotations.getAnnotationsData();}};
r.prototype.submitChanges=function(s,E,P){var R,i,t=this,j,k,T,l,S,K;if(this.sChangeKey){j=this.sChangeKey.replace(this.sServiceUrl,'');S=this._getObject(j);i=S;if(p(S)){i=m({},S);if(i.__metadata){T=i.__metadata.type;l=i.__metadata.etag;delete i.__metadata;if(T||l){i.__metadata={};}if(T){i.__metadata.type=T;}if(!!l){i.__metadata.etag=l;}}q.each(i,function(x,y){if(y&&y.__deferred){delete i[x];}});var v=this.oMetadata._getEntityTypeByPath(j);if(v){var N=this.oMetadata._getNavigationPropertyNames(v);q.each(N,function(I,x){delete i[x];});}i=this._removeReferences(i);}if(P&&P.sETag){k=P.sETag;}R=this._createRequest(this.sChangeKey,"MERGE",true,i,k);if(this.sUrlParams){R.requestUri+="?"+this.sUrlParams;}R.keys={};if(S){K=this._getKey(S);R.keys[K]=true;}this.oRequestQueue[this.sChangeKey]=R;}if(q.isEmptyObject(this.oRequestQueue)){return undefined;}if(this.bUseBatch){var w=[];q.each(this.oRequestQueue,function(K,x){delete x._oRef;var y=m({},x);x._oRef=y;y.requestUri=y.requestUri.replace(t.sServiceUrl+'/','');y.data._bCreate?delete y.data._bCreate:false;w.push(y);});R=this._createBatchRequest([{__changeRequests:w}],true);this._submitRequest(R,this.bUseBatch,s,E,true);}else{q.each(this.oRequestQueue,function(K,x){delete x._oRef;var y=m({},x);x._oRef=y;if(y.data&&y.data._bCreate){delete y.data._bCreate;}t._submitRequest(y,this.bUseBatch,s,E,true);});}return undefined;};
r.prototype._updateRequestQueue=function(R,k){var l,s,t,v=this;if(k){l=R.data.__batchRequests;if(l){for(var i=0;i<l.length;i++){s=l[i].__changeRequests;if(s){for(var j=0;j<s.length;j++){t=s[j];q.each(this.oRequestQueue,function(K,w){if(w._oRef===t&&K!==v.sChangeKey){delete v.oRequestQueue[K];delete v.oData[K];delete v.mContexts["/"+K];}else if(v.sChangeKey&&K===v.sChangeKey){delete v.oRequestQueue[K];v.sChangeKey=null;}});}}}}}else{q.each(this.oRequestQueue,function(K,w){if(w._oRef===R&&K!==v.sChangeKey){delete v.oRequestQueue[K];delete v.oData[K];delete v.mContexts["/"+K];}else if(v.sChangeKey&&K===v.sChangeKey){delete v.oRequestQueue[K];v.sChangeKey=null;}});}};
r.prototype.resetChanges=function(s,E){var P;if(this.sChangeKey){P=this.sChangeKey.replace(this.sServiceUrl,'');this._loadData(P,null,s,E);}};
r.prototype.setProperty=function(P,v,j,A){var s,E={},D={},k=this._createRequestUrl(P,j),l=P.substring(0,P.lastIndexOf("/")),K,t,w={},x=false;if(!this.resolve(P,j)){return false;}k=k.replace(this.sServiceUrl+'/','');k=k.substring(0,k.indexOf("/"));k=this.sServiceUrl+'/'+k;s=P.substr(P.lastIndexOf("/")+1);D=this._getObject(l,j);if(!D){return false;}t=l.split("/");for(var i=t.length-1;i>=0;i--){E=this._getObject(t.join("/"),j);if(E){K=this._getKey(E);if(K){break;}}t.splice(i-1,1);}if(!K){K=this._getKey(j);}if(K){w[K]=true;}if(D._bCreate){D[s]=v;x=true;this.checkUpdate(false,A,w);}else{if(!this.sChangeKey){this.sChangeKey=k;}if(this.sChangeKey==k){D[s]=v;x=true;this.checkUpdate(false,A,w);}else{this.fireRejectChange({rejectedValue:v,oldValue:D[s]});}}return x;};
r.prototype._isHeaderPrivate=function(H){switch(H.toLowerCase()){case"accept":case"accept-language":case"maxdataserviceversion":case"dataserviceversion":return true;case"x-csrf-token":return this.bTokenHandling;default:return false;}};
r.prototype.setHeaders=function(H){var i={},t=this;if(H){q.each(H,function(s,j){if(t._isHeaderPrivate(s)){L.warning("Not allowed to modify private header: "+s);}else{i[s]=j;}});this.mCustomHeaders=i;}else{this.mCustomHeaders={};}if(this.oAnnotations){this.oAnnotations.setHeaders(this.mCustomHeaders);}};
r.prototype.getHeaders=function(){return q.extend({},this.mCustomHeaders,this.oHeaders);};
r.prototype._getHeader=function(s,H){var i;for(i in H){if(i.toLowerCase()===s.toLowerCase()){return H[i];}}return null;};
r.prototype.hasPendingChanges=function(){return this.sChangeKey!=null;};
r.prototype.updateBindings=function(i){this.checkUpdate(i);};
r.prototype.forceNoCache=function(i){this.bCache=!i;};
r.prototype.setTokenHandlingEnabled=function(t){this.bTokenHandling=t;};
r.prototype.setUseBatch=function(i){this.bUseBatch=i;};
r.prototype.formatValue=function(v,t){return O.formatValue(v,t);};
r.prototype.deleteCreatedEntry=function(i){if(i){var P=i.getPath();delete this.mContexts[P];if(P.startsWith("/")){P=P.substr(1);}delete this.oRequestQueue[P];delete this.oData[P];}};
r.prototype.createEntry=function(P,v){var E={},k,s,R;if(!P.startsWith("/")){P="/"+P;}var j=this.oMetadata._getEntityTypeByPath(P);if(!j){n(j,"No Metadata for collection "+P+" found");return undefined;}if(typeof v==="object"&&!Array.isArray(v)){E=v;}else{for(var i=0;i<j.property.length;i++){var l=j.property[i];var t=v&&v.indexOf(l.name)>-1;if(!v||t){E[l.name]=this._createPropertyValue(l.type);if(t){v.splice(v.indexOf(l.name),1);}}}if(v){n(v.length===0,"No metadata for the following properties found: "+v.join(","));}}E._bCreate=true;k=P.substring(1)+"('"+u()+"')";this.oData[k]=E;E.__metadata={type:""+j.entityType};s=this._createRequestUrl(P);R=this._createRequest(s,"POST",true,E);R.entityTypes={};R.entityTypes[j.entityType]=true;this.oRequestQueue[k]=R;return this.getContext("/"+k);};
r.prototype._createPropertyValue=function(t){var T=this.oMetadata._splitName(t);var N=T.namespace;var s=T.name;if(N.toUpperCase()!=='EDM'){var j={};var k=this.oMetadata._getObjectMetadata("complexType",s,N);n(k,"Complex type "+t+" not found in the metadata !");for(var i=0;i<k.property.length;i++){var P=k.property[i];j[P.name]=this._createPropertyValue(P.type);}return j;}else{return this._getDefaultPropertyValue(s,N);}};
r.prototype._getDefaultPropertyValue=function(t,N){return undefined;};
r.prototype._normalizePath=function(P,i){if(P&&P.indexOf('?')!=-1){P=P.substr(0,P.indexOf('?'));}if(!i&&!P.startsWith("/")){P='/'+P;L.warning(this+" path "+P+" should be absolute if no Context is set");}return this.resolve(P,i);};
r.prototype.setRefreshAfterChange=function(R){this.bRefreshAfterChange=R;};
r.prototype.isList=function(P,i){var P=this.resolve(P,i);return P&&P.substr(P.lastIndexOf("/")).indexOf("(")===-1;};
r.prototype.isMetaModelPath=function(P){return P.indexOf("##")==0||P.indexOf("/##")>-1;};
r.prototype._request=function(R,s,E,H,i,j){if(this.bDestroyed){return{abort:function(){}};}var t=this;function w(l){return function(){if(t.aPendingRequestHandles){var I=t.aPendingRequestHandles.indexOf(k);if(I>-1){t.aPendingRequestHandles.splice(I,1);}}if(!(k&&k.bSuppressErrorHandlerCall)){l.apply(this,arguments);}};}var k=h.request(R,w(s||h.defaultSuccess),w(E||h.defaultError),H,i,j);if(R.async!==false){this.aPendingRequestHandles.push(k);}return k;};
r.prototype.destroy=function(){this.bDestroyed=true;if(this.aPendingRequestHandles){for(var i=this.aPendingRequestHandles.length-1;i>=0;i--){var R=this.aPendingRequestHandles[i];if(R&&R.abort){R.bSuppressErrorHandlerCall=true;R.abort();}}delete this.aPendingRequestHandles;}if(!!this.oMetadataLoadEvent){clearTimeout(this.oMetadataLoadEvent);}if(!!this.oMetadataFailedEvent){clearTimeout(this.oMetadataFailedEvent);}if(this.oMetadata){this.oMetadata.detachLoaded(this.onMetadataLoaded);this.oMetadata.detachFailed(this.onMetadataFailed);if(!this.oMetadata.isLoaded()&&!this.oMetadata.hasListeners("loaded")){this.oMetadata.destroy();delete this.oServiceData.oMetadata;}delete this.oMetadata;}if(this.oAnnotations){this.oAnnotations.detachFailed(this.onAnnotationsFailed);this.oAnnotations.detachLoaded(this.onAnnotationsLoaded);this.oAnnotations.destroy();delete this.oAnnotations;delete this.pAnnotationsLoaded;}M.prototype.destroy.apply(this,arguments);};
r.prototype._getAnnotationParser=function(A){if(!this.oAnnotations){var i=sap.ui.requireSync("sap/ui/model/odata/ODataAnnotations");this.oAnnotations=new i({annotationData:A,url:null,metadata:this.oMetadata,async:this.bLoadMetadataAsync,headers:this.mCustomHeaders});this.oAnnotations.attachFailed(this.onAnnotationsFailed,this);this.oAnnotations.attachLoaded(this.onAnnotationsLoaded,this);}return this.oAnnotations;};
r.prototype.onAnnotationsFailed=function(E){this.fireAnnotationsFailed(E.getParameters());};
r.prototype.onAnnotationsLoaded=function(E){this.fireAnnotationsLoaded(E.getParameters());};
r.prototype.addAnnotationUrl=function(v){var j=[].concat(v),k=[],A=[],E=[],t=this;q.each(j,function(i,s){var I=s.indexOf("$metadata");if(I>=0){if(I==0){s=t.sServiceUrl+'/'+s;}k.push(s);}else{A.push(s);}});return this.oMetadata._addUrl(k).then(function(P){return Promise.all(q.map(P,function(i){E=E.concat(i.entitySets);return t.addAnnotationXML(i["metadataString"]);}));}).then(function(){return t._getAnnotationParser().addUrl(A);}).then(function(P){return{annotations:P.annotations,entitySets:E};});};
r.prototype.addAnnotationXML=function(x,s){return new Promise(function(i,j){this._getAnnotationParser().setXML(null,x,{success:i,error:j,fireEvents:!s});}.bind(this));};
r.prototype.getMetaModel=function(){var t=this;if(!this.oMetaModel){this.oMetaModel=new g(this.oMetadata,this.oAnnotations,{addAnnotationUrl:this.addAnnotationUrl.bind(this),annotationsLoadedPromise:this.oMetadata.isLoaded()&&(!this.oAnnotations||this.oAnnotations.isLoaded())?null:this.pAnnotationsLoaded});this.oMetaModel.loaded().then(function(){t.bMetaModelLoaded=true;t.checkUpdate(false,false,null,true);});}return this.oMetaModel;};
return r;});
sap.ui.predefine('sap/ui/model/odata/ODataPropertyBinding',['sap/ui/model/Context','sap/ui/model/ChangeReason','sap/ui/model/PropertyBinding',"sap/base/util/deepEqual",'sap/ui/model/ChangeReason'],function(C,a,P,d){"use strict";
var O=P.extend("sap.ui.model.odata.ODataPropertyBinding",{constructor:function(m,p,c,b){P.apply(this,arguments);this.bInitial=true;this.oValue=this._getValue();this.vOriginalValue;this.getDataState().setValue(this.oValue);this.setIgnoreMessages(b&&b.ignoreMessages);}});
O.prototype.initialize=function(){if(this.oModel.oMetadata.isLoaded()&&this.bInitial){this.checkUpdate(true);this.bInitial=false;}};
O.prototype.getValue=function(){return this.oValue;};
O.prototype._getValue=function(){return this.oModel._getObject(this.sPath,this.oContext);};
O.prototype.setValue=function(v){if(this.bSuspended){return;}if(!d(v,this.oValue)&&this.oModel.setProperty(this.sPath,v,this.oContext,true)){this.oValue=v;var D=this.getDataState();D.setValue(this.oValue);this.oModel.firePropertyChange({reason:a.Binding,path:this.sPath,context:this.oContext,value:v});}};
O.prototype.setContext=function(c){var f,o=this.oContext;if(c&&c.isPreliminary()){return;}if(C.hasChanged(this.oContext,c)){this.oContext=c;if(this.isRelative()){f=!!(o!==c&&this.getDataState().getControlMessages().length);this.checkUpdate(f);}}};
O.prototype.checkUpdate=function(f){if(this.bSuspended&&!f){return;}var D=this.getDataState();var c=false;var o=this.oModel.getOriginalProperty(this.sPath,this.oContext);if(f||!d(o,this.vOriginalValue)){this.vOriginalValue=o;D.setOriginalValue(o);c=true;}var v=this._getValue();if(f||!d(v,this.oValue)){this.oValue=v;D.setValue(this.oValue);this._fireChange({reason:a.Change});c=true;}if(c){this.checkDataState();}};
O.prototype.checkDataState=function(p){var c=this.oModel.resolve(this.sPath,this.oContext,true)||this.oModel.resolve(this.sPath,this.oContext);this.getDataState().setLaundering(!!p&&!!(c in p));P.prototype._checkDataState.call(this,c,p);};
O.prototype.supportsIgnoreMessages=function(){return true;};
return O;});
sap.ui.predefine('sap/ui/model/odata/ODataTreeBinding',['sap/ui/model/TreeBinding','./CountMode',"sap/base/Log","sap/ui/thirdparty/jquery"],function(T,C,L,q){"use strict";
var O=T.extend("sap.ui.model.odata.ODataTreeBinding",{constructor:function(m,p,c,f,P){T.apply(this,arguments);this.bPendingRequest=false;this.oFinalLengths={};this.oLengths={};this.oKeys={};this.bNeedsUpdate=false;this.bHasTreeAnnotations=this._hasTreeAnnotations();this.oRootContext=null;this.iNumberOfExpandedLevels=P&&P.numberOfExpandedLevels;this.sCountMode=(P&&P.countMode)||this.oModel.sDefaultCountMode;if(!this.bHasTreeAnnotations){if(!P||!P.navigation){L.error("A navigation paths parameter object has to be defined");this.oNavigationPaths={};}else{this.oNavigationPaths=P.navigation;}}else{L.warning("Tree hierarchy annotations are deprecated and may not work correctly with the sap.ui.model.odata.ODataModel."+" Please use the sap.ui.model.odata.v2.ODataModel (since version 1.28) instead which fully supports hierarchy annotations.");}}});
O.prototype.getRootContexts=function(s,l,t){var n=null,r={numberOfExpandedLevels:this.iNumberOfExpandedLevels},R=[],b=true,a=this;if(this.bHasTreeAnnotations){r.level=0;if(!this.bDisplayRootNode){r.level=1;}}else{n=this.oModel.resolve(this.getPath(),this.getContext());r.navPath=this._getNavPath(this.getPath());if(r.numberOfExpandedLevels>0){var A=n;for(var i=0;i<r.numberOfExpandedLevels;i++){var N=this._getNavPath(A);r.navPath+="/"+N;A+="/"+N;}}var I=this.oModel.isList(this.sPath,this.getContext());if(I){this.bDisplayRootNode=true;}else{b=false;this.oModel.createBindingContext(n,null,{expand:r.navPath},function(o){R=[o];if(a.oRootContext!==o){a.oRootContext=o;a._processODataObject(o.getObject(),n,r.navPath);a.bNeedsUpdate=true;}},this.bRefresh);this.bRefresh=false;}}if(b){if(!this.bDisplayRootNode){R=this._getContextsForNodeId(n,0,1,0,r);}else{R=this._getContextsForNodeId(n,s,l,t,r);}}if(!this.bDisplayRootNode&&R.length>0){this.oRootContext=R[0];R=this.getNodeContexts(R[0],s,l,t);}return R;};
O.prototype.getNodeContexts=function(c,s,l,t){var n,r={};if(this.bHasTreeAnnotations){var d=c.getProperty(this.oTreeProperties["hierarchy-drill-state-for"]);if(d=="leaf"){return[];}n=c.getProperty(this.oTreeProperties["hierarchy-node-for"]);r.level=parseInt(c.getProperty(this.oTreeProperties["hierarchy-level-for"]))+1;}else{var N=this._getNavPath(c.getPath());if(!N){return[];}n=this.oModel.resolve(N,c);r.navPath=this.oNavigationPaths[N];}return this._getContextsForNodeId(n,s,l,t,r);};
O.prototype.hasChildren=function(c){if(!c){return false;}if(this.bHasTreeAnnotations){var d=c.getProperty(this.oTreeProperties["hierarchy-drill-state-for"]);return d==="expanded"||d==="collapsed";}else{var n=this._getNavPath(c.getPath());var p=c.getPath()+"/"+n;return n&&this.oLengths[p]>0;}};
O.prototype.getChildCount=function(c){if(this.bHasTreeAnnotations){var h;if(!c){if(this.oRootContext){h=this.oRootContext.getProperty(this.oTreeProperties["hierarchy-node-for"]);}else{h="000000";}}else{h=c.getProperty(this.oTreeProperties["hierarchy-node-for"]);}return this.oLengths[h];}else{if(!c){return this.oLengths[this.getPath()];}return this.oLengths[c.getPath()+"/"+this._getNavPath(c.getPath())];}};
O.prototype._getContextsForNodeId=function(n,s,l,t,p){var c=[],b,k;if(!s){s=0;}if(!l){l=this.oModel.iSizeLimit;}if(!t){t=0;}if(this.bHasTreeAnnotations){if(n==null){n="000000";}if(p.level==0){p.level++;}}if(this.oFinalLengths[n]&&this.oLengths[n]<l){l=this.oLengths[n];}if(this.oKeys[n]){for(var i=s;i<s+l;i++){k=this.oKeys[n][i];if(!k){break;}c.push(this.oModel.getContext('/'+k));}}b=c.length!=l&&!(this.oFinalLengths[n]&&c.length>=this.oLengths[n]);if(this.oModel.getServiceMetadata()){if(!this.bPendingRequest&&b){var P=[];if(this.bHasTreeAnnotations){if(p.numberOfExpandedLevels>0){var a=p.level+p.numberOfExpandedLevels;P.push("$filter="+this.oTreeProperties["hierarchy-level-for"]+" le '0"+a+"'");}else{P.push("$filter="+this.oTreeProperties["hierarchy-level-for"]+" eq '0"+p.level+"' and "+this.oTreeProperties["hierarchy-parent-node-for"]+" eq '"+n+"'");}}else{if(p.navPath){P.push("$expand="+p.navPath);}}this._loadSubNodes(n,s,l,t,P,p);}}return c;};
O.prototype._getCountForNodeId=function(n,s,l,t,p){var a=this;var P=[];function _(d){a.oFinalLengths[n]=true;a.oLengths[n]=parseInt(d);}function b(e){var E="Request for $count failed: "+e.message;if(e.response){E+=", "+e.response.statusCode+", "+e.response.statusText+", "+e.response.body;}L.warning(E);}var c;if(this.bHasTreeAnnotations){c=this.oModel.resolve(this.getPath(),this.getContext());P.push("$filter="+this.oTreeProperties["hierarchy-parent-node-for"]+" eq '"+n+"'");}else{c=n;}if(c){var u=this.oModel._createRequestUrl(c+"/$count",null,P);var r=this.oModel._createRequest(u,"GET",false);r.headers["Accept"]="text/plain, */*;q=0.5";this.oModel._request(r,_,b,undefined,undefined,this.oModel.getServiceMetadata());}};
O.prototype._loadSubNodes=function(n,s,l,t,p,P){var a=this,I=false;if(s||l){p.push("$skip="+s+"&$top="+l);}if(!a.bHasTreeAnnotations&&!this.oFinalLengths[n]&&(this.sCountMode==C.Inline||this.sCountMode==C.Both)){p.push("$inlinecount=allpages");I=true;}function S(d){if(d.results){if(!a.bHasTreeAnnotations){if(I&&d.__count){a.oLengths[n]=parseInt(d.__count);a.oFinalLengths[n]=true;}else{if(a.oModel.isCountSupported()){a._getCountForNodeId(n);}}a.oKeys[n]=[];for(var i=0;i<d.results.length;i++){var E=d.results[i];var k=a.oModel._getKey(E);a._processODataObject(E,"/"+k,P.navPath);a.oKeys[n][i+s]=k;}}else{var m={};for(var i=0;i<d.results.length;i++){var E=d.results[i];n=E[a.oTreeProperties["hierarchy-parent-node-for"]];if(i==0){m[n]=s;}else if(m[n]==undefined){m[n]=0;}if(!(n in a.oKeys)){a.oKeys[n]=[];a._getCountForNodeId(n);}a.oKeys[n][m[n]]=a.oModel._getKey(E);m[n]++;}}}else{a.oKeys[null]=a.oModel._getKey(d);if(!a.bHasTreeAnnotations){a._processODataObject(d,n,P.navPath);}}a.oRequestHandle=null;a.bPendingRequest=false;a.bNeedsUpdate=true;}function c(){a.fireDataReceived();}function e(d){a.oRequestHandle=null;a.bPendingRequest=false;a.fireDataReceived();}function u(h){a.oRequestHandle=h;}if(n){if(!this.oFinalLengths[n]){this.bPendingRequest=true;this.fireDataRequested();var A;if(this.bHasTreeAnnotations){A=this.oModel.resolve(this.getPath(),this.getContext());}else{A=n;}this.oModel._loadData(A,p,S,e,false,u,c);}}};
O.prototype.resetData=function(c){if(c){var p=c.getPath();delete this.oKeys[p];delete this.oLengths[p];delete this.oFinalLengths[p];}else{this.oKeys={};this.oLengths={};this.oFinalLengths={};this.oRootContext=null;}};
O.prototype.refresh=function(f,c,e){var b=false;if(!f){if(e){var r=this.oModel.resolve(this.sPath,this.oContext);var E=this.oModel.oMetadata._getEntityTypeByPath(r);if(E&&(E.entityType in e)){b=true;}}if(c&&!b){q.each(this.oKeys,function(i,n){q.each(n,function(i,k){if(k in c){b=true;return false;}});if(b){return false;}});}if(!c&&!e){b=true;}}if(f||b){this.resetData();this.bNeedsUpdate=false;this.bRefresh=true;this._fireChange();}};
O.prototype.filter=function(f){L.warning("Filtering is currently not possible in the ODataTreeBinding");return this;};
O.prototype.checkUpdate=function(f,c){var b=false;if(!f){if(this.bNeedsUpdate||!c){b=true;}else{q.each(this.oKeys,function(i,n){q.each(n,function(i,k){if(k in c){b=true;return false;}});if(b){return false;}});}}if(f||b){this.bNeedsUpdate=false;this._fireChange();}};
O.prototype._getNavPath=function(p){var a=this.oModel.resolve(p,this.getContext());if(!a){return;}var P=a.split("/"),e=P[P.length-1],n;var c=e.split("(")[0];if(c&&this.oNavigationPaths[c]){n=this.oNavigationPaths[c];}return n;};
O.prototype._processODataObject=function(o,p,n){var N=[],t=this;if(n&&n.indexOf("/")>-1){N=n.split("/");n=N[0];N.splice(0,1);}var r=this.oModel._getObject(p);if(Array.isArray(r)){this.oKeys[p]=r;this.oLengths[p]=r.length;this.oFinalLengths[p]=true;}if(n&&o[n]){if(Array.isArray(r)){r.forEach(function(R){var o=t.getModel().getData("/"+R);t._processODataObject(o,"/"+R+"/"+n,N.join("/"));});}else if(typeof r==="object"){t._processODataObject(o,p+"/"+n,N.join("/"));}}};
O.prototype._hasTreeAnnotations=function(){var m=this.oModel,M=m.oMetadata,a=m.resolve(this.getPath(),this.getContext()),e=M._getEntityTypeByPath(a),t=M.mNamespaces["sap"],b=this;this.oTreeProperties={"hierarchy-level-for":false,"hierarchy-parent-node-for":false,"hierarchy-node-for":false,"hierarchy-drill-state-for":false};if(!e){L.fatal("EntityType for path "+a+" could not be found.");return false;}q.each(e.property,function(i,p){if(!p.extensions){return true;}q.each(p.extensions,function(i,E){var n=E.name;if(E.namespace===t&&n in b.oTreeProperties&&!b.oTreeProperties[n]){b.oTreeProperties[n]=p.name;}});});var c=false;q.each(this.oTreeProperties,function(i,o){if(!o){c=true;return false;}});return!c;};
return O;});
sap.ui.predefine('sap/ui/model/odata/ODataTreeBindingAdapter',['sap/ui/model/TreeBinding','./v2/ODataTreeBinding','sap/ui/model/TreeBindingAdapter','sap/ui/model/TreeAutoExpandMode','sap/ui/model/ChangeReason','./OperationMode','sap/base/assert','sap/ui/model/Filter','sap/ui/model/odata/ODataUtils'],function(T,O,a,b,C,c,d,F,e){"use strict";var f=function(){if(!(this instanceof T)||this._bIsAdapted){return;}a.apply(this);for(var g in f.prototype){if(f.prototype.hasOwnProperty(g)){this[g]=f.prototype[g];}}this.mParameters=this.mParameters||{};this._aRowIndexMap=[];this._iThreshold=0;this._iPageSize=0;this.setAutoExpandMode(this.mParameters.autoExpandMode||b.Sequential);if(this.mParameters.collapseRecursive===undefined){this.bCollapseRecursive=true;}else{this.bCollapseRecursive=!!this.mParameters.collapseRecursive;}this._createTreeState();if(this.mParameters.treeState&&this.sOperationMode==c.Client){this.setTreeState(this.mParameters.treeState);}};
f.prototype.nodeHasChildren=function(n){d(n,"ODataTreeBindingAdapter.nodeHasChildren: No node given!");if(!n){return false;}else if(n.isArtificial){return true;}else{return O.prototype.hasChildren.call(this,n.context);}};
f.prototype._calculateGroupID=function(n){var g="";var G="";var E;if(n.context===null){return"/";}if(n.parent){g=n.parent.groupID;g=g[g.length-1]!=="/"?g+"/":g;if(this.bHasTreeAnnotations){E=(n.context.getProperty(this.oTreeProperties["hierarchy-node-for"])+"").replace(/\//g,"%2F");G=E+"/";}else{G=n.context.sPath.substring(1)+"/";}}else{if(this.bHasTreeAnnotations){g="/";E=(n.context.getProperty(this.oTreeProperties["hierarchy-node-for"])+"").replace(/\//g,"%2F");G=E+"/";}else{g="/";G=n.context.sPath[0]==="/"?n.context.sPath.substring(1):n.context.sPath;}}var s=g+G;return s;};
f.prototype.resetData=function(o,p){var r=O.prototype.resetData.call(this,o,p);this._aRowIndexMap=[];this._oRootNode=undefined;this._iPageSize=0;this._iThreshold=0;if(!p||p.reason!==C.Sort){this.clearSelection();this._createTreeState(true);}return r;};
f.prototype.expandNodeToLevel=function(i,l,s){var t=this;if(this.sOperationMode!=="Server"){return Promise.reject(new Error("expandNodeToLevel() does not support binding operation modes other than OperationMode.Server"));}var n=this.findNode(i),p=[],A="";if(this.sOperationMode=="Server"||this.bUseServersideApplicationFilters){A=this.getFilterParams();}var N=n.context.getProperty(this.oTreeProperties["hierarchy-node-for"]);var E=this._getEntityType();var g=e._createFilterParams(new F(this.oTreeProperties["hierarchy-node-for"],"EQ",N),this.oModel.oMetadata,E);var L=this._getLevelFilterParams("LE",l);p.push("$filter="+g+"%20and%20"+L+(A?"%20and%20"+A:""));if(this.sCustomParams){p.push(this.sCustomParams);}return this._loadSubTree(n,p).then(function(D){var h=D.results.filter(function(o){return o[t.oTreeProperties["hierarchy-level-for"]]<l;});this._expandSubTree(n,h);if(!s){this._fireChange({reason:C.Expand});}}.bind(this));};
f.prototype._expandSubTree=function(p,D){this._updateTreeState({groupID:p.groupID,expanded:true});var P,s,n,m={},i;n=p.context.getProperty(this.oTreeProperties["hierarchy-node-for"]);m[n]=p.groupID;for(i=1;i<D.length;i++){var I,k,g,E,o;E=D[i];I=E[this.oTreeProperties["hierarchy-node-for"]];P=E[this.oTreeProperties["hierarchy-parent-node-for"]];if(E[this.oTreeProperties["hierarchy-drill-state-for"]]==="leaf"){continue;}k=this.oModel._getKey(E);o=this.oModel.getContext("/"+k);s=m[P];g=this._calculateGroupID({parent:{groupID:s},context:o});m[I]=g;this._updateTreeState({groupID:g,expanded:true});}};
f.prototype.getLength=function(){if((!this._oRootNode||!this._oRootNode.magnitude)&&this.oFinalLengths[null]){return this.oLengths[null];}return a.prototype.getLength.apply(this);};
return f;},true);
sap.ui.predefine('sap/ui/model/odata/ODataTreeBindingFlat',['sap/ui/model/Filter','sap/ui/model/TreeBinding','sap/ui/model/odata/v2/ODataTreeBinding','sap/ui/model/ChangeReason','sap/ui/model/TreeBindingUtils',"sap/base/util/uid","sap/base/Log","sap/base/assert","sap/ui/thirdparty/jquery","sap/base/util/isEmptyObject"],function(F,T,O,C,c,u,L,d,q,e){"use strict";var f=function(){if(!(this instanceof T)||this._bIsAdapted){return;}for(var a in f.prototype){if(f.prototype.hasOwnProperty(a)){this[a]=f.prototype[a];}}this.mParameters=this.mParameters||{};this._iPageSize=0;this._aNodes=this._aNodes||[];this._aNodeCache=[];this._aCollapsed=this._aCollapsed||[];this._aExpanded=this._aExpanded||[];this._aRemoved=[];this._aAdded=[];this._aNodeChanges=[];this._aAllChangedNodes=[];this._mSubtreeHandles={};this._iLowestServerLevel=null;this._aExpandedAfterSelectAll=this._aExpandedAfterSelectAll||[];this._mSelected=this._mSelected||{};this._mDeselected=this._mDeselected||{};this._bSelectAll=false;this._iLengthDelta=0;if(this.mParameters.collapseRecursive===undefined){this.bCollapseRecursive=true;}else{this.bCollapseRecursive=!!this.mParameters.collapseRecursive;}this._bIsAdapted=true;this._bReadOnly=true;this._aPendingRequests=[];this._aPendingChildrenRequests=[];this._aPendingSubtreeRequests=[];};
f.prototype.setNumberOfExpandedLevels=function(l){this.resetData();O.prototype.setNumberOfExpandedLevels.apply(this,arguments);};
f.prototype.getContexts=function(s,l,t,r){if(this.isInitial()){return[];}s=s||0;l=l||this.oModel.iSizeLimit;t=t||0;this._iPageSize=l;this._iThreshold=t;if(this._aNodes.length==0&&!this.isLengthFinal()){this._loadData(s,l,t);}var R=[];var n=this._retrieveNodeSection(s,l);this._aNodeCache=[];var S;var a=0;var b=0;var g={};for(var i=0;i<n.length;i++){var N=n[i];this._aNodeCache[s+i]=N&&N.context?N:undefined;R.push(N.context);if(!N.context){if(N.serverIndex!=undefined){if(S==undefined){S=N.serverIndex;}b=N.serverIndex;}else if(N.positionInParent!=undefined){var p=N.parent;g[p.key]=g[p.key]||[];g[p.key].push(N);}}}a=1+Math.max(b-(S||0),0);if(S!=undefined&&a){this._loadData(S,a,t);}for(var m in g){var o=this._calculateRequestParameters(g[m]);this._loadChildren(g[m][0].parent,o.skip,o.top);}if(r){return n;}else{return R;}};
f.prototype._calculateRequestParameters=function(m){var p=m[0].parent;var M=m[0].positionInParent;var a=Math.min(M+Math.max(this._iThreshold,m.length),p.children.length);for(var i=M;i<a;i++){var o=p.children[i];if(o){break;}}return{skip:M,top:i-M};};
f.prototype._retrieveNodeSection=function(s,l){return this._bReadOnly?this._indexRetrieveNodeSection(s,l):this._mapRetrieveNodeSection(s,l);};
f.prototype._mapRetrieveNodeSection=function(s,l){var n=-1;var N=[];this._map(function(o,r,i,I,p){n++;if(n>=s){if(!o){if(i=="serverIndex"){o={serverIndex:I};}else if(i=="positionInParent"){o={positionInParent:I,parent:p};}}N.push(o);}if(N.length>=l){r.broken=true;}});return N;};
f.prototype._indexRetrieveNodeSection=function(s,l){var i,n=[],N,o;for(i=s;i<s+l;i++){N=this.getNodeInfoByRowIndex(i);if(N.index!==undefined&&N.index<this._aNodes.length){o=this._aNodes[N.index];if(!o){o={serverIndex:N.index};}}else if(N.parent){o=N.parent.children[N.childIndex];if(!o){o={parent:N.parent,positionInParent:N.childIndex};}}if(o){n.push(o);o=null;}}return n;};
f.prototype.getNodes=function(s,l,t){var n=this.getContexts(s,l,t,true);return n;};
f.prototype._map=function(m){var r={broken:false};var a=function(n){if(n.addedSubtrees.length>0&&!n.nodeState.collapsed){for(var j=0;j<n.addedSubtrees.length;j++){var s=n.addedSubtrees[j];t(n,s);if(r.broken){return;}}}};var t=function(n,s){var S=s._getSubtree();if(s){if(Array.isArray(S)){if(s._oSubtreeRoot){g(S,s._oSubtreeRoot.serverIndex,s._oSubtreeRoot,s._oSubtreeRoot.originalLevel||0,n.level+1);}else{g(S,null,null,0,n.level+1);}}else{s._oSubtreeRoot.level=n.level+1;b(s._oSubtreeRoot,false,s._oNewParentNode,-1,s._oSubtreeRoot);}}};var b=function(n,I,p,P,o){if(!I){if(!n.nodeState.removed||o==n){m(n,r,"positionInParent",P,p);if(r.broken){return;}}}a(n);if(r.broken){return;}if(n&&n.children&&n.nodeState.expanded){for(var i=0;i<n.children.length;i++){var h=n.children[i];if(h&&!h.nodeState.removed&&!h.nodeState.reinserted){h.level=n.level+1;}if(h&&!h.nodeState.removed){b(h,false,n,i,o);}else if(!h){m(h,r,"positionInParent",i,n);}if(r.broken){return;}}}};var g=function(h,s,I,S,n){for(var i=0;i<h.length;i++){var N=h[i];if(N&&N.nodeState&&N.nodeState.removed&&N!=I){if(!N.initiallyCollapsed){i+=N.magnitude;}continue;}if(N&&S>=0&&n>=0){N.level=N.originalLevel||0;var l=(N.level-S)||0;N.level=n+l||0;}if(s===null){m(N,r,"newNode");}else{m(N,r,"serverIndex",s+i);}if(r.broken){return;}if(N&&N.nodeState){if(!N.initiallyCollapsed&&N.nodeState.collapsed){i+=N.magnitude;}else{if(N.initiallyCollapsed&&N.nodeState.expanded){b(N,true);if(r.broken){return;}}else if(!N.initiallyCollapsed&&N.nodeState.expanded){a(N);}}}if(r.broken){return;}}};g(this._aNodes,0,null);};
f.prototype._loadData=function(s,t,i){var a=this;this.fireDataRequested();return this._requestServerIndexNodes(s,t,i).then(function(r){a._addServerIndexNodes(r.oData,r.iSkip);a._fireChange({reason:C.Change});a.fireDataReceived({data:r.oData});},function(E){var A=E.statusCode===0;if(!A){a._aNodes=[];a._bLengthFinal=true;a._fireChange({reason:C.Change});}a.fireDataReceived();});};
f.prototype._restoreServerIndexNodes=function(s,t,i){var a=this;return this._requestServerIndexNodes(s,t,0,i).then(function(r){a._addServerIndexNodes(r.oData,r.iSkip);return r;});};
f.prototype._addServerIndexNodes=function(D,s){var E,k,I,i,t=function(n,b){if(!n.isDeepOne&&!n.initiallyCollapsed&&n.serverIndex<I&&n.serverIndex+n.magnitude>=I){return true;}};if(!this._bLengthFinal){var a=D.__count?parseInt(D.__count):0;this._aNodes[a-1]=undefined;this._bLengthFinal=true;}if(D.results&&D.results.length>0){for(i=0;i<D.results.length;i++){E=D.results[i];k=this.oModel.getKey(E);I=s+i;var m=E[this.oTreeProperties["hierarchy-node-descendant-count-for"]];if(m<0){m=0;L.error("The entry data with key '"+k+"' under binding path '"+this.getPath()+"' has a negative 'hierarchy-node-descendant-count-for' which isn't allowed.");}var n=this._aNodes[I]=this._aNodes[I]||{key:k,context:this.oModel.getContext("/"+k),magnitude:m,level:E[this.oTreeProperties["hierarchy-level-for"]],originalLevel:E[this.oTreeProperties["hierarchy-level-for"]],initiallyCollapsed:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="collapsed",nodeState:{isLeaf:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="leaf",expanded:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="expanded",collapsed:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="collapsed",selected:this._mSelected[k]?this._mSelected[k].nodeState.selected:false},children:[],addedSubtrees:[],serverIndex:I,parent:null,isDeepOne:false};if(this._iLowestServerLevel===null){this._iLowestServerLevel=n.level;}else{this._iLowestServerLevel=Math.min(this._iLowestServerLevel,n.level);}if(this._bSelectAll){if(!this._aExpandedAfterSelectAll.some(t)){this.setNodeSelection(n,true);}}}}};
f.prototype._requestServerIndexNodes=function(s,t,g,I){return new Promise(function(r,h){var R={iSkip:s,iTop:t+(g||0),iThreshold:g};this._aPendingRequests.sort(function(a,b){return a.iSkip-b.iSkip;});for(var i=0;i<this._aPendingRequests.length;i++){if(c._determineRequestDelta(R,this._aPendingRequests[i])===false){return;}}s=R.iSkip;t=R.iTop;function _(D){var a=this._aPendingRequests.indexOf(R);this._aPendingRequests.splice(a,1);r({oData:D,iSkip:s,iTop:t});}function j(E){var a=this._aPendingRequests.indexOf(R);this._aPendingRequests.splice(a,1);h(E);}var U=["$skip="+s,"$top="+t];if(!this._bLengthFinal||I){U.push("$inlinecount=allpages");}if(this.sCustomParams){U.push(this.sCustomParams);}var l=new F(this.oTreeProperties["hierarchy-level-for"],"LE",this.getNumberOfExpandedLevels());var k=[l];if(this.aApplicationFilters){k=k.concat(this.aApplicationFilters);}var A=this.oModel.resolve(this.getPath(),this.getContext());if(A){R.oRequestHandle=this.oModel.read(A,{urlParameters:U,filters:[new F({filters:k,and:true})],sorters:this.aSorters||[],success:_.bind(this),error:j.bind(this),groupId:this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId});this._aPendingRequests.push(R);}}.bind(this));};
f.prototype._propagateMagnitudeChange=function(p,D){while(p!=null&&(p.initiallyCollapsed||p.isDeepOne)){p.magnitude+=D;if(!p.nodeState.expanded){return;}p=p.parent;}};
f.prototype._getInitialMagnitude=function(n){var D=0,o;if(n.isDeepOne){return 0;}if(n.children){for(var i=0;i<n.children.length;i++){o=n.children[i];D+=o.magnitude+1;}}return n.magnitude-D;};
f.prototype._loadChildren=function(p,s,t){var a=this;this.fireDataRequested();this._requestChildren(p,s,t).then(function(r){a._addChildNodes(r.oData,p,r.iSkip);a._fireChange({reason:C.Change});a.fireDataReceived({data:r.oData});},function(E){var A=E.statusCode===0;if(!A){if(p.childCount===undefined){p.children=[];p.childCount=0;a._fireChange({reason:C.Change});}}a.fireDataReceived();});};
f.prototype._restoreChildren=function(p,s,t){var a=this,P=p.context.getProperty(this.oTreeProperties["hierarchy-node-for"]);return this._requestChildren(p,s,t,true).then(function(r){var n;a._map(function(N,R){if(N&&N.context.getProperty(a.oTreeProperties["hierarchy-node-for"])===P){n=N;R.broken=true;}});if(n){a._addChildNodes(r.oData,n,r.iSkip);a.expand(n,true);}return r;});};
f.prototype._addChildNodes=function(D,p,s){if(p.childCount==undefined&&D&&D.__count){var a=D.__count?parseInt(D.__count):0;p.childCount=a;p.children[a-1]=undefined;if(p.nodeState.expanded){this._propagateMagnitudeChange(p,a);}else{p.magnitude=a;}this._cleanTreeStateMaps();}if(D.results&&D.results.length>0){for(var i=0;i<D.results.length;i++){var E=D.results[i];this._createChildNode(E,p,s+i);}}};
f.prototype._createChildNode=function(E,p,P){var k=this.oModel.getKey(E);var i;if(p.containingServerIndex!==undefined){i=p.containingServerIndex;}else{i=p.serverIndex;}var n=p.children[P]=p.children[P]||{key:k,context:this.oModel.getContext("/"+k),magnitude:0,level:p.level+1,originalLevel:p.level+1,initiallyCollapsed:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="collapsed",nodeState:{isLeaf:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="leaf",expanded:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="expanded",collapsed:E[this.oTreeProperties["hierarchy-drill-state-for"]]==="collapsed",selected:this._mSelected[k]?this._mSelected[k].nodeState.selected:false},positionInParent:P,children:[],addedSubtrees:[],parent:p,originalParent:p,isDeepOne:true,containingServerIndex:i};if(this._bSelectAll&&this._aExpandedAfterSelectAll.indexOf(p)===-1){this.setNodeSelection(n,true);}return n;};
f.prototype._requestChildren=function(p,s,t,I){return new Promise(function(r,g){var R={sParent:p.key,iSkip:s,iTop:t};this._aPendingChildrenRequests.sort(function(a,b){return a.iSkip-b.iSkip;});for(var i=0;i<this._aPendingChildrenRequests.length;i++){var P=this._aPendingChildrenRequests[i];if(P.sParent===R.sParent){if(c._determineRequestDelta(R,P)===false){return;}}}s=R.iSkip;t=R.iTop;function _(D){var a=this._aPendingChildrenRequests.indexOf(R);this._aPendingChildrenRequests.splice(a,1);r({oData:D,iSkip:s,iTop:t});}function h(E){var a=this._aPendingChildrenRequests.indexOf(R);this._aPendingChildrenRequests.splice(a,1);g(E);}var U=["$skip="+s,"$top="+t];if(p.childCount==undefined||I){U.push("$inlinecount=allpages");}if(this.sCustomParams){U.push(this.sCustomParams);}var l=new F(this.oTreeProperties["hierarchy-parent-node-for"],"EQ",p.context.getProperty(this.oTreeProperties["hierarchy-node-for"]));var j=[l];if(this.aApplicationFilters){j=j.concat(this.aApplicationFilters);}var A=this.oModel.resolve(this.getPath(),this.getContext());if(A){R.oRequestHandle=this.oModel.read(A,{urlParameters:U,filters:[new F({filters:j,and:true})],sorters:this.aSorters||[],success:_.bind(this),error:h.bind(this),groupId:this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId});this._aPendingChildrenRequests.push(R);}}.bind(this));};
f.prototype._loadSubTree=function(p,l){var t=this;var m;if(p.serverIndex!==undefined&&!p.initiallyCollapsed){var M=[];var s;var S=p.serverIndex+1;var a=S+p.magnitude;for(var i=S;i<a;i++){if(this._aNodes[i]===undefined){if(!s){s={iSkip:i,iTop:1};M.push(s);}else{s.iTop++;}}else{s=null;}}if(M.length){m=Promise.all(M.map(function(o){return t._loadData(o.iSkip,o.iTop);}));}}if(!m){m=Promise.resolve();}return m.then(function(){t.fireDataRequested();return t._requestSubTree(p,l).then(function(r){t._addSubTree(r.oData,p);t.fireDataReceived({data:r.oData});},function(E){L.warning("ODataTreeBindingFlat: Error during subtree request",E.message);t.fireDataReceived();});});};
f.prototype._addSubTree=function(D,s){if(D.results&&D.results.length>0){var n,p,E,N,P,a=[],m={},i,j,k;if(s.serverIndex!==undefined&&!s.initiallyCollapsed){a=this._aNodes.slice(s.serverIndex,s.serverIndex+s.magnitude+1);}else{a.push(s);}for(j=a.length-1;j>=0;j--){N=a[j];if(N.nodeState.isLeaf){continue;}if(N.initiallyCollapsed||N.isDeepOne){N.childCount=undefined;if(N.magnitude&&N.nodeState.expanded){this._propagateMagnitudeChange(N.parent,-N.magnitude);}N.magnitude=0;}m[N.context.getProperty(this.oTreeProperties["hierarchy-node-for"])]=N;}for(i=0;i<D.results.length;i++){E=D.results[i];n=E[this.oTreeProperties["hierarchy-node-for"]];if(m[n]){continue;}p=E[this.oTreeProperties["hierarchy-parent-node-for"]];P=m[p];if(P.childCount===undefined){P.childCount=0;}N=P.children[P.childCount];if(N){a.push(N);if(N.childCount){N.childCount=undefined;if(N.initiallyCollapsed||N.isDeepOne){N.magnitude=0;}}}else{N=this._createChildNode(E,P,P.childCount);if(N.nodeState.expanded){this._aExpanded.push(N);this._sortNodes(this._aExpanded);}}P.childCount++;if(P.nodeState.expanded){this._propagateMagnitudeChange(P,1);}else{P.magnitude++;}if(!N.nodeState.isLeaf){m[n]=N;}}for(k=a.length-1;k>=0;k--){N=a[k];if(!N.nodeState.expanded&&!N.nodeState.isLeaf){this.expand(N,true);}}}};
f.prototype._requestSubTree=function(p,l){return new Promise(function(r,a){var R={sParent:p.key,iLevel:l};for(var i=0;i<this._aPendingSubtreeRequests.length;i++){var P=this._aPendingSubtreeRequests[i];if(P.sParent===R.sParent&&P.iLevel===R.iLevel){return;}}function _(D){var h=this._aPendingSubtreeRequests.indexOf(R);this._aPendingSubtreeRequests.splice(h,1);r({oData:D,sParent:R.sParent,iLevel:R.iLevel});}function b(E){var h=this._aPendingSubtreeRequests.indexOf(R);this._aPendingSubtreeRequests.splice(h,1);a(E);}var U=[];if(this.sCustomParams){U.push(this.sCustomParams);}var n=new F(this.oTreeProperties["hierarchy-node-for"],"EQ",p.context.getProperty(this.oTreeProperties["hierarchy-node-for"]));var o=new F(this.oTreeProperties["hierarchy-level-for"],"LE",l);var g=[n,o];if(this.aApplicationFilters){g=g.concat(this.aApplicationFilters);}var A=this.oModel.resolve(this.getPath(),this.getContext());if(A){R.oRequestHandle=this.oModel.read(A,{urlParameters:U,filters:[new F({filters:g,and:true})],sorters:this.aSorters||[],success:_.bind(this),error:b.bind(this),groupId:this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId});this._aPendingSubtreeRequests.push(R);}}.bind(this));};
f.prototype.findNode=function(r){return this._bReadOnly?this._indexFindNode(r):this._mapFindNode(r);};
f.prototype._mapFindNode=function(r){if(this.isInitial()){return;}var o=this._aNodeCache[r];if(o){return o;}var n=-1;this._map(function(N,R,i,I,p){n++;if(n===r){o=N;R.broken=true;}});return o;};
f.prototype._indexFindNode=function(r){if(this.isInitial()){return;}var n=this._aNodeCache[r];if(n){return n;}var N=this.getNodeInfoByRowIndex(r),n;if(N.parent){n=N.parent.children[N.childIndex];}else{n=this._aNodes[N.index];}this._aNodeCache[r]=n;return n;};
f.prototype.toggleIndex=function(r){var t=this.findNode(r);d(t!=undefined,"toggleIndex("+r+"): Node not found!");if(t){if(t.nodeState.expanded){this.collapse(t);}else{this.expand(t);}}};
f.prototype.expand=function(r,s){var t=r;if(typeof r!=="object"){t=this.findNode(r);d(t!=undefined,"expand("+r+"): Node not found!");}if(t.nodeState.expanded){return;}t.nodeState.expanded=true;t.nodeState.collapsed=false;var i=this._aCollapsed.indexOf(t);if(i!=-1){this._aCollapsed.splice(i,1);}this._aExpanded.push(t);this._sortNodes(this._aExpanded);if(t.serverIndex!==undefined){this._aNodeChanges[t.serverIndex]=true;}if(this._bSelectAll){this._aExpandedAfterSelectAll.push(t);}if(t.initiallyCollapsed&&t.childCount==undefined){this._loadChildren(t,0,this._iPageSize+this._iThreshold);}else{this._propagateMagnitudeChange(t.parent,t.magnitude);}this._cleanTreeStateMaps();this._aNodeCache=[];if(!s){this._fireChange({reason:C.Expand});}};
f.prototype.expandToLevel=function(l){this.setNumberOfExpandedLevels(l);};
f.prototype.expandNodeToLevel=function(i,l,s){if(!this._bReadOnly){return Promise.reject(new Error("ODataTreeBindingFlat: expandNodeToLevel is not supported while there are pending changes in the hierarchy"));}var S=this.findNode(i);return this._loadSubTree(S,l).then(function(){if(!s){this._fireChange({reason:C.Expand});}}.bind(this));};
f.prototype.collapse=function(r,s){var t=r;if(typeof r!=="object"){t=this.findNode(r);d(t!=undefined,"expand("+r+"): Node not found!");}if(t.nodeState.collapsed){return;}t.nodeState.expanded=false;t.nodeState.collapsed=true;var i=this._aExpanded.indexOf(t);if(i!=-1){this._aExpanded.splice(i,1);}if(this._bSelectAll){i=this._aExpandedAfterSelectAll.indexOf(t);if(i!==-1){this._aExpandedAfterSelectAll.splice(i,1);}}this._aCollapsed.push(t);this._sortNodes(this._aCollapsed);if(t.isDeepOne){this._propagateMagnitudeChange(t.parent,t.magnitude*-1);}if(t.serverIndex!==undefined){this._aNodeChanges[t.serverIndex]=true;}this._cleanUpSelection();this._cleanTreeStateMaps();this._aNodeCache=[];if(!s){this._fireChange({reason:C.Collapse});}};
f.prototype.collapseToLevel=function(l){var o=-1,a=[],r;if(this.bCollapseRecursive){for(var k in this._mSelected){var s=this._mSelected[k];if(s.level>l){r=this.getRowIndexByNode(s);a.push(r);if(this._sLeadSelectionKey==k){o=r;}this.setNodeSelection(s,false);}}}this.setNumberOfExpandedLevels(l);if(this.bCollapseRecursive&&a.length){this._publishSelectionChanges({rowIndices:a,oldIndex:o,leadIndex:-1});}};
f.prototype._getInvisibleSelectedNodes=function(){var a=[];var i=true;var b=function(n,B){if(n.nodeState.collapsed||(n.nodeState.removed&&!n.nodeState.reinserted)){i=false;B.broken=true;}};for(var k in this._mSelected){var s=this._mSelected[k];i=true;this._up(s,b,false);if(!i){a.push(s);}}return a;};
f.prototype._cleanUpSelection=function(b){var i=this._getInvisibleSelectedNodes();i.forEach(function(s){if(s.key==this._sLeadSelectionKey){this._sLeadSelectionKey=null;}if(this.bCollapseRecursive||b){this.setNodeSelection(s,false);}}.bind(this));if((this.bCollapseRecursive||b)&&i.length){this._publishSelectionChanges({rowIndices:[],indexChangesCouldNotBeDetermined:true});}};
f.prototype._isInSubtree=function(a,o){var i=false;var b=function(n,B){if(n==a){B.broken=true;i=true;}};this._up(o,b,false);return i;};
f.prototype._up=function(n,U,o){var r={broken:false};var p=this._getParent(n,o);if(p){this._structuralUp(p,U,r,o);}else{this._flatUp(n,U,r,true);}};
f.prototype._structuralUp=function(n,U,b,o){var p=n;do{U(p,b);if(b.broken){return;}n=p;p=this._getParent(p);}while(p);this._flatUp(n,U,b);};
f.prototype._flatUp=function(n,U,b,I){var s=n.serverIndex,i=I?s-1:s,o,p;for(;i>=0;i--){if(this._aNodeChanges[i]){o=this._aNodes[i];if(o.initiallyCollapsed){continue;}if(o.serverIndex+o.magnitude>=s){U(o,b);if(b.broken){return;}p=this._getParent(o);if(p){this._structuralUp(p,U,b);return;}}else{continue;}}}};
f.prototype._getParent=function(n,o){return o?n.originalParent:n.parent;};
f.prototype._cleanTreeStateMaps=function(){this._iLengthDelta=this._bReadOnly?this._indexCleanTreeStateMaps():this._mapCleanTreeStateMaps();};
f.prototype._indexCleanTreeStateMaps=function(){return this._calcIndexDelta(this._aNodes.length);};
f.prototype._mapCleanTreeStateMaps=function(){var a=this._aCollapsed.concat(this._aRemoved).concat(this._aExpanded).concat(this._aAdded),v=true,V,D=0,b=function(n,B){if(n.nodeState.collapsed||(n.nodeState.removed&&!n.nodeState.reinserted)){v=false;B.broken=true;}},s={};var g=[[0,1],[-1,0]];a.forEach(function(n){if(s[n.key]){return;}else{s[n.key]=true;}if(n.nodeState.added){if(!n.nodeState.removed||n.nodeState.reinserted){v=true;this._up(n,b,false);if(v){D++;}}}else{if(n.nodeState.collapsed||n.nodeState.expanded||n.nodeState.removed){v=true;this._up(n,b,false);if(v){if(n.nodeState.removed&&!n.nodeState.reinserted){if(n.isDeepOne||n.initiallyCollapsed){D-=1;}else{D-=(n.magnitude+1);}}else{if(n.nodeState.collapsed&&n.serverIndex!==undefined&&!n.initiallyCollapsed){D-=n.magnitude;}if(n.nodeState.expanded&&(n.isDeepOne||n.initiallyCollapsed)){D+=n.children.length;}}}if(n.nodeState.reinserted){V=v;v=true;this._up(n,b,true);var i=(g[v|0][V|0]);if(!!i){if(n.isDeepOne){D+=i*1;}else{if(n.initiallyCollapsed){D+=i;}else{D+=i*(1+n.magnitude);}}}}}}}.bind(this));return D;};
f.prototype.isLengthFinal=function(){return this._bLengthFinal;};
f.prototype.getLength=function(){return this._aNodes.length+this._iLengthDelta;};
f.prototype.getContextByIndex=function(r){if(this.isInitial()){return;}var n=this.findNode(r);return n&&n.context;};
f.prototype.getNodeByIndex=function(r){if(this.isInitial()){return;}var n=this.findNode(r);return n;};
f.prototype.isExpanded=function(r){var n=this.findNode(r);return n&&n.nodeState.expanded;};
f.prototype.hasChildren=function(o){if(!o){return false;}var n=this._findNodeByContext(o);var N=n&&n.node;return!(N&&N.nodeState.isLeaf);};
f.prototype.nodeHasChildren=function(n){return!(n&&n.nodeState.isLeaf);};
f.prototype.setNodeSelection=function(n,i){d(n,"Node must be defined!");n.nodeState.selected=i;if(i){delete this._mDeselected[n.key];this._mSelected[n.key]=n;}else{delete this._mSelected[n.key];this._mDeselected[n.key]=n;if(n.key===this._sLeadSelectionKey){this._sLeadSelectionKey=null;}}};
f.prototype.isIndexSelected=function(r){var n=this.findNode(r);return n&&n.nodeState?n.nodeState.selected:false;};
f.prototype.isIndexSelectable=function(r){var n=this.findNode(r);return!!n;};
f.prototype._clearSelection=function(){return this._bReadOnly?this._indexClearSelection():this._mapClearSelection();};
f.prototype._indexClearSelection=function(){var o=-1,a=[],s,n,r;this._bSelectAll=false;this._aExpandedAfterSelectAll=[];for(s in this._mSelected){n=this._mSelected[s];this.setNodeSelection(n,false);r=this.getRowIndexByNode(n);a.push(r);if(this._sLeadSelectionKey==s){o=r;}}return{rowIndices:a,oldIndex:o,leadIndex:-1};};
f.prototype._mapClearSelection=function(){var n=-1;var o=-1;var m=0;var a=[];this._bSelectAll=false;this._aExpandedAfterSelectAll=[];for(var k in this._mSelected){if(k){m++;}}this._map(function(N,r,i,I,p){n++;if(N&&N.nodeState.selected){this.setNodeSelection(N,false);a.push(n);if(this._sLeadSelectionKey==N.key){o=n;}if(a.length==m){r.broken=true;}}}.bind(this));return{rowIndices:a,oldIndex:o,leadIndex:-1};};
f.prototype.setSelectedIndex=function(r){var n=this.findNode(r);if(n){var o=this._clearSelection();var i=o.rowIndices.indexOf(r);if(i>=0){o.rowIndices.splice(i,1);}else{o.rowIndices.push(r);}o.leadKey=n.key;o.leadIndex=r;this.setNodeSelection(n,true);this._publishSelectionChanges(o);}else{L.warning("ODataTreeBindingFlat: The selection of index '"+r+"' was ignored. Please make sure to only select rows, for which data has been fetched to the client.");}};
f.prototype.getSelectedIndex=function(){return this._bReadOnly?this._indexGetSelectedIndex():this._mapGetSelectedIndex();};
f.prototype._indexGetSelectedIndex=function(){if(!this._sLeadSelectionKey||e(this._mSelected)){return-1;}var s=this._mSelected[this._sLeadSelectionKey];if(s){return this.getRowIndexByNode(s);}else{return-1;}};
f.prototype._mapGetSelectedIndex=function(){if(!this._sLeadSelectionKey||e(this._mSelected)){return-1;}var n=-1;this._map(function(N,r){n++;if(N){if(N.key===this._sLeadSelectionKey){r.broken=true;}}}.bind(this));return n;};
f.prototype.getSelectedIndices=function(){return this._bReadOnly?this._indexGetSelectedIndices():this._mapGetSelectedIndices();};
f.prototype._indexGetSelectedIndices=function(){var n=this._getSelectedNodesInfo();return n.map(function(N){return N.rowIndex;});};
f.prototype._mapGetSelectedIndices=function(){var r=[];if(e(this._mSelected)){return r;}var n=-1;this._map(function(N){n++;if(N){if(N.nodeState&&N.nodeState.selected){r.push(n);}}});return r;};
f.prototype.getSelectedNodesCount=function(){var s;if(this._bSelectAll){if(this._bReadOnly){var r=[],n=0,k;this._aExpandedAfterSelectAll.sort(function(a,b){var A=this._getRelatedServerIndex(a);var B=this._getRelatedServerIndex(b);d(A!=undefined,"getSelectedNodesCount: (containing) Server-Index not found for node 'a'");d(B!=undefined,"getSelectedNodesCount: (containing) Server-Index not found node 'b'");if(A==B&&a.isDeepOne&&b.isDeepOne){return a.originalLevel-b.originalLevel;}return A-B;}.bind(this));var l=-1,N,g,i;for(i=0;i<this._aExpandedAfterSelectAll.length;i++){N=this._aExpandedAfterSelectAll[i];g=this._getRelatedServerIndex(N);if(g<=l&&!N.initiallyCollapsed){continue;}if(N.initiallyCollapsed){l=g;}else{l=g+N.magnitude;}r.push(N);n+=N.magnitude;}var h=function(N,b){if(r.indexOf(N)!==-1){n--;b.broken=true;}};for(k in this._mSelected){this._up(this._mSelected[k],h,true);}var I;var j=function(N,b){if(N.nodeState.collapsed||(N.nodeState.removed&&!N.nodeState.reinserted)||r.indexOf(N)!==-1){I=false;b.broken=true;}};for(k in this._mDeselected){I=true;this._up(this._mDeselected[k],j,true);if(I){n++;}}s=this.getLength()-n;}else{s=0;this._map(function(N,R,a,b,p){var P;if(N){if(N.nodeState.selected){s++;}}else if(N===undefined&&a==="serverIndex"){var o=true;for(var i=b-1;i>=0;i--){if(this._aNodeChanges[i]){P=this._aNodes[i];if(P.serverIndex+P.magnitude>=b&&this._aExpandedAfterSelectAll.indexOf(P)!==-1){o=false;break;}}}if(o){s++;}}}.bind(this));}}else{var m=this._getInvisibleSelectedNodes();s=Math.max(Object.keys(this._mSelected).length-m.length,0);}return s;};
f.prototype.getSelectedContexts=function(){return this._bReadOnly?this._indexGetSelectedContexts():this._mapGetSelectedContexts();};
f.prototype._indexGetSelectedContexts=function(){var n=this._getSelectedNodesInfo();return n.map(function(N){return N.node.context;});};
f.prototype._mapGetSelectedContexts=function(){var r=[];if(e(this._mSelected)){return r;}var m=function(n){if(n){if(n.nodeState.selected&&!n.isArtificial){r.push(n.context);}}};this._map(m);return r;};
f.prototype.setSelectionInterval=function(a,t){var m=this._clearSelection();var s=this._setSelectionInterval(a,t,true);var I={};var r=[];var b;for(var i=0;i<m.rowIndices.length;i++){b=m.rowIndices[i];I[b]=true;}for(i=0;i<s.rowIndices.length;i++){b=s.rowIndices[i];if(I[b]){delete I[b];}else{I[b]=true;}}for(b in I){if(I[b]){r.push(parseInt(b));}}this._publishSelectionChanges({rowIndices:r,oldIndex:m.oldIndex,leadIndex:s.leadIndex,leadKey:s.leadKey});};
f.prototype._setSelectionInterval=function(i,t,s){return this._bReadOnly?this._indexSetSelectionInterval(i,t,s):this._mapSetSelectionInterval(i,t,s);};
f.prototype._indexSetSelectionInterval=function(a,t,s){var n=Math.min(a,t),N=Math.max(a,t),b=[],g=[],o,h,i,p;s=!!s;for(i=n;i<=N;i++){h=this.findNode(i);if(h){if(h.nodeState.selected!==s){g.push(i);}if(h.key===this._sLeadSelectionKey){o=i;}this.setNodeSelection(h,s);b.push(h);}}p={rowIndices:g,oldIndex:o,leadIndex:o&&!s?-1:undefined};if(b.length>0&&s){p.leadKey=b[b.length-1].key;p.leadIndex=N;}return p;};
f.prototype._mapSetSelectionInterval=function(i,t,s){var n=Math.min(i,t);var N=Math.max(i,t);var a=[];var b=[];var g=Math.abs(N-n)+1;var o;var h=-1;var m=function(j,r,I,k,P){h++;if(j){if(h>=n&&h<=N){if(j.nodeState.selected!==!!s){b.push(h);}if(j.key===this._sLeadSelectionKey){o=h;}this.setNodeSelection(j,!!s);a.push(j);if(a.length===g){r.broken=true;}}}}.bind(this);this._map(m);var p={rowIndices:b,oldIndex:o,leadIndex:o&&!s?-1:undefined};if(a.length>0&&s){var l=a[a.length-1];p.leadKey=l.key;p.leadIndex=N;}return p;};
f.prototype.addSelectionInterval=function(i,t){var p=this._setSelectionInterval(i,t,true);this._publishSelectionChanges(p);};
f.prototype.removeSelectionInterval=function(i,t){var p=this._setSelectionInterval(i,t,false);this._publishSelectionChanges(p);};
f.prototype.selectAll=function(){this._bReadOnly?this._indexSelectAll():this._mapSelectAll();};
f.prototype._indexSelectAll=function(){this._bSelectAll=true;this._aExpandedAfterSelectAll=[];var p={rowIndices:[],oldIndex:-1,selectAll:true};var l=this.getLength(),i,n;for(i=0;i<l;i++){n=this.findNode(i);if(n&&!n.isArtificial){if(n.key===this._sLeadSelectionKey){p.oldIndex=i;}if(!n.nodeState.selected){p.rowIndices.push(i);}this.setNodeSelection(n,true);p.leadKey=n.key;p.leadIndex=i;}}this._publishSelectionChanges(p);};
f.prototype._mapSelectAll=function(){this._bSelectAll=true;this._aExpandedAfterSelectAll=[];var p={rowIndices:[],oldIndex:-1,selectAll:true};var n=-1;this._map(function(N){if(!N||!N.isArtificial){n++;}if(N){if(N.key===this._sLeadSelectionKey){p.oldIndex=n;}if(N){if(!N.isArtificial&&!N.nodeState.selected){p.rowIndices.push(n);}this.setNodeSelection(N,true);p.leadKey=N.key;p.leadIndex=n;}}}.bind(this));this._publishSelectionChanges(p);};
f.prototype.clearSelection=function(s){var o=this._clearSelection();if(!s){this._publishSelectionChanges(o);}};
f.prototype._publishSelectionChanges=function(p){p.oldIndex=p.oldIndex||this.getSelectedIndex();p.rowIndices.sort(function(a,b){return a-b;});if(p.leadIndex>=0&&p.leadKey){this._sLeadSelectionKey=p.leadKey;}else if(p.leadIndex===-1){this._sLeadSelectionKey=undefined;}else{p.leadIndex=p.oldIndex;}if(p.rowIndices.length>0||(p.leadIndex!=undefined&&p.leadIndex!==-1)||p.indexChangesCouldNotBeDetermined){this.fireSelectionChanged(p);}};
f.prototype.setCollapseRecursive=function(b){this.bCollapseRecursive=!!b;};
f.prototype.resetData=function(){O.prototype.resetData.apply(this,arguments);this._aNodes=[];this._aNodeCache=[];this._aCollapsed=[];this._aExpanded=[];this._aExpandedAfterSelectAll=[];this._mSelected={};this._mDeselected={};this._aAdded=[];this._aRemoved=[];this._aNodeChanges=[];this._aAllChangedNodes=[];this._bLengthFinal=false;this._iLowestServerLevel=null;this._bSelectAll=false;this._bReadOnly=true;this._iLengthDelta=0;};
f.prototype._findNodeByContext=function(o){for(var i in this._aNodeCache){if(this._aNodeCache[i]&&this._aNodeCache[i].context==o){return{node:this._aNodeCache[i],index:parseInt(i)};}}var n=-1;var N;this._map(function(a,r,I,b,p){n++;if(a){if(a.context===o){N=a;r.broken=true;}}});return{node:N,index:n};};
f.prototype._getCorrectChangeGroup=function(k){if(!k){k=this.oModel.resolve(this.getPath(),this.getContext());}return this.oModel._resolveGroup(k).groupId;};
f.prototype.createEntry=function(p){var a=this.oModel.resolve(this.getPath(),this.getContext());var n;if(a){p=p||{};p.groupId=this._getCorrectChangeGroup(a);p.refreshAfterChange=false;n=this.oModel.createEntry(a,p);}else{L.warning("ODataTreeBindingFlat: createEntry failed, as the binding path could not be resolved.");}return n;};
f.prototype.submitChanges=function(p){p=p||{};var a=this.oModel.resolve(this.getPath(),this.getContext()),o=this._optimizeChanges();if(!a){L.warning("ODataTreeBindingFlat: submitChanges failed, because the binding-path could not be resolved.");return;}p.groupId=this._getCorrectChangeGroup(a);var b=p.success||function(){};var g=p.error||function(){};var r=false;p.success=function(D){b(D);var s=false;if(D.__batchResponses&&D.__batchResponses[0]&&D.__batchResponses[0].__changeResponses&&D.__batchResponses[0].__changeResponses.length>0){var h=D.__batchResponses[0].__changeResponses;for(var i=0;i<h.length;i++){var R=h[i];var S=parseInt(R.statusCode);if(S<200||S>299){s=true;break;}}if(s){}else if(this._bRestoreTreeStateAfterChange&&!r&&(!this.aApplicationFilters||this.aApplicationFilters.length===0)){this._restoreTreeState(o).catch(function(j){L.error("ODataTreeBindingFlat - "+j.message,j.stack);this._refresh(true);}.bind(this));}else{this._refresh(true);}}else{L.warning("ODataTreeBindingFlat.submitChanges - success: Batch-request response does not contain change response.");}}.bind(this);p.error=function(E){g(E);};this._generateSubmitData(o,function(h){L.error("ODataTreeBindingFlat - Tree state restoration request failed. "+h.message,h.stack);r=true;});this.oModel.submitChanges(p);};
f.prototype._generateSubmitData=function(o,r){var R=o.removed,a=o.creationCancelled,A=o.added,m=o.moved,t=this;function s(n){d(n.context,"Node does not have a context.");var p=n.parent.context.getProperty(t.oTreeProperties["hierarchy-node-for"]);t.oModel.setProperty(t.oTreeProperties["hierarchy-parent-node-for"],p,n.context);}var b={groupId:this._getCorrectChangeGroup(),error:r};A.forEach(s);m.forEach(function(n){s(n);if(this._bRestoreTreeStateAfterChange&&(!this.aApplicationFilters||this.aApplicationFilters.length===0)){this._generatePreorderPositionRequest(n,b);this._generateSiblingsPositionRequest(n,b);}}.bind(this));R.forEach(function(n){this._generateDeleteRequest(n);L.debug("ODataTreeBindingFlat: DELETE "+n.key);}.bind(this));a.forEach(function(n){this._generateDeleteRequest(n);}.bind(this));};
f.prototype._generatePreorderPositionRequest=function(n,p){var g,k,K,U,s,a,b=[],S=this.aSorters||[],i;if(p){g=p.groupId||this.sGroupId;s=p.success;a=p.error;}if(this.aApplicationFilters){b=b.concat(this.aApplicationFilters);}for(i=this._aTreeKeyProperties.length-1;i>=0;i--){k=this._aTreeKeyProperties[i];if(!K){K=k;}else{K+=","+k;}b.push(new F(k,"EQ",n.context.getProperty(k)));}b.push(new F(this.oTreeProperties["hierarchy-level-for"],"LE",this.getNumberOfExpandedLevels()));U=q.extend({},this.mParameters);U.select=K+","+this.oTreeProperties["hierarchy-node-for"]+","+this.oTreeProperties["hierarchy-node-descendant-count-for"]+","+this.oTreeProperties["hierarchy-drill-state-for"]+","+this.oTreeProperties["hierarchy-preorder-rank-for"];var A=this.oModel.resolve(this.getPath(),this.getContext());if(A){this.oModel.read(A,{urlParameters:this.oModel.createCustomParams(U),filters:[new F({filters:b,and:true})],sorters:S,groupId:g,success:s,error:a});}};
f.prototype._generateSiblingsPositionRequest=function(n,p){var g,U,s,a;if(p){g=p.groupId||this.sGroupId;s=p.success;a=p.error;}U=q.extend({},this.mParameters);U.select=this.oTreeProperties["hierarchy-sibling-rank-for"];this.oModel.read(n.context.getPath(),{urlParameters:this.oModel.createCustomParams(U),groupId:g,success:s,error:a});};
f.prototype._nodeIsOnTopLevel=function(n){if(n&&n.serverIndex>=0){var p=n.parent==null;if(p){if(n.originalLevel==this._iLowestServerLevel){return true;}else{return false;}}}else{L.warning("ODataTreeBindingFlat.nodeIsOnTopLevel: Node is not defined or not a server-indexed node.");}};
f.prototype._generateDeleteRequest=function(n){var o=n.context;if(n.nodeState.added){this.oModel.deleteCreatedEntry(o);}else{var D=this.oModel.remove(o.getPath(),{groupId:this._getCorrectChangeGroup(),refreshAfterChange:false});return D;}};
f.prototype._filterChangeForServerSections=function(o){var a={};a.removed=o.removed.filter(function(r){return!r.isDeepOne;});a.added=o.added.filter(function(A){return!A.isDeepOne;});o.moved.forEach(function(m){if(!m.newIsDeepOne){a.added.push(m);}if(!m.isDeepOne){a.removed.push(m);}});return a;};
f.prototype._filterChangesForDeepSections=function(o){var m={};o.removed.forEach(function(r){var p;if(r.isDeepOne){p=r.parent;if(!m[p.key]){m[p.key]={added:[],removed:[]};}m[p.key].removed.push(r);}});o.added.forEach(function(a){var p;if(a.isDeepOne){p=a.parent;if(!m[p.key]){m[p.key]={added:[],removed:[]};}m[p.key].added.push(a);}});o.moved.forEach(function(M){var p;if(M.newIsDeepOne){p=M.parent;if(!m[p.key]){m[p.key]={added:[],removed:[]};}m[p.key].added.push(M);}if(M.isDeepOne){p=M.originalParent;if(!m[p.key]){m[p.key]={added:[],removed:[]};}m[p.key].removed.push(M);}});return m;};
f.prototype._optimizeOptimizedChanges=function(o){var A,t=this;A=o.added.slice();A.sort(function(a,b){var I=a.newIsDeepOne!==undefined?a.newIsDeepOne:a.isDeepOne,g=b.newIsDeepOne!==undefined?b.newIsDeepOne:b.isDeepOne;if(I&&g){return 0;}if(I){return 1;}if(g){return-1;}return a.context.getProperty(t.oTreeProperties["hierarchy-preorder-rank-for"])-b.context.getProperty(t.oTreeProperties["hierarchy-preorder-rank-for"]);});var i=-1;A=A.filter(function(n,a){if(n.newIsDeepOne!==undefined?n.newIsDeepOne:n.isDeepOne){return true;}if(a<=i){return false;}var m=n.context.getProperty(t.oTreeProperties["hierarchy-node-descendant-count-for"]);if(m){i=a+m;}return true;});return{added:A,removed:o.removed,moved:o.moved};};
f.prototype._updateNodeInfoAfterSave=function(n){var i=n.context.getProperty(this.oTreeProperties["hierarchy-preorder-rank-for"])===undefined;if(n.isDeepOne===undefined){n.isDeepOne=i;}else{n.newIsDeepOne=i;}var I=n.context.getProperty(this.oTreeProperties["hierarchy-drill-state-for"])==="collapsed";if(n.initiallyCollapsed===undefined){n.initiallyCollapsed=I;}else{n.newInitiallyCollapsed=I;}};
f.prototype._requestExtraInfoForAddedNodes=function(a){var P=[],t=this;a.forEach(function(n){var p=new Promise(function(r,b){t._generatePreorderPositionRequest(n,{success:r,error:b});});P.push(p);});P=P.map(function(p){return p.then(function(r){return{responseData:r};},function(E){return{error:E};});});return Promise.all(P).then(function(D){var A=0;D.forEach(function(o){if(o.error){if(o.error.statusCode===0){A++;}else{throw new Error("Tree state restoration request failed. Complete or partial tree state might get lost. Error: "+(o.error.message.value||o.error.message));}}});return A===0;});};
f.prototype._restoreTreeState=function(o){var t=this;this._abortPendingRequest();o=o||{creationCancelled:[],added:[],removed:[],moved:[]};this.fireDataRequested();return this._requestExtraInfoForAddedNodes(o.added).then(function(n){if(n){return t._executeRestoreTreeState(o).then(function(D){if(D){t._fireChange({reason:C.Change});t.fireDataReceived({data:D});return D;}});}});};
f.prototype._executeRestoreTreeState=function(o){var a,s,S,D,b,m,p,i,j,k,l,g,h,t=this;o.added.forEach(this._updateNodeInfoAfterSave.bind(this));o.moved.forEach(this._updateNodeInfoAfterSave.bind(this));p=[];S=this._collectServerSections(this._aNodes);o=this._optimizeOptimizedChanges(o);g=this._filterChangeForServerSections(o);this._adaptSections(S,g);for(i=0;i<S.length;i++){s=S[i];p.push(this._restoreServerIndexNodes(s.iSkip,s.iTop,i===0));}var n=this._collectDeepNodes();h=this._filterChangesForDeepSections(o);for(j=0;j<n.length;j++){D=n[j];if(h){g=h[D.oParentNode.key];if(g){this._adaptSections(D.aChildSections,g,{indexName:"positionInParent",ignoreMagnitude:true});}}for(k=0;k<D.aChildSections.length;k++){b=D.aChildSections[k];p.push(this._restoreChildren(D.oParentNode,b.iSkip,b.iTop));}}m={};for(l=0;l<this._aCollapsed.length;l++){m[this._aCollapsed[l].key]=true;}a=this._aCollapsed.length;this.resetData(true);function r(){if(a>0){t._map(function(N,R){if(N&&m[N.key]){t.collapse(N,true);a--;if(a===0){R.broken=true;}}});}}p=p.map(function(v){return v.then(function(R){return{responseData:R};},function(E){return{error:E};});});return Promise.all(p).then(function(v){var A=0;v.forEach(function(w){if(w.error){if(w.error.statusCode===0){A++;}else{throw new Error("Tree state restoration request failed. Complete or partial tree state might get lost. Error: "+(w.error.message.value||w.error.message));}}});if(A<v.length){r();return v;}});};
f.prototype._collectServerSections=function(n){var s=[];var S;for(var i=0;i<n.length;i++){if(n[i]!==undefined){if(!S){S={iSkip:i,iTop:1};s.push(S);}else{S.iTop++;}}else{S=null;}}return s;};
f.prototype._adaptSections=function(s,o,g){var r=o.removed||[],A=o.added||[],I=(g&&g.indexName)||"serverIndex",N,S,h,R,p,t=0,M,P,v,w,x,y,z,B=0,D,E,G=[];for(var l=A.length-1;l>=0;l--){N=A[l];if(N.newIsDeepOne!==undefined?N.newIsDeepOne:N.isDeepOne){E=this.oTreeProperties["hierarchy-sibling-rank-for"];}else{E=this.oTreeProperties["hierarchy-preorder-rank-for"];if(N.newInitiallyCollapsed!==undefined?!N.newInitiallyCollapsed:!N.initiallyCollapsed){M=N.context.getProperty(this.oTreeProperties["hierarchy-node-descendant-count-for"]);}}P=N.context.getProperty(E);if(P===undefined){L.warning("ODataTreeBindingFlat","Missing "+E+" value for node "+N.key);break;}G.push({position:P,magnitude:M||0,assignedToSection:false});}for(var i=0;i<s.length;i++){S=s[i];z=B;v=w;w=0;D=0;for(var j=r.length-1;j>=0;j--){N=r[j];P=N[I];if(P>=S.iSkip&&P<=S.iSkip+S.iTop){if(I==="serverIndex"){t++;}M=(g&&g.ignoreMagnitude)?0:this._getInitialMagnitude(N);p=(1+M);R=(S.iSkip+S.iTop)-P-p;if(R>0){D-=p;}else{D-=(S.iSkip+S.iTop)-P;if(R<0){w=P+p;}}z-=p;}}if(S.iSkip<=v){x=S.iSkip-v;D+=x;if(S.iTop+D<0){w=v;}}S.iSkip+=B;S.iTop+=D;if(S.iTop>0){B=0;D=0;for(var k=0;k<G.length;k++){h=G[k];P=h.position;y=(g&&g.ignoreMagnitude)?1:h.magnitude+1;if(P>=S.iSkip&&P<=S.iSkip+S.iTop){D+=y;G[k].assignedToSection=true;}else if(P<S.iSkip){B+=y;}}S.iSkip+=B;S.iTop+=D;S.iTop+=t;}if(S.iTop<=0){s.splice(i,1);i--;}B=z;}for(var m=0;m<G.length;m++){h=G[m];y=(g&&g.ignoreMagnitude)?1:h.magnitude+1;if(!h.assignedToSection){s.push({iSkip:h.position,iTop:y});}}s.sort(function(a,b){return a.iSkip-b.iSkip;});for(var n=0;n<s.length;n++){if(n+1<s.length){S=s[n];var H=s[n+1];if(S.iSkip+S.iTop===H.iSkip){S.iTop+=H.iTop;s.splice(n+1,1);n--;}}}};
f.prototype._optimizeChanges=function(){var r=[],g=[],A=[],m=[];var I=false;var h=function(N,b){if(N.nodeState.removed&&!N.nodeState.reinserted){I=true;b.broken=true;}};var p=[];var t=function(N){if((N.isDeepOne||N.serverIndex>=0)&&p.indexOf(N)==-1){p.push(N);}if(N.nodeState.added){g.push(N);}};this._aAllChangedNodes.forEach(function(N){I=false;this._up(N,h,false);if(I){t(N);}else{if(N.nodeState.removed&&!N.nodeState.reinserted){t(N);}else if(N.nodeState.added){A.push(N);}else{m.push(N);}}}.bind(this));p.sort(function(a,b){var j=this._getRelatedServerIndex(a);var B=this._getRelatedServerIndex(b);d(j!=undefined,"_generateSubmitData: (containing) Server-Index not found for node 'a'");d(B!=undefined,"_generateSubmitData: (containing) Server-Index not found node 'b'");if(j==B&&a.isDeepOne&&b.isDeepOne){if(a.parent===b.parent){return a.positionInParent-b.positionInParent;}else{return a.originalLevel-b.originalLevel;}}return j-B;}.bind(this));var n=function(D){var b=false;this._up(D,function(P,B){if(P.nodeState.removed&&!P.nodeState.reinserted){b=true;B.broken=true;}},true);return b;}.bind(this);for(var i=0;i<p.length;i++){var D=p[i];if(!n(D)){r.push(D);}}return{removed:r,creationCancelled:g,added:A,moved:m};};
f.prototype._collectDeepNodes=function(){var D=[],t=this;this._map(function(n){if(n&&n.nodeState.expanded&&((n.initiallyCollapsed||n.isDeepOne))){D.push({oParentNode:n,aChildSections:t._collectServerSections(n.children)});}});return D;};
f.prototype._trackChangedNode=function(n){if(this._aAllChangedNodes.indexOf(n)==-1){this._aAllChangedNodes.push(n);}};
f.prototype.addContexts=function(p,v){var n=this._findNodeByContext(p),N=n.node,m=this.getModel(),o,a;d(p&&v,"ODataTreeBinding.addContexts() was called with incomplete arguments!");if(N){this._bReadOnly=false;if(N.nodeState&&N.nodeState.isLeaf){N.nodeState.isLeaf=false;N.nodeState.collapsed=true;}if(!Array.isArray(v)){if(v instanceof sap.ui.model.Context){v=[v];}else{L.warning("ODataTreeBinding.addContexts(): The child node argument is not of type sap.ui.model.Context.");}}var b=function(g){return function(){return[g];};};v=v.slice();v.reverse();for(var j=0;j<v.length;j++){var a=v[j];if(!a||!(a instanceof sap.ui.model.Context)){L.warning("ODataTreeBindingFlat.addContexts(): no valid child context given!");return;}var o=this._mSubtreeHandles[a.getPath()];this._ensureHierarchyNodeIDForContext(a);if(o&&o._isRemovedSubtree){L.info("ODataTreeBindingFlat.addContexts(): Existing context added '"+a.getPath()+"'");o._oNewParentNode=N;o._oSubtreeRoot.nodeState.reinserted=true;o._oSubtreeRoot.originalParent=o._oSubtreeRoot.originalParent||o._oSubtreeRoot.parent;o._oSubtreeRoot.parent=N;o._oSubtreeRoot.containingSubtreeHandle=o;a=o.getContext();this._trackChangedNode(o._oSubtreeRoot);this._mSubtreeHandles[a.getPath()];}else{L.info("ODataTreeBindingFlat.addContexts(): Newly created context added.");this._ensureHierarchyNodeIDForContext(a);var g={context:a,key:m.getKey(a),parent:N,nodeState:{isLeaf:true,collapsed:false,expanded:false,selected:false,added:true},addedSubtrees:[],children:[],magnitude:0};this._trackChangedNode(g);this._aAdded.push(g);o={_getSubtree:b(g),_oSubtreeRoot:null,_oNewParentNode:N};}o._iContainingServerIndex=N.serverIndex||N.containingServerIndex;N.addedSubtrees.unshift(o);if(N.serverIndex!==undefined){this._aNodeChanges[N.serverIndex]=true;}}this._aNodeCache=[];this._cleanTreeStateMaps();this._fireChange({reason:C.Add});}else{L.warning("The given parent context could not be found in the tree. No new sub-nodes were added!");}};
f.prototype._ensureHierarchyNodeIDForContext=function(o){if(o){var n=o.getProperty(this.oTreeProperties["hierarchy-node-for"]);if(o.bCreated&&!n){this.oModel.setProperty(this.oTreeProperties["hierarchy-node-for"],u(),o);}}};
f.prototype.removeContext=function(o){var t=this;var n=this._findNodeByContext(o);var N=n.node;var i=n.index;if(N){this._bReadOnly=false;N.nodeState.removed=true;this._aRemoved.push(N);this._trackChangedNode(N);if(N.serverIndex!==undefined){this._aNodeChanges[N.serverIndex]=true;}if(N.containingSubtreeHandle&&N.parent!=null){var a=N.parent.addedSubtrees.indexOf(N.containingSubtreeHandle);if(a!=-1){N.parent.addedSubtrees.splice(a,1);N.nodeState.reinserted=false;N.parent=null;}}this._aNodeCache=[];this.setNodeSelection(N,false);this._cleanUpSelection(true);this._cleanTreeStateMaps();this._fireChange({reason:C.Remove});this._mSubtreeHandles[o.getPath()]={_removedFromVisualIndex:i,_isRemovedSubtree:true,_oSubtreeRoot:N,_getSubtree:function(){if(N.serverIndex!=undefined&&!N.initiallyCollapsed){return t._aNodes.slice(N.serverIndex,N.serverIndex+N.magnitude+1);}else{return N;}},getContext:function(){return o;},_restore:function(){N.nodeState.removed=false;var b=t._aRemoved.indexOf(N);if(b!=-1){t._aRemoved.splice(b,1);}this._aNodeCache=[];t._cleanTreeStateMaps();t._fireChange({reason:C.Add});}};return o;}else{L.warning("ODataTreeBinding.removeContexts(): The given context is not part of the tree. Was it removed already?");}};
f.prototype._getRelatedServerIndex=function(n){if(n.serverIndex===undefined){return n.containingServerIndex;}else{return n.serverIndex;}};
f.prototype.getNodeInfoByRowIndex=function(r){var i=0,E=0,n,t,v=-1;while(i<this._aCollapsed.length||E<this._aExpanded.length){if(this._aCollapsed[i]&&this._aExpanded[E]){if(this._getRelatedServerIndex(this._aCollapsed[i])>this._getRelatedServerIndex(this._aExpanded[E])){n=this._aExpanded[E];E++;t=false;}else{n=this._aCollapsed[i];i++;t=true;}}else if(this._aCollapsed[i]){n=this._aCollapsed[i];i++;t=true;}else{n=this._aExpanded[E];E++;t=false;}if(r<=this._getRelatedServerIndex(n)){break;}if(t){if(!n.isDeepOne&&!n.initiallyCollapsed&&n.serverIndex>v){r+=n.magnitude;v=n.serverIndex+n.magnitude;}}else{if(n.serverIndex>v){if(!n.isDeepOne&&n.initiallyCollapsed){r-=n.magnitude;}if(r<=n.serverIndex){return this._calcDirectIndex(n,r+n.magnitude-n.serverIndex-1);}}}}return{index:r};};
f.prototype._calcDirectIndex=function(n,a){var i,m,o;for(i=0;i<n.children.length;i++){o=n.children[i];if(a===0){return{parent:n,childIndex:i};}m=o?o.magnitude:0;a--;if(!o||o.nodeState.collapsed){continue;}if(a<m){return this._calcDirectIndex(o,a);}else{a-=m;}}};
f.prototype.getRowIndexByNode=function(n){var D=0;var o;var i;if(n.isDeepOne){while(n.parent){D+=n.positionInParent+1;for(i=0;i<n.positionInParent;i++){o=n.parent.children[i];if(o&&o.nodeState.expanded){D+=o.magnitude;}}n=n.parent;}}return this._calcIndexDelta(n.serverIndex)+n.serverIndex+D;};
f.prototype._getSelectedNodesInfo=function(){var n=[];if(e(this._mSelected)){return n;}var i=true;var a=function(N,b){if(N.nodeState.collapsed||(N.nodeState.removed&&!N.nodeState.reinserted)){i=false;b.broken=true;}};for(var k in this._mSelected){var s=this._mSelected[k];i=true;this._up(s,a,false);if(i){n.push({node:s,rowIndex:this.getRowIndexByNode(s)});}}n.sort(function(N,o){return N.rowIndex-o.rowIndex;});return n;};
f.prototype._calcIndexDelta=function(E){var m={};this._aCollapsed.forEach(function(n){if(n.serverIndex>=0&&n.serverIndex<E&&!n.isDeepOne&&!n.initiallyCollapsed){m[n.serverIndex]=n.magnitude;}});var l=0;var a=0;for(var i=0;i<this._aCollapsed.length;i++){var o=this._aCollapsed[i];if(this._getRelatedServerIndex(o)>=E){break;}if(!o.isDeepOne){if(o.serverIndex>=l&&!o.initiallyCollapsed){a-=o.magnitude;l=o.serverIndex+o.magnitude;}else{}}else{}}var b=0;var I=function(n){var h=false;var k=n.serverIndex||n.containingServerIndex;for(var j in m){if(k>j&&k<j+m[j]){h=true;break;}}return h;};for(i=0;i<this._aExpanded.length;i++){var g=this._aExpanded[i];if(this._getRelatedServerIndex(g)>=E){break;}if(g.isDeepOne){var p=g.parent;var y=false;while(p){if(p.nodeState.collapsed){y=true;break;}p=p.parent;}var h=I(g);if(!y&&!h){b+=g.children.length;}}else if(g.initiallyCollapsed){var h=I(g);if(!h){b+=g.children.length;}}}return b+a;};
f.prototype._sortNodes=function(n){var s=function(a,b){var A=this._getRelatedServerIndex(a);var B=this._getRelatedServerIndex(b);return A-B;}.bind(this);n.sort(s);};
f.prototype._abortPendingRequest=function(){O.prototype._abortPendingRequest.apply(this,arguments);var i,j;for(i=this._aPendingRequests.length-1;i>=0;i--){this._aPendingRequests[i].oRequestHandle.abort();}this._aPendingRequests=[];for(j=this._aPendingChildrenRequests.length-1;j>=0;j--){this._aPendingChildrenRequests[j].oRequestHandle.abort();}this._aPendingChildrenRequests=[];};
f.prototype.attachSelectionChanged=function(D,a,l){this.attachEvent("selectionChanged",D,a,l);return this;};
f.prototype.detachSelectionChanged=function(a,l){this.detachEvent("selectionChanged",a,l);return this;};
f.prototype.fireSelectionChanged=function(p){this.fireEvent("selectionChanged",p);return this;};
f.prototype.getRootContexts=function(){};
f.prototype.getNodeContexts=function(){};
return f;},true);
sap.ui.predefine('sap/ui/model/odata/ODataUtils',['sap/ui/model/Sorter','sap/ui/model/FilterProcessor','sap/ui/core/format/DateFormat',"sap/base/Log","sap/base/assert","sap/ui/thirdparty/jquery","sap/base/security/encodeURL","sap/ui/core/CalendarType"],function(S,F,D,L,a,q,e,C){"use strict";var d,o,b,r=/^([-+]?)0*(\d+)(\.\d+|)$/,t,c=/\.$/,f=/0+$/;
function s(){if(!d){d=D.getDateInstance({pattern:"'datetime'''yyyy-MM-dd'T'HH:mm:ss''",calendarType:C.Gregorian});o=D.getDateInstance({pattern:"'datetime'''yyyy-MM-dd'T'HH:mm:ss.SSS''",calendarType:C.Gregorian});b=D.getDateInstance({pattern:"'datetimeoffset'''yyyy-MM-dd'T'HH:mm:ss'Z'''",calendarType:C.Gregorian});t=D.getTimeInstance({pattern:"'time''PT'HH'H'mm'M'ss'S'''",calendarType:C.Gregorian});}}
var O=function(){};
O.createSortParams=function(x){var y;if(!x||x.length==0){return;}y="$orderby=";for(var i=0;i<x.length;i++){var z=x[i];if(z instanceof S){y+=z.sPath;y+=z.bDescending?"%20desc":"%20asc";y+=",";}else{L.error("Trying to use "+z+" as a Sorter, but it is a "+typeof z);}}y=y.slice(0,-1);return y;};
function g(i){if(i&&typeof i.convert==="function"){i=i.convert();}return i;}
O.createFilterParams=function(i,M,E){var x;if(Array.isArray(i)){i=i.map(g);x=F.groupFilters(i);}else{x=g(i);}if(!x){return;}return"$filter="+this._createFilterParams(x,M,E);};
O._createFilterParams=function(x,M,E){var y=this,z=Array.isArray(x)?F.groupFilters(x):x;function A(z,i){z=g(z);if(z.aFilters){return B(z,i);}return y._createFilterSegment(z.sPath,M,E,z.sOperator,z.oValue1,z.oValue2,z.bCaseSensitive);}function B(G,H){var I=G.aFilters,J=!!G.bAnd,K="";if(I.length===0){return J?"true":"false";}if(I.length===1){if(I[0]._bMultiFilter){return A(I[0]);}return A(I[0],true);}if(!H){K+="(";}K+=A(I[0]);for(var i=1;i<I.length;i++){K+=J?"%20and%20":"%20or%20";K+=A(I[i]);}if(!H){K+=")";}return K;}if(!z){return;}return A(z,true);};
O._createUrlParamsArray=function(P){var U,T=typeof P,i;if(Array.isArray(P)){return P;}U=[];if(T==="string"||P instanceof String){if(P){U.push(P);}}else if(T==="object"){i=this._encodeURLParameters(P);if(i){U.push(i);}}return U;};
O._encodeURLParameters=function(P){if(!P){return"";}var U=[];q.each(P,function(i,V){if(typeof V==="string"||V instanceof String){V=encodeURIComponent(V);}i=i.startsWith('$')?i:encodeURIComponent(i);U.push(i+"="+V);});return U.join("&");};
O.setOrigin=function(i,P){var x,y,z;if(!i||!P||i.indexOf(";mo")>0){return i;}if(typeof P=="string"){x=P;}else{x=P.alias;if(!x){y=P.system;z=P.client;if(!y||!z){L.warning("ODataUtils.setOrigin: No Client or System ID given for Origin");return i;}x="sid("+y+"."+z+")";}}var U=i.split("?");var B=U[0];var A=U[1]?"?"+U[1]:"";var T="";if(B[B.length-1]==="/"){B=B.substring(0,B.length-1);T="/";}var E=/(\/[^\/]+)$/g;var G=/(;o=[^\/;]+)/g;var H=B.match(E)[0];var I=H.match(G);var J=I?I[0]:null;if(J){if(P.force){var K=H.replace(J,";o="+x);B=B.replace(H,K);return B+T+A;}return i;}B=B+";o="+x+T;return B+A;};
O.setAnnotationOrigin=function(A,P){var i;var x=A.indexOf("/Annotations(");var H=P&&P.preOriginBaseUri?P.preOriginBaseUri.indexOf(".xsodata"):-1;if(x===-1){x=A.indexOf("/Annotations%28");}if(x>=0){if(A.indexOf("/$value",x)===-1){L.warning("ODataUtils.setAnnotationOrigin: Annotation url is missing $value segment.");i=A;}else{var y=A.substring(0,x);var z=A.substring(x,A.length);var B=O.setOrigin(y,P);i=B+z;}}else if(H>=0){i=O.setOrigin(A,P);}else{i=A.replace(P.preOriginBaseUri,P.postOriginBaseUri);}return i;};
O._resolveMultiFilter=function(M,x,E){var y=this,z=M.aFilters,A="";if(z){A+="(";q.each(z,function(i,B){if(B._bMultiFilter){A+=y._resolveMultiFilter(B,x,E);}else if(B.sPath){A+=y._createFilterSegment(B.sPath,x,E,B.sOperator,B.oValue1,B.oValue2,"",B.bCaseSensitive);}if(i<(z.length-1)){if(M.bAnd){A+="%20and%20";}else{A+="%20or%20";}}});A+=")";}return A;};
O._createFilterSegment=function(P,M,E,i,V,x,y){var z,T;if(y===undefined){y=true;}if(E){z=M._getPropertyMetadata(E,P);T=z&&z.type;a(z,"PropertyType for property "+P+" of EntityType "+E.name+" not found!");}if(T){V=this.formatValue(V,T,y);x=(x!=null)?this.formatValue(x,T,y):null;}else{a(null,"Type for filter property could not be found in metadata!");}if(V){V=e(String(V));}if(x){x=e(String(x));}if(!y&&T==="Edm.String"){P="toupper("+P+")";}switch(i){case"EQ":case"NE":case"GT":case"GE":case"LT":case"LE":return P+"%20"+i.toLowerCase()+"%20"+V;case"BT":return"("+P+"%20ge%20"+V+"%20and%20"+P+"%20le%20"+x+")";case"NB":return"not%20("+P+"%20ge%20"+V+"%20and%20"+P+"%20le%20"+x+")";case"Contains":return"substringof("+V+","+P+")";case"NotContains":return"not%20substringof("+V+","+P+")";case"StartsWith":return"startswith("+P+","+V+")";case"NotStartsWith":return"not%20startswith("+P+","+V+")";case"EndsWith":return"endswith("+P+","+V+")";case"NotEndsWith":return"not%20endswith("+P+","+V+")";default:L.error("ODataUtils :: Unknown filter operator "+i);return"true";}};
O.formatValue=function(V,T,i){var x,y;if(i===undefined){i=true;}if(V===null||V===undefined){return"null";}s();switch(T){case"Edm.String":V=i?V:V.toUpperCase();y="'"+String(V).replace(/'/g,"''")+"'";break;case"Edm.Time":if(typeof V==="object"){y=t.format(new Date(V.ms),true);}else{y="time'"+V+"'";}break;case"Edm.DateTime":x=V instanceof Date?V:new Date(V);if(x.getMilliseconds()>0){y=o.format(x,true);}else{y=d.format(x,true);}break;case"Edm.DateTimeOffset":x=V instanceof Date?V:new Date(V);y=b.format(x,true);break;case"Edm.Guid":y="guid'"+V+"'";break;case"Edm.Decimal":y=V+"m";break;case"Edm.Int64":y=V+"l";break;case"Edm.Double":y=V+"d";break;case"Edm.Float":case"Edm.Single":y=V+"f";break;case"Edm.Binary":y="binary'"+V+"'";break;default:y=String(V);break;}return y;};
O.parseValue=function(V){var i=V[0],x=V[V.length-1];s();if(i==="'"){return V.slice(1,-1).replace(/''/g,"'");}else if(V.startsWith("time'")){return{__edmType:"Edm.Time",ms:t.parse(V,true).getTime()};}else if(V.startsWith("datetime'")){if(V.indexOf(".")===-1){return d.parse(V,true);}else{return o.parse(V,true);}}else if(V.startsWith("datetimeoffset'")){return b.parse(V,true);}else if(V.startsWith("guid'")){return V.slice(5,-1);}else if(V==="null"){return null;}else if(x==="m"||x==="l"||x==="d"||x==="f"){return V.slice(0,-1);}else if(!isNaN(i)||i==="-"){return parseInt(V);}else if(V==="true"||V==="false"){return V==="true";}else if(V.startsWith("binary'")){return V.slice(7,-1);}throw new Error("Cannot parse value '"+V+"', no Edm type found");};
function h(V,i){if(V===i){return 0;}if(V===null||i===null||V===undefined||i===undefined){return NaN;}return V>i?1:-1;}
function p(V){var M;if(typeof V!=="string"){return undefined;}M=r.exec(V);if(!M){return undefined;}return{sign:M[1]==="-"?-1:1,integerLength:M[2].length,abs:M[2]+M[3].replace(f,"").replace(c,"")};}
function j(V,i){var x,y,R;if(V===i){return 0;}x=p(V);y=p(i);if(!x||!y){return NaN;}if(x.sign!==y.sign){return x.sign>y.sign?1:-1;}R=h(x.integerLength,y.integerLength)||h(x.abs,y.abs);return x.sign*R;}
var k=/^PT(\d\d)H(\d\d)M(\d\d)S$/;
function l(V){if(typeof V==="string"&&k.test(V)){V=parseInt(RegExp.$1)*3600000+parseInt(RegExp.$2)*60000+parseInt(RegExp.$3)*1000;}if(V instanceof Date){return V.getTime();}if(V&&V.__edmType==="Edm.Time"){return V.ms;}return V;}
O.compare=function(V,i,A){return A?j(V,i):h(l(V),l(i));};
O.getComparator=function(E){switch(E){case"Edm.Date":case"Edm.DateTime":case"Edm.DateTimeOffset":case"Edm.Time":return O.compare;case"Edm.Decimal":case"Edm.Int64":return j;default:return h;}};
var m=/([(=,])('.*?')([,)])/g,n=/[MLDF](?=[,)](?:[^']*'[^']*')*[^']*$)/g,u=/([(=,])(X')/g,N=function(i,x,y,z){return x+encodeURIComponent(decodeURIComponent(y))+z;},v=function(i){return i.toLowerCase();},w=function(i,x){return x+"binary'";};
O._normalizeKey=function(K){return K.replace(m,N).replace(n,v).replace(u,w);};
return O;},true);
sap.ui.predefine('sap/ui/model/odata/OperationMode',function(){"use strict";var O={Default:"Default",Server:"Server",Client:"Client",Auto:"Auto"};return O;},true);
sap.ui.predefine('sap/ui/model/odata/UpdateMethod',function(){"use strict";var U={Merge:"MERGE",Put:"PUT"};return U;},true);
sap.ui.predefine('sap/ui/model/odata/_AnnotationHelperBasics',["sap/base/Log","sap/ui/base/BindingParser","sap/ui/performance/Measurement","sap/ui/thirdparty/jquery"],function(L,B,M,q){'use strict';var a="sap.ui.model.odata.AnnotationHelper",r=/[\\\{\}:]/,b,d=/^(\/dataServices\/schema\/\d+\/entityContainer\/\d+\/entitySet\/\d+)(?:\/|$)/,p=[a],P=a+"/followPath",f=/^(\/dataServices\/schema\/\d+\/(?:complex|entity)Type\/\d+)(?:\/|$)/,u={"Edm.Boolean":"sap.ui.model.odata.type.Boolean","Edm.Byte":"sap.ui.model.odata.type.Byte","Edm.Date":"sap.ui.model.odata.type.Date","Edm.DateTime":"sap.ui.model.odata.type.DateTime","Edm.DateTimeOffset":"sap.ui.model.odata.type.DateTimeOffset","Edm.Decimal":"sap.ui.model.odata.type.Decimal","Edm.Double":"sap.ui.model.odata.type.Double","Edm.Float":"sap.ui.model.odata.type.Single","Edm.Guid":"sap.ui.model.odata.type.Guid","Edm.Int16":"sap.ui.model.odata.type.Int16","Edm.Int32":"sap.ui.model.odata.type.Int32","Edm.Int64":"sap.ui.model.odata.type.Int64","Edm.SByte":"sap.ui.model.odata.type.SByte","Edm.Single":"sap.ui.model.odata.type.Single","Edm.String":"sap.ui.model.odata.type.String","Edm.Stream":"sap.ui.model.odata.type.Stream","Edm.Time":"sap.ui.model.odata.type.Time","Edm.TimeOfDay":"sap.ui.model.odata.type.TimeOfDay"};b={descend:function(o,v,e){var t=q.extend({},o);b.expectType(o,typeof v==="number"?"array":"object");t.path=o.path+"/"+v;t.value=o.value[v];if(e===true){t.asExpression=true;}else if(e){b.expectType(t,e);}return t;},error:function(o,m,c){m=o.path+": "+m;L.error(m,b.toErrorString(o.value),c||a);throw new SyntaxError(m);},expectType:function(o,e){var E,v=o.value;if(e==="array"){E=!Array.isArray(v);}else{E=typeof v!==e||v===null||Array.isArray(v);}if(E){b.error(o,"Expected "+e);}},followPath:function(i,R){var A,s,c,I,m=i.getModel(),e,o={associationSetEnd:undefined,navigationAfterMultiple:false,isMultiple:false,navigationProperties:[],resolvedPath:undefined},S,t;M.average(P,"",p);s=b.getPath(R);c=s!==undefined&&b.getStartingPoint(i,s);if(!c){M.end(P);return undefined;}e=s.split("/");while(s&&e.length&&c){S=e[0];I=S.indexOf("@");if(I===0){c+="/"+S.slice(1);e.shift();continue;}t=m.getObject(c);A=m.getODataAssociationEnd(t,S);if(A){o.associationSetEnd=m.getODataAssociationSetEnd(t,S);o.navigationProperties.push(S);if(o.isMultiple){o.navigationAfterMultiple=true;}o.isMultiple=A.multiplicity==="*";c=m.getODataEntityType(A.type,true);e.shift();continue;}c=m.getODataProperty(t,e,true);}o.resolvedPath=c;M.end(P);return o;},getPath:function(R){if(R){if(R.hasOwnProperty("AnnotationPath")){return R.AnnotationPath;}if(R.hasOwnProperty("Path")){return R.Path;}if(R.hasOwnProperty("PropertyPath")){return R.PropertyPath;}if(R.hasOwnProperty("NavigationPropertyPath")){return R.NavigationPropertyPath;}}return undefined;},getStartingPoint:function(i,s){var e,m=f.exec(i.getPath()),o;if(m){return m[1];}m=d.exec(i.getPath());if(m){if(!s){return m[1];}o=i.getModel();e=o.getObject(m[1]);return o.getODataEntityType(e.entityType,true);}return undefined;},property:function(o,v,e){return b.descend(o,v,e).value;},resultToString:function(R,e,w){var v=R.value;function c(A){var C,F,s=R.parameters&&b.toJSON(R.parameters),h=s&&s!=="{}",i,t=u[R.type];A=A&&!R.ignoreTypeInPath&&t;if(A||r.test(v)||h){i="{path:"+b.toJSON(v);if(A){i+=",type:'"+t+"'";C=b.toJSON(R.constraints);if(C&&C!=="{}"){i+=",constraints:"+C;}F=R.formatOptions&&b.toJSON(R.formatOptions);if(F&&F!=="{}"){i+=",formatOptions:"+F;}}if(h){i+=",parameters:"+s;}return i+"}";}return"{"+v+"}";}function g(R){switch(R.type){case"Edm.Boolean":case"Edm.Double":case"Edm.Int32":return String(R.value);default:return b.toJSON(R.value);}}switch(R.result){case"binding":return(e?"$":"")+c(w);case"composite":if(e){throw new Error("Trying to embed a composite binding into an expression binding");}return v;case"constant":if(R.type==="edm:Null"){return e?"null":null;}if(e){return g(R);}return typeof v==="string"?B.complexParser.escape(v):String(v);case"expression":return e?v:"{="+v+"}";}},toErrorString:function(v){var j;if(typeof v!=="function"){try{j=b.toJSON(v);if(j!==undefined&&j!=="null"){return j;}}catch(e){}}return String(v);},toJSON:function(v){var s,e=false,R="",i,c;s=JSON.stringify(v);if(s===undefined){return undefined;}for(i=0;i<s.length;i+=1){switch(c=s.charAt(i)){case"'":R+="\\'";break;case'"':if(e){R+=c;e=false;}else{R+="'";}break;case"\\":if(e){R+="\\\\";}e=!e;break;default:if(e){R+="\\";e=false;}R+=c;}}return R;}};return b;},false);
sap.ui.predefine('sap/ui/model/odata/_AnnotationHelperExpression',["./_AnnotationHelperBasics","sap/base/Log","sap/ui/base/BindingParser","sap/ui/base/ManagedObject","sap/ui/core/CalendarType","sap/ui/core/format/DateFormat","sap/ui/model/odata/ODataUtils","sap/ui/performance/Measurement"],function(B,L,a,M,C,D,O,b){'use strict';var A="sap.ui.model.odata.AnnotationHelper",d,o,s="\\d{4}-(?:0[1-9]|1[0-2])-(?:0[1-9]|[12]\\d|3[01])",c="[-+]?\\d+(?:\\.\\d+)?",m="9007199254740991",f="-"+m,p=[A],P=A+"/getExpression",t,T="(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(\\.\\d{1,12})?)?",E={Bool:/^true$|^false$/i,Float:new RegExp("^"+c+"(?:[eE][-+]?\\d+)?$|^NaN$|^-INF$|^INF$"),Date:new RegExp("^"+s+"$"),DateTimeOffset:new RegExp("^"+s+"T"+T+"(?:Z|[-+](?:0\\d|1[0-3]):[0-5]\\d|[-+]14:00)$","i"),Decimal:new RegExp("^"+c+"$"),Guid:/^[A-F0-9]{8}-(?:[A-F0-9]{4}-){3}[A-F0-9]{12}$/i,Int:/^[-+]?\d{1,19}$/,TimeOfDay:new RegExp("^"+T+"$")},g,r=/^\{@i18n>[^\\\{\}:]+\}$/,h=/^\d+$/,j={And:"&&",Eq:"===",Ge:">=",Gt:">",Le:"<=",Lt:"<",Ne:"!==",Not:"!",Or:"||"},k=/^(\/dataServices\/schema\/\d+)(?:\/|$)/,l={"Edm.Boolean":"boolean","Edm.Byte":"number","Edm.Date":"date","Edm.DateTime":"datetime","Edm.DateTimeOffset":"datetime","Edm.Decimal":"decimal","Edm.Double":"number","Edm.Float":"number","Edm.Guid":"string","Edm.Int16":"number","Edm.Int32":"number","Edm.Int64":"decimal","Edm.SByte":"number","Edm.Single":"number","Edm.String":"string","Edm.Time":"time","Edm.TimeOfDay":"time"},n={Bool:"Edm.Boolean",Float:"Edm.Double",Date:"Edm.Date",DateTimeOffset:"Edm.DateTimeOffset",Decimal:"Edm.Decimal",Guid:"Edm.Guid",Int:"Edm.Int64",String:"Edm.String",TimeOfDay:"Edm.TimeOfDay"},q={"boolean":false,"date":true,"datetime":true,"decimal":true,"number":false,"string":false,"time":true};g={_setDateTimeFormatter:function(){d=D.getDateInstance({calendarType:C.Gregorian,pattern:"yyyy-MM-dd",strictParsing:true,UTC:true});o=D.getDateTimeInstance({calendarType:C.Gregorian,pattern:"yyyy-MM-dd'T'HH:mm:ss.SSSXXX",strictParsing:true});t=D.getTimeInstance({calendarType:C.Gregorian,pattern:"HH:mm:ss.SSS",strictParsing:true,UTC:true});},adjustOperands:function(e,i){if(e.result!=="constant"&&e.category==="number"&&i.result==="constant"&&i.type==="Edm.Int64"){i.category="number";}if(e.result!=="constant"&&e.category==="decimal"&&i.result==="constant"&&i.type==="Edm.Int32"){i.category="decimal";i.type=e.type;}if(e.result==="constant"&&e.category==="date"&&i.result!=="constant"&&i.category==="datetime"){i.category="date";}},apply:function(i,e){var N=B.descend(e,"Name","string"),u=B.descend(e,"Parameters");switch(N.value){case"odata.concat":return g.concat(i,u);case"odata.fillUriTemplate":return g.fillUriTemplate(i,u);case"odata.uriEncode":return g.uriEncode(i,u);default:B.error(N,"unknown function: "+N.value);}},concat:function(I,e){var u=e.asExpression,v=[],R,w=[];B.expectType(e,"array");e.value.forEach(function(U,i){R=g.parameter(I,e,i);u=u||R.result==="expression";w.push(R);});w.forEach(function(R){if(u){g.wrapExpression(R);}if(R.type!=='edm:Null'){v.push(B.resultToString(R,u,e.withType));}});R=u?{result:"expression",value:v.join("+")}:{result:"composite",value:v.join("")};R.type="Edm.String";return R;},conditional:function(i,e){var u=g.parameter(i,e,0,"Edm.Boolean"),v=g.parameter(i,e,1),w=g.parameter(i,e,2),x=v.type,W=e.withType;if(v.type==="edm:Null"){x=w.type;}else if(w.type!=="edm:Null"&&v.type!==w.type){B.error(e,"Expected same type for second and third parameter, types are '"+v.type+"' and '"+w.type+"'");}return{result:"expression",type:x,value:B.resultToString(g.wrapExpression(u),true,false)+"?"+B.resultToString(g.wrapExpression(v),true,W)+":"+B.resultToString(g.wrapExpression(w),true,W)};},constant:function(i,e,u){var v=e.value;B.expectType(e,"string");if(u==="String"){if(r.test(v)){return{ignoreTypeInPath:true,result:"binding",type:"Edm.String",value:v.slice(1,-1)};}else if(i.getSetting&&i.getSetting("bindTexts")){return{result:"binding",type:"Edm.String",ignoreTypeInPath:true,value:"/##"+g.replaceIndexes(i.getModel(),e.path)};}u="Edm.String";}else if(!E[u].test(v)){B.error(e,"Expected "+u+" value but instead saw '"+v+"'");}else{u=n[u];if(u==="Edm.Int64"&&O.compare(v,f,true)>=0&&O.compare(v,m,true)<=0){u="Edm.Int32";}}return{result:"constant",type:u,value:v};},expression:function(i,e){var R=e.value,S,u;B.expectType(e,"object");if(R.hasOwnProperty("Type")){u=B.property(e,"Type","string");S=B.descend(e,"Value");}else{["And","Apply","Bool","Date","DateTimeOffset","Decimal","Float","Eq","Ge","Gt","Guid","If","Int","Le","Lt","Ne","Not","Null","Or","Path","PropertyPath","String","TimeOfDay"].forEach(function(v){if(R.hasOwnProperty(v)){u=v;S=B.descend(e,v);}});}switch(u){case"Apply":return g.apply(i,S);case"If":return g.conditional(i,S);case"Path":case"PropertyPath":return g.path(i,S);case"Bool":case"Date":case"DateTimeOffset":case"Decimal":case"Float":case"Guid":case"Int":case"String":case"TimeOfDay":return g.constant(i,S,u);case"And":case"Eq":case"Ge":case"Gt":case"Le":case"Lt":case"Ne":case"Or":return g.operator(i,S,u);case"Not":return g.not(i,S);case"Null":return{result:"constant",value:"null",type:"edm:Null"};default:B.error(e,"Unsupported OData expression");}},formatOperand:function(e,i,R,w){var u;if(R.result==="constant"){switch(R.category){case"boolean":case"number":return R.value;case"date":u=g.parseDate(R.value);if(!u){B.error(B.descend(e,i),"Invalid Date "+R.value);}return String(u.getTime());case"datetime":u=g.parseDateTimeOffset(R.value);if(!u){B.error(B.descend(e,i),"Invalid DateTime "+R.value);}return String(u.getTime());case"time":return String(g.parseTimeOfDay(R.value).getTime());}}if(w){g.wrapExpression(R);}return B.resultToString(R,true);},getExpression:function(i,R,w){var u;if(R===undefined){return undefined;}b.average(P,"",p);if(!g.simpleParserWarningLogged&&M.bindingParser===a.simpleParser){L.warning("Complex binding syntax not active",null,A);g.simpleParserWarningLogged=true;}try{u=g.expression(i,{asExpression:false,path:i.getPath(),value:R,withType:w});b.end(P);return B.resultToString(u,false,w);}catch(e){b.end(P);if(e instanceof SyntaxError){return"Unsupported: "+a.complexParser.escape(B.toErrorString(R));}throw e;}},fillUriTemplate:function(I,e){var i,N,u=[],v="",w,x=e.value,R,y=g.parameter(I,e,0,"Edm.String");u.push('odata.fillUriTemplate(',B.resultToString(y,true),',{');for(i=1;i<x.length;i+=1){w=B.descend(e,i,"object");N=B.property(w,"Name","string");R=g.expression(I,B.descend(w,"Value"),true);u.push(v,B.toJSON(N),":",B.resultToString(R,true));v=",";}u.push("})");return{result:"expression",value:u.join(""),type:"Edm.String"};},not:function(i,e){var u;e.asExpression=true;u=g.expression(i,e);return{result:"expression",value:"!"+B.resultToString(g.wrapExpression(u),true),type:"Edm.Boolean"};},operator:function(i,e,u){var v=u==="And"||u==="Or"?"Edm.Boolean":undefined,w=g.parameter(i,e,0,v),x=g.parameter(i,e,1,v),y,N,V,z;if(w.type!=="edm:Null"&&x.type!=="edm:Null"){w.category=l[w.type];x.category=l[x.type];g.adjustOperands(w,x);g.adjustOperands(x,w);if(w.category!==x.category){B.error(e,"Expected two comparable parameters but instead saw "+w.type+" and "+x.type);}y=w.category==="decimal"?",true":"";N=q[w.category];}V=g.formatOperand(e,0,w,!N);z=g.formatOperand(e,1,x,!N);return{result:"expression",value:N?"odata.compare("+V+","+z+y+")"+j[u]+"0":V+j[u]+z,type:"Edm.Boolean"};},parameter:function(i,e,I,u){var v=B.descend(e,I),R;v.asExpression=true;R=g.expression(i,v);if(u&&u!==R.type){B.error(v,"Expected "+u+" but instead saw "+R.type);}return R;},parseDate:function(v){return d.parse(v);},parseDateTimeOffset:function(v){var e=E.DateTimeOffset.exec(v);if(e&&e[1]&&e[1].length>4){v=v.replace(e[1],e[1].slice(0,4));}return o.parse(v.toUpperCase());},parseTimeOfDay:function(v){if(v.length>12){v=v.slice(0,12);}return t.parse(v);},path:function(i,e){var u=e.value,v={},w,I,x,y=i.getModel(),z={getModel:function(){return y;},getPath:function(){return e.path;}},F,R={result:"binding",value:u},G;B.expectType(e,"string");G=B.followPath(z,{"Path":u});if(G&&G.resolvedPath){F=y.getProperty(G.resolvedPath);R.type=F.type;switch(F.type){case"Edm.DateTime":v.displayFormat=F["sap:display-format"];break;case"Edm.Decimal":if(F.precision){v.precision=F.precision;}if(F.scale){v.scale=F.scale;}x=F["Org.OData.Validation.V1.Minimum"];if(x&&(x.Decimal||x.String)){v.minimum=x.Decimal||x.String;w=x["Org.OData.Validation.V1.Exclusive"];if(w){v.minimumExclusive=w.Bool||"true";}}x=F["Org.OData.Validation.V1.Maximum"];if(x&&(x.Decimal||x.String)){v.maximum=x.Decimal||x.String;w=x["Org.OData.Validation.V1.Exclusive"];if(w){v.maximumExclusive=w.Bool||"true";}}break;case"Edm.String":v.maxLength=F.maxLength;I=F["com.sap.vocabularies.Common.v1.IsDigitSequence"];if(I){v.isDigitSequence=I.Bool||"true";}break;}if(F.nullable==="false"){v.nullable="false";}R.constraints=v;}else{L.warning("Could not find property '"+u+"' starting from '"+e.path+"'",null,A);}return R;},replaceIndexes:function(e,u){var v,w=u.split('/'),x,R;function y(z,i){var F=e.getProperty(x+"/"+z);if(typeof F==="string"){w[i]="[${"+z+"}==="+B.toJSON(F)+"]";return true;}return false;}v=k.exec(u);if(!v){return u;}x=v[1];if(!y("namespace",3)){return u;}for(var i=4;i<w.length;i+=1){x=x+"/"+w[i];if(h.test(w[i])&&!y("name",i)){R=e.getProperty(x+"/RecordType");if(R){if(R==="com.sap.vocabularies.UI.v1.DataFieldForAction"){y("Action/String",i);}else if(R==="com.sap.vocabularies.UI.v1.DataFieldForAnnotation"){y("Target/AnnotationPath",i);}else if(R.indexOf("com.sap.vocabularies.UI.v1.DataField")===0){y("Value/Path",i);}}}}return w.join('/');},simpleParserWarningLogged:false,uriEncode:function(i,e){var R=g.parameter(i,e,0);if(R.result==="constant"){if(R.type==="Edm.Date"){R.type="Edm.DateTime";R.value=R.value+"T00:00:00Z";}else if(R.type==="Edm.TimeOfDay"){R.type="Edm.Time";R.value="PT"+R.value.slice(0,2)+"H"+R.value.slice(3,5)+"M"+R.value.slice(6,8)+"S";}}return{result:"expression",value:'odata.uriEncode('+B.resultToString(R,true)+","+B.toJSON(R.type)+")",type:"Edm.String"};},wrapExpression:function(R){if(R.result==="expression"){R.value="("+R.value+")";}return R;}};g._setDateTimeFormatter();return g;},false);
sap.ui.predefine('sap/ui/model/odata/_ODataMetaModelUtils',["./_AnnotationHelperBasics","sap/base/Log","sap/ui/thirdparty/jquery"],function(_,L,q){"use strict";var b={"Bool":"false"},B={"Bool":"true"},d={"fiscalyear":"IsFiscalYear","fiscalyearperiod":"IsFiscalYearPeriod","year":"IsCalendarYear","yearmonth":"IsCalendarYearMonth","yearmonthday":"IsCalendarDate","yearquarter":"IsCalendarYearQuarter","yearweek":"IsCalendarYearWeek"},f={"interval":"SingleInterval","multi-value":"MultiValue","single-value":"SingleValue"},l="sap.ui.model.odata.ODataMetaModel",s={"bday":"Contact","city":"Contact/adr","country":"Contact/adr","email":"Contact/email","familyname":"Contact/n","givenname":"Contact/n","honorific":"Contact/n","middlename":"Contact/n","name":"Contact","nickname":"Contact","note":"Contact","org":"Contact","org-role":"Contact","org-unit":"Contact","photo":"Contact","pobox":"Contact/adr","region":"Contact/adr","street":"Contact/adr","suffix":"Contact/n","tel":"Contact/tel","title":"Contact","zip":"Contact/adr","class":"Event","dtend":"Event","dtstart":"Event","duration":"Event","fbtype":"Event","location":"Event","status":"Event","transp":"Event","wholeday":"Event","body":"Message","from":"Message","received":"Message","sender":"Message","subject":"Message","completed":"Task","due":"Task","percent-complete":"Task","priority":"Task"},r=/(\w+)(?:;type=([\w,]+))?/,v={"email":{typeMapping:{"home":"home","pref":"preferred","work":"work"},v4EnumType:"com.sap.vocabularies.Communication.v1.ContactInformationType",v4PropertyAnnotation:"com.sap.vocabularies.Communication.v1.IsEmailAddress"},"tel":{typeMapping:{"cell":"cell","fax":"fax","home":"home","pref":"preferred","video":"video","voice":"voice","work":"work"},v4EnumType:"com.sap.vocabularies.Communication.v1.PhoneType",v4PropertyAnnotation:"com.sap.vocabularies.Communication.v1.IsPhoneNumber"}},V={creatable:{"Org.OData.Capabilities.V1.InsertRestrictions":{"Insertable":b}},pageable:{"Org.OData.Capabilities.V1.SkipSupported":b,"Org.OData.Capabilities.V1.TopSupported":b},"requires-filter":{"Org.OData.Capabilities.V1.FilterRestrictions":{"RequiresFilter":B}},topable:{"Org.OData.Capabilities.V1.TopSupported":b}},m={"city":"locality","email":"address","familyname":"surname","givenname":"given","honorific":"prefix","middlename":"additional","name":"fn","org-role":"role","org-unit":"orgunit","percent-complete":"percentcomplete","tel":"uri","zip":"code"},a={"sap:filterable":["Org.OData.Capabilities.V1.FilterRestrictions","NonFilterableProperties"],"sap:required-in-filter":["Org.OData.Capabilities.V1.FilterRestrictions","RequiredProperties"],"sap:sortable":["Org.OData.Capabilities.V1.SortRestrictions","NonSortableProperties"]},c=/^com\.sap\.vocabularies\.Common\.v1\.ValueList(#.*)?$/,w=L.Level.WARNING,U;U={addEntitySetAnnotation:function(o,e,t,n,D){if(t==="EntitySet"&&e.value===n){if(D){q.extend(true,o,V[e.name]);}else{q.extend(o,V[e.name]);}}},addFilterRestriction:function(p,e){var F,g=f[p["sap:filter-restriction"]];if(!g){if(L.isLoggable(w,l)){L.warning("Unsupported sap:filter-restriction: "+p["sap:filter-restriction"],e.entityType+"."+p.name,l);}return;}F=e["com.sap.vocabularies.Common.v1.FilterExpressionRestrictions"]||[];F.push({"Property":{"PropertyPath":p.name},"AllowedExpressions":{"EnumMember":"com.sap.vocabularies.Common.v1.FilterExpressionType/"+g}});e["com.sap.vocabularies.Common.v1.FilterExpressionRestrictions"]=F;},addNavigationFilterRestriction:function(n,e){var N=e["Org.OData.Capabilities.V1.NavigationRestrictions"]||{};N.RestrictedProperties=N.RestrictedProperties||[];N.RestrictedProperties.push({"FilterRestrictions":{"Filterable":b},"NavigationProperty":{"NavigationPropertyPath":n.name}});e["Org.OData.Capabilities.V1.NavigationRestrictions"]=N;},addPropertyToAnnotation:function(e,E,p){var n=a[e],t=n[0],C=n[1],A=E[t]||{},g=A[C]||[];g.push({"PropertyPath":p.name});A[C]=g;E[t]=A;},addSapSemantics:function(t){if(t.property){t.property.forEach(function(p){var A,i,M,S,T,e=p["sap:semantics"],g,h,o,j,k;if(!e){return;}if(e==="url"){p["Org.OData.Core.V1.IsURL"]=B;return;}if(e in d){g="com.sap.vocabularies.Common.v1."+d[e];p[g]=B;return;}M=r.exec(e);if(!M){if(L.isLoggable(w,l)){L.warning("Unsupported sap:semantics: "+e,t.name+"."+p.name,l);}return;}if(M[2]){e=M[1];k=U.getV4TypesForV2Semantics(e,M[2],p,t);}j=v[e];i=e==="tel"||e==="email";h=s[e];if(h){A=h.split("/");g="com.sap.vocabularies.Communication.v1."+A[0];t[g]=t[g]||{};o=t[g];S=A[1];if(S){o[S]=o[S]||(i?[]:{});if(i){T={};o[S].push(T);o=T;}else{o=o[S];}}o[m[e]||e]={"Path":p.name};if(k){o.type={"EnumMember":k};}}if(j){p[j.v4PropertyAnnotation]=p[j.v4PropertyAnnotation]||B;}});}},addUnitAnnotations:function(S,M){function p(t){(t||[]).forEach(function(T){(T.property||[]).forEach(function(P){var A,i,e,o,u,g=P["sap:unit"],h;if(g){i={getModel:function(){return M;},getPath:function(){return T.$path;}};u={"Path":g};o=_.followPath(i,u);if(o&&o.resolvedPath){h=M.getProperty(o.resolvedPath);e=h["sap:semantics"];if(e==="unit-of-measure"){A="Org.OData.Measures.V1.Unit";}else if(e==="currency-code"){A="Org.OData.Measures.V1.ISOCurrency";}else if(L.isLoggable(w,l)){L.warning("Unsupported sap:semantics='"+e+"' at sap:unit='"+g+"'; "+"expected 'currency-code' or 'unit-of-measure'",T.namespace+"."+T.name+"/"+P.name,l);}if(A&&!(A in P)){P[A]=u;}}else if(L.isLoggable(w,l)){L.warning("Path '"+g+"' for sap:unit cannot be resolved",T.namespace+"."+T.name+"/"+P.name,l);}}});});}S.forEach(function(o){p(o.complexType);p(o.entityType);});},addV4Annotation:function(o,e,t){switch(e.name){case"aggregation-role":if(e.value==="dimension"){o["com.sap.vocabularies.Analytics.v1.Dimension"]=B;}else if(e.value==="measure"){o["com.sap.vocabularies.Analytics.v1.Measure"]=B;}break;case"display-format":if(e.value==="NonNegative"){o["com.sap.vocabularies.Common.v1.IsDigitSequence"]=B;}else if(e.value==="UpperCase"){o["com.sap.vocabularies.Common.v1.IsUpperCase"]=B;}break;case"pageable":case"topable":U.addEntitySetAnnotation(o,e,t,"false",false);break;case"creatable":U.addEntitySetAnnotation(o,e,t,"false",true);break;case"deletable":case"deletable-path":U.handleXableAndXablePath(o,e,t,"Org.OData.Capabilities.V1.DeleteRestrictions","Deletable");break;case"updatable":case"updatable-path":U.handleXableAndXablePath(o,e,t,"Org.OData.Capabilities.V1.UpdateRestrictions","Updatable");break;case"requires-filter":U.addEntitySetAnnotation(o,e,t,"true",true);break;case"field-control":o["com.sap.vocabularies.Common.v1.FieldControl"]={"Path":e.value};break;case"heading":o["com.sap.vocabularies.Common.v1.Heading"]={"String":e.value};break;case"label":o["com.sap.vocabularies.Common.v1.Label"]={"String":e.value};break;case"precision":o["Org.OData.Measures.V1.Scale"]={"Path":e.value};break;case"quickinfo":o["com.sap.vocabularies.Common.v1.QuickInfo"]={"String":e.value};break;case"text":o["com.sap.vocabularies.Common.v1.Text"]={"Path":e.value};break;case"visible":if(e.value==="false"){o["com.sap.vocabularies.Common.v1.FieldControl"]={"EnumMember":"com.sap.vocabularies.Common.v1.FieldControlType/Hidden"};o["com.sap.vocabularies.UI.v1.Hidden"]=B;}break;default:}},calculateEntitySetAnnotations:function(e,E){if(E.property){E.property.forEach(function(p){if(p["sap:filterable"]==="false"){U.addPropertyToAnnotation("sap:filterable",e,p);}if(p["sap:required-in-filter"]==="true"){U.addPropertyToAnnotation("sap:required-in-filter",e,p);}if(p["sap:sortable"]==="false"){U.addPropertyToAnnotation("sap:sortable",e,p);}if(p["sap:filter-restriction"]){U.addFilterRestriction(p,e);}});}if(E.navigationProperty){E.navigationProperty.forEach(function(n){if(n["sap:filterable"]==="false"){U.addNavigationFilterRestriction(n,e);U.addPropertyToAnnotation("sap:filterable",e,n);}U.handleCreatableNavigationProperty(e,n);});}},findIndex:function(A,e,p){var i,n;p=p||"name";if(A){for(i=0,n=A.length;i<n;i+=1){if(A[i][p]===e){return i;}}}return-1;},findObject:function(A,e,p){var i=U.findIndex(A,e,p);return i<0?null:A[i];},getChildAnnotations:function(A,Q,i){var o=i?A.EntityContainer:A.propertyAnnotations;return o&&o[Q]||{};},getFromContainer:function(e,A,n,g){var k,R=g?undefined:null;if(e){k=U.findIndex(e[A],n);if(k>=0){R=g?e.$path+"/"+A+"/"+k:e[A][k];}}return R;},getObject:function(M,A,Q,e){var g,R=e?undefined:null,S,i,n,N;Q=Q||"";i=Q.lastIndexOf(".");n=Q.slice(0,i);N=Q.slice(i+1);S=U.getSchema(M,n);if(S){g=S[A];if(g){g.forEach(function(t){if(t.name===N){R=e?t.$path:t;return false;}});}}return R;},getSchema:function(M,n){var S=null,e=Array.isArray(M)?M:M.getObject("/dataServices/schema");if(e){e.forEach(function(o){if(o.namespace===n){S=o;return false;}});}return S;},getV4TypesForV2Semantics:function(S,t,p,T){var R=[],o=v[S];if(o){t.split(",").forEach(function(e){var g=o.typeMapping[e];if(g){R.push(o.v4EnumType+"/"+g);}else if(L.isLoggable(w,l)){L.warning("Unsupported type for sap:semantics: "+e,T.name+"."+p.name,l);}});}return R.join(" ");},getValueLists:function(p){var M,n,Q,e={};for(n in p){M=c.exec(n);if(M){Q=(M[1]||"").slice(1);e[Q]=p[n];}}return e;},handleCreatableNavigationProperty:function(e,n){var C=n["sap:creatable"],g=n["sap:creatable-path"],i,N={"NavigationPropertyPath":n.name},h;if(C&&g){L.warning("Inconsistent service","Use either 'sap:creatable' or 'sap:creatable-path' at navigation property "+"'"+e.entityType+"/"+n.name+"'",l);C="false";g=undefined;}if(C==="false"||g){i=e["Org.OData.Capabilities.V1.InsertRestrictions"]=e["Org.OData.Capabilities.V1.InsertRestrictions"]||{};h=i["NonInsertableNavigationProperties"]=i["NonInsertableNavigationProperties"]||[];if(g){N={"If":[{"Not":{"Path":g}},N]};}h.push(N);}},handleXableAndXablePath:function(o,e,t,T,p){var g=p.toLowerCase(),h;if(t!=="EntitySet"){return;}if(o["sap:"+g]&&o["sap:"+g+"-path"]){L.warning("Inconsistent service","Use either 'sap:"+g+"' or 'sap:"+g+"-path'"+" at entity set '"+o.name+"'",l);h=b;}else if(g!==e.name){h={"Path":e.value};}else if(e.value==="false"){h=b;}if(h){o[T]=o[T]||{};o[T][p]=h;}},liftSAPData:function(o,t){if(!o.extensions){return;}o.extensions.forEach(function(e){if(e.namespace==="http://www.sap.com/Protocols/SAPData"){o["sap:"+e.name]=e.value;U.addV4Annotation(o,e,t);}});switch(t){case"Property":if(o["sap:updatable"]==="false"){if(o["sap:creatable"]==="false"){o["Org.OData.Core.V1.Computed"]=B;}else{o["Org.OData.Core.V1.Immutable"]=B;}}break;case"EntitySet":if(o["sap:searchable"]!=="true"){o["Org.OData.Capabilities.V1.SearchRestrictions"]={"Searchable":b};}break;default:}},merge:function(A,D,M){var S=D.dataServices.schema;if(!S){return;}S.forEach(function(o,i){var e;delete o.annotations;U.liftSAPData(o);o.$path="/dataServices/schema/"+i;e=o["sap:schema-version"];if(e){o["Org.Odata.Core.V1.SchemaVersion"]={String:e};}q.extend(o,A[o.namespace]);U.visitParents(o,A,"association",function(g,C){U.visitChildren(g.end,C);});U.visitParents(o,A,"complexType",function(C,g){U.visitChildren(C.property,g,"Property");U.addSapSemantics(C);});U.visitParents(o,A,"entityType",U.visitEntityType);U.visitParents(o,A,"entityContainer",function(E,C){U.visitChildren(E.associationSet,C);U.visitChildren(E.entitySet,C,"EntitySet",S);U.visitChildren(E.functionImport,C,"",null,U.visitParameters.bind(this,A,o,E));});});U.addUnitAnnotations(S,M);},visitChildren:function(C,e,t,S,g,i){if(!C){return;}if(i){C=C.slice(i);}C.forEach(function(o){U.liftSAPData(o,t);});C.forEach(function(o){var E;if(t==="EntitySet"){E=U.getObject(S,"entityType",o.entityType);U.calculateEntitySetAnnotations(o,E);}if(g){g(o);}q.extend(o,e[o.name||o.role]);});},visitEntityType:function(e,C){U.visitChildren(e.property,C,"Property");U.visitChildren(e.navigationProperty,C);U.addSapSemantics(e);},visitParameters:function(A,S,e,F){var g;if(!F.parameter){return;}g=U.getChildAnnotations(A,S.namespace+"."+e.name,true);F.parameter.forEach(function(p){U.liftSAPData(p);q.extend(p,g[F.name+"/"+p.name]);});},visitParents:function(S,A,e,C,i){var p=S[e];function g(P,j){var Q=S.namespace+"."+P.name,h=U.getChildAnnotations(A,Q,e==="entityContainer");U.liftSAPData(P);P.namespace=S.namespace;P.$path=S.$path+"/"+e+"/"+j;C(P,h);q.extend(P,A[Q]);}if(!p){return;}if(i!==undefined){g(p[i],i);}else{p.forEach(g);}}};return U;},false);
sap.ui.predefine('sap/ui/model/odata/type/Boolean',["sap/base/Log","sap/ui/core/Core","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType"],function(L,C,F,P,V,O){"use strict";
function g(){return a("EnterYesOrNo",[b(true),b(false)]);}
function a(k,p){return sap.ui.getCore().getLibraryResourceBundle().getText(k,p);}
function b(v){return a(v?"YES":"NO");}
function s(t,c){var n;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}}
var E=O.extend("sap.ui.model.odata.type.Boolean",{constructor:function(f,c){O.apply(this,arguments);s(this,c);}});
E.prototype.formatValue=function(v,t){if(v===null||v===undefined){return null;}switch(this.getPrimitiveType(t)){case"any":case"boolean":return v;case"string":return b(v);default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
E.prototype.parseValue=function(v,S){var c;if(v===null||v===""){return null;}switch(this.getPrimitiveType(S)){case"boolean":return v;case"string":c=v.trim().toLowerCase();if(c===b(true).toLowerCase()){return true;}if(c===b(false).toLowerCase()){return false;}throw new P(g());default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}};
E.prototype.validateValue=function(v){if(v===null){if(this.oConstraints&&this.oConstraints.nullable===false){throw new V(g());}return;}if(typeof v!=="boolean"){throw new V("Illegal "+this.getName()+" value: "+v);}};
E.prototype.getName=function(){return"sap.ui.model.odata.type.Boolean";};
return E;});
sap.ui.predefine('sap/ui/model/odata/type/Byte',["sap/ui/model/odata/type/Int"],function(I){"use strict";var r={minimum:0,maximum:255};
var B=I.extend("sap.ui.model.odata.type.Byte",{constructor:function(){I.apply(this,arguments);}});
B.prototype.getName=function(){return"sap.ui.model.odata.type.Byte";};
B.prototype.getRange=function(){return r;};
return B;});
sap.ui.predefine('sap/ui/model/odata/type/Currency',["./UnitMixin","sap/ui/model/type/Currency"],function(a,B){"use strict";
var C=B.extend("sap.ui.model.odata.type.Currency",{constructor:function(f,c){this._applyUnitMixin.apply(this,arguments);}});
a(C.prototype,B,"customCurrencies");
C.prototype.getCustomUnitForKey=function(c,k){return{decimals:c[k].UnitSpecificScale,isoCode:c[k].StandardCode};};
C.prototype.getName=function(){return"sap.ui.model.odata.type.Currency";};
return C;});
sap.ui.predefine('sap/ui/model/odata/type/Date',["sap/base/Log","sap/ui/core/CalendarType","sap/ui/core/format/DateFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType","sap/ui/thirdparty/jquery"],function(L,C,D,F,P,V,O,q){"use strict";var r=/\d{4}-(?:0[1-9]|1[0-2])-(?:0[1-9]|[12]\d|3[01])/,d=new Date().getFullYear()+"-12-31",m;
function g(t){return sap.ui.getCore().getLibraryResourceBundle().getText("EnterDate",[t.formatValue(d,"string")]);}
function a(t){var f;if(!t.oFormat){f=q.extend({strictParsing:true},t.oFormatOptions);f.UTC=true;t.oFormat=D.getDateInstance(f);}return t.oFormat;}
function b(){if(!m){m=D.getDateInstance({calendarType:C.Gregorian,pattern:'yyyy-MM-dd',strictParsing:true,UTC:true});}return m;}
function s(t,c){var n;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}}
var E=O.extend("sap.ui.model.odata.type.Date",{constructor:function(f,c){O.apply(this,arguments);this.oFormatOptions=f;s(this,c);}});
E.prototype._handleLocalizationChange=function(){this.oFormat=null;};
E.prototype.formatValue=function(v,t){var o;if(v===undefined||v===null){return null;}switch(this.getPrimitiveType(t)){case"any":return v;case"object":return v instanceof Date?new Date(v.getUTCFullYear(),v.getUTCMonth(),v.getUTCDate()):b().parse(v,false);case"string":o=v instanceof Date?v:b().parse(v);return o?a(this).format(o):v;default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
E.prototype.getModelFormat=function(){return b();};
E.prototype.getName=function(){return"sap.ui.model.odata.type.Date";};
E.prototype.parseValue=function(v,S){var R;if(v===""||v===null){return null;}switch(this.getPrimitiveType(S)){case"object":return b().format(v,false);case"string":R=a(this).parse(v);if(!R){throw new P(g(this));}return b().format(R);default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}};
E.prototype.validateValue=function(v){if(v===null){if(this.oConstraints&&this.oConstraints.nullable===false){throw new V(g(this));}}else if(typeof v!=="string"||!r.test(v)){throw new V("Illegal "+this.getName()+" value: "+v);}};
E._resetModelFormatter=function(){m=undefined;};
return E;});
sap.ui.predefine('sap/ui/model/odata/type/DateTime',["sap/base/Log","sap/ui/model/odata/type/DateTimeBase"],function(L,D){"use strict";
function a(t,c){var A={};if(c){switch(c.displayFormat){case"Date":A.isDateOnly=true;break;case undefined:break;default:L.warning("Illegal displayFormat: "+c.displayFormat,null,t.getName());}A.nullable=c.nullable;}return A;}
var b=D.extend("sap.ui.model.odata.type.DateTime",{constructor:function(f,c){D.call(this,f,a(this,c));}});
b.prototype.getName=function(){return"sap.ui.model.odata.type.DateTime";};
return b;});
sap.ui.predefine('sap/ui/model/odata/type/DateTimeBase',["sap/base/Log","sap/ui/core/format/DateFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType","sap/ui/thirdparty/jquery"],function(L,D,F,P,V,O,q){"use strict";var f=new Date().getFullYear(),d=new Date(Date.UTC(f,11,31)),o=new Date(f,11,31,23,59,58);
function i(t){return t.oConstraints&&t.oConstraints.isDateOnly;}
function g(t){return sap.ui.getCore().getLibraryResourceBundle().getText(i(t)?"EnterDate":"EnterDateTime",[t.formatValue(i(t)?d:o,"string")]);}
function a(t){var c;if(!t.oFormat){c=q.extend({strictParsing:true},t.oFormatOptions);if(i(t)){c.UTC=true;t.oFormat=D.getDateInstance(c);}else{t.oFormat=D.getDateTimeInstance(c);}}return t.oFormat;}
function s(t,c){var n,p;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}if(c.isDateOnly===true){t.oConstraints=t.oConstraints||{};t.oConstraints.isDateOnly=true;}p=c.precision;if(p!==undefined){if(p===Math.floor(p)&&p>=1&&p<=12){t.oConstraints=t.oConstraints||{};t.oConstraints.precision=p;}else if(p!==0){L.warning("Illegal precision: "+p,null,t.getName());}}}t._handleLocalizationChange();}
var b=O.extend("sap.ui.model.odata.type.DateTimeBase",{
constructor:function(c,C){O.apply(this,arguments);s(this,C);this.oFormat=null;this.oFormatOptions=c;},
metadata:{"abstract":true}
});
b.prototype.formatValue=function(v,t){if(v===null||v===undefined){return null;}switch(this.getPrimitiveType(t)){case"any":case"object":return v;case"string":if(!(v instanceof Date)){throw new F("Illegal "+this.getName()+" value: "+v);}return a(this).format(v);default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
b.prototype.parseValue=function(v,S){var r;if(v===null||v===""){return null;}switch(this.getPrimitiveType(S)){case"object":return v;case"string":r=a(this).parse(v);if(!r){throw new P(g(this));}return r;default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}};
b.prototype._handleLocalizationChange=function(){this.oFormat=null;};
b.prototype.validateValue=function(v){if(v===null){if(this.oConstraints&&this.oConstraints.nullable===false){throw new V(g(this));}return;}else if(v instanceof Date){if(v.getFullYear()===0){throw new V(g(this));}return;}throw new V("Illegal "+this.getName()+" value: "+v);};
return b;});
sap.ui.predefine('sap/ui/model/odata/type/DateTimeOffset',["sap/base/Log","sap/ui/core/CalendarType","sap/ui/core/format/DateFormat","sap/ui/model/FormatException","sap/ui/model/odata/type/DateTimeBase"],function(L,C,D,F,a){"use strict";
var b=a.extend("sap.ui.model.odata.type.DateTimeOffset",{constructor:function(f,c){var v;a.call(this,f,{nullable:c?c.nullable:undefined,precision:c?c.precision:undefined});this.rDateTimeOffset=undefined;this.oModelFormat=undefined;this.bV4=false;if(c){v=c.V4;if(v===true){this.bV4=true;}else if(v!==undefined&&v!==false){L.warning("Illegal V4: "+v,null,this.getName());}}}});
function g(t){var p="yyyy-MM-dd'T'HH:mm:ss",P;if(!t.oModelFormat){P=t.oConstraints&&t.oConstraints.precision;if(P){p+="."+"".padEnd(P,"S");}t.oModelFormat=D.getDateInstance({calendarType:C.Gregorian,pattern:p+"XXX",strictParsing:true,UTC:t.oFormatOptions&&t.oFormatOptions.UTC});}return t.oModelFormat;}
b.prototype._resetModelFormatter=function(){this.oModelFormat=undefined;};
b.prototype.formatValue=function(v,t){var d;if(v===undefined||v===null){return null;}if(this.getPrimitiveType(t)==="object"){if(v instanceof Date){return new Date(v.getUTCFullYear(),v.getUTCMonth(),v.getUTCDate(),v.getUTCHours(),v.getUTCMinutes(),v.getUTCSeconds());}return g(this).parse(v);}if(typeof v==="string"&&this.getPrimitiveType(t)==="string"){d=g(this).parse(v);if(!d){throw new F("Illegal "+this.getName()+" value: "+v);}v=d;}return a.prototype.formatValue.call(this,v,t);};
b.prototype.getModelFormat=function(){if(this.bV4){return g(this);}return a.prototype.getModelFormat.call(this);};
b.prototype.getName=function(){return"sap.ui.model.odata.type.DateTimeOffset";};
b.prototype.parseValue=function(v,s){var r=a.prototype.parseValue.call(this,v,s);return this.bV4&&r!==null?g(this).format(r):r;};
b.prototype.setV4=function(){this.bV4=true;return this;};
b.prototype.validateValue=function(v){var p;if(this.bV4){if(typeof v==="string"){if(!this.rDateTimeOffset){p=this.oConstraints&&this.oConstraints.precision;this.rDateTimeOffset=new RegExp("^"+"\\d{4}-(?:0[1-9]|1[0-2])-(?:0[1-9]|[12]\\d|3[01])"+"T"+"(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d"+(p?"(\\.\\d{1,"+p+"})?":"")+")?"+"(?:Z|[-+](?:0\\d|1[0-3]):[0-5]\\d|[-+]14:00)$","i");}if(this.rDateTimeOffset.test(v)){return;}}else if(v){v=v.toString();}}a.prototype.validateValue.call(this,v);};
return b;});
sap.ui.predefine('sap/ui/model/odata/type/Decimal',["sap/base/Log","sap/ui/core/format/NumberFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/ODataUtils","sap/ui/model/odata/type/ODataType","sap/ui/thirdparty/jquery"],function(L,N,F,P,V,B,O,q){"use strict";var r=/^[-+]?(\d+)(?:\.(\d+))?$/,a=/(?:(\.[0-9]*[1-9]+)0+|\.0*)$/;
function g(t){var f,S;if(!t.oFormat){f={groupingEnabled:true,maxIntegerDigits:Infinity};S=b(t);if(S!==Infinity){f.minFractionDigits=f.maxFractionDigits=S;}f=q.extend(f,t.oFormatOptions);f.parseAsString=true;t.oFormat=N.getFloatInstance(f);}return t.oFormat;}
function b(t){return(t.oConstraints&&t.oConstraints.scale)||0;}
function c(k,p){return sap.ui.getCore().getLibraryResourceBundle().getText(k,p);}
function d(v){if(v.indexOf(".")>=0){v=v.replace(a,"$1");}return v;}
function s(t,C){var n,p,v,S,e;function l(k,m){L.warning("Illegal "+m+": "+k,null,t.getName());}function f(k,m,M,o){var u=typeof k==="string"?parseInt(k):k;if(u===undefined){return m;}if(typeof u!=="number"||isNaN(u)||u<M){l(k,o);return m;}return u;}function h(k,m){if(k){if(k.match(r)){return k;}l(k,m);}}function i(k,m){if(k===true||k==="true"){return true;}if(k!==undefined&&k!==false&&k!=="false"){l(k,m);}}function j(k,m,o){if(m!==o){t.oConstraints=t.oConstraints||{};t.oConstraints[k]=m;}}t.oConstraints=undefined;if(C){n=C.nullable;v=C.precision;e=C.scale;S=e==="variable"?Infinity:f(e,0,0,"scale");p=f(v,Infinity,1,"precision");if(S!==Infinity&&p<=S){L.warning("Illegal scale: must be less than precision (precision="+v+", scale="+e+")",null,t.getName());S=Infinity;}j("precision",p,Infinity);j("scale",S,0);if(n===false||n==="false"){j("nullable",false,true);}else if(n!==undefined&&n!==true&&n!=="true"){l(n,"nullable");}j("minimum",h(C.minimum,"minimum"));j("minimumExclusive",i(C.minimumExclusive,"minimumExclusive"));j("maximum",h(C.maximum,"maximum"));j("maximumExclusive",i(C.maximumExclusive,"maximumExclusive"));}t._handleLocalizationChange();}
var D=O.extend("sap.ui.model.odata.type.Decimal",{constructor:function(f,C){O.apply(this,arguments);this.oFormatOptions=f;s(this,C);}});
D.prototype.formatValue=function(v,t){if(v===null||v===undefined){return null;}switch(this.getPrimitiveType(t)){case"any":return v;case"float":return parseFloat(v);case"int":return Math.floor(parseFloat(v));case"string":return g(this).format(d(String(v)));default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
D.prototype.parseValue=function(v,S){var R;if(v===null||v===""){return null;}switch(this.getPrimitiveType(S)){case"string":R=g(this).parse(v);if(!R){throw new P(sap.ui.getCore().getLibraryResourceBundle().getText("EnterNumber"));}R=d(R);break;case"int":case"float":R=N.getFloatInstance({maxIntegerDigits:Infinity,decimalSeparator:".",groupingEnabled:false}).format(v);break;default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}return R;};
D.prototype._handleLocalizationChange=function(){this.oFormat=null;};
D.prototype.validateValue=function(v){var f,i,m,M,e,h,j,p,S;if(v===null&&(!this.oConstraints||this.oConstraints.nullable!==false)){return;}if(typeof v!=="string"){throw new V(c("EnterNumber"));}m=r.exec(v);if(!m){throw new V(c("EnterNumber"));}i=m[1].length;f=(m[2]||"").length;S=b(this);p=(this.oConstraints&&this.oConstraints.precision)||Infinity;h=this.oConstraints&&this.oConstraints.minimum;M=this.oConstraints&&this.oConstraints.maximum;if(f>S){if(S===0){throw new V(c("EnterInt"));}else if(i+S>p){throw new V(c("EnterNumberIntegerFraction",[p-S,S]));}throw new V(c("EnterNumberFraction",[S]));}if(S===Infinity){if(i+f>p){throw new V(c("EnterNumberPrecision",[p]));}}else if(i>p-S){if(S){throw new V(c("EnterNumberInteger",[p-S]));}else{throw new V(c("EnterMaximumOfDigits",[p]));}}if(h){j=this.oConstraints.minimumExclusive;if(B.compare(h,v,true)>=(j?0:1)){throw new V(c(j?"EnterNumberMinExclusive":"EnterNumberMin",[this.formatValue(h,"string")]));}}if(M){e=this.oConstraints.maximumExclusive;if(B.compare(M,v,true)<=(e?0:-1)){throw new V(c(e?"EnterNumberMaxExclusive":"EnterNumberMax",[this.formatValue(M,"string")]));}}};
D.prototype.getName=function(){return"sap.ui.model.odata.type.Decimal";};
return D;});
sap.ui.predefine('sap/ui/model/odata/type/Double',["sap/base/Log","sap/ui/core/format/NumberFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType","sap/ui/thirdparty/jquery"],function(L,N,F,P,V,O,q){"use strict";
function g(){return sap.ui.getCore().getLibraryResourceBundle().getText("EnterNumber");}
function a(t){var f;if(!t.oFormat){f=q.extend({groupingEnabled:true},t.oFormatOptions);t.oFormat=N.getFloatInstance(f);}return t.oFormat;}
function i(t){return!t.oConstraints||t.oConstraints.nullable!==false;}
function s(t,c){var n;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}t._handleLocalizationChange();}
var D=O.extend("sap.ui.model.odata.type.Double",{constructor:function(f,c){O.apply(this,arguments);this.oFormatOptions=f;s(this,c);}});
D.prototype.formatValue=function(v,t){var f,b;if(v===null||v===undefined){return null;}if(typeof v==="number"){b=v;}else if(typeof v==="string"){b=parseFloat(v);}else if(t!=="any"){throw new F("Illegal "+this.getName()+" value: "+v);}switch(this.getPrimitiveType(t)){case"any":return v;case"float":return b;case"int":return Math.floor(b);case"string":if(b&&(Math.abs(b)>=1e15||Math.abs(b)<1e-4)){f=a(this).oFormatOptions;return b.toExponential().replace("e","\u00a0E").replace(".",f.decimalSeparator).replace("+",f.plusSign).replace("-",f.minusSign);}return a(this).format(b);default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
D.prototype.parseValue=function(v,S){var r;if(v===null||v===""){return null;}switch(this.getPrimitiveType(S)){case"string":r=a(this).parse(v);if(isNaN(r)){throw new P(g());}break;case"int":case"float":r=v;break;default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}return r;};
D.prototype._handleLocalizationChange=function(){this.oFormat=null;};
D.prototype.validateValue=function(v){if(v===null&&i(this)){return;}if(typeof v==="number"){return;}throw new V(g());};
D.prototype.getName=function(){return"sap.ui.model.odata.type.Double";};
return D;});
sap.ui.predefine('sap/ui/model/odata/type/Guid',["sap/base/Log","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType"],function(L,F,P,V,O){"use strict";var r=/[-\s]/g,a=/^[A-F0-9]{8}-([A-F0-9]{4}-){3}[A-F0-9]{12}$/i;
function g(){return sap.ui.getCore().getLibraryResourceBundle().getText("EnterGuid");}
function s(t,c){var n;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}}
var E=O.extend("sap.ui.model.odata.type.Guid",{constructor:function(f,c){O.apply(this,arguments);s(this,c);}});
E.prototype.formatValue=function(v,t){if(v===undefined||v===null){return null;}switch(this.getPrimitiveType(t)){case"any":case"string":return v;default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
E.prototype.getName=function(){return"sap.ui.model.odata.type.Guid";};
E.prototype.parseValue=function(v,S){var R;if(v===""||v===null){return null;}if(this.getPrimitiveType(S)!=="string"){throw new P("Don't know how to parse "+this.getName()+" from "+S);}R=v.replace(r,'');if(R.length!==32){return v;}return R.slice(0,8)+'-'+R.slice(8,12)+'-'+R.slice(12,16)+'-'+R.slice(16,20)+'-'+R.slice(20);};
E.prototype.validateValue=function(v){if(v===null){if(this.oConstraints&&this.oConstraints.nullable===false){throw new V(g());}return;}if(typeof v!=="string"){throw new V("Illegal "+this.getName()+" value: "+v);}if(!a.test(v)){throw new V(g());}};
return E;});
sap.ui.predefine('sap/ui/model/odata/type/Int',["sap/base/Log","sap/ui/core/format/NumberFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType","sap/ui/thirdparty/jquery"],function(L,N,F,P,V,O,q){"use strict";
function g(t){var f;if(!t.oFormat){f=q.extend({groupingEnabled:true},t.oFormatOptions);t.oFormat=N.getIntegerInstance(f);}return t.oFormat;}
function a(k,p){return sap.ui.getCore().getLibraryResourceBundle().getText(k,p);}
function s(t,c){var n;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}t._handleLocalizationChange();}
var I=O.extend("sap.ui.model.odata.type.Int",{
constructor:function(f,c){O.apply(this,arguments);this.oFormatOptions=f;s(this,c);},
metadata:{"abstract":true}
});
I.prototype._handleLocalizationChange=function(){this.oFormat=null;};
I.prototype.formatValue=function(v,t){if(v===undefined||v===null){return null;}if(typeof v!=="number"&&t!=="any"){throw new F("Illegal "+this.getName()+" value: "+v);}switch(this.getPrimitiveType(t)){case"string":return g(this).format(v);case"int":return Math.floor(v);case"float":case"any":return v;default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
I.prototype.parseValue=function(v,S){var r;if(v===null||v===""){return null;}switch(this.getPrimitiveType(S)){case"string":r=g(this).parse(v);if(isNaN(r)){throw new P(a("EnterInt"));}return r;case"float":return Math.floor(v);case"int":return v;default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}};
I.prototype.validateValue=function(v){var r=this.getRange();if(v===null){if(this.oConstraints&&this.oConstraints.nullable===false){throw new V(a("EnterInt"));}return;}if(typeof v!=="number"){throw new V(v+" (of type "+typeof v+") is not a valid "+this.getName()+" value");}if(Math.floor(v)!==v){throw new V(a("EnterInt"));}if(v<r.minimum){throw new V(a("EnterNumberMin",[this.formatValue(r.minimum,"string")]));}if(v>r.maximum){throw new V(a("EnterNumberMax",[this.formatValue(r.maximum,"string")]));}};
return I;});
sap.ui.predefine('sap/ui/model/odata/type/Int16',["sap/ui/model/odata/type/Int"],function(I){"use strict";var r={minimum:-32768,maximum:32767};
var a=I.extend("sap.ui.model.odata.type.Int16",{constructor:function(){I.apply(this,arguments);}});
a.prototype.getName=function(){return"sap.ui.model.odata.type.Int16";};
a.prototype.getRange=function(){return r;};
return a;});
sap.ui.predefine('sap/ui/model/odata/type/Int32',["sap/ui/model/odata/type/Int"],function(I){"use strict";var r={minimum:-2147483648,maximum:2147483647};
var a=I.extend("sap.ui.model.odata.type.Int32",{constructor:function(){I.apply(this,arguments);}});
a.prototype.getName=function(){return"sap.ui.model.odata.type.Int32";};
a.prototype.getRange=function(){return r;};
return a;});
sap.ui.predefine('sap/ui/model/odata/type/Int64',["sap/base/Log","sap/ui/core/format/NumberFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType","sap/ui/thirdparty/jquery"],function(L,N,F,P,V,O,q){"use strict";var r=/^[-+]?(\d+)$/,R={minimum:"-9223372036854775808",maximum:"9223372036854775807"},s={minimum:"-9007199254740991",maximum:"9007199254740991"};
function c(t,v,R){var A,m,n;m=r.exec(v);if(m){n=v.charAt(0)==='-';A=n?R.minimum.slice(1):R.maximum;if(m[1].length<A.length){return undefined;}if(m[1].length>A.length||m[1]>A){if(n){return a("EnterNumberMin",[t.formatValue(R.minimum,"string")]);}else{return a("EnterNumberMax",[t.formatValue(R.maximum,"string")]);}}return undefined;}return a("EnterInt");}
function g(t){var f;if(!t.oFormat){f=q.extend({groupingEnabled:true},t.oFormatOptions);f.parseAsString=true;t.oFormat=N.getIntegerInstance(f);}return t.oFormat;}
function a(k,p){return sap.ui.getCore().getLibraryResourceBundle().getText(k,p);}
function i(t){return!t.oConstraints||t.oConstraints.nullable!==false;}
function b(t,C){var n;t.oConstraints=undefined;if(C){n=C.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}t._handleLocalizationChange();}
var I=O.extend("sap.ui.model.odata.type.Int64",{constructor:function(f,C){O.apply(this,arguments);this.oFormatOptions=f;b(this,C);}});
I.prototype.formatValue=function(v,t){var e;if(v===null||v===undefined){return null;}switch(this.getPrimitiveType(t)){case"any":return v;case"float":case"int":e=c(this,v,s);if(e){throw new F(e);}return parseInt(v);case"string":return g(this).format(v);default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
I.prototype.getName=function(){return"sap.ui.model.odata.type.Int64";};
I.prototype._handleLocalizationChange=function(){this.oFormat=null;};
I.prototype.parseValue=function(v,S){var d;if(v===null||v===""){return null;}switch(this.getPrimitiveType(S)){case"string":d=g(this).parse(v);if(!d){throw new P(a("EnterInt"));}break;case"int":case"float":d=N.getIntegerInstance({maxIntegerDigits:Infinity,groupingEnabled:false}).format(v);break;default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}return d;};
I.prototype.validateValue=function(v){var e;if(v===null&&i(this)){return;}if(typeof v==="string"){e=c(this,v,R);if(e){throw new V(e);}return;}throw new V(a("EnterInt"));};
return I;});
sap.ui.predefine('sap/ui/model/odata/type/ODataType',["sap/ui/model/SimpleType"],function(S){"use strict";
var O=S.extend("sap.ui.model.odata.type.ODataType",{
constructor:function(f,c){},
metadata:{"abstract":true}
});
O.prototype.getInterface=function(){return this;};
O.prototype.setConstraints=function(c){};
O.prototype.setFormatOptions=function(f){};
return O;});
sap.ui.predefine('sap/ui/model/odata/type/Raw',["sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType"],function(F,P,V,O){"use strict";
var R=O.extend("sap.ui.model.odata.type.Raw",{constructor:function(f,c){O.apply(this,arguments);if(f!==undefined||c!==undefined||arguments.length>2){throw new Error("Unsupported arguments");}}});
R.prototype.formatValue=function(v,t){if(t==="any"){return v;}throw new F("Type 'sap.ui.model.odata.type.Raw' does not support formatting");};
R.prototype.getName=function(){return"sap.ui.model.odata.type.Raw";};
R.prototype.parseValue=function(){throw new P("Type 'sap.ui.model.odata.type.Raw' does not support parsing");};
R.prototype.validateValue=function(){throw new V("Type 'sap.ui.model.odata.type.Raw' does not support validating");};
return R;});
sap.ui.predefine('sap/ui/model/odata/type/SByte',["sap/ui/model/odata/type/Int"],function(I){"use strict";var r={minimum:-128,maximum:127};
var S=I.extend("sap.ui.model.odata.type.SByte",{constructor:function(){I.apply(this,arguments);}});
S.prototype.getName=function(){return"sap.ui.model.odata.type.SByte";};
S.prototype.getRange=function(){return r;};
return S;});
sap.ui.predefine('sap/ui/model/odata/type/Single',["sap/base/Log","sap/ui/core/format/NumberFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType","sap/ui/thirdparty/jquery"],function(L,N,F,P,V,O,q){"use strict";
function g(){return sap.ui.getCore().getLibraryResourceBundle().getText("EnterNumber");}
function a(t){var f;if(!t.oFormat){f=q.extend({groupingEnabled:true},t.oFormatOptions);t.oFormat=N.getFloatInstance(f);}return t.oFormat;}
function i(t){return!t.oConstraints||t.oConstraints.nullable!==false;}
function s(t,c){var n;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false||n==="false"){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}t._handleLocalizationChange();}
var S=O.extend("sap.ui.model.odata.type.Single",{constructor:function(f,c){O.apply(this,arguments);this.oFormatOptions=f;s(this,c);}});
S.prototype.formatValue=function(v,t){var f;if(v===null||v===undefined){return null;}if(typeof v==="number"){f=v;}else if(typeof v==="string"){f=parseFloat(v);}else if(t!=="any"){throw new F("Illegal "+this.getName()+" value: "+v);}switch(this.getPrimitiveType(t)){case"any":return v;case"float":return f;case"int":return Math.floor(f);case"string":return a(this).format(parseFloat(f.toPrecision(7)));default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
S.prototype.parseValue=function(v,b){var r;if(v===null||v===""){return null;}switch(this.getPrimitiveType(b)){case"string":r=a(this).parse(v);if(isNaN(r)){throw new P(g());}break;case"int":case"float":r=v;break;default:throw new P("Don't know how to parse "+this.getName()+" from "+b);}return Math.fround(r);};
S.prototype._handleLocalizationChange=function(){this.oFormat=null;};
S.prototype.validateValue=function(v){if(v===null&&i(this)){return;}if(typeof v==="number"){return;}throw new V(g());};
S.prototype.getName=function(){return"sap.ui.model.odata.type.Single";};
return S;});
sap.ui.predefine('sap/ui/model/odata/type/Stream',["sap/base/Log","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType"],function(L,F,P,V,O){"use strict";
function s(t,c){var n;t.oConstraints=undefined;if(c){n=c.nullable;if(n===false){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true){L.warning("Illegal nullable: "+n,null,t.getName());}}}
var S=O.extend("sap.ui.model.odata.type.Stream",{constructor:function(f,c){O.apply(this,arguments);if(f!==undefined){throw new Error("Unsupported arguments");}s(this,c);}});
S.prototype.formatValue=function(v,t){switch(this.getPrimitiveType(t)){case"any":case"string":return v;default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
S.prototype.getName=function(){return"sap.ui.model.odata.type.Stream";};
S.prototype.parseValue=function(){throw new P("Type 'sap.ui.model.odata.type.Stream' does not support parsing");};
S.prototype.validateValue=function(){throw new V("Type 'sap.ui.model.odata.type.Stream' does not support validating");};
return S;});
sap.ui.predefine('sap/ui/model/odata/type/String',["sap/base/Log","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType","sap/ui/model/type/String"],function(L,V,O,S){"use strict";var r=/^\d+$/,a=/^0*(?=\d)/;
function i(v,c){return c&&c.isDigitSequence&&v&&v.match(r);}
function s(t,c){var I,m,n;t.oConstraints=undefined;if(c){m=c.maxLength;if(typeof m==="string"){m=parseInt(m);}if(typeof m==="number"&&!isNaN(m)&&m>0){t.oConstraints={maxLength:m};}else if(m!==undefined){L.warning("Illegal maxLength: "+c.maxLength,null,t.getName());}I=c.isDigitSequence;if(I===true||I==="true"){t.oConstraints=t.oConstraints||{};t.oConstraints.isDigitSequence=true;}else if(I!==undefined&&I!==false&&I!=="false"){L.warning("Illegal isDigitSequence: "+I,null,t.getName());}n=c.nullable;if(n===false||n==="false"){t.oConstraints=t.oConstraints||{};t.oConstraints.nullable=false;}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,t.getName());}}}
var E=O.extend("sap.ui.model.odata.type.String",{constructor:function(f,c){var p=f?f.parseKeepsEmptyString:undefined;O.apply(this,arguments);s(this,c);this._sParsedEmptyString=null;if(this.oConstraints&&this.oConstraints.nullable===false&&this.oConstraints.isDigitSequence){this._sParsedEmptyString="0";}else if(p!==undefined){if(p===true){this._sParsedEmptyString="";}else if(p!==false){L.warning("Illegal parseKeepsEmptyString: "+p,null,this.getName());}}}});
E.prototype.formatValue=function(v,t){if(v===null&&this.getPrimitiveType(t)==="string"){return"";}if(i(v,this.oConstraints)){v=v.replace(a,"");}return S.prototype.formatValue.call(this,v,t);};
E.prototype.parseValue=function(v,b){var R;R=v===""?this._sParsedEmptyString:S.prototype.parseValue.apply(this,arguments);if(i(R,this.oConstraints)){R=R.replace(a,"");if(this.oConstraints.maxLength){R=R.padStart(this.oConstraints.maxLength,"0");}}return R;};
E.prototype.validateValue=function(v){var c=this.oConstraints||{},m=c.maxLength;if(v===null){if(c.nullable!==false){return;}}else if(typeof v!=="string"){throw new V("Illegal "+this.getName()+" value: "+v);}else if(c.isDigitSequence){if(!v.match(r)){throw new V(sap.ui.getCore().getLibraryResourceBundle().getText("EnterDigitsOnly"));}if(m&&v.length>m){throw new V(sap.ui.getCore().getLibraryResourceBundle().getText("EnterMaximumOfDigits",[m]));}return;}else if(!m||v.length<=m){return;}throw new V(sap.ui.getCore().getLibraryResourceBundle().getText(m?"EnterTextMaxLength":"EnterText",[m]));};
E.prototype.getName=function(){return"sap.ui.model.odata.type.String";};
return E;});
sap.ui.predefine('sap/ui/model/odata/type/Time',["sap/base/Log","sap/ui/core/format/DateFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType","sap/ui/thirdparty/jquery"],function(L,D,F,P,V,O,q){"use strict";var d={__edmType:"Edm.Time",ms:86398000},m={format:b,parse:t};
function g(o){return sap.ui.getCore().getLibraryResourceBundle().getText("EnterTime",[o.formatValue(d,"string")]);}
function a(o){var f;if(!o.oFormat){f=q.extend({strictParsing:true},o.oFormatOptions);f.UTC=true;o.oFormat=D.getTimeInstance(f);}return o.oFormat;}
function i(o){return typeof o==="object"&&o.__edmType==="Edm.Time"&&typeof o.ms==="number";}
function s(o,C){var n;o.oConstraints=undefined;if(C){n=C.nullable;if(n===false||n==="false"){o.oConstraints={nullable:false};}else if(n!==undefined&&n!==true&&n!=="true"){L.warning("Illegal nullable: "+n,null,o.getName());}}}
function t(o){if(!i(o)){throw new F("Illegal sap.ui.model.odata.type.Time value: "+c(o));}return new Date(o.ms);}
function b(o){return{__edmType:"Edm.Time",ms:((o.getUTCHours()*60+o.getUTCMinutes())*60+o.getUTCSeconds())*1000+o.getUTCMilliseconds()};}
function c(v){try{return JSON.stringify(v);}catch(e){return String(v);}}
var T=O.extend("sap.ui.model.odata.type.Time",{constructor:function(f,C){O.apply(this,arguments);s(this,C);this.oFormatOptions=f;}});
T.prototype.formatValue=function(v,e){if(v===undefined||v===null){return null;}switch(this.getPrimitiveType(e)){case"any":return v;case"string":return a(this).format(t(v));default:throw new F("Don't know how to format "+this.getName()+" to "+e);}};
T.prototype.getModelFormat=function(){return m;};
T.prototype.getName=function(){return"sap.ui.model.odata.type.Time";};
T.prototype.parseValue=function(v,S){var o;if(v===""||v===null){return null;}if(this.getPrimitiveType(S)!=="string"){throw new P("Don't know how to parse "+this.getName()+" from "+S);}o=a(this).parse(v);if(!o){throw new P(g(this));}return b(o);};
T.prototype.validateValue=function(v){if(v===null){if(this.oConstraints&&this.oConstraints.nullable===false){throw new V(g(this));}return;}if(!i(v)){throw new V("Illegal "+this.getName()+" value: "+c(v));}};
T.prototype._handleLocalizationChange=function(){this.oFormat=null;};
return T;});
sap.ui.predefine('sap/ui/model/odata/type/TimeOfDay',["sap/base/Log","sap/ui/core/CalendarType","sap/ui/core/format/DateFormat","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/model/odata/type/ODataType","sap/ui/thirdparty/jquery"],function(L,C,D,F,P,V,O,q){"use strict";
function g(t){return sap.ui.getCore().getLibraryResourceBundle().getText("EnterTime",[t.formatValue("23:59:58","string")]);}
function a(t){var f;if(!t.oUiFormat){f=q.extend({strictParsing:true},t.oFormatOptions);f.UTC=true;t.oUiFormat=D.getTimeInstance(f);}return t.oUiFormat;}
function s(t,c){var n,p;t.oConstraints=undefined;if(c){n=c.nullable;p=c.precision;if(n===false){t.oConstraints={nullable:false};}else if(n!==undefined&&n!==true){L.warning("Illegal nullable: "+n,null,t.getName());}if(p===Math.floor(p)&&p>0&&p<=12){t.oConstraints=t.oConstraints||{};t.oConstraints.precision=p;}else if(p!==undefined&&p!==0){L.warning("Illegal precision: "+p,null,t.getName());}}}
var T=O.extend("sap.ui.model.odata.type.TimeOfDay",{constructor:function(f,c){O.apply(this,arguments);this.oModelFormat=undefined;this.rTimeOfDay=undefined;this.oUiFormat=undefined;s(this,c);this.oFormatOptions=f;}});
T.prototype._handleLocalizationChange=function(){this.oUiFormat=null;};
T.prototype._resetModelFormatter=function(){this.oModelFormat=undefined;};
T.prototype.formatValue=function(v,t){var d,i,p;if(v===undefined||v===null){return null;}p=this.getPrimitiveType(t);switch(p){case"any":return v;case"object":case"string":i=v.indexOf(".");if(i>=0){v=v.slice(0,i+4);}d=this.getModelFormat().parse(v);if(d){if(p==="object"){return new Date(1970,0,1,d.getUTCHours(),d.getUTCMinutes(),d.getUTCSeconds());}return a(this).format(d);}throw new F("Illegal "+this.getName()+" value: "+v);default:throw new F("Don't know how to format "+this.getName()+" to "+t);}};
T.prototype.getModelFormat=function(){var p="HH:mm:ss",i;if(!this.oModelFormat){i=this.oConstraints&&this.oConstraints.precision;if(i){p+="."+"".padEnd(i,"S");}this.oModelFormat=D.getTimeInstance({calendarType:C.Gregorian,pattern:p,strictParsing:true,UTC:true});}return this.oModelFormat;};
T.prototype.getName=function(){return"sap.ui.model.odata.type.TimeOfDay";};
T.prototype.parseValue=function(v,S){var d;if(v===""||v===null){return null;}switch(this.getPrimitiveType(S)){case"object":return this.getModelFormat().format(v,false);case"string":d=a(this).parse(v);if(!d){throw new P(g(this));}return this.getModelFormat().format(d);default:throw new P("Don't know how to parse "+this.getName()+" from "+S);}};
T.prototype.validateValue=function(v){var p;if(v===null){if(this.oConstraints&&this.oConstraints.nullable===false){throw new V(g(this));}return;}if(!this.rTimeOfDay){p=this.oConstraints&&this.oConstraints.precision;this.rTimeOfDay=new RegExp("^(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d"+(p?"(\\.\\d{1,"+p+"})?":"")+")?$");}if(!this.rTimeOfDay.test(v)){throw new V("Illegal sap.ui.model.odata.type.TimeOfDay value: "+v);}};
return T;});
sap.ui.predefine('sap/ui/model/odata/type/Unit',["./UnitMixin","sap/ui/core/format/NumberFormat","sap/ui/model/type/Unit"],function(a,N,B){"use strict";
var U=B.extend("sap.ui.model.odata.type.Unit",{constructor:function(f,c,d){this._applyUnitMixin.apply(this,arguments);}});
a(U.prototype,B,"customUnits");
U.prototype.getCustomUnitForKey=function(c,k){return{decimals:c[k].UnitSpecificScale,displayName:c[k].Text,"unitPattern-count-other":N.getDefaultUnitPattern(k)};};
U.prototype.getName=function(){return"sap.ui.model.odata.type.Unit";};
return U;});
sap.ui.predefine('sap/ui/model/odata/type/UnitMixin',["sap/ui/model/ParseException","sap/ui/model/ValidateException"],function(P,V){"use strict";var c=new Map(),r=/\.(\d+)$/,a=/\.$/,b=/0+$/;
function g(k,p){return sap.ui.getCore().getLibraryResourceBundle().getText(k,p);}
function d(){return this;}
function v(e){if(this.mCustomUnits===undefined){throw new V("Cannot validate value without customizing");}}
return function(p,B,f){function e(j,t){var F,k=this;if(this.mCustomUnits===undefined&&j&&j[2]!==undefined){if(j[2]===null){this.mCustomUnits=null;}else{this.mCustomUnits=c.get(j[2]);if(!this.mCustomUnits){this.mCustomUnits={};Object.keys(j[2]).forEach(function(K){k.mCustomUnits[K]=k.getCustomUnitForKey(j[2],K);});c.set(j[2],this.mCustomUnits);}F={};F[f]=this.mCustomUnits;B.prototype.setFormatOptions.call(this,Object.assign(F,this.oFormatOptions));}}if(!j||j[0]===undefined||j[1]===undefined||this.mCustomUnits===undefined&&j[2]===undefined){return null;}return B.prototype.formatValue.call(this,j.slice(0,2),t);}function h(){if(this.oFormatOptions.showMeasure===false){return[1,2];}return[2];}function i(j,s,C){var D,F,m,u,k;if(this.mCustomUnits===undefined){throw new P("Cannot parse value without customizing");}k=B.prototype.parseValue.apply(this,arguments);u=k[1]||C[1];if(k[0].includes(".")){k[0]=k[0].replace(b,"").replace(a,"");}if(u&&this.mCustomUnits){m=r.exec(k[0]);F=m?m[1].length:0;D=this.mCustomUnits[u].decimals;if(F>D){throw new P(D?g("EnterNumberFraction",[D]):g("EnterInt"));}}if(!this.bParseAsString){k[0]=Number(k[0]);}return k;}function U(F,C){if(F&&F[f]){throw new Error("Format option "+f+" is not supported");}if(C){throw new Error("Constraints not supported");}if(arguments.length>2){throw new Error("Only the parameter oFormatOptions is supported");}this.bParseAsString=!F||!("parseAsString"in F)||F.parseAsString;F=Object.assign({unitOptional:true,emptyString:0},F,{parseAsString:true});B.call(this,F,C);this.mCustomUnits=undefined;this.bParseWithValues=true;this.setConstraints=function(){throw new Error("Constraints not supported");};this.setFormatOptions=function(){throw new Error("Format options are immutable");};}p._applyUnitMixin=U;p.formatValue=e;p.getInterface=d;p.getPartsIgnoringMessages=h;p.parseValue=i;p.validateValue=v;};},false);
sap.ui.predefine('sap/ui/model/odata/v2/BatchMode',function(){"use strict";var B={None:"None",Group:"Group"};return B;},true);
sap.ui.predefine('sap/ui/model/odata/v2/ODataAnnotations',['sap/ui/model/odata/AnnotationParser','sap/ui/Device','sap/ui/base/EventProvider','sap/ui/core/cache/CacheManager',"sap/base/assert","sap/ui/thirdparty/jquery"],function(A,D,E,C,a,q){"use strict";
var O=E.extend("sap.ui.model.odata.v2.ODataAnnotations",{
constructor:function(m,o){var t=this;E.apply(this,[o]);this._oMetadata=m;this._pLoaded=m.loaded();this._mCustomHeaders={};this._mAnnotations={};this._hasErrors=false;function w(r){if(!t._hasErrors){C.set(t.sCacheKey,JSON.stringify(r));}}if(!o||!o.skipMetadata){if(!o){o={};}if(!o.source){o.source=[];}else if(Array.isArray(o.source)){o.source=o.source.slice(0);}else{o.source=[o.source];}o.source.unshift({type:"xml",data:m.loaded().then(function(p){return{xml:p["metadataString"],lastModified:p["lastModified"],eTag:p["eTag"]};})});}if(o){this.sCacheKey=o.cacheKey;this.setHeaders(o.headers);if(this.sCacheKey){this._pLoaded=C.get(t.sCacheKey).then(function(s){var r;if(s){r=JSON.parse(s);}if(Array.isArray(r)){r.annotations={};r.forEach(function(b){A.restoreAnnotationsAtArrays(b.annotations);A.merge(r.annotations,b.annotations);});t._mAnnotations=r.annotations;t._fireSomeLoaded(r);t._fireLoaded(r);return r;}else{return t.addSource(o.source).then(function(r){w(r);return r;});}});}else{this._pLoaded=this.addSource(o.source);}}},
metadata:{publicMethods:["getData","addSource","getHeaders","setHeaders","attachSuccess","detachSuccess","attachError","detachError","attachLoaded","detachLoaded","attachFailed","detachFailed"]}
});
O.prototype.getData=function(){return this._mAnnotations;};
O.prototype.getAnnotationsData=function(){return this._mAnnotations;};
O.prototype.getHeaders=function(){return q.extend({},this._mCustomHeaders);};
O.prototype.setHeaders=function(h){this._mCustomHeaders=q.extend({},h);};
O.prototype.loaded=function(){return this._pLoaded;};
O.prototype.addSource=function(s){if(!s||Array.isArray(s)&&s.length===0){return this._oMetadata.loaded();}if(!Array.isArray(s)){s=[s];}var t=this;var m=s.map(function(v){v=(typeof v==="string")?{type:"url",data:v}:v;return t._loadSource(v).then(t._parseSourceXML).then(t._parseSource.bind(t)).catch(function(e){return e;});});return Promise.all(m).then(function(b){return b.map(function(o){try{o=t._mergeSource(o);t._fireSuccess(o);}catch(e){t._fireError(o);}return o;});}).then(function(r){r.annotations=t.getData();var e=r.filter(function(R){return R instanceof Error;});if(e.length>0){t._hasErrors=true;if(e.length!==r.length){t._fireSomeLoaded(r);t._fireFailed(r);}else{t._fireFailed(r);t._fireAllFailed(r);return Promise.reject(r);}}else{t._fireSomeLoaded(r);t._fireLoaded(r);}return r;});};
O.prototype.attachSuccess=function(d,f,l){return this.attachEvent("success",d,f,l);};
O.prototype.detachSuccess=function(f,l){return this.detachEvent("success",f,l);};
O.prototype.attachError=function(d,f,l){return this.attachEvent("error",d,f,l);};
O.prototype.detachError=function(f,l){return this.detachEvent("error",f,l);};
O.prototype.attachLoaded=function(d,f,l){return this.attachEvent("loaded",d,f,l);};
O.prototype.detachLoaded=function(f,l){return this.detachEvent("loaded",f,l);};
O.prototype.attachFailed=function(d,f,l){return this.attachEvent("failed",d,f,l);};
O.prototype.detachFailed=function(f,l){return this.detachEvent("failed",f,l);};
O.prototype.attachSomeLoaded=function(d,f,l){return this.attachEvent("someLoaded",d,f,l);};
O.prototype.detachSomeLoaded=function(f,l){return this.detachEvent("someLoaded",f,l);};
O.prototype.attachAllFailed=function(d,f,l){return this.attachEvent("allFailed",d,f,l);};
O.prototype.detachAllFailed=function(f,l){return this.detachEvent("allFailed",f,l);};
O.prototype._fireSuccess=function(r){return this.fireEvent("success",{result:r},false,false);};
O.prototype._fireError=function(e){return this.fireEvent("error",{result:e},false,false);};
O.prototype._fireLoaded=function(r){return this.fireEvent("loaded",{result:r},false,false);};
O.prototype._fireFailed=function(e){return this.fireEvent("failed",{result:e},false,false);};
O.prototype._fireSomeLoaded=function(r){return this.fireEvent("someLoaded",{result:r},false,false);};
O.prototype._fireAllFailed=function(e){return this.fireEvent("allFailed",{result:e},false,false);};
O.prototype._loadSource=function(s){if(s.data instanceof Promise){return s.data.then(function(d){delete s.data;s.type="xml";s.xml=d.xml;s.lastModified=d.lastModified;s.eTag=d.eTag;return this._loadSource(s);}.bind(this));}else if(s.type==="xml"){if(typeof s.data==="string"){s.xml=s.data;delete s.data;}return Promise.resolve(s);}else if(s.type==="url"){return this._loadUrl(s);}else{var e=new Error("Unknown source type: \""+s.type+"\"");e.source=s;return Promise.reject(e);}};
O.prototype._loadUrl=function(s){a(s.type==="url","Source type must be \"url\" in order to be loaded");return new Promise(function(r,R){var m={url:s.data,async:true,headers:this._getHeaders(),beforeSend:function(x){x.overrideMimeType("text/plain");}};var S=function(d,b,x){s.xml=x.responseText;if(x.getResponseHeader("Last-Modified")){s.lastModified=new Date(x.getResponseHeader("Last-Modified"));}if(x.getResponseHeader("eTag")){s.eTag=x.getResponseHeader("eTag");}r(s);};var f=function(x,b){var e=new Error("Could not load annotation URL: \""+s.data+"\"");e.source=s;R(e);};q.ajax(m).done(S).fail(f);}.bind(this));};
O.prototype._parseSourceXML=function(s){a(typeof s.xml==="string","Source must contain XML string in order to be parsed");return new Promise(function(r,R){var x;if(D.browser.msie){x=new window.ActiveXObject("Microsoft.XMLDOM");x.preserveWhiteSpace=true;var X=s.xml;if(X.indexOf(" xmlns:xml=")>-1){X=X.replace(' xmlns:xml="http://www.w3.org/XML/1998/namespace"',"").replace(" xmlns:xml='http://www.w3.org/XML/1998/namespace'","");}x.loadXML(X);}else if(window.DOMParser){x=new DOMParser().parseFromString(s.xml,'application/xml');}var e;if(!x){e=new Error("The browser does not support XML parsing. Annotations are not available.");e.source=s;R(e);}else if(x.getElementsByTagName("parsererror").length>0||(x.parseError&&x.parseError.errorCode!==0)){e=new Error("There were errors parsing the XML.");e.source={type:s.type,data:s.data,xml:s.xml,document:x};R(e);}else{s.document=x;r(s);}});};
O.prototype._parseSource=function(s){a(s.document instanceof window.Document||D.browser.msie,"Source must contain a parsed XML document converted to an annotation object");return this._oMetadata.loaded().then(function(){s.annotations=A.parse(this._oMetadata,s.document,s.data);delete s.document;return s;}.bind(this));};
O.prototype._mergeSource=function(s){a(typeof s.annotations==="object","Source must contain an annotation object to be merged");A.merge(this._mAnnotations,s.annotations);return s;};
O.prototype._getHeaders=function(){return q.extend({"sap-cancel-on-close":true},this.getHeaders(),{"Accept-Language":sap.ui.getCore().getConfiguration().getLanguageTag()});};
return O;});
sap.ui.predefine('sap/ui/model/odata/v2/ODataContextBinding',['sap/ui/model/Context','sap/ui/model/ContextBinding','sap/ui/model/ChangeReason',"sap/ui/thirdparty/jquery"],function(C,a,b,q){"use strict";
var O=a.extend("sap.ui.model.odata.v2.ODataContextBinding",{constructor:function(m,p,c,P,e){a.call(this,m,p,c,P,e);this.sRefreshGroupId=undefined;this.bPendingRequest=false;this.mParameters=q.extend(true,{},this.mParameters);this.bCreatePreliminaryContext=this.mParameters.createPreliminaryContext||m.bPreliminaryContext;this.bUsePreliminaryContext=this.mParameters.usePreliminaryContext||m.bPreliminaryContext;this.mParameters.createPreliminaryContext=this.bCreatePreliminaryContext;this.mParameters.usePreliminaryContext=this.bUsePreliminaryContext;this.bPendingRequest=false;}});
O.prototype.initialize=function(){var t=this,r,c=this.isRelative()&&this.oContext&&this.oContext.bCreated,p=this.oContext&&this.oContext.isPreliminary(),R;if(!this.oModel.oMetadata.isLoaded()||!this.bInitial){return;}this.bInitial=false;if(p&&!this.bUsePreliminaryContext){return;}r=this.oModel.resolve(this.sPath,this.oContext);if(!r||c){this.oElementContext=null;this._fireChange({reason:b.Context});return;}R=this.oModel._isReloadNeeded(r,this.mParameters);if(R){this.fireDataRequested();this.bPendingRequest=true;}var o=this.oModel.createBindingContext(this.sPath,this.oContext,this.mParameters,function(o){var d,u=o&&o.isUpdated(),f=o&&o.isRefreshForced();if(t.bCreatePreliminaryContext&&o&&t.oElementContext){t.oElementContext.setPreliminary(false);t.oModel._updateContext(t.oElementContext,o.getPath());t._fireChange({reason:b.Context},false,true);}else if(!o||C.hasChanged(o,t.oElementContext)){t.oElementContext=o;t._fireChange({reason:b.Context},f,u);}if(R){if(t.oElementContext){d=t.oElementContext.getObject(t.mParameters);}t.oModel.callAfterUpdate(function(){t.fireDataReceived({data:d});});t.bPendingRequest=false;}},R);if(o){if(this.bCreatePreliminaryContext&&this.oElementContext!==o){o.setPreliminary(true);this.oElementContext=o;this.oModel.oMetadata.loaded().then(function(){this._fireChange({reason:b.Context});}.bind(this));}}else if(this.oContext){this.oElementContext=null;this._fireChange({reason:b.Context});}};
O.prototype.checkUpdate=function(){var c,p=this.mParameters,P=this.oContext&&this.oContext.isPreliminary();if(this.bInitial||this.bPendingRequest){return;}if(this.oContext&&this.oContext.isUpdated()){this.setContext(this.oContext);return;}if(P&&!this.bUsePreliminaryContext){return;}if(p.createPreliminaryContext){p=Object.assign({},p);delete p.createPreliminaryContext;}c=this.oModel.createBindingContext(this.sPath,this.oContext,p);if(c!==undefined&&c!==this.oElementContext){this.oElementContext=c;this._fireChange({reason:b.Context});}};
O.prototype.refresh=function(f,g){if(typeof f==="string"){g=f;f=false;}this.sRefreshGroupId=g;this._refresh(f);this.sRefreshGroupId=undefined;};
O.prototype._refresh=function(f,c){var t=this,d,k,s,e=false,p=this.mParameters,g=this.isRelative()&&this.oContext&&this.oContext.bCreated,r=this.oModel.resolve(this.sPath,this.oContext),h;if(this.bInitial||g){return;}if(c){s=this.oModel._getObject(this.sPath,this.oContext);if(s){k=this.oModel._getKey(s);if(k in c){e=true;}}}else{e=true;}if(f||e){if(r){this.fireDataRequested();this.bPendingRequest=true;}if(this.sRefreshGroupId){p=q.extend({},this.mParameters);p.groupId=this.sRefreshGroupId;}var o=this.oModel.createBindingContext(this.sPath,this.oContext,p,function(o){if(t.bCreatePreliminaryContext&&o&&t.oElementContext){t.oElementContext.setPreliminary(false);t.oModel._updateContext(t.oElementContext,o.getPath());t._fireChange({reason:b.Context},false,true);}else if(C.hasChanged(o,t.oElementContext)||f){t.oElementContext=o;t._fireChange({reason:b.Context},f);}if(t.oElementContext){d=t.oElementContext.getObject(t.mParameters);}if(r){t.oModel.callAfterUpdate(function(){t.fireDataReceived({data:d});});t.bPendingRequest=false;}},true);if(o&&this.bCreatePreliminaryContext){if(this.oElementContext!==o||f){o.setPreliminary(true);this.oElementContext=o;h=this.oElementContext.sPath;this.oModel._updateContext(this.oElementContext,r);this._fireChange({reason:b.Context},f);this.oModel._updateContext(this.oElementContext,h);}}}};
O.prototype.setContext=function(c){var t=this,d,r,e=c&&c.bCreated,p=c&&c.isPreliminary(),f=c&&c.isRefreshForced(),u=c&&c.isUpdated(),s,R;if(this.bInitial||!this.isRelative()){return;}if(p&&!this.bUsePreliminaryContext){return;}if(u&&this.bUsePreliminaryContext){this._fireChange({reason:b.Context});return;}if(C.hasChanged(this.oContext,c)){this.oContext=c;r=this.oModel.resolve(this.sPath,this.oContext);if(!r||e){if(this.oElementContext!==null){this.oElementContext=null;this._fireChange({reason:b.Context});}return;}d=this.oModel._getObject(this.sPath,this.oContext);R=f||this.oModel._isReloadNeeded(r,this.mParameters);if(r&&R){this.fireDataRequested();this.bPendingRequest=true;}var c=this.oModel.createBindingContext(this.sPath,this.oContext,this.mParameters,function(c){if(t.bCreatePreliminaryContext&&c&&t.oElementContext){t.oElementContext.setPreliminary(false);t.oModel._updateContext(t.oElementContext,c.getPath());t._fireChange({reason:b.Context},false,true);}else if(C.hasChanged(c,t.oElementContext)){t.oElementContext=c;t._fireChange({reason:b.Context},f,u);}if(r&&R){if(t.oElementContext){d=t.oElementContext.getObject(t.mParameters);}t.oModel.callAfterUpdate(function(){t.fireDataReceived({data:d});});t.bPendingRequest=false;}},R);if(c){if(this.bCreatePreliminaryContext){c.setPreliminary(true);this.oElementContext=c;s=this.oElementContext.sPath;this.oModel._updateContext(this.oElementContext,r);this._fireChange({reason:b.Context},f);this.oModel._updateContext(this.oElementContext,s);}}else if(this.oContext&&this.oElementContext!==null){this.oElementContext=null;this._fireChange({reason:b.Context});}}};
O.prototype._fireChange=function(p,f,u){if(this.oElementContext){this.oElementContext.setForceRefresh(f);this.oElementContext.setUpdated(u);}a.prototype._fireChange.call(this,p);if(this.oElementContext){this.oElementContext.setForceRefresh(false);this.oElementContext.setUpdated(false);}};
return O;});
sap.ui.predefine('sap/ui/model/odata/v2/ODataListBinding',["sap/base/assert","sap/base/Log","sap/base/util/deepEqual","sap/base/util/isEmptyObject","sap/base/util/uid","sap/ui/model/ChangeReason","sap/ui/model/Context","sap/ui/model/Filter","sap/ui/model/FilterOperator","sap/ui/model/FilterProcessor","sap/ui/model/FilterType","sap/ui/model/ListBinding","sap/ui/model/Sorter","sap/ui/model/SorterProcessor","sap/ui/model/odata/CountMode","sap/ui/model/odata/Filter","sap/ui/model/odata/ODataUtils","sap/ui/model/odata/OperationMode","sap/ui/thirdparty/jquery"],function(a,L,d,b,u,C,c,F,e,f,g,h,S,j,k,O,l,m,q){"use strict";
var n=h.extend("sap.ui.model.odata.v2.ODataListBinding",{
constructor:function(M,P,i,s,r,t){h.apply(this,arguments);this.sFilterParams=null;this.sSortParams=null;this.sRangeParams=null;this.sCustomParams=this.oModel.createCustomParams(this.mParameters);this.mCustomParams=t&&t.custom;this.iStartIndex=0;this.iLength=0;this.bPendingChange=false;this.aAllKeys=null;this.aKeys=[];this.sCountMode=(t&&t.countMode)||this.oModel.sDefaultCountMode;this.sOperationMode=(t&&t.operationMode)||this.oModel.sDefaultOperationMode;this.bCreatePreliminaryContext=(t&&t.createPreliminaryContext)||M.bPreliminaryContext;this.bUsePreliminaryContext=(t&&t.usePreliminaryContext)||M.bPreliminaryContext;this.bRefresh=false;this.bNeedsUpdate=false;this.bDataAvailable=false;this.bIgnoreSuspend=false;this.bPendingRefresh=false;this.sGroupId=undefined;this.sRefreshGroupId=undefined;this.bLengthRequested=false;this.bUseExtendedChangeDetection=true;this.bFaultTolerant=t&&t.faultTolerant;this.bLengthFinal=false;this.iLastEndIndex=0;this.aLastContexts=null;this.aLastContextData=null;this.bInitial=true;this.mRequestHandles={};this.oCountHandle=null;this.bSkipDataEvents=false;this.bUseExpandedList=false;this.oCombinedFilter=null;this.sDeepPath=M.resolveDeep(P,i);this.bCanonicalRequest=t&&t.bCanonicalRequest;this.mNormalizeCache={};this.bTransitionMessagesOnly=!!(t&&t.transitionMessagesOnly);this.oModel.checkFilterOperation(this.aApplicationFilters);if(t&&(t.batchGroupId||t.groupId)){this.sGroupId=t.groupId||t.batchGroupId;}this.iThreshold=(t&&t.threshold)||0;this.bThresholdRejected=false;if(this.sCountMode==k.None){this.bThresholdRejected=true;}var U=this.checkExpandedList();if(!U){this.resetData();}},
metadata:{publicMethods:["getLength"]}
});
n.prototype.getContexts=function(s,r,t){if(this.bInitial){return[];}if(!this.bLengthFinal&&this.sOperationMode==m.Auto&&(this.sCountMode==k.Request||this.sCountMode==k.Both)){if(!this.bLengthRequested){this._getLength();this.bLengthRequested=true;}return[];}if(!this.bLengthFinal&&!this.bPendingRequest&&!this.bLengthRequested){this._getLength();this.bLengthRequested=true;}this.iLastLength=r;this.iLastStartIndex=s;this.iLastThreshold=t;if(!s){s=0;}if(!r){r=this.oModel.iSizeLimit;if(this.bLengthFinal&&this.iLength<r){r=this.iLength;}}if(!t){t=0;}if(this.sOperationMode==m.Auto){if(this.iThreshold>=0){t=Math.max(this.iThreshold,t);}}var v=true,w=this._getContexts(s,r),x=[],M;if(this.useClientMode()){if(!this.aAllKeys&&!this.bPendingRequest&&this.oModel.getServiceMetadata()){this.loadData();w.dataRequested=true;}}else{M=this.calculateSection(s,r,t,w);v=w.length!==r||M.length>0;if(this.oModel.getServiceMetadata()){if(!this.bPendingRequest&&M.length>0&&v){this.loadData(M.startIndex,M.length);w.dataRequested=true;}}}if(this.bRefresh){this.bRefresh=false;}else{for(var i=0;i<w.length;i++){x.push(this.getContextData(w[i]));}if(this.bUseExtendedChangeDetection){if(this.aLastContexts&&s<this.iLastEndIndex){w.diff=this.diffData(this.aLastContextData,x);}}this.iLastEndIndex=s+r;this.aLastContexts=w.slice(0);this.aLastContextData=x.slice(0);}return w;};
n.prototype.getCurrentContexts=function(){return this.aLastContexts||[];};
n.prototype.getEntryKey=function(i){return i.getPath();};
n.prototype.getEntryData=function(i){return JSON.stringify(i.getObject(this.mParameters));};
n.prototype._getContexts=function(s,r){var t=[],v,K;if(!s){s=0;}if(!r){r=this.oModel.iSizeLimit;if(this.bLengthFinal&&this.iLength<r){r=this.iLength;}}for(var i=s;i<s+r;i++){K=this.aKeys[i];if(!K){break;}v=this.oModel.getContext('/'+K,this.oModel.resolveDeep(this.sPath,this.oContext)+K.substr(K.indexOf("(")));t.push(v);}return t;};
n.prototype.calculateSection=function(s,i,t){var E=false;if(s>=t){s-=t;i+=t;}else{i+=s;s=0;}i+=t;if(this.bLengthFinal&&s+i>this.iLength){i=this.iLength-s;}while(i&&this.aKeys[s]){s+=1;i-=1;}while(i&&this.aKeys[s+i-1]){i-=1;E=true;}if(i&&!E&&i<t){while(i<t&&!this.aKeys[s+i]){i+=1;}}return{startIndex:s,length:i};};
n.prototype.setContext=function(i){var r,s=i&&i.bCreated,t=i&&i.isRefreshForced(),U=i&&i.isUpdated(),P=i&&i.isPreliminary();if(this.bInitial||!this.isRelative()){return;}if(P&&!this.bUsePreliminaryContext){return;}if(U&&this.bUsePreliminaryContext&&this.oContext===i){this._fireChange({reason:C.Context});return;}if(c.hasChanged(this.oContext,i)){this.oContext=i;r=this.oModel.resolve(this.sPath,this.oContext);this.sDeepPath=this.oModel.resolveDeep(this.sPath,this.oContext);if(!this._checkPathType()){L.error("List Binding is not bound against a list for "+r);}this.checkDataState();if(!r||s){if(this.aAllKeys||this.aKeys.length>0||this.iLength>0){this.aAllKeys=null;this.aKeys=[];this.iLength=0;this.bLengthFinal=true;this._fireChange({reason:C.Context});}return;}this._initSortersFilters();if(this.checkExpandedList()&&!t){this.abortPendingRequest();this._fireChange({reason:C.Context});}else{this._refresh();}}};
n.prototype.checkExpandedList=function(s){var r=!!this.oModel.resolve(this.sPath,this.oContext),R=this.oModel._getObject(this.sPath,this.oContext);if(!r||R===undefined||this.mCustomParams||(this.sOperationMode===m.Server&&(this.aApplicationFilters.length>0||this.aFilters.length>0||this.aSorters.length>0))){this.bUseExpandedList=false;this.aExpandRefs=undefined;return false;}else{this.bUseExpandedList=true;if(Array.isArray(R)){if(!s&&(this.oModel._isReloadNeeded("/"+R[0],this.mParameters)||this.oModel._isReloadNeeded("/"+R[R.length-1],this.mParameters))){this.bUseExpandedList=false;this.aExpandRefs=undefined;return false;}this.aExpandRefs=R;this.aAllKeys=R;this.iLength=R.length;this.bLengthFinal=true;this.bDataAvailable=true;this._initSortersFilters();this.applyFilter();this.applySort();}else{this.aExpandRefs=undefined;this.aAllKeys=null;this.aKeys=[];this.iLength=0;this.bLengthFinal=true;this.bDataAvailable=true;}return true;}};
n.prototype.updateExpandedList=function(K){if(this.aExpandRefs){for(var i=0;i<K.length;i++){this.aExpandRefs[i]=K[i];}this.aExpandRefs.length=K.length;}};
n.prototype.useClientMode=function(){return(this.sOperationMode===m.Client||this.sOperationMode===m.Auto&&!this.bThresholdRejected||this.sOperationMode!==m.Server&&this.bUseExpandedList);};
n.prototype.loadData=function(s,r){var t=this,I=false,G=u(),v;if(s||r){this.sRangeParams="$skip="+s+"&$top="+r;this.iStartIndex=s;}else{s=this.iStartIndex;}var P=[];if(this.sRangeParams&&!this.useClientMode()){P.push(this.sRangeParams);}if(this.sSortParams){P.push(this.sSortParams);}if(this.sFilterParams&&!this.useClientMode()){P.push(this.sFilterParams);}if(this.sCustomParams){P.push(this.sCustomParams);}if(this.sCountMode==k.InlineRepeat||!this.bLengthFinal&&(this.sCountMode===k.Inline||this.sCountMode===k.Both)){P.push("$inlinecount=allpages");I=true;}function w(D){if(I&&D.__count!==undefined){t.iLength=parseInt(D.__count);t.bLengthFinal=true;if(t.sOperationMode==m.Auto){if(t.iLength<=t.mParameters.threshold){t.bThresholdRejected=false;}else{t.bThresholdRejected=true;delete t.mRequestHandles[G];t.bPendingRequest=false;t.bNeedsUpdate=true;return;}}}if(t.useClientMode()){t.aKeys=[];q.each(D.results,function(i,y){t.aKeys[i]=t.oModel._getKey(y);});t.updateExpandedList(t.aKeys);t.aAllKeys=t.aKeys.slice();t.iLength=t.aKeys.length;t.bLengthFinal=true;t.applyFilter();t.applySort();}else{if(D.results.length>0){q.each(D.results,function(i,y){t.aKeys[s+i]=t.oModel._getKey(y);});if(t.iLength<s+D.results.length){t.iLength=s+D.results.length;t.bLengthFinal=false;}if(!D.__next&&(D.results.length<r||r===undefined)){t.iLength=s+D.results.length;t.bLengthFinal=true;}}else{if(t.bFaultTolerant&&D.__next){t.iLength=s;t.bLengthFinal=true;}if(s===0){t.iLength=0;t.aKeys=[];t.bLengthFinal=true;}if(s===t.iLength){t.bLengthFinal=true;}}}delete t.mRequestHandles[G];t.bPendingRequest=false;t.bNeedsUpdate=true;t.bIgnoreSuspend=true;t.oModel.callAfterUpdate(function(){t.fireDataReceived({data:D});});}function E(i){var A=i.statusCode==0;delete t.mRequestHandles[G];t.bPendingRequest=false;if(t.bFaultTolerant){t.iLength=t.aKeys.length;t.bLengthFinal=true;t.bDataAvailable=true;}else if(!A){t.aKeys=[];t.aAllKeys=[];t.iLength=0;t.bLengthFinal=true;t.bDataAvailable=true;t._fireChange({reason:C.Change});}if(!t.bSkipDataEvents){t.fireDataReceived();}}var x=this.sPath;if(this.isRelative()){x=this.oModel.resolve(this.sPath,this.oContext);}if(x){this.bPendingRequest=true;if(!this.bSkipDataEvents){this.fireDataRequested();}this.bSkipDataEvents=false;v=this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId;this.mRequestHandles[G]=this.oModel.read(this.sPath,{headers:this.bTransitionMessagesOnly?{"sap-messages":"transientOnly"}:undefined,context:this.oContext,groupId:v,urlParameters:P,success:w,error:E,canonicalRequest:this.bCanonicalRequest,updateAggregatedMessages:this.bRefresh});}};
n.prototype.isLengthFinal=function(){return this.bLengthFinal;};
n.prototype.getLength=function(){if(this.bLengthFinal||this.iLength==0){return this.iLength;}else{var A=this.iLastThreshold||this.iLastLength||10;return this.iLength+A;}};
n.prototype._getLength=function(){var t=this;var G;if(this.sCountMode!==k.Request&&this.sCountMode!==k.Both){return;}var P=[];if(this.sFilterParams&&this.sOperationMode!=m.Auto){P.push(this.sFilterParams);}if(this.mParameters&&this.mParameters.custom){var i={custom:{}};q.each(this.mParameters.custom,function(v,V){i.custom[v]=V;});P.push(this.oModel.createCustomParams(i));}function _(D){t.iLength=parseInt(D);t.bLengthFinal=true;t.bLengthRequested=true;t.oCountHandle=null;if(t.sOperationMode==m.Auto){if(t.iLength<=t.mParameters.threshold){t.bThresholdRejected=false;}else{t.bThresholdRejected=true;}t._fireChange({reason:C.Change});}}function r(E){delete t.mRequestHandles[s];var v="Request for $count failed: "+E.message;if(E.response){v+=", "+E.response.statusCode+", "+E.response.statusText+", "+E.response.body;}L.warning(v);}var s=this.oModel.resolve(this.sPath,this.oContext);if(s){G=this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId;this.oCountHandle=this.oModel.read(this.sPath+"/$count",{context:this.oContext,withCredentials:this.oModel.bWithCredentials,groupId:G,urlParameters:P,success:_,error:r,canonicalRequest:this.bCanonicalRequest});}};
n.prototype.refresh=function(i,G){if(typeof i==="string"){G=i;i=false;}this.sRefreshGroupId=G;this._refresh(i);this.sRefreshGroupId=undefined;};
n.prototype._refresh=function(r,s,E){var t=false,v=this.isRelative()&&this.oContext&&this.oContext.bCreated;if(v){return;}this.bPendingRefresh=false;if(!r){if(E){var R=this.oModel.resolve(this.sPath,this.oContext);if(R){var w=this.oModel.oMetadata._getEntityTypeByPath(R);if(w&&(w.entityType in E)){t=true;}}}if(s&&!t){q.each(this.aKeys,function(i,K){if(K in s){t=true;return false;}});}if(!s&&!E){t=true;}}if(r||t){if(this.bSuspended&&!this.bIgnoreSuspend&&!r){this.bPendingRefresh=true;return;}this.abortPendingRequest(true);this.resetData();this._fireRefresh({reason:C.Refresh});}};
n.prototype._fireRefresh=function(P){if(this.oModel.resolve(this.sPath,this.oContext)){this.bRefresh=true;this.fireEvent("refresh",P);}};
n.prototype._checkPathType=function(){var P=this.oModel.resolve(this.sPath,this.oContext);if(P){if(!this._mPathType||!this._mPathType[P]){this._mPathType={};var I=P.lastIndexOf("/");var t,E;if(I>1){E=this.oModel.oMetadata._getEntityTypeByPath(P.substring(0,I));if(E){t=this.oModel.oMetadata._getEntityAssociationEnd(E,P.substring(I+1));if(t&&t.multiplicity==="*"){this._mPathType[P]=true;}}}else if(I===0){var M,N=P.substring(1);M=this.oModel.oMetadata._findEntitySetByName(N);if(M){this._mPathType[P]=true;}else{var r=this.oModel.oMetadata._getFunctionImportMetadataByName(N);for(var i=0;i<r.length;i++){var s=r[i];if(s.entitySet){M=this.oModel.oMetadata._findEntitySetByName(s.entitySet);if(M){this._mPathType[P]=true;}}}}}}return!!this._mPathType[P];}return true;};
n.prototype.initialize=function(){var i=this.isRelative()&&this.oContext&&this.oContext.bCreated;if(this.oModel.oMetadata&&this.oModel.oMetadata.isLoaded()&&this.bInitial&&!i){if(!this._checkPathType()){L.error("List Binding is not bound against a list for "+this.oModel.resolve(this.sPath,this.oContext));}this.bInitial=false;this._initSortersFilters();if(!this.bSuspended){if(this.bDataAvailable){this._fireChange({reason:C.Change});}else{this._fireRefresh({reason:C.Refresh});}}this.checkDataState();}return this;};
n.prototype.checkUpdate=function(i,r){var s=this.sChangeReason?this.sChangeReason:C.Change,t=false,v,w=this,x;if((this.bSuspended&&!this.bIgnoreSuspend&&!i)||this.bPendingRequest){return;}if(this.bInitial){if(this.oContext&&this.oContext.isUpdated()){this.initialize();}return;}this.bIgnoreSuspend=false;if(!i&&!this.bNeedsUpdate){x=this.aExpandRefs;var y=this.aKeys.slice();var E=this.checkExpandedList(true);if(!E&&this.useClientMode()){this.applyFilter();this.applySort();}if(!d(x,this.aExpandRefs)){t=true;}else if(r){if(this.aKeys.length!==y.length){t=true;}else{for(var K in r){if(this.aKeys.indexOf(K)>-1||y.indexOf(K)>-1){t=true;break;}}}}else{t=true;}if(t&&this.aLastContexts){t=false;var z=this._getContexts(this.iLastStartIndex,this.iLastLength,this.iLastThreshold);if(this.aLastContexts.length!==z.length){t=true;}else{q.each(this.aLastContextData,function(I,A){v=w.getContextData(z[I]);if(A!==v){t=true;return false;}});}}}if(i||t||this.bNeedsUpdate){this.bNeedsUpdate=false;this._fireChange({reason:s});}this.sChangeReason=undefined;};
n.prototype.resetData=function(){this.aKeys=[];this.aAllKeys=null;this.iLength=0;this.bLengthFinal=false;this.sChangeReason=undefined;this.bDataAvailable=false;this.bLengthRequested=false;this.bThresholdRejected=false;if(this.sCountMode==k.None){this.bThresholdRejected=true;}};
n.prototype.abortPendingRequest=function(A){if(!b(this.mRequestHandles)){this.bSkipDataEvents=true;q.each(this.mRequestHandles,function(P,r){r.abort();});if(A&&this.oCountHandle){this.oCountHandle.abort();}this.mRequestHandles={};this.bPendingRequest=false;}};
n.prototype.getDownloadUrl=function(s){var P=[],i;if(s){P.push("$format="+encodeURIComponent(s));}if(this.sSortParams){P.push(this.sSortParams);}if(this.sFilterParams){P.push(this.sFilterParams);}if(this.sCustomParams){P.push(this.sCustomParams);}i=this.oModel.resolve(this.sPath,this.oContext);if(i){return this.oModel._createRequestUrl(i,null,P);}};
n.prototype.sort=function(s,r){var i=false;this.bIgnoreSuspend=true;if(!s){s=[];}if(s instanceof S){s=[s];}this.aSorters=s;if(!this.useClientMode()){this.createSortParams(s);}if(!this.bInitial){this.addComparators(s,true);if(this.useClientMode()){if(this.aAllKeys){if(s.length==0){this.applyFilter();}else{this.applySort();}this._fireChange({reason:C.Sort});}else{this.sChangeReason=C.Sort;}}else{this.aKeys=[];this.abortPendingRequest(false);this.sChangeReason=C.Sort;this._fireRefresh({reason:this.sChangeReason});}this._fireSort({sorter:s});i=true;}if(r){return i;}else{return this;}};
n.prototype.addComparators=function(E,s){var P,t,i=this.oEntityType,r;if(!i){L.warning("Cannot determine sort/filter comparators, as entitytype of the collection is unkown!");return;}E.forEach(function(v){if(v.aFilters){this.addComparators(v.aFilters);}else if(!v.fnCompare){P=this.oModel.oMetadata._getPropertyMetadata(i,v.sPath);t=P&&P.type;a(P,"PropertyType for property "+v.sPath+" of EntityType "+i.name+" not found!");r=l.getComparator(t);if(s){v.fnCompare=o(r);}else{v.fnCompare=r;p(t,v);}}}.bind(this));};
function o(i){return function(v,V){if(v===V){return 0;}if(v===null){return-1;}if(V===null){return 1;}return i(v,V);};}
function p(t,i){switch(t){case"Edm.Decimal":case"Edm.Int64":if(typeof i.oValue1=="number"){i.oValue1=i.oValue1.toString();}if(typeof i.oValue2=="number"){i.oValue2=i.oValue2.toString();}break;case"Edm.Byte":case"Edm.Int16":case"Edm.Int32":case"Edm.SByte":if(typeof i.oValue1=="string"){i.oValue1=parseInt(i.oValue1);}if(typeof i.oValue2=="string"){i.oValue2=parseInt(i.oValue2);}break;case"Edm.Float":case"Edm.Single":case"Edm.Double":if(typeof i.oValue1=="string"){i.oValue1=parseFloat(i.oValue1);}if(typeof i.oValue2=="string"){i.oValue2=parseFloat(i.oValue2);}break;default:}}
n.prototype.applySort=function(){var t=this,i;this.aKeys=j.apply(this.aKeys,this.aSorters,function(r,P){i=t.oModel.getContext('/'+r);return t.oModel.getProperty(P,i);});};
n.prototype.createSortParams=function(s){this.sSortParams=l.createSortParams(s);};
n.prototype.filter=function(i,s,r){var t=false;this.bIgnoreSuspend=true;if(!i){i=[];}if(i instanceof F){i=[i];}this.oModel.checkFilterOperation(i);if(s===g.Application){this.aApplicationFilters=i;}else{this.aFilters=i;}if(!this.aFilters||!Array.isArray(this.aFilters)){this.aFilters=[];}if(!this.aApplicationFilters||!Array.isArray(this.aApplicationFilters)){this.aApplicationFilters=[];}this.convertFilters();this.oCombinedFilter=f.combineFilters(this.aFilters,this.aApplicationFilters);if(!this.useClientMode()){this.createFilterParams(this.oCombinedFilter);}if(!this.bInitial){this.addComparators(this.aFilters);this.addComparators(this.aApplicationFilters);if(this.useClientMode()){if(this.aAllKeys){this.applyFilter();this.applySort();this._fireChange({reason:C.Filter});}else{this.sChangeReason=C.Filter;}}else{this.resetData();this.abortPendingRequest(true);this.sChangeReason=C.Filter;this._fireRefresh({reason:this.sChangeReason});}if(s===g.Application){this._fireFilter({filters:this.aApplicationFilters});}else{this._fireFilter({filters:this.aFilters});}t=true;}if(r){return t;}else{return this;}};
n.prototype.convertFilters=function(){this.aFilters=this.aFilters.map(function(i){return i instanceof O?i.convert():i;});this.aApplicationFilters=this.aApplicationFilters.map(function(i){return i instanceof O?i.convert():i;});};
n.prototype.applyFilter=function(){var t=this,i;this.oCombinedFilter=f.combineFilters(this.aFilters,this.aApplicationFilters);this.aKeys=f.apply(this.aAllKeys,this.oCombinedFilter,function(r,P){i=t.oModel.getContext('/'+r);return t.oModel.getProperty(P,i);},this.mNormalizeCache);this.iLength=this.aKeys.length;};
n.prototype.createFilterParams=function(i){this.sFilterParams=l.createFilterParams(i,this.oModel.oMetadata,this.oEntityType);};
n.prototype._initSortersFilters=function(){var r=this.oModel.resolve(this.sPath,this.oContext);if(!r){return;}this.oEntityType=this._getEntityType();this.addComparators(this.aSorters,true);this.addComparators(this.aFilters);this.addComparators(this.aApplicationFilters);this.convertFilters();this.oCombinedFilter=f.combineFilters(this.aFilters,this.aApplicationFilters);if(!this.useClientMode()){this.createSortParams(this.aSorters);this.createFilterParams(this.oCombinedFilter);}};
n.prototype._getEntityType=function(){var r=this.oModel.resolve(this.sPath,this.oContext);if(r){var E=this.oModel.oMetadata._getEntityTypeByPath(r);a(E,"EntityType for path "+r+" could not be found!");return E;}return undefined;};
n.prototype.resume=function(){this.bIgnoreSuspend=false;this.bSuspended=false;if(this.bPendingRefresh){this._refresh();}else{this.checkUpdate();}};
n.prototype.suspend=function(){if(this.bInitial){this.bPendingRefresh=true;}h.prototype.suspend.apply(this,arguments);};
n.prototype._checkDataStateMessages=function(D,r){if(r){D.setModelMessages(this.oModel.getMessagesByPath(this.sDeepPath,true));}};
n.prototype._getFilterForPredicate=function(P){var i=[],K=P.slice(1,-1).split(","),t=this;K.forEach(function(s){var r=s.split("="),v=r[0],V=r[1];if(r.length===1){V=v;v=t.oModel.oMetadata.getKeyPropertyNamesByPath(t.sDeepPath)[0];}i.push(new F(v,e.EQ,l.parseValue(V)));});if(i.length===1){return i[0];}return new F({and:true,filters:i});};
n.prototype.requestFilterForMessages=function(i){var D=this.sDeepPath,r=null,s=[],P=new Set(),R=this.oModel.resolve(this.sPath,this.oContext),t=this;if(!R){return Promise.resolve(null);}this.oModel.getMessagesByPath(D,true).forEach(function(M){var v;if(!i||i(M)){M.aFullTargets.forEach(function(w){if(w.startsWith(D)){v=w.slice(D.length).split("/")[0];if(v){P.add(v);}}});}});P.forEach(function(v){s.push(t._getFilterForPredicate(v));});if(s.length===1){r=s[0];}else if(s.length>1){r=new F({filters:s});}return Promise.resolve(r);};
return n;});
sap.ui.predefine('sap/ui/model/odata/v2/ODataModel',["./ODataAnnotations","./ODataContextBinding","./ODataListBinding","./ODataTreeBinding","sap/base/assert","sap/base/Log","sap/base/security/encodeURL","sap/base/util/deepEqual","sap/base/util/each","sap/base/util/isEmptyObject","sap/base/util/isPlainObject","sap/base/util/merge","sap/base/util/uid","sap/base/util/UriParameters","sap/ui/core/library","sap/ui/core/message/Message","sap/ui/core/message/MessageParser","sap/ui/model/BindingMode","sap/ui/model/Context","sap/ui/model/FilterProcessor","sap/ui/model/Model","sap/ui/model/odata/CountMode","sap/ui/model/odata/MessageScope","sap/ui/model/odata/ODataMetadata","sap/ui/model/odata/ODataMetaModel","sap/ui/model/odata/ODataMessageParser","sap/ui/model/odata/ODataPropertyBinding","sap/ui/model/odata/ODataUtils","sap/ui/model/odata/OperationMode","sap/ui/model/odata/UpdateMethod","sap/ui/thirdparty/datajs","sap/ui/thirdparty/jquery","sap/ui/thirdparty/URI"],function(O,a,b,c,d,L,e,f,g,h,l,m,u,U,o,M,p,B,C,F,q,r,s,t,v,w,x,y,z,A,D,Q,E){"use strict";var G="sap.ui.model.odata.v2.ODataModel",H=o.MessageType,I={};I[H.Error]=0;I[H.Warning]=1;I[H.Success]=2;I[H.Information]=3;I[H.None]=4;
var J=q.extend("sap.ui.model.odata.v2.ODataModel",{
constructor:function(S,P){q.apply(this,arguments);var i,j,k,T,W,n,N,R,V,X,Y,Z,$,_,a1,b1,c1,d1,e1,f1,g1,h1,i1,j1,k1,l1,m1,n1,o1,p1=this;if(typeof(S)==="object"){P=S;S=P.serviceUrl;}if(P){i=P.user;j=P.password;k=P.headers;T=P.tokenHandling;W=P.withCredentials;n=P.maxDataServiceVersion;N=P.useBatch;R=P.refreshAfterChange;V=P.annotationURI;X=P.loadAnnotationsJoined;$=P.defaultBindingMode;Y=P.defaultCountMode;Z=P.preliminaryContext;_=P.defaultOperationMode;a1=P.metadataNamespaces;b1=P.serviceUrlParams;c1=P.metadataUrlParams;d1=P.json;e1=P.messageParser;f1=P.skipMetadataAnnotationParsing;g1=P.defaultUpdateMethod;h1=P.disableHeadRequestForToken;i1=P.sequentializeRequests;j1=P.disableSoftStateHeader;k1=P.bindableResponseHeaders;l1=P.warmupUrl;m1=P.canonicalRequests;n1=P.tokenHandlingForGet;o1=P.earlyTokenRequest;}this.mPathCache={};this.mInvalidatedPaths={};this.bCanonicalRequests=!!m1;this.bTokenHandlingForGet=!!n1;this.sMessageScope=s.RequestedObjects;this.sWarmupUrl=l1;this.bWarmup=!!l1;this.mSupportedBindingModes={"OneWay":true,"OneTime":true,"TwoWay":true};this.mUnsupportedFilterOperators={"Any":true,"All":true};this.sDefaultBindingMode=$||B.OneWay;this.bIsMessageScopeSupported=false;this.iPendingDeferredRequests=0;this.bJSON=d1!==false;this.aPendingRequestHandles=[];this.aCallAfterUpdate=[];this.mRequests={};this.mDeferredRequests={};this.mChangedEntities={};this.mChangeHandles={};this.mDeferredGroups={};this.mLaunderingState={};this.sDefaultUpdateMethod=g1||A.Merge;this.bTokenHandling=T!==false;this.bWithCredentials=W===true;this.bUseBatch=N!==false;this.bRefreshAfterChange=R!==false;this.sMaxDataServiceVersion=n;this.bLoadAnnotationsJoined=X!==false;this.sAnnotationURI=V;this.sDefaultCountMode=Y||r.Request;this.sDefaultOperationMode=_||z.Default;this.sMetadataLoadEvent=null;this.oMetadataFailedEvent=null;this.sRefreshGroupId=undefined;this.bIncludeInCurrentBatch=false;this.bSkipMetadataAnnotationParsing=!!f1;this.bDisableHeadRequestForToken=!!h1;this.bSequentializeRequests=!!i1;this.bDisableSoftStateHeader=!!j1;this.aBindableResponseHeaders=k1?k1:null;this.bPreliminaryContext=Z||false;this.mMetadataUrlParams=c1||{};this.mChangedEntities4checkUpdate={};if(e1){e1.setProcessor(this);}this.oMessageParser=e1;this.sDefaultChangeGroup="changes";this.setDeferredGroups([this.sDefaultChangeGroup]);this.setChangeGroups({"*":{groupId:this.sDefaultChangeGroup}});this.oData={};this.oMetadata=null;this.oAnnotations=null;this.aUrlParams=[];this.pSequentialRequestCompleted=Promise.resolve();this.pReadyForRequest=Promise.resolve();this.sServiceUrl=S;var q1=S.split("?");if(q1.length>1){this.sServiceUrl=q1[0];if(q1[1]){this.aUrlParams.push(q1[1]);}}this.sServiceUrl=this.sServiceUrl.replace(/\/$/,"");this.sUser=i;this.sPassword=j;if(sap.ui.getCore().getConfiguration().getStatistics()){this.aUrlParams.push("sap-statistics=true");}this.oHeaders={};this.setHeaders(k);if(!this.bDisableSoftStateHeader){this.oHeaders["sap-contextid-accept"]="header";this.mCustomHeaders["sap-contextid-accept"]="header";}var r1=this._getServerUrl();var s1=this.sWarmupUrl||this._createMetadataUrl("/$metadata");this.oSharedServerData=J._getSharedData("server",r1);this.oSharedServiceData=J._getSharedData("service",this.sServiceUrl);this.oSharedMetaData=J._getSharedData("meta",s1);this.bUseCache=this._cacheSupported(s1);if(!this.oSharedMetaData.oMetadata||this.oSharedMetaData.oMetadata.bFailed){this.oMetadata=new t(s1,{async:true,cacheKey:this.bUseCache?s1:undefined,user:this.sUser,password:this.sPassword,headers:this.mCustomHeaders,namespaces:a1,withCredentials:this.bWithCredentials});if(!this.bWarmup){this.oSharedMetaData.oMetadata=this.oMetadata;}}else{this.oMetadata=this.oSharedMetaData.oMetadata;}this.oAnnotations=new O(this.oMetadata,{source:this.sAnnotationURI,skipMetadata:this.bSkipMetadataAnnotationParsing,headers:this.mCustomHeaders,combineEvents:true,cacheKey:this._getAnnotationCacheKey(s1),useCache:this.bUseCache});if(!this.bDisableSoftStateHeader){delete this.mCustomHeaders["sap-contextid-accept"];}this.oAnnotations.attachAllFailed(this.onAnnotationsFailed,this);this.oAnnotations.attachSomeLoaded(this.onAnnotationsLoaded,this);this.pAnnotationsLoaded=this.oAnnotations.loaded();if(b1){this.aUrlParams=this.aUrlParams.concat(y._createUrlParamsArray(b1));}this.onMetadataFailed=function(t1){p1.fireMetadataFailed(t1.getParameters());};if(!this.oMetadata.isLoaded()){this.oMetadata.attachFailed(this.onMetadataFailed);}this.oMetadata.loaded().then(function(){p1._initializeMetadata();});if(this.bJSON){if(this.sMaxDataServiceVersion==="3.0"){this.oHeaders["Accept"]="application/json;odata=fullmetadata";}else{this.oHeaders["Accept"]="application/json";}}else{this.oHeaders["Accept"]="application/atom+xml,application/atomsvc+xml,application/xml";}if(this.bTokenHandling){if(this.oSharedServiceData.securityToken){this.oHeaders["x-csrf-token"]=this.oSharedServiceData.securityToken;}else if(this.oSharedServerData.securityToken){this.oSharedServiceData.securityToken=this.oSharedServerData.securityToken;this.oHeaders["x-csrf-token"]=this.oSharedServiceData.securityToken;}if(o1){this.securityTokenAvailable();}}this.oHeaders["Accept-Language"]=sap.ui.getCore().getConfiguration().getLanguageTag();this.oHeaders["DataServiceVersion"]="2.0";this.oHeaders["MaxDataServiceVersion"]="2.0";if(this.sMaxDataServiceVersion){this.oHeaders["MaxDataServiceVersion"]=this.sMaxDataServiceVersion;}},
metadata:{publicMethods:["read","create","update","remove","submitChanges","getServiceMetadata","metadataLoaded","hasPendingChanges","getPendingChanges","refresh","refreshMetadata","resetChanges","setDefaultCountMode","setDefaultBindingMode","getDefaultBindingMode","getDefaultCountMode","setProperty","getSecurityToken","refreshSecurityToken","setHeaders","getHeaders","setUseBatch","setDeferredBatchGroups","getDeferredBatchGroups","setChangeBatchGroups","getChangeBatchGroups"]}
});
J.M_EVENTS={MetadataLoaded:"metadataLoaded",MetadataFailed:"metadataFailed",AnnotationsLoaded:"annotationsLoaded",AnnotationsFailed:"annotationsFailed",BatchRequestFailed:"batchRequestFailed",BatchRequestSent:"batchRequestSent",BatchRequestCompleted:"batchRequestCompleted"};
J.prototype.attachBatchRequestFailed=function(i,j,k){this.attachEvent("batchRequestFailed",i,j,k);return this;};
J.prototype.detachBatchRequestFailed=function(i,j){this.detachEvent("batchRequestFailed",i,j);return this;};
J.prototype.fireBatchRequestFailed=function(P){this.fireEvent("batchRequestFailed",P);return this;};
J.prototype.attachBatchRequestSent=function(i,j,k){this.attachEvent("batchRequestSent",i,j,k);return this;};
J.prototype.detachBatchRequestSent=function(i,j){this.detachEvent("batchRequestSent",i,j);return this;};
J.prototype.fireBatchRequestSent=function(P){this.fireEvent("batchRequestSent",P);return this;};
J.prototype.attachBatchRequestCompleted=function(i,j,k){this.attachEvent("batchRequestCompleted",i,j,k);return this;};
J.prototype.detachBatchRequestCompleted=function(i,j){this.detachEvent("batchRequestCompleted",i,j);return this;};
J.prototype.fireBatchRequestCompleted=function(P){this.fireEvent("batchRequestCompleted",P);return this;};
J.mSharedData={server:{},service:{},meta:{}};
J._getSharedData=function(S,k){var i=this.mSharedData[S][k];if(!i){i={};this.mSharedData[S][k]=i;}return i;};
J.prototype._initializeMetadata=function(){if(this.bDestroyed){return;}this.bIsMessageScopeSupported=this.oMetadata._isMessageScopeSupported();var i=function(){this.fireMetadataLoaded({metadata:this.oMetadata});L.debug(this+" - metadataloaded fired");}.bind(this);this.initialize();if(this.bLoadAnnotationsJoined){this.oAnnotations.loaded().then(i,this.fireMetadataFailed.bind(this));}else{i();}};
J.prototype.refreshMetadata=function(){if(this.oMetadata&&this.oMetadata.refresh){return this.oMetadata.refresh();}};
J.prototype.fireAnnotationsLoaded=function(P){this.fireEvent("annotationsLoaded",P);return this;};
J.prototype.attachAnnotationsLoaded=function(i,j,k){this.attachEvent("annotationsLoaded",i,j,k);return this;};
J.prototype.detachAnnotationsLoaded=function(i,j){this.detachEvent("annotationsLoaded",i,j);return this;};
J.prototype.fireAnnotationsFailed=function(P){this.fireEvent("annotationsFailed",P);L.debug(this+" - annotationsfailed fired");return this;};
J.prototype.attachAnnotationsFailed=function(i,j,k){this.attachEvent("annotationsFailed",i,j,k);return this;};
J.prototype.detachAnnotationsFailed=function(i,j){this.detachEvent("annotationsFailed",i,j);return this;};
J.prototype.fireMetadataLoaded=function(P){this.fireEvent("metadataLoaded",P);return this;};
J.prototype.attachMetadataLoaded=function(i,j,k){this.attachEvent("metadataLoaded",i,j,k);return this;};
J.prototype.detachMetadataLoaded=function(i,j){this.detachEvent("metadataLoaded",i,j);return this;};
J.prototype.fireMetadataFailed=function(P){this.fireEvent("metadataFailed",P);return this;};
J.prototype.attachMetadataFailed=function(i,j,k){this.attachEvent("metadataFailed",i,j,k);return this;};
J.prototype.detachMetadataFailed=function(i,j){this.detachEvent("metadataFailed",i,j);return this;};
J.prototype._createEventInfo=function(R,k,n){var N={};N.url=R.requestUri;N.method=R.method;N.async=R.async;N.headers=R.headers;if(n){N.requests=[];for(var i=0;i<n.length;i++){var P={};if(Array.isArray(n[i])){var S=n[i];for(var j=0;j<S.length;j++){var R=S[j].request;var T=n[i][j].response;P={};P.url=R.requestUri;P.method=R.method;P.headers=R.headers;if(T){P.response={};if(R._aborted){P.success=false;P.response.statusCode=0;P.response.statusText="abort";}else{P.success=true;if(T.message){P.response.message=T.message;T=T.response;P.response.responseText=T.body;P.success=false;}P.response.headers=T.headers;P.response.statusCode=T.statusCode;P.response.statusText=T.statusText;}}N.requests.push(P);}}else{var R=n[i].request;var T=n[i].response;P.url=R.requestUri;P.method=R.method;P.headers=R.headers;if(T){P.response={};if(R._aborted){P.success=false;P.response.statusCode=0;P.response.statusText="abort";}else{P.success=true;if(T.message){P.response.message=T.message;T=T.response;P.response.responseText=T.body;P.success=false;}P.response.headers=T.headers;P.response.statusCode=T.statusCode;P.response.statusText=T.statusText;}}N.requests.push(P);}}}if(k){N.response={};N.success=true;if(k.message){N.response.message=k.message;N.success=false;}if(k.response){k=k.response;}if(k&&k.statusCode!=undefined){N.response.headers=k.headers;N.response.statusCode=k.statusCode;N.response.statusText=k.statusText;N.response.responseText=k.body!==undefined?k.body:k.responseText;N.response.expandAfterCreateFailed=k.expandAfterCreateFailed;}}N.ID=R.requestID;return N;};
J.prototype._createRequestID=function(){var R;R=u();return R;};
J.prototype._getServerUrl=function(){var S,i;S=new E(this.sServiceUrl).absoluteTo(document.baseURI);i=new E("/").absoluteTo(S).toString();return i;};
J.prototype._createMetadataUrl=function(i){if(i.indexOf(this.sServiceUrl)==-1){if(!i.startsWith("/")){i="/"+i;}i=this.sServiceUrl+i;}var j=U.fromURL(i||window.location.href);var k=Object.assign({},this.mMetadataUrlParams);Array.from(j.keys()).forEach(function(P){k[P]=j.get(P);});var n=y._createUrlParamsArray(k);var N=i.split("?");if(N.length>1){i=N[0];}return this._addUrlParams(i,n);};
J.prototype._addUrlParams=function(i,j){var k=[];if(this.aUrlParams){k=k.concat(this.aUrlParams);}if(j){k=k.concat(j);}if(k&&k.length>0){i+="?"+k.join("&");}return i;};
J.prototype._createRequestUrl=function(P,i,j,k){return this._createRequestUrlWithNormalizedPath(this._normalizePath(P,i),j,k);};
J.prototype._createRequestUrlWithNormalizedPath=function(n,i,j){var k="";if(!j){k=this.sServiceUrl+n;}else{k=n.substr(n.indexOf('/')+1);}return this._addUrlParams(k,i);};
J.prototype._importData=function(j,k,R,P,n,N,S,T){var V=this,W,X,Y,Z;P=P||"";N=N||"";if(j.results&&Array.isArray(j.results)){W=[];g(j.results,function(i,e1){var N=V._getKey(e1);N=V._importData(e1,k,R,P.substr(0,P.lastIndexOf("/")),n,N);if(N){W.push(N);}});return W;}else{if(N){P="/"+N;n+=N.substr(N.indexOf("("));}else{N=this._getKey(j);}if(!N){return N;}Y=this._getEntity(N);Z=Y;if(!Y||(Y.__metadata&&Y.__metadata.invalid)){if(!Z){Z=j;}Y=j;N=this._addEntity(Y);}if(this.aBindableResponseHeaders){var $={};for(var _ in R.headers){var a1=_.toLowerCase();if(this.aBindableResponseHeaders.indexOf(a1)>-1){$[a1]=R.headers[_];}}if(!h($)){if(!j.__metadata){j.__metadata={};}j.__metadata.headers=$;}}g(j,function(i,e1){if(e1&&(e1.__metadata&&e1.__metadata.uri||e1.results)&&!e1.__deferred){var f1=P+"/"+i;var g1=n+"/"+i;X=V._importData(e1,k,R,f1,g1,undefined,false,"/"+N+"/"+i);if(Array.isArray(X)){Y[i]={__list:X};}else{if(Z[i]&&Z[i].__ref){if(Z[i].__ref!==X){V.mInvalidatedPaths[P.substr(P.lastIndexOf("("))+"/"+i]="/"+X;}}Y[i]={__ref:X};}}else if(!e1||!e1.__deferred){if(Z[i]&&e1===null){V.mInvalidatedPaths[P.substr(P.lastIndexOf("("))+"/"+i]=null;}Y[i]=e1;}});var b1={};b1[N]=Y;if(this.hasContext("/"+N)&&this.getContext("/"+N).isPreliminary()){var c1=this.getContext("/"+N);c1.setUpdated(true);c1.setPreliminary(false);}this._updateChangedEntities(b1);k[N]=true;P=P||'/'+N;n=n||P;var d1=this.resolveFromCache(n);if(d1==="/"+N||(d1&&d1.split("/").length>2)){this._writePathCache(d1,"/"+N,S);}this._writePathCache(P,"/"+N,S);this._writePathCache(n,"/"+N,S,true);if(T){this._writePathCache(T,"/"+N,S);}return N;}};
J.prototype._writePathCache=function(P,i,j,k){var n,N,R,S,T,V;if(P&&i){if(!this.mPathCache[P]){this.mPathCache[P]={};}if(!j&&P.lastIndexOf("/")===0){i=P;}this.mPathCache[P].canonicalPath=i;if(k){T=P.split("/");for(V=3;V<T.length;V+=1){R=T.slice(0,V).join("/");S=this.mPathCache[R];if(S){n=S.canonicalPath+P.slice(R.length);N=this.mPathCache[n];if(N){N.canonicalPath=i;}}}}}};
J.prototype._removeReferences=function(j){var k=this,n;if(!j){return j;}if(j.results){n=[];g(j.results,function(i,N){n.push(k._removeReferences(N));});return n;}else{g(j,function(P,i){if(i){if(i["__ref"]||i["__list"]){delete j[P];}}});return j;}};
J.prototype._restoreReferences=function(j,V){var k=this,n,N,R;function P(n){var N=V[n];if(!N){N=k._getObject("/"+n);d(N,"ODataModel inconsistent: "+n+" not found!");if(N){N=m({},N);V[n]=N;k._restoreReferences(N,V);}}return N;}if(!V){V={};}g(j,function(S,T){if(T){if(T.__ref){n=T.__ref;N=P(n);if(N){j[S]=N;}delete T.__ref;}else if(T.__list){R=[];g(T.__list,function(i,n){N=P(n);if(N){R.push(N);}});delete T.__list;T.results=R;}}});return j;};
J.prototype.removeData=function(){this.oData={};};
J.prototype.initialize=function(){var i=this.getBindings();i.forEach(function(j){j.initialize();});};
J.prototype.invalidate=function(i){var j;for(var k in this.oData){j=this.oData[k];if(!i||i(k,j)){j.__metadata.invalid=true;}}};
J.prototype.invalidateEntry=function(i){var j;if(typeof i==="string"){if(i.indexOf("/")===0){j=this._getObject(i);}else{j=this.oData[i];}}else if(i instanceof C){j=this._getObject(i.getPath());}if(j&&j.__metadata){j.__metadata.invalid=true;}};
J.prototype.invalidateEntityType=function(i){var j;for(var k in this.oData){j=this.oData[k];if(j.__metadata.type===i){j.__metadata.invalid=true;}}};
J.prototype.refresh=function(i,R,j){if(typeof i==="string"){j=i;i=false;R=false;}if(R){this.removeData();}this._refresh(i,j);};
J.prototype._refresh=function(i,j,k,n){var N=this.getBindings();this.sRefreshGroupId=j;N.forEach(function(P){P._refresh(i,k,n);});this.sRefreshGroupId=undefined;};
J.prototype.checkUpdate=function(i,j,k,n){if(j){this.bForceUpdate=this.bForceUpdate||i;Object.assign(this.mChangedEntities4checkUpdate,k);if(!this.sUpdateTimer){this.sUpdateTimer=setTimeout(function(){this.checkUpdate(this.bForceUpdate,false,this.mChangedEntities4checkUpdate);}.bind(this),0);}return;}if(this.sUpdateTimer){clearTimeout(this.sUpdateTimer);this.sUpdateTimer=null;this.bForceUpdate=undefined;this.mChangedEntities4checkUpdate={};}var N=this.getBindings();N.forEach(function(P){if(!n||this.isMetaModelPath(P.getPath())){P.checkUpdate(i,k);}}.bind(this));this._processAfterUpdate();};
J.prototype.checkDataState=function(i){var j=this.getBindings();j.forEach(function(k){if(k.checkDataState){k.checkDataState(i);}});};
J.prototype.bindProperty=function(P,i,j){var k=new x(this,P,i,j);return k;};
J.prototype.bindList=function(P,i,S,j,k){var n=new b(this,P,i,S,j,k);return n;};
J.prototype.bindTree=function(P,i,j,k,S){var n=new c(this,P,i,j,k,S);return n;};
J.prototype.createBindingContext=function(P,i,j,k,R){var n,N,S,T,V,W=this,X;if(i!==null&&typeof i==="object"&&!(i instanceof sap.ui.model.Context)){R=k;k=j;j=i;i=undefined;}if(typeof i=="function"){R=j;k=i;j=undefined;i=undefined;}if(typeof i=="boolean"){R=i;k=undefined;j=undefined;i=undefined;}if(typeof j=="function"){R=k;k=j;j=undefined;}if(typeof j=="boolean"){R=j;k=undefined;j=undefined;}if(typeof k=="boolean"){R=k;k=undefined;}if(j){X=j.canonicalRequest;}X=this._isCanonicalRequestNeeded(X);n=this.resolve(P,i,X);if(!n&&X){n=this.resolve(P,i);}V=this.resolveDeep(P,i);if(!n){if(k){k(null);}return null;}if(R===undefined){R=this._isReloadNeeded(n,j);}if(!R){N=this.resolve(P,i,true);if(N){S=this.getContext(N,V);}else{S=null;}if(k){k(S);}return S;}function Y(b1){var c1=b1?W._getKey(b1):null,d1=!(P===""||P.indexOf("/")>0),e1=null,f1,g1;S=null;if(c1){S=W.getContext('/'+c1,V);e1={__ref:c1};}if(i&&$&&d1){f1=i.getPath();f1=f1.substr(1);g1=W._getEntity(f1);if(g1){g1[P]=e1;}}k(S);}function Z(b1){var c1;if(b1.statusCode=='404'&&i&&$){var d1=i.getPath();d1=d1.substr(1);c1=W._getEntity(d1);if(c1){c1[P]={__ref:null};}}k(null);}if(k){var $=!P.startsWith("/");if(n){var _=[],a1=this.createCustomParams(j);if(a1){_.push(a1);}if(j&&(j.batchGroupId||j.groupId)){T=j.groupId||j.batchGroupId;}this.read(P,{canonicalRequest:X,context:i,error:Z,groupId:T,success:Y,updateAggregatedMessages:true,urlParameters:_});}else{k(null);}}if(j&&j.createPreliminaryContext){n=this.resolve(P,i,X);if(!n&&X){n=this.resolve(P,i);}S=this.getContext(n,V);return S;}};
J.prototype._updateContext=function(i,P){if(!P.startsWith("/")){throw new Error("Path "+P+" must start with a / ");}i.sPath=P;this.mContexts[P]=i;};
J.prototype._splitEntries=function(i){return i.replace(/\s/g,"").split(',').map(function(j){return j.split("/");});};
J.prototype._filterOwnSelect=function(S,i){var j,k;if(!i){return[];}k=i.map(function(P){return P.name;});j=S.filter(function(n){return n.length===1;}).map(function(n){return n[0];});if(S.length===0||j.indexOf("*")!==-1||j.indexOf("**")!==-1){return k;}else{return j.filter(function(n){return k.indexOf(n)!==-1;});}};
J.prototype._filterOwnExpand=function(i,S){return i.map(function(j){return j[0];}).filter(function(V,j,k){return k.indexOf(V)===j;}).filter(function(V){return S.length===0||S.some(function(j){return j.indexOf(V)===0||j.indexOf("**")===0;});});};
J.prototype._filterSelectByNavProp=function(i,n){return i.filter(function(S){return S[0]===n;}).map(function(S){return S.length>1?S.slice(1):["**"];});};
J.prototype._filterExpandByNavProp=function(i,n){return i.filter(function(S){return S.length>1&&S[0]===n;}).map(function(S){return S.slice(1);});};
J.prototype._isReloadNeeded=function(P,k){var n=this,N=this.oMetadata,R,S=this._getObject(P),T=[],V=[];if(!this.oMetadata.isLoaded()){return true;}R=this.oMetadata._getEntityTypeByPath(P);if(this._isCreatedEntity(S)){return false;}function W(R,S,V,T){var X,Y,Z,$,_,a1,b1,c1,d1;if(!R){return false;}if(S===null){return false;}if(!S){return true;}if(S.__metadata&&S.__metadata.invalid){return true;}X=n._filterOwnSelect(V,R.property);for(var i=0;i<X.length;i++){d1=X[i];if(S[d1]===undefined){return true;}}Y=n._filterOwnExpand(T,V);for(var i=0;i<Y.length;i++){c1=Y[i];Z=S[c1];if(Z===null){continue;}if(Z===undefined||Z.__deferred){return true;}$=N._getEntityTypeByNavProperty(R,c1);a1=n._filterSelectByNavProp(V,c1);b1=n._filterExpandByNavProp(T,c1);if(Z.__ref){_=n._getEntity(Z.__ref);if(W($,_,a1,b1)){return true;}}if(Z.__list){for(var j=0;j<Z.__list.length;j++){_=n._getEntity(Z.__list[j]);if(W($,_,a1,b1)){return true;}}}}return false;}if(k){if(k.select){V=this._splitEntries(k.select);}if(k.expand){T=this._splitEntries(k.expand);}}return W(R,S,V,T);};
J.prototype.createCustomParams=function(P){var i=[],j,S={expand:true,select:true};for(var n in P){if(n in S){i.push("$"+n+"="+e(P[n]));}if(n==="custom"){j=P[n];for(n in j){if(n.indexOf("$")===0){L.warning(this+" - Trying to set OData parameter '"+n+"' as custom query option!");}else if(typeof j[n]==='string'){i.push(n+"="+e(j[n]));}else{i.push(n);}}}}return i.join("&");};
J.prototype.bindContext=function(P,i,j){var k=new a(this,P,i,j);return k;};
J.prototype.setDefaultCountMode=function(i){this.sDefaultCountMode=i;};
J.prototype.getDefaultCountMode=function(){return this.sDefaultCountMode;};
J.prototype._addEntity=function(i){var k=this._getKey(i);this.oData[k]=i;return k;};
J.prototype._removeEntity=function(k){k=k&&y._normalizeKey(k);delete this.oData[k];delete this.mChangedEntities[k];delete this.mContexts["/"+k];};
J.prototype._getEntity=function(k){var i=this.oData[k];if(!i){k=k&&y._normalizeKey(k);i=this.oData[k];}return i;};
J.prototype._getKey=function(V){var k,i;if(V instanceof C){k=V.getPath().substr(1);}else if(V&&V.__metadata&&V.__metadata.uri){i=V.__metadata.uri;k=i.substr(i.lastIndexOf("/")+1);}else if(typeof V==='string'){k=V.substr(V.lastIndexOf("/")+1);}if(!this.oData[k]){k=k&&y._normalizeKey(k);}return k;};
J.prototype.getKey=function(V){return this._getKey(V);};
J.prototype.createKey=function(j,k){var n=this.oMetadata._getEntityTypeByPath(j),N=j,P=this,R,S;d(n,"Could not find entity type of collection \""+j+"\" in service metadata!");N+="(";if(n.key.propertyRef.length===1){R=n.key.propertyRef[0].name;d(R in k,"Key property \""+R+"\" is missing in object!");S=this.oMetadata._getPropertyMetadata(n,R);N+=encodeURIComponent(y.formatValue(k[R],S.type));}else{g(n.key.propertyRef,function(i,T){if(i>0){N+=",";}R=T.name;d(R in k,"Key property \""+R+"\" is missing in object!");S=P.oMetadata._getPropertyMetadata(n,R);N+=R;N+="=";N+=encodeURIComponent(y.formatValue(k[R],S.type));});}N+=")";return N;};
J.prototype.getProperty=function(P,i,j){var V=this._getObject(P,i);if(!j){return V;}if(!l(V)){return V;}V=m({},V);if(j===true){return this._restoreReferences(V);}else{return this._removeReferences(V);}};
J.prototype.getObject=function(P,n,N){if(l(n)){N=n;n=undefined;}var R=this,S=this.resolve(P,n),V=this._getObject(S),T=this.oMetadata._getEntityTypeByPath(S),W=[],X=[];if(!T||!l(V)||!V.__metadata||!V.__metadata.uri){return V;}if(!N||!(N.select||N.expand)){return m({},V);}function Y(T,V,X,W){var Z,$,_,a1,b1,c1,d1,e1,f1,g1,h1,i1,j1;if(!V){return undefined;}if(!T){return undefined;}_=R._filterOwnSelect(X,T.property);$={};for(var i=0;i<_.length;i++){i1=_[i];if(V[i1]!==undefined){$[i1]=V[i1];}else{L.fatal("No data loaded for select property: "+i1+" of entry: "+R.getKey(V));return undefined;}}if(V.__metadata){$.__metadata=V.__metadata;}Z=R._filterOwnExpand(W,X);for(var i=0;i<Z.length;i++){h1=Z[i];b1=V[h1];c1=R.oMetadata._getEntityTypeByNavProperty(T,h1);f1=R._filterSelectByNavProp(X,h1);g1=R._filterExpandByNavProp(W,h1);if(b1&&b1.__ref){e1=R._getObject("/"+b1.__ref);d1=Y(c1,e1,f1,g1);if(d1!==undefined){$[h1]=d1;}else{L.fatal("No data loaded for expand property: "+h1+" of entry: "+R.getKey(d1));return undefined;}}if(b1&&b1.__list){j1=[];for(var j=0;j<b1.__list.length;j++){e1=R._getObject("/"+b1.__list[j]);d1=Y(c1,e1,f1,g1);if(d1!==undefined){j1.push(d1);}else{L.fatal("No data loaded for expand property: "+h1+" of entry: "+R.getKey(d1));return undefined;}}$[h1]=j1;}}a1=R._filterOwnSelect(X,T.navigationProperty);for(var k=0;k<a1.length;k++){h1=a1[k];if(Z.indexOf(h1)===-1){var k1=$.__metadata.uri+"/"+h1;$[h1]={__deferred:{uri:k1}};}}return $;}if(N.select){X=this._splitEntries(N.select);}if(N.expand){W=this._splitEntries(N.expand);}V=Y(T,V,X,W);return V;};
J.prototype._getObject=function(P,i,j){var n=this.isLegacySyntax()?this.oData:null,k,N,R,S,T,V,W,X,Y;R=this.resolve(P,i,this.bCanonicalRequests);if(!R&&this.bCanonicalRequests){R=this.resolve(P,i);}if(!R){return n;}if(this._isMetadataPath(R)){if(this.oMetadata&&this.oMetadata.isLoaded()){if(this.isMetaModelPath(R)){S=R.indexOf('/##');Y=this.getMetaModel();if(!this.bMetaModelLoaded){return null;}T=R.substr(0,S);V=R.substr(S+3);W=Y.getMetaContext(T);n=Y.getProperty(V,W);}else{n=this.oMetadata._getAnnotation(R);}}}else{if(R==="/"){return this.oData;}var Z=R.split("/"),$=0;X=Z[1];Z.splice(0,2);k=this.mChangedEntities[X];N=this._getEntity(X);n=j?N:k||N;while(n&&Z[$]){var _=k&&k.hasOwnProperty(Z[$]);k=k&&k[Z[$]];N=N&&N[Z[$]];n=j||!_?N:k;if(n){if(n.__ref){k=this.mChangedEntities[n.__ref];N=this._getEntity(n.__ref);n=j?N:k||N;}else if(n.__list){n=n.__list;}else if(n.__deferred){n=undefined;}}$++;}}if(l(k)){n=j?N:m({},N,k);}return n;};
J.prototype.updateSecurityToken=function(){if(this.bTokenHandling){if(!this.oSharedServiceData.securityToken){this.refreshSecurityToken();}if(this.bTokenHandling){this.oHeaders["x-csrf-token"]=this.oSharedServiceData.securityToken;}}};
J.prototype.resetSecurityToken=function(){delete this.oSharedServiceData.securityToken;delete this.oHeaders["x-csrf-token"];delete this.pSecurityToken;};
J.prototype.getSecurityToken=function(){var T=this.oSharedServiceData.securityToken;if(!T){this.refreshSecurityToken();T=this.oSharedServiceData.securityToken;}return T;};
J.prototype.securityTokenAvailable=function(){if(!this.pSecurityToken){if(this.oSharedServiceData.securityToken){this.pSecurityToken=Promise.resolve(this.oSharedServiceData.securityToken);}else{this.pSecurityToken=new Promise(function(i,j){this.refreshSecurityToken(function(){i(this.oSharedServiceData.securityToken);}.bind(this),function(){j();},true);}.bind(this));}}return this.pSecurityToken;};
J.prototype.refreshSecurityToken=function(S,i,j){var T;var k=this;var n=this._createRequestUrlWithNormalizedPath("/");var N={abort:function(){this.request.abort();}};function P(X,Y){if(Y){T=k._getHeader("x-csrf-token",Y.headers);k._setSessionContextIdHeader(k._getHeader("sap-contextid",Y.headers));if(T){k.oSharedServerData.securityToken=T;k.oSharedServiceData.securityToken=T;k.pSecurityToken=Promise.resolve(T);k.oHeaders["x-csrf-token"]=T;}else{k.resetSecurityToken();k.bTokenHandling=false;}}if(S){S(X,Y);}}function R(X){k.resetSecurityToken();k.bTokenHandling=false;k._handleError(X);if(i){i(X);}}function V(X){N.request=W("GET",R);}function W(X,i){var Y=k._createRequest(n,"",X,k._getHeaders(undefined,true),null,null,!!j);Y.headers["x-csrf-token"]="Fetch";return k._request(Y,P,i,undefined,undefined,k.getServiceMetadata());}if(this.bDisableHeadRequestForToken){N.request=W("GET",R);}else{N.request=W("HEAD",V);}return N;};
J.prototype._submitRequest=function(R,S,j){var k=this,n,N,P,T,V;T=new Promise(function(i,a1){V=i;});function W(i,a1){if(S){S(i,a1);}V();}function X(i){if(k.bTokenHandling&&i.response){var a1=k._getHeader("x-csrf-token",i.response.headers);if(!R.bTokenReset&&i.response.statusCode=='403'&&a1&&a1.toLowerCase()==="required"){k.resetSecurityToken();R.bTokenReset=true;Z();return;}}if(j){j(i);}V();}function Y(R){if(k.bTokenHandling&&(R.method!=="GET"||k.bTokenHandlingForGet)){k.pReadyForRequest=k.securityTokenAvailable();}return k.pReadyForRequest;}function Z(){if(k.bTokenHandling){delete R.headers["x-csrf-token"];}Y(R).then(function(i){if(k.bTokenHandling&&(R.method!=="GET"||k.bTokenHandlingForGet)){R.headers["x-csrf-token"]=i;}_();},function(){_();});}function $(a1,R,b1){var c1,d1=R.eventInfo.requests;if(d1){g(d1,function(i,R){if(Array.isArray(R)){R.forEach(function(R){g(R.parts,function(i,e1){c1=k._createEventInfo(R.request,e1.fnError);k["fireRequest"+a1](c1);});});}else{if(R.parts){g(R.parts,function(i,e1){c1=k._createEventInfo(R.request,e1.fnError);k["fireRequest"+a1](c1);});}else{c1=k._createEventInfo(R.request,R.fnError);k["fireRequest"+a1](c1);}}});if(R.eventInfo.batch){c1=k._createEventInfo(R,b1,d1);k["fireBatchRequest"+a1](c1);}}}function _(){if(k.sSessionContextId){R.headers["sap-contextid"]=k.sSessionContextId;}N=k._request(R,W,X,n,undefined,k.getServiceMetadata());if(R.eventInfo){$("Sent",R,null);delete R.eventInfo;}if(P){N.abort();}}n=k._getODataHandler(R.requestUri);if(this.bSequentializeRequests){this.pSequentialRequestCompleted.then(function(){Z();});this.pSequentialRequestCompleted=T;}else{Z();}return{abort:function(){if(N){N.abort();}P=true;}};};
J.prototype._setSessionContextIdHeader=function(S){if(S){this.sSessionContextId=S;}};
J.prototype._submitSingleRequest=function(R){var j=this,k,n={},N={},P={};function S(V,W){if(V===undefined&&W.statusCode===200){T({message:"Response did not contain a valid OData result",response:W});return;}function X(V,W){for(var i=0;i<R.parts.length;i++){if(R.parts[i].request._aborted){j._processAborted(R.parts[i].request,W);}else if(R.parts[i].fnSuccess){R.parts[i].fnSuccess(V,W);}}if(R.request.requestUri.indexOf("$count")===-1){j.checkUpdate(false,false,N);if(R.bRefreshAfterChange){j._refresh(false,undefined,n,P);}}}j._processSuccess(R.request,W,X,N,n,P);j._invalidatePathCache();j._setSessionContextIdHeader(j._getHeader("sap-contextid",W.headers));}function T(V){if(V.message=="Request aborted"){for(var i=0;i<R.parts.length;i++){j._processAborted(R.parts[i].request,V);}}else{for(var i=0;i<R.parts.length;i++){j._processError(R.parts[i].request,V,R.parts[i].fnError);}}j._processAfterUpdate();}R.request.eventInfo={requests:R.parts,batch:false};k=this._submitRequest(R.request,S,T);return k;};
J.prototype._submitBatchRequest=function(k,R,S,n){var N=this,P={},T={},V={},W={};function X(j,b1,c1){var d1,e1,i;for(i=0;i<j.parts.length;i++){if(c1||j.parts[i].request._aborted){N._processAborted(j.parts[i].request,b1);}else if(b1.message){N._processError(j.parts[i].request,b1,j.parts[i].fnError);}else{if(j.request.withContentID){d1=j.request.withContentID;if(j.request.created){e1=N._getKey(b1.data);T[d1]={key:e1,deepPath:j.request.deepPath.replace("('"+d1+"')",e1.slice(e1.indexOf("(")))};}else{e1=T[d1].key;j.request.requestUri=j.request.requestUri.replace("$"+d1,e1);j.request.deepPath=T[d1].deepPath;}}N._processSuccess(j.parts[i].request,b1,j.parts[i].fnSuccess,V,P,W);}}}function Y(b1,c1){if(b1===undefined&&c1.statusCode===200){Z({message:"Response did not contain a valid OData batch result",response:c1});return;}var d1,e1,f1,g1=b1.__batchResponses;if(g1){var i,j;for(i=0;i<g1.length;i++){d1=g1[i];if(Array.isArray(R[i])){if(d1.message){for(j=0;j<R[i].length;j++){d1.$reported=false;e1=R[i][j];X(e1,d1);e1.response=d1;}}else{f1=d1.__changeResponses;for(j=0;j<f1.length;j++){var h1=f1[j];e1=R[i][j];X(e1,h1);e1.response=h1;}}}else{e1=R[i];X(e1,d1);e1.response=d1;}}N._invalidatePathCache();N.checkUpdate(false,false,V);}N._processSuccess(k,c1,S,V,P,W,true,R);N._setSessionContextIdHeader(N._getHeader("sap-contextid",c1.headers));}function Z(j){var b1=j.message=="Request aborted";j.$reported=true;g(R,function(i,c1){if(Array.isArray(c1)){c1.forEach(function(c1){X(c1,j,b1);});}else{X(c1,j,b1);}});N._processAfterUpdate();if(b1){N._processAborted(k,j,true);}else{j.$reported=false;N._processError(k,j,n,true,R);}}k.eventInfo={requests:R,batch:true};var $=this._submitRequest(k,Y,Z);function _(j){var n;for(var i=0;i<j.parts.length;i++){n=j.parts[i].fnError;if(!j.parts[i].request._aborted&&n){n(K);}}}var a1={abort:function(j){g(R,function(i,b1){if(Array.isArray(b1)){b1.forEach(function(b1){_(b1);});}else{_(b1);}});if(n&&!j){n(K);}$.abort();}};return a1;};
J.prototype._invalidatePathCache=function(){var i=this,j;if(Object.keys(this.mInvalidatedPaths).length>0){Object.keys(this.mPathCache).forEach(function(k){for(var n in i.mInvalidatedPaths){j=k.indexOf(n);if(j>-1){if(j+n.length!==k.length){var N=k.substr(j+n.length);i.mPathCache[k].canonicalPath=i.mInvalidatedPaths[n]===null?null:i.mInvalidatedPaths[n]+N;}else{i.mPathCache[k].canonicalPath=i.mInvalidatedPaths[n];}}}});}this.mInvalidatedPaths={};};
J.prototype._createBatchRequest=function(i){var j,R,k={},P={},n=true;P.__batchRequests=i;for(var N in i){if(i[N]&&i[N].__changeRequests||i[N]&&i[N].headers&&!i[N].headers['sap-cancel-on-close']){n=false;break;}}j=this.sServiceUrl+"/$batch";if(this.aUrlParams.length>0){j+="?"+this.aUrlParams.join("&");}Q.extend(k,this.mCustomHeaders,this.oHeaders);k["Accept"]="multipart/mixed";delete k["Content-Type"];k['sap-cancel-on-close']=n;R={headers:k,requestUri:j,method:"POST",data:P,user:this.sUser,password:this.sPassword,async:true};R.withCredentials=this.bWithCredentials;return R;};
J.prototype.abortInternalRequest=function(j,P){var R=this.mRequests;var k,n;if(P){k=P.requestKey;n=P.path;}if(j in this.mDeferredGroups){R=this.mDeferredRequests;}var N=function(T){for(var i=0;i<T.parts.length;i++){T.parts[i].requestHandle.abort();}};var S=R[j];if(S){if(k in S.map){N(S.map[k]);}else if(n){g(S.map,function(k,i){if(k.indexOf(n)>=0){N(i);}});}else if(j&&!P){g(S.map,function(i,T){N(T);});}}};
J.prototype._pushToRequestQueue=function(R,i,j,k,S,n,N,P){var T=R[i],V=k.key?k.key:k.method+":"+k.requestUri;if(this.bWarmup){return;}if(!T){T={};T.map={};T.requests=[];R[i]=T;}if(V in T.map&&(k.key||k.method==='GET')){var W=T.map[V];var X=W.request;k.deepPath=X.deepPath;if(this.sMessageScope===s.BusinessObject){k.headers["sap-message-scope"]=X.headers["sap-message-scope"];}if(W.bRefreshAfterChange===undefined){W.bRefreshAfterChange=P;}if(!k.key){W.parts.push({request:k,fnSuccess:S,fnError:n,requestHandle:N});}if(k.method==="GET"){delete X.data;}else{X.method=k.method;X.headers=k.headers;X.data=k.data;X.requestUri=k.requestUri;if(k.method==="PUT"){delete X.headers["x-http-method"];}if(k.functionTarget){X.functionTarget=k.functionTarget;}if(X._aborted){delete X._aborted;}}}else{var W={request:k,bRefreshAfterChange:P,parts:[{request:k,fnSuccess:S,fnError:n,requestHandle:N}]};if(k.method==="GET"){T.requests.push(W);}else{if(!T.changes){T.changes={};}var Y=T.changes[j];if(!Y){Y=[];T.changes[j]=Y;}W.changeSetId=j;Y.push(W);}T.map[V]=W;}};
J.prototype._collectChangedEntities=function(j,k,n){var N=this;if(j.changes){g(j.changes,function(P,R){for(var i=0;i<R.length;i++){if(R[i].bRefreshAfterChange){var S=R[i].request,T="/"+S.requestUri.split("?")[0],V,W;if(S.method==="POST"||S.method==="DELETE"){var X=N.oMetadata._getEntityTypeByPath(T);if(X){n[X.entityType]=true;}}else{V=N._getObject(T);if(V){W=N._getKey(V);}else if(T.lastIndexOf("/")===0){W=N._getKey(T);}if(W){k[W]=true;}}}}});}};
J.prototype._processRequestQueue=function(R,j,S,k){var n=this,P,N=[];function T(W,X){for(var i=0;i<W.parts.length;i++){var Y=W.parts[i];if(Y.request._aborted){n._processAborted(W.request,null);W.parts.splice(i,1);i--;}else if(X){Y.request._handle=X;X.iRelevantRequests++;}}}function V(){return{iRelevantRequests:0,oRequestHandle:{},abort:function(){this.iRelevantRequests--;if(this.iRelevantRequests===0&&this.oRequestHandle){this.oRequestHandle.abort(true);if(S){S({},undefined);}}}};}if(this.bUseBatch){g(R,function(i,W){if(i===j||!j){var X={},Y={};n._collectChangedEntities(W,X,Y);if(Object.keys(X).length||Object.keys(Y).length){n.bIncludeInCurrentBatch=true;n._refresh(false,i,X,Y);n.bIncludeInCurrentBatch=false;}}});g(R,function(W,X){if(W===j||!j){var Y=[],Z=[],$,_;var a1=V();if(X.changes){g(X.changes,function(d1,e1){var f1,i,g1;$={__changeRequests:[]};_=[];for(i=0;i<e1.length;i++){f1=e1[i].request;P='/'+n.getKey(f1.data);n.increaseLaundering(P,f1.data);T(e1[i],a1);if(e1[i].parts.length>0){n.removeInternalMetadata(f1.data);$.__changeRequests.push(f1);if(f1.expandRequest){g1=e1[i].parts[0];n._pushToRequestQueue(R,W,undefined,f1.expandRequest,g1.fnSuccess,g1.fnError,g1.requestHandle,false);}_.push(e1[i]);}}if($.__changeRequests&&$.__changeRequests.length>0){Y.push($);Z.push(_);}});}if(X.requests){var b1=X.requests;for(var i=0;i<b1.length;i++){T(b1[i],a1);if(b1[i].parts.length>0){Y.push(b1[i].request);Z.push(b1[i]);}}}if(Y.length>0){var c1=n._createBatchRequest(Y);a1.oRequestHandle=n._submitBatchRequest(c1,Z,S,k);N.push(a1.oRequestHandle);}delete R[W];}});}else{g(R,function(W,X){if(W===j||!j){if(X.changes){g(X.changes,function($,_){for(var i=0;i<_.length;i++){var Z=V();P='/'+n.getKey(_[i].request.data);n.increaseLaundering(P,_[i].request.data);T(_[i],Z);if(_[i].parts.length>0){n.removeInternalMetadata(_[i].request.data);Z.oRequestHandle=n._submitSingleRequest(_[i]);N.push(Z.oRequestHandle);}}});}if(X.requests){var Y=X.requests;for(var i=0;i<Y.length;i++){var Z=V();T(Y[i],Z);if(Y[i].parts.length>0){Z.oRequestHandle=n._submitSingleRequest(Y[i]);N.push(Z.oRequestHandle);}}}delete R[W];}});}this.checkDataState(this.mLaunderingState);return N.length==1?N[0]:N;};
J.prototype._processRequestQueueAsync=function(R){var i=this;if(!this.pCallAsync){this.pCallAsync=this.oMetadata.loaded().then(function(){return Promise.resolve().then(function(){i._processRequestQueue(R);i.pCallAsync=undefined;});});}};
J.prototype._processSuccess=function(R,i,S,j,k,n,N,P){var T,V,W,X,Y,Z,$,_,a1,b1,c1,d1={},e1={},f1=i.data,g1=this;if(!N){V=!(i.statusCode===204||i.statusCode==='204');c1=R.requestUri;a1=c1.replace(this.sServiceUrl,"");if(!a1.startsWith('/')){a1='/'+a1;}var h1=this._normalizePath(a1);var i1=this.oMetadata._getEntityTypeByPath(h1);var j1=i1?!i1.isFunction:true;a1=this._normalizePath(a1,undefined,j1);this.decreaseLaundering(a1,R.data);this._decreaseDeferredRequestCount(R);if(R.functionMetadata){if(i.headers&&i.headers.location){Z=i.headers.location;b1=Z.lastIndexOf(this.sServiceUrl);if(b1>-1){T=Z.slice(b1+this.sServiceUrl.length);if(R.functionTarget===T){W=this.getDeepPathForCanonicalPath(T);if(W){R.deepPath=W;}}R.functionTarget=T;}}if(R.adjustDeepPath){R.deepPath=R.adjustDeepPath({deepPath:W||R.functionTarget,response:m({},i)});}else if(!W){R.deepPath=R.functionTarget;}}if(V&&f1===undefined&&i){this._parseResponse(i,R);L.fatal(this+" - No data was retrieved by service: '"+i.requestUri+"'");g1.fireRequestCompleted({url:i.requestUri,type:"GET",async:i.async,info:"Accept headers:"+this.oHeaders["Accept"],infoObject:{acceptHeaders:this.oHeaders["Accept"]},success:false});return false;}if(f1&&!f1.__metadata&&f1.results&&!Array.isArray(f1.results)){f1=f1.results;}if(!i._imported&&f1&&(Array.isArray(f1)||typeof f1=='object')){$=m({},f1);if(R.key||R.created){g1._importData($,e1,i,undefined,undefined,undefined,i1&&i1.isFunction);}else{g1._importData($,e1,i,a1,R.deepPath,undefined,i1&&i1.isFunction);}i._imported=true;}X=this._getEntity(R.key);if(e1&&X&&X.__metadata.created&&X.__metadata.created.functionImport){var k1=[];var l1=X["$result"];if(l1&&l1.__list){g(e1,function(n1){k1.push(n1);});l1.__list=k1;}else if(l1&&l1.__ref){g(e1,function(n1){l1.__ref=n1;});}}if(!V){_=a1.split("/");if(_[1]){d1[_[1]]=R;var m1={};m1[_[1]]=R.data;this._updateChangedEntities(m1);}if(R.method==="DELETE"&&_[2]!=="$links"){this._removeEntity(_[1]);}}if(V&&R.method==="POST"){Y=this.oMetadata._getEntityTypeByPath(a1);if(Y){n[Y.entityType]=true;}if(R.key){if(R.created){var n1=this._getKey(f1);var o1=this.getContext("/"+R.key);this._updateContext(o1,'/'+n1);W=R.deepPath;if(o1.bCreated&&W.endsWith(")")){R.deepPath=W.slice(0,W.lastIndexOf("("))+n1.slice(n1.indexOf("("));}o1.bCreated=false;o1.setUpdated(true);this.callAfterUpdate(function(){o1.setUpdated(false);});X=this._getEntity(n1);if(X){delete X.__metadata.created;}}this._removeEntity(R.key);}}this._parseResponse(i,R,e1,d1);Q.extend(j,e1);Q.extend(k,d1);this._updateETag(R,i);}if(S){S(f1,i);}var p1=this._createEventInfo(R,i,P);if(N){this.fireBatchRequestCompleted(p1);}else{this.fireRequestCompleted(p1);}return true;};
J.prototype._processError=function(R,i,j,k,n){var P,N=this._handleError(i,R);if(!k){P='/'+this.getKey(R.data);this.decreaseLaundering(P,R.data);this._decreaseDeferredRequestCount(R);}if(j){j(N);}var S=this._createEventInfo(R,N,n);if(k){this.fireBatchRequestCompleted(S);this.fireBatchRequestFailed(S);}else{this.fireRequestCompleted(S);this.fireRequestFailed(S);}};
var K={message:"Request aborted",statusCode:0,statusText:"abort",headers:{},responseText:""};
J.prototype._processAborted=function(R,i,j){var P;if(!j){P='/'+this.getKey(R.data);this.decreaseLaundering(P,R.data);this._decreaseDeferredRequestCount(R);}if(i){var k=this._createEventInfo(R,K);k.success=false;if(j){this.fireBatchRequestCompleted(k);}else{this.fireRequestCompleted(k);}}};
J.prototype._processAfterUpdate=function(){var j=this.aCallAfterUpdate;this.aCallAfterUpdate=[];for(var i=0;i<j.length;i++){j[i]();}};
J.prototype._processChange=function(k,i,j,N){var P,R,S,T,V,W,X,Y,Z,$,_,a1,b1,c1=this;if(N&&this.mChangedEntities[k]&&this.mChangedEntities[k].__metadata){this.mChangedEntities[k].__metadata.deepPath=N;}else if(!N&&this.mChangedEntities[k]&&this.mChangedEntities[k].__metadata&&this.mChangedEntities[k].__metadata.deepPath){N=this.mChangedEntities[k].__metadata.deepPath;}R=this.oMetadata._getEntityTypeByPath(k);if(!j){j="MERGE";}Y=m({},this._getObject('/'+k,true),i);if(i.__metadata&&i.__metadata.created){W=i.__metadata.created.method?i.__metadata.created.method:"POST";k=i.__metadata.created.key;P=true;X=i.__metadata.created;T=i.__metadata.created.expandRequest;b1=i.__metadata.created.withContentID;if(i.__metadata.created.functionImport){X.urlParameters=this._createFunctionImportParameters(i.__metadata.created.key,W,Y);Y=undefined;}else{delete Y.__metadata['uri'];}}else if(j==="MERGE"){W="MERGE";$=this._getEntity(k);}else{W="PUT";}if(Y&&Y.__metadata){for(var n in Y.__metadata){if(n!=='type'&&n!=='uri'&&n!=='etag'&&n!=='content_type'&&n!=='media_src'){delete Y.__metadata[n];}}}if(Y&&R){var d1=this.oMetadata._getNavigationPropertyNames(R);d1.forEach(function(g1){delete Y[g1];});}if(W==="MERGE"&&R&&$){g(Y,function(g1,h1){if(g1!=='__metadata'){if(f($[g1],h1)&&!c1.isLaundering('/'+k+'/'+g1)){delete Y[g1];}}});var e1="/"+k,f1;g(Y,function(g1,h1){if(g1!=='__metadata'){f1=c1.getProperty(e1+"/"+g1+"/#@sap:unit");if(f1){if(Y[f1]===undefined){Y[f1]=$[f1];}}}});}Y=this._removeReferences(Y);a1=X&&X.urlParameters?y._createUrlParamsArray(X.urlParameters):undefined;V=X?this._getHeaders(X.headers):this._getHeaders();S=X&&X.eTag?X.eTag:this.getETag(Y);_=this._createRequestUrl('/'+k,null,a1,this.bUseBatch);Z=this._createRequest(_,N,W,V,Y,S,undefined,true);if(P){Z.created=true;if(T){Z.expandRequest=T;Z.withContentID=b1;}if(i.__metadata.created.functionMetadata){Z.functionTarget=this.oMetadata._getCanonicalPathOfFunctionImport(i.__metadata.created.functionMetadata,X.urlParameters);}}if(this.bUseBatch){Z.requestUri=Z.requestUri.replace(this.sServiceUrl+'/','');}return Z;};
J.prototype._resolveGroup=function(k){var i,j,P,n,N,R;j=this.oMetadata._getEntityTypeByPath(k);R=this._getObject('/'+k);if(R){P=R.__metadata.created;if(P){return{groupId:P.groupId,changeSetId:P.changeSetId};}}if(this.mChangeGroups[j.name]){i=this.mChangeGroups[j.name];n=i.groupId;N=i.single?u():i.changeSetId;}else if(this.mChangeGroups['*']){i=this.mChangeGroups['*'];n=i.groupId;N=i.single?u():i.changeSetId;}return{groupId:n,changeSetId:N};};
J.prototype._updateETag=function(R,i){var j,k,n;j=R.requestUri.replace(this.sServiceUrl+'/','');if(!j.startsWith("/")){j="/"+j;}k=this._getObject(j.split("?")[0]);n=this._getHeader("etag",i.headers);if(k&&k.__metadata&&n){k.__metadata.etag=n;}};
J.prototype._handleError=function(i,R){var j,P={message:i.message},T;if(i.response){if(!i.$reported){this._parseResponse(i.response,R);if(this.bTokenHandling){T=this._getHeader("x-csrf-token",i.response.headers);if(i.response.statusCode=='403'&&T&&T.toLowerCase()==="required"){this.resetSecurityToken();}}j=i.message+" ("+i.response.statusCode+" "+i.response.statusText+"): "+i.response.body;}P.statusCode=i.response.statusCode;P.statusText=i.response.statusText;P.headers=i.response.headers;P.responseText=i.response.body;}else{j="The following problem occurred: "+i.message;}if(!i.$reported){L.error(j,undefined,G);}i.$reported=true;return P;};
J.prototype.getData=function(P,i,j){return this.getProperty(P,i,j);};
J.prototype._getODataHandler=function(i){if(i.indexOf("$batch")>-1){return D.batchHandler;}else if(i.indexOf("$count")>-1){return undefined;}else if(this.bJSON){return D.jsonHandler;}else{return D.atomHandler;}};
J.prototype.getETag=function(P,i,j){if(typeof P=="object"){j=P;P="";}return this._getETag(P,i,j);};
J.prototype._getETag=function(P,i,j){if(!j||!j.__metadata){j=this._getObject(P,i);}if(j&&j.__metadata){return j.__metadata.etag;}return null;};
J.prototype.forceEntityUpdate=function(k){var i=this.mChangedEntities[k];if(i&&i.__metadata){i.__metadata.etag='*';}else{L.error(this+" - Entity with key "+k+" does not exist or has no change");}};
J.prototype._createRequest=function(i,j,k,n,N,P,R,S){R=R!==false;if(P&&k!=="GET"){n["If-Match"]=P;}if(!n["Content-Type"]&&k!=="DELETE"&&k!=="GET"){if(this.bJSON){n["Content-Type"]="application/json";}else{n["Content-Type"]="application/atom+xml";}}if(i.indexOf("$count")>-1){n["Accept"]="text/plain, */*;q=0.5";}if(k==="MERGE"&&!this.bUseBatch){n["x-http-method"]="MERGE";k="POST";}if(this.sMessageScope===s.BusinessObject){if(this.bIsMessageScopeSupported){n["sap-message-scope"]=this.sMessageScope;}else{L.error("Message scope 'sap.ui.model.odata.MessageScope.BusinessObject' is not"+" supported by the service: "+this.sServiceUrl,undefined,G);}}S=S&&this.sMessageScope===s.BusinessObject&&this.bIsMessageScopeSupported;var T={headers:n,requestUri:i,method:k,user:this.sUser,password:this.sPassword,async:R,deepPath:j,updateAggregatedMessages:S};if(N){T.data=N;}if(this.bWithCredentials){T.withCredentials=this.bWithCredentials;}T.requestID=this._createRequestID();return T;};
J.prototype._processRequest=function(P,i,j){var R,k,n=false,N=this;if(this.bWarmup){return{abort:function(){}};}if(j){this.iPendingDeferredRequests++;}R={abort:function(){if(j&&!n){N.iPendingDeferredRequests--;}if(!n&&i){i(K);}if(k){k._aborted=true;if(k._handle){k._handle.abort();}}n=true;}};this.oMetadata.loaded().then(function(){k=P(R);if(k){k.deferred=!!j;}N._processRequestQueueAsync(N.mRequests);if(n){R.abort();}});return R;};
J.prototype.update=function(P,i,j){var S,k,R,n,N,T,V,W,X,Y,Z,$,_,a1,b1,c1=this,d1,e1,f1;if(j){W=j.groupId||j.batchGroupId;X=j.changeSetId;N=j.context;S=j.success;k=j.error;T=j.eTag;Z=j.headers;Y=j.urlParameters;a1=j.refreshAfterChange;f1=j.canonicalRequest;if(j.merge!==undefined){$=j.merge?"MERGE":"PUT";}}f1=this._isCanonicalRequestNeeded(f1);b1=W in c1.mDeferredGroups;a1=this._getRefreshAfterChange(a1,W);V=y._createUrlParamsArray(Y);Z=this._getHeaders(Z);$=$?$:this.sDefaultUpdateMethod;T=T||this._getETag(P,N,i);d1=this._normalizePath(P,N,f1);e1=this.resolveDeep(P,N);return this._processRequest(function(g1){n=c1._createRequestUrlWithNormalizedPath(d1,V,c1.bUseBatch);R=c1._createRequest(n,e1,$,Z,i,T);_=c1.mRequests;if(b1){_=c1.mDeferredRequests;}c1._pushToRequestQueue(_,W,X,R,S,k,g1,a1);return R;},k,b1);};
J.prototype.create=function(P,i,j){var R,k,n,N,S,T,V,W,X,Y,Z,$,_,a1,b1,c1,d1=this,e1,f1,g1;if(j){N=j.context;V=j.urlParameters;S=j.success;T=j.error;$=j.groupId||j.batchGroupId;a1=j.changeSetId;Z=j.eTag;X=j.headers;b1=j.refreshAfterChange;g1=j.canonicalRequest;}g1=this._isCanonicalRequestNeeded(g1);b1=this._getRefreshAfterChange(b1,$);Y=y._createUrlParamsArray(V);X=this._getHeaders(X);_="POST";c1=$ in d1.mDeferredGroups;e1=d1._normalizePath(P,N,g1);f1=this.resolveDeep(P,N);return this._processRequest(function(h1){k=d1._createRequestUrlWithNormalizedPath(e1,Y,d1.bUseBatch);R=d1._createRequest(k,f1,_,X,i,Z);R.created=true;n=d1.oMetadata._getEntityTypeByPath(e1);R.entityTypes={};if(n){R.entityTypes[n.entityType]=true;}W=d1.mRequests;if(c1){W=d1.mDeferredRequests;}d1._pushToRequestQueue(W,$,a1,R,S,T,h1,b1);return R;},T,c1);};
J.prototype.remove=function(P,i){var j,k,S,n,R,N,T,V,W,X,Y,Z,$,_,a1,b1,c1=this,d1,e1,f1=this.bCanonicalRequests;if(i){T=i.groupId||i.batchGroupId;V=i.changeSetId;j=i.context;S=i.success;n=i.error;W=i.eTag;Z=i.headers;Y=i.urlParameters;X=i.refreshAfterChange;f1=i.canonicalRequest;}f1=this._isCanonicalRequestNeeded(f1);X=this._getRefreshAfterChange(X,T);$=y._createUrlParamsArray(Y);Z=this._getHeaders(Z);_="DELETE";W=W||this._getETag(P,j);b1=T in c1.mDeferredGroups;d1=this._normalizePath(P,j,f1);e1=this.resolveDeep(P,j);function g1(h1,i1){k=N.substr(N.lastIndexOf('/')+1);if(k.indexOf('?')!==-1){k=k.substr(0,k.indexOf('?'));}c1._removeEntity(k);if(S){S(h1,i1);}}return this._processRequest(function(h1){N=c1._createRequestUrlWithNormalizedPath(d1,$,c1.bUseBatch);R=c1._createRequest(N,e1,_,Z,undefined,W,undefined,true);a1=c1.mRequests;if(b1){a1=c1.mDeferredRequests;}c1._pushToRequestQueue(a1,T,V,R,g1,n,h1,X);return R;},n,b1);};
J.prototype.callFunction=function(i,P){var j,k,n,N,R,S,T,V,W,X,Y,Z,$,_=this;if(!i.startsWith("/")){L.fatal("callFunction: sFunctionName has to be absolute, but the given '"+i+"' is not absolute",this,G);return undefined;}P=P||{};j=P.changeSetId;n=P.error;N=P.eTag;R=P.groupId||P.batchGroupId;S=P.headers;T=P.method||"GET";V=P.refreshAfterChange;Z=P.success;$=Object.assign({},P.urlParameters);V=this._getRefreshAfterChange(V,R);k=new Promise(function(a1,b1){Y=a1;W=b1;});X=this._processRequest(function(a1){var b1,c1,d1,e1,f1,g1,h1,i1={};c1=_.oMetadata._getFunctionImportMetadata(i,T);if(!c1){L.error("Function '"+i+"' not found in the metadata",_,G);W();return undefined;}if(c1.entitySet||c1.entitySetPath){i1.$result={__list:[]};if(c1.returnType&&!c1.returnType.startsWith("Collection")){i1.$result={__ref:{}};}}if(c1.parameter!=null){c1.parameter.forEach(function(j1){i1[j1.name]=_._createPropertyValue(j1.type);if($[j1.name]!==undefined){i1[j1.name]=$[j1.name];$[j1.name]=y.formatValue($[j1.name],j1.type);}else{L.warning("No value given for parameter '"+j1.name+"' of function import '"+i+"'",_,G);}});}i1.__metadata={uri:_.sServiceUrl+i+"('"+u()+"')",created:{changeSetId:j,error:n,eTag:N,functionImport:true,groupId:R,headers:Object.assign({},S),key:i.substring(1),method:T,success:Z}};d1=_._addEntity(i1);b1=_.getContext("/"+d1);_._writePathCache("/"+d1,"/"+d1);Y(b1);h1=y._createUrlParamsArray($);g1=_._createRequestUrlWithNormalizedPath(i,h1,_.bUseBatch);e1=_._createRequest(g1,i,T,_._getHeaders(S),undefined,N,undefined,true);e1.adjustDeepPath=P.adjustDeepPath;e1.functionMetadata=c1;i1.__metadata.created.functionMetadata=c1;e1.functionTarget=_.oMetadata._getCanonicalPathOfFunctionImport(c1,$);e1.key=d1;f1=_.mRequests;if(R in _.mDeferredGroups){f1=_.mDeferredRequests;}_._pushToRequestQueue(f1,R,j,e1,Z,n,a1,V);return e1;},n);X.contextCreated=function(){return k;};return X;};
J.prototype._createFunctionImportParameters=function(i,j,P){var k=Q.extend(true,{},P);delete k.__metadata;delete k["$result"];var n=this.oMetadata._getFunctionImportMetadata(i,j);d(n,this+": Function "+i+" not found in the metadata !");if(!n){return;}if(n.parameter!=null){g(n.parameter,function(N,R){if(k&&k[R.name]!==undefined){k[R.name]=y.formatValue(k[R.name],R.type);}});}return k;};
J.prototype.read=function(P,i){var j,k,n,N,R,S,T,V,W,X,Y,Z,$,_,a1,b1,c1,d1,e1,f1,g1,h1,i1,j1=this;if(i){_=i.canonicalRequest;a1=i.context;b1=i.error;c1=i.filters;d1=i.groupId||i.batchGroupId;e1=i.headers;f1=i.sorters;g1=i.success;h1=i.updateAggregatedMessages;i1=i.urlParameters;}_=this._isCanonicalRequestNeeded(_);if(this.sRefreshGroupId){d1=this.sRefreshGroupId;}$=y._createUrlParamsArray(i1);e1=this._getHeaders(e1,true);S="GET";n=this._getETag(P,a1);var k1={abort:function(){if(W){W._aborted=true;}}};var l1=P;var m1=P.indexOf("$count");if(m1!==-1){l1=P.substring(0,m1-1);}V=this._normalizePath(l1,a1,_);T=this._normalizePath(P,a1,_);j=this.resolveDeep(P,a1);function n1(o1){Y=y.createSortParams(f1);if(Y){$.push(Y);}k=j1.oMetadata._getEntityTypeByPath(V);N=F.groupFilters(c1);R=y.createFilterParams(N,j1.oMetadata,k);if(R){$.push(R);}Z=j1._createRequestUrlWithNormalizedPath(T,$,j1.bUseBatch);W=j1._createRequest(Z,j,S,e1,null,n,undefined,h1);X=j1.mRequests;if(d1 in j1.mDeferredGroups){X=j1.mDeferredRequests;}j1._pushToRequestQueue(X,d1,null,W,g1,b1,o1,false);return W;}if(this.bUseBatch&&this.bIncludeInCurrentBatch){W=n1(k1);return k1;}else{return this._processRequest(n1,b1);}};
J.prototype.getServiceMetadata=function(){if(this.oMetadata&&this.oMetadata.isLoaded()){return this.oMetadata.getServiceMetadata();}};
J.prototype.metadataLoaded=function(R){var i=this.oMetadata.loaded(R);if(this.bLoadAnnotationsJoined){if(R){return Promise.all([i,this.pAnnotationsLoaded]);}var j=function(){return i;};return this.pAnnotationsLoaded.then(j,j);}else{return i;}};
J.prototype.annotationsLoaded=function(){return this.pAnnotationsLoaded;};
J.prototype.isMetadataLoadingFailed=function(){return this.oMetadata.isFailed();};
J.prototype.getServiceAnnotations=function(){var i=this.oAnnotations.getData();return h(i)?null:i;};
J.prototype.onAnnotationsFailed=function(i){this.fireAnnotationsFailed(i.getParameters());};
J.prototype.onAnnotationsLoaded=function(i){this.fireAnnotationsLoaded(i.getParameters());};
J.prototype.addAnnotationUrl=function(i){var j=[].concat(i),k=[],n=[],N=[],P=this;j.forEach(function(R){var S=R.indexOf("$metadata");if(S>=0){R=P._createMetadataUrl(R);k.push(R);}else{n.push(R);}});return this.oMetadata._addUrl(k).then(function(R){return Promise.all(R.map(function(S){N=N.concat(S.entitySets);return P.oAnnotations.addSource({type:"xml",data:S["metadataString"]});}));}).then(function(){return P.oAnnotations.addSource(n);}).then(function(R){return{annotations:P.oAnnotations.getData(),entitySets:N};});};
J.prototype.addAnnotationXML=function(X,S){return this.oAnnotations.addSource({type:"xml",data:X});};
J.prototype.submitChanges=function(P){var R,j,k,S,n,N,T,V=false,W,X,Y=this.bRefreshAfterChange,Z,$=this;if(P){j=P.groupId||P.batchGroupId;S=P.success;n=P.error;if(P.merge!==undefined){W=P.merge?"MERGE":"PUT";}}if(j&&!this.mDeferredGroups[j]){L.fatal(this+" submitChanges: \""+j+"\" is not a deferred group!");}X=m({},$.mChangedEntities);this.oMetadata.loaded().then(function(){g(X,function(e1,f1){k=$._resolveGroup(e1);if(k.groupId===j||!j){R=$._processChange(e1,f1,W||$.sDefaultUpdateMethod);R.key=e1;Z=f1.__metadata&&f1.__metadata.created?f1.__metadata.created:{};var N={abort:function(){R._aborted=true;}};if(k.groupId in $.mDeferredGroups){$._pushToRequestQueue($.mDeferredRequests,k.groupId,k.changeSetId,R,Z.success,Z.error,N,Y);}}});var _,a1,b1,c1,d1,i;for(_ in $.mDeferredRequests){b1=$.mDeferredRequests[_];for(a1 in b1.changes){c1=b1.changes[a1];for(i=c1.length-1;i>=0;i--){d1=c1[i];if(d1.bRefreshAfterChange===undefined){d1.bRefreshAfterChange=Y;}}}}T=$._processRequestQueue($.mDeferredRequests,j,S,n);if(V){N.abort();}if(Array.isArray(T)&&T.length==0&&S){S({},undefined);}});N={abort:function(){if(T){if(Array.isArray(T)){T.forEach(function(N){N.abort();});}else{T.abort();}}else{V=true;}}};return N;};
J.prototype._updateChangedEntities=function(i){var j=this,R,k,n;function N(P,S,T){g(S,function(V){var W=T+'/'+V;if(l(S[V])&&l(P[V])){N(P[V],S[V],W);if(h(S[V])){delete S[V];}}else if(T.endsWith("__metadata")||f(S[V],P[V])&&!j.isLaundering(W)){delete S[V];if(T===R){k=j.oMetadata._getEntityTypeByPath(R);n=k&&j.oMetadata._getNavPropertyRefInfo(k,V);if(n&&S[n.name]){P[n.name]=S[n.name];delete S[n.name];}}}});}g(i,function(P,S){if(P in j.mChangedEntities){var T=j._getObject('/'+P,null,true);var V=j._getObject('/'+P);m(T,S);R='/'+P;var W=j.removeInternalMetadata(V).deepPath;N(T,V,R);if(h(V)){delete j.mChangedEntities[P];j.abortInternalRequest(j._resolveGroup(P).groupId,{requestKey:P});}else{j.mChangedEntities[P]=V;V.__metadata={deepPath:W};Q.extend(V.__metadata,T.__metadata);}}});};
J.prototype.resetChanges=function(P,j){var k=this,n,N={},R,S;if(j){if(P){P.forEach(function(i){k.oMetadata.loaded().then(function(){g(k.mDeferredGroups,function(T){k.abortInternalRequest(T,{path:i.substring(1)});});});});}else{this.oMetadata.loaded().then(function(){g(k.mDeferredGroups,function(i){k.abortInternalRequest(i);});});}}if(P){g(P,function(T,V){k.getEntityByPath(V,null,N);if(N&&N.propertyPath!==undefined){n=N.propertyPath.split("/");var W=N.key;R=k.mChangedEntities[W];for(var i=0;i<n.length-1;i++){if(R.hasOwnProperty(n[i])){R=R[n[i]];}else{R=undefined;}}if(R){delete R[n[n.length-1]];}if(k.mChangedEntities[W]){S=k.mChangedEntities[W].__metadata;delete k.mChangedEntities[W].__metadata;if(h(k.mChangedEntities[W])||!N.propertyPath){k.oMetadata.loaded().then(function(){k.abortInternalRequest(k._resolveGroup(W).groupId,{requestKey:W});});delete k.mChangedEntities[W];sap.ui.getCore().getMessageManager().removeMessages(k.getMessagesByEntity(W,true));}else{k.mChangedEntities[W].__metadata=S;}}else{L.warning(k+" - resetChanges: "+V+" is not changed");}}});}else{g(this.mChangedEntities,function(i,T){k.oMetadata.loaded().then(function(){k.abortInternalRequest(k._resolveGroup(i).groupId,{requestKey:i});});delete k.mChangedEntities[i];sap.ui.getCore().getMessageManager().removeMessages(k.getMessagesByEntity(i,true));});}this.checkUpdate(true);return this.oMetadata.loaded();};
J.prototype.setProperty=function(P,V,j,k){var n,N,R,S,T,W,X,Y,Z,$,_,a1,b1={},c1={},d1,e1,f1,g1=false,h1=this,i1,j1,k1,l1,m1,n1,o1;function p1(r1,s1){g(s1,function(Z){if(l(s1[Z])&&l(r1[Z])){p1(r1[Z],s1[Z]);if(h(s1[Z])){delete s1[Z];}}else if(f(s1[Z],r1[Z])){delete s1[Z];}});}X=this.resolve(P,j);o1=this.resolveDeep(P,j);W=this.getEntityByPath(X,null,c1);if(!W){return false;}N=X.substring(X.lastIndexOf("/")+1);Z=c1.key;T=this._getObject('/'+Z,null,true);n=this._getObject(P,j,true);if(!this.mChangedEntities[Z]){a1=W.__metadata;W={};W.__metadata=Object.assign({},a1);if(c1.propertyPath.length>0){var q1=o1.lastIndexOf(c1.propertyPath);W.__metadata.deepPath=o1.substring(0,q1-1);}this.mChangedEntities[Z]=W;}e1=this.mChangedEntities[Z];Y=c1.propertyPath.split("/");for(var i=0;i<Y.length-1;i++){if(!e1.hasOwnProperty(Y[i])){e1[Y[i]]={};}e1=e1[Y[i]];}g1=T.__metadata.created&&T.__metadata.created.functionImport;e1[N]=V;j1=this.oMetadata._getEntityTypeByPath(c1.key);k1=j1&&this.oMetadata._getNavPropertyRefInfo(j1,N);l1=k1&&T[k1.name]&&T[k1.name].__ref;if(l1&&k1.keys.length===1){if(V===null){n1=null;}else{m1={};k1.keys.forEach(function(r1){m1[r1]=W[r1]!==undefined?W[r1]:T[r1];});m1[k1.keys[0]]=V;n1=this.createKey(k1.entitySet,m1);}e1[k1.name]={__ref:n1};}if(f(V,n)&&!this.isLaundering('/'+Z)&&!g1){a1=this.mChangedEntities[Z].__metadata;i1=a1&&a1.created;delete this.mChangedEntities[Z].__metadata;if(!i1){p1(T,this.mChangedEntities[Z]);}if(h(this.mChangedEntities[Z])){delete this.mChangedEntities[Z];b1[Z]=true;this.checkUpdate(false,k,b1);h1.oMetadata.loaded().then(function(){h1.abortInternalRequest(h1._resolveGroup(Z).groupId,{requestKey:Z});});return true;}this.mChangedEntities[Z].__metadata=a1;}$=this._resolveGroup(Z);R=this.mRequests;if($.groupId in this.mDeferredGroups){R=this.mDeferredRequests;S=this._processChange(Z,{__metadata:W.__metadata},this.sDefaultUpdateMethod);}else{S=this._processChange(Z,this._getObject('/'+Z),this.sDefaultUpdateMethod);}S.key=Z;d1=e1.__metadata&&e1.__metadata.created?e1.__metadata.created:{};f1=this._getRefreshAfterChange(undefined,$.groupId);this.oMetadata.loaded().then(function(){_={abort:function(){S._aborted=true;}};h1._pushToRequestQueue(R,$.groupId,$.changeSetId,S,d1.success,d1.error,_,f1);h1._processRequestQueueAsync(h1.mRequests);});b1[Z]=true;this.checkUpdate(false,k,b1);return true;};
J.prototype._isHeaderPrivate=function(i){switch(i.toLowerCase()){case"accept":case"accept-language":case"maxdataserviceversion":case"dataserviceversion":return true;case"x-csrf-token":return this.bTokenHandling;case"sap-contextid-accept":case"sap-contextid":return!this.bDisableSoftStateHeader;default:return false;}};
J.prototype.setHeaders=function(i){var j={},k=this;this.mCustomHeaders={};if(i){g(i,function(n,N){if(k._isHeaderPrivate(n)){L.warning(this+" - modifying private header: '"+n+"' not allowed!");}else{j[n]=N;}});this.mCustomHeaders=j;}if(this.oAnnotations){this.oAnnotations.setHeaders(this.mCustomHeaders);}};
J.prototype._getHeaders=function(i,j){var k={},n=this;if(i){g(i,function(N,P){if(n._isHeaderPrivate(N)){L.warning(this+" - modifying private header: '"+N+"' not allowed!");}else{k[N]=P;}});}return Q.extend({'sap-cancel-on-close':!!j},this.mCustomHeaders,k,this.oHeaders);};
J.prototype.getHeaders=function(){return Q.extend({},this.mCustomHeaders,this.oHeaders);};
J.prototype._getHeader=function(i,j){var k;for(k in j){if(k.toLowerCase()===i.toLowerCase()){return j[k];}}return null;};
J.prototype.hasPendingChanges=function(i){var j=!h(this.mChangedEntities);if(i){j=j||this.iPendingDeferredRequests>0;}return j;};
J.prototype.hasPendingRequests=function(){return this.aPendingRequestHandles.length>0;};
J.prototype.getPendingChanges=function(){return m({},this.mChangedEntities);};
J.prototype.updateBindings=function(i){this.checkUpdate(i);};
J.prototype.setTokenHandlingEnabled=function(T){this.bTokenHandling=T;};
J.prototype.setUseBatch=function(i){this.bUseBatch=i;};
J.prototype.formatValue=function(V,T){return y.formatValue(V,T);};
J.prototype.deleteCreatedEntry=function(i){var j=this,k,n;if(i){var k=i.getPath().substr(1);n=this._resolveGroup(k).groupId;j.oMetadata.loaded().then(function(){j.abortInternalRequest(n,{requestKey:k});});j._removeEntity(k);sap.ui.getCore().getMessageManager().removeMessages(this.getMessagesByEntity(i.getPath(),true));}};
J.prototype.createEntry=function(P,j){var k,n,N,R,S,T,V,W,X,Y,Z,$,_,a1,b1,c1,d1,e1,f1,g1,h1={},i1="POST",j1=this;if(j){_=j.properties;X=j.groupId||j.batchGroupId;n=j.changeSetId;N=j.context;d1=j.success;T=j.error;R=j.created;V=j.eTag;Y=j.headers;g1=j.urlParameters;a1=j.refreshAfterChange;k=j.canonicalRequest;W=j.expand;}if(W&&!this.bUseBatch){throw new Error("The 'expand' parameter is only supported if batch mode is used");}k=this._isCanonicalRequestNeeded(k);Y=Y||{};a1=this._getRefreshAfterChange(a1,X);X=X?X:this.sDefaultChangeGroup;f1=y._createUrlParamsArray(g1);var k1={abort:function(){if(b1){b1._aborted=true;if(b1.expandRequest){b1.expandRequest._aborted=true;}}}};if(!P.startsWith("/")&&!N){P="/"+P;}$=j1._normalizePath(P,N,k);S=j1.resolveDeep(P,N);function l1(){var m1,n1,o1,p1,q1,r1,s1=false,t1=T,u1=d1;var v1=j1.oMetadata._getEntityTypeByPath($);if(!v1){d(v1,"No Metadata for collection "+$+" found");return undefined;}if(typeof _==="object"&&!Array.isArray(_)){h1=m({},_);}else{for(var i=0;i<v1.property.length;i++){var w1=v1.property[i];var x1=(_?_.indexOf(w1.name):-1)>-1;if(!_||x1){h1[w1.name]=j1._createPropertyValue(w1.type);if(x1){_.splice(_.indexOf(w1.name),1);}}}if(_){d(_.length===0,"No metadata for the following properties found: "+_.join(","));}}p1=j1.oMetadata._getEntitySetByType(v1);r1=u();Z=p1.name+"('"+r1+"')";if(S&&j1.oMetadata._isCollection(S)){S=S+"('"+r1+"')";}if(W){Y=Object.assign({},Y,{"Content-ID":r1,"sap-messages":"transientOnly"});d1=function(y1,z1){if(!m1){m1=y1;o1=z1;return;}if(u1){y1=Object.assign({},m1,y1);u1(y1,o1);}};T=function(y1){if(m1){o1.expandAfterCreateFailed=true;y1.expandAfterCreateFailed=true;L.error("Entity creation was successful but expansion of navigation"+" properties failed",y1,G);if(u1){u1(m1,o1);}return;}if(!s1){s1=true;if(t1){t1(y1);}}else{y1.expandAfterCreateFailed=true;s1=false;}};}h1.__metadata={type:""+v1.entityType,uri:j1.sServiceUrl+'/'+Z,created:{key:$.substring(1),success:d1,error:T,headers:Y,urlParameters:g1,groupId:X,changeSetId:n,eTag:V},deepPath:S};Z=j1._addEntity(m({},h1));j1.mChangedEntities[Z]=h1;e1=j1._createRequestUrlWithNormalizedPath($,f1,j1.bUseBatch);b1=j1._createRequest(e1,S,i1,Y,h1,V);if(W){q1=j1._createRequest("$"+r1+"?"+y._encodeURLParameters({$expand:W,$select:W}),"/$"+r1,"GET",j1._getHeaders(undefined,true),null,undefined,undefined,true);q1.withContentID=r1;b1.expandRequest=q1;b1.withContentID=r1;h1.__metadata.created.expandRequest=q1;h1.__metadata.created.withContentID=r1;}n1=j1.getContext("/"+Z,S);n1.bCreated=true;b1.key=Z;b1.created=true;c1=j1.mRequests;if(X in j1.mDeferredGroups){c1=j1.mDeferredRequests;}j1.oMetadata.loaded().then(function(){j1._pushToRequestQueue(c1,X,n,b1,d1,T,k1,a1);j1._processRequestQueueAsync(j1.mRequests);});return n1;}if(R){this.oMetadata.loaded().then(function(){R(l1());});}else if(this.oMetadata.isLoaded()){return l1();}else{L.error("Tried to use createEntry without created-callback, before metadata is available!");}};
J.prototype._isCreatedEntity=function(i){return!!(i&&i.__metadata&&i.__metadata.created);};
J.prototype._createPropertyValue=function(T){var j=this.oMetadata._splitName(T);var n=j.namespace;var k=j.name;if(n.toUpperCase()!=='EDM'){var N={};var P=this.oMetadata._getObjectMetadata("complexType",k,n);d(P,"Complex type "+T+" not found in the metadata !");for(var i=0;i<P.property.length;i++){var R=P.property[i];N[R.name]=this._createPropertyValue(R.type);}return N;}else{return this._getDefaultPropertyValue(k,n);}};
J.prototype._getDefaultPropertyValue=function(T,n){return undefined;};
J.prototype._normalizePath=function(P,i,j){if(P&&P.indexOf('?')!==-1){P=P.substr(0,P.indexOf('?'));}if(!i&&!P.startsWith("/")){L.fatal(this+" path "+P+" must be absolute if no Context is set");}return this.resolve(P,i,j)||this.resolve(P,i);};
J.prototype.getRefreshAfterChange=function(){return this.bRefreshAfterChange;};
J.prototype.setRefreshAfterChange=function(R){this.bRefreshAfterChange=R;};
J.prototype.isList=function(P,i){P=this.resolve(P,i);return P&&P.substr(P.lastIndexOf("/")).indexOf("(")===-1;};
J.prototype._isMetadataPath=function(P){var i=false;if(P&&P.indexOf('/#')>-1){i=true;}return i;};
J.prototype.isMetaModelPath=function(P){return P.indexOf("##")==0||P.indexOf("/##")>-1;};
J.prototype._request=function(R,S,i,j,k,n){var N;if(this.bDestroyed){return{abort:function(){}};}var P=this;function T(V){return function(){if(P.aPendingRequestHandles){var W=P.aPendingRequestHandles.indexOf(N);if(W>-1){P.aPendingRequestHandles.splice(W,1);}}if(!(N&&N.bSuppressErrorHandlerCall)){V.apply(this,arguments);}};}N=D.request(R,T(S||D.defaultSuccess),T(i||D.defaultError),j,k,n);if(R.async!==false){this.aPendingRequestHandles.push(N);}return N;};
J.prototype.destroy=function(){this.bDestroyed=true;q.prototype.destroy.apply(this,arguments);if(this.aPendingRequestHandles){for(var i=this.aPendingRequestHandles.length-1;i>=0;i--){var R=this.aPendingRequestHandles[i];if(R&&R.abort){R.bSuppressErrorHandlerCall=true;R.abort();}}delete this.aPendingRequestHandles;}if(this.sMetadataLoadEvent){clearTimeout(this.sMetadataLoadEvent);}if(this.oMetadataFailedEvent){clearTimeout(this.oMetadataFailedEvent);}if(this.oMetadata){this.oMetadata.detachFailed(this.onMetadataFailed);if(!this.oMetadata.isLoaded()&&!this.oMetadata.hasListeners("loaded")){this.oMetadata.destroy();delete this.oSharedMetaData.oMetadata;}delete this.oMetadata;delete this.pMetadataLoaded;}if(this.oMetaModel){this.oMetaModel.destroy();delete this.oMetaModel;}if(this.oAnnotations){this.oAnnotations.detachSomeLoaded(this.onAnnotationsLoaded);this.oAnnotations.detachAllFailed(this.onAnnotationsFailed);this.oAnnotations.destroy();delete this.oAnnotations;delete this.pAnnotationsLoaded;}};
J.prototype.setDeferredBatchGroups=function(i){this.setDeferredGroups(i);};
J.prototype.setDeferredGroups=function(i){var j=this;this.mDeferredGroups={};g(i,function(k,n){j.mDeferredGroups[n]=n;});};
J.prototype.getDeferredBatchGroups=function(){return this.getDeferredGroups();};
J.prototype.getDeferredGroups=function(){return Object.keys(this.mDeferredGroups);};
J.prototype.setChangeBatchGroups=function(i){g(i,function(j,k){k.groupId=k.batchGroupId;});this.setChangeGroups(i);};
J.prototype.setChangeGroups=function(i){this.mChangeGroups=i;};
J.prototype.getChangeBatchGroups=function(){return this.getChangeGroups();};
J.prototype.getChangeGroups=function(){return this.mChangeGroups;};
J.prototype.setMessageParser=function(P){if(!(P instanceof p)){L.error("Given MessageParser is not of type sap.ui.core.message.MessageParser");return this;}P.setProcessor(this);this.oMessageParser=P;return this;};
J.prototype._parseResponse=function(R,i,j,k){try{if(!this.oMessageParser){this.oMessageParser=new w(this.sServiceUrl,this.oMetadata);this.oMessageParser.setProcessor(this);}this.oMessageParser.parse(R,i,j,k,this.bIsMessageScopeSupported);}catch(n){L.error("Error parsing OData messages: "+n);}};
J.prototype.callAfterUpdate=function(i){this.aCallAfterUpdate.push(i);};
J.prototype.getMetaModel=function(){var i=this;if(!this.oMetaModel){this.oMetaModel=new v(this.oMetadata,this.oAnnotations,{addAnnotationUrl:this.addAnnotationUrl.bind(this),annotationsLoadedPromise:this.pAnnotationsLoaded});this.oMetaModel.loaded().then(function(){i.bMetaModelLoaded=true;i.checkUpdate(false,false,null,true);},function(j){var k=j.message,n;if(!k&&j.xmlDoc&&j.xmlDoc.parseError){k=j.xmlDoc.parseError.reason;n=j.xmlDoc.parseError.srcText;}L.error("error in ODataMetaModel.loaded(): "+k,n,G);});}return this.oMetaModel;};
J.prototype.getOriginalProperty=function(P,i){return this._getObject(P,i,true);};
J.prototype.getEntityByPath=function(P,i,j){var R=q.prototype.resolve.call(this,P,i);if(!R){return null;}var k=R.split("/"),n=null,N=[];while(k.length>0){var S=k.join("/"),T=this._getObject(S);if(l(T)){var V=this._getKey(T);if(V){n=T;break;}}N.unshift(k.pop());}if(n){j.propertyPath=N.join("/");j.key=V;return n;}return null;};
J.prototype.resolveFromCache=function(P){if(!this.mPathCache){return undefined;}var S,i="",j,n,k;j=this.mPathCache[P]?this.mPathCache[P].canonicalPath:undefined;if(P&&j!==P){S=j||P;if(!j){k=S.lastIndexOf("/");i=S.substr(k);S=S.substr(0,k);}n=this.resolveFromCache(S);if(n&&n!==S){j=n+i;}}return j;};
J.prototype.resolve=function(P,i,j){var R=q.prototype.resolve.call(this,P,i);if(R&&!this._isMetadataPath(R)&&j){var k=this.resolveFromCache(R);if(!k){k=this.oMetadata._calculateCanonicalPath(R);k=this.resolveFromCache(k)||k;}this._writePathCache(R,k);return k;}return R;};
J.prototype.resolveDeep=function(P,i){var R=q.prototype.resolve.call(this,P,i);if(P&&!P.startsWith("/")){R=i?i.sDeepPath+'/'+P:R;}if(P===""){R=i?i.sDeepPath:R;}return R;};
J.prototype.isLaundering=function(P,i){var R=this.resolve(P,i);return(R in this.mLaunderingState)&&this.mLaunderingState[R]>0;};
J.prototype.increaseLaundering=function(P,i){if(!i){return;}for(var n in i){if(n==="__metadata"){continue;}var j=i[n];if(l(j)){this.increaseLaundering(P+"/"+n,j);}else{var T=P+"/"+n;if(!(T in this.mLaunderingState)){this.mLaunderingState[T]=0;}this.mLaunderingState[T]++;}}if(!(P in this.mLaunderingState)){this.mLaunderingState[P]=0;}this.mLaunderingState[P]++;};
J.prototype.decreaseLaundering=function(P,i){if(!i){return;}for(var n in i){if(n==="__metadata"){continue;}var j=i[n],T=P+"/"+n;if(l(j)){this.decreaseLaundering(T,j);}else{if(T in this.mLaunderingState){this.mLaunderingState[T]--;if(this.mLaunderingState[T]===0){delete this.mLaunderingState[T];}}}}this.mLaunderingState[P]--;if(this.mLaunderingState[P]===0){delete this.mLaunderingState[P];}};
J.prototype._getRefreshAfterChange=function(R,i){if(R===undefined&&!(i in this.mDeferredGroups)){return this.bRefreshAfterChange;}return R;};
J.prototype.getMessagesByEntity=function(j,k){var n=j,N=[],P;function R(N){var S=[];for(var i=0;i<N.length;i++){if(!k||(k&&!N[i].persistent)){S.push(N[i]);}}return S;}if(!n.startsWith('/')){n='/'+n;}if(this.mMessages){for(P in this.mMessages){if(typeof n=="string"&&n.length>0&&P.startsWith(n)){N=N.concat(R(this.mMessages[P]));}}return N;}return null;};
J.prototype._cacheSupported=function(i){var j=/\/~[\w\-]+~[A-Z0-9]?/;var k=[i];if(this.sAnnotationURI){if(!Array.isArray(this.sAnnotationURI)){this.sAnnotationURI=[this.sAnnotationURI];}k=k.concat(this.sAnnotationURI);}k=k.filter(function(n){return n.indexOf("sap-context-token")===-1;});k=k.filter(function(n){return!j.test(n);});return k.length===0?true:false;};
J.prototype._getAnnotationCacheKey=function(i){var j;if(this.bUseCache){if(!this.bSkipMetadataAnnotationParsing){j=i+"#annotations";}if(this.sAnnotationURI){if(!Array.isArray(this.sAnnotationURI)){this.sAnnotationURI=[this.sAnnotationURI];}this.sAnnotationURI=this.sAnnotationURI.map(function(k){return k+"#annotations";});j=this.bSkipMetadataAnnotationParsing?this.sAnnotationURI.join("_"):j+"_"+this.sAnnotationURI.join("_");}}return j;};
J.prototype.canonicalRequestsEnabled=function(){return this.bCanonicalRequests;};
J.prototype._decreaseDeferredRequestCount=function(R){if(R.deferred){this.iPendingDeferredRequests--;}};
J.prototype.enableCanonicalRequests=function(i){this.bCanonicalRequests=!!i;};
J.prototype.getMessageScope=function(){return this.sMessageScope;};
J.prototype.setMessageScope=function(i){if(i!==s.RequestedObjects&&i!==s.BusinessObject){throw new Error("Unsupported message scope: "+i);}this.sMessageScope=i;};
J.prototype.messageScopeSupported=function(){var i=this;return this.metadataLoaded().then(function(){return i.bIsMessageScopeSupported;});};
J.prototype.getContext=function(P,i){var j=q.prototype.getContext.apply(this,arguments);if(i){j.sDeepPath=i;}else if(!i&&!j.sDeepPath){j.sDeepPath=P;}return j;};
J.prototype.hasContext=function(P){return this.mContexts[P];};
J.prototype.removeInternalMetadata=function(i){var j,k,n,V;if(i&&i.__metadata){j=i.__metadata.created;k=i.__metadata.deepPath;delete i.__metadata.created;delete i.__metadata.deepPath;}for(n in i){V=i[n];if(Array.isArray(V)){V.forEach(J.prototype.removeInternalMetadata);}else if(typeof V==="object"){J.prototype.removeInternalMetadata(V);}}return{created:j,deepPath:k};};
J.prototype._isCanonicalRequestNeeded=function(i){if(i!==undefined){return!!i;}else{return!!this.bCanonicalRequests;}};
J.prototype.filterMatchingMessages=function(i,P){var j=this;return this.mMessages[i].filter(function(k){return j.isMessageMatching(k,P);});};
J.prototype.isMessageMatching=function(i,P){var j=P.length;return i.aFullTargets.some(function(k){return k===P||k.startsWith(P)&&(P==="/"||k[j]==="/"||k[j]==="(");});};
J.prototype.getMessages=function(i){return this.getMessagesByPath(i.sDeepPath,true).sort(M.compare);};
J.prototype.getDeepPathForCanonicalPath=function(j){var k,N,P,R,S,i,n,T=j.slice(j.indexOf("("));S=this.aBindings.filter(function(V){return(V instanceof a||V instanceof b)&&V.isResolved();});for(i=0,n=S.length;i<n;i+=1){k=S[i];P=this.resolveDeep(k instanceof b?k.sPath+T:k.sPath,k.oContext);N=this.resolveFromCache(P);if(N===j){if(R&&R!==P){return undefined;}R=P;}}return R;};
return J;});
sap.ui.predefine('sap/ui/model/odata/v2/ODataTreeBinding',['sap/ui/model/TreeBinding','sap/ui/model/odata/CountMode','sap/ui/model/ChangeReason','sap/ui/model/Filter','sap/ui/model/Sorter','sap/ui/model/odata/ODataUtils','sap/ui/model/TreeBindingUtils','sap/ui/model/odata/OperationMode','sap/ui/model/SorterProcessor','sap/ui/model/FilterProcessor','sap/ui/model/FilterType','sap/ui/model/Context',"sap/base/Log","sap/base/assert","sap/ui/thirdparty/jquery","sap/base/util/isEmptyObject"],function(T,C,a,F,S,O,b,c,d,e,f,g,L,h,q,l){"use strict";
var m=T.extend("sap.ui.model.odata.v2.ODataTreeBinding",{constructor:function(M,p,o,A,P,s){T.apply(this,arguments);this.mParameters=this.mParameters||P||{};this.sGroupId;this.sRefreshGroupId;this.oFinalLengths={};this.oLengths={};this.oKeys={};this.bNeedsUpdate=false;this._bRootMissing=false;this.aSorters=s||[];this.sFilterParams="";this.mNormalizeCache={};if(A instanceof F){A=[A];}this.aApplicationFilters=A;this.oModel.checkFilterOperation(this.aApplicationFilters);this.mRequestHandles={};this.oRootContext=null;this.iNumberOfExpandedLevels=(P&&P.numberOfExpandedLevels)||0;this.iRootLevel=(P&&P.rootLevel)||0;this.sCountMode=(P&&P.countMode)||this.oModel.sDefaultCountMode;if(this.sCountMode==C.None){L.fatal("To use an ODataTreeBinding at least one CountMode must be supported by the service!");}if(P){this.sGroupId=P.groupId||P.batchGroupId;}this.bInitial=true;this._mLoadedSections={};this._iPageSize=0;this.sOperationMode=(P&&P.operationMode)||this.oModel.sDefaultOperationMode;if(this.sOperationMode===c.Default){this.sOperationMode=c.Server;}this.bClientOperation=false;switch(this.sOperationMode){case c.Server:this.bClientOperation=false;break;case c.Client:this.bClientOperation=true;break;case c.Auto:this.bClientOperation=false;break;}this.iThreshold=(P&&P.threshold)||0;this.bThresholdRejected=false;this.iTotalCollectionCount=null;this.bUseServersideApplicationFilters=(P&&P.useServersideApplicationFilters)||false;this.oAllKeys=null;this.oAllLengths=null;this.oAllFinalLengths=null;}});
m.DRILLSTATES={Collapsed:"collapsed",Expanded:"expanded",Leaf:"leaf"};
m.prototype._getNodeFilterParams=function(p){var P=p.isRoot?this.oTreeProperties["hierarchy-node-for"]:this.oTreeProperties["hierarchy-parent-node-for"];var E=this._getEntityType();return O._createFilterParams(new F(P,"EQ",p.id),this.oModel.oMetadata,E);};
m.prototype._getLevelFilterParams=function(o,i){var E=this._getEntityType();return O._createFilterParams(new F(this.oTreeProperties["hierarchy-level-for"],o,i),this.oModel.oMetadata,E);};
m.prototype._loadSingleRootNodeByNavigationProperties=function(n,r){var t=this,G;if(this.mRequestHandles[r]){this.mRequestHandles[r].abort();}G=this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId;var A=this.oModel.resolve(this.getPath(),this.getContext());if(A){this.mRequestHandles[r]=this.oModel.read(A,{groupId:G,success:function(D){var N=t._getNavPath(t.getPath());if(D){var E=D;var k=t.oModel._getKey(E);var o=t.oModel.getContext('/'+k);t.oRootContext=o;t._processODataObject(o.getObject(),n,N);}else{t._bRootMissing=true;}t.bNeedsUpdate=true;delete t.mRequestHandles[r];t.oModel.callAfterUpdate(function(){t.fireDataReceived({data:D});});},error:function(E){if(E&&E.statusCode!=0&&E.statusText!="abort"){t.bNeedsUpdate=true;t._bRootMissing=true;delete t.mRequestHandles[r];t.fireDataReceived();}}});}};
m.prototype.getRootContexts=function(s,i,t){var n=null,r={numberOfExpandedLevels:this.iNumberOfExpandedLevels},R=[];if(this.isInitial()){return R;}s=s||0;i=i||this.oModel.sizeLimit;t=t||0;var j=""+n+"-"+s+"-"+this._iPageSize+"-"+t;if(this.bHasTreeAnnotations){this.bDisplayRootNode=true;R=this._getContextsForNodeId(null,s,i,t);}else{n=this.oModel.resolve(this.getPath(),this.getContext());var I=this.oModel.isList(this.sPath,this.getContext());if(I){this.bDisplayRootNode=true;}if(this.bDisplayRootNode&&!I){if(this.oRootContext){return[this.oRootContext];}else if(this._bRootMissing){return[];}else{this._loadSingleRootNodeByNavigationProperties(n,j);}}else{r.navPath=this._getNavPath(this.getPath());if(!this.bDisplayRootNode){n+="/"+r.navPath;}R=this._getContextsForNodeId(n,s,i,t,r);}}return R;};
m.prototype.getNodeContexts=function(o,s,i,t){var n,r={};if(this.isInitial()){return[];}if(this.bHasTreeAnnotations){n=this.oModel.getKey(o);r.level=parseInt(o.getProperty(this.oTreeProperties["hierarchy-level-for"]))+1;}else{var N=this._getNavPath(o.getPath());if(!N){return[];}n=this.oModel.resolve(N,o);r.navPath=this.oNavigationPaths[N];}return this._getContextsForNodeId(n,s,i,t,r);};
m.prototype.hasChildren=function(o){if(this.bHasTreeAnnotations){if(!o){return false;}var D=o.getProperty(this.oTreeProperties["hierarchy-drill-state-for"]);var n=this.oModel.getKey(o);var i=this.oLengths[n];if(i===0&&this.oFinalLengths[n]){return false;}if(D==="expanded"||D==="collapsed"){return true;}else if(D==="leaf"){return false;}else{L.warning("The entity '"+o.getPath()+"' has not specified Drilldown State property value.");if(D===undefined||D===""){return true;}return false;}}else{if(!o){return this.oLengths[this.getPath()]>0;}var i=this.oLengths[o.getPath()+"/"+this._getNavPath(o.getPath())];return i!==0;}};
m.prototype.getChildCount=function(o){if(this.bHasTreeAnnotations){var H;if(!o){H=null;}else{H=this.oModel.getKey(o);}return this.oLengths[H];}else{if(!o){if(!this.bDisplayRootNode){return this.oLengths[this.getPath()+"/"+this._getNavPath(this.getPath())];}else{return this.oLengths[this.getPath()];}}return this.oLengths[o.getPath()+"/"+this._getNavPath(o.getPath())];}};
m.prototype._getContextsForNodeId=function(n,s,j,t,r){var k=[],K;if(this.sOperationMode==c.Auto){if(this.iTotalCollectionCount==null){if(!this.bCollectionCountRequested){this._getCountForCollection();this.bCollectionCountRequested=true;}return[];}}s=s||0;j=j||this.oModel.iSizeLimit;t=t||0;if(this.sOperationMode==c.Auto){if(this.iThreshold>=0){t=Math.max(this.iThreshold,t);}}if(!this._mLoadedSections[n]){this._mLoadedSections[n]=[];}if(this.oFinalLengths[n]&&this.oLengths[n]<s+j){j=Math.max(this.oLengths[n]-s,0);}var o=this;var p=function(s){for(var i=0;i<o._mLoadedSections[n].length;i++){var I=o._mLoadedSections[n][i];if(s>=I.startIndex&&s<I.startIndex+I.length){return true;}}};var M=[];var i=Math.max((s-t-this._iPageSize),0);if(this.oKeys[n]){var u=s+j+(t);if(this.oLengths[n]){u=Math.min(u,this.oLengths[n]);}for(i;i<u;i++){K=this.oKeys[n][i];if(!K){if(!this.bClientOperation&&!p(i)){M=b.mergeSections(M,{startIndex:i,length:1});}}if(i>=s&&i<s+j){if(K){k.push(this.oModel.getContext('/'+K));}else{k.push(undefined);}}}var B=Math.max((s-t-this._iPageSize),0);var E=s+j+(t);var v=M[0]&&M[0].startIndex===B&&M[0].startIndex+M[0].length===E;if(M.length>0&&!v){i=Math.max((M[0].startIndex-t-this._iPageSize),0);var w=M[0].startIndex;for(i;i<w;i++){var K=this.oKeys[n][i];if(!K){if(!p(i)){M=b.mergeSections(M,{startIndex:i,length:1});}}}i=M[M.length-1].startIndex+M[M.length-1].length;var x=i+t+this._iPageSize;if(this.oLengths[n]){x=Math.min(x,this.oLengths[n]);}for(i;i<x;i++){var K=this.oKeys[n][i];if(!K){if(!p(i)){M=b.mergeSections(M,{startIndex:i,length:1});}}}}}else{if(!p(s)){var y=s-i;M=b.mergeSections(M,{startIndex:i,length:j+y+t});}}if(this.oModel.getServiceMetadata()){if(M.length>0){var P=[];var z="";if(this.bHasTreeAnnotations){if(this.sOperationMode=="Server"||this.bUseServersideApplicationFilters){z=this.getFilterParams();}if(n){z=z?"%20and%20"+z:"";var N=this.oModel.getContext("/"+n);var A=N.getProperty(this.oTreeProperties["hierarchy-node-for"]);var D=this._getNodeFilterParams({id:A});P.push("$filter="+D+z);}else if(n==null){var G="";if(!this.bClientOperation||this.iRootLevel>0){var H=this.bClientOperation?"GE":"EQ";G=this._getLevelFilterParams(H,this.iRootLevel);}if(G||z){if(z&&G){z="%20and%20"+z;}P.push("$filter="+G+z);}}}else{z=this.getFilterParams();if(z){P.push("$filter="+z);}}if(this.sCustomParams){P.push(this.sCustomParams);}if(!this.bClientOperation){for(i=0;i<M.length;i++){var R=M[i];this._mLoadedSections[n]=b.mergeSections(this._mLoadedSections[n],{startIndex:R.startIndex,length:R.length});this._loadSubNodes(n,R.startIndex,R.length,0,P,r,R);}}else{if(!this.oAllKeys&&!this.mRequestHandles[m.REQUEST_KEY_CLIENT]){this._loadCompleteTreeWithAnnotations(P);}}}}return k;};
m.prototype._getCountForCollection=function(){if(!this.bHasTreeAnnotations||this.sOperationMode!=c.Auto){L.error("The Count for the collection can only be retrieved with Hierarchy Annotations and in OperationMode.Auto.");return;}var p=[];function _(D){var n=D.__count?parseInt(D.__count):parseInt(D);this.iTotalCollectionCount=n;if(this.sOperationMode==c.Auto){if(this.iTotalCollectionCount<=this.iThreshold){this.bClientOperation=true;this.bThresholdRejected=false;}else{this.bClientOperation=false;this.bThresholdRejected=true;}this._fireChange({reason:a.Change});}}function i(E){if(E&&E.statusCode===0&&E.statusText==="abort"){return;}var n="Request for $count failed: "+E.message;if(E.response){n+=", "+E.response.statusCode+", "+E.response.statusText+", "+E.response.body;}L.warning(n);}var A=this.oModel.resolve(this.getPath(),this.getContext());var s="";if(this.iRootLevel>0){s=this._getLevelFilterParams("GE",this.getRootLevel());}var j="";if(this.bUseServersideApplicationFilters){var j=this.getFilterParams();}if(s||j){if(j&&s){j="%20and%20"+j;}p.push("$filter="+s+j);}var k="";if(this.sCountMode==C.Request||this.sCountMode==C.Both){k="/$count";}else if(this.sCountMode==C.Inline||this.sCountMode==C.InlineRepeat){p.push("$top=0");p.push("$inlinecount=allpages");}if(A){this.oModel.read(A+k,{urlParameters:p,success:_.bind(this),error:i.bind(this),groupId:this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId});}};
m.prototype._getCountForNodeId=function(n,s,i,t,p){var j=this,G;var P=[];function _(D){j.oFinalLengths[n]=true;j.oLengths[n]=parseInt(D);}function k(E){if(E&&E.statusCode===0&&E.statusText==="abort"){return;}var v="Request for $count failed: "+E.message;if(E.response){v+=", "+E.response.statusCode+", "+E.response.statusText+", "+E.response.body;}L.warning(v);}var A;var o=this.getFilterParams()||"";var N="";if(this.bHasTreeAnnotations){var r=this.oModel.getContext("/"+n);var H=r.getProperty(this.oTreeProperties["hierarchy-node-for"]);A=this.oModel.resolve(this.getPath(),this.getContext());if(n!=null){N=this._getNodeFilterParams({id:H});}else{N=this._getLevelFilterParams("EQ",this.getRootLevel());}}else{A=n;}if(N||o){var u="";if(N&&o){u="%20and%20";}o="$filter="+o+u+N;P.push(o);}if(A){G=this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId;this.oModel.read(A+"/$count",{urlParameters:P,success:_,error:k,sorters:this.aSorters,groupId:G});}};
m.prototype._getParentMap=function(D){var p={};for(var i=0;i<D.length;i++){var I=D[i][this.oTreeProperties["hierarchy-node-for"]];if(p[I]){L.warning("ODataTreeBinding: Duplicate key: "+I+"!");}p[I]=this.oModel._getKey(D[i]);}return p;};
m.prototype._createKeyMap=function(D,s){if(D&&D.length>0){var p=this._getParentMap(D),k={};for(var i=s?1:0;i<D.length;i++){var P=D[i][this.oTreeProperties["hierarchy-parent-node-for"]],j=p[P];if(parseInt(D[i][this.oTreeProperties["hierarchy-level-for"]])===this.iRootLevel){j="null";}if(!k[j]){k[j]=[];}k[j].push(this.oModel._getKey(D[i]));}return k;}};
m.prototype._importCompleteKeysHierarchy=function(k){var i,K;for(K in k){i=k[K].length||0;this.oKeys[K]=k[K];this.oLengths[K]=i;this.oFinalLengths[K]=true;this._mLoadedSections[K]=[{startIndex:0,length:i}];}};
m.prototype._updateNodeKey=function(n,N){var o=this.oModel.getKey(n.context),p,i;if(parseInt(n.context.getProperty(this.oTreeProperties["hierarchy-level-for"]))===this.iRootLevel){p="null";}else{p=this.oModel.getKey(n.parent.context);}i=this.oKeys[p].indexOf(o);if(i!==-1){this.oKeys[p][i]=N;}else{this.oKeys[p].push(N);}};
m.prototype._loadSubTree=function(n,p){return new Promise(function(r,i){var R,G,A;if(!this.bHasTreeAnnotations){i(new Error("_loadSubTree: doesn't support hierarchies without tree annotations"));return;}R="loadSubTree-"+p.join("-");if(this.mRequestHandles[R]){this.mRequestHandles[R].abort();}var s=function(D){if(D.results.length>0){var P=this.oModel.getKey(D.results[0]);this._updateNodeKey(n,P);var k=this._createKeyMap(D.results);this._importCompleteKeysHierarchy(k);}delete this.mRequestHandles[R];this.bNeedsUpdate=true;this.oModel.callAfterUpdate(function(){this.fireDataReceived({data:D});}.bind(this));r(D);}.bind(this);var E=function(o){this.fireDataReceived();if(o&&o.statusCode===0&&o.statusText==="abort"){return;}delete this.mRequestHandles[R];i();}.bind(this);this.fireDataRequested();A=this.oModel.resolve(this.getPath(),this.getContext());if(A){G=this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId;this.mRequestHandles[R]=this.oModel.read(A,{urlParameters:p,success:s,error:E,sorters:this.aSorters,groupId:G});}}.bind(this));};
m.prototype._loadSubNodes=function(n,s,j,t,p,P,r){var k=this,G,I=false;if((s||j)&&!this.bClientOperation){p.push("$skip="+s+"&$top="+(j+t));}if(!this.oFinalLengths[n]||this.sCountMode==C.InlineRepeat){if(this.sCountMode==C.Inline||this.sCountMode==C.InlineRepeat||this.sCountMode==C.Both){p.push("$inlinecount=allpages");I=true;}else if(this.sCountMode==C.Request){k._getCountForNodeId(n);}}var R=""+n+"-"+s+"-"+this._iPageSize+"-"+t;function o(D){if(D){k.oKeys[n]=k.oKeys[n]||[];if(I&&D.__count>=0){k.oLengths[n]=parseInt(D.__count);k.oFinalLengths[n]=true;}}if(Array.isArray(D.results)&&D.results.length>0){if(k.bHasTreeAnnotations){var u={};for(var i=0;i<D.results.length;i++){var v=D.results[i];if(i==0){u[n]=s;}else if(u[n]==undefined){u[n]=0;}k.oKeys[n][u[n]]=k.oModel._getKey(v);u[n]++;}}else{for(var i=0;i<D.results.length;i++){var v=D.results[i];var K=k.oModel._getKey(v);k._processODataObject(v,"/"+K,P.navPath);k.oKeys[n][i+s]=K;}}}else if(D&&!Array.isArray(D.results)){k.oKeys[null]=k.oModel._getKey(D);if(!k.bHasTreeAnnotations){k._processODataObject(D,n,P.navPath);}}delete k.mRequestHandles[R];k.bNeedsUpdate=true;k.oModel.callAfterUpdate(function(){k.fireDataReceived({data:D});});}function E(u){k.fireDataReceived();if(u&&u.statusCode===0&&u.statusText==="abort"){return;}delete k.mRequestHandles[R];if(r){var v=[];for(var i=0;i<k._mLoadedSections[n].length;i++){var w=k._mLoadedSections[n][i];if(r.startIndex>=w.startIndex&&r.startIndex+r.length<=w.startIndex+w.length){if(r.startIndex!==w.startIndex&&r.length!==w.length){v=b.mergeSections(v,{startIndex:w.startIndex,length:r.startIndex-w.startIndex});v=b.mergeSections(v,{startIndex:r.startIndex+r.length,length:(w.startIndex+w.length)-(r.startIndex+r.length)});}}else{v.push(w);}}k._mLoadedSections[n]=v;}}if(n!==undefined){this.fireDataRequested();var A;if(this.bHasTreeAnnotations){A=this.oModel.resolve(this.getPath(),this.getContext());}else{A=n;}if(this.mRequestHandles[R]){this.mRequestHandles[R].abort();}if(A){G=this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId;this.mRequestHandles[R]=this.oModel.read(A,{urlParameters:p,success:o,error:E,sorters:this.aSorters,groupId:G});}}};
m.REQUEST_KEY_CLIENT="_OPERATIONMODE_CLIENT_TREE_LOADING";
m.prototype._loadCompleteTreeWithAnnotations=function(u){var t=this;var r=m.REQUEST_KEY_CLIENT;var s=function(D){if(D.results&&D.results.length>0){var p={};var o;for(var k=0;k<D.results.length;k++){o=D.results[k];var j=o[t.oTreeProperties["hierarchy-node-for"]];if(p[j]){L.warning("ODataTreeBinding - Duplicate data entry for key: "+j+"!");}p[j]=t.oModel._getKey(o);}for(var i=0;i<D.results.length;i++){o=D.results[i];var P=o[t.oTreeProperties["hierarchy-parent-node-for"]];var n=p[P];if(parseInt(o[t.oTreeProperties["hierarchy-level-for"]])===t.iRootLevel){n="null";}t.oKeys[n]=t.oKeys[n]||[];var K=t.oModel._getKey(o);t.oKeys[n].push(K);t.oLengths[n]=t.oLengths[n]||0;t.oLengths[n]++;t.oFinalLengths[n]=true;t._mLoadedSections[n]=t._mLoadedSections[n]||[];t._mLoadedSections[n][0]=t._mLoadedSections[n][0]||{startIndex:0,length:0};t._mLoadedSections[n][0].length++;}}else{t.oKeys["null"]=[];t.oLengths["null"]=0;t.oFinalLengths["null"]=true;}t.oAllKeys=q.extend(true,{},t.oKeys);t.oAllLengths=q.extend(true,{},t.oLengths);t.oAllFinalLengths=q.extend(true,{},t.oFinalLengths);delete t.mRequestHandles[r];t.bNeedsUpdate=true;if((t.aApplicationFilters&&t.aApplicationFilters.length>0)||(t.aFilters&&t.aFilters.length>0)){t._applyFilter();}if(t.aSorters&&t.aSorters.length>0){t._applySort();}t.oModel.callAfterUpdate(function(){t.fireDataReceived({data:D});});};var E=function(o){delete t.mRequestHandles[r];var i=o.statusCode==0;if(!i){t.oKeys={};t.oLengths={};t.oFinalLengths={};t.oAllKeys={};t.oAllLengths={};t.oAllFinalLengths={};t._fireChange({reason:a.Change});}t.fireDataReceived();};this.fireDataRequested();if(this.mRequestHandles[r]){this.mRequestHandles[r].abort();}var A=this.oModel.resolve(this.getPath(),this.getContext());if(A){this.mRequestHandles[r]=this.oModel.read(A,{urlParameters:u,success:s,error:E,sorters:this.aSorters,groupId:this.sRefreshGroupId?this.sRefreshGroupId:this.sGroupId});}};
m.prototype.resetData=function(v){var o,D=false;if(typeof v==="boolean"){D=v;}else{o=v;}if(o){var p=o.getPath();delete this.oKeys[p];delete this.oLengths[p];delete this.oFinalLengths[p];delete this._mLoadedSections[p];}else{this.oKeys={};this.bClientOperation=false;switch(this.sOperationMode){case c.Server:this.bClientOperation=false;break;case c.Client:this.bClientOperation=true;break;case c.Auto:this.bClientOperation=false;break;}this.bThresholdRejected=false;this.iTotalCollectionCount=null;this.bCollectionCountRequested=false;this.oAllKeys=null;this.oAllLengths=null;this.oAllFinalLengths=null;this.oLengths={};this.oFinalLengths={};this.oRootContext=null;this._bRootMissing=false;if(!D){this._abortPendingRequest();}this._mLoadedSections={};this._iPageSize=0;this.sFilterParams="";}};
m.prototype.refresh=function(i,G){if(typeof i==="string"){G=i;}this.sRefreshGroupId=G;this._refresh(i);this.sRefreshGroupId=undefined;};
m.prototype._refresh=function(j,k,E){var n=false;if(!j){if(E){var r=this.oModel.resolve(this.sPath,this.oContext);if(r){if(r.indexOf("?")!==-1){r=r.split("?")[0];}var o=this.oModel.oMetadata._getEntityTypeByPath(r);if(o&&(o.entityType in E)){n=true;}}}if(k&&!n){q.each(this.oKeys,function(i,N){q.each(N,function(i,K){if(K in k){n=true;return false;}});if(n){return false;}});}if(!k&&!E){n=true;}}if(j||n){this.resetData();this.bNeedsUpdate=false;this.bRefresh=true;this._fireRefresh({reason:a.Refresh});}};
m.prototype.filter=function(i,s,r){var j=false;s=s||f.Control;this.oModel.checkFilterOperation(i);if(s==f.Control&&(!this.bClientOperation||this.sOperationMode==c.Server)){L.warning("Filtering with ControlFilters is ONLY possible if the ODataTreeBinding is running in OperationMode.Client or "+"OperationMode.Auto, in case the given threshold is lower than the total number of tree nodes.");return;}if(!i){i=[];}if(i instanceof F){i=[i];}if(s===f.Control){this.aFilters=i;}else{this.aApplicationFilters=i;}if(!this.bInitial){if(this.bClientOperation&&(s===f.Control||(s===f.Application&&!this.bUseServersideApplicationFilters))){if(this.oAllKeys){this.oKeys=q.extend(true,{},this.oAllKeys);this.oLengths=q.extend(true,{},this.oAllLengths);this.oFinalLengths=q.extend(true,{},this.oAllFinalLengths);this._applyFilter();this._applySort();this._fireChange({reason:a.Filter});}else{this.sChangeReason=a.Filter;}}else{this.resetData();this.sChangeReason=a.Filter;this._fireRefresh({reason:this.sChangeReason});}j=true;}if(r){return j;}else{return this;}};
m.prototype._applyFilter=function(){var t=this;var o;if(this.bUseServersideApplicationFilters){o=e.groupFilters(this.aFilters);}else{o=e.combineFilters(this.aFilters,this.aApplicationFilters);}var i=function(k){var n=e.apply([k],o,function(r,p){var s=t.oModel.getContext('/'+r);return t.oModel.getProperty(p,s);},t.mNormalizeCache);return n.length>0;};var j={};this._filterRecursive({id:"null"},j,i);this.oKeys=j;if(!this.oKeys["null"]){L.warning("Clientside filter did not match on any node!");}else{this.oLengths["null"]=this.oKeys["null"].length;this.oFinalLengths["null"]=true;}};
m.prototype._filterRecursive=function(n,k,j){var o=this.oKeys[n.id];if(o){n.children=n.children||[];for(var i=0;i<o.length;i++){var p=this._filterRecursive({id:o[i]},k,j);if(p.isFiltered){k[n.id]=k[n.id]||[];k[n.id].push(p.id);n.children.push(p);}}if(n.children.length>0){n.isFiltered=true;}else{n.isFiltered=j(n.id);}if(n.isFiltered){this.oLengths[n.id]=n.children.length;this.oFinalLengths[n.id]=true;}return n;}else{n.isFiltered=j(n.id);return n;}};
m.prototype.sort=function(s,r){var i=false;if(s instanceof S){s=[s];}this.aSorters=s||[];if(!this.bInitial){this._abortPendingRequest();if(this.bClientOperation){this.addSortComparators(s,this.oEntityType);if(this.oAllKeys){this._applySort();this._fireChange({reason:a.Sort});}else{this.sChangeReason=a.Sort;}}else{this.resetData(undefined,{reason:a.Sort});this.sChangeReason=a.Sort;this._fireRefresh({reason:this.sChangeReason});}i=true;}if(r){return i;}else{return this;}};
m.prototype.addSortComparators=function(s,E){var p,t;if(!E){L.warning("Cannot determine sort comparators, as entitytype of the collection is unkown!");return;}q.each(s,function(i,o){if(!o.fnCompare){p=this.oModel.oMetadata._getPropertyMetadata(E,o.sPath);t=p&&p.type;h(p,"PropertyType for property "+o.sPath+" of EntityType "+E.name+" not found!");o.fnCompare=O.getComparator(t);}}.bind(this));};
m.prototype._applySort=function(){var t=this,o;var G=function(k,p){o=t.oModel.getContext('/'+k);return t.oModel.getProperty(p,o);};for(var n in this.oKeys){d.apply(this.oKeys[n],this.aSorters,G);}};
m.prototype.checkUpdate=function(j,k){var s=this.sChangeReason?this.sChangeReason:a.Change;var n=false;if(!j){if(this.bNeedsUpdate||!k){n=true;}else{q.each(this.oKeys,function(i,N){q.each(N,function(i,K){if(K in k){n=true;return false;}});if(n){return false;}});}}if(j||n){this.bNeedsUpdate=false;this._fireChange({reason:s});}this.sChangeReason=undefined;};
m.prototype._getNavPath=function(p){var A=this.oModel.resolve(p,this.getContext());if(!A){return;}var P=A.split("/"),E=P[P.length-1],n;var s=E.split("(")[0];if(s&&this.oNavigationPaths[s]){n=this.oNavigationPaths[s];}return n;};
m.prototype._processODataObject=function(o,p,n){var N=[],t=this;if(n&&n.indexOf("/")>-1){N=n.split("/");n=N[0];N.splice(0,1);}var r=this.oModel._getObject(p);if(Array.isArray(r)){this.oKeys[p]=r;this.oLengths[p]=r.length;this.oFinalLengths[p]=true;}else if(r){this.oLengths[p]=1;this.oFinalLengths[p]=true;}if(n&&o[n]){if(Array.isArray(r)){r.forEach(function(R){var o=t.getModel().getData("/"+R);t._processODataObject(o,"/"+R+"/"+n,N.join("/"));});}else if(typeof r==="object"){t._processODataObject(o,p+"/"+n,N.join("/"));}}};
m.prototype._hasTreeAnnotations=function(){var M=this.oModel,o=M.oMetadata,A=M.resolve(this.getPath(),this.getContext()),E,t=o.mNamespaces["sap"],i=this;this.oTreeProperties={"hierarchy-level-for":false,"hierarchy-parent-node-for":false,"hierarchy-node-for":false,"hierarchy-drill-state-for":false};var s=function(){var j=0;var k=0;q.each(i.oTreeProperties,function(p,P){k++;if(P){j+=1;}});if(j===k){return true;}else if(j>0&&j<k){L.warning("Incomplete hierarchy tree annotations. Please check your service metadata definition!");}return false;};if(this.mParameters&&this.mParameters.treeAnnotationProperties){this.oTreeProperties["hierarchy-level-for"]=this.mParameters.treeAnnotationProperties.hierarchyLevelFor;this.oTreeProperties["hierarchy-parent-node-for"]=this.mParameters.treeAnnotationProperties.hierarchyParentNodeFor;this.oTreeProperties["hierarchy-node-for"]=this.mParameters.treeAnnotationProperties.hierarchyNodeFor;this.oTreeProperties["hierarchy-drill-state-for"]=this.mParameters.treeAnnotationProperties.hierarchyDrillStateFor;return s();}if(A.indexOf("?")!==-1){A=A.split("?")[0];}E=o._getEntityTypeByPath(A);if(!E){L.fatal("EntityType for path "+A+" could not be found.");return false;}q.each(E.property,function(I,p){if(!p.extensions){return true;}q.each(p.extensions,function(I,j){var n=j.name;if(j.namespace===t&&n in i.oTreeProperties&&!i.oTreeProperties[n]){i.oTreeProperties[n]=p.name;}});});return s();};
m.prototype.initialize=function(){if(this.oModel.oMetadata&&this.oModel.oMetadata.isLoaded()&&this.bInitial){var i=this.isRelative();if(!i||(i&&this.oContext)){this._initialize();}this._fireRefresh({reason:a.Refresh});}return this;};
m.prototype._initialize=function(){this.bInitial=false;this.bHasTreeAnnotations=this._hasTreeAnnotations();this.oEntityType=this._getEntityType();this._processSelectParameters();this._applyAdapter();return this;};
m.prototype.setContext=function(o){if(g.hasChanged(this.oContext,o)){this.oContext=o;if(!this.isRelative()){return;}var r=this.oModel.resolve(this.sPath,this.oContext);if(r){this.resetData();this._initialize();this._fireChange({reason:a.Context});}else{if(!l(this.oAllKeys)||!l(this.oKeys)||!l(this._aNodes)){this.resetData();this._fireChange({reason:a.Context});}}}};
m.prototype.applyAdapterInterface=function(){this.getContexts=this.getContexts||function(){return[];};this.getNodes=this.getNodes||function(){return[];};this.getLength=this.getLength||function(){return 0;};this.isLengthFinal=this.isLengthFinal||function(){return false;};this.getContextByIndex=this.getContextByIndex||function(){return;};this.attachSelectionChanged=this.attachSelectionChanged||function(D,i,o){this.attachEvent("selectionChanged",D,i,o);return this;};this.detachSelectionChanged=this.detachSelectionChanged||function(i,o){this.detachEvent("selectionChanged",i,o);return this;};this.fireSelectionChanged=this.fireSelectionChanged||function(p){this.fireEvent("selectionChanged",p);return this;};return this;};
m.prototype._applyAdapter=function(){var M="hierarchy-node-descendant-count-for";var s="hierarchy-sibling-rank-for";var p="hierarchy-preorder-rank-for";if(this.bHasTreeAnnotations){var A=this.oModel.resolve(this.getPath(),this.getContext());if(A.indexOf("?")!==-1){A=A.split("?")[0];}var E=this.oModel.oMetadata._getEntityTypeByPath(A);var t=this;q.each(E.property,function(I,P){if(!P.extensions){return true;}q.each(P.extensions,function(I,r){var N=r.name;if(r.namespace===t.oModel.oMetadata.mNamespaces["sap"]&&(N==M||N==s||N==p)){t.oTreeProperties[N]=P.name;}});});this.oTreeProperties[M]=this.oTreeProperties[M]||(this.mParameters.treeAnnotationProperties&&this.mParameters.treeAnnotationProperties.hierarchyNodeDescendantCountFor);if(this.oTreeProperties[M]&&this.sOperationMode==c.Server){var i,j,k;this.oTreeProperties[s]=this.oTreeProperties[s]||(this.mParameters.treeAnnotationProperties&&this.mParameters.treeAnnotationProperties.hierarchySiblingRankFor);this.oTreeProperties[p]=this.oTreeProperties[p]||(this.mParameters.treeAnnotationProperties&&this.mParameters.treeAnnotationProperties.hierarchyPreorderRankFor);if(this.mParameters.restoreTreeStateAfterChange){if(this.oTreeProperties[s]&&this.oTreeProperties[p]){this._bRestoreTreeStateAfterChange=true;this._aTreeKeyProperties=[];for(i=E.key.propertyRef.length-1;i>=0;i--){this._aTreeKeyProperties.push(E.key.propertyRef[i].name);}}else{L.warning("Tree state restoration not possible: Missing annotation \"hierarchy-sibling-rank-for\" and/or \"hierarchy-preorder-rank-for\"");this._bRestoreTreeStateAfterChange=false;}}else{this._bRestoreTreeStateAfterChange=false;}if(this.mParameters&&this.mParameters.select){if(this.mParameters.select.indexOf(this.oTreeProperties[M])===-1){this.mParameters.select+=","+this.oTreeProperties[M];}if(this._bRestoreTreeStateAfterChange){for(j=this._aTreeKeyProperties.length-1;j>=0;j--){k=this._aTreeKeyProperties[j];if(this.mParameters.select.indexOf(k)===-1){this.mParameters.select+=","+k;}}}this.sCustomParams=this.oModel.createCustomParams(this.mParameters);}var n=sap.ui.requireSync("sap/ui/model/odata/ODataTreeBindingFlat");n.apply(this);}else{var o=sap.ui.requireSync("sap/ui/model/odata/ODataTreeBindingAdapter");o.apply(this);}}else if(this.oNavigationPaths){var o=sap.ui.requireSync("sap/ui/model/odata/ODataTreeBindingAdapter");o.apply(this);}else{L.error("Neither hierarchy annotations, nor navigation properties are specified to build the tree.",this);}};
m.prototype._processSelectParameters=function(){if(this.mParameters){this.oNavigationPaths=this.mParameters.navigation;if(this.mParameters.select){var s=this.mParameters.select.split(",");var n=[];if(this.oNavigationPaths){q.each(this.oNavigationPaths,function(p,P){if(n.indexOf(P)==-1){n.push(P);}});}q.each(n,function(p,P){if(s.indexOf(P)==-1){s.push(P);}});if(this.bHasTreeAnnotations){q.each(this.oTreeProperties,function(A,t){if(t){if(s.indexOf(t)==-1){s.push(t);}}});}this.mParameters.select=s.join(",");}this.sCustomParams=this.oModel.createCustomParams(this.mParameters);}if(!this.bHasTreeAnnotations&&!this.oNavigationPaths){L.error("Neither navigation paths parameters, nor (complete/valid) tree hierarchy annotations where provided to the TreeBinding.");this.oNavigationPaths={};}};
m.prototype.getTreeAnnotation=function(A){return this.bHasTreeAnnotations?this.oTreeProperties[A]:undefined;};
m.prototype.getDownloadUrl=function(s){var p=[],P;if(s){p.push("$format="+encodeURIComponent(s));}if(this.aSorters&&this.aSorters.length>0){p.push(O.createSortParams(this.aSorters));}if(this.getFilterParams()){p.push("$filter="+this.getFilterParams());}if(this.sCustomParams){p.push(this.sCustomParams);}P=this.oModel.resolve(this.sPath,this.oContext);if(P){return this.oModel._createRequestUrl(P,null,p);}};
m.prototype.setNumberOfExpandedLevels=function(i){i=i||0;if(i<0){L.warning("ODataTreeBinding: numberOfExpandedLevels was set to 0. Negative values are prohibited.");i=0;}this.iNumberOfExpandedLevels=i;this._fireChange();};
m.prototype.getNumberOfExpandedLevels=function(){return this.iNumberOfExpandedLevels;};
m.prototype.setRootLevel=function(r){r=parseInt(r||0);if(r<0){L.warning("ODataTreeBinding: rootLevels was set to 0. Negative values are prohibited.");r=0;}this.iRootLevel=r;this.refresh();};
m.prototype.getRootLevel=function(){return parseInt(this.iRootLevel);};
m.prototype._getEntityType=function(){var r=this.oModel.resolve(this.sPath,this.oContext);if(r){var E=this.oModel.oMetadata._getEntityTypeByPath(r);h(E,"EntityType for path "+r+" could not be found!");return E;}return undefined;};
m.prototype.getFilterParams=function(){var G;if(this.aApplicationFilters){this.aApplicationFilters=Array.isArray(this.aApplicationFilters)?this.aApplicationFilters:[this.aApplicationFilters];if(this.aApplicationFilters.length>0&&!this.sFilterParams){G=e.groupFilters(this.aApplicationFilters);this.sFilterParams=O._createFilterParams(G,this.oModel.oMetadata,this.oEntityType);this.sFilterParams=this.sFilterParams?"("+this.sFilterParams+")":"";}}else{this.sFilterParams="";}return this.sFilterParams;};
m.prototype._abortPendingRequest=function(){q.each(this.mRequestHandles,function(r,R){if(R){R.abort();}});this.mRequestHandles={};};
return m;});
sap.ui.predefine('sap/ui/model/odata/v4/AnnotationHelper',["./_AnnotationHelperExpression"],function(E){"use strict";var r=/[\\\{\}:]/,a=/\/\$count$/,b=/\$(?:(?:Annotation)|(?:(?:Navigation)?Property))?Path/,c=/^(.+?\/(\$(?:Annotation)?Path))(\/?)(.*)$/,d=/\$(?:Navigation)?PropertyPath/,A={format:function(R,D){var m,M=D.context.getModel(),p=D.context.getPath();function g(P){if(p.endsWith("/")){p=p.slice(0,-1);}return E.getExpression({asExpression:false,complexBinding:true,formatOptions:D.arguments&&D.arguments[1],ignoreAsPrefix:D.overload&&D.overload.$IsBound&&!p.includes("/$Parameter/")?D.overload.$Parameter[0].$Name+"/":"",model:M,parameters:D.arguments&&D.arguments[0],path:p,prefix:P,value:R,$$valueAsPromise:true});}if(p.endsWith("/$Path")){p=p.slice(0,-6);R={$Path:R};}else if(p.endsWith('/$PropertyPath')){p=p.slice(0,-14);R={$PropertyPath:R};}m=d.exec(p);if(m){throw new Error("Unsupported path segment "+m[0]+" in "+p);}m=c.exec(p);if(m&&p.length>m[1].length){if(c.test(m[4])){throw new Error("Only one $Path or $AnnotationPath segment is supported: "+p);}return M.fetchObject(m[1]).then(function(P){var i,I=m[2]==="$AnnotationPath",s=I?P.split("@")[0]:P;if(!I&&m[3]){s=s+"/";}else if(!s.endsWith("/")){i=s.lastIndexOf("/");s=i<0?"":s.slice(0,i+1);}return g(s);});}return g("");},getNavigationBinding:function(p){p=A.getNavigationPath(p);if(r.test(p)){throw new Error("Invalid OData identifier: "+p);}return p?"{"+p+"}":p;},getNavigationPath:function(p){var i;if(!p||p[0]==="@"){return"";}if(a.test(p)){return p.slice(0,-7);}i=p.indexOf("@");if(i>-1){p=p.slice(0,i);}if(p[p.length-1]==="/"){p=p.slice(0,-1);}if(p.indexOf(".")>-1){p=p.split("/").filter(function(s){return s.indexOf(".")<0;}).join("/");}return p;},getValueListType:function(R,D){var p=typeof R==="string"?"/"+D.schemaChildName+"/"+R:D.context.getPath();return D.$$valueAsPromise?D.context.getModel().fetchValueListType(p).unwrap():D.context.getModel().getValueListType(p);},isMultiple:function(p,D){var i;function e(v){return v===true;}if(!p||p[0]==="@"){return false;}if(a.test(p)){return true;}i=p.indexOf("@");if(i>-1){p=p.slice(0,i);}if(p[p.length-1]!=="/"){p+="/";}p="/"+D.schemaChildName+"/"+p+"$isCollection";return D.$$valueAsPromise?D.context.getModel().fetchObject(p).then(e).unwrap():D.context.getObject(p)===true;},label:function(R,D){var n;if(R.Label){return A.value(R.Label,{context:D.context.getModel().createBindingContext("Label",D.context)});}if(R.Value&&R.Value.$Path){n=D.context.getModel().createBindingContext("Value/$Path@com.sap.vocabularies.Common.v1.Label",D.context);if(D.$$valueAsPromise){return n.getModel().fetchObject("",n).then(function(o){return A.value(o,{context:n});}).unwrap();}return A.value(n.getObject(""),{context:n});}},resolve$Path:function(C){var e,i,I,l,m,p=C.getPath(),P,v;for(;;){m=p.match(b);if(!m){return p;}I=m.index;e=I+m[0].length;P=p.slice(0,e);v=C.getModel().getObject(P);if(typeof v!=="string"){throw new Error("Cannot resolve "+P+" due to unexpected value "+v);}P=p.slice(0,I);i=P.indexOf("@");l=P.lastIndexOf("/",i);if(l===0){P=P.slice(0,i);if(i>1&&v){P+="/";}}else{P=P.slice(0,l+1);}p=P+v+p.slice(e);}},value:function(R,D){var p=D.context.getPath();if(p.endsWith("/")){p=p.slice(0,-1);}else if(p.endsWith("/$Path")){p=p.slice(0,-6);R={$Path:R};}else if(p.endsWith('/$PropertyPath')){p=p.slice(0,-14);R={$PropertyPath:R};}return E.getExpression({asExpression:false,complexBinding:false,ignoreAsPrefix:D.overload&&D.overload.$IsBound&&!p.includes("/$Parameter/")?D.overload.$Parameter[0].$Name+"/":"",model:D.context.getModel(),parameters:D.arguments&&D.arguments[0],path:p,prefix:"",value:R,$$valueAsPromise:D.$$valueAsPromise});}};return A;},true);
sap.ui.predefine('sap/ui/model/odata/v4/Context',["./lib/_Helper","sap/base/Log","sap/ui/base/SyncPromise","sap/ui/model/Context"],function(_,L,S,B){"use strict";var c="sap.ui.model.odata.v4.Context",m,r=0,v=-9007199254740991;
function f(o,p,e,b){var E,P=[o.fetchValue(p,null,b)],R=p[0]==="/"?p:_.buildPath(o.getPath(),p);if(e){P.push(o.oModel.getMetaModel().fetchUI5Type(R));}return S.all(P).then(function(a){var t=a[1],V=a[0];if(V&&typeof V==="object"){E=new Error("Accessed value is not primitive: "+R);E.isNotPrimitive=true;throw E;}return e?t.formatValue(V,"string"):V;});}
var C=B.extend("sap.ui.model.odata.v4.Context",{constructor:function(M,b,p,i,o,R){if(p[0]!=="/"){throw new Error("Not an absolute path: "+p);}if(p.endsWith("/")){throw new Error("Unsupported trailing slash: "+p);}B.call(this,M,p);this.oBinding=b;this.oCreatePromise=o&&Promise.resolve(o).then(function(){});this.oSyncCreatePromise=o&&S.resolve(o);this.iIndex=i;this.bKeepAlive=false;this.iReturnValueContextId=R;}});
C.prototype._delete=function(g,e){var t=this;if(this.isTransient()){return this.oBinding._delete(g,"n/a",this);}return this.fetchCanonicalPath().then(function(s){return t.oBinding._delete(g,s.slice(1),t,e);}).then(function(){t.bKeepAlive=false;});};
C.prototype.adjustPredicate=function(t,p,P){var T=this.sPath;if(T.includes(t)){this.sPath=T.split("/").map(function(s){if(s.endsWith(t)){s=s.slice(0,-t.length)+p;}return s;}).join("/");if(P){P(T,this.sPath);}this.oModel.getDependentBindings(this).forEach(function(d){d.adjustPredicate(t,p);});}};
C.prototype.checkUpdate=function(){return S.all(this.oModel.getDependentBindings(this).map(function(d){return d.checkUpdate();}));};
C.prototype.created=function(){return this.oCreatePromise;};
C.prototype.delete=function(g){var G,M=this.oModel,t=this;M.checkGroupId(g);this.oBinding.checkSuspended();if(this.isTransient()){g=g||"$direct";}else if(this.hasPendingChanges()){throw new Error("Cannot delete due to pending changes");}G=this.oBinding.lockGroup(g,true,true);return this._delete(G).then(function(){var R=t.sPath.slice(1);M.getAllBindings().forEach(function(b){b.removeCachesAndMessages(R,true);});}).catch(function(e){G.unlock(true);M.reportError("Failed to delete "+t,c,e);throw e;});};
C.prototype.destroy=function(){this.oModel.getDependentBindings(this).forEach(function(d){d.setContext(undefined);});this.oBinding=undefined;this.oModel=undefined;B.prototype.destroy.call(this);};
C.prototype.doSetProperty=function(p,V,g,s){var M=this.oModel.getMetaModel(),t=this;if(this.oModel.bAutoExpandSelect){p=M.getReducedPath(_.buildPath(this.sPath,p),this.oBinding.getBaseForPathReduction());}return this.withCache(function(o,a,b){return b.doSetProperty(a,V,g)||M.fetchUpdateData(p,t,!g).then(function(R){var e=_.getRelativePath(R.entityPath,b.oReturnValueContext?b.oReturnValueContext.getPath():t.oModel.resolve(b.sPath,b.oContext)),F=false;function d(E){t.oModel.reportError("Failed to update path "+t.oModel.resolve(p,t),c,E);h(false);}function h(j){if(F){b.firePatchCompleted(j);F=false;}}function i(){F=true;b.firePatchSent();}if(!g){return o.setProperty(R.propertyPath,V,e);}return o.update(g,R.propertyPath,V,s?undefined:d,R.editUrl,e,M.getUnitOrCurrencyPath(t.oModel.resolve(p,t)),b.isPatchWithoutSideEffects(),i).then(function(){h(true);},function(E){h(false);throw E;});});},p,false,true);};
C.prototype.expand=function(){var t=this;switch(this.isExpanded()){case false:this.oBinding.expand(this).catch(function(e){t.oModel.reportError("Failed to expand "+t,c,e);});break;case true:throw new Error("Already expanded: "+this);default:throw new Error("Not expandable: "+this);}};
C.prototype.fetchCanonicalPath=function(){return this.oModel.getMetaModel().fetchCanonicalPath(this);};
C.prototype.fetchValue=function(p,l,b){if(this.iIndex===v){return S.resolve();}if(!p||p[0]!=="/"){p=_.buildPath(this.sPath,p);if(this.oModel.bAutoExpandSelect){p=this.oModel.getMetaModel().getReducedPath(p,this.oBinding.getBaseForPathReduction());}}return this.oBinding.fetchValue(p,l,b);};
C.prototype.getBinding=function(){return this.oBinding;};
C.prototype.getCanonicalPath=_.createGetMethod("fetchCanonicalPath",true);
C.prototype.getGroupId=function(){return this.oBinding.getGroupId();};
C.prototype.getIndex=function(){if(this.oBinding.bCreatedAtEnd){return this.iIndex<0?this.oBinding.iMaxLength-this.iIndex-1:this.iIndex;}return this.getModelIndex();};
C.prototype.getModelIndex=function(){if(this.iIndex!==undefined&&this.oBinding.iCreatedContexts){return this.iIndex+this.oBinding.iCreatedContexts;}return this.iIndex;};
C.prototype.getObject=function(p){return _.publicClone(this.getValue(p));};
C.prototype.getProperty=function(p,e){var E,s;this.oBinding.checkSuspended();s=f(this,p,e,true);if(s.isRejected()){s.caught();E=s.getResult();if(E.isNotPrimitive){throw E;}else if(!E.$cached){L.warning(E.message,p,c);}}return s.isFulfilled()?s.getResult():undefined;};
C.prototype.getReturnValueContextId=function(){if(this.iReturnValueContextId){return this.iReturnValueContextId;}if(this.oBinding.bRelative&&this.oBinding.oContext&&this.oBinding.oContext.getReturnValueContextId){return this.oBinding.oContext.getReturnValueContextId();}};
C.prototype.getQueryOptionsForPath=function(p){return this.oBinding.getQueryOptionsForPath(p);};
C.prototype.getUpdateGroupId=function(){return this.oBinding.getUpdateGroupId();};
C.prototype.getValue=function(p){var s,t=this;this.oBinding.checkSuspended();s=this.fetchValue(p,null,true).catch(function(e){if(!e.$cached){t.oModel.reportError("Unexpected error",c,e);}});if(s.isFulfilled()){return s.getResult();}};
C.prototype.hasPendingChanges=function(){return this.isTransient()||this.oModel.getDependentBindings(this).some(function(d){return d.hasPendingChanges();})||this.oModel.withUnresolvedBindings("hasPendingChangesInCaches",this.sPath.slice(1));};
C.prototype.isExpanded=function(){return this.getProperty("@$ui5.node.isExpanded");};
C.prototype.isKeepAlive=function(){return this.bKeepAlive;};
C.prototype.isTransient=function(){return this.oSyncCreatePromise&&this.oSyncCreatePromise.isPending();};
C.prototype.patch=function(d){return this.withCache(function(o,p){o.patch(p,d);},"");};
C.prototype.refresh=function(g,a){this.oModel.checkGroupId(g);this.oBinding.checkSuspended();if(this.hasPendingChanges()){throw new Error("Cannot refresh entity due to pending changes: "+this);}if(this.oBinding.refreshSingle){this.oBinding.refreshSingle(this,this.oBinding.lockGroup(g,true),a);}else{if(arguments.length>1){throw new Error("Unsupported parameter bAllowRemoval: "+a);}if(!this.oBinding.refreshReturnValueContext(this,g)){this.oBinding.refresh(g);}}this.oModel.withUnresolvedBindings("removeCachesAndMessages",this.sPath.slice(1));};
C.prototype.requestCanonicalPath=_.createRequestMethod("fetchCanonicalPath");
C.prototype.requestObject=function(p){this.oBinding.checkSuspended();return Promise.resolve(this.fetchValue(p)).then(_.publicClone);};
C.prototype.requestProperty=function(p,e){var P=Array.isArray(p)?p:[p],t=this;this.oBinding.checkSuspended();return Promise.all(P.map(function(s){return t.oBinding.fetchIfChildCanUseCache(t,s,S.resolve({})).then(function(R){if(R){return f(t,R,e);}L.error("Not a valid property path: "+s,undefined,c);});})).then(function(V){return Array.isArray(p)?V:V[0];});};
C.prototype.requestSideEffects=function(p,g){var M=this.oModel.getMetaModel(),P=[],a=[],R,s,t=this;function i(b){if(!b){return false;}if(b==="*"){return true;}if(b.endsWith("/*")){b=b.slice(0,-2);}return!b.includes("*");}this.oBinding.checkSuspended();this.oModel.checkGroupId(g);if(this.isTransient()){throw new Error("Unsupported context: "+this);}if(!p||!p.length){throw new Error("Missing edm:(Navigation)PropertyPath expressions");}if(!this.oBinding.isResolved()){throw new Error("Cannot request side effects of unresolved binding's context: "+this);}p.map(function(o){if(o&&typeof o==="object"){if(i(o.$PropertyPath)){return o.$PropertyPath;}if(typeof o.$NavigationPropertyPath==="string"&&!o.$NavigationPropertyPath.includes("*")){return o.$NavigationPropertyPath;}}throw new Error("Not an edm:(Navigation)PropertyPath expression: "+JSON.stringify(o));}).forEach(function(b){if(b[0]==="/"){a.push(b);}else{P.push(b);}});R=this.oBinding.getRootBinding();s=this.oModel.resolve(R.getPath(),R.getContext());P=P.reduce(function(b,d){return b.concat(M.getAllPathReductions(_.buildPath(t.getPath(),d),s));},[]);g=g||this.getUpdateGroupId();return Promise.resolve(S.resolve(this.oModel.isAutoGroup(g)&&this.oModel.oRequestor.waitForRunningChangeRequests(g).then(function(){t.oModel.oRequestor.relocateAll("$parked."+g,g);})).then(function(){return S.all([t.oModel.requestSideEffects(g,a),t.requestSideEffectsInternal(P,g)]);})).then(function(){});};
C.prototype.requestSideEffectsInternal=function(a,g){var t=this,b,o=t,d,O=[],p,P=[],s,e=[];for(;;){b=o.getBinding();s=b.getPath();p=b.getContext();if(b.oCache&&(!d||b.oCache.hasChangeListeners())){d=o;}if(d&&s){break;}if(!b.getBoundContext){throw new Error("Not a context binding: "+b);}o=p;}b=d.getBinding();a.forEach(function(A){var R=_.getRelativePath(A,d.getPath());if(R===undefined){P.push(A);}else{O.push(R);}});if(P.length){e.push(b.getContext().requestSideEffectsInternal(P,g));}if(O.length&&b.oCache!==undefined){e.push(b.requestSideEffects(g,O,d));}return S.all(e);};
C.prototype.setKeepAlive=function(k){if(this.isTransient()){throw new Error("Unsupported transient context "+this);}if(!_.getPrivateAnnotation(this.getValue(),"predicate")){throw new Error("No key predicate known at "+this);}this.oBinding.checkKeepAlive(this);this.bKeepAlive=k;};
C.prototype.setProperty=function(p,V,g){var G=null;this.oBinding.checkSuspended();if(typeof V==="function"||(V&&typeof V==="object")){throw new Error("Not a primitive value");}if(g!==null){this.oModel.checkGroupId(g);G=this.oBinding.lockGroup(g,true,true);}return Promise.resolve(this.doSetProperty(p,V,G,true)).catch(function(e){if(G){G.unlock(true);}throw e;});};
C.prototype.toString=function(){var i="";if(this.iIndex!==undefined){i="["+this.iIndex+(this.isTransient()?"|transient":"")+"]";}return this.sPath+i;};
C.prototype.withCache=function(p,P,s,w){if(this.iIndex===v){return S.resolve();}return this.oBinding.withCache(p,P[0]==="/"?P:_.buildPath(this.sPath,P),s,w);};
m={create:function(M,b,p,i,o){return new C(M,b,p,i,o);},createReturnValueContext:function(M,b,p){r+=1;return new C(M,b,p,undefined,undefined,r);}};Object.defineProperty(m,"VIRTUAL",{value:v});return m;},false);
sap.ui.predefine('sap/ui/model/odata/v4/ODataBinding',["./lib/_Helper","sap/ui/base/SyncPromise","sap/ui/model/ChangeReason","sap/ui/model/odata/OperationMode","sap/ui/model/odata/v4/Context"],function(_,S,C,O,a){"use strict";var c=[C.Change,C.Refresh,C.Sort,C.Filter],s="sap.ui.model.odata.v4.ODataBinding",r=/\/\d|\(\$uid=/;
function b(){this.mCacheByResourcePath=undefined;this.oCache=null;this.oCachePromise=S.resolve(null);this.mCacheQueryOptions=undefined;this.oFetchCacheCallToken=undefined;this.mLateQueryOptions=undefined;this.sReducedPath=undefined;this.sResumeChangeReason=undefined;}
b.prototype.assertSameCache=function(e){var E;if(this.oCache!==e){E=new Error("Response discarded: cache is inactive");E.canceled=true;throw E;}};
b.prototype.checkBindingParameters=function(p,A){var t=this;Object.keys(p).forEach(function(k){var v=p[k];if(!k.startsWith("$$")){return;}if(A.indexOf(k)<0){throw new Error("Unsupported binding parameter: "+k);}switch(k){case"$$aggregation":break;case"$$groupId":case"$$updateGroupId":t.oModel.checkGroupId(v,false,"Unsupported value for binding parameter '"+k+"': ");break;case"$$ignoreMessages":if(v!==true&&v!==false){throw new Error("Unsupported value for binding parameter "+"'$$ignoreMessages': "+v);}break;case"$$inheritExpandSelect":if(v!==true&&v!==false){throw new Error("Unsupported value for binding parameter "+"'$$inheritExpandSelect': "+v);}if(!t.oOperation){throw new Error("Unsupported binding parameter $$inheritExpandSelect: "+"binding is not an operation binding");}if(p.$expand||p.$select){throw new Error("Must not set parameter $$inheritExpandSelect on a binding "+"which has a $expand or $select binding parameter");}break;case"$$operationMode":if(v!==O.Server){throw new Error("Unsupported operation mode: "+v);}break;case"$$canonicalPath":case"$$noPatch":case"$$ownRequest":case"$$patchWithoutSideEffects":case"$$sharedRequest":if(v!==true){throw new Error("Unsupported value for binding parameter '"+k+"': "+v);}break;default:throw new Error("Unknown binding-specific parameter: "+k);}});};
b.prototype.checkSuspended=function(){var R=this.getRootBinding();if(R&&R.isSuspended()){throw new Error("Must not call method when the binding's root binding is suspended: "+this);}};
b.prototype.checkUpdate=function(f){var t=this;if(arguments.length>1){throw new Error("Only the parameter bForceUpdate is supported");}this.checkUpdateInternal(f).catch(function(e){t.oModel.reportError("Failed to update "+t,s,e);});};
b.prototype.createAndSetCache=function(q,R,o){var e,D,i;this.mCacheQueryOptions=Object.assign({},this.oModel.mUriParameters,q);if(this.bRelative){e=this.mCacheByResourcePath&&this.mCacheByResourcePath[R];i=o.getReturnValueContextId&&o.getReturnValueContextId();if(e&&e.$returnValueContextId===i){e.setActive(true);}else{D=_.buildPath(o.getPath(),this.sPath).slice(1);e=this.doCreateCache(R,this.mCacheQueryOptions,o,D);if(!(this.mParameters&&this.mParameters.$$sharedRequest)){this.mCacheByResourcePath=this.mCacheByResourcePath||{};this.mCacheByResourcePath[R]=e;}e.$deepResourcePath=D;e.$resourcePath=R;e.$returnValueContextId=i;}}else{e=this.doCreateCache(R,this.mCacheQueryOptions);}this.oCache=e;return e;};
b.prototype.destroy=function(){this.mCacheByResourcePath=undefined;this.oCachePromise.then(function(o){if(o){o.setActive(false);}},function(){});this.oCache=null;this.oCachePromise=S.resolve(null);this.mCacheQueryOptions=undefined;this.oContext=undefined;this.oFetchCacheCallToken=undefined;};
b.prototype.doDeregisterChangeListener=function(p,l){this.oCache.deregisterChange(p,l);};
b.prototype.fetchCache=function(o,i){var e,f={},p,t=this;if(!this.bRelative){o=undefined;}if(this.oCache){this.oCache.setActive(false);}this.oCache=undefined;p=[this.fetchQueryOptionsForOwnCache(o,i),this.oModel.oRequestor.ready()];this.mCacheQueryOptions=undefined;this.mLateQueryOptions=undefined;e=S.all(p).then(function(R){var q=R[0].mQueryOptions;t.sReducedPath=R[0].sReducedPath;if(q&&!(o&&o.iIndex===a.VIRTUAL)){return t.fetchResourcePath(o).then(function(g){var E;if(e&&t.oFetchCacheCallToken!==f){E=new Error("Cache discarded as a new cache has been created");E.canceled=true;throw E;}return t.createAndSetCache(q,g,o);});}t.oCache=null;return null;});e.catch(function(E){t.oModel.reportError("Failed to create cache for binding "+t,s,E);});this.oCachePromise=e;this.oFetchCacheCallToken=f;};
b.prototype.fetchQueryOptionsForOwnCache=function(o,i){var h,q,R=this.oModel.resolve(this.sPath,o),t=this;function w(Q,e){return S.resolve(Q).then(function(m){return{mQueryOptions:m,sReducedPath:e||R};});}if(this.oOperation||this.bRelative&&!o||this.isMeta()){return w(undefined);}q=this.doFetchQueryOptions(o);if(this.oModel.bAutoExpandSelect&&this.aChildCanUseCachePromises&&!(this.mParameters&&this.mParameters.$$aggregation)){q=S.all([q,Promise.resolve().then(function(){return S.all(t.aChildCanUseCachePromises);})]).then(function(e){t.aChildCanUseCachePromises=[];t.updateAggregatedQueryOptions(e[0]);return t.mAggregatedQueryOptions;});}if(i||!this.bRelative||!o.fetchValue){return w(q);}if(this.oModel.bAutoExpandSelect){h=this.mParameters&&Object.keys(t.mParameters).some(function(k){return k[0]!=="$"||k[1]==="$";});if(h){return w(q);}return o.getBinding().fetchIfChildCanUseCache(o,t.sPath,q).then(function(e){return w(e?undefined:q,e);});}if(this.mParameters&&Object.keys(this.mParameters).length){return w(q);}return q.then(function(Q){return w(Object.keys(Q).length?Q:undefined);});};
b.prototype.fetchResourcePath=function(o){var e,f,g,t=this;if(!this.bRelative){return S.resolve(this.sPath.slice(1));}o=o||this.oContext;if(!o){return S.resolve();}f=o.getPath();e=o.fetchCanonicalPath&&(this.mParameters&&this.mParameters.$$canonicalPath||r.test(f));g=e?o.fetchCanonicalPath():S.resolve(f);return g.then(function(h){return _.buildPath(h,t.sPath).slice(1);});};
b.prototype.getGroupId=function(){return this.sGroupId||(this.bRelative&&this.oContext&&this.oContext.getGroupId&&this.oContext.getGroupId())||this.oModel.getGroupId();};
b.prototype.getRelativePath=function(p){var R;if(p[0]==="/"){R=_.getRelativePath(p,this.oModel.resolve(this.sPath,this.oContext));if(R===undefined&&this.oReturnValueContext){R=_.getRelativePath(p,this.oReturnValueContext.getPath());}return R;}return p;};
b.prototype.getRootBinding=function(){if(this.bRelative){if(!this.oContext){return undefined;}if(this.oContext.getBinding){return this.oContext.getBinding().getRootBinding();}}return this;};
b.prototype.getRootBindingResumePromise=function(){var R=this.getRootBinding();return R&&R.getResumePromise()||S.resolve();};
b.prototype.getUpdateGroupId=function(){return this.sUpdateGroupId||(this.bRelative&&this.oContext&&this.oContext.getUpdateGroupId&&this.oContext.getUpdateGroupId())||this.oModel.getUpdateGroupId();};
b.prototype.hasPendingChanges=function(){return this.isResolved()&&(this.hasPendingChangesForPath("")||this.hasPendingChangesInDependents());};
b.prototype.hasPendingChangesForPath=function(p){return this.withCache(function(o,e){return o.hasPendingChangesForPath(e);},p,true).unwrap();};
b.prototype.hasPendingChangesInCaches=function(R){var t=this;if(!this.mCacheByResourcePath){return false;}return Object.keys(this.mCacheByResourcePath).some(function(e){var o=t.mCacheByResourcePath[e];return o.$deepResourcePath.startsWith(R)&&o.hasPendingChangesForPath("");});};
b.prototype.isInitial=function(){throw new Error("Unsupported operation: isInitial");};
b.prototype.isRoot=function(){return!this.bRelative||this.oContext&&!this.oContext.getBinding;};
b.prototype.isRootBindingSuspended=function(){var R=this.getRootBinding();return R&&R.isSuspended();};
b.prototype.lockGroup=function(g,l,m,f){g=g||(m?this.getUpdateGroupId():this.getGroupId());return this.oModel.lockGroup(g,this,l,m,f);};
b.prototype.refresh=function(g){if(!this.isRoot()){throw new Error("Refresh on this binding is not supported");}if(this.hasPendingChanges()){throw new Error("Cannot refresh due to pending changes");}this.oModel.checkGroupId(g);this.refreshInternal("",g,true).catch(function(){});};
b.prototype.removeCachesAndMessages=function(R,e){var m=this.oModel,f,t=this;if(!e){f=m.resolve(this.sPath,this.oContext);if(f){m.reportBoundMessages(f.slice(1),{});}}if(this.mCacheByResourcePath){Object.keys(this.mCacheByResourcePath).forEach(function(g){var o=t.mCacheByResourcePath[g],D=t.mCacheByResourcePath[g].$deepResourcePath;if(R===""||D===R||D.startsWith(R+"/")||D.startsWith(R+"(")){if(!e){m.reportBoundMessages(o.$deepResourcePath,{});}delete t.mCacheByResourcePath[g];}});}};
b.prototype.resetChanges=function(){var p=[];this.checkSuspended();this.resetChangesForPath("",p);this.resetChangesInDependents(p);this.resetInvalidDataState();return Promise.all(p).then(function(){});};
b.prototype.resetChangesForPath=function(p,P){P.push(this.withCache(function(o,e){o.resetChangesForPath(e);},p).unwrap());};
b.prototype.resetInvalidDataState=function(){};
b.prototype.setResumeChangeReason=function(e){if(c.indexOf(e)>c.indexOf(this.sResumeChangeReason)){this.sResumeChangeReason=e;}};
b.prototype.toString=function(){return this.getMetadata().getName()+": "+(this.bRelative?this.oContext+"|":"")+this.sPath;};
b.prototype.withCache=function(p,P,e,w){var o=e?S.resolve(this.oCache):this.oCachePromise,R,t=this;P=P||"";return o.then(function(f){if(f){R=t.getRelativePath(P);if(R!==undefined){return p(f,R,t);}}else if(f===undefined){return undefined;}else if(t.oOperation){return w?p(null,t.getRelativePath(P),t):undefined;}if(t.bRelative&&t.oContext&&t.oContext.withCache){return t.oContext.withCache(p,P[0]==="/"?P:_.buildPath(t.sPath,P),e,w);}return undefined;});};
function d(p){if(this){b.apply(this,arguments);}else{Object.assign(p,b.prototype);}}
d.prototype.doDeregisterChangeListener=b.prototype.doDeregisterChangeListener;d.prototype.destroy=b.prototype.destroy;d.prototype.fetchCache=b.prototype.fetchCache;d.prototype.hasPendingChangesForPath=b.prototype.hasPendingChangesForPath;return d;},false);
sap.ui.predefine('sap/ui/model/odata/v4/ODataContextBinding',["./Context","./ODataParentBinding","./lib/_Cache","./lib/_GroupLock","./lib/_Helper","sap/ui/base/SyncPromise","sap/ui/model/Binding","sap/ui/model/ChangeReason","sap/ui/model/ContextBinding"],function(C,a,_,b,c,S,B,d,f){"use strict";var s="sap.ui.model.odata.v4.ODataContextBinding",m={AggregatedDataStateChange:true,change:true,dataReceived:true,dataRequested:true,DataStateChange:true,patchCompleted:true,patchSent:true};
function g(p,r){var e=p.slice(0,p.lastIndexOf("/")),i=e.indexOf("(");return(i<0?e:p.slice(0,i))+r;}
var O=f.extend("sap.ui.model.odata.v4.ODataContextBinding",{
constructor:function(M,p,o,P){var i=p.indexOf("(...)");f.call(this,M,p);a.call(this);if(p.endsWith("/")){throw new Error("Invalid path: "+p);}this.oOperation=undefined;this.oParameterContext=null;this.oReturnValueContext=null;if(i>=0){if(i!==this.sPath.length-5){throw new Error("The path must not continue after a deferred operation: "+this.sPath);}this.oOperation={bAction:undefined,mChangeListeners:{},mParameters:{},sResourcePath:undefined};if(!this.bRelative){this.oParameterContext=C.create(this.oModel,this,this.sPath+"/$Parameter");}}P=c.clone(P)||{};this.checkBindingParameters(P,["$$canonicalPath","$$groupId","$$inheritExpandSelect","$$ownRequest","$$patchWithoutSideEffects","$$updateGroupId"]);this.sGroupId=P.$$groupId;this.bInheritExpandSelect=P.$$inheritExpandSelect;this.sUpdateGroupId=P.$$updateGroupId;this.applyParameters(P);this.oElementContext=this.bRelative?null:C.create(this.oModel,this,p);if(!this.oOperation&&(!this.bRelative||o&&!o.fetchValue)){this.createReadGroupLock(this.getGroupId(),true);}this.setContext(o);M.bindingCreated(this);},
metadata:{publicMethods:[]}
});
a(O.prototype);
O.prototype._delete=function(G,e){var E=this._findEmptyPathParentContext(this.oElementContext),o=E.getBinding();if(!o.execute){return this.fetchValue("",undefined,true).then(function(h){return E._delete(G,h);});}return this.deleteFromCache(G,e,"",undefined,function(){o._destroyContextAfterDelete();});};
O.prototype._destroyContextAfterDelete=function(){this.oElementContext.destroy();this.oElementContext=null;if(this.oReturnValueContext){this.oReturnValueContext.destroy();this.oReturnValueContext=null;}this._fireChange({reason:d.Remove});};
O.prototype._execute=function(G,p){var M=this.oModel.getMetaModel(),o,P,r=this.getResolvedPath(),t=this;function e(){t._fireChange({reason:d.Change});return t.refreshDependentBindings("",G.getGroupId(),true);}P=M.fetchObject(M.getMetaPath(r)+"/@$ui5.overload").then(function(h){var i,I,j;if(!h){throw new Error("Unknown operation: "+r);}if(h.length!==1){throw new Error("Expected a single overload, but found "+h.length+" for "+r);}if(t.bRelative&&t.oContext.getBinding){I=t.sPath.lastIndexOf("/");j=I>=0?t.sPath.slice(0,I):"";i=t.oContext.getValue.bind(t.oContext,j);}o=h[0];return t.createCacheAndRequest(G,r,o,p,i);}).then(function(R){var h,i,j;return e().then(function(){if(t.isReturnValueLikeBindingParameter(o)){i=t.oContext.getValue();h=i&&c.getPrivateAnnotation(i,"predicate");j=c.getPrivateAnnotation(R,"predicate");if(h===j){t.oContext.patch(R);}}if(t.hasReturnValueContext(o)){if(t.oReturnValueContext){t.oReturnValueContext.destroy();}t.oReturnValueContext=C.createReturnValueContext(t.oModel,t,g(r,j));t.oCache.setResourcePath(t.oReturnValueContext.getPath().slice(1));return t.oReturnValueContext;}});},function(E){function h(i){var j,k;function l(){return o.$Parameter.some(function(n){return j===n.$Name;});}if(i.target){k=i.target.split("/");j=k.shift();if(o.$IsBound&&j===o.$Parameter[0].$Name){i.target=c.buildPath(t.oContext.getPath(),k.join("/"));return;}else if(l()){i.target=t.oParameterContext.getPath()+"/"+i.target;return;}}delete i.target;}if(o){if(E.error){h(E.error);if(E.error.details){E.error.details.forEach(h);}}}return e().then(function(){throw E;});}).catch(function(E){G.unlock(true);if(t.oReturnValueContext){t.oReturnValueContext.destroy();t.oReturnValueContext=null;}t.oModel.reportError("Failed to execute "+r,s,E);throw E;});return Promise.resolve(P);};
O.prototype.adjustPredicate=function(t,p){if(this.oElementContext){this.oElementContext.adjustPredicate(t,p);}};
O.prototype.applyParameters=function(p,e){this.mQueryOptions=this.oModel.buildQueryOptions(p,true);this.mParameters=p;if(this.isRootBindingSuspended()){this.sResumeChangeReason=d.Change;}else if(!this.oOperation){this.fetchCache(this.oContext);if(e){this.refreshInternal("",undefined,true).catch(function(){});}}else if(this.oOperation.bAction===false){this.execute();}};
O.prototype.attachEvent=function(e){if(!(e in m)){throw new Error("Unsupported event '"+e+"': v4.ODataContextBinding#attachEvent");}return f.prototype.attachEvent.apply(this,arguments);};
O.prototype.computeOperationQueryOptions=function(){return Object.assign({},this.oModel.mUriParameters,this.getQueryOptionsFromParameters());};
O.prototype.checkKeepAlive=function(){throw new Error("Unsupported "+this);};
O.prototype.createCacheAndRequest=function(G,p,o,P,e){var A=o.$kind==="Action",h,E=e,M=this.oModel,i=M.getMetaModel().getMetaPath(p)+"/@$ui5.overload/0/$ReturnType",j=p.slice(1),r=M.oRequestor,t=this;function k(R){if(t.hasReturnValueContext(o)){return g(j,c.getPrivateAnnotation(R,"predicate"));}if(t.isReturnValueLikeBindingParameter(o)&&c.getPrivateAnnotation(E,"predicate")===c.getPrivateAnnotation(R,"predicate")){return j.slice(0,j.lastIndexOf("/"));}return j;}if(!A&&o.$kind!=="Function"){throw new Error("Not an operation: "+p);}if(this.bInheritExpandSelect&&!this.isReturnValueLikeBindingParameter(o)){throw new Error("Must not set parameter $$inheritExpandSelect on this binding");}this.oOperation.bAction=A;if(A&&e){E=e();}this.oOperation.mRefreshParameters=P;P=Object.assign({},P);this.mCacheQueryOptions=this.computeOperationQueryOptions();p=r.getPathAndAddQueryOptions(p,o,P,this.mCacheQueryOptions,E);if(o.$ReturnType&&!o.$ReturnType.$Type.startsWith("Edm.")){i+="/$Type";}h=_.createSingle(r,p,this.mCacheQueryOptions,M.bAutoExpandSelect,M.bSharedRequests,k,A,i);this.oCache=h;this.oCachePromise=S.resolve(h);return A?h.post(G,P,E):h.fetchValue(G);};
O.prototype.destroy=function(){if(this.oElementContext){this.oElementContext.destroy();this.oElementContext=undefined;}if(this.oParameterContext){this.oParameterContext.destroy();this.oParameterContext=undefined;}if(this.oReturnValueContext){this.oReturnValueContext.destroy();this.oReturnValueContext=undefined;}this.oModel.bindingDestroyed(this);this.mCacheByResourcePath=undefined;this.oOperation=undefined;this.mParameters=undefined;this.mQueryOptions=undefined;a.prototype.destroy.call(this);f.prototype.destroy.call(this);};
O.prototype.doCreateCache=function(r,q,o,D){return _.createSingle(this.oModel.oRequestor,r,q,this.oModel.bAutoExpandSelect,this.oModel.bSharedRequests,function(){return D;});};
O.prototype.doDeregisterChangeListener=function(p,l){if(this.oOperation&&(p==="$Parameter"||p.startsWith("$Parameter/"))){c.removeByPath(this.oOperation.mChangeListeners,p.slice(11),l);return;}a.prototype.doDeregisterChangeListener.apply(this,arguments);};
O.prototype.doFetchQueryOptions=function(o){return this.fetchResolvedQueryOptions(o);};
O.prototype.doSetProperty=function(p,v,G){if(this.oOperation&&(p==="$Parameter"||p.startsWith("$Parameter/"))){c.updateAll(this.oOperation.mChangeListeners,"",this.oOperation.mParameters,_.makeUpdateData(p.split("/").slice(1),v));this.oOperation.bAction=undefined;if(G){G.unlock();}return S.resolve();}};
O.prototype.execute=function(G){var r=this.oModel.resolve(this.sPath,this.oContext);this.checkSuspended();this.oModel.checkGroupId(G);if(!this.oOperation){throw new Error("The binding must be deferred: "+this.sPath);}if(this.bRelative){if(!r){throw new Error("Unresolved binding: "+this.sPath);}if(this.oContext.isTransient&&this.oContext.isTransient()){throw new Error("Execute for transient context not allowed: "+r);}if(this.oContext.getPath().indexOf("(...)")>=0){throw new Error("Nested deferred operation bindings not supported: "+r);}}return this._execute(this.lockGroup(G,true),c.clone(this.oOperation.mParameters));};
O.prototype.fetchValue=function(p,l,e){var o=e&&this.oCache!==undefined?S.resolve(this.oCache):this.oCachePromise,E,r=this.getRootBinding(),t=this;if(r&&r.isSuspended()){E=new Error("Suspended binding provides no value");E.canceled="noDebugLog";throw E;}return o.then(function(h){var D=false,G,R=h||t.oOperation?t.getRelativePath(p):undefined,i,v;if(t.oOperation){if(R===undefined){return t.oContext.fetchValue(p,l,e);}i=R.split("/");if(i[0]==="$Parameter"){if(i.length===1){return undefined;}c.addByPath(t.oOperation.mChangeListeners,R.slice(11),l);v=c.drillDown(t.oOperation.mParameters,i.slice(1));return v===undefined?null:v;}}if(h&&R!==undefined){if(e){G=b.$cached;}else{G=t.oReadGroupLock||t.lockGroup();t.oReadGroupLock=undefined;}return t.resolveRefreshPromise(h.fetchValue(G,R,function(){D=true;t.fireDataRequested();},l)).then(function(v){t.assertSameCache(h);return v;}).then(function(v){if(D){t.fireDataReceived({data:{}});}return v;},function(E){G.unlock(true);if(D){t.oModel.reportError("Failed to read path "+t.sPath,s,E);t.fireDataReceived(E.canceled?{data:{}}:{error:E});}throw E;});}if(!t.oOperation&&t.oContext){return t.oContext.fetchValue(p,l,e);}});};
O.prototype.getDependentBindings=function(){return this.oModel.getDependentBindings(this);};
O.prototype.getParameterContext=function(){if(!this.oOperation){throw new Error("Not a deferred operation binding: "+this);}return this.oParameterContext;};
O.prototype.getQueryOptionsFromParameters=function(){var p,q;if(!this.bInheritExpandSelect){return this.mQueryOptions;}p=this.oContext.getBinding().getCacheQueryOptions();q=Object.assign({},this.mQueryOptions);if("$select"in p){q.$select=p.$select;}if("$expand"in p){q.$expand=p.$expand;}return q;};
O.prototype.getResolvedPath=function(){var p="",r=this.oModel.resolve(this.sPath,this.oContext),e,t=this;if(r&&r.includes("($uid=")){e=r.slice(1).split("/");r="";e.forEach(function(h){var E,P,T;p+="/"+h;T=h.indexOf("($uid=");if(T>=0){E=t.oContext.getValue(p);P=E&&c.getPrivateAnnotation(E,"predicate");if(!P){throw new Error("No key predicate known at "+p);}r+="/"+h.slice(0,T)+P;}else{r+="/"+h;}});}return r;};
O.prototype.hasReturnValueContext=function(M){var o=this.oModel.getMetaModel(),e;if(!this.isReturnValueLikeBindingParameter(M)){return false;}e=o.getMetaPath(this.oModel.resolve(this.sPath,this.oContext)).split("/");return e.length===3&&o.getObject("/"+e[1]).$kind==="EntitySet";};
O.prototype.initialize=function(){if(this.isResolved()){if(this.getRootBinding().isSuspended()){this.sResumeChangeReason=d.Change;}else{this._fireChange({reason:d.Change});}}};
O.prototype.isReturnValueLikeBindingParameter=function(M){if(!(this.bRelative&&this.oContext&&this.oContext.getBinding)){return false;}return M.$IsBound&&M.$ReturnType&&!M.$ReturnType.$isCollection&&M.$EntitySetPath&&M.$EntitySetPath.indexOf("/")<0;};
O.prototype.refreshInternal=function(r,G,e,k){var t=this;if(this.oOperation&&this.oOperation.bAction!==false){return S.resolve();}if(this.isRootBindingSuspended()){this.refreshSuspended(G);return this.refreshDependentBindings(r,G,e,k);}this.createReadGroupLock(G,this.isRoot());return this.oCachePromise.then(function(o){var p=t.oRefreshPromise,R=t.oReadGroupLock;if(!t.oElementContext){t.oElementContext=C.create(t.oModel,t,t.oModel.resolve(t.sPath,t.oContext));if(!o){t._fireChange({reason:d.Refresh});}}if(t.oOperation){t.oReadGroupLock=undefined;return t._execute(R,t.oOperation.mRefreshParameters);}if(o&&!p){t.removeCachesAndMessages(r);t.fetchCache(t.oContext);p=t.createRefreshPromise();if(k){p=p.catch(function(E){return t.fetchResourcePath(t.oContext).then(function(h){if(!t.bRelative||o.$resourcePath===h){t.oCache=o;t.oCachePromise=S.resolve(o);o.setActive(true);return t.checkUpdateInternal();}}).then(function(){throw E;});});}if(!e){t.fetchValue("").catch(function(){});}}return S.all([p,t.refreshDependentBindings(r,G,e,k)]);});};
O.prototype.refreshReturnValueContext=function(o,G){var e,M=this.oModel;if(this.oReturnValueContext!==o){return null;}this.mCacheQueryOptions=this.computeOperationQueryOptions();e=_.createSingle(M.oRequestor,this.oReturnValueContext.getPath().slice(1),this.mCacheQueryOptions,true,M.bSharedRequests);this.oCache=e;this.oCachePromise=S.resolve(e);this.createReadGroupLock(G,true);return this.refreshDependentBindings("",G,true);};
O.prototype.requestSideEffects=function(G,p,o){var M=this.oModel,n={},P=[],t=this;function r(h){return h.catch(function(E){M.reportError("Failed to request side effects",s,E);throw E;});}if(p.indexOf("")<0){try{P.push(this.oCache.requestSideEffects(this.lockGroup(G),p,n,o&&o.getPath().slice(1)));this.visitSideEffects(G,p,o,n,P);return S.all(P.map(r)).then(function(){return t.refreshDependentListBindingsWithoutCache();});}catch(e){if(!e.message.startsWith("Unsupported collection-valued navigation property ")){throw e;}}}return o&&this.refreshReturnValueContext(o,G)||this.refreshInternal("",G,true,true);};
O.prototype.requestObject=function(p){return this.oElementContext?this.oElementContext.requestObject(p):Promise.resolve();};
O.prototype.resumeInternal=function(e,p){var r=this.sResumeChangeReason;this.sResumeChangeReason=undefined;if(!this.oOperation){if(p||r){this.mAggregatedQueryOptions={};this.bAggregatedQueryOptionsInitial=true;this.removeCachesAndMessages("");this.fetchCache(this.oContext);}this.getDependentBindings().forEach(function(D){D.resumeInternal(e,!!r);});if(r){this._fireChange({reason:r});}}};
O.prototype.setContext=function(o){if(this.oContext!==o){if(this.bRelative&&(this.oContext||o)){if(this.oElementContext){this.oElementContext.destroy();this.oElementContext=null;}if(this.oReturnValueContext){this.oReturnValueContext.destroy();this.oReturnValueContext=null;}if(this.oParameterContext){this.oParameterContext.destroy();this.oParameterContext=null;}this.fetchCache(o);if(o){this.oElementContext=C.create(this.oModel,this,this.oModel.resolve(this.sPath,o));if(this.oOperation){this.oParameterContext=C.create(this.oModel,this,this.oModel.resolve(this.sPath+"/$Parameter",o));}}B.prototype.setContext.call(this,o);}else{this.oContext=o;}}};
O.prototype.setParameter=function(p,v){var o;if(!this.oOperation){throw new Error("The binding must be deferred: "+this.sPath);}if(!p){throw new Error("Missing parameter name");}if(v===undefined){throw new Error("Missing value for parameter: "+p);}o=this.oOperation.mParameters[p];this.oOperation.mParameters[p]=v;c.informAll(this.oOperation.mChangeListeners,p,o,v);this.oOperation.bAction=undefined;return this;};
return O;});
sap.ui.predefine('sap/ui/model/odata/v4/ODataListBinding',["./Context","./ODataParentBinding","./lib/_AggregationCache","./lib/_AggregationHelper","./lib/_Cache","./lib/_GroupLock","./lib/_Helper","sap/base/Log","sap/base/util/uid","sap/ui/base/SyncPromise","sap/ui/model/Binding","sap/ui/model/ChangeReason","sap/ui/model/FilterOperator","sap/ui/model/FilterProcessor","sap/ui/model/FilterType","sap/ui/model/ListBinding","sap/ui/model/Sorter","sap/ui/model/odata/OperationMode"],function(C,a,_,b,c,d,e,L,u,S,B,f,F,g,h,j,k,O){"use strict";var s="sap.ui.model.odata.v4.ODataListBinding",m={AggregatedDataStateChange:true,change:true,createCompleted:true,createSent:true,dataReceived:true,dataRequested:true,DataStateChange:true,patchCompleted:true,patchSent:true,refresh:true};
var l=j.extend("sap.ui.model.odata.v4.ODataListBinding",{constructor:function(M,p,o,v,i,P){j.call(this,M,p);a.call(this);if(p.endsWith("/")){throw new Error("Invalid path: "+p);}P=e.clone(P)||{};this.checkBindingParameters(P,["$$aggregation","$$canonicalPath","$$groupId","$$operationMode","$$ownRequest","$$patchWithoutSideEffects","$$sharedRequest","$$updateGroupId"]);this.aApplicationFilters=e.toArray(i);this.sChangeReason=M.bAutoExpandSelect&&!P.$$aggregation?"AddVirtualContext":undefined;this.oDiff=undefined;this.aFilters=[];this.sGroupId=P.$$groupId;this.bHasAnalyticalInfo=false;this.oHeaderContext=this.bRelative?null:C.create(M,this,p);this.sOperationMode=P.$$operationMode||M.sOperationMode;this.mPreviousContextsByPath={};this.aPreviousData=[];this.bSharedRequest=P.$$sharedRequest||M.bSharedRequests;this.aSorters=e.toArray(v);this.sUpdateGroupId=P.$$updateGroupId;if(!this.sOperationMode&&(this.aSorters.length||this.aApplicationFilters.length)){throw new Error("Unsupported operation mode: "+this.sOperationMode);}this.applyParameters(P);if(!this.bRelative||o&&!o.fetchValue){this.createReadGroupLock(this.getGroupId(),true);}this.setContext(o);M.bindingCreated(this);}});
a(l.prototype);
l.prototype.attachCreateCompleted=function(i,o){this.attachEvent("createCompleted",i,o);};
l.prototype.detachCreateCompleted=function(i,o){this.detachEvent("createCompleted",i,o);};
l.prototype.attachCreateSent=function(i,o){this.attachEvent("createSent",i,o);};
l.prototype.detachCreateSent=function(i,o){this.detachEvent("createSent",i,o);};
l.prototype._delete=function(G,E,o,n){var p=false,P=o.iIndex===undefined?e.getRelativePath(o.getPath(),this.oHeaderContext.getPath()):String(o.iIndex),t=this;return this.deleteFromCache(G,E,P,n,function(I,q){var r,i,v,R,w;if(o.created()){t.destroyCreated(o,true);p=true;}else if(I>=0){for(i=I;i<t.aContexts.length;i+=1){o=t.aContexts[i];if(o){t.mPreviousContextsByPath[o.getPath()]=o;}}R=t.oModel.resolve(t.sPath,t.oContext);t.aContexts.splice(I,1);for(i=I;i<t.aContexts.length;i+=1){if(t.aContexts[i]){w=i-t.iCreatedContexts;v=e.getPrivateAnnotation(q[i],"predicate");r=R+(v||"/"+w);o=t.mPreviousContextsByPath[r];if(o){delete t.mPreviousContextsByPath[r];if(o.iIndex===w){o.checkUpdate();}else{o.iIndex=w;}}else{o=C.create(t.oModel,t,r,w);}t.aContexts[i]=o;}}t.iMaxLength-=1;p=true;}else{t.iMaxLength-=1;o.destroy();delete t.mPreviousContextsByPath[o.getPath()];}}).then(function(){if(p){t._fireChange({reason:f.Remove});}});};
l.prototype.adjustPredicate=function(t,p,o){var i=this;function n(q,N){var I=i.aPreviousData.indexOf(q);if(I>=0){i.aPreviousData[I]=N;}}if(o){o.adjustPredicate(t,p,n);}else{this.oHeaderContext.adjustPredicate(t,p);this.aContexts.forEach(function(o){o.adjustPredicate(t,p,n);});}};
l.prototype.applyParameters=function(p,i){var A,o=this.mParameters&&this.mParameters.$$aggregation,n=this.mQueryOptions&&this.mQueryOptions.$apply;if("$$aggregation"in p){if("$apply"in p){throw new Error("Cannot combine $$aggregation and $apply");}A=b.buildApply(p.$$aggregation).$apply;}this.mQueryOptions=this.oModel.buildQueryOptions(p,true);this.mParameters=p;if(A){this.mQueryOptions.$apply=A;}if(i===""){if(this.mQueryOptions.$apply===n&&(!this.mParameters.$$aggregation||!o||e.deepEqual(this.mParameters.$$aggregation,o))){return;}i=this.bHasAnalyticalInfo?f.Change:f.Filter;}if(this.isRootBindingSuspended()){this.setResumeChangeReason(i);return;}this.removeCachesAndMessages("");this.fetchCache(this.oContext);this.reset(i);};
l.prototype.attachEvent=function(E){if(!(E in m)){throw new Error("Unsupported event '"+E+"': v4.ODataListBinding#attachEvent");}return j.prototype.attachEvent.apply(this,arguments);};
l.prototype.checkKeepAlive=function(o){if(this.isRelative()&&!this.mParameters.$$ownRequest){throw new Error("Missing $$ownRequest at "+this);}if(o===this.oHeaderContext){throw new Error("Unsupported header context "+o);}if(this.mParameters.$$aggregation){throw new Error("Unsupported $$aggregation at "+this);}};
l.prototype.create=function(i,n,A){var o,p=this.fetchResourcePath(),q,G,r=this.oModel.resolve(this.sPath,this.oContext),t="($uid="+u()+")",T=r+t,v=this;if(!r){throw new Error("Binding is unresolved: "+this);}this.checkSuspended();A=!!A;if(A&&!this.bLengthFinal){throw new Error("Must know the final length to create at the end. Consider setting $count");}if(this.bCreatedAtEnd!==undefined&&this.bCreatedAtEnd!==A){throw new Error("Creating entities at the start and at the end is not supported.");}this.bCreatedAtEnd=A;G=this.lockGroup(undefined,true,true,function(){v.destroyCreated(o,true);return Promise.resolve().then(function(){v._fireChange({reason:f.Remove});});});q=this.createInCache(G,p,"",t,i,function(E){v.oModel.reportError("POST on '"+p+"' failed; will be repeated automatically",s,E);v.fireEvent("createCompleted",{context:o,success:false});},function(){v.fireEvent("createSent",{context:o});}).then(function(w){var x,P;if(!(i&&i["@$ui5.keepTransientPath"])){P=e.getPrivateAnnotation(w,"predicate");if(P){v.adjustPredicate(t,P,o);v.oModel.checkMessages();}}v.fireEvent("createCompleted",{context:o,success:true});if(!n){x=v.getGroupId();if(!v.oModel.isDirectGroup(x)&&!v.oModel.isAutoGroup(x)){x="$auto";}return v.refreshSingle(o,v.lockGroup(x));}},function(E){G.unlock(true);throw E;});this.iCreatedContexts+=1;o=C.create(this.oModel,this,T,-this.iCreatedContexts,q);this.aContexts.unshift(o);this._fireChange({reason:f.Add});return o;};
l.prototype.createContexts=function(n,o,r){var p=false,q,t,i,v=r.$count,w,x=this.bLengthFinal,M=this.oModel,P=M.resolve(this.sPath,this.oContext),y,z=n>this.aContexts.length,A=this;function D(){var i,N=A.iMaxLength+A.iCreatedContexts;if(N>=A.aContexts.length){return;}for(i=N;i<A.aContexts.length;i+=1){if(A.aContexts[i]){A.aContexts[i].destroy();}}while(N>0&&!A.aContexts[N-1]){N-=1;}A.aContexts.length=N;p=true;}for(i=n;i<n+r.length;i+=1){if(this.aContexts[i]===undefined&&r[i-n]){p=true;w=i-this.iCreatedContexts;y=e.getPrivateAnnotation(r[i-n],"predicate")||e.getPrivateAnnotation(r[i-n],"transientPredicate");t=P+(y||"/"+w);q=this.mPreviousContextsByPath[t];if(q&&(!q.created()||q.isTransient())){delete this.mPreviousContextsByPath[t];q.iIndex=w;q.checkUpdate();}else{q=C.create(M,this,t,w);}this.aContexts[i]=q;}}if(Object.keys(this.mPreviousContextsByPath).length){M.addPrerenderingTask(this.destroyPreviousContexts.bind(this));}if(v!==undefined){this.bLengthFinal=true;this.iMaxLength=v-this.iCreatedContexts;D();}else{if(!r.length){this.iMaxLength=n-this.iCreatedContexts;D();}else if(this.aContexts.length>this.iMaxLength+this.iCreatedContexts){this.iMaxLength=Infinity;}if(!(z&&r.length===0)){this.bLengthFinal=this.aContexts.length===this.iMaxLength+this.iCreatedContexts;}}if(this.bLengthFinal!==x){p=true;}return p;};
l.prototype.destroy=function(){if(this.bHasAnalyticalInfo&&this.aContexts===undefined){return;}this.aContexts.forEach(function(o){o.destroy();});this.destroyPreviousContexts(true);if(this.oHeaderContext){this.oHeaderContext.destroy();}this.oModel.bindingDestroyed(this);this.aApplicationFilters=undefined;this.aContexts=undefined;this.oDiff=undefined;this.aFilters=undefined;this.oHeaderContext=undefined;this.mPreviousContextsByPath=undefined;this.aPreviousData=undefined;this.mQueryOptions=undefined;this.aSorters=undefined;a.prototype.destroy.call(this);j.prototype.destroy.call(this);};
l.prototype.destroyCreated=function(o,D){var i,I=o.getModelIndex();this.iCreatedContexts-=1;for(i=0;i<I;i+=1){this.aContexts[i].iIndex+=1;}if(!this.iCreatedContexts){this.bCreatedAtEnd=undefined;}this.aContexts.splice(I,1);if(D&&this.iCurrentEnd){this.mPreviousContextsByPath[o.getPath()]=o;}else{o.destroy();}};
l.prototype.destroyPreviousContexts=function(A){var p=this.mPreviousContextsByPath;if(p){Object.keys(p).forEach(function(P){var o=p[P];if(A||!o.isKeepAlive()){o.destroy();delete p[P];}else{o.iIndex=undefined;}});}};
l.prototype.doCreateCache=function(r,q,o,D){var A=this.mParameters.$$aggregation,i=A&&(A.groupLevels.length||b.hasMinOrMax(A.aggregate)||b.hasGrandTotal(A.aggregate));q=this.inheritQueryOptions(q,o);if(!i&&q.$$filterBeforeAggregate){q.$apply="filter("+q.$$filterBeforeAggregate+")/"+q.$apply;delete q.$$filterBeforeAggregate;}return i?_.create(this.oModel.oRequestor,r,A,q):c.create(this.oModel.oRequestor,r,q,this.oModel.bAutoExpandSelect,D,this.bSharedRequest);};
l.prototype.doFetchQueryOptions=function(o){var t=this;return this.fetchResolvedQueryOptions(o).then(function(q){return t.fetchFilter(o,q.$filter).then(function(i){return e.mergeQueryOptions(q,t.getOrderby(q.$orderby),i);});});};
l.prototype.doSetProperty=function(){};
l.prototype.expand=function(o){var D=false,t=this;this.checkSuspended();return this.oCache.expand(this.lockGroup(),e.getRelativePath(o.getPath(),this.oHeaderContext.getPath()),function(){D=true;t.fireDataRequested();}).then(function(n){var p=t.aContexts,M=o.getModelIndex(),q,i;for(i=p.length-1;i>M;i-=1){q=p[i];if(q){q.iIndex+=n;p[i+n]=q;delete p[i];}}t.iMaxLength+=n;t._fireChange({reason:f.Change});if(D){t.fireDataReceived({});}},function(E){if(D){t.fireDataReceived({error:E});}throw E;});};
l.prototype.fetchCache=function(){var o=this.oCache,i=this.oModel.resolve(this.sPath,this.oContext),t=this;a.prototype.fetchCache.apply(this,arguments);if(o){this.oCachePromise.then(function(n){Object.keys(t.mPreviousContextsByPath).forEach(function(p){var q=t.mPreviousContextsByPath[p];if(q.isKeepAlive()){n.addKeptElement(o.getValue(e.getRelativePath(p,i)));q.checkUpdate();}});if(n&&n.hasChangeListeners()){n.setLateQueryOptions(o.getLateQueryOptions());}});}};
l.prototype.fetchContexts=function(i,n,M,G,A,D){var p,t=this;if(this.bCreatedAtEnd){i+=this.iCreatedContexts;}G=G||this.lockGroup();p=this.fetchData(i,n,M,G,D);if(A){p=Promise.resolve(p);}return p.then(function(r){return r&&t.createContexts(i,n,r.value);},function(E){G.unlock(true);throw E;});};
l.prototype.fetchData=function(i,n,M,G,D){var o=this.oContext,t=this;return this.oCachePromise.then(function(p){if(t.bRelative&&o!==t.oContext){return undefined;}if(p){return p.read(i,n,M,G,D).then(function(r){t.assertSameCache(p);return r;});}G.unlock();return o.fetchValue(t.sReducedPath).then(function(r){var q;r=r||[];q=r.$count;r=r.slice(i,i+n);r.$count=q;return{value:r};});});};
l.prototype.fetchDownloadUrl=function(){var U=this.oModel.mUriParameters;if(!this.isResolved()){throw new Error("Binding is unresolved");}return this.withCache(function(o,p){return o.getDownloadUrl(p,U);});};
l.prototype.fetchFilter=function(o,i){var n,p,M,q;function r(x,E,W){var y,z,T,V;function A(D){return T?"tolower("+D+")":D;}T=E==="Edm.String"&&x.bCaseSensitive===false;z=A(decodeURIComponent(x.sPath));V=A(e.formatLiteral(x.oValue1,E));switch(x.sOperator){case F.BT:y=z+" ge "+V+" and "+z+" le "+A(e.formatLiteral(x.oValue2,E));break;case F.NB:y=w(z+" lt "+V+" or "+z+" gt "+A(e.formatLiteral(x.oValue2,E)),W);break;case F.EQ:case F.GE:case F.GT:case F.LE:case F.LT:case F.NE:y=z+" "+x.sOperator.toLowerCase()+" "+V;break;case F.Contains:case F.EndsWith:case F.NotContains:case F.NotEndsWith:case F.NotStartsWith:case F.StartsWith:y=x.sOperator.toLowerCase().replace("not","not ")+"("+z+","+V+")";break;default:throw new Error("Unsupported operator: "+x.sOperator);}return y;}function t(x,y,W){var R;if(!x){return S.resolve();}if(x.aFilters){return S.all(x.aFilters.map(function(z){return t(z,y,x.bAnd);})).then(function(z){return w(z.join(x.bAnd?" and ":" or "),W&&!x.bAnd);});}R=M.resolve(v(x.sPath,y),q);return M.fetchObject(R).then(function(P){var z,A,D;if(!P){throw new Error("Type cannot be determined, no metadata for path: "+R);}D=x.sOperator;if(D===F.All||D===F.Any){z=x.oCondition;A=x.sVariable;if(D===F.Any&&!z){return x.sPath+"/any()";}y=Object.create(y);y[A]=v(x.sPath,y);return t(z,y).then(function(E){return x.sPath+"/"+x.sOperator.toLowerCase()+"("+A+":"+E+")";});}return r(x,P.$Type,W);});}function v(P,x){var y=P.split("/");y[0]=x[y[0]];return y[0]?y.join("/"):P;}function w(x,W){return W?"("+x+")":x;}n=g.combineFilters(this.aFilters,this.aApplicationFilters);if(!n){return S.resolve([i]);}p=b.splitFilter(n,this.mParameters.$$aggregation);M=this.oModel.getMetaModel();q=M.getMetaContext(this.oModel.resolve(this.sPath,o));return S.all([t(p[0],{},i).then(function(x){return x&&i?x+" and ("+i+")":x||i;}),t(p[1],{})]);};
l.prototype.fetchValue=function(p,o,i){var n=i&&this.oCache!==undefined?S.resolve(this.oCache):this.oCachePromise,t=this;return n.then(function(q){var G,r;if(q){G=i?d.$cached:t.lockGroup();r=t.getRelativePath(p);if(r!==undefined){return q.fetchValue(G,r,undefined,o);}}if(t.oContext){return t.oContext.fetchValue(p,o,i);}});};
l.prototype.filter=function(v,i){if(this.sOperationMode!==O.Server){throw new Error("Operation mode has to be sap.ui.model.odata.OperationMode.Server");}if(this.hasPendingChanges()){throw new Error("Cannot filter due to pending changes");}if(i===h.Control){this.aFilters=e.toArray(v);}else{this.aApplicationFilters=e.toArray(v);}if(this.isRootBindingSuspended()){this.setResumeChangeReason(f.Filter);return this;}this.createReadGroupLock(this.getGroupId(),true);this.removeCachesAndMessages("");this.fetchCache(this.oContext);this.reset(f.Filter);return this;};
l.prototype.getContexts=function(i,n,M){var o,p,D=false,q=false,G,P,r=!!this.sChangeReason,R=this.oModel.resolve(this.sPath,this.oContext),v,t=this;L.debug(this+"#getContexts("+i+", "+n+", "+M+")",undefined,s);this.checkSuspended();if(i!==0&&this.bUseExtendedChangeDetection){throw new Error("Unsupported operation: v4.ODataListBinding#getContexts,"+" first parameter must be 0 if extended change detection is enabled, but is "+i);}if(M!==undefined&&this.bUseExtendedChangeDetection){throw new Error("Unsupported operation: v4.ODataListBinding#getContexts,"+" third parameter must not be set if extended change detection is enabled");}if(!this.isResolved()){this.aPreviousData=[];return[];}o=this.sChangeReason||f.Change;this.sChangeReason=undefined;if(o==="AddVirtualContext"){this.oModel.addPrerenderingTask(function(){var w=t.bUseExtendedChangeDetection;if(t.aContexts===undefined){v.destroy();return;}if(!t.isRootBindingSuspended()){t.bUseExtendedChangeDetection=false;t.getContexts(i,n,M);t.bUseExtendedChangeDetection=w;}t.oModel.addPrerenderingTask(function(){if(t.aContexts&&!t.isRootBindingSuspended()){t.sChangeReason="RemoveVirtualContext";t._fireChange({detailedReason:"RemoveVirtualContext",reason:f.Change});t.reset(f.Refresh);}v.destroy();});},true);v=C.create(this.oModel,this,R+"/"+C.VIRTUAL,C.VIRTUAL);return[v];}if(o==="RemoveVirtualContext"||(this.oContext&&this.oContext.iIndex===C.VIRTUAL)){return[];}i=i||0;n=n||this.oModel.iSizeLimit;if(!M||M<0){M=0;}G=this.oReadGroupLock;this.oReadGroupLock=undefined;if(!this.oDiff){P=this.fetchContexts(i,n,M,G,r,function(){D=true;t.fireDataRequested();});this.resolveRefreshPromise(P);P.then(function(w){if(t.bUseExtendedChangeDetection){t.oDiff={aDiff:t.getDiff(n),iLength:n};}if(q){if(w||(t.oDiff&&t.oDiff.aDiff.length)){t._fireChange({reason:o});}else{t.oDiff=undefined;}}if(D){t.fireDataReceived({data:{}});}},function(E){if(D){t.fireDataReceived(E.canceled?{data:{}}:{error:E});}throw E;}).catch(function(E){t.oModel.reportError("Failed to get contexts for "+t.oModel.sServiceUrl+R.slice(1)+" with start index "+i+" and length "+n,s,E);});q=true;}this.iCurrentBegin=i;this.iCurrentEnd=i+n;p=this.getContextsInViewOrder(i,n);if(this.bUseExtendedChangeDetection){if(this.oDiff&&n!==this.oDiff.iLength){throw new Error("Extended change detection protocol violation: Expected "+"getContexts(0,"+this.oDiff.iLength+"), but got getContexts(0,"+n+")");}p.dataRequested=!this.oDiff;p.diff=this.oDiff?this.oDiff.aDiff:[];}this.oDiff=undefined;return p;};
l.prototype.getContextsInViewOrder=function(n,o){var p,i,q;if(this.bCreatedAtEnd){p=[];q=Math.min(o,this.getLength()-n);for(i=0;i<q;i+=1){p[i]=this.aContexts[this.getModelIndex(n+i)];}}else{p=this.aContexts.slice(n,n+o);}return p;};
l.prototype.getCurrentContexts=function(){var i,n=Math.min(this.iCurrentEnd,this.iMaxLength+this.iCreatedContexts)-this.iCurrentBegin;i=this.getContextsInViewOrder(this.iCurrentBegin,n);while(i.length<n){i.push(undefined);}return i;};
l.prototype.getDependentBindings=function(){var t=this;return this.oModel.getDependentBindings(this).filter(function(D){return!(D.oContext.getPath()in t.mPreviousContextsByPath);});};
l.prototype.getDiff=function(i){var p=this.aPreviousData,t=this;this.aPreviousData=this.getContextsInViewOrder(0,i).map(function(o){return t.getContextData(o);});return this.diffData(p,this.aPreviousData);};
l.prototype.getDistinctValues=function(){throw new Error("Unsupported operation: v4.ODataListBinding#getDistinctValues");};
l.prototype.getDownloadUrl=e.createGetMethod("fetchDownloadUrl",true);
l.prototype.getEntryData=function(o){return JSON.stringify(o.getValue());};
l.prototype.getEntryKey=function(o){return o.getPath();};
l.prototype.getFilterInfo=function(i){var o=g.combineFilters(this.aFilters,this.aApplicationFilters),r=null,n;if(o){r=o.getAST(i);}if(this.mQueryOptions.$filter){n={expression:this.mQueryOptions.$filter,syntax:"OData "+this.oModel.getODataVersion(),type:"Custom"};if(r){r={left:r,op:"&&",right:n,type:"Logical"};}else{r=n;}}return r;};
l.prototype.getHeaderContext=function(){return this.isResolved()?this.oHeaderContext:null;};
l.prototype.getModelIndex=function(v){if(!this.bCreatedAtEnd){return v;}return v<this.getLength()-this.iCreatedContexts?v+this.iCreatedContexts:this.getLength()-v-1;};
l.prototype.getLength=function(){if(this.bLengthFinal){return this.iMaxLength+this.iCreatedContexts;}return this.aContexts.length?this.aContexts.length+10:0;};
l.prototype.getOrderby=function(o){var i=[],t=this;this.aSorters.forEach(function(n){if(n instanceof k){i.push(n.sPath+(n.bDescending?" desc":""));}else{throw new Error("Unsupported sorter: "+n+" - "+t);}});if(o){i.push(o);}return i.join(',');};
l.prototype.getQueryOptions=function(w){var r={},t=this;if(w){throw new Error("Unsupported parameter value: bWithSystemQueryOptions: "+w);}Object.keys(this.mQueryOptions).forEach(function(K){if(K[0]!=="$"){r[K]=e.clone(t.mQueryOptions[K]);}});return r;};
l.prototype.getQueryOptionsFromParameters=function(){return this.mQueryOptions;};
l.prototype.hasPendingChangesForPath=function(p){if(this.oCache===undefined){return this.iCreatedContexts>0;}return a.prototype.hasPendingChangesForPath.apply(this,arguments);};
l.prototype.inheritQueryOptions=function(q,o){var i;if(!Object.keys(this.mParameters).length){i=this.getQueryOptionsForPath("",o);if(q.$orderby&&i.$orderby){q.$orderby+=","+i.$orderby;}if(q.$filter&&i.$filter){q.$filter="("+q.$filter+") and ("+i.$filter+")";}q=Object.assign({},i,q);e.aggregateQueryOptions(q,i);}return q;};
l.prototype.initialize=function(){if(this.isResolved()){if(this.getRootBinding().isSuspended()){this.sResumeChangeReason=this.sChangeReason==="AddVirtualContext"?f.Change:f.Refresh;}else if(this.sChangeReason==="AddVirtualContext"){this._fireChange({detailedReason:"AddVirtualContext",reason:f.Change});}else{this.sChangeReason=f.Refresh;this._fireRefresh({reason:f.Refresh});}}};
l.prototype.isLengthFinal=function(){return this.bLengthFinal;};
l.prototype.refreshInternal=function(r,G,i,K){var t=this;function n(o){return o.map(function(p){return p.refreshInternal(r,G,false,K);});}if(this.isRootBindingSuspended()){this.refreshSuspended(G);return S.all(n(t.getDependentBindings()));}this.createReadGroupLock(G,this.isRoot());return this.oCachePromise.then(function(o){var D,p=t.oRefreshPromise;if(o&&!p){t.removeCachesAndMessages(r);t.fetchCache(t.oContext);p=t.createRefreshPromise();if(K){p=p.catch(function(E){return t.fetchResourcePath(t.oContext).then(function(R){if(!t.bRelative||o.$resourcePath===R){t.oCache=o;t.oCachePromise=S.resolve(o);o.setActive(true);t._fireChange({reason:f.Change});}throw E;});});}}D=t.getDependentBindings();t.reset(f.Refresh);return S.all(n(D).concat(p));});};
l.prototype.refreshSingle=function(o,G,A){var r=o.getPath().slice(1),t=this;if(o===this.oHeaderContext){throw new Error("Unsupported header context: "+o);}return this.withCache(function(n,p,q){var D=false,P=[],R=false;function v(i){if(D){t.fireDataReceived(i);}}function w(){D=true;t.fireDataRequested();}function x(){var i,I;if(o.created()){t.destroyCreated(o);}else{I=o.getModelIndex();t.aContexts.splice(I,1);for(i=I;i<t.aContexts.length;i+=1){if(t.aContexts[i]){t.aContexts[i].iIndex-=1;}}o.destroy();t.iMaxLength-=1;}R=true;t._fireChange({reason:f.Remove});}P.push((A?n.refreshSingleWithRemove(G,p,o.getModelIndex(),w,x):n.refreshSingle(G,p,o.getModelIndex(),w)).then(function(E){var U=[];v({data:{}});if(!R){U.push(o.checkUpdate());if(A){U.push(t.refreshDependentBindings(r,G.getGroupId()));}}return S.all(U).then(function(){return E;});},function(E){v({error:E});throw E;}).catch(function(E){G.unlock(true);t.oModel.reportError("Failed to refresh entity: "+o,s,E);}));if(!A){P.push(t.refreshDependentBindings(r,G.getGroupId()));}return S.all(P).then(function(i){return i[0];});});};
l.prototype.requestContexts=function(i,n,G){var t=this;if(!this.isResolved()){throw new Error("Unresolved binding: "+this.sPath);}this.checkSuspended();this.oModel.checkGroupId(G);i=i||0;n=n||this.oModel.iSizeLimit;return Promise.resolve(this.fetchContexts(i,n,0,this.lockGroup(G,true))).then(function(o){if(o){t._fireChange({reason:f.Change});}return t.getContextsInViewOrder(i,n);},function(E){t.oModel.reportError("Failed to get contexts for "+t.oModel.sServiceUrl+t.oModel.resolve(t.sPath,t.oContext).slice(1)+" with start index "+i+" and length "+n,s,E);throw E;});};
l.prototype.requestDownloadUrl=e.createRequestMethod("fetchDownloadUrl");
l.prototype.requestSideEffects=function(G,p,o){var A,M=this.oModel,n={},P,i,q=o&&o!==this.oHeaderContext,t=this;function r(P){return P.catch(function(E){M.reportError("Failed to request side effects",s,E);throw E;});}if(this.mParameters.$$aggregation){if(q){throw new Error("Must not request side effects for a context of a binding with $$aggregation");}if(b.isAffected(this.mParameters.$$aggregation,this.aFilters.concat(this.aApplicationFilters),p)){return this.refreshInternal("",G,false,true);}return S.resolve();}if(p.indexOf("")<0){P=this.oCache.requestSideEffects(this.lockGroup(G),p,n,q?o.getModelIndex():this.iCurrentBegin,q?undefined:this.iCurrentEnd-this.iCurrentBegin);if(P){i=[P];this.visitSideEffects(G,p,q?o:undefined,n,i);return S.all(i.map(r)).then(function(){return t.refreshDependentListBindingsWithoutCache();});}}if(q){return this.refreshSingle(o,this.lockGroup(G),false);}if(this.aContexts.length){A=this.aContexts.every(function(o){return o.isTransient();});if(A){return S.resolve();}}return this.refreshInternal("",G,false,true);};
l.prototype.reset=function(i){var E=this.iCurrentEnd===0,t=this;if(this.aContexts){this.aContexts.forEach(function(o){t.mPreviousContextsByPath[o.getPath()]=o;});}this.aContexts=[];this.iCreatedContexts=0;this.bCreatedAtEnd=undefined;this.iCurrentBegin=this.iCurrentEnd=0;this.iMaxLength=Infinity;this.bLengthFinal=false;if(i&&!(E&&i===f.Change)){this.sChangeReason=i;this._fireRefresh({reason:i});}if(this.getHeaderContext()){this.oModel.getDependentBindings(this.oHeaderContext).forEach(function(o){o.checkUpdate();});}};
l.prototype.resetKeepAlive=function(){var p=this.mPreviousContextsByPath;function r(o){if(o.isKeepAlive()){o.setKeepAlive(false);}}Object.keys(p).forEach(function(P){r(p[P]);});this.aContexts.forEach(r);};
l.prototype.resumeInternal=function(i,p){var n=this.getDependentBindings(),r=this.sResumeChangeReason,R=p||r;this.sResumeChangeReason=undefined;if(R){this.removeCachesAndMessages("");this.reset();this.fetchCache(this.oContext,!p);}n.forEach(function(D){D.resumeInternal(!R,!!r);});if(this.sChangeReason==="AddVirtualContext"){this._fireChange({detailedReason:"AddVirtualContext",reason:r});}else if(r){this._fireRefresh({reason:r});}this.oModel.getDependentBindings(this.oHeaderContext).forEach(function(o){o.checkUpdate();});};
l.prototype.setAggregation=function(A){var p;if(this.hasPendingChanges()){throw new Error("Cannot set $$aggregation due to pending changes");}p=Object.assign({},this.mParameters);if(A===undefined){delete p.$$aggregation;}else{p.$$aggregation=e.clone(A);this.resetKeepAlive();}this.applyParameters(p,"");};
l.prototype.setContext=function(o){var i,r,t=this;if(this.oContext!==o){if(this.bRelative){this.checkSuspended();for(i=0;i<t.iCreatedContexts;i+=1){if(t.aContexts[i].isTransient()){throw new Error("setContext on relative binding is forbidden if a "+"transient entity exists: "+t);}}this.reset();this.resetKeepAlive();this.fetchCache(o);if(o){r=this.oModel.resolve(this.sPath,o);if(this.oHeaderContext&&this.oHeaderContext.getPath()!==r){this.oHeaderContext.destroy();this.oHeaderContext=null;}if(!this.oHeaderContext){this.oHeaderContext=C.create(this.oModel,this,r);}}B.prototype.setContext.call(this,o,this.sChangeReason);}else{this.oContext=o;}}};
l.prototype.sort=function(v){if(this.sOperationMode!==O.Server){throw new Error("Operation mode has to be sap.ui.model.odata.OperationMode.Server");}if(this.hasPendingChanges()){throw new Error("Cannot sort due to pending changes");}this.aSorters=e.toArray(v);if(this.isRootBindingSuspended()){this.setResumeChangeReason(f.Sort);return this;}this.createReadGroupLock(this.getGroupId(),true);this.removeCachesAndMessages("");this.fetchCache(this.oContext);this.reset(f.Sort);return this;};
l.prototype.updateAnalyticalInfo=function(A){var o={aggregate:{},group:{}},H=false,t=this;A.forEach(function(i){var D={};if("total"in i){if("grouped"in i){throw new Error("Both dimension and measure: "+i.name);}if(i.as){D.name=i.name;o.aggregate[i.as]=D;}else{o.aggregate[i.name]=D;}if(i.min){D.min=true;H=true;}if(i.max){D.max=true;H=true;}if(i.with){D.with=i.with;}}else if(!("grouped"in i)||i.inResult||i.visible){o.group[i.name]=D;}});this.bHasAnalyticalInfo=true;this.setAggregation(o);if(H){return{measureRangePromise:Promise.resolve(this.getRootBindingResumePromise().then(function(){return t.oCachePromise;}).then(function(i){return i.getMeasureRangePromise();}))};}};
return l;});
sap.ui.predefine('sap/ui/model/odata/v4/ODataMetaModel',["./ValueListType","./lib/_Helper","sap/base/assert","sap/base/Log","sap/base/util/isEmptyObject","sap/base/util/JSTokenizer","sap/base/util/ObjectPath","sap/ui/base/SyncPromise","sap/ui/model/BindingMode","sap/ui/model/ChangeReason","sap/ui/model/ClientListBinding","sap/ui/model/Context","sap/ui/model/ContextBinding","sap/ui/model/MetaModel","sap/ui/model/PropertyBinding","sap/ui/model/odata/OperationMode","sap/ui/model/odata/type/Boolean","sap/ui/model/odata/type/Byte","sap/ui/model/odata/type/Date","sap/ui/model/odata/type/DateTimeOffset","sap/ui/model/odata/type/Decimal","sap/ui/model/odata/type/Double","sap/ui/model/odata/type/Guid","sap/ui/model/odata/type/Int16","sap/ui/model/odata/type/Int32","sap/ui/model/odata/type/Int64","sap/ui/model/odata/type/Raw","sap/ui/model/odata/type/SByte","sap/ui/model/odata/type/Single","sap/ui/model/odata/type/Stream","sap/ui/model/odata/type/String","sap/ui/model/odata/type/TimeOfDay","sap/ui/thirdparty/URI"],function(V,_,a,L,b,J,O,S,B,C,c,d,f,M,P,g,h,k,E,D,l,m,G,I,o,p,R,q,r,s,t,T,U){"use strict";var u,v=new Map(),w=L.Level.DEBUG,x=/\$\(/g,y=/^-?\d+$/,z,A,F="sap.ui.model.odata.v4.ODataMetaModel",H,K=/\(.*\)$/,N=new R(),Q=/\$\)/g,W=new Map(),X={messageChange:true},Y={"Edm.Boolean":{Type:h},"Edm.Byte":{Type:k},"Edm.Date":{Type:E},"Edm.DateTimeOffset":{constraints:{"$Precision":"precision"},Type:D},"Edm.Decimal":{constraints:{"@Org.OData.Validation.V1.Minimum/$Decimal":"minimum","@Org.OData.Validation.V1.Minimum@Org.OData.Validation.V1.Exclusive":"minimumExclusive","@Org.OData.Validation.V1.Maximum/$Decimal":"maximum","@Org.OData.Validation.V1.Maximum@Org.OData.Validation.V1.Exclusive":"maximumExclusive","$Precision":"precision","$Scale":"scale"},Type:l},"Edm.Double":{Type:m},"Edm.Guid":{Type:G},"Edm.Int16":{Type:I},"Edm.Int32":{Type:o},"Edm.Int64":{Type:p},"Edm.SByte":{Type:q},"Edm.Single":{Type:r},"Edm.Stream":{Type:s},"Edm.String":{constraints:{"@com.sap.vocabularies.Common.v1.IsDigitSequence":"isDigitSequence","$MaxLength":"maxLength"},Type:t},"Edm.TimeOfDay":{constraints:{"$Precision":"precision"},Type:T}},Z={},$="@com.sap.vocabularies.Common.v1.ValueList",a1="@com.sap.vocabularies.Common.v1.ValueListMapping",b1="@com.sap.vocabularies.Common.v1.ValueListReferences",c1="@com.sap.vocabularies.Common.v1.ValueListWithFixedValues",d1=L.Level.WARNING;
function e1(e,i,j,n){var n1,o1=e.mSchema2MetadataUrl[i];if(!o1){o1=e.mSchema2MetadataUrl[i]={};o1[j]=false;}else if(!(j in o1)){n1=Object.keys(o1)[0];if(o1[n1]){k1(e,"A schema cannot span more than one document: "+i+" - expected reference URI "+n1+" but instead saw "+j,n);}o1[j]=false;}}
function f1(e,i,j,n){var n1,o1,p1,q1;function r1(s1){var t1,u1;if(!(j in s1)){n(d1,o1," does not contain ",j);return;}n(w,"Including ",j," from ",o1);for(u1 in s1){if(u1[0]!=="$"&&l1(u1)===j){t1=s1[u1];i[u1]=t1;j1(t1,i.$Annotations);}}}if(j in i){return i[j];}q1=e.mSchema2MetadataUrl[j];if(q1){p1=Object.keys(q1);if(p1.length>1){k1(e,"A schema cannot span more than one document: "+"schema is referenced by following URLs: "+p1.join(", "),j);}o1=p1[0];q1[o1]=true;n(w,"Namespace ",j," found in $Include of ",o1);n1=e.mMetadataUrl2Promise[o1];if(!n1){n(w,"Reading ",o1);n1=e.mMetadataUrl2Promise[o1]=S.resolve(e.oRequestor.read(o1)).then(e.validate.bind(e,o1));}n1=n1.then(r1);if(j in i){return i[j];}i[j]=n1;return n1;}}
function g1(e,i){if(e===i){return"";}if(e.startsWith(i)&&e[i.length]==="#"&&e.indexOf("@",i.length)<0){return e.slice(i.length+1);}}
function h1(e){var i=g1(e,a1);return i!==undefined?i:g1(e,$);}
function i1(n,e){return e.some(function(i){return n==="$ReturnType"?i.$ReturnType:i.$Parameter&&i.$Parameter.some(function(j){return j.$Name===n;});});}
function j1(e,i,j){var n;function n1(o1,p1){var q1;for(q1 in p1){if(j||!(q1 in o1)){o1[q1]=p1[q1];}}}for(n in e.$Annotations){if(!(n in i)){i[n]={};}n1(i[n],e.$Annotations[n]);}delete e.$Annotations;}
function k1(e,i,j){var n=new Error(j+": "+i);e.oModel.reportError(i,F,n);throw n;}
function l1(e){return e.slice(0,e.lastIndexOf(".")+1);}
z=f.extend("sap.ui.model.odata.v4.ODataMetaContextBinding",{constructor:function(e,i,j){a(!j||j.getModel()===e,"oContext must belong to this model");f.call(this,e,i,j);},initialize:function(){var e=this.oModel.createBindingContext(this.sPath,this.oContext);this.bInitial=false;if(e!==this.oElementContext){this.oElementContext=e;this._fireChange();}},setContext:function(e){a(!e||e.getModel()===this.oModel,"oContext must belong to this model");if(e!==this.oContext){this.oContext=e;if(!this.bInitial){this.initialize();}}}});A=c.extend("sap.ui.model.odata.v4.ODataMetaListBinding",{constructor:function(){c.apply(this,arguments);},_fireFilter:function(){},_fireSort:function(){},checkUpdate:function(e){var i=this.oList.length;this.update();if(e||this.oList.length!==i){this._fireChange({reason:C.Change});}},fetchContexts:function(){var i,e=this.oModel.resolve(this.sPath,this.oContext),j=this;if(!e){return S.resolve([]);}i=e.endsWith("@");if(!i&&!e.endsWith("/")){e+="/";}return this.oModel.fetchObject(e).then(function(n){if(!n){return[];}if(i){e=e.slice(0,-1);}return Object.keys(n).filter(function(n1){return n1[0]!=="$"&&i!==(n1[0]!=="@");}).map(function(n1){return new d(j.oModel,e+n1);});});},getContexts:function(i,e){this.iCurrentStart=i||0;this.iCurrentLength=Math.min(e||Infinity,this.iLength-this.iCurrentStart);return this.getCurrentContexts();},getCurrentContexts:function(){var e=[],i,n=this.iCurrentStart+this.iCurrentLength;for(i=this.iCurrentStart;i<n;i+=1){e.push(this.oList[this.aIndices[i]]);}if(this.oList.dataRequested){e.dataRequested=true;}return e;},setContexts:function(e){this.oList=e;this.updateIndices();this.applyFilter();this.applySort();this.iLength=this._getLength();},update:function(){var e=[],i=this.fetchContexts(),j=this;if(i.isFulfilled()){e=i.getResult();}else{i.then(function(e){j.setContexts(e);j._fireChange({reason:C.Change});});e.dataRequested=true;}this.setContexts(e);}});H=P.extend("sap.ui.model.odata.v4.ODataMetaPropertyBinding",{constructor:function(){P.apply(this,arguments);this.vValue=undefined;},checkUpdate:function(e,i){var j,n=this;function n1(o1){if(e||o1!==n.vValue){n.vValue=o1;n._fireChange({reason:i||C.Change});}return o1;}j=this.oModel.fetchObject(this.sPath,this.oContext,this.mParameters).then(n1);if(this.mParameters&&this.mParameters.$$valueAsPromise&&j.isPending()){n1(j.unwrap());}else if(j.isRejected()){j.unwrap();}},getValue:function(){return this.vValue;},setContext:function(e){if(this.oContext!==e){this.oContext=e;if(this.bRelative){this.checkUpdate(false,C.Context);}}},setValue:function(){throw new Error("Unsupported operation: ODataMetaPropertyBinding#setValue");}});
var m1=M.extend("sap.ui.model.odata.v4.ODataMetaModel",{constructor:function(e,i,j,n,n1){M.call(this);this.aAnnotationUris=j&&!Array.isArray(j)?[j]:j;this.sDefaultBindingMode=B.OneTime;this.mETags={};this.dLastModified=new Date(0);this.oMetadataPromise=null;this.oModel=n;this.mMetadataUrl2Promise={};this.oRequestor=e;this.mSchema2MetadataUrl={};this.mSupportedBindingModes={"OneTime":true,"OneWay":true};this.bSupportReferences=n1!==false;this.mUnsupportedFilterOperators={"All":true,"Any":true};this.sUrl=i;}});
m1.prototype.$$valueAsPromise=true;
m1.prototype._mergeAnnotations=function(e,j){var n=this;this.validate(this.sUrl,e);e.$Annotations={};Object.keys(e).forEach(function(i){if(e[i].$kind==="Schema"){e1(n,i,n.sUrl);j1(e[i],e.$Annotations);}});j.forEach(function(n1,i){var o1,p1;n.validate(n.aAnnotationUris[i],n1);for(p1 in n1){if(p1[0]!=="$"){if(p1 in e){k1(n,"A schema cannot span more than one document: "+p1,n.aAnnotationUris[i]);}o1=n1[p1];e[p1]=o1;if(o1.$kind==="Schema"){e1(n,p1,n.aAnnotationUris[i]);j1(o1,e.$Annotations,true);}}}});};
m1.prototype.attachEvent=function(e){if(!(e in X)){throw new Error("Unsupported event '"+e+"': v4.ODataMetaModel#attachEvent");}return M.prototype.attachEvent.apply(this,arguments);};
m1.prototype.bindContext=function(e,i){return new z(this,e,i);};
m1.prototype.bindList=function(e,i,j,n){return new A(this,e,i,j,n);};
m1.prototype.bindProperty=function(e,i,j){return new H(this,e,i,j);};
m1.prototype.bindTree=function(){throw new Error("Unsupported operation: v4.ODataMetaModel#bindTree");};
m1.prototype.fetchCanonicalPath=function(e){return this.fetchUpdateData("",e).then(function(i){if(!i.editUrl){throw new Error(e.getPath()+": No canonical path for transient entity");}if(i.propertyPath){throw new Error("Context "+e.getPath()+" does not point to an entity. It should be "+i.entityPath);}return"/"+i.editUrl;});};
m1.prototype.fetchData=function(){return this.fetchEntityContainer().then(function(e){return JSON.parse(JSON.stringify(e));});};
m1.prototype.fetchEntityContainer=function(e){var i,j=this;if(!this.oMetadataPromise){i=[S.resolve(this.oRequestor.read(this.sUrl,false,e))];if(this.aAnnotationUris){this.aAnnotationUris.forEach(function(n){i.push(S.resolve(j.oRequestor.read(n,true,e)));});}if(!e){this.oMetadataPromise=S.all(i).then(function(n){var n1=n[0];j._mergeAnnotations(n1,n.slice(1));return n1;});}}return this.oMetadataPromise;};
m1.prototype.fetchObject=function(j,n,n1){var o1=this.resolve(j,n),p1=this;if(!o1){L.error("Invalid relative path w/o context",j,F);return S.resolve(null);}return this.fetchEntityContainer().then(function(q1){var r1,s1,t1,u1,v1,w1,x1,y1,z1;function A1(e,i,I1){var J1,K1,L1,M1,N1="";if(i){K1=i.indexOf("@@");if(K1>0){i=i.slice(0,K1);}}else{i=e;}I1=I1||"";if(r1){w1=M1=z1.filter(D1);if(M1.length!==1){return E1(d1,"Expected a single overload, but found "+M1.length);}if(r1!==Z){N1=M1[0].$Parameter[0].$isCollection?"Collection("+r1+")":r1;}L1=y1+"("+N1+")"+I1;if(q1.$Annotations[L1]){if(i==="@"){z1=q1.$Annotations[L1];J1=q1.$Annotations[y1+I1];if(J1){z1=Object.assign({},J1,z1);}return false;}if(i in q1.$Annotations[L1]){y1=L1;z1=q1;return true;}}}y1+=I1;z1=q1;return true;}function B1(i,j){var I1,J1,K1,L1=i.indexOf("@",2);if(L1>-1){return E1(d1,"Unsupported path after ",i.slice(0,L1));}i=i.slice(2);K1=i.indexOf("(");if(K1>0){if(!i.endsWith(")")){return E1(d1,"Expected ')' instead of '",i.slice(-1),"'");}try{J1=J.parseJS("["+i.slice(K1+1,-1).replace(x,"{").replace(Q,"}")+"]");}catch(e){return E1(d1,e.message,": ",e.text.slice(1,e.at),"<--",e.text.slice(e.at,-1));}i=i.slice(0,K1);}I1=i[0]==="."?O.get(i.slice(1),n1.scope):n1&&O.get(i,n1.scope)||(i==="requestCurrencyCodes"||i==="requestUnitsOfMeasure"?p1[i].bind(p1):O.get(i));if(typeof I1!=="function"){return E1(d1,i," is not a function but: "+I1);}try{z1=I1(z1,{$$valueAsPromise:n1&&n1.$$valueAsPromise,arguments:J1,context:new d(p1,j),schemaChildName:x1,overload:w1.length===1?w1[0]:undefined});}catch(e){E1(d1,"Error calling ",i,": ",e);}return true;}function C1(e,i){var I1;if(e==="$ReturnType"){if(i.$ReturnType){z1=i.$ReturnType;return true;}}else if(e&&i.$Parameter){I1=i.$Parameter.filter(function(J1){return J1.$Name===e;});if(I1.length){z1=I1[0];return true;}}return false;}function D1(e){return!e.$IsBound&&r1===Z||e.$IsBound&&r1===e.$Parameter[0].$Type;}function E1(i){var e;if(L.isLoggable(i,F)){e=Array.isArray(t1)?t1.join("/"):t1;L[i===w?"debug":"warning"](Array.prototype.slice.call(arguments,1).join("")+(e?" at /"+e:""),o1,F);}if(i===d1){z1=undefined;}return false;}function F1(e,i){var I1;function J1(){t1=t1||y1&&i&&y1+"/"+i;return E1.apply(this,arguments);}r1=z1&&z1.$Type||r1;if(p1.bSupportReferences&&!(e in q1)){I1=l1(e);z1=f1(p1,q1,I1,J1);}if(e in q1){y1=u1=x1=e;z1=w1=q1[x1];if(!S.isThenable(z1)){return true;}}if(S.isThenable(z1)&&z1.isPending()){return J1(w,"Waiting for ",I1);}return J1(d1,"Unknown qualified name ",e);}function G1(e,i,I1){var J1,K1;if(e==="$Annotations"){return E1(d1,"Invalid segment: $Annotations");}if(i&&typeof z1==="object"&&e in z1){if(e[0]==="$"||y.test(e)){v1=false;}}else{J1=e.indexOf("@@");if(J1<0){if(e.endsWith("@sapui.name")){J1=e.length-11;}else{J1=e.indexOf("@");}}if(J1>0){if(!G1(e.slice(0,J1),i,I1)){return false;}e=e.slice(J1);K1=true;}if(typeof z1==="string"&&!(K1&&(e==="@sapui.name"||e[1]==="@"))&&!H1(z1,I1.slice(0,i))){return false;}if(v1){if(e[0]==="$"&&e!=="$Parameter"&&e!=="$ReturnType"||y.test(e)){v1=false;}else{if(K1){}else if(e[0]!=="@"&&e.indexOf(".")>0){return F1(e);}else if(z1&&"$Type"in z1){if(!F1(z1.$Type,"$Type")){return false;}}else if(z1&&"$Action"in z1){if(!F1(z1.$Action,"$Action")){return false;}r1=Z;}else if(z1&&"$Function"in z1){if(!F1(z1.$Function,"$Function")){return false;}r1=Z;}else if(!i){y1=u1=x1=x1||q1.$EntityContainer;z1=w1=w1||q1[x1];if(Array.isArray(z1)&&C1(e,z1[0])){return true;}if(e&&e[0]!=="@"&&!(e in w1)){return E1(d1,"Unknown child ",e," of ",x1);}}if(Array.isArray(z1)){if(e==="$Parameter"){return true;}if(e.startsWith("@$ui5.overload@")){e=e.slice(14);K1=true;}if(K1){if(e[1]!=="@"&&!A1(e)){return false;}}else{if(e!==I1[i]&&I1[i][e.length+1]!=="@"&&i1(e,z1)){u1=e;return A1(e,I1[i].slice(e.length),"/"+u1);}if(r1){z1=z1.filter(D1);}if(e==="@$ui5.overload"){return true;}if(z1.length!==1){return E1(d1,"Expected a single overload, but found "+z1.length);}if(C1(e,z1[0])){return true;}z1=z1[0].$ReturnType;y1+="/0/$ReturnType";if(z1){if(e==="value"&&!(q1[z1.$Type]&&q1[z1.$Type].value)){u1=undefined;return true;}if(!F1(z1.$Type,"$Type")){return false;}}if(!e){return true;}}}}}if(!e){return i+1>=I1.length||E1(d1,"Invalid empty segment");}if(e[0]==="@"){if(e==="@sapui.name"){z1=u1;if(z1===undefined){E1(d1,"Unsupported path before @sapui.name");}else if(i+1<I1.length){E1(d1,"Unsupported path after @sapui.name");}return false;}if(e[1]==="@"){if(i+1<I1.length){return E1(d1,"Unsupported path after ",e);}return B1(e,[""].concat(I1.slice(0,i),I1[i].slice(0,J1)).join("/"));}}if(!z1||typeof z1!=="object"){z1=undefined;return!s1&&E1(w,"Invalid segment: ",e);}if(v1&&e[0]==="@"){r1=z1.$Type||r1;z1=q1.$Annotations[y1]||{};v1=false;}else if(e==="$"&&i+1<I1.length){return E1(d1,"Unsupported path after $");}}if(e!=="@"&&e!=="$"){if(e[0]==="@"){s1=true;}u1=v1||e[0]==="@"?e:undefined;y1=v1?y1+"/"+e:undefined;z1=z1[e];}return true;}function H1(e,i){var I1;if(t1){return E1(d1,"Invalid recursion");}t1=i;s1=false;v1=true;z1=q1;I1=e.split("/").every(G1);t1=undefined;return I1;}if(!H1(o1.slice(1))&&S.isThenable(z1)){z1=z1.then(function(){return p1.fetchObject(j,n,n1);});}return z1;});};
m1.prototype.fetchUI5Type=function(e,i){var j=this.getMetaContext(e),n=this;if(e.endsWith("/$count")){u=u||new p();return S.resolve(u);}return this.fetchObject(undefined,j).catch(function(){}).then(function(n1){var o1=N,p1;if(!n1){L.warning("No metadata for path '"+e+"', using "+o1.getName(),undefined,F);return o1;}if(i){if(b(i)){i=undefined;}else if("parseKeepsEmptyString"in i&&n1.$Type!=="Edm.String"){if(Object.keys(i).length===1){i=undefined;}else{i=Object.assign({},i);delete i.parseKeepsEmptyString;}}}if(!i&&n1["$ui5.type"]){return n1["$ui5.type"];}if(n1.$isCollection){L.warning("Unsupported collection type, using "+o1.getName(),e,F);}else{p1=Y[n1.$Type];if(p1){o1=new p1.Type(i,n.getConstraints(n1,j.getPath()));}else{L.warning("Unsupported type '"+n1.$Type+"', using "+o1.getName(),e,F);}}if(!i){n1["$ui5.type"]=o1;}return o1;});};
m1.prototype.fetchUpdateData=function(e,j,n){var n1=j.getModel(),o1=n1.resolve(e,j),p1=this;function q1(i){var r1=new Error(o1+": "+i);n1.reportError(i,F,r1);throw r1;}return this.fetchObject(this.getMetaPath(o1)).then(function(){return p1.fetchEntityContainer();}).then(function(r1){var s1,t1=r1[r1.$EntityContainer],u1,v1,w1,x1,y1,z1,A1,B1;function C1(G1){var i=G1.indexOf("(");return i>=0?G1.slice(i):"";}function D1(i){s1.push({path:y1,prefix:i,type:B1});}function E1(G1){var i=G1.indexOf("(");return i>=0?G1.slice(0,i):G1;}function F1(i){if(i.includes("($uid=")){D1(E1(i));}else{s1.push(i);}}A1=o1.slice(1).split("/");x1=A1.shift();y1="/"+x1;u1=y1;w1=decodeURIComponent(E1(x1));v1=t1[w1];if(!v1){q1("Not an entity set: "+w1);}B1=r1[v1.$Type];e="";z1="";s1=[];F1(x1);A1.forEach(function(i){var G1,H1;y1+="/"+i;if(y.test(i)){D1(s1.pop());u1+="/"+i;}else{H1=decodeURIComponent(E1(i));z1=_.buildPath(z1,H1);G1=B1[H1];if(!G1){q1("Not a (navigation) property: "+H1);}B1=r1[G1.$Type];if(G1.$kind==="NavigationProperty"){if(v1.$NavigationPropertyBinding&&z1 in v1.$NavigationPropertyBinding){w1=v1.$NavigationPropertyBinding[z1];v1=t1[w1];z1="";s1=[encodeURIComponent(w1)+C1(i)];if(!G1.$isCollection){D1(s1.pop());}}else{F1(i);}u1=y1;e="";}else{e=_.buildPath(e,i);}}});if(n){return S.resolve({editUrl:undefined,entityPath:u1,propertyPath:e});}return S.all(s1.map(function(i){if(typeof i==="string"){return i;}return j.fetchValue(i.path).then(function(G1){var H1;if(!G1){q1("No instance to calculate key predicate at "+i.path);}if(_.hasPrivateAnnotation(G1,"transient")){n=true;return undefined;}H1=_.getPrivateAnnotation(G1,"predicate");if(!H1){q1("No key predicate known at "+i.path);}return i.prefix+H1;},function(G1){q1(G1.message+" at "+i.path);});})).then(function(i){return{editUrl:n?undefined:i.join("/"),entityPath:u1,propertyPath:e};});});};
m1.prototype.fetchValueListMappings=function(e,i,j,n){var n1=this,o1=e.getMetaModel();function p1(){var q1=n[0],r1="";if(n.length!==1){throw new Error("Expected a single overload, but found "+n.length);}if(q1.$IsBound){r1=q1.$Parameter[0].$isCollection?"Collection("+q1.$Parameter[0].$Type+")":q1.$Parameter[0].$Type;}return i+"("+r1+")";}return o1.fetchEntityContainer().then(function(q1){var r1,s1=q1.$Annotations,t1,u1=_.namespace(i),v1={},w1=n1===o1,x1,y1;if(j.$Name){t1=p1()+"/"+j.$Name;y1=i+"/"+j.$Name;}x1=Object.keys(s1).filter(function(z1){if(_.namespace(z1)===u1){if(t1?z1===t1||z1===y1:n1.getObject("/"+z1)===j){return true;}if(w1||y1&&_.getMetaPath(z1)===y1){return false;}throw new Error("Unexpected annotation target '"+z1+"' with namespace of data service in "+e.sServiceUrl);}return false;});if(!x1.length){throw new Error("No annotation '"+$.slice(1)+"' in "+e.sServiceUrl);}if(x1.length===1){r1=s1[x1[0]];}else{r1=Object.assign({},s1[y1],s1[t1]);}Object.keys(r1).forEach(function(z1){var A1=h1(z1);if(A1!==undefined){v1[A1]=r1[z1];["CollectionRoot","SearchSupported"].forEach(function(B1){if(B1 in r1[z1]){throw new Error("Property '"+B1+"' is not allowed in annotation '"+z1.slice(1)+"' for target '"+x1[0]+"' in "+e.sServiceUrl);}});}else if(!w1){throw new Error("Unexpected annotation '"+z1.slice(1)+"' for target '"+x1[0]+"' with namespace of data service in "+e.sServiceUrl);}});return v1;});};
m1.prototype.fetchValueListType=function(e){var i=this.getMetaContext(e),j=this;return this.fetchObject(undefined,i).then(function(n){var n1,o1;if(!n){throw new Error("No metadata for "+e);}n1=j.getObject("@",i);if(n1[c1]){return V.Fixed;}for(o1 in n1){if(g1(o1,b1)!==undefined||g1(o1,a1)!==undefined){return V.Standard;}if(g1(o1,$)!==undefined){return n1[o1].SearchSupported===false?V.Fixed:V.Standard;}}return V.None;});};
m1.prototype.getAbsoluteServiceUrl=function(e){var i=new U(this.sUrl).absoluteTo(document.baseURI).pathname().toString();return new U(e).absoluteTo(i).filename("").toString();};
m1.prototype.getAllPathReductions=function(e,n,n1,o1){var p1=n.split("/").length,q1,r1={},s1=e.split("/"),t1=this;function u1(j,v1,w1,x1){var i,y1,z1;function A1(B1){if(!n1){u1(j,v1,i-1,true);}if(x1){v1=v1.slice();j=j.slice();}v1.splice(i,B1);j.splice(i,B1);if(!n1){r1[j.join("/")]=true;}}for(i=w1;i>=p1;i-=1){y1=y.test(j[i+1])?i+2:i+1;if(y1<j.length&&v1[i].$Partner===j[y1]&&!v1[y1].$isCollection&&v1[y1].$Partner===j[i].replace(K,"")){A1(y1-i+1);}else if(Array.isArray(v1[i])&&j[i+1]==="$Parameter"){z1=t1.getObject(t1.getMetaPath(j.slice(0,i+1).join("/")+"/@$ui5.overload"));if(z1.length===1&&z1[0].$Parameter[0].$Name===j[i+2]){A1(3);}}else if(o1&&v1[i].$isCollection){break;}}}q1=s1.map(function(i,j){return j<p1||i[0]==="#"||i[0]==="@"||y.test(i)||i==="$Parameter"?{}:t1.getObject(t1.getMetaPath(s1.slice(0,j+1).join("/")))||{};});r1[e]=true;if(!(o1&&q1[s1.length-1].$isCollection)){u1(s1,q1,s1.length-2);}return n1?s1.join("/"):Object.keys(r1);};
m1.prototype.getConstraints=function(e,i){var j,n,n1,o1=Y[e.$Type];function p1(q1,r1){if(r1!==undefined){n=n||{};n[q1]=r1;}}if(o1){n1=o1.constraints;for(j in n1){p1(n1[j],j[0]==="@"?this.getObject(i+j):e[j]);}if(e.$Nullable===false){p1("nullable",false);}}return n;};
m1.prototype.getData=_.createGetMethod("fetchData");
m1.prototype.getETags=function(){return this.mETags;};
m1.prototype.getLastModified=function(){return this.dLastModified;};
m1.prototype.getMetaContext=function(e){return new d(this,this.getMetaPath(e));};
m1.prototype.getMetaPath=function(e){return _.getMetaPath(e);};
m1.prototype.getObject=_.createGetMethod("fetchObject");
m1.prototype.getOrCreateSharedModel=function(e,i,j){var n,n1;e=this.getAbsoluteServiceUrl(e);n=!!j+e;n1=W.get(n);if(!n1){n1=new this.oModel.constructor({autoExpandSelect:j,groupId:i,httpHeaders:this.oModel.getHttpHeaders(),operationMode:g.Server,serviceUrl:e,sharedRequests:true,synchronizationMode:"None"});W.set(n,n1);}return n1;};
m1.prototype.getOriginalProperty=function(){throw new Error("Unsupported operation: v4.ODataMetaModel#getOriginalProperty");};
m1.prototype.getProperty=m1.prototype.getObject;
m1.prototype.getReducedPath=function(e,i){return this.getAllPathReductions(e,i,true,true);};
m1.prototype.getUI5Type=_.createGetMethod("fetchUI5Type",true);
m1.prototype.getUnitOrCurrencyPath=function(e){var i=this.getObject("@",this.getMetaContext(e)),j=i&&(i["@Org.OData.Measures.V1.Unit"]||i["@Org.OData.Measures.V1.ISOCurrency"]);return j&&j.$Path;};
m1.prototype.getValueListType=_.createGetMethod("fetchValueListType",true);
m1.prototype.isList=function(){throw new Error("Unsupported operation: v4.ODataMetaModel#isList");};
m1.prototype.refresh=function(){throw new Error("Unsupported operation: v4.ODataMetaModel#refresh");};
m1.prototype.requestCodeList=function(e,i,j){var n=this.fetchEntityContainer().getResult(),n1=n[n.$EntityContainer],o1=this;if(j&&j.context){if(j.context.getModel()!==this||j.context.getPath()!=="/"){throw new Error("Unsupported context: "+j.context);}}if(i!==undefined&&i!==n1){throw new Error("Unsupported raw value: "+i);}return this.requestObject("/@com.sap.vocabularies.CodeList.v1."+e).then(function(p1){var q1,r1,s1,t1,u1;if(!p1){return null;}q1=o1.getAbsoluteServiceUrl(p1.Url)+"#"+p1.CollectionPath;t1=v.get(q1);if(t1){return t1;}s1=o1.getOrCreateSharedModel(p1.Url,"$direct");r1=s1.getMetaModel();u1="/"+p1.CollectionPath+"/";t1=r1.requestObject(u1).then(function(v1){var w1=u1+"@Org.OData.Core.V1.AlternateKeys",x1=r1.getObject(w1),y1,z1=H1(v1.$Key),A1=u1+z1+"@com.sap.vocabularies.Common.v1.",B1,C1,D1=u1+z1+"@com.sap.vocabularies.CodeList.v1.StandardCode/$Path",E1,F1;function G1(I1,J1){var K1=J1.getProperty(z1),L1={Text:J1.getProperty(F1),UnitSpecificScale:J1.getProperty(C1)};if(E1){L1.StandardCode=J1.getProperty(E1);}if(L1.UnitSpecificScale===null){L.error("Ignoring customizing w/o unit-specific scale for code "+K1+" from "+p1.CollectionPath,p1.Url,F);}else{I1[K1]=L1;}return I1;}function H1(I1){var J1;if(I1&&I1.length===1){J1=I1[0];}else{throw new Error("Single key expected: "+u1);}return typeof J1==="string"?J1:J1[Object.keys(J1)[0]];}if(x1){if(x1.length!==1){throw new Error("Single alternative expected: "+w1);}else if(x1[0].Key.length!==1){throw new Error("Single key expected: "+w1+"/0/Key");}z1=x1[0].Key[0].Name.$PropertyPath;}C1=r1.getObject(A1+"UnitSpecificScale/$Path");F1=r1.getObject(A1+"Text/$Path");B1=[z1,C1,F1];E1=r1.getObject(D1);if(E1){B1.push(E1);}y1=s1.bindList("/"+p1.CollectionPath,null,null,null,{$select:B1});return y1.requestContexts(0,Infinity).then(function(I1){if(!I1.length){L.error("Customizing empty for ",s1.sServiceUrl+p1.CollectionPath,F);}return I1.reduce(G1,{});}).finally(function(){y1.destroy();});});v.set(q1,t1);return t1;});};
m1.prototype.requestCurrencyCodes=function(e,i){return this.requestCodeList("CurrencyCodes",e,i);};
m1.prototype.requestData=_.createRequestMethod("fetchData");m1.prototype.requestObject=_.createRequestMethod("fetchObject");m1.prototype.requestUI5Type=_.createRequestMethod("fetchUI5Type");
m1.prototype.requestUnitsOfMeasure=function(e,i){return this.requestCodeList("UnitsOfMeasure",e,i);};
m1.prototype.requestValueListInfo=function(e,i){var j=this.getMetaPath(e),n=j.slice(0,j.lastIndexOf("/")).replace("/$Parameter",""),n1=n.slice(n.lastIndexOf("/")+1),o1=this;if(!n1.includes(".")){n1=undefined;}return Promise.all([n1||this.requestObject(n+"/@sapui.name"),this.requestObject(j),this.requestObject(j+"@"),this.requestObject(j+c1),this.requestObject(n+"/@$ui5.overload")]).then(function(p1){var q1=p1[2],r1=p1[3],s1={},t1=p1[1],u1={};function v1(w1,x1,y1,z1){if(r1!==undefined&&"SearchSupported"in w1){throw new Error("Must not set 'SearchSupported' in annotation "+"'com.sap.vocabularies.Common.v1.ValueList' and annotation "+"'com.sap.vocabularies.Common.v1.ValueListWithFixedValues'");}if("CollectionRoot"in w1){z1=o1.getOrCreateSharedModel(w1.CollectionRoot,undefined,i);if(u1[x1]&&u1[x1].$model===z1){s1[x1]=undefined;}}if(s1[x1]){throw new Error("Annotations '"+$.slice(1)+"' with identical qualifier '"+x1+"' for property "+e+" in "+s1[x1]+" and "+y1);}s1[x1]=y1;w1=_.clone(w1);w1.$model=z1;delete w1.CollectionRoot;delete w1.SearchSupported;u1[x1]=w1;}if(!t1){throw new Error("No metadata for "+e);}return Promise.all(Object.keys(q1).filter(function(w1){return g1(w1,b1)!==undefined;}).map(function(w1){var x1=q1[w1];return Promise.all(x1.map(function(y1){var z1=o1.getOrCreateSharedModel(y1,undefined,i);return o1.fetchValueListMappings(z1,p1[0],t1,p1[4]).then(function(A1){Object.keys(A1).forEach(function(B1){v1(A1[B1],B1,y1,z1);});});}));})).then(function(){var w1;Object.keys(q1).filter(function(x1){return h1(x1)!==undefined;}).forEach(function(x1){v1(q1[x1],h1(x1),o1.sUrl,o1.oModel);});w1=Object.keys(u1);if(!w1.length){throw new Error("No annotation '"+b1.slice(1)+"' for "+e);}if(r1){if(w1.length>1){throw new Error("Annotation '"+c1.slice(1)+"' but multiple '"+$.slice(1)+"' for property "+e);}return{"":u1[w1[0]]};}return u1;});});};
m1.prototype.requestValueListType=_.createRequestMethod("fetchValueListType");
m1.prototype.resolve=function(e,i){var j,n;if(!e){return i?i.getPath():undefined;}n=e[0];if(n==="/"){return e;}if(!i){return undefined;}if(n==="."){if(e[1]!=="/"){throw new Error("Unsupported relative path: "+e);}e=e.slice(2);}j=i.getPath();return n==="@"||j.endsWith("/")?j+e:j+"/"+e;};
m1.prototype.setLegacySyntax=function(){throw new Error("Unsupported operation: v4.ODataMetaModel#setLegacySyntax");};
m1.prototype.toString=function(){return F+": "+this.sUrl;};
m1.prototype.validate=function(e,j){var i,n,n1,o1,p1,q1;if(!this.bSupportReferences){return j;}for(q1 in j.$Reference){p1=j.$Reference[q1];q1=new U(q1).absoluteTo(this.sUrl).toString();if("$IncludeAnnotations"in p1){k1(this,"Unsupported IncludeAnnotations",e);}for(i in p1.$Include){o1=p1.$Include[i];if(o1 in j){k1(this,"A schema cannot span more than one document: "+o1+" - is both included and defined",e);}e1(this,o1,q1,e);}}n1=j.$LastModified?new Date(j.$LastModified):null;this.mETags[e]=j.$ETag?j.$ETag:n1;n=j.$Date?new Date(j.$Date):new Date();n1=n1||n;if(this.dLastModified<n1){this.dLastModified=n1;}delete j.$Date;delete j.$ETag;delete j.$LastModified;return j;};
return m1;});
sap.ui.predefine('sap/ui/model/odata/v4/ODataModel',["./ODataContextBinding","./ODataListBinding","./ODataMetaModel","./ODataPropertyBinding","./SubmitMode","./lib/_GroupLock","./lib/_Helper","./lib/_MetadataRequestor","./lib/_Parser","./lib/_Requestor","sap/base/assert","sap/base/Log","sap/ui/base/SyncPromise","sap/ui/core/library","sap/ui/core/message/Message","sap/ui/model/BindingMode","sap/ui/model/Context","sap/ui/model/Model","sap/ui/model/odata/OperationMode","sap/ui/thirdparty/URI"],function(O,a,b,c,S,_,d,e,f,g,h,L,i,j,M,B,k,l,m,U){"use strict";var r=/^\w+$/,C="sap.ui.model.odata.v4.ODataModel",E=["$count","$expand","$filter","$levels","$orderby","$search","$select"],n=/^(\$auto(\.\w+)?|\$direct|\w+)$/,o=j.MessageType,p=[undefined,o.Success,o.Information,o.Warning,o.Error],s={messageChange:true,sessionTimeout:true},q={annotationURI:true,autoExpandSelect:true,earlyRequests:true,groupId:true,groupProperties:true,httpHeaders:true,metadataUrlParams:true,odataVersion:true,operationMode:true,serviceUrl:true,sharedRequests:true,supportReferences:true,synchronizationMode:true,updateGroupId:true},t=["$apply","$count","$expand","$filter","$orderby","$search","$select"],u=/^[ -~]+$/;
var v=l.extend("sap.ui.model.odata.v4.ODataModel",{constructor:function(P){var G,w,x=sap.ui.getCore().getConfiguration().getLanguageTag(),y,z,A,D,F=this;l.call(this);if(!P||P.synchronizationMode!=="None"){throw new Error("Synchronization mode must be 'None'");}y=P.odataVersion||"4.0";this.sODataVersion=y;if(y!=="4.0"&&y!=="2.0"){throw new Error("Unsupported value for parameter odataVersion: "+y);}for(z in P){if(!(z in q)){throw new Error("Unsupported parameter: "+z);}}A=P.serviceUrl;if(!A){throw new Error("Missing service root URL");}D=new U(A);if(D.path()[D.path().length-1]!=="/"){throw new Error("Service root URL must end with '/'");}if(P.operationMode&&P.operationMode!==m.Server){throw new Error("Unsupported operation mode: "+P.operationMode);}this.sOperationMode=P.operationMode;this.mUriParameters=this.buildQueryOptions(D.query(true),false,true);this.sServiceUrl=D.query("").toString();this.sGroupId=P.groupId;if(this.sGroupId===undefined){this.sGroupId="$auto";}if(this.sGroupId!=="$auto"&&this.sGroupId!=="$direct"){throw new Error("Group ID must be '$auto' or '$direct'");}this.checkGroupId(P.updateGroupId,false,"Invalid update group ID: ");this.sUpdateGroupId=P.updateGroupId||this.getGroupId();this.mGroupProperties={};for(G in P.groupProperties){F.checkGroupId(G,true);w=P.groupProperties[G];if(typeof w!=="object"||Object.keys(w).length!==1||!(w.submit in S)){throw new Error("Group '"+G+"' has invalid properties: '"+w+"'");}}this.mGroupProperties=d.clone(P.groupProperties)||{};this.mGroupProperties.$auto={submit:S.Auto};this.mGroupProperties.$direct={submit:S.Direct};if(P.autoExpandSelect!==undefined&&typeof P.autoExpandSelect!=="boolean"){throw new Error("Value for autoExpandSelect must be true or false");}this.bAutoExpandSelect=P.autoExpandSelect===true;if("sharedRequests"in P&&P.sharedRequests!==true){throw new Error("Value for sharedRequests must be true");}this.bSharedRequests=P.sharedRequests===true;this.mHeaders={"Accept-Language":x};this.mMetadataHeaders={"Accept-Language":x};this.oMetaModel=new b(e.create(this.mMetadataHeaders,y,Object.assign({},this.mUriParameters,P.metadataUrlParams)),this.sServiceUrl+"$metadata",P.annotationURI,this,P.supportReferences);this.oInterface={fetchEntityContainer:this.oMetaModel.fetchEntityContainer.bind(this.oMetaModel),fetchMetadata:this.oMetaModel.fetchObject.bind(this.oMetaModel),fireSessionTimeout:function(){F.fireEvent("sessionTimeout");},getGroupProperty:this.getGroupProperty.bind(this),onCreateGroup:function(G){if(F.isAutoGroup(G)){F.addPrerenderingTask(F._submitBatch.bind(F,G,true));}},reportBoundMessages:this.reportBoundMessages.bind(this),reportUnboundMessages:this.reportUnboundMessages.bind(this)};this.oRequestor=g.create(this.sServiceUrl,this.oInterface,this.mHeaders,this.mUriParameters,y);this.changeHttpHeaders(P.httpHeaders);if(P.earlyRequests){this.oMetaModel.fetchEntityContainer(true);this.initializeSecurityToken();}this.aAllBindings=[];this.mSupportedBindingModes={OneTime:true,OneWay:true};if(P.sharedRequests){this.sDefaultBindingMode=B.OneWay;}else{this.sDefaultBindingMode=B.TwoWay;this.mSupportedBindingModes.TwoWay=true;}this.aPrerenderingTasks=null;}});
v.prototype._submitBatch=function(G,w){var x=this;return this.oRequestor.submitBatch(G).catch(function(y){x.reportError("$batch failed",C,y);if(!w){throw y;}});};
v.prototype.addPrerenderingTask=function(P,F){var w=this;if(!this.aPrerenderingTasks){this.aPrerenderingTasks=[];sap.ui.getCore().addPrerenderingTask(function(){while(w.aPrerenderingTasks.length){w.aPrerenderingTasks.shift()();}w.aPrerenderingTasks=null;});}if(F){this.aPrerenderingTasks.unshift(P);}else{this.aPrerenderingTasks.push(P);}};
v.prototype.attachEvent=function(w){if(!(w in s)){throw new Error("Unsupported event '"+w+"': v4.ODataModel#attachEvent");}return l.prototype.attachEvent.apply(this,arguments);};
v.prototype.attachSessionTimeout=function(F,w){return this.attachEvent("sessionTimeout",F,w);};
v.prototype.bindContext=function(P,w,x){return new O(this,P,w,x);};
v.prototype.bindingCreated=function(w){this.aAllBindings.push(w);};
v.prototype.bindingDestroyed=function(w){var I=this.aAllBindings.indexOf(w);if(I<0){throw new Error("Unknown "+w);}this.aAllBindings.splice(I,1);};
v.prototype.bindList=function(P,w,x,F,y){return new a(this,P,w,x,F,y);};
v.prototype.bindProperty=function(P,w,x){return new c(this,P,w,x);};
v.prototype.bindTree=function(){throw new Error("Unsupported operation: v4.ODataModel#bindTree");};
v.prototype.buildQueryOptions=function(P,w,x){var y,T=d.clone(P)||{};function z(A,D,F){var G,H,I,V=A[D];if(!w||F.indexOf(D)<0){throw new Error("System query option "+D+" is not supported");}if((D==="$expand"||D==="$select")&&typeof V==="string"){V=f.parseSystemQueryOption(D+"="+V)[D];A[D]=V;}if(D==="$expand"){for(I in V){H=V[I];if(H===null||typeof H!=="object"){H=V[I]={};}for(G in H){z(H,G,E);}}}else if(D==="$count"){if(typeof V==="boolean"){if(!V){delete A.$count;}}else{switch(typeof V==="string"&&V.toLowerCase()){case"false":delete A.$count;break;case"true":A.$count=true;break;default:throw new Error("Invalid value for $count: "+V);}}}}if(P){for(y in P){if(y.startsWith("$$")){delete T[y];}else if(y[0]==="@"){throw new Error("Parameter "+y+" is not supported");}else if(y[0]==="$"){z(T,y,t);}else if(!x&&y.startsWith("sap-")){throw new Error("Custom query option "+y+" is not supported");}}}return T;};
v.prototype.changeHttpHeaders=function(H){var w,x,y={},z,K;this.oRequestor.checkHeaderNames(H);for(K in H){x=K.toLowerCase();z=H[K];if(y[x]){throw new Error("Duplicate header "+K);}else if(!(typeof z==="string"&&u.test(z)||z===undefined)){throw new Error("Unsupported value for header '"+K+"': "+z);}else{if(x==="x-csrf-token"){K="X-CSRF-Token";}y[x]={key:K,value:z};}}this.oRequestor.checkForOpenRequests();for(K in this.mHeaders){x=K.toLowerCase();w=y[x];if(w){delete this.mHeaders[K];delete this.mMetadataHeaders[K];if(w.value!==undefined){this.mHeaders[w.key]=w.value;this.mMetadataHeaders[w.key]=w.value;}delete y[x];}}for(K in y){w=y[K];if(w.value!==undefined){this.mHeaders[w.key]=w.value;if(K!=="x-csrf-token"){this.mMetadataHeaders[w.key]=w.value;}}}};
v.prototype.checkBatchGroupId=function(G){this.checkGroupId(G);if(this.isDirectGroup(G)){throw new Error("Group ID does not use batch requests: "+G);}};
v.prototype.checkGroupId=function(G,A,w){if(!A&&G===undefined||typeof G==="string"&&(A?r:n).test(G)){return;}throw new Error((w||"Invalid group ID: ")+G);};
v.prototype.createBindingContext=function(P,w){var D,x,y,R,z;function A(y){var F=y.indexOf("."),G=y.indexOf("/");return F>0&&(G<0||F<G);}if(arguments.length>2){throw new Error("Only the parameters sPath and oContext are supported");}if(w&&w.getBinding){throw new Error("Unsupported type: oContext must be of type sap.ui.model.Context, "+"but was sap.ui.model.odata.v4.Context");}R=this.resolve(P,w);if(R===undefined){throw new Error("Cannot create binding context from relative path '"+P+"' without context");}z=R.indexOf('#');if(z>=0){D=R.slice(0,z);y=R.slice(z+1);if(y[0]==="#"){y=y.slice(1);}else if(D.length>1&&y[0]!=="@"&&A(y)){return new k(this,R);}if(y[0]==="/"){y="."+y;}x=this.oMetaModel.getMetaContext(D);return this.oMetaModel.createBindingContext(y,x);}return new k(this,R);};
v.prototype.destroy=function(){this.oMetaModel.destroy();this.oRequestor.destroy();this.mHeaders=undefined;this.mMetadataHeaders=undefined;return l.prototype.destroy.apply(this,arguments);};
v.prototype.destroyBindingContext=function(){throw new Error("Unsupported operation: v4.ODataModel#destroyBindingContext");};
v.prototype.detachSessionTimeout=function(F,w){return this.detachEvent("sessionTimeout",F,w);};
v.prototype.getAllBindings=function(){return this.aAllBindings.slice();};
v.prototype.getContext=function(){throw new Error("Unsupported operation: v4.ODataModel#getContext");};
v.prototype.getDependentBindings=function(P){return this.aAllBindings.filter(function(w){var x=w.getContext();return w.isRelative()&&(x===P||x&&x.getBinding&&x.getBinding()===P);});};
v.prototype.getGroupId=function(){return this.sGroupId;};
v.prototype.getGroupProperty=function(G,P){switch(P){case"submit":if(G.startsWith("$auto.")){return S.Auto;}return this.mGroupProperties[G]?this.mGroupProperties[G].submit:S.API;default:throw new Error("Unsupported group property: '"+P+"'");}};
v.prototype.getHttpHeaders=function(){var H=Object.assign({},this.mHeaders);delete H["SAP-ContextId"];if(H["X-CSRF-Token"]===null){delete H["X-CSRF-Token"];}return H;};
v.prototype.getMetaModel=function(){return this.oMetaModel;};
v.prototype.getObject=function(){throw new Error("Unsupported operation: v4.ODataModel#getObject");};
v.prototype.getODataVersion=function(){return this.sODataVersion;};
v.prototype.getOriginalProperty=function(){throw new Error("Unsupported operation: v4.ODataModel#getOriginalProperty");};
v.prototype.getProperty=function(){throw new Error("Unsupported operation: v4.ODataModel#getProperty");};
v.prototype.getUpdateGroupId=function(){return this.sUpdateGroupId;};
v.prototype.hasPendingChanges=function(G){if(G!==undefined){this.checkBatchGroupId(G);if(this.isAutoGroup(G)&&this.oRequestor.hasPendingChanges("$parked."+G)){return true;}}return this.oRequestor.hasPendingChanges(G);};
v.prototype.initializeSecurityToken=function(){this.oRequestor.refreshSecurityToken().catch(function(){});};
v.prototype.isAutoGroup=function(G){return this.getGroupProperty(G,"submit")===S.Auto;};
v.prototype.isDirectGroup=function(G){return this.getGroupProperty(G,"submit")===S.Direct;};
v.prototype.isList=function(){throw new Error("Unsupported operation: v4.ODataModel#isList");};
v.prototype.lockGroup=function(G,w,x,y,z){return this.oRequestor.lockGroup(G,w,x,y,z);};
v.prototype.refresh=function(G){this.checkGroupId(G);this.getBindings().forEach(function(w){if(w.isRoot()){w.refresh(w.isSuspended()?undefined:G);}});};
v.prototype.reportBoundMessages=function(R,P,w){var D="/"+R,N=[],x=[],y=this;Object.keys(P).forEach(function(z){P[z].forEach(function(A){var T=A.target[0]==="/"?A.target:d.buildPath(D,z,A.target);N.push(new M({code:A.code,descriptionUrl:A.longtextUrl||undefined,message:A.message,persistent:A.transition,processor:y,target:T,technical:A.technical,technicalDetails:d.createTechnicalDetails(A),type:p[A.numericSeverity]||o.None}));});});(w||[""]).forEach(function(z){var A=d.buildPath(D,z);Object.keys(y.mMessages).forEach(function(F){if(F===A||F.startsWith(A+"/")||F.startsWith(A+"(")){x=x.concat(y.mMessages[F].filter(function(G){return!G.persistent;}));}});});if(N.length||x.length){this.fireMessageChange({newMessages:N,oldMessages:x});}};
v.prototype.reportError=function(w,R,x){var y=[],D,z,A=[];function F(G,N,T){var H={code:G.code,message:G.message,numericSeverity:N,technical:T||G.technical,"@$ui5.originalMessage":G};Object.keys(G).forEach(function(P){if(P[0]==='@'){if(P.endsWith(".numericSeverity")){H.numericSeverity=G[P];}else if(P.endsWith(".longtextUrl")&&x.requestUrl&&z){H.longtextUrl=d.makeAbsolute(G[P],x.requestUrl);}}});if(typeof G.target!=="string"){A.push(H);}else if(G.target[0]==="$"||!z){H.message=G.target+": "+H.message;A.push(H);}else{H.target=G.target;H.transition=true;y.push(H);}}if(x.canceled==="noDebugLog"){return;}D=x.stack||x.message;if(D.indexOf(x.message)<0){D=x.message+"\n"+x.stack;}if(x.canceled){L.debug(w,D,R);return;}L.error(w,D,R);if(x.$reported){return;}x.$reported=true;if(x.error){z=x.resourcePath&&x.resourcePath.split("?")[0];F(x.error,4,true);if(x.error.details){x.error.details.forEach(function(G){F(G);});}if(y.length){this.reportBoundMessages(z,{"":y},[]);}}else{F(x,4,true);}this.reportUnboundMessages(z,A);};
v.prototype.reportUnboundMessages=function(R,w){var x=this;if(w&&w.length){this.fireMessageChange({newMessages:w.map(function(y){var z=y.longtextUrl;return new M({code:y.code,descriptionUrl:z&&R?d.makeAbsolute(z,x.sServiceUrl+R):undefined,message:y.message,persistent:true,processor:x,target:"",technical:y.technical,technicalDetails:d.createTechnicalDetails(y),type:p[y.numericSeverity]||o.None});})});}};
v.prototype.requestCanonicalPath=function(w){h(w.getModel()===this,"oEntityContext must belong to this model");return w.requestCanonicalPath();};
v.prototype.requestSideEffects=function(G,A){var w;if(!A.length){return undefined;}w=this.oMetaModel.getObject("/$EntityContainer");A=A.map(function(x){var y=x.split("/");if(y[1]!==w){throw new Error("Path must start with '/"+w+"': "+x);}y.splice(1,1);return y.join("/");});return i.all(this.aAllBindings.filter(function(x){return x.isRoot()&&x.requestAbsoluteSideEffects;}).map(function(R){return R.requestAbsoluteSideEffects(G,A);}));};
v.prototype.resetChanges=function(G){G=G||this.sUpdateGroupId;this.checkBatchGroupId(G);if(this.isAutoGroup(G)){this.oRequestor.cancelChanges("$parked."+G);}this.oRequestor.cancelChanges(G);this.aAllBindings.forEach(function(w){if(G===w.getUpdateGroupId()){w.resetInvalidDataState();}});};
v.prototype.resolve=function(P,w){var R;if(P&&P[0]==="/"){R=P;}else if(w){R=w.getPath();if(P){if(!R.endsWith("/")){R+="/";}R+=P;}}if(R&&R!=="/"&&R[R.length-1]==="/"&&R.indexOf("#")<0){R=R.slice(0,R.length-1);}return R;};
v.prototype.setLegacySyntax=function(){throw new Error("Unsupported operation: v4.ODataModel#setLegacySyntax");};
v.prototype.submitBatch=function(G){var w=this;this.checkBatchGroupId(G);if(this.isAutoGroup(G)){this.oRequestor.relocateAll("$parked."+G,G);}else{this.oRequestor.addChangeSet(G);}return new Promise(function(x){w.addPrerenderingTask(function(){x(w._submitBatch(G));});});};
v.prototype.toString=function(){return C+": "+this.sServiceUrl;};
v.prototype.withUnresolvedBindings=function(w,P){return this.aAllBindings.filter(function(x){return!x.isResolved();}).some(function(x){return x[w](P);});};
return v;});
sap.ui.predefine('sap/ui/model/odata/v4/ODataParentBinding',["./ODataBinding","./SubmitMode","./lib/_Helper","sap/base/Log","sap/ui/base/SyncPromise","sap/ui/model/ChangeReason"],function(a,S,_,L,b,C){"use strict";
function O(){a.call(this);this.mAggregatedQueryOptions={};this.bAggregatedQueryOptionsInitial=true;this.aChildCanUseCachePromises=[];this.iPatchCounter=0;this.bPatchSuccess=true;this.oReadGroupLock=undefined;this.oRefreshPromise=null;this.oResumePromise=undefined;}
a(O.prototype);var c="sap.ui.model.odata.v4.ODataParentBinding";
O.prototype.attachPatchCompleted=function(f,l){this.attachEvent("patchCompleted",f,l);};
O.prototype.detachPatchCompleted=function(f,l){this.detachEvent("patchCompleted",f,l);};
O.prototype.firePatchCompleted=function(s){if(this.iPatchCounter===0){throw new Error("Completed more PATCH requests than sent");}this.iPatchCounter-=1;this.bPatchSuccess=this.bPatchSuccess&&s;if(this.iPatchCounter===0){this.fireEvent("patchCompleted",{success:this.bPatchSuccess});this.bPatchSuccess=true;}};
O.prototype.attachPatchSent=function(f,l){this.attachEvent("patchSent",f,l);};
O.prototype.detachPatchSent=function(f,l){this.detachEvent("patchSent",f,l);};
O.prototype.firePatchSent=function(){this.iPatchCounter+=1;if(this.iPatchCounter===1){this.fireEvent("patchSent");}};
O.prototype._findEmptyPathParentContext=function(o){if(this.sPath===""&&this.oContext.getBinding){return this.oContext.getBinding()._findEmptyPathParentContext(this.oContext);}return o;};
O.prototype.aggregateQueryOptions=function(q,B,e){var A=_.merge({},this.mAggregatedQueryOptions,this.mLateQueryOptions),f=false,t=this;function m(g,Q,M,i,h){function j(E){var l=!g.$expand[E],s=M+"/"+E;if(l){g.$expand[E]={};if(e&&t.oModel.getMetaModel().fetchObject(s).getResult().$isCollection){return false;}f=true;}return m(g.$expand[E],Q.$expand[E],s,true,l);}function k(s){if(g.$select.indexOf(s)<0){f=true;g.$select.push(s);}return true;}return(!i||Object.keys(g).every(function(n){return n in Q||n==="$count"||n==="$expand"||n==="$select";}))&&Object.keys(Q).every(function(n){switch(n){case"$count":if(Q.$count){g.$count=true;}return true;case"$expand":g.$expand=g.$expand||{};return Object.keys(Q.$expand).every(j);case"$select":g.$select=g.$select||[];return Q.$select.every(k);default:if(h){g[n]=Q[n];return true;}return Q[n]===g[n];}});}if(m(A,q,B)){if(!e){this.mAggregatedQueryOptions=A;}else if(f){this.mLateQueryOptions=A;}return true;}return false;};
O.prototype.changeParameters=function(p){var B=Object.assign({},this.mParameters),s,k,t=this;function e(n){if(t.oModel.bAutoExpandSelect&&n in p){throw new Error("Cannot change $expand or $select parameter in "+"auto-$expand/$select mode: "+n+"="+JSON.stringify(p[n]));}}function u(n){if(n==="$filter"||n==="$search"){s=C.Filter;}else if(n==="$orderby"&&s!==C.Filter){s=C.Sort;}else if(!s){s=C.Change;}}if(!p){throw new Error("Missing map of binding parameters");}e("$expand");e("$select");if(this.hasPendingChanges()){throw new Error("Cannot change parameters due to pending changes");}for(k in p){if(k.startsWith("$$")){throw new Error("Unsupported parameter: "+k);}if(p[k]===undefined&&B[k]!==undefined){u(k);delete B[k];}else if(B[k]!==p[k]){u(k);if(typeof p[k]==="object"){B[k]=_.clone(p[k]);}else{B[k]=p[k];}}}if(s){this.applyParameters(B,s);}};
O.prototype.checkUpdateInternal=function(f){var t=this;function u(){return b.all(t.getDependentBindings().map(function(D){return D.checkUpdateInternal();}));}if(f!==undefined){throw new Error("Unsupported operation: "+c+"#checkUpdateInternal must not"+" be called with parameters");}return this.oCachePromise.then(function(o){if(o&&t.bRelative){return t.fetchResourcePath(t.oContext).then(function(r){if(o.$resourcePath===r){return u();}return t.refreshInternal("");});}return u();});};
O.prototype.createInCache=function(u,v,p,t,i,e,s){var f=this;return this.oCachePromise.then(function(o){if(o){return o.create(u,v,p,t,i,e,s).then(function(g){if(o.$resourcePath){delete f.mCacheByResourcePath[o.$resourcePath];}return g;});}return f.oContext.getBinding().createInCache(u,v,_.buildPath(f.oContext.iIndex,f.sPath,p),t,i,e,s);});};
O.prototype.createReadGroupLock=function(g,l,i){var G,t=this;function e(){t.oModel.addPrerenderingTask(function(){i-=1;if(i>0){Promise.resolve().then(e);}else if(t.oReadGroupLock===G){L.debug("Timeout: unlocked "+G,null,c);t.removeReadGroupLock();}});}this.removeReadGroupLock();this.oReadGroupLock=G=this.lockGroup(g,l);if(l){i=2+(i||0);e();}};
O.prototype.createRefreshPromise=function(){var p,r;p=new Promise(function(e){r=e;});p.$resolve=r;this.oRefreshPromise=p;return p;};
O.prototype.deleteFromCache=function(g,e,p,E,f){var G;if(this.oCache===undefined){throw new Error("DELETE request not allowed");}if(this.oCache){G=g.getGroupId();if(!this.oModel.isAutoGroup(G)&&!this.oModel.isDirectGroup(G)){throw new Error("Illegal update group ID: "+G);}return this.oCache._delete(g,e,p,E,f);}return this.oContext.getBinding().deleteFromCache(g,e,_.buildPath(this.oContext.iIndex,this.sPath,p),E,f);};
O.prototype.destroy=function(){this.aChildCanUseCachePromises=[];this.removeReadGroupLock();this.oResumePromise=undefined;a.prototype.destroy.call(this);};
O.prototype.fetchIfChildCanUseCache=function(o,s,e){var B=this.getBaseForPathReduction(),f,g,h,F,i=s[0]==="#",m=this.oModel.getMetaModel(),p,r=this.oModel.resolve(s,o),R=o.iReturnValueContextId?o.getPath():this.oModel.resolve(this.sPath,this.oContext),D=R.indexOf("(...)")>=0,t=this;function j(){if(i){return m.fetchObject(F.slice(0,F.lastIndexOf("/")+1));}return _.fetchPropertyAndType(t.oModel.oInterface.fetchMetadata,F);}if(D&&!r.includes("/$Parameter/")||this.getRootBinding().isSuspended()||this.mParameters&&this.mParameters.$$aggregation){return b.resolve(r);}g=this.oCachePromise.isRejected()||this.oCache===null||this.oCache&&this.oCache.hasSentRequest();f=m.getMetaPath(o.getPath());F=m.getMetaPath(r);p=[this.doFetchQueryOptions(this.oContext),j(),e];h=b.all(p).then(function(k){var l,n=k[2],w,q=k[0],P=k[1],u;if(Array.isArray(P)){return undefined;}u=m.getReducedPath(r,B);if(s==="$count"||s.endsWith("/$count")||s[0]==="@"){return b.resolve(u);}if(_.getRelativePath(u,R)===undefined){return t.oContext.getBinding().fetchIfChildCanUseCache(t.oContext,_.getRelativePath(r,t.oContext.getPath()),e);}if(D){return b.resolve(u);}l=_.getRelativePath(_.getMetaPath(u),f);if(t.bAggregatedQueryOptionsInitial){t.selectKeyProperties(q,f);t.mAggregatedQueryOptions=_.clone(q);t.bAggregatedQueryOptionsInitial=false;}if(i){w={"$select":[l.slice(1)]};return t.aggregateQueryOptions(w,f,g)?u:undefined;}if(l===""||P&&(P.$kind==="Property"||P.$kind==="NavigationProperty")){w=_.wrapChildQueryOptions(f,l,n,t.oModel.oInterface.fetchMetadata);if(w){return t.aggregateQueryOptions(w,f,g)?u:undefined;}return undefined;}if(l==="value"){return t.aggregateQueryOptions(n,f,g)?u:undefined;}L.error("Failed to enhance query options for auto-$expand/$select as the path '"+F+"' does not point to a property",JSON.stringify(P),c);return undefined;}).then(function(k){if(t.mLateQueryOptions){if(t.oCache){t.oCache.setLateQueryOptions(t.mLateQueryOptions);}else{return t.oContext.getBinding().fetchIfChildCanUseCache(t.oContext,t.sPath,b.resolve(t.mLateQueryOptions)).then(function(P){return P&&k;});}}return k;});this.aChildCanUseCachePromises.push(h);this.oCachePromise=b.all([this.oCachePromise,h]).then(function(k){var l=k[0];if(l&&!l.hasSentRequest()&&!t.oOperation){if(t.bSharedRequest){l.setActive(false);l=t.createAndSetCache(t.mAggregatedQueryOptions,l.getResourcePath(),o);}else{l.setQueryOptions(_.merge({},t.oModel.mUriParameters,t.mAggregatedQueryOptions));}}return l;});this.oCachePromise.catch(function(E){t.oModel.reportError(t+": Failed to enhance query options for "+"auto-$expand/$select for child "+s,c,E);});return h;};
O.prototype.fetchResolvedQueryOptions=function(o){var f,m,M,e=this.oModel,q=this.getQueryOptionsFromParameters();if(!(e.bAutoExpandSelect&&q.$select)){return b.resolve(q);}f=e.oInterface.fetchMetadata;M=_.getMetaPath(e.resolve(this.sPath,o));m=Object.assign({},q,{$select:[]});return b.all(q.$select.map(function(s){return _.fetchPropertyAndType(f,M+"/"+s).then(function(){var w=_.wrapChildQueryOptions(M,s,{},f);if(w){_.aggregateQueryOptions(m,w);}else{_.addToSelect(m,[s]);}});})).then(function(){return m;});};
O.prototype.getBaseForPathReduction=function(){var p,P;if(!this.isRoot()){p=this.oContext.getBinding();P=p.getUpdateGroupId();if(P===this.getUpdateGroupId()||this.oModel.getGroupProperty(P,"submit")!==S.API){return p.getBaseForPathReduction();}}return this.oModel.resolve(this.sPath,this.oContext);};
O.prototype.getCacheQueryOptions=function(){return this.mCacheQueryOptions||_.getQueryOptionsForPath(this.oContext.getBinding().getCacheQueryOptions(),this.sPath);};
O.prototype.getQueryOptionsForPath=function(p,o){if(Object.keys(this.mParameters).length){return _.getQueryOptionsForPath(this.getQueryOptionsFromParameters(),p);}o=o||this.oContext;if(!this.bRelative||!o.getQueryOptionsForPath){return{};}return o.getQueryOptionsForPath(_.buildPath(this.sPath,p));};
O.prototype.getResumePromise=function(){return this.oResumePromise;};
O.prototype.hasPendingChangesInDependents=function(){var D=this.getDependentBindings();return D.some(function(o){var e=o.oCache,h;if(e!==undefined){if(e&&e.hasPendingChangesForPath("")){return true;}}else if(o.hasPendingChangesForPath("")){return true;}if(o.mCacheByResourcePath){h=Object.keys(o.mCacheByResourcePath).some(function(p){return o.mCacheByResourcePath[p].hasPendingChangesForPath("");});if(h){return true;}}return o.hasPendingChangesInDependents();})||this.oModel.withUnresolvedBindings("hasPendingChangesInCaches",this.oModel.resolve(this.sPath,this.oContext).slice(1));};
O.prototype.isPatchWithoutSideEffects=function(){return this.mParameters.$$patchWithoutSideEffects||!this.isRoot()&&this.oContext&&this.oContext.getBinding().isPatchWithoutSideEffects();};
O.prototype.isMeta=function(){return false;};
O.prototype.refreshDependentBindings=function(r,g,e,k){return b.all(this.getDependentBindings().map(function(D){return D.refreshInternal(r,g,e,k);}));};
O.prototype.refreshDependentListBindingsWithoutCache=function(){return b.all(this.getDependentBindings().map(function(D){if(D.filter&&D.oCache===null){return D.refreshInternal("");}if(D.refreshDependentListBindingsWithoutCache){return D.refreshDependentListBindingsWithoutCache();}}));};
O.prototype.removeReadGroupLock=function(){if(this.oReadGroupLock){this.oReadGroupLock.unlock(true);this.oReadGroupLock=undefined;}};
O.prototype.refreshSuspended=function(g){if(g&&g!==this.getGroupId()){throw new Error(this+": Cannot refresh a suspended binding with group ID '"+g+"' (own group ID is '"+this.getGroupId()+"')");}this.setResumeChangeReason(C.Refresh);};
O.prototype.requestAbsoluteSideEffects=function(g,A){var p=[],m=_.getMetaPath(this.oModel.resolve(this.sPath,this.oContext)),r;r=A.some(function(s){var R=_.getRelativePath(s,m);if(R!==undefined){p.push(R);}return _.hasPathPrefix(m,s);});if(r){return this.refreshInternal("",g);}else if(p.length){return this.requestSideEffects(g,p);}};
O.prototype.resetChangesInDependents=function(p){this.getDependentBindings().forEach(function(D){p.push(D.oCachePromise.then(function(o){if(o){o.resetChangesForPath("");}D.resetInvalidDataState();}).unwrap());if(D.mCacheByResourcePath){Object.keys(D.mCacheByResourcePath).forEach(function(P){D.mCacheByResourcePath[P].resetChangesForPath("");});}D.resetChangesInDependents(p);});};
O.prototype.resolveRefreshPromise=function(r){if(this.oRefreshPromise){this.oRefreshPromise.$resolve(r);this.oRefreshPromise=null;}return r;};
O.prototype._resume=function(A){var t=this;function e(){t.bSuspended=false;if(t.oResumePromise){t.resumeInternal(true);t.oResumePromise.$resolve();t.oResumePromise=undefined;}}if(this.oOperation){throw new Error("Cannot resume an operation binding: "+this);}if(!this.isRoot()){throw new Error("Cannot resume a relative binding: "+this);}if(!this.bSuspended){throw new Error("Cannot resume a not suspended binding: "+this);}if(A){this.createReadGroupLock(this.getGroupId(),true,1);this.oModel.addPrerenderingTask(e);}else{this.createReadGroupLock(this.getGroupId(),true);e();}};
O.prototype.resume=function(){this._resume(false);};
O.prototype.resumeAsync=function(){this._resume(true);return Promise.resolve(this.oResumePromise);};
O.prototype.selectKeyProperties=function(q,m){_.selectKeyProperties(q,this.oModel.getMetaModel().getObject(m+"/"));};
O.prototype.suspend=function(){var r;if(this.oOperation){throw new Error("Cannot suspend an operation binding: "+this);}if(!this.isRoot()){throw new Error("Cannot suspend a relative binding: "+this);}if(this.bSuspended){throw new Error("Cannot suspend a suspended binding: "+this);}if(this.hasPendingChanges()){throw new Error("Cannot suspend a binding with pending changes: "+this);}this.bSuspended=true;this.oResumePromise=new b(function(e,f){r=e;});this.oResumePromise.$resolve=r;this.removeReadGroupLock();};
O.prototype.updateAggregatedQueryOptions=function(n){var A=Object.keys(n),t=this;if(this.mAggregatedQueryOptions){A=A.concat(Object.keys(this.mAggregatedQueryOptions));A.forEach(function(N){if(t.bAggregatedQueryOptionsInitial||N!=="$select"&&N!=="$expand"){if(n[N]===undefined){delete t.mAggregatedQueryOptions[N];}else{t.mAggregatedQueryOptions[N]=n[N];}}});}};
O.prototype.visitSideEffects=function(g,p,o,n,P,s){var D=o?this.oModel.getDependentBindings(o):this.getDependentBindings();D.forEach(function(e){var f=_.buildPath(s,_.getMetaPath(e.getPath())),h;if(e.oCache){h=_.stripPathPrefix(f,p);if(h.length){P.push(e.requestSideEffects(g,h));}}else if(n[f]){P.push(e.refreshInternal("",g));}else{e.visitSideEffects(g,p,null,n,P,f);}});};
function d(p){if(this){O.apply(this,arguments);}else{Object.assign(p,O.prototype);}}
d.prototype.doDeregisterChangeListener=O.prototype.doDeregisterChangeListener;d.prototype.destroy=O.prototype.destroy;d.prototype.fetchCache=O.prototype.fetchCache;d.prototype.hasPendingChangesForPath=O.prototype.hasPendingChangesForPath;return d;},false);
sap.ui.predefine('sap/ui/model/odata/v4/ODataPropertyBinding',["./ODataBinding","./lib/_Cache","./lib/_Helper","sap/base/Log","sap/ui/base/SyncPromise","sap/ui/model/BindingMode","sap/ui/model/ChangeReason","sap/ui/model/odata/v4/Context","sap/ui/model/PropertyBinding"],function(a,_,b,L,S,B,C,c,P){"use strict";var s="sap.ui.model.odata.v4.ODataPropertyBinding",i=Object.freeze([]),m={AggregatedDataStateChange:true,change:true,dataReceived:true,dataRequested:true,DataStateChange:true};
var O=P.extend("sap.ui.model.odata.v4.ODataPropertyBinding",{
constructor:function(M,p,o,d){P.call(this,M,p);a.call(this);if(p.endsWith("/")){throw new Error("Invalid path: "+p);}if(d){this.checkBindingParameters(d,["$$groupId","$$ignoreMessages","$$noPatch"]);this.sGroupId=d.$$groupId;this.bNoPatch=d.$$noPatch;this.setIgnoreMessages(d.$$ignoreMessages);}else{this.sGroupId=undefined;}this.oCheckUpdateCallToken=undefined;this.mQueryOptions=this.oModel.buildQueryOptions(b.clone(d),false);this.fetchCache(o);this.oContext=o;this.bHasDeclaredType=undefined;this.bInitial=true;this.vValue=undefined;M.bindingCreated(this);},
metadata:{publicMethods:[]}
});
a(O.prototype);
O.prototype.adjustPredicate=function(){};
O.prototype.attachEvent=function(e){if(!(e in m)){throw new Error("Unsupported event '"+e+"': v4.ODataPropertyBinding#attachEvent");}return P.prototype.attachEvent.apply(this,arguments);};
O.prototype.checkUpdateInternal=function(f,d,g,v){var D=false,h=this.sPath.indexOf("##"),I=h>=0,M=this.oModel.getMetaModel(),p={data:{}},r=this.oModel.resolve(this.sPath,this.oContext),o={forceUpdate:r&&(f||this.oCheckUpdateCallToken&&this.oCheckUpdateCallToken.forceUpdate)},t=this.oType,e=this;this.oCheckUpdateCallToken=o;if(this.bHasDeclaredType===undefined){this.bHasDeclaredType=!!t;}if(r&&!this.bHasDeclaredType&&this.sInternalType!=="any"&&!I){t=M.fetchUI5Type(r);}if(arguments.length<4){v=this.oCachePromise.then(function(j){var k,l;if(j){return j.fetchValue(e.lockGroup(g||e.getGroupId()),undefined,function(){D=true;e.fireDataRequested();},e).then(function(R){e.assertSameCache(j);return R;});}if(!e.sReducedPath||!e.isResolved()){return undefined;}if(e.bRelative&&e.oContext.iIndex===c.VIRTUAL){o.forceUpdate=false;}if(!I){return e.oContext.fetchValue(e.sReducedPath,e);}k=e.sPath.slice(0,h);l=e.sPath.slice(h+2);if(l[0]==="/"){l="."+l;}return M.fetchObject(l,M.getMetaContext(e.oModel.resolve(k,e.oContext)));}).then(function(v){if(!v||typeof v!=="object"){return v;}if(e.sInternalType==="any"&&(e.getBindingMode()===B.OneTime||(e.sPath[e.sPath.lastIndexOf("/")+1]==="#"&&!I))){if(I){return v;}else if(e.bRelative){return b.publicClone(v);}}L.error("Accessed value is not primitive",r,s);},function(E){e.oModel.reportError("Failed to read path "+r,s,E);if(E.canceled){o.forceUpdate=false;return e.vValue;}p={error:E};});if(f&&v.isFulfilled()){if(t&&t.isFulfilled&&t.isFulfilled()){this.setType(t.getResult(),this.sInternalType);}this.vValue=v.getResult();}v=Promise.resolve(v);}return S.all([v,t]).then(function(R){var T=R[1],v=R[0];if(o===e.oCheckUpdateCallToken){e.oCheckUpdateCallToken=undefined;e.setType(T,e.sInternalType);if(o.forceUpdate||e.vValue!==v){e.bInitial=false;e.vValue=v;e._fireChange({reason:d||C.Change});}e.checkDataState();}if(D){e.fireDataReceived(p);}});};
O.prototype.deregisterChange=function(){var t=this;this.withCache(function(o,p,d){d.doDeregisterChangeListener(p,t);}).catch(function(e){t.oModel.reportError("Error in deregisterChange",s,e);},"",false,true);};
O.prototype.destroy=function(){this.deregisterChange();this.oModel.bindingDestroyed(this);this.oCheckUpdateCallToken=undefined;this.mQueryOptions=undefined;this.vValue=undefined;a.prototype.destroy.call(this);P.prototype.destroy.apply(this,arguments);};
O.prototype.doCreateCache=function(r,q){return _.createProperty(this.oModel.oRequestor,r,q);};
O.prototype.doFetchQueryOptions=function(){return this.isRoot()?S.resolve(this.mQueryOptions):S.resolve({});};
O.prototype.getDependentBindings=function(){return i;};
O.prototype.getResumePromise=function(){};
O.prototype.getValue=function(){return this.vValue;};
O.prototype.getValueListType=function(){var r=this.getModel().resolve(this.sPath,this.oContext);if(!r){throw new Error(this+" is unresolved");}return this.getModel().getMetaModel().getValueListType(r);};
O.prototype.hasPendingChangesInDependents=function(){return false;};
O.prototype.initialize=function(){if(this.isResolved()){if(this.getRootBinding().isSuspended()){this.sResumeChangeReason=C.Change;}else{this.checkUpdate(true);}}};
O.prototype.isMeta=function(){return this.sPath.includes("##");};
O.prototype.onChange=function(v){this.checkUpdateInternal(undefined,undefined,undefined,v);};
O.prototype.refreshInternal=function(r,g,d){if(this.isRootBindingSuspended()){this.sResumeChangeReason=C.Refresh;return S.resolve();}this.fetchCache(this.oContext);return d?this.checkUpdateInternal(false,C.Refresh,g):S.resolve();};
O.prototype.requestValue=function(){var t=this;return Promise.resolve(this.checkUpdateInternal().then(function(){return t.getValue();}));};
O.prototype.requestValueListInfo=function(A){var r=this.getModel().resolve(this.sPath,this.oContext);if(!r){throw new Error(this+" is unresolved");}return this.getModel().getMetaModel().requestValueListInfo(r,A);};
O.prototype.requestValueListType=function(){var r=this.getModel().resolve(this.sPath,this.oContext);if(!r){throw new Error(this+" is unresolved");}return this.getModel().getMetaModel().requestValueListType(r);};
O.prototype.resetChangesInDependents=function(){};
O.prototype.resetInvalidDataState=function(){if(this.getDataState().isControlDirty()){this._fireChange({reason:C.Change});}};
O.prototype.resume=function(){throw new Error("Unsupported operation: resume");};
O.prototype.resumeInternal=function(d){var r=this.sResumeChangeReason;this.sResumeChangeReason=undefined;this.fetchCache(this.oContext);if(d){this.checkUpdateInternal(false,r);}};
O.prototype.setContext=function(o){if(this.oContext!==o){if(this.bRelative){this.deregisterChange();}this.oContext=o;if(this.bRelative){this.fetchCache(this.oContext);this.checkUpdateInternal(false,C.Context);}}};
O.prototype.setType=function(t){var o=this.oType;if(t&&t.getName()==="sap.ui.model.odata.type.DateTimeOffset"){t.setV4();}P.prototype.setType.apply(this,arguments);if(!this.bInitial&&o!==t){this._fireChange({reason:C.Change});}};
O.prototype.setValue=function(v,g){var G,t=this;function r(e){t.oModel.reportError("Failed to update path "+t.oModel.resolve(t.sPath,t.oContext),s,e);return e;}this.checkSuspended();if(this.bNoPatch&&g){throw r(new Error("Must not specify a group ID ("+g+") with $$noPatch"));}this.oModel.checkGroupId(g);if(typeof v==="function"||(v&&typeof v==="object")){throw r(new Error("Not a primitive value"));}if(!this.bNoPatch&&this.vValue===undefined){throw r(new Error("Must not change a property before it has been read"));}if(this.vValue!==v){if(this.oCache){r(new Error("Cannot set value on this binding as it is not relative"+" to a sap.ui.model.odata.v4.Context"));return;}G=this.bNoPatch?null:this.lockGroup(g,true,true);this.oContext.doSetProperty(this.sPath,v,G).catch(function(e){if(G){G.unlock(true);}r(e);});}};
O.prototype.supportsIgnoreMessages=function(){return true;};
O.prototype.suspend=function(){throw new Error("Unsupported operation: suspend");};
O.prototype.visitSideEffects=function(){};
return O;});
sap.ui.predefine('sap/ui/model/odata/v4/ODataUtils',["sap/ui/core/CalendarType","sap/ui/core/format/DateFormat","sap/ui/model/odata/ODataUtils","sap/ui/model/odata/v4/lib/_Helper"],function(C,D,B,_){"use strict";var d,o,s="\\d{4}-(?:0[1-9]|1[0-2])-(?:0[1-9]|[12]\\d|3[01])",t,T="(?:[01]\\d|2[0-3]):[0-5]\\d(?::[0-5]\\d(\\.\\d{1,12})?)?",r=new RegExp("^"+s+"$"),a=new RegExp("^"+s+"T"+T+"(?:Z|[-+](?:0\\d|1[0-3]):[0-5]\\d|[-+]14:00)$","i"),b=new RegExp("^"+T+"$"),O={_setDateTimeFormatter:function(){d=D.getDateInstance({calendarType:C.Gregorian,pattern:"yyyy-MM-dd",strictParsing:true,UTC:true});o=D.getDateTimeInstance({calendarType:C.Gregorian,pattern:"yyyy-MM-dd'T'HH:mm:ss.SSSXXX",strictParsing:true});t=D.getTimeInstance({calendarType:C.Gregorian,pattern:"HH:mm:ss.SSS",strictParsing:true,UTC:true});},compare:function(v,V,e){if(e===true||e==="Decimal"){return B.compare(v,V,true);}if(e==="DateTime"){return B.compare(O.parseDateTimeOffset(v),O.parseDateTimeOffset(V));}return B.compare(v,V);},formatLiteral:function(v,c){return _.formatLiteral(v,c);},parseDate:function(c){var e=r.test(c)&&d.parse(c);if(!e){throw new Error("Not a valid Edm.Date value: "+c);}return e;},parseDateTimeOffset:function(c){var e,m=a.exec(c);if(m){if(m[1]&&m[1].length>4){c=c.replace(m[1],m[1].slice(0,4));}e=o.parse(c.toUpperCase());}if(!e){throw new Error("Not a valid Edm.DateTimeOffset value: "+c);}return e;},parseTimeOfDay:function(c){var e;if(b.test(c)){if(c.length>12){c=c.slice(0,12);}e=t.parse(c);}if(!e){throw new Error("Not a valid Edm.TimeOfDay value: "+c);}return e;}};O._setDateTimeFormatter();return O;},true);
sap.ui.predefine('sap/ui/model/odata/v4/SubmitMode',function(){"use strict";var S={API:"API",Auto:"Auto",Direct:"Direct"};return S;},true);
sap.ui.predefine('sap/ui/model/odata/v4/ValueListType',function(){"use strict";var V={None:"None",Fixed:"Fixed",Standard:"Standard"};return V;},true);
sap.ui.predefine('sap/ui/model/odata/v4/_AnnotationHelperExpression',["../_AnnotationHelperBasics","sap/base/Log","sap/ui/base/BindingParser","sap/ui/base/ManagedObject","sap/ui/base/SyncPromise","sap/ui/performance/Measurement"],function(B,L,a,M,S,b){'use strict';var A="sap.ui.model.odata.v4.AnnotationHelper",p=[A],P=A+"/getExpression",E,r=/^\{@i18n>[^\\\{\}:]+\}$/,o={And:"&&",Eq:"===",Ge:">=",Gt:">",Le:"<=",Lt:"<",Ne:"!==",Not:"!",Or:"||"},s=false,t={"Edm.Boolean":"boolean","Edm.Byte":"number","Edm.Date":"Date","Edm.DateTimeOffset":"DateTimeOffset","Edm.Decimal":"Decimal","Edm.Double":"number","Edm.Guid":"string","Edm.Int16":"number","Edm.Int32":"number","Edm.Int64":"Decimal","Edm.SByte":"number","Edm.Single":"number","Edm.String":"string","Edm.TimeOfDay":"TimeOfDay"},T={Bool:"Edm.Boolean",Float:"Edm.Double",Date:"Edm.Date",DateTimeOffset:"Edm.DateTimeOffset",Decimal:"Edm.Decimal",Guid:"Edm.Guid",Int:"Edm.Int64",Int32:"Edm.Int32",String:"Edm.String",TimeOfDay:"Edm.TimeOfDay"},m={"boolean":false,"Date":false,"DateTimeOffset":true,"Decimal":true,"number":false,"string":false,"TimeOfDay":false};
function c(e,f){return S.resolve().then(function(){d(e,f);});}
function d(e,f){B.error(e,f,A);}
E={adjustOperands:function(O,e){if(O.result!=="constant"&&O.category==="number"&&e.result==="constant"&&e.type==="Edm.Int64"){e.category="number";}if(O.result!=="constant"&&O.category==="Decimal"&&e.result==="constant"&&e.type==="Edm.Int32"){e.category="Decimal";e.type=O.type;}},apply:function(e,f){var F=B.descend(e,"$Function","string");switch(F.value){case"odata.concat":return E.concat(f);case"odata.fillUriTemplate":return E.fillUriTemplate(f);case"odata.uriEncode":return E.uriEncode(f);default:return c(F,"unknown function: "+F.value);}},concat:function(e){var f;B.expectType(e,"array");f=e.value.map(function(u,i){return E.parameter(e,i);});return S.all(f).then(function(g){var h,i,R;h=e.asExpression||g.some(function(j){return j.result==="expression";});i=g.filter(function(j){return j.type!=='edm:Null';}).map(function(j){if(h){E.wrapExpression(j);}return B.resultToString(j,h,e.complexBinding);});R=h?{result:"expression",value:i.join("+")}:{result:"composite",value:i.join("")};R.type="Edm.String";return R;});},conditional:function(e){var C=e.complexBinding,f=C?Object.assign({},e,{complexBinding:false}):e;function g(h,i){return B.resultToString(E.wrapExpression(h),true,i);}return S.all([E.parameter(f,0,"Edm.Boolean"),E.parameter(e,1),E.parameter(e,2)]).then(function(R){var h=R[0],i=R[1],j=R[2],k=i.type;if(i.type==="edm:Null"){k=j.type;}else if(j.type!=="edm:Null"&&i.type!==j.type){d(e,"Expected same type for second and third parameter, types are '"+i.type+"' and '"+j.type+"'");}return{result:"expression",type:k,value:g(h,false)+"?"+g(i,C)+":"+g(j,C)};});},constant:function(e,f){var v=e.value;if(f==="String"){if(r.test(v)){return{ignoreTypeInPath:true,result:"binding",type:"Edm.String",value:v.slice(1,-1)};}}return{result:"constant",type:T[f],value:v};},expression:function(e){var R=e.value,f=e,g;if(R===null){g="Null";}else if(typeof R==="boolean"){g="Bool";}else if(typeof R==="number"){g=isFinite(R)&&Math.floor(R)===R?"Int32":"Float";}else if(typeof R==="string"){g="String";}else{B.expectType(e,"object");if(R.$kind==="Property"){e.value=e.model.getObject(e.path+"@sapui.name");return E.path(e);}["$And","$Apply","$Date","$DateTimeOffset","$Decimal","$Float","$Eq","$Ge","$Gt","$Guid","$If","$Int","$Le","$Lt","$Name","$Ne","$Not","$Null","$Or","$Path","$PropertyPath","$TimeOfDay","$LabeledElement"].forEach(function(h){if(R.hasOwnProperty(h)){g=h.slice(1);f=B.descend(e,h);}});}switch(g){case"Apply":return E.apply(e,f);case"If":return E.conditional(f);case"Name":case"Path":case"PropertyPath":return E.path(f);case"Date":case"DateTimeOffset":case"Decimal":case"Guid":case"Int":case"String":case"TimeOfDay":B.expectType(f,"string");case"Bool":case"Float":case"Int32":return S.resolve(E.constant(f,g));case"And":case"Eq":case"Ge":case"Gt":case"Le":case"Lt":case"Ne":case"Or":return E.operator(f,g);case"Not":return E.not(f);case"Null":return S.resolve({result:"constant",type:"edm:Null",value:null});default:return c(e,"Unsupported OData expression");}},fetchCurrencyOrUnit:function(e,v,f,C){var g="sap.ui.model.odata.type.Unit",h="@@requestUnitsOfMeasure",i=e.model,j=e.path+"@Org.OData.Measures.V1.Unit/$Path",k=i.getObject(j);function l(n,q,u){return B.resultToString({constraints:n,result:"binding",type:q,value:e.prefix+u},false,true);}if(!k){g="sap.ui.model.odata.type.Currency";h="@@requestCurrencyCodes";j=e.path+"@Org.OData.Measures.V1.ISOCurrency/$Path";k=i.getObject(j);}if(!k){return undefined;}return i.fetchObject(j+"/$").then(function(n){return{result:"composite",type:g,value:(t[f]==="number"?"{formatOptions:{parseAsString:false},":"{")+"mode:'TwoWay',parts:["+l(C,f,v)+","+l(i.getConstraints(n,j),n.$Type,k)+",{mode:'OneTime',path:'/##"+h+"',targetType:'any'}"+"],type:'"+g+"'}"};});},fillUriTemplate:function(e){var i,f=[],g;e.complexBinding=false;g=[E.parameter(e,0,"Edm.String")];for(i=1;i<e.value.length;i+=1){f[i]=B.descend(e,i,"object");g.push(E.expression(B.descend(f[i],"$LabeledElement",true)));}return S.all(g).then(function(R){var n,h=[],j="";h.push('odata.fillUriTemplate(',B.resultToString(R[0],true,false),',{');for(i=1;i<e.value.length;i+=1){n=B.property(f[i],"$Name","string");h.push(j,B.toJSON(n),":",B.resultToString(R[i],true,false));j=",";}h.push("})");return{result:"expression",type:"Edm.String",value:h.join("")};});},formatOperand:function(R,w){if(R.result==="constant"){switch(R.category){case"boolean":case"number":return String(R.value);}}if(w){E.wrapExpression(R);}return B.resultToString(R,true,false);},getExpression:function(f){if(f.value===undefined){return undefined;}b.average(P,"",p);if(!s&&M.bindingParser===a.simpleParser){L.warning("Complex binding syntax not active",null,A);s=true;}return E.expression(f).then(function(R){return B.resultToString(R,false,f.complexBinding);},function(e){if(e instanceof SyntaxError){return"Unsupported: "+a.complexParser.escape(B.toErrorString(f.value));}throw e;}).finally(function(){b.end(P);}).unwrap();},not:function(e){e.asExpression=true;e.complexBinding=false;return E.expression(e).then(function(f){return{result:"expression",type:"Edm.Boolean",value:"!"+B.resultToString(E.wrapExpression(f),true,false)};});},operator:function(e,f){var g=f==="And"||f==="Or"?"Edm.Boolean":undefined;e.complexBinding=false;return S.all([E.parameter(e,0,g),E.parameter(e,1,g)]).then(function(R){var n,h=R[0],i=R[1],j="",v,V;if(h.type!=="edm:Null"&&i.type!=="edm:Null"){h.category=t[h.type];i.category=t[i.type];E.adjustOperands(h,i);E.adjustOperands(i,h);if(h.category!==i.category){d(e,"Expected two comparable parameters but instead saw "+h.type+" and "+i.type);}switch(h.category){case"Decimal":j=",'Decimal'";break;case"DateTimeOffset":j=",'DateTime'";break;}n=m[h.category];}v=E.formatOperand(h,!n);V=E.formatOperand(i,!n);return{result:"expression",type:"Edm.Boolean",value:n?"odata.compare("+v+","+V+j+")"+o[f]+"0":v+o[f]+V};});},parameter:function(e,i,f){var g=B.descend(e,i,true);return E.expression(g).then(function(R){if(f&&f!==R.type){d(g,"Expected "+f+" but instead saw "+R.type);}return R;});},path:function(e){var i=e.ignoreAsPrefix,f=e.model,g,v=e.value;if(i&&v.startsWith(i)){v=v.slice(i.length);}B.expectType(e,"string");g=f.fetchObject(e.path+"/$");if(g.isPending()&&!e.$$valueAsPromise){g.caught();g=S.resolve();}return g.then(function(h){var C,j,k=h&&h.$Type;if(h&&e.complexBinding){C=f.getConstraints(h,e.path);j=E.fetchCurrencyOrUnit(e,v,k,C);}return j||{constraints:C,formatOptions:k==="Edm.String"&&!(e.formatOptions&&"parseKeepsEmptyString"in e.formatOptions)?Object.assign({parseKeepsEmptyString:true},e.formatOptions):e.formatOptions,parameters:e.parameters,result:"binding",type:k,value:e.prefix+v};});},uriEncode:function(e){return E.parameter(e,0).then(function(R){return{result:"expression",type:"Edm.String",value:R.type==="Edm.String"?'odata.uriEncode('+B.resultToString(R,true,false)+","+B.toJSON(R.type)+")":'String('+B.resultToString(R,true,false)+")"};});},wrapExpression:function(R){if(R.result==="expression"){R.value="("+R.value+")";}return R;}};return E;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_AggregationCache',["./_AggregationHelper","./_Cache","./_GroupLock","./_Helper","./_Parser","sap/base/Log","sap/ui/base/SyncPromise"],function(_,a,b,c,d,L,S){"use strict";var r=/,|%2C|%2c/,e=new RegExp("^"+d.sODataIdentifier+"(?:"+d.sWhitespace+"+(?:asc|desc))?$"),f=new RegExp(d.sWhitespace+"+");
function g(R,s,A,q){var m={},F,M;a.call(this,R,s,q,true);this.oAggregation=A;if("$expand"in q){throw new Error("Unsupported system query option: $expand");}if("$select"in q){throw new Error("Unsupported system query option: $select");}if(_.hasMinOrMax(A.aggregate)){if(A.groupLevels.length){throw new Error("Unsupported group levels together with min/max");}this.oMeasureRangePromise=new Promise(function(h,i){M=h;});F=_.buildApply(A,q,m);this.oFirstLevel=a.create(R,s,F,true);this.oFirstLevel.getResourcePathWithQuery=g.getResourcePathWithQuery.bind(this.oFirstLevel,A,q);this.oFirstLevel.handleResponse=g.handleResponse.bind(this.oFirstLevel,null,m,M,this.oFirstLevel.handleResponse);}else if(A.groupLevels.length){this.aElements=[];this.aElements.$byPredicate={};this.aElements.$count=undefined;this.aElements.$created=0;if(q.$count){throw new Error("Unsupported system query option: $count");}if(q.$filter){throw new Error("Unsupported system query option: $filter");}this.oFirstLevel=this.createGroupLevelCache();}else{this.oFirstLevel=a.create(R,s,q,true);this.oFirstLevel.getResourcePathWithQuery=g.getResourcePathWithQuery.bind(this.oFirstLevel,A,q);this.oFirstLevel.handleResponse=g.handleResponse.bind(this.oFirstLevel,A,null,null,this.oFirstLevel.handleResponse);}}
g.prototype=Object.create(a.prototype);
g.prototype.addElements=function(R,o){var E=this.aElements;R.forEach(function(h,i){var p=c.getPrivateAnnotation(h,"predicate");E[o+i]=h;E.$byPredicate[p]=h;});};
g.prototype.createGroupLevelCache=function(p){var C,F,s,G,l,i,m,q,t;i=p?p["@$ui5.node.level"]+1:1;F=g.filterAggregation(this.oAggregation,i);G=F.$groupBy;delete F.$groupBy;m=F.$missing;delete F.$missing;q=Object.assign({},this.mQueryOptions);s=g.filterOrderby(this.mQueryOptions.$orderby,F);if(s){q.$orderby=s;}else{delete q.$orderby;}if(p){q.$$filterBeforeAggregate=c.getPrivateAnnotation(p,"filter");}delete q.$count;q=_.buildApply(F,q);q.$count=true;C=a.create(this.oRequestor,this.sResourcePath,q,true);l=!F.groupLevels.length;t=!l&&Object.keys(F.aggregate).length>0;C.calculateKeyPredicate=g.calculateKeyPredicate.bind(null,p,G,m,l,t,this.aElements.$byPredicate);return C;};
g.prototype.expand=function(G,s){var C,o,t=this;o=this.fetchValue(b.$cached,s).getResult();c.updateAll(this.mChangeListeners,s,o,{"@$ui5.node.isExpanded":true});C=this.createGroupLevelCache(o);return C.read(0,this.iReadLength,0,G).then(function(R){var h=R.value.$count,I=t.aElements.indexOf(o)+1,i;for(i=t.aElements.length-1;i>=I;i-=1){t.aElements[i+h]=t.aElements[i];}t.addElements(R.value,I);t.aElements.$count+=h;for(i=I+R.value.length;i<I+h;i+=1){t.aElements[i]={};c.setPrivateAnnotation(t.aElements[i],"index",i-I);c.setPrivateAnnotation(t.aElements[i],"parent",C);}return h;},function(E){c.updateAll(t.mChangeListeners,s,o,{"@$ui5.node.isExpanded":false});throw E;});};
g.prototype.fetchValue=function(G,p,D,l){var t=this;if(p==="$count"){if(!this.mQueryOptions.$count){L.error("Failed to drill-down into $count, invalid segment: $count",this.toString(),"sap.ui.model.odata.v4.lib._Cache");return S.resolve();}if(!this.oMeasureRangePromise){return this.oFirstLevel.fetchValue(G,p).then(function(){return t.oFirstLevel.iLeafCount;});}}if(this.oAggregation.groupLevels.length){this.registerChange(p,l);return this.drillDown(this.aElements,p,G);}return this.oFirstLevel.fetchValue(G,p,D,l);};
g.prototype.getMeasureRangePromise=function(){return this.oMeasureRangePromise;};
g.prototype.read=function(I,l,p,G,D){var i,n,C,o,h,H=this.oAggregation.groupLevels.length,R=[],t=this;function k(h,j){var s=c.getPrivateAnnotation(t.aElements[h],"index"),m=t.aElements[h];R.push(o.read(s,j-h,0,G.getUnlockedCopy(),D).then(function(q){if(m!==t.aElements[h]&&q.value[0]!==t.aElements[h]){h=t.aElements.indexOf(m);if(h<0){h=t.aElements.indexOf(q.value[0]);}}t.addElements(q.value,h);}));}if(H&&this.aElements.length){for(i=I,n=Math.min(I+l,this.aElements.length);i<n;i+=1){C=c.getPrivateAnnotation(this.aElements[i],"parent");if(C!==o){if(h){k(h,i);o=h=undefined;}if(C){h=i;o=C;}}}if(h){k(h,i);}G.unlock();return S.all(R).then(function(){var E=t.aElements.slice(I,I+l);E.$count=t.aElements.$count;return{value:E};});}return this.oFirstLevel.read(I,l,p,G,D).then(function(m){var j;if(H){t.addElements(m.value,I);t.aElements.$count=m.value.$count;for(j=0;j<t.aElements.$count;j+=1){if(!t.aElements[j]){t.aElements[j]={};c.setPrivateAnnotation(t.aElements[j],"index",j);c.setPrivateAnnotation(t.aElements[j],"parent",t.oFirstLevel);}}t.iReadLength=l+p;}else if(!t.oMeasureRangePromise){m.value.forEach(function(E){if(!("@$ui5.node.level"in E)){E["@$ui5.node.isExpanded"]=undefined;E["@$ui5.node.isTotal"]=false;E["@$ui5.node.level"]=1;}});}return m;});};
g.prototype.toString=function(){return this.oRequestor.getServiceUrl()+this.sResourcePath+this.oRequestor.buildQueryString(this.sMetaPath,_.buildApply(this.oAggregation,this.mQueryOptions),false,true);};
g.calculateKeyPredicate=function(G,h,m,l,t,B,E,T,M){var p;function s(o){return JSON.stringify(c.publicClone(o));}h.forEach(function(n){if(!(n in E)){E[n]=G[n];}});m.forEach(function(n){E[n]=null;});p=c.getKeyPredicate(E,M,T,h,true);if(p in B){throw new Error("Multi-unit situation detected: "+s(E)+" vs. "+s(B[p]));}c.setPrivateAnnotation(E,"predicate",p);if(!l){c.setPrivateAnnotation(E,"filter",c.getKeyFilter(E,M,T,h));}if(E["@$ui5.node.level"]!==0){E["@$ui5.node.isExpanded"]=l?undefined:false;E["@$ui5.node.isTotal"]=t;E["@$ui5.node.level"]=G?G["@$ui5.node.level"]+1:1;}};
g.create=function(R,s,A,q){return new g(R,s,A,q);};
g.filterAggregation=function(A,l){var F,G,h;function i(t,K){t[K]=this[K];return t;}function j(M,K){return K.reduce(i.bind(M),{});}function k(M,p){return Object.keys(M).filter(p);}function m(s){return!A.aggregate[s].subtotals;}function n(s){return A.aggregate[s].subtotals;}function o(s){return A.groupLevels.indexOf(s)<0;}G=A.groupLevels.slice(l-1,l);F={aggregate:G.length?j(A.aggregate,k(A.aggregate,n)):A.aggregate,groupLevels:G,$groupBy:A.groupLevels.slice(0,l)};h=k(A.group,o).sort();if(G.length){F.group={};F.$missing=A.groupLevels.slice(l).concat(h).concat(Object.keys(A.aggregate).filter(m));}else{F.group=j(A.group,h);F.$groupBy=F.$groupBy.concat(h);F.$missing=[];}return F;};
g.filterOrderby=function(o,A){if(o){return o.split(r).filter(function(O){var n;if(e.test(O)){n=O.split(f)[0];return n in A.aggregate||n in A.group||A.groupLevels.indexOf(n)>=0;}return true;}).join(",");}};
g.getResourcePathWithQuery=function(A,q,s,E){q=Object.assign({},q,{$skip:s,$top:E-s});q=_.buildApply(A,q,null,this.bFollowUp);this.bFollowUp=true;return this.sResourcePath+this.oRequestor.buildQueryString(this.sMetaPath,q,false,true);};
g.handleResponse=function(A,m,M,h,s,E,R,t){var i,j={},o;function k(l){j[l]=j[l]||{};return j[l];}if(m){o=R.value.shift();R["@odata.count"]=o.UI5__count;for(i in m){k(m[i].measure)[m[i].method]=o[i];}M(j);this.handleResponse=h;}else{o=R.value[0];if("UI5__count"in o){this.iLeafCount=parseInt(o.UI5__count);R["@odata.count"]=this.iLeafCount+1;if(s>0){R.value.shift();}}if(s===0){o["@$ui5.node.isExpanded"]=true;o["@$ui5.node.isTotal"]=true;o["@$ui5.node.level"]=0;Object.keys(o).forEach(function(K){if(K.startsWith("UI5grand__")){o[K.slice(10)]=o[K];}});Object.keys(A.aggregate).forEach(function(l){o[l]=o[l]||null;});Object.keys(A.group).forEach(function(G){o[G]=null;});}}h.call(this,s,E,R,t);};
return g;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_AggregationHelper',["./_Helper","sap/ui/model/Filter"],function(_,F){"use strict";var a={"grandTotal":"boolean","max":"boolean","min":"boolean","name":"string","subtotals":"boolean","with":"string"},A={aggregate:"object",group:"object",groupLevels:"array"},b;
function c(D,m,n){var k;function e(M){if(n){M+=" at property: "+n;}throw new Error(M);}function t(v){return Array.isArray(v)?"array":typeof v;}for(k in D){if(!(m&&k in m)){e("Unsupported '"+k+"'");}else if(t(D[k])!==m[k]){e("Not a "+m[k]+" value for '"+k+"'");}}}
function d(m,e){var n;for(n in m){c(m[n],e,n);}}
b={buildApply:function(o,q,m,f){var e,s="",C=[],g,h,S;function i(k){var D=o.aggregate[k],l=D.name||k,G=k,w=D.with;if(w){if((w==="average"||w==="countdistinct")&&(D.grandTotal||D.subtotals)){throw new Error("Cannot aggregate totals with '"+w+"'");}l+=" with "+w+" as "+k;}else if(D.name){l+=" as "+k;}if(!f){if(D.min){p(k,"min");}if(D.max){p(k,"max");}}if(D.grandTotal){h=true;if(!q.$skip){if(w){G+=" with "+w+" as UI5grand__"+k;}C.push(G);}}return l;}function n(G){return o.groupLevels.indexOf(G)<0;}function p(N,M){var k="UI5"+M+"__"+N;C.push(N+" with "+M+" as "+k);if(m){m[k]={measure:N,method:M};}}function j(){var t="";if(q.$skip){t="skip("+q.$skip+")";}delete q.$skip;if(q.$top<Infinity){if(t){t+="/";}t+="top("+q.$top+")";}delete q.$top;return t;}q=Object.assign({},q);c(o,A);o.groupLevels=o.groupLevels||[];o.aggregate=o.aggregate||{};d(o.aggregate,a);e=Object.keys(o.aggregate).sort().map(i);if(h&&o.groupLevels.length){throw new Error("Cannot combine visual grouping with grand total");}if(e.length){s="aggregate("+e.join(",")+")";}o.group=o.group||{};d(o.group);g=o.groupLevels.concat(Object.keys(o.group).sort().filter(n));if(g.length){s="groupby(("+g.join(",")+(s?"),"+s+")":"))");}if(f){delete q.$count;}else if(q.$count){C.push("$count as UI5__count");delete q.$count;}if(q.$$filterBeforeAggregate){s="filter("+q.$$filterBeforeAggregate+")/"+s;delete q.$$filterBeforeAggregate;}if(q.$filter){s+="/filter("+q.$filter+")";delete q.$filter;}if(q.$orderby){s+="/orderby("+q.$orderby+")";delete q.$orderby;}if(h){if(q.$skip){q.$skip-=1;}else{q.$top-=1;}}S=j();if(C.length){s+="/concat(aggregate("+C.join(",")+"),"+(S||"identity")+")";}else if(S){s+="/"+S;}if(s){q.$apply=s;}return q;},hasGrandTotal:function(m){return!!m&&Object.keys(m).some(function(s){return m[s].grandTotal;});},hasMinOrMax:function(m){return!!m&&Object.keys(m).some(function(s){var D=m[s];return D.min||D.max;});},isAffected:function(o,f,s){function e(S,p){if(S.endsWith("/*")){S=S.slice(0,-2);}return _.hasPathPrefix(p,S)||_.hasPathPrefix(S,p);}function h(S,g){return g.some(function(i){return i.aFilters?h(S,i.aFilters):e(S,i.sPath);});}return s.some(function(S){var g=e.bind(null,S);return S===""||S==="*"||Object.keys(o.aggregate).some(function(i){var D=o.aggregate[i];return e(S,D.name||i);})||Object.keys(o.group).some(g)||o.groupLevels.some(g)||h(S,f);});},splitFilter:function(f,o){var e=[],g=[];function i(f){return f.aFilters?f.aFilters.some(i):f.sPath in o.aggregate;}function s(f){if(f.aFilters&&f.bAnd){f.aFilters.forEach(s);}else{(i(f)?e:g).push(f);}}function w(h){return h.length>1?new F(h,true):h[0];}if(!o||!o.aggregate){return[f];}s(f);return[w(e),w(g)];}};return b;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_Batch',["./_Helper","sap/base/strings/escapeRegExp"],function(_,e){"use strict";var a={"POST":true,"PUT":true,"PATCH":true,"DELETE":true},b,r=/^\$\d+/,c=/(\S*?)=(?:"(.+)"|(\S+))/;
function g(C){var B=d(C,"boundary"),m=C.trim().indexOf("multipart/mixed");if(m!==0||!B){throw new Error('Invalid $batch response header "Content-Type": '+C);}B=e(B);return new RegExp('--'+B+'(?:[ \t]*\r\n|--)');}
function d(H,p){var P,i=H.split(";"),m;p=p.toLowerCase();for(P=1;P<i.length;P+=1){m=c.exec(i[P]);if(m[1].toLowerCase()===p){return m[2]||m[3];}}}
function f(m){var C=j(m,"content-type");return C.startsWith("multipart/mixed;")?C:undefined;}
function h(m){var C=j(m,"content-id"),R;if(!C){throw new Error("Content-ID MIME header missing for the change set response.");}R=parseInt(C);if(isNaN(R)){throw new Error("Invalid Content-ID value in change set response.");}return R;}
function j(H,m){var i,n,o=H.split("\r\n");for(i=0;i<o.length;i+=1){n=o[i].split(":");if(n[0].toLowerCase().trim()===m){return n[1].trim();}}}
function k(C,R,I){var B=R.split(g(C)),m=[];B=B.slice(1,-1);B.forEach(function(n){var o,p,q,H,t,u,v,w,x,y,i,M,z,A={},D;z=n.indexOf("\r\n\r\n");M=n.slice(0,z);x=n.indexOf("\r\n\r\n",z+4);w=n.slice(z+4,x);o=f(M);if(o){m.push(k(o,n.slice(z+4),true));return;}v=w.split("\r\n");y=v[0].split(" ");A.status=parseInt(y[1]);A.statusText=y.slice(2).join(' ');A.headers={};for(i=1;i<v.length;i+=1){H=v[i];q=H.indexOf(':');t=H.slice(0,q).trim();u=H.slice(q+1).trim();A.headers[t]=u;if(t.toLowerCase()==="content-type"){p=d(u,"charset");if(p&&p.toLowerCase()!=="utf-8"){throw new Error('Unsupported "Content-Type" charset: '+p);}}}A.responseText=n.slice(x+4,-2);if(I){D=h(M);m[D]=A;}else{m.push(A);}});return m;}
function s(H){var i,m=[];for(i in H){m=m.concat(i,":",H[i],"\r\n");}return m;}
function l(R,C){var B=(C!==undefined?"changeset_":"batch_")+_.uid(),i=C!==undefined,m=[];if(i){m=m.concat("Content-Type: multipart/mixed;boundary=",B,"\r\n\r\n");}R.forEach(function(o,n){var p="",u=o.url;if(i){p="Content-ID:"+n+"."+C+"\r\n";}m=m.concat("--",B,"\r\n");if(Array.isArray(o)){if(i){throw new Error('Change set must not contain a nested change set.');}m=m.concat(l(o,n).body);}else{if(i&&!a[o.method]){throw new Error("Invalid HTTP request method: "+o.method+". Change set must contain only POST, PUT, PATCH or DELETE requests.");}if(C!==undefined&&u[0]==="$"){u=u.replace(r,"$&."+C);}m=m.concat("Content-Type:application/http\r\n","Content-Transfer-Encoding:binary\r\n",p,"\r\n",o.method," ",u," HTTP/1.1\r\n",s(_.resolveIfMatchHeader(o.headers)),"\r\n",JSON.stringify(o.body)||"","\r\n");}});m=m.concat("--",B,"--\r\n");return{body:m,batchBoundary:B};}
b={deserializeBatchResponse:function(C,R){return k(C,R,false);},serializeBatchRequest:function(R){var B=l(R);return{body:B.body.join(""),headers:{"Content-Type":"multipart/mixed; boundary="+B.batchBoundary,"MIME-Version":"1.0"}};}};return b;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_Cache',["./_GroupLock","./_Helper","./_Requestor","sap/base/Log","sap/base/util/isEmptyObject","sap/ui/base/SyncPromise"],function(_,a,b,L,c,S){"use strict";var r=/\(\$uid=[-\w]+\)$/,m="@com.sap.vocabularies.Common.v1.Messages",d=/^-?\d+$/,e=/^([^(]*)(\(.*\))$/;
function f(i,p,k,D){if(k.$count!==undefined){s(i,p,k,k.$count+D);}}
function g(R,p){return p===""||R===p||R.startsWith(p+"/");}
function s(i,p,k,v){if(typeof v==="string"){v=parseInt(v);}a.updateExisting(i,p,k,{$count:v});}
function C(R,i,q,k,G,l){this.iActiveUsages=1;this.mChangeListeners={};this.fnGetOriginalResourcePath=G;this.iInactiveSince=Infinity;this.mPatchRequests={};this.oPendingRequestsPromise=null;this.mPostRequests={};this.oRequestor=R;this.bSentRequest=false;this.bSortExpandSelect=k;this.setResourcePath(i);this.setQueryOptions(q);this.bSharedRequest=l;}
C.prototype._delete=function(G,E,p,o,i){var k=p.split("/"),D=k.pop(),l=k.join("/"),t=this;this.checkSharedRequest();this.addPendingRequest();return this.fetchValue(_.$cached,l).then(function(v){var n=C.from$skip(D,v),q=D?v[n]||v.$byPredicate[n]:v,H,K=a.getPrivateAnnotation(q,"predicate"),u=a.buildPath(l,Array.isArray(v)?K:D),T=a.getPrivateAnnotation(q,"transient");if(T===true){throw new Error("No 'delete' allowed while waiting for server response");}if(T){G.unlock();t.oRequestor.removePost(T,q);return undefined;}if(q["$ui5.deleting"]){throw new Error("Must not delete twice: "+E);}q["$ui5.deleting"]=true;H={"If-Match":o||q};E+=t.oRequestor.buildQueryString(t.sMetaPath,t.mQueryOptions,true);return t.oRequestor.request("DELETE",E,G,H,undefined,undefined,undefined,undefined,a.buildPath(t.getOriginalResourcePath(q),u)).catch(function(w){if(w.status!==404){delete q["$ui5.deleting"];throw w;}}).then(function(){if(Array.isArray(v)){i(t.removeElement(v,Number(D),K,l),v);}else{if(D){a.updateExisting(t.mChangeListeners,l,v,C.makeUpdateData([D],null));}else{q["$ui5.deleted"]=true;}i();}t.oRequestor.getModelInterface().reportBoundMessages(t.sResourcePath,[],[u]);});}).finally(function(){t.removePendingRequest();});};
C.prototype.addPendingRequest=function(){var R;if(!this.oPendingRequestsPromise){this.oPendingRequestsPromise=new S(function(i){R=i;});this.oPendingRequestsPromise.$count=0;this.oPendingRequestsPromise.$resolve=R;}this.oPendingRequestsPromise.$count+=1;};
C.prototype.calculateKeyPredicate=function(i,t,M){var p,T=t[M];if(T&&T.$Key){p=a.getKeyPredicate(i,M,t);if(p){a.setPrivateAnnotation(i,"predicate",p);}}return p;};
C.prototype.checkSharedRequest=function(){if(this.bSharedRequest){throw new Error(this+" is read-only");}};
C.prototype.create=function(G,p,i,t,E,k,l){var n,K=E&&E["@$ui5.keepTransientPath"],o,q=this;function u(){a.removeByPath(q.mPostRequests,i,E);n.splice(n.indexOf(E),1);n.$created-=1;f(q.mChangeListeners,i,n,-1);delete n.$byPredicate[t];if(!i){q.adjustReadRequests(0,-1);}G.cancel();}function v(){q.addPendingRequest();a.setPrivateAnnotation(E,"transient",true);l();}function w(x,y){var z=y.getGroupId();a.setPrivateAnnotation(E,"transient",z);a.addByPath(q.mPostRequests,i,E);return S.all([q.oRequestor.request("POST",x,y,null,o,v,u,undefined,a.buildPath(q.sResourcePath,i,t)),q.fetchTypes()]).then(function(R){var A=R[0],B;a.deletePrivateAnnotation(E,"postBody");a.deletePrivateAnnotation(E,"transient");E["@$ui5.context.isTransient"]=false;a.removeByPath(q.mPostRequests,i,E);q.visitResponse(A,R[1],a.getMetaPath(a.buildPath(q.sMetaPath,i)),i+t,K);if(!K){B=a.getPrivateAnnotation(A,"predicate");if(B){n.$byPredicate[B]=E;a.updateTransientPaths(q.mChangeListeners,t,B);}}a.updateSelected(q.mChangeListeners,a.buildPath(i,B||t),E,A,a.getQueryOptionsForPath(q.mQueryOptions,i).$select);q.removePendingRequest();return E;},function(A){if(A.canceled){throw A;}q.removePendingRequest();k(A);if(q.fetchTypes().isRejected()){throw A;}return w(x,q.oRequestor.lockGroup(q.oRequestor.getGroupSubmitMode(z)==="API"?z:"$parked."+z,q,true,true));});}this.checkSharedRequest();E=a.merge({},E);E=b.cleanPayload(E);o=a.merge({},E);a.setPrivateAnnotation(E,"postBody",o);a.setPrivateAnnotation(E,"transientPredicate",t);E["@$ui5.context.isTransient"]=true;n=this.getValue(i);if(!Array.isArray(n)){throw new Error("Create is only supported for collections; '"+i+"' does not reference a collection");}n.unshift(E);n.$created+=1;f(this.mChangeListeners,i,n,1);n.$byPredicate=n.$byPredicate||{};n.$byPredicate[t]=E;if(!i){q.adjustReadRequests(0,1);}return p.then(function(x){x+=q.oRequestor.buildQueryString(q.sMetaPath,q.mQueryOptions,true);return w(x,G);});};
C.prototype.deregisterChange=function(p,l){if(!this.bSharedRequest){a.removeByPath(this.mChangeListeners,p,l);}};
C.prototype.drillDown=function(D,p,G,k){var o=S.resolve(D),E,l,n,t=false,q=this;function u(i){L.error("Failed to drill-down into "+p+", invalid segment: "+i,q.toString(),"sap.ui.model.odata.v4.lib._Cache");return undefined;}function v(V,i,w){var x=n.slice(0,w).join("/"),R,y;if(Array.isArray(V)){return u(i);}return q.oRequestor.getModelInterface().fetchMetadata(q.sMetaPath+"/"+a.getMetaPath(x)).then(function(z){if(!z){return u(i);}if(z.$Type==="Edm.Stream"){R=V[i+"@odata.mediaReadLink"];y=q.oRequestor.getServiceUrl();return R||a.buildPath(y+q.sResourcePath,x);}if(!t){if(!E&&!Array.isArray(D)){E=D;l=0;}return E&&q.fetchLateProperty(G,E,n.slice(0,l).join("/"),n.slice(l).join("/"),n.slice(l,w).join("/"))||u(i);}if(z.$kind==="NavigationProperty"){return null;}if(!z.$Type.startsWith("Edm.")){return{};}if("$DefaultValue"in z){return z.$Type==="Edm.String"?z.$DefaultValue:a.parseLiteral(z.$DefaultValue,z.$Type,x);}return null;});}if(!p){return o;}n=p.split("/");return n.reduce(function(w,x,i){return w.then(function(V){var I,M,y;if(x==="$count"){return Array.isArray(V)?V.$count:u(x);}if(V===undefined||V===null){return undefined;}if(typeof V!=="object"||x==="@$ui5._"||Array.isArray(V)&&(x[0]==="$"||x==="length")){return u(x);}if(a.hasPrivateAnnotation(V,"predicate")){E=V;l=i;}y=V;t=t||a.getPrivateAnnotation(V,"transient");M=e.exec(x);if(M){if(M[1]){V=V[M[1]];}if(V){V=V.$byPredicate[M[2]];}}else{I=C.from$skip(x,V);if(k&&I===x&&(V[x]===undefined||V[x]===null)){V[x]={};}V=V[I];}return V===undefined&&x[0]!=="#"&&x[0]!=="@"?v(y,x,i+1):V;});},o);};
C.prototype.fetchLateProperty=function(G,R,i,k,M){var F,l,n,p,q,o,t=a.getMetaPath(i),T=this.fetchTypes().getResult(),u=[k],v=this;function w(Q,B){var x=a.buildPath(F,B),E=T[x],y;if(!E){E=v.fetchType(T,x).getResult();}if(B){(E.$Key||[]).forEach(function(K){if(typeof K==="object"){K=K[Object.keys(K)[0]];}u.push(a.buildPath(B,K));});u.push(B+"/@odata.etag");u.push(B+"/@$ui5._/predicate");}if(Q.$expand){y=Object.keys(Q.$expand)[0];w(Q.$expand[y],a.buildPath(B,y));}}if(!this.mLateQueryOptions){return undefined;}F=a.buildPath(this.sMetaPath,t);q=a.intersectQueryOptions(a.getQueryOptionsForPath(this.mLateQueryOptions,i),[k],this.oRequestor.getModelInterface().fetchMetadata,F,{});if(!q){return undefined;}w(q);l=a.buildPath(this.sResourcePath,i);o=l+this.oRequestor.buildQueryString(F,q,false,true);p=this.mPropertyRequestByPath[o];if(!p){n=l+this.oRequestor.buildQueryString(F,this.mQueryOptions,true);p=this.oRequestor.request("GET",n,G.getUnlockedCopy(),undefined,undefined,undefined,undefined,F,undefined,false,q).then(function(D){v.visitResponse(D,T,F,i);return D;}).finally(function(){delete v.mPropertyRequestByPath[o];});this.mPropertyRequestByPath[o]=p;}return p.then(function(D){var x=a.getPrivateAnnotation(D,"predicate");if(x&&a.getPrivateAnnotation(R,"predicate")!==x){throw new Error("GET "+o+": Key predicate changed from "+a.getPrivateAnnotation(R,"predicate")+" to "+x);}if(D["@odata.etag"]!==R["@odata.etag"]){throw new Error("GET "+o+": ETag changed");}a.updateSelected(v.mChangeListeners,i,R,D,u);return a.drillDown(R,M.split("/"));});};
C.prototype.fetchType=function(t,M){var i=this;return this.oRequestor.fetchTypeForPath(M).then(function(T){var o,p=[];if(T){o=i.oRequestor.getModelInterface().fetchMetadata(M+"/"+m).getResult();if(o){T=Object.create(T);T[m]=o;}t[M]=T;(T.$Key||[]).forEach(function(k){if(typeof k==="object"){k=k[Object.keys(k)[0]];p.push(i.fetchType(t,M+"/"+k.slice(0,k.lastIndexOf("/"))));}});return S.all(p).then(function(){return T;});}});};
C.prototype.fetchTypes=function(){var p,t,i=this;function k(B,q){if(q&&q.$expand){Object.keys(q.$expand).forEach(function(n){var M=B;n.split("/").forEach(function(l){M+="/"+l;p.push(i.fetchType(t,M));});k(M,q.$expand[n]);});}}if(!this.oTypePromise){p=[];t={};p.push(this.fetchType(t,this.sMetaPath));k(this.sMetaPath,this.mQueryOptions);this.oTypePromise=S.all(p).then(function(){return t;});}return this.oTypePromise;};
C.prototype.getDownloadUrl=function(p,i){var q=this.mQueryOptions;if(p){q=a.getQueryOptionsForPath(q,p);q=a.merge({},i,q);}return this.oRequestor.getServiceUrl()+a.buildPath(this.sResourcePath,p)+this.oRequestor.buildQueryString(a.buildPath(this.sMetaPath,a.getMetaPath(p)),q);};
C.prototype.getLateQueryOptions=function(){return this.mLateQueryOptions;};
C.prototype.getMeasureRangePromise=function(){return undefined;};
C.prototype.getValue=function(p){throw new Error("Unsupported operation");};
C.prototype.getOriginalResourcePath=function(E){return this.fnGetOriginalResourcePath&&this.fnGetOriginalResourcePath(E)||this.sResourcePath;};
C.prototype.getResourcePath=function(){return this.sResourcePath;};
C.prototype.hasChangeListeners=function(){return!c(this.mChangeListeners);};
C.prototype.hasPendingChangesForPath=function(p){return Object.keys(this.mPatchRequests).some(function(R){return g(R,p);})||Object.keys(this.mPostRequests).some(function(R){return g(R,p);});};
C.prototype.hasSentRequest=function(){return this.bSentRequest;};
C.prototype.patch=function(p,D){var t=this;this.checkSharedRequest();return this.fetchValue(_.$cached,p).then(function(o){a.updateExisting(t.mChangeListeners,p,o,D);return o;});};
C.prototype.refreshSingle=function(G,p,i,D){var t=this;this.checkSharedRequest();return this.fetchValue(_.$cached,p).then(function(E){var k=a.getPrivateAnnotation(E[i],"predicate"),R=a.buildPath(t.sResourcePath,p,k),q=Object.assign({},a.getQueryOptionsForPath(t.mQueryOptions,p));delete q.$apply;delete q.$count;delete q.$filter;delete q.$orderby;delete q.$search;R+=t.oRequestor.buildQueryString(t.sMetaPath,q,false,t.bSortExpandSelect);t.bSentRequest=true;return S.all([t.oRequestor.request("GET",R,G,undefined,undefined,D),t.fetchTypes()]).then(function(l){var o=l[0];t.replaceElement(E,i,k,o,l[1],p);return o;});});};
C.prototype.refreshSingleWithRemove=function(G,p,i,D,o){var t=this;this.checkSharedRequest();return S.all([this.fetchValue(_.$cached,p),this.fetchTypes()]).then(function(R){var E=R[0],k=E[i],l=a.getPrivateAnnotation(k,"predicate"),q=Object.assign({},a.getQueryOptionsForPath(t.mQueryOptions,p)),F=q.$filter,n=a.buildPath(t.sResourcePath,p),T=R[1];delete q.$count;delete q.$orderby;q.$filter=(F?"("+F+") and ":"")+a.getKeyFilter(k,t.sMetaPath,T);n+=t.oRequestor.buildQueryString(t.sMetaPath,q,false,t.bSortExpandSelect);t.bSentRequest=true;return t.oRequestor.request("GET",n,G,undefined,undefined,D).then(function(u){if(u.value.length>1){throw new Error("Unexpected server response, more than one entity returned.");}else if(u.value.length===0){t.removeElement(E,i,l,p);t.oRequestor.getModelInterface().reportBoundMessages(t.sResourcePath,[],[p+l]);o();}else{t.replaceElement(E,i,l,u.value[0],T,p);}});});};
C.prototype.registerChange=function(p,l){if(!this.bSharedRequest){a.addByPath(this.mChangeListeners,p,l);}};
C.prototype.removeElement=function(E,i,p,k){var I=isNaN(i),o,t;o=E.$byPredicate[p];if(!I){i=C.getElementIndex(E,p,i);E.splice(i,1);}delete E.$byPredicate[p];t=a.getPrivateAnnotation(o,"transientPredicate");if(t){E.$created-=1;delete E.$byPredicate[t];}else if(!k){this.iLimit-=1;if(!I){this.adjustReadRequests(i,-1);}}f(this.mChangeListeners,k,E,-1);return i;};
C.prototype.removePendingRequest=function(){if(this.oPendingRequestsPromise){this.oPendingRequestsPromise.$count-=1;if(!this.oPendingRequestsPromise.$count){this.oPendingRequestsPromise.$resolve();this.oPendingRequestsPromise=null;}}};
C.prototype.replaceElement=function(E,i,p,o,t,k){var O,T;i=C.getElementIndex(E,p,i);O=E[i];E[i]=E.$byPredicate[p]=o;T=a.getPrivateAnnotation(O,"transientPredicate");if(T){o["@$ui5.context.isTransient"]=false;E.$byPredicate[T]=o;a.setPrivateAnnotation(o,"transientPredicate",T);}this.visitResponse(o,t,a.getMetaPath(a.buildPath(this.sMetaPath,k)),k+p);};
C.prototype.resetChangesForPath=function(p){var t=this;Object.keys(this.mPatchRequests).forEach(function(R){var i,k;if(g(R,p)){k=t.mPatchRequests[R];for(i=k.length-1;i>=0;i-=1){t.oRequestor.removePatch(k[i]);}delete t.mPatchRequests[R];}});Object.keys(this.mPostRequests).forEach(function(R){var E,i,T;if(g(R,p)){E=t.mPostRequests[R];for(i=E.length-1;i>=0;i-=1){T=a.getPrivateAnnotation(E[i],"transient");t.oRequestor.removePost(T,E[i]);}delete t.mPostRequests[R];}});};
C.prototype.setActive=function(A){if(A){this.iActiveUsages+=1;this.iInactiveSince=Infinity;}else{this.iActiveUsages-=1;if(!this.iActiveUsages){this.iInactiveSince=Date.now();}this.mChangeListeners={};}};
C.prototype.setLateQueryOptions=function(q){if(q){this.mLateQueryOptions={$select:q.$select,$expand:q.$expand};}else{this.mLateQueryOptions=null;}};
C.prototype.setProperty=function(p,v,E){var t=this;this.checkSharedRequest();return this.fetchValue(_.$cached,E,null,null,true).then(function(o){a.updateSelected(t.mChangeListeners,E,o,C.makeUpdateData(p.split("/"),v));});};
C.prototype.setQueryOptions=function(q){this.checkSharedRequest();if(this.bSentRequest){throw new Error("Cannot set query options: Cache has already sent a request");}this.mQueryOptions=q;this.sQueryString=this.oRequestor.buildQueryString(this.sMetaPath,q,false,this.bSortExpandSelect);};
C.prototype.setResourcePath=function(R){this.checkSharedRequest();this.sResourcePath=R;this.sMetaPath=a.getMetaPath("/"+R);this.oTypePromise=undefined;this.mLateQueryOptions=null;this.mPropertyRequestByPath={};};
C.prototype.toString=function(){return this.oRequestor.getServiceUrl()+this.sResourcePath+this.sQueryString;};
C.prototype.update=function(G,p,v,E,i,k,u,l,n){var o,q=p.split("/"),U,t=this;this.checkSharedRequest();try{o=this.fetchValue(_.$cached,k);}catch(w){if(!w.$cached){throw w;}o=S.resolve({"@odata.etag":"*"});}return o.then(function(x){var F=a.buildPath(k,p),y=G.getGroupId(),O,z,A,B,T,D,H=C.makeUpdateData(q,v);function I(){a.removeByPath(t.mPatchRequests,F,z);a.updateExisting(t.mChangeListeners,k,x,C.makeUpdateData(q,O));}function J(K,M){var R;function N(){R=t.oRequestor.lockGroup(y,t,true);if(n){n();}}z=t.oRequestor.request("PATCH",i,K,{"If-Match":x},H,N,I,undefined,a.buildPath(t.getOriginalResourcePath(x),k),M);a.addByPath(t.mPatchRequests,F,z);return S.all([z,t.fetchTypes()]).then(function(Q){var V=Q[0];a.removeByPath(t.mPatchRequests,F,z);if(!l){t.visitResponse(V,Q[1],a.getMetaPath(a.buildPath(t.sMetaPath,k)),k);}a.updateExisting(t.mChangeListeners,k,x,l?{"@odata.etag":V["@odata.etag"]}:V);},function(w){var Q=y;a.removeByPath(t.mPatchRequests,F,z);if(!E||w.canceled){throw w;}E(w);switch(t.oRequestor.getGroupSubmitMode(y)){case"API":break;case"Auto":if(!t.oRequestor.hasChanges(y,x)){Q="$parked."+y;}break;default:throw w;}R.unlock();R=undefined;return J(t.oRequestor.lockGroup(Q,t,true,true),true);}).finally(function(){if(R){R.unlock();}});}if(!x){throw new Error("Cannot update '"+p+"': '"+k+"' does not exist");}T=a.getPrivateAnnotation(x,"transient");if(T){if(T===true){throw new Error("No 'update' allowed while waiting for server response");}if(T.startsWith("$parked.")){B=T;T=T.slice(8);}if(T!==y){throw new Error("The entity will be created via group '"+T+"'. Cannot patch via group '"+y+"'");}}O=a.drillDown(x,q);a.updateAll(t.mChangeListeners,k,x,H);A=a.getPrivateAnnotation(x,"postBody");if(A){a.updateAll({},k,A,H);}if(u){U=u.split("/");u=a.buildPath(k,u);D=t.getValue(u);if(D===undefined){L.debug("Missing value for unit of measure "+u+" when updating "+F,t.toString(),"sap.ui.model.odata.v4.lib._Cache");}else{a.merge(T?A:H,C.makeUpdateData(U,D));}}if(T){if(B){a.setPrivateAnnotation(x,"transient",T);t.oRequestor.relocate(B,A,T);}G.unlock();return Promise.resolve();}t.oRequestor.relocateAll("$parked."+y,y,x);i+=t.oRequestor.buildQueryString(t.sMetaPath,t.mQueryOptions,true);return J(G);});};
C.prototype.visitResponse=function(R,t,k,l,K,n){var o,H=false,p={},q=this.oRequestor.getServiceUrl()+this.sResourcePath,u=this;function v(M,i,z){H=true;if(M&&M.length){p[i]=M;M.forEach(function(A){if(A.longtextUrl){A.longtextUrl=a.makeAbsolute(A.longtextUrl,z);}});}}function w(B,i){return i?a.makeAbsolute(i,B):B;}function x(I,M,z,A){var B={},i,D,E,F;for(i=0;i<I.length;i+=1){E=I[i];D=z===""?n+i:i;if(E&&typeof E==="object"){y(E,M,z,A,D);F=a.getPrivateAnnotation(E,"predicate");if(!z){o.push(F||D.toString());}if(F){B[F]=E;I.$byPredicate=B;}}}}function y(i,M,I,z,A){var B,D,T=t[M],E=T&&T[m]&&T[m].$Path,F;z=w(z,i["@odata.context"]);D=u.calculateKeyPredicate(i,t,M);if(A!==undefined){I=a.buildPath(I,D||A);}else if(!K&&D){B=r.exec(I);if(B){I=I.slice(0,-B[0].length)+D;}}if(l&&!o){o=[I];}if(E){F=a.drillDown(i,E.split("/"));if(F!==undefined){v(F,I,z);}}Object.keys(i).forEach(function(G){var J,N=M+"/"+G,O=i[G],Q=a.buildPath(I,G);if(G.endsWith("@odata.mediaReadLink")){i[G]=a.makeAbsolute(O,z);}if(G.includes("@")){return;}if(Array.isArray(O)){O.$created=0;O.$count=undefined;J=i[G+"@odata.count"];if(J){s({},"",O,J);}else if(!i[G+"@odata.nextLink"]){s({},"",O,O.length);}x(O,N,Q,w(z,i[G+"@odata.context"]));}else if(O&&typeof O==="object"){y(O,N,Q,z);}});}if(n!==undefined){o=[];x(R.value,k||this.sMetaPath,"",w(q,R["@odata.context"]));}else if(R&&typeof R==="object"){y(R,k||this.sMetaPath,l||"",q);}if(H){this.oRequestor.getModelInterface().reportBoundMessages(this.getOriginalResourcePath(R),p,o);}};
function h(R,i,q,k,D,l){C.call(this,R,i,q,k,function(){return D;},l);this.sContext=undefined;this.aElements=[];this.aElements.$byPredicate={};this.aElements.$count=undefined;this.aElements.$created=0;this.aElements.$tail=undefined;this.iLimit=Infinity;this.aReadRequests=[];this.bServerDrivenPaging=false;this.oSyncPromiseAll=undefined;}
h.prototype=Object.create(C.prototype);
h.prototype.addKeptElement=function(E){this.aElements.$byPredicate[a.getPrivateAnnotation(E,"predicate")]=E;};
h.prototype.adjustReadRequests=function(i,o){this.aReadRequests.forEach(function(R){if(R.iStart>=i){R.iStart+=o;R.iEnd+=o;}});};
h.prototype.fetchValue=function(G,p,D,l,i){var E,F=p.split("/")[0],o,t=this;G.unlock();if(this.aElements.$byPredicate[F]){o=S.resolve();}else if((G===_.$cached||F!=="$count")&&this.aElements[F]!==undefined){o=S.resolve(this.aElements[F]);}else{if(!this.oSyncPromiseAll){E=this.aElements.$tail?this.aElements.concat(this.aElements.$tail):this.aElements;this.oSyncPromiseAll=S.all(E);}o=this.oSyncPromiseAll;}return o.then(function(){t.registerChange(p,l);return t.drillDown(t.aElements,p,G,i);});};
h.prototype.fill=function(p,k,E){var i,n=Math.max(this.aElements.length,1024);if(E>n){if(this.aElements.$tail&&p){throw new Error("Cannot fill from "+k+" to "+E+", $tail already in use, # of elements is "+this.aElements.length);}this.aElements.$tail=p;E=this.aElements.length;}for(i=k;i<E;i+=1){this.aElements[i]=p;}this.oSyncPromiseAll=undefined;};
h.prototype.getQueryString=function(){var q=Object.assign({},this.mQueryOptions),E,k,F=q.$filter,i,K,l=[],Q=this.sQueryString,t;for(i=0;i<this.aElements.$created;i+=1){E=this.aElements[i];if(!E["@$ui5.context.isTransient"]){t=t||this.fetchTypes().getResult();K=a.getKeyFilter(E,this.sMetaPath,t);if(K){l.push(K);}}}if(l.length){k="not ("+l.join(" or ")+")";if(F){q.$filter="("+F+") and "+k;Q=this.oRequestor.buildQueryString(this.sMetaPath,q,false,this.bSortExpandSelect);}else{Q+=(Q?"&":"?")+"$filter="+a.encode(k,false);}}return Q;};
h.prototype.getReadRange=function(k,l,p){var E=this.aElements;function n(k,o){var i;for(i=k;i<o;i+=1){if(E[i]===undefined){return true;}}return false;}if(n(k+l,k+l+p/2)){l+=p;}if(n(Math.max(k-p/2,0),k)){l+=p;k-=p;if(k<0){l+=k;if(isNaN(l)){l=Infinity;}k=0;}}return{length:l,start:k};};
h.prototype.getResourcePathWithQuery=function(i,E){var k=this.aElements.$created,q=this.getQueryString(),D=q?"&":"?",l=E-i,R=this.sResourcePath+q;if(i<k){throw new Error("Must not request created element");}i-=k;if(i>0||l<Infinity){R+=D+"$skip="+i;}if(l<Infinity){R+="&$top="+l;}return R;};
h.prototype.getValue=function(p){var o=this.drillDown(this.aElements,p,_.$cached);if(o.isFulfilled()){return o.getResult();}};
h.prototype.handleResponse=function(k,E,R,t){var l=-1,n,o=this.aElements.$created,p,i,K,O=this.aElements.$count,q,u=R.value.length;this.sContext=R["@odata.context"];this.visitResponse(R,t,undefined,undefined,undefined,k);for(i=0;i<u;i+=1){p=R.value[i];q=a.getPrivateAnnotation(p,"predicate");if(q){K=this.aElements.$byPredicate[q];if(K){if(p["@odata.etag"]===K["@odata.etag"]){p=K;}else if(this.hasPendingChangesForPath(q)){throw new Error("Modified on client and on server: "+this.sResourcePath+q);}}this.aElements.$byPredicate[q]=p;}this.aElements[k+i]=p;}n=R["@odata.count"];if(n){this.iLimit=l=parseInt(n);}if(R["@odata.nextLink"]){this.bServerDrivenPaging=true;if(E<this.aElements.length){for(i=k+u;i<E;i+=1){delete this.aElements[i];}}else{this.aElements.length=k+u;}}else if(u<E-k){if(l===-1){l=O&&O-o;}l=Math.min(l!==undefined?l:Infinity,k-o+u);this.aElements.length=o+l;this.iLimit=l;if(!n&&l>0&&!this.aElements[l-1]){l=undefined;}}if(l!==-1){s(this.mChangeListeners,"",this.aElements,l!==undefined?l+o:undefined);}};
h.prototype.read=function(I,l,p,G,D){var i,n,E,k,o=-1,q=this.oPendingRequestsPromise||this.aElements.$tail,R,t=this;if(I<0){throw new Error("Illegal index "+I+", must be >= 0");}if(l<0){throw new Error("Illegal length "+l+", must be >= 0");}if(q){return q.then(function(){return t.read(I,l,p,G,D);});}R=this.getReadRange(I,l,this.bServerDrivenPaging?0:p);k=Math.min(R.start+R.length,this.aElements.$created+this.iLimit);n=Math.min(k,Math.max(R.start,this.aElements.length)+1);for(i=R.start;i<n;i+=1){if(this.aElements[i]!==undefined){if(o>=0){this.requestElements(o,i,G.getUnlockedCopy(),D);D=undefined;o=-1;}}else if(o<0){o=i;}}if(o>=0){this.requestElements(o,k,G.getUnlockedCopy(),D);}G.unlock();E=this.aElements.slice(I,k);if(this.aElements.$tail){E.push(this.aElements.$tail);}return S.all(E).then(function(){var u=t.aElements.slice(I,k);u.$count=t.aElements.$count;return{"@odata.context":t.sContext,value:u};});};
h.prototype.requestElements=function(i,E,G,D){var p,R={iEnd:E,iStart:i},t=this;this.aReadRequests.push(R);this.bSentRequest=true;p=S.all([this.oRequestor.request("GET",this.getResourcePathWithQuery(i,E),G,undefined,undefined,D),this.fetchTypes()]).then(function(k){if(t.aElements.$tail===p){t.aElements.$tail=undefined;}t.handleResponse(R.iStart,R.iEnd,k[0],k[1]);}).catch(function(o){t.fill(undefined,R.iStart,R.iEnd);throw o;}).finally(function(){t.aReadRequests.splice(t.aReadRequests.indexOf(R),1);});this.fill(p,i,E);};
h.prototype.requestSideEffects=function(G,p,N,k,l){var E,F=[],M,q,R,t=this.fetchTypes().getResult(),o=this,i;function u(n){var v=a.getKeyFilter(n,o.sMetaPath,t);F.push(v);return v;}this.checkSharedRequest();if(this.oPendingRequestsPromise){return this.oPendingRequestsPromise.then(function(){return o.requestSideEffects(G,p,N,k,l);});}q=a.intersectQueryOptions(this.mLateQueryOptions||this.mQueryOptions,p,this.oRequestor.getModelInterface().fetchMetadata,this.sMetaPath,N,"",true);if(!q){return S.resolve();}if(l===undefined){if(!u(this.aElements[k])){return null;}}else{for(i=0;i<this.aElements.length;i+=1){E=this.aElements[i];if(!E||a.hasPrivateAnnotation(E,"transient")){continue;}if((i<k||i>=k+l)&&!a.hasPrivateAnnotation(E,"transientPredicate")){delete this.aElements.$byPredicate[a.getPrivateAnnotation(E,"predicate")];delete this.aElements[i];continue;}if(!u(E)){return null;}}this.aElements.length=l?Math.min(k+l,this.aElements.length):this.aElements.$created;if(!F.length){return S.resolve();}}q.$filter=F.join(" or ");a.selectKeyProperties(q,t[this.sMetaPath]);delete q.$count;delete q.$orderby;delete q.$search;M=a.extractMergeableQueryOptions(q);R=this.sResourcePath+this.oRequestor.buildQueryString(this.sMetaPath,q,false,true);return this.oRequestor.request("GET",R,G,undefined,undefined,undefined,undefined,this.sMetaPath,undefined,false,M).then(function(v){var E,w,i,n;function x(y){y=y.slice(w.length+1);return!p.some(function(z){return a.getRelativePath(y,z)!==undefined;});}if(v.value.length!==F.length){throw new Error("Expected "+F.length+" row(s), but instead saw "+v.value.length);}o.visitResponse(v,t,undefined,"",false,NaN);for(i=0,n=v.value.length;i<n;i+=1){E=v.value[i];w=a.getPrivateAnnotation(E,"predicate");a.updateAll(o.mChangeListeners,w,o.aElements.$byPredicate[w],E,x);}});};
function P(R,i,q){C.call(this,R,i,q);this.oPromise=null;}
P.prototype=Object.create(C.prototype);
P.prototype._delete=function(){throw new Error("Unsupported");};
P.prototype.create=function(){throw new Error("Unsupported");};
P.prototype.fetchValue=function(G,p,D,l,i){var t=this;if(i){throw new Error("Unsupported argument: bCreateOnDemand");}if(this.oPromise){G.unlock();}else{this.bSentRequest=true;this.oPromise=S.resolve(this.oRequestor.request("GET",this.sResourcePath+this.sQueryString,G,undefined,undefined,D,undefined,this.sMetaPath));}return this.oPromise.then(function(R){R=R||{value:null};t.registerChange("",l);return R.value;});};
P.prototype.update=function(){throw new Error("Unsupported");};
function j(R,i,q,k,l,G,p,M){C.call(this,R,i,q,k,G,l);this.sMetaPath=M||this.sMetaPath;this.bPost=p;this.bPosting=false;this.oPromise=null;}
j.prototype=Object.create(C.prototype);
j.prototype.fetchValue=function(G,p,D,l,i){var R=this.sResourcePath+this.sQueryString,t=this;if(this.oPromise){G.unlock();}else{if(this.bPost){throw new Error("Cannot fetch a value before the POST request");}this.bSentRequest=true;this.oPromise=S.all([this.oRequestor.request("GET",R,G,undefined,undefined,D,undefined,this.sMetaPath),this.fetchTypes()]).then(function(k){t.visitResponse(k[0],k[1]);return k[0];});}return this.oPromise.then(function(o){if(o&&o["$ui5.deleted"]){throw new Error("Cannot read a deleted entity");}t.registerChange(p,l);return t.drillDown(o,p,G,i);});};
j.prototype.getValue=function(p){var o;if(this.oPromise&&this.oPromise.isFulfilled()){o=this.drillDown(this.oPromise.getResult(),p,_.$cached);if(o.isFulfilled()){return o.getResult();}}};
j.prototype.post=function(G,D,E){var i,H="POST",t=this;this.checkSharedRequest();if(!this.bPost){throw new Error("POST request not allowed");}if(this.bPosting){throw new Error("Parallel POST requests not allowed");}if(E){i=G.getGroupId();this.oRequestor.relocateAll("$parked."+i,i,E);}if(D){H=D["X-HTTP-Method"]||H;delete D["X-HTTP-Method"];if(this.oRequestor.isActionBodyOptional()&&!Object.keys(D).length){D=undefined;}}this.bPosting=true;this.bSentRequest=true;this.oPromise=S.all([this.oRequestor.request(H,this.sResourcePath+this.sQueryString,G,E&&{"If-Match":E},D),this.fetchTypes()]).then(function(R){t.visitResponse(R[0],R[1]);t.bPosting=false;return R[0];},function(o){t.bPosting=false;throw o;});return this.oPromise;};
j.prototype.requestSideEffects=function(G,p,n,R){var M,o=this.oPromise,q,i,t=this;this.checkSharedRequest();q=o&&a.intersectQueryOptions(this.mLateQueryOptions||this.mQueryOptions,p,this.oRequestor.getModelInterface().fetchMetadata,this.sMetaPath,n);if(!q){return S.resolve();}M=a.extractMergeableQueryOptions(q);R=(R||this.sResourcePath)+this.oRequestor.buildQueryString(this.sMetaPath,q,false,true);i=S.all([this.oRequestor.request("GET",R,G,undefined,undefined,undefined,undefined,this.sMetaPath,undefined,false,M),this.fetchTypes(),this.fetchValue(_.$cached,"")]).then(function(k){return k;}).then(function(k){var N=k[0],O=k[2];t.visitResponse(N,k[1]);a.updateAll(t.mChangeListeners,"",O,N,function(l){return!p.some(function(u){return a.getRelativePath(l,u)!==undefined;});});});return i;};
C.create=function(R,i,q,k,D,l){var n,K,p,o,t;if(l){p=i+R.buildQueryString(a.getMetaPath("/"+i),q,false,k);t=R.$mSharedCollectionCacheByPath;if(!t){t=R.$mSharedCollectionCacheByPath={};}o=t[p];if(o){o.setActive(true);}else{K=Object.keys(t);n=K.length;if(n>100){K.filter(function(u){return!t[u].iActiveUsages;}).sort(function(u,v){return t[u].iInactiveSince-t[v].iInactiveSince;}).every(function(u){delete t[u];n-=1;return n>100;});}o=t[p]=new h(R,i,q,k,D,l);}return o;}return new h(R,i,q,k,D);};
C.createProperty=function(R,i,q){return new P(R,i,q);};
C.createSingle=function(R,i,q,k,l,G,p,M){return new j(R,i,q,k,l,G,p,M);};
C.from$skip=function(i,k){return d.test(i)?k.$created+Number(i):i;};
C.getElementIndex=function(E,k,i){var o=E[i];if(!o||a.getPrivateAnnotation(o,"predicate")!==k){i=E.indexOf(E.$byPredicate[k]);}return i;};
C.makeUpdateData=function(p,v){return p.reduceRight(function(V,i){var R={};R[i]=V;return R;},v);};
return C;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_GroupLock',["sap/ui/base/SyncPromise"],function(S){"use strict";
function _(g,o,l,m,s,c){if(!o){throw new Error("Missing owner");}if(m&&!l){throw new Error("A modifying group lock has to be locked");}this.fnCancel=c;this.bCanceled=false;this.sGroupId=g;this.bLocked=!!l;this.bModifying=!!m;this.oOwner=o;this.oPromise=null;this.iSerialNumber=s===undefined?Infinity:s;}
_.prototype.cancel=function(){if(!this.bCanceled){this.bCanceled=true;if(this.fnCancel){this.fnCancel();}this.unlock(true);}};
_.prototype.getGroupId=function(){return this.sGroupId;};
_.prototype.getSerialNumber=function(){return this.iSerialNumber;};
_.prototype.getUnlockedCopy=function(){return new _(this.sGroupId,this.oOwner,false,false,this.iSerialNumber);};
_.prototype.isCanceled=function(){return this.bCanceled;};
_.prototype.isLocked=function(){return this.bLocked;};
_.prototype.isModifying=function(){return this.bModifying;};
_.prototype.toString=function(){return"sap.ui.model.odata.v4.lib._GroupLock(group="+this.sGroupId+", owner="+this.oOwner+(this.isLocked()?", locked":"")+(this.isModifying()?", modifying":"")+(this.iSerialNumber!==Infinity?", serialNumber="+this.iSerialNumber:"")+")";};
_.prototype.unlock=function(f){if(this.bLocked===undefined&&!f){throw new Error("GroupLock unlocked twice");}this.bLocked=undefined;if(this.oPromise){this.oPromise.$resolve();}};
_.prototype.waitFor=function(g){var r;if(this.bLocked&&this.sGroupId===g){if(!this.oPromise){this.oPromise=new S(function(a){r=a;});this.oPromise.$resolve=r;}return this.oPromise;}};
_.$cached=new _("$cached","sap.ui.model.odata.v4.lib._GroupLock");
_.$cached.unlock=function(){};
return _;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_Helper',["sap/base/Log","sap/base/util/deepEqual","sap/base/util/isEmptyObject","sap/base/util/merge","sap/base/util/uid","sap/ui/base/SyncPromise","sap/ui/thirdparty/URI"],function(L,d,a,m,u,S,U){"use strict";var r=/&/g,c="sap.ui.model.odata.v4.lib._Helper",b=/\=/g,f=/%29/g,g=/%28/g,h=/%27/g,j=/#/g,_,k=/\([^/]*|\/-?\d+/g,l=/\+/g,n=/'/g;_={addByPath:function(M,p,i){if(i){if(!M[p]){M[p]=[i];}else if(M[p].indexOf(i)<0){M[p].push(i);}}},addChildrenWithAncestor:function(C,A,e){if(A.length){C.forEach(function(p){var s;if(A.indexOf(p)>=0){e[p]=true;return;}s=p.split("/");s.pop();while(s.length){if(A.indexOf(s.join("/"))>=0){e[p]=true;break;}s.pop();}});}},addToSelect:function(q,s){q.$select=q.$select||[];s.forEach(function(p){if(q.$select.indexOf(p)<0){q.$select.push(p);}});},aggregateQueryOptions:function(A,q){if(q.$select){_.addToSelect(A,q.$select);}if(q.$expand){A.$expand=A.$expand||{};Object.keys(q.$expand).forEach(function(p){if(A.$expand[p]){_.aggregateQueryOptions(A.$expand[p],q.$expand[p]);}else{A.$expand[p]=q.$expand[p];}});}},buildPath:function(){var i,p="",s;for(i=0;i<arguments.length;i+=1){s=arguments[i];if(s||s===0){if(p&&p!=="/"&&s[0]!=="("){p+="/";}p+=s;}}return p;},buildQuery:function(p){var K,q;if(!p){return"";}K=Object.keys(p);if(K.length===0){return"";}q=[];K.forEach(function(s){var v=p[s];if(Array.isArray(v)){v.forEach(function(i){q.push(_.encodePair(s,i));});}else{q.push(_.encodePair(s,v));}});return"?"+q.join("&");},clone:function clone(v,R){return v===undefined||v===Infinity||v===-Infinity||v!==v?v:JSON.parse(JSON.stringify(v,R));},createError:function(i,M,R,s){var B=i.responseText,C=i.getResponseHeader("Content-Type"),o=new Error(M+": "+i.status+" "+i.statusText);o.status=i.status;o.statusText=i.statusText;o.requestUrl=R;o.resourcePath=s;if(i.status===0){o.message="Network error";return o;}if(C){C=C.split(";")[0];}if(i.status===412){o.isConcurrentModification=true;}if(C==="application/json"){try{o.error=JSON.parse(B).error;o.message=o.error.message;if(typeof o.message==="object"){o.message=o.error.message.value;}}catch(e){L.warning(e.toString(),B,c);}}else if(C==="text/plain"){o.message=B;}return o;},createGetMethod:function(F,t){return function(){var s=this[F].apply(this,arguments);if(s.isFulfilled()){return s.getResult();}else if(t){if(s.isRejected()){s.caught();throw s.getResult();}else{throw new Error("Result pending");}}};},createRequestMethod:function(F){return function(){return Promise.resolve(this[F].apply(this,arguments));};},createTechnicalDetails:function(M){var C,o=M["@$ui5.originalMessage"]||M,t={};if(!(o instanceof Error)){Object.defineProperty(t,"originalMessage",{enumerable:true,get:function(){if(!C){C=_.publicClone(o);}return C;}});}return t;},deepEqual:d,deletePrivateAnnotation:function(o,A){var p=o["@$ui5._"];if(p){delete p[A];}},drillDown:function(D,p){return p.reduce(function(D,s){return(D&&s in D)?D[s]:undefined;},D);},encode:function(p,e){var E=encodeURI(p).replace(r,"%26").replace(j,"%23").replace(l,"%2B");if(e){E=E.replace(b,"%3D");}return E;},encodePair:function(K,v){return _.encode(K,true)+"="+_.encode(v,false);},extractMergeableQueryOptions:function(q){var e={};if("$expand"in q){e.$expand=q.$expand;q.$expand="~";}if("$select"in q){e.$select=q.$select;q.$select="~";}return e;},fetchPropertyAndType:function(F,M){return F(M).then(function(p){if(p&&p.$kind==="NavigationProperty"){return F(M+"/").then(function(){return p;});}return p;});},fireChange:function(C,p,v){var e=C[p],i;if(e){for(i=0;i<e.length;i+=1){e[i].onChange(v);}}},fireChanges:function(C,p,v,R){Object.keys(v).forEach(function(P){var s=_.buildPath(p,P),V=v[P];if(V&&typeof V==="object"){_.fireChanges(C,s,V,R);}else{_.fireChange(C,s,R?undefined:V);}});_.fireChange(C,p,R?undefined:v);},formatLiteral:function(v,t){if(v===undefined){throw new Error("Illegal value: undefined");}if(v===null){return"null";}switch(t){case"Edm.Binary":return"binary'"+v+"'";case"Edm.Boolean":case"Edm.Byte":case"Edm.Double":case"Edm.Int16":case"Edm.Int32":case"Edm.SByte":case"Edm.Single":return String(v);case"Edm.Date":case"Edm.DateTimeOffset":case"Edm.Decimal":case"Edm.Guid":case"Edm.Int64":case"Edm.TimeOfDay":return v;case"Edm.Duration":return"duration'"+v+"'";case"Edm.String":return"'"+v.replace(n,"''")+"'";default:throw new Error("Unsupported type: "+t);}},getKeyFilter:function(i,M,t,K){var F=[],s,e=_.getKeyProperties(i,M,t,K);if(!e){return undefined;}for(s in e){F.push(s+" eq "+e[s]);}return F.join(" and ");},getKeyPredicate:function(i,M,t,K,e){var o=_.getKeyProperties(i,M,t,K,true);if(!o){return undefined;}K=Object.keys(o).map(function(A,I,p){var v=encodeURIComponent(o[A]);return e||p.length>1?encodeURIComponent(A)+"="+v:v;});return"("+K.join(",")+")";},getKeyProperties:function(i,M,t,K,R){var F,e={};K=K||t[M].$Key;F=K.some(function(v){var s,o,p,P,T,V;if(typeof v==="string"){s=o=v;}else{s=Object.keys(v)[0];o=v[s];if(!R){s=o;}}p=o.split("/");V=_.drillDown(i,p);if(V===undefined){return true;}P=p.pop();T=t[_.buildPath(M,p.join("/"))];V=_.formatLiteral(V,T[P].$Type);e[s]=V;});return F?undefined:e;},getMetaPath:function(p){if(p[0]==="/"){return p.replace(k,"");}if(p[0]!=="("){p="/"+p;}return p.replace(k,"").slice(1);},getPrivateAnnotation:function(o,A){var p=o["@$ui5._"];return p&&p[A];},getQueryOptionsForPath:function(q,p){p=_.getMetaPath(p);if(p){p.split("/").some(function(s){q=q&&q.$expand&&q.$expand[s];if(!q||q===true){q={};return true;}});}return q||{};},getRelativePath:function(p,B){if(!p.startsWith(B)){return undefined;}p=p.slice(B.length);if(p){if(p[0]==="/"){return p.slice(1);}if(p[0]!=="("){return undefined;}}return p;},hasPrivateAnnotation:function(o,A){var p=o["@$ui5._"];return p?A in p:false;},informAll:function(C,p,o,N){if(N===o){return;}if(N&&typeof N==="object"){Object.keys(N).forEach(function(P){_.informAll(C,_.buildPath(p,P),o&&o[P],N[P]);});}else{_.fireChange(C,p,N===undefined?null:N);N={};}if(o&&typeof o==="object"){Object.keys(o).forEach(function(P){if(!N.hasOwnProperty(P)){_.informAll(C,_.buildPath(p,P),o[P],undefined);}});}},intersectQueryOptions:function(C,p,F,R,N,P,A){var e=[],E={},o,q,s,t={};function v(w,M){var x=M.split("/");return x.every(function(y,i){return i===0&&w||F(R+"/"+x.slice(0,i+1).join("/")).getResult().$kind==="Property";});}if(p.indexOf("")>=0){throw new Error("Unsupported empty navigation property path");}if(p.indexOf("*")>=0){s=C&&C.$select||[];}else if(C&&C.$select&&C.$select.indexOf("*")<0){_.addChildrenWithAncestor(p,C.$select,t);_.addChildrenWithAncestor(C.$select,p,t);s=Object.keys(t).filter(v.bind(null,true));}else{s=p.filter(v.bind(null,false));}if(C&&C.$expand){e=Object.keys(C.$expand);e.forEach(function(i){var w,M=R+"/"+i,x=_.buildPath(P,i),y={},z;_.addChildrenWithAncestor([i],p,y);if(!a(y)){if(F(M).getResult().$isCollection){N[x]=true;}E[i]=C.$expand[i];return;}z=_.stripPathPrefix(i,p);if(z.length){if(F(M).getResult().$isCollection){throw new Error("Unsupported collection-valued navigation property "+M);}w=_.intersectQueryOptions(C.$expand[i]||{},z,F,M,N,x);if(w){E[i]=w;}}});}if(!s.length&&a(E)){return null;}o=Object.assign({},C,{$select:s});q=F(R).getResult();if(q.$kind==="NavigationProperty"&&!q.$isCollection){_.selectKeyProperties(o,F(R+"/").getResult());}else if(!s.length&&!A){o.$select=Object.keys(E).slice(0,1);}if(a(E)){delete o.$expand;}else{o.$expand=E;}return o;},hasPathPrefix:function(p,B){return _.getRelativePath(p,B)!==undefined;},isSafeInteger:function(N){if(typeof N!=="number"||!isFinite(N)){return false;}N=Math.abs(N);return N<=9007199254740991&&Math.floor(N)===N;},makeAbsolute:function(s,B){return new U(s).absoluteTo(B).toString().replace(h,"'").replace(g,"(").replace(f,")");},merge:m,mergeQueryOptions:function(q,o,F){var R;function s(p,v){if(v&&(!q||q[p]!==v)){if(!R){R=q?_.clone(q):{};}R[p]=v;}}s("$orderby",o);if(F){s("$filter",F[0]);s("$$filterBeforeAggregate",F[1]);}return R||q;},namespace:function(N){var i;N=N.split("/")[0].split("(")[0];i=N.lastIndexOf(".");return i<0?"":N.slice(0,i);},parseLiteral:function(s,t,p){function e(i){if(!isFinite(i)){throw new Error(p+": Not a valid "+t+" literal: "+s);}return i;}if(s==="null"){return null;}switch(t){case"Edm.Boolean":return s==="true";case"Edm.Byte":case"Edm.Int16":case"Edm.Int32":case"Edm.SByte":return e(parseInt(s));case"Edm.Date":case"Edm.DateTimeOffset":case"Edm.Decimal":case"Edm.Guid":case"Edm.Int64":case"Edm.TimeOfDay":return s;case"Edm.Double":case"Edm.Single":return s==="INF"||s==="-INF"||s==="NaN"?s:e(parseFloat(s));default:throw new Error(p+": Unsupported type: "+t);}},publicClone:function(v){return _.clone(v,function(K,v){if(K!=="@$ui5._"){return v;}});},removeByPath:function(M,p,i){var I=M[p],e;if(I){e=I.indexOf(i);if(e>=0){if(I.length===1){delete M[p];}else{I.splice(e,1);}}}},resolveIfMatchHeader:function(H){var i=H&&H["If-Match"];if(i&&typeof i==="object"){i=i["@odata.etag"];H=Object.assign({},H);if(i===undefined){delete H["If-Match"];}else{H["If-Match"]=i;}}return H;},selectKeyProperties:function(q,t){if(t&&t.$Key){_.addToSelect(q,t.$Key.map(function(K){if(typeof K==="object"){return K[Object.keys(K)[0]];}return K;}));}},setPrivateAnnotation:function(o,A,v){var p=o["@$ui5._"];if(!p){p=o["@$ui5._"]={};}p[A]=v;},stripPathPrefix:function(p,P){var s=p+"/";if(p===""){return P;}return P.filter(function(e){return e===p||e.startsWith(s);}).map(function(e){return e.slice(s.length);});},toArray:function(e){if(e===undefined||e===null){return[];}if(Array.isArray(e)){return e;}return[e];},uid:u,updateAll:function(C,p,t,s,e){Object.keys(s).forEach(function(P){var i=_.buildPath(p,P),o,v=s[P],T,q=t[P];if(P==="@$ui5._"){o=_.getPrivateAnnotation(s,"predicate");if(e&&e(p)){T=_.getPrivateAnnotation(t,"predicate");if(o!==T){throw new Error("Key predicate of '"+p+"' changed from "+T+" to "+o);}}else{_.setPrivateAnnotation(t,"predicate",o);}}else if(Array.isArray(v)){t[P]=v;}else if(v&&typeof v==="object"){t[P]=_.updateAll(C,i,q||{},v,e);}else if(q!==v){t[P]=v;if(q&&typeof q==="object"){_.fireChanges(C,i,q,true);}else{_.fireChange(C,i,v);}}});return t;},updateExisting:function(C,p,o,N){if(!N){return;}Object.keys(o).forEach(function(P){var s=_.buildPath(p,P),O=o[P],v=N[P];if(P in N||P[0]==="#"){if(Array.isArray(v)){o[P]=v;}else if(v&&typeof v==="object"){if(O){_.updateExisting(C,s,O,v);}else{o[P]=v;_.fireChanges(C,s,v,false);}}else if(O!==v){o[P]=v;if(O&&typeof O==="object"){_.fireChanges(C,s,O,true);}else{_.fireChange(C,s,v);}}}});Object.keys(N).filter(function(P){return P[0]==="#";}).filter(function(A){return!(A in o);}).forEach(function(s){var v=N[s],P=_.buildPath(p,s);o[s]=v;_.fireChanges(C,P,v,false);});},updateSelected:function(C,p,o,N,s){var P;function e(i,q,t){var v=i.split("/");v.every(function(w,I){var x=q[w],T=t[w];if(Array.isArray(x)){t[w]=x;}else if(x&&typeof x==="object"){t=t[w]=T||{};q=x;return true;}else if(T!==x){t[w]=x;if(T&&typeof T==="object"){_.fireChanges(C,_.buildPath(p,v.slice(0,I+1).join("/")),T,true);}else if(I===v.length-1){_.fireChange(C,_.buildPath(p,i),x);}}return false;});}if(!s||s.indexOf("*")>=0){_.updateAll(C,p,o,N);return;}s=s.concat("@odata.etag");s.forEach(function(i){e(i,N,o);});P=_.getPrivateAnnotation(N,"predicate");if(P){_.setPrivateAnnotation(o,"predicate",P);}},updateTransientPaths:function(M,t,p){var P;for(P in M){if(P.includes(t)){M[P.replace(t,p)]=M[P];delete M[P];}}},wrapChildQueryOptions:function(B,C,e,F){var E="",i,M=C.split("/"),p,P=B,q={},Q=q;if(C===""){return e;}for(i=0;i<M.length;i+=1){P=_.buildPath(P,M[i]);E=_.buildPath(E,M[i]);p=F(P).getResult();if(p.$kind==="NavigationProperty"){Q.$expand={};Q=Q.$expand[E]=(i===M.length-1)?e:{};_.selectKeyProperties(Q,F(P+"/").getResult());E="";}else if(p.$kind!=="Property"){return undefined;}}if(p.$kind==="Property"){if(Object.keys(e).length>0){L.error("Failed to enhance query options for auto-$expand/$select as the"+" child binding has query options, but its path '"+C+"' points to a structural property",JSON.stringify(e),c);return undefined;}_.addToSelect(Q,[E]);}if("$apply"in e){L.debug("Cannot wrap $apply into $expand: "+C,JSON.stringify(e),c);return undefined;}return q;}};return _;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_MetadataConverter',["./_Helper","sap/base/Log","sap/ui/performance/Measurement"],function(_,L,M){"use strict";var c="sap.ui.model.odata.v4.lib._MetadataConverter";
function a(){this.aliases={};this.oAnnotatable=null;this.entityContainer=null;this.entitySet=null;this.namespace=null;this.oOperation=null;this.reference=null;this.schema=null;this.type=null;this.result=null;this.url=null;this.xmlns=null;}
a.prototype.rCollection=/^Collection\((.*)\)$/;a.prototype.sEdmNamespace="http://docs.oasis-open.org/odata/ns/edm";a.prototype.sEdmxNamespace="http://docs.oasis-open.org/odata/ns/edmx";
a.prototype.addToResult=function(q,v){if(q in this.result){L.warning("Duplicate qualified name "+q,undefined,c);}this.result[q]=v;};
a.prototype.annotatable=function(t,p,q){var A,o,P;if(typeof t==="string"){A=this.oAnnotatable;if(A){t=_.buildPath(A.path,t);}P=t;o=this.schema.$Annotations;if(o&&o[t]){t=o[t];}}this.oAnnotatable={parent:this.oAnnotatable,path:P,prefix:p||"",qualifiedName:undefined,qualifier:q,target:t};};
a.prototype.convertXMLMetadata=function(d,u){var e;M.average("convertXMLMetadata","","sap.ui.model.odata.v4.lib._V4MetadataConverter");e=d.documentElement;if(e.localName!=="Edmx"||e.namespaceURI!==this.sRootNamespace){throw new Error(u+": expected <Edmx> in namespace '"+this.sRootNamespace+"'");}this.result={};this.url=u;this.traverse(e,this.oAliasConfig);this.traverse(e,this.oFullConfig,true);this.finalize();M.end("convertXMLMetadata");return this.result;};
a.prototype.getAnnotationValue=function(t,v){var i,V,b;switch(t){case"AnnotationPath":case"NavigationPropertyPath":case"Path":case"PropertyPath":v=this.resolveAliasInPath(v);case"Binary":case"Date":case"DateTimeOffset":case"Decimal":case"Duration":case"Guid":case"TimeOfDay":case"UrlRef":V={};V["$"+t]=v;return V;case"Bool":return v==="true";case"EnumMember":b=v.trim().replace(/ +/g," ").split(" ");for(i=0;i<b.length;i+=1){b[i]=this.resolveAliasInPath(b[i]);}return{$EnumMember:b.join(" ")};case"Float":if(v==="NaN"||v==="INF"||v==="-INF"){return{$Float:v};}return parseFloat(v);case"Int":V=parseInt(v);return _.isSafeInteger(V)?V:{$Int:v};case"String":return v;default:return undefined;}};
a.prototype.getInlineAnnotationValue=function(e){var A,o=e.attributes,i,v;for(i=o.length-1;i>=0;i-=1){A=o.item(i);v=this.getAnnotationValue(A.name,A.value);if(v!==undefined){return v;}}return true;};
a.prototype.getOrCreateArray=function(p,P){var r=p[P];if(!r){r=p[P]=[];}return r;};
a.prototype.getOrCreateObject=function(p,P){var r=p[P];if(!r){r=p[P]={};}return r;};
a.prototype.postProcessAnnotation=function(e,r){var A=this.oAnnotatable.parent;A.target[A.qualifiedName]=r.length?r[0]:this.getInlineAnnotationValue(e);};
a.prototype.postProcessApply=function(e,r){var R=this.oAnnotatable.target;R.$Apply=r;R.$Function=this.resolveAlias(e.getAttribute("Function"));return R;};
a.prototype.postProcessCastOrIsOf=function(e,r){var n=e.localName,R=this.oAnnotatable.target;R["$"+n]=r[0];this.processTypedCollection(e.getAttribute("Type"),R);this.processFacetAttributes(e,R);return R;};
a.prototype.postProcessCollection=function(e,r){return r;};
a.prototype.postProcessLabeledElement=function(e,r){var R=this.oAnnotatable.target;R.$LabeledElement=r.length?r[0]:this.getInlineAnnotationValue(e);R.$Name=e.getAttribute("Name");return R;};
a.prototype.postProcessLabeledElementReference=function(e,r){return{"$LabeledElementReference":this.resolveAlias(e.textContent)};};
a.prototype.postProcessLeaf=function(e,r){return this.getAnnotationValue(e.localName,e.textContent);};
a.prototype.postProcessNot=function(e,r){var R=this.oAnnotatable.target;R.$Not=r[0];return R;};
a.prototype.postProcessNull=function(e,r){var A=this.oAnnotatable,R=null;if(A.qualifiedName){R=A.target;R.$Null=null;}return R;};
a.prototype.postProcessOperation=function(e,r){var R=this.oAnnotatable.target;R["$"+e.localName]=r;return R;};
a.prototype.postProcessPropertyValue=function(e,r){return{property:e.getAttribute("Property"),value:r.length?r[0]:this.getInlineAnnotationValue(e)};};
a.prototype.postProcessRecord=function(e,r){var i,p,R=this.oAnnotatable.target,t=e.getAttribute("Type");if(t){R.$Type=this.resolveAlias(t);}for(i=0;i<r.length;i+=1){p=r[i];R[p.property]=p.value;}return R;};
a.prototype.postProcessUrlRef=function(e,r){return{$UrlRef:r[0]};};
a.prototype.processAlias=function(e){var A=e.getAttribute("Alias");if(A){this.aliases[A]=e.getAttribute("Namespace")+".";}};
a.prototype.processAnnotatableExpression=function(e){this.annotatable({});};
a.prototype.processAnnotation=function(e){var A=this.oAnnotatable,o,q=A.prefix+"@"+this.resolveAlias(e.getAttribute("Term")),Q=A.qualifier||e.getAttribute("Qualifier");if(Q){q+="#"+Q;}if(typeof A.target==="string"){o=this.getOrCreateObject(this.schema,"$Annotations");A.target=o[A.target]={};}A.qualifiedName=q;A.target[q]=true;this.annotatable(A.target,q);};
a.prototype.processAnnotations=function(e){this.annotatable(this.resolveAliasInPath(e.getAttribute("Target"),true),undefined,e.getAttribute("Qualifier"));};
a.prototype.processAttributes=function(e,t,C){var p;for(p in C){var v=C[p](e.getAttribute(p));if(v!==undefined&&v!==null){t["$"+p]=v;}}};
a.prototype.processInclude=function(e){var i=this.getOrCreateArray(this.reference,"$Include");i.push(e.getAttribute("Namespace")+".");};
a.prototype.processIncludeAnnotations=function(e){var r=this.reference,i={"$TermNamespace":e.getAttribute("TermNamespace")+"."},I=this.getOrCreateArray(r,"$IncludeAnnotations");this.processAttributes(e,i,{"TargetNamespace":function setValue(v){return v?v+".":v;},"Qualifier":this.setValue});I.push(i);};
a.prototype.processPropertyValue=function(e){this.annotatable(this.oAnnotatable.target,e.getAttribute("Property"));};
a.prototype.processReference=function(e){var r=this.getOrCreateObject(this.result,"$Reference");this.reference=r[e.getAttribute("Uri")]={};this.annotatable(this.reference);};
a.prototype.resolveAlias=function(n){var d=n.indexOf("."),N;if(d>=0&&!n.includes(".",d+1)){N=this.aliases[n.slice(0,d)];if(N){return N+n.slice(d+1);}}return n;};
a.prototype.resolveAliasInParentheses=function(h,s){var p=h?s.indexOf("("):-1;if(p>=0){return this.resolveAlias(s.slice(0,p))+"("+s.slice(p+1,-1).split(",").map(this.resolveAliasInParentheses.bind(this,h)).join(",")+")";}return this.resolveAlias(s);};
a.prototype.resolveAliasInPath=function(p,h){var A,t="";if(!p.includes(".")){return p;}A=p.indexOf("@");if(A>=0){t="@"+this.resolveAlias(p.slice(A+1));p=p.slice(0,A);}return p.split("/").map(this.resolveAliasInParentheses.bind(this,h)).join("/")+t;};
a.prototype.setIfFalse=function(v){return v==="false"?false:undefined;};
a.prototype.setIfTrue=function(v){return v==="true"?true:undefined;};
a.prototype.setNumber=function(v){return v?parseInt(v):undefined;};
a.prototype.setValue=function(v){return v;};
a.prototype.traverse=function(e,C,u){var A=this.oAnnotatable,o,b=e.childNodes,d,v,i,I,j,n,p=this.xmlns,r,R=[],x=C.__xmlns||this.xmlns;if(x&&x!==e.namespaceURI){return undefined;}this.xmlns=x;if(u){this.processElement(e,C.__processor);}else if(C.__processor){C.__processor.call(this,e);}for(i=0;i<b.length;i+=1){d=b.item(i);if(d.nodeType===1){n=d.localName;o=C[n];if(!o&&C.__include){I=C.__include;for(j=0;j<I.length;j+=1){o=I[j][n];if(o){break;}}}if(o){v=this.traverse(d,o,u);if(v!==undefined&&C.__postProcessor){R.push(v);}}}}if(C.__postProcessor){r=C.__postProcessor.call(this,e,R);}this.oAnnotatable=A;this.xmlns=p;return r;};
(function($){var A,o,b,e,O;b={"AnnotationPath":{__postProcessor:$.postProcessLeaf},"Binary":{__postProcessor:$.postProcessLeaf},"Bool":{__postProcessor:$.postProcessLeaf},"Date":{__postProcessor:$.postProcessLeaf},"DateTimeOffset":{__postProcessor:$.postProcessLeaf},"Decimal":{__postProcessor:$.postProcessLeaf},"Duration":{__postProcessor:$.postProcessLeaf},"EnumMember":{__postProcessor:$.postProcessLeaf},"Float":{__postProcessor:$.postProcessLeaf},"Guid":{__postProcessor:$.postProcessLeaf},"Int":{__postProcessor:$.postProcessLeaf},"LabeledElementReference":{__postProcessor:$.postProcessLabeledElementReference},"NavigationPropertyPath":{__postProcessor:$.postProcessLeaf},"Path":{__postProcessor:$.postProcessLeaf},"PropertyPath":{__postProcessor:$.postProcessLeaf},"String":{__postProcessor:$.postProcessLeaf},"TimeOfDay":{__postProcessor:$.postProcessLeaf}};e=[b];$.oAnnotationConfig={"Annotation":{__xmlns:$.sEdmNamespace,__processor:$.processAnnotation,__postProcessor:$.postProcessAnnotation,__include:e}};A=[b,$.oAnnotationConfig];O={__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessOperation,__include:A};o={"And":O,"Apply":{__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessApply,__include:A},"Cast":{__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessCastOrIsOf,__include:A},"Collection":{__postProcessor:$.postProcessCollection,__include:e},"Eq":O,"Ge":O,"Gt":O,"If":O,"IsOf":{__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessCastOrIsOf,__include:A},"LabeledElement":{__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessLabeledElement,__include:A},"Le":O,"Lt":O,"Ne":O,"Null":{__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessNull,__include:[$.oAnnotationConfig]},"Not":{__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessNot,__include:A},"Or":O,"Record":{__processor:$.processAnnotatableExpression,__postProcessor:$.postProcessRecord,__include:[$.oAnnotationConfig],"PropertyValue":{__processor:$.processPropertyValue,__postProcessor:$.postProcessPropertyValue,__include:A}},"UrlRef":{__postProcessor:$.postProcessUrlRef,__include:e}};$.oAnnotationsConfig={"Annotations":{__processor:$.processAnnotations,__include:[$.oAnnotationConfig]}};e.push(o);A.push(o);$.oAnnotationConfig.Annotation.Annotation=$.oAnnotationConfig.Annotation;$.oReferenceInclude={"Reference":{__xmlns:$.sEdmxNamespace,__processor:$.processReference,__include:[$.oAnnotationConfig],"Include":{__processor:$.processInclude},"IncludeAnnotations":{__processor:$.processIncludeAnnotations}}};})(a.prototype);return a;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_MetadataRequestor',["./_Helper","./_V2MetadataConverter","./_V4MetadataConverter","sap/base/Log","sap/ui/thirdparty/jquery"],function(_,a,b,L,q){"use strict";return{create:function(h,o,Q){var u={},s=_.buildQuery(Q);return{read:function(U,A,p){var P;function c(j){var C=o==="4.0"||A?b:a,d=j.$XML;delete j.$XML;return Object.assign(new C().convertXMLMetadata(d,U),j);}if(U in u){if(p){throw new Error("Must not prefetch twice: "+U);}P=u[U].then(c);delete u[U];}else{P=new Promise(function(r,R){q.ajax(A?U:U+s,{method:"GET",headers:h}).then(function(d,t,j){var D=j.getResponseHeader("Date"),e=j.getResponseHeader("ETag"),J={$XML:d},l=j.getResponseHeader("Last-Modified");if(D){J.$Date=D;}if(e){J.$ETag=e;}if(l){J.$LastModified=l;}r(J);},function(j,t,e){var E=_.createError(j,"Could not load metadata");L.error("GET "+U,E.message,"sap.ui.model.odata.v4.lib._MetadataRequestor");R(E);});if(!A&&Q&&"sap-context-token"in Q){delete Q["sap-context-token"];s=_.buildQuery(Q);}});if(p){u[U]=P;}else{P=P.then(c);}}return P;}};}};},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_Parser',[],function(){"use strict";var d="[=(),; \t\"']|%(09|20|22|27|28|29|2c|2C|3b|3B)",s="\\$\\w+",o="[a-zA-Z_\\u0080-\\uFFFF][\\w\\u0080-\\uFFFF]*",w="(?:[ \\t]|%09|%20)",r=new RegExp(w+"+","g"),a=new RegExp("^not"+w+"+"),O="("+w+"+)(and|eq|ge|gt|le|lt|ne|or)"+w+"+",g="[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}",S="(?:\\*|%2[aA])",n=o+"(?:[./]"+o+")*"+"(?:[./]"+S+"|/\\$ref|/\\$count)?",b=S+"(?:/\\$ref)?",p=n+"|"+b,v='(?:[-+:./\\w"]|%2[bB])+',e=new RegExp("^(?:"+O+"|"+d+"|("+g+")|("+p+")|("+v+")|("+s+"))"),f=/^[0-9a-f]{2}$/i,F={"ceiling":{ambiguousParameters:true},"concat":{type:"Edm.String"},"contains":{type:"Edm.Boolean"},"day":{type:"Edm.Int32",ambiguousParameters:true},"endswith":{type:"Edm.Boolean"},"floor":{ambiguousParameters:true},"hour":{type:"Edm.Int32",ambiguousParameters:true},"indexof":{type:"Edm.Int32"},"length":{type:"Edm.Int32"},"minute":{type:"Edm.Int32",ambiguousParameters:true},"month":{type:"Edm.Int32",ambiguousParameters:true},"round":{ambiguousParameters:true},"second":{type:"Edm.Int32",ambiguousParameters:true},"startswith":{type:"Edm.Boolean"},"substring":{type:"Edm.String"},"tolower":{type:"Edm.String"},"toupper":{type:"Edm.String"},"trim":{type:"Edm.String"},"year":{type:"Edm.Int32",ambiguousParameters:true}},m={"(":{lbp:9,led:function(T,L){var c,i;if(L.id!=="PATH"){this.error("Unexpected ",T);}c=F[L.value];if(!c){this.error("Unknown function ",L);}L.id="FUNCTION";if(c.type){L.type=c.type;}L.parameters=[];do{this.advanceBws();i=this.expression(0);if(c.ambiguousParameters){i.ambiguous=true;}L.parameters.push(i);this.advanceBws();}while(this.advanceIf(","));this.advanceBws();this.advance(')');return L;},nud:function(){this.advanceBws();var T=this.expression(0);this.advanceBws();this.advance(')');return T;}},"not":{lbp:7,nud:function(T){T.precedence=7;T.right=this.expression(7);T.type="Edm.Boolean";return T;}}};
function h(i,L){m[i]={lbp:L,led:function(T,c){T.type="Edm.Boolean";T.precedence=L;T.left=c;T.right=this.expression(L);return T;}};}
function j(i){m[i]={lbp:0,nud:function(T){T.precedence=99;return T;}};}
h("and",2);h("eq",3);h("ge",4);h("gt",4);h("le",4);h("lt",4);h("ne",3);h("or",1);j("PATH");j("VALUE");
function P(){}
P.prototype.advance=function(E){var T=this.current();if(E&&(!T||T.id!==E)){if(E==="OPTION"){E="system query option";}else if(E.length===1){E="'"+E+"'";}this.expected(E,T);}this.iCurrentToken+=1;return T;};
P.prototype.advanceIf=function(E){var T=this.current();if(T&&T.id===E){this.iCurrentToken+=1;return true;}return false;};
P.prototype.current=function(){return this.aTokens[this.iCurrentToken];};
P.prototype.error=function(M,T){var v;if(T){v=T.value;M+="'"+(v===" "?v:v.replace(r,""))+"' at "+T.at;}else{M+="end of input";}throw new SyntaxError(M+": "+this.sText);};
P.prototype.expected=function(W,T){this.error("Expected "+W+" but instead saw ",T);};
P.prototype.finish=function(){if(this.iCurrentToken<this.aTokens.length){this.expected("end of input",this.aTokens[this.iCurrentToken]);}};
P.prototype.init=function(T){this.sText=T;this.aTokens=x(T);this.iCurrentToken=0;};
function k(){}
k.prototype=Object.create(P.prototype);
k.prototype.advanceBws=function(){var T;for(;;){T=this.current();if(!T||(T.id!==" "&&T.id!=="\t")){return;}this.advance();}};
k.prototype.expression=function(R){var L,c,T;T=this.advance();if(!T){this.expected("expression");}L=this.getSymbolValue(T,"nud");if(!L){this.expected("expression",T);}c=L.call(this,T);T=this.current();while(T&&this.getSymbolValue(T,"lbp",0)>R){c=this.getSymbolValue(T,"led").call(this,this.advance(),c);T=this.current();}return c;};
k.prototype.getSymbolValue=function(T,W,D){var c=m[T.id];return c&&W in c?c[W]:D;};
k.prototype.parse=function(c){var R;this.init(c);R=this.expression(0);this.finish();return R;};
function K(){}
K.prototype=Object.create(P.prototype);
K.prototype.parse=function(c){var i,y={},v;this.init(c);this.advance("(");if(this.current().id==="VALUE"){y[""]=this.advance().value;}else{do{i=this.advance("PATH").value;this.advance("=");v=this.advance("VALUE").value;y[i]=v;}while(this.advanceIf(","));}this.advance(")");this.finish();return y;};
function l(){}
l.prototype=Object.create(P.prototype);
l.prototype.parse=function(c){var R;this.init(c);R=this.parseSystemQueryOption();this.finish();return R;};
l.prototype.parseAnythingWithBrackets=function(c){var v="",R={},T,i=this;function y(){for(;;){T=i.advance();if(!T||T.id===';'){i.expected("')'",T);}v+=T.value;if(T.id===")"){return;}if(T.id==="("){y();}}}this.advance("=");for(;;){T=this.current();if(!T||T.id===")"||T.id===";"){break;}v+=this.advance().value;if(T.id==="("){y();}}if(!v){this.expected("an option value",T);}R[c.value]=v;return R;};
l.prototype.parseExpand=function(){var E={},c,Q,i,V;this.advance("=");do{V=null;c=this.advance("PATH").value.replace(/%2a/i,"*");if(this.advanceIf("(")){V={};do{Q=this.parseSystemQueryOption();i=Object.keys(Q)[0];V[i]=Q[i];}while(this.advanceIf(";"));this.advance(")");}E[c]=V;}while(this.advanceIf(","));return{"$expand":E};};
l.prototype.parseSelect=function(){var p,c,i=[],T;this.advance("=");do{T=this.advance("PATH");p=T.value.replace(/%2a/i,"*");if(this.advanceIf("(")){c="(";do{p+=c+this.advance("PATH").value;c=",";}while(this.advanceIf(","));p+=this.advance(")").value;}i.push(p);}while(this.advanceIf(","));return{"$select":i};};
l.prototype.parseSystemQueryOption=function(){var T=this.advance('OPTION');switch(T.value){case"$expand":return this.parseExpand();case"$select":return this.parseSelect();default:return this.parseAnythingWithBrackets(T);}};
function u(E){return String.fromCharCode(parseInt(E,16));}
function t(N,y,A){var i;function z(C){var c=N[i];if(c==="%"&&N[i+1]==="2"&&N[i+2]==="7"){c="'";if(C){i+=2;}}if(C){i+=1;}return c;}for(i=1;i<N.length;){if(z(true)==="'"){if(z(false)!=="'"){return N.slice(0,i);}z(true);}}throw new SyntaxError("Unterminated string at "+A+": "+y);}
function q(N,y,A){var c,E,z=false,i;for(i=1;i<N.length;i+=1){if(z){z=false;}else{c=N[i];if(c==="%"){E=N.slice(i+1,i+3);if(f.test(E)){c=u(E);i+=2;}}if(c==='"'){return N.slice(0,i+1);}z=c==='\\';}}throw new SyntaxError("Unterminated string at "+A+": "+y);}
function x(c){var A=1,i,M,N=c,y,T,z=[],v;while(N.length){M=e.exec(N);y=0;if(M){v=M[0];if(M[7]){i="OPTION";}else if(M[6]||M[4]){i="VALUE";}else if(M[5]){i="PATH";if(v==="false"||v==="true"||v==="null"){i="VALUE";}else if(v==="not"){M=a.exec(N);if(M){i="not";v=M[0];}}}else if(M[3]){i=u(M[3]);}else if(M[2]){i=M[2];y=M[1].length;}else{i=M[0];}if(i==='"'){i="VALUE";v=q(N,c,A);}else if(i==="'"){i="VALUE";v=t(N,c,A);}T={at:A+y,id:i,value:v};}else{throw new SyntaxError("Unknown character '"+N[0]+"' at "+A+": "+c);}N=N.slice(v.length);A+=v.length;z.push(T);}return z;}
return{buildFilterString:function(c){function i(N,y){var z;if(!N){return"";}if(N.parameters){z=N.parameters.map(function(A){return i(A,0);}).join(",");return N.value+"("+z+")";}z=i(N.left,N.precedence)+N.value+i(N.right,N.precedence);if(N.precedence<y){z="("+z+")";}return z;}return i(c,0);},parseFilter:function(c){return new k().parse(c);},parseKeyPredicate:function(c){return new K().parse(c);},parseSystemQueryOption:function(c){return new l().parse(c);},sODataIdentifier:o,sWhitespace:w};},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_Requestor',["./_Batch","./_GroupLock","./_Helper","./_V2Requestor","sap/base/Log","sap/ui/base/SyncPromise","sap/ui/thirdparty/jquery"],function(_,a,b,c,L,S,q){"use strict";var B={"Accept":"multipart/mixed"},C="sap.ui.model.odata.v4.lib._Requestor",d,r=/(\$\w+)=~/g,e=/^\d+$/;
function g(h){var s;h=h.toLowerCase();for(s in this.headers){if(s.toLowerCase()===h){return this.headers[s];}}}
function R(s,h,Q,m){this.mBatchQueue={};this.mHeaders=h||{};this.aLockedGroupLocks=[];this.oModelInterface=m;this.sQueryParams=b.buildQuery(Q);this.mRunningChangeRequests={};this.oSecurityTokenPromise=null;this.iSessionTimer=0;this.iSerialNumber=0;this.sServiceUrl=s;}
R.prototype.mFinalHeaders={"Content-Type":"application/json;charset=UTF-8;IEEE754Compatible=true"};R.prototype.mPredefinedPartHeaders={"Accept":"application/json;odata.metadata=minimal;IEEE754Compatible=true"};R.prototype.mPredefinedRequestHeaders={"Accept":"application/json;odata.metadata=minimal;IEEE754Compatible=true","OData-MaxVersion":"4.0","OData-Version":"4.0","X-CSRF-Token":"Fetch"};R.prototype.mReservedHeaders={accept:true,"accept-charset":true,"content-encoding":true,"content-id":true,"content-language":true,"content-length":true,"content-transfer-encoding":true,"content-type":true,"if-match":true,"if-none-match":true,isolation:true,"odata-isolation":true,"odata-maxversion":true,"odata-version":true,prefer:true,"sap-contextid":true};
R.prototype.addChangeSet=function(G){var f=[],h=this.getOrCreateBatchQueue(G);f.iSerialNumber=this.getSerialNumber();h.iChangeSet+=1;h.splice(h.iChangeSet,0,f);};
R.prototype.addChangeToGroup=function(o,G){var f;if(this.getGroupSubmitMode(G)==="Direct"){o.$resolve(this.request(o.method,o.url,this.lockGroup(G,this,true,true),o.headers,o.body,o.$submit,o.$cancel));}else{f=this.getOrCreateBatchQueue(G);f[f.iChangeSet].push(o);}};
R.prototype.addQueryString=function(s,m,Q){var f;Q=this.convertQueryOptions(m,Q,false,true);s=s.replace(r,function(u,o){var v=Q[o];delete Q[o];return o+"="+v;});f=b.buildQuery(Q);if(!f){return s;}return s+(s.includes("?")?"&"+f.slice(1):f);};
R.prototype.batchRequestSent=function(G,h){var p,f;if(h){if(this.mRunningChangeRequests[G]){throw new Error("Unexpected second $batch");}p=new S(function(i){f=i;});p.$resolve=f;this.mRunningChangeRequests[G]=p;}};
R.prototype.batchResponseReceived=function(G,h){if(h){this.mRunningChangeRequests[G].$resolve();delete this.mRunningChangeRequests[G];}};
R.prototype.buildQueryString=function(m,Q,D,s){return b.buildQuery(this.convertQueryOptions(m,Q,D,s));};
R.prototype.cancelChanges=function(G){if(this.mRunningChangeRequests[G]){throw new Error("Cannot cancel the changes for group '"+G+"', the batch request is running");}this.cancelChangesByFilter(function(){return true;},G);this.cancelGroupLocks(G);};
R.prototype.cancelChangesByFilter=function(f,G){var h=false,t=this;function k(s){var l=t.mBatchQueue[s],o,m,E,i,j;for(j=l.length-1;j>=0;j-=1){if(Array.isArray(l[j])){m=l[j];for(i=m.length-1;i>=0;i-=1){o=m[i];if(o.$cancel&&f(o)){o.$cancel();E=new Error("Request canceled: "+o.method+" "+o.url+"; group: "+s);E.canceled=true;o.$reject(E);m.splice(i,1);h=true;}}}}}if(G){if(this.mBatchQueue[G]){k(G);}}else{for(G in this.mBatchQueue){k(G);}}return h;};
R.prototype.cancelGroupLocks=function(G){this.aLockedGroupLocks.forEach(function(o){if((!G||G===o.getGroupId())&&o.isModifying()&&o.isLocked()){o.cancel();}});};
R.prototype.checkForOpenRequests=function(){var t=this;if(Object.keys(this.mRunningChangeRequests).length||Object.keys(this.mBatchQueue).some(function(G){return t.mBatchQueue[G].some(function(v){return Array.isArray(v)?v.length:true;});})||this.aLockedGroupLocks.some(function(G){return G.isLocked();})){throw new Error("Unexpected open requests");}};
R.prototype.checkHeaderNames=function(h){var k;for(k in h){if(this.mReservedHeaders[k.toLowerCase()]){throw new Error("Unsupported header: "+k);}}};
R.prototype.cleanUpChangeSets=function(f){var h,H=false,i;function j(o){if(!m(o)){h.push(o);}}function m(o){if(o.method!=="PATCH"){return false;}return h.some(function(k){if(k.method==="PATCH"&&k.headers["If-Match"]===o.headers["If-Match"]){b.merge(k.body,o.body);o.$resolve(k.$promise);return true;}});}for(i=f.iChangeSet;i>=0;i-=1){h=[];f[i].forEach(j);if(h.length===0){f.splice(i,1);}else if(h.length===1&&this.isChangeSetOptional()){f[i]=h[0];}else{f[i]=h;}H=H||h.length>0;}return H;};
R.prototype.clearSessionContext=function(t){if(t){this.oModelInterface.fireSessionTimeout();}delete this.mHeaders["SAP-ContextId"];if(this.iSessionTimer){clearInterval(this.iSessionTimer);this.iSessionTimer=0;}};
R.prototype.convertExpand=function(E,s){var k,f=[],t=this;if(!E||typeof E!=="object"){throw new Error("$expand must be a valid object");}k=Object.keys(E);if(s){k=k.sort();}k.forEach(function(h){var v=E[h];if(v&&typeof v==="object"){f.push(t.convertExpandOptions(h,v,s));}else{f.push(h);}});return f.join(",");};
R.prototype.convertExpandOptions=function(E,v,s){var f=[];this.doConvertSystemQueryOptions(undefined,v,function(o,O){f.push(o+'='+O);},undefined,s);return f.length?E+"("+f.join(";")+")":E;};
R.prototype.convertQueryOptions=function(m,Q,D,s){var f={};if(!Q){return undefined;}this.doConvertSystemQueryOptions(m,Q,function(k,v){f[k]=v;},D,s);return f;};
R.prototype.convertResourcePath=function(s){return s;};
R.prototype.destroy=function(){this.clearSessionContext();};
R.prototype.doCheckVersionHeader=function(G,s,v){var o=G("OData-Version"),D=!o&&G("DataServiceVersion");if(D){throw new Error("Expected 'OData-Version' header with value '4.0' but received"+" 'DataServiceVersion' header with value '"+D+"' in response for "+this.sServiceUrl+s);}if(o==="4.0"||!o&&v){return;}throw new Error("Expected 'OData-Version' header with value '4.0' but received value '"+o+"' in response for "+this.sServiceUrl+s);};
R.prototype.doConvertResponse=function(o,m){return o;};
R.prototype.doConvertSystemQueryOptions=function(m,Q,f,D,s){var t=this;Object.keys(Q).forEach(function(k){var v=Q[k];if(D&&k[0]==='$'){return;}switch(k){case"$expand":if(v!=="~"){v=t.convertExpand(v,s);}break;case"$select":if(Array.isArray(v)){v=s?v.sort().join(","):v.join(",");}break;default:}f(k,v);});};
R.prototype.fetchTypeForPath=function(m,A){return this.oModelInterface.fetchMetadata(m+(A?"/$Type":"/"));};
R.prototype.formatPropertyAsLiteral=function(v,p){return b.formatLiteral(v,p.$Type);};
R.prototype.getGroupSubmitMode=function(G){return this.oModelInterface.getGroupProperty(G,"submit");};
R.prototype.getModelInterface=function(){return this.oModelInterface;};
R.prototype.getOrCreateBatchQueue=function(G){var f,h=this.mBatchQueue[G];if(!h){f=[];f.iSerialNumber=0;h=this.mBatchQueue[G]=[f];h.iChangeSet=0;if(this.oModelInterface.onCreateGroup){this.oModelInterface.onCreateGroup(G);}}return h;};
R.prototype.getPathAndAddQueryOptions=function(p,o,P){var A=[],n,N={},f,t=this;p=p.slice(1,-5);if(o.$Parameter){o.$Parameter.forEach(function(f){N[f.$Name]=f;});}if(o.$kind==="Function"){for(n in P){f=N[n];if(f){if(f.$isCollection){throw new Error("Unsupported collection-valued parameter: "+n);}A.push(encodeURIComponent(n)+"="+encodeURIComponent(t.formatPropertyAsLiteral(P[n],f)));}}p+="("+A.join(",")+")";}else{for(n in P){if(!(n in N)){delete P[n];}}}return p;};
R.prototype.getSerialNumber=function(){this.iSerialNumber+=1;return this.iSerialNumber;};
R.prototype.getServiceUrl=function(){return this.sServiceUrl;};
R.prototype.hasChanges=function(G,E){var f=this.mBatchQueue[G];if(f){return f.some(function(v){return Array.isArray(v)&&v.some(function(o){return o.headers["If-Match"]===E;});});}return false;};
R.prototype.hasPendingChanges=function(G){var t=this;function f(m){if(!G){return Object.keys(m);}return G in m?[G]:[];}return f(this.mRunningChangeRequests).length>0||this.aLockedGroupLocks.some(function(o){return(G===undefined||o.getGroupId()===G)&&o.isModifying()&&o.isLocked();})||f(this.mBatchQueue).some(function(s){return t.mBatchQueue[s].some(function(v){return Array.isArray(v)&&v.some(function(o){return o.$cancel;});});});};
R.prototype.isActionBodyOptional=function(){return false;};
R.prototype.isChangeSetOptional=function(){return true;};
R.prototype.mergeGetRequests=function(f){var h=[],t=this;function m(o){return o.$queryOptions&&h.some(function(i){if(i.$queryOptions&&o.url===i.url){b.aggregateQueryOptions(i.$queryOptions,o.$queryOptions);o.$resolve(i.$promise);return true;}return false;});}f.forEach(function(o){if(!m(o)){h.push(o);}});h.forEach(function(o){if(o.$queryOptions){o.url=t.addQueryString(o.url,o.$metaPath,o.$queryOptions);}});h.iChangeSet=f.iChangeSet;return h;};
R.prototype.processBatch=function(G){var h,f=this.mBatchQueue[G]||[],t=this;function o(j){if(Array.isArray(j)){j.forEach(o);}else if(j.$submit){j.$submit();}}function i(E,j){if(Array.isArray(j)){j.forEach(i.bind(null,E));}else{j.$reject(E);}}function v(f,j){var k;f.forEach(function(l,m){var E,s,n,p=j[m];if(Array.isArray(p)){v(l,p);}else if(!p){E=new Error("HTTP request was not processed because the previous request failed");E.cause=k;E.$reported=true;l.$reject(E);}else if(p.status>=400){p.getResponseHeader=g;k=b.createError(p,"Communication error",l.url,l.$resourcePath);i(k,l);}else{if(p.responseText){try{t.doCheckVersionHeader(g.bind(p),l.url,true);n=t.doConvertResponse(JSON.parse(p.responseText),l.$metaPath);}catch(u){l.$reject(u);return;}}else{n=l.method==="GET"?null:{};}t.reportUnboundMessagesAsJSON(l.url,g.call(p,"sap-messages"));s=g.call(p,"ETag");if(s){n["@odata.etag"]=s;}l.$resolve(n);}});}delete this.mBatchQueue[G];o(f);h=this.cleanUpChangeSets(f);if(f.length===0){return Promise.resolve();}this.batchRequestSent(G,h);f=this.mergeGetRequests(f);return this.sendBatch(d.cleanBatch(f)).then(function(j){v(f,j);}).catch(function(E){var j=new Error("HTTP request was not processed because $batch failed");j.cause=E;i(j,f);throw E;}).finally(function(){t.batchResponseReceived(G,h);});};
R.prototype.ready=function(){return S.resolve();};
R.prototype.lockGroup=function(G,o,l,m,f){var h;h=new a(G,o,l,m,this.getSerialNumber(),f);if(l){this.aLockedGroupLocks.push(h);}return h;};
R.prototype.refreshSecurityToken=function(o){var t=this;if(!this.oSecurityTokenPromise){if(o!==this.mHeaders["X-CSRF-Token"]){return Promise.resolve();}this.oSecurityTokenPromise=new Promise(function(f,h){q.ajax(t.sServiceUrl+t.sQueryParams,{method:"HEAD",headers:Object.assign({},t.mHeaders,{"X-CSRF-Token":"Fetch"})}).then(function(D,T,j){var s=j.getResponseHeader("X-CSRF-Token");if(s){t.mHeaders["X-CSRF-Token"]=s;}else{delete t.mHeaders["X-CSRF-Token"];}t.oSecurityTokenPromise=null;f();},function(j,T,E){t.oSecurityTokenPromise=null;h(b.createError(j,"Could not refresh security token"));});});}return this.oSecurityTokenPromise;};
R.prototype.relocate=function(s,o,n){var f=this.mBatchQueue[s],t=this,F=f&&f[0].some(function(h,i){if(h.body===o){t.addChangeToGroup(h,n);f[0].splice(i,1);return true;}});if(!F){throw new Error("Request not found in group '"+s+"'");}};
R.prototype.relocateAll=function(s,n,E){var j=0,f=this.mBatchQueue[s],t=this;if(f){f[0].slice().forEach(function(o){if(!E||o.headers["If-Match"]===E){t.addChangeToGroup(o,n);f[0].splice(j,1);}else{j+=1;}});}};
R.prototype.removePatch=function(p){var f=this.cancelChangesByFilter(function(o){return o.$promise===p;});if(!f){throw new Error("Cannot reset the changes, the batch request is running");}};
R.prototype.removePost=function(G,E){var o=b.getPrivateAnnotation(E,"postBody"),f=this.cancelChangesByFilter(function(h){return h.body===o;},G);if(!f){throw new Error("Cannot reset the changes, the batch request is running");}};
R.prototype.reportUnboundMessagesAsJSON=function(s,m){this.oModelInterface.reportUnboundMessages(s,JSON.parse(m||null));};
R.prototype.request=function(m,s,G,h,p,f,i,M,o,A,Q){var j,E,k=G&&G.getGroupId()||"$direct",P,l=Infinity,n,t=this;if(k==="$cached"){E=new Error("Unexpected request: "+m+" "+s);E.$cached=true;throw E;}if(G&&G.isCanceled()){if(i){i();}E=new Error("Request already canceled");E.canceled=true;return Promise.reject(E);}if(G){G.unlock();l=G.getSerialNumber();}s=this.convertResourcePath(s);o=o||s;if(this.getGroupSubmitMode(k)!=="Direct"){P=new Promise(function(u,v){var w=t.getOrCreateBatchQueue(k);n={method:m,url:s,headers:Object.assign({},t.mPredefinedPartHeaders,t.mHeaders,h,t.mFinalHeaders),body:p,$cancel:i,$metaPath:M,$queryOptions:Q,$reject:v,$resolve:u,$resourcePath:o,$submit:f};if(m==="GET"){w.push(n);}else if(A){w[0].unshift(n);}else{j=w.iChangeSet;while(w[j].iSerialNumber>l){j-=1;}w[j].push(n);}});n.$promise=P;return P;}if(Q){s=t.addQueryString(s,M,Q);}if(f){f();}return this.sendRequest(m,s,Object.assign({},h,this.mFinalHeaders),JSON.stringify(d.cleanPayload(p)),o).then(function(u){t.reportUnboundMessagesAsJSON(u.resourcePath,u.messages);return t.doConvertResponse(u.body,M);});};
R.prototype.sendBatch=function(f){var o=_.serializeBatchRequest(f);return this.sendRequest("POST","$batch"+this.sQueryParams,Object.assign(o.headers,B),o.body).then(function(h){if(h.messages!==null){throw new Error("Unexpected 'sap-messages' response header for batch request");}return _.deserializeBatchResponse(h.contentType,h.body);});};
R.prototype.sendRequest=function(m,s,h,p,o){var f=this.sServiceUrl+s,t=this;return new Promise(function(i,j){function k(I){var O=t.mHeaders["X-CSRF-Token"];return q.ajax(f,{contentType:h&&h["Content-Type"],data:p,headers:Object.assign({},t.mPredefinedRequestHeaders,t.mHeaders,b.resolveIfMatchHeader(h)),method:m}).then(function(v,T,l){var E=l.getResponseHeader("ETag"),n=l.getResponseHeader("X-CSRF-Token");try{t.doCheckVersionHeader(l.getResponseHeader,s,!v);}catch(u){j(u);return;}if(n){t.mHeaders["X-CSRF-Token"]=n;}t.setSessionContext(l.getResponseHeader("SAP-ContextId"),l.getResponseHeader("SAP-Http-Session-Timeout"));if(!v){v=m==="GET"?null:{};}if(E){v["@odata.etag"]=E;}i({body:v,contentType:l.getResponseHeader("Content-Type"),messages:l.getResponseHeader("sap-messages"),resourcePath:s});},function(l,T,E){var n=l.getResponseHeader("SAP-ContextId"),u=l.getResponseHeader("X-CSRF-Token"),M;if(!I&&l.status===403&&u&&u.toLowerCase()==="required"){t.refreshSecurityToken(O).then(function(){k(true);},j);}else{M="Communication error";if(n){t.setSessionContext(n,l.getResponseHeader("SAP-Http-Session-Timeout"));}else if(t.mHeaders["SAP-ContextId"]){M="Session not found on server";L.error(M,undefined,C);t.clearSessionContext(true);}j(b.createError(l,M,f,o));}});}if(t.oSecurityTokenPromise&&m!=="GET"){return t.oSecurityTokenPromise.then(k);}return k();});};
R.prototype.setSessionContext=function(s,f){var t=e.test(f)?parseInt(f):0,i=Date.now()+30*60*1000,h=this;this.clearSessionContext();if(s){h.mHeaders["SAP-ContextId"]=s;if(t>=60){this.iSessionTimer=setInterval(function(){if(Date.now()>=i){h.clearSessionContext(true);}else{q.ajax(h.sServiceUrl+h.sQueryParams,{method:"HEAD",headers:{"SAP-ContextId":h.mHeaders["SAP-ContextId"]}}).fail(function(j){if(j.getResponseHeader("SAP-Err-Id")==="ICMENOSESSION"){L.error("Session not found on server",undefined,C);h.clearSessionContext(true);}});}},(t-5)*1000);}else if(f!==null){L.warning("Unsupported SAP-Http-Session-Timeout header",f,C);}}};
R.prototype.submitBatch=function(G){var f,p,t=this;p=S.all(this.aLockedGroupLocks.map(function(o){return o.waitFor(G);}));f=p.isPending();if(f){L.info("submitBatch('"+G+"') is waiting for locks",null,C);}return p.then(function(){if(f){L.info("submitBatch('"+G+"') continues",null,C);}t.aLockedGroupLocks=t.aLockedGroupLocks.filter(function(o){return o.isLocked();});return t.processBatch(G);});};
R.prototype.waitForRunningChangeRequests=function(G){return this.mRunningChangeRequests[G]||S.resolve();};
d={cleanBatch:function(f){f.forEach(function(o){if(Array.isArray(o)){d.cleanBatch(o);}else{o.body=d.cleanPayload(o.body);}});return f;},cleanPayload:function(p){var o=p;if(o){Object.keys(o).forEach(function(k){if(k.startsWith("@$ui5.")){if(o===p){o=Object.assign({},p);}delete o[k];}});}return o;},create:function(s,m,h,Q,o){var f=new R(s,h,Q,m);if(o==="2.0"){c(f);}return f;}};return d;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_V2MetadataConverter',["./_Helper","./_MetadataConverter","sap/base/Log"],function(_,a,L){"use strict";var c="sap.ui.model.odata.v4.lib._V2MetadataConverter",r=/^(?:DELETE|GET|MERGE|PATCH|POST|PUT)$/,e="http://schemas.microsoft.com/ado/2007/06/edmx",m="http://schemas.microsoft.com/ado/2007/08/dataservices/metadata",s="http://www.sap.com/Protocols/SAPData",v={"creatable":{"property":"Insertable","term":"@Org.OData.Capabilities.V1.InsertRestrictions"},"deletable":{"property":"Deletable","term":"@Org.OData.Capabilities.V1.DeleteRestrictions"},"deletable-path":{"property":"Deletable","term":"@Org.OData.Capabilities.V1.DeleteRestrictions"},"field-control":{"term":"@com.sap.vocabularies.Common.v1.FieldControl"},"heading":{"term":"@com.sap.vocabularies.Common.v1.Heading"},"label":{"term":"@com.sap.vocabularies.Common.v1.Label"},"precision":{"term":"@Org.OData.Measures.V1.Scale"},"quickinfo":{"term":"@com.sap.vocabularies.Common.v1.QuickInfo"},"requires-filter":{"property":"RequiresFilter","term":"@Org.OData.Capabilities.V1.FilterRestrictions"},"searchable":{"property":"Searchable","term":"@Org.OData.Capabilities.V1.SearchRestrictions"},"text":{"term":"@com.sap.vocabularies.Common.v1.Text"},"topable":{"term":"@Org.OData.Capabilities.V1.TopSupported"},"updatable":{"property":"Updatable","term":"@Org.OData.Capabilities.V1.UpdateRestrictions"},"updatable-path":{"property":"Updatable","term":"@Org.OData.Capabilities.V1.UpdateRestrictions"}},V={"bday":{TermName:"Contact"},"city":{Path:"adr",TermName:"Contact",V4Attribute:"locality"},"country":{Path:"adr",TermName:"Contact"},"email":{Path:"address",TermName:"Contact",V4Attribute:"uri",typeMapping:{"home":"home","pref":"preferred","work":"work"},v4EnumType:"com.sap.vocabularies.Communication.v1.ContactInformationType",v4PropertyAnnotation:"@com.sap.vocabularies.Communication.v1.IsEmailAddress"},"familyname":{Path:"n",TermName:"Contact",V4Attribute:"surname"},"givenname":{Path:"n",TermName:"Contact",V4Attribute:"given"},"honorific":{Path:"n",TermName:"Contact",V4Attribute:"prefix"},"middlename":{Path:"n",TermName:"Contact",V4Attribute:"additional"},"name":{TermName:"Contact",V4Attribute:"fn"},"nickname":{TermName:"Contact"},"note":{TermName:"Contact"},"org":{TermName:"Contact"},"org-role":{TermName:"Contact",V4Attribute:"role"},"org-unit":{TermName:"Contact",V4Attribute:"orgunit"},"photo":{TermName:"Contact"},"pobox":{Path:"adr",TermName:"Contact"},"region":{Path:"adr",TermName:"Contact"},"street":{Path:"adr",TermName:"Contact"},"suffix":{Path:"n",TermName:"Contact"},"tel":{Path:"tel",TermName:"Contact",V4Attribute:"uri",typeMapping:{"cell":"cell","fax":"fax","home":"home","pref":"preferred","video":"video","voice":"voice","work":"work"},v4EnumType:"com.sap.vocabularies.Communication.v1.PhoneType",v4PropertyAnnotation:"@com.sap.vocabularies.Communication.v1.IsPhoneNumber"},"title":{TermName:"Contact"},"zip":{Path:"adr",TermName:"Contact",V4Attribute:"code"},"class":{TermName:"Event"},"dtend":{TermName:"Event"},"dtstart":{TermName:"Event"},"duration":{TermName:"Event"},"fbtype":{TermName:"Event"},"location":{TermName:"Event"},"status":{TermName:"Event"},"transp":{TermName:"Event"},"wholeday":{TermName:"Event"},"body":{TermName:"Message"},"from":{TermName:"Message"},"received":{TermName:"Message"},"sender":{TermName:"Message"},"subject":{TermName:"Message"},"completed":{TermName:"Task"},"due":{TermName:"Task"},"percent-complete":{TermName:"Task",V4Attribute:"percentcomplete"},"priority":{TermName:"Task"}},b={"fiscalyear":"@com.sap.vocabularies.Common.v1.IsFiscalYear","fiscalyearperiod":"@com.sap.vocabularies.Common.v1.IsFiscalYearPeriod","year":"@com.sap.vocabularies.Common.v1.IsCalendarYear","yearmonth":"@com.sap.vocabularies.Common.v1.IsCalendarYearMonth","yearmonthday":"@com.sap.vocabularies.Common.v1.IsCalendarDate","yearquarter":"@com.sap.vocabularies.Common.v1.IsCalendarYearQuarter","yearweek":"@com.sap.vocabularies.Common.v1.IsCalendarYearWeek","url":"@Org.OData.Core.V1.IsURL"};
function A(C,t){var p=C.oAnnotatable;if(p){t=_.buildPath(p.sPath,t);}this.oConverter=C;this.sPath=t;this.oParent=p;this.mSapAttributes=C.mSapAttributes;this.mAnnotationsForTarget=null;}
A.prototype.annotate=function(t,g){this.getTarget()[t]=g;};
A.prototype.consume=function(n){return this.oConverter.consumeSapAnnotation(n);};
A.prototype.convert=function(g,h){var o,i;if(h===undefined||h===""){return;}i=v[g];if(i.property){o=this.getOrCreateAnnotationRecord(i.term);o[i.property]=h;}else{this.annotate(i.term,h);}};
A.prototype.getOrCreateAnnotationRecord=function(t){return this.oConverter.getOrCreateObject(this.getTarget(),t);};
A.prototype.getTarget=function(){if(!this.mAnnotationsForTarget){this.mAnnotationsForTarget=this.oConverter.convertedV2Annotations[this.sPath]={};}return this.mAnnotationsForTarget;};
A.prototype.peek=function(n){return this.oConverter.mSapAnnotations[n];};
function d(){this.association=null;this.associations={};this.associationSet=null;this.associationSets=[];this.aBoundOperations=[];this.constraintRole=null;this.convertedV2Annotations={};this.defaultEntityContainer=null;this.mEntityContainersOfSchema={};this.mEntityType2EntitySetAnnotation={};this.mProperty2Semantics={};this.sPropertyName=null;this.navigationProperties=[];this.mSapAnnotations={};this.sTypeName=null;this.mProperty2Unit={};a.call(this);}
d.prototype=Object.create(a.prototype);
d.prototype.collectSapAnnotations=function(E){var o,g=E.attributes,i,n;this.mSapAnnotations={};for(i=0,n=g.length;i<n;i+=1){o=g.item(i);if(o.namespaceURI===s&&o.localName!=="content-version"){this.mSapAnnotations[o.localName]=o.value;}}};
d.prototype.consumeSapAnnotation=function(n){var g=this.mSapAnnotations[n];delete this.mSapAnnotations[n];return g;};
d.prototype.convertEntitySetAnnotation=function(o,n){var C,g;switch(n){case"creatable":case"deletable":case"updatable":if(o.peek(n)==="false"){o.convert(n,false);}break;case"deletable-path":case"updatable-path":C=n.slice(0,9);g=o.consume(n);if(o.peek(C)){o.convert(n,false);L.warning("Inconsistent metadata in '"+this.url+"'","Use either 'sap:"+C+"' or 'sap:"+C+"-path'"+" at entity set '"+o.sPath+"'",c);}else{o.convert(n,{$Path:g});}break;case"label":this.convertLabel(o);break;case"pageable":g=o.consume(n);if(g==="false"){o.annotate("@Org.OData.Capabilities.V1.SkipSupported",false);o.annotate("@Org.OData.Capabilities.V1.TopSupported",false);}break;case"requires-filter":g=o.consume(n);if(g==="true"){o.convert(n,true);}break;case"topable":g=o.consume(n);if(g==="false"){o.convert(n,false);}break;default:}};
d.prototype.convertLabel=function(o){o.convert("label",o.consume("label"));};
d.prototype.convertPropertyAnnotation=function(o,n){var g;switch(n){case"heading":case"label":case"quickinfo":o.convert(n,o.consume(n));break;case"field-control":case"precision":case"text":o.convert(n,{$Path:o.consume(n)});break;case"aggregation-role":g=o.consume(n);if(g==="dimension"){o.annotate("@com.sap.vocabularies.Analytics.v1.Dimension",true);}else if(g==="measure"){o.annotate("@com.sap.vocabularies.Analytics.v1.Measure",true);}break;case"display-format":g=o.consume(n);if(g==="NonNegative"){o.annotate("@com.sap.vocabularies.Common.v1.IsDigitSequence",true);}else if(g==="UpperCase"){o.annotate("@com.sap.vocabularies.Common.v1.IsUpperCase",true);}break;case"semantics":this.convertPropertySemanticsAnnotation(o);break;case"unit":this.mProperty2Unit[o.sPath]=o.consume("unit");break;case"visible":g=o.consume(n);if(g==="false"){o.annotate("@com.sap.vocabularies.UI.v1.Hidden",true);o.annotate("@com.sap.vocabularies.Common.v1.FieldControl",{$EnumMember:"com.sap.vocabularies.Common.v1.FieldControlType/Hidden"});}break;default:}};
d.prototype.convertPropertySemanticsAnnotation=function(o){var g,E,p,R,S,h=o.peek("semantics").split(";"),i=h[0],j=V[i];if(i==="unit-of-measure"||i==="currency-code"){this.mProperty2Semantics[o.sPath]=o.consume("semantics");}else if(b[i]){o.annotate(b[i],true);o.consume("semantics");}else if(j){p={"$Path":this.sPropertyName};g=o.oParent.getOrCreateAnnotationRecord("@com.sap.vocabularies.Communication.v1."+j.TermName);if(j.Path){S=this.getOrCreateObject(g,j.Path);S[j.V4Attribute||i]=p;if(j.v4PropertyAnnotation){o.annotate(j.v4PropertyAnnotation,true);if(h[1]){R=[];E=h[1].split("=")[1];E.split(",").forEach(function(t){var T=j.typeMapping[t];if(T){R.push(j.v4EnumType+"/"+T);}else{L.warning("Unsupported semantic type: "+t,undefined,c);}});if(R.length>0){S.type={"EnumMember":R.join(" ")};}}g[j.Path]=[S];}else{g[j.Path]=S;}}else{g[j.V4Attribute||i]=p;}o.consume("semantics");}};
d.prototype.finalize=function(){this.result.$Version="4.0";this.setDefaultEntityContainer();this.updateNavigationPropertiesAndCreateBindings();this.processBoundOperations();this.processUnitConversion();};
d.prototype.mergeAnnotations=function(C,g){var h;for(h in C){if(h in g){g[h]=Object.assign(C[h],g[h]);}else{g[h]=C[h];}}};
d.prototype.postProcessSchema=function(E,R){var g,o,h,i,j,t;for(h in this.mEntityContainersOfSchema){o=this.mEntityContainersOfSchema[h];for(j in o){i=o[j];if(i.$kind!=="EntitySet"){continue;}t=h+"/"+j;g=_.merge(this.convertedV2Annotations[t]||{},this.mEntityType2EntitySetAnnotation[i.$Type]);if(Object.keys(g).length){this.convertedV2Annotations[t]=g;}}}if(this.schema.$Annotations){this.mergeAnnotations(this.convertedV2Annotations,this.schema.$Annotations);}else if(Object.keys(this.convertedV2Annotations).length>0){this.schema.$Annotations=this.convertedV2Annotations;}this.convertedV2Annotations={};this.mEntityContainersOfSchema={};};
d.prototype.processAssociation=function(E){var n=this.namespace+E.getAttribute("Name");this.associations[n]=this.association={referentialConstraint:null,roles:{}};};
d.prototype.processAssociationEnd=function(E){var n=E.getAttribute("Role");this.association.roles[n]={multiplicity:E.getAttribute("Multiplicity"),propertyName:undefined,typeName:this.resolveAlias(E.getAttribute("Type"))};};
d.prototype.processAssociationSet=function(E){var o={associationName:this.resolveAlias(E.getAttribute("Association")),ends:[],entityContainer:this.entityContainer};this.associationSet=o;this.associationSets.push(o);this.consumeSapAnnotation("creatable");this.consumeSapAnnotation("deletable");this.consumeSapAnnotation("updatable");};
d.prototype.processAssociationSetEnd=function(E){this.associationSet.ends.push({entitySetName:E.getAttribute("EntitySet"),roleName:E.getAttribute("Role")});};
d.prototype.processComplexType=function(E){this.processType(E,{"$kind":"ComplexType"});};
d.prototype.processDataServices=function(E){if(E.getAttributeNS(m,"DataServiceVersion")!=="2.0"){throw new Error(this.url+": expected DataServiceVersion=\"2.0\": "+f(E));}};
d.prototype.processDependent=function(E){var C=this.association.referentialConstraint;this.constraintRole=C.dependent={roleName:E.getAttribute("Role")};};
d.prototype.processElement=function(E,p){this.collectSapAnnotations(E);if(p){p.call(this,E);}this.warnUnsupportedSapAnnotations(E);};
d.prototype.processEntityContainer=function(E){var q=this.namespace+E.getAttribute("Name");this.mEntityContainersOfSchema[q]=this.entityContainer={"$kind":"EntityContainer"};this.addToResult(q,this.entityContainer);if(E.getAttributeNS(m,"IsDefaultEntityContainer")==="true"){this.defaultEntityContainer=q;}this.v2annotatable(q);};
d.prototype.processEntitySet=function(E){var o,n=E.getAttribute("Name");this.entityContainer[n]=this.entitySet={$kind:"EntitySet",$Type:this.resolveAlias(E.getAttribute("EntityType"))};o=this.v2annotatable(n,this.convertEntitySetAnnotation);o.consume("creatable");o.consume("deletable");o.consume("updatable");if(o.consume("searchable")!=="true"){o.convert("searchable",false);}};
d.prototype.processEntityType=function(E){var t={$kind:"EntityType"},g=this;this.processType(E,t);this.processAttributes(E,t,{"Abstract":this.setIfTrue,"BaseType":function(T){return T?g.resolveAlias(T):undefined;}});this.convertLabel(this.oAnnotatable);};
d.prototype.processEntityTypeKeyPropertyRef=function(E){var n=E.getAttribute("Name");this.getOrCreateArray(this.type,"$Key").push(n);};
d.prototype.processFacetAttributes=function(E,R){var t=this;this.processAttributes(E,R,{"DefaultValue":this.setValue,"MaxLength":function(g){return g==="Max"?undefined:t.setNumber(g);},"Nullable":this.setIfFalse,"Precision":this.setNumber,"Scale":this.setNumber,"Unicode":this.setIfFalse});if(E.getAttribute("FixedLength")==="false"){R.$Scale="variable";}};
d.prototype.processFunctionImport=function(E){var g,h=E.getAttributeNS(m,"HttpMethod"),k=h!=="GET"?"Action":"Function",l,n=E.getAttribute("Name"),o={$kind:k},O={$kind:k+"Import"},q=this.namespace+n,R=E.getAttribute("ReturnType"),i;O["$"+k]=q;this.processAttributes(E,O,{"EntitySet":this.setValue});if(R){o.$ReturnType=i={};this.processTypedCollection(R,i);}if(!r.test(h)){L.warning("Unsupported HttpMethod at FunctionImport '"+n+"', removing this FunctionImport",undefined,c);this.consumeSapAnnotation("action-for");this.consumeSapAnnotation("applicable-path");}else{if(h!=="GET"&&h!=="POST"){o.$v2HttpMethod=h;}this.addToResult(q,[o]);g=this.consumeSapAnnotation("action-for");if(g){o.$IsBound=true;o.$Parameter=[{"$Name":null,"$Nullable":false,"$Type":this.resolveAlias(g)}];this.aBoundOperations.push(o);this.consumeSapAnnotation("applicable-path");l=this.consumeSapAnnotation("label");if(l){o[v["label"].term]=l;}}else{this.entityContainer[n]=O;this.v2annotatable(n);this.convertLabel(this.oAnnotatable);}}this.oOperation=o;};
d.prototype.processParameter=function(E){var l,o=this.oOperation,p={$Name:E.getAttribute("Name")};this.processFacetAttributes(E,p);this.processTypedCollection(E.getAttribute("Type"),p);this.getOrCreateArray(o,"$Parameter").push(p);l=this.consumeSapAnnotation("label");if(l){p[v["label"].term]=l;}};
d.prototype.processPrincipal=function(E){var C=this.association.referentialConstraint;this.constraintRole=C.principal={roleName:E.getAttribute("Role")};};
d.prototype.processReferentialConstraint=function(E){this.association.referentialConstraint={};};
d.prototype.processReferentialConstraintPropertyRef=function(E){this.constraintRole.propertyRef=E.getAttribute("Name");};
d.prototype.processSchema=function(E){var S=this.consumeSapAnnotation("schema-version");this.namespace=E.getAttribute("Namespace")+".";this.schema={"$kind":"Schema"};this.addToResult(this.namespace,this.schema);if(S){this.schema["@Org.Odata.Core.V1.SchemaVersion"]=S;}};
d.prototype.processType=function(E,t){var q=this.namespace+E.getAttribute("Name");this.sTypeName=q;this.type=t;this.addToResult(q,t);this.v2annotatable(q);};
d.prototype.processTypedCollection=function(t,p){var M=this.rCollection.exec(t);if(M){p.$isCollection=true;t=M[1];}if(t.indexOf(".")<0){t="Edm."+t;}switch(t){case"Edm.DateTime":p.$v2Type=t;if(this.mSapAnnotations["display-format"]==="Date"){t="Edm.Date";delete p.$Precision;}else{t="Edm.DateTimeOffset";}break;case"Edm.Float":p.$v2Type=t;t="Edm.Single";break;case"Edm.Time":p.$v2Type=t;t="Edm.TimeOfDay";break;default:t=this.resolveAlias(t);}p.$Type=t;};
d.prototype.processTypeNavigationProperty=function(E){var C=this.consumeSapAnnotation("creatable"),g=this.consumeSapAnnotation("creatable-path"),F=this.consumeSapAnnotation("filterable"),o,h,n=E.getAttribute("Name"),N,p={$kind:"NavigationProperty"},t=this;function i(T,P,j){h=t.getOrCreateObject(t.mEntityType2EntitySetAnnotation,t.sTypeName);h=t.getOrCreateObject(h,T);h=t.getOrCreateArray(h,P);h.push(j);}this.type[n]=p;this.navigationProperties.push({associationName:this.resolveAlias(E.getAttribute("Relationship")),fromRoleName:E.getAttribute("FromRole"),property:p,propertyName:n,toRoleName:E.getAttribute("ToRole")});this.v2annotatable(n);if(C){N={"$NavigationPropertyPath":n};if(g){L.warning("Inconsistent metadata in '"+this.url+"'","Use either 'sap:creatable' or 'sap:creatable-path' at navigation property '"+this.oAnnotatable.sPath+"'",c);}else if(C==="true"){N=null;}}else if(g){N={"$If":[{"$Not":{"$Path":g}},{"$NavigationPropertyPath":n}]};}if(N){i("@Org.OData.Capabilities.V1.InsertRestrictions","NonInsertableNavigationProperties",N);}if(F==="false"){o={"NavigationProperty":{"$NavigationPropertyPath":n},"FilterRestrictions":{"Filterable":false}};i("@Org.OData.Capabilities.V1.NavigationRestrictions","RestrictedProperties",o);}};
d.prototype.processTypeProperty=function(E){var o,g,F,h,n=E.getAttribute("Name"),p={"$kind":"Property"},t=this;function i(T,P,j){if(t.type.$kind==="EntityType"){h=t.getOrCreateObject(t.mEntityType2EntitySetAnnotation,t.sTypeName);h=t.getOrCreateObject(h,T);h=t.getOrCreateArray(h,P);h.push({"$PropertyPath":n});}else{L.warning("Unsupported SAP annotation at a complex type in '"+t.url+"'","sap:"+j+" at property '"+o.sPath+"'",c);}}this.sPropertyName=n;this.type[n]=p;this.processFacetAttributes(E,p);this.processTypedCollection(E.getAttribute("Type"),p);o=this.v2annotatable(n,this.convertPropertyAnnotation);if(o.consume("updatable")==="false"){if(o.consume("creatable")==="false"){o.annotate("@Org.OData.Core.V1.Computed",true);}else{o.annotate("@Org.OData.Core.V1.Immutable",true);}}if(o.consume("filterable")==="false"){i("@Org.OData.Capabilities.V1.FilterRestrictions","NonFilterableProperties","filterable");}F=o.consume("filter-restriction");if(F){switch(F){case"interval":g="SingleInterval";break;case"multi-value":g="MultiValue";break;case"single-value":g="SingleValue";break;default:L.warning("Inconsistent metadata in '"+this.url+"'","Unsupported sap:filter-restriction=\""+F+"\" at property '"+o.sPath+"'",c);}if(g){if(this.type.$kind==="EntityType"){h=this.getOrCreateObject(this.mEntityType2EntitySetAnnotation,this.sTypeName);h=this.getOrCreateArray(h,"@com.sap.vocabularies.Common.v1.FilterExpressionRestrictions");h.push({"AllowedExpressions":{"EnumMember":"com.sap.vocabularies.Common.v1.FilterExpressionType/"+g},"Property":{"$PropertyPath":n}});}else{L.warning("Unsupported SAP annotation at a complex type in '"+this.url+"'","sap:filter-restriction at property '"+o.sPath+"'",c);}}}if(o.consume("required-in-filter")==="true"){i("@Org.OData.Capabilities.V1.FilterRestrictions","RequiredProperties","required-in-filter");}if(o.consume("sortable")==="false"){i("@Org.OData.Capabilities.V1.SortRestrictions","NonSortableProperties","sortable");}};
d.prototype.processBoundOperations=function(){var t=this;this.aBoundOperations.forEach(function(o){var E=t.result[o.$Parameter[0].$Type];E.$Key.forEach(function(k){o.$Parameter.some(function(p,i){if(p.$Name===k){o.$Parameter.splice(i,1);return true;}});});});};
d.prototype.processUnitConversion=function(){var t=this;Object.keys(this.mProperty2Unit).forEach(function(p){var h,T,g=p.split("/")[0],u,U=t.mProperty2Unit[p],j=U.split("/"),o,k,i,n=j.length;for(i=0;i<n;i+=1){T=t.result[g];o=T[j[i]];if(!o){L.warning("Path '"+U+"' for sap:unit cannot be resolved",p,c);return;}if(i<n-1){g=o.$Type;}}k=t.mProperty2Semantics[g+"/"+j[n-1]];if(!k){L.warning("Unsupported sap:semantics at sap:unit='"+U+"'; expected 'currency-code' or 'unit-of-measure'",p,c);return;}u=k==="currency-code"?"ISOCurrency":"Unit";u="@Org.OData.Measures.V1."+u;h=t.getOrCreateObject(t.result[_.namespace(p)+"."],"$Annotations");h=t.getOrCreateObject(h,p);if(!(u in h)){h[u]={"$Path":U};}});};
function f(E){var o,g=E.attributes,t="<"+E.nodeName,i,n;for(i=0,n=g.length;i<n;i+=1){o=g.item(i);t+=" "+o.name+'="'+o.value+'"';}return t+(E.childNodes.length?">":"/>");}
d.prototype.setDefaultEntityContainer=function(){var D=this.defaultEntityContainer,E,R=this.result;if(D){R.$EntityContainer=D;}else{E=Object.keys(R).filter(function(q){return R[q].$kind==="EntityContainer";});if(E.length===1){R.$EntityContainer=E[0];}}};
d.prototype.updateNavigationPropertiesAndCreateBindings=function(){var t=this;this.navigationProperties.forEach(function(n){var o=t.associations[n.associationName],C=o.referentialConstraint,N=n.property,T=o.roles[n.toRoleName];N.$Type=T.typeName;T.propertyName=n.propertyName;if(T.multiplicity==="1"){N.$Nullable=false;}if(T.multiplicity==="*"){N.$isCollection=true;}if(C&&C.principal.roleName===n.toRoleName){N.$ReferentialConstraint={};N.$ReferentialConstraint[C.dependent.propertyRef]=C.principal.propertyRef;}});this.associationSets.forEach(function(o){var g=t.associations[o.associationName],E=o.entityContainer;function h(i,j){var k=E[i.entitySetName],T=g.roles[j.roleName];if(T.propertyName){k.$NavigationPropertyBinding=k.$NavigationPropertyBinding||{};k.$NavigationPropertyBinding[T.propertyName]=j.entitySetName;}}h(o.ends[0],o.ends[1]);h(o.ends[1],o.ends[0]);});};
d.prototype.v2annotatable=function(n,p){var o=new A(this,n);this.oAnnotatable=o;if(p){p=p.bind(this);Object.keys(this.mSapAnnotations).forEach(function(n){p(o,n);});}return o;};
d.prototype.warnUnsupportedSapAnnotations=function(E){Object.keys(this.mSapAnnotations).forEach(function(n){L.warning("Unsupported annotation 'sap:"+n+"'",f(E),c);});};
(function($){var S;$.sRootNamespace=e;$.oAliasConfig={"Reference":{__xmlns:a.sEdmxNamespace,"Include":{__processor:$.processAlias}},"DataServices":{"Schema":{__processor:$.processAlias}}};S={"NavigationProperty":{__processor:$.processTypeNavigationProperty},"Property":{__processor:$.processTypeProperty}};$.oFullConfig={__include:[$.oReferenceInclude],"DataServices":{__processor:$.processDataServices,"Schema":{__postProcessor:$.postProcessSchema,__processor:$.processSchema,__include:[$.oAnnotationsConfig],"Association":{__processor:$.processAssociation,"End":{__processor:$.processAssociationEnd},"ReferentialConstraint":{__processor:$.processReferentialConstraint,"Dependent":{__processor:$.processDependent,"PropertyRef":{__processor:$.processReferentialConstraintPropertyRef}},"Principal":{__processor:$.processPrincipal,"PropertyRef":{__processor:$.processReferentialConstraintPropertyRef}}}},"ComplexType":{__processor:$.processComplexType,__include:[S]},"EntityContainer":{__processor:$.processEntityContainer,"AssociationSet":{__processor:$.processAssociationSet,"End":{__processor:$.processAssociationSetEnd}},"EntitySet":{__processor:$.processEntitySet},"FunctionImport":{__processor:$.processFunctionImport,"Parameter":{__processor:$.processParameter}}},"EntityType":{__processor:$.processEntityType,__include:[S],"Key":{"PropertyRef":{__processor:$.processEntityTypeKeyPropertyRef}}}}}};})(d.prototype);return d;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_V2Requestor',["./_Helper","./_Parser","sap/ui/core/CalendarType","sap/ui/core/format/DateFormat","sap/ui/model/odata/ODataUtils"],function(_,a,C,D,O){"use strict";var r=/^\/Date\((-?\d+)\)\/$/,d,b=/^\/Date\((-?\d+)(?:([-+])(\d\d)(\d\d))?\)\/$/,o,p={},c=/\+/g,e=/^([^(]+)(\(.+\))$/,f=/\//g,g=/^PT(?:(?:(\d+)H)?(?:(\d+)M)?(?:(\d+)(\.\d+)?S)?)$/i,t;
function h(){}
h.prototype.mFinalHeaders={"Content-Type":"application/json;charset=UTF-8"};h.prototype.mPredefinedPartHeaders={"Accept":"application/json"};h.prototype.mPredefinedRequestHeaders={"Accept":"application/json","MaxDataServiceVersion":"2.0","DataServiceVersion":"2.0","X-CSRF-Token":"Fetch"};h.prototype.mReservedHeaders={accept:true,"content-id":true,"content-transfer-encoding":true,"content-type":true,dataserviceversion:true,"if-match":true,"if-none-match":true,maxdataserviceversion:true,"sap-contextid":true,"x-http-method":true};
h.prototype.convertBinary=function(v){return v.replace(c,"-").replace(f,"_");};
h.prototype.convertDate=function(v){var i,m=r.exec(v);if(!m){throw new Error("Not a valid Edm.DateTime value '"+v+"'");}i=new Date(parseInt(m[1]));if(Number(m[1]%(24*60*60*1000))!==0){throw new Error("Cannot convert Edm.DateTime value '"+v+"' to Edm.Date because it contains a time of day");}return d.format(i);};
h.prototype.convertDateTimeOffset=function(v,P){var m=b.exec(v),s,i,k,l,n="yyyy-MM-dd'T'HH:mm:ss",q=P.$Precision,T;if(!m){throw new Error("Not a valid Edm.DateTimeOffset value '"+v+"'");}T=parseInt(m[1]);i=parseInt(m[3]);k=parseInt(m[4]);if(!m[2]||i===0&&k===0){s="Z";}else{l=m[2]==="-"?-1:1;T+=l*(i*60*60*1000+k*60*1000);s=m[2]+m[3]+":"+m[4];}if(q>0){n+="."+"".padEnd(q,"S");}if(!p[n]){p[n]=D.getDateTimeInstance({calendarType:C.Gregorian,pattern:n,UTC:true});}return p[n].format(new Date(T))+s;};
h.prototype.convertDoubleSingle=function(v){switch(v){case"NaN":case"INF":case"-INF":return v;default:return parseFloat(v);}};
h.prototype.convertFilter=function(F,m){var i=a.parseFilter(F),k=this;function l(L,s){var M,T=q(s);if(T.$Type!=="Edm.String"){M=_.parseLiteral(L.value,T.$Type,T.path);L.value=k.formatPropertyAsLiteral(M,T);}}function n(N,M){throw new Error("Cannot convert filter to V2, "+M+" at "+N.at+": "+F);}function q(N){var P;if(N.type){return{$Type:N.type};}if(N.id==="PATH"){P=k.oModelInterface.fetchMetadata(m+"/"+N.value).getResult();if(!P){throw new Error("Invalid filter path: "+N.value);}return{path:N.value,$Type:P.$Type,$v2Type:P.$v2Type};}return q(N.parameters[0]);}function v(N){if(N){if(N.id==="VALUE"&&N.ambiguous){n(N,"ambiguous type for the literal");}v(N.left);v(N.right);if(N.parameters){if(N.value==="contains"){N.value="substringof";N.parameters.push(N.parameters.shift());}N.parameters.forEach(v);}if(N.left&&N.right){if(N.left.id==="VALUE"){if(N.right.id==="VALUE"){n(N,"saw literals on both sides of '"+N.id+"'");}l(N.left,N.right);}else if(N.right.id==="VALUE"){l(N.right,N.left);}}}}v(i);return a.buildFilterString(i);};
h.prototype.convertKeyPredicate=function(v,P){var E=this.fetchTypeForPath(_.getMetaPath(P)).getResult(),k=a.parseKeyPredicate(decodeURIComponent(v)),i=this;function l(s,V){var m=E[s];if(m.$Type!=="Edm.String"){V=i.formatPropertyAsLiteral(_.parseLiteral(V,m.$Type,P),m);}return encodeURIComponent(V);}if(""in k){return"("+l(E.$Key[0],k[""])+")";}return"("+E.$Key.map(function(s){return encodeURIComponent(s)+"="+l(s,k[s]);}).join(",")+")";};
h.prototype.convertResourcePath=function(R){var I=R.indexOf("?"),q="",s,S=-1,k=this;if(I>0){q=R.slice(I);R=R.slice(0,I);}s=R.split("/");return s.map(function(l,i){var m=e.exec(l);S+=l.length+1;if(m){l=m[1]+k.convertKeyPredicate(m[2],"/"+R.slice(0,S));}return l;}).join("/")+q;};
h.prototype.convertTimeOfDay=function(v){var i,m=g.exec(v),T;if(!m){throw new Error("Not a valid Edm.Time value '"+v+"'");}T=Date.UTC(1970,0,1,m[1]||0,m[2]||0,m[3]||0);i=new Date(T);return t.format(i)+(m[4]||"");};
h.prototype.convertNonPrimitive=function(i){var P,T,s,v,k=this;if(Array.isArray(i.results)){i.results.forEach(function(I){k.convertNonPrimitive(I);});return i.results;}if(!i.__metadata||!i.__metadata.type){throw new Error("Cannot convert structured value without type information in "+"__metadata.type: "+JSON.stringify(i));}s=i.__metadata.type;T=k.getTypeForName(s);delete i.__metadata;for(P in i){v=i[P];if(v===null){continue;}if(typeof v==="object"){if(v.__deferred){delete i[P];}else{i[P]=this.convertNonPrimitive(v);}continue;}i[P]=this.convertPrimitive(v,T[P],s,P);}return i;};
h.prototype.convertPrimitive=function(v,P,T,s){switch(P&&P.$Type){case"Edm.Binary":return this.convertBinary(v);case"Edm.Date":return this.convertDate(v);case"Edm.DateTimeOffset":return this.convertDateTimeOffset(v,P);case"Edm.Boolean":case"Edm.Byte":case"Edm.Decimal":case"Edm.Guid":case"Edm.Int16":case"Edm.Int32":case"Edm.Int64":case"Edm.SByte":case"Edm.String":return v;case"Edm.Double":case"Edm.Single":return this.convertDoubleSingle(v);case"Edm.TimeOfDay":return this.convertTimeOfDay(v);default:throw new Error("Type '"+(P&&P.$Type)+"' of property '"+s+"' in type '"+T+"' is unknown; cannot convert value: "+v);}};
h.prototype.doCheckVersionHeader=function(G,R,v){var s=G("DataServiceVersion"),i=!s&&G("OData-Version");if(i){throw new Error("Expected 'DataServiceVersion' header with value '1.0' or '2.0' but "+"received 'OData-Version' header with value '"+i+"' in response for "+this.sServiceUrl+R);}if(!s){return;}s=s.split(";")[0];if(s==="1.0"||s==="2.0"){return;}throw new Error("Expected 'DataServiceVersion' header with value '1.0' or '2.0' but "+"received value '"+s+"' in response for "+this.sServiceUrl+R);};
h.prototype.doConvertResponse=function(R,m){var i,I,k,P,l,n=this;R=R.d;I=Array.isArray(R.results);if(!I&&!R.__metadata){k=Object.keys(R);i=R[k[0]];if(k.length===1){if(i===null){return{value:null};}else if(typeof i!=="object"){return{value:this.convertPrimitive(i,this.oModelInterface.fetchMetadata(m).getResult(),m,k[0])};}else if(i.__metadata){R=i;}}}if(I&&!R.results.length){P=[];}else if(I&&!R.results[0].__metadata){l=this.oModelInterface.fetchMetadata(m).getResult();P=R.results.map(function(v){return n.convertPrimitive(v,l,m,"");});}else{P=this.convertNonPrimitive(R);}if(I){P={value:P};if(R.__count){P["@odata.count"]=R.__count;}if(R.__next){P["@odata.nextLink"]=R.__next;}}return P;};
h.prototype.doConvertSystemQueryOptions=function(m,q,R,i,s){var S,k={},l=this;function n(v,E){if(!Array.isArray(v)){v=v.split(",");}v.forEach(function(w){var I=w.indexOf("/");if(I>=0&&w.indexOf(".")<0){w=w.slice(0,I);}k[_.buildPath(E,w)]=true;});}function u(E,v,P){if(!v||typeof v!=="object"){throw new Error("$expand must be a valid object");}Object.keys(v).forEach(function(w){var A=_.buildPath(P,w),x=v[w];E.push(A);if(typeof x==="object"){Object.keys(x).forEach(function(Q){switch(Q){case"$expand":u(E,x.$expand,A);break;case"$select":n(x.$select,A);break;default:throw new Error("Unsupported query option in $expand: "+Q);}});}if(!x.$select){k[A+"/*"]=true;}});return E;}Object.keys(q).forEach(function(N){var I=N[0]==='$',v=q[N];if(i&&I){return;}switch(N){case"$count":N="$inlinecount";v=v?"allpages":"none";break;case"$expand":v=u([],v,"");v=(s?v.sort():v).join(",");break;case"$orderby":break;case"$select":n(v);return;case"$filter":v=l.convertFilter(v,m);break;default:if(I){throw new Error("Unsupported system query option: "+N);}}R(N,v);});S=Object.keys(k);if(S.length>0){if(!q.$select){S.push("*");}R("$select",(s?S.sort():S).join(","));}};
h.prototype.formatPropertyAsLiteral=function(v,P){function i(k,V){var l=k.parse(V);if(!l){throw new Error("Not a valid "+P.$Type+" value: "+V);}return l;}if(v===null){return"null";}switch(P.$Type){case"Edm.Boolean":case"Edm.Byte":case"Edm.Decimal":case"Edm.Double":case"Edm.Guid":case"Edm.Int16":case"Edm.Int32":case"Edm.Int64":case"Edm.SByte":case"Edm.Single":case"Edm.String":break;case"Edm.Date":v=i(d,v);break;case"Edm.DateTimeOffset":v=i(o,v);break;case"Edm.TimeOfDay":v={__edmType:"Edm.Time",ms:i(t,v).getTime()};break;default:throw new Error("Type '"+P.$Type+"' in the key predicate is not supported");}return O.formatValue(v,P.$v2Type||P.$Type);};
h.prototype.getPathAndAddQueryOptions=function(P,i,m,q,E){var n,T,k=this;P=P.slice(1,-5);if(i.$IsBound){P=P.slice(P.lastIndexOf(".")+1);if(typeof E==="function"){E=E();}T=this.getTypeForName(i.$Parameter[0].$Type);T.$Key.forEach(function(n){q[n]=k.formatPropertyAsLiteral(E[n],T[n]);});}if(i.$Parameter){i.$Parameter.forEach(function(l){n=l.$Name;if(n in m){if(l.$isCollection){throw new Error("Unsupported collection-valued parameter: "+n);}q[n]=k.formatPropertyAsLiteral(m[n],l);delete m[n];}});}for(n in m){delete m[n];}if(i.$v2HttpMethod){m["X-HTTP-Method"]=i.$v2HttpMethod;}return P;};
h.prototype.getTypeForName=function(n){var T;this.mTypesByName=this.mTypesByName||{};T=this.mTypesByName[n];if(!T){T=this.mTypesByName[n]=this.oModelInterface.fetchMetadata("/"+n).getResult();}return T;};
h.prototype.isActionBodyOptional=function(){return true;};
h.prototype.isChangeSetOptional=function(){return false;};
h.prototype.ready=function(){return this.oModelInterface.fetchEntityContainer().then(function(){});};
function j(R){Object.assign(R,h.prototype);R.oModelInterface.reportBoundMessages=function(){};R.oModelInterface.reportUnboundMessages=function(){};}
j._setDateTimeFormatter=function(){d=D.getDateInstance({calendarType:C.Gregorian,pattern:"yyyy-MM-dd",UTC:true});o=D.getDateTimeInstance({calendarType:C.Gregorian,pattern:"yyyy-MM-dd'T'HH:mm:ss.SSSZ"});t=D.getTimeInstance({calendarType:C.Gregorian,pattern:"HH:mm:ss",UTC:true});};
j._setDateTimeFormatter();return j;},false);
sap.ui.predefine('sap/ui/model/odata/v4/lib/_V4MetadataConverter',["./_Helper","./_MetadataConverter"],function(_,a){"use strict";
function V(){this.enumType=null;this.enumTypeMemberCounter=0;this.navigationProperty=null;a.call(this);}
V.prototype=Object.create(a.prototype);
V.prototype.finalize=function(){if(this.result.$Version!=="4.0"){throw new Error(this.url+": Unsupported OData version "+this.result.$Version);}};
V.prototype.processActionOrFunction=function(e){var k=e.localName,o={$kind:k},O,p,q=this.namespace+e.getAttribute("Name"),s="",t=this;function g(P){var T={};t.processTypedCollection(P.getAttribute("Type"),T);return T.$isCollection?"Collection("+T.$Type+")":T.$Type;}this.processAttributes(e,o,{"IsBound":this.setIfTrue,"EntitySetPath":this.setValue,"IsComposable":this.setIfTrue});O=this.getOrCreateArray(this.result,q);if(!Array.isArray(O)){O=[];this.addToResult(q,O);}O.push(o);this.oOperation=o;if(o.$IsBound){p=e.getElementsByTagName("Parameter");s=e.localName==="Action"?g(p[0]):Array.prototype.map.call(p,g).join(",");}this.annotatable(q+"("+s+")");};
V.prototype.processComplexType=function(e){this.processType(e,{"$kind":"ComplexType"});};
V.prototype.processEdmx=function(e){this.processAttributes(e,this.result,{"Version":this.setValue});};
V.prototype.processElement=function(e,p){if(p){p.call(this,e);}};
V.prototype.processEntityContainer=function(e){var q=this.namespace+e.getAttribute("Name");this.entityContainer={"$kind":"EntityContainer"};this.addToResult(q,this.entityContainer);this.addToResult("$EntityContainer",q);this.annotatable(q);};
V.prototype.processEntitySet=function(e){var n=e.getAttribute("Name");this.entityContainer[n]=this.entitySet={$kind:"EntitySet",$Type:this.resolveAlias(e.getAttribute("EntityType"))};this.processAttributes(e,this.entitySet,{"IncludeInServiceDocument":this.setIfFalse});this.annotatable(n);};
V.prototype.processEntityType=function(e){this.processType(e,{$kind:"EntityType"});};
V.prototype.processEntityTypeKeyPropertyRef=function(e){var A=e.getAttribute("Alias"),k,n=e.getAttribute("Name");if(A){k={};k[A]=n;}else{k=n;}this.getOrCreateArray(this.type,"$Key").push(k);};
V.prototype.processEnumType=function(e){var q=this.namespace+e.getAttribute("Name"),E={"$kind":"EnumType"};this.processAttributes(e,E,{"IsFlags":this.setIfTrue,"UnderlyingType":function(v){return v!=="Edm.Int32"?v:undefined;}});this.enumType=E;this.addToResult(q,E);this.enumTypeMemberCounter=0;this.annotatable(q);};
V.prototype.processEnumTypeMember=function(e){var n=e.getAttribute("Name"),v=e.getAttribute("Value"),b;if(v){b=parseInt(v);if(!_.isSafeInteger(b)){b=v;}}else{b=this.enumTypeMemberCounter;this.enumTypeMemberCounter+=1;}this.enumType[n]=b;this.annotatable(n);};
V.prototype.processFacetAttributes=function(e,r){var t=this;this.processAttributes(e,r,{"MaxLength":function(v){return v==="max"?undefined:t.setNumber(v);},"Precision":this.setNumber,"Scale":function(v){return v==="variable"?v:t.setNumber(v);},"SRID":this.setValue,"Unicode":this.setIfFalse});};
V.prototype.processImport=function(e){var k=e.localName,i={$kind:k},n=e.getAttribute("Name"),t=this;k=k.replace("Import","");i["$"+k]=this.resolveAlias(e.getAttribute(k));this.processAttributes(e,i,{"EntitySet":function(v){return t.resolveTargetPath(v);},"IncludeInServiceDocument":this.setIfTrue});this.entityContainer[n]=i;this.annotatable(n);};
V.prototype.processNavigationPropertyBinding=function(e){var n=this.getOrCreateObject(this.entitySet,"$NavigationPropertyBinding");n[e.getAttribute("Path")]=this.resolveTargetPath(e.getAttribute("Target"));};
V.prototype.processParameter=function(e){var A=this.oOperation,p={};this.processTypedCollection(e.getAttribute("Type"),p);this.processAttributes(e,p,{"Name":this.setValue,"Nullable":this.setIfFalse});this.processFacetAttributes(e,p);this.getOrCreateArray(A,"$Parameter").push(p);this.annotatable(p.$Name);};
V.prototype.processReturnType=function(e){var A=this.oOperation,r={};this.processTypedCollection(e.getAttribute("Type"),r);this.processAttributes(e,r,{"Nullable":this.setIfFalse});this.processFacetAttributes(e,r);A.$ReturnType=r;this.annotatable("$ReturnType");};
V.prototype.processSchema=function(e){this.namespace=e.getAttribute("Namespace")+".";this.schema={"$kind":"Schema"};this.addToResult(this.namespace,this.schema);this.annotatable(this.schema);};
V.prototype.processSingleton=function(e){var n=e.getAttribute("Name");this.entityContainer[n]=this.entitySet={$kind:"Singleton",$Type:this.resolveAlias(e.getAttribute("Type"))};this.annotatable(n);};
V.prototype.processTerm=function(e){var q=this.namespace+e.getAttribute("Name"),t={$kind:"Term"},b=this;this.processTypedCollection(e.getAttribute("Type"),t);this.processAttributes(e,t,{"Nullable":this.setIfFalse,"BaseTerm":function(v){return v?b.resolveAlias(v):undefined;}});this.processFacetAttributes(e,t);this.addToResult(q,t);this.annotatable(q);};
V.prototype.processType=function(e,t){var q=this.namespace+e.getAttribute("Name"),b=this;this.processAttributes(e,t,{"OpenType":b.setIfTrue,"HasStream":b.setIfTrue,"Abstract":b.setIfTrue,"BaseType":function(T){return T?b.resolveAlias(T):undefined;}});this.type=t;this.addToResult(q,t);this.annotatable(q);};
V.prototype.processTypedCollection=function(t,p){var m=this.rCollection.exec(t);if(m){p.$isCollection=true;t=m[1];}p.$Type=this.resolveAlias(t);};
V.prototype.processTypeDefinition=function(e){var q=this.namespace+e.getAttribute("Name"),t={"$kind":"TypeDefinition","$UnderlyingType":e.getAttribute("UnderlyingType")};this.addToResult(q,t);this.processFacetAttributes(e,t);this.annotatable(q);};
V.prototype.processTypeNavigationProperty=function(e){var n=e.getAttribute("Name"),p={$kind:"NavigationProperty"};this.processTypedCollection(e.getAttribute("Type"),p);this.processAttributes(e,p,{"Nullable":this.setIfFalse,"Partner":this.setValue,"ContainsTarget":this.setIfTrue});this.type[n]=this.navigationProperty=p;this.annotatable(n);};
V.prototype.processTypeNavigationPropertyOnDelete=function(e){this.navigationProperty.$OnDelete=e.getAttribute("Action");this.annotatable(this.navigationProperty,"$OnDelete");};
V.prototype.processTypeNavigationPropertyReferentialConstraint=function(e){var p=e.getAttribute("Property"),r=this.getOrCreateObject(this.navigationProperty,"$ReferentialConstraint");r[p]=e.getAttribute("ReferencedProperty");this.annotatable(r,p);};
V.prototype.processTypeProperty=function(e){var n=e.getAttribute("Name"),p={"$kind":"Property"};this.processTypedCollection(e.getAttribute("Type"),p);this.processAttributes(e,p,{"Nullable":this.setIfFalse,"DefaultValue":this.setValue});this.processFacetAttributes(e,p);this.type[n]=p;this.annotatable(n);};
V.prototype.resolveTargetPath=function(p){var s;if(!p){return p;}p=this.resolveAliasInPath(p);s=p.indexOf("/");if(s>=0&&p.indexOf("/",s+1)<0){if(p.slice(0,s)===this.result.$EntityContainer){return p.slice(s+1);}}return p;};
(function($){var A,e,s;$.sRootNamespace=$.sEdmxNamespace;$.oAliasConfig={__xmlns:$.sEdmxNamespace,"Reference":{"Include":{__processor:$.processAlias}},"DataServices":{"Schema":{__xmlns:$.sEdmNamespace,__processor:$.processAlias}}};s={"Property":{__processor:$.processTypeProperty,__include:[$.oAnnotationConfig]},"NavigationProperty":{__processor:$.processTypeNavigationProperty,__include:[$.oAnnotationConfig],"OnDelete":{__processor:$.processTypeNavigationPropertyOnDelete,__include:[$.oAnnotationConfig]},"ReferentialConstraint":{__processor:$.processTypeNavigationPropertyReferentialConstraint,__include:[$.oAnnotationConfig]}}};e={"NavigationPropertyBinding":{__processor:$.processNavigationPropertyBinding}};A={"Parameter":{__processor:$.processParameter,__include:[$.oAnnotationConfig]},"ReturnType":{__processor:$.processReturnType,__include:[$.oAnnotationConfig]}};$.oFullConfig={__xmlns:$.sEdmxNamespace,__processor:$.processEdmx,__include:[$.oReferenceInclude],"DataServices":{"Schema":{__xmlns:$.sEdmNamespace,__processor:$.processSchema,__include:[$.oAnnotationsConfig,$.oAnnotationConfig],"Action":{__processor:$.processActionOrFunction,__include:[A,$.oAnnotationConfig]},"Function":{__processor:$.processActionOrFunction,__include:[A,$.oAnnotationConfig]},"EntityType":{__processor:$.processEntityType,__include:[s,$.oAnnotationConfig],"Key":{"PropertyRef":{__processor:$.processEntityTypeKeyPropertyRef}}},"ComplexType":{__processor:$.processComplexType,__include:[s,$.oAnnotationConfig]},"EntityContainer":{__processor:$.processEntityContainer,__include:[$.oAnnotationConfig],"ActionImport":{__processor:$.processImport,__include:[$.oAnnotationConfig]},"EntitySet":{__processor:$.processEntitySet,__include:[e,$.oAnnotationConfig]},"FunctionImport":{__processor:$.processImport,__include:[$.oAnnotationConfig]},"Singleton":{__processor:$.processSingleton,__include:[e,$.oAnnotationConfig]}},"EnumType":{__processor:$.processEnumType,__include:[$.oAnnotationConfig],"Member":{__processor:$.processEnumTypeMember,__include:[$.oAnnotationConfig]}},"Term":{__processor:$.processTerm,__include:[$.oAnnotationConfig]},"TypeDefinition":{__processor:$.processTypeDefinition,__include:[$.oAnnotationConfig]}}}};})(V.prototype);return V;},false);
sap.ui.predefine('sap/ui/model/resource/ResourceModel',['sap/ui/model/BindingMode','sap/ui/model/Model','./ResourcePropertyBinding',"sap/base/i18n/ResourceBundle","sap/base/Log"],function(B,M,R,a,L){"use strict";var r=/^(?:\/|\.)*/;
var b=M.extend("sap.ui.model.resource.ResourceModel",{constructor:function(d){var u;M.apply(this,arguments);this.aCustomBundles=[];this.bReenhance=false;this.bAsync=!!(d&&d.async);this.sDefaultBindingMode=d.defaultBindingMode||B.OneWay;this.mSupportedBindingModes={"OneWay":true,"TwoWay":false,"OneTime":!this.bAsync};if(this.bAsync&&this.sDefaultBindingMode==B.OneTime){L.warning("Using binding mode OneTime for asynchronous ResourceModel is not supported!");}this.oData=Object.assign({},d);u=Array.isArray(this.oData.enhanceWith)&&this.oData.enhanceWith.some(function(e){return e instanceof a;});if(d&&d.bundle){this._oResourceBundle=d.bundle;u=true;}else if(d&&(d.bundleUrl||d.bundleName)){if(u){delete this.oData.enhanceWith;if(d.terminologies||d.activeTerminologies){throw new Error("'terminologies' parameter and 'activeTerminologies' parameter are not"+" supported in configuration when enhanceWith contains ResourceBundles");}}_(this);}else{throw new Error("At least bundle, bundleName or bundleUrl must be provided!");}if(u&&Array.isArray(d.enhanceWith)){if(this.bAsync){this._pEnhanced=d.enhanceWith.reduce(function(c,e){return c.then(this.enhance.bind(this,e));}.bind(this),Promise.resolve());}else{d.enhanceWith.forEach(this.enhance.bind(this));}}}});
b._sanitizeBundleName=function(s){if(s&&(s[0]==="/"||s[0]===".")){L.error('Incorrect resource bundle name "'+s+'"','Leading slashes or dots in resource bundle names are ignored, since such names are'+' invalid UI5 module names. Please check whether the resource bundle "'+s+'" is actually needed by your application.',"sap.base.i18n.ResourceBundle");s=s.replace(r,"");}return s;};
b.loadResourceBundle=function(d,A){var c=sap.ui.getCore().getConfiguration(),l=d.bundleLocale,p;if(!l){l=c.getLanguage();}d.bundleName=b._sanitizeBundleName(d.bundleName);p=Object.assign({async:A,includeInfo:c.getOriginInfo(),locale:l},d);return a.create(p);};
b.prototype.enhance=function(d){var t=this,f,p=this.bAsync?new Promise(function(e){f=e;}):null;function c(){if(d instanceof a){t._oResourceBundle._enhance(d);t.checkUpdate(true);if(p){f(true);}}else{if(d.terminologies){throw new Error("'terminologies' parameter is not"+" supported for enhancement");}var e=b.loadResourceBundle(d,t.bAsync);if(e instanceof Promise){e.then(function(g){t._oResourceBundle._enhance(g);t.checkUpdate(true);f(true);},function(){f(true);});}else if(e){t._oResourceBundle._enhance(e);t.checkUpdate(true);}}}if(this._oPromise){Promise.resolve(this._oPromise).then(c);}else{c();}if(!this.bReenhance){this.aCustomBundles.push(d);}return p;};
b.prototype.bindProperty=function(p){return new R(this,p);};
b.prototype.getProperty=function(p){return this._oResourceBundle?this._oResourceBundle.getText(p):null;};
b.prototype.getResourceBundle=function(){if(!this.bAsync){return this._oResourceBundle;}else{var p=this._oPromise;if(p){return new Promise(function(c,d){function e(o){c(o);}p.then(e,e);});}else{return Promise.resolve(this._oResourceBundle);}}};
b.prototype._handleLocalizationChange=function(){_(this);};
b.prototype._reenhance=function(){this.bReenhance=true;this.aCustomBundles.forEach(function(d){this.enhance(d);}.bind(this));this.bReenhance=false;};
function _(m){var d=m.oData;if(d&&(d.bundleUrl||d.bundleName)){var c=b.loadResourceBundle(d,d.async);if(c instanceof Promise){var e={url:a._getUrl(d.bundleUrl,b._sanitizeBundleName(d.bundleName)),async:true};m.fireRequestSent(e);m._oPromise=c;m._oPromise.then(function(o){m._oResourceBundle=o;m._reenhance();delete m._oPromise;m.checkUpdate(true);m.fireRequestCompleted(e);});}else{m._oResourceBundle=c;m._reenhance();m.checkUpdate(true);}}}
return b;});
sap.ui.predefine('sap/ui/model/resource/ResourcePropertyBinding',['sap/ui/model/PropertyBinding','sap/ui/model/ChangeReason'],function(P,C){"use strict";
var R=P.extend("sap.ui.model.resource.ResourcePropertyBinding",{constructor:function(m,p){P.apply(this,arguments);this.oValue=this.oModel.getProperty(p);}});
R.prototype.getValue=function(){return this.oValue;};
R.prototype.checkUpdate=function(f){if(!this.bSuspended){var v=this.oModel.getProperty(this.sPath);if(f||v!=this.oValue){this.oValue=v;this._fireChange({reason:C.Change});}}};
return R;});
sap.ui.predefine('sap/ui/model/type/Boolean',['sap/ui/model/SimpleType','sap/ui/model/FormatException','sap/ui/model/ParseException'],function(S,F,P){"use strict";
var B=S.extend("sap.ui.model.type.Boolean",{constructor:function(){S.apply(this,arguments);this.sName="Boolean";}});
B.prototype.formatValue=function(v,i){if(v==undefined||v==null){return null;}switch(this.getPrimitiveType(i)){case"any":case"boolean":return v;case"string":return v.toString();default:throw new F("Don't know how to format Boolean to "+i);}};
B.prototype.parseValue=function(v,i){var b;switch(this.getPrimitiveType(i)){case"boolean":return v;case"string":if(v.toLowerCase()=="true"||v=="X"){return true;}if(v.toLowerCase()=="false"||v==""||v==" "){return false;}b=sap.ui.getCore().getLibraryResourceBundle();throw new P(b.getText("Boolean.Invalid"));default:throw new P("Don't know how to parse Boolean from "+i);}};
B.prototype.validateValue=function(){};
return B;});
sap.ui.predefine('sap/ui/model/type/Currency',["sap/base/Log",'sap/ui/core/format/NumberFormat','sap/ui/model/CompositeType','sap/ui/model/FormatException','sap/ui/model/ParseException','sap/ui/model/ValidateException',"sap/ui/thirdparty/jquery","sap/base/util/isEmptyObject"],function(L,N,C,F,P,V,q,i){"use strict";
var a=C.extend("sap.ui.model.type.Currency",{constructor:function(){C.apply(this,arguments);this.sName="Currency";this.bUseRawValues=true;}});
a.prototype.formatValue=function(v,t){var b=v;if(v==undefined||v==null){return null;}if(this.oInputFormat){b=this.oInputFormat.parse(v);}if(!Array.isArray(b)){throw new F("Cannot format currency: "+v+" has the wrong format");}if(b[0]==undefined||b[0]==null){return null;}switch(this.getPrimitiveType(t)){case"string":return this.oOutputFormat.format(b);default:throw new F("Don't know how to format currency to "+t);}};
a.prototype.parseValue=function(v,s){var r,b;switch(this.getPrimitiveType(s)){case"string":r=this.oOutputFormat.parse(v);if(!Array.isArray(r)||isNaN(r[0])){b=sap.ui.getCore().getLibraryResourceBundle();throw new P(b.getText("Currency.Invalid",[v]));}break;default:throw new P("Don't know how to parse Currency from "+s);}if(this.oInputFormat){r=this.oInputFormat.format(r);}return r;};
a.prototype.validateValue=function(v){if(this.oConstraints){var b=sap.ui.getCore().getLibraryResourceBundle(),c=[],m=[],d=v,e;if(this.oInputFormat){d=this.oInputFormat.parse(v);}e=d[0];q.each(this.oConstraints,function(n,o){switch(n){case"minimum":if(e<o){c.push("minimum");m.push(b.getText("Currency.Minimum",[o]));}break;case"maximum":if(e>o){c.push("maximum");m.push(b.getText("Currency.Maximum",[o]));}break;default:L.warning("Unknown constraint '"+n+"': Value is not validated.",null,"sap.ui.model.type.Currency");}});if(c.length>0){throw new V(this.combineMessages(m),c);}}};
a.prototype.setFormatOptions=function(f){this.oFormatOptions=f;this._createFormats();};
a.prototype._handleLocalizationChange=function(){this._createFormats();};
a.prototype._createFormats=function(){var s=this.oFormatOptions.source;this.oOutputFormat=N.getCurrencyInstance(this.oFormatOptions);if(s){if(i(s)){s={groupingEnabled:false,groupingSeparator:",",decimalSeparator:"."};}this.oInputFormat=N.getCurrencyInstance(s);}};
a.prototype.getPartsIgnoringMessages=function(){if(this.oFormatOptions.showMeasure===false){return[1];}return[];};
return a;});
sap.ui.predefine('sap/ui/model/type/Date',['sap/ui/core/format/DateFormat','sap/ui/model/SimpleType','sap/ui/model/FormatException','sap/ui/model/ParseException','sap/ui/model/ValidateException',"sap/ui/thirdparty/jquery","sap/base/util/isEmptyObject"],function(D,S,F,P,V,q,i){"use strict";
var a=S.extend("sap.ui.model.type.Date",{constructor:function(){S.apply(this,arguments);this.sName="Date";}});
a.prototype.formatValue=function(v,I){var f;switch(this.getPrimitiveType(I)){case"string":case"any":if(v==null){return"";}if(this.oFormatOptions.source&&this.oFormatOptions.source.pattern!=="timestamp"&&v===""){return"";}f=this.getModelFormat();v=f.parse(v);return this.oOutputFormat.format(v);default:throw new F("Don't know how to format Date to "+I);}};
a.prototype.parseValue=function(v,I){var r,b;switch(this.getPrimitiveType(I)){case"string":if(v===""){return null;}var r=this.oOutputFormat.parse(v);if(!r){b=sap.ui.getCore().getLibraryResourceBundle();throw new P(b.getText(this.sName+".Invalid"));}if(this.oInputFormat){if(this.oFormatOptions.source.pattern=="timestamp"){r=r.getTime();}else{r=this.oInputFormat.format(r);}}return r;default:throw new P("Don't know how to parse Date from "+I);}};
a.prototype.validateValue=function(v){if(this.oConstraints){var b=sap.ui.getCore().getLibraryResourceBundle(),c=[],m=[],I=this.oInputFormat,C,d=this;if(I&&this.oFormatOptions.source.pattern!="timestamp"){v=I.parse(v);}q.each(this.oConstraints,function(n,o){if(I){o=I.parse(o);}C=d.oOutputFormat.format(o);switch(n){case"minimum":if(v<o){c.push("minimum");m.push(b.getText(d.sName+".Minimum",[C]));}break;case"maximum":if(v>o){c.push("maximum");m.push(b.getText(d.sName+".Maximum",[C]));}break;}});if(c.length>0){throw new V(this.combineMessages(m),c);}}};
var t={format:function(v){if(v instanceof Date){return v.getTime();}return null;},parse:function(v){if(typeof(v)!="number"){if(isNaN(v)){throw new F("Cannot format date: "+v+" is not a valid Timestamp");}else{v=parseInt(v);}}v=new Date(v);return v;}};
a.prototype.getModelFormat=function(){if(this.oInputFormat){if(this.oFormatOptions.source.pattern=="timestamp"){return t;}else{return this.oInputFormat;}}else{return S.prototype.getModelFormat.call(this);}};
a.prototype.setFormatOptions=function(f){this.oFormatOptions=f;this._createFormats();};
a.prototype.getOutputPattern=function(){return this.oOutputFormat.oFormatOptions.pattern;};
a.prototype._handleLocalizationChange=function(){this._createFormats();};
a.prototype._createFormats=function(){var s=this.oFormatOptions.source;this.oOutputFormat=D.getInstance(this.oFormatOptions);if(s){if(i(s)){s={pattern:"yyyy-MM-dd"};}this.oInputFormat=D.getInstance(s);}};
return a;});
sap.ui.predefine('sap/ui/model/type/DateInterval',['sap/ui/core/format/DateFormat','sap/ui/model/CompositeType','sap/ui/model/FormatException','sap/ui/model/ParseException','sap/ui/model/ValidateException',"sap/base/util/isEmptyObject"],function(D,C,F,P,V,i){"use strict";
var a=C.extend("sap.ui.model.type.DateInterval",{constructor:function(){C.apply(this,arguments);this.sName="DateInterval";this.bUseInternalValues=true;}});
a.prototype.formatValue=function(v,I){if(!Array.isArray(v)){throw new F("Cannot format date interval: "+v+" is expected as an Array but given the wrong format");}switch(this.getPrimitiveType(I)){case"string":case"any":if(!v[0]||(!v[1]&&!this.oFormatOptions.singleIntervalValue)){return"";}if(this.oInputFormat){v=v.slice(0,2);v.forEach(function(o,b){if(this.oFormatOptions.source.pattern=="timestamp"){if(typeof(o)!="number"){if(isNaN(o)){throw new F("Cannot format date: "+o+" is not a valid Timestamp");}else{o=parseInt(o);}}o=new Date(o);}else{o=this.oInputFormat.parse(o);if(o==null){throw new F("Cannot format date: "+o+" has the wrong format");}}v[b]=o;}.bind(this));}return this.oOutputFormat.format(v);default:throw new F("Don't know how to format Date to "+I);}};
a.prototype.parseValue=function(v,I){var d;function t(n){var b=sap.ui.getCore().getLibraryResourceBundle();throw new P(b.getText(n+".Invalid"));}switch(this.getPrimitiveType(I)){case"string":if(v===""){return[null,null];}d=this.oOutputFormat.parse(v);if(!d[0]||(!d[1]&&!this.oFormatOptions.singleIntervalValue)){t(this.sName);}if(this.oInputFormat){d.forEach(function(o,b){if(this.oFormatOptions.source.pattern=="timestamp"){o=o.getTime();}else{o=this.oInputFormat.format(o);}d[b]=o;}.bind(this));}return d;default:throw new P("Don't know how to parse Date from "+I);}};
a.prototype.validateValue=function(v){if(this.oConstraints){var b=sap.ui.getCore().getLibraryResourceBundle(),c=[],m=[];if(this.oInputFormat&&this.oFormatOptions.source.pattern!="timestamp"){v=v.slice(0,2);v.forEach(function(o,d){o=this.oInputFormat.parse(o);v[d]=o;}.bind(this));}Object.keys(this.oConstraints).forEach(function(k){var o=this.oConstraints[k];var d=true;switch(k){case"minimum":if(this.oFormatOptions.singleIntervalValue&&v[1]===null){if(v[0]<o){d=false;}}else if(v[0]<o||v[1]<o){d=false;}if(d===false){c.push("minimum");m.push(b.getText("Date.Minimum",[o]));}break;case"maximum":if(this.oFormatOptions.singleIntervalValue&&v[1]===null){if(v[0]>o){d=false;}}else if(v[0]>o||v[1]>o){d=false;}if(d===false){c.push("maximum");m.push(b.getText("Date.Maximum",[o]));}}}.bind(this));if(c.length>0){throw new V(this.combineMessages(m),c);}}};
a.prototype.setFormatOptions=function(f){this.oFormatOptions=f;this._createFormats();};
a.prototype._handleLocalizationChange=function(){this._createFormats();};
a.prototype._createFormats=function(){var s=this.oFormatOptions.source;this.oFormatOptions.interval=true;this.oOutputFormat=D.getDateInstance(this.oFormatOptions);if(s){if(i(s)){s={pattern:"yyyy-MM-dd"};}this.oInputFormat=D.getDateInstance(s);}};
return a;});
sap.ui.predefine('sap/ui/model/type/DateTime',['./Date','sap/ui/core/format/DateFormat'],function(D,a){"use strict";
var b=D.extend("sap.ui.model.type.DateTime",{constructor:function(){D.apply(this,arguments);this.sName="DateTime";}});
b.prototype._createFormats=function(){this.oOutputFormat=a.getDateTimeInstance(this.oFormatOptions);if(this.oFormatOptions.source){this.oInputFormat=a.getDateTimeInstance(this.oFormatOptions.source);}};
return b;});
sap.ui.predefine('sap/ui/model/type/DateTimeInterval',['./DateInterval','sap/ui/core/format/DateFormat'],function(D,a){"use strict";
var b=D.extend("sap.ui.model.type.DateTimeInterval",{constructor:function(){D.apply(this,arguments);this.sName="DateTimeInterval";}});
b.prototype._createFormats=function(){this.oFormatOptions.interval=true;this.oOutputFormat=a.getDateTimeInstance(this.oFormatOptions);if(this.oFormatOptions.source){this.oInputFormat=a.getDateTimeInstance(this.oFormatOptions.source);}};
return b;});
sap.ui.predefine('sap/ui/model/type/FileSize',['sap/ui/core/format/FileSizeFormat','sap/ui/model/SimpleType','sap/ui/model/FormatException','sap/ui/model/ParseException','sap/ui/model/ValidateException',"sap/ui/thirdparty/jquery"],function(F,S,a,P,V,q){"use strict";
var b=S.extend("sap.ui.model.type.FileSize",{constructor:function(){S.apply(this,arguments);this.sName="FileSize";}});
b.prototype.formatValue=function(v,i){var f;if(v==undefined||v==null){return null;}if(this.oInputFormat&&typeof v==="string"){f=this.oInputFormat.parse(v);if(isNaN(f)){throw new a("Cannot format file size: "+v+" has the wrong format");}}else if(!this.oInputFormat&&typeof v==="string"){throw new a("Cannot format file size: "+v+" of type string without input/source formatter");}else if(typeof v==="number"){f=v;}else{throw new a("Cannot format file size: "+v+" has wrong type: "+(typeof v));}if(f==undefined||f==null){return null;}switch(this.getPrimitiveType(i)){case"string":return this.oOutputFormat.format(f);case"int":return Math.floor(f);case"float":case"any":return f;default:throw new a("Don't know how to format FileSize to "+i);}};
b.prototype.parseValue=function(v,i){var r,B;if(v==undefined||v==null){return null;}switch(this.getPrimitiveType(i)){case"string":r=this.oOutputFormat.parse(v);if(isNaN(r)){B=sap.ui.getCore().getLibraryResourceBundle();throw new P(B.getText("FileSize.Invalid"));}break;case"int":case"float":r=v;break;default:throw new P("Don't know how to parse FileSize from "+i);}if(this.oInputFormat){r=this.oInputFormat.format(r);}return r;};
b.prototype.validateValue=function(v){if(this.oConstraints){var B=sap.ui.getCore().getLibraryResourceBundle(),c=[],m=[],i=this.oInputFormat;if(i&&typeof v==="string"){v=i.parse(v);}else if(!i&&typeof v==="string"){throw new Error("No Validation possible: '"+v+"' is of type string but not input/source format specified.");}q.each(this.oConstraints,function(n,C){if(i&&typeof C==="string"){C=i.parse(C);}else if(!i&&typeof C==="string"){throw new Error("No Validation possible: Compare value ("+n+") '"+C+"' is of type string but not input/source format specified.");}switch(n){case"minimum":if(v<C){c.push("minimum");m.push(B.getText("FileSize.Minimum",[C]));}break;case"maximum":if(v>C){c.push("maximum");m.push(B.getText("FileSize.Maximum",[C]));}}});if(c.length>0){throw new V(this.combineMessages(m),c);}}};
b.prototype.setFormatOptions=function(f){this.oFormatOptions=f;this._handleLocalizationChange();};
b.prototype._handleLocalizationChange=function(){this.oOutputFormat=F.getInstance(this.oFormatOptions);if(this.oFormatOptions.source){this.oInputFormat=F.getInstance(this.oFormatOptions.source);}};
return b;});
sap.ui.predefine('sap/ui/model/type/Float',['sap/ui/core/format/NumberFormat','sap/ui/model/SimpleType','sap/ui/model/FormatException','sap/ui/model/ParseException','sap/ui/model/ValidateException',"sap/ui/thirdparty/jquery","sap/base/util/isEmptyObject"],function(N,S,F,P,V,q,i){"use strict";
var a=S.extend("sap.ui.model.type.Float",{constructor:function(){S.apply(this,arguments);this.sName="Float";}});
a.prototype.formatValue=function(v,I){var f=v;if(v==undefined||v==null){return null;}if(this.oInputFormat){f=this.oInputFormat.parse(v);if(f==null){throw new F("Cannot format float: "+v+" has the wrong format");}}switch(this.getPrimitiveType(I)){case"string":return this.oOutputFormat.format(f);case"int":return Math.floor(f);case"float":case"any":return f;default:throw new F("Don't know how to format Float to "+I);}};
a.prototype.parseValue=function(v,I){var r,b;switch(this.getPrimitiveType(I)){case"string":r=this.oOutputFormat.parse(v);if(isNaN(r)){b=sap.ui.getCore().getLibraryResourceBundle();throw new P(b.getText("Float.Invalid"));}break;case"int":case"float":r=v;break;default:throw new P("Don't know how to parse Float from "+I);}if(this.oInputFormat){r=this.oInputFormat.format(r);}return r;};
a.prototype.validateValue=function(v){if(this.oConstraints){var b=sap.ui.getCore().getLibraryResourceBundle(),c=[],m=[],f=v;if(this.oInputFormat){f=this.oInputFormat.parse(v);}q.each(this.oConstraints,function(n,C){switch(n){case"minimum":if(f<C){c.push("minimum");m.push(b.getText("Float.Minimum",[C]));}break;case"maximum":if(f>C){c.push("maximum");m.push(b.getText("Float.Maximum",[C]));}}});if(c.length>0){throw new V(this.combineMessages(m),c);}}};
a.prototype.setFormatOptions=function(f){this.oFormatOptions=f;this._createFormats();};
a.prototype._handleLocalizationChange=function(){this._createFormats();};
a.prototype._createFormats=function(){var s=this.oFormatOptions.source;this.oOutputFormat=N.getFloatInstance(this.oFormatOptions);if(s){if(i(s)){s={groupingEnabled:false,groupingSeparator:",",decimalSeparator:"."};}this.oInputFormat=N.getFloatInstance(s);}};
return a;});
sap.ui.predefine('sap/ui/model/type/Integer',['sap/ui/core/format/NumberFormat','sap/ui/model/SimpleType','sap/ui/model/FormatException','sap/ui/model/ParseException','sap/ui/model/ValidateException',"sap/ui/thirdparty/jquery","sap/base/util/isEmptyObject"],function(N,S,F,P,V,q,i){"use strict";
var I=S.extend("sap.ui.model.type.Integer",{constructor:function(){S.apply(this,arguments);this.sName="Integer";}});
I.prototype.formatValue=function(v,s){var a=v;if(v==undefined||v==null){return null;}if(this.oInputFormat){a=this.oInputFormat.parse(v);if(a==null){throw new F("Cannot format float: "+v+" has the wrong format");}}switch(this.getPrimitiveType(s)){case"string":return this.oOutputFormat.format(a);case"int":case"float":case"any":return a;default:throw new F("Don't know how to format Integer to "+s);}};
I.prototype.parseValue=function(v,s){var r,b;switch(this.getPrimitiveType(s)){case"string":r=this.oOutputFormat.parse(String(v));if(isNaN(r)){b=sap.ui.getCore().getLibraryResourceBundle();throw new P(b.getText("EnterInt"));}break;case"float":r=Math.floor(v);if(r!=v){b=sap.ui.getCore().getLibraryResourceBundle();throw new P(b.getText("EnterInt"));}break;case"int":r=v;break;default:throw new P("Don't know how to parse Integer from "+s);}if(this.oInputFormat){r=this.oInputFormat.format(r);}return r;};
I.prototype.validateValue=function(v){if(this.oConstraints){var b=sap.ui.getCore().getLibraryResourceBundle(),a=[],m=[],c=v;if(this.oInputFormat){c=this.oInputFormat.parse(v);}q.each(this.oConstraints,function(n,C){switch(n){case"minimum":if(c<C){a.push("minimum");m.push(b.getText("Integer.Minimum",[C]));}break;case"maximum":if(c>C){a.push("maximum");m.push(b.getText("Integer.Maximum",[C]));}}});if(a.length>0){throw new V(this.combineMessages(m),a);}}};
I.prototype.setFormatOptions=function(f){this.oFormatOptions=f;this._createFormats();};
I.prototype._handleLocalizationChange=function(){this._createFormats();};
I.prototype._createFormats=function(){var s=this.oFormatOptions.source;this.oOutputFormat=N.getIntegerInstance(this.oFormatOptions);if(s){if(i(s)){s={groupingEnabled:false,groupingSeparator:",",decimalSeparator:"."};}this.oInputFormat=N.getIntegerInstance(s);}};
return I;});
sap.ui.predefine('sap/ui/model/type/String',["sap/base/Log","sap/ui/model/SimpleType","sap/ui/model/FormatException","sap/ui/model/ParseException","sap/ui/model/ValidateException","sap/ui/thirdparty/jquery"],function(L,S,F,P,V,q){"use strict";
var a=S.extend("sap.ui.model.type.String",{constructor:function(){S.apply(this,arguments);this.sName="String";if(this.oConstraints.search&&typeof this.oConstraints.search=="string"){this.oConstraints.search=new RegExp(this.oConstraints.search);}}});
a.prototype.formatValue=function(v,t){if(v==undefined||v==null){return null;}switch(this.getPrimitiveType(t)){case"string":case"any":return v;case"int":var r=parseInt(v);if(isNaN(r)){throw new F(v+" is not a valid int value");}return r;case"float":var R=parseFloat(v);if(isNaN(R)){throw new F(v+" is not a valid float value");}return R;case"boolean":if(v.toLowerCase()=="true"||v=="X"){return true;}if(v.toLowerCase()=="false"||v==""){return false;}throw new F(v+" is not a valid boolean value");default:throw new F("Don't know how to format String to "+t);}};
a.prototype.parseValue=function(v,s){switch(this.getPrimitiveType(s)){case"string":return v;case"boolean":case"int":case"float":return v.toString();default:throw new P("Don't know how to parse String from "+s);}};
a.prototype.validateValue=function(v){if(this.oConstraints){var b=sap.ui.getCore().getLibraryResourceBundle(),c=[],m=[];if(v===null){v="";}q.each(this.oConstraints,function(n,C){switch(n){case"maxLength":if(v.length>C){c.push("maxLength");m.push(b.getText("String.MaxLength",[C]));}break;case"minLength":if(v.length<C){c.push("minLength");m.push(b.getText("String.MinLength",[C]));}break;case"startsWith":if(!(typeof C=="string"&&C.length>0&&v.startsWith(C))){c.push("startsWith");m.push(b.getText("String.StartsWith",[C]));}break;case"startsWithIgnoreCase":if(!(typeof C=="string"&&C!=""?v.toLowerCase().startsWith(C.toLowerCase()):false)){c.push("startsWithIgnoreCase");m.push(b.getText("String.StartsWith",[C]));}break;case"endsWith":if(!(typeof C=="string"&&C.length>0&&v.endsWith(C))){c.push("endsWith");m.push(b.getText("String.EndsWith",[C]));}break;case"endsWithIgnoreCase":if(!((typeof C=="string"&&C!=""?v.toLowerCase().endsWith(C.toLowerCase()):false))){c.push("endsWithIgnoreCase");m.push(b.getText("String.EndsWith",[C]));}break;case"contains":if(v.indexOf(C)==-1){c.push("contains");m.push(b.getText("String.Contains",[C]));}break;case"equals":if(v!=C){c.push("equals");m.push(b.getText("String.Equals",[C]));}break;case"search":if(v.search(C)==-1){c.push("search");m.push(b.getText("String.Search",[C]));}break;default:L.warning("Ignoring unknown constraint: '"+n+"'",null,"sap.ui.model.type.String");}});if(c.length>0){throw new V(this.combineMessages(m),c);}}};
return a;});
sap.ui.predefine('sap/ui/model/type/Time',['./Date','sap/ui/core/format/DateFormat'],function(D,a){"use strict";
var T=D.extend("sap.ui.model.type.Time",{constructor:function(){D.apply(this,arguments);this.sName="Time";}});
T.prototype._createFormats=function(){this.oOutputFormat=a.getTimeInstance(this.oFormatOptions);if(this.oFormatOptions.source){this.oInputFormat=a.getTimeInstance(this.oFormatOptions.source);}};
return T;});
sap.ui.predefine('sap/ui/model/type/TimeInterval',['./DateInterval','sap/ui/core/format/DateFormat'],function(D,a){"use strict";
var T=D.extend("sap.ui.model.type.TimeInterval",{constructor:function(){D.apply(this,arguments);this.sName="TimeInterval";}});
T.prototype._createFormats=function(){this.oFormatOptions.interval=true;this.oOutputFormat=a.getTimeInstance(this.oFormatOptions);if(this.oFormatOptions.source){this.oInputFormat=a.getTimeInstance(this.oFormatOptions.source);}};
return T;});
sap.ui.predefine('sap/ui/model/type/Unit',['sap/ui/core/format/NumberFormat','sap/ui/model/CompositeType','sap/ui/model/FormatException','sap/ui/model/ParseException','sap/ui/model/ValidateException','sap/ui/core/LocaleData',"sap/base/strings/hash","sap/ui/thirdparty/jquery","sap/base/util/isEmptyObject"],function(N,C,F,P,V,L,h,q,i){"use strict";
var U=C.extend("sap.ui.model.type.Unit",{constructor:function(f,c,d){C.apply(this,arguments);this.sName="Unit";this.bUseRawValues=true;this.aDynamicFormatOptionNames=d;}});
U.prototype._getInstance=function(a,u){var f=this.createFormatOptions(a);if(u&&!this.oFormatOptions.customUnits&&!f.customUnits){var l=sap.ui.getCore().getConfiguration().getFormatSettings().getFormatLocale();var o=L.getInstance(l);var s=o.getUnitFromMapping(u)||u;var m=o.getUnitFormat(s);if(m){var b=q.extend({},m);b.decimals=(f.decimals!=undefined)?f.decimals:b.decimals;b.precision=(f.precision!=undefined)?f.precision:b.precision;f.customUnits={};f.customUnits[u]=b;}}var c=f;if(this.oFormatOptions){c=q.extend({},this.oFormatOptions,f);}if(this.getMetadata().getClass()!==U){var M=this.getMetadata();M._mTypeInstanceCache=M._mTypeInstanceCache||{};var H=h(JSON.stringify(c)||"");var d=M._mTypeInstanceCache[H];if(!d){d=N.getUnitInstance(c);M._mTypeInstanceCache[H]=d;}return d;}else{return N.getUnitInstance(c);}};
U.prototype._clearInstances=function(){if(this.getMetadata().getClass()!==U){var m=this.getMetadata();if(m._mTypeInstanceCache){m._mTypeInstanceCache={};}}};
U.prototype.createFormatOptions=function(v){var f={};if(this.aDynamicFormatOptionNames&&v.length>=this.aDynamicFormatOptionNames.length){this.aDynamicFormatOptionNames.forEach(function(d,I){if(d){f[d]=v[I];}});}return f;};
U.prototype.extractArguments=function(v){return Array.isArray(v)&&v.length>2?v.slice(2):[];};
U.prototype.formatValue=function(v,I){var a=v;if(v==undefined||v==null){return null;}if(this.oInputFormat){a=this.oInputFormat.parse(v);}if(!Array.isArray(a)){throw new F("Cannot format Unit: "+v+" has the wrong format");}if(a[0]==undefined||a[0]==null){return null;}switch(this.getPrimitiveType(I)){case"string":this.aDynamicValues=this.extractArguments(a);this.oOutputFormat=this._getInstance(this.aDynamicValues,a[1]);return this.oOutputFormat.format(a);case"int":case"float":case"any":default:throw new F("Don't know how to format Unit to "+I);}};
U.prototype.parseValue=function(v,I){var r,b;switch(this.getPrimitiveType(I)){case"string":this.oOutputFormat=this._getInstance(this.aDynamicValues);r=this.oOutputFormat.parse(v);if(!Array.isArray(r)||isNaN(r[0])){b=sap.ui.getCore().getLibraryResourceBundle();throw new P(b.getText("Unit.Invalid",[v]));}break;case"int":case"float":default:throw new P("Don't know how to parse Unit from "+I);}if(this.oInputFormat){r=this.oInputFormat.format(r);}return r;};
U.prototype.validateValue=function(v){if(this.oConstraints){var b=sap.ui.getCore().getLibraryResourceBundle(),a=[],m=[],c=v,d;if(this.oInputFormat){c=this.oInputFormat.parse(v);}d=c[0];q.each(this.oConstraints,function(n,o){switch(n){case"minimum":if(d<o){a.push("minimum");m.push(b.getText("Unit.Minimum",[o]));}break;case"maximum":if(d>o){a.push("maximum");m.push(b.getText("Unit.Maximum",[o]));}break;case"decimals":var t=N._shiftDecimalPoint(d,o);if(Math.floor(t)!==t){a.push("decimals");m.push(b.getText("Unit.Decimals",[o]));}break;}});if(a.length>0){throw new V(m.join(" "),a);}}};
U.prototype.setFormatOptions=function(f){this.oFormatOptions=f;this._clearInstances();this._createInputFormat();};
U.prototype._handleLocalizationChange=function(){this._clearInstances();this._createInputFormat();};
U.prototype._createInputFormat=function(){var s=this.oFormatOptions.source;if(s){if(i(s)){s={groupingEnabled:false,groupingSeparator:",",decimalSeparator:"."};}this.oInputFormat=N.getUnitInstance(s);}};
return U;});
sap.ui.predefine('sap/ui/model/xml/XMLListBinding',['sap/ui/model/ChangeReason','sap/ui/model/ClientListBinding',"sap/ui/util/XMLHelper","sap/base/util/deepEqual","sap/base/util/each"],function(C,a,X,d,e){"use strict";
var b=a.extend("sap.ui.model.xml.XMLListBinding");
b.prototype.getContexts=function(s,l){this.iLastStartIndex=s;this.iLastLength=l;if(!s){s=0;}if(!l){l=Math.min(this.iLength,this.oModel.iSizeLimit);}var c=this._getContexts(s,l),f=[];if(this.bUseExtendedChangeDetection){for(var i=0;i<c.length;i++){f.push(this.getContextData(c[i]));}if(this.aLastContexts&&s<this.iLastEndIndex){c.diff=this.diffData(this.aLastContextData,f);}this.iLastEndIndex=s+l;this.aLastContexts=c.slice(0);this.aLastContextData=f.slice(0);}return c;};
b.prototype.getCurrentContexts=function(){if(this.bUseExtendedChangeDetection){return this.aLastContexts||[];}else{return this.getContexts(this.iLastStartIndex,this.iLastLength);}};
b.prototype.getEntryData=function(c){return X.serialize(c.getObject());};
b.prototype.update=function(){var l=this.oModel._getObject(this.sPath,this.oContext);if(l){this.oList=[];var t=this;if(this.bUseExtendedChangeDetection){e(l,function(k,n){t.oList.push(n.cloneNode(true));});}else{this.oList=l.slice(0);}this.updateIndices();this.applyFilter();this.applySort();this.iLength=this._getLength();}else{this.oList=[];this.aIndices=[];this.iLength=0;}};
b.prototype.checkUpdate=function(f){if(this.bSuspended&&!this.bIgnoreSuspend&&!f){return;}if(!this.bUseExtendedChangeDetection){var l=this.oModel._getObject(this.sPath,this.oContext)||[];if(l.length!=this.oList.length||f){this.update();this._fireChange({reason:C.Change});}}else{var c=false;var t=this;var l=this.oModel._getObject(this.sPath,this.oContext)||[];if(this.oList.length!=l.length){c=true;}if(!d(this.oList,l)){this.update();}var g=this._getContexts(this.iLastStartIndex,this.iLastLength);if(this.aLastContexts){if(this.aLastContexts.length!=g.length){c=true;}else{e(this.aLastContextData,function(i,L){var o=t.getContextData(g[i]);if(o!==L){c=true;return false;}});}}else{c=true;}if(c||f){this._fireChange({reason:C.Change});}}};
return b;});
sap.ui.predefine('sap/ui/model/xml/XMLModel',['sap/ui/model/ClientModel','sap/ui/model/Context','./XMLListBinding','./XMLPropertyBinding','./XMLTreeBinding',"sap/ui/util/XMLHelper","sap/base/Log","sap/base/util/each"],function(C,a,X,b,c,d,L,e){"use strict";
var f=C.extend("sap.ui.model.xml.XMLModel",{
constructor:function(D){C.apply(this,arguments);this.oNameSpaces=null;if(D&&D.documentElement){this.setData(D);}},
metadata:{publicMethods:["setXML","getXML","setNameSpace"]}
});
f.prototype.setXML=function(x){var o=d.parse(x);if(o.parseError.errorCode!=0){var p=o.parseError;L.fatal("The following problem occurred: XML parse Error for "+p.url+" code: "+p.errorCode+" reason: "+p.reason+" src: "+p.srcText+" line: "+p.line+" linepos: "+p.linepos+" filepos: "+p.filepos);this.fireParseError({url:p.url,errorCode:p.errorCode,reason:p.reason,srcText:p.srcText,line:p.line,linepos:p.linepos,filepos:p.filepos});}this.setData(o);};
f.prototype.getXML=function(){return d.serialize(this.oData);};
f.prototype.setData=function(D){this.oData=D;this.checkUpdate();};
f.prototype.loadData=function(u,p,A,t,g,h){var i=this;A=(A!==false);t=t||"GET";g=g===undefined?this.bCache:g;this.fireRequestSent({url:u,type:t,async:A,headers:h,info:"cache="+g,infoObject:{cache:g}});this._ajax({url:u,async:A,cache:g,dataType:'xml',data:p,headers:h,type:t,success:function(D){if(!D){L.fatal("The following problem occurred: No data was retrieved by service: "+u);}i.setData(D);i.fireRequestCompleted({url:u,type:t,async:A,headers:h,info:"cache="+g,infoObject:{cache:g},success:true});},error:function(j,k,l){var E={message:k,statusCode:j.status,statusText:j.statusText,responseText:j.responseText};L.fatal("The following problem occurred: "+k,j.responseText+","+j.status+","+j.statusText);i.fireRequestCompleted({url:u,type:t,async:A,headers:h,info:"cache="+g,infoObject:{cache:g},success:false,errorobject:E});i.fireRequestFailed(E);}});};
f.prototype.setNameSpace=function(n,p){if(!p){p="";}if(!this.oNameSpaces){this.oNameSpaces={};}this.oNameSpaces[p]=n;};
f.prototype.bindProperty=function(p,o,P){var B=new b(this,p,o,P);return B;};
f.prototype.bindList=function(p,o,s,F,P){var B=new X(this,p,o,s,F,P);return B;};
f.prototype.bindTree=function(p,o,F,P,s){var B=new c(this,p,o,F,P,s);return B;};
f.prototype.setProperty=function(p,v,o,A){var O=p.substring(0,p.lastIndexOf("/")+1),P=p.substr(p.lastIndexOf("/")+1);if(!this.resolve(p,o)){return false;}if(!this.oData.documentElement){L.warning("Trying to set property "+p+", but no document exists.");return false;}var g;if(P.indexOf("@")==0){g=this._getObject(O,o);if(g[0]){g[0].setAttribute(P.substr(1),v);this.checkUpdate(false,A);return true;}}else{g=this._getObject(p,o);if(g[0]){g[0].textContent=v;this.checkUpdate(false,A);return true;}}return false;};
f.prototype.getProperty=function(p,o){var r=this._getObject(p,o);if(r&&typeof r!="string"){r=r[0]?r[0].textContent:"";}return r;};
f.prototype.getObject=function(p,o){var O=this._getObject(p,o);if(Array.isArray(O)){O=O[0];}return O;};
f.prototype._getObject=function(p,o){var r=this.oData.documentElement;if(!r){return null;}var n=this.isLegacySyntax()?[r]:[];if(o instanceof a){n=this._getObject(o.getPath());}else if(o){n=[o];}if(!p){return n;}var P=p.split("/"),s,i=0;if(!P[0]){n=r;i++;}n=n.length==undefined?[n]:n;n=n[0]?n:null;while(n&&n.length>0&&P[i]){s=P[i];if(s.indexOf("@")==0){n=this._getAttribute(n[0],s.substr(1));}else if(s=="text()"){n=n[0]?n[0].textContent:"";}else if(isNaN(s)){n=this._getChildElementsByTagName(n[0],s);}else{n=[n[s]];}i++;}return n;};
f.prototype._getAttribute=function(n,N){if(!this.oNameSpaces||N.indexOf(":")==-1){return n.getAttribute(N);}var s=this._getNameSpace(N),l=this._getLocalName(N);if(n.getAttributeNS){return n.getAttributeNS(s,l);}else{if(!this.oDocNSPrefixes){this.oDocNSPrefixes=this._getDocNSPrefixes();}var p=this.oDocNSPrefixes[s];N=(p?p+":":"")+l;return n.getAttribute(N);}};
f.prototype._getChildElementsByTagName=function(n,N){var g=n.childNodes,r=[];if(this.oNameSpaces){var s=this._getNameSpace(N),l=this._getLocalName(N),h;e(g,function(i,o){h=o.localName||o.baseName;if(o.nodeType==1&&h==l&&o.namespaceURI==s){r.push(o);}});}else{e(g,function(i,o){if(o.nodeType==1&&o.nodeName==N){r.push(o);}});}return r;};
f.prototype._getNameSpace=function(n){var i=n.indexOf(":"),p="";if(i>0){p=n.substr(0,i);}return this.oNameSpaces[p];};
f.prototype._getLocalName=function(n){var i=n.indexOf(":"),l=n;if(i>0){l=n.substr(i+1);}return l;};
f.prototype._getDocNSPrefixes=function(){var p={},D=this.oData&&this.oData.documentElement;if(!D){return p;}var A=D.attributes;e(A,function(i,o){var n=o.name,v=o.value;if(n=="xmlns"){p[v]="";}else if(n.indexOf("xmlns")==0){p[v]=n.substr(6);}});return p;};
f.prototype._resolve=function(p,o){var i=!p.startsWith("/"),r=p;if(i){if(o){r=o.getPath()+"/"+p;}else{r=this.isLegacySyntax()?"/"+p:undefined;}}return r;};
f.prototype.isList=function(p,o){return false;};
f.prototype._setMetaModel=function(m){this._oMetaModel=m;};
f.prototype.getMetaModel=function(){return this._oMetaModel;};
return f;});
sap.ui.predefine('sap/ui/model/xml/XMLPropertyBinding',['sap/ui/model/ChangeReason','sap/ui/model/ClientPropertyBinding',"sap/base/util/deepEqual"],function(C,a,d){"use strict";
var X=a.extend("sap.ui.model.xml.XMLPropertyBinding");
X.prototype.setValue=function(v){if(this.bSuspended){return;}if(this.oValue!=v){if(this.oModel.setProperty(this.sPath,v,this.oContext,true)){this.oValue=v;this.oModel.firePropertyChange({reason:C.Binding,path:this.sPath,context:this.oContext,value:v});}}};
X.prototype.checkUpdate=function(f){if(this.bSuspended&&!f){return;}var v=this._getValue();if(!d(v,this.oValue)||f){this.oValue=v;this._fireChange({reason:C.Change});}};
return X;});
sap.ui.predefine('sap/ui/model/xml/XMLTreeBinding',['sap/ui/model/ClientTreeBinding',"sap/base/util/each"],function(C,e){"use strict";
var X=C.extend("sap.ui.model.xml.XMLTreeBinding");
X.prototype.getNodeContexts=function(c,s,l){if(!s){s=0;}if(!l){l=this.oModel.iSizeLimit;}var a=c.getPath();if(!a.endsWith("/")){a=a+"/";}if(!a.startsWith("/")){a="/"+a;}var b=[],n={},t=this,N=this.oModel._getObject(c.getPath()),d,o;e(N[0].childNodes,function(f,g){if(g.nodeType==1){if(n[g.nodeName]==undefined){n[g.nodeName]=0;}else{n[g.nodeName]++;}d=a+g.nodeName+"/"+n[g.nodeName];o=t.oModel.getContext(d);if(t.oCombinedFilter&&!t.bIsFiltering){if(t.filterInfo.aFilteredContexts&&t.filterInfo.aFilteredContexts.indexOf(o)!=-1){b.push(o);}}else{b.push(o);}}});this._applySorter(b);this._setLengthCache(a,b.length);return b.slice(s,s+l);};
return X;});
sap.ui.predefine('sap/ui/util/Mobile',['sap/ui/Device','sap/base/Log',"sap/ui/thirdparty/jquery"],function(D,L,q){"use strict";var M={};if(D.os.windows_phone){var t;t=document.createElement("meta");t.setAttribute("name","msapplication-tap-highlight");t.setAttribute("content","no");document.head.appendChild(t);t=document.createElement("style");t.appendChild(document.createTextNode('@-ms-viewport{width:device-width;}'));document.head.appendChild(t);}var _=false;
M.init=function(o){var $=q("head");if(!_){_=true;o=q.extend({},{viewport:true,statusBar:"default",hideBrowser:true,preventScroll:true,preventPhoneNumberDetection:true,useFullScreenHeight:true,homeIconPrecomposed:false,mobileWebAppCapable:"default"},o);if(D.os.ios&&o.preventPhoneNumberDetection){$.append(q('<meta name="format-detection" content="telephone=no">'));}else if(D.browser.msie){$.append(q('<meta http-equiv="cleartype" content="on">'));$.append(q('<meta name="msapplication-tap-highlight" content="no">'));}var i=D.os.ios&&D.os.version>=7&&D.os.version<8&&D.browser.name==="sf";if(o.viewport){var m;var I=D.resize.height;var a=D.resize.width;if(i&&D.system.phone){m='minimal-ui, initial-scale=1.0, maximum-scale=1.0, user-scalable=0';}else if(i&&D.system.tablet){m='initial-scale=1.0, maximum-scale=1.0, user-scalable=no';}else if((D.os.ios&&D.system.phone)&&(Math.max(window.screen.height,window.screen.width)===568)){m="user-scalable=0, initial-scale=1.0";}else if(D.os.android&&D.os.version<3){m="width=device-width, height=device-height, initial-scale=1.0, maximum-scale=1.0, user-scalable=no";}else{m="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no";}$.append(q('<meta name="viewport" content="'+m+'">'));if((I!==window.innerHeight||a!==window.innerWidth)&&D.resize._update){D.resize._update();}}if(o.mobileWebAppCapable==="default"){if(D.os.ios){$.append(q('<meta name="apple-mobile-web-app-capable" content="yes">'));}}if(D.os.ios){$.append(q('<meta name="apple-mobile-web-app-status-bar-style" content="'+o.statusBar+'">'));}if(o.useFullScreenHeight){q(function(){document.documentElement.style.height="100%";});}if(o.preventScroll&&D.os.ios){q(function(){document.documentElement.style.position="fixed";document.documentElement.style.overflow="hidden";document.documentElement.style.height="100%";document.documentElement.style.width="100%";});}}if(o&&o.homeIcon){var b;if(typeof o.homeIcon==="string"){b={phone:o.homeIcon};}else{b=q.extend({},o.homeIcon);}b.precomposed=o.homeIconPrecomposed||b.precomposed;b.favicon=o.homeIcon.icon||b.favicon;b.icon=undefined;M.setIcons(b);}if(o&&o.mobileWebAppCapable!=="default"){M.setWebAppCapable(o.mobileWebAppCapable);}};
M.setIcons=function(i){if(!i||(typeof i!=="object")){L.warning("Call to sap/ui/util/Mobile.setIcons() has been ignored because there were no icons given or the argument was not an object.");return;}var $=q("head"),p=i.precomposed?"-precomposed":"",g=function(r){return i[r]||i['tablet@2']||i['phone@2']||i['phone']||i['tablet'];},s={"phone":"","tablet":"76x76","phone@2":"120x120","tablet@2":"152x152"};if(i["favicon"]){var a=$.find("[rel^=shortcut]");a.each(function(){if(this.rel==="shortcut icon"){q(this).remove();}});if(D.browser.msie){var b=q('<link rel="shortcut icon">');$.append(b);b.attr("href",i["favicon"]);}else{$.append(q('<link rel="shortcut icon" href="'+i["favicon"]+'">'));}}if(g("phone")){$.find("[rel=apple-touch-icon]").remove();$.find("[rel=apple-touch-icon-precomposed]").remove();}for(var c in s){i[c]=i[c]||g(c);if(i[c]){var d=s[c];$.append(q('<link rel="apple-touch-icon'+p+'" '+(d?'sizes="'+d+'"':"")+' href="'+i[c]+'">'));}}};
M.setWebAppCapable=function(v){if(!D.system.tablet&&!D.system.phone){return;}var h=q("head"),p=["","apple"],n="mobile-web-app-capable",c=v?"yes":"no",i,N,w;for(i=0;i<p.length;i++){N=p[i]?(p[i]+"-"+n):n;w=h.children('meta[name="'+N+'"]');if(w.length){w.attr("content",c);}else{h.append(q('<meta name="'+N+'" content="'+c+'">'));}}};
return M;});
sap.ui.predefine('sap/ui/util/Storage',["sap/base/assert"],function(a){"use strict";var S="state.key_";var b=function(c,s){var t="unknown",P=(s||S)+"-",o;if(!c||typeof(c)==="string"){t=c||b.Type.session;try{o=window[t+"Storage"];if(o){var T=P+"___sapui5TEST___";o.setItem(T,"1");o.removeItem(T);}}catch(e){o=null;}}else if(typeof(c)==="object"){t=c.getType?c.getType():"unknown";o=c;}var h=function(f){try{if(this.isSupported()){f();return true;}}catch(e){return false;}return false;}.bind(this);this.isSupported=function(){return typeof(o.isSupported)=="function"?o.isSupported():true;};this.put=function(k,d){a(typeof k==="string"&&k.length>0,"key must be a non-empty string");return h(function(){o.setItem(P+k,JSON.stringify(d));});};this.get=function(k){a(typeof k==="string"&&k.length>0,"key must be a non-empty string");var d;h(function(){d=JSON.parse(o.getItem(P+k));});return d!==undefined?d:null;};this.remove=function(k){a(typeof k==="string"&&k.length>0,"key must be a non-empty string");return h(function(){o.removeItem(P+k);});};this.removeAll=function(I){return h(function(){var k,p=P+(I||"");for(var i=0,m=o.length;i<m;){k=o.key(i);if(k&&k.startsWith(p)){o.removeItem(k);}else{i++;}}});};this.clear=function(){return h(function(){o.clear();});};this.getType=function(){return t;};};b.Type={local:"local",session:"session"};Object.assign(b,new b());return b;});
sap.ui.predefine('sap/ui/util/XMLHelper',['sap/ui/Device'],function(D){"use strict";var H={};
H.parse=function(x){var X;var p;var a=new DOMParser();try{X=a.parseFromString(x,"text/xml");}catch(e){p=H.getParseError();p.reason=e.message;X={};X.parseError=p;return X;}p=H.getParseError(X);if(p){if(!X.parseError){X.parseError=p;}}return X;};
H.getParseError=function(d){var p={errorCode:-1,url:"",reason:"unknown error",srcText:"",line:-1,linepos:-1,filepos:-1};if(D.browser.msie&&d&&d.parseError&&d.parseError.errorCode!=0){return d.parseError;}if((D.browser.firefox||D.browser.edge)&&d&&d.documentElement&&d.documentElement.tagName=="parsererror"){var e=d.documentElement.firstChild.nodeValue,r=/XML Parsing Error: (.*)\nLocation: (.*)\nLine Number (\d+), Column (\d+):(.*)/;if(r.test(e)){p.reason=RegExp.$1;p.url=RegExp.$2;p.line=parseInt(RegExp.$3);p.linepos=parseInt(RegExp.$4);p.srcText=RegExp.$5;}return p;}if(D.browser.webkit&&d&&d.documentElement&&d.getElementsByTagName("parsererror").length>0){var e=H.serialize(d),r=/(error|warning) on line (\d+) at column (\d+): ([^<]*)\n/;if(r.test(e)){p.reason=RegExp.$4;p.url="";p.line=parseInt(RegExp.$2);p.linepos=parseInt(RegExp.$3);p.srcText="";p.type=RegExp.$1;}return p;}if(!d||!d.documentElement){return p;}return{errorCode:0};};
H.serialize=function(x){var s=new XMLSerializer();return s.serializeToString(x);};
return H;});
sap.ui.predefine('jquery.sap.dom',['jquery.sap.global','sap/ui/dom/containsOrEquals','sap/ui/core/syncStyleClass','sap/ui/dom/getOwnerWindow','sap/ui/dom/getScrollbarSize','sap/ui/dom/denormalizeScrollLeftRTL','sap/ui/dom/denormalizeScrollBeginRTL','sap/ui/dom/units/Rem','sap/ui/dom/jquery/Aria','sap/ui/dom/jquery/Selection','sap/ui/dom/jquery/zIndex','sap/ui/dom/jquery/parentByAttribute','sap/ui/dom/jquery/cursorPos','sap/ui/dom/jquery/selectText','sap/ui/dom/jquery/getSelectedText','sap/ui/dom/jquery/rect','sap/ui/dom/jquery/rectContains','sap/ui/dom/jquery/Focusable','sap/ui/dom/jquery/hasTabIndex','sap/ui/dom/jquery/scrollLeftRTL','sap/ui/dom/jquery/scrollRightRTL','sap/ui/dom/jquery/Selectors'],function(q,d,s,a,b,c,e,f){"use strict";
q.sap.domById=function domById(i,w){return i?(w||window).document.getElementById(i):null;};
q.sap.byId=function byId(i,C){var g="";if(i){g="#"+i.replace(/(:|\.)/g,'\\$1');}return q(g,C);};
q.sap.focus=function focus(D){if(!D){return;}D.focus();return true;};
q.sap.pxToRem=f.fromPx;q.sap.remToPx=f.toPx;
q.fn.outerHTML=function(){var D=this.get(0);if(D&&D.outerHTML){return q.trim(D.outerHTML);}else{var g=this[0]?this[0].ownerDocument:document;var o=g.createElement("div");o.appendChild(D.cloneNode(true));return o.innerHTML;}};
q.sap.containsOrEquals=d;q.sap.denormalizeScrollLeftRTL=c;q.sap.denormalizeScrollBeginRTL=e;
/*
	 * The following methods are taken from jQuery UI core but modified.
	 *
	 * jQuery UI Core
	 * http://jqueryui.com
	 *
	 * Copyright 2014 jQuery Foundation and other contributors
	 * Released under the MIT license.
	 * http://jquery.org/license
	 *
	 * http://api.jqueryui.com/category/ui-core/
	 */
q.support.selectstart="onselectstart"in document.createElement("div");q.sap.ownerWindow=a;q.sap.scrollbarSize=b;q.sap.syncStyleClass=s;return q;});
/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('jquery.sap.script',['jquery.sap.global','sap/base/util/uid','sap/base/strings/hash','sap/base/util/array/uniqueSort','sap/base/util/deepEqual','sap/base/util/each','sap/base/util/array/diff','sap/base/util/JSTokenizer','sap/base/util/merge','sap/base/util/UriParameters'],function(q,u,h,a,d,e,b,J,m,U){"use strict";q.sap.uid=u;q.sap.hashCode=h;q.sap.unique=a;q.sap.equal=d;q.sap.each=e;q.sap.arraySymbolDiff=b;
q.sap._createJSTokenizer=function(){return new J();};
q.sap.parseJS=J.parseJS;
q.sap.extend=function(){var c=arguments,f=false;if(typeof arguments[0]==="boolean"){f=arguments[0];c=Array.prototype.slice.call(arguments,1);}if(f){return m.apply(this,c);}else{
/*
			 * The code in this function is taken from jQuery 2.2.3 "jQuery.extend" and got modified.
			 *
			 * jQuery JavaScript Library v2.2.3
			 * http://jquery.com/
			 *
			 * Copyright jQuery Foundation and other contributors
			 * Released under the MIT license
			 * http://jquery.org/license
			 */
var g,n,o,t=arguments[0]||{},i=1,l=arguments.length;if(typeof t!=="object"&&typeof t!=="function"){t={};}for(;i<l;i++){o=arguments[i];for(n in o){g=o[n];if(t===g){continue;}t[n]=g;}}return t;}};
q.sap.getUriParameters=function getUriParameters(s){return U.fromURL(s||window.location.href);};
q.sap.delayedCall=function delayedCall(D,o,c,p){return setTimeout(function(){if(typeof c==="string"){c=o[c];}c.apply(o,p||[]);},D);};
q.sap.clearDelayedCall=function clearDelayedCall(D){clearTimeout(D);return this;};
q.sap.intervalCall=function intervalCall(i,o,c,p){return setInterval(function(){if(typeof c==="string"){c=o[c];}c.apply(o,p||[]);},i);};
q.sap.clearIntervalCall=function clearIntervalCall(i){clearInterval(i);return this;};
q.sap.forIn=e;
q.sap.arrayDiff=function(o,n,c,f){c=c||function(v,V){return d(v,V);};var O=[];var N=[];var M=[];for(var i=0;i<n.length;i++){var g=n[i];var F=0;var t;if(f&&c(o[i],g)){F=1;t=i;}else{for(var j=0;j<o.length;j++){if(c(o[j],g)){F++;t=j;if(f||F>1){break;}}}}if(F==1){var k={oldIndex:t,newIndex:i};if(M[t]){delete O[t];delete N[M[t].newIndex];}else{N[i]={data:n[i],row:t};O[t]={data:o[t],row:i};M[t]=k;}}}for(var i=0;i<n.length-1;i++){if(N[i]&&!N[i+1]&&N[i].row+1<o.length&&!O[N[i].row+1]&&c(o[N[i].row+1],n[i+1])){N[i+1]={data:n[i+1],row:N[i].row+1};O[N[i].row+1]={data:O[N[i].row+1],row:i+1};}}for(var i=n.length-1;i>0;i--){if(N[i]&&!N[i-1]&&N[i].row>0&&!O[N[i].row-1]&&c(o[N[i].row-1],n[i-1])){N[i-1]={data:n[i-1],row:N[i].row-1};O[N[i].row-1]={data:O[N[i].row-1],row:i-1};}}var D=[];if(n.length==0){for(var i=0;i<o.length;i++){D.push({index:0,type:'delete'});}}else{var l=0;if(!O[0]){for(var i=0;i<o.length&&!O[i];i++){D.push({index:0,type:'delete'});l=i+1;}}for(var i=0;i<n.length;i++){if(!N[i]||N[i].row>l){D.push({index:i,type:'insert'});}else{l=N[i].row+1;for(var j=N[i].row+1;j<o.length&&(!O[j]||O[j].row<i);j++){D.push({index:i+1,type:'delete'});l=j+1;}}}}return D;};
return q;});
/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
/*!
 * Portions of this module ("Least Recently Used" logic) are taken from the node-lru-cache project (see https://github.com/isaacs/node-lru-cache/blob/v2.7.3/README.md),
 * but modified. Please see the OpenUI5 LICENSE file for license information respecting node-lru-cache.
 */
sap.ui.predefine('sap/ui/core/cache/LRUPersistentCache',["sap/base/Log","sap/ui/performance/Measurement"],function(L,M){"use strict";var a={name:"LRUPersistentCache",defaultOptions:{databaseName:"ui5-cachemanager-db",_contentStoreName:"content-store",_metadataStoreName:"metadata-store",_metadataKey:"metadataKey"},_db:{},init:function(){this._metadata={};this._mru=-1;this._lru=-1;return l(this);},_destroy:function(){if(this._db.close){this._db.close();}this._metadata=null;this._ui5version=null;},set:function(e,i){if(E(e)){L.warning("Cache Manager ignored 'set' for key ["+e+"]");return Promise.resolve();}if(e==null){return Promise.reject("Cache Manager does not accept undefined or null as key");}if(typeof i==="undefined"){return Promise.reject("Cache Manager does not accept undefined as value");}L.debug("Cache Manager LRUPersistentCache: adding item with key ["+e+"]...");var p=this,H="[sync ] fnSet: total[sync]  key ["+e+"]",J="[sync ] fnSet: txStart[sync]  key ["+e+"]",K="[sync ] fnSet: storeOpen[sync]  key ["+e+"]",N="[sync ] fnSet: putContent[sync]  key ["+e+"]",O="[sync ] fnSet: putMetadata[sync]  key ["+e+"]",P="[sync ] fnSet: serialize[sync]  key ["+e+"]";return new Promise(function fnSet(Q,R){M.start(H,"CM",s);var S,T,U,V,W;W=q(p._metadata);V=new n(e,i,typeof i,++p._mru,P,s).serialize();M.start(J,"CM",s);var X=p._db.transaction([p.defaultOptions._contentStoreName,p.defaultOptions._metadataStoreName],"readwrite");M.end(J);X.onerror=function(Y){var Z="Cache Manager cannot complete add/put transaction for entry with key: "+V.oData.key+". Details: "+B(Y);L.error(Z);p._metadata=W;r(p);R(Z);};X.onabort=function(Y){p._metadata=W;r(p);var Z=t(p);if(y(Y)&&Z>0){L.warning("Cache Manager is trying to free some space to add/put new item");x(p,e,i).then(function(){L.debug("Cache Manager LRUPersistentCache: set completed after freeing space. ItemCount changed from "+Z+" to "+t(p));Q();},function(_){var a1="Cache Manager LRUPersistentCache: set unsuccessful. Cannot free space to add/put entry. Details: "+_;L.error(a1);R(a1);});}else{var $="Cache Manager LRUPersistentCache: set failed: "+B(Y);L.error($);R($);}};X.oncomplete=function(){L.debug("Cache Manager LRUPersistentCache: adding item with key ["+e+"]... done");Q();};M.start(K,"CM",s);S=X.objectStore(p.defaultOptions._contentStoreName);U=X.objectStore(p.defaultOptions._metadataStoreName);M.end(K);M.start(N,"CM",s);T=S.put(V.oData,V.oData.key);M.end(N);M.end(H);T.onsuccess=function(){u(p,V);M.start(O,"CM",s);U.put(p._metadata,p.defaultOptions._metadataKey);M.end(O);};if(L.getLevel()>=L.Level.DEBUG){L.debug("Cache Manager LRUPersistentCache: measurements: "+H+": "+M.getMeasurement(H).duration+"; "+P+": "+M.getMeasurement(P).duration+"; "+J+": "+M.getMeasurement(J).duration+"; "+K+": "+M.getMeasurement(K).duration+"; "+N+": "+M.getMeasurement(N).duration+"; "+O+": "+M.getMeasurement(O).duration);}});},has:function(e){if(E(e)){L.warning("Cache Manager ignored 'has' for key ["+e+"]");return Promise.resolve(false);}return this.get(e).then(function(i){return typeof i!=="undefined";});},_getCount:function(){return Promise.resolve(t(this));},_getAll:function(e){var i=this,p,H="[sync ] _getAll: deserialize";return new Promise(function(J,K){var N=[],O=i._db.transaction([i.defaultOptions._contentStoreName],"readonly"),P=O.objectStore(i.defaultOptions._contentStoreName);O.onerror=function(Q){K(B(Q));};O.oncomplete=function(Q){J(N);};P.openCursor().onsuccess=function(Q){var R=Q.target.result;if(R&&R.value){p=new n(R.value,H,m).deserialize();N.push({key:p.oData.key,value:p.oData.value});R.continue();}};});},_loadMetaStructure:function(){var i=this;return new Promise(function(p,H){var J=i._db.transaction([i.defaultOptions._metadataStoreName],"readonly");J.onerror=function(O){if(!J.errorHandled){J.errorHandled=true;var P="Cache Manager cannot complete transaction for read metadata. Details: "+J.error;L.error(P);H(P);}};var K=J.objectStore(i.defaultOptions._metadataStoreName);try{var N=K.get(i.defaultOptions._metadataKey);N.onsuccess=function(O){i._metadata=N.result?N.result:o(i._ui5version);if(i._metadata.__ui5version!==i._ui5version){i.reset().then(p,function(e){L.error("Cannot reset the cache. Details:"+e);J.abort();});}else{p();}};N.onerror=function(O){L.error("Cache Manager cannot complete transaction for read metadata items. Details: "+O.message);H(O.message);};}catch(e){L.error("Cache Manager cannot read metadata entries behind key: "+i.defaultOptions._metadataKey+". Details: "+e.message);H(e.message);}});},get:function(e){if(E(e)){L.warning("Cache Manager ignored 'get' for key ["+e+"]");return Promise.resolve();}return g(this,e);},del:function(e){if(E(e)){L.warning("Cache Manager ignored 'del' for key ["+e+"]");return Promise.resolve();}return d(this,e);},reset:function(){var i=this;return new Promise(function(p,H){var J,K,N,O,P;P=i._db.transaction([i.defaultOptions._contentStoreName,i.defaultOptions._metadataStoreName],"readwrite");P.onerror=P.onabort=function(Q){if(!P.errorHandled){P.errorHandled=true;var R="Cache Manager LRUPersistentCache: transaction for reset() failed. Details: "+P.error;L.error(R);H(R);}};P.oncomplete=function(Q){p();};J=P.objectStore(i.defaultOptions._contentStoreName);K=P.objectStore(i.defaultOptions._metadataStoreName);try{N=J.clear();N.onerror=function(){P.abort();};N.onsuccess=function(){O=K.clear();O.onerror=function(){P.abort();};O.onsuccess=function(){i._metadata=o(sap.ui.version);r(i);};};}catch(e){P.abort();}});}};var m="LRUPersistentCache,get",s="LRUPersistentCache,set",b=0;
function c(i){var p=i._db.transaction([i.defaultOptions._contentStoreName,i.defaultOptions._metadataStoreName],"readwrite");p.onerror=p.onabort=function(H){L.warning("Cache Manager cannot persist the information about usage of an entry. This may lead to earlier removal of the entry if browser storage space is over. Details: "+p.error);};try{p.objectStore(i.defaultOptions._metadataStoreName).put(i._metadata,i.defaultOptions._metadataKey);}catch(e){L.warning("Cache Manager cannot persist the information about usage of an entry. This may lead to earlier removal of the entry if browser storage space is over. Details: "+e.message);}}
function d(e,i){return new Promise(function(p,H){var J,K;J=e._db.transaction([e.defaultOptions._contentStoreName,e.defaultOptions._metadataStoreName],"readwrite");K=q(e._metadata);function N(P){e._metadata=K;r(e);var Q="Cache Manager LRUPersistentCache: cannot delete item with key: "+i+". Details: "+B(P);L.error(Q);H(Q);}J.onerror=N;J.onabort=N;J.oncomplete=function(){if(t(e)===0){e._lru=-1;e._mru=-1;e._metadata=o(e._ui5version);}L.debug("Cache Manager LRUPersistentCache: item with key "+i+" deleted");p();};L.debug("Cache Manager LRUPersistentCache: deleting item ["+i+"]");var O=J.objectStore(e.defaultOptions._contentStoreName).delete(i);O.onsuccess=function(){L.debug("Cache Manager LRUPersistentCache: request for deleting item ["+i+"] is successful, updating metadata...");z(e,i);J.objectStore(e.defaultOptions._metadataStoreName).put(e._metadata,e.defaultOptions._metadataKey);};});}
function g(i,H){if(i.getCounter===undefined){i.getCounter=0;}i.getCounter++;var J="[sync ] fnGet"+i.getCounter+": total[sync]  key ["+H+"]",K="[sync ] fnGet"+i.getCounter+": txStart[sync]  key ["+H+"]",N="[sync ] fnGet"+i.getCounter+": storeOpen[sync]  key ["+H+"]",O="[sync ] fnGet"+i.getCounter+": access result[sync]  key ["+H+"]",P="[sync ] fnGet"+i.getCounter+": putMetadata[sync]  key ["+H+"]",Q="[sync ] fnGet"+i.getCounter+": deserialize[sync]  key ["+H+"]",R="[sync ]  _instance.get",S="[sync ]  getRequest.onSuccess";L.debug("Cache Manager LRUPersistentCache: get for key ["+H+"]...");M.start(R,"CM",m);var p=new Promise(function fnGet(T,U){var V,W,X,Y;M.start(J,"CM",m);M.start(K,"CM",m);W=i._db.transaction([i.defaultOptions._contentStoreName,i.defaultOptions._metadataStoreName],"readwrite");M.end(K);W.onerror=function(Z){var $="Cache Manager cannot complete delete transaction for entry with key: "+H+". Details: "+W.error;L.error($);U($);};try{M.start(N,"CM",m);X=W.objectStore(i.defaultOptions._contentStoreName).get(H);M.end(N);X.onsuccess=function(Z){M.start(S,"CM",m);M.start(O,"CM",m);Y=new n(X.result,Q,m);M.end(O);G("Cache Manager LRUPersistentCache: accessing the result",H,O);if(Y.oData){M.start(P,"CM",m);if(Y.oData.lu!==i._mru){Y.oData.lu=++i._mru;u(i,Y);c(i);}M.end(P);V=Y.deserialize().oData.value;}M.end(S);L.debug("Cache Manager LRUPersistentCache: get for key ["+H+"]...done");T(V);};X.onerror=function(Z){L.error("Cache Manager cannot get entry with key: "+H+". Details: "+Z.message);U(Z.message);};}catch(e){L.error("Cache Manager cannot get entry with key: "+H+". Details: "+e.message);U(e.message);return;}M.end(J);});M.end(R);return p;}
function f(e){var K=v(e);if(K==undefined){var i="Cache Manager LRUPersistentCache: deleteItemAndUpdateMetadata cannot find item to delete";L.debug(i);return Promise.reject(i);}return j(e,K).then(function(){return Promise.resolve().then(function(){z(e,K);return h(e).then(function(){return K;},function(){L.warning("Cache Manager LRUPersistentCache: Free space algorithm deleted item "+"but the metadata changes could not be persisted. This won't break the functionality.");return K;});});});}
function h(i){return new Promise(function(p,H){try{var J=i._db.transaction([i.defaultOptions._contentStoreName,i.defaultOptions._metadataStoreName],"readwrite");J.onerror=K;J.onabort=K;J.oncomplete=function(){L.debug("Cache Manager LRUPersistentCache: persistMetadata - metadata was successfully updated");p();};J.objectStore(i.defaultOptions._metadataStoreName).put(i._metadata,i.defaultOptions._metadataKey);}catch(e){K(null,e);}function K(N,O){var P="Cache Manager LRUPersistentCache: persistMetadata error - metadata was not successfully persisted. Details: "+B(N)+". Exception: "+(O?O.message:"");L.debug(P);H(P);}});}
function j(e,i){return new Promise(function(p,H){var J=e._db.transaction([e.defaultOptions._contentStoreName,e.defaultOptions._metadataStoreName],"readwrite");function K(N){var O="Cache Manager LRUPersistentCache: internalDel cannot complete delete transaction for entry with key: "+i+". Details: "+B(N);L.warning(O);H(N);}J.onerror=K;J.onabort=K;J.oncomplete=function(){if(t(e)===0){e._lru=0;e._mru=0;e._metadata=o(e._ui5version);}L.debug("Cache Manager LRUPersistentCache: internalDel deleting item ["+i+"]...done");p();};L.debug("Cache Manager LRUPersistentCache: internalDel deleting item ["+i+"]...");J.objectStore(e.defaultOptions._contentStoreName).delete(i);});}
function k(e,i,p){return new Promise(function(H,J){var K,N,O,P="[sync ] internalSet: serialize[sync]  key ["+i+"]";O=q(e._metadata);var Q=new n(i,p,typeof p,++e._mru,P,s).serialize();L.debug("Cache Manager: LRUPersistentCache: internal set with parameters: key ["+Q.oData.key+"], access index ["+Q.oData.lu+"]");N=e._db.transaction([e.defaultOptions._contentStoreName,e.defaultOptions._metadataStoreName],"readwrite");N.onerror=R;N.onabort=R;function R(S){L.debug("Cache Manager: LRUPersistentCache: internal set failed. Details: "+B(S));e._metadata=O;r(e);J(S);}N.oncomplete=function(){L.debug("Cache Manager: LRUPersistentCache: Internal set transaction completed. ItemCount: "+t(e));H();};K=N.objectStore(e.defaultOptions._contentStoreName).put(Q.oData,Q.oData.key);K.onsuccess=function(){u(e,Q);N.objectStore(e.defaultOptions._metadataStoreName).put(e._metadata,e.defaultOptions._metadataKey);};});}
function u(e,i){if(e._metadata.__byKey__[i.oData.key]!=null){var p=e._metadata.__byKey__[i.oData.key];delete e._metadata.__byIndex__[p];L.debug("Cache Manager LRUPersistentCache: set/internalset - item already exists, so its indexes are updated");}e._metadata.__byIndex__[i.oData.lu]=i.oData.key;e._metadata.__byKey__[i.oData.key]=i.oData.lu;A(e);}
function l(i){i._ui5version=sap.ui.version;return new Promise(function executorInitIndexedDB(p,H){var J;L.debug("Cache Manager "+"_initIndexedDB started");function K(){try{J=window.indexedDB.open(i.defaultOptions.databaseName,1);}catch(e){L.error("Could not open Cache Manager database. Details: "+e.message);H(e.message);}}K();J.onerror=function(e){L.error("Could not initialize Cache Manager database. Details: "+e.message);H(e.error);};J.onsuccess=function(e){var N=F("init_onsuccess");i._db=J.result;i._db.onversionchange=function(e){if(!e.newVersion){e.target.close();}};i._loadMetaStructure().then(function(){L.debug("Cache Manager "+" metadataLoaded. Serialization support: "+C()+", resolving initIndexDb promise");p(i);},H);N.endSync();};J.onupgradeneeded=function(N){var O=N.target.result;O.onerror=function(N){L.error("Cache Manager error. Details: "+N.message);H(O.error);};try{var P=O.createObjectStore(i.defaultOptions._contentStoreName);O.createObjectStore(i.defaultOptions._metadataStoreName);}catch(e){L.error("Could not initialize Cache Manager object store. Details: "+e.message);throw e;}P.createIndex("ui5version","ui5version",{unique:false});};});}
function I(e,i,p,H){this.key=e;this.sOrigType=p;this.value=i;this.lu=H;}
function n(e,i,p,H,J,K){if(arguments.length===3){this.oData=e;this.sMeasureId=i;this.sMsrCat=p;}else{this.oData=new I(e,i,p,H);}}
n.prototype.deserialize=function(){if(C()&&this.oData.sOrigType==="object"){M.start(this.sMeasureId,this.sMeasureId,this.sMsrCat);this.oData.value=JSON.parse(this.oData.value);M.end(this.sMeasureId);G("Cache Manager LRUPersistentCache: de-serialization the result",this.oData.key,this.sMeasureId);}return this;};
n.prototype.serialize=function(){if(C()&&this.oData.sOrigType==="object"){M.start(this.sMeasureId,this.sMeasureId,this.sMsrCat);this.oData.value=JSON.stringify(this.oData.value);M.end(this.sMeasureId);G("Cache Manager LRUPersistentCache: serialization of the value",this.oData.key,this.sMeasureId);}return this;};
function o(e){return{__byKey__:{},__byIndex__:{},__ui5version:e};}
function q(e){var i=o(e.__ui5version);for(var p in e.__byIndex__){i.__byIndex__[p]=e.__byIndex__[p];}for(var H in e.__byKey__){i.__byKey__[H]=e.__byKey__[H];}return i;}
function r(e){var i=w(e._metadata.__byIndex__);e._mru=i.mru;e._lru=i.lru;L.debug("Cache Manager LRUPersistentCache: LRU counters are assigned to the CM: "+JSON.stringify(i));}
function t(e){return Object.keys(e._metadata.__byKey__).length;}
function v(e){var K=e._metadata.__byIndex__[e._lru];if(K==undefined&&!A(e)){return null;}else{return e._metadata.__byIndex__[e._lru];}}
function w(e){var i=-1,p=-1,H=Number.MAX_VALUE,J=Object.keys(e),K=J.length;if(K===0){return{mru:-1,lru:-1};}else{while(++i<K){var N=parseInt(J[i]);if(p<N){p=N;}if(H>N){H=N;}}return{mru:p,lru:H};}}
function x(e,i,p){return new Promise(function(H,J){var K=0;_(e,i,p);function _(e,i,p){K++;L.debug("Cache Manager LRUPersistentCache: cleanAndStore: freeing space attempt ["+(K)+"]");f(e).then(function(N){L.debug("Cache Manager LRUPersistentCache: cleanAndStore: deleted item with key ["+N+"]. Going to put "+i);return k(e,i,p).then(H,function(O){if(y(O)){L.debug("Cache Manager LRUPersistentCache: cleanAndStore: QuotaExceedError during freeing up space...");if(t(e)>0){_(e,i,p);}else{J("Cache Manager LRUPersistentCache: cleanAndStore: even when the cache is empty, the new item with key ["+i+"] cannot be added");}}else{J("Cache Manager LRUPersistentCache: cleanAndStore: cannot free space: "+B(O));}});},J);}});}
function y(e){return(e&&e.target&&e.target.error&&e.target.error.name==="QuotaExceededError");}
function z(e,i){var p=e._metadata.__byKey__[i];delete e._metadata.__byKey__[i];delete e._metadata.__byIndex__[p];A(e);}
function A(e){while(e._lru<=e._mru&&e._metadata.__byIndex__[e._lru]==undefined){e._lru++;}return(e._lru<=e._mru);}
function B(e){if(!e){return"";}var R=e.message;if(e.target&&e.target.error&&e.target.error.name){R+=" Error name: "+e.target.error.name;}return R;}
function C(){return sap.ui.getCore().getConfiguration().isUI5CacheSerializationSupportOn();}
function D(){return sap.ui.getCore().getConfiguration().getUI5CacheExcludedKeys();}
function E(e){return D().some(function(i){return e.indexOf(i)>-1;});}
function F(O,e){b++;var i="[async]  "+O+"["+e+"]- #"+(b),p="[sync ]  "+O+"["+e+"]- #"+(b);M.start(i,"CM",["LRUPersistentCache",O]);M.start(p,"CM",["LRUPersistentCache",O]);return{sMeasureAsync:i,sMeasureSync:p,endAsync:function(){M.end(this.sMeasureAsync);},endSync:function(){M.end(this.sMeasureSync);}};}
function G(e,K,i){if(L.getLevel()>=L.Level.DEBUG){L.debug(e+" for key ["+K+"] took: "+M.getMeasurement(i).duration);}}
return a;});
/*!
* OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
*/
sap.ui.predefine('sap/ui/core/hyphenation/Hyphenation',["./HyphenationTestingWords","sap/ui/base/ManagedObject","sap/base/Log","sap/base/util/deepEqual","sap/ui/core/Locale","sap/ui/Device"],function(H,M,L,d,a,D){"use strict";var t={'bg':true,'ca':true,'hr':true,'cs':false,
// no valid license
'da':true,'nl':true,'en-us':true,'et':true,'fi':true,'fr':true,'de':true,'el-monoton':true,'hi':true,'hu':true,'it':true,'lt':true,'nb-no':true,'pl':false,'pt':true,'ru':true,'sr':false,'sl':true,'es':true,'sv':true,'th':true,'tr':true,'uk':true};var l={"bg":"Bulgarian","ca":"Catalan","hr":"Croatian","cs":"Czech","da":"Danish","nl":"Dutch","en":"English","et":"Estonian","fi":"Finnish","fr":"French","de":"German","el":"Greek","hi":"Hindi","hu":"Hungarian","it":"Italian","lt":"Lithuanian","nb":"Norwegian Bokmål","no":"Norwegian","pl":"Polish","pt":"Portuguese","ru":"Russian","sr":"Serbian","sl":"Slovenian","es":"Spanish","sv":"Swedish","th":"Thai","tr":"Turkish","uk":"Ukrainian"};var b={};var s={};var T={};var h=null;var f=null;var o={};var p={};var c=[];var m={};
function i(E,F,G){L.info("[UI5 Hyphenation] Initializing third-party module for language "+z(E),"sap.ui.core.hyphenation.Hyphenation.initialize()");window.hyphenopoly.initializeLanguage(F).then(e.bind(this,E,G));}
function r(E,F,G){L.info("[UI5 Hyphenation] Re-initializing third-party module for language "+z(E),"sap.ui.core.hyphenation.Hyphenation.initialize()");window.hyphenopoly.reInitializeLanguage(E,F).then(e.bind(this,E,G));}
function e(E,F,G){o[E]=G;h.bIsInitialized=true;if(c.length>0){c.forEach(function(I){i(I.sLanguage,I.oConfig,I.resolve);});c=[];}h.bLoading=false;F(y(E));}
function g(E,F){var G={"require":[E],"hyphen":"\u00AD","leftmin":3,"rightmin":3,"compound":"all","path":sap.ui.require.toUrl("sap/ui/thirdparty/hyphenopoly")};if(F){if("hyphen"in F){G.hyphen=F.hyphen;}if("minWordLength"in F){G.minWordLength=F.minWordLength;}if("exceptions"in F){L.info("[UI5 Hyphenation] Add hyphenation exceptions '"+JSON.stringify(F.exceptions)+"' for language "+z(E),"sap.ui.core.hyphenation.Hyphenation");var W=[];Object.keys(F.exceptions).forEach(function(I){W.push(F.exceptions[I]);});if(W.length>0){G.exceptions={};G.exceptions[E]=W.join(", ");}}}return G;}
function j(P,F){return new Promise(function(E,G){var I=document.createElement('script');I.async=true;I.src=P+F;I.addEventListener('load',E);I.addEventListener('error',function(){return G('Error loading script: '+F);});I.addEventListener('abort',function(){return G(F+' Script loading aborted.');});document.head.appendChild(I);});}
var k=(function createCss(){var E=["visibility:hidden;","-moz-hyphens:auto;","-webkit-hyphens:auto;","-ms-hyphens:auto;","hyphens:auto;","width:48px;","font-size:12px;","line-height:12px;","border:none;","padding:0;","word-wrap:normal"];return E.join("");}());
function n(E){if(!f){f=document.createElement("body");}var F=document.createElement("div");F.lang=E;F.id=E;F.style.cssText=k;F.appendChild(document.createTextNode(H[E.toLowerCase()]));f.appendChild(F);}
function q(E){if(f){E.appendChild(f);return f;}return null;}
function u(){if(f){f.parentNode.removeChild(f);}}
function v(E){return(E.style.hyphens==="auto"||E.style.webkitHyphens==="auto"||E.style.msHyphens==="auto"||E.style["-moz-hyphens"]==="auto");}
function w(E){var F;if(E){F=new a(E);}else{F=sap.ui.getCore().getConfiguration().getLocale();}var G=F.getLanguage().toLowerCase();switch(G){case"en":G="en-us";break;case"nb":G="nb-no";break;case"no":G="nb-no";break;case"el":G="el-monoton";break;}return G;}
function x(E){if(E){return new a(E).toString();}return sap.ui.getCore().getConfiguration().getLocale().toString();}
function y(P){if(typeof P==="string"){return P.substring(0,2);}else{return null;}}
function z(P){var E=y(P);if(l.hasOwnProperty(E)){return"'"+l[E]+"' (code:'"+E+"')";}else{return"'"+E+"'";}}
function A(E){h.fireError(E);L.error("[UI5 Hyphenation] "+E,"sap.ui.core.hyphenation.Hyphenation");}
function B(){return!(D.os.macintosh&&D.browser.chrome);}
var C=M.extend("sap.ui.core.hyphenation.Hyphenation",{metadata:{library:"sap.ui.core",events:{error:{parameters:{sErrorMessage:{type:"string"}}}}}});
C.prototype.canUseNativeHyphenation=function(E){var F=x(E);var G;if(!this.isLanguageSupported(E)){return null;}if(!b.hasOwnProperty(F)){n(F);var I=q(document.documentElement);if(I!==null){var J=document.getElementById(F);if(B()&&v(J)&&J.offsetHeight>12){G=true;}else{G=false;}u();}b[F]=G;if(G){L.info("[UI5 Hyphenation] Browser-native hyphenation can be used for language "+z(F),"sap.ui.core.hyphenation.Hyphenation.canUseNativeHyphenation()");}else{L.info("[UI5 Hyphenation] Browser-native hyphenation is not supported by current platform for language "+z(F),"sap.ui.core.hyphenation.Hyphenation.canUseNativeHyphenation()");}}else{G=b[F];}return G;};
C.prototype.canUseThirdPartyHyphenation=function(E){var F=w(E),G;if(!this.isLanguageSupported(E)){return null;}if(!T.hasOwnProperty(F)){G=t.hasOwnProperty(F)&&t[F];if(G){L.info("[UI5 Hyphenation] Third-party hyphenation can be used for language "+z(F),"sap.ui.core.hyphenation.Hyphenation.canUseThirdPartyHyphenation()");}else{L.info("[UI5 Hyphenation] Third-party hyphenation is not supported for language "+z(F),"sap.ui.core.hyphenation.Hyphenation.canUseThirdPartyHyphenation()");}T[F]=G;}else{G=T[F];}return G;};
C.prototype.isLanguageSupported=function(E){var F=w(E),I;if(!s.hasOwnProperty(F)){I=H.hasOwnProperty(F);if(!I){L.info("[UI5 Hyphenation] Language "+z(F)+" is not known to the Hyphenation API","sap.ui.core.hyphenation.Hyphenation.isLanguageSupported()");}s[F]=I;}else{I=s[F];}return I;};
C.prototype.hyphenate=function(E,F){var G=w(F);if(!o.hasOwnProperty(G)){A("Language "+z(G)+" is not initialized. You have to initialize it first with method 'initialize()'");return E;}return o[G](E);};
C.prototype.getInitializedLanguages=function(){return Object.keys(o).map(function(E){return y(E);});};
C.prototype.isLanguageInitialized=function(E){var E=w(E);return Object.keys(o).indexOf(E)!=-1;};
C.prototype.getExceptions=function(E){var E=w(E);if(this.isLanguageInitialized(E)){return window.hyphenopoly.languages[E].exceptions;}else{A("Language "+z(E)+" is not initialized. You have to initialize it first with method 'initialize()'");}};
C.prototype.addExceptions=function(E,F){var E=w(E);if(this.isLanguageInitialized(E)){L.info("[UI5 Hyphenation] Add hyphenation exceptions '"+JSON.stringify(F)+"' for language "+z(E),"sap.ui.core.hyphenation.Hyphenation.addExceptions()");Object.keys(F).forEach(function(G){window.hyphenopoly.languages[E].cache[G]=F[G];window.hyphenopoly.languages[E].exceptions[G]=F[G];});}else{A("Language "+z(E)+" is not initialized. You have to initialize it first with method 'initialize()'");}};
C.prototype.initialize=function(E,F){var G=w(E);var F=g(G,F);var I=true;if(m[G]&&d(m[G],F)){I=false;}m[G]=F;if(t[G]){if(!h.bIsInitialized&&!h.bLoading){h.bLoading=true;p[G]=new Promise(function(K,N){j(F.path,"/hyphenopoly.bundle.js").then(i.bind(this,G,F,K));});return p[G];}else if(h.bLoading&&!o[G]&&p[G]){return p[G];}else if(this.isLanguageInitialized(G)){if(I){p[G]=new Promise(function(K){r(G,F,K);});}}else{p[G]=new Promise(function(K,N){if(!h.bIsInitialized){c.push({sLanguage:G,oConfig:F,resolve:K});}else{i(G,F,K);}});}h.bLoading=true;return p[G];}else{var J="Language "+z(E)+" can not be initialized. It is either not supported by the third-party module or an error occurred";A(J);return new Promise(function(K,N){N(J);});}};
C.getInstance=function(){if(!h){h=new C();h.bIsInitialized=false;h.bLoading=false;}return h;};
return C;});
/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/ui/core/library',['sap/ui/base/DataType','./CalendarType','./Core'],function(D,C){"use strict";sap.ui.getCore().initLibrary({name:"sap.ui.core",version:"1.82.2",designtime:"sap/ui/core/designtime/library.designtime",types:["any","boolean","float","int","object","string","void","sap.ui.core.AbsoluteCSSSize","sap.ui.core.AccessibleRole","sap.ui.core.AccessibleLandmarkRole","sap.ui.core.BarColor","sap.ui.core.BusyIndicatorSize","sap.ui.core.CalendarType","sap.ui.core.CSSColor","sap.ui.core.CSSSize","sap.ui.core.CSSSizeShortHand","sap.ui.core.Collision","sap.ui.core.ComponentLifecycle","sap.ui.core.Design","sap.ui.core.Dock","sap.ui.core.HorizontalAlign","sap.ui.core.ID","sap.ui.core.IconColor","sap.ui.core.ImeMode","sap.ui.core.IndicationColor","sap.ui.core.MessageType","sap.ui.core.OpenState","sap.ui.core.Orientation","sap.ui.core.Percentage","sap.ui.core.Priority","sap.ui.core.ScrollBarAction","sap.ui.core.Scrolling","sap.ui.core.SortOrder","sap.ui.core.TextAlign","sap.ui.core.TextDirection","sap.ui.core.TitleLevel","sap.ui.core.URI","sap.ui.core.ValueState","sap.ui.core.VerticalAlign","sap.ui.core.Wrapping","sap.ui.core.InvisibleMessageMode","sap.ui.core.dnd.DropEffect","sap.ui.core.dnd.DropLayout","sap.ui.core.dnd.DropPosition","sap.ui.core.mvc.ViewType","sap.ui.core.routing.HistoryDirection"],interfaces:["sap.ui.core.IShrinkable","sap.ui.core.Label","sap.ui.core.PopupInterface","sap.ui.core.Toolbar","sap.ui.core.IContextMenu","sap.ui.core.IFormContent","sap.ui.core.dnd.IDragInfo","sap.ui.core.dnd.IDropInfo","sap.ui.core.IDScope"],controls:["sap.ui.core.ComponentContainer","sap.ui.core.Control","sap.ui.core.HTML","sap.ui.core.Icon","sap.ui.core.InvisibleText","sap.ui.core.LocalBusyIndicator","sap.ui.core.ScrollBar","sap.ui.core.TooltipBase","sap.ui.core.XMLComposite","sap.ui.core.mvc.HTMLView","sap.ui.core.mvc.JSONView","sap.ui.core.mvc.JSView","sap.ui.core.mvc.TemplateView","sap.ui.core.mvc.View","sap.ui.core.mvc.XMLView","sap.ui.core.tmpl.DOMElement","sap.ui.core.tmpl.TemplateControl","sap.ui.core.util.Export"],elements:["sap.ui.core.CustomData","sap.ui.core.Element","sap.ui.core.Item","sap.ui.core.LayoutData","sap.ui.core.ListItem","sap.ui.core.Message","sap.ui.core.SeparatorItem","sap.ui.core.Title","sap.ui.core.VariantLayoutData","sap.ui.core.dnd.DragDropBase","sap.ui.core.dnd.DragInfo","sap.ui.core.dnd.DropInfo","sap.ui.core.dnd.DragDropInfo","sap.ui.core.search.OpenSearchProvider","sap.ui.core.search.SearchProvider","sap.ui.core.tmpl.DOMAttribute","sap.ui.core.util.ExportCell","sap.ui.core.InvisibleMessage"],extensions:{"sap.ui.support":{diagnosticPlugins:["sap/ui/core/support/plugins/TechInfo","sap/ui/core/support/plugins/ControlTree","sap/ui/core/support/plugins/Debugging","sap/ui/core/support/plugins/Trace","sap/ui/core/support/plugins/Selector","sap/ui/core/support/plugins/Breakpoint","sap/ui/core/support/plugins/ViewInfo","sap/ui/core/support/plugins/LocalStorage","sap/ui/core/support/plugins/Interaction","sap/ui/core/support/plugins/Performance"],publicRules:true,internalRules:true}}});var t=sap.ui.core;t.AbsoluteCSSSize=D.createType('sap.ui.core.AbsoluteCSSSize',{isValid:function(v){return/^([-+]?(0*|([0-9]+|[0-9]*\.[0-9]+)([rR][eE][mM]|[eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC]))|calc\(\s*(\(\s*)*[-+]?(([0-9]+|[0-9]*\.[0-9]+)([rR][eE][mM]|[eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC])?)(\s*(\)\s*)*(\s[-+]\s|[*\/])\s*(\(\s*)*([-+]?(([0-9]+|[0-9]*\.[0-9]+)([rR][eE][mM]|[eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC])?)))*\s*(\)\s*)*\))$/.test(v);}},D.getType('string'));t.AccessibleRole={Alert:"Alert",AlertDialog:"AlertDialog",Application:"Application",Banner:"Banner",Button:"Button",Checkbox:"Checkbox",ColumnHeader:"ColumnHeader",Combobox:"Combobox",
/**
		 * Information about the content on the page. Examples are footnotes, copyrights, or links to privacy statements.
		 *
		 * @public
		 */
ContentInfo:"ContentInfo",Definition:"Definition",Description:"Description",Dialog:"Dialog",Directory:"Directory",Document:"Document",Grid:"Grid",GridCell:"GridCell",Group:"Group",Heading:"Heading",Img:"Img",Link:"Link",List:"List",Listbox:"Listbox",ListItem:"ListItem",Log:"Log",Main:"Main",Marquee:"Marquee",Menu:"Menu",Menubar:"Menubar",MenuItem:"MenuItem",MenuItemCheckbox:"MenuItemCheckbox",MenuItemRadio:"MenuItemRadio",Navigation:"Navigation",Note:"Note",Option:"Option",Presentation:"Presentation",ProgressBar:"ProgressBar",Radio:"Radio",RadioGroup:"RadioGroup",Region:"Region",Row:"Row",RowHeader:"RowHeader",Search:"Search",Secondary:"Secondary",SeeAlso:"SeeAlso",Separator:"Separator",Slider:"Slider",SpinButton:"SpinButton",Status:"Status",Tab:"Tab",Tablist:"Tablist",Tabpanel:"Tabpanel",Textbox:"Textbox",Timer:"Timer",Toolbar:"Toolbar",Tooltip:"Tooltip",Tree:"Tree",TreeGrid:"TreeGrid",TreeItem:"TreeItem"};t.AccessibleLandmarkRole={None:"None",Banner:"Banner",Main:"Main",Region:"Region",Navigation:"Navigation",Search:"Search",Complementary:"Complementary",Form:"Form",ContentInfo:"ContentInfo"};t.BarColor={NEUTRAL:"NEUTRAL",POSITIVE:"POSITIVE",CRITICAL:"CRITICAL",NEGATIVE:"NEGATIVE"};t.BusyIndicatorSize={Auto:"Auto",Small:"Small",Medium:"Medium",Large:"Large"};t.CSSColor=D.createType('sap.ui.core.CSSColor',{isValid:function(v){return/^(#([0-9a-fA-F]{3}|[0-9a-fA-F]{6})|rgb\(\s*((1?[0-9]?[0-9]|2([0-4][0-9]|5[0-5]))|([0-9]?[0-9](\.[0-9]+)?|100(\.0+)?)%)\s*(,\s*((1?[0-9]?[0-9]|2([0-4][0-9]|5[0-5]))|([0-9]?[0-9](\.[0-9]+)?|100(\.0+)?)%)\s*){2}\)|rgba\((\s*((1?[0-9]?[0-9]|2([0-4][0-9]|5[0-5]))|([0-9]?[0-9](\.[0-9]+)?|100(\.0+)?)%)\s*,){3}\s*(0(\.[0-9]+)?|1(\.0+)?)\s*\)|hsl\(\s*([0-2]?[0-9]?[0-9]|3([0-5][0-9]|60))\s*(,\s*(([0-9]?[0-9](\.[0-9]+)?|100(\.0+)?)%)\s*){2}\)|hsla\(\s*([0-2]?[0-9]?[0-9]|3([0-5][0-9]|60))\s*,(\s*(([0-9]?[0-9](\.[0-9]+)?|100(\.0+)?)%)\s*,){2}\s*(0(\.[0-9]+)?|1(\.0+)?)\s*\)|aliceblue|antiquewhite|aqua|aquamarine|azure|beige|bisque|black|blanchedalmond|blue|blueviolet|brown|burlywood|cadetblue|chartreuse|chocolate|coral|cornflowerblue|cornsilk|crimson|cyan|darkblue|darkcyan|darkgoldenrod|darkgray|darkgrey|darkgreen|darkkhaki|darkmagenta|darkolivegreen|darkorange|darkorchid|darkred|darksalmon|darkseagreen|darkslateblue|darkslategray|darkslategrey|darkturquoise|darkviolet|deeppink|deepskyblue|dimgray|dimgrey|dodgerblue|firebrick|floralwhite|forestgreen|fuchsia|gainsboro|ghostwhite|gold|goldenrod|gray|grey|green|greenyellow|honeydew|hotpink|indianred|indigo|ivory|khaki|lavender|lavenderblush|lawngreen|lemonchiffon|lightblue|lightcoral|lightcyan|lightgoldenrodyellow|lightgray|lightgrey|lightgreen|lightpink|lightsalmon|lightseagreen|lightskyblue|lightslategray|lightslategrey|lightsteelblue|lightyellow|lime|limegreen|linen|magenta|maroon|mediumaquamarine|mediumblue|mediumorchid|mediumpurple|mediumseagreen|mediumslateblue|mediumspringgreen|mediumturquoise|mediumvioletred|midnightblue|mintcream|mistyrose|moccasin|navajowhite|navy|oldlace|olive|olivedrab|orange|orangered|orchid|palegoldenrod|palegreen|paleturquoise|palevioletred|papayawhip|peachpuff|peru|pink|plum|powderblue|purple|red|rosybrown|royalblue|saddlebrown|salmon|sandybrown|seagreen|seashell|sienna|silverskyblue|slateblue|slategray|slategrey|snow|springgreen|steelblue|tan|teal|thistle|tomato|turquoise|violet|wheat|white|whitesmoke|yellow|yellowgreen|transparent|inherit|)$/.test(v);}},D.getType('string'));t.CSSSize=D.createType('sap.ui.core.CSSSize',{isValid:function(v){return/^(auto|inherit|[-+]?(0*|([0-9]+|[0-9]*\.[0-9]+)([rR][eE][mM]|[eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC]|[vV][wW]|[vV][hH]|[vV][mM][iI][nN]|[vV][mM][aA][xX]|%))|calc\(\s*(\(\s*)*[-+]?(([0-9]+|[0-9]*\.[0-9]+)([rR][eE][mM]|[eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC]|[vV][wW]|[vV][hH]|[vV][mM][iI][nN]|[vV][mM][aA][xX]|%)?)(\s*(\)\s*)*(\s[-+]\s|[*\/])\s*(\(\s*)*([-+]?(([0-9]+|[0-9]*\.[0-9]+)([rR][eE][mM]|[eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC]|[vV][wW]|[vV][hH]|[vV][mM][iI][nN]|[vV][mM][aA][xX]|%)?)))*\s*(\)\s*)*\))$/.test(v);}},D.getType('string'));t.CSSSizeShortHand=D.createType('sap.ui.core.CSSSizeShortHand',{isValid:function(v){return/^(inherit|(auto|[-+]?(0*|(\d+|\d*\.\d+)([eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC]|%))){1}(\s(auto|[-+]?(0*|(\d+|\d*\.\d+)([eE][mM]|[eE][xX]|[pP][xX]|[cC][mM]|[mM][mM]|[iI][nN]|[pP][tT]|[pP][cC]|%)))){0,3})$/.test(v);}},D.getType('string'));t.Collision=D.createType('sap.ui.core.Collision',{isValid:function(v){return/^((flip|fit|none)( (flip|fit|none))?)$/.test(v);}},D.getType('string'));t.Design={Standard:"Standard",Monospace:"Monospace"};t.Dock=D.createType('sap.ui.core.Dock',{isValid:function(v){return/^((begin|left|center|right|end) (top|center|bottom))$/.test(v);}},D.getType('string'));t.HorizontalAlign={Begin:"Begin",End:"End",Left:"Left",Right:"Right",Center:"Center"};t.ID=D.createType('sap.ui.core.ID',{isValid:function(v){return/^([A-Za-z_][-A-Za-z0-9_.:]*)$/.test(v);}},D.getType('string'));t.IconColor={Default:"Default",Positive:"Positive",Negative:"Negative",Critical:"Critical",Neutral:"Neutral",Contrast:"Contrast",NonInteractive:"NonInteractive",Tile:"Tile",Marker:"Marker"};t.ImeMode={Auto:"Auto",Active:"Active",Inactive:"Inactive",Disabled:"Disabled"};t.IndicationColor={Indication01:"Indication01",Indication02:"Indication02",Indication03:"Indication03",Indication04:"Indication04",Indication05:"Indication05",Indication06:"Indication06",Indication07:"Indication07",Indication08:"Indication08"};t.MessageType={Information:"Information",Warning:"Warning",Error:"Error",None:"None",Success:"Success"};t.OpenState={OPEN:"OPEN",CLOSED:"CLOSED",OPENING:"OPENING",CLOSING:"CLOSING"};t.Orientation={Horizontal:"Horizontal",Vertical:"Vertical"};t.Percentage=D.createType('sap.ui.core.Percentage',{isValid:function(v){return/^([0-9][0-9]*(\.[0-9]+)?%)$/.test(v);}},D.getType('string'));t.Priority={None:"None",Low:"Low",Medium:"Medium",High:"High"};t.ScrollBarAction={Step:"Step",Page:"Page",MouseWheel:"MouseWheel",Drag:"Drag"};t.Scrolling={None:"None",Auto:"Auto",Scroll:"Scroll",Hidden:"Hidden"};t.SortOrder={None:"None",Ascending:"Ascending",Descending:"Descending"};t.TextAlign={Begin:"Begin",End:"End",Left:"Left",Right:"Right",Center:"Center",Initial:"Initial"};t.TextDirection={LTR:"LTR",RTL:"RTL",Inherit:"Inherit"};t.TitleLevel={Auto:"Auto",H1:"H1",H2:"H2",H3:"H3",H4:"H4",H5:"H5",H6:"H6"};t.URI=D.createType('sap.ui.core.URI',{isValid:function(v){return/^((([^:\/?#]+):)?(\/\/([^\/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?)$/.test(v);}},D.getType('string'));t.ValueState={Error:"Error",Warning:"Warning",Success:"Success",Information:"Information",None:"None"};t.VerticalAlign={Bottom:"Bottom",Middle:"Middle",Top:"Top",Inherit:"Inherit"};t.Wrapping={None:"None",Soft:"Soft",Hard:"Hard",Off:"Off"};t.dnd=t.dnd||{};t.dnd.DropPosition={On:"On",Between:"Between",OnOrBetween:"OnOrBetween"};t.dnd.DropLayout={Default:"Default",Vertical:"Vertical",Horizontal:"Horizontal"};t.dnd.DropEffect={Copy:"Copy",Move:"Move",Link:"Link",None:"None"};t.mvc=t.mvc||{};t.mvc.ViewType={JSON:"JSON",XML:"XML",HTML:"HTML",JS:"JS",Template:"Template"};t.routing=t.routing||{};t.routing.HistoryDirection={Forwards:"Forwards",Backwards:"Backwards",NewEntry:"NewEntry",Unknown:"Unknown"};sap.ui.core.ComponentLifecycle={Legacy:"Legacy",Application:"Application",Container:"Container"};sap.ui.core.InvisibleMessageMode={Polite:"Polite",Assertive:"Assertive"};var l=sap.ui.lazyRequire;
function e(p,c,s){for(var i=0;i<c.length;i++){if(s){l(s,c[i].toLowerCase(),p+c[i]);}else{l(p+c[i],"new extend getMetadata");}}}
l("sap.ui.core.BusyIndicator","show hide attachOpen detachOpen attachClose detachClose");l("sap.ui.core.tmpl.Template","registerType unregisterType");l("sap.ui.core.Fragment","registerType byId createId");l("sap.ui.core.IconPool","createControlByURI addIcon getIconURI getIconInfo isIconURI getIconCollectionNames getIconNames getIconForMimeType");l("sap.ui.core.service.ServiceFactoryRegistry","register unregister get");l("sap.ui.model.odata.AnnotationHelper","createPropertySetting format getNavigationPath"+" gotoEntitySet gotoEntityType gotoFunctionImport isMultiple resolvePath simplePath");var A=sap.ui.model&&sap.ui.model.odata&&sap.ui.model.odata.AnnotationHelper;if(A){A.format.requiresIContext=true;A.getNavigationPath.requiresIContext=true;A.isMultiple.requiresIContext=true;A.simplePath.requiresIContext=true;}l("sap.ui","xmlfragment","sap.ui.core.Fragment");l("sap.ui","jsfragment","sap.ui.core.Fragment");l("sap.ui","htmlfragment","sap.ui.core.Fragment");e("sap.ui.model.",["Filter","Sorter","json.JSONModel","resource.ResourceModel","odata.ODataModel","odata.v2.ODataModel","odata.v4.ODataModel","xml.XMLModel"]);e("sap.ui.model.type.",["Boolean","Integer","Float","String","Date","Time","DateTime","FileSize","Currency","Unit","DateInterval","DateTimeInterval","TimeInterval"]);e("sap.ui.model.odata.type.",["Boolean","Byte","Currency","Date","DateTime","DateTimeOffset","Double","Decimal","Guid","Int16","Int32","Int64","Raw","SByte","Single","Stream","String","Time","TimeOfDay","Unit"]);e("sap.ui.core.",["Locale","LocaleData","mvc.Controller","UIComponent"]);e("sap.ui.core.mvc.",["Controller","View","JSView","JSONView","XMLView","HTMLView","TemplateView"],"sap.ui");e("sap.ui.core.",["Component"],"sap.ui");e("sap.ui.core.tmpl.",["Template"],"sap.ui");e("sap.ui.core.routing.",["HashChanger","History","Route","Router","Target","Targets","Views"]);e("sap.ui.core.service.",["ServiceFactory","Service"]);return sap.ui.core;});
/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
sap.ui.predefine('sap/ui/dom/jquery/zIndex',['sap/ui/thirdparty/jquery'],function(q){"use strict";
function g(t,p){var d=Object.getOwnPropertyDescriptor(t,p);return d&&d.value;}
if(!g(q.fn,"zIndex")){var f=function(z){if(z!==undefined){return this.css("zIndex",z);}if(this.length){var e=q(this[0]),p,v;while(e.length&&e[0]!==document){p=e.css("position");if(p==="absolute"||p==="relative"||p==="fixed"){v=parseInt(e.css("zIndex"));if(!isNaN(v)&&v!==0){return v;}}e=e.parent();}}return 0;};
/*!
		 * The following function is taken from
		 * jQuery UI Core 1.11.1
		 * http://jqueryui.com
		 *
		 * Copyright 2014 jQuery Foundation and other contributors
		 * Released under the MIT license.
		 * http://jquery.org/license
		 *
		 * http://api.jqueryui.com/category/ui-core/
		 */
q.fn.zIndex=f;}return q;});
sap.ui.require.preload({
	"sap/ui/core/manifest.json":'{"_version":"1.21.0","sap.app":{"id":"sap.ui.core","type":"library","embeds":[],"applicationVersion":{"version":"1.82.2"},"title":"The SAPUI5 Core Runtime.","description":"The SAPUI5 Core Runtime.\\n\\n  Contains the UI5 jQuery plugins (jQuery.sap.*), the Core and all its components,\\n  base classes for Controls, Components and the Model View Controller classes.","ach":"CA-UI5-COR","resources":"resources.json","offline":true,"openSourceComponents":[{"name":"jquery","packagedWithMySelf":true,"version":"0.0.0"},{"name":"jquery-migrate","packagedWithMySelf":true,"version":"0.0.0"},{"name":"jquery_mobile","packagedWithMySelf":true,"version":"0.0.0"},{"name":"qunit-composite","packagedWithMySelf":true,"version":"0.0.0"},{"name":"qunit-reporter-junit","packagedWithMySelf":true,"version":"0.0.0"},{"name":"iscroll","packagedWithMySelf":true,"version":"0.0.0"},{"name":"swipeview","packagedWithMySelf":true,"version":"0.0.0"},{"name":"mobify","packagedWithMySelf":true,"version":"0.0.0"},{"name":"zynga","packagedWithMySelf":true,"version":"0.0.0"},{"name":"less","packagedWithMySelf":true,"version":"0.0.0"},{"name":"datajs","packagedWithMySelf":true,"version":"0.0.0"},{"name":"d3","packagedWithMySelf":true,"version":"0.0.0"},{"name":"jszip","packagedWithMySelf":true,"version":"0.0.0"},{"name":"caja","packagedWithMySelf":true,"version":"0.0.0"},{"name":"cldr","packagedWithMySelf":true,"version":"0.0.0"},{"name":"mobiscroll","packagedWithMySelf":true,"version":"0.0.0"},{"name":"sinonjs","packagedWithMySelf":true,"version":"0.0.0"},{"name":"urijs","packagedWithMySelf":true,"version":"0.0.0"},{"name":"punycodejs","packagedWithMySelf":true,"version":"0.0.0"},{"name":"flexie.js","packagedWithMySelf":true,"version":"0.0.0"},{"name":"handlebars","packagedWithMySelf":true,"version":"0.0.0"},{"name":"requirejs","packagedWithMySelf":true,"version":"0.0.0"},{"name":"crossroadsjs","packagedWithMySelf":true,"version":"0.0.0"},{"name":"hasherjs","packagedWithMySelf":true,"version":"0.0.0"},{"name":"jssignals","packagedWithMySelf":true,"version":"0.0.0"},{"name":"blanket","packagedWithMySelf":true,"version":"0.0.0"},{"name":"array-polyfills","packagedWithMySelf":true,"version":"0.0.0"},{"name":"Element-getAttributeNames-polyfill","packagedWithMySelf":true,"version":"0.0.0"},{"name":"object-assign-polyfill","packagedWithMySelf":true,"version":"0.0.0"},{"name":"unorm","packagedWithMySelf":true,"version":"0.0.0"},{"name":"tdop","packagedWithMySelf":true,"version":"0.0.0"},{"name":"es6-promise","packagedWithMySelf":true,"version":"0.0.0"},{"name":"es6-string-method-startsWith","packagedWithMySelf":true,"version":"0.0.0"},{"name":"es6-string-methods-endsWith","packagedWithMySelf":true,"version":"0.0.0"},{"name":"es6-string-methods-includes","packagedWithMySelf":true,"version":"0.0.0"},{"name":"es6-string-methods-repeat","packagedWithMySelf":true,"version":"0.0.0"},{"name":"es6-string-methods-pad","packagedWithMySelf":true,"version":"0.0.0"},{"name":"klayjs","packagedWithMySelf":true,"version":"0.0.0"},{"name":"bignumber","packagedWithMySelf":true,"version":"0.0.0"},{"name":"lodash","packagedWithMySelf":true,"version":"0.0.0"},{"name":"hyphenopoly","packagedWithMySelf":true,"version":"0.0.0"},{"name":"es6-shim-nopromise","packagedWithMySelf":true,"version":"0.0.0"},{"name":"p-cancelable","packagedWithMySelf":true,"version":"0.0.0"},{"name":"@babel/helpers","packagedWithMySelf":true,"version":"0.0.0"}]},"sap.ui":{"technology":"UI5","supportedThemes":["base","sap_hcb"]},"sap.ui5":{"dependencies":{"minUI5Version":"1.82","libs":{}},"library":{"i18n":{"bundleUrl":"messagebundle.properties","supportedLocales":["","ar","bg","ca","cs","da","de","el","en","en-US-sappsd","en-US-saptrc","es","et","fi","fr","hi","hr","hu","it","iw","ja","kk","ko","lt","lv","ms","nl","no","pl","pt","rigi","ro","ru","sh","sk","sl","sv","th","tr","uk","vi","zh-CN","zh-TW"]},"content":{"controls":["sap.ui.core.ComponentContainer","sap.ui.core.Control","sap.ui.core.HTML","sap.ui.core.Icon","sap.ui.core.InvisibleText","sap.ui.core.LocalBusyIndicator","sap.ui.core.ScrollBar","sap.ui.core.TooltipBase","sap.ui.core.XMLComposite","sap.ui.core.mvc.HTMLView","sap.ui.core.mvc.JSONView","sap.ui.core.mvc.JSView","sap.ui.core.mvc.TemplateView","sap.ui.core.mvc.View","sap.ui.core.mvc.XMLView","sap.ui.core.tmpl.DOMElement","sap.ui.core.tmpl.TemplateControl","sap.ui.core.util.Export"],"elements":["sap.ui.core.CustomData","sap.ui.core.Element","sap.ui.core.Item","sap.ui.core.LayoutData","sap.ui.core.ListItem","sap.ui.core.Message","sap.ui.core.SeparatorItem","sap.ui.core.Title","sap.ui.core.VariantLayoutData","sap.ui.core.dnd.DragDropBase","sap.ui.core.dnd.DragInfo","sap.ui.core.dnd.DropInfo","sap.ui.core.dnd.DragDropInfo","sap.ui.core.search.OpenSearchProvider","sap.ui.core.search.SearchProvider","sap.ui.core.tmpl.DOMAttribute","sap.ui.core.util.ExportCell","sap.ui.core.InvisibleMessage"],"types":["any","boolean","float","int","object","string","void","sap.ui.core.AbsoluteCSSSize","sap.ui.core.AccessibleRole","sap.ui.core.AccessibleLandmarkRole","sap.ui.core.BarColor","sap.ui.core.BusyIndicatorSize","sap.ui.core.CalendarType","sap.ui.core.CSSColor","sap.ui.core.CSSSize","sap.ui.core.CSSSizeShortHand","sap.ui.core.Collision","sap.ui.core.ComponentLifecycle","sap.ui.core.Design","sap.ui.core.Dock","sap.ui.core.HorizontalAlign","sap.ui.core.ID","sap.ui.core.IconColor","sap.ui.core.ImeMode","sap.ui.core.IndicationColor","sap.ui.core.MessageType","sap.ui.core.OpenState","sap.ui.core.Orientation","sap.ui.core.Percentage","sap.ui.core.Priority","sap.ui.core.ScrollBarAction","sap.ui.core.Scrolling","sap.ui.core.SortOrder","sap.ui.core.TextAlign","sap.ui.core.TextDirection","sap.ui.core.TitleLevel","sap.ui.core.URI","sap.ui.core.ValueState","sap.ui.core.VerticalAlign","sap.ui.core.Wrapping","sap.ui.core.InvisibleMessageMode","sap.ui.core.dnd.DropEffect","sap.ui.core.dnd.DropLayout","sap.ui.core.dnd.DropPosition","sap.ui.core.mvc.ViewType","sap.ui.core.routing.HistoryDirection"],"interfaces":["sap.ui.core.IShrinkable","sap.ui.core.Label","sap.ui.core.PopupInterface","sap.ui.core.Toolbar","sap.ui.core.IContextMenu","sap.ui.core.IFormContent","sap.ui.core.dnd.IDragInfo","sap.ui.core.dnd.IDropInfo","sap.ui.core.IDScope"]}}}}',
/*!!
 * Hasher <http://github.com/millermedeiros/hasher>
 * @author Miller Medeiros
 * @version 1.2.0 (2013/11/11 03:18 PM)
 * Released under the MIT License
 */
	"sap/ui/thirdparty/hasher.js":function(){;(function(){var f=function(s){var h=(function(w){var P=25,d=w.document,a=w.history,S=s.Signal,h,_,b,c,g,i,j=/#(.*)$/,k=/(\?.*)|(\#.*)/,l=/^\#/,m=(!+"\v1"),n=('onhashchange'in w)&&d.documentMode!==7,o=m&&!n,p=(location.protocol==='file:');function q(e){return String(e||'').replace(/\W/g,"\\$&");}function r(e){if(!e)return'';var D=new RegExp('^'+q(h.prependHash)+'|'+q(h.appendHash)+'$','g');return e.replace(D,'');}function t(){var D=j.exec(h.getURL());var E=(D&&D[1])||'';try{return h.raw?E:decodeURIComponent(E);}catch(e){return E;}}function u(){return(g)?g.contentWindow.frameHash:null;}function v(){g=d.createElement('iframe');g.src='about:blank';g.style.display='none';d.body.appendChild(g);}function x(){if(g&&_!==u()){var e=g.contentWindow.document;e.open();e.write('<html><head><title>'+d.title+'</title><script type="text/javascript">var frameHash="'+_+'";</script></head><body>&nbsp;</body></html>');e.close();}}function y(e,D){if(_!==e){var E=_;_=e;if(o){if(!D){x();}else{g.contentWindow.frameHash=e;}}return function(){h.changed.dispatch(r(e),r(E));};}}if(o){i=function(){var e=t(),D=u(),E;if(D!==_&&D!==e){h.setHash(r(D));}else if(e!==_){E=y(e);E&&E();}};}else{i=function(){var e=t(),D;if(e!==_){D=y(e);D&&D();}};}function z(e,D,E){if(e.addEventListener){e.addEventListener(D,E,false);}else if(e.attachEvent){e.attachEvent('on'+D,E);}}function A(e,D,E){if(e.removeEventListener){e.removeEventListener(D,E,false);}else if(e.detachEvent){e.detachEvent('on'+D,E);}}function B(e){e=Array.prototype.slice.call(arguments);var D=e.join(h.separator);D=D?h.prependHash+D.replace(l,'')+h.appendHash:D;return D;}function C(e){e=encodeURI(e);if(m&&p){e=e.replace(/\?/,'%3F');}return e;}h={VERSION:'1.2.0',raw:false,appendHash:'',prependHash:'/',separator:'/',changed:new S(),stopped:new S(),initialized:new S(),init:function(){if(c)return;_=t();if(n){z(w,'hashchange',i);}else{if(o){if(!g){v();}x();}b=setInterval(i,P);}c=true;h.initialized.dispatch(r(_));},stop:function(){if(!c)return;if(n){A(w,'hashchange',i);}else{clearInterval(b);b=null;}c=false;h.stopped.dispatch(r(_));},isActive:function(){return c;},getURL:function(){return w.location.href;},getBaseURL:function(){return h.getURL().replace(k,'');},setHash:function(e){var D;e=B.apply(null,arguments);if(e!==_){D=y(e);if(!h.raw){e=C(e);}w.location.hash='#'+e;D&&D();}},replaceHash:function(e){var D,E=w.location.href,F=E.indexOf("#");e=B.apply(null,arguments);if(e!==_){D=y(e);if(!h.raw){e=C(e);}if(F!==-1){E=E.slice(0,F);}w.location.replace(E+'#'+e);D&&D();}},getHash:function(){return r(_);},getHashAsArray:function(){return h.getHash().split(h.separator);},dispose:function(){h.stop();h.initialized.dispose();h.stopped.dispose();h.changed.dispose();g=h=w.hasher=null;},toString:function(){return'[hasher version="'+h.VERSION+'" hash="'+h.getHash()+'"]';}};h.initialized.memorize=true;return h;}(window));return h;};if(typeof define==='function'&&define.amd){define(['signals'],f);}else if(typeof exports==='object'){module.exports=f(require('signals'));}else{window['hasher']=f(window['signals']);}}());
},
/** @license
 * JS Signals <http://millermedeiros.github.com/js-signals/>
 * Released under the MIT license
 * Author: Miller Medeiros
 * Version: 1.0.0 - Build: 268 (2012/11/29 05:48 PM)
 */
	"sap/ui/thirdparty/signals.js":function(){(function(g){
function S(b,l,i,c,p){this._listener=l;this._isOnce=i;this.context=c;this._signal=b;this._priority=p||0;}
S.prototype={active:true,params:null,execute:function(p){var h,b;if(this.active&&!!this._listener){b=this.params?this.params.concat(p):p;h=this._listener.apply(this.context,b);if(this._isOnce){this.detach();}}return h;},detach:function(){return this.isBound()?this._signal.remove(this._listener,this.context):null;},isBound:function(){return(!!this._signal&&!!this._listener);},isOnce:function(){return this._isOnce;},getListener:function(){return this._listener;},getSignal:function(){return this._signal;},_destroy:function(){delete this._signal;delete this._listener;delete this.context;},toString:function(){return'[SignalBinding isOnce:'+this._isOnce+', isBound:'+this.isBound()+', active:'+this.active+']';}};
function v(l,n){if(typeof l!=='function'){throw new Error('listener is a required param of {fn}() and should be a Function.'.replace('{fn}',n));}}
function a(){this._bindings=[];this._prevParams=null;var b=this;this.dispatch=function(){a.prototype.dispatch.apply(b,arguments);};}
a.prototype={VERSION:'1.0.0',memorize:false,_shouldPropagate:true,active:true,_registerListener:function(l,i,b,p){var c=this._indexOfListener(l,b),d;if(c!==-1){d=this._bindings[c];if(d.isOnce()!==i){throw new Error('You cannot add'+(i?'':'Once')+'() then add'+(!i?'':'Once')+'() the same listener without removing the relationship first.');}}else{d=new S(this,l,i,b,p);this._addBinding(d);}if(this.memorize&&this._prevParams){d.execute(this._prevParams);}return d;},_addBinding:function(b){var n=this._bindings.length;do{--n;}while(this._bindings[n]&&b._priority<=this._bindings[n]._priority);this._bindings.splice(n+1,0,b);},_indexOfListener:function(l,c){var n=this._bindings.length,b;while(n--){b=this._bindings[n];if(b._listener===l&&b.context===c){return n;}}return-1;},has:function(l,c){return this._indexOfListener(l,c)!==-1;},add:function(l,b,p){v(l,'add');return this._registerListener(l,false,b,p);},addOnce:function(l,b,p){v(l,'addOnce');return this._registerListener(l,true,b,p);},remove:function(l,c){v(l,'remove');var i=this._indexOfListener(l,c);if(i!==-1){this._bindings[i]._destroy();this._bindings.splice(i,1);}return l;},removeAll:function(){var n=this._bindings.length;while(n--){this._bindings[n]._destroy();}this._bindings.length=0;},getNumListeners:function(){return this._bindings.length;},halt:function(){this._shouldPropagate=false;},dispatch:function(p){if(!this.active){return;}var b=Array.prototype.slice.call(arguments),n=this._bindings.length,c;if(this.memorize){this._prevParams=b;}if(!n){return;}c=this._bindings.slice();this._shouldPropagate=true;do{n--;}while(c[n]&&this._shouldPropagate&&c[n].execute(b)!==false);},forget:function(){this._prevParams=null;},dispose:function(){this.removeAll();delete this._bindings;delete this._prevParams;},toString:function(){return'[Signal active:'+this.active+' numListeners:'+this.getNumListeners()+']';}};var s=a;s.Signal=a;if(typeof define==='function'&&define.amd){define(function(){return s;});}else{g['signals']=s;}}(this));
},
/** @license
 * crossroads <http://millermedeiros.github.com/crossroads.js/>
 * Author: Miller Medeiros | MIT License
 * v0.12.0 (2013/01/21 13:47)
 */
	"sap/ui/thirdparty/crossroads.js":function(){(function(){var f=function(s){var c,_,U;_=(/t(.+)?/).exec('t')[1]==='';function a(i,v){if(i.indexOf){return i.indexOf(v);}else{var n=i.length;while(n--){if(i[n]===v){return n;}}return-1;}}function b(l,m){var i=a(l,m);if(i!==-1){l.splice(i,1);}}function d(v,i){return'[object '+i+']'===Object.prototype.toString.call(v);}function e(v){return d(v,'RegExp');}function g(v){return d(v,'Array');}function h(v){return typeof v==='function';}function t(v){var r;if(v===null||v==='null'){r=null;}else if(v==='true'){r=true;}else if(v==='false'){r=false;}else if(v===U||v==='undefined'){r=U;}else if(v===''||isNaN(v)){r=v;}else{r=parseFloat(v);}return r;}function j(v){var n=v.length,r=[];while(n--){r[n]=t(v[n]);}return r;}function k(i,l){var q=(i||'').replace('?','').split('&'),n=q.length,o={},m,v;while(n--){m=q[n].split('=');v=l?t(m[1]):m[1];o[m[0]]=(typeof v==='string')?decodeURIComponent(v):v;}return o;}function C(){this.bypassed=new s.Signal();this.routed=new s.Signal();this._routes=[];this._prevRoutes=[];this._piped=[];this.resetState();}C.prototype={greedy:false,greedyEnabled:true,ignoreCase:true,ignoreState:false,shouldTypecast:false,normalizeFn:null,resetState:function(){this._prevRoutes.length=0;this._prevMatchedRequest=null;this._prevBypassedRequest=null;},create:function(){return new C();},addRoute:function(p,i,l){var r=new R(p,i,l,this);this._sortedInsert(r);return r;},removeRoute:function(r){b(this._routes,r);r._destroy();},removeAllRoutes:function(){var n=this.getNumRoutes();while(n--){this._routes[n]._destroy();}this._routes.length=0;},parse:function(r,l){r=r||'';l=l||[];if(!this.ignoreState&&(r===this._prevMatchedRequest||r===this._prevBypassedRequest)){return;}var m=this._getMatchedRoutes(r),i=0,n=m.length,o;if(n){this._prevMatchedRequest=r;this._notifyPrevRoutes(m,r);this._prevRoutes=m;while(i<n){o=m[i];o.route.matched.dispatch.apply(o.route.matched,l.concat(o.params));o.isFirst=!i;this.routed.dispatch.apply(this.routed,l.concat([r,o]));i+=1;}}else{this._prevBypassedRequest=r;this.bypassed.dispatch.apply(this.bypassed,l.concat([r]));}this._pipeParse(r,l);},_notifyPrevRoutes:function(m,r){var i=0,p;while(p=this._prevRoutes[i++]){if(p.route.switched&&this._didSwitch(p.route,m)){p.route.switched.dispatch(r);}}},_didSwitch:function(r,m){var l,i=0;while(l=m[i++]){if(l.route===r){return false;}}return true;},_pipeParse:function(r,l){var i=0,m;while(m=this._piped[i++]){m.parse(r,l);}},getNumRoutes:function(){return this._routes.length;},_sortedInsert:function(r){var i=this._routes,n=i.length;do{--n;}while(i[n]&&r._priority<=i[n]._priority);i.splice(n+1,0,r);},_getMatchedRoutes:function(r){var i=[],l=this._routes,n=l.length,m;while(m=l[--n]){if((!i.length||this.greedy||m.greedy)&&m.match(r)){i.push({route:m,params:m._getParamsArray(r)});}if(!this.greedyEnabled&&i.length){break;}}return i;},pipe:function(o){this._piped.push(o);},unpipe:function(o){b(this._piped,o);},toString:function(){return'[crossroads numRoutes:'+this.getNumRoutes()+']';}};c=new C();c.VERSION='0.12.0';c.NORM_AS_ARRAY=function(r,v){return[v.vals_];};c.NORM_AS_OBJECT=function(r,v){return[v];};function R(p,i,l,r){var m=e(p),n=r.patternLexer;this._router=r;this._pattern=p;this._paramsIds=m?null:n.getParamIds(p);this._optionalParamsIds=m?null:n.getOptionalParamsIds(p);this._matchRegexp=m?p:n.compilePattern(p,r.ignoreCase);this.matched=new s.Signal();this.switched=new s.Signal();if(i){this.matched.add(i);}this._priority=l||0;}R.prototype={greedy:false,rules:void(0),match:function(r){r=r||'';return this._matchRegexp.test(r)&&this._validateParams(r);},_validateParams:function(r){var i=this.rules,v=this._getParamsObject(r),l;for(l in i){if(l!=='normalize_'&&i.hasOwnProperty(l)&&!this._isValidParam(r,l,v)){return false;}}return true;},_isValidParam:function(r,p,v){var i=this.rules[p],l=v[p],m=false,n=(p.indexOf('?')===0);if(l==null&&this._optionalParamsIds&&a(this._optionalParamsIds,p)!==-1){m=true;}else if(e(i)){if(n){l=v[p+'_'];}m=i.test(l);}else if(g(i)){if(n){l=v[p+'_'];}m=this._isValidArrayRule(i,l);}else if(h(i)){m=i(l,r,v);}return m;},_isValidArrayRule:function(i,v){if(!this._router.ignoreCase){return a(i,v)!==-1;}if(typeof v==='string'){v=v.toLowerCase();}var n=i.length,l,m;while(n--){l=i[n];m=(typeof l==='string')?l.toLowerCase():l;if(m===v){return true;}}return false;},_getParamsObject:function(r){var i=this._router.shouldTypecast,v=this._router.patternLexer.getParamValues(r,this._matchRegexp,i),o={},n=v.length,p,l;while(n--){l=v[n];if(this._paramsIds){p=this._paramsIds[n];if(p.indexOf('?')===0&&l){o[p+'_']=l;l=k(l,i);v[n]=l;}if(_&&l===''&&a(this._optionalParamsIds,p)!==-1){l=void(0);v[n]=l;}o[p]=l;}o[n]=l;}o.request_=i?t(r):r;o.vals_=v;return o;},_getParamsArray:function(r){var n=this.rules?this.rules.normalize_:null,p;n=n||this._router.normalizeFn;if(n&&h(n)){p=n(r,this._getParamsObject(r));}else{p=this._getParamsObject(r).vals_;}return p;},interpolate:function(r){var i=this._router.patternLexer.interpolate(this._pattern,r);if(!this._validateParams(i)){throw new Error('Generated string doesn\'t validate against `Route.rules`.');}return i;},extrapolate:function(r){var i={};if(!r){return i;}var p=this._getParamsObject(r);this._paramsIds.forEach(function(l){if(p.hasOwnProperty(l)){i[l]=p[l];}});return i;},dispose:function(){this._router.removeRoute(this);},_destroy:function(){this.matched.dispose();this.switched.dispose();this.matched=this.switched=this._pattern=this._matchRegexp=null;},toString:function(){return'[Route pattern:"'+this._pattern+'", numListeners:'+this.matched.getNumListeners()+']';}};C.prototype.patternLexer=(function(){var E=/[\\.+*?\^$\[\](){}\/'#]/g,L=/^\/|\/$/g,i=/\/$/g,P=/(?:\{|:)([^}:]+)(?:\}|:)/g,r=function(z,A,B){var D=B.lastIndexOf("__CR_RS__"),F=B.indexOf("__CR_RQ__"),G=B.indexOf("__CR_OQ__"),H=B.indexOf("\\/",A),I=Math.min(G===-1?B.length:G,F===-1?B.length:F),J=A+z.length;if(J>=I||J<D||J<H){return T.OS.res_normal;}else{return T.OS.res_arsbq;}},T={'OS':{rgx:/([:})]|\w(?=\/))\/?(:|(?:\{\?))/g,save:'$1{{id}}$2',res:r,res_normal:'\\/?',res_arsbq:'(?:(?:\\/(?=(?:[^\\/?]+)?))|^\\/?|\\/?$)'},'RS':{rgx:/([:}])\/?(\{)/g,save:'$1{{id}}$2',res:'\\/'},'RQ':{rgx:/\{\?([^}]+)\}/g,res:'\\?([^#]+)'},'OQ':{rgx:/:\?([^:]+):/g,res:'(?:\\?([^#]*))?'},'OR':{rgx:/:([^:]+)\*:/g,res:'(.*)?'},'RR':{rgx:/\{([^}]+)\*\}/g,res:'(.+)'},'RP':{rgx:/\{([^}]+)\}/g,res:'([^\\/?]+)'},'OP':{rgx:/:([^:]+):/g,res:'([^\\/?]+)?(?:\\/(?!\\/))?'}},l=1,S=2,m=3,n=l;function p(){var z,A;for(z in T){if(T.hasOwnProperty(z)){A=T[z];A.id='__CR_'+z+'__';A.save=('save'in A)?A.save.replace('{{id}}',A.id):A.id;A.rRestore=new RegExp(A.id,'g');}}}p();function o(z,A){var B=[],D;z.lastIndex=0;while(D=z.exec(A)){B.push(D[1]);}return B;}function q(z){return o(P,z);}function u(z){return o(T.OP.rgx,z);}function v(z,A){z=z||'';if(z){if(n===l){z=z.replace(L,'');}else if(n===m){z=z.replace(i,'');}z=w(z,'rgx','save');z=z.replace(E,'\\$&');z=w(z,'rRestore','res');if(n===l){z='\\/?'+z;}}if(n!==S){z+='\\/?';}return new RegExp('^'+z+'$',A?'i':'');}function w(z,A,B){var D,F;for(F in T){if(T.hasOwnProperty(F)){D=T[F];z=z.replace(D[A],D[B]);}}return z;}function x(z,A,B){var D=A.exec(z);if(D){D.shift();if(B){D=j(D);}}return D;}function y(z,A){if(typeof z!=='string'){throw new Error('Route pattern should be a string.');}var B=function(D,F){var G,H;if(F.charAt(0)==='?'){H=A[F]||A[F.substring(1)];}else{H=A[F];}if(H!=null){if(typeof H==='object'){var I=[];for(var J in H){I.push(encodeURI(J+'='+H[J]));}G='?'+I.join('&');}else{G=String(H);}if(D.indexOf('*')===-1&&G.indexOf('/')!==-1){throw new Error('Invalid value "'+G+'" for segment "'+D+'".');}}else if(D.indexOf('{')!==-1){throw new Error('The segment '+D+' is required.');}else{G='';}return G;};if(!T.OS.trail){T.OS.trail=new RegExp('(?:'+T.OS.id+')+$');}return z.replace(T.OS.rgx,T.OS.save).replace(P,B).replace(T.OS.trail,'').replace(T.OS.rRestore,'/');}return{strict:function(){n=S;},loose:function(){n=l;},legacy:function(){n=m;},getParamIds:q,getOptionalParamsIds:u,getParamValues:x,compilePattern:v,interpolate:y};}());return c;};if(typeof define==='function'&&define.amd){define(['signals'],f);}else{window['crossroads']=f(window['signals']);}}());
},
/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
	"jquery.sap.logger.js":function(){jQuery.sap.declare("jquery.sap.logger",false);
},
/*!
 * jQuery UI Core 1.10.4
 * http://jqueryui.com
 *
 * Copyright 2014 jQuery Foundation and other contributors
 * Released under the MIT license.
 * http://jquery.org/license
 *
 * http://api.jqueryui.com/category/ui-core/
 */
	"sap/ui/thirdparty/jqueryui/jquery-ui-core.js":function(){(function($,u){$.fn.zIndex=u;$.fn.enableSelection=u;$.fn.disableSelection=u;$.expr[":"].focusable=u;var b=0,r=/^ui-id-\d+$/;$.ui=$.ui||{};$.extend($.ui,{version:"1.10.4",keyCode:{BACKSPACE:8,COMMA:188,DELETE:46,DOWN:40,END:35,ENTER:13,ESCAPE:27,HOME:36,LEFT:37,NUMPAD_ADD:107,NUMPAD_DECIMAL:110,NUMPAD_DIVIDE:111,NUMPAD_ENTER:108,NUMPAD_MULTIPLY:106,NUMPAD_SUBTRACT:109,PAGE_DOWN:34,PAGE_UP:33,PERIOD:190,RIGHT:39,SPACE:32,TAB:9,UP:38}});$.fn.extend({focus:(function(o){return function(d,a){return typeof d==="number"?this.each(function(){var e=this;setTimeout(function(){$(e).focus();if(a){a.call(e);}},d);}):o.apply(this,arguments);};})($.fn.focus),scrollParent:function(){var s;if(($.ui.ie&&(/(static|relative)/).test(this.css("position")))||(/absolute/).test(this.css("position"))){s=this.parents().filter(function(){return(/(relative|absolute|fixed)/).test($.css(this,"position"))&&(/(auto|scroll)/).test($.css(this,"overflow")+$.css(this,"overflow-y")+$.css(this,"overflow-x"));}).eq(0);}else{s=this.parents().filter(function(){return(/(auto|scroll)/).test($.css(this,"overflow")+$.css(this,"overflow-y")+$.css(this,"overflow-x"));}).eq(0);}return(/fixed/).test(this.css("position"))||!s.length?$(document):s;},zIndex:function(z){if(z!==u){return this.css("zIndex",z);}if(this.length){var e=$(this[0]),p,a;while(e.length&&e[0]!==document){p=e.css("position");if(p==="absolute"||p==="relative"||p==="fixed"){a=parseInt(e.css("zIndex"),10);if(!isNaN(a)&&a!==0){return a;}}e=e.parent();}}return 0;},uniqueId:function(){return this.each(function(){if(!this.id){this.id="ui-id-"+(++b);}});},removeUniqueId:function(){return this.each(function(){if(r.test(this.id)){$(this).removeAttr("id");}});}});
function f(e,i){var m,a,c,n=e.nodeName.toLowerCase();if("area"===n){m=e.parentNode;a=m.name;if(!e.href||!a||m.nodeName.toLowerCase()!=="map"){return false;}c=$("img[usemap='#"+a+"']")[0];return!!c&&v(c);}return(/input|select|textarea|button|object/.test(n)?!e.disabled:"a"===n?e.href||i:i)&&v(e);}
function v(e){return $.expr.filters.visible(e)&&!$(e).parents().addBack().filter(function(){return $.css(this,"visibility")==="hidden";}).length;}
$.extend($.expr[":"],{data:$.expr.createPseudo?$.expr.createPseudo(function(d){return function(e){return!!$.data(e,d);};}):function(e,i,m){return!!$.data(e,m[3]);},focusable:function(e){return f(e,!isNaN($.attr(e,"tabindex")));},tabbable:function(e){var t=$.attr(e,"tabindex"),i=isNaN(t);return(i||t>=0)&&f(e,!i);}});if(!$("<a>").outerWidth(1).jquery){$.each(["Width","Height"],function(i,n){var s=n==="Width"?["Left","Right"]:["Top","Bottom"],t=n.toLowerCase(),o={innerWidth:$.fn.innerWidth,innerHeight:$.fn.innerHeight,outerWidth:$.fn.outerWidth,outerHeight:$.fn.outerHeight};function a(e,c,d,m){$.each(s,function(){c-=parseFloat($.css(e,"padding"+this))||0;if(d){c-=parseFloat($.css(e,"border"+this+"Width"))||0;}if(m){c-=parseFloat($.css(e,"margin"+this))||0;}});return c;}$.fn["inner"+n]=function(c){if(c===u){return o["inner"+n].call(this);}return this.each(function(){$(this).css(t,a(this,c)+"px");});};$.fn["outer"+n]=function(c,m){if(typeof c!=="number"){return o["outer"+n].call(this,c);}return this.each(function(){$(this).css(t,a(this,c,true,m)+"px");});};});}if(!$.fn.addBack){$.fn.addBack=function(s){return this.add(s==null?this.prevObject:this.prevObject.filter(s));};}if($("<a>").data("a-b","a").removeData("a-b").data("a-b")){$.fn.removeData=(function(a){return function(k){if(arguments.length){return a.call(this,$.camelCase(k));}else{return a.call(this);}};})($.fn.removeData);}$.ui.ie=!!/msie [\w.]+/.exec(navigator.userAgent.toLowerCase());$.support.selectstart="onselectstart"in document.createElement("div");$.fn.extend({disableSelection:function(){return this.bind(($.support.selectstart?"selectstart":"mousedown")+".ui-disableSelection",function(e){e.preventDefault();});},enableSelection:function(){return this.unbind(".ui-disableSelection");}});$.extend($.ui,{plugin:{add:function(m,o,s){var i,p=$.ui[m].prototype;for(i in s){p.plugins[i]=p.plugins[i]||[];p.plugins[i].push([o,s[i]]);}},call:function(a,n,c){var i,s=a.plugins[n];if(!s||!a.element[0].parentNode||a.element[0].parentNode.nodeType===11){return;}for(i=0;i<s.length;i++){if(a.options[s[i][0]]){s[i][1].apply(a.element,c);}}}},hasScroll:function(e,a){if($(e).css("overflow")==="hidden"){return false;}var s=(a&&a==="left")?"scrollLeft":"scrollTop",h=false;if(e[s]>0){return true;}e[s]=1;h=(e[s]>0);e[s]=0;return h;}});})(jQuery);
},
/*!
 * jQuery UI Datepicker 1.10.4
 * http://jqueryui.com
 *
 * Copyright 2014 jQuery Foundation and other contributors
 * Released under the MIT license.
 * http://jquery.org/license
 *
 * http://api.jqueryui.com/datepicker/
 *
 * Depends:
 *	jquery.ui.core.js
 */
	"sap/ui/thirdparty/jqueryui/jquery-ui-datepicker.js":function(){(function($,u){$.extend($.ui,{datepicker:{version:"1.10.4"}});var P="datepicker",c;
function D(){this._curInst=null;this._keyEvent=false;this._disabledInputs=[];this._datepickerShowing=false;this._inDialog=false;this._mainDivId="ui-datepicker-div";this._inlineClass="ui-datepicker-inline";this._appendClass="ui-datepicker-append";this._triggerClass="ui-datepicker-trigger";this._dialogClass="ui-datepicker-dialog";this._disableClass="ui-datepicker-disabled";this._unselectableClass="ui-datepicker-unselectable";this._currentClass="ui-datepicker-current-day";this._dayOverClass="ui-datepicker-days-cell-over";this.regional=[];this.regional[""]={closeText:"Done",prevText:"Prev",nextText:"Next",currentText:"Today",monthNames:["January","February","March","April","May","June","July","August","September","October","November","December"],monthNamesShort:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],dayNames:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],dayNamesShort:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],dayNamesMin:["Su","Mo","Tu","We","Th","Fr","Sa"],weekHeader:"Wk",dateFormat:"mm/dd/yy",firstDay:0,isRTL:false,showMonthAfterYear:false,yearSuffix:""};this._defaults={showOn:"focus",showAnim:"fadeIn",showOptions:{},defaultDate:null,appendText:"",buttonText:"...",buttonImage:"",buttonImageOnly:false,hideIfNoPrevNext:false,navigationAsDateFormat:false,gotoCurrent:false,changeMonth:false,changeYear:false,yearRange:"c-10:c+10",showOtherMonths:false,selectOtherMonths:false,showWeek:false,calculateWeek:this.iso8601Week,shortYearCutoff:"+10",minDate:null,maxDate:null,duration:"fast",beforeShowDay:null,beforeShow:null,onSelect:null,onChangeMonthYear:null,onClose:null,numberOfMonths:1,showCurrentAtPos:0,stepMonths:1,stepBigMonths:12,altField:"",altFormat:"",constrainInput:true,showButtonPanel:false,autoSize:false,disabled:false};$.extend(this._defaults,this.regional[""]);this.dpDiv=d($("<div id='"+this._mainDivId+"' class='ui-datepicker ui-widget ui-widget-content ui-helper-clearfix ui-corner-all'></div>"));}
$.extend(D.prototype,{markerClassName:"hasDatepicker",maxRows:4,_widgetDatepicker:function(){return this.dpDiv;},setDefaults:function(s){f(this._defaults,s||{});return this;},_attachDatepicker:function(t,s){var n,i,a;n=t.nodeName.toLowerCase();i=(n==="div"||n==="span");if(!t.id){this.uuid+=1;t.id="dp"+this.uuid;}a=this._newInst($(t),i);a.settings=$.extend({},s||{});if(n==="input"){this._connectDatepicker(t,a);}else if(i){this._inlineDatepicker(t,a);}},_newInst:function(t,i){var a=t[0].id.replace(/([^A-Za-z0-9_\-])/g,"\\\\$1");return{id:a,input:t,selectedDay:0,selectedMonth:0,selectedYear:0,drawMonth:0,drawYear:0,inline:i,dpDiv:(!i?this.dpDiv:d($("<div class='"+this._inlineClass+" ui-datepicker ui-widget ui-widget-content ui-helper-clearfix ui-corner-all'></div>")))};},_connectDatepicker:function(t,i){var a=$(t);i.append=$([]);i.trigger=$([]);if(a.hasClass(this.markerClassName)){return;}this._attachments(a,i);a.addClass(this.markerClassName).keydown(this._doKeyDown).keypress(this._doKeyPress).keyup(this._doKeyUp);this._autoSize(i);$.data(t,P,i);if(i.settings.disabled){this._disableDatepicker(t);}},_attachments:function(i,a){var s,b,e,g=this._get(a,"appendText"),h=this._get(a,"isRTL");if(a.append){a.append.remove();}if(g){a.append=$("<span class='"+this._appendClass+"'>"+g+"</span>");i[h?"before":"after"](a.append);}i.unbind("focus",this._showDatepicker);if(a.trigger){a.trigger.remove();}s=this._get(a,"showOn");if(s==="focus"||s==="both"){i.focus(this._showDatepicker);}if(s==="button"||s==="both"){b=this._get(a,"buttonText");e=this._get(a,"buttonImage");a.trigger=$(this._get(a,"buttonImageOnly")?$("<img/>").addClass(this._triggerClass).attr({src:e,alt:b,title:b}):$("<button type='button'></button>").addClass(this._triggerClass).html(!e?b:$("<img/>").attr({src:e,alt:b,title:b})));i[h?"before":"after"](a.trigger);a.trigger.click(function(){if($.datepicker._datepickerShowing&&$.datepicker._lastInput===i[0]){$.datepicker._hideDatepicker();}else if($.datepicker._datepickerShowing&&$.datepicker._lastInput!==i[0]){$.datepicker._hideDatepicker();$.datepicker._showDatepicker(i[0]);}else{$.datepicker._showDatepicker(i[0]);}return false;});}},_autoSize:function(a){if(this._get(a,"autoSize")&&!a.inline){var b,m,e,i,g=new Date(2009,12-1,20),h=this._get(a,"dateFormat");if(h.match(/[DM]/)){b=function(n){m=0;e=0;for(i=0;i<n.length;i++){if(n[i].length>m){m=n[i].length;e=i;}}return e;};g.setMonth(b(this._get(a,(h.match(/MM/)?"monthNames":"monthNamesShort"))));g.setDate(b(this._get(a,(h.match(/DD/)?"dayNames":"dayNamesShort")))+20-g.getDay());}a.input.attr("size",this._formatDate(a,g).length);}},_inlineDatepicker:function(t,i){var a=$(t);if(a.hasClass(this.markerClassName)){return;}a.addClass(this.markerClassName).append(i.dpDiv);$.data(t,P,i);this._setDate(i,this._getDefaultDate(i),true);this._updateDatepicker(i);this._updateAlternate(i);if(i.settings.disabled){this._disableDatepicker(t);}i.dpDiv.css("display","block");},_dialogDatepicker:function(i,a,o,s,p){var b,e,g,h,j,k=this._dialogInst;if(!k){this.uuid+=1;b="dp"+this.uuid;this._dialogInput=$("<input type='text' id='"+b+"' style='position: absolute; top: -100px; width: 0px;'/>");this._dialogInput.keydown(this._doKeyDown);$("body").append(this._dialogInput);k=this._dialogInst=this._newInst(this._dialogInput,false);k.settings={};$.data(this._dialogInput[0],P,k);}f(k.settings,s||{});a=(a&&a.constructor===Date?this._formatDate(k,a):a);this._dialogInput.val(a);this._pos=(p?(p.length?p:[p.pageX,p.pageY]):null);if(!this._pos){e=document.documentElement.clientWidth;g=document.documentElement.clientHeight;h=document.documentElement.scrollLeft||document.body.scrollLeft;j=document.documentElement.scrollTop||document.body.scrollTop;this._pos=[(e/2)-100+h,(g/2)-150+j];}this._dialogInput.css("left",(this._pos[0]+20)+"px").css("top",this._pos[1]+"px");k.settings.onSelect=o;this._inDialog=true;this.dpDiv.addClass(this._dialogClass);this._showDatepicker(this._dialogInput[0]);if($.blockUI){$.blockUI(this.dpDiv);}$.data(this._dialogInput[0],P,k);return this;},_destroyDatepicker:function(t){var n,a=$(t),i=$.data(t,P);if(!a.hasClass(this.markerClassName)){return;}n=t.nodeName.toLowerCase();$.removeData(t,P);if(n==="input"){i.append.remove();i.trigger.remove();a.removeClass(this.markerClassName).unbind("focus",this._showDatepicker).unbind("keydown",this._doKeyDown).unbind("keypress",this._doKeyPress).unbind("keyup",this._doKeyUp);}else if(n==="div"||n==="span"){a.removeClass(this.markerClassName).empty();}},_enableDatepicker:function(t){var n,i,a=$(t),b=$.data(t,P);if(!a.hasClass(this.markerClassName)){return;}n=t.nodeName.toLowerCase();if(n==="input"){t.disabled=false;b.trigger.filter("button").each(function(){this.disabled=false;}).end().filter("img").css({opacity:"1.0",cursor:""});}else if(n==="div"||n==="span"){i=a.children("."+this._inlineClass);i.children().removeClass("ui-state-disabled");i.find("select.ui-datepicker-month, select.ui-datepicker-year").prop("disabled",false);}this._disabledInputs=$.map(this._disabledInputs,function(v){return(v===t?null:v);});},_disableDatepicker:function(t){var n,i,a=$(t),b=$.data(t,P);if(!a.hasClass(this.markerClassName)){return;}n=t.nodeName.toLowerCase();if(n==="input"){t.disabled=true;b.trigger.filter("button").each(function(){this.disabled=true;}).end().filter("img").css({opacity:"0.5",cursor:"default"});}else if(n==="div"||n==="span"){i=a.children("."+this._inlineClass);i.children().addClass("ui-state-disabled");i.find("select.ui-datepicker-month, select.ui-datepicker-year").prop("disabled",true);}this._disabledInputs=$.map(this._disabledInputs,function(v){return(v===t?null:v);});this._disabledInputs[this._disabledInputs.length]=t;},_isDisabledDatepicker:function(t){if(!t){return false;}for(var i=0;i<this._disabledInputs.length;i++){if(this._disabledInputs[i]===t){return true;}}return false;},_getInst:function(t){try{return $.data(t,P);}catch(e){throw"Missing instance data for this datepicker";}},_optionDatepicker:function(t,n,v){var s,a,m,b,i=this._getInst(t);if(arguments.length===2&&typeof n==="string"){return(n==="defaults"?$.extend({},$.datepicker._defaults):(i?(n==="all"?$.extend({},i.settings):this._get(i,n)):null));}s=n||{};if(typeof n==="string"){s={};s[n]=v;}if(i){if(this._curInst===i){this._hideDatepicker();}a=this._getDateDatepicker(t,true);m=this._getMinMaxDate(i,"min");b=this._getMinMaxDate(i,"max");f(i.settings,s);if(m!==null&&s.dateFormat!==u&&s.minDate===u){i.settings.minDate=this._formatDate(i,m);}if(b!==null&&s.dateFormat!==u&&s.maxDate===u){i.settings.maxDate=this._formatDate(i,b);}if("disabled"in s){if(s.disabled){this._disableDatepicker(t);}else{this._enableDatepicker(t);}}this._attachments($(t),i);this._autoSize(i);this._setDate(i,a);this._updateAlternate(i);this._updateDatepicker(i);}},_changeDatepicker:function(t,n,v){this._optionDatepicker(t,n,v);},_refreshDatepicker:function(t){var i=this._getInst(t);if(i){this._updateDatepicker(i);}},_setDateDatepicker:function(t,a){var i=this._getInst(t);if(i){this._setDate(i,a);this._updateDatepicker(i);this._updateAlternate(i);}},_getDateDatepicker:function(t,n){var i=this._getInst(t);if(i&&!i.inline){this._setDateFromField(i,n);}return(i?this._getDate(i):null);},_doKeyDown:function(e){var o,a,s,i=$.datepicker._getInst(e.target),h=true,b=i.dpDiv.is(".ui-datepicker-rtl");i._keyEvent=true;if($.datepicker._datepickerShowing){switch(e.keyCode){case 9:$.datepicker._hideDatepicker();h=false;break;case 13:s=$("td."+$.datepicker._dayOverClass+":not(."+$.datepicker._currentClass+")",i.dpDiv);if(s[0]){$.datepicker._selectDay(e.target,i.selectedMonth,i.selectedYear,s[0]);}o=$.datepicker._get(i,"onSelect");if(o){a=$.datepicker._formatDate(i);o.apply((i.input?i.input[0]:null),[a,i]);}else{$.datepicker._hideDatepicker();}return false;case 27:$.datepicker._hideDatepicker();break;case 33:$.datepicker._adjustDate(e.target,(e.ctrlKey?-$.datepicker._get(i,"stepBigMonths"):-$.datepicker._get(i,"stepMonths")),"M");break;case 34:$.datepicker._adjustDate(e.target,(e.ctrlKey?+$.datepicker._get(i,"stepBigMonths"):+$.datepicker._get(i,"stepMonths")),"M");break;case 35:if(e.ctrlKey||e.metaKey){$.datepicker._clearDate(e.target);}h=e.ctrlKey||e.metaKey;break;case 36:if(e.ctrlKey||e.metaKey){$.datepicker._gotoToday(e.target);}h=e.ctrlKey||e.metaKey;break;case 37:if(e.ctrlKey||e.metaKey){$.datepicker._adjustDate(e.target,(b?+1:-1),"D");}h=e.ctrlKey||e.metaKey;if(e.originalEvent.altKey){$.datepicker._adjustDate(e.target,(e.ctrlKey?-$.datepicker._get(i,"stepBigMonths"):-$.datepicker._get(i,"stepMonths")),"M");}break;case 38:if(e.ctrlKey||e.metaKey){$.datepicker._adjustDate(e.target,-7,"D");}h=e.ctrlKey||e.metaKey;break;case 39:if(e.ctrlKey||e.metaKey){$.datepicker._adjustDate(e.target,(b?-1:+1),"D");}h=e.ctrlKey||e.metaKey;if(e.originalEvent.altKey){$.datepicker._adjustDate(e.target,(e.ctrlKey?+$.datepicker._get(i,"stepBigMonths"):+$.datepicker._get(i,"stepMonths")),"M");}break;case 40:if(e.ctrlKey||e.metaKey){$.datepicker._adjustDate(e.target,+7,"D");}h=e.ctrlKey||e.metaKey;break;default:h=false;}}else if(e.keyCode===36&&e.ctrlKey){$.datepicker._showDatepicker(this);}else{h=false;}if(h){e.preventDefault();e.stopPropagation();}},_doKeyPress:function(e){var a,b,i=$.datepicker._getInst(e.target);if($.datepicker._get(i,"constrainInput")){a=$.datepicker._possibleChars($.datepicker._get(i,"dateFormat"));b=String.fromCharCode(e.charCode==null?e.keyCode:e.charCode);return e.ctrlKey||e.metaKey||(b<" "||!a||a.indexOf(b)>-1);}},_doKeyUp:function(e){var a,i=$.datepicker._getInst(e.target);if(i.input.val()!==i.lastVal){try{a=$.datepicker.parseDate($.datepicker._get(i,"dateFormat"),(i.input?i.input.val():null),$.datepicker._getFormatConfig(i));if(a){$.datepicker._setDateFromField(i);$.datepicker._updateAlternate(i);$.datepicker._updateDatepicker(i);}}catch(b){}}return true;},_showDatepicker:function(i){i=i.target||i;if(i.nodeName.toLowerCase()!=="input"){i=$("input",i.parentNode)[0];}if($.datepicker._isDisabledDatepicker(i)||$.datepicker._lastInput===i){return;}var a,b,e,g,o,s,h;a=$.datepicker._getInst(i);if($.datepicker._curInst&&$.datepicker._curInst!==a){$.datepicker._curInst.dpDiv.stop(true,true);if(a&&$.datepicker._datepickerShowing){$.datepicker._hideDatepicker($.datepicker._curInst.input[0]);}}b=$.datepicker._get(a,"beforeShow");e=b?b.apply(i,[i,a]):{};if(e===false){return;}f(a.settings,e);a.lastVal=null;$.datepicker._lastInput=i;$.datepicker._setDateFromField(a);if($.datepicker._inDialog){i.value="";}if(!$.datepicker._pos){$.datepicker._pos=$.datepicker._findPos(i);$.datepicker._pos[1]+=i.offsetHeight;}g=false;$(i).parents().each(function(){g|=$(this).css("position")==="fixed";return!g;});o={left:$.datepicker._pos[0],top:$.datepicker._pos[1]};$.datepicker._pos=null;a.dpDiv.empty();a.dpDiv.css({position:"absolute",display:"block",top:"-1000px"});$.datepicker._updateDatepicker(a);o=$.datepicker._checkOffset(a,o,g);a.dpDiv.css({position:($.datepicker._inDialog&&$.blockUI?"static":(g?"fixed":"absolute")),display:"none",left:o.left+"px",top:o.top+"px"});if(!a.inline){s=$.datepicker._get(a,"showAnim");h=$.datepicker._get(a,"duration");a.dpDiv.zIndex($(i).zIndex()+1);$.datepicker._datepickerShowing=true;if($.effects&&$.effects.effect[s]){a.dpDiv.show(s,$.datepicker._get(a,"showOptions"),h);}else{a.dpDiv[s||"show"](s?h:null);}if($.datepicker._shouldFocusInput(a)){a.input.focus();}$.datepicker._curInst=a;}},_updateDatepicker:function(i){this.maxRows=4;c=i;i.dpDiv.empty().append(this._generateHTML(i));this._attachHandlers(i);i.dpDiv.find("."+this._dayOverClass+" a").mouseover();var o,n=this._getNumberOfMonths(i),a=n[1],w=17;i.dpDiv.removeClass("ui-datepicker-multi-2 ui-datepicker-multi-3 ui-datepicker-multi-4").width("");if(a>1){i.dpDiv.addClass("ui-datepicker-multi-"+a).css("width",(w*a)+"em");}i.dpDiv[(n[0]!==1||n[1]!==1?"add":"remove")+"Class"]("ui-datepicker-multi");i.dpDiv[(this._get(i,"isRTL")?"add":"remove")+"Class"]("ui-datepicker-rtl");if(i===$.datepicker._curInst&&$.datepicker._datepickerShowing&&$.datepicker._shouldFocusInput(i)){i.input.focus();}if(i.yearshtml){o=i.yearshtml;setTimeout(function(){if(o===i.yearshtml&&i.yearshtml){i.dpDiv.find("select.ui-datepicker-year:first").replaceWith(i.yearshtml);}o=i.yearshtml=null;},0);}},_shouldFocusInput:function(i){return i.input&&i.input.is(":visible")&&!i.input.is(":disabled")&&!i.input.is(":focus");},_checkOffset:function(i,o,a){var b=i.dpDiv.outerWidth(),e=i.dpDiv.outerHeight(),g=i.input?i.input.outerWidth():0,h=i.input?i.input.outerHeight():0,v=document.documentElement.clientWidth+(a?0:$(document).scrollLeft()),j=document.documentElement.clientHeight+(a?0:$(document).scrollTop());o.left-=(this._get(i,"isRTL")?(b-g):0);o.left-=(a&&o.left===i.input.offset().left)?$(document).scrollLeft():0;o.top-=(a&&o.top===(i.input.offset().top+h))?$(document).scrollTop():0;o.left-=Math.min(o.left,(o.left+b>v&&v>b)?Math.abs(o.left+b-v):0);o.top-=Math.min(o.top,(o.top+e>j&&j>e)?Math.abs(e+h):0);return o;},_findPos:function(o){var p,i=this._getInst(o),a=this._get(i,"isRTL");while(o&&(o.type==="hidden"||o.nodeType!==1||$.expr.filters.hidden(o))){o=o[a?"previousSibling":"nextSibling"];}p=$(o).offset();return[p.left,p.top];},_hideDatepicker:function(i){var s,a,p,o,b=this._curInst;if(!b||(i&&b!==$.data(i,P))){return;}if(this._datepickerShowing){s=this._get(b,"showAnim");a=this._get(b,"duration");p=function(){$.datepicker._tidyDialog(b);};if($.effects&&($.effects.effect[s]||$.effects[s])){b.dpDiv.hide(s,$.datepicker._get(b,"showOptions"),a,p);}else{b.dpDiv[(s==="slideDown"?"slideUp":(s==="fadeIn"?"fadeOut":"hide"))]((s?a:null),p);}if(!s){p();}this._datepickerShowing=false;o=this._get(b,"onClose");if(o){o.apply((b.input?b.input[0]:null),[(b.input?b.input.val():""),b]);}this._lastInput=null;if(this._inDialog){this._dialogInput.css({position:"absolute",left:"0",top:"-100px"});if($.blockUI){$.unblockUI();$("body").append(this.dpDiv);}}this._inDialog=false;}},_tidyDialog:function(i){i.dpDiv.removeClass(this._dialogClass).unbind(".ui-datepicker-calendar");},_checkExternalClick:function(e){if(!$.datepicker._curInst){return;}var a=$(e.target),i=$.datepicker._getInst(a[0]);if(((a[0].id!==$.datepicker._mainDivId&&a.parents("#"+$.datepicker._mainDivId).length===0&&!a.hasClass($.datepicker.markerClassName)&&!a.closest("."+$.datepicker._triggerClass).length&&$.datepicker._datepickerShowing&&!($.datepicker._inDialog&&$.blockUI)))||(a.hasClass($.datepicker.markerClassName)&&$.datepicker._curInst!==i)){$.datepicker._hideDatepicker();}},_adjustDate:function(i,o,p){var t=$(i),a=this._getInst(t[0]);if(this._isDisabledDatepicker(t[0])){return;}this._adjustInstDate(a,o+(p==="M"?this._get(a,"showCurrentAtPos"):0),p);this._updateDatepicker(a);},_gotoToday:function(i){var a,t=$(i),b=this._getInst(t[0]);if(this._get(b,"gotoCurrent")&&b.currentDay){b.selectedDay=b.currentDay;b.drawMonth=b.selectedMonth=b.currentMonth;b.drawYear=b.selectedYear=b.currentYear;}else{a=new Date();b.selectedDay=a.getDate();b.drawMonth=b.selectedMonth=a.getMonth();b.drawYear=b.selectedYear=a.getFullYear();}this._notifyChange(b);this._adjustDate(t);},_selectMonthYear:function(i,s,p){var t=$(i),a=this._getInst(t[0]);a["selected"+(p==="M"?"Month":"Year")]=a["draw"+(p==="M"?"Month":"Year")]=parseInt(s.options[s.selectedIndex].value,10);this._notifyChange(a);this._adjustDate(t);},_selectDay:function(i,m,y,t){var a,b=$(i);if($(t).hasClass(this._unselectableClass)||this._isDisabledDatepicker(b[0])){return;}a=this._getInst(b[0]);a.selectedDay=a.currentDay=$("a",t).html();a.selectedMonth=a.currentMonth=m;a.selectedYear=a.currentYear=y;this._selectDate(i,this._formatDate(a,a.currentDay,a.currentMonth,a.currentYear));},_clearDate:function(i){var t=$(i);this._selectDate(t,"");},_selectDate:function(i,a){var o,t=$(i),b=this._getInst(t[0]);a=(a!=null?a:this._formatDate(b));if(b.input){b.input.val(a);}this._updateAlternate(b);o=this._get(b,"onSelect");if(o){o.apply((b.input?b.input[0]:null),[a,b]);}else if(b.input){b.input.trigger("change");}if(b.inline){this._updateDatepicker(b);}else{this._hideDatepicker();this._lastInput=b.input[0];if(typeof(b.input[0])!=="object"){b.input.focus();}this._lastInput=null;}},_updateAlternate:function(i){var a,b,e,g=this._get(i,"altField");if(g){a=this._get(i,"altFormat")||this._get(i,"dateFormat");b=this._getDate(i);e=this.formatDate(a,b,this._getFormatConfig(i));$(g).each(function(){$(this).val(e);});}},noWeekends:function(a){var b=a.getDay();return[(b>0&&b<6),""];},iso8601Week:function(a){var t,b=new Date(a.getTime());b.setDate(b.getDate()+4-(b.getDay()||7));t=b.getTime();b.setMonth(0);b.setDate(1);return Math.floor(Math.round((t-b)/86400000)/7)+1;},parseDate:function(e,g,s){if(e==null||g==null){throw"Invalid arguments";}g=(typeof g==="object"?g.toString():g+"");if(g===""){return null;}var F,h,j,V=0,l=(s?s.shortYearCutoff:null)||this._defaults.shortYearCutoff,m=(typeof l!=="string"?l:new Date().getFullYear()%100+parseInt(l,10)),n=(s?s.dayNamesShort:null)||this._defaults.dayNamesShort,o=(s?s.dayNames:null)||this._defaults.dayNames,p=(s?s.monthNamesShort:null)||this._defaults.monthNamesShort,q=(s?s.monthNames:null)||this._defaults.monthNames,y=-1,r=-1,t=-1,w=-1,x=false,z,A=function(a){var b=(F+1<e.length&&e.charAt(F+1)===a);if(b){F++;}return b;},B=function(a){var i=A(a),b=(a==="@"?14:(a==="!"?20:(a==="y"&&i?4:(a==="o"?3:2)))),k=new RegExp("^\\d{1,"+b+"}"),v=g.substring(V).match(k);if(!v){throw"Missing number at position "+V;}V+=v[0].length;return parseInt(v[0],10);},C=function(G,H,I){var J=-1,K=$.map(A(G)?I:H,function(v,k){return[[k,v]];}).sort(function(a,b){return-(a[1].length-b[1].length);});$.each(K,function(i,a){var b=a[1];if(g.substr(V,b.length).toLowerCase()===b.toLowerCase()){J=a[0];V+=b.length;return false;}});if(J!==-1){return J+1;}else{throw"Unknown name at position "+V;}},E=function(){if(g.charAt(V)!==e.charAt(F)){throw"Unexpected literal at position "+V;}V++;};for(F=0;F<e.length;F++){if(x){if(e.charAt(F)==="'"&&!A("'")){x=false;}else{E();}}else{switch(e.charAt(F)){case"d":t=B("d");break;case"D":C("D",n,o);break;case"o":w=B("o");break;case"m":r=B("m");break;case"M":r=C("M",p,q);break;case"y":y=B("y");break;case"@":z=new Date(B("@"));y=z.getFullYear();r=z.getMonth()+1;t=z.getDate();break;case"!":z=new Date((B("!")-this._ticksTo1970)/10000);y=z.getFullYear();r=z.getMonth()+1;t=z.getDate();break;case"'":if(A("'")){E();}else{x=true;}break;default:E();}}}if(V<g.length){j=g.substr(V);if(!/^\s+/.test(j)){throw"Extra/unparsed characters found in date: "+j;}}if(y===-1){y=new Date().getFullYear();}else if(y<100){y+=new Date().getFullYear()-new Date().getFullYear()%100+(y<=m?0:-100);}if(w>-1){r=1;t=w;do{h=this._getDaysInMonth(y,r-1);if(t<=h){break;}r++;t-=h;}while(true);}z=this._daylightSavingAdjust(new Date(y,r-1,t));if(z.getFullYear()!==y||z.getMonth()+1!==r||z.getDate()!==t){throw"Invalid date";}return z;},ATOM:"yy-mm-dd",COOKIE:"D, dd M yy",ISO_8601:"yy-mm-dd",RFC_822:"D, d M y",RFC_850:"DD, dd-M-y",RFC_1036:"D, d M y",RFC_1123:"D, d M yy",RFC_2822:"D, d M yy",RSS:"D, d M y",TICKS:"!",TIMESTAMP:"@",W3C:"yy-mm-dd",_ticksTo1970:(((1970-1)*365+Math.floor(1970/4)-Math.floor(1970/100)+Math.floor(1970/400))*24*60*60*10000000),formatDate:function(a,b,s){if(!b){return"";}var F,e=(s?s.dayNamesShort:null)||this._defaults.dayNamesShort,g=(s?s.dayNames:null)||this._defaults.dayNames,m=(s?s.monthNamesShort:null)||this._defaults.monthNamesShort,h=(s?s.monthNames:null)||this._defaults.monthNames,l=function(n){var p=(F+1<a.length&&a.charAt(F+1)===n);if(p){F++;}return p;},i=function(n,v,p){var q=""+v;if(l(n)){while(q.length<p){q="0"+q;}}return q;},j=function(n,v,p,q){return(l(n)?q[v]:p[v]);},o="",k=false;if(b){for(F=0;F<a.length;F++){if(k){if(a.charAt(F)==="'"&&!l("'")){k=false;}else{o+=a.charAt(F);}}else{switch(a.charAt(F)){case"d":o+=i("d",b.getDate(),2);break;case"D":o+=j("D",b.getDay(),e,g);break;case"o":o+=i("o",Math.round((new Date(b.getFullYear(),b.getMonth(),b.getDate()).getTime()-new Date(b.getFullYear(),0,0).getTime())/86400000),3);break;case"m":o+=i("m",b.getMonth()+1,2);break;case"M":o+=j("M",b.getMonth(),m,h);break;case"y":o+=(l("y")?b.getFullYear():(b.getYear()%100<10?"0":"")+b.getYear()%100);break;case"@":o+=b.getTime();break;case"!":o+=b.getTime()*10000+this._ticksTo1970;break;case"'":if(l("'")){o+="'";}else{k=true;}break;default:o+=a.charAt(F);}}}}return o;},_possibleChars:function(a){var F,b="",l=false,e=function(m){var g=(F+1<a.length&&a.charAt(F+1)===m);if(g){F++;}return g;};for(F=0;F<a.length;F++){if(l){if(a.charAt(F)==="'"&&!e("'")){l=false;}else{b+=a.charAt(F);}}else{switch(a.charAt(F)){case"d":case"m":case"y":case"@":b+="0123456789";break;case"D":case"M":return null;case"'":if(e("'")){b+="'";}else{l=true;}break;default:b+=a.charAt(F);}}}return b;},_get:function(i,n){return i.settings[n]!==u?i.settings[n]:this._defaults[n];},_setDateFromField:function(i,n){if(i.input.val()===i.lastVal){return;}var a=this._get(i,"dateFormat"),b=i.lastVal=i.input?i.input.val():null,e=this._getDefaultDate(i),g=e,s=this._getFormatConfig(i);try{g=this.parseDate(a,b,s)||e;}catch(h){b=(n?"":b);}i.selectedDay=g.getDate();i.drawMonth=i.selectedMonth=g.getMonth();i.drawYear=i.selectedYear=g.getFullYear();i.currentDay=(b?g.getDate():0);i.currentMonth=(b?g.getMonth():0);i.currentYear=(b?g.getFullYear():0);this._adjustInstDate(i);},_getDefaultDate:function(i){return this._restrictMinMax(i,this._determineDate(i,this._get(i,"defaultDate"),new Date()));},_determineDate:function(i,a,b){var o=function(e){var a=new Date();a.setDate(a.getDate()+e);return a;},g=function(h){try{return $.datepicker.parseDate($.datepicker._get(i,"dateFormat"),h,$.datepicker._getFormatConfig(i));}catch(e){}var a=(h.toLowerCase().match(/^c/)?$.datepicker._getDate(i):null)||new Date(),y=a.getFullYear(),m=a.getMonth(),j=a.getDate(),p=/([+\-]?[0-9]+)\s*(d|D|w|W|m|M|y|Y)?/g,k=p.exec(h);while(k){switch(k[2]||"d"){case"d":case"D":j+=parseInt(k[1],10);break;case"w":case"W":j+=parseInt(k[1],10)*7;break;case"m":case"M":m+=parseInt(k[1],10);j=Math.min(j,$.datepicker._getDaysInMonth(y,m));break;case"y":case"Y":y+=parseInt(k[1],10);j=Math.min(j,$.datepicker._getDaysInMonth(y,m));break;}k=p.exec(h);}return new Date(y,m,j);},n=(a==null||a===""?b:(typeof a==="string"?g(a):(typeof a==="number"?(isNaN(a)?b:o(a)):new Date(a.getTime()))));n=(n&&n.toString()==="Invalid Date"?b:n);if(n){n.setHours(0);n.setMinutes(0);n.setSeconds(0);n.setMilliseconds(0);}return this._daylightSavingAdjust(n);},_daylightSavingAdjust:function(a){if(!a){return null;}a.setHours(a.getHours()>12?a.getHours()+2:0);return a;},_setDate:function(i,a,n){var b=!a,o=i.selectedMonth,e=i.selectedYear,g=this._restrictMinMax(i,this._determineDate(i,a,new Date()));i.selectedDay=i.currentDay=g.getDate();i.drawMonth=i.selectedMonth=i.currentMonth=g.getMonth();i.drawYear=i.selectedYear=i.currentYear=g.getFullYear();if((o!==i.selectedMonth||e!==i.selectedYear)&&!n){this._notifyChange(i);}this._adjustInstDate(i);if(i.input){i.input.val(b?"":this._formatDate(i));}},_getDate:function(i){var s=(!i.currentYear||(i.input&&i.input.val()==="")?null:this._daylightSavingAdjust(new Date(i.currentYear,i.currentMonth,i.currentDay)));return s;},_attachHandlers:function(i){var s=this._get(i,"stepMonths"),a="#"+i.id.replace(/\\\\/g,"\\");i.dpDiv.find("[data-handler]").map(function(){var h={prev:function(){$.datepicker._adjustDate(a,-s,"M");},next:function(){$.datepicker._adjustDate(a,+s,"M");},hide:function(){$.datepicker._hideDatepicker();},today:function(){$.datepicker._gotoToday(a);},selectDay:function(){$.datepicker._selectDay(a,+this.getAttribute("data-month"),+this.getAttribute("data-year"),this);return false;},selectMonth:function(){$.datepicker._selectMonthYear(a,this,"M");return false;},selectYear:function(){$.datepicker._selectMonthYear(a,this,"Y");return false;}};$(this).bind(this.getAttribute("data-event"),h[this.getAttribute("data-handler")]);});},_generateHTML:function(i){var m,p,a,n,b,e,g,h,j,k,s,l,o,q,r,t,v,w,x,y,z,A,B,C,E,F,G,H,I,J,K,L,M,N,R,O,Q,S,T,U=new Date(),V=this._daylightSavingAdjust(new Date(U.getFullYear(),U.getMonth(),U.getDate())),W=this._get(i,"isRTL"),X=this._get(i,"showButtonPanel"),Y=this._get(i,"hideIfNoPrevNext"),Z=this._get(i,"navigationAsDateFormat"),_=this._getNumberOfMonths(i),a1=this._get(i,"showCurrentAtPos"),b1=this._get(i,"stepMonths"),c1=(_[0]!==1||_[1]!==1),d1=this._daylightSavingAdjust((!i.currentDay?new Date(9999,9,9):new Date(i.currentYear,i.currentMonth,i.currentDay))),e1=this._getMinMaxDate(i,"min"),f1=this._getMinMaxDate(i,"max"),g1=i.drawMonth-a1,h1=i.drawYear;if(g1<0){g1+=12;h1--;}if(f1){m=this._daylightSavingAdjust(new Date(f1.getFullYear(),f1.getMonth()-(_[0]*_[1])+1,f1.getDate()));m=(e1&&m<e1?e1:m);while(this._daylightSavingAdjust(new Date(h1,g1,1))>m){g1--;if(g1<0){g1=11;h1--;}}}i.drawMonth=g1;i.drawYear=h1;p=this._get(i,"prevText");p=(!Z?p:this.formatDate(p,this._daylightSavingAdjust(new Date(h1,g1-b1,1)),this._getFormatConfig(i)));a=(this._canAdjustMonth(i,-1,h1,g1)?"<a class='ui-datepicker-prev ui-corner-all' data-handler='prev' data-event='click'"+" title='"+p+"'><span class='ui-icon ui-icon-circle-triangle-"+(W?"e":"w")+"'>"+p+"</span></a>":(Y?"":"<a class='ui-datepicker-prev ui-corner-all ui-state-disabled' title='"+p+"'><span class='ui-icon ui-icon-circle-triangle-"+(W?"e":"w")+"'>"+p+"</span></a>"));n=this._get(i,"nextText");n=(!Z?n:this.formatDate(n,this._daylightSavingAdjust(new Date(h1,g1+b1,1)),this._getFormatConfig(i)));b=(this._canAdjustMonth(i,+1,h1,g1)?"<a class='ui-datepicker-next ui-corner-all' data-handler='next' data-event='click'"+" title='"+n+"'><span class='ui-icon ui-icon-circle-triangle-"+(W?"w":"e")+"'>"+n+"</span></a>":(Y?"":"<a class='ui-datepicker-next ui-corner-all ui-state-disabled' title='"+n+"'><span class='ui-icon ui-icon-circle-triangle-"+(W?"w":"e")+"'>"+n+"</span></a>"));e=this._get(i,"currentText");g=(this._get(i,"gotoCurrent")&&i.currentDay?d1:V);e=(!Z?e:this.formatDate(e,g,this._getFormatConfig(i)));h=(!i.inline?"<button type='button' class='ui-datepicker-close ui-state-default ui-priority-primary ui-corner-all' data-handler='hide' data-event='click'>"+this._get(i,"closeText")+"</button>":"");j=(X)?"<div class='ui-datepicker-buttonpane ui-widget-content'>"+(W?h:"")+(this._isInRange(i,g)?"<button type='button' class='ui-datepicker-current ui-state-default ui-priority-secondary ui-corner-all' data-handler='today' data-event='click'"+">"+e+"</button>":"")+(W?"":h)+"</div>":"";k=parseInt(this._get(i,"firstDay"),10);k=(isNaN(k)?0:k);s=this._get(i,"showWeek");l=this._get(i,"dayNames");o=this._get(i,"dayNamesMin");q=this._get(i,"monthNames");r=this._get(i,"monthNamesShort");t=this._get(i,"beforeShowDay");v=this._get(i,"showOtherMonths");w=this._get(i,"selectOtherMonths");x=this._getDefaultDate(i);y="";z;for(A=0;A<_[0];A++){B="";this.maxRows=4;for(C=0;C<_[1];C++){E=this._daylightSavingAdjust(new Date(h1,g1,i.selectedDay));F=" ui-corner-all";G="";if(c1){G+="<div class='ui-datepicker-group";if(_[1]>1){switch(C){case 0:G+=" ui-datepicker-group-first";F=" ui-corner-"+(W?"right":"left");break;case _[1]-1:G+=" ui-datepicker-group-last";F=" ui-corner-"+(W?"left":"right");break;default:G+=" ui-datepicker-group-middle";F="";break;}}G+="'>";}G+="<div class='ui-datepicker-header ui-widget-header ui-helper-clearfix"+F+"'>"+(/all|left/.test(F)&&A===0?(W?b:a):"")+(/all|right/.test(F)&&A===0?(W?a:b):"")+this._generateMonthYearHeader(i,g1,h1,e1,f1,A>0||C>0,q,r)+"</div><table class='ui-datepicker-calendar'><thead>"+"<tr>";H=(s?"<th class='ui-datepicker-week-col'>"+this._get(i,"weekHeader")+"</th>":"");for(z=0;z<7;z++){I=(z+k)%7;H+="<th"+((z+k+6)%7>=5?" class='ui-datepicker-week-end'":"")+">"+"<span title='"+l[I]+"'>"+o[I]+"</span></th>";}G+=H+"</tr></thead><tbody>";J=this._getDaysInMonth(h1,g1);if(h1===i.selectedYear&&g1===i.selectedMonth){i.selectedDay=Math.min(i.selectedDay,J);}K=(this._getFirstDayOfMonth(h1,g1)-k+7)%7;L=Math.ceil((K+J)/7);M=(c1?this.maxRows>L?this.maxRows:L:L);this.maxRows=M;N=this._daylightSavingAdjust(new Date(h1,g1,1-K));for(R=0;R<M;R++){G+="<tr>";O=(!s?"":"<td class='ui-datepicker-week-col'>"+this._get(i,"calculateWeek")(N)+"</td>");for(z=0;z<7;z++){Q=(t?t.apply((i.input?i.input[0]:null),[N]):[true,""]);S=(N.getMonth()!==g1);T=(S&&!w)||!Q[0]||(e1&&N<e1)||(f1&&N>f1);O+="<td class='"+((z+k+6)%7>=5?" ui-datepicker-week-end":"")+(S?" ui-datepicker-other-month":"")+((N.getTime()===E.getTime()&&g1===i.selectedMonth&&i._keyEvent)||(x.getTime()===N.getTime()&&x.getTime()===E.getTime())?" "+this._dayOverClass:"")+(T?" "+this._unselectableClass+" ui-state-disabled":"")+(S&&!v?"":" "+Q[1]+(N.getTime()===d1.getTime()?" "+this._currentClass:"")+(N.getTime()===V.getTime()?" ui-datepicker-today":""))+"'"+((!S||v)&&Q[2]?" title='"+Q[2].replace(/'/g,"&#39;")+"'":"")+(T?"":" data-handler='selectDay' data-event='click' data-month='"+N.getMonth()+"' data-year='"+N.getFullYear()+"'")+">"+(S&&!v?"&#xa0;":(T?"<span class='ui-state-default'>"+N.getDate()+"</span>":"<a class='ui-state-default"+(N.getTime()===V.getTime()?" ui-state-highlight":"")+(N.getTime()===d1.getTime()?" ui-state-active":"")+(S?" ui-priority-secondary":"")+"' href='#'>"+N.getDate()+"</a>"))+"</td>";N.setDate(N.getDate()+1);N=this._daylightSavingAdjust(N);}G+=O+"</tr>";}g1++;if(g1>11){g1=0;h1++;}G+="</tbody></table>"+(c1?"</div>"+((_[0]>0&&C===_[1]-1)?"<div class='ui-datepicker-row-break'></div>":""):"");B+=G;}y+=B;}y+=j;i._keyEvent=false;return y;},_generateMonthYearHeader:function(i,a,b,m,e,s,g,h){var j,k,l,y,t,n,o,p,q=this._get(i,"changeMonth"),r=this._get(i,"changeYear"),v=this._get(i,"showMonthAfterYear"),w="<div class='ui-datepicker-title'>",x="";if(s||!q){x+="<span class='ui-datepicker-month'>"+g[a]+"</span>";}else{j=(m&&m.getFullYear()===b);k=(e&&e.getFullYear()===b);x+="<select class='ui-datepicker-month' data-handler='selectMonth' data-event='change'>";for(l=0;l<12;l++){if((!j||l>=m.getMonth())&&(!k||l<=e.getMonth())){x+="<option value='"+l+"'"+(l===a?" selected='selected'":"")+">"+h[l]+"</option>";}}x+="</select>";}if(!v){w+=x+(s||!(q&&r)?"&#xa0;":"");}if(!i.yearshtml){i.yearshtml="";if(s||!r){w+="<span class='ui-datepicker-year'>"+b+"</span>";}else{y=this._get(i,"yearRange").split(":");t=new Date().getFullYear();n=function(z){var o=(z.match(/c[+\-].*/)?b+parseInt(z.substring(1),10):(z.match(/[+\-].*/)?t+parseInt(z,10):parseInt(z,10)));return(isNaN(o)?t:o);};o=n(y[0]);p=Math.max(o,n(y[1]||""));o=(m?Math.max(o,m.getFullYear()):o);p=(e?Math.min(p,e.getFullYear()):p);i.yearshtml+="<select class='ui-datepicker-year' data-handler='selectYear' data-event='change'>";for(;o<=p;o++){i.yearshtml+="<option value='"+o+"'"+(o===b?" selected='selected'":"")+">"+o+"</option>";}i.yearshtml+="</select>";w+=i.yearshtml;i.yearshtml=null;}}w+=this._get(i,"yearSuffix");if(v){w+=(s||!(q&&r)?"&#xa0;":"")+x;}w+="</div>";return w;},_adjustInstDate:function(i,o,p){var y=i.drawYear+(p==="Y"?o:0),m=i.drawMonth+(p==="M"?o:0),a=Math.min(i.selectedDay,this._getDaysInMonth(y,m))+(p==="D"?o:0),b=this._restrictMinMax(i,this._daylightSavingAdjust(new Date(y,m,a)));i.selectedDay=b.getDate();i.drawMonth=i.selectedMonth=b.getMonth();i.drawYear=i.selectedYear=b.getFullYear();if(p==="M"||p==="Y"){this._notifyChange(i);}},_restrictMinMax:function(i,a){var m=this._getMinMaxDate(i,"min"),b=this._getMinMaxDate(i,"max"),n=(m&&a<m?m:a);return(b&&n>b?b:n);},_notifyChange:function(i){var o=this._get(i,"onChangeMonthYear");if(o){o.apply((i.input?i.input[0]:null),[i.selectedYear,i.selectedMonth+1,i]);}},_getNumberOfMonths:function(i){var n=this._get(i,"numberOfMonths");return(n==null?[1,1]:(typeof n==="number"?[1,n]:n));},_getMinMaxDate:function(i,m){return this._determineDate(i,this._get(i,m+"Date"),null);},_getDaysInMonth:function(y,m){return 32-this._daylightSavingAdjust(new Date(y,m,32)).getDate();},_getFirstDayOfMonth:function(y,m){return new Date(y,m,1).getDay();},_canAdjustMonth:function(i,o,a,b){var n=this._getNumberOfMonths(i),e=this._daylightSavingAdjust(new Date(a,b+(o<0?o:n[0]*n[1]),1));if(o<0){e.setDate(this._getDaysInMonth(e.getFullYear(),e.getMonth()));}return this._isInRange(i,e);},_isInRange:function(i,a){var y,b,m=this._getMinMaxDate(i,"min"),e=this._getMinMaxDate(i,"max"),g=null,h=null,j=this._get(i,"yearRange");if(j){y=j.split(":");b=new Date().getFullYear();g=parseInt(y[0],10);h=parseInt(y[1],10);if(y[0].match(/[+\-].*/)){g+=b;}if(y[1].match(/[+\-].*/)){h+=b;}}return((!m||a.getTime()>=m.getTime())&&(!e||a.getTime()<=e.getTime())&&(!g||a.getFullYear()>=g)&&(!h||a.getFullYear()<=h));},_getFormatConfig:function(i){var s=this._get(i,"shortYearCutoff");s=(typeof s!=="string"?s:new Date().getFullYear()%100+parseInt(s,10));return{shortYearCutoff:s,dayNamesShort:this._get(i,"dayNamesShort"),dayNames:this._get(i,"dayNames"),monthNamesShort:this._get(i,"monthNamesShort"),monthNames:this._get(i,"monthNames")};},_formatDate:function(i,a,m,y){if(!a){i.currentDay=i.selectedDay;i.currentMonth=i.selectedMonth;i.currentYear=i.selectedYear;}var b=(a?(typeof a==="object"?a:this._daylightSavingAdjust(new Date(y,m,a))):this._daylightSavingAdjust(new Date(i.currentYear,i.currentMonth,i.currentDay)));return this.formatDate(this._get(i,"dateFormat"),b,this._getFormatConfig(i));}});
function d(a){var s="button, .ui-datepicker-prev, .ui-datepicker-next, .ui-datepicker-calendar td a";return a.delegate(s,"mouseout",function(){$(this).removeClass("ui-state-hover");if(this.className.indexOf("ui-datepicker-prev")!==-1){$(this).removeClass("ui-datepicker-prev-hover");}if(this.className.indexOf("ui-datepicker-next")!==-1){$(this).removeClass("ui-datepicker-next-hover");}}).delegate(s,"mouseover",function(){if(!$.datepicker._isDisabledDatepicker(c.inline?a.parent()[0]:c.input[0])){$(this).parents(".ui-datepicker-calendar").find("a").removeClass("ui-state-hover");$(this).addClass("ui-state-hover");if(this.className.indexOf("ui-datepicker-prev")!==-1){$(this).addClass("ui-datepicker-prev-hover");}if(this.className.indexOf("ui-datepicker-next")!==-1){$(this).addClass("ui-datepicker-next-hover");}}});}
function f(t,p){$.extend(t,p);for(var n in p){if(p[n]==null){t[n]=p[n];}}return t;}
$.fn.datepicker=function(o){if(!this.length){return this;}if(!$.datepicker.initialized){$(document).mousedown($.datepicker._checkExternalClick);$.datepicker.initialized=true;}if($("#"+$.datepicker._mainDivId).length===0){$("body").append($.datepicker.dpDiv);}var a=Array.prototype.slice.call(arguments,1);if(typeof o==="string"&&(o==="isDisabled"||o==="getDate"||o==="widget")){return $.datepicker["_"+o+"Datepicker"].apply($.datepicker,[this[0]].concat(a));}if(o==="option"&&arguments.length===2&&typeof arguments[1]==="string"){return $.datepicker["_"+o+"Datepicker"].apply($.datepicker,[this[0]].concat(a));}return this.each(function(){typeof o==="string"?$.datepicker["_"+o+"Datepicker"].apply($.datepicker,[this].concat(a)):$.datepicker._attachDatepicker(this,o);});};
$.datepicker=new D();$.datepicker.initialized=false;$.datepicker.uuid=new Date().getTime();$.datepicker.version="1.10.4";})(jQuery);
},
	"sap/ui/thirdparty/caja-html-sanitizer.js":function(){
/* the subsequent text seems not to contain a copyright or license statement */
(function(){
/* Copyright Google Inc.
 * Licensed under the Apache Licence Version 2.0
 * Autogenerated at Tue May 22 10:18:21 PDT 2012
 * \@overrides window
 * \@provides cssSchema, CSS_PROP_BIT_QUANTITY, CSS_PROP_BIT_HASH_VALUE, CSS_PROP_BIT_NEGATIVE_QUANTITY, CSS_PROP_BIT_QSTRING_CONTENT, CSS_PROP_BIT_QSTRING_URL, CSS_PROP_BIT_HISTORY_INSENSITIVE, CSS_PROP_BIT_Z_INDEX, CSS_PROP_BIT_ALLOWED_IN_LINK */
var C=1;var a=2;var b=4;var d=8;var f=16;var g=32;var l=64;var o=128;var r=(function(){var s=['rgb(?:\\(\\s*(?:\\d+|0|\\d+(?:\\.\\d+)?%)\\s*,\\s*(?:\\d+|0|\\d+(?:\\.\\d+)?%)\\s*,\\s*(?:\\d+|0|\\d+(?:\\.\\d+)?%)|a\\(\\s*(?:\\d+|0|\\d+(?:\\.\\d+)?%)\\s*,\\s*(?:\\d+|0|\\d+(?:\\.\\d+)?%)\\s*,\\s*(?:\\d+|0|\\d+(?:\\.\\d+)?%)\\s*,\\s*(?:\\d+|0(?:\\.\\d+)?|\\.\\d+|1(?:\\.0+)?|0|\\d+(?:\\.\\d+)?%)) *\\)'],c=[/^ *$/i,RegExp('^ *(?:\\s*'+s[0]+'|(?:\\s*'+s[0]+')?)+ *$','i'),RegExp('^ *\\s*'+s[0]+' *$','i'),RegExp('^ *\\s*'+s[0]+'\\s*'+s[0]+' *$','i')],L=[['aliceblue','antiquewhite','aqua','aquamarine','azure','beige','bisque','black','blanchedalmond','blue','blueviolet','brown','burlywood','cadetblue','chartreuse','chocolate','coral','cornflowerblue','cornsilk','crimson','cyan','darkblue','darkcyan','darkgoldenrod','darkgray','darkgreen','darkkhaki','darkmagenta','darkolivegreen','darkorange','darkorchid','darkred','darksalmon','darkseagreen','darkslateblue','darkslategray','darkturquoise','darkviolet','deeppink','deepskyblue','dimgray','dodgerblue','firebrick','floralwhite','forestgreen','fuchsia','gainsboro','ghostwhite','gold','goldenrod','gray','green','greenyellow','honeydew','hotpink','indianred','indigo','ivory','khaki','lavender','lavenderblush','lawngreen','lemonchiffon','lightblue','lightcoral','lightcyan','lightgoldenrodyellow','lightgreen','lightgrey','lightpink','lightsalmon','lightseagreen','lightskyblue','lightslategray','lightsteelblue','lightyellow','lime','limegreen','linen','magenta','maroon','mediumaquamarine','mediumblue','mediumorchid','mediumpurple','mediumseagreen','mediumslateblue','mediumspringgreen','mediumturquoise','mediumvioletred','midnightblue','mintcream','mistyrose','moccasin','navajowhite','navy','oldlace','olive','olivedrab','orange','orangered','orchid','palegoldenrod','palegreen','paleturquoise','palevioletred','papayawhip','peachpuff','peru','pink','plum','powderblue','purple','red','rosybrown','royalblue','saddlebrown','salmon','sandybrown','seagreen','seashell','sienna','silver','skyblue','slateblue','slategray','snow','springgreen','steelblue','tan','teal','thistle','tomato','turquoise','violet','wheat','white','whitesmoke','yellow','yellowgreen'],['all-scroll','col-resize','crosshair','default','e-resize','hand','help','move','n-resize','ne-resize','no-drop','not-allowed','nw-resize','pointer','progress','row-resize','s-resize','se-resize','sw-resize','text','vertical-text','w-resize','wait'],['-moz-inline-box','-moz-inline-stack','block','inline','inline-block','inline-table','list-item','run-in','table','table-caption','table-cell','table-column','table-column-group','table-footer-group','table-header-group','table-row','table-row-group'],['armenian','circle','decimal','decimal-leading-zero','disc','georgian','lower-alpha','lower-greek','lower-latin','lower-roman','square','upper-alpha','upper-latin','upper-roman'],['100','200','300','400','500','600','700','800','900','bold','bolder','lighter'],['condensed','expanded','extra-condensed','extra-expanded','narrower','semi-condensed','semi-expanded','ultra-condensed','ultra-expanded','wider'],['behind','center-left','center-right','far-left','far-right','left-side','leftwards','right-side','rightwards'],['large','larger','small','smaller','x-large','x-small','xx-large','xx-small'],['-moz-pre-wrap','-o-pre-wrap','-pre-wrap','nowrap','pre','pre-line','pre-wrap'],['dashed','dotted','double','groove','outset','ridge','solid'],['baseline','middle','sub','super','text-bottom','text-top'],['caption','icon','menu','message-box','small-caption','status-bar'],['fast','faster','slow','slower','x-fast','x-slow'],['above','below','higher','level','lower'],['border-box','contain','content-box','cover','padding-box'],['cursive','fantasy','monospace','sans-serif','serif'],['loud','silent','soft','x-loud','x-soft'],['no-repeat','repeat-x','repeat-y','round','space'],['blink','line-through','overline','underline'],['high','low','x-high','x-low'],['absolute','relative','static'],['capitalize','lowercase','uppercase'],['child','female','male'],['bidi-override','embed'],['bottom','top'],['clip','ellipsis'],['continuous','digits'],['hide','show'],['inside','outside'],['italic','oblique'],['left','right'],['ltr','rtl'],['no-content','no-display'],['suppress','unrestricted'],['thick','thin'],[','],['/'],['always'],['auto'],['avoid'],['both'],['break-word'],['center'],['code'],['collapse'],['fixed'],['hidden'],['inherit'],['inset'],['invert'],['justify'],['local'],['medium'],['mix'],['none'],['normal'],['once'],['repeat'],['scroll'],['separate'],['small-caps'],['spell-out'],['transparent'],['visible']];return{'-moz-border-radius':{'cssExtra':c[0],'cssPropBits':5,'cssLitGroup':[L[36]]},'-moz-border-radius-bottomleft':{'cssExtra':c[0],'cssPropBits':5},'-moz-border-radius-bottomright':{'cssExtra':c[0],'cssPropBits':5},'-moz-border-radius-topleft':{'cssExtra':c[0],'cssPropBits':5},'-moz-border-radius-topright':{'cssExtra':c[0],'cssPropBits':5},'-moz-box-shadow':{'cssExtra':c[1],'cssAlternates':['boxShadow'],'cssPropBits':7,'cssLitGroup':[L[0],L[35],L[48],L[54]]},'-moz-opacity':{'cssPropBits':1,'cssLitGroup':[L[47]]},'-moz-outline':{'cssExtra':c[3],'cssPropBits':7,'cssLitGroup':[L[0],L[9],L[34],L[46],L[47],L[48],L[49],L[52],L[54]]},'-moz-outline-color':{'cssExtra':c[2],'cssPropBits':2,'cssLitGroup':[L[0],L[47],L[49]]},'-moz-outline-style':{'cssPropBits':0,'cssLitGroup':[L[9],L[46],L[47],L[48],L[54]]},'-moz-outline-width':{'cssPropBits':5,'cssLitGroup':[L[34],L[47],L[52]]},'-o-text-overflow':{'cssPropBits':0,'cssLitGroup':[L[25]]},'-webkit-border-bottom-left-radius':{'cssExtra':c[0],'cssPropBits':5},'-webkit-border-bottom-right-radius':{'cssExtra':c[0],'cssPropBits':5},'-webkit-border-radius':{'cssExtra':c[0],'cssPropBits':5,'cssLitGroup':[L[36]]},'-webkit-border-radius-bottom-left':{'cssExtra':c[0],'cssPropBits':5},'-webkit-border-radius-bottom-right':{'cssExtra':c[0],'cssPropBits':5},'-webkit-border-radius-top-left':{'cssExtra':c[0],'cssPropBits':5},'-webkit-border-radius-top-right':{'cssExtra':c[0],'cssPropBits':5},'-webkit-border-top-left-radius':{'cssExtra':c[0],'cssPropBits':5},'-webkit-border-top-right-radius':{'cssExtra':c[0],'cssPropBits':5},'-webkit-box-shadow':{'cssExtra':c[1],'cssAlternates':['boxShadow'],'cssPropBits':7,'cssLitGroup':[L[0],L[35],L[48],L[54]]},'azimuth':{'cssPropBits':5,'cssLitGroup':[L[6],L[30],L[42],L[47]]},'background':{'cssExtra':RegExp('^ *(?:\\s*'+s[0]+'){0,2} *$','i'),'cssPropBits':23,'cssLitGroup':[L[0],L[14],L[17],L[24],L[30],L[35],L[36],L[38],L[42],L[45],L[47],L[51],L[54],L[57],L[58],L[62]]},'background-attachment':{'cssExtra':c[0],'cssPropBits':0,'cssLitGroup':[L[35],L[45],L[51],L[58]]},'background-color':{'cssExtra':c[2],'cssPropBits':130,'cssLitGroup':[L[0],L[47],L[62]]},'background-image':{'cssExtra':c[0],'cssPropBits':16,'cssLitGroup':[L[35],L[54]]},'background-position':{'cssExtra':c[0],'cssPropBits':5,'cssLitGroup':[L[24],L[30],L[35],L[42]]},'background-repeat':{'cssExtra':c[0],'cssPropBits':0,'cssLitGroup':[L[17],L[35],L[57]]},'border':{'cssExtra':c[3],'cssPropBits':7,'cssLitGroup':[L[0],L[9],L[34],L[46],L[47],L[48],L[52],L[54],L[62]]},'border-bottom':{'cssExtra':c[3],'cssPropBits':7,'cssLitGroup':[L[0],L[9],L[34],L[46],L[47],L[48],L[52],L[54],L[62]]},'border-bottom-color':{'cssExtra':c[2],'cssPropBits':2,'cssLitGroup':[L[0],L[47],L[62]]},'border-bottom-left-radius':{'cssExtra':c[0],'cssPropBits':5},'border-bottom-right-radius':{'cssExtra':c[0],'cssPropBits':5},'border-bottom-style':{'cssPropBits':0,'cssLitGroup':[L[9],L[46],L[47],L[48],L[54]]},'border-bottom-width':{'cssPropBits':5,'cssLitGroup':[L[34],L[47],L[52]]},'border-collapse':{'cssPropBits':0,'cssLitGroup':[L[44],L[47],L[59]]},'border-color':{'cssExtra':RegExp('^ *(?:\\s*'+s[0]+'){1,4} *$','i'),'cssPropBits':2,'cssLitGroup':[L[0],L[47],L[62]]},'border-left':{'cssExtra':c[3],'cssPropBits':7,'cssLitGroup':[L[0],L[9],L[34],L[46],L[47],L[48],L[52],L[54],L[62]]},'border-left-color':{'cssExtra':c[2],'cssPropBits':2,'cssLitGroup':[L[0],L[47],L[62]]},'border-left-style':{'cssPropBits':0,'cssLitGroup':[L[9],L[46],L[47],L[48],L[54]]},'border-left-width':{'cssPropBits':5,'cssLitGroup':[L[34],L[47],L[52]]},'border-radius':{'cssExtra':c[0],'cssPropBits':5,'cssLitGroup':[L[36]]},'border-right':{'cssExtra':c[3],'cssPropBits':7,'cssLitGroup':[L[0],L[9],L[34],L[46],L[47],L[48],L[52],L[54],L[62]]},'border-right-color':{'cssExtra':c[2],'cssPropBits':2,'cssLitGroup':[L[0],L[47],L[62]]},'border-right-style':{'cssPropBits':0,'cssLitGroup':[L[9],L[46],L[47],L[48],L[54]]},'border-right-width':{'cssPropBits':5,'cssLitGroup':[L[34],L[47],L[52]]},'border-spacing':{'cssExtra':c[0],'cssPropBits':5,'cssLitGroup':[L[47]]},'border-style':{'cssPropBits':0,'cssLitGroup':[L[9],L[46],L[47],L[48],L[54]]},'border-top':{'cssExtra':c[3],'cssPropBits':7,'cssLitGroup':[L[0],L[9],L[34],L[46],L[47],L[48],L[52],L[54],L[62]]},'border-top-color':{'cssExtra':c[2],'cssPropBits':2,'cssLitGroup':[L[0],L[47],L[62]]},'border-top-left-radius':{'cssExtra':c[0],'cssPropBits':5},'border-top-right-radius':{'cssExtra':c[0],'cssPropBits':5},'border-top-style':{'cssPropBits':0,'cssLitGroup':[L[9],L[46],L[47],L[48],L[54]]},'border-top-width':{'cssPropBits':5,'cssLitGroup':[L[34],L[47],L[52]]},'border-width':{'cssPropBits':5,'cssLitGroup':[L[34],L[47],L[52]]},'bottom':{'cssPropBits':5,'cssLitGroup':[L[38],L[47]]},'box-shadow':{'cssExtra':c[1],'cssPropBits':7,'cssLitGroup':[L[0],L[35],L[48],L[54]]},'caption-side':{'cssPropBits':0,'cssLitGroup':[L[24],L[47]]},'clear':{'cssPropBits':0,'cssLitGroup':[L[30],L[40],L[47],L[54]]},'clip':{'cssExtra':/^ *\s*rect\(\s*(?:0|[+\-]?\d+(?:\.\d+)?(?:[cem]m|ex|in|p[ctx])|auto)\s*,\s*(?:0|[+\-]?\d+(?:\.\d+)?(?:[cem]m|ex|in|p[ctx])|auto)\s*,\s*(?:0|[+\-]?\d+(?:\.\d+)?(?:[cem]m|ex|in|p[ctx])|auto)\s*,\s*(?:0|[+\-]?\d+(?:\.\d+)?(?:[cem]m|ex|in|p[ctx])|auto) *\) *$/i,'cssPropBits':0,'cssLitGroup':[L[38],L[47]]},'color':{'cssExtra':c[2],'cssPropBits':130,'cssLitGroup':[L[0],L[47]]},'content':{'cssPropBits':0},'counter-increment':{'cssExtra':c[0],'cssPropBits':5,'cssLitGroup':[L[47],L[54]]},'counter-reset':{'cssExtra':c[0],'cssPropBits':5,'cssLitGroup':[L[47],L[54]]},'cue':{'cssPropBits':16,'cssLitGroup':[L[47],L[54]]},'cue-after':{'cssPropBits':16,'cssLitGroup':[L[47],L[54]]},'cue-before':{'cssPropBits':16,'cssLitGroup':[L[47],L[54]]},'cursor':{'cssExtra':c[0],'cssPropBits':144,'cssLitGroup':[L[1],L[35],L[38],L[47]]},'direction':{'cssPropBits':0,'cssLitGroup':[L[31],L[47]]},'display':{'cssPropBits':32,'cssLitGroup':[L[2],L[47],L[54]]},'elevation':{'cssPropBits':5,'cssLitGroup':[L[13],L[47]]},'empty-cells':{'cssPropBits':0,'cssLitGroup':[L[27],L[47]]},'filter':{'cssExtra':/^ *(?:\s*alpha\(\s*opacity\s*=\s*(?:0|\d+(?:\.\d+)?%|[+\-]?\d+(?:\.\d+)?) *\))+ *$/i,'cssPropBits':32},'float':{'cssAlternates':['cssFloat','styleFloat'],'cssPropBits':32,'cssLitGroup':[L[30],L[47],L[54]]},'font':{'cssExtra':c[0],'cssPropBits':9,'cssLitGroup':[L[4],L[7],L[11],L[15],L[29],L[35],L[36],L[47],L[52],L[55],L[60]]},'font-family':{'cssExtra':c[0],'cssPropBits':8,'cssLitGroup':[L[15],L[35],L[47]]},'font-size':{'cssPropBits':1,'cssLitGroup':[L[7],L[47],L[52]]},'font-stretch':{'cssPropBits':0,'cssLitGroup':[L[5],L[55]]},'font-style':{'cssPropBits':0,'cssLitGroup':[L[29],L[47],L[55]]},'font-variant':{'cssPropBits':0,'cssLitGroup':[L[47],L[55],L[60]]},'font-weight':{'cssPropBits':0,'cssLitGroup':[L[4],L[47],L[55]]},'height':{'cssPropBits':37,'cssLitGroup':[L[38],L[47]]},'left':{'cssPropBits':37,'cssLitGroup':[L[38],L[47]]},'letter-spacing':{'cssPropBits':5,'cssLitGroup':[L[47],L[55]]},'line-height':{'cssPropBits':1,'cssLitGroup':[L[47],L[55]]},'list-style':{'cssPropBits':16,'cssLitGroup':[L[3],L[28],L[47],L[54]]},'list-style-image':{'cssPropBits':16,'cssLitGroup':[L[47],L[54]]},'list-style-position':{'cssPropBits':0,'cssLitGroup':[L[28],L[47]]},'list-style-type':{'cssPropBits':0,'cssLitGroup':[L[3],L[47],L[54]]},'margin':{'cssPropBits':5,'cssLitGroup':[L[38],L[47]]},'margin-bottom':{'cssPropBits':5,'cssLitGroup':[L[38],L[47]]},'margin-left':{'cssPropBits':5,'cssLitGroup':[L[38],L[47]]},'margin-right':{'cssPropBits':5,'cssLitGroup':[L[38],L[47]]},'margin-top':{'cssPropBits':5,'cssLitGroup':[L[38],L[47]]},'max-height':{'cssPropBits':1,'cssLitGroup':[L[38],L[47],L[54]]},'max-width':{'cssPropBits':1,'cssLitGroup':[L[38],L[47],L[54]]},'min-height':{'cssPropBits':1,'cssLitGroup':[L[38],L[47]]},'min-width':{'cssPropBits':1,'cssLitGroup':[L[38],L[47]]},'opacity':{'cssPropBits':33,'cssLitGroup':[L[47]]},'outline':{'cssExtra':c[3],'cssPropBits':7,'cssLitGroup':[L[0],L[9],L[34],L[46],L[47],L[48],L[49],L[52],L[54]]},'outline-color':{'cssExtra':c[2],'cssPropBits':2,'cssLitGroup':[L[0],L[47],L[49]]},'outline-style':{'cssPropBits':0,'cssLitGroup':[L[9],L[46],L[47],L[48],L[54]]},'outline-width':{'cssPropBits':5,'cssLitGroup':[L[34],L[47],L[52]]},'overflow':{'cssPropBits':32,'cssLitGroup':[L[38],L[46],L[47],L[58],L[63]]},'overflow-x':{'cssPropBits':0,'cssLitGroup':[L[32],L[38],L[46],L[58],L[63]]},'overflow-y':{'cssPropBits':0,'cssLitGroup':[L[32],L[38],L[46],L[58],L[63]]},'padding':{'cssPropBits':1,'cssLitGroup':[L[47]]},'padding-bottom':{'cssPropBits':33,'cssLitGroup':[L[47]]},'padding-left':{'cssPropBits':33,'cssLitGroup':[L[47]]},'padding-right':{'cssPropBits':33,'cssLitGroup':[L[47]]},'padding-top':{'cssPropBits':33,'cssLitGroup':[L[47]]},'page-break-after':{'cssPropBits':0,'cssLitGroup':[L[30],L[37],L[38],L[39],L[47]]},'page-break-before':{'cssPropBits':0,'cssLitGroup':[L[30],L[37],L[38],L[39],L[47]]},'page-break-inside':{'cssPropBits':0,'cssLitGroup':[L[38],L[39],L[47]]},'pause':{'cssPropBits':5,'cssLitGroup':[L[47]]},'pause-after':{'cssPropBits':5,'cssLitGroup':[L[47]]},'pause-before':{'cssPropBits':5,'cssLitGroup':[L[47]]},'pitch':{'cssPropBits':5,'cssLitGroup':[L[19],L[47],L[52]]},'pitch-range':{'cssPropBits':5,'cssLitGroup':[L[47]]},'play-during':{'cssExtra':c[0],'cssPropBits':16,'cssLitGroup':[L[38],L[47],L[53],L[54],L[57]]},'position':{'cssPropBits':32,'cssLitGroup':[L[20],L[47]]},'quotes':{'cssExtra':c[0],'cssPropBits':0,'cssLitGroup':[L[47],L[54]]},'richness':{'cssPropBits':5,'cssLitGroup':[L[47]]},'right':{'cssPropBits':37,'cssLitGroup':[L[38],L[47]]},'speak':{'cssPropBits':0,'cssLitGroup':[L[47],L[54],L[55],L[61]]},'speak-header':{'cssPropBits':0,'cssLitGroup':[L[37],L[47],L[56]]},'speak-numeral':{'cssPropBits':0,'cssLitGroup':[L[26],L[47]]},'speak-punctuation':{'cssPropBits':0,'cssLitGroup':[L[43],L[47],L[54]]},'speech-rate':{'cssPropBits':5,'cssLitGroup':[L[12],L[47],L[52]]},'stress':{'cssPropBits':5,'cssLitGroup':[L[47]]},'table-layout':{'cssPropBits':0,'cssLitGroup':[L[38],L[45],L[47]]},'text-align':{'cssPropBits':0,'cssLitGroup':[L[30],L[42],L[47],L[50]]},'text-decoration':{'cssPropBits':0,'cssLitGroup':[L[18],L[47],L[54]]},'text-indent':{'cssPropBits':5,'cssLitGroup':[L[47]]},'text-overflow':{'cssPropBits':0,'cssLitGroup':[L[25]]},'text-shadow':{'cssExtra':c[1],'cssPropBits':7,'cssLitGroup':[L[0],L[35],L[48],L[54]]},'text-transform':{'cssPropBits':0,'cssLitGroup':[L[21],L[47],L[54]]},'text-wrap':{'cssPropBits':0,'cssLitGroup':[L[33],L[54],L[55]]},'top':{'cssPropBits':37,'cssLitGroup':[L[38],L[47]]},'unicode-bidi':{'cssPropBits':0,'cssLitGroup':[L[23],L[47],L[55]]},'vertical-align':{'cssPropBits':5,'cssLitGroup':[L[10],L[24],L[47]]},'visibility':{'cssPropBits':32,'cssLitGroup':[L[44],L[46],L[47],L[63]]},'voice-family':{'cssExtra':c[0],'cssPropBits':8,'cssLitGroup':[L[22],L[35],L[47]]},'volume':{'cssPropBits':1,'cssLitGroup':[L[16],L[47],L[52]]},'white-space':{'cssPropBits':0,'cssLitGroup':[L[8],L[47],L[55]]},'width':{'cssPropBits':33,'cssLitGroup':[L[38],L[47]]},'word-spacing':{'cssPropBits':5,'cssLitGroup':[L[47],L[55]]},'word-wrap':{'cssPropBits':0,'cssLitGroup':[L[41],L[55]]},'z-index':{'cssPropBits':69,'cssLitGroup':[L[38],L[47]]},'zoom':{'cssPropBits':1,'cssLitGroup':[L[55]]}};})();if(typeof window!=='undefined'){window['cssSchema']=r;}
// Copyright (C) 2011 Google Inc.
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//      http://www.apache.org/licenses/LICENSE-2.0
// distributed under the License is distributed on an "AS IS" BASIS,
// See the License for the specific language governing permissions and
// limitations under the License.
var t;var u;(function(){
function c(s){var i=parseInt(s.substring(1),16);if(i>0xffff){return i-=0x10000,String.fromCharCode(0xd800+(i>>10),0xdc00+(i&0x3FF));}else if(i==i){return String.fromCharCode(i);}else if(s[1]<' '){return'';}else{return s[1];}}
function e(s,i){return'"'+s.replace(/[\u0000-\u001f\\\"<>]/g,i)+'"';}
function h(i){return m[i]||(m[i]='\\'+i.charCodeAt(0).toString(16)+' ');}
function k(i){return p[i]||(p[i]=(i<'\x10'?'%0':'%')+i.charCodeAt(0).toString(16));}
var m={'\\':'\\\\'};var p={'\\':'%5c'};var q='[\\t\\n\\f ]';var W=q+'*';var N='[\\n\\f]';var v='[\\ud800-\\udbff][\\udc00-\\udfff]';var F='[\\u0080-\\ud7ff\\ue000-\\ufffd]|'+v;var U='[0-9a-fA-F]{1,6}'+q+'?';var G='\\\\'+U;var H='(?:'+U+'|[\\u0020-\\u007e\\u0080-\\ud7ff\\ue000\\ufffd]|'+v+')';var I='\\\\'+H;var J='(?:[\\t\\x21\\x23-\\x26\\x28-\\x5b\\x5d-\\x7e]|'+F+'|'+I+')';var K='[^\'"\\n\\f\\\\]|\\\\[\\s\\S]';var L='"(?:\'|'+K+')*"'+'|\'(?:\"|'+K+')*\'';var M='[-+]?(?:[0-9]+(?:[.][0-9]+)?|[.][0-9]+)';var O='(?:[a-zA-Z_]|'+F+'|'+I+')';var P='(?:[a-zA-Z0-9_-]|'+F+'|'+I+')';var Q=P+'+';var R='-?'+O+P+'*';var T='@'+R;var V='#'+Q;var X=M;var Y='(?:@?-?'+O+'|#)'+P+'*';var Z=M+'%';var $=M+R;var _=M+'(?:%|'+R+')?';var a1='url[(]'+W+'(?:'+L+'|'+J+'*)'+W+'[)]';var b1='U[+][0-9A-F?]{1,6}(?:-[0-9A-F]{1,6})?';var c1='<\!--';var d1='-->';var S=q+'+';var e1='/(?:[*][^*]*[*]+(?:[^/][^*]*[*]+)*/|/[^\\n\\f]*)';var f1='(?!url[(])(?=('+R+'))\\1[(]';var g1='~=';var h1='[|]=';var i1='[^]=';var j1='[$]=';var k1='[*]=';var l1='[~|^$*]=';var m1='[^"\'\\\\/]|/(?![/*])';var n1='\\uFEFF';var o1=new RegExp([n1,b1,a1,f1,Y,L,_,c1,d1,S,e1,l1,m1].join("|"),'gi');u=function(i){return i.replace(new RegExp('\\\\(?:'+H+'|'+N+')','g'),c);};t=function(s){s=''+s;var p1=s.replace(/\r\n?/g,'\n').match(o1)||[];var j=0;var q1=' ';for(var i=0,n=p1.length;i<n;++i){var r1=u(p1[i]);var s1=r1.length;var cc=r1.charCodeAt(0);r1=(cc=='"'.charCodeAt(0)||cc=='\''.charCodeAt(0))?e(r1.substring(1,s1-1),h):(cc=='/'.charCodeAt(0)&&s1>1||r1=='\\'||r1==d1||r1==c1||r1=='\ufeff'||cc<=' '.charCodeAt(0))?' ':/url\(/i.test(r1)?'url('+e(r1.replace(new RegExp('^url\\('+W+'["\']?|["\']?'+W+'\\)$','gi'),''),k)+')':r1;if(q1!=r1||r1!=' '){p1[j++]=q1=r1;}}p1.length=j;return p1;};})();if(typeof window!=='undefined'){window['lexCss']=t;window['decodeCss']=u;}
// Copyright (C) 2011 Google Inc.
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//      http://www.apache.org/licenses/LICENSE-2.0
// distributed under the License is distributed on an "AS IS" BASIS,
// See the License for the specific language governing permissions and
// limitations under the License.
var w=(function(){var N='url("about:blank")';var c=/[\n\f\r\"\'()*<>]/g;var e={'\n':'%0a','\f':'%0c','\r':'%0d','"':'%22','\'':'%27','(':'%28',')':'%29','*':'%2a','<':'%3c','>':'%3e'};function h(s){if('string'===typeof s){return'url("'+s.replace(c,m)+'")';}else{return N;}}function m(i){return e[i];}var U=new RegExp('^'+'(?:'+'([^:\/?# ]+)'+':)?');var p=/^(?:https?|mailto)$/i;function q(i,j,n){if(!n){return null;}var k=(''+i).match(U);if(k&&(!k[1]||p.test(k[1]))){return n(i,j);}else{return null;}}function v(k){var n={};for(var i=k.length;--i>=0;){var s=k[i];for(var j=s.length;--j>=0;){n[s[j]]=G;}}return n;}function F(i,s){var j=1,k=s+1,n=i.length;while(k<n&&j){var H=i[k++];j+=(H==='('?1:H===')'?-1:0);}return k;}var G={};return function(j,n,s,H){var I=n.cssPropBits;var J=I&(d|f);var K=NaN;var i=0,k=0;for(;i<s.length;++i){var L=s[i].toLowerCase();var M=L.charCodeAt(0),O,P,Q,R,S;var T,V;L=((M===' '.charCodeAt(0))?'':(M==='"'.charCodeAt(0))?((J===f&&H)?(h(q(u(s[i].substring(1,L.length-1)),j,H))):(J===d)?L:''):(M==='#'.charCodeAt(0)&&/^#(?:[0-9a-f]{3}){1,2}$/.test(L))?(I&a?L:''):('0'.charCodeAt(0)<=M&&M<='9'.charCodeAt(0))?((I&C)?((I&l)?(L.match(/^\d{1,7}$/)?L:''):L):''):(O=L.charCodeAt(1),P=L.charCodeAt(2),Q='0'.charCodeAt(0)<=O&&O<='9'.charCodeAt(0),R='0'.charCodeAt(0)<=P&&P<='9'.charCodeAt(0),(M==='+'.charCodeAt(0)&&(Q||(O==='.'.charCodeAt(0)&&R))))?((I&C)?((I&l)?(L.match(/^\+\d{1,7}$/)?L:''):((Q?'':'0')+L.substring(1))):''):(M==='-'.charCodeAt(0)&&(Q||(O==='.'.charCodeAt(0)&&R)))?((I&b)?((I&l)?(L.match(/^\-\d{1,7}$/)?L:''):((Q?'-':'-0')+L.substring(1))):((I&C)?'0':'')):(M==='.'.charCodeAt(0)&&Q)?((I&C)?'0'+L:''):('url('===L.substring(0,4))?((H&&(J&f))?h(q(s[i].substring(5,L.length-2),j,H)):''):((L.charAt(L.length-1)==='(')&&(S=F(s,i),s.splice(i,S-i,L=s.slice(i,S).join(' '))),T=n.cssLitGroup,V=(T?(n.cssLitMap||(n.cssLitMap=v(T))):G),(V[L]===G||n.cssExtra&&n.cssExtra.test(L)))?L:(/^\w+$/.test(L)&&(J===d))?(K+1===k?(s[K]=s[K].substring(0,s[K].length-1)+' '+L+'"',L=''):(K=k,'"'+L+'"')):'');if(L){s[k++]=L;}}if(k===1&&s[0]===N){k=0;}s.length=k;};})();
function x(s,c){var h=[];var e=[];var k=0,i;for(i=0;i<s.length;++i){if(!(s[i]==' '&&(s[i-1]=='>'||s[i+1]=='>'))){s[k++]=s[i];}}s.length=k;var n=s.length,j=0;for(i=0;i<n;++i){if(s[i]==','){p(j,i);j=i+1;}}p(j,n);function p(j,m){var q=false;if(s[j]===' '){++j;}if(m-1!==j&&s[m]===' '){--m;}var v=[];var F=j;var G='';for(var i=j;i<m;++i){var H=s[i];var I=(H==='>');if(I||H===' '){G=J(F,i,false);if(!G||(I&&/^html/i.test(G))){return;}F=i+1;v.push(G,I?' > ':' ');}}G=J(F,m,true);if(!G){return;}v.push(G);function J(j,m,L){var M=j,N=m;var O,P,Q,H,R;O='';if(j<m){H=s[j].toLowerCase();if(H==='*'||(H==='body'&&j+1!==m&&!L)||('number'===typeof(R=B.ELEMENTS[H])&&!(R&B.eflags.UNSAFE))){++j;O=H;}}P='';while(j<m){H=s[j];if(H.charAt(0)==='#'){if(/^#_|__$|[^#0-9A-Za-z:_\-]/.test(H)){return null;}P+=H+'-'+c;}else if(H==='.'){if(++j<m&&/^[0-9A-Za-z:_\-]+$/.test(H=s[j])&&!/^_|__$/.test(H)){P+='.'+H;}else{return null;}}else{break;}++j;}Q='';if(j<m&&s[j]===':'){H=s[++j];if(H==='visited'||H==='link'){if(!/^[a*]?$/.test(O)){return null;}q=true;Q=':'+H;O='a';++j;}}if(j===m){return O+P+Q;}return null;}var K=v.join('');if(/^body\b/.test(K)){K='.vdoc-body___.'+c+K.substring(4);}else{K='.'+c+' '+K;}(q?h:e).push(K);}return[e,h];}
var y=(function(){var c={};var e={'braille':c,'embossed':c,'handheld':c,'print':c,'projection':c,'screen':c,'speech':c,'tty':c,'tv':c};function s(h){var j=false;for(var i=0,n=h.length;i<n-1;++i){var k=h[i];if(':'===h[i+1]){j=!(r[k].cssPropBits&o);}if(j){h[i]='';}if(';'===k){j=false;}}return h.join('');}return function(h,i,j){var k=void 0;var m=[];var n=false;z(h,{startStylesheet:function(){k=[];},endStylesheet:function(){},startAtrule:function(q,v){if(n){q=null;}else if(q==='@media'){v=v.filter(function(F){return e[F]==c;});if(v.length){k.push(q,v.join(','),'{');}else{q=null;}}else{if(q==='@import'){if(window.console){window.console.log('@import '+v.join(' ')+' elided');}}q=null;}n=!q;m.push(q);},endAtrule:function(){var q=m.pop();if(!n){k.push(';');}p();},startBlock:function(){if(!n){k.push('{');}},endBlock:function(){if(!n){k.push('}');n=true;}},startRuleset:function(q){var v=void 0;var F=false;if(!n){var G=x(q,i);var H=G[0];v=G[1];if(!H.length&&!v.length){n=true;}else{var I=H.join(', ');if(!I){I='head > html';F=true;}k.push(I,'{');}}m.push(n?null:{historySensitiveSelectors:v,endOfSelectors:k.length-1,removeHistoryInsensitiveSelectors:F});},endRuleset:function(){var q=m.pop();var v=k.length;if(!n){k.push('}');if(q){var F=q.historySensitiveSelectors;if(F.length){var G=k.slice(q.endOfSelectors);k.push(F.join(', '),s(G));}}}if(q&&q.removeHistoryInsensitiveSelectors){k.splice(q.endOfSelectors-1,v+1);}p();},declaration:function(q,v){if(!n){var F=r[q];if(F){w(q,F,v,j);if(v.length){k.push(q,':',v.join(' '),';');}}}}});function p(){n=m.length!==0&&m[m.length-1]!==null;}return k.join('');};})();if(typeof window!=='undefined'){window['sanitizeCssProperty']=w;window['sanitizeCssSelectors']=x;window['sanitizeStylesheet']=y;}
// Copyright (C) 2010 Google Inc.
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//      http://www.apache.org/licenses/LICENSE-2.0
// distributed under the License is distributed on an "AS IS" BASIS,
// See the License for the specific language governing permissions and
// limitations under the License.
var z;var A;(function(){z=function(e,j){var s=t(e);if(j.startStylesheet){j.startStylesheet();}for(var i=0,n=s.length;i<n;){i=s[i]===' '?i+1:c(s,i,n,j);}if(j.endStylesheet){j.endStylesheet();}};
function c(e,i,n,j){if(i<n){var s=e[i];if(s.charAt(0)==='@'){return h(e,i,n,j,true);}else{return m(e,i,n,j);}}else{return i;}}
function h(j,i,n,F,G){var H=i++;while(i<n&&j[i]!=='{'&&j[i]!==';'){++i;}if(i<n&&(G||j[i]===';')){var s=H+1,e=i;if(s<n&&j[s]===' '){++s;}if(e>s&&j[e-1]===' '){--e;}if(F.startAtrule){F.startAtrule(j[H].toLowerCase(),j.slice(s,e));}i=(j[i]==='{')?k(j,i,n,F):i+1;if(F.endAtrule){F.endAtrule();}}return i;}
function k(e,i,n,j){++i;if(j.startBlock){j.startBlock();}while(i<n){var s=e[i].charAt(0);if(s=='}'){++i;break;}if(s===' '||s===';'){i=i+1;}else if(s==='@'){i=h(e,i,n,j,false);}else if(s==='{'){i=k(e,i,n,j);}else{i=m(e,i,n,j);}}if(j.endBlock){j.endBlock();}return i;}
function m(j,i,n,F){var s=i,e=p(j,i,n,true);if(e<0){e=~e;return i===e?e+1:e;}i=e;if(e>s&&j[e-1]===' '){--e;}var G=j[i];++i;if(G!=='{'){return i;}if(F.startRuleset){F.startRuleset(j.slice(s,e));}while(i<n){G=j[i];if(G==='}'){++i;break;}if(G===' '){i=i+1;}else{i=v(j,i,n,F);}}if(F.endRuleset){F.endRuleset();}return i<n?i+1:i;}
function p(e,i,n,j){var s=i;var F;var G=[],H=-1;for(;i<n;++i){F=e[i].charAt(0);if(F==='['||F==='('){G[++H]=F;}else if((F===']'&&G[H]==='[')||(F===')'&&G[H]==='(')){--H;}else if(F==='{'||F==='}'||F===';'||F==='@'||(F===':'&&!j)){break;}}if(H>=0){i=~(i+1);}return i;}
var q=/^-?[a-z]/i;
function v(F,i,n,G){var H=F[i++];if(!q.test(H)){return i+1;}var I;if(i<n&&F[i]===' '){++i;}if(i==n||F[i]!==':'){while(i<n&&(I=F[i])!==';'&&I!=='}'){++i;}return i;}++i;if(i<n&&F[i]===' '){++i;}var s=i,e=p(F,i,n,false);if(e<0){e=~e;}else{var J=[],K=0;for(var j=s;j<e;++j){I=F[j];if(I!==' '){J[K++]=I;}}if(e<n){do{I=F[e];if(I===';'||I==='}'){break;}K=0;}while(++e<n);if(I===';'){++e;}}if(K&&G.declaration){G.declaration(H.toLowerCase(),J);}}return e;}
A=function(e,j){var s=t(e);for(var i=0,n=s.length;i<n;){i=s[i]!==' '?v(s,i,n,j):i+1;}};})();if(typeof window!=='undefined'){window['parseCssStylesheet']=z;window['parseCssDeclarations']=A;}
/*!
 * OpenUI5
 * (c) Copyright 2009-2020 SAP SE or an SAP affiliate company.
 * Licensed under the Apache License, Version 2.0 - see LICENSE.txt.
 */
var B={};B.atype={NONE:0,URI:1,URI_FRAGMENT:11,SCRIPT:2,STYLE:3,ID:4,IDREF:5,IDREFS:6,GLOBAL_NAME:7,LOCAL_NAME:8,CLASSES:9,FRAME_TARGET:10};B.ATTRIBS={'*::accesskey':0,'*::class':9,'*::contenteditable':0,'*::contextmenu':0,'*::dir':0,'*::draggable':0,'*::dropzone':0,'*::hidden':0,'*::id':4,'*::lang':0,'*::onabort':2,'*::onblur':2,'*::oncanplay':2,'*::oncanplaythrough':2,'*::onchange':2,'*::onclick':2,'*::oncontextmenu':2,'*::oncuechange':2,'*::ondblclick':2,'*::ondrag':2,'*::ondragend':2,'*::ondragenter':2,'*::ondragleave':2,'*::ondragover':2,'*::ondragstart':2,'*::ondrop':2,'*::ondurationchange':2,'*::onemptied':2,'*::onended':2,'*::onerror':2,'*::onfocus':2,'*::oninput':2,'*::oninvalid':2,'*::onkeydown':2,'*::onkeypress':2,'*::onkeyup':2,'*::onload':2,'*::onloadeddata':2,'*::onloadedmetadata':2,'*::onloadstart':2,'*::onmousedown':2,'*::onmousemove':2,'*::onmouseout':2,'*::onmouseover':2,'*::onmouseup':2,'*::onmousewheel':2,'*::onpause':2,'*::onplay':2,'*::onplaying':2,'*::onprogress':2,'*::onratechange':2,'*::onreadystatechange':2,'*::onreset':2,'*::onscroll':2,'*::onseeked':2,'*::onseeking':2,'*::onselect':2,'*::onshow':2,'*::onstalled':2,'*::onsubmit':2,'*::onsuspend':2,'*::ontimeupdate':2,'*::onvolumechange':2,'*::onwaiting':2,'*::spellcheck':0,'*::style':3,'*::tabindex':0,'*::title':0,'a::href':1,'a::hreflang':0,'a::media':0,'a::rel':0,'a::target':0,'a::type':0,'area::alt':0,'area::coords':0,'area::href':1,'area::hreflang':0,'area::media':0,'area::rel':0,'area::shape':0,'area::target':10,'area::type':0,'audio::autoplay':0,'audio::controls':0,'audio::loop':0,'audio::mediagroup':0,'audio::preload':0,'audio::src':1,'base::href':1,'base::target':10,'blockquote::cite':1,'body::onafterprint':2,'body::onbeforeprint':2,'body::onbeforeunload':2,'body::onblur':2,'body::onerror':2,'body::onfocus':2,'body::onhashchange':2,'body::onload':2,'body::onmessage':2,'body::onoffline':2,'body::ononline':2,'body::onpagehide':2,'body::onpageshow':2,'body::onpopstate':2,'body::onredo':2,'body::onresize':2,'body::onscroll':2,'body::onstorage':2,'body::onundo':2,'body::onunload':2,'button::autofocus':0,'button::disabled':0,'button::form':0,'button::formaction':1,'button::formenctype':0,'button::formmethod':0,'button::formnovalidate':0,'button::formtarget':10,'button::name':8,'button::type':0,'button::value':0,'canvas::height':0,'canvas::width':0,'col::span':0,'colgroup::span':0,'command::checked':0,'command::disabled':0,'command::icon':1,'command::label':0,'command::radiogroup':0,'command::type':0,'del::cite':1,'del::datetime':0,'details::open':0,'embed::height':0,'embed::src':1,'embed::type':0,'embed::width':0,'fieldset::disabled':0,'fieldset::form':0,'fieldset::name':8,'form::accept-charset':0,'form::action':1,'form::autocomplete':0,'form::enctype':0,'form::method':0,'form::name':7,'form::novalidate':0,'form::target':10,'html:: manifest':1,'iframe::height':0,'iframe::name':7,'iframe::sandbox':0,'iframe::seamless':0,'iframe::src':1,'iframe::srcdoc':10,'iframe::width':0,'img::alt':0,'img::height':0,'img::ismap':0,'img::name':7,'img::src':1,'img::usemap':11,'img::width':0,'input::accept':0,'input::alt':0,'input::autocomplete':0,'input::autofocus':0,'input::checked':0,'input::dirname':0,'input::disabled':0,'input::form':0,'input::formaction':1,'input::formenctype':0,'input::formmethod':0,'input::formnovalidate':0,'input::formtarget':10,'input::height':0,'input::list':0,'input::max':0,'input::maxlength':0,'input::min':0,'input::multiple':0,'input::name':8,'input::pattern':0,'input::placeholder':0,'input::readonly':0,'input::required':0,'input::step':0,'input::size':0,'input::src':1,'input::type':0,'input::value':0,'input::width':0,'ins::cite':1,'ins::datetime':0,'keygen::autofocus':0,'keygen::challenge':0,'keygen::disabled':0,'keygen::form':0,'keygen::keytype':0,'keygen::name':8,'label::for':5,'label::form':0,'link::href':1,'link::hreflang':0,'link::media':0,'link::rel':0,'link::sizes':0,'link::type':0,'li::value':0,'map::name':7,'menu::label':0,'menu::type':0,'meta::charset':0,'meta::content':0,'meta::http-equiv':0,'meta::name':7,'meter::form':0,'meter::high':0,'meter::low':0,'meter::max':0,'meter::min':0,'meter::optimum':0,'meter::value':0,'object::data':1,'object::form':0,'object::height':0,'object::name':8,'object::type':0,'object::usemap':11,'object::width':0,'ol::reversed':0,'ol::start':0,'optgroup::disabled':0,'optgroup::label':0,'option::disabled':0,'option::label':0,'option::selected':0,'option::value':0,'output::for':5,'output::form':0,'output::name':8,'param::name':8,'param::value':0,'progress::form':0,'progress::max':0,'progress::value':0,'q::cite':1,'script::async':0,'script::charset':0,'script::defer':0,'script::src':1,'script::type':0,'select::autofocus':0,'select::disabled':0,'select::form':0,'select::multiple':0,'select::name':8,'select::required':0,'select::size':0,'source::media':0,'source::src':1,'source::type':0,'style::media':0,'style::scoped':0,'style::type':0,'table::border':0,'td::colspan':0,'td::headers':6,'td::rowspan':0,'textarea::autofocus':0,'textarea::cols':0,'textarea::disabled':0,'textarea::form':0,'textarea::maxlength':0,'textarea::name':8,'textarea::placeholder':0,'textarea::readonly':0,'textarea::required':0,'textarea::rows':0,'textarea::wrap':0,'th::colspan':0,'th::headers':6,'th::rowspan':0,'th::scope':0,'time::datetime':0,'time::pubdate':0,'track::default':0,'track::kind':0,'track::label':0,'track::src':1,'track::srclang':0,'video::autoplay':0,'video::controls':0,'video::height':0,'video::loop':0,'video::mediagroup':0,'video::poster':1,'video::preload':0,'video::src':1,'video::width':0};B.eflags={OPTIONAL_ENDTAG:1,EMPTY:2,CDATA:4,RCDATA:8,UNSAFE:16,FOLDABLE:32,SCRIPT:64,STYLE:128};B.ELEMENTS={'a':0,'abbr':0,'address':0,'area':2,'article':0,'aside':0,'audio':0,'b':0,'base':18,'bdi':0,'bdo':0,'blockquote':0,'body':49,'br':2,'button':0,'canvas':0,'caption':0,'cite':0,'code':0,'col':2,'colgroup':1,'command':2,'datalist':0,'dd':1,'del':0,'details':0,'dfn':0,'div':0,'dl':0,'dt':1,'em':0,'embed':18,'fieldset':0,'figcaption':0,'figure':0,'footer':0,'form':0,'h1':0,'h2':0,'h3':0,'h4':0,'h5':0,'h6':0,'head':49,'header':0,'hgroup':0,'hr':2,'html':49,'i':0,'iframe':4,'img':2,'input':2,'ins':0,'kbd':0,'keygen':2,'label':0,'legend':0,'li':1,'link':18,'map':0,'mark':0,'menu':0,'meta':18,'meter':0,'nav':0,'noscript':20,'object':16,'ol':0,'optgroup':1,'option':1,'output':0,'p':1,'param':18,'pre':0,'progress':0,'q':0,'rp':1,'rt':1,'ruby':0,'s':0,'samp':0,'script':84,'section':0,'select':0,'small':0,'source':2,'span':0,'strong':0,'style':148,'sub':0,'summary':0,'sup':0,'table':0,'tbody':1,'td':1,'textarea':8,'tfoot':1,'th':1,'thead':1,'time':0,'title':24,'tr':1,'track':2,'u':0,'ul':0,'var':0,'video':0,'wbr':2};B.ueffects={NOT_LOADED:0,SAME_DOCUMENT:1,NEW_DOCUMENT:2};B.URIEFFECTS={'a::href':2,'area::href':2,'audio::src':1,'base::href':2,'blockquote::cite':0,'button::formaction':2,'command::icon':1,'del::cite':0,'embed::src':1,'form::action':2,'html:: manifest':1,'iframe::src':1,'img::src':1,'input::formaction':2,'input::src':1,'ins::cite':0,'link::href':2,'object::data':1,'q::cite':0,'script::src':1,'source::src':1,'track::src':1,'video::poster':1,'video::src':1};B.ltypes={UNSANDBOXED:2,SANDBOXED:1,DATA:0};B.LOADERTYPES={'a::href':2,'area::href':2,'audio::src':1,'base::href':2,'blockquote::cite':2,'button::formaction':2,'command::icon':1,'del::cite':2,'embed::src':1,'form::action':2,'html:: manifest':1,'iframe::src':1,'img::src':1,'input::formaction':2,'input::src':1,'ins::cite':2,'link::href':2,'object::data':0,'q::cite':2,'script::src':1,'source::src':1,'track::src':1,'video::poster':1,'video::src':1};if(typeof window!=='undefined'){window['html4']=B;}
// Copyright (C) 2006 Google Inc.
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//      http://www.apache.org/licenses/LICENSE-2.0
// distributed under the License is distributed on an "AS IS" BASIS,
// See the License for the specific language governing permissions and
// limitations under the License.
var D=(function(B){var A,w,r;if('undefined'!==typeof window){A=window['parseCssDeclarations'];w=window['sanitizeCssProperty'];r=window['cssSchema'];}var c;if('script'==='SCRIPT'.toLowerCase()){c=function(s){return s.toLowerCase();};}else{c=function(s){return s.replace(/[A-Z]/g,function(e){return String.fromCharCode(e.charCodeAt(0)|32);});};}var j={'lt':'<','gt':'>','amp':'&','nbsp':'\240','quot':'"','apos':'\''};var k=/^#(\d+)$/;var F=/^#x([0-9A-Fa-f]+)$/;function G(n){n=c(n);if(j.hasOwnProperty(n)){return j[n];}var m=n.match(k);if(m){return String.fromCharCode(parseInt(m[1],10));}else if(!!(m=n.match(F))){return String.fromCharCode(parseInt(m[1],16));}return'';}function H(_,n){return G(n);}var I=/\0/g;function J(s){return s.replace(I,'');}var K=/&(#\d+|#x[0-9A-Fa-f]+|\w+);/g;function L(s){return s.replace(K,H);}var M=/&/g;var N=/&([^a-z#]|#(?:[^0-9x]|x(?:[^0-9a-f]|$)|$)|$)/gi;var O=/[<]/g;var P=/>/g;var Q=/\"/g;function R(s){return(''+s).replace(M,'&amp;').replace(O,'&lt;').replace(P,'&gt;').replace(Q,'&#34;');}function S(e){return e.replace(N,'&amp;$1').replace(O,'&lt;').replace(P,'&gt;');}var T=new RegExp('^\\s*'+'([a-z][a-z-]*)'+'(?:'+('\\s*(=)\\s*'+'('+('(\")[^\"]*(\"|$)'+'|'+'(\')[^\']*(\'|$)'+'|'+'(?=[a-z][a-z-]*\\s*=)'+'|'+'[^\"\'\\s]*')+')')+')?','i');var U=/^(#[0-9]+|#x[0-9a-f]+|\w+);/i;var V=('a,b'.split(/(,)/).length===3);var W=B.eflags.CDATA|B.eflags.RCDATA;function X(h){return function(e,p){return Z(e,h,p);};}var Y={};function Z(e,i,n){var h=i;var m,p,q;var s=b1(e);var v={noMoreGT:false,noMoreEndComments:false};a1(i,s,0,v,n);}function $(h,p,i,s,e){return function(){a1(h,p,i,s,e);};}function a1(h,i,n,s,q){try{if(h.startDoc&&n==0){h.startDoc(q);}var m,p,v;for(var _=n,q1=i.length;_<q1;){var r1=i[_++];var s1=i[_];switch(r1){case'&':if(U.test(s1)){if(h.pcdata){h.pcdata('&'+s1,q,Y,$(h,i,_,s,q));}_++;}else{if(h.pcdata){h.pcdata("&amp;",q,Y,$(h,i,_,s,q));}}break;case'<\/':if(m=/^(\w+)[^\'\"]*/.exec(s1)){if(m[0].length===s1.length&&i[_+1]==='>'){_+=2;v=c(m[1]);if(B.ELEMENTS.hasOwnProperty(v)){if(h.endTag){h.endTag(v,q,Y,$(h,i,_,s,q));}}}else{_=c1(i,_,h,q,Y,s);}}else{if(h.pcdata){h.pcdata('&lt;/',q,Y,$(h,i,_,s,q));}}break;case'<':if(m=/^(\w+)\s*\/?/.exec(s1)){if(m[0].length===s1.length&&i[_+1]==='>'){_+=2;v=c(m[1]);if(B.ELEMENTS.hasOwnProperty(v)){if(h.startTag){h.startTag(v,[],q,Y,$(h,i,_,s,q));}var t1=B.ELEMENTS[v];if(t1&W){var u1={name:v,next:_,eflags:t1};_=f1(i,u1,h,q,Y,s);}}}else{_=d1(i,_,h,q,Y,s);}}else{if(h.pcdata){h.pcdata('&lt;',q,Y,$(h,i,_,s,q));}}break;case'<\!--':if(!s.noMoreEndComments){for(p=_+1;p<q1;p++){if(i[p]==='>'&&/--$/.test(i[p-1])){break;}}if(p<q1){_=p+1;}else{s.noMoreEndComments=true;}}if(s.noMoreEndComments){if(h.pcdata){h.pcdata('&lt;!--',q,Y,$(h,i,_,s,q));}}break;case'<\!':if(!/^\w/.test(s1)){if(h.pcdata){h.pcdata('&lt;!',q,Y,$(h,i,_,s,q));}}else{if(!s.noMoreGT){for(p=_+1;p<q1;p++){if(i[p]==='>'){break;}}if(p<q1){_=p+1;}else{s.noMoreGT=true;}}if(s.noMoreGT){if(h.pcdata){h.pcdata('&lt;!',q,Y,$(h,i,_,s,q));}}}break;case'<?':if(!s.noMoreGT){for(p=_+1;p<q1;p++){if(i[p]==='>'){break;}}if(p<q1){_=p+1;}else{s.noMoreGT=true;}}if(s.noMoreGT){if(h.pcdata){h.pcdata('&lt;?',q,Y,$(h,i,_,s,q));}}break;case'>':if(h.pcdata){h.pcdata("&gt;",q,Y,$(h,i,_,s,q));}break;case'':break;default:if(h.pcdata){h.pcdata(r1,q,Y,$(h,i,_,s,q));}break;}}if(h.endDoc){h.endDoc(q);}}catch(e){if(e!==Y){throw e;}}}function b1(s){var e=/(<\/|<\!--|<[!?]|[&<>])/g;s+='';if(V){return s.split(e);}else{var p=[];var h=0;var m;while((m=e.exec(s))!==null){p.push(s.substring(h,m.index));p.push(m[0]);h=m.index+m[0].length;}p.push(s.substring(h));return p;}}function c1(p,e,h,i,Y,s){var m=g1(p,e);if(!m){return p.length;}if(m.eflags!==void 0){if(h.endTag){h.endTag(m.name,i,Y,$(h,p,e,s,i));}}return m.next;}function d1(p,e,h,i,Y,s){var m=g1(p,e);if(!m){return p.length;}if(m.eflags!==void 0){if(h.startTag){h.startTag(m.name,m.attrs,i,Y,$(h,p,m.next,s,i));}if(m.eflags&W){return f1(p,m,h,i,Y,s);}}return m.next;}var e1={};function f1(e,i,h,m,Y,s){var n=e.length;if(!e1.hasOwnProperty(i.name)){e1[i.name]=new RegExp('^'+i.name+'(?:[\\s\\/]|$)','i');}var q=e1[i.name];var v=i.next;var p=i.next+1;for(;p<n;p++){if(e[p-1]==='<\/'&&q.test(e[p])){break;}}if(p<n){p-=1;}var _=e.slice(v,p).join('');if(i.eflags&B.eflags.CDATA){if(h.cdata){h.cdata(_,m,Y,$(h,e,p,s,m));}}else if(i.eflags&B.eflags.RCDATA){if(h.rcdata){h.rcdata(S(_),m,Y,$(h,e,p,s,m));}}else{throw new Error('bug');}return p;}function g1(e,h){var m=/^(\w+)/.exec(e[h]);var i={name:c(m[1])};if(B.ELEMENTS.hasOwnProperty(i.name)){i.eflags=B.ELEMENTS[i.name];}else{i.eflags=void 0;}var n=e[h].substr(m[0].length);var p=h+1;var q=e.length;for(;p<q;p++){if(e[p]==='>'){break;}n+=e[p];}if(q<=p){return void 0;}var s=[];while(n!==''){m=T.exec(n);if(!m){n=n.replace(/^[\s\S][^a-z\s]*/,'');}else if((m[4]&&!m[5])||(m[6]&&!m[7])){var v=m[4]||m[6];var _=false;var q1=[n,e[p++]];for(;p<q;p++){if(_){if(e[p]==='>'){break;}}else if(0<=e[p].indexOf(v)){_=true;}q1.push(e[p]);}if(q<=p){break;}n=q1.join('');continue;}else{var r1=c(m[1]);var s1=m[2]?h1(m[3]):r1;s.push(r1,s1);n=n.substr(m[0].length);}}i.attrs=s;i.next=p+1;return i;}function h1(v){var q=v.charCodeAt(0);if(q===0x22||q===0x27){v=v.substr(1,v.length-2);}return L(J(v));}function i1(e){var s;var h;var m=function(i,n){if(!h){n.push(i);}};return X({startDoc:function(_){s=[];h=false;},startTag:function(p,q,v){if(h){return;}if(!B.ELEMENTS.hasOwnProperty(p)){return;}var _=B.ELEMENTS[p];if(_&B.eflags.FOLDABLE){return;}q=e(p,q);if(!q){h=!(_&B.eflags.EMPTY);return;}if(!(_&B.eflags.EMPTY)){s.push(p);}v.push('<',p);for(var i=0,n=q.length;i<n;i+=2){var q1=q[i],r1=q[i+1];if(r1!==null&&r1!==void 0){v.push(' ',q1,'="',R(r1),'"');}}v.push('>');},endTag:function(n,p){if(h){h=false;return;}if(!B.ELEMENTS.hasOwnProperty(n)){return;}var q=B.ELEMENTS[n];if(!(q&(B.eflags.EMPTY|B.eflags.FOLDABLE))){var v;if(q&B.eflags.OPTIONAL_ENDTAG){for(v=s.length;--v>=0;){var _=s[v];if(_===n){break;}if(!(B.ELEMENTS[_]&B.eflags.OPTIONAL_ENDTAG)){return;}}}else{for(v=s.length;--v>=0;){if(s[v]===n){break;}}}if(v<0){return;}for(var i=s.length;--i>v;){var _=s[i];if(!(B.ELEMENTS[_]&B.eflags.OPTIONAL_ENDTAG)){p.push('<\/',_,'>');}}s.length=v;p.push('<\/',n,'>');}},pcdata:m,rcdata:m,cdata:m,endDoc:function(i){for(;s.length;s.length--){i.push('<\/',s[s.length-1],'>');}}});}var j1=new RegExp('^'+'(?:'+'([^:\/?# ]+)'+':)?');var k1=/^(?:https?|mailto)$/i;function l1(e,n){if(!n){return null;}var p=(''+e).match(j1);if(p&&(!p[1]||k1.test(p[1]))){return n(e);}else{return null;}}function m1(e,h,m,n){for(var i=0;i<h.length;i+=2){var p=h[i];var v=h[i+1];var q=null,s;if((s=e+'::'+p,B.ATTRIBS.hasOwnProperty(s))||(s='*::'+p,B.ATTRIBS.hasOwnProperty(s))){q=B.ATTRIBS[s];}if(q!==null){switch(q){case B.atype.NONE:break;case B.atype.SCRIPT:v=null;break;case B.atype.STYLE:if('undefined'===typeof A){v=null;break;}var _=[];A(v,{declaration:function(q1,r1){var s1=q1.toLowerCase();var t1=r[s1];if(!t1){return;}w(s1,t1,r1,m);_.push(q1+': '+r1.join(' '));}});v=_.length>0?_.join(' ; '):null;break;case B.atype.ID:case B.atype.IDREF:case B.atype.IDREFS:case B.atype.GLOBAL_NAME:case B.atype.LOCAL_NAME:case B.atype.CLASSES:v=n?n(v):v;break;case B.atype.URI:v=l1(v,m);break;case B.atype.URI_FRAGMENT:if(v&&'#'===v.charAt(0)){v=v.substring(1);v=n?n(v):v;if(v!==null&&v!==void 0){v='#'+v;}}else{v=null;}break;default:v=null;break;}}else{v=null;}h[i+1]=v;}return h;}function n1(e,h){return function(i,m){if(!(B.ELEMENTS[i]&B.eflags.UNSAFE)){return m1(i,m,e,h);}};}function o1(i,e){var h=[];i1(e)(i,h);return h.join('');}function p1(i,e,h){var m=n1(e,h);return o1(i,m);}return{escapeAttrib:R,makeHtmlSanitizer:i1,makeSaxParser:X,makeTagPolicy:n1,normalizeRCData:S,sanitize:p1,sanitizeAttribs:m1,sanitizeWithPolicy:o1,unescapeEntities:L};})(B);var E=D.sanitize;if(typeof window!=='undefined'){window['html']=D;window['html_sanitize']=E;}}());
}
},"sap/ui/core/library-preload"
);
//# sourceMappingURL=library-preload.js.map